/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var se=["require","exports","vs/base/common/lifecycle","vs/base/common/types","vs/nls!vs/code/node/cliProcessMain","vs/base/common/event","vs/platform/log/common/log","vs/nls","vs/base/common/async","vs/base/common/errors","vs/platform/instantiation/common/instantiation","vs/base/common/uri","vs/base/common/platform","vs/platform/files/common/files","vs/base/common/buffer","vs/base/common/network","vs/base/common/path","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/platform/extensionManagement/common/extensionManagement","vs/platform/telemetry/common/telemetry","vs/base/common/cancellation","vs/platform/uriIdentity/common/uriIdentity","vs/platform/userDataProfile/common/userDataProfile","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/objects","vs/base/common/uuid","vs/platform/configuration/common/configuration","vs/base/common/map","vs/base/common/strings","vs/platform/product/common/productService","os","vs/base/common/errorMessage","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/base/common/json","vs/platform/policy/common/policy","vs/platform/configuration/common/configurationRegistry","vs/platform/telemetry/common/telemetryUtils","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/base/common/hash","vs/base/common/semver/semver","vs/platform/request/common/request","vs/base/common/stream","vs/base/common/marshalling","vs/base/common/ternarySearchTree","vs/base/node/zip","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/severity","vs/base/common/processes","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","fs","vs/platform/download/common/download","vs/platform/files/common/io","vs/base/common/extpath","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/remote/common/remoteHosts","vs/platform/state/node/stateService","vs/platform/telemetry/common/commonProperties","vs/platform/extensionManagement/node/extensionSignatureVerificationService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/base/common/amd","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/jsonEdit","vs/base/common/numbers","vs/base/common/skipList","vs/base/node/macAddress","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/amdX","vs/base/node/id","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLI","vs/nls!vs/platform/extensionManagement/common/extensionNls","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/contextkey/common/scanner","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/extensionNls","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/contextkey/common/contextkey","vs/platform/files/node/watcher/baseWatcher","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/log/common/logService","vs/platform/log/node/spdlogLog","vs/platform/log/node/loggerService","vs/platform/policy/common/filePolicyService","vs/platform/policy/node/nativePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/state","vs/platform/extensionManagement/common/extensionManagementCLI","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/externalServices/common/marketplace","vs/platform/languagePacks/node/languagePacks","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/telemetry/node/telemetryUtils","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/extensionManagement/node/extensionsProfileScannerService","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/request/node/requestService","vs/base/common/lazy","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/base/common/linkedList","graceful-fs","vs/platform/environment/node/argvHelper","crypto","https","vs/base/common/stopwatch","zlib","vs/code/node/cliProcessMain","vs/base/node/unc"],re=function(X){for(var e=[],A=0,O=X.length;A<O;A++)e[A]=se[X[A]];return e};define(se[74],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$U=e.$T=void 0,e.$T=!1;class A{static get(){const I=new Map,L=new Map,N=new Map,P=new Map;function l(y,$){y.has($.detail)||y.set($.detail,-$.timestamp)}function a(y,$){const R=y.get($.detail);R&&(R>=0||y.set($.detail,R+$.timestamp))}let h=[];typeof X=="function"&&typeof X.getStats=="function"&&(h=X.getStats().slice(0).sort((y,$)=>y.timestamp-$.timestamp));for(const y of h)switch(y.type){case 10:l(I,y);break;case 11:case 12:a(I,y);break;case 21:l(L,y);break;case 22:a(L,y);break;case 33:l(N,y);break;case 34:a(N,y);break;case 31:l(P,y);break;case 32:a(P,y);break}let b=0;N.forEach(y=>b+=y);function v(y){const $=[];return y.forEach((R,g)=>$.push([g,R])),$}return{amdLoad:v(I),amdInvoke:v(L),nodeRequire:v(N),nodeEval:v(P),nodeRequireTotal:b}}static toMarkdownTable(I,L){let N="";const P=[];return I.forEach((l,a)=>{P[a]=l.length}),L.forEach(l=>{l.forEach((a,h)=>{typeof a>"u"&&(a=l[h]="-");const b=a.toString().length;P[h]=Math.max(b,P[h])})}),I.forEach((l,a)=>{N+=`| ${l+" ".repeat(P[a]-l.toString().length)} `}),N+=`|
`,I.forEach((l,a)=>{N+=`| ${"-".repeat(P[a])} `}),N+=`|
`,L.forEach(l=>{l.forEach((a,h)=>{typeof a<"u"&&(N+=`| ${a+" ".repeat(P[h]-a.toString().length)} `)}),N+=`|
`}),N}}e.$U=A}),define(se[55],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=O,e.$4h=I,e.$5h=L;function A(N){return(P,l,a)=>{let h=null,b=null;if(typeof a.value=="function"?(h="value",b=a.value):typeof a.get=="function"&&(h="get",b=a.get),!b)throw new Error("not supported");a[h]=N(b,l)}}function O(N,P,l){let a=null,h=null;if(typeof l.value=="function"?(a="value",h=l.value,h.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof l.get=="function"&&(a="get",h=l.get),!h)throw new Error("not supported");const b=`$memoize$${P}`;l[a]=function(...v){return this.hasOwnProperty(b)||Object.defineProperty(this,b,{configurable:!1,enumerable:!1,writable:!1,value:h.apply(this,v)}),this[b]}}function I(N,P,l){return A((a,h)=>{const b=`$debounce$${h}`,v=`$debounce$result$${h}`;return function(...y){this[v]||(this[v]=l?l():void 0),clearTimeout(this[b]),P&&(this[v]=P(this[v],...y),y=[this[v]]),this[b]=setTimeout(()=>{a.apply(this,y),this[v]=l?l():void 0},N)}})}function L(N,P,l){return A((a,h)=>{const b=`$throttle$timer$${h}`,v=`$throttle$result$${h}`,y=`$throttle$lastRun$${h}`,$=`$throttle$pending$${h}`;return function(...R){if(this[v]||(this[v]=l?l():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),P&&(this[v]=P(this[v],...R)),this[$])return;const g=this[y]+N;g<=Date.now()?(this[y]=Date.now(),a.apply(this,[this[v]]),this[v]=l?l():void 0):(this[$]=!0,this[b]=setTimeout(()=>{this[$]=!1,this[y]=Date.now(),a.apply(this,[this[v]]),this[v]=l?l():void 0},g-Date.now()))}})}}),define(se[75],re([0,1,9]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=O,e.$ed=I,e.$fd=L,e.$gd=N,e.$hd=P,e.$id=l;function O(a,h){if(!a)throw new Error(h?`Assertion failed (${h})`:"Assertion Failed")}function I(a,h="Unreachable"){throw new Error(h)}function L(a,h="unexpected state"){if(!a)throw new A.$cb(`Assertion Failed: ${h}`)}function N(a){a||(0,A.$1)(new A.$cb("Soft Assertion Failed"))}function P(a){if(!a()){debugger;a(),(0,A.$1)(new A.$cb("Assertion Failed"))}}function l(a,h){let b=0;for(;b<a.length-1;){const v=a[b],y=a[b+1];if(!h(v,y))return!1;b++}return!0}}),define(se[38],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=N,e.$Kn=b,e.$Ln=v,e.$Mn=y,e.$Nn=$,e.$On=R,e.$Pn=g,e.$Qn=c,e.$Rn=w,e.$Sn=p,e.$Tn=m,e.$Un=f;var A;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(A||(e.ScanError=A={}));var O;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(O||(e.SyntaxKind=O={}));var I;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(I||(e.ParseErrorCode=I={}));var L;(function(n){n.DEFAULT={allowTrailingComma:!0}})(L||(e.ParseOptions=L={}));function N(n,r=!1){let i=0;const t=n.length;let s="",o=0,u=16,S=0;function j(ie){let ue=0,le=0;for(;ue<ie;){const ce=n.charCodeAt(i);if(ce>=48&&ce<=57)le=le*16+ce-48;else if(ce>=65&&ce<=70)le=le*16+ce-65+10;else if(ce>=97&&ce<=102)le=le*16+ce-97+10;else break;i++,ue++}return ue<ie&&(le=-1),le}function k(ie){i=ie,s="",o=0,u=16,S=0}function D(){const ie=i;if(n.charCodeAt(i)===48)i++;else for(i++;i<n.length&&a(n.charCodeAt(i));)i++;if(i<n.length&&n.charCodeAt(i)===46)if(i++,i<n.length&&a(n.charCodeAt(i)))for(i++;i<n.length&&a(n.charCodeAt(i));)i++;else return S=3,n.substring(ie,i);let ue=i;if(i<n.length&&(n.charCodeAt(i)===69||n.charCodeAt(i)===101))if(i++,(i<n.length&&n.charCodeAt(i)===43||n.charCodeAt(i)===45)&&i++,i<n.length&&a(n.charCodeAt(i))){for(i++;i<n.length&&a(n.charCodeAt(i));)i++;ue=i}else S=3;return n.substring(ie,ue)}function F(){let ie="",ue=i;for(;;){if(i>=t){ie+=n.substring(ue,i),S=2;break}const le=n.charCodeAt(i);if(le===34){ie+=n.substring(ue,i),i++;break}if(le===92){if(ie+=n.substring(ue,i),i++,i>=t){S=2;break}switch(n.charCodeAt(i++)){case 34:ie+='"';break;case 92:ie+="\\";break;case 47:ie+="/";break;case 98:ie+="\b";break;case 102:ie+="\f";break;case 110:ie+=`
`;break;case 114:ie+="\r";break;case 116:ie+="	";break;case 117:{const V=j(4);V>=0?ie+=String.fromCharCode(V):S=4;break}default:S=5}ue=i;continue}if(le>=0&&le<=31)if(l(le)){ie+=n.substring(ue,i),S=2;break}else S=6;i++}return ie}function C(){if(s="",S=0,o=i,i>=t)return o=t,u=17;let ie=n.charCodeAt(i);if(P(ie)){do i++,s+=String.fromCharCode(ie),ie=n.charCodeAt(i);while(P(ie));return u=15}if(l(ie))return i++,s+=String.fromCharCode(ie),ie===13&&n.charCodeAt(i)===10&&(i++,s+=`
`),u=14;switch(ie){case 123:return i++,u=1;case 125:return i++,u=2;case 91:return i++,u=3;case 93:return i++,u=4;case 58:return i++,u=6;case 44:return i++,u=5;case 34:return i++,s=F(),u=10;case 47:{const ue=i-1;if(n.charCodeAt(i+1)===47){for(i+=2;i<t&&!l(n.charCodeAt(i));)i++;return s=n.substring(ue,i),u=12}if(n.charCodeAt(i+1)===42){i+=2;const le=t-1;let ce=!1;for(;i<le;){if(n.charCodeAt(i)===42&&n.charCodeAt(i+1)===47){i+=2,ce=!0;break}i++}return ce||(i++,S=1),s=n.substring(ue,i),u=13}return s+=String.fromCharCode(ie),i++,u=16}case 45:if(s+=String.fromCharCode(ie),i++,i===t||!a(n.charCodeAt(i)))return u=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return s+=D(),u=11;default:for(;i<t&&J(ie);)i++,ie=n.charCodeAt(i);if(o!==i){switch(s=n.substring(o,i),s){case"true":return u=8;case"false":return u=9;case"null":return u=7}return u=16}return s+=String.fromCharCode(ie),i++,u=16}}function J(ie){if(P(ie)||l(ie))return!1;switch(ie){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ne(){let ie;do ie=C();while(ie>=12&&ie<=15);return ie}return{setPosition:k,getPosition:()=>i,scan:r?ne:C,getToken:()=>u,getTokenValue:()=>s,getTokenOffset:()=>o,getTokenLength:()=>i-o,getTokenError:()=>S}}function P(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function l(n){return n===10||n===13||n===8232||n===8233}function a(n){return n>=48&&n<=57}var h;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(h||(h={}));function b(n,r){const i=[],t=new Object;let s;const o={value:{},offset:0,length:0,type:"object",parent:void 0};let u=!1;function S(j,k,D,F){o.value=j,o.offset=k,o.length=D,o.type=F,o.colonOffset=void 0,s=o}try{p(n,{onObjectBegin:(j,k)=>{if(r<=j)throw t;s=void 0,u=r>j,i.push("")},onObjectProperty:(j,k,D)=>{if(r<k||(S(j,k,D,"property"),i[i.length-1]=j,r<=k+D))throw t},onObjectEnd:(j,k)=>{if(r<=j)throw t;s=void 0,i.pop()},onArrayBegin:(j,k)=>{if(r<=j)throw t;s=void 0,i.push(0)},onArrayEnd:(j,k)=>{if(r<=j)throw t;s=void 0,i.pop()},onLiteralValue:(j,k,D)=>{if(r<k||(S(j,k,D,f(j)),r<=k+D))throw t},onSeparator:(j,k,D)=>{if(r<=k)throw t;if(j===":"&&s&&s.type==="property")s.colonOffset=k,u=!1,s=void 0;else if(j===","){const F=i[i.length-1];typeof F=="number"?i[i.length-1]=F+1:(u=!0,i[i.length-1]=""),s=void 0}}})}catch(j){if(j!==t)throw j}return{path:i,previousNode:s,isAtPropertyKey:u,matches:j=>{let k=0;for(let D=0;k<j.length&&D<i.length;D++)if(j[k]===i[D]||j[k]==="*")k++;else if(j[k]!=="**")return!1;return k===j.length}}}function v(n,r=[],i=L.DEFAULT){let t=null,s=[];const o=[];function u(j){Array.isArray(s)?s.push(j):t!==null&&(s[t]=j)}return p(n,{onObjectBegin:()=>{const j={};u(j),o.push(s),s=j,t=null},onObjectProperty:j=>{t=j},onObjectEnd:()=>{s=o.pop()},onArrayBegin:()=>{const j=[];u(j),o.push(s),s=j,t=null},onArrayEnd:()=>{s=o.pop()},onLiteralValue:u,onError:(j,k,D)=>{r.push({error:j,offset:k,length:D})}},i),s[0]}function y(n,r=[],i=L.DEFAULT){let t={type:"array",offset:-1,length:-1,children:[],parent:void 0};function s(j){t.type==="property"&&(t.length=j-t.offset,t=t.parent)}function o(j){return t.children.push(j),j}p(n,{onObjectBegin:j=>{t=o({type:"object",offset:j,length:-1,parent:t,children:[]})},onObjectProperty:(j,k,D)=>{t=o({type:"property",offset:k,length:-1,parent:t,children:[]}),t.children.push({type:"string",value:j,offset:k,length:D,parent:t})},onObjectEnd:(j,k)=>{t.length=j+k-t.offset,t=t.parent,s(j+k)},onArrayBegin:(j,k)=>{t=o({type:"array",offset:j,length:-1,parent:t,children:[]})},onArrayEnd:(j,k)=>{t.length=j+k-t.offset,t=t.parent,s(j+k)},onLiteralValue:(j,k,D)=>{o({type:f(j),offset:k,length:D,parent:t,value:j}),s(k+D)},onSeparator:(j,k,D)=>{t.type==="property"&&(j===":"?t.colonOffset=k:j===","&&s(k))},onError:(j,k,D)=>{r.push({error:j,offset:k,length:D})}},i);const S=t.children[0];return S&&delete S.parent,S}function $(n,r){if(!n)return;let i=n;for(const t of r)if(typeof t=="string"){if(i.type!=="object"||!Array.isArray(i.children))return;let s=!1;for(const o of i.children)if(Array.isArray(o.children)&&o.children[0].value===t){i=o.children[1],s=!0;break}if(!s)return}else{const s=t;if(i.type!=="array"||s<0||!Array.isArray(i.children)||s>=i.children.length)return;i=i.children[s]}return i}function R(n){if(!n.parent||!n.parent.children)return[];const r=R(n.parent);if(n.parent.type==="property"){const i=n.parent.children[0].value;r.push(i)}else if(n.parent.type==="array"){const i=n.parent.children.indexOf(n);i!==-1&&r.push(i)}return r}function g(n){switch(n.type){case"array":return n.children.map(g);case"object":{const r=Object.create(null);for(const i of n.children){const t=i.children[1];t&&(r[i.children[0].value]=g(t))}return r}case"null":case"string":case"number":case"boolean":return n.value;default:return}}function c(n,r,i=!1){return r>=n.offset&&r<n.offset+n.length||i&&r===n.offset+n.length}function w(n,r,i=!1){if(c(n,r,i)){const t=n.children;if(Array.isArray(t))for(let s=0;s<t.length&&t[s].offset<=r;s++){const o=w(t[s],r,i);if(o)return o}return n}}function p(n,r,i=L.DEFAULT){const t=N(n,!1);function s(Y){return Y?()=>Y(t.getTokenOffset(),t.getTokenLength()):()=>!0}function o(Y){return Y?_=>Y(_,t.getTokenOffset(),t.getTokenLength()):()=>!0}const u=s(r.onObjectBegin),S=o(r.onObjectProperty),j=s(r.onObjectEnd),k=s(r.onArrayBegin),D=s(r.onArrayEnd),F=o(r.onLiteralValue),C=o(r.onSeparator),J=s(r.onComment),ne=o(r.onError),ie=i&&i.disallowComments,ue=i&&i.allowTrailingComma;function le(){for(;;){const Y=t.scan();switch(t.getTokenError()){case 4:ce(14);break;case 5:ce(15);break;case 3:ce(13);break;case 1:ie||ce(11);break;case 2:ce(12);break;case 6:ce(16);break}switch(Y){case 12:case 13:ie?ce(10):J();break;case 16:ce(1);break;case 15:case 14:break;default:return Y}}}function ce(Y,_=[],U=[]){if(ne(Y),_.length+U.length>0){let q=t.getToken();for(;q!==17;){if(_.indexOf(q)!==-1){le();break}else if(U.indexOf(q)!==-1)break;q=le()}}}function V(Y){const _=t.getTokenValue();return Y?F(_):S(_),le(),!0}function Z(){switch(t.getToken()){case 11:{let Y=0;try{Y=JSON.parse(t.getTokenValue()),typeof Y!="number"&&(ce(2),Y=0)}catch{ce(2)}F(Y);break}case 7:F(null);break;case 8:F(!0);break;case 9:F(!1);break;default:return!1}return le(),!0}function B(){return t.getToken()!==10?(ce(3,[],[2,5]),!1):(V(!1),t.getToken()===6?(C(":"),le(),Q()||ce(4,[],[2,5])):ce(5,[],[2,5]),!0)}function T(){u(),le();let Y=!1;for(;t.getToken()!==2&&t.getToken()!==17;){if(t.getToken()===5){if(Y||ce(4,[],[]),C(","),le(),t.getToken()===2&&ue)break}else Y&&ce(6,[],[]);B()||ce(4,[],[2,5]),Y=!0}return j(),t.getToken()!==2?ce(7,[2],[]):le(),!0}function H(){k(),le();let Y=!1;for(;t.getToken()!==4&&t.getToken()!==17;){if(t.getToken()===5){if(Y||ce(4,[],[]),C(","),le(),t.getToken()===4&&ue)break}else Y&&ce(6,[],[]);Q()||ce(4,[],[4,5]),Y=!0}return D(),t.getToken()!==4?ce(8,[4],[]):le(),!0}function Q(){switch(t.getToken()){case 3:return H();case 1:return T();case 10:return V(!0);default:return Z()}}return le(),t.getToken()===17?i.allowEmptyContent?!0:(ce(4,[],[]),!1):Q()?(t.getToken()!==17&&ce(9,[],[]),!0):(ce(4,[],[]),!1)}function m(n,r){const i=N(n),t=[];let s,o=0,u;do switch(u=i.getPosition(),s=i.scan(),s){case 12:case 13:case 17:o!==u&&t.push(n.substring(o,u)),r!==void 0&&t.push(i.getTokenValue().replace(/[^\r\n]/g,r)),o=i.getPosition();break}while(s!==17);return t.join("")}function f(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}}),define(se[76],re([0,1,38]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vn=O,e.$Wn=I,e.$Xn=P,e.$Yn=l;function O(a,h,b){let v,y,$,R,g;if(h){for(R=h.offset,g=R+h.length,$=R;$>0&&!l(a,$-1);)$--;let u=g;for(;u<a.length&&!l(a,u);)u++;y=a.substring($,u),v=N(y,b)}else y=a,v=0,$=0,R=0,g=a.length;const c=P(b,a);let w=!1,p=0,m;b.insertSpaces?m=L(" ",b.tabSize||4):m="	";const f=(0,A.$Jn)(y,!1);let n=!1;function r(){return c+L(m,v+p)}function i(){let u=f.scan();for(w=!1;u===15||u===14;)w=w||u===14,u=f.scan();return n=u===16||f.getTokenError()!==0,u}const t=[];function s(u,S,j){!n&&S<g&&j>R&&a.substring(S,j)!==u&&t.push({offset:S,length:j-S,content:u})}let o=i();if(o!==17){const u=f.getTokenOffset()+$,S=L(m,v);s(S,$,u)}for(;o!==17;){let u=f.getTokenOffset()+f.getTokenLength()+$,S=i(),j="";for(;!w&&(S===12||S===13);){const D=f.getTokenOffset()+$;s(" ",u,D),u=f.getTokenOffset()+f.getTokenLength()+$,j=S===12?r():"",S=i()}if(S===2)o!==1&&(p--,j=r());else if(S===4)o!==3&&(p--,j=r());else{switch(o){case 3:case 1:p++,j=r();break;case 5:case 12:j=r();break;case 13:w?j=r():j=" ";break;case 6:j=" ";break;case 10:if(S===6){j="";break}case 7:case 8:case 9:case 11:case 2:case 4:S===12||S===13?j=" ":S!==5&&S!==17&&(n=!0);break;case 16:n=!0;break}w&&(S===12||S===13)&&(j=r())}const k=f.getTokenOffset()+$;s(j,u,k),o=S}return t}function I(a,h){const b=JSON.stringify(a,void 0,h.insertSpaces?h.tabSize||4:"	");return h.eol!==void 0?b.replace(/\r\n|\r|\n/g,h.eol):b}function L(a,h){let b="";for(let v=0;v<h;v++)b+=a;return b}function N(a,h){let b=0,v=0;const y=h.tabSize||4;for(;b<a.length;){const $=a.charAt(b);if($===" ")v++;else if($==="	")v+=y;else break;b++}return Math.floor(v/y)}function P(a,h){for(let b=0;b<h.length;b++){const v=h.charAt(b);if(v==="\r")return b+1<h.length&&h.charAt(b+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return a&&a.eol||`
`}function l(a,h){return`\r
`.indexOf(a.charAt(h))!==-1}}),define(se[77],re([0,1,38,76]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zn=I,e.$1n=L,e.$2n=N,e.$3n=P,e.$4n=l;function I(a,h,b){return L(a,h,void 0,b)}function L(a,h,b,v,y){const $=h.slice(),R=[],g=(0,A.$Mn)(a,R);let c,w;for(;$.length>0&&(w=$.pop(),c=(0,A.$Nn)(g,$),c===void 0&&b!==void 0);)typeof w=="string"?b={[w]:b}:b=[b];if(c)if(c.type==="object"&&typeof w=="string"&&Array.isArray(c.children)){const p=(0,A.$Nn)(c,[w]);if(p!==void 0)if(b===void 0){if(!p.parent)throw new Error("Malformed AST");const m=c.children.indexOf(p.parent);let f,n=p.parent.offset+p.parent.length;if(m>0){const r=c.children[m-1];f=r.offset+r.length}else f=c.offset+1,c.children.length>1&&(n=c.children[1].offset);return N(a,{offset:f,length:n-f,content:""},v)}else return N(a,{offset:p.offset,length:p.length,content:JSON.stringify(b)},v);else{if(b===void 0)return[];const m=`${JSON.stringify(w)}: ${JSON.stringify(b)}`,f=y?y(c.children.map(r=>r.children[0].value)):c.children.length;let n;if(f>0){const r=c.children[f-1];n={offset:r.offset+r.length,length:0,content:","+m}}else c.children.length===0?n={offset:c.offset+1,length:0,content:m}:n={offset:c.offset+1,length:0,content:m+","};return N(a,n,v)}}else if(c.type==="array"&&typeof w=="number"&&Array.isArray(c.children))if(b!==void 0){const p=`${JSON.stringify(b)}`;let m;if(c.children.length===0||w===0)m={offset:c.offset+1,length:0,content:c.children.length===0?p:p+","};else{const f=w===-1||w>c.children.length?c.children.length:w,n=c.children[f-1];m={offset:n.offset+n.length,length:0,content:","+p}}return N(a,m,v)}else{const p=w,m=c.children[p];let f;if(c.children.length===1)f={offset:c.offset+1,length:c.length-2,content:""};else if(c.children.length-1===p){const n=c.children[p-1],r=n.offset+n.length,i=c.offset+c.length;f={offset:r,length:i-2-r,content:""}}else f={offset:m.offset,length:c.children[p+1].offset-m.offset,content:""};return N(a,f,v)}else throw new Error(`Can not add ${typeof w!="number"?"index":"property"} to parent of type ${c.type}`);else return b===void 0?[]:N(a,{offset:g?g.offset:0,length:g?g.length:0,content:JSON.stringify(b)},v)}function N(a,h,b){let v=P(a,h),y=h.offset,$=h.offset+h.content.length;if(h.length===0||h.content.length===0){for(;y>0&&!(0,O.$Yn)(v,y-1);)y--;for(;$<v.length&&!(0,O.$Yn)(v,$);)$++}const R=(0,O.$Vn)(v,{offset:y,length:$-y},b);for(let c=R.length-1;c>=0;c--){const w=R[c];v=P(v,w),y=Math.min(y,w.offset),$=Math.max($,w.offset+w.length),$+=w.content.length-w.length}const g=a.length-(v.length-$)-y;return[{offset:y,length:g,content:v.substring(y,$)}]}function P(a,h){return a.substring(0,h.offset)+h.content+a.substring(h.offset+h.length)}function l(a,h){const b=h.slice(0).sort((y,$)=>{const R=y.offset-$.offset;return R===0?y.length-$.length:R});let v=a.length;for(let y=b.length-1;y>=0;y--){const $=b[y];if($.offset+$.length<=v)a=P(a,$);else throw new Error("Overlapping edit");v=$.offset}return a}}),define(se[78],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=A,e.rot=O;function A(P,l,a){return Math.min(Math.max(P,l),a)}function O(P,l){return(l+P%l)%l}class I{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=I;class L{constructor(){this.a=1,this.b=0}update(l){return this.b=this.b+(l-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=L;class N{constructor(l){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(l),this.c.fill(0,0,l)}update(l){const a=this.c[this.d];return this.c[this.d]=l,this.d=(this.d+1)%this.c.length,this.e-=a,this.e+=l,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=N}),function(){function X(I){const L=[];typeof I=="number"&&L.push("code/timeOrigin",I);function N(l){L.push(l,Date.now())}function P(){const l=[];for(let a=0;a<L.length;a+=2)l.push({name:L[a],startTime:L[a+1]});return l}return{mark:N,getMarks:P}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(I){performance.mark(I)},getMarks(){let I=performance.timeOrigin;typeof I!="number"&&(I=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(I)}];for(const N of performance.getEntriesByType("mark"))L.push({name:N.name,startTime:Math.round(I+N.startTime)});return L}};if(typeof process=="object"){const I=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(I)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function A(I){return I.MonacoPerformanceMarks||(I.MonacoPerformanceMarks=e()),I.MonacoPerformanceMarks}var O;typeof global=="object"?O=global:typeof self=="object"?O=self:O={},typeof define=="function"?define("vs/base/common/performance",[],function(){return A(O)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=A(O):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),O.perf=A(O))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var A=e();for(var O in A)(typeof exports=="object"?exports:X)[O]=A[O]}}(typeof self<"u"?self:this,function(){return function(X){var e={};function A(O){if(e[O])return e[O].exports;var I=e[O]={i:O,l:!1,exports:{}};return X[O].call(I.exports,I,I.exports,A),I.l=!0,I.exports}return A.m=X,A.c=e,A.d=function(O,I,L){A.o(O,I)||Object.defineProperty(O,I,{enumerable:!0,get:L})},A.r=function(O){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(O,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(O,"__esModule",{value:!0})},A.t=function(O,I){if(1&I&&(O=A(O)),8&I||4&I&&typeof O=="object"&&O&&O.__esModule)return O;var L=Object.create(null);if(A.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:O}),2&I&&typeof O!="string")for(var N in O)A.d(L,N,function(P){return O[P]}.bind(null,N));return L},A.n=function(O){var I=O&&O.__esModule?function(){return O.default}:function(){return O};return A.d(I,"a",I),I},A.o=function(O,I){return Object.prototype.hasOwnProperty.call(O,I)},A.p="",A(A.s=0)}([function(X,e,A){(function(O){var I;e=X.exports=U,I=typeof O=="object"&&O.env&&O.env.NODE_DEBUG&&/\bsemver\b/i.test(O.env.NODE_DEBUG)?function(){var x=Array.prototype.slice.call(arguments,0);x.unshift("SEMVER"),console.log.apply(console,x)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,N=Number.MAX_SAFE_INTEGER||9007199254740991,P=e.re=[],l=e.src=[],a=0,h=a++;l[h]="0|[1-9]\\d*";var b=a++;l[b]="[0-9]+";var v=a++;l[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=a++;l[y]="("+l[h]+")\\.("+l[h]+")\\.("+l[h]+")";var $=a++;l[$]="("+l[b]+")\\.("+l[b]+")\\.("+l[b]+")";var R=a++;l[R]="(?:"+l[h]+"|"+l[v]+")";var g=a++;l[g]="(?:"+l[b]+"|"+l[v]+")";var c=a++;l[c]="(?:-("+l[R]+"(?:\\."+l[R]+")*))";var w=a++;l[w]="(?:-?("+l[g]+"(?:\\."+l[g]+")*))";var p=a++;l[p]="[0-9A-Za-z-]+";var m=a++;l[m]="(?:\\+("+l[p]+"(?:\\."+l[p]+")*))";var f=a++,n="v?"+l[y]+l[c]+"?"+l[m]+"?";l[f]="^"+n+"$";var r="[v=\\s]*"+l[$]+l[w]+"?"+l[m]+"?",i=a++;l[i]="^"+r+"$";var t=a++;l[t]="((?:<|>)?=?)";var s=a++;l[s]=l[b]+"|x|X|\\*";var o=a++;l[o]=l[h]+"|x|X|\\*";var u=a++;l[u]="[v=\\s]*("+l[o]+")(?:\\.("+l[o]+")(?:\\.("+l[o]+")(?:"+l[c]+")?"+l[m]+"?)?)?";var S=a++;l[S]="[v=\\s]*("+l[s]+")(?:\\.("+l[s]+")(?:\\.("+l[s]+")(?:"+l[w]+")?"+l[m]+"?)?)?";var j=a++;l[j]="^"+l[t]+"\\s*"+l[u]+"$";var k=a++;l[k]="^"+l[t]+"\\s*"+l[S]+"$";var D=a++;l[D]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var F=a++;l[F]="(?:~>?)";var C=a++;l[C]="(\\s*)"+l[F]+"\\s+",P[C]=new RegExp(l[C],"g");var J=a++;l[J]="^"+l[F]+l[u]+"$";var ne=a++;l[ne]="^"+l[F]+l[S]+"$";var ie=a++;l[ie]="(?:\\^)";var ue=a++;l[ue]="(\\s*)"+l[ie]+"\\s+",P[ue]=new RegExp(l[ue],"g");var le=a++;l[le]="^"+l[ie]+l[u]+"$";var ce=a++;l[ce]="^"+l[ie]+l[S]+"$";var V=a++;l[V]="^"+l[t]+"\\s*("+r+")$|^$";var Z=a++;l[Z]="^"+l[t]+"\\s*("+n+")$|^$";var B=a++;l[B]="(\\s*)"+l[t]+"\\s*("+r+"|"+l[u]+")",P[B]=new RegExp(l[B],"g");var T=a++;l[T]="^\\s*("+l[u]+")\\s+-\\s+("+l[u]+")\\s*$";var H=a++;l[H]="^\\s*("+l[S]+")\\s+-\\s+("+l[S]+")\\s*$";var Q=a++;l[Q]="(<|>)?=?\\s*\\*";for(var Y=0;Y<35;Y++)I(Y,l[Y]),P[Y]||(P[Y]=new RegExp(l[Y]));function _(x,K){if(x instanceof U)return x;if(typeof x!="string"||x.length>L||!(K?P[i]:P[f]).test(x))return null;try{return new U(x,K)}catch{return null}}function U(x,K){if(x instanceof U){if(x.loose===K)return x;x=x.version}else if(typeof x!="string")throw new TypeError("Invalid Version: "+x);if(x.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof U))return new U(x,K);I("SemVer",x,K),this.loose=K;var ee=x.trim().match(K?P[i]:P[f]);if(!ee)throw new TypeError("Invalid Version: "+x);if(this.raw=x,this.major=+ee[1],this.minor=+ee[2],this.patch=+ee[3],this.major>N||this.major<0)throw new TypeError("Invalid major version");if(this.minor>N||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>N||this.patch<0)throw new TypeError("Invalid patch version");ee[4]?this.prerelease=ee[4].split(".").map(function(ge){if(/^[0-9]+$/.test(ge)){var be=+ge;if(be>=0&&be<N)return be}return ge}):this.prerelease=[],this.build=ee[5]?ee[5].split("."):[],this.format()}e.parse=_,e.valid=function(x,K){var ee=_(x,K);return ee?ee.version:null},e.clean=function(x,K){var ee=_(x.trim().replace(/^[=v]+/,""),K);return ee?ee.version:null},e.SemVer=U,U.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},U.prototype.toString=function(){return this.version},U.prototype.compare=function(x){return I("SemVer.compare",this.version,this.loose,x),x instanceof U||(x=new U(x,this.loose)),this.compareMain(x)||this.comparePre(x)},U.prototype.compareMain=function(x){return x instanceof U||(x=new U(x,this.loose)),d(this.major,x.major)||d(this.minor,x.minor)||d(this.patch,x.patch)},U.prototype.comparePre=function(x){if(x instanceof U||(x=new U(x,this.loose)),this.prerelease.length&&!x.prerelease.length)return-1;if(!this.prerelease.length&&x.prerelease.length)return 1;if(!this.prerelease.length&&!x.prerelease.length)return 0;var K=0;do{var ee=this.prerelease[K],ge=x.prerelease[K];if(I("prerelease compare",K,ee,ge),ee===void 0&&ge===void 0)return 0;if(ge===void 0)return 1;if(ee===void 0)return-1;if(ee!==ge)return d(ee,ge)}while(++K)},U.prototype.inc=function(x,K){switch(x){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ee=this.prerelease.length;--ee>=0;)typeof this.prerelease[ee]=="number"&&(this.prerelease[ee]++,ee=-2);ee===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+x)}return this.format(),this.raw=this.version,this},e.inc=function(x,K,ee,ge){typeof ee=="string"&&(ge=ee,ee=void 0);try{return new U(x,ee).inc(K,ge).version}catch{return null}},e.diff=function(x,K){if(G(x,K))return null;var ee=_(x),ge=_(K);if(ee.prerelease.length||ge.prerelease.length){for(var be in ee)if((be==="major"||be==="minor"||be==="patch")&&ee[be]!==ge[be])return"pre"+be;return"prerelease"}for(var be in ee)if((be==="major"||be==="minor"||be==="patch")&&ee[be]!==ge[be])return be},e.compareIdentifiers=d;var q=/^[0-9]+$/;function d(x,K){var ee=q.test(x),ge=q.test(K);return ee&&ge&&(x=+x,K=+K),ee&&!ge?-1:ge&&!ee?1:x<K?-1:x>K?1:0}function E(x,K,ee){return new U(x,ee).compare(new U(K,ee))}function z(x,K,ee){return E(x,K,ee)>0}function M(x,K,ee){return E(x,K,ee)<0}function G(x,K,ee){return E(x,K,ee)===0}function W(x,K,ee){return E(x,K,ee)!==0}function te(x,K,ee){return E(x,K,ee)>=0}function ae(x,K,ee){return E(x,K,ee)<=0}function he(x,K,ee,ge){var be;switch(K){case"===":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),be=x===ee;break;case"!==":typeof x=="object"&&(x=x.version),typeof ee=="object"&&(ee=ee.version),be=x!==ee;break;case"":case"=":case"==":be=G(x,ee,ge);break;case"!=":be=W(x,ee,ge);break;case">":be=z(x,ee,ge);break;case">=":be=te(x,ee,ge);break;case"<":be=M(x,ee,ge);break;case"<=":be=ae(x,ee,ge);break;default:throw new TypeError("Invalid operator: "+K)}return be}function pe(x,K){if(x instanceof pe){if(x.loose===K)return x;x=x.value}if(!(this instanceof pe))return new pe(x,K);I("comparator",x,K),this.loose=K,this.parse(x),this.semver===ye?this.value="":this.value=this.operator+this.semver.version,I("comp",this)}e.rcompareIdentifiers=function(x,K){return d(K,x)},e.major=function(x,K){return new U(x,K).major},e.minor=function(x,K){return new U(x,K).minor},e.patch=function(x,K){return new U(x,K).patch},e.compare=E,e.compareLoose=function(x,K){return E(x,K,!0)},e.rcompare=function(x,K,ee){return E(K,x,ee)},e.sort=function(x,K){return x.sort(function(ee,ge){return e.compare(ee,ge,K)})},e.rsort=function(x,K){return x.sort(function(ee,ge){return e.rcompare(ee,ge,K)})},e.gt=z,e.lt=M,e.eq=G,e.neq=W,e.gte=te,e.lte=ae,e.cmp=he,e.Comparator=pe;var ye={};function fe(x,K){if(x instanceof fe)return x.loose===K?x:new fe(x.raw,K);if(x instanceof pe)return new fe(x.value,K);if(!(this instanceof fe))return new fe(x,K);if(this.loose=K,this.raw=x,this.set=x.split(/\s*\|\|\s*/).map(function(ee){return this.parseRange(ee.trim())},this).filter(function(ee){return ee.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+x);this.format()}function me(x){return!x||x.toLowerCase()==="x"||x==="*"}function de(x,K,ee,ge,be,Oe,Se,Le,je,Ae,qe,De,Ne){return((K=me(ee)?"":me(ge)?">="+ee+".0.0":me(be)?">="+ee+"."+ge+".0":">="+K)+" "+(Le=me(je)?"":me(Ae)?"<"+(+je+1)+".0.0":me(qe)?"<"+je+"."+(+Ae+1)+".0":De?"<="+je+"."+Ae+"."+qe+"-"+De:"<="+Le)).trim()}function we(x,K){for(var ee=0;ee<x.length;ee++)if(!x[ee].test(K))return!1;if(K.prerelease.length){for(ee=0;ee<x.length;ee++)if(I(x[ee].semver),x[ee].semver!==ye&&x[ee].semver.prerelease.length>0){var ge=x[ee].semver;if(ge.major===K.major&&ge.minor===K.minor&&ge.patch===K.patch)return!0}return!1}return!0}function Ee(x,K,ee){try{K=new fe(K,ee)}catch{return!1}return K.test(x)}function Ie(x,K,ee,ge){var be,Oe,Se,Le,je;switch(x=new U(x,ge),K=new fe(K,ge),ee){case">":be=z,Oe=ae,Se=M,Le=">",je=">=";break;case"<":be=M,Oe=te,Se=z,Le="<",je="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ee(x,K,ge))return!1;for(var Ae=0;Ae<K.set.length;++Ae){var qe=K.set[Ae],De=null,Ne=null;if(qe.forEach(function(ze){ze.semver===ye&&(ze=new pe(">=0.0.0")),De=De||ze,Ne=Ne||ze,be(ze.semver,De.semver,ge)?De=ze:Se(ze.semver,Ne.semver,ge)&&(Ne=ze)}),De.operator===Le||De.operator===je||(!Ne.operator||Ne.operator===Le)&&Oe(x,Ne.semver)||Ne.operator===je&&Se(x,Ne.semver))return!1}return!0}pe.prototype.parse=function(x){var K=this.loose?P[V]:P[Z],ee=x.match(K);if(!ee)throw new TypeError("Invalid comparator: "+x);this.operator=ee[1],this.operator==="="&&(this.operator=""),ee[2]?this.semver=new U(ee[2],this.loose):this.semver=ye},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(x){return I("Comparator.test",x,this.loose),this.semver===ye||(typeof x=="string"&&(x=new U(x,this.loose)),he(x,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(x,K){if(!(x instanceof pe))throw new TypeError("a Comparator is required");var ee;if(this.operator==="")return ee=new fe(x.value,K),Ee(this.value,ee,K);if(x.operator==="")return ee=new fe(this.value,K),Ee(x.semver,ee,K);var ge=!(this.operator!==">="&&this.operator!==">"||x.operator!==">="&&x.operator!==">"),be=!(this.operator!=="<="&&this.operator!=="<"||x.operator!=="<="&&x.operator!=="<"),Oe=this.semver.version===x.semver.version,Se=!(this.operator!==">="&&this.operator!=="<="||x.operator!==">="&&x.operator!=="<="),Le=he(this.semver,"<",x.semver,K)&&(this.operator===">="||this.operator===">")&&(x.operator==="<="||x.operator==="<"),je=he(this.semver,">",x.semver,K)&&(this.operator==="<="||this.operator==="<")&&(x.operator===">="||x.operator===">");return ge||be||Oe&&Se||Le||je},e.Range=fe,fe.prototype.format=function(){return this.range=this.set.map(function(x){return x.join(" ").trim()}).join("||").trim(),this.range},fe.prototype.toString=function(){return this.range},fe.prototype.parseRange=function(x){var K=this.loose;x=x.trim(),I("range",x,K);var ee=K?P[H]:P[T];x=x.replace(ee,de),I("hyphen replace",x),x=x.replace(P[B],"$1$2$3"),I("comparator trim",x,P[B]),x=(x=(x=x.replace(P[C],"$1~")).replace(P[ue],"$1^")).split(/\s+/).join(" ");var ge=K?P[V]:P[Z],be=x.split(" ").map(function(Oe){return function(Se,Le){return I("comp",Se),Se=function(je,Ae){return je.trim().split(/\s+/).map(function(qe){return function(De,Ne){I("caret",De,Ne);var ze=Ne?P[ce]:P[le];return De.replace(ze,function(Ue,ve,Pe,ke,Re){var Fe;return I("caret",De,Ue,ve,Pe,ke,Re),me(ve)?Fe="":me(Pe)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":me(ke)?Fe=ve==="0"?">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+".0 <"+(+ve+1)+".0.0":Re?(I("replaceCaret pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+ke+Re+" <"+ve+"."+Pe+"."+(+ke+1):">="+ve+"."+Pe+"."+ke+Re+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+ke+Re+" <"+(+ve+1)+".0.0"):(I("no pr"),Fe=ve==="0"?Pe==="0"?">="+ve+"."+Pe+"."+ke+" <"+ve+"."+Pe+"."+(+ke+1):">="+ve+"."+Pe+"."+ke+" <"+ve+"."+(+Pe+1)+".0":">="+ve+"."+Pe+"."+ke+" <"+(+ve+1)+".0.0"),I("caret return",Fe),Fe})}(qe,Ae)}).join(" ")}(Se,Le),I("caret",Se),Se=function(je,Ae){return je.trim().split(/\s+/).map(function(qe){return function(De,Ne){var ze=Ne?P[ne]:P[J];return De.replace(ze,function(Ue,ve,Pe,ke,Re){var Fe;return I("tilde",De,Ue,ve,Pe,ke,Re),me(ve)?Fe="":me(Pe)?Fe=">="+ve+".0.0 <"+(+ve+1)+".0.0":me(ke)?Fe=">="+ve+"."+Pe+".0 <"+ve+"."+(+Pe+1)+".0":Re?(I("replaceTilde pr",Re),Re.charAt(0)!=="-"&&(Re="-"+Re),Fe=">="+ve+"."+Pe+"."+ke+Re+" <"+ve+"."+(+Pe+1)+".0"):Fe=">="+ve+"."+Pe+"."+ke+" <"+ve+"."+(+Pe+1)+".0",I("tilde return",Fe),Fe})}(qe,Ae)}).join(" ")}(Se,Le),I("tildes",Se),Se=function(je,Ae){return I("replaceXRanges",je,Ae),je.split(/\s+/).map(function(qe){return function(De,Ne){De=De.trim();var ze=Ne?P[k]:P[j];return De.replace(ze,function(Ue,ve,Pe,ke,Re,Fe){I("xRange",De,Ue,ve,Pe,ke,Re,Fe);var Ce=me(Pe),Me=Ce||me(ke),Te=Me||me(Re);return ve==="="&&Te&&(ve=""),Ce?Ue=ve===">"||ve==="<"?"<0.0.0":"*":ve&&Te?(Me&&(ke=0),Te&&(Re=0),ve===">"?(ve=">=",Me?(Pe=+Pe+1,ke=0,Re=0):Te&&(ke=+ke+1,Re=0)):ve==="<="&&(ve="<",Me?Pe=+Pe+1:ke=+ke+1),Ue=ve+Pe+"."+ke+"."+Re):Me?Ue=">="+Pe+".0.0 <"+(+Pe+1)+".0.0":Te&&(Ue=">="+Pe+"."+ke+".0 <"+Pe+"."+(+ke+1)+".0"),I("xRange return",Ue),Ue})}(qe,Ae)}).join(" ")}(Se,Le),I("xrange",Se),Se=function(je,Ae){return I("replaceStars",je,Ae),je.trim().replace(P[Q],"")}(Se,Le),I("stars",Se),Se}(Oe,K)}).join(" ").split(/\s+/);return this.loose&&(be=be.filter(function(Oe){return!!Oe.match(ge)})),be=be.map(function(Oe){return new pe(Oe,K)})},fe.prototype.intersects=function(x,K){if(!(x instanceof fe))throw new TypeError("a Range is required");return this.set.some(function(ee){return ee.every(function(ge){return x.set.some(function(be){return be.every(function(Oe){return ge.intersects(Oe,K)})})})})},e.toComparators=function(x,K){return new fe(x,K).set.map(function(ee){return ee.map(function(ge){return ge.value}).join(" ").trim().split(" ")})},fe.prototype.test=function(x){if(!x)return!1;typeof x=="string"&&(x=new U(x,this.loose));for(var K=0;K<this.set.length;K++)if(we(this.set[K],x))return!0;return!1},e.satisfies=Ee,e.maxSatisfying=function(x,K,ee){var ge=null,be=null;try{var Oe=new fe(K,ee)}catch{return null}return x.forEach(function(Se){Oe.test(Se)&&(ge&&be.compare(Se)!==-1||(be=new U(ge=Se,ee)))}),ge},e.minSatisfying=function(x,K,ee){var ge=null,be=null;try{var Oe=new fe(K,ee)}catch{return null}return x.forEach(function(Se){Oe.test(Se)&&(ge&&be.compare(Se)!==1||(be=new U(ge=Se,ee)))}),ge},e.validRange=function(x,K){try{return new fe(x,K).range||"*"}catch{return null}},e.ltr=function(x,K,ee){return Ie(x,K,"<",ee)},e.gtr=function(x,K,ee){return Ie(x,K,">",ee)},e.outside=Ie,e.prerelease=function(x,K){var ee=_(x,K);return ee&&ee.prerelease.length?ee.prerelease:null},e.intersects=function(x,K,ee){return x=new fe(x,ee),K=new fe(K,ee),x.intersects(K)},e.coerce=function(x){if(x instanceof U)return x;if(typeof x!="string")return null;var K=x.match(P[D]);return K==null?null:_((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,A(1))},function(X,e){var A,O,I=X.exports={};function L(){throw new Error("setTimeout has not been defined")}function N(){throw new Error("clearTimeout has not been defined")}function P(g){if(A===setTimeout)return setTimeout(g,0);if((A===L||!A)&&setTimeout)return A=setTimeout,setTimeout(g,0);try{return A(g,0)}catch{try{return A.call(null,g,0)}catch{return A.call(this,g,0)}}}(function(){try{A=typeof setTimeout=="function"?setTimeout:L}catch{A=L}try{O=typeof clearTimeout=="function"?clearTimeout:N}catch{O=N}})();var l,a=[],h=!1,b=-1;function v(){h&&l&&(h=!1,l.length?a=l.concat(a):b=-1,a.length&&y())}function y(){if(!h){var g=P(v);h=!0;for(var c=a.length;c;){for(l=a,a=[];++b<c;)l&&l[b].run();b=-1,c=a.length}l=null,h=!1,function(w){if(O===clearTimeout)return clearTimeout(w);if((O===N||!O)&&clearTimeout)return O=clearTimeout,clearTimeout(w);try{O(w)}catch{try{return O.call(null,w)}catch{return O.call(this,w)}}}(g)}}function $(g,c){this.fun=g,this.array=c}function R(){}I.nextTick=function(g){var c=new Array(arguments.length-1);if(arguments.length>1)for(var w=1;w<arguments.length;w++)c[w-1]=arguments[w];a.push(new $(g,c)),a.length!==1||h||P(y)},$.prototype.run=function(){this.fun.apply(null,this.array)},I.title="browser",I.browser=!0,I.env={},I.argv=[],I.version="",I.versions={},I.on=R,I.addListener=R,I.once=R,I.off=R,I.removeListener=R,I.removeAllListeners=R,I.emit=R,I.prependListener=R,I.prependOnceListener=R,I.listeners=function(g){return[]},I.binding=function(g){throw new Error("process.binding is not supported")},I.cwd=function(){return"/"},I.chdir=function(g){throw new Error("process.chdir is not supported")},I.umask=function(){return 0}}])}),define(se[79],re([0,1]),function(X,e){"use strict";var A;Object.defineProperty(e,"__esModule",{value:!0}),e.$Es=void 0;class O{constructor(P,l,a){this.level=P,this.key=l,this.value=a,this.forward=[]}}const I=void 0;class L{constructor(P,l=2**16){this.comparator=P,this[A]="SkipList",this.d=0,this.f=0,this.c=Math.max(1,Math.log2(l)|0),this.e=new O(this.c,I,I)}get size(){return this.f}clear(){this.e=new O(this.c,I,I),this.f=0}has(P){return!!L.g(this,P,this.comparator)}get(P){return L.g(this,P,this.comparator)?.value}set(P,l){return L.h(this,P,l,this.comparator)&&(this.f+=1),this}delete(P){const l=L.k(this,P,this.comparator);return l&&(this.f-=1),l}forEach(P,l){let a=this.e.forward[0];for(;a;)P.call(l,a.value,a.key,this),a=a.forward[0]}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let P=this.e.forward[0];for(;P;)yield[P.key,P.value],P=P.forward[0]}*keys(){let P=this.e.forward[0];for(;P;)yield P.key,P=P.forward[0]}*values(){let P=this.e.forward[0];for(;P;)yield P.value,P=P.forward[0]}toString(){let P="[SkipList]:",l=this.e.forward[0];for(;l;)P+=`node(${l.key}, ${l.value}, lvl:${l.level})`,l=l.forward[0];return P}static g(P,l,a){let h=P.e;for(let b=P.d-1;b>=0;b--)for(;h.forward[b]&&a(h.forward[b].key,l)<0;)h=h.forward[b];if(h=h.forward[0],h&&a(h.key,l)===0)return h}static h(P,l,a,h){const b=[];let v=P.e;for(let y=P.d-1;y>=0;y--){for(;v.forward[y]&&h(v.forward[y].key,l)<0;)v=v.forward[y];b[y]=v}if(v=v.forward[0],v&&h(v.key,l)===0)return v.value=a,!1;{const y=L.j(P);if(y>P.d){for(let $=P.d;$<y;$++)b[$]=P.e;P.d=y}v=new O(y,l,a);for(let $=0;$<y;$++)v.forward[$]=b[$].forward[$],b[$].forward[$]=v;return!0}}static j(P,l=.5){let a=1;for(;Math.random()<l&&a<P.c;)a+=1;return a}static k(P,l,a){const h=[];let b=P.e;for(let v=P.d-1;v>=0;v--){for(;b.forward[v]&&a(b.forward[v].key,l)<0;)b=b.forward[v];h[v]=b}if(b=b.forward[0],!b||a(b.key,l)!==0)return!1;for(let v=0;v<P.d&&h[v].forward[v]===b;v++)h[v].forward[v]=b.forward[v];for(;P.d>0&&P.e.forward[P.d-1]===I;)P.d-=1;return!0}}e.$Es=L}),define(se[46],re([0,1,9,2]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=I,e.$te=L,e.$ue=N,e.$ve=P,e.$we=a,e.$xe=h,e.$ye=b,e.$ze=v,e.$Ae=y,e.$Be=$,e.$Ce=R,e.$De=g,e.$Ee=c,e.$Fe=w,e.$Ge=p;function I(m){const f=m;return f?typeof f.read=="function":!1}function L(m){const f=m;return f?[f.on,f.pause,f.resume,f.destroy].every(n=>typeof n=="function"):!1}function N(m){const f=m;return f?L(f.stream)&&Array.isArray(f.buffer)&&typeof f.ended=="boolean":!1}function P(m,f){return new l(m,f)}class l{constructor(f,n){this.e=f,this.f=n,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(f){if(!this.a.destroyed){if(this.a.flowing)this.g(f);else if(this.b.data.push(f),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(n=>this.d.push(n))}}error(f){this.a.destroyed||(this.a.flowing?this.h(f):this.b.error.push(f))}end(f){this.a.destroyed||(typeof f<"u"&&this.write(f),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(f){this.c.data.slice(0).forEach(n=>n(f))}h(f){this.c.error.length===0?(0,A.$1)(f):this.c.error.slice(0).forEach(n=>n(f))}i(){this.c.end.slice(0).forEach(f=>f())}on(f,n){if(!this.a.destroyed)switch(f){case"data":this.c.data.push(n),this.resume();break;case"end":this.c.end.push(n),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(n),this.a.flowing&&this.k();break}}removeListener(f,n){if(this.a.destroyed)return;let r;switch(f){case"data":r=this.c.data;break;case"end":r=this.c.end;break;case"error":r=this.c.error;break}if(r){const i=r.indexOf(n);i>=0&&r.splice(i,1)}}j(){if(this.b.data.length>0){const f=this.e(this.b.data);this.g(f),this.b.data.length=0;const n=[...this.d];this.d.length=0,n.forEach(r=>r())}}k(){if(this.c.error.length>0){for(const f of this.b.error)this.h(f);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function a(m,f){const n=[];let r;for(;(r=m.read())!==null;)n.push(r);return f(n)}function h(m,f,n){const r=[];let i;for(;(i=m.read())!==null&&r.length<n;)r.push(i);return i===null&&r.length>0?f(r):{read:()=>{if(r.length>0)return r.shift();if(typeof i<"u"){const t=i;return i=void 0,t}return m.read()}}}function b(m,f){return new Promise((n,r)=>{const i=[];v(m,{onData:t=>{f&&i.push(t)},onError:t=>{f?r(t):n(void 0)},onEnd:()=>{n(f?f(i):void 0)}})})}function v(m,f,n){m.on("error",r=>{n?.isCancellationRequested||f.onError(r)}),m.on("end",()=>{n?.isCancellationRequested||f.onEnd()}),m.on("data",r=>{n?.isCancellationRequested||f.onData(r)})}function y(m,f){return new Promise((n,r)=>{const i=new O.$Tc,t=[],s=S=>{if(t.push(S),t.length>f)return i.dispose(),m.pause(),n({stream:m,buffer:t,ended:!1})},o=S=>(i.dispose(),r(S)),u=()=>(i.dispose(),n({stream:m,buffer:t,ended:!0}));i.add((0,O.$Sc)(()=>m.removeListener("error",o))),m.on("error",o),i.add((0,O.$Sc)(()=>m.removeListener("end",u))),m.on("end",u),i.add((0,O.$Sc)(()=>m.removeListener("data",s))),m.on("data",s)})}function $(m,f){const n=P(f);return n.end(m),n}function R(){const m=P(()=>{throw new Error("not supported")});return m.end(),m}function g(m){let f=!1;return{read:()=>f?null:(f=!0,m)}}function c(m,f,n){const r=P(n);return v(m,{onData:i=>r.write(f.data(i)),onError:i=>r.error(f.error?f.error(i):i),onEnd:()=>r.end()}),r}function w(m,f,n){let r=!1;return{read:()=>{const i=f.read();return r?i:(r=!0,i!==null?n([m,i]):m)}}}function p(m,f,n){let r=!1;const i=P(n);return v(f,{onData:t=>r?i.write(t):(r=!0,i.write(n([m,t]))),onError:t=>i.error(t),onEnd:()=>{r||(r=!0,i.write(m)),i.end()}}),i}}),define(se[14],re([0,1,169,46]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=a,e.$Je=h,e.$Ke=b,e.$Le=v,e.$Me=y,e.$Ne=$,e.$Oe=R,e.$Pe=g,e.$Qe=c,e.$Re=w,e.$Se=p,e.$Te=m,e.$Ue=f,e.$Ve=n,e.$We=r,e.$Xe=i,e.$Ye=t,e.$Ze=s,e.$1e=o,e.$2e=j;const I=typeof Buffer<"u",L=new A.$V(()=>new Uint8Array(256));let N,P;class l{static alloc(D){return I?new l(Buffer.allocUnsafe(D)):new l(new Uint8Array(D))}static wrap(D){return I&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new l(D)}static fromString(D,F){return!(F?.dontUseNodeBuffer||!1)&&I?new l(Buffer.from(D)):(N||(N=new TextEncoder),new l(N.encode(D)))}static fromByteArray(D){const F=l.alloc(D.length);for(let C=0,J=D.length;C<J;C++)F.buffer[C]=D[C];return F}static concat(D,F){if(typeof F>"u"){F=0;for(let ne=0,ie=D.length;ne<ie;ne++)F+=D[ne].byteLength}const C=l.alloc(F);let J=0;for(let ne=0,ie=D.length;ne<ie;ne++){const ue=D[ne];C.set(ue,J),J+=ue.byteLength}return C}constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}clone(){const D=l.alloc(this.byteLength);return D.set(this),D}toString(){return I?this.buffer.toString():(P||(P=new TextDecoder),P.decode(this.buffer))}slice(D,F){return new l(this.buffer.subarray(D,F))}set(D,F){if(D instanceof l)this.buffer.set(D.buffer,F);else if(D instanceof Uint8Array)this.buffer.set(D,F);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),F);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),F);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return v(this.buffer,D)}writeUInt32BE(D,F){y(this.buffer,D,F)}readUInt32LE(D){return $(this.buffer,D)}writeUInt32LE(D,F){R(this.buffer,D,F)}readUInt8(D){return g(this.buffer,D)}writeUInt8(D,F){c(this.buffer,D,F)}indexOf(D,F=0){return a(this.buffer,D instanceof l?D.buffer:D,F)}}e.$He=l;function a(k,D,F=0){const C=D.byteLength,J=k.byteLength;if(C===0)return 0;if(C===1)return k.indexOf(D[0]);if(C>J-F)return-1;const ne=L.value;ne.fill(D.length);for(let ce=0;ce<D.length;ce++)ne[D[ce]]=D.length-ce-1;let ie=F+D.length-1,ue=ie,le=-1;for(;ie<J;)if(k[ie]===D[ue]){if(ue===0){le=ie;break}ie--,ue--}else ie+=Math.max(D.length-ue,ne[k[ie]]),ue=D.length-1;return le}function h(k,D){return k[D+0]<<0>>>0|k[D+1]<<8>>>0}function b(k,D,F){k[F+0]=D&255,D=D>>>8,k[F+1]=D&255}function v(k,D){return k[D]*2**24+k[D+1]*2**16+k[D+2]*2**8+k[D+3]}function y(k,D,F){k[F+3]=D,D=D>>>8,k[F+2]=D,D=D>>>8,k[F+1]=D,D=D>>>8,k[F]=D}function $(k,D){return k[D+0]<<0>>>0|k[D+1]<<8>>>0|k[D+2]<<16>>>0|k[D+3]<<24>>>0}function R(k,D,F){k[F+0]=D&255,D=D>>>8,k[F+1]=D&255,D=D>>>8,k[F+2]=D&255,D=D>>>8,k[F+3]=D&255}function g(k,D){return k[D]}function c(k,D,F){k[F]=D}function w(k){return O.$we(k,D=>l.concat(D))}function p(k){return O.$De(k)}function m(k){return O.$ye(k,D=>l.concat(D))}async function f(k){return k.ended?l.concat(k.buffer):l.concat([...k.buffer,await m(k.stream)])}function n(k){return O.$Be(k,D=>l.concat(D))}function r(k){return O.$Ee(k,{data:D=>typeof D=="string"?l.fromString(D):l.wrap(D)},D=>l.concat(D))}function i(k){return O.$ve(D=>l.concat(D),k)}function t(k,D){return O.$Fe(k,D,F=>l.concat(F))}function s(k,D){return O.$Ge(k,D,F=>l.concat(F))}function o(k){let D=0,F=0,C=0;const J=new Uint8Array(Math.floor(k.length/4*3)),ne=ue=>{switch(F){case 3:J[C++]=D|ue,F=0;break;case 2:J[C++]=D|ue>>>2,D=ue<<6,F=3;break;case 1:J[C++]=D|ue>>>4,D=ue<<4,F=2;break;default:D=ue<<2,F=1}};for(let ue=0;ue<k.length;ue++){const le=k.charCodeAt(ue);if(le>=65&&le<=90)ne(le-65);else if(le>=97&&le<=122)ne(le-97+26);else if(le>=48&&le<=57)ne(le-48+52);else if(le===43||le===45)ne(62);else if(le===47||le===95)ne(63);else{if(le===61)break;throw new SyntaxError(`Unexpected base64 character ${k[ue]}`)}}const ie=C;for(;F>0;)ne(0);return l.wrap(J).slice(0,ie)}const u="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",S="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function j({buffer:k},D=!0,F=!1){const C=F?S:u;let J="";const ne=k.byteLength%3;let ie=0;for(;ie<k.byteLength-ne;ie+=3){const ue=k[ie+0],le=k[ie+1],ce=k[ie+2];J+=C[ue>>>2],J+=C[(ue<<4|le>>>4)&63],J+=C[(le<<2|ce>>>6)&63],J+=C[ce&63]}if(ne===1){const ue=k[ie+0];J+=C[ue>>>2],J+=C[ue<<4&63],D&&(J+="==")}else if(ne===2){const ue=k[ie+0],le=k[ie+1];J+=C[ue>>>2],J+=C[(ue<<4|le>>>4)&63],J+=C[le<<2&63],D&&(J+="=")}return J}}),define(se[43],re([0,1,31]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sj=e.$qj=void 0,e.$mj=O,e.$nj=I,e.$oj=L,e.$pj=P,e.$rj=R;function O(c){return I(c,0)}function I(c,w){switch(typeof c){case"object":return c===null?L(349,w):Array.isArray(c)?l(c,w):a(c,w);case"string":return P(c,w);case"boolean":return N(c,w);case"number":return L(c,w);case"undefined":return L(937,w);default:return L(617,w)}}function L(c,w){return(w<<5)-w+c|0}function N(c,w){return L(c?433:863,w)}function P(c,w){w=L(149417,w);for(let p=0,m=c.length;p<m;p++)w=L(c.charCodeAt(p),w);return w}function l(c,w){return w=L(104579,w),c.reduce((p,m)=>I(m,p),w)}function a(c,w){return w=L(181387,w),Object.keys(c).sort().reduce((p,m)=>(p=P(m,p),I(c[m],p)),w)}class h{constructor(){this.g=0}get value(){return this.g}hash(w){return this.g=I(w,this.g),this.g}}e.$qj=h;var b;(function(c){c[c.BLOCK_SIZE=64]="BLOCK_SIZE",c[c.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(b||(b={}));function v(c,w,p=32){const m=p-w,f=~((1<<m)-1);return(c<<w|(f&c)>>>m)>>>0}function y(c,w=0,p=c.byteLength,m=0){for(let f=0;f<p;f++)c[w+f]=m}function $(c,w,p="0"){for(;c.length<w;)c=p+c;return c}function R(c,w=32){return c instanceof ArrayBuffer?Array.from(new Uint8Array(c)).map(p=>p.toString(16).padStart(2,"0")).join(""):$((c>>>0).toString(16),w/4)}class g{static{this.g=new DataView(new ArrayBuffer(320))}constructor(){this.h=1732584193,this.l=4023233417,this.m=2562383102,this.n=271733878,this.o=3285377520,this.p=new Uint8Array(67),this.q=new DataView(this.p.buffer),this.r=0,this.t=0,this.u=0,this.v=!1}update(w){const p=w.length;if(p===0)return;const m=this.p;let f=this.r,n=this.u,r,i;for(n!==0?(r=n,i=-1,n=0):(r=w.charCodeAt(0),i=0);;){let t=r;if(A.$Df(r))if(i+1<p){const s=w.charCodeAt(i+1);A.$Ef(s)?(i++,t=A.$Ff(r,s)):t=65533}else{n=r;break}else A.$Ef(r)&&(t=65533);if(f=this.w(m,f,t),i++,i<p)r=w.charCodeAt(i);else break}this.r=f,this.u=n}w(w,p,m){return m<128?w[p++]=m:m<2048?(w[p++]=192|(m&1984)>>>6,w[p++]=128|(m&63)>>>0):m<65536?(w[p++]=224|(m&61440)>>>12,w[p++]=128|(m&4032)>>>6,w[p++]=128|(m&63)>>>0):(w[p++]=240|(m&1835008)>>>18,w[p++]=128|(m&258048)>>>12,w[p++]=128|(m&4032)>>>6,w[p++]=128|(m&63)>>>0),p>=64&&(this.y(),p-=64,this.t+=64,w[0]=w[64],w[1]=w[65],w[2]=w[66]),p}digest(){return this.v||(this.v=!0,this.u&&(this.u=0,this.r=this.w(this.p,this.r,65533)),this.t+=this.r,this.x()),R(this.h)+R(this.l)+R(this.m)+R(this.n)+R(this.o)}x(){this.p[this.r++]=128,y(this.p,this.r),this.r>56&&(this.y(),y(this.p));const w=8*this.t;this.q.setUint32(56,Math.floor(w/4294967296),!1),this.q.setUint32(60,w%4294967296,!1),this.y()}y(){const w=g.g,p=this.q;for(let u=0;u<64;u+=4)w.setUint32(u,p.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)w.setUint32(u,v(w.getUint32(u-12,!1)^w.getUint32(u-32,!1)^w.getUint32(u-56,!1)^w.getUint32(u-64,!1),1),!1);let m=this.h,f=this.l,n=this.m,r=this.n,i=this.o,t,s,o;for(let u=0;u<80;u++)u<20?(t=f&n|~f&r,s=1518500249):u<40?(t=f^n^r,s=1859775393):u<60?(t=f&n|f&r|n&r,s=2400959708):(t=f^n^r,s=3395469782),o=v(m,5)+t+i+s+w.getUint32(u*4,!1)&4294967295,i=r,r=n,n=v(f,30),f=m,m=o;this.h=this.h+m&4294967295,this.l=this.l+f&4294967295,this.m=this.m+n&4294967295,this.n=this.n+r&4294967295,this.o=this.o+i&4294967295}}e.$sj=g}),define(se[56],re([0,1,31]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var O;(function(I){I[I.Ignore=0]="Ignore",I[I.Info=1]="Info",I[I.Warning=2]="Warning",I[I.Error=3]="Error"})(O||(O={})),function(I){const L="error",N="warning",P="warn",l="info",a="ignore";function h(v){return v?A.$zf(L,v)?I.Error:A.$zf(N,v)||A.$zf(P,v)?I.Warning:A.$zf(l,v)?I.Info:I.Ignore:I.Ignore}I.fromValue=h;function b(v){switch(v){case I.Error:return L;case I.Warning:return N;case I.Info:return l;default:return a}}I.toString=b}(O||(O={})),e.default=O}),define(se[27],re([0,1,3]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5n=O,e.$6n=I,e.$7n=N,e.$8n=l,e.$9n=a,e.$0n=h,e.$$n=b,e.$_n=v,e.$ao=y,e.$bo=$,e.$co=R,e.$do=g,e.$eo=c;function O(w){if(!w||typeof w!="object"||w instanceof RegExp)return w;const p=Array.isArray(w)?[]:{};return Object.entries(w).forEach(([m,f])=>{p[m]=f&&typeof f=="object"?O(f):f}),p}function I(w){if(!w||typeof w!="object")return w;const p=[w];for(;p.length>0;){const m=p.shift();Object.freeze(m);for(const f in m)if(L.call(m,f)){const n=m[f];typeof n=="object"&&!Object.isFrozen(n)&&!(0,A.$bg)(n)&&p.push(n)}}return w}const L=Object.prototype.hasOwnProperty;function N(w,p){return P(w,p,new Set)}function P(w,p,m){if((0,A.$hg)(w))return w;const f=p(w);if(typeof f<"u")return f;if(Array.isArray(w)){const n=[];for(const r of w)n.push(P(r,p,m));return n}if((0,A.$ag)(w)){if(m.has(w))throw new Error("Cannot clone recursive data-structure");m.add(w);const n={};for(const r in w)L.call(w,r)&&(n[r]=P(w[r],p,m));return m.delete(w),n}return w}function l(w,p,m=!0){return(0,A.$ag)(w)?((0,A.$ag)(p)&&Object.keys(p).forEach(f=>{f in w?m&&((0,A.$ag)(w[f])&&(0,A.$ag)(p[f])?l(w[f],p[f],m):w[f]=p[f]):w[f]=p[f]}),w):p}function a(w,p){if(w===p)return!0;if(w==null||p===null||p===void 0||typeof w!=typeof p||typeof w!="object"||Array.isArray(w)!==Array.isArray(p))return!1;let m,f;if(Array.isArray(w)){if(w.length!==p.length)return!1;for(m=0;m<w.length;m++)if(!a(w[m],p[m]))return!1}else{const n=[];for(f in w)n.push(f);n.sort();const r=[];for(f in p)r.push(f);if(r.sort(),!a(n,r))return!1;for(m=0;m<n.length;m++)if(!a(w[n[m]],p[n[m]]))return!1}return!0}function h(w){const p=new Set;return JSON.stringify(w,(m,f)=>{if((0,A.$ag)(f)||Array.isArray(f)){if(p.has(f))return"[Circular]";p.add(f)}return typeof f=="bigint"?`[BigInt ${f.toString()}]`:f})}function b(w,p){const m=Object.create(null);return!w||!p||Object.keys(p).forEach(n=>{const r=w[n],i=p[n];a(r,i)||(m[n]=i)}),m}function v(w,p){const m=p.toLowerCase(),f=Object.keys(w).find(n=>n.toLowerCase()===m);return f?w[f]:w[p]}function y(w,p){const m=Object.create(null);for(const[f,n]of Object.entries(w))p(f,n)&&(m[f]=n);return m}function $(w){let p=[];for(;Object.prototype!==w;)p=p.concat(Object.getOwnPropertyNames(w)),w=Object.getPrototypeOf(w);return p}function R(w){const p=[];for(const m of $(w))typeof w[m]=="function"&&p.push(m);return p}function g(w,p){const m=n=>function(){const r=Array.prototype.slice.call(arguments,0);return p(n,r)},f={};for(const n of w)f[n]=m(n);return f}function c(w,p){const m={};for(const[f,n]of Object.entries(w))m[f]=p(n,f);return m}}),define(se[28],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=O;const A=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function O(I){return A.test(I)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let I;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?I=crypto.getRandomValues.bind(crypto):I=function(P){for(let l=0;l<P.length;l++)P[l]=Math.floor(Math.random()*256);return P};const L=new Uint8Array(16),N=[];for(let P=0;P<256;P++)N.push(P.toString(16).padStart(2,"0"));return function(){I(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let l=0,a="";return a+=N[L[l++]],a+=N[L[l++]],a+=N[L[l++]],a+=N[L[l++]],a+="-",a+=N[L[l++]],a+=N[L[l++]],a+="-",a+=N[L[l++]],a+=N[L[l++]],a+="-",a+=N[L[l++]],a+=N[L[l++]],a+="-",a+=N[L[l++]],a+=N[L[l++]],a+=N[L[l++]],a+=N[L[l++]],a+=N[L[l++]],a+=N[L[l++]],a}}()}),define(se[80],re([0,1,33]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fn=L;const O=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function I(N){const P=N.replace(/\-/g,":").toLowerCase();return!O.has(P)}function L(){const N=(0,A.networkInterfaces)();for(const P in N){const l=N[P];if(l){for(const{mac:a}of l)if(I(a))return a}}throw new Error("Unable to retrieve mac address (unexpected format)")}}),define(se[81],re([7,4]),function(X,e){return X.create("vs/base/common/date",e)}),define(se[82],re([0,1,81]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=a,e.$5m=h,e.$6m=b;const O=60,I=O*60,L=I*24,N=L*7,P=L*30,l=L*365;function a(v,y,$,R){typeof v!="number"&&(v=v.getTime());const g=Math.round((new Date().getTime()-v)/1e3);if(g<-30)return(0,A.localize)(0,null,a(new Date().getTime()+g*1e3,!1));if(!R&&g<30)return(0,A.localize)(1,null);let c;return g<O?(c=g,y?c===1?$?(0,A.localize)(2,null,c):(0,A.localize)(3,null,c):$?(0,A.localize)(4,null,c):(0,A.localize)(5,null,c):c===1?$?(0,A.localize)(6,null,c):(0,A.localize)(7,null,c):$?(0,A.localize)(8,null,c):(0,A.localize)(9,null,c)):g<I?(c=Math.floor(g/O),y?c===1?$?(0,A.localize)(10,null,c):(0,A.localize)(11,null,c):$?(0,A.localize)(12,null,c):(0,A.localize)(13,null,c):c===1?$?(0,A.localize)(14,null,c):(0,A.localize)(15,null,c):$?(0,A.localize)(16,null,c):(0,A.localize)(17,null,c)):g<L?(c=Math.floor(g/I),y?c===1?$?(0,A.localize)(18,null,c):(0,A.localize)(19,null,c):$?(0,A.localize)(20,null,c):(0,A.localize)(21,null,c):c===1?$?(0,A.localize)(22,null,c):(0,A.localize)(23,null,c):$?(0,A.localize)(24,null,c):(0,A.localize)(25,null,c)):g<N?(c=Math.floor(g/L),y?c===1?(0,A.localize)(26,null,c):(0,A.localize)(27,null,c):c===1?(0,A.localize)(28,null,c):(0,A.localize)(29,null,c)):g<P?(c=Math.floor(g/N),y?c===1?$?(0,A.localize)(30,null,c):(0,A.localize)(31,null,c):$?(0,A.localize)(32,null,c):(0,A.localize)(33,null,c):c===1?$?(0,A.localize)(34,null,c):(0,A.localize)(35,null,c):$?(0,A.localize)(36,null,c):(0,A.localize)(37,null,c)):g<l?(c=Math.floor(g/P),y?c===1?$?(0,A.localize)(38,null,c):(0,A.localize)(39,null,c):$?(0,A.localize)(40,null,c):(0,A.localize)(41,null,c):c===1?$?(0,A.localize)(42,null,c):(0,A.localize)(43,null,c):$?(0,A.localize)(44,null,c):(0,A.localize)(45,null,c)):(c=Math.floor(g/l),y?c===1?$?(0,A.localize)(46,null,c):(0,A.localize)(47,null,c):$?(0,A.localize)(48,null,c):(0,A.localize)(49,null,c):c===1?$?(0,A.localize)(50,null,c):(0,A.localize)(51,null,c):$?(0,A.localize)(52,null,c):(0,A.localize)(53,null,c))}function h(v,y){const $=Math.abs(v/1e3);return $<1?y?(0,A.localize)(54,null,v):(0,A.localize)(55,null,v):$<O?y?(0,A.localize)(56,null,Math.round(v)/1e3):(0,A.localize)(57,null,Math.round(v)/1e3):$<I?y?(0,A.localize)(58,null,Math.round(v/(1e3*O))):(0,A.localize)(59,null,Math.round(v/(1e3*O))):$<L?y?(0,A.localize)(60,null,Math.round(v/(1e3*I))):(0,A.localize)(61,null,Math.round(v/(1e3*I))):(0,A.localize)(62,null,Math.round(v/(1e3*L)))}function b(v){return v.getFullYear()+"-"+String(v.getMonth()+1).padStart(2,"0")+"-"+String(v.getDate()).padStart(2,"0")+"T"+String(v.getHours()).padStart(2,"0")+":"+String(v.getMinutes()).padStart(2,"0")+":"+String(v.getSeconds()).padStart(2,"0")+"."+(v.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(se[83],re([7,4]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(se[34],re([0,1,19,3,83]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=l,e.$kj=a,e.$lj=h;function L(b,v){return v&&(b.stack||b.stacktrace)?I.localize(0,null,P(b),N(b.stack)||N(b.stacktrace)):P(b)}function N(b){return Array.isArray(b)?b.join(`
`):b}function P(b){return b.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${b.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof b.code=="string"&&typeof b.errno=="number"&&typeof b.syscall=="string"?I.localize(1,null,b.message):b.message||I.localize(2,null)}function l(b=null,v=!1){if(!b)return I.localize(3,null);if(Array.isArray(b)){const y=A.$Hb(b),$=l(y[0],v);return y.length>1?I.localize(4,null,$,y.length):$}if(O.$$f(b))return b;if(b.detail){const y=b.detail;if(y.error)return L(y.error,v);if(y.exception)return L(y.exception,v)}return b.stack?L(b,v):b.message?b.message:I.localize(5,null)}function a(b){const v=b;return v instanceof Error&&Array.isArray(v.actions)}function h(b,v){let y;return typeof b=="string"?y=new Error(b):y=b,y.actions=v,y}}),define(se[84],re([7,4]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(se[85],re([0,1,84]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vq=O;function O(I){switch(I){case 1:return(0,A.localize)(0,null);case 2:return(0,A.localize)(1,null);case 3:return(0,A.localize)(2,null);case 4:return(0,A.localize)(3,null);case 5:return(0,A.localize)(4,null);case 6:return(0,A.localize)(5,null);case 7:return(0,A.localize)(6,null);case 8:return(0,A.localize)(7,null);case 9:return(0,A.localize)(8,null);default:return""}}}),define(se[57],re([0,1,12]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminateResponseCode=e.Source=void 0,e.$om=L,e.$pm=N;var O;(function(P){P[P.stdout=0]="stdout",P[P.stderr=1]="stderr"})(O||(e.Source=O={}));var I;(function(P){P[P.Success=0]="Success",P[P.Unknown=1]="Unknown",P[P.AccessDenied=2]="AccessDenied",P[P.ProcessNotFound=3]="ProcessNotFound"})(I||(e.TerminateResponseCode=I={}));function L(P,...l){const a=l.reduce((v,y)=>(v[y]=!0,v),{}),h=[/^ELECTRON_.+$/,/^VSCODE_(?!(PORTABLE|SHELL_LOGIN|ENV_REPLACE|ENV_APPEND|ENV_PREPEND)).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(P).filter(v=>!a[v]).forEach(v=>{for(let y=0;y<h.length;y++)if(v.search(h[y])!==-1){delete P[v];break}})}function N(P){P&&(delete P.DEBUG,A.$j&&delete P.DYLD_LIBRARY_PATH,A.$k&&delete P.LD_PRELOAD)}}),define(se[86],re([0,1,11]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1q=O,e.$2q=I,e.$3q=L,e.log=P;function O(a){const h=a;return h&&typeof h.type=="string"&&typeof h.severity=="string"}function I(a){const h=[];let b;try{const v=JSON.parse(a.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),b=y.__$stack),h.push(...v)}catch{h.push("Unable to log remote console arguments",a.arguments)}return{args:h,stack:b}}function L(a){if(typeof a!="string")return L(I(a).stack);const h=a;if(h){const b=N(h),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(b||"");if(v&&v.length===4)return{uri:A.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}function N(a){if(!a)return a;const h=a.indexOf(`
`);return h===-1?a:a.substring(0,h)}function P(a,h){const{args:b,stack:v}=I(a),y=typeof b[0]=="string"&&b.length===1;let $=N(v);$&&($=`(${$.trim()})`);let R=[];if(typeof b[0]=="string"?$&&y?R=[`%c[${h}] %c${b[0]} %c${$}`,l("blue"),l(""),l("grey")]:R=[`%c[${h}] %c${b[0]}`,l("blue"),l(""),...b.slice(1)]:R=[`%c[${h}]%`,l("blue"),...b],$&&!y&&R.push($),typeof console[a.severity]!="function")throw new Error("Unknown console method");console[a.severity].apply(console,R)}function l(a){return`color: ${a}`}}),define(se[47],re([0,1,14,11]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=I,e.$7h=L,e.$8h=P;function I(l){return JSON.stringify(l,N)}function L(l){let a=JSON.parse(l);return a=P(a),a}function N(l,a){return a instanceof RegExp?{$mid:2,source:a.source,flags:a.flags}:a}function P(l,a=0){if(!l||a>200)return l;if(typeof l=="object"){switch(l.$mid){case 1:return O.URI.revive(l);case 2:return new RegExp(l.source,l.flags);case 17:return new Date(l.source)}if(l instanceof A.$He||l instanceof Uint8Array)return l;if(Array.isArray(l))for(let h=0;h<l.length;++h)l[h]=P(l[h],a+1);else for(const h in l)Object.hasOwnProperty.call(l,h)&&(l[h]=P(l[h],a+1))}return l}}),define(se[87],re([0,1,74,15,12,11]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$aE=h;class N{constructor(v,y,$){this.id=v,this.dependencies=y,this.callback=$}}class P{static{this.INSTANCE=new P}constructor(){this.a=typeof self=="object"&&self.constructor&&self.constructor.name==="DedicatedWorkerGlobalScope",this.b=typeof document=="object",this.c=[],this.d=!1}g(){this.d||(this.d=!0,globalThis.define=(v,y,$)=>{typeof v!="string"&&($=y,y=v,v=null),(typeof y!="object"||!Array.isArray(y))&&($=y,y=null),this.c.push(new N(v,y,$))},globalThis.define.amd=!0,this.b?this.f=window.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){if(v.startsWith(window.location.origin)||v.startsWith("vscode-file://vscode-app"))return v;throw new Error(`[trusted_script_src] Invalid script url: ${v}`)}}):this.a&&(this.f=globalThis.trustedTypes?.createPolicy("amdLoader",{createScriptURL(v){return v}})))}async load(v){this.g();const y=await(this.a?this.i(v):this.b?this.h(v):this.j(v));if(!y)throw new Error(`Did not receive a define call from script ${v}`);if(Array.isArray(y.dependencies)&&y.dependencies.length>0)throw new Error(`Cannot resolve dependencies for script ${v}. The dependencies are: ${y.dependencies.join(", ")}`);return typeof y.callback=="function"?y.callback([]):y.callback}h(v){return new Promise((y,$)=>{const R=document.createElement("script");R.setAttribute("async","async"),R.setAttribute("type","text/javascript");const g=()=>{R.removeEventListener("load",c),R.removeEventListener("error",w)},c=p=>{g(),y(this.c.pop())},w=p=>{g(),$(p)};R.addEventListener("load",c),R.addEventListener("error",w),this.f&&(v=this.f.createScriptURL(v)),R.setAttribute("src",v),window.document.getElementsByTagName("head")[0].appendChild(R)})}i(v){return new Promise((y,$)=>{try{this.f&&(v=this.f.createScriptURL(v)),importScripts(v),y(this.c.pop())}catch(R){$(R)}})}async j(v){try{const y=globalThis._VSCODE_NODE_MODULES.fs,$=globalThis._VSCODE_NODE_MODULES.vm,R=globalThis._VSCODE_NODE_MODULES.module,g=L.URI.parse(v).fsPath,c=y.readFileSync(g).toString(),w=R.wrap(c.replace(/^#!.*/,""));return new $.Script(w).runInThisContext().apply(),this.c.pop()}catch(y){throw y}}}const l=new Map;let a={};typeof globalThis.require=="object"&&(a=globalThis.require.paths??{});async function h(b,v,y){if(A.$T){y===void 0&&(y=!!(globalThis._VSCODE_PRODUCT_JSON??globalThis.vscode?.context?.configuration()?.product)?.commit),a[b]&&(b=a[b]);const $=`${b}/${v}`;if(l.has($))return l.get($);let R;if(/^\w[\w\d+.-]*:\/\//.test($))R=$;else{const p=`${y&&!I.$o?O.$Pg:O.$Og}/${$}`;R=O.$Sg.asBrowserUri(p).toString(!0)}const g=P.INSTANCE.load(R);return l.set($,g),g}else return await new Promise(($,R)=>{X([b],$,R)})}}),define(se[88],re([0,1,33,48,28,80,12]),function(X,e,A,O,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gn=void 0,e.$Hn=l,e.$In=b,e.$Gn=new class{c(v){return this.a||(this.a=O.$Ei.forStrings(),this.a.set("00-50-56",!0),this.a.set("00-0C-29",!0),this.a.set("00-05-69",!0),this.a.set("00-03-FF",!0),this.a.set("00-1C-42",!0),this.a.set("00-16-3E",!0),this.a.set("08-00-27",!0),this.a.set("00:50:56",!0),this.a.set("00:0C:29",!0),this.a.set("00:05:69",!0),this.a.set("00:03:FF",!0),this.a.set("00:1C:42",!0),this.a.set("00:16:3E",!0),this.a.set("08:00:27",!0)),!!this.a.findSubstr(v)}value(){if(this.b===void 0){let v=0,y=0;const $=(0,A.networkInterfaces)();for(const R in $){const g=$[R];if(g)for(const{mac:c,internal:w}of g)w||(y+=1,this.c(c.toUpperCase())&&(v+=1))}this.b=y>0?v/y:0}return this.b}};let P;async function l(v){return P||(P=(async()=>await a(v)||I.$Ug())()),P}async function a(v){try{const y=await new Promise((R,g)=>{X(["crypto"],R,g)}),$=(0,L.$Fn)();return y.createHash("sha256").update($,"utf8").digest("hex")}catch(y){v(y);return}}const h="Software\\Microsoft\\SQMClient";async function b(v){if(N.$i){const y=await new Promise(($,R)=>{X(["@vscode/windows-registry"],$,R)});try{return y.GetStringRegKey("HKEY_LOCAL_MACHINE",h,"MachineId")||""}catch($){return v($),""}}return""}}),define(se[89],re([0,1,33,16,25]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mm=w,e.$nm=p;const L=/^\d+$/,N=/^Microsoft.PowerShell_.*/,P=/^Microsoft.PowerShellPreview_.*/;var l;(function(m){m[m.x64=0]="x64",m[m.x86=1]="x86",m[m.ARM=2]="ARM"})(l||(l={}));let a;switch(process.arch){case"ia32":a=1;break;case"arm":case"arm64":a=2;break;default:a=0;break}let h;process.env.PROCESSOR_ARCHITEW6432?h=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?h=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?h=1:h=0;class b{constructor(f,n,r){this.exePath=f,this.displayName=n,this.a=r}async exists(){return this.a===void 0&&(this.a=await I.SymlinkSupport.existsFile(this.exePath)),this.a}}function v({useAlternateBitness:m=!1}={}){return m?a===0?process.env["ProgramFiles(x86)"]||null:h===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:m=!1,findPreview:f=!1}={}){const n=v({useAlternateBitness:m});if(!n)return null;const r=O.$jc(n,"PowerShell");if(!await I.SymlinkSupport.existsDirectory(r))return null;let i=-1,t=null;for(const u of await I.Promises.readdir(r)){let S=-1;if(f){const k=u.indexOf("-");if(k<0)continue;const D=u.substring(0,k);if(!L.test(D)||u.substring(k+1)!=="preview")continue;S=parseInt(D,10)}else{if(!L.test(u))continue;S=parseInt(u,10)}if(S<=i)continue;const j=O.$jc(r,u,"pwsh.exe");await I.SymlinkSupport.existsFile(j)&&(t=j,i=S)}if(!t)return null;const s=n.includes("x86")?" (x86)":"",o=f?" Preview":"";return new b(t,`PowerShell${o}${s}`,!0)}async function $({findPreview:m}={}){if(!process.env.LOCALAPPDATA)return null;const f=O.$jc(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await I.SymlinkSupport.existsDirectory(f))return null;const{pwshMsixDirRegex:n,pwshMsixName:r}=m?{pwshMsixDirRegex:P,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:N,pwshMsixName:"PowerShell (Store)"};for(const i of await I.Promises.readdir(f))if(n.test(i)){const t=O.$jc(f,i,"pwsh.exe");return new b(t,r)}return null}function R(){const m=O.$jc(A.homedir(),".dotnet","tools","pwsh.exe");return new b(m,".NET Core PowerShell Global Tool")}function g(){const m=O.$jc(process.env.windir,a===1&&h!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new b(m,"Windows PowerShell",!0)}async function*c(){let m=await y();m&&(yield m),m=await y({useAlternateBitness:!0}),m&&(yield m),m=await $(),m&&(yield m),m=R(),m&&(yield m),m=await y({findPreview:!0}),m&&(yield m),m=await $({findPreview:!0}),m&&(yield m),m=await y({useAlternateBitness:!0,findPreview:!0}),m&&(yield m),m=g(),m&&(yield m)}async function*w(){for await(const m of c())await m.exists()&&(yield m)}async function p(){for await(const m of w())return m;return null}}),define(se[58],re([0,1,16,12,35,57,3,25]),function(X,e,A,O,I,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.TerminateResponseCode=e.Source=void 0,e.$qm=l,e.$rm=a,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function l(b=I.env){return b.comspec||"cmd.exe"}function a(b){let v=[],y=!1;const $=function(R){if(y){v.push(R);return}(!b.send(R,c=>{if(c&&console.error(c),y=!1,v.length>0){const w=v.slice(0);v=[],w.forEach(p=>$(p))}})||O.$i)&&(y=!0)};return{send:$}}var h;(function(b){async function v(y,$,R){if(A.$ic(y))return y;if($===void 0&&($=I.cwd()),A.$mc(y)!=="."||(R===void 0&&N.$$f(I.env.PATH)&&(R=I.env.PATH.split(A.$tc)),R===void 0||R.length===0))return A.$jc($,y);async function c(w){if(await P.Promises.exists(w)){let p;try{p=await P.Promises.stat(w)}catch(m){m.message.startsWith("EACCES")&&(p=await P.Promises.lstat(w))}return p?!p.isDirectory():!1}return!1}for(const w of R){let p;if(A.$ic(w)?p=A.$jc(w,y):p=A.$jc($,w,y),await c(p))return p;let m=p+".com";if(await c(m)||(m=p+".exe",await c(m)))return m}return A.$jc($,y)}b.findExecutable=v})(h||(e.win32=h={}))}),define(se[90],re([0,1,33,12,89,58]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sm=N;async function N(b,v){return b===1?O.$i?h():L.$qm(v):l(b,v)}let P=null;function l(b,v){if(O.$k&&b===2||O.$j&&b===3)return"/bin/bash";if(!P){let y;if(O.$i)y="/bin/bash";else{if(y=v.SHELL,!y)try{y=(0,A.userInfo)().shell}catch{}y||(y="sh"),y==="/bin/false"&&(y="/bin/bash")}P=y}return P}let a=null;async function h(){return a||(a=(await(0,I.$nm)()).exePath),a}});var $e=this&&this.__decorate||function(X,e,A,O){var I=arguments.length,L=I<3?e:O===null?O=Object.getOwnPropertyDescriptor(e,A):O,N;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(X,e,A,O);else for(var P=X.length-1;P>=0;P--)(N=X[P])&&(L=(I<3?N(L):I>3?N(e,A,L):N(e,A))||L);return I>3&&L&&Object.defineProperty(e,A,L),L};define(se[59],re([0,1,19,8,14,22,55,9,5,2,47,31,3]),function(X,e,A,O,I,L,N,P,l,a,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hi=e.ProxyChannel=e.$gi=e.$di=e.$ci=e.$bi=e.RequestInitiator=e.$ai=e.$0h=e.$9h=void 0,e.$$h=o,e.$_h=u,e.$ei=C,e.$fi=J;var y;(function(B){B[B.Promise=100]="Promise",B[B.PromiseCancel=101]="PromiseCancel",B[B.EventListen=102]="EventListen",B[B.EventDispose=103]="EventDispose"})(y||(y={}));function $(B){switch(B){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var R;(function(B){B[B.Initialize=200]="Initialize",B[B.PromiseSuccess=201]="PromiseSuccess",B[B.PromiseError=202]="PromiseError",B[B.PromiseErrorObj=203]="PromiseErrorObj",B[B.EventFire=204]="EventFire"})(R||(R={}));function g(B){switch(B){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var c;(function(B){B[B.Uninitialized=0]="Uninitialized",B[B.Idle=1]="Idle"})(c||(c={}));function w(B){let T=0;for(let H=0;;H+=7){const Q=B.read(1);if(T|=(Q.buffer[0]&127)<<H,!(Q.buffer[0]&128))return T}}const p=i(0);function m(B,T){if(T===0){B.write(p);return}let H=0;for(let Y=T;Y!==0;Y=Y>>>7)H++;const Q=I.$He.alloc(H);for(let Y=0;T!==0;Y++)Q.buffer[Y]=T&127,T=T>>>7,T>0&&(Q.buffer[Y]|=128);B.write(Q)}class f{constructor(T){this.b=T,this.a=0}read(T){const H=this.b.slice(this.a,this.a+T);return this.a+=H.byteLength,H}}e.$9h=f;class n{constructor(){this.a=[]}get buffer(){return I.$He.concat(this.a)}write(T){this.a.push(T)}}e.$0h=n;var r;(function(B){B[B.Undefined=0]="Undefined",B[B.String=1]="String",B[B.Buffer=2]="Buffer",B[B.VSBuffer=3]="VSBuffer",B[B.Array=4]="Array",B[B.Object=5]="Object",B[B.Int=6]="Int"})(r||(r={}));function i(B){const T=I.$He.alloc(1);return T.writeUInt8(B,0),T}const t={Undefined:i(r.Undefined),String:i(r.String),Buffer:i(r.Buffer),VSBuffer:i(r.VSBuffer),Array:i(r.Array),Object:i(r.Object),Uint:i(r.Int)},s=typeof Buffer<"u";function o(B,T){if(typeof T>"u")B.write(t.Undefined);else if(typeof T=="string"){const H=I.$He.fromString(T);B.write(t.String),m(B,H.byteLength),B.write(H)}else if(s&&Buffer.isBuffer(T)){const H=I.$He.wrap(T);B.write(t.Buffer),m(B,H.byteLength),B.write(H)}else if(T instanceof I.$He)B.write(t.VSBuffer),m(B,T.byteLength),B.write(T);else if(Array.isArray(T)){B.write(t.Array),m(B,T.length);for(const H of T)o(B,H)}else if(typeof T=="number"&&(T|0)===T)B.write(t.Uint),m(B,T);else{const H=I.$He.fromString(JSON.stringify(T));B.write(t.Object),m(B,H.byteLength),B.write(H)}}function u(B){switch(B.read(1).readUInt8(0)){case r.Undefined:return;case r.String:return B.read(w(B)).toString();case r.Buffer:return B.read(w(B)).buffer;case r.VSBuffer:return B.read(w(B));case r.Array:{const H=w(B),Q=[];for(let Y=0;Y<H;Y++)Q.push(u(B));return Q}case r.Object:return JSON.parse(B.read(w(B)).toString());case r.Int:return w(B)}}class S{constructor(T,H,Q=null,Y=1e3){this.h=T,this.j=H,this.k=Q,this.l=Y,this.b=new Map,this.d=new Map,this.g=new Map,this.f=this.h.onMessage(_=>this.q(_)),this.m({type:200})}registerChannel(T,H){this.b.set(T,H),setTimeout(()=>this.w(T),0)}m(T){switch(T.type){case 200:{const H=this.o([T.type]);this.k?.logOutgoing(H,0,1,g(T.type));return}case 201:case 202:case 204:case 203:{const H=this.o([T.type,T.id],T.data);this.k?.logOutgoing(H,T.id,1,g(T.type),T.data);return}}}o(T,H=void 0){const Q=new n;return o(Q,T),o(Q,H),this.p(Q.buffer)}p(T){try{return this.h.send(T),T.byteLength}catch{return 0}}q(T){const H=new f(T),Q=u(H),Y=u(H),_=Q[0];switch(_){case 100:return this.k?.logIncoming(T.byteLength,Q[1],1,`${$(_)}: ${Q[2]}.${Q[3]}`,Y),this.s({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:Y});case 102:return this.k?.logIncoming(T.byteLength,Q[1],1,`${$(_)}: ${Q[2]}.${Q[3]}`,Y),this.t({type:_,id:Q[1],channelName:Q[2],name:Q[3],arg:Y});case 101:return this.k?.logIncoming(T.byteLength,Q[1],1,`${$(_)}`),this.u({type:_,id:Q[1]});case 103:return this.k?.logIncoming(T.byteLength,Q[1],1,`${$(_)}`),this.u({type:_,id:Q[1]})}}s(T){const H=this.b.get(T.channelName);if(!H){this.v(T);return}const Q=new L.$qe;let Y;try{Y=H.call(this.j,T.name,T.arg,Q.token)}catch(q){Y=Promise.reject(q)}const _=T.id;Y.then(q=>{this.m({id:_,data:q,type:201})},q=>{q instanceof Error?this.m({id:_,data:{message:q.message,name:q.name,stack:q.stack?q.stack.split?q.stack.split(`
`):q.stack:void 0},type:202}):this.m({id:_,data:q,type:203})}).finally(()=>{U.dispose(),this.d.delete(T.id)});const U=(0,a.$Sc)(()=>Q.cancel());this.d.set(T.id,U)}t(T){const H=this.b.get(T.channelName);if(!H){this.v(T);return}const Q=T.id,_=H.listen(this.j,T.name,T.arg)(U=>this.m({id:Q,data:U,type:204}));this.d.set(T.id,_)}u(T){const H=this.d.get(T.id);H&&(H.dispose(),this.d.delete(T.id))}v(T){let H=this.g.get(T.channelName);H||(H=[],this.g.set(T.channelName,H));const Q=setTimeout(()=>{console.error(`Unknown channel: ${T.channelName}`),T.type===100&&this.m({id:T.id,data:{name:"Unknown channel",message:`Channel name '${T.channelName}' timed out after ${this.l}ms`,stack:void 0},type:202})},this.l);H.push({request:T,timeoutTimer:Q})}w(T){const H=this.g.get(T);if(H){for(const Q of H)switch(clearTimeout(Q.timeoutTimer),Q.request.type){case 100:this.s(Q.request);break;case 102:this.t(Q.request);break}this.g.delete(T)}}dispose(){this.f&&(this.f.dispose(),this.f=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$ai=S;var j;(function(B){B[B.LocalSide=0]="LocalSide",B[B.OtherSide=1]="OtherSide"})(j||(e.RequestInitiator=j={}));class k{constructor(T,H=null){this.l=T,this.a=!1,this.b=c.Uninitialized,this.d=new Set,this.f=new Map,this.g=0,this.k=new l.$fe,this.onDidInitialize=this.k.event,this.h=this.l.onMessage(Q=>this.s(Q)),this.j=H}getChannel(T){const H=this;return{call(Q,Y,_){return H.a?Promise.reject(new P.$5):H.m(T,Q,Y,_)},listen(Q,Y){return H.a?l.Event.None:H.o(T,Q,Y)}}}m(T,H,Q,Y=L.CancellationToken.None){const _=this.g++,q={id:_,type:100,channelName:T,name:H,arg:Q};if(Y.isCancellationRequested)return Promise.reject(new P.$5);let d;return new Promise((z,M)=>{if(Y.isCancellationRequested)return M(new P.$5);const G=()=>{const he=pe=>{switch(pe.type){case 201:this.f.delete(_),z(pe.data);break;case 202:{this.f.delete(_);const ye=new Error(pe.data.message);ye.stack=Array.isArray(pe.data.stack)?pe.data.stack.join(`
`):pe.data.stack,ye.name=pe.data.name,M(ye);break}case 203:this.f.delete(_),M(pe.data);break}};this.f.set(_,he),this.p(q)};let W=null;this.b===c.Idle?G():(W=(0,O.$lh)(he=>this.u()),W.then(()=>{W=null,G()}));const te=()=>{W?(W.cancel(),W=null):this.p({id:_,type:101}),M(new P.$5)},ae=Y.onCancellationRequested(te);d=(0,a.$Rc)((0,a.$Sc)(te),ae),this.d.add(d)}).finally(()=>{d.dispose(),this.d.delete(d)})}o(T,H,Q){const Y=this.g++,U={id:Y,type:102,channelName:T,name:H,arg:Q};let q=null;const d=new l.$fe({onWillAddFirstListener:()=>{q=(0,O.$lh)(z=>this.u()),q.then(()=>{q=null,this.d.add(d),this.p(U)})},onDidRemoveLastListener:()=>{q?(q.cancel(),q=null):(this.d.delete(d),this.p({id:Y,type:103}))}}),E=z=>d.fire(z.data);return this.f.set(Y,E),d.event}p(T){switch(T.type){case 100:case 102:{const H=this.q([T.type,T.id,T.channelName,T.name],T.arg);this.j?.logOutgoing(H,T.id,0,`${$(T.type)}: ${T.channelName}.${T.name}`,T.arg);return}case 101:case 103:{const H=this.q([T.type,T.id]);this.j?.logOutgoing(H,T.id,0,$(T.type));return}}}q(T,H=void 0){const Q=new n;return o(Q,T),o(Q,H),this.r(Q.buffer)}r(T){try{return this.l.send(T),T.byteLength}catch{return 0}}s(T){const H=new f(T),Q=u(H),Y=u(H),_=Q[0];switch(_){case 200:return this.j?.logIncoming(T.byteLength,0,0,g(_)),this.t({type:Q[0]});case 201:case 202:case 204:case 203:return this.j?.logIncoming(T.byteLength,Q[1],0,g(_),Y),this.t({type:Q[0],id:Q[1],data:Y})}}t(T){if(T.type===200){this.b=c.Idle,this.k.fire();return}this.f.get(T.id)?.(T)}get onDidInitializePromise(){return l.Event.toPromise(this.onDidInitialize)}u(){return this.b===c.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.a=!0,this.h&&(this.h.dispose(),this.h=null),(0,a.$Pc)(this.d.values()),this.d.clear()}}e.$bi=k,$e([N.$3h],k.prototype,"onDidInitializePromise",null);class D{get connections(){const T=[];return this.f.forEach(H=>T.push(H)),T}constructor(T,H,Q){this.a=new Map,this.f=new Set,this.g=new l.$fe,this.onDidAddConnection=this.g.event,this.h=new l.$fe,this.onDidRemoveConnection=this.h.event,this.j=new a.$Tc,this.j.add(T(({protocol:Y,onDidClientDisconnect:_})=>{const U=l.Event.once(Y.onMessage);this.j.add(U(q=>{const d=new f(q),E=u(d),z=new S(Y,E,H,Q),M=new k(Y,H);this.a.forEach((W,te)=>z.registerChannel(te,W));const G={channelServer:z,channelClient:M,ctx:E};this.f.add(G),this.g.fire(G),this.j.add(_(()=>{z.dispose(),M.dispose(),this.f.delete(G),this.h.fire(G)}))}))}))}getChannel(T,H){const Q=this;return{call(Y,_,U){let q;if((0,v.$mg)(H)){const E=(0,A.$3b)(Q.connections.filter(H));q=E?Promise.resolve(E):l.Event.toPromise(l.Event.filter(Q.onDidAddConnection,H))}else q=H.routeCall(Q,Y,_);const d=q.then(E=>E.channelClient.getChannel(T));return C(d).call(Y,_,U)},listen(Y,_){if((0,v.$mg)(H))return Q.k(T,H,Y,_);const U=H.routeEvent(Q,Y,_).then(q=>q.channelClient.getChannel(T));return C(U).listen(Y,_)}}}k(T,H,Q,Y){const _=this;let U;const q=new l.$fe({onWillAddFirstListener:()=>{U=new a.$Tc;const d=new l.$le,E=new Map,z=G=>{const te=G.channelClient.getChannel(T).listen(Q,Y),ae=d.add(te);E.set(G,ae)},M=G=>{const W=E.get(G);W&&(W.dispose(),E.delete(G))};_.connections.filter(H).forEach(z),l.Event.filter(_.onDidAddConnection,H)(z,void 0,U),_.onDidRemoveConnection(M,void 0,U),d.event(q.fire,q,U),U.add(d)},onDidRemoveLastListener:()=>{U?.dispose(),U=void 0}});return q.event}registerChannel(T,H){this.a.set(T,H);for(const Q of this.f)Q.channelServer.registerChannel(T,H)}dispose(){this.j.dispose();for(const T of this.f)T.channelClient.dispose(),T.channelServer.dispose();this.f.clear(),this.a.clear(),this.g.dispose(),this.h.dispose()}}e.$ci=D;class F{constructor(T,H,Q=null){const Y=new n;o(Y,H),T.send(Y.buffer),this.a=new k(T,Q),this.d=new S(T,H,Q)}getChannel(T){return this.a.getChannel(T)}registerChannel(T,H){this.d.registerChannel(T,H)}dispose(){this.a.dispose(),this.d.dispose()}}e.$di=F;function C(B){return{call(T,H,Q){return B.then(Y=>Y.call(T,H,Q))},listen(T,H){const Q=new l.$oe;return B.then(Y=>Q.input=Y.listen(T,H)),Q.event}}}function J(B){let T=!1;return{call(H,Q,Y){return T?B.call(H,Q,Y):(0,O.$zh)(0).then(()=>T=!0).then(()=>B.call(H,Q,Y))},listen(H,Q){if(T)return B.listen(H,Q);const Y=new l.$oe;return(0,O.$zh)(0).then(()=>T=!0).then(()=>Y.input=B.listen(H,Q)),Y.event}}}class ne{constructor(T){this.a=T}routeCall(T){return this.b(T)}routeEvent(T){return this.b(T)}async b(T){for(const H of T.connections)if(await Promise.resolve(this.a(H.ctx)))return Promise.resolve(H);return await l.Event.toPromise(T.onDidAddConnection),await this.b(T)}}e.$gi=ne;var ie;(function(B){function T(_,U,q){const d=_,E=q&&q.disableMarshalling,z=new Map;for(const M in d)Q(M)&&z.set(M,l.Event.buffer(d[M],!0,void 0,U));return new class{listen(M,G,W){const te=z.get(G);if(te)return te;const ae=d[G];if(typeof ae=="function"){if(Y(G))return ae.call(d,W);if(Q(G))return z.set(G,l.Event.buffer(d[G],!0,void 0,U)),z.get(G)}throw new P.$bb(`Event not found: ${G}`)}call(M,G,W){const te=d[G];if(typeof te=="function"){if(!E&&Array.isArray(W))for(let he=0;he<W.length;he++)W[he]=(0,h.$8h)(W[he]);let ae=te.apply(d,W);return ae instanceof Promise||(ae=Promise.resolve(ae)),ae}throw new P.$bb(`Method not found: ${G}`)}}}B.fromService=T;function H(_,U){const q=U&&U.disableMarshalling;return new Proxy({},{get(d,E){if(typeof E=="string")return U?.properties?.has(E)?U.properties.get(E):Y(E)?function(z){return _.listen(E,z)}:Q(E)?_.listen(E):async function(...z){let M;U&&!(0,v.$hg)(U.context)?M=[U.context,...z]:M=z;const G=await _.call(E,M);return q?G:(0,h.$8h)(G)};throw new P.$bb(`Property not found: ${String(E)}`)}})}B.toService=H;function Q(_){return _[0]==="o"&&_[1]==="n"&&b.$yf(_.charCodeAt(2))}function Y(_){return/^onDynamic/.test(_)&&b.$yf(_.charCodeAt(9))}})(ie||(e.ProxyChannel=ie={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function le(B){if(Array.isArray(B))return B;if(B&&typeof B=="object"&&typeof B.toString=="function"){const T=B.toString();if(T!=="[object Object]")return T}return B}function ce(B){return Array.isArray(B)?B.map(le):le(B)}function V(B,T,H,Q,Y,_,U){U=ce(U);const q=ue[Y],d=q[Q%q.length];let E=[`%c[${B}]%c[${String(T).padStart(7," ")}]%c[len: ${String(H).padStart(5," ")}]%c${String(Q).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${d}`];/\($/.test(_)?(E=E.concat(U),E.push(")")):E.push(U),console.log.apply(console,E)}class Z{constructor(T,H){this.d=T,this.f=H,this.a=0,this.b=0}logOutgoing(T,H,Q,Y,_){this.b+=T,V(this.d,this.b,T,H,Q,Y,_)}logIncoming(T,H,Q,Y,_){this.a+=T,V(this.f,this.a,T,H,Q,Y,_)}}e.$hi=Z}),define(se[91],re([0,1,60,8,14,22,86,9,5,2,27,58,57,59]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6q=e.$5q=void 0;class $ extends y.$ai{constructor(c){super({send:w=>{try{process.send?.(w.buffer.toString("base64"))}catch{}},onMessage:l.Event.fromNodeEventEmitter(process,"message",w=>I.$He.wrap(Buffer.from(w,"base64")))},c),process.once("disconnect",()=>this.dispose())}}e.$5q=$;class R{constructor(c,w){this.i=c,this.j=w,this.c=new Set,this.g=new Map,this.h=new l.$fe,this.onDidProcessExit=this.h.event;const p=w&&w.timeout?w.timeout:6e4;this.b=new O.$vh(p),this.d=null,this.f=null}getChannel(c){const w=this;return{call(p,m,f){return w.k(c,p,m,f)},listen(p,m){return w.l(c,p,m)}}}k(c,w,p,m=L.CancellationToken.None){if(!this.b)return Promise.reject(new Error("disposed"));if(m.isCancellationRequested)return Promise.reject(P.$6());this.b.cancel();const f=this.n(c),n=(0,O.$lh)(t=>f.call(w,p,t)),r=m.onCancellationRequested(()=>n.cancel()),i=(0,a.$Sc)(()=>n.cancel());return this.c.add(i),n.finally(()=>{r.dispose(),this.c.delete(i),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}),n}l(c,w,p){if(!this.b)return l.Event.None;this.b.cancel();let m;const f=new l.$fe({onWillAddFirstListener:()=>{m=this.n(c).listen(w,p)(f.fire,f),this.c.add(m)},onDidRemoveLastListener:()=>{this.c.delete(m),m.dispose(),this.c.size===0&&this.b&&this.b.trigger(()=>this.o())}});return f.event}get m(){if(!this.f){const c=this.j&&this.j.args?this.j.args:[],w=Object.create(null);w.env={...(0,h.$5n)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.j&&this.j.env&&(w.env={...w.env,...this.j.env}),this.j&&this.j.freshExecArgv&&(w.execArgv=[]),this.j&&typeof this.j.debug=="number"&&(w.execArgv=["--nolazy","--inspect="+this.j.debug]),this.j&&typeof this.j.debugBrk=="number"&&(w.execArgv=["--nolazy","--inspect-brk="+this.j.debugBrk]),w.execArgv===void 0&&(w.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o)).filter(o=>!o.startsWith("--vscode-"))),(0,v.$pm)(w.env),this.d=(0,A.fork)(this.i,c,w);const p=new l.$fe,f=l.Event.fromNodeEventEmitter(this.d,"message",o=>o)(o=>{if((0,N.$1q)(o)){(0,N.log)(o,`IPC Library: ${this.j.serverName}`);return}p.fire(I.$He.wrap(Buffer.from(o,"base64")))}),n=this.j.useQueue?(0,b.$rm)(this.d):this.d,r=o=>this.d&&this.d.connected&&n.send(o.buffer.toString("base64")),i=p.event,t={send:r,onMessage:i};this.f=new y.$bi(t);const s=()=>this.o();process.once("exit",s),this.d.on("error",o=>console.warn('IPC "'+this.j.serverName+'" errored with '+o)),this.d.on("exit",(o,u)=>{process.removeListener("exit",s),f.dispose(),this.c.forEach(S=>(0,a.$Pc)(S)),this.c.clear(),o!==0&&u!=="SIGTERM"&&console.warn('IPC "'+this.j.serverName+'" crashed with exit code '+o+" and signal "+u),this.b?.cancel(),this.o(),this.h.fire({code:o,signal:u})})}return this.f}n(c){let w=this.g.get(c);return w||(w=this.m.getChannel(c),this.g.set(c,w)),w}o(){this.f&&(this.d&&(this.d.kill(),this.d=null),this.f=null,this.g.clear())}dispose(){this.h.dispose(),this.b?.cancel(),this.b=void 0,this.o(),this.c.clear()}}e.$6q=R}),define(se[92],re([0,1,8,5,2,47,3]),function(X,e,A,O,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.StorageState=e.StorageHint=void 0,e.$Zp=l;var P;(function(v){v[v.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",v[v.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(P||(e.StorageHint=P={}));function l(v){const y=v;return y?.changed instanceof Map||y?.deleted instanceof Set}var a;(function(v){v[v.None=0]="None",v[v.Initialized=1]="Initialized",v[v.Closed=2]="Closed"})(a||(e.StorageState=a={}));class h extends I.$Uc{static{this.a=100}constructor(y,$=Object.create(null)){super(),this.r=y,this.s=$,this.b=this.B(new O.$ie),this.onDidChangeStorage=this.b.event,this.c=a.None,this.f=new Map,this.g=this.B(new A.$wh(h.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(y=>this.u(y)))}u(y){this.b.pause();try{y.changed?.forEach(($,R)=>this.w(R,$)),y.deleted?.forEach($=>this.w($,void 0))}finally{this.b.resume()}}w(y,$){if(this.c===a.Closed)return;let R=!1;(0,N.$hg)($)?R=this.f.delete(y):this.f.get(y)!==$&&(this.f.set(y,$),R=!0),R&&this.b.fire({key:y,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===a.None&&(this.c=a.Initialized,this.s.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(y,$){const R=this.f.get(y);return(0,N.$hg)(R)?$:R}getBoolean(y,$){const R=this.get(y);return(0,N.$hg)(R)?$:R==="true"}getNumber(y,$){const R=this.get(y);return(0,N.$hg)(R)?$:parseInt(R,10)}getObject(y,$){const R=this.get(y);return(0,N.$hg)(R)?$:(0,L.$7h)(R)}async set(y,$,R=!1){if(this.c===a.Closed)return;if((0,N.$hg)($))return this.delete(y,R);const g=(0,N.$ag)($)||Array.isArray($)?(0,L.$6h)($):String($);if(this.f.get(y)!==g)return this.f.set(y,g),this.j.set(y,g),this.h.delete(y),this.b.fire({key:y,external:R}),this.D()}async delete(y,$=!1){if(!(this.c===a.Closed||!this.f.delete(y)))return this.h.has(y)||this.h.add(y),this.j.delete(y),this.b.fire({key:y,external:$}),this.D()}async optimize(){if(this.c!==a.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=a.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const y={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(y).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(y){if(!(this.c===a.Closed||this.m))return this.D(y)}async D(y){return this.s.hint===P.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),y)}async whenFlushed(){if(this.z)return new Promise(y=>this.n.push(y))}isInMemory(){return this.s.hint===P.STORAGE_IN_MEMORY}}e.$1p=h;class b{constructor(){this.onDidChangeItemsExternal=O.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(y){y.insert?.forEach(($,R)=>this.a.set(R,$)),y.delete?.forEach($=>this.a.delete($))}async optimize(){}async close(){}}e.$2p=b}),define(se[93],re([7,4]),function(X,e){return X.create("vs/base/node/zip",e)}),define(se[49],re([0,1,61,8,16,3,25,93]),function(X,e,A,O,I,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lq=e.$kq=void 0,e.zip=g,e.$nq=c,e.$oq=p,e.$kq="end of central directory record signature not found";const l=new RegExp(e.$kq);class a extends Error{constructor(f,n){let r=n.message;switch(f){case"CorruptZip":r=`Corrupt ZIP: ${r}`;break}super(r),this.type=f,this.cause=n}}e.$lq=a;function h(m){const f=m.externalFileAttributes>>16||33188;return[448,56,7].map(n=>f&n).reduce((n,r)=>n+r,f&61440)}function b(m){if(m instanceof a)return m;let f;return l.test(m.message)&&(f="CorruptZip"),new a(f,m)}function v(m,f,n,r,i,t){const s=I.$mc(f),o=I.$jc(r,s);if(!o.startsWith(r))return Promise.reject(new Error(P.localize(0,null,f)));const u=I.$jc(r,f);let S;return t.onCancellationRequested(()=>{S?.destroy()}),Promise.resolve(N.Promises.mkdir(o,{recursive:!0})).then(()=>new Promise((j,k)=>{if(!t.isCancellationRequested)try{S=(0,A.createWriteStream)(u,{mode:n}),S.once("close",()=>j()),S.once("error",k),m.once("error",k),m.pipe(S)}catch(D){k(D)}}))}function y(m,f,n,r){let i=(0,O.$lh)(()=>Promise.resolve()),t=0;const s=r.onCancellationRequested(()=>{i.cancel(),m.close()});return new Promise((o,u)=>{const S=new O.$th,j=k=>{k.isCancellationRequested||(t++,m.readEntry())};m.once("error",u),m.once("close",()=>i.then(()=>{r.isCancellationRequested||m.entryCount===t?o():u(new a("Incomplete",new Error(P.localize(1,null,t,m.entryCount))))},u)),m.readEntry(),m.on("entry",k=>{if(r.isCancellationRequested)return;if(!n.sourcePathRegex.test(k.fileName)){j(r);return}const D=k.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(D)){const J=I.$jc(f,D);i=(0,O.$lh)(ne=>N.Promises.mkdir(J,{recursive:!0}).then(()=>j(ne)).then(void 0,u));return}const F=R(m,k),C=h(k);i=(0,O.$lh)(J=>S.queue(()=>F.then(ne=>v(ne,D,C,f,n,J).then(()=>j(J)))).then(null,u))})}).finally(()=>s.dispose())}async function $(m,f=!1){const{open:n}=await new Promise((r,i)=>{X(["yauzl"],r,i)});return new Promise((r,i)=>{n(m,f?{lazyEntries:!0}:void 0,(t,s)=>{t?i(b(t)):r((0,L.$jg)(s))})})}function R(m,f){return new Promise((n,r)=>{m.openReadStream(f,(i,t)=>{i?r(b(i)):n((0,L.$jg)(t))})})}async function g(m,f){const{ZipFile:n}=await new Promise((r,i)=>{X(["yazl"],r,i)});return new Promise((r,i)=>{const t=new n;f.forEach(o=>{o.contents?t.addBuffer(typeof o.contents=="string"?Buffer.from(o.contents,"utf8"):o.contents,o.path):o.localPath&&t.addFile(o.localPath,o.path)}),t.end();const s=(0,A.createWriteStream)(m);t.outputStream.pipe(s),t.outputStream.once("error",i),s.once("error",i),s.once("finish",()=>r(m))})}function c(m,f,n={},r){const i=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let t=$(m,!0);return n.overwrite&&(t=t.then(s=>N.Promises.rm(f).then(()=>s))),t.then(s=>y(s,f,{sourcePathRegex:i},r))}function w(m,f){return $(m).then(n=>new Promise((r,i)=>{n.on("entry",t=>{t.fileName===f&&R(n,t).then(s=>r(s),s=>i(s))}),n.once("close",()=>i(new Error(P.localize(2,null,f))))}))}function p(m,f){return w(m,f).then(n=>new Promise((r,i)=>{const t=[];n.once("error",i),n.on("data",s=>t.push(s)),n.on("end",()=>r(Buffer.concat(t)))}))}}),define(se[94],re([7,4]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(se[95],re([7,4]),function(X,e){return X.create("vs/platform/contextkey/common/contextkey",e)}),define(se[96],re([7,4]),function(X,e){return X.create("vs/platform/contextkey/common/scanner",e)}),define(se[97],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(se[98],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(se[99],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagementCLI",e)}),define(se[100],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionNls",e)}),define(se[101],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(se[102],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(se[103],re([7,4]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(se[104],re([7,4]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(se[105],re([7,4]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(se[106],re([7,4]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(se[107],re([7,4]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(se[108],re([7,4]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(se[109],re([7,4]),function(X,e){return X.create("vs/platform/log/common/log",e)}),define(se[110],re([7,4]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(se[111],re([7,4]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(se[112],re([7,4]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(se[113],re([7,4]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(se[114],re([7,4]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(se[115],re([0,1,9,96]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var I;(function(a){a[a.LParen=0]="LParen",a[a.RParen=1]="RParen",a[a.Neg=2]="Neg",a[a.Eq=3]="Eq",a[a.NotEq=4]="NotEq",a[a.Lt=5]="Lt",a[a.LtEq=6]="LtEq",a[a.Gt=7]="Gt",a[a.GtEq=8]="GtEq",a[a.RegexOp=9]="RegexOp",a[a.RegexStr=10]="RegexStr",a[a.True=11]="True",a[a.False=12]="False",a[a.In=13]="In",a[a.Not=14]="Not",a[a.And=15]="And",a[a.Or=16]="Or",a[a.Str=17]="Str",a[a.QuotedStr=18]="QuotedStr",a[a.Error=19]="Error",a[a.EOF=20]="EOF"})(I||(e.TokenType=I={}));function L(...a){switch(a.length){case 1:return(0,O.localize)(0,null,a[0]);case 2:return(0,O.localize)(1,null,a[0],a[1]);case 3:return(0,O.localize)(2,null,a[0],a[1],a[2]);default:return}}const N=(0,O.localize)(3,null),P=(0,O.localize)(4,null);class l{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(h){switch(h.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return h.isTripleEq?"===":"==";case 4:return h.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return h.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return h.lexeme;case 18:return h.lexeme;case 19:return h.lexeme;case 20:return"EOF";default:throw(0,A.$8)(`unhandled token type: ${JSON.stringify(h)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(h=>h.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(h){return this.c=h,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const b=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:b})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const b=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:b})}else this.h(126)?this.k(9):this.l(L("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(L("&&"));break;case 124:this.h(124)?this.k(16):this.l(L("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(h){return this.r()||this.c.charCodeAt(this.e)!==h?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(h){this.f.push({type:h,offset:this.d})}l(h){const b=this.d,v=this.c.substring(this.d,this.e),y={type:19,offset:this.d,lexeme:v};this.g.push({offset:b,lexeme:v,additionalInfo:h}),this.f.push(y)}n(){this.m.lastIndex=this.d;const h=this.m.exec(this.c);if(h){this.e=this.d+h[0].length;const b=this.c.substring(this.d,this.e),v=l.b.get(b);v?this.k(v):this.f.push({type:17,lexeme:b,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(N);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let h=this.e,b=!1,v=!1;for(;;){if(h>=this.c.length){this.e=h,this.l(P);return}const $=this.c.charCodeAt(h);if(b)b=!1;else if($===47&&!v){h++;break}else $===91?v=!0:$===92?b=!0:$===93&&(v=!1);h++}for(;h<this.c.length&&l.a.has(this.c.charCodeAt(h));)h++;this.e=h;const y=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:y,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=l}),define(se[116],re([0,1,82,55,15,16,35,17,11]),function(X,e,A,O,I,L,N,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8m=e.$7m=void 0,e.$9m=h,e.$0m=b,e.$7m=/^([^.]+\..+)[:=](.+)$/;class a{get appRoot(){return(0,L.$mc)(I.$Sg.asFileUri("").fsPath)}get userHome(){return l.URI.file(this.b.homeDir)}get userDataPath(){return this.b.userDataDir}get appSettingsHome(){return l.URI.file((0,L.$jc)(this.userDataPath,"User"))}get tmpDir(){return l.URI.file(this.b.tmpDir)}get cacheHome(){return l.URI.file(this.userDataPath)}get stateResource(){return(0,P.$_g)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome.with({scheme:I.Schemas.vscodeUserData})}get userDataSyncHome(){return(0,P.$_g)(this.appSettingsHome,"sync")}get logsHome(){if(!this.args.logsPath){const y=(0,A.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.$jc)(this.userDataPath,"logs",y)}return l.URI.file(this.args.logsPath)}get sync(){return this.args.sync}get machineSettingsResource(){return(0,P.$_g)(l.URI.file((0,L.$jc)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,P.$_g)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,P.$_g)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,P.$_g)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const y=N.env.VSCODE_PORTABLE;return y?l.URI.file((0,L.$jc)(y,"argv.json")):(0,P.$_g)(this.userHome,this.c.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return l.URI.file((0,L.$jc)(this.userDataPath,"Workspaces"))}get builtinExtensionsPath(){const y=this.args["builtin-extensions-dir"];return y?(0,L.$kc)(y):(0,L.$hc)((0,L.$jc)(I.$Sg.asFileUri("").fsPath,"..","extensions"))}get extensionsDownloadLocation(){const y=this.args["extensions-download-dir"];return y?l.URI.file((0,L.$kc)(y)):l.URI.file((0,L.$jc)(this.userDataPath,"CachedExtensionVSIXs"))}get extensionsPath(){const y=this.args["extensions-dir"];if(y)return(0,L.$kc)(y);const $=N.env.VSCODE_EXTENSIONS;if($)return $;const R=N.env.VSCODE_PORTABLE;return R?(0,L.$jc)(R,"extensions"):(0,P.$_g)(this.userHome,this.c.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const y=this.args.extensionDevelopmentPath;if(Array.isArray(y))return y.map($=>/^[^:/?#]+?:\/\//.test($)?l.URI.parse($):l.URI.file((0,L.$hc)($)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(y=>y==="ui"||y==="workspace"||y==="web"?y:"workspace")}get extensionTestsLocationURI(){const y=this.args.extensionTestsPath;if(y)return/^[^:/?#]+?:\/\//.test(y)?l.URI.parse(y):l.URI.file((0,L.$hc)(y))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const y=this.args["disable-extension"];if(y){if(typeof y=="string")return[y];if(Array.isArray(y)&&y.length>0)return y}return!1}get debugExtensionHost(){return h(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!N.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log?.find(y=>!e.$7m.test(y))}get extensionLogLevel(){const y=[];for(const $ of this.args.log||[]){const R=e.$7m.exec($);R&&R[1]&&R[2]&&y.push([R[1],R[2]])}return y.length?y:void 0}get serviceMachineIdResource(){return(0,P.$_g)(l.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get useInMemorySecretStorage(){return!!this.args["use-inmemory-secretstorage"]}get policyFile(){if(this.args["__enable-file-policy"]){const y=N.env.VSCODE_PORTABLE;return y?l.URI.file((0,L.$jc)(y,"policy.json")):(0,P.$_g)(this.userHome,this.c.dataFolderName,"policy.json")}}get continueOn(){return this.args.continueOn}set continueOn(y){this.args.continueOn=y}get args(){return this.a}constructor(y,$,R){this.a=y,this.b=$,this.c=R,this.editSessionId=this.args.editSessionId}}e.$8m=a,$e([O.$3h],a.prototype,"appRoot",null),$e([O.$3h],a.prototype,"userHome",null),$e([O.$3h],a.prototype,"userDataPath",null),$e([O.$3h],a.prototype,"appSettingsHome",null),$e([O.$3h],a.prototype,"tmpDir",null),$e([O.$3h],a.prototype,"cacheHome",null),$e([O.$3h],a.prototype,"stateResource",null),$e([O.$3h],a.prototype,"userRoamingDataHome",null),$e([O.$3h],a.prototype,"userDataSyncHome",null),$e([O.$3h],a.prototype,"sync",null),$e([O.$3h],a.prototype,"machineSettingsResource",null),$e([O.$3h],a.prototype,"workspaceStorageHome",null),$e([O.$3h],a.prototype,"localHistoryHome",null),$e([O.$3h],a.prototype,"keyboardLayoutResource",null),$e([O.$3h],a.prototype,"argvResource",null),$e([O.$3h],a.prototype,"isExtensionDevelopment",null),$e([O.$3h],a.prototype,"untitledWorkspacesHome",null),$e([O.$3h],a.prototype,"builtinExtensionsPath",null),$e([O.$3h],a.prototype,"extensionsPath",null),$e([O.$3h],a.prototype,"extensionDevelopmentLocationURI",null),$e([O.$3h],a.prototype,"extensionDevelopmentKind",null),$e([O.$3h],a.prototype,"extensionTestsLocationURI",null),$e([O.$3h],a.prototype,"debugExtensionHost",null),$e([O.$3h],a.prototype,"logLevel",null),$e([O.$3h],a.prototype,"extensionLogLevel",null),$e([O.$3h],a.prototype,"serviceMachineIdResource",null),$e([O.$3h],a.prototype,"disableTelemetry",null),$e([O.$3h],a.prototype,"disableWorkspaceTrust",null),$e([O.$3h],a.prototype,"useInMemorySecretStorage",null),$e([O.$3h],a.prototype,"policyFile",null);function h(v,y){return b(v["inspect-extensions"],v["inspect-brk-extensions"],5870,y,v.debugId,v.extensionEnvironment)}function b(v,y,$,R,g,c){const p=Number(y||v)||(R?null:$),m=p?!!y:!1;let f;if(c)try{f=JSON.parse(c)}catch{}return{port:p,break:m,debugId:g,env:f}}}),function(){"use strict";function X(e,A,O){function I(N,P){const l=L(N,P),a=[l];return e.isAbsolute(l)||a.unshift(O),e.resolve(...a)}function L(N,P){process.env.VSCODE_DEV&&(P="code-oss-dev");const l=process.env.VSCODE_PORTABLE;if(l)return e.join(l,"user-data");let a=process.env.VSCODE_APPDATA;if(a)return e.join(a,P);const h=N["user-data-dir"];if(h)return h;switch(process.platform){case"win32":if(a=process.env.APPDATA,!a){const b=process.env.USERPROFILE;if(typeof b!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");a=e.join(b,"AppData","Roaming")}break;case"darwin":a=e.join(A.homedir(),"Library","Application Support");break;case"linux":a=process.env.XDG_CONFIG_HOME||e.join(A.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(a,P)}return{getUserDataPath:I}}if(typeof define=="function")define(se[117],re([170,33,35]),function(e,A,O){return X(e,A,O.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("path"),A=require("os");module.exports=X(e,A,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(se[118],re([0,1,33,116,117]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$m=void 0,e.$_m=N,e.$an=P;class L extends O.$8m{constructor(a,h){super(a,{homeDir:(0,A.homedir)(),tmpDir:(0,A.tmpdir)(),userDataDir:(0,I.getUserDataPath)(a,h.nameShort)},h)}}e.$$m=L;function N(l,a){return(0,O.$0m)(l["inspect-ptyhost"],l["inspect-brk-ptyhost"],5877,a,l.extensionEnvironment)}function P(l,a){return(0,O.$0m)(l["inspect-sharedprocess"],l["inspect-brk-sharedprocess"],5879,a,l.extensionEnvironment)}}),define(se[119],re([0,1,3,100]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wq=I;function I(N,P,l,a){try{L(N,P,l,a)}catch(h){N.error(h?.message??h)}return P}function L(N,P,l,a){const h=(b,v,y)=>{const $=b[v];if((0,A.$$f)($)){const R=$,g=R.length;if(g>1&&R[0]==="%"&&R[g-1]==="%"){const c=R.substr(1,g-2);let w=l[c];w===void 0&&a&&(w=a[c]);const p=typeof w=="string"?w:w?.message,m=a?.[c],f=typeof m=="string"?m:m?.message;if(!p){f||N.warn(`[${P.name}]: ${(0,O.localize)(0,null,c)}`);return}if(y&&(v==="title"||v==="category")&&f&&f!==p){const n={value:p,original:f};b[v]=n}else b[v]=p}}else if((0,A.$ag)($))for(const R in $)$.hasOwnProperty(R)&&(R==="commands"?h($,R,!0):h($,R,y));else if(Array.isArray($))for(let R=0;R<$.length;R++)h($,R,y)};for(const b in P)P.hasOwnProperty(b)&&h(P,b)}}),define(se[50],re([0,1,17,56,104,44]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=l,e.$Lp=a,e.$Mp=h,e.$Np=b,e.$Op=v,e.$Pp=y,e.$Qp=$;const N=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,P=/^-(\d{4})(\d{2})(\d{2})$/;function l(c){return c=c.trim(),c==="*"||N.test(c)}function a(c){if(!l(c))return null;if(c=c.trim(),c==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const w=c.match(N);return w?{hasCaret:w[1]==="^",hasGreaterEquals:w[1]===">=",majorBase:w[2]==="x"?0:parseInt(w[2],10),majorMustEqual:w[2]!=="x",minorBase:w[4]==="x"?0:parseInt(w[4],10),minorMustEqual:w[4]!=="x",patchBase:w[6]==="x"?0:parseInt(w[6],10),patchMustEqual:w[6]!=="x",preRelease:w[8]||null}:null}function h(c){if(!c)return null;const w=c.majorBase,p=c.majorMustEqual,m=c.minorBase;let f=c.minorMustEqual;const n=c.patchBase;let r=c.patchMustEqual;c.hasCaret&&(w===0||(f=!1),r=!1);let i=0;if(c.preRelease){const t=P.exec(c.preRelease);if(t){const[,s,o,u]=t;i=Date.UTC(Number(s),Number(o)-1,Number(u))}}return{majorBase:w,majorMustEqual:p,minorBase:m,minorMustEqual:f,patchBase:n,patchMustEqual:r,isMinimum:c.hasGreaterEquals,notBefore:i}}function b(c,w,p){let m;typeof c=="string"?m=h(a(c)):m=c;let f;w instanceof Date?f=w.getTime():typeof w=="string"&&(f=new Date(w).getTime());let n;if(typeof p=="string"?n=h(a(p)):n=p,!m||!n)return!1;const r=m.majorBase,i=m.minorBase,t=m.patchBase;let s=n.majorBase,o=n.minorBase,u=n.patchBase;const S=n.notBefore;let j=n.majorMustEqual,k=n.minorMustEqual,D=n.patchMustEqual;return n.isMinimum?r>s?!0:r<s?!1:i>o?!0:i<o||f&&f<S?!1:t>=u:(r===1&&s===0&&(!j||!k||!D)&&(s=1,o=0,u=0,j=!0,k=!1,D=!1),r<s?!1:r>s?!j:i<o?!1:i>o?!k:t<u?!1:t>u?!D:!(f&&f<S))}function v(c,w,p,m,f){const n=[];if(typeof m.publisher<"u"&&typeof m.publisher!="string")return n.push([O.default.Error,I.localize(0,null)]),n;if(typeof m.name!="string")return n.push([O.default.Error,I.localize(1,null,"name")]),n;if(typeof m.version!="string")return n.push([O.default.Error,I.localize(2,null,"version")]),n;if(!m.engines)return n.push([O.default.Error,I.localize(3,null,"engines")]),n;if(typeof m.engines.vscode!="string")return n.push([O.default.Error,I.localize(4,null,"engines.vscode")]),n;if(typeof m.extensionDependencies<"u"&&!g(m.extensionDependencies))return n.push([O.default.Error,I.localize(5,null,"extensionDependencies")]),n;if(typeof m.activationEvents<"u"){if(!g(m.activationEvents))return n.push([O.default.Error,I.localize(6,null,"activationEvents")]),n;if(typeof m.main>"u"&&typeof m.browser>"u")return n.push([O.default.Error,I.localize(7,null,"activationEvents","main","browser")]),n}if(typeof m.extensionKind<"u"&&typeof m.main>"u"&&n.push([O.default.Warning,I.localize(8,null,"extensionKind")]),typeof m.main<"u"){if(typeof m.main!="string")return n.push([O.default.Error,I.localize(9,null,"main")]),n;{const t=(0,A.$_g)(p,m.main);(0,A.$6g)(t,p)||n.push([O.default.Warning,I.localize(10,null,t.path,p.path)])}}if(typeof m.browser<"u"){if(typeof m.browser!="string")return n.push([O.default.Error,I.localize(11,null,"browser")]),n;{const t=(0,A.$_g)(p,m.browser);(0,A.$6g)(t,p)||n.push([O.default.Warning,I.localize(12,null,t.path,p.path)])}}if(!L.valid(m.version))return n.push([O.default.Error,I.localize(13,null)]),n;const r=[];if(!y(c,w,m,f,r))for(const t of r)n.push([O.default.Error,t]);return n}function y(c,w,p,m,f){return m||typeof p.main>"u"&&typeof p.browser>"u"?!0:R(c,w,p.engines.vscode,f)}function $(c,w,p){return c==="*"||R(w,p,c)}function R(c,w,p,m=[]){const f=h(a(p));if(!f)return m.push(I.localize(14,null,p)),!1;if(f.majorBase===0){if(!f.majorMustEqual||!f.minorMustEqual)return m.push(I.localize(15,null,p)),!1}else if(!f.majorMustEqual)return m.push(I.localize(16,null,p)),!1;return b(c,w,f)?!0:(m.push(I.localize(17,null,c,p)),!1)}function g(c){if(!Array.isArray(c))return!1;for(let w=0,p=c.length;w<p;w++)if(typeof c[w]!="string")return!1;return!0}}),define(se[120],re([0,1,14,28]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$p=I;async function I(L,N,P){let l=P&&P.get("storage.serviceMachineId",-1)||null;if(l)return l;try{const h=(await N.readFile(L.serviceMachineIdResource)).value.toString();l=(0,O.$Tg)(h)?h:null}catch{l=null}if(!l){l=(0,O.$Ug)();try{await N.writeFile(L.serviceMachineIdResource,A.$He.fromString(l))}catch{}}return P?.store("storage.serviceMachineId",l,-1,1),l}}),define(se[51],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class A{constructor(I,L=[],N=!1){this.ctor=I,this.staticArguments=L,this.supportsDelayedInstantiation=N}}e.$vi=A}),define(se[121],re([0,1,51]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Cs=L,e.$Ds=N;const O=[];var I;(function(P){P[P.Eager=0]="Eager",P[P.Delayed=1]="Delayed"})(I||(e.InstantiationType=I={}));function L(P,l,a){l instanceof A.$vi||(l=new A.$vi(l,[],!!a)),O.push([P,l])}function N(){return O}}),define(se[122],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0;class A{constructor(L,N){this.key=L,this.data=N,this.incoming=new Map,this.outgoing=new Map}}e.$fr=A;class O{constructor(L){this.b=L,this.a=new Map}roots(){const L=[];for(const N of this.a.values())N.outgoing.size===0&&L.push(N);return L}insertEdge(L,N){const P=this.lookupOrInsertNode(L),l=this.lookupOrInsertNode(N);P.outgoing.set(l.key,l),l.incoming.set(P.key,P)}removeNode(L){const N=this.b(L);this.a.delete(N);for(const P of this.a.values())P.outgoing.delete(N),P.incoming.delete(N)}lookupOrInsertNode(L){const N=this.b(L);let P=this.a.get(N);return P||(P=new A(N,L),this.a.set(N,P)),P}lookup(L){return this.a.get(this.b(L))}isEmpty(){return this.a.size===0}toString(){const L=[];for(const[N,P]of this.a)L.push(`${N}
	(-> incoming)[${[...P.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...P.outgoing.keys()].join(",")}]
`);return L.join(`
`)}findCycleSlow(){for(const[L,N]of this.a){const P=new Set([L]),l=this.c(N,P);if(l)return l}}c(L,N){for(const[P,l]of L.outgoing){if(N.has(P))return[...N,P].join(" -> ");N.add(P);const a=this.c(l,N);if(a)return a;N.delete(P)}}}e.$gr=O}),define(se[29],re([0,1,3,11,10]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=L,e.$7i=N,e.$8i=l,e.$9i=a,e.$0i=h,e.$$i=b,e.$_i=v,e.$aj=$,e.$bj=R,e.$cj=g,e.$5i=(0,I.$yi)("configurationService");function L(c){return c&&typeof c=="object"&&(!c.overrideIdentifier||typeof c.overrideIdentifier=="string")&&(!c.resource||c.resource instanceof O.URI)}function N(c){return c&&typeof c=="object"&&(!c.overrideIdentifiers||Array.isArray(c.overrideIdentifiers))&&!c.overrideIdentifier&&(!c.resource||c.resource instanceof O.URI)}var P;(function(c){c[c.APPLICATION=1]="APPLICATION",c[c.USER=2]="USER",c[c.USER_LOCAL=3]="USER_LOCAL",c[c.USER_REMOTE=4]="USER_REMOTE",c[c.WORKSPACE=5]="WORKSPACE",c[c.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",c[c.DEFAULT=7]="DEFAULT",c[c.MEMORY=8]="MEMORY"})(P||(e.ConfigurationTarget=P={}));function l(c){switch(c){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function a(c){return c.applicationValue!==void 0||c.userValue!==void 0||c.userLocalValue!==void 0||c.userRemoteValue!==void 0||c.workspaceValue!==void 0||c.workspaceFolderValue!==void 0}function h(c,w){const p=Object.create(null);for(const m in c)b(p,m,c[m],w);return p}function b(c,w,p,m){const f=w.split("."),n=f.pop();let r=c;for(let i=0;i<f.length;i++){const t=f[i];let s=r[t];switch(typeof s){case"undefined":s=r[t]=Object.create(null);break;case"object":if(s===null){m(`Ignoring ${w} as ${f.slice(0,i+1).join(".")} is null`);return}break;default:m(`Ignoring ${w} as ${f.slice(0,i+1).join(".")} is ${JSON.stringify(s)}`);return}r=s}if(typeof r=="object"&&r!==null)try{r[n]=p}catch{m(`Ignoring ${w} as ${f.join(".")} is ${JSON.stringify(r)}`)}else m(`Ignoring ${w} as ${f.join(".")} is ${JSON.stringify(r)}`)}function v(c,w){const p=w.split(".");y(c,p)}function y(c,w){const p=w.shift();if(w.length===0){delete c[p];return}if(Object.keys(c).indexOf(p)!==-1){const m=c[p];typeof m=="object"&&!Array.isArray(m)&&(y(m,w),Object.keys(m).length===0&&delete c[p])}}function $(c,w,p){function m(r,i){let t=r;for(const s of i){if(typeof t!="object"||t===null)return;t=t[s]}return t}const f=w.split("."),n=m(c,f);return typeof n>"u"?p:n}function R(c,w,p){Object.keys(w).forEach(m=>{m!=="__proto__"&&(m in c?A.$ag(c[m])&&A.$ag(w[m])?R(c[m],w[m],p):p&&(c[m]=w[m]):c[m]=w[m])})}function g(c){return c.replace(/[\[\]]/g,"")}}),define(se[123],re([0,1,12,31,115,10,95,9]),function(X,e,A,O,I,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=a,e.$xj=r,e.$yj=i,e.$Rj=Y;const l=new Map;l.set("false",!1),l.set("true",!0),l.set("isMac",A.$j),l.set("isLinux",A.$k),l.set("isWindows",A.$i),l.set("isWeb",A.$o),l.set("isMacNative",A.$j&&!A.$o),l.set("isEdge",A.$H),l.set("isFirefox",A.$F),l.set("isChrome",A.$E),l.set("isSafari",A.$G);function a(q,d){if(l.get(q)!==void 0)throw(0,P.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");l.set(q,d)}const h=Object.prototype.hasOwnProperty;var b;(function(q){q[q.False=0]="False",q[q.True=1]="True",q[q.Defined=2]="Defined",q[q.Not=3]="Not",q[q.Equals=4]="Equals",q[q.NotEquals=5]="NotEquals",q[q.And=6]="And",q[q.Regex=7]="Regex",q[q.NotRegex=8]="NotRegex",q[q.Or=9]="Or",q[q.In=10]="In",q[q.NotIn=11]="NotIn",q[q.Greater=12]="Greater",q[q.GreaterEquals=13]="GreaterEquals",q[q.Smaller=14]="Smaller",q[q.SmallerEquals=15]="SmallerEquals"})(b||(e.ContextKeyExprType=b={}));const v={regexParsingWithErrorRecovery:!0},y=(0,N.localize)(0,null),$=(0,N.localize)(1,null),R=(0,N.localize)(2,null),g=(0,N.localize)(3,null),c=(0,N.localize)(4,null),w=(0,N.localize)(5,null),p=(0,N.localize)(6,null),m=(0,N.localize)(7,null);class f{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(d=v){this.k=d,this.d=new I.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(d){if(d===""){this.h.push({message:y,offset:0,lexeme:"",additionalInfo:$});return}this.f=this.d.reset(d).scan(),this.g=0,this.h=[];try{const E=this.l();if(!this.E()){const z=this.D(),M=z.type===17?w:void 0;throw this.h.push({message:c,offset:z.offset,lexeme:I.$tj.getLexeme(z),additionalInfo:M}),f.c}return E}catch(E){if(E!==f.c)throw E;return}}l(){return this.m()}m(){const d=[this.o()];for(;this.y(16);){const E=this.o();d.push(E)}return d.length===1?d[0]:n.or(...d)}o(){const d=[this.s()];for(;this.y(15);){const E=this.s();d.push(E)}return d.length===1?d[0]:n.and(...d)}s(){if(this.y(2)){const d=this.D();switch(d.type){case 11:return this.z(),s.INSTANCE;case 12:return this.z(),o.INSTANCE;case 0:{this.z();const E=this.l();return this.A(1,g),E?.negate()}case 17:return this.z(),F.create(d.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",d)}}return this.t()}t(){const d=this.D();switch(d.type){case 11:return this.z(),n.true();case 12:return this.z(),n.false();case 0:{this.z();const E=this.l();return this.A(1,g),E}case 17:{const E=d.lexeme;if(this.z(),this.y(9)){const M=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),M.type!==10)throw this.B("REGEX",M);const G=M.lexeme,W=G.lastIndexOf("/"),te=W===G.length-1?void 0:this.w(G.substring(W+1));let ae;try{ae=new RegExp(G.substring(1,W),te)}catch{throw this.B("REGEX",M)}return le.create(E,ae)}switch(M.type){case 10:case 19:{const G=[M.lexeme];this.z();let W=this.D(),te=0;for(let fe=0;fe<M.lexeme.length;fe++)M.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--;for(;!this.E()&&W.type!==15&&W.type!==16;){switch(W.type){case 0:te++;break;case 1:te--;break;case 10:case 18:for(let fe=0;fe<W.lexeme.length;fe++)W.lexeme.charCodeAt(fe)===40?te++:M.lexeme.charCodeAt(fe)===41&&te--}if(te<0)break;G.push(I.$tj.getLexeme(W)),this.z(),W=this.D()}const ae=G.join(""),he=ae.lastIndexOf("/"),pe=he===ae.length-1?void 0:this.w(ae.substring(he+1));let ye;try{ye=new RegExp(ae.substring(1,he),pe)}catch{throw this.B("REGEX",M)}return n.regex(E,ye)}case 18:{const G=M.lexeme;this.z();let W=null;if(!(0,O.$9e)(G)){const te=G.indexOf("/"),ae=G.lastIndexOf("/");if(te!==ae&&te>=0){const he=G.slice(te+1,ae),pe=G[ae+1]==="i"?"i":"";try{W=new RegExp(he,pe)}catch{throw this.B("REGEX",M)}}}if(W===null)throw this.B("REGEX",M);return le.create(E,W)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,R);const M=this.u();return n.notIn(E,M)}switch(this.D().type){case 3:{this.z();const M=this.u();if(this.x().type===18)return n.equals(E,M);switch(M){case"true":return n.has(E);case"false":return n.not(E);default:return n.equals(E,M)}}case 4:{this.z();const M=this.u();if(this.x().type===18)return n.notEquals(E,M);switch(M){case"true":return n.not(E);case"false":return n.has(E);default:return n.notEquals(E,M)}}case 5:return this.z(),ie.create(E,this.u());case 6:return this.z(),ue.create(E,this.u());case 7:return this.z(),J.create(E,this.u());case 8:return this.z(),ne.create(E,this.u());case 13:return this.z(),n.in(E,this.u());default:return n.has(E)}}case 20:throw this.h.push({message:p,offset:d.offset,lexeme:"",additionalInfo:m}),f.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const d=this.D();switch(d.type){case 17:case 18:return this.z(),d.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(d){return d.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(d){return this.C(d)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(d,E){if(this.C(d))return this.z();throw this.B(E,this.D())}B(d,E,z){const M=(0,N.localize)(8,null,d,I.$tj.getLexeme(E)),G=E.offset,W=I.$tj.getLexeme(E);return this.h.push({message:M,offset:G,lexeme:W,additionalInfo:z}),f.c}C(d){return this.D().type===d}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=f;class n{static false(){return s.INSTANCE}static true(){return o.INSTANCE}static has(d){return u.create(d)}static equals(d,E){return S.create(d,E)}static notEquals(d,E){return D.create(d,E)}static regex(d,E){return le.create(d,E)}static in(d,E){return j.create(d,E)}static notIn(d,E){return k.create(d,E)}static not(d){return F.create(d)}static and(...d){return Z.create(d,null,!0)}static or(...d){return B.create(d,null,!0)}static greater(d,E){return J.create(d,E)}static greaterEquals(d,E){return ne.create(d,E)}static smaller(d,E){return ie.create(d,E)}static smallerEquals(d,E){return ue.create(d,E)}static{this.c=new f({regexParsingWithErrorRecovery:!1})}static deserialize(d){return d==null?void 0:this.c.parse(d)}}e.$wj=n;function r(q){const d=new f({regexParsingWithErrorRecovery:!1});return q.map(E=>(d.parse(E),d.lexingErrors.length>0?d.lexingErrors.map(z=>({errorMessage:z.additionalInfo?(0,N.localize)(9,null,z.additionalInfo):(0,N.localize)(10,null),offset:z.offset,length:z.lexeme.length})):d.parsingErrors.length>0?d.parsingErrors.map(z=>({errorMessage:z.additionalInfo?`${z.message}. ${z.additionalInfo}`:z.message,offset:z.offset,length:z.lexeme.length})):[]))}function i(q,d){const E=q?q.substituteConstants():void 0,z=d?d.substituteConstants():void 0;return!E&&!z?!0:!E||!z?!1:E.equals(z)}function t(q,d){return q.cmp(d)}class s{static{this.INSTANCE=new s}constructor(){this.type=0}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!1}serialize(){return"false"}keys(){return[]}map(d){return this}negate(){return o.INSTANCE}}e.$zj=s;class o{static{this.INSTANCE=new o}constructor(){this.type=1}cmp(d){return this.type-d.type}equals(d){return d.type===this.type}substituteConstants(){return this}evaluate(d){return!0}serialize(){return"true"}keys(){return[]}map(d){return this}negate(){return s.INSTANCE}}e.$Aj=o;class u{static create(d,E=null){const z=l.get(d);return typeof z=="boolean"?z?o.INSTANCE:s.INSTANCE:new u(d,E)}constructor(d,E){this.key=d,this.c=E,this.type=2}cmp(d){return d.type!==this.type?this.type-d.type:H(this.key,d.key)}equals(d){return d.type===this.type?this.key===d.key:!1}substituteConstants(){const d=l.get(this.key);return typeof d=="boolean"?d?o.INSTANCE:s.INSTANCE:this}evaluate(d){return!!d.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(d){return d.mapDefined(this.key)}negate(){return this.c||(this.c=F.create(this.key,this)),this.c}}e.$Bj=u;class S{static create(d,E,z=null){if(typeof E=="boolean")return E?u.create(d,z):F.create(d,z);const M=l.get(d);return typeof M=="boolean"?E===(M?"true":"false")?o.INSTANCE:s.INSTANCE:new S(d,E,z)}constructor(d,E,z){this.c=d,this.d=E,this.f=z,this.type=4}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=l.get(this.c);if(typeof d=="boolean"){const E=d?"true":"false";return this.d===E?o.INSTANCE:s.INSTANCE}return this}evaluate(d){return d.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(d){return d.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=D.create(this.c,this.d,this)),this.f}}e.$Cj=S;class j{static create(d,E){return new j(d,E)}constructor(d,E){this.d=d,this.f=E,this.type=10,this.c=null}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.d,this.f,d.d,d.f)}equals(d){return d.type===this.type?this.d===d.d&&this.f===d.f:!1}substituteConstants(){return this}evaluate(d){const E=d.getValue(this.f),z=d.getValue(this.d);return Array.isArray(E)?E.includes(z):typeof z=="string"&&typeof E=="object"&&E!==null?h.call(E,z):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(d){return d.mapIn(this.d,this.f)}negate(){return this.c||(this.c=k.create(this.d,this.f)),this.c}}e.$Dj=j;class k{static create(d,E){return new k(d,E)}constructor(d,E){this.d=d,this.f=E,this.type=11,this.c=j.create(d,E)}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(d){return d.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=k;class D{static create(d,E,z=null){if(typeof E=="boolean")return E?F.create(d,z):u.create(d,z);const M=l.get(d);return typeof M=="boolean"?E===(M?"true":"false")?s.INSTANCE:o.INSTANCE:new D(d,E,z)}constructor(d,E,z){this.c=d,this.d=E,this.f=z,this.type=5}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){const d=l.get(this.c);if(typeof d=="boolean"){const E=d?"true":"false";return this.d===E?s.INSTANCE:o.INSTANCE}return this}evaluate(d){return d.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(d){return d.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=S.create(this.c,this.d,this)),this.f}}e.$Fj=D;class F{static create(d,E=null){const z=l.get(d);return typeof z=="boolean"?z?s.INSTANCE:o.INSTANCE:new F(d,E)}constructor(d,E){this.c=d,this.d=E,this.type=3}cmp(d){return d.type!==this.type?this.type-d.type:H(this.c,d.c)}equals(d){return d.type===this.type?this.c===d.c:!1}substituteConstants(){const d=l.get(this.c);return typeof d=="boolean"?d?s.INSTANCE:o.INSTANCE:this}evaluate(d){return!d.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(d){return d.mapNot(this.c)}negate(){return this.d||(this.d=u.create(this.c,this)),this.d}}e.$Gj=F;function C(q,d){if(typeof q=="string"){const E=parseFloat(q);isNaN(E)||(q=E)}return typeof q=="string"||typeof q=="number"?d(q):s.INSTANCE}class J{static create(d,E,z=null){return C(E,M=>new J(d,M,z))}constructor(d,E,z){this.c=d,this.d=E,this.f=z,this.type=12}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=ue.create(this.c,this.d,this)),this.f}}e.$Hj=J;class ne{static create(d,E,z=null){return C(E,M=>new ne(d,M,z))}constructor(d,E,z){this.c=d,this.d=E,this.f=z,this.type=13}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(d){return d.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=ie.create(this.c,this.d,this)),this.f}}e.$Ij=ne;class ie{static create(d,E,z=null){return C(E,M=>new ie(d,M,z))}constructor(d,E,z){this.c=d,this.d=E,this.f=z,this.type=14}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=ne.create(this.c,this.d,this)),this.f}}e.$Jj=ie;class ue{static create(d,E,z=null){return C(E,M=>new ue(d,M,z))}constructor(d,E,z){this.c=d,this.d=E,this.f=z,this.type=15}cmp(d){return d.type!==this.type?this.type-d.type:Q(this.c,this.d,d.c,d.d)}equals(d){return d.type===this.type?this.c===d.c&&this.d===d.d:!1}substituteConstants(){return this}evaluate(d){return typeof this.d=="string"?!1:parseFloat(d.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(d){return d.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=J.create(this.c,this.d,this)),this.f}}e.$Kj=ue;class le{static create(d,E){return new le(d,E)}constructor(d,E){this.d=d,this.f=E,this.type=7,this.c=null}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.d<d.d)return-1;if(this.d>d.d)return 1;const E=this.f?this.f.source:"",z=d.f?d.f.source:"";return E<z?-1:E>z?1:0}equals(d){if(d.type===this.type){const E=this.f?this.f.source:"",z=d.f?d.f.source:"";return this.d===d.d&&E===z}return!1}substituteConstants(){return this}evaluate(d){const E=d.getValue(this.d);return this.f?this.f.test(E):!1}serialize(){const d=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${d}`}keys(){return[this.d]}map(d){return d.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=ce.create(this)),this.c}}e.$Lj=le;class ce{static create(d){return new ce(d)}constructor(d){this.c=d,this.type=8}cmp(d){return d.type!==this.type?this.type-d.type:this.c.cmp(d.c)}equals(d){return d.type===this.type?this.c.equals(d.c):!1}substituteConstants(){return this}evaluate(d){return!this.c.evaluate(d)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(d){return new ce(this.c.map(d))}negate(){return this.c}}e.$Mj=ce;function V(q){let d=null;for(let E=0,z=q.length;E<z;E++){const M=q[E].substituteConstants();if(q[E]!==M&&d===null){d=[];for(let G=0;G<E;G++)d[G]=q[G]}d!==null&&(d[E]=M)}return d===null?q:d}class Z{static create(d,E,z){return Z.d(d,E,z)}constructor(d,E){this.expr=d,this.c=E,this.type=6}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let E=0,z=this.expr.length;E<z;E++){const M=t(this.expr[E],d.expr[E]);if(M!==0)return M}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].equals(d.expr[E]))return!1;return!0}return!1}substituteConstants(){const d=V(this.expr);return d===this.expr?this:Z.create(d,this.c,!1)}evaluate(d){for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].evaluate(d))return!1;return!0}static d(d,E,z){const M=[];let G=!1;for(const W of d)if(W){if(W.type===1){G=!0;continue}if(W.type===0)return s.INSTANCE;if(W.type===6){M.push(...W.expr);continue}M.push(W)}if(M.length===0&&G)return o.INSTANCE;if(M.length!==0){if(M.length===1)return M[0];M.sort(t);for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];for(;M.length>1;){const W=M[M.length-1];if(W.type!==9)break;M.pop();const te=M.pop(),ae=M.length===0,he=B.create(W.expr.map(pe=>Z.create([pe,te],null,z)),null,ae);he&&(M.push(he),M.sort(t))}if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let te=W+1;te<M.length;te++)if(M[W].negate().equals(M[te]))return s.INSTANCE;if(M.length===1)return M[0]}return new Z(M,E)}}serialize(){return this.expr.map(d=>d.serialize()).join(" && ")}keys(){const d=[];for(const E of this.expr)d.push(...E.keys());return d}map(d){return new Z(this.expr.map(E=>E.map(d)),null)}negate(){if(!this.c){const d=[];for(const E of this.expr)d.push(E.negate());this.c=B.create(d,this,!0)}return this.c}}e.$Nj=Z;class B{static create(d,E,z){return B.d(d,E,z)}constructor(d,E){this.expr=d,this.c=E,this.type=9}cmp(d){if(d.type!==this.type)return this.type-d.type;if(this.expr.length<d.expr.length)return-1;if(this.expr.length>d.expr.length)return 1;for(let E=0,z=this.expr.length;E<z;E++){const M=t(this.expr[E],d.expr[E]);if(M!==0)return M}return 0}equals(d){if(d.type===this.type){if(this.expr.length!==d.expr.length)return!1;for(let E=0,z=this.expr.length;E<z;E++)if(!this.expr[E].equals(d.expr[E]))return!1;return!0}return!1}substituteConstants(){const d=V(this.expr);return d===this.expr?this:B.create(d,this.c,!1)}evaluate(d){for(let E=0,z=this.expr.length;E<z;E++)if(this.expr[E].evaluate(d))return!0;return!1}static d(d,E,z){let M=[],G=!1;if(d){for(let W=0,te=d.length;W<te;W++){const ae=d[W];if(ae){if(ae.type===0){G=!0;continue}if(ae.type===1)return o.INSTANCE;if(ae.type===9){M=M.concat(ae.expr);continue}M.push(ae)}}if(M.length===0&&G)return s.INSTANCE;M.sort(t)}if(M.length!==0){if(M.length===1)return M[0];for(let W=1;W<M.length;W++)M[W-1].equals(M[W])&&(M.splice(W,1),W--);if(M.length===1)return M[0];if(z){for(let W=0;W<M.length;W++)for(let te=W+1;te<M.length;te++)if(M[W].negate().equals(M[te]))return o.INSTANCE;if(M.length===1)return M[0]}return new B(M,E)}}serialize(){return this.expr.map(d=>d.serialize()).join(" || ")}keys(){const d=[];for(const E of this.expr)d.push(...E.keys());return d}map(d){return new B(this.expr.map(E=>E.map(d)),null)}negate(){if(!this.c){const d=[];for(const E of this.expr)d.push(E.negate());for(;d.length>1;){const E=d.shift(),z=d.shift(),M=[];for(const G of U(E))for(const W of U(z))M.push(Z.create([G,W],null,!1));d.unshift(B.create(M,null,!1))}this.c=B.create(d,this,!0)}return this.c}}e.$Oj=B;class T extends u{static{this.d=[]}static all(){return T.d.values()}constructor(d,E,z){super(d,null),this.f=E,typeof z=="object"?T.d.push({...z,key:d}):z!==!0&&T.d.push({key:d,description:z,type:E!=null?typeof E:void 0})}bindTo(d){return d.createKey(this.key,this.f)}getValue(d){return d.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(d){return S.create(this.key,d)}notEqualsTo(d){return D.create(this.key,d)}}e.$Pj=T,e.$Qj=(0,L.$yi)("contextKeyService");function H(q,d){return q<d?-1:q>d?1:0}function Q(q,d,E,z){return q<E?-1:q>E?1:d<z?-1:d>z?1:0}function Y(q,d){if(q.type===0||d.type===1)return!0;if(q.type===9)return d.type===9?_(q.expr,d.expr):!1;if(d.type===9){for(const E of d.expr)if(Y(q,E))return!0;return!1}if(q.type===6){if(d.type===6)return _(d.expr,q.expr);for(const E of q.expr)if(Y(E,d))return!0;return!1}return q.equals(d)}function _(q,d){let E=0,z=0;for(;E<q.length&&z<d.length;){const M=q[E].cmp(d[z]);if(M<0)return!1;M===0&&E++,z++}return E===q.length}function U(q){return q.type===9?q.expr:[q]}}),define(se[62],re([0,1,10]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$No=void 0,e.$No=(0,A.$yi)("downloadService")}),define(se[18],re([0,1,10]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,A.$yi)("environmentService"),e.$Gi=(0,A.$zi)(e.$Fi)}),define(se[20],re([0,1,98,10]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.ExtensionManagementErrorCode=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$4o=L,e.$5o=N,e.$6o=P,e.$7o=l,e.$8o=a,e.$9o=h,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionInstallSource",e.$2o="dependecyOrPackExtensionInstall",e.$3o="clientTargetPlatform";var I;(function(p){p.COMMAND="command",p.SETTINGS_SYNC="settingsSync"})(I||(e.ExtensionInstallSource=I={}));function L(p){switch(p){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function N(p){switch(p){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function P(p,m){switch(p){case 3:return m==="x64"?"win32-x64":m==="arm64"?"win32-arm64":"unknown";case 2:return m==="x64"?"linux-x64":m==="arm64"?"linux-arm64":m==="arm"?"linux-armhf":"unknown";case"alpine":return m==="x64"?"alpine-x64":m==="arm64"?"alpine-arm64":"unknown";case 1:return m==="x64"?"darwin-x64":m==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function l(p,m){return m==="web"&&!p.includes("web")}function a(p,m,f){return l(m,f)?!1:p==="undefined"||p==="universal"?!0:p==="unknown"?!1:p===f}function h(p){return p&&typeof p=="object"&&typeof p.id=="string"&&(!p.uuid||typeof p.uuid=="string")}var b;(function(p){p[p.NoneOrRelevance=0]="NoneOrRelevance",p[p.LastUpdatedDate=1]="LastUpdatedDate",p[p.Title=2]="Title",p[p.PublisherName=3]="PublisherName",p[p.InstallCount=4]="InstallCount",p[p.PublishedDate=10]="PublishedDate",p[p.AverageRating=6]="AverageRating",p[p.WeightedRating=12]="WeightedRating"})(b||(e.SortBy=b={}));var v;(function(p){p[p.Default=0]="Default",p[p.Ascending=1]="Ascending",p[p.Descending=2]="Descending"})(v||(e.SortOrder=v={}));var y;(function(p){p.Install="install",p.Uninstall="uninstall"})(y||(e.StatisticType=y={}));var $;(function(p){p[p.None=1]="None",p[p.Install=2]="Install",p[p.Update=3]="Update",p[p.Migrate=4]="Migrate"})($||(e.InstallOperation=$={})),e.$0o=(0,O.$yi)("extensionGalleryService");var R;(function(p){p.Timeout="Timeout",p.Cancelled="Cancelled",p.Failed="Failed",p.DownloadFailedWriting="DownloadFailedWriting"})(R||(e.ExtensionGalleryErrorCode=R={}));class g extends Error{constructor(m,f){super(m),this.code=f,this.name=f}}e.$$o=g;var c;(function(p){p.Unsupported="Unsupported",p.Deprecated="Deprecated",p.Malicious="Malicious",p.Incompatible="Incompatible",p.IncompatibleTargetPlatform="IncompatibleTargetPlatform",p.ReleaseVersionNotFound="ReleaseVersionNotFound",p.Invalid="Invalid",p.Download="Download",p.DownloadSignature="DownloadSignature",p.DownloadFailedWriting="DownloadFailedWriting",p.UpdateMetadata="UpdateMetadata",p.Extract="Extract",p.Scanning="Scanning",p.ScanningExtension="ScanningExtension",p.ReadUninstalled="ReadUninstalled",p.UnsetUninstalled="UnsetUninstalled",p.Delete="Delete",p.Rename="Rename",p.IntializeDefaultProfile="IntializeDefaultProfile",p.AddToProfile="AddToProfile",p.PostInstall="PostInstall",p.CorruptZip="CorruptZip",p.IncompleteZip="IncompleteZip",p.Signature="Signature",p.NotAllowed="NotAllowed",p.Gallery="Gallery",p.Cancelled="Cancelled",p.Unknown="Unknown",p.Internal="Internal"})(c||(e.ExtensionManagementErrorCode=c={}));class w extends Error{constructor(m,f){super(m),this.code=f,this.name=f}}e.$_o=w,e.$ap=(0,O.$yi)("extensionManagementService"),e.$bp="extensionsIdentifiers/disabled",e.$cp="extensionsIdentifiers/enabled",e.$dp=(0,O.$yi)("IGlobalExtensionEnablementService"),e.$ep=(0,O.$yi)("IExtensionTipsService"),e.$fp=(0,A.localize2)(0,"Extensions"),e.$gp=(0,A.localize2)(1,"Preferences")}),define(se[63],re([0,1,14,9,106,13]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mq=N;async function N(h,b,v,y,$,R){let g;try{await P(h,b,v,y,$,R)}catch(c){g=c}finally{g&&$.errorTransformer&&(g=$.errorTransformer(g)),typeof g<"u"&&v.error(g),v.end()}}async function P(h,b,v,y,$,R){l(R);const g=await h.open(b,{create:!1});try{l(R);let c=0,w=0,p=$&&typeof $.length=="number"?$.length:void 0,m=A.$He.alloc(Math.min($.bufferSize,typeof p=="number"?p:$.bufferSize)),f=$&&typeof $.position=="number"?$.position:0,n=0;do w=await h.read(g,f,m.buffer,n,m.byteLength-n),f+=w,n+=w,c+=w,typeof p=="number"&&(p-=w),n===m.byteLength&&(await v.write(y(m)),m=A.$He.alloc(Math.min($.bufferSize,typeof p=="number"?p:$.bufferSize)),n=0);while(w>0&&(typeof p!="number"||p>0)&&l(R)&&a(c,$));if(n>0){let r=n;typeof p=="number"&&(r=Math.min(n,p)),v.write(y(m.slice(0,r)))}}catch(c){throw(0,L.$gl)(c)}finally{await h.close(g)}}function l(h){if(h.isCancellationRequested)throw(0,O.$6)();return!0}function a(h,b){if(typeof b?.limits?.size=="number"&&h>b.limits.size)throw(0,L.$fl)((0,I.localize)(0,null),L.FileSystemProviderErrorCode.FileTooLarge);return!0}}),define(se[124],re([0,1,61,2,52,5,11,8]),function(X,e,A,O,I,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8q=void 0;class l extends O.$Uc{constructor(){super(),this.a=this.B(new L.$fe),this.onDidChangeFile=this.a.event,this.b=this.B(new L.$fe),this.onDidLogMessage=this.b.event,this.c=this.B(new L.$fe),this.f=this.c.event,this.g=new Set,this.h=new Map,this.j=this.B(new O.$4c),this.m=new Set,this.n=5007,this.r=new P.$Vh,this.P=!1,this.B(this.f(h=>this.s(h)))}s(h){this.t(h)&&this.w(h)}t(h){return(0,I.$Oq)(h)}async watch(h){this.r.isSettled||this.r.complete(),this.r=new P.$Vh;try{this.h.clear(),this.g.clear();for(const b of h)this.t(b)?this.h.set(b.correlationId,b):this.g.add(b);for(const[b]of this.j)this.h.has(b)||(this.j.deleteAndDispose(b),this.m.delete(b));return await this.u()}finally{this.r.complete()}}u(){return this.L([...this.g,...Array.from(this.h.values()).filter(h=>!this.j.has(h.correlationId))])}isSuspended(h){return typeof h.correlationId!="number"?!1:this.m.has(h.correlationId)?"polling":this.j.has(h.correlationId)}async w(h){if(this.j.has(h.correlationId))return;const b=new O.$Tc;this.j.set(h.correlationId,b),await this.r.p,!b.isDisposed&&(this.z(h,b),this.u())}y(h){this.j.deleteAndDispose(h.correlationId),this.m.delete(h.correlationId),this.u()}z(h,b){this.C(h,b)?(this.N(`reusing an existing recursive watcher to monitor ${h.path}`),this.m.delete(h.correlationId)):(this.D(h,b),this.m.add(h.correlationId))}C(h,b){const v=this.M?.subscribe(h.path,(y,$)=>{b.isDisposed||(y?this.z(h,b):$?.type===1&&this.F(h))});return v?(b.add(v),!0):!1}D(h,b){let v=!1;const y=($,R)=>{if(b.isDisposed)return;const g=this.G($),c=this.G(R),w=v;v=g,!g&&(c||w)&&this.F(h)};this.N(`starting fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,A.watchFile)(h.path,{persistent:!1,interval:this.n},y)}catch($){this.O(`fs.watchFile() failed with error ${$} on path ${h.path} (correlationId: ${h.correlationId})`)}b.add((0,O.$Sc)(()=>{this.N(`stopping fs.watchFile() on ${h.path} (correlationId: ${h.correlationId})`);try{(0,A.unwatchFile)(h.path,y)}catch($){this.O(`fs.unwatchFile() failed with error ${$} on path ${h.path} (correlationId: ${h.correlationId})`)}}))}F(h){this.N(`detected ${h.path} exists again, resuming watcher (correlationId: ${h.correlationId})`);const b={resource:N.URI.file(h.path),type:1,cId:h.correlationId};this.a.fire([b]),this.H(b,h),this.y(h)}G(h){return h.ctimeMs===0&&h.ino===0}async stop(){this.j.clearAndDisposeAll(),this.m.clear()}H(h,b){if(this.P){const v=` >> normalized ${h.type===1?"[ADDED]":h.type===2?"[DELETED]":"[CHANGED]"} ${h.resource.fsPath}`;this.I(v,b)}}I(h,b){this.P&&this.N(`${h}${typeof b.correlationId=="number"?` <${b.correlationId}> `:""}`)}J(h){return`${h.path} (excludes: ${h.excludes.length>0?h.excludes:"<none>"}, includes: ${h.includes&&h.includes.length>0?JSON.stringify(h.includes):"<all>"}, filter: ${(0,I.$Yq)(h.filter)}, correlationId: ${typeof h.correlationId=="number"?h.correlationId:"<none>"})`}async setVerboseLogging(h){this.P=h}}e.$8q=l}),define(se[125],re([0,1,5,171,124,12,172,64]),function(X,e,A,O,I,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cr=void 0;class l extends I.$8q{constructor(h){super(),this.M=h,this.onDidError=A.Event.None,this.watchers=new Set}async L(h){h=this.X(h);const b=[],v=new Set(Array.from(this.watchers));for(const y of h){const $=this.S(y);$&&(0,O.$wk)($.request.excludes,y.excludes)&&(0,O.$wk)($.request.includes,y.includes)?v.delete($):b.push(y)}b.length&&this.N(`Request to start watching: ${b.map(y=>this.J(y)).join(",")}`),v.size&&this.N(`Request to stop watching: ${Array.from(v).map(y=>this.J(y.request)).join(",")}`);for(const y of v)this.W(y);for(const y of b)this.U(y)}S(h){for(const b of this.watchers)if(typeof h.correlationId=="number"||typeof b.request.correlationId=="number"){if(b.request.correlationId===h.correlationId)return b}else if((0,P.$wg)(b.request.path,h.path,!L.$k))return b}U(h){const b=new N.$ar(h,this.M,y=>this.a.fire(y),()=>this.c.fire(h),y=>this.b.fire(y),this.P),v={request:h,instance:b};this.watchers.add(v)}async stop(){await super.stop();for(const h of this.watchers)this.W(h)}W(h){this.N("stopping file watcher",h),this.watchers.delete(h),h.instance.dispose()}X(h){const b=new Map;for(const v of h){const y=L.$k?v.path:v.path.toLowerCase();let $=b.get(v.correlationId);$||($=new Map,b.set(v.correlationId,$)),$.has(y)&&this.N(`ignoring a request for watching who's path is already watched: ${this.J(v)}`),$.set(y,v)}return Array.from(b.values()).map(v=>Array.from(v.values())).flat()}async setVerboseLogging(h){super.setVerboseLogging(h);for(const b of this.watchers)b.instance.setVerboseLogging(h)}N(h,b){this.P&&this.b.fire({type:"trace",message:this.$(h,b)})}O(h){this.b.fire({type:"warn",message:this.$(h)})}$(h,b){return b?`[File Watcher (node.js)] ${h} (${this.J(b.request)})`:`[File Watcher (node.js)] ${h}`}}e.$cr=l}),define(se[126],re([0,1,52,125]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dr=void 0;class I extends A.$Rq{constructor(N,P,l){super(N,P,l),this.s()}r(N){return N.add(new O.$cr(void 0))}}e.$dr=I}),define(se[127],re([0,1,15,59,91,52]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7q=void 0;class N extends L.$Sq{constructor(l,a,h){super(l,a,h),this.s()}r(l){const a=l.add(new I.$6q(A.$Sg.asFileUri("bootstrap-fork").fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return l.add(a.onDidProcessExit(({code:h,signal:b})=>this.t(`terminated by itself with code ${h}, signal: ${b} (ETERM)`))),O.ProxyChannel.toService((0,O.$fi)(a.getChannel("watcher")))}}e.$7q=N}),define(se[65],re([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class A{constructor(...I){this.a=new Map;for(const[L,N]of I)this.set(L,N)}set(I,L){const N=this.a.get(I);return this.a.set(I,L),N}has(I){return this.a.has(I)}get(I){return this.a.get(I)}}e.$wi=A}),define(se[128],re([0,1,8,9,2,51,122,10,65,173]),function(X,e,A,O,I,L,N,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0;const h=!1;class b extends Error{constructor(g){super("cyclic dependency between services"),this.message=g.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${g.toString()}`}}class v{constructor(g=new l.$wi,c=!1,w,p=h){this.i=g,this.j=c,this.k=w,this.l=p,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(P.$xi,this),this._globalGraph=p?w?._globalGraph??new N.$gr(m=>m):void 0}dispose(){if(!this.f){this.f=!0,(0,I.$Pc)(this.h),this.h.clear();for(const g of this.g)(0,I.$Oc)(g)&&g.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(g){this.m();const c=new class extends v{dispose(){this.h.delete(c),super.dispose()}}(g,this.j,this,this.l);return this.h.add(c),c}invokeFunction(g,...c){this.m();const w=$.traceInvocation(this.l,g);let p=!1;try{return g({get:f=>{if(p)throw(0,O.$8)("service accessor is only valid during the invocation of its target method");const n=this.s(f,w);if(!n)throw new Error(`[invokeFunction] unknown service '${f}'`);return n}},...c)}finally{p=!0,w.stop()}}createInstance(g,...c){this.m();let w,p;return g instanceof L.$vi?(w=$.traceCreation(this.l,g.ctor),p=this.o(g.ctor,g.staticArguments.concat(c),w)):(w=$.traceCreation(this.l,g),p=this.o(g,c,w)),w.stop(),p}o(g,c=[],w){const p=P._util.getServiceDependencies(g).sort((n,r)=>n.index-r.index),m=[];for(const n of p){const r=this.s(n.id,w);r||this.y(`[createInstance] ${g.name} depends on UNKNOWN service ${n.id}.`,!1),m.push(r)}const f=p.length>0?p[0].index:c.length;if(c.length!==f){console.trace(`[createInstance] First service dependency of ${g.name} at position ${f+1} conflicts with ${c.length} static arguments`);const n=f-c.length;n>0?c=c.concat(new Array(n)):c=c.slice(0,f)}return Reflect.construct(g,c.concat(m))}q(g,c){if(this.i.get(g)instanceof L.$vi)this.i.set(g,c);else if(this.k)this.k.q(g,c);else throw new Error("illegalState - setting UNKNOWN service instance")}r(g){const c=this.i.get(g);return!c&&this.k?this.k.r(g):c}s(g,c){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(g));const w=this.r(g);return w instanceof L.$vi?this.u(g,w,c.branch(g,!0)):(c.branch(g,!1),w)}u(g,c,w){if(this.t.has(g))throw new Error(`illegal state - RECURSIVELY instantiating service '${g}'`);this.t.add(g);try{return this.v(g,c,w)}finally{this.t.delete(g)}}v(g,c,w){const p=new N.$gr(n=>n.id.toString());let m=0;const f=[{id:g,desc:c,_trace:w}];for(;f.length;){const n=f.pop();if(p.lookupOrInsertNode(n),m++>1e3)throw new b(p);for(const r of P._util.getServiceDependencies(n.desc.ctor)){const i=this.r(r.id);if(i||this.y(`[createInstance] ${g} depends on ${r.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(n.id),String(r.id)),i instanceof L.$vi){const t={id:r.id,desc:i,_trace:n._trace.branch(r.id,!0)};p.insertEdge(n,t),f.push(t)}}}for(;;){const n=p.roots();if(n.length===0){if(!p.isEmpty())throw new b(p);break}for(const{data:r}of n){if(this.r(r.id)instanceof L.$vi){const t=this.w(r.id,r.desc.ctor,r.desc.staticArguments,r.desc.supportsDelayedInstantiation,r._trace);this.q(r.id,t)}p.removeNode(r)}}return this.r(g)}w(g,c,w=[],p,m){if(this.i.get(g)instanceof L.$vi)return this.x(g,c,w,p,m,this.g);if(this.k)return this.k.w(g,c,w,p,m);throw new Error(`illegalState - creating UNKNOWN service instance ${c.name}`)}x(g,c,w=[],p,m,f){if(p){const n=new v(void 0,this.j,this,this.l);n.c=String(g);const r=new Map,i=new A.$Rh(()=>{const t=n.o(c,w,m);for(const[s,o]of r){const u=t[s];if(typeof u=="function")for(const S of o)S.disposable=u.apply(t,S.listener)}return r.clear(),f.add(t),t});return new Proxy(Object.create(null),{get(t,s){if(!i.isInitialized&&typeof s=="string"&&(s.startsWith("onDid")||s.startsWith("onWill"))){let S=r.get(s);return S||(S=new a.$5c,r.set(s,S)),(k,D,F)=>{if(i.isInitialized)return i.value[s](k,D,F);{const C={listener:[k,D,F],disposable:void 0},J=S.push(C);return(0,I.$Sc)(()=>{J(),C.disposable?.dispose()})}}}if(s in t)return t[s];const o=i.value;let u=o[s];return typeof u!="function"||(u=u.bind(o),t[s]=u),u},set(t,s,o){return i.value[s]=o,!0},getPrototypeOf(t){return c.prototype}})}else{const n=this.o(c,w,m);return f.add(n),n}}y(g,c){if(c&&console.warn(g),this.j)throw new Error(g)}}e.$hr=v;var y;(function(R){R[R.None=0]="None",R[R.Creation=1]="Creation",R[R.Invocation=2]="Invocation",R[R.Branch=3]="Branch"})(y||(y={}));class ${static{this.all=new Set}static{this.c=new class extends ${constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(g,c){return g?new $(2,c.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):$.c}static traceCreation(g,c){return g?new $(1,c.name):$.c}static{this.f=0}constructor(g,c){this.type=g,this.name=c,this.g=Date.now(),this.h=[]}branch(g,c){const w=new $(3,g.toString());return this.h.push([g,c,w]),w}stop(){const g=Date.now()-this.g;$.f+=g;let c=!1;function w(m,f){const n=[],r=new Array(m+1).join("	");for(const[i,t,s]of f.h)if(t&&s){c=!0,n.push(`${r}CREATES -> ${i}`);const o=w(m+1,s);o&&n.push(o)}else n.push(`${r}uses -> ${i}`);return n.join(`
`)}const p=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${w(1,this)}`,`DONE, took ${g.toFixed(2)}ms (grand total ${$.f.toFixed(2)}ms)`];(g>2||c)&&$.all.add(p.join(`
`))}}e.$ir=$});var oe=this&&this.__param||function(X,e){return function(A,O){e(A,O,X)}};define(se[66],re([0,1,22,2,12,108,20,10]),function(X,e,A,O,I,L,N,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xr=e.$Wr=void 0,e.$Vr=l;function l(h){return h.tags.find(b=>b.startsWith("lp-"))?.split("lp-")[1]}e.$Wr=(0,P.$yi)("languagePackService");let a=class extends O.$Uc{constructor(b){super(),this.c=b}async getAvailableLanguages(){const b=new A.$qe;setTimeout(()=>b.cancel(),1e3);let v;try{v=await this.c.query({text:'category:"language packs"',pageSize:20},b.token)}catch{return[]}const $=v.firstPage.filter(R=>R.properties.localizedLanguages?.length&&R.tags.some(g=>g.startsWith("lp-"))).map(R=>{const g=R.properties.localizedLanguages?.[0],c=l(R);return{...this.f(c,g,R),extensionId:R.identifier.id,galleryExtension:R}});return $.push(this.f("en","English")),$}f(b,v,y){const $=v??b;let R;if($!==b&&(R=`(${b})`),b.toLowerCase()===I.$w.toLowerCase()&&(R??="",R+=(0,L.localize)(0,null)),y?.installCount){R??="";const g=y.installCount;let c;g>1e6?c=`${Math.floor(g/1e5)/10}M`:g>1e3?c=`${Math.floor(g/1e3)}K`:c=String(g),R+=` $(cloud-download) ${c}`}return{id:b,label:$,description:R}}};e.$Xr=a,e.$Xr=a=$e([oe(0,N.$0o)],a)}),define(se[6],re([0,1,109,34,5,43,2,30,12,17,3,11,123,10]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=R,e.log=c,e.$gk=u,e.$hk=S,e.$ik=j,e.$jk=k,e.$5j=(0,y.$yi)("logService"),e.$6j=(0,y.$yi)("loggerService");function $(){return new Date().toISOString()}function R(D){return(0,h.$cg)(D)}var g;(function(D){D[D.Off=0]="Off",D[D.Trace=1]="Trace",D[D.Debug=2]="Debug",D[D.Info=3]="Info",D[D.Warning=4]="Warning",D[D.Error=5]="Error"})(g||(e.LogLevel=g={})),e.$8j=g.Info;function c(D,F,C){switch(F){case g.Trace:D.trace(C);break;case g.Debug:D.debug(C);break;case g.Info:D.info(C);break;case g.Warning:D.warn(C);break;case g.Error:D.error(C);break;case g.Off:break;default:throw new Error(`Invalid log level ${F}`)}}function w(D,F=!1){let C="";for(let J=0;J<D.length;J++){let ne=D[J];if(ne instanceof Error&&(ne=(0,O.$jj)(ne,F)),typeof ne=="object")try{ne=JSON.stringify(ne)}catch{}C+=(J>0?" ":"")+ne}return C}class p extends N.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new I.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(F){this.b!==F&&(this.b=F,this.c.fire(this.b))}getLevel(){return this.b}f(F){return this.b!==g.Off&&this.b<=F}}e.$0j=p;class m extends p{constructor(F){super(),this.h=F}f(F){return this.h||super.f(F)}trace(F,...C){this.f(g.Trace)&&this.g(g.Trace,w([F,...C],!0))}debug(F,...C){this.f(g.Debug)&&this.g(g.Debug,w([F,...C]))}info(F,...C){this.f(g.Info)&&this.g(g.Info,w([F,...C]))}warn(F,...C){this.f(g.Warning)&&this.g(g.Warning,w([F,...C]))}error(F,...C){if(this.f(g.Error))if(F instanceof Error){const J=Array.prototype.slice.call(arguments);J[0]=F.stack,this.g(g.Error,w(J))}else this.g(g.Error,w([F,...C]))}flush(){}}e.$$j=m;class f extends p{constructor(F=e.$8j){super(),this.setLevel(F),this.g=!l.$i}trace(F,...C){this.f(g.Trace)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,F,...C):console.log(`[main ${$()}]`,F,...C))}debug(F,...C){this.f(g.Debug)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,F,...C):console.log(`[main ${$()}]`,F,...C))}info(F,...C){this.f(g.Info)&&(this.g?console.log(`\x1B[90m[main ${$()}]\x1B[0m`,F,...C):console.log(`[main ${$()}]`,F,...C))}warn(F,...C){this.f(g.Warning)&&(this.g?console.warn(`\x1B[93m[main ${$()}]\x1B[0m`,F,...C):console.warn(`[main ${$()}]`,F,...C))}error(F,...C){this.f(g.Error)&&(this.g?console.error(`\x1B[91m[main ${$()}]\x1B[0m`,F,...C):console.error(`[main ${$()}]`,F,...C))}flush(){}}e.$_j=f;class n extends p{constructor(F=e.$8j,C=!0){super(),this.g=C,this.setLevel(F)}trace(F,...C){this.f(g.Trace)&&(this.g?console.log("%cTRACE","color: #888",F,...C):console.log(F,...C))}debug(F,...C){this.f(g.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",F,...C):console.log(F,...C))}info(F,...C){this.f(g.Info)&&(this.g?console.log("%c INFO","color: #33f",F,...C):console.log(F,...C))}warn(F,...C){this.f(g.Warning)&&(this.g?console.log("%c WARN","color: #993",F,...C):console.log(F,...C))}error(F,...C){this.f(g.Error)&&(this.g?console.log("%c  ERR","color: #f33",F,...C):console.error(F,...C))}flush(){}}e.$ak=n;class r extends p{constructor(F,C=e.$8j){super(),this.g=F,this.setLevel(C)}trace(F,...C){this.f(g.Trace)&&this.g.log(g.Trace,[this.h(F),...C])}debug(F,...C){this.f(g.Debug)&&this.g.log(g.Debug,[this.h(F),...C])}info(F,...C){this.f(g.Info)&&this.g.log(g.Info,[this.h(F),...C])}warn(F,...C){this.f(g.Warning)&&this.g.log(g.Warning,[this.h(F),...C])}error(F,...C){this.f(g.Error)&&this.g.log(g.Error,[this.h(F),...C])}h(F){return typeof F=="string"?F:(0,O.$jj)(F,this.f(g.Trace))}flush(){}}e.$bk=r;class i extends p{constructor(F){super(),this.g=F,F.length&&this.setLevel(F[0].getLevel())}setLevel(F){for(const C of this.g)C.setLevel(F);super.setLevel(F)}trace(F,...C){for(const J of this.g)J.trace(F,...C)}debug(F,...C){for(const J of this.g)J.debug(F,...C)}info(F,...C){for(const J of this.g)J.info(F,...C)}warn(F,...C){for(const J of this.g)J.warn(F,...C)}error(F,...C){for(const J of this.g)J.error(F,...C)}flush(){for(const F of this.g)F.flush()}dispose(){for(const F of this.g)F.dispose();super.dispose()}}e.$ck=i;class t extends N.$Uc{constructor(F,C,J){if(super(),this.h=F,this.j=C,this.b=new P.$Ac,this.c=this.B(new I.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new I.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new I.$fe),this.onDidChangeVisibility=this.g.event,J)for(const ne of J)this.b.set(ne.resource,{logger:void 0,info:ne})}m(F){return(0,h.$$f)(F)?[...this.b.values()].find(C=>C.info.id===F):this.b.get(F)}getLogger(F){return this.m(F)?.logger}createLogger(F,C){const J=this.n(F),ne=(0,h.$$f)(F)?F:C?.id??(0,L.$mj)(J.toString()).toString(16);let ie=this.b.get(J)?.logger;const ue=C?.logLevel==="always"?g.Trace:C?.logLevel;ie||(ie=this.s(J,ue??this.getLogLevel(J)??this.h,{...C,id:ne}));const le={logger:ie,info:{resource:J,id:ne,logLevel:ue,name:C?.name,hidden:C?.hidden,extensionId:C?.extensionId,when:C?.when}};return this.registerLogger(le.info),this.b.set(J,le),ie}n(F){return(0,h.$$f)(F)?(0,a.$_g)(this.j,`${F}.log`):F}setLogLevel(F,C){if(b.URI.isUri(F)){const J=F,ne=C,ie=this.b.get(J);ie&&ne!==ie.info.logLevel&&(ie.info.logLevel=ne===this.h?void 0:ne,ie.logger?.setLevel(ne),this.b.set(ie.info.resource,ie),this.f.fire([J,ne]))}else{this.h=F;for(const[J,ne]of this.b.entries())this.b.get(J)?.info.logLevel===void 0&&ne.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(F,C){const J=this.m(F);J&&C!==!J.info.hidden&&(J.info.hidden=!C,this.b.set(J.info.resource,J),this.g.fire([J.info.resource,C]))}getLogLevel(F){let C;return F&&(C=this.b.get(F)?.info.logLevel),C??this.h}registerLogger(F){const C=this.b.get(F.resource);C?C.info.hidden!==F.hidden&&this.setVisibility(F.resource,!F.hidden):(this.b.set(F.resource,{info:F,logger:void 0}),this.c.fire({added:[F],removed:[]}))}deregisterLogger(F){const C=this.b.get(F);C&&(C.logger&&C.logger.dispose(),this.b.delete(F),this.c.fire({added:[],removed:[C.info]}))}*getRegisteredLoggers(){for(const F of this.b.values())yield F.info}getRegisteredLogger(F){return this.b.get(F)?.info}dispose(){this.b.forEach(F=>F.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=t;class s{constructor(){this.onDidChangeLogLevel=new I.$fe().event}setLevel(F){}getLevel(){return g.Info}trace(F,...C){}debug(F,...C){}info(F,...C){}warn(F,...C){}error(F,...C){}critical(F,...C){}dispose(){}flush(){}}e.$ek=s;class o extends s{}e.$fk=o;function u(D){if(D.verbose)return g.Trace;if(typeof D.logLevel=="string"){const F=k(D.logLevel.toLowerCase());if(F!==void 0)return F}return e.$8j}function S(D){switch(D){case g.Trace:return"trace";case g.Debug:return"debug";case g.Info:return"info";case g.Warning:return"warn";case g.Error:return"error";case g.Off:return"off"}}function j(D){switch(D){case g.Trace:return{original:"Trace",value:A.localize(0,null)};case g.Debug:return{original:"Debug",value:A.localize(1,null)};case g.Info:return{original:"Info",value:A.localize(2,null)};case g.Warning:return{original:"Warning",value:A.localize(3,null)};case g.Error:return{original:"Error",value:A.localize(4,null)};case g.Off:return{original:"Off",value:A.localize(5,null)}}}function k(D){switch(D){case"trace":return g.Trace;case"debug":return g.Debug;case"info":return g.Info;case"warn":return g.Warning;case"error":return g.Error;case"critical":return g.Error;case"off":return g.Off}}e.$kk=new v.$Pj("logLevel",S(g.Info))}),define(se[129],re([0,1,19,8,9,5,64,2,16,52,6]),function(X,e,A,O,I,L,N,P,l,a,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zq=void 0;class b extends P.$Uc{constructor(y,$){super(),this.a=y,this.b=$,this.c=this.B(new L.$fe),this.onDidChangeFile=this.c.event,this.g=this.B(new L.$fe),this.onDidWatchError=this.g.event,this.j=[],this.m=this.B(new O.$wh(0)),this.w=[],this.y=this.B(new O.$wh(0))}watch(y,$){return $.recursive||this.b?.watcher?.forceUniversal?this.n(y,$):this.z(y,$)}n(y,$){const R={path:this.J(y),excludes:$.excludes,includes:$.includes,recursive:$.recursive,filter:$.filter,correlationId:$.correlationId},g=(0,A.$Tb)(this.j,R);return this.r(),(0,P.$Sc)(()=>{g(),this.r()})}r(){this.m.trigger(()=>this.s()).catch(y=>(0,I.$1)(y))}s(){this.h||(this.h=this.B(this.t($=>this.c.fire((0,a.$Tq)($)),$=>this.G($),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.h?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)})));const y=this.b?.watcher?.recursive?.usePolling;if(y===!0)for(const $ of this.j)(0,a.$Pq)($)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(y))for(const $ of this.j)(0,a.$Pq)($)&&y.includes($.path)&&($.pollingInterval=this.b?.watcher?.recursive?.pollingInterval??5e3);return this.h.watch(this.j)}z(y,$){const R={path:this.J(y),excludes:$.excludes,includes:$.includes,recursive:!1,filter:$.filter,correlationId:$.correlationId},g=(0,A.$Tb)(this.w,R);return this.C(),(0,P.$Sc)(()=>{g(),this.C()})}C(){this.y.trigger(()=>this.D()).catch(y=>(0,I.$1)(y))}D(){return this.u||(this.u=this.B(this.F(y=>this.c.fire((0,a.$Tq)(y)),y=>this.G(y),this.a.getLevel()===h.LogLevel.Trace)),this.B(this.a.onDidChangeLogLevel(()=>{this.u?.setVerboseLogging(this.a.getLevel()===h.LogLevel.Trace)}))),this.u.watch(this.w)}G(y){y.type==="error"&&this.g.fire(y.message),this.H(y)}H(y){this.a[y.type](y.message)}I(y){return(0,l.$hc)(y.fsPath)}J(y){const $=this.I(y);return(0,N.$Ag)($)}}e.$Zq=b}),define(se[130],re([0,1,19,8,14,22,5,43,67,2,48,15,131,17,46,105,13,63,6,9]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w,p){"use strict";var m;Object.defineProperty(e,"__esModule",{value:!0}),e.$Nq=void 0;let f=class extends a.$Uc{static{m=this}constructor(r){super(),this.b=r,this.a=256*1024,this.c=this.B(new N.$fe),this.onDidChangeFileSystemProviderRegistrations=this.c.event,this.f=this.B(new N.$fe),this.onWillActivateFileSystemProvider=this.f.event,this.g=this.B(new N.$fe),this.onDidChangeFileSystemProviderCapabilities=this.g.event,this.h=new Map,this.r=this.B(new N.$fe),this.onDidRunOperation=this.r.event,this.X=this.B(new N.$fe),this.Y=this.B(new N.$fe),this.onDidFilesChange=this.Y.event,this.Z=this.B(new N.$fe),this.onDidWatchError=this.Z.event,this.$=new Map,this.cb=this.B(new O.$Hh)}registerProvider(r,i){if(this.h.has(r))throw new Error(`A filesystem provider for the scheme '${r}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${r}`);const t=new a.$Tc;return this.h.set(r,i),this.c.fire({added:!0,scheme:r,provider:i}),t.add(i.onDidChangeFile(s=>{const o=new g.$ll(s,!this.S(i));this.X.fire(o),o.hasCorrelation()||this.Y.fire(o)})),typeof i.onDidWatchError=="function"&&t.add(i.onDidWatchError(s=>this.Z.fire(new Error(s)))),t.add(i.onDidChangeCapabilities(()=>this.g.fire({provider:i,scheme:r}))),(0,a.$Sc)(()=>{this.c.fire({added:!1,scheme:r,provider:i}),this.h.delete(r),(0,a.$Pc)(t)})}getProvider(r){return this.h.get(r)}async activateProvider(r){const i=[];this.f.fire({scheme:r,join(t){i.push(t)}}),!this.h.has(r)&&await O.Promises.settled(i)}async canHandleResource(r){return await this.activateProvider(r.scheme),this.hasProvider(r)}hasProvider(r){return this.h.has(r.scheme)}hasCapability(r,i){const t=this.h.get(r.scheme);return!!(t&&t.capabilities&i)}listCapabilities(){return l.Iterable.map(this.h,([r,i])=>({scheme:r,capabilities:i.capabilities}))}async j(r){if(!(0,y.$dh)(r))throw new g.$nl((0,R.localize)(0,null,this.sb(r)),8);await this.activateProvider(r.scheme);const i=this.h.get(r.scheme);if(!i){const t=new p.$bb;throw t.message=(0,R.localize)(1,null,r.toString()),t}return i}async m(r){const i=await this.j(r);if((0,g.$$k)(i)||(0,g.$8k)(i)||(0,g.$_k)(i))return i;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async n(r){const i=await this.j(r);if((0,g.$$k)(i)||(0,g.$8k)(i))return i;throw new Error(`Filesystem provider for scheme '${r.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(r,i){try{return await this.s(r,i)}catch(t){throw(0,g.$il)(t)===g.FileSystemProviderErrorCode.FileNotFound?new g.$nl((0,R.localize)(2,null,this.sb(r)),1):(0,g.$gl)(t)}}async s(r,i){const t=await this.j(r),s=this.S(t),o=i?.resolveTo,u=i?.resolveSingleChildDescendants,S=i?.resolveMetadata,j=await t.stat(r);let k;return this.t(t,r,j,void 0,!!S,(D,F)=>(k||(k=h.$Ei.forUris(()=>!s),k.set(r,!0),o&&k.fill(!0,o)),k.get(D.resource)||k.findSuperstr(D.resource.with({query:null,fragment:null}))?!0:D.isDirectory&&u?F===1:!1))}async t(r,i,t,s,o,u){const{providerExtUri:S}=this.R(r),j={resource:i,name:S.basename(i),isFile:(t.type&g.FileType.File)!==0,isDirectory:(t.type&g.FileType.Directory)!==0,isSymbolicLink:(t.type&g.FileType.SymbolicLink)!==0,mtime:t.mtime,ctime:t.ctime,size:t.size,readonly:!!((t.permissions??0)&g.FilePermission.Readonly)||!!(r.capabilities&2048),locked:!!((t.permissions??0)&g.FilePermission.Locked),etag:(0,g.$yl)({mtime:t.mtime,size:t.size}),children:void 0};if(j.isDirectory&&u(j,s)){try{const k=await r.readdir(i),D=await O.Promises.settled(k.map(async([F,C])=>{try{const J=S.joinPath(i,F),ne=o?await r.stat(J):{type:C};return await this.t(r,J,ne,k.length,o,u)}catch(J){return this.b.trace(J),null}}));j.children=(0,A.$Hb)(D)}catch(k){this.b.trace(k),j.children=[]}return j}return j}async resolveAll(r){return O.Promises.settled(r.map(async i=>{try{return{stat:await this.s(i.resource,i.options),success:!0}}catch(t){return this.b.trace(t),{stat:void 0,success:!1}}}))}async stat(r){const i=await this.j(r),t=await i.stat(r);return this.t(i,r,t,void 0,!0,()=>!1)}async exists(r){const i=await this.j(r);try{return!!await i.stat(r)}catch{return!1}}async canCreateFile(r,i){try{await this.u(r,i)}catch(t){return t}return!0}async u(r,i){if(!i?.overwrite&&await this.exists(r))throw new g.$nl((0,R.localize)(3,null,this.sb(r)),3,i)}async createFile(r,i=I.$He.fromString(""),t){await this.u(r,t);const s=await this.writeFile(r,i);return this.r.fire(new g.$kl(r,0,s)),s}async writeFile(r,i,t){const s=this.qb(await this.n(r),r),{providerExtUri:o}=this.R(s);let u=t;if((0,g.$bl)(s)&&!u?.atomic){const S=s.enforceAtomicWriteFile?.(r);S&&(u={...t,atomic:S})}try{await this.w(s,r,u)||await this.U(s,o.dirname(r));let j;if((0,g.$8k)(s)&&!(i instanceof I.$He))if((0,$.$te)(i)){const k=await(0,$.$Ae)(i,3);k.ended?j=I.$He.concat(k.buffer):j=k}else j=(0,$.$xe)(i,k=>I.$He.concat(k),3);else j=i;!(0,g.$$k)(s)||(0,g.$8k)(s)&&j instanceof I.$He||(0,g.$8k)(s)&&(0,g.$bl)(s)&&u?.atomic?await this.hb(s,r,u,j):await this.db(s,r,u,j instanceof I.$He?(0,I.$Se)(j):j),this.r.fire(new g.$kl(r,4))}catch(S){throw new g.$nl((0,R.localize)(4,null,this.sb(r),(0,g.$gl)(S).toString()),(0,g.$jl)(S),u)}return this.resolve(r,{resolveMetadata:!0})}async w(r,i,t){const s=!!t?.unlock;if(s&&!(r.capabilities&8192))throw new Error((0,R.localize)(5,null,this.sb(i)));if(!!t?.atomic){if(!(r.capabilities&32768))throw new Error((0,R.localize)(6,null,this.sb(i)));if(!(r.capabilities&2))throw new Error((0,R.localize)(7,null,this.sb(i)));if(s)throw new Error((0,R.localize)(8,null,this.sb(i)))}let u;try{u=await r.stat(i)}catch{return}if(u.type&g.FileType.Directory)throw new g.$nl((0,R.localize)(9,null,this.sb(i)),0,t);if(this.rb(i,u),typeof t?.mtime=="number"&&typeof t.etag=="string"&&t.etag!==g.$xl&&typeof u.mtime=="number"&&typeof u.size=="number"&&t.mtime<u.mtime&&t.etag!==(0,g.$yl)({mtime:t.mtime,size:u.size}))throw new g.$nl((0,R.localize)(10,null),3,t);return u}async readFile(r,i,t){const s=await this.m(r);return i?.atomic?this.z(s,r,i,t):this.C(s,r,i,t)}async z(r,i,t,s){return new Promise((o,u)=>{this.cb.queueFor(i,async()=>{try{const S=await this.C(r,i,t,s);o(S)}catch(S){u(S)}},this.R(r).providerExtUri)})}async C(r,i,t,s){const o=await this.D(r,i,{...t,preferUnbuffered:!0},s);return{...o,value:await(0,I.$Te)(o.value)}}async readFileStream(r,i,t){const s=await this.m(r);return this.D(s,r,i,t)}async D(r,i,t,s){const o=new L.$qe(s);let u=t;(0,g.$al)(r)&&r.enforceAtomicReadFile?.(i)&&(u={...t,atomic:!0});const S=this.J(i,u).then(k=>k,k=>{throw o.dispose(!0),k});let j;try{return typeof u?.etag=="string"&&u.etag!==g.$xl&&await S,u?.atomic&&(0,g.$al)(r)||!((0,g.$$k)(r)||(0,g.$_k)(r))||(0,g.$8k)(r)&&u?.preferUnbuffered?j=this.I(r,i,u):(0,g.$_k)(r)?j=this.G(r,i,o.token,u):j=this.H(r,i,o.token,u),j.on("end",()=>o.dispose()),j.on("error",()=>o.dispose()),{...await S,value:j}}catch(k){throw j&&await(0,$.$ye)(j),this.F(k,i,u)}}F(r,i,t){const s=(0,R.localize)(11,null,this.sb(i),(0,g.$gl)(r).toString());return r instanceof g.$pl?new g.$pl(s,r.stat,t):r instanceof g.$ol?new g.$ol(s,r.fileOperationResult,r.size,r.options):new g.$nl(s,(0,g.$jl)(r),t)}G(r,i,t,s=Object.create(null)){const o=r.readFileStream(i,s,t);return(0,$.$Ee)(o,{data:u=>u instanceof I.$He?u:I.$He.wrap(u),error:u=>this.F(u,i,s)},u=>I.$He.concat(u))}H(r,i,t,s=Object.create(null)){const o=(0,I.$Xe)();return(0,c.$Mq)(r,i,o,u=>u,{...s,bufferSize:this.a,errorTransformer:u=>this.F(u,i,s)},t),o}I(r,i,t){const s=(0,$.$ve)(o=>I.$He.concat(o));return(async()=>{try{let o;t?.atomic&&(0,g.$al)(r)?o=await r.readFile(i,{atomic:!0}):o=await r.readFile(i),typeof t?.position=="number"&&(o=o.slice(t.position)),typeof t?.length=="number"&&(o=o.slice(0,t.length)),this.L(i,o.byteLength,t),s.end(I.$He.wrap(o))}catch(o){s.error(o),s.end()}})(),s}async J(r,i){const t=await this.resolve(r,{resolveMetadata:!0});if(t.isDirectory)throw new g.$nl((0,R.localize)(12,null,this.sb(r)),0,i);if(typeof i?.etag=="string"&&i.etag!==g.$xl&&i.etag===t.etag)throw new g.$pl((0,R.localize)(13,null),t,i);return this.L(r,t.size,i),t}L(r,i,t){if(typeof t?.limits?.size=="number"&&i>t.limits.size)throw new g.$ol((0,R.localize)(14,null,this.sb(r)),7,i,t)}async canMove(r,i,t){return this.M(r,i,"move",t)}async canCopy(r,i,t){return this.M(r,i,"copy",t)}async M(r,i,t,s){if(r.toString()!==i.toString())try{const o=t==="move"?this.qb(await this.n(r),r):await this.m(r),u=this.qb(await this.n(i),i);await this.Q(o,r,u,i,t,s)}catch(o){return o}return!0}async move(r,i,t){const s=this.qb(await this.n(r),r),o=this.qb(await this.n(i),i),u=await this.N(s,r,o,i,"move",!!t),S=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new g.$kl(r,u==="move"?2:3,S)),S}async copy(r,i,t){const s=await this.m(r),o=this.qb(await this.n(i),i),u=await this.N(s,r,o,i,"copy",!!t),S=await this.resolve(i,{resolveMetadata:!0});return this.r.fire(new g.$kl(r,u==="copy"?3:2,S)),S}async N(r,i,t,s,o,u){if(i.toString()===s.toString())return o;const{exists:S,isSameResourceWithDifferentPathCase:j}=await this.Q(r,i,t,s,o,u);if(S&&!j&&u&&await this.del(s,{recursive:!0}),await this.U(t,this.R(t).providerExtUri.dirname(s)),o==="copy"){if(r===t&&(0,g.$9k)(r))await r.copy(i,s,{overwrite:u});else{const k=await this.resolve(i);k.isDirectory?await this.P(r,k,t,s):await this.O(r,i,t,s)}return o}else return r===t?(await r.rename(i,s,{overwrite:u}),o):(await this.N(r,i,t,s,"copy",u),await this.del(i,{recursive:!0}),"copy")}async O(r,i,t,s){if((0,g.$$k)(r)&&(0,g.$$k)(t))return this.jb(r,i,t,s);if((0,g.$$k)(r)&&(0,g.$8k)(t))return this.pb(r,i,t,s);if((0,g.$8k)(r)&&(0,g.$$k)(t))return this.nb(r,i,t,s);if((0,g.$8k)(r)&&(0,g.$8k)(t))return this.lb(r,i,t,s)}async P(r,i,t,s){await t.mkdir(s),Array.isArray(i.children)&&await O.Promises.settled(i.children.map(async o=>{const u=this.R(t).providerExtUri.joinPath(s,o.name);return o.isDirectory?this.P(r,await this.resolve(o.resource),t,u):this.O(r,o.resource,t,u)}))}async Q(r,i,t,s,o,u){let S=!1;if(r===t){const{providerExtUri:k,isPathCaseSensitive:D}=this.R(r);if(D||(S=k.isEqual(i,s)),S&&o==="copy")throw new Error((0,R.localize)(15,null,this.sb(i),this.sb(s)));if(!S&&k.isEqualOrParent(s,i))throw new Error((0,R.localize)(16,null,this.sb(i),this.sb(s)))}const j=await this.exists(s);if(j&&!S){if(!u)throw new g.$nl((0,R.localize)(17,null,this.sb(i),this.sb(s)),4);if(r===t){const{providerExtUri:k}=this.R(r);if(k.isEqualOrParent(i,s))throw new Error((0,R.localize)(18,null,this.sb(i),this.sb(s)))}}return{exists:j,isSameResourceWithDifferentPathCase:S}}R(r){const i=this.S(r);return{providerExtUri:i?y.$2g:y.$4g,isPathCaseSensitive:i}}S(r){return!!(r.capabilities&1024)}async createFolder(r){const i=this.qb(await this.j(r),r);await this.U(i,r);const t=await this.resolve(r,{resolveMetadata:!0});return this.r.fire(new g.$kl(r,0,t)),t}async U(r,i){const t=[],{providerExtUri:s}=this.R(r);for(;!s.isEqual(i,s.dirname(i));)try{if(!((await r.stat(i)).type&g.FileType.Directory))throw new Error((0,R.localize)(19,null,this.sb(i)));break}catch(o){if((0,g.$il)(o)!==g.FileSystemProviderErrorCode.FileNotFound)throw o;t.push(s.basename(i)),i=s.dirname(i)}for(let o=t.length-1;o>=0;o--){i=s.joinPath(i,t[o]);try{await r.mkdir(i)}catch(u){if((0,g.$il)(u)!==g.FileSystemProviderErrorCode.FileExists)throw u}}}async canDelete(r,i){try{await this.W(r,i)}catch(t){return t}return!0}async W(r,i){const t=this.qb(await this.j(r),r),s=!!i?.useTrash;if(s&&!(t.capabilities&4096))throw new Error((0,R.localize)(20,null,this.sb(r)));const o=i?.atomic;if(o&&!(t.capabilities&65536))throw new Error((0,R.localize)(21,null,this.sb(r)));if(s&&o)throw new Error((0,R.localize)(22,null,this.sb(r)));let u;try{u=await t.stat(r)}catch{}if(u)this.rb(r,u);else throw new g.$nl((0,R.localize)(23,null,this.sb(r)),1);if(!!!i?.recursive){const j=await this.resolve(r);if(j.isDirectory&&Array.isArray(j.children)&&j.children.length>0)throw new Error((0,R.localize)(24,null,this.sb(r)))}return t}async del(r,i){const t=await this.W(r,i);let s=i;if((0,g.$cl)(t)&&!s?.atomic){const j=t.enforceAtomicDelete?.(r);j&&(s={...i,atomic:j})}const o=!!s?.useTrash,u=!!s?.recursive,S=s?.atomic??!1;await t.delete(r,{recursive:u,useTrash:o,atomic:S}),this.r.fire(new g.$kl(r,1))}async cloneFile(r,i){const t=await this.j(r),s=this.qb(await this.n(i),i);if(!(t===s&&this.R(t).providerExtUri.isEqual(r,i)))return t===s&&(0,g.$0k)(t)?t.cloneFile(r,i):(await this.U(s,this.R(s).providerExtUri.dirname(i)),t===s&&(0,g.$9k)(t)?this.cb.queueFor(r,()=>t.copy(r,i,{overwrite:!0}),this.R(t).providerExtUri):this.cb.queueFor(r,()=>this.O(t,r,s,i),this.R(t).providerExtUri))}static{this.ab=0}createWatcher(r,i){return this.watch(r,{...i,correlationId:m.ab++})}watch(r,i={recursive:!1,excludes:[]}){const t=new a.$Tc;let s=!1,o=()=>{s=!0};t.add((0,a.$Sc)(()=>o())),(async()=>{try{const S=await this.bb(r,i);s?(0,a.$Pc)(S):o=()=>(0,a.$Pc)(S)}catch(S){this.b.error(S)}})();const u=i.correlationId;if(typeof u=="number"){const S=t.add(new N.$fe);return t.add(this.X.event(k=>{k.correlates(u)&&S.fire(k)})),{onDidChange:S.event,dispose:()=>t.dispose()}}return t}async bb(r,i){const t=await this.j(r),s=(0,P.$mj)([this.R(t).providerExtUri.getComparisonKey(r),i]);let o=this.$.get(s);return o||(o={count:0,disposable:t.watch(r,i)},this.$.set(s,o)),o.count+=1,(0,a.$Sc)(()=>{o&&(o.count--,o.count===0&&((0,a.$Pc)(o.disposable),this.$.delete(s)))})}dispose(){super.dispose();for(const[,r]of this.$)(0,a.$Pc)(r.disposable);this.$.clear()}async db(r,i,t,s){return this.cb.queueFor(i,async()=>{const o=await r.open(i,{create:!0,unlock:t?.unlock??!1});try{(0,$.$te)(s)||(0,$.$ue)(s)?await this.eb(r,o,s):await this.fb(r,o,s)}catch(u){throw(0,g.$gl)(u)}finally{await r.close(o)}},this.R(r).providerExtUri)}async eb(r,i,t){let s=0,o;if((0,$.$ue)(t)){if(t.buffer.length>0){const u=I.$He.concat(t.buffer);await this.gb(r,i,u,u.byteLength,s,0),s+=u.byteLength}if(t.ended)return;o=t.stream}else o=t;return new Promise((u,S)=>{(0,$.$ze)(o,{onData:async j=>{o.pause();try{await this.gb(r,i,j,j.byteLength,s,0)}catch(k){return S(k)}s+=j.byteLength,setTimeout(()=>o.resume())},onError:j=>S(j),onEnd:()=>u()})})}async fb(r,i,t){let s=0,o;for(;(o=t.read())!==null;)await this.gb(r,i,o,o.byteLength,s,0),s+=o.byteLength}async gb(r,i,t,s,o,u){let S=0;for(;S<s;){const j=await r.write(i,o+S,t.buffer,u+S,s-S);S+=j}}async hb(r,i,t,s){return this.cb.queueFor(i,()=>this.ib(r,i,t,s),this.R(r).providerExtUri)}async ib(r,i,t,s){let o;s instanceof I.$He?o=s:(0,$.$te)(s)?o=await(0,I.$Te)(s):(0,$.$ue)(s)?o=await(0,I.$Ue)(s):o=(0,I.$Re)(s),await r.writeFile(i,o.buffer,{create:!0,overwrite:!0,unlock:t?.unlock??!1,atomic:t?.atomic??!1})}async jb(r,i,t,s){return this.cb.queueFor(s,()=>this.kb(r,i,t,s),this.R(t).providerExtUri)}async kb(r,i,t,s){let o,u;try{o=await r.open(i,{create:!1}),u=await t.open(s,{create:!0,unlock:!1});const S=I.$He.alloc(this.a);let j=0,k=0,D=0;do D=await r.read(o,j,S.buffer,k,S.byteLength-k),await this.gb(t,u,S,D,j,k),j+=D,k+=D,k===S.byteLength&&(k=0);while(D>0)}catch(S){throw(0,g.$gl)(S)}finally{await O.Promises.settled([typeof o=="number"?r.close(o):Promise.resolve(),typeof u=="number"?t.close(u):Promise.resolve()])}}async lb(r,i,t,s){return this.cb.queueFor(s,()=>this.mb(r,i,t,s),this.R(t).providerExtUri)}async mb(r,i,t,s){return t.writeFile(s,await r.readFile(i),{create:!0,overwrite:!0,unlock:!1,atomic:!1})}async nb(r,i,t,s){return this.cb.queueFor(s,()=>this.ob(r,i,t,s),this.R(t).providerExtUri)}async ob(r,i,t,s){const o=await t.open(s,{create:!0,unlock:!1});try{const u=await r.readFile(i);await this.gb(t,o,I.$He.wrap(u),u.byteLength,0,0)}catch(u){throw(0,g.$gl)(u)}finally{await t.close(o)}}async pb(r,i,t,s){const o=await(0,I.$Te)(this.H(r,i,L.CancellationToken.None));await this.hb(t,s,void 0,o)}qb(r,i){if(r.capabilities&2048)throw new g.$nl((0,R.localize)(25,null,this.sb(i)),6);return r}rb(r,i){if((i.permissions??0)&g.FilePermission.Readonly)throw new g.$nl((0,R.localize)(26,null,this.sb(r)),6)}sb(r){return r.scheme===b.Schemas.file?r.fsPath:r.toString(!0)}};e.$Nq=f,e.$Nq=f=m=$e([oe(0,w.$5j)],f)}),define(se[132],re([0,1,61,174,8,30,14,5,64,2,16,12,17,46,25,107,13,63,129,34,127,126]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$er=void 0,(()=>{try{(0,O.gracefulify)(A)}catch(r){console.error(`Error enabling graceful-fs: ${(0,p.$jj)(r)}`)}})();class n extends w.$Zq{static{this.L=!1}constructor(i,t){super(i,t),this.onDidChangeCapabilities=P.Event.None,this.P=new L.$Ac(s=>v.$3g.getComparisonKey(s)),this.X=new Map,this.Y=new Map,this.Z=new Map}get capabilities(){return this.M||(this.M=253982,b.$k&&(this.M|=1024)),this.M}async stat(i){try{const{stat:t,symbolicLink:s}=await $.SymlinkSupport.stat(this.I(i));return{type:this.O(t,s),ctime:t.birthtime.getTime(),mtime:t.mtime.getTime(),size:t.size,permissions:t.mode&128?void 0:g.FilePermission.Locked}}catch(t){throw this.hb(t)}}async N(i){try{return await this.stat(i)}catch{return}}async readdir(i){try{const t=await $.Promises.readdir(this.I(i),{withFileTypes:!0}),s=[];return await Promise.all(t.map(async o=>{try{let u;o.isSymbolicLink()?u=(await this.stat((0,v.$_g)(i,o.name))).type:u=this.O(o),s.push([o.name,u])}catch(u){this.a.trace(u)}})),s}catch(t){throw this.hb(t)}}O(i,t){let s;return t?.dangling?s=g.FileType.Unknown:i.isFile()?s=g.FileType.File:i.isDirectory()?s=g.FileType.Directory:s=g.FileType.Unknown,t&&(s|=g.FileType.SymbolicLink),s}async Q(i){const t=this.I(i);this.R(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${t})`);let s;for(;s=this.P.get(i);)this.R(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${t})`),await s.wait();const o=new I.$xh;return this.P.set(i,o),this.R(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${t})`),(0,a.$Sc)(()=>{this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${t})`),this.P.get(i)===o&&(this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${t})`),this.P.delete(i)),this.R(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${t})`),o.open()})}async readFile(i,t){let s;try{t?.atomic&&(this.R(`[Disk FileSystemProvider]: atomic read operation started (${this.I(i)})`),s=await this.Q(i));const o=this.I(i);return await $.Promises.readFile(o)}catch(o){throw this.hb(o)}finally{s?.dispose()}}R(i){n.L&&this.a.trace(i)}readFileStream(i,t,s){const o=(0,y.$ve)(u=>N.$He.concat(u.map(S=>N.$He.wrap(S))).buffer);return(0,c.$Mq)(this,i,o,u=>u.buffer,{...t,bufferSize:256*1024},s),o}async writeFile(i,t,s){return s?.atomic!==!1&&s?.atomic?.postfix&&await this.S(i)?this.U(i,(0,v.$_g)((0,v.$$g)(i),`${(0,v.$9g)(i)}${s.atomic.postfix}`),t,s):this.W(i,t,s)}async S(i){try{const t=this.I(i),{symbolicLink:s}=await $.SymlinkSupport.stat(t);if(s)return!1}catch{}return!0}async U(i,t,s,o){const u=new a.$Tc;try{u.add(await this.Q(i)),u.add(await this.Q(t)),await this.W(t,s,o,!0);try{await this.rename(t,i,{overwrite:!0})}catch(S){try{await this.delete(t,{recursive:!1,useTrash:!1,atomic:!1})}catch{}throw S}}finally{u.dispose()}}async W(i,t,s,o){let u;try{const S=this.I(i);if(!s.create||!s.overwrite){if(await $.Promises.exists(S)){if(!s.overwrite)throw(0,g.$fl)((0,R.localize)(0,null),g.FileSystemProviderErrorCode.FileExists)}else if(!s.create)throw(0,g.$fl)((0,R.localize)(1,null),g.FileSystemProviderErrorCode.FileNotFound)}u=await this.open(i,{create:!0,unlock:s.unlock},o),await this.write(u,0,t,0,t.byteLength)}catch(S){throw await this.ib(i,S)}finally{typeof u=="number"&&await this.close(u)}}static{this.$=!0}static configureFlushOnWrite(i){n.$=i}async open(i,t,s){const o=this.I(i);let u;(0,g.$6k)(t)&&!s&&(u=await this.Q(i));let S;try{if((0,g.$6k)(t)&&t.unlock)try{const{stat:k}=await $.SymlinkSupport.stat(o);k.mode&128||await $.Promises.chmod(o,k.mode|128)}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}let j;if((0,g.$6k)(t)){if(b.$i)try{await $.Promises.truncate(o,0),j="r+"}catch(k){k.code!=="ENOENT"&&this.a.trace(k)}j||(j="w")}else j="r";S=await $.Promises.open(o,j)}catch(j){throw u?.dispose(),(0,g.$6k)(t)?await this.ib(i,j):this.hb(j)}if(this.X.set(S,0),(0,g.$6k)(t)&&this.Z.set(S,i),u){const j=this.Y.get(S);this.R(`[Disk FileSystemProvider]: open() - storing lock for handle ${S} (${o})`),this.Y.set(S,u),j&&(this.R(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${S} (${o})`),j.dispose())}return S}async close(i){const t=this.Y.get(i);try{if(this.X.delete(i),this.Z.delete(i)&&n.$)try{await $.Promises.fdatasync(i)}catch(s){n.configureFlushOnWrite(!1),this.a.error(s)}return await $.Promises.close(i)}catch(s){throw this.hb(s)}finally{t&&(this.Y.get(i)===t&&(this.R(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${i}`),this.Y.delete(i)),this.R(`[Disk FileSystemProvider]: close() - disposing lock for handle ${i}`),t.dispose())}}async read(i,t,s,o,u){const S=this.ab(i,t);let j=null;try{j=(await $.Promises.read(i,s,o,u,S)).bytesRead}catch(k){throw this.hb(k)}finally{this.bb(i,S,j)}return j}ab(i,t){return t===this.X.get(i)?null:t}bb(i,t,s){const o=this.X.get(i);typeof o=="number"&&(typeof t=="number"||(typeof s=="number"?this.X.set(i,o+s):this.X.delete(i)))}async write(i,t,s,o,u){return(0,I.$Sh)(()=>this.cb(i,t,s,o,u),100,3)}async cb(i,t,s,o,u){const S=this.ab(i,t);let j=null;try{j=(await $.Promises.write(i,s,o,u,S)).bytesWritten}catch(k){throw await this.ib(this.Z.get(i),k)}finally{this.bb(i,S,j)}return j}async mkdir(i){try{await $.Promises.mkdir(this.I(i))}catch(t){throw this.hb(t)}}async delete(i,t){try{const s=this.I(i);if(t.recursive){let o;t?.atomic!==!1&&t.atomic.postfix&&(o=(0,h.$jc)((0,h.$mc)(s),`${(0,h.$nc)(s)}${t.atomic.postfix}`)),await $.Promises.rm(s,$.RimRafMode.MOVE,o)}else try{await $.Promises.unlink(s)}catch(o){if(o.code==="EPERM"||o.code==="EISDIR"){let u=!1;try{const{stat:S,symbolicLink:j}=await $.SymlinkSupport.stat(s);u=S.isDirectory()&&!j}catch{}if(u)await $.Promises.rmdir(s);else throw o}else throw o}}catch(s){throw this.hb(s)}}async rename(i,t,s){const o=this.I(i),u=this.I(t);if(o!==u)try{await this.db(i,t,"move",s.overwrite),await $.Promises.rename(o,u)}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(2,null,(0,h.$nc)(o),(0,h.$nc)((0,h.$mc)(u)),S.toString()))),this.hb(S)}}async copy(i,t,s){const o=this.I(i),u=this.I(t);if(o!==u)try{await this.db(i,t,"copy",s.overwrite),await $.Promises.copy(o,u,{preserveSymlinks:!0})}catch(S){throw(S.code==="EINVAL"||S.code==="EBUSY"||S.code==="ENAMETOOLONG")&&(S=new Error((0,R.localize)(3,null,(0,h.$nc)(o),(0,h.$nc)((0,h.$mc)(u)),S.toString()))),this.hb(S)}}async db(i,t,s,o){const u=this.I(i),S=this.I(t);let j=!1;if(!!(this.capabilities&1024)||(j=(0,l.$wg)(u,S,!0)),j){if(s==="copy")throw(0,g.$fl)((0,R.localize)(4,null),g.FileSystemProviderErrorCode.FileExists);if(s==="move")return}const D=await this.N(i);if(!D)throw(0,g.$fl)((0,R.localize)(5,null),g.FileSystemProviderErrorCode.FileNotFound);const F=await this.N(t);if(F){if(!o)throw(0,g.$fl)((0,R.localize)(6,null),g.FileSystemProviderErrorCode.FileExists);D.type&g.FileType.File&&F.type&g.FileType.File||await this.delete(t,{recursive:!0,useTrash:!1,atomic:!1})}}async cloneFile(i,t){return this.eb(i,t,!1)}async eb(i,t,s){const o=this.I(i),u=this.I(t),S=!!(this.capabilities&1024);if((0,l.$wg)(o,u,!S))return;const j=new a.$Tc;try{j.add(await this.Q(i)),j.add(await this.Q(t)),s&&await $.Promises.mkdir((0,h.$mc)(u),{recursive:!0}),await $.Promises.copyFile(o,u)}catch(k){if(k.code==="ENOENT"&&!s)return this.eb(i,t,!0);throw this.hb(k)}finally{j.dispose()}}t(i,t,s){return new m.$7q(o=>i(o),o=>t(o),s)}F(i,t,s){return new f.$dr(o=>i(o),o=>t(o),s)}hb(i){if(i instanceof g.$el)return i;let t=i,s;switch(i.code){case"ENOENT":s=g.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":s=g.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":s=g.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":s=g.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":s=g.FileSystemProviderErrorCode.NoPermissions;break;case"ERR_UNC_HOST_NOT_ALLOWED":t=`${i.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`,s=g.FileSystemProviderErrorCode.Unknown;break;default:s=g.FileSystemProviderErrorCode.Unknown}return(0,g.$fl)(t,s)}async ib(i,t){let s=this.hb(t);if(i&&s.code===g.FileSystemProviderErrorCode.NoPermissions)try{const{stat:o}=await $.SymlinkSupport.stat(this.I(i));o.mode&128||(s=(0,g.$fl)(t,g.FileSystemProviderErrorCode.FileWriteLocked))}catch(o){this.a.trace(o)}return s}}e.$er=n}),define(se[133],re([0,1,2,6]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=void 0;class I extends A.$Uc{constructor(N,P=[]){super(),this.a=new O.$ck([N,...P]),this.B(N.onDidChangeLogLevel(l=>this.setLevel(l)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(N){this.a.setLevel(N)}getLevel(){return this.a.getLevel()}trace(N,...P){this.a.trace(N,...P)}debug(N,...P){this.a.debug(N,...P)}info(N,...P){this.a.info(N,...P)}warn(N,...P){this.a.warn(N,...P)}error(N,...P){this.a.error(N,...P)}flush(){this.a.flush()}}e.$dQ=I}),define(se[134],re([0,1,13,6]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5P=void 0;var I;(function(a){a[a.Trace=0]="Trace",a[a.Debug=1]="Debug",a[a.Info=2]="Info",a[a.Warning=3]="Warning",a[a.Error=4]="Error",a[a.Critical=5]="Critical",a[a.Off=6]="Off"})(I||(I={}));async function L(a,h,b,v,y){try{const $=await new Promise((g,c)=>{X(["@vscode/spdlog"],g,c)});$.setFlushOn(I.Trace);const R=await $.createAsyncRotatingLogger(a,h,b,v);return y?R.clearFormatters():R.setPattern("%Y-%m-%d %H:%M:%S.%e [%l] %v"),R}catch($){console.error($)}return null}function N(a,h,b){switch(h){case O.LogLevel.Trace:a.trace(b);break;case O.LogLevel.Debug:a.debug(b);break;case O.LogLevel.Info:a.info(b);break;case O.LogLevel.Warning:a.warn(b);break;case O.LogLevel.Error:a.error(b);break;case O.LogLevel.Off:break;default:throw new Error(`Invalid log level ${h}`)}}function P(a,h){switch(h){case O.LogLevel.Trace:a.setLevel(I.Trace);break;case O.LogLevel.Debug:a.setLevel(I.Debug);break;case O.LogLevel.Info:a.setLevel(I.Info);break;case O.LogLevel.Warning:a.setLevel(I.Warning);break;case O.LogLevel.Error:a.setLevel(I.Error);break;case O.LogLevel.Off:a.setLevel(I.Off);break;default:throw new Error(`Invalid log level ${h}`)}}class l extends O.$$j{constructor(h,b,v,y,$){super(),this.m=[],this.setLevel($),this.n=this.s(h,b,v,y),this.B(this.onDidChangeLogLevel(R=>{this.r&&P(this.r,R)}))}async s(h,b,v,y){const $=v?6:1,R=30/$*A.$Al.MB,g=await L(h,b,R,$,y);if(g){this.r=g,P(this.r,this.getLevel());for(const{level:c,message:w}of this.m)N(this.r,c,w);this.m=[]}}g(h,b){this.r?N(this.r,h,b):this.getLevel()<=h&&this.m.push({level:h,message:b})}flush(){this.r?this.r.flush():this.n.then(()=>this.flush())}dispose(){this.r?this.u():this.n.then(()=>this.u()),super.dispose()}u(){this.r&&(this.r.drop(),this.r=void 0)}}e.$5P=l}),define(se[135],re([0,1,28,6,134]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6P=void 0;class L extends O.$dk{s(P,l,a){return new I.$5P((0,A.$Ug)(),P.fsPath,!a?.donotRotate,!!a?.donotUseFormatters,l)}}e.$6P=L}),define(se[39],re([0,1,5,67,2,10]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jo=e.$io=e.$ho=void 0,e.$ho=(0,L.$yi)("policy");class N extends I.$Uc{constructor(){super(...arguments),this.f={},this.g=new Map,this.h=this.B(new A.$fe),this.onDidChange=this.h.event}async updatePolicyDefinitions(a){const h=Object.keys(this.f).length;return this.f={...a,...this.f},h!==Object.keys(this.f).length&&await this.j(a),O.Iterable.reduce(this.g.entries(),(b,[v,y])=>({...b,[v]:y}),{})}getPolicyValue(a){return this.g.get(a)}serialize(){return O.Iterable.reduce(Object.entries(this.f),(a,[h,b])=>({...a,[h]:{definition:b,value:this.g.get(h)}}),{})}}e.$io=N;class P{constructor(){this.onDidChange=A.Event.None}async updatePolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.$jo=P}),define(se[136],re([0,1,8,5,67,3,13,6,39]),function(X,e,A,O,I,L,N,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Eec=void 0;function a(b,v){const y=[];for(const $ of new Set(I.Iterable.concat(b.keys(),v.keys())))b.get($)!==v.get($)&&y.push($);return y}let h=class extends l.$io{constructor(v,y,$){super(),this.m=v,this.n=y,this.s=$,this.c=this.B(new A.$wh(500));const R=O.Event.filter(y.onDidFilesChange,g=>g.affects(v));this.B(y.watch(v)),this.B(R(()=>this.c.trigger(()=>this.w())))}async j(){await this.w()}async u(){const v=new Map;try{const y=await this.n.readFile(this.m),$=JSON.parse(y.value.toString());if(!(0,L.$ag)($))throw new Error("Policy file isn't a JSON object");for(const R of Object.keys($))this.f[R]&&v.set(R,$[R])}catch(y){y.fileOperationResult!==1&&this.s.error("[FilePolicyService] Failed to read policies",y)}return v}async w(){const v=await this.u(),y=a(this.g,v);this.g=v,y.length>0&&this.h.fire(y)}};e.$Eec=h,e.$Eec=h=$e([oe(1,N.$5k),oe(2,P.$5j)],h)}),define(se[137],re([0,1,39,8,2,6]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dec=void 0;let N=class extends A.$io{constructor(l,a){super(),this.m=l,this.n=a,this.a=new O.$sh,this.b=this.B(new I.$Vc)}async j(l){this.m.trace(`NativePolicyService#_updatePolicyDefinitions - Found ${Object.keys(l).length} policy definitions`);const{createWatcher:a}=await new Promise((h,b)=>{X(["@vscode/policy-watcher"],h,b)});await this.a.queue(()=>new Promise((h,b)=>{try{this.b.value=a(this.n,l,v=>{this.t(v),h()})}catch(v){this.m.error("NativePolicyService#_updatePolicyDefinitions - Error creating watcher:",v),b(v)}}))}t(l){this.m.trace(`NativePolicyService#_onDidPolicyChange - Updated policy values: ${JSON.stringify(l)}`);for(const a in l){const h=l[a];h===void 0?this.g.delete(a):this.g.set(a,h)}this.h.fire(Object.keys(l))}};e.$Dec=N,e.$Dec=N=$e([oe(0,L.$5j)],N)}),define(se[32],re([0,1,10]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,A.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"}),define(se[36],re([0,1,75,3]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class I{constructor(){this.a=new Map}add(N,P){A.ok(O.$$f(N)),A.ok(O.$ag(P)),A.ok(!this.a.has(N),"There is already an extension with this id"),this.a.set(N,P)}knows(N){return this.a.has(N)}as(N){return this.a.get(N)||null}}e.$fo=new I}),define(se[138],re([0,1,5,36]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function I(P){return P.length>0&&P.charAt(P.length-1)==="#"?P.substring(0,P.length-1):P}class L{constructor(){this.b=new A.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(l,a){this.a[I(l)]=a,this.b.fire(l)}notifySchemaChanged(l){this.b.fire(l)}getSchemaContributions(){return{schemas:this.a}}}const N=new L;O.$fo.add(e.$go.JSONContribution,N)}),define(se[40],re([0,1,19,5,3,94,29,138,36]),function(X,e,A,O,I,L,N,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=R,e.$wo=g,e.$xo=c,e.$yo=p,e.$zo=m;var a;(function(f){f.Multiline="multilineText",f.Singleline="singlelineText"})(a||(e.EditPresentationTypes=a={})),e.$ko={Configuration:"base.contributions.configuration"};var h;(function(f){f[f.APPLICATION=1]="APPLICATION",f[f.MACHINE=2]="MACHINE",f[f.WINDOW=3]="WINDOW",f[f.RESOURCE=4]="RESOURCE",f[f.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",f[f.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(h||(e.ConfigurationScope=h={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const b=l.$fo.as(P.$go.JSONContribution);class v{constructor(){this.h=new Set,this.i=new O.$fe,this.onDidSchemaChange=this.i.event,this.j=new O.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},b.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(n,r=!0){this.registerConfigurations([n],r)}registerConfigurations(n,r=!0){const i=new Set;this.n(n,r,i),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:i})}deregisterConfigurations(n){const r=new Set;this.o(n,r),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:r})}updateConfigurations({add:n,remove:r}){const i=new Set;this.o(r,i),this.n(n,!1,i),b.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:i})}registerDefaultConfigurations(n){const r=new Set;this.k(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}k(n,r){const i=[];for(const{overrides:t,source:s}of n)for(const o in t)if(r.add(o),e.$uo.test(o)){const u=this.a.get(o),S=u?.valuesSources??new Map;if(s)for(const F of Object.keys(t[o]))S.set(F,s);const j={...u?.value||{},...t[o]};this.a.set(o,{source:s,value:j,valuesSources:S});const k=(0,N.$cj)(o),D={type:"object",default:j,description:L.localize(1,null,k),$ref:e.$ro,defaultDefaultValue:j,source:I.$$f(s)?void 0:s,defaultValueSource:s};i.push(...R(o)),this.d[o]=D,this.b.properties[o]=D}else{this.a.set(o,{value:t[o],source:s});const u=this.d[o];u&&(this.w(o,u),this.r(o,u))}this.m(i)}deregisterDefaultConfigurations(n){const r=new Set;this.l(n,r),this.i.fire(),this.j.fire({properties:r,defaultsOverrides:!0})}l(n,r){for(const{overrides:i,source:t}of n)for(const s in i){const o=this.a.get(s),u=I.$$f(t)?t:t?.id,S=I.$$f(o?.source)?o?.source:o?.source?.id;if(u===S)if(r.add(s),this.a.delete(s),e.$uo.test(s))delete this.d[s],delete this.b.properties[s];else{const j=this.d[s];j&&(this.w(s,j),this.r(s,j))}}this.u()}deltaConfiguration(n){let r=!1;const i=new Set;n.removedDefaults&&(this.l(n.removedDefaults,i),r=!0),n.addedDefaults&&(this.k(n.addedDefaults,i),r=!0),n.removedConfigurations&&this.o(n.removedConfigurations,i),n.addedConfigurations&&this.n(n.addedConfigurations,!1,i),this.i.fire(),this.j.fire({properties:i,defaultsOverrides:r})}notifyConfigurationSchemaUpdated(...n){this.i.fire()}registerOverrideIdentifiers(n){this.m(n),this.i.fire()}m(n){for(const r of n)this.h.add(r);this.u()}n(n,r,i){n.forEach(t=>{this.p(t,r,t.extensionInfo,t.restrictedProperties,void 0,i),this.c.push(t),this.q(t)})}o(n,r){const i=t=>{if(t.properties)for(const s in t.properties){r.add(s);const o=this.d[s];o?.policy?.name&&this.e.delete(o.policy.name),delete this.d[s],this.s(s,t.properties[s])}t.allOf?.forEach(s=>i(s))};for(const t of n){i(t);const s=this.c.indexOf(t);s!==-1&&this.c.splice(s,1)}}p(n,r=!0,i,t,s=3,o){s=I.$hg(n.scope)?s:n.scope;const u=n.properties;if(u)for(const j in u){const k=u[j];if(r&&p(j,k)){delete u[j];continue}if(k.source=i,k.defaultDefaultValue=u[j].default,this.w(j,k),e.$uo.test(j)?k.scope=void 0:(k.scope=I.$hg(k.scope)?s:k.scope,k.restricted=I.$hg(k.restricted)?!!t?.includes(j):k.restricted),u[j].hasOwnProperty("included")&&!u[j].included){this.f[j]=u[j],delete u[j];continue}else this.d[j]=u[j],u[j].policy?.name&&this.e.set(u[j].policy.name,j);!u[j].deprecationMessage&&u[j].markdownDeprecationMessage&&(u[j].deprecationMessage=u[j].markdownDeprecationMessage),o.add(j)}const S=n.allOf;if(S)for(const j of S)this.p(j,r,i,t,s,o)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(n){const r=i=>{const t=i.properties;if(t)for(const o in t)this.r(o,t[o]);i.allOf?.forEach(r)};r(n)}r(n,r){switch(e.$lo.properties[n]=r,r.scope){case 1:e.$mo.properties[n]=r;break;case 2:e.$no.properties[n]=r;break;case 6:e.$oo.properties[n]=r;break;case 3:e.$po.properties[n]=r;break;case 4:e.$qo.properties[n]=r;break;case 5:e.$qo.properties[n]=r,this.g.properties[n]=r;break}}s(n,r){switch(delete e.$lo.properties[n],r.scope){case 1:delete e.$mo.properties[n];break;case 2:delete e.$no.properties[n];break;case 6:delete e.$oo.properties[n];break;case 3:delete e.$po.properties[n];break;case 4:case 5:delete e.$qo.properties[n],delete this.g.properties[n];break}}u(){for(const n of this.h.values()){const r=`[${n}]`,i={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.$ro};this.w(r,i),e.$lo.properties[r]=i,e.$mo.properties[r]=i,e.$no.properties[r]=i,e.$oo.properties[r]=i,e.$po.properties[r]=i,e.$qo.properties[r]=i}}v(){const n={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=n,e.$mo.patternProperties[e.$to]=n,e.$no.patternProperties[e.$to]=n,e.$oo.patternProperties[e.$to]=n,e.$po.patternProperties[e.$to]=n,e.$qo.patternProperties[e.$to]=n,this.i.fire()}w(n,r){const i=this.a.get(n);let t=i?.value,s=i?.source;I.$fg(t)&&(t=r.defaultDefaultValue,s=void 0),I.$fg(t)&&(t=c(r.type)),r.default=t,r.defaultValueSource=s}}const y="\\[([^\\]]+)\\]",$=new RegExp(y,"g");e.$to=`^(${y})+$`,e.$uo=new RegExp(e.$to);function R(f){const n=[];if(e.$uo.test(f)){let r=$.exec(f);for(;r?.length;){const i=r[1].trim();i&&n.push(i),r=$.exec(f)}}return(0,A.$Mb)(n)}function g(f){return f.reduce((n,r)=>`${n}[${r}]`,"")}function c(f){switch(Array.isArray(f)?f[0]:f){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const w=new v;l.$fo.add(e.$ko.Configuration,w);function p(f,n){return f.trim()?e.$uo.test(f)?L.localize(7,null,f):w.getConfigurationProperties()[f]!==void 0?L.localize(8,null,f):n.policy?.name&&w.getPolicyConfigurations().get(n.policy?.name)!==void 0?L.localize(9,null,f,n.policy?.name,w.getPolicyConfigurations().get(n.policy?.name)):null:L.localize(6,null)}function m(){const f=[],n=w.getConfigurationProperties();for(const r of Object.keys(n))f.push([r,n[r].scope]);return f.push(["launch",4]),f.push(["task",4]),f}}),define(se[68],re([0,1,19,5,38,2,30,27,3,11,29,40,36]),function(X,e,A,O,I,L,N,P,l,a,h,b,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=p;function y(r){return Object.isFrozen(r)?r:P.$6n(r)}class ${static createEmptyModel(i){return new $({},[],[],void 0,i)}constructor(i,t,s,o,u){this.b=i,this.c=t,this.d=s,this.raw=o,this.f=u,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const i=this.raw.map(t=>{if(t instanceof $)return t;const s=new R("",this.f);return s.parseRaw(t),s.configurationModel});this.g=i.reduce((t,s)=>s===t?s:t.merge(s),i[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(i){return i?(0,h.$aj)(this.contents,i):this.contents}inspect(i,t){const s=this;return{get value(){return y(s.rawConfiguration.getValue(i))},get override(){return t?y(s.rawConfiguration.getOverrideValue(i,t)):void 0},get merged(){return y(t?s.rawConfiguration.override(t).getValue(i):s.rawConfiguration.getValue(i))},get overrides(){const o=[];for(const{contents:u,identifiers:S,keys:j}of s.rawConfiguration.overrides){const k=new $(u,j,[],void 0,s.f).getValue(i);k!==void 0&&o.push({identifiers:S,value:k})}return o.length?y(o):void 0}}}getOverrideValue(i,t){const s=this.j(t);return s?i?(0,h.$aj)(s,i):s:void 0}getKeysForOverrideIdentifier(i){const t=[];for(const s of this.overrides)s.identifiers.includes(i)&&t.push(...s.keys);return A.$Mb(t)}getAllOverrideIdentifiers(){const i=[];for(const t of this.overrides)i.push(...t.identifiers);return A.$Mb(i)}override(i){let t=this.a.get(i);return t||(t=this.h(i),this.a.set(i,t)),t}merge(...i){const t=P.$5n(this.contents),s=P.$5n(this.overrides),o=[...this.keys],u=this.raw?.length?[...this.raw]:[this];for(const S of i)if(u.push(...S.raw?.length?S.raw:[S]),!S.isEmpty()){this.i(t,S.contents);for(const j of S.overrides){const[k]=s.filter(D=>A.$ub(D.identifiers,j.identifiers));k?(this.i(k.contents,j.contents),k.keys.push(...j.keys),k.keys=A.$Mb(k.keys)):s.push(P.$5n(j))}for(const j of S.keys)o.indexOf(j)===-1&&o.push(j)}return new $(t,o,s,u.every(S=>S instanceof $)?void 0:u,this.f)}h(i){const t=this.j(i);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const s={};for(const o of A.$Mb([...Object.keys(this.contents),...Object.keys(t)])){let u=this.contents[o];const S=t[o];S&&(typeof u=="object"&&typeof S=="object"?(u=P.$5n(u),this.i(u,S)):u=S),s[o]=u}return new $(s,this.keys,this.overrides,void 0,this.f)}i(i,t){for(const s of Object.keys(t)){if(s in i&&l.$ag(i[s])&&l.$ag(t[s])){this.i(i[s],t[s]);continue}i[s]=P.$5n(t[s])}}j(i){let t=null,s=null;const o=u=>{u&&(s?this.i(s,u):s=P.$5n(u))};for(const u of this.overrides)u.identifiers.length===1&&u.identifiers[0]===i?t=u.contents:u.identifiers.includes(i)&&o(u.contents);return o(t),s}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(i,t){this.k(i,t,!0)}setValue(i,t){this.k(i,t,!1)}removeValue(i){const t=this.keys.indexOf(i);t!==-1&&(this.keys.splice(t,1),(0,h.$_i)(this.contents,i),b.$uo.test(i)&&this.overrides.splice(this.overrides.findIndex(s=>A.$ub(s.identifiers,(0,b.$vo)(i))),1))}k(i,t,s){(0,h.$$i)(this.contents,i,t,o=>this.f.error(o)),s=s||this.keys.indexOf(i)===-1,s&&this.keys.push(i),b.$uo.test(i)&&this.overrides.push({identifiers:(0,b.$vo)(i),keys:Object.keys(this.contents[i]),contents:(0,h.$0i)(this.contents[i],o=>this.f.error(o))})}}e.$Ao=$;class R{constructor(i,t){this.f=i,this.g=t,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||$.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(i,t){if(!l.$hg(i)){const s=this.h(i);this.parseRaw(s,t)}}reparse(i){this.a&&this.parseRaw(this.a,i)}parseRaw(i,t){this.a=i;const{contents:s,keys:o,overrides:u,restricted:S,hasExcludedProperties:j}=this.i(i,t);this.b=new $(s,o,u,j?[i]:void 0,this.g),this.c=S||[]}h(i){let t={},s=null,o=[];const u=[],S=[];function j(D){Array.isArray(o)?o.push(D):s!==null&&(o[s]=D)}const k={onObjectBegin:()=>{const D={};j(D),u.push(o),o=D,s=null},onObjectProperty:D=>{s=D},onObjectEnd:()=>{o=u.pop()},onArrayBegin:()=>{const D=[];j(D),u.push(o),o=D,s=null},onArrayEnd:()=>{o=u.pop()},onLiteralValue:j,onError:(D,F,C)=>{S.push({error:D,offset:F,length:C})}};if(i)try{I.$Sn(i,k),t=o[0]||{}}catch(D){this.g.error(`Error while parsing settings file ${this.f}: ${D}`),this.d=[D]}return t}i(i,t){const s=v.$fo.as(b.$ko.Configuration).getConfigurationProperties(),o=this.j(i,s,!0,t);i=o.raw;const u=(0,h.$0i)(i,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`)),S=Object.keys(i),j=this.l(i,k=>this.g.error(`Conflict in settings file ${this.f}: ${k}`));return{contents:u,keys:S,overrides:j,restricted:o.restricted,hasExcludedProperties:o.hasExcludedProperties}}j(i,t,s,o){let u=!1;if(!o?.scopes&&!o?.skipRestricted&&!o?.exclude?.length)return{raw:i,restricted:[],hasExcludedProperties:u};const S={},j=[];for(const k in i)if(b.$uo.test(k)&&s){const D=this.j(i[k],t,!1,o);S[k]=D.raw,u=u||D.hasExcludedProperties,j.push(...D.restricted)}else{const D=t[k],F=D?typeof D.scope<"u"?D.scope:3:void 0;D?.restricted&&j.push(k),!o.exclude?.includes(k)&&(o.include?.includes(k)||(F===void 0||o.scopes===void 0||o.scopes.includes(F))&&!(o.skipRestricted&&D?.restricted))?S[k]=i[k]:u=!0}return{raw:S,restricted:j,hasExcludedProperties:u}}l(i,t){const s=[];for(const o of Object.keys(i))if(b.$uo.test(o)){const u={};for(const S in i[o])u[S]=i[o][S];s.push({identifiers:(0,b.$vo)(o),keys:Object.keys(u),contents:(0,h.$0i)(u,t)})}return s}}e.$Bo=R;class g extends L.$Uc{constructor(i,t,s,o,u){super(),this.c=i,this.f=t,this.g=o,this.h=u,this.b=this.B(new O.$fe),this.onDidChange=this.b.event,this.a=new R(this.c.toString(),u),this.B(this.g.watch(s.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(O.Event.any(O.Event.filter(this.g.onDidFilesChange,S=>S.contains(this.c)),O.Event.filter(this.g.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&s.isEqual(S.resource,i)))(()=>this.b.fire()))}async loadConfiguration(){try{const i=await this.g.readFile(this.c);return this.a.parse(i.value.toString()||"{}",this.f),this.a.configurationModel}catch{return $.createEmptyModel(this.h)}}reparse(i){return i&&(this.f=i),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=g;class c{constructor(i,t,s,o,u,S,j,k,D,F,C,J,ne){this.a=i,this.b=t,this.c=s,this.overrideIdentifiers=o,this.d=u,this.f=S,this.g=j,this.h=k,this.i=D,this.j=F,this.k=C,this.l=J,this.m=ne}get value(){return y(this.c)}n(i){return i?.value!==void 0||i?.override!==void 0||i?.overrides!==void 0?i:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class w{constructor(i,t,s,o,u,S,j,k,D,F){this.j=i,this.l=t,this.m=s,this.n=o,this.p=u,this.q=S,this.r=j,this.s=k,this.t=D,this.u=F,this.h=null,this.i=new N.$Ac,this.v=null}getValue(i,t,s){return this.w(i,t,s).getValue(i)}updateValue(i,t,s={}){let o;s.resource?(o=this.t.get(s.resource),o||(o=$.createEmptyModel(this.u),this.t.set(s.resource,o))):o=this.s,t===void 0?o.removeValue(i):o.setValue(i,t),s.resource||(this.h=null)}inspect(i,t,s){const o=this.w(i,t,s),u=this.A(t.resource,s),S=t.resource?this.t.get(t.resource)||this.s:this.s,j=new Set;for(const k of o.overrides)for(const D of k.identifiers)o.getOverrideValue(i,D)!==void 0&&j.add(D);return new c(i,t,o.getValue(i),j.size?[...j]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,s?this.q:void 0,u||void 0,S)}keys(i){const t=this.A(void 0,i);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:t?t.keys.slice(0):[]}}updateDefaultConfiguration(i){this.j=i,this.h=null,this.i.clear()}updatePolicyConfiguration(i){this.l=i}updateApplicationConfiguration(i){this.m=i,this.h=null,this.i.clear()}updateLocalUserConfiguration(i){this.n=i,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(i){this.p=i,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(i){this.q=i,this.h=null,this.i.clear()}updateFolderConfiguration(i,t){this.r.set(i,t),this.i.delete(i)}deleteFolderConfiguration(i){this.folderConfigurations.delete(i),this.i.delete(i)}compareAndUpdateDefaultConfiguration(i,t){const s=[];if(!t){const{added:o,updated:u,removed:S}=f(this.j,i);t=[...o,...u,...S]}for(const o of t)for(const u of(0,b.$vo)(o)){const S=this.j.getKeysForOverrideIdentifier(u),j=i.getKeysForOverrideIdentifier(u),k=[...j.filter(D=>S.indexOf(D)===-1),...S.filter(D=>j.indexOf(D)===-1),...S.filter(D=>!P.$9n(this.j.override(u).getValue(D),i.override(u).getValue(D)))];s.push([u,k])}return this.updateDefaultConfiguration(i),{keys:t,overrides:s}}compareAndUpdatePolicyConfiguration(i){const{added:t,updated:s,removed:o}=f(this.l,i),u=[...t,...s,...o];return u.length&&this.updatePolicyConfiguration(i),{keys:u,overrides:[]}}compareAndUpdateApplicationConfiguration(i){const{added:t,updated:s,removed:o,overrides:u}=f(this.applicationConfiguration,i),S=[...t,...s,...o];return S.length&&this.updateApplicationConfiguration(i),{keys:S,overrides:u}}compareAndUpdateLocalUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:u}=f(this.localUserConfiguration,i),S=[...t,...s,...o];return S.length&&this.updateLocalUserConfiguration(i),{keys:S,overrides:u}}compareAndUpdateRemoteUserConfiguration(i){const{added:t,updated:s,removed:o,overrides:u}=f(this.remoteUserConfiguration,i),S=[...t,...s,...o];return S.length&&this.updateRemoteUserConfiguration(i),{keys:S,overrides:u}}compareAndUpdateWorkspaceConfiguration(i){const{added:t,updated:s,removed:o,overrides:u}=f(this.workspaceConfiguration,i),S=[...t,...s,...o];return S.length&&this.updateWorkspaceConfiguration(i),{keys:S,overrides:u}}compareAndUpdateFolderConfiguration(i,t){const s=this.folderConfigurations.get(i),{added:o,updated:u,removed:S,overrides:j}=f(s,t),k=[...o,...u,...S];return(k.length||!s)&&this.updateFolderConfiguration(i,t),{keys:k,overrides:j}}compareAndDeleteFolderConfiguration(i){const t=this.folderConfigurations.get(i);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(i);const{added:s,updated:o,removed:u,overrides:S}=f(t,void 0);return{keys:[...s,...o,...u],overrides:S}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(i,t,s){let o=this.x(t,s);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(i)!==void 0&&(o=o.merge(this.l)),o}x({resource:i},t){let s=this.y();if(t&&i){const o=t.getFolder(i);o&&(s=this.z(o.uri)||s);const u=this.t.get(i);u&&(s=s.merge(u))}return s}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(i){let t=this.i.get(i);if(!t){const s=this.y(),o=this.r.get(i);o?(t=s.merge(o),this.i.set(i,t)):t=s}return t}A(i,t){if(t&&i){const s=t.getFolder(i);if(s)return this.r.get(s.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((i,t)=>{const{contents:s,overrides:o,keys:u}=this.r.get(t);return i.push([t,{contents:s,overrides:o,keys:u}]),i},[])}}allKeys(){const i=new Set;return this.j.keys.forEach(t=>i.add(t)),this.userConfiguration.keys.forEach(t=>i.add(t)),this.q.keys.forEach(t=>i.add(t)),this.r.forEach(t=>t.keys.forEach(s=>i.add(s))),[...i.values()]}B(){const i=new Set;return this.j.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.userConfiguration.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.q.getAllOverrideIdentifiers().forEach(t=>i.add(t)),this.r.forEach(t=>t.getAllOverrideIdentifiers().forEach(s=>i.add(s))),[...i.values()]}D(i){const t=new Set;return this.j.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.q.getKeysForOverrideIdentifier(i).forEach(s=>t.add(s)),this.r.forEach(s=>s.getKeysForOverrideIdentifier(i).forEach(o=>t.add(o))),[...t.values()]}static parse(i,t){const s=this.E(i.defaults,t),o=this.E(i.policy,t),u=this.E(i.application,t),S=this.E(i.user,t),j=this.E(i.workspace,t),k=i.folders.reduce((D,F)=>(D.set(a.URI.revive(F[0]),this.E(F[1],t)),D),new N.$Ac);return new w(s,o,u,S,$.createEmptyModel(t),j,k,$.createEmptyModel(t),new N.$Ac,t)}static E(i,t){return new $(i.contents,i.keys,i.overrides,void 0,t)}}e.$Do=w;function p(...r){if(r.length===0)return{keys:[],overrides:[]};if(r.length===1)return r[0];const i=new Set,t=new Map;for(const o of r)o.keys.forEach(u=>i.add(u)),o.overrides.forEach(([u,S])=>{const j=(0,N.$xc)(t,u,new Set);S.forEach(k=>j.add(k))});const s=[];return t.forEach((o,u)=>s.push([u,[...o.values()]])),{keys:[...i.values()],overrides:s}}class m{constructor(i,t,s,o,u){this.change=i,this.f=t,this.g=s,this.h=o,this.i=u,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const S of i.keys)this.affectedKeys.add(S);for(const[,S]of i.overrides)for(const j of S)this.affectedKeys.add(j);this.d=this.a;for(const S of this.affectedKeys)this.d+=S+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=w.parse(this.f.data,this.i)),this.j}affectsConfiguration(i,t){const s=this.a+i,o=this.d.indexOf(s);if(o<0)return!1;const u=o+s.length;if(u>=this.d.length)return!1;const S=this.d.charCodeAt(u);if(S!==this.b&&S!==this.c)return!1;if(t){const j=this.previousConfiguration?this.previousConfiguration.getValue(i,t,this.f?.workspace):void 0,k=this.g.getValue(i,t,this.h);return!P.$9n(j,k)}return!0}}e.$Fo=m;function f(r,i){const{added:t,removed:s,updated:o}=n(i?.rawConfiguration,r?.rawConfiguration),u=[],S=r?.getAllOverrideIdentifiers()||[],j=i?.getAllOverrideIdentifiers()||[];if(i){const k=j.filter(D=>!S.includes(D));for(const D of k)u.push([D,i.getKeysForOverrideIdentifier(D)])}if(r){const k=S.filter(D=>!j.includes(D));for(const D of k)u.push([D,r.getKeysForOverrideIdentifier(D)])}if(i&&r){for(const k of S)if(j.includes(k)){const D=n({contents:r.getOverrideValue(void 0,k)||{},keys:r.getKeysForOverrideIdentifier(k)},{contents:i.getOverrideValue(void 0,k)||{},keys:i.getKeysForOverrideIdentifier(k)});u.push([k,[...D.added,...D.removed,...D.updated]])}}return{added:t,removed:s,updated:o,overrides:u}}function n(r,i){const t=r?i?r.keys.filter(u=>i.keys.indexOf(u)===-1):[...r.keys]:[],s=i?r?i.keys.filter(u=>r.keys.indexOf(u)===-1):[...i.keys]:[],o=[];if(r&&i){for(const u of i.keys)if(r.keys.indexOf(u)!==-1){const S=(0,h.$aj)(i.contents,u),j=(0,h.$aj)(r.contents,u);P.$9n(S,j)||o.push(u)}}return{added:t,removed:s,updated:o}}}),define(se[139],re([0,1,19,5,2,27,3,68,40,6,39,36]),function(X,e,A,O,I,L,N,P,l,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Io=e.$Ho=e.$Go=void 0;class v extends I.$Uc{get configurationModel(){return this.b}constructor(g){super(),this.c=g,this.a=this.B(new O.$fe),this.onDidChangeConfiguration=this.a.event,this.b=P.$Ao.createEmptyModel(this.c)}async initialize(){return this.h(),this.B(b.$fo.as(l.$ko.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.f(Array.from(g),c))),this.configurationModel}reload(){return this.h(),this.configurationModel}f(g,c){this.j(g,b.$fo.as(l.$ko.Configuration).getConfigurationProperties()),this.a.fire({defaults:this.configurationModel,properties:g})}g(){return{}}h(){this.b=P.$Ao.createEmptyModel(this.c);const g=b.$fo.as(l.$ko.Configuration).getConfigurationProperties();this.j(Object.keys(g),g)}j(g,c){const w=this.g();for(const p of g){const m=w[p],f=c[p];m!==void 0?this.b.addValue(p,m):f?this.b.addValue(p,f.default):this.b.removeValue(p)}}}e.$Go=v;class y{constructor(){this.onDidChangeConfiguration=O.Event.None,this.configurationModel=P.$Ao.createEmptyModel(new a.$fk)}async initialize(){return this.configurationModel}}e.$Ho=y;let $=class extends I.$Uc{get configurationModel(){return this.b}constructor(g,c,w){super(),this.c=g,this.f=c,this.g=w,this.a=this.B(new O.$fe),this.onDidChangeConfiguration=this.a.event,this.b=P.$Ao.createEmptyModel(this.g)}async initialize(){return this.g.trace("PolicyConfiguration#initialize"),this.m(await this.h(this.c.configurationModel.keys),!1),this.B(this.f.onDidChange(g=>this.j(g))),this.B(this.c.onDidChangeConfiguration(async({properties:g})=>this.m(await this.h(g),!0))),this.b}async h(g){this.g.trace("PolicyConfiguration#updatePolicyDefinitions",g);const c={},w=[],p=b.$fo.as(l.$ko.Configuration).getConfigurationProperties();for(const m of g){const f=p[m];if(!f){w.push(m);continue}if(f.policy){if(f.type!=="string"&&f.type!=="number"){this.g.warn(`Policy ${f.policy.name} has unsupported type ${f.type}`);continue}w.push(m),c[f.policy.name]={type:f.type}}}return(0,N.$lg)(c)||await this.f.updatePolicyDefinitions(c),w}j(g){this.g.trace("PolicyConfiguration#onDidChangePolicies",g);const c=b.$fo.as(l.$ko.Configuration).getPolicyConfigurations(),w=(0,A.$Hb)(g.map(p=>c.get(p)));this.m(w,!0)}m(g,c){this.g.trace("PolicyConfiguration#update",g);const w=b.$fo.as(l.$ko.Configuration).getConfigurationProperties(),p=[],m=this.b.isEmpty();for(const f of g){const n=w[f]?.policy?.name;if(n){const r=this.f.getPolicyValue(n);(m?r!==void 0:!(0,L.$9n)(this.b.getValue(f),r))&&p.push([f,r])}else this.b.getValue(f)!==void 0&&p.push([f,void 0])}if(p.length){this.g.trace("PolicyConfiguration#changed",p);const f=this.b;this.b=P.$Ao.createEmptyModel(this.g);for(const n of f.keys)this.b.setValue(n,f.getValue(n));for(const[n,r]of p)r===void 0?this.b.removeValue(n):this.b.setValue(n,r);c&&this.a.fire(this.b)}}};e.$Io=$,e.$Io=$=$e([oe(1,h.$ho),oe(2,a.$5j)],$)}),define(se[140],re([0,1,19,8,14,5,38,77,2,30,27,12,17,29,68,40,139,39]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jo=void 0;class w extends l.$Uc{constructor(f,n,r,i){super(),this.m=f,this.n=i,this.h=this.B(new L.$fe),this.onDidChangeConfiguration=this.h.event,this.b=this.B(new g.$Go(i)),this.c=r instanceof c.$jo?new g.$Ho:this.B(new g.$Io(this.b,r,i)),this.f=this.B(new $.$Co(this.m,{},v.$3g,n,i)),this.a=new $.$Do(this.b.configurationModel,this.c.configurationModel,$.$Ao.createEmptyModel(i),$.$Ao.createEmptyModel(i),$.$Ao.createEmptyModel(i),$.$Ao.createEmptyModel(i),new a.$Ac,$.$Ao.createEmptyModel(i),new a.$Ac,i),this.j=new p(f,n,this),this.g=this.B(new O.$Kh(()=>this.reloadConfiguration(),50)),this.B(this.b.onDidChangeConfiguration(({defaults:t,properties:s})=>this.s(t,s))),this.B(this.c.onDidChangeConfiguration(t=>this.t(t))),this.B(this.f.onDidChange(()=>this.g.schedule()))}async initialize(){const[f,n,r]=await Promise.all([this.b.initialize(),this.c.initialize(),this.f.loadConfiguration()]);this.a=new $.$Do(f,n,$.$Ao.createEmptyModel(this.n),r,$.$Ao.createEmptyModel(this.n),$.$Ao.createEmptyModel(this.n),new a.$Ac,$.$Ao.createEmptyModel(this.n),new a.$Ac,this.n)}getConfigurationData(){return this.a.toData()}getValue(f,n){const r=typeof f=="string"?f:void 0,i=(0,y.$6i)(f)?f:(0,y.$6i)(n)?n:{};return this.a.getValue(r,i,void 0)}async updateValue(f,n,r,i,t){const s=(0,y.$7i)(r)?r:(0,y.$6i)(r)?{resource:r.resource,overrideIdentifiers:r.overrideIdentifier?[r.overrideIdentifier]:void 0}:void 0,o=s?i:r;if(o!==void 0&&o!==3&&o!==2)throw new Error(`Unable to write ${f} to target ${o}.`);s?.overrideIdentifiers&&(s.overrideIdentifiers=(0,A.$Mb)(s.overrideIdentifiers),s.overrideIdentifiers=s.overrideIdentifiers.length?s.overrideIdentifiers:void 0);const u=this.inspect(f,{resource:s?.resource,overrideIdentifier:s?.overrideIdentifiers?s.overrideIdentifiers[0]:void 0});if(u.policyValue!==void 0)throw new Error(`Unable to write ${f} because it is configured in system policy.`);if((0,h.$9n)(n,u.defaultValue)&&(n=void 0),s?.overrideIdentifiers?.length&&s.overrideIdentifiers.length>1){const j=s.overrideIdentifiers.sort(),k=this.a.localUserConfiguration.overrides.find(D=>(0,A.$ub)([...D.identifiers].sort(),j));k&&(s.overrideIdentifiers=k.identifiers)}const S=s?.overrideIdentifiers?.length?[(0,R.$wo)(s.overrideIdentifiers),f]:[f];await this.j.write(S,n),await this.reloadConfiguration()}inspect(f,n={}){return this.a.inspect(f,n,void 0)}keys(){return this.a.keys(void 0)}async reloadConfiguration(){const f=await this.f.loadConfiguration();this.r(f)}r(f){const n=this.a.toData(),r=this.a.compareAndUpdateLocalUserConfiguration(f);this.u(r,n,2)}s(f,n){const r=this.a.toData(),i=this.a.compareAndUpdateDefaultConfiguration(f,n);this.u(i,r,7)}t(f){const n=this.a.toData(),r=this.a.compareAndUpdatePolicyConfiguration(f);this.u(r,n,7)}u(f,n,r){const i=new $.$Fo(f,{data:n},this.a,void 0,this.n);i.source=r,this.h.fire(i)}}e.$Jo=w;class p{constructor(f,n,r){this.b=f,this.c=n,this.d=r,this.a=new O.$Fh}write(f,n){return this.a.queue(()=>this.e(f,n))}async e(f,n){let r;try{r=(await this.c.readFile(this.b)).value.toString()}catch(s){if(s.fileOperationResult===1)r="{}";else throw s}const i=[];if((0,N.$Ln)(r,i,{allowTrailingComma:!0,allowEmptyContent:!0}),i.length>0)throw new Error("Unable to write into the settings file. Please open the file to correct errors/warnings in the file and try again.");const t=this.f(r,f,n);r=(0,P.$4n)(r,t),await this.c.writeFile(this.b,I.$He.fromString(r))}f(f,n,r){const{tabSize:i,insertSpaces:t,eol:s}=this.h;if(!n.length){const o=JSON.stringify(r,null,t?" ".repeat(i):"	");return[{content:o,length:o.length,offset:0}]}return(0,P.$1n)(f,n,r,{tabSize:i,insertSpaces:t,eol:s})}get h(){if(!this.g){let f=b.OS===3||b.OS===2?`
`:`\r
`;const n=this.d.getValue("files.eol",{overrideIdentifier:"jsonc"});n&&typeof n=="string"&&n!=="auto"&&(f=n),this.g={eol:f,insertSpaces:!!this.d.getValue("editor.insertSpaces",{overrideIdentifier:"jsonc"}),tabSize:this.d.getValue("editor.tabSize",{overrideIdentifier:"jsonc"})}}return this.g}}}),define(se[69],re([0,1,15]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=O,e.$Km=I,e.$Lm=L,e.$Mm=N;function O(l){return l.scheme===A.Schemas.vscodeRemote?l.authority:void 0}function I(l){if(!l)return;const a=l.indexOf("+");return a<0?l:l.substr(0,a)}function L(l){const{host:a,port:h}=P(l);if(typeof h>"u")throw new Error(`Invalid remote authority: ${l}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:a,port:h}}function N(l,a){let{host:h,port:b}=P(l);return typeof b>"u"&&(b=a),{host:h,port:b}}function P(l){const a=l.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(a)return{host:a[1],port:parseInt(a[2],10)};const h=l.match(/^(\[[0-9a-z:]+\])$/);if(h)return{host:h[1],port:void 0};const b=l.match(/(.*):(\d+)$/);return b?{host:b[1],port:parseInt(b[2],10)}:{host:l,port:void 0}}}),define(se[37],re([0,1,31,10,69]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=L,e.$Wm=b,e.$Xm=v,e.$Ym=y,e.$Zm=$,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function L(R){if(typeof R=="object"&&R!==null&&R.supported!==!0)return R.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var N;(function(R){R[R.System=0]="System",R[R.User=1]="User"})(N||(e.ExtensionType=N={}));var P;(function(R){R.WIN32_X64="win32-x64",R.WIN32_ARM64="win32-arm64",R.LINUX_X64="linux-x64",R.LINUX_ARM64="linux-arm64",R.LINUX_ARMHF="linux-armhf",R.ALPINE_X64="alpine-x64",R.ALPINE_ARM64="alpine-arm64",R.DARWIN_X64="darwin-x64",R.DARWIN_ARM64="darwin-arm64",R.WEB="web",R.UNIVERSAL="universal",R.UNKNOWN="unknown",R.UNDEFINED="undefined"})(P||(e.TargetPlatform=P={}));class l{constructor(g){this.value=g,this._lower=g.toLowerCase()}static equals(g,c){if(typeof g>"u"||g===null)return typeof c>"u"||c===null;if(typeof c>"u"||c===null)return!1;if(typeof g=="string"||typeof c=="string"){const w=typeof g=="string"?g:g.value,p=typeof c=="string"?c:c.value;return A.$zf(w,p)}return g._lower===c._lower}static toKey(g){return typeof g=="string"?g.toLowerCase():g._lower}}e.$Tm=l;class a{get size(){return this.c.size}constructor(g){if(this.c=new Set,g)for(const c of g)this.add(c)}add(g){this.c.add(l.toKey(g))}delete(g){return this.c.delete(l.toKey(g))}has(g){return this.c.has(l.toKey(g))}}e.$Um=a;class h{constructor(){this.c=new Map}clear(){this.c.clear()}delete(g){this.c.delete(l.toKey(g))}get(g){return this.c.get(l.toKey(g))}has(g){return this.c.has(l.toKey(g))}set(g,c){this.c.set(l.toKey(g),c)}values(){return this.c.values()}forEach(g){this.c.forEach(g)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=h;function b(R){return v(R)}function v(R){return R.contributes&&R.contributes.localizations?R.contributes.localizations.length>0:!1}function y(R){return R.contributes&&R.contributes.authentication?R.contributes.authentication.length>0:!1}function $(R,g){if(g){const c=`onResolveRemoteAuthority:${(0,I.$Km)(g)}`;return!!R.activationEvents?.includes(c)}return!1}e.$1m=(0,O.$yi)("IBuiltinExtensionsScannerService")}),define(se[141],re([0,1,2,37,13]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gq=void 0;class L extends A.$Uc{constructor(P,l,a,h,b){super(),this.a=P,this.b=l,this.c=a,this.f=b,this.B(h.onDidInstallExtensions(v=>this.g(v))),this.B(h.onDidUninstallExtension(v=>this.h(v)))}g(P){for(const l of P)l.local&&this.invalidate(l.profileLocation)}h(P){P.error||this.invalidate(P.profileLocation)}async invalidate(P){if(P)for(const l of this.a.profiles)this.c.extUri.isEqual(l.extensionsResource,P)&&await this.j(l);else await this.j(this.a.defaultProfile)}async j(P){try{await this.b.del(this.c.extUri.joinPath(P.cacheHome,O.$Nm))}catch(l){(0,I.$jl)(l)!==1&&this.f.error(l)}}}e.$Gq=L}),define(se[45],re([0,1,14,9,2,110,40,10,6,36]),function(X,e,A,O,I,L,N,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Tp=v,e.$Up=y,e.$Vp=$,e.$Wp=R,e.$Xp=g,e.$Yp=c,e.$Rp=(0,P.$yi)("requestService");class h{constructor(f){this.b=f}toJSON(){if(!this.a){const f=Object.create(null);for(const n in this.b)n.toLowerCase()==="authorization"||n.toLowerCase()==="proxy-authorization"?f[n]="*****":f[n]=this.b[n];this.a=f}return this.a}}class b extends I.$Uc{constructor(f){super(),this.b=0,this.a=f.createLogger("network",{name:(0,L.localize)(0,null),when:l.$kk.isEqualTo((0,l.$hk)(l.LogLevel.Trace)).serialize()})}async c(f,n,r){const i=`${f} #${++this.b}: ${n.url}`;this.a.trace(`${i} - begin`,n.type,new h(n.headers??{}));try{const t=await r();return this.a.trace(`${i} - end`,n.type,t.res.statusCode,t.res.headers),t}catch(t){throw this.a.error(`${i} - error`,n.type,(0,O.$0)(t)),t}}}e.$Sp=b;function v(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}function y(m){return m.res.statusCode===204}async function $(m){return y(m)?null:(await(0,A.$Te)(m.stream)).toString()}async function R(m){if(!v(m))throw new Error("Server returned "+m.res.statusCode);return $(m)}async function g(m){if(!v(m))throw new Error("Server returned "+m.res.statusCode);if(y(m))return null;const n=(await(0,A.$Te)(m.stream)).toString();try{return JSON.parse(n)}catch(r){throw r.message+=`:
`+n,r}}function c(m){p(m)}let w;function p(m){const f=a.$fo.as(N.$ko.Configuration),n=w;w={id:"http",order:15,title:(0,L.localize)(1,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,L.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(6,null),(0,L.localize)(7,null),(0,L.localize)(8,null),(0,L.localize)(9,null)],default:"override",description:(0,L.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,L.localize)(12,null),restricted:!0}}},f.updateConfigurations({add:[w],remove:n?[n]:[]})}p(1)}),define(se[142],re([0,1,22,15,13,45]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$sQ=void 0;let N=class{constructor(l,a){this.a=l,this.b=a}async download(l,a,h=A.CancellationToken.None){if(l.scheme===O.Schemas.file||l.scheme===O.Schemas.vscodeRemote){await this.b.copy(l,a);return}const b={type:"GET",url:l.toString(!0)},v=await this.a.request(b,h);if(v.res.statusCode===200)await this.b.writeFile(a,v.stream);else{const y=await(0,L.$Wp)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${y}`)}}};e.$sQ=N,e.$sQ=N=$e([oe(0,L.$Rp),oe(1,I.$5k)],N)}),define(se[143],re([0,1,144,3]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2r=L;function I(N,P){return N.protocol==="http:"?P.HTTP_PROXY||P.http_proxy||null:N.protocol==="https:"&&(P.HTTPS_PROXY||P.https_proxy||P.HTTP_PROXY||P.http_proxy)||null}async function L(N,P,l={}){const a=(0,A.parse)(N),h=l.proxyUrl||I(a,P);if(!h)return null;const b=(0,A.parse)(h);if(!/^https?:$/.test(b.protocol||""))return null;const v={host:b.hostname||"",port:(b.port?+b.port:0)||(b.protocol==="https"?443:80),auth:b.auth,rejectUnauthorized:(0,O.$eg)(l.strictSSL)?l.strictSSL:!0};return a.protocol==="http:"?new(await new Promise((y,$)=>{X(["http-proxy-agent"],y,$)})).HttpProxyAgent(h,v):new(await new Promise((y,$)=>{X(["https-proxy-agent"],y,$)})).HttpsProxyAgent(h,v)}}),define(se[145],re([0,1,60,16,111,22,34,9,12,28,90,175,8,78]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Im=R;let $;async function R(c,w,p,m){return p["force-disable-user-env"]?(w.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):l.$i?(w.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,b.$Cm)(m)&&!p["force-user-env"]?(w.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,b.$Cm)(m)?w.trace("resolveShellEnv(): running (--force-user-env)"):w.trace("resolveShellEnv(): running (macOS/Linux)"),$||($=v.Promises.withAsyncBody(async(f,n)=>{const r=new L.$qe;let i=1e4;const t=c.getValue("application.shellEnvironmentResolutionTimeout");typeof t=="number"&&(i=(0,y.$Dm)(t,1,120)*1e3);const s=setTimeout(()=>{r.dispose(!0),n(new Error((0,I.localize)(0,null)))},i);try{f(await g(w,r.token))}catch(o){!(0,P.$4)(o)&&!r.token.isCancellationRequested?n(new Error((0,I.localize)(1,null,(0,N.$jj)(o)))):f({})}finally{clearTimeout(s),r.dispose()}})),$)}async function g(c,w){const p=process.env.ELECTRON_RUN_AS_NODE;c.trace("getUnixShellEnvironment#runAsNode",p);const m=process.env.ELECTRON_NO_ATTACH_CONSOLE;c.trace("getUnixShellEnvironment#noAttach",m);const f=(0,a.$Ug)().replace(/-/g,"").substr(0,12),n=new RegExp(f+"({.*})"+f),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1",VSCODE_RESOLVING_ENVIRONMENT:"1"};c.trace("getUnixShellEnvironment#env",r);const i=await(0,h.$sm)(l.OS,r);return c.trace("getUnixShellEnvironment#shell",i),new Promise((t,s)=>{if(w.isCancellationRequested)return s(new P.$5);const o=(0,O.$nc)(i);let u,S;const j="";/^pwsh(-preview)?$/.test(o)?(u=`& '${process.execPath}' ${j} -p '''${f}'' + JSON.stringify(process.env) + ''${f}'''`,S=["-Login","-Command"]):o==="nu"?(u=`^'${process.execPath}' ${j} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,S=["-i","-l","-c"]):o==="xonsh"?(u=`import os, json; print("${f}", json.dumps(dict(os.environ)), "${f}")`,S=["-i","-l","-c"]):(u=`'${process.execPath}' ${j} -p '"${f}" + JSON.stringify(process.env) + "${f}"'`,o==="tcsh"||o==="csh"?S=["-ic"]:S=["-i","-l","-c"]),c.trace("getUnixShellEnvironment#spawn",JSON.stringify(S),u);const k=(0,A.spawn)(i,[...S,u],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});w.onCancellationRequested(()=>(k.kill(),s(new P.$5))),k.on("error",C=>{c.error("getUnixShellEnvironment#errorChildProcess",(0,N.$jj)(C)),s(C)});const D=[];k.stdout.on("data",C=>D.push(C));const F=[];k.stderr.on("data",C=>F.push(C)),k.on("close",(C,J)=>{const ne=Buffer.concat(D).toString("utf8");c.trace("getUnixShellEnvironment#raw",ne);const ie=Buffer.concat(F).toString("utf8");if(ie.trim()&&c.trace("getUnixShellEnvironment#stderr",ie),C||J)return s(new Error((0,I.localize)(2,null,C,J)));const ue=n.exec(ne),le=ue?ue[1]:"{}";try{const ce=JSON.parse(le);p?ce.ELECTRON_RUN_AS_NODE=p:delete ce.ELECTRON_RUN_AS_NODE,m?ce.ELECTRON_NO_ATTACH_CONSOLE=m:delete ce.ELECTRON_NO_ATTACH_CONSOLE,delete ce.VSCODE_RESOLVING_ENVIRONMENT,delete ce.XDG_RUNTIME_DIR,c.trace("getUnixShellEnvironment#result",ce),t(ce)}catch(ce){c.error("getUnixShellEnvironment#errorCaught",(0,N.$jj)(ce)),s(ce)}})})}}),define(se[146],re([0,1,10]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8P=e.$7P=void 0,e.$7P=(0,A.$yi)("stateReadService"),e.$8P=(0,A.$yi)("stateService")}),define(se[70],re([0,1,8,14,2,3,18,13,6]),function(X,e,A,O,I,L,N,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$P=e.$0P=e.$9P=e.SaveStrategy=void 0;var a;(function(y){y[y.IMMEDIATE=0]="IMMEDIATE",y[y.DELAYED=1]="DELAYED"})(a||(e.SaveStrategy=a={}));class h extends I.$Uc{constructor($,R,g,c){super(),this.h=$,this.j=R,this.m=g,this.n=c,this.a=Object.create(null),this.b="",this.c=this.B(new A.$wh(this.j===0?0:100)),this.f=void 0,this.g=void 0}init(){return this.f||(this.f=this.r()),this.f}async r(){try{this.b=(await this.n.readFile(this.h)).value.toString(),this.a=JSON.parse(this.b)}catch($){$.fileOperationResult!==1&&this.m.error($)}}getItem($,R){const g=this.a[$];return(0,L.$hg)(g)?R:g}setItem($,R){this.setItems([{key:$,data:R}])}setItems($){let R=!1;for(const{key:g,data:c}of $)this.a[g]!==c&&((0,L.$hg)(c)?(0,L.$fg)(this.a[g])||(this.a[g]=void 0,R=!0):(this.a[g]=c,R=!0));R&&this.s()}removeItem($){(0,L.$fg)(this.a[$])||(this.a[$]=void 0,this.s())}async s(){if(!this.g)return this.c.trigger(()=>this.t())}async t(){if(!this.f)return;await this.f;const $=JSON.stringify(this.a,null,4);if($!==this.b)try{await this.n.writeFile(this.h,O.$He.fromString($),{atomic:{postfix:".vsctmp"}}),this.b=$}catch(R){this.m.error(R)}}async close(){return this.g||(this.g=this.c.trigger(()=>this.t(),0)),this.g}}e.$9P=h;let b=class extends I.$Uc{constructor($,R,g,c){super(),this.a=this.B(new h(R.stateResource,$,g,c))}async init(){await this.a.init()}getItem($,R){return this.a.getItem($,R)}};e.$0P=b,e.$0P=b=$e([oe(1,N.$Fi),oe(2,l.$5j),oe(3,P.$5k)],b);class v extends b{setItem($,R){this.a.setItem($,R)}setItems($){this.a.setItems($)}removeItem($){this.a.removeItem($)}close(){return this.a.close()}}e.$$P=v}),define(se[71],re([0,1,12,35,28]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=N,e.$ip=P;function L(l){if(A.$u===2&&/^penguin(\.|$)/i.test(l))return"chromebook"}function N(l,a,h,b,v,y,$,R,g){const c=Object.create(null);c["common.machineId"]=y,c["common.sqmId"]=$,c.sessionID=(0,I.$Ug)()+Date.now(),c.commitHash=b,c.version=v,c["common.platformVersion"]=(l||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,A.$h)(A.$u),c["common.nodePlatform"]=O.$dc,c["common.nodeArch"]=h,c["common.product"]=g||"desktop",R&&(c["common.msftInternal"]=R);let w=0;const p=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-p,enumerable:!0},"common.sequence":{get:()=>w++,enumerable:!0}}),A.$l&&(c["common.snap"]="true");const m=L(a);return m&&(c["common.platformDetail"]=m),c}function P(l){const a=O.env.USERDNSDOMAIN;if(!a)return!1;const h=a.toLowerCase();return l.some(b=>h===b)}}),define(se[21],re([0,1,10]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,A.$yi)("telemetryService"),e.$5l=(0,A.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var O;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(O||(e.TelemetryLevel=O={}));var I;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(I||(e.TelemetryConfiguration=I={}))}),define(se[72],re([0,1,9,10,6,21]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fq=e.$eq=e.ExtensionSignatureVerificationCode=e.$dq=void 0,e.$dq=(0,O.$yi)("IExtensionSignatureVerificationService");var N;(function(a){a.None="None",a.RequiredArgumentMissing="RequiredArgumentMissing",a.InvalidArgument="InvalidArgument",a.PackageIsUnreadable="PackageIsUnreadable",a.UnhandledException="UnhandledException",a.SignatureManifestIsMissing="SignatureManifestIsMissing",a.SignatureManifestIsUnreadable="SignatureManifestIsUnreadable",a.SignatureIsMissing="SignatureIsMissing",a.SignatureIsUnreadable="SignatureIsUnreadable",a.CertificateIsUnreadable="CertificateIsUnreadable",a.SignatureArchiveIsUnreadable="SignatureArchiveIsUnreadable",a.FileAlreadyExists="FileAlreadyExists",a.SignatureArchiveIsInvalidZip="SignatureArchiveIsInvalidZip",a.SignatureArchiveHasSameSignatureFile="SignatureArchiveHasSameSignatureFile",a.Success="Success",a.PackageIntegrityCheckFailed="PackageIntegrityCheckFailed",a.SignatureIsInvalid="SignatureIsInvalid",a.SignatureManifestIsInvalid="SignatureManifestIsInvalid",a.SignatureIntegrityCheckFailed="SignatureIntegrityCheckFailed",a.EntryIsMissing="EntryIsMissing",a.EntryIsTampered="EntryIsTampered",a.Untrusted="Untrusted",a.CertificateRevoked="CertificateRevoked",a.SignatureIsNotValid="SignatureIsNotValid",a.UnknownError="UnknownError",a.PackageIsInvalidZip="PackageIsInvalidZip",a.SignatureArchiveHasTooManyEntries="SignatureArchiveHasTooManyEntries"})(N||(e.ExtensionSignatureVerificationCode=N={}));class P extends Error{constructor(h){super(h),this.code=h}}e.$eq=P;let l=class{constructor(h,b){this.b=h,this.c=b}d(){return this.a||(this.a=new Promise((h,b)=>X(["@vscode/vsce-sign"],async v=>h(v),b))),this.a}async verify(h,b,v,y){let $;const R=h.identifier.id;try{$=await this.d()}catch(p){return this.b.error("Could not load vsce-sign module",(0,A.$0)(p)),this.b.info(`Extension signature verification is not done: ${R}`),!1}const g=new Date().getTime();let c;try{this.b.trace(`Verifying extension signature for ${R}...`),c=await $.verify(b,v,this.b.getLevel()===I.LogLevel.Trace)}catch(p){c={code:"UnknownError",didExecute:!1,output:(0,A.$0)(p)}}const w=new Date().getTime()-g;if(this.b.info(`Extension signature verification result for ${R}: ${c.code}. Executed: ${c.didExecute}. Duration: ${w}ms.`),this.b.trace(`Extension signature verification output for ${R}:
${c.output}`),this.c.publicLog2("extensionsignature:verification",{extensionId:R,extensionVersion:h.version,code:c.code,internalCode:c.internalCode,duration:w,didExecute:c.didExecute,clientTargetPlatform:y}),c.code==="Success")return!0;throw new P(c.code)}};e.$fq=l,e.$fq=l=$e([oe(0,I.$5j),oe(1,L.$4l)],l)}),define(se[41],re([0,1,27,3,69,71,21]),function(X,e,A,O,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$qp=h,e.$rp=b,e.$sp=v,e.$tp=y,e.$up=R,e.$vp=c,e.$wp=w,e.$xp=f;class P{constructor(r){this.value=r,this.isTrustedTelemetryValue=!0}}e.$jp=P;class l{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$kp=l,e.$lp=new l;class a{async publicLog(r,i,t){}async publicLogError(r,i,t){}}e.$mp=a,e.$np="telemetry",e.$op="extensionTelemetryLog",e.$pp={log:()=>null,flush:()=>Promise.resolve(null)};function h(n,r){return!r.isBuilt&&!r.disableTelemetry?!0:!(r.disableTelemetry||!n.enableTelemetry)}function b(n,r){return r.extensionTestsLocationURI?!0:!(r.isBuilt||r.disableTelemetry||n.enableTelemetry&&n.aiConfig?.ariaKey)}function v(n){const r=n.getValue(N.$_l),i=n.getValue(N.$am);if(n.getValue(N.$bm)===!1||i===!1)return 0;switch(r??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function y(n){const r={},i={},t={};g(n,t);for(let s in t){s=s.length>150?s.substr(s.length-149):s;const o=t[s];typeof o=="number"?i[s]=o:typeof o=="boolean"?i[s]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${s} has been trimmed to 8192, the original length is ${o.length}`),r[s]=o.substring(0,8191)):typeof o<"u"&&o!==null&&(r[s]=o)}return{properties:r,measurements:i}}const $=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function R(n){if(!n)return"none";const r=(0,I.$Km)(n);return $.has(r)?r:"other"}function g(n,r,i=0,t){if(n)for(const s of Object.getOwnPropertyNames(n)){const o=n[s],u=t?t+s:s;Array.isArray(o)?r[u]=(0,A.$0n)(o):o instanceof Date?r[u]=o.toISOString():(0,O.$ag)(o)?i<2?g(o,r,i+1,u+"."):r[u]=(0,A.$0n)(o):r[u]=o}}function c(n,r){const i=n.msftInternalDomains||[],t=r.getValue("telemetry.internalTesting");return(0,L.$ip)(i)||t}function w(n){return[n.appRoot,n.extensionsPath,n.userHome.fsPath,n.tmpDir.fsPath,n.userDataPath]}function p(n,r){if(!n||!n.includes("/")&&!n.includes("\\"))return n;let i=n;const t=[];for(const S of r)for(;;){const j=S.exec(n);if(!j)break;t.push([j.index,S.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,o=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let u=0;for(i="";;){const S=o.exec(n);if(!S)break;const j=t.some(([k,D])=>S.index<D&&k<o.lastIndex);!s.test(S[0])&&!j&&(i+=n.substring(u,S.index)+"<REDACTED: user-file-path>",u=o.lastIndex)}return u<n.length&&(i+=n.substr(u)),i}function m(n){if(!n)return n;const r=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const i of r)if(i.regex.test(n))return`<REDACTED: ${i.label}>`;return n}function f(n,r){return(0,A.$7n)(n,i=>{if(i instanceof P||Object.hasOwnProperty.call(i,"isTrustedTelemetryValue"))return i.value;if(typeof i=="string"){let t=i.replaceAll("%20"," ");t=p(t,r);for(const s of r)t=t.replace(s,"");return t=m(t),t}})}}),define(se[26],re([0,1,31,20,37,12,11,9,35,41]),function(X,e,A,O,I,L,N,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$zp=void 0,e.$yp=h,e.$Ap=$,e.$Bp=R,e.$Cp=g,e.$Dp=c,e.$Ep=w,e.$Fp=p,e.$Gp=m,e.$Ip=f,e.$Jp=r;function h(i,t){return i.uuid&&t.uuid?i.uuid===t.uuid:i.id===t.id?!0:(0,A.$uf)(i.id,t.id)===0}const b=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class v{static create(t){const s=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new v(t.identifier,s,o)}static parse(t){const s=b.exec(t);return s&&s[1]&&s[2]?new v({id:s[1]},s[2],s[4]||void 0):null}constructor(t,s,o="undefined"){this.version=s,this.targetPlatform=o,this.id=t.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof v?h(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.$zp=v;const y=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function $(i){const t=y.exec(i);return t&&t[1]?[g(t[1]),t[2]]:[g(i),void 0]}function R(i,t){return`${i}.${t}`}function g(i){return i.toLowerCase()}function c(i,t){return g(R(i??I.$Pm,t))}function w(i,t){const s=[],o=u=>{for(const S of s)if(S.some(j=>h(t(j),t(u))))return S;return null};for(const u of i){const S=o(u);S?S.push(u):s.push([u])}return s}function p(i){return{id:i.identifier.id,name:i.manifest.name,galleryId:null,publisherId:i.publisherId,publisherName:i.manifest.publisher,publisherDisplayName:i.publisherDisplayName,dependencies:i.manifest.extensionDependencies&&i.manifest.extensionDependencies.length>0}}function m(i){return{id:new a.$jp(i.identifier.id),name:new a.$jp(i.name),version:i.version,galleryId:i.identifier.uuid,publisherId:i.publisherId,publisherName:i.publisher,publisherDisplayName:i.publisherDisplayName,isPreReleaseVersion:i.properties.isPreReleaseVersion,dependencies:!!(i.properties.dependencies&&i.properties.dependencies.length>0),isSigned:i.isSigned,...i.telemetryData}}e.$Hp=new I.$Tm("pprice.better-merge");function f(i,t){const s=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const u=o.shift();if(u&&s.every(S=>!h(S.identifier,{id:u}))){const S=i.filter(j=>h(j.identifier,{id:u}));S.length===1&&(s.push(S[0]),o.push(...S[0].manifest.extensionDependencies?.slice(0)??[]))}}return s}async function n(i,t){if(!L.$k)return!1;let s;try{s=(await i.readFile(N.URI.file("/etc/os-release"))).value.toString()}catch{try{s=(await i.readFile(N.URI.file("/usr/lib/os-release"))).value.toString()}catch(u){t.debug("Error while getting the os-release file.",(0,P.$0)(u))}}return!!s&&(s.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function r(i,t){const s=await n(i,t),o=(0,O.$6o)(s?"alpine":L.$u,l.$ec);return t.debug("ComputeTargetPlatform:",o),o}}),define(se[147],re([0,1,22,9,15,17,44,11,99,20,26,37]),function(X,e,A,O,I,L,N,P,l,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gq=void 0;const v=R=>(0,l.localize)(0,null,R),y=(0,l.localize)(1,null,"ms-dotnettools.csharp");let $=class{constructor(g,c,w){this.a=g,this.b=c,this.d=w}get f(){}async listExtensions(g,c,w){let p=await this.b.getInstalled(1,w);const m=b.$Sm.map(n=>n.toLowerCase());if(c&&c!==""){if(m.indexOf(c.toLowerCase())<0){this.a.info("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}p=p.filter(n=>n.manifest.categories?n.manifest.categories.map(i=>i.toLowerCase()).indexOf(c.toLowerCase())>-1:!1)}else if(c===""){this.a.info("Possible Categories: "),m.forEach(n=>{this.a.info(n)});return}this.f&&this.a.info((0,l.localize)(2,null,this.f)),p=p.sort((n,r)=>n.identifier.id.localeCompare(r.identifier.id));let f;for(const n of p)f!==n.identifier.id&&(f=n.identifier.id,this.a.info(g?`${f}@${n.manifest.version}`:f))}async installExtensions(g,c,w,p){const m=[];try{g.length&&this.a.info(this.f?(0,l.localize)(3,null,this.f):(0,l.localize)(4,null));const f=[],n=[],r=(t,s,o)=>{n.push({id:t,version:s!=="prerelease"?s:void 0,installOptions:{...w,isBuiltin:o,installPreReleaseVersion:s==="prerelease"||w.installPreReleaseVersion}})};for(const t of g)if(t instanceof P.URI)f.push({vsix:t,installOptions:w});else{const[s,o]=(0,h.$Ap)(t);r(s,o,!1)}for(const t of c)if(t instanceof P.URI)f.push({vsix:t,installOptions:{...w,isBuiltin:!0,donotIncludePackAndDependencies:!0}});else{const[s,o]=(0,h.$Ap)(t);r(s,o,!0)}const i=await this.b.getInstalled(void 0,w.profileLocation);if(f.length&&await Promise.all(f.map(async({vsix:t,installOptions:s})=>{try{await this.h(t,s,p,i)}catch(o){this.a.error(o),m.push(t.toString())}})),n.length){const t=await this.g(n,i,p);m.push(...t)}}catch(f){throw this.a.error((0,l.localize)(5,null,(0,O.$0)(f))),f}if(m.length)throw new Error((0,l.localize)(6,null,m.join(", ")))}async updateExtensions(g){const c=await this.b.getInstalled(1,g),w=[];for(const n of c)n.identifier.uuid&&w.push({...n.identifier,preRelease:n.preRelease});this.a.trace((0,l.localize)(7,null,w.length));const p=await this.d.getExtensions(w,{compatible:!0},A.CancellationToken.None),m=[];for(const n of p)for(const r of c)(0,h.$yp)(r.identifier,n.identifier)&&(0,N.gt)(n.version,r.manifest.version)&&m.push({extension:n,options:{operation:3,installPreReleaseVersion:r.preRelease,profileLocation:g}});if(!m.length){this.a.info((0,l.localize)(8,null));return}this.a.info((0,l.localize)(9,null,m.map(n=>n.extension.identifier.id).join(", ")));const f=await this.b.installGalleryExtensions(m);for(const n of f)n.error?this.a.error((0,l.localize)(10,null,n.identifier.id,(0,O.$0)(n.error))):this.a.info((0,l.localize)(11,null,n.identifier.id,n.local?.manifest.version))}async g(g,c,w){if(g=g.filter(({id:n,version:r})=>{const i=c.find(t=>(0,h.$yp)(t.identifier,{id:n}));if(i){if(!w&&(!r||r==="prerelease"&&i.preRelease))return this.a.info((0,l.localize)(12,null,n,i.manifest.version,n)),!1;if(r&&i.manifest.version===r)return this.a.info((0,l.localize)(13,null,`${n}@${r}`)),!1}return!0}),!g.length)return[];const p=[],m=[],f=await this.j(g);if(await Promise.all(g.map(async({id:n,version:r,installOptions:i})=>{const t=f.get(n.toLowerCase());if(!t){this.a.error(`${v(r?`${n}@${r}`:n)}
${y}`),p.push(n);return}try{const o=await this.d.getManifest(t,A.CancellationToken.None);if(o&&!this.k(o))return}catch(o){this.a.error(o.message||o.stack||o),p.push(n);return}const s=c.find(o=>(0,h.$yp)(o.identifier,t.identifier));if(s){if(t.version===s.manifest.version){this.a.info((0,l.localize)(14,null,r?`${n}@${r}`:n));return}this.a.info((0,l.localize)(15,null,n,t.version))}i.isBuiltin?this.a.info(r?(0,l.localize)(16,null,n,r):(0,l.localize)(17,null,n)):this.a.info(r?(0,l.localize)(18,null,n,r):(0,l.localize)(19,null,n)),m.push({extension:t,options:{...i,installGivenVersion:!!r}})})),m.length){const n=await this.b.installGalleryExtensions(m);for(const r of n)r.error?(this.a.error((0,l.localize)(20,null,r.identifier.id,(0,O.$0)(r.error))),p.push(r.identifier.id)):this.a.info((0,l.localize)(21,null,r.identifier.id,r.local?.manifest.version))}return p}async h(g,c,w,p){const m=await this.b.getManifest(g);if(!m)throw new Error("Invalid vsix");if(await this.l(m,w,c.profileLocation,p))try{await this.b.install(g,c),this.a.info((0,l.localize)(22,null,(0,L.$9g)(g)))}catch(n){if((0,O.$4)(n))this.a.info((0,l.localize)(23,null,(0,L.$9g)(g)));else throw n}}async j(g){const c=new Map,w=g.some(f=>f.installOptions.installPreReleaseVersion),p=await this.b.getTargetPlatform(),m=[];for(const f of g)a.$Xo.test(f.id)&&m.push({...f,preRelease:w});if(m.length){const f=await this.d.getExtensions(m,{targetPlatform:p},A.CancellationToken.None);for(const n of f)c.set(n.identifier.id.toLowerCase(),n)}return c}k(g){return!0}async l(g,c,w,p){if(!c){const m={id:(0,h.$Dp)(g.publisher,g.name)},f=p.find(n=>(0,h.$yp)(m,n.identifier)&&(0,N.gt)(n.manifest.version,g.version));if(f)return this.a.info((0,l.localize)(24,null,f.identifier.id,f.manifest.version,g.version)),!1}return this.k(g)}async uninstallExtensions(g,c,w){const p=async f=>{if(f instanceof P.URI){const n=await this.b.getManifest(f);return(0,h.$Bp)(n.publisher,n.name)}return f},m=[];for(const f of g){const n=await p(f),i=(await this.b.getInstalled(void 0,w)).filter(t=>(0,h.$yp)(t.identifier,{id:n}));if(!i.length)throw new Error(`${this.m(n)}
${y}`);if(i.some(t=>t.type===0)){this.a.info((0,l.localize)(25,null,n));return}if(!c&&i.some(t=>t.isBuiltin)){this.a.info((0,l.localize)(26,null,n));return}this.a.info((0,l.localize)(27,null,n));for(const t of i)await this.b.uninstall(t,{profileLocation:w}),m.push(t);this.f?this.a.info((0,l.localize)(28,null,n,this.f)):this.a.info((0,l.localize)(29,null,n))}}async locateExtension(g){const c=await this.b.getInstalled();g.forEach(w=>{c.forEach(p=>{if(p.identifier.id===w&&p.location.scheme===I.Schemas.file){this.a.info(p.location.fsPath);return}})})}m(g){return this.f?(0,l.localize)(30,null,g,this.f):(0,l.localize)(31,null,g)}};e.$gq=$,e.$gq=$=$e([oe(1,a.$ap),oe(2,a.$0o)],$)}),define(se[148],re([0,1,5,2,30,26,37]),function(X,e,A,O,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hq=void 0;class P extends O.$Uc{constructor(a,h,b,v,y,$,R){super(),this.f=a,this.g=h,this.h=b,this.j=v,this.m=y,this.n=$,this.r=R,this.a=this.B(new A.$fe),this.onDidChangeExtensionsByAnotherSource=this.a.event,this.b=new Map,this.c=this.B(new O.$4c),this.s().then(null,g=>R.error(g))}async s(){await this.g.initializeDefaultProfileExtensions(),await this.u(this.h.profiles),this.t(),await this.H()}t(){this.B(this.h.onDidChangeProfiles(a=>this.u(a.added))),this.B(this.j.onAddExtensions(a=>this.w(a))),this.B(this.j.onDidAddExtensions(a=>this.y(a))),this.B(this.j.onRemoveExtensions(a=>this.z(a))),this.B(this.j.onDidRemoveExtensions(a=>this.C(a))),this.B(this.n.onDidFilesChange(a=>this.D(a)))}async u(a){try{a.length&&await Promise.all(a.map(h=>(this.c.set(h.id,(0,O.$Rc)(this.n.watch(this.m.extUri.dirname(h.extensionsResource)),this.n.watch(h.extensionsResource))),this.G(h.extensionsResource))))}catch(h){throw this.r.error(h),h}}async w(a){for(const h of a.extensions)this.I(this.L(h.identifier,h.version),a.profileLocation)}async y(a){for(const h of a.extensions){const b=this.L(h.identifier,h.version);a.error?this.J(b,a.profileLocation):this.I(b,a.profileLocation)}}async z(a){for(const h of a.extensions)this.J(this.L(h.identifier,h.version),a.profileLocation)}async C(a){const h=[],b=[];for(const v of a.extensions){const y=this.L(v.identifier,v.version);a.error?this.I(y,a.profileLocation):(this.J(y,a.profileLocation),this.b.has(y)||(this.r.debug("Extension is removed from all profiles",v.identifier.id,v.version),b.push(this.f.scanInstalledExtensionAtLocation(v.location).then($=>{$?h.push($):this.r.info("Extension not found at the location",v.location.toString())},$=>this.r.error($)))))}try{await Promise.all(b),h.length&&await this.H(h)}catch(v){this.r.error(v)}}D(a){for(const h of this.h.profiles)a.contains(h.extensionsResource,0,1)&&this.F(h.extensionsResource)}async F(a){const h=[],b=[],v=await this.j.scanProfileExtensions(a),y=new Set,$=new Set;for(const[R,g]of this.b)g.has(a)&&$.add(R);for(const R of v){const g=this.L(R.identifier,R.version);y.add(g),$.has(g)||(h.push(R.identifier),this.I(g,a))}for(const R of $)if(!y.has(R)){const g=this.M(R);g&&(b.push(g.identifier),this.J(R,a))}(h.length||b.length)&&this.a.fire({added:h.length?{extensions:h,profileLocation:a}:void 0,removed:b.length?{extensions:b,profileLocation:a}:void 0})}async G(a){const h=await this.j.scanProfileExtensions(a);for(const b of h)this.I(this.L(b.identifier,b.version),a)}async H(a){a||(a=(await this.f.scanAllUserInstalledExtensions()).filter(b=>!this.b.has(this.L(b.identifier,b.manifest.version)))),a.length&&await this.f.markAsUninstalled(...a)}I(a,h){let b=this.b.get(a);b||this.b.set(a,b=new I.$Bc(v=>this.m.extUri.getComparisonKey(v))),b.add(h)}J(a,h){const b=this.b.get(a);b&&b.delete(h),b?.size||this.b.delete(a)}L(a,h){return`${N.$Tm.toKey(a.id)}@${h}`}M(a){const[h,b]=(0,L.$Ap)(a);return b?{identifier:{id:h},version:b}:void 0}}e.$Hq=P}),define(se[149],re([0,1,120,41]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_p=I;async function I(L,N,P,l,a,h,b){const v={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${N.nameShort})`};if((0,O.$qp)(N,P)&&(0,O.$sp)(l)===3){const y=await(0,A.$$p)(P,a,h);v["X-Market-User-Id"]=y,v["VSCode-SessionId"]=b.machineId||y}return v}}),define(se[150],re([0,1,176,19,8,2,15,16,25,18,20,26,6,66,11]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Yr=void 0;let R=class extends y.$Xr{constructor(p,m,f,n){super(f),this.h=p,this.j=n,this.g=this.B(new g(m,n)),this.h.registerParticipant({postInstall:async r=>this.m(r),postUninstall:async r=>this.n(r)})}async getBuiltInExtensionTranslationsUri(p,m){const n=(await this.g.getLanguagePacks())[m];if(!n){this.j.warn(`No language pack found for ${m}`);return}const r=n.translations[p];return r?$.URI.file(r):void 0}async getInstalledLanguages(){const p=await this.g.getLanguagePacks(),m=Object.keys(p).map(f=>{const n=p[f];return{...this.f(f,n.label),extensionId:n.extensions[0].extensionIdentifier.id}});return m.push(this.f("en","English")),m.sort((f,n)=>f.label.localeCompare(n.label)),m}async m(p){p&&p.manifest&&p.manifest.contributes&&p.manifest.contributes.localizations&&p.manifest.contributes.localizations.length&&(this.j.info("Adding language packs from the extension",p.identifier.id),await this.update())}async n(p){const m=await this.g.getLanguagePacks();Object.keys(m).some(f=>m[f]&&m[f].extensions.some(n=>(0,b.$yp)(n.extensionIdentifier,p.identifier)))&&(this.j.info("Removing language packs from the extension",p.identifier.id),await this.update())}async update(){const[p,m]=await Promise.all([this.g.getLanguagePacks(),this.h.getInstalled()]),f=await this.g.update(m);return!(0,O.$ub)(Object.keys(p),Object.keys(f))}};e.$Yr=R,e.$Yr=R=$e([oe(0,h.$ap),oe(1,a.$Gi),oe(2,h.$0o),oe(3,v.$5j)],R);let g=class extends L.$Uc{constructor(p,m){super(),this.j=m,this.c={},this.f=(0,P.$jc)(p.userDataPath,"languagepacks.json"),this.g=new I.$Fh}getLanguagePacks(){return this.g.size||!this.h?this.s().then(()=>this.c):Promise.resolve(this.c)}update(p){return this.s(m=>{Object.keys(m).forEach(f=>delete m[f]),this.m(m,...p)}).then(()=>this.c)}m(p,...m){for(const f of m)f&&f.manifest&&f.manifest.contributes&&f.manifest.contributes.localizations&&f.manifest.contributes.localizations.length&&this.n(p,f);Object.keys(p).forEach(f=>this.r(p[f]))}n(p,m){const f=m.identifier,n=m.manifest.contributes&&m.manifest.contributes.localizations?m.manifest.contributes.localizations:[];for(const r of n)if(m.location.scheme===N.Schemas.file&&c(r)){let i=p[r.languageId];i||(i={hash:"",extensions:[],translations:{},label:r.localizedLanguageName??r.languageName},p[r.languageId]=i);const t=i.extensions.filter(s=>(0,b.$yp)(s.extensionIdentifier,f))[0];t?t.version=m.manifest.version:i.extensions.push({extensionIdentifier:f,version:m.manifest.version});for(const s of r.translations)i.translations[s.id]=(0,P.$jc)(m.location.fsPath,s.path)}}r(p){if(p){const m=(0,A.createHash)("md5");for(const f of p.extensions)m.update(f.extensionIdentifier.uuid||f.extensionIdentifier.id).update(f.version);p.hash=m.digest("hex")}}s(p=()=>null){return this.g.queue(()=>{let m=null;return l.Promises.readFile(this.f,"utf8").then(void 0,f=>f.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(f)).then(f=>{try{return JSON.parse(f)}catch{return{}}}).then(f=>(m=p(f),f)).then(f=>{for(const r of Object.keys(f))f[r]||delete f[r];this.c=f,this.h=!0;const n=JSON.stringify(this.c);return this.j.debug("Writing language packs",n),l.Promises.writeFile(this.f,n)}).then(()=>m,f=>this.j.error(f))})}};g=$e([oe(0,a.$Gi),oe(1,v.$5j)],g);function c(w){if(typeof w.languageId!="string"||!Array.isArray(w.translations)||w.translations.length===0)return!1;for(const p of w.translations)if(typeof p.id!="string"||typeof p.path!="string")return!1;return!(w.languageName&&typeof w.languageName!="string"||w.localizedLanguageName&&typeof w.localizedLanguageName!="string")}}),define(se[151],re([0,1,87,9,27,41]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3P=void 0;const N="https://mobile.events.data.microsoft.com/OneCollector/1.0",P="https://mobile.events.data.microsoft.com/ping";async function l(h,b,v){const y=await(0,A.$aE)("@microsoft/1ds-core-js","dist/ms.core.js"),$=await(0,A.$aE)("@microsoft/1ds-post-js","dist/ms.post.js"),R=new y.AppInsightsCore,g=new $.PostChannel,c={instrumentationKey:h,endpointUrl:N,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[g]]};if(v){c.extensionConfig={};const w={alwaysUseXhrOverride:!0,ignoreMc1Ms0CookieProcessing:!0,httpXHROverride:v};c.extensionConfig[g.identifier]=w}return R.initialize(c,[]),R.addTelemetryInitializer(w=>{w.ext=w.ext??{},w.ext.web=w.ext.web??{},w.ext.web.consentDetails='{"GPC_DataSharingOptIn":false}',b&&(w.ext.utc=w.ext.utc??{},w.ext.utc.flags=8462029)}),R}class a{constructor(b,v,y,$,R){this.e=b,this.f=v,this.g=y,this.h=R,this.c=N,this.d=P,this.g||(this.g={}),typeof $=="function"?this.a=$():this.a=$,this.b=null}i(b){if(this.a){if(typeof this.a!="string"){b(this.a);return}this.b||(this.b=l(this.a,this.e,this.h)),this.b.then(v=>{b(v)},v=>{(0,O.$1)(v),console.error(v)})}}log(b,v){if(!this.a)return;v=(0,I.$8n)(v,this.g),v=(0,L.$tp)(v);const y=this.f+"/"+b;try{this.i($=>{$.pluginVersionString=v?.properties.version??"Unknown",$.track({name:y,baseData:{name:y,properties:v?.properties,measurements:v?.measurements}})})}catch{}}flush(){return this.a?new Promise(b=>{this.i(v=>{v.unload(!0,()=>{this.a=void 0,b(void 0)})})}):Promise.resolve(void 0)}}e.$3P=a}),define(se[152],re([0,1,2,27,12,31,112,29,40,153,32,36,21,41]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5r=void 0;let $=class{static{this.IDLE_START_EVENT_NAME="UserIdleStart"}static{this.IDLE_STOP_EVENT_NAME="UserIdleStop"}constructor(c,w,p){this.k=w,this.l=p,this.d={},this.i=new A.$Tc,this.j=[],this.b=c.appenders,this.c=c.commonProperties??Object.create(null),this.sessionId=this.c.sessionID,this.machineId=this.c["common.machineId"],this.sqmId=this.c["common.sqmId"],this.firstSessionDate=this.c["common.firstSessionDate"],this.msftInternal=this.c["common.msftInternal"],this.f=c.piiPaths||[],this.g=3,this.h=!!c.sendErrorTelemetry,this.j=[/(vscode-)?file:\/\/\/.*?\/resources\/app\//gi];for(const m of this.f)this.j.push(new RegExp((0,L.$bf)(m),"gi")),m.indexOf("\\")>=0&&this.j.push(new RegExp((0,L.$bf)(m.replace(/\\/g,"/")),"gi"));this.m(),this.i.add(this.k.onDidChangeConfiguration(m=>{(m.affectsConfiguration(v.$_l)||m.affectsConfiguration(v.$bm)||m.affectsConfiguration(v.$am))&&this.m()}))}setExperimentProperty(c,w){this.d[c]=w}m(){let c=(0,y.$sp)(this.k);const w=this.l.enabledTelemetryLevels;if(w){this.h=this.sendErrorTelemetry?w.error:!1;const p=w.usage?3:w.error?2:0;c=Math.min(c,p)}this.g=c}get sendErrorTelemetry(){return this.h}get telemetryLevel(){return this.g}dispose(){this.i.dispose()}n(c,w,p){this.g<w||(p=(0,O.$8n)(p,this.d),p=(0,y.$xp)(p,this.j),p=(0,O.$8n)(p,this.c),this.b.forEach(m=>m.log(c,p)))}publicLog(c,w){this.n(c,3,w)}publicLog2(c,w){this.publicLog(c,w)}publicLogError(c,w){this.h&&this.n(c,2,w)}publicLogError2(c,w){this.publicLogError(c,w)}};e.$5r=$,e.$5r=$=$e([oe(1,P.$5i),oe(2,h.$lk)],$);function R(){const g=(0,N.localize)(0,null,a.default.nameLong),c=a.default.privacyStatementUrl?(0,N.localize)(2,null,"https://aka.ms/vscode-telemetry",a.default.privacyStatementUrl):(0,N.localize)(1,null,"https://aka.ms/vscode-telemetry"),w=I.$o?"":(0,N.localize)(3,null),p=(0,N.localize)(4,null),m=(0,N.localize)(5,null),f=(0,N.localize)(6,null),n=(0,N.localize)(7,null),r=`
|       | ${p} | ${m} | ${f} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,N.localize)(8,null);return`
${g} ${c} ${w}

&nbsp;

${n}
${r}

&nbsp;

${i}
`}b.$fo.as(l.$ko.Configuration).registerConfiguration({id:v.$$l,order:1,type:"object",title:(0,N.localize)(9,null),properties:{[v.$_l]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,N.localize)(10,null),(0,N.localize)(11,null),(0,N.localize)(12,null),(0,N.localize)(13,null)],markdownDescription:R(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),b.$fo.as(l.$ko.Configuration).registerConfiguration({id:v.$$l,order:110,type:"object",title:(0,N.localize)(14,null),properties:{[v.$bm]:{type:"boolean",markdownDescription:a.default.privacyStatementUrl?(0,N.localize)(16,null,a.default.nameLong,a.default.privacyStatementUrl):(0,N.localize)(15,null,a.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,N.localize)(17,null,`\`#${v.$_l}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(se[154],re([0,1,14,22,177,151]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4P=void 0;async function N(h,b){const v=await b.request(h,O.CancellationToken.None),y=(await(0,A.$Te)(v.stream)).toString(),$=v.res.statusCode??200;return{headers:v.res.headers,statusCode:$,responseData:y}}async function P(h){const b={method:h.type,headers:h.headers};return new Promise((y,$)=>{const R=I.request(h.url??"",b,g=>{g.on("data",function(c){y({headers:g.headers,statusCode:g.statusCode??200,responseData:c.toString()})}),g.on("error",function(c){$(c)})});R.write(h.data,g=>{g&&$(g)}),R.end()})}async function l(h,b,v){const y=typeof b.data=="string"?b.data:new TextDecoder().decode(b.data),$={type:"POST",headers:{...b.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(b.data).toString()},url:b.urlString,data:y};try{const R=h?await N($,h):await P($);v(R.statusCode,R.headers,R.responseData)}catch{v(0,{})}}class a extends L.$3P{constructor(b,v,y,$,R){const g={sendPOST:(c,w)=>{l(b,c,w)}};super(v,y,$,R,g)}}e.$4P=a}),define(se[155],re([0,1,16,25]),function(X,e,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4ec=I;async function I(L,N){const P=Object.create(null),l=(h,b)=>{const v=JSON.parse(h);P[b]=v};if(N){const h=[],b=await O.Promises.readdir(N);for(const y of b)try{(await O.Promises.stat((0,A.$jc)(N,y))).isDirectory()&&h.push(y)}catch{}const v=[];for(const y of h)(await O.Promises.readdir((0,A.$jc)(N,y))).filter(R=>R==="telemetry.json").length===1&&v.push(y);for(const y of v){const $=(await O.Promises.readFile((0,A.$jc)(N,y,"telemetry.json"))).toString();l($,y)}}let a=(await O.Promises.readFile((0,A.$jc)(L,"telemetry-core.json"))).toString();return l(a,"vscode-core"),a=(await O.Promises.readFile((0,A.$jc)(L,"telemetry-extensions.json"))).toString(),l(a,"vscode-extensions"),JSON.stringify(P,null,4)}}),define(se[156],re([0,1,12,88,21]),function(X,e,A,O,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hec=L,e.$iec=N;async function L(P,l){let a=P.getItem(I.$9l);return(typeof a!="string"||A.$j&&a==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(a=await(0,O.$Hn)(l.error.bind(l))),a}async function N(P,l){let a=P.getItem(I.$0l);return typeof a!="string"&&(a=await(0,O.$In)(l.error.bind(l))),a}}),define(se[23],re([0,1,10]),function(X,e,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,A.$yi)("IUriIdentityService")}),define(se[157],re([0,1,23,121,13,17,79,5,2]),function(X,e,A,O,I,L,N,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fs=void 0;class a{static{this._clock=0}constructor(v){this.uri=v,this.time=a._clock++}touch(){return this.time=a._clock++,this}}let h=class{constructor(v){this.g=v,this.c=new l.$Tc,this.f=2**16;const y=new Map,$=R=>{let g=y.get(R.scheme);return g===void 0&&(g=v.hasProvider(R)&&!this.g.hasCapability(R,1024),y.set(R.scheme,g)),g};this.c.add(P.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(R=>{y.delete(R.scheme)})),this.extUri=new L.$1g($),this.d=new N.$Es((R,g)=>this.extUri.compare(R,g,!0),this.f)}dispose(){this.c.dispose(),this.d.clear()}asCanonicalUri(v){this.g.hasProvider(v)&&(v=(0,L.$ah)(v));const y=this.d.get(v);return y?y.touch().uri.with({fragment:v.fragment}):(this.d.set(v,new a(v)),this.h(),v)}h(){if(this.d.size<this.f)return;const v=[...this.d.entries()].sort(($,R)=>$[1].time<R[1].time?1:$[1].time>R[1].time?-1:0);a._clock=0,this.d.clear();const y=this.f*.5;for(let $=0;$<y;$++)this.d.set(v[$][0],v[$][1].touch())}};e.$Fs=h,e.$Fs=h=$e([oe(0,I.$5k)],h),(0,O.$Cs)(A.$Cl,h,1)}),define(se[158],re([0,1,5,2,13,48,30]),function(X,e,A,O,I,L,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fec=void 0;class P extends O.$Uc{constructor(a,h,b,v,y,$){super(),this.f=a,this.g=h,this.h=b,this.j=v,this.m=y,this.n=$,this.capabilities=this.g.capabilities,this.onDidChangeCapabilities=this.g.onDidChangeCapabilities,this.a=this.B(new A.$fe),this.onDidChangeFile=this.a.event,this.b=L.$Ei.forUris(()=>!(this.capabilities&1024)),this.c=new N.$Bc(R=>this.m.extUri.getComparisonKey(this.t(R))),this.r(),this.B(v.onDidChangeProfiles(()=>this.r())),this.B(this.g.onDidChangeFile(R=>this.s(R)))}r(){this.c.clear();for(const a of this.j.profiles)this.c.add(a.settingsResource),this.c.add(a.keybindingsResource),this.c.add(a.tasksResource),this.c.add(a.extensionsResource)}open(a,h){return this.g.open(this.t(a),h)}close(a){return this.g.close(a)}read(a,h,b,v,y){return this.g.read(a,h,b,v,y)}write(a,h,b,v,y){return this.g.write(a,h,b,v,y)}watch(a,h){this.b.set(a,a);const b=this.g.watch(this.t(a),h);return(0,O.$Sc)(()=>{this.b.delete(a),b.dispose()})}stat(a){return this.g.stat(this.t(a))}mkdir(a){return this.g.mkdir(this.t(a))}rename(a,h,b){return this.g.rename(this.t(a),this.t(h),b)}readFile(a,h){return this.g.readFile(this.t(a),h)}readFileStream(a,h,b){return this.g.readFileStream(this.t(a),h,b)}readdir(a){return this.g.readdir(this.t(a))}enforceAtomicReadFile(a){return this.c.has(a)}writeFile(a,h,b){return this.g.writeFile(this.t(a),h,b)}enforceAtomicWriteFile(a){return this.c.has(a)?{postfix:".vsctmp"}:!1}delete(a,h){return this.g.delete(this.t(a),h)}copy(a,h,b){if((0,I.$9k)(this.g))return this.g.copy(this.t(a),this.t(h),b);throw new Error("copy not supported")}cloneFile(a,h){if((0,I.$0k)(this.g))return this.g.cloneFile(this.t(a),this.t(h));throw new Error("clone not supported")}s(a){const h=[];for(const b of a){if(b.resource.scheme!==this.f)continue;const v=this.u(b.resource);this.b.findSubstr(v)&&h.push({resource:v,type:b.type,cId:b.cId})}h.length&&(this.n.debug("User data changed"),this.a.fire(h))}t(a){return a.with({scheme:this.f})}u(a){return a.with({scheme:this.h})}}e.$Fec=P}),define(se[159],re([0,1,114,16,48,17,11,10,15]),function(X,e,A,O,I,L,N,P,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=a,e.$Ji=h,e.$Mi=b,e.$Ni=v,e.$Oi=y,e.$Pi=R,e.$Qi=g,e.$Ti=p,e.$Yi=m,e.$Zi=f,e.$2i=n,e.$3i=r,e.$4i=i,e.$Hi=(0,P.$yi)("contextService");function a(t){const s=t;return typeof s?.id=="string"&&N.URI.isUri(s.uri)}function h(t){return typeof t?.id=="string"&&!a(t)&&!v(t)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function b(t,s){if(typeof t=="string"||typeof t>"u")return typeof t=="string"?{id:(0,O.$nc)(t)}:s?e.$Ki:e.$Li;const o=t;return o.configuration?{id:o.id,configPath:o.configuration}:o.folders.length===1?{id:o.id,uri:o.folders[0].uri}:{id:o.id}}function v(t){const s=t;return typeof s?.id=="string"&&N.URI.isUri(s.configPath)}function y(t){const s=t;if(s?.uri)return{id:s.id,uri:N.URI.revive(s.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:N.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}var $;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})($||(e.WorkbenchState=$={}));function R(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&Array.isArray(s.folders))}function g(t){const s=t;return!!(s&&typeof s=="object"&&N.URI.isUri(s.uri)&&typeof s.name=="string"&&typeof s.toResource=="function")}class c{constructor(s,o,u,S,j){this.h=s,this.j=u,this.k=S,this.l=j,this.c=I.$Ei.forUris(this.l,()=>!0),this.folders=o}update(s){this.h=s.id,this.k=s.configuration,this.j=s.transient,this.l=s.l,this.folders=s.folders}get folders(){return this.g}set folders(s){this.g=s,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(s){this.k=s}getFolder(s){return s&&this.c.findSubstr(s)||null}n(){this.c=I.$Ei.forUris(this.l,()=>!0);for(const s of this.folders)this.c.set(s.uri,s)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=c;class w{constructor(s,o){this.raw=o,this.uri=s.uri,this.index=s.index,this.name=s.name}toResource(s){return(0,L.$_g)(this.uri,s)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=w;function p(t){return new w({uri:t,index:0,name:(0,L.$8g)(t)},{uri:t.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,A.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function m(t,s){return L.$3g.isEqualOrParent(t,s.untitledWorkspacesHome)}function f(t){let s;return N.URI.isUri(t)?s=t:s=t.configuration,s?.scheme===l.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function n(t){return t.id===e.$1i}function r(t,s){return!m(t,s)&&!f(t)}function i(t){return(typeof t=="string"?(0,O.$oc)(t):(0,L.$0g)(t))===e.$Vi}}),define(se[24],re([0,1,43,5,2,17,11,113,18,13,10,6,159,30,23,8,28,31,3]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=m,e.$Fl=f,e.$Gl=n;var p;(function(t){t.Settings="settings",t.Keybindings="keybindings",t.Snippets="snippets",t.Tasks="tasks",t.Extensions="extensions",t.GlobalState="globalState"})(p||(e.ProfileResourceType=p={}));function m(t){const s=t;return!!(s&&typeof s=="object"&&typeof s.id=="string"&&typeof s.isDefault=="boolean"&&typeof s.name=="string"&&N.URI.isUri(s.location)&&N.URI.isUri(s.globalStorageHome)&&N.URI.isUri(s.settingsResource)&&N.URI.isUri(s.keybindingsResource)&&N.URI.isUri(s.tasksResource)&&N.URI.isUri(s.snippetsHome)&&N.URI.isUri(s.extensionsResource))}e.$El=(0,h.$yi)("IUserDataProfilesService");function f(t,s){return{id:t.id,isDefault:t.isDefault,name:t.name,shortName:t.shortName,icon:t.icon,location:N.URI.revive(t.location).with({scheme:s}),globalStorageHome:N.URI.revive(t.globalStorageHome).with({scheme:s}),settingsResource:N.URI.revive(t.settingsResource).with({scheme:s}),keybindingsResource:N.URI.revive(t.keybindingsResource).with({scheme:s}),tasksResource:N.URI.revive(t.tasksResource).with({scheme:s}),snippetsHome:N.URI.revive(t.snippetsHome).with({scheme:s}),extensionsResource:N.URI.revive(t.extensionsResource).with({scheme:s}),cacheHome:N.URI.revive(t.cacheHome).with({scheme:s}),useDefaultFlags:t.useDefaultFlags,isTransient:t.isTransient}}function n(t,s,o,u,S,j){return{id:t,name:s,location:o,isDefault:!1,shortName:S?.shortName,icon:S?.icon,globalStorageHome:j&&S?.useDefaultFlags?.globalState?j.globalStorageHome:(0,L.$_g)(o,"globalStorage"),settingsResource:j&&S?.useDefaultFlags?.settings?j.settingsResource:(0,L.$_g)(o,"settings.json"),keybindingsResource:j&&S?.useDefaultFlags?.keybindings?j.keybindingsResource:(0,L.$_g)(o,"keybindings.json"),tasksResource:j&&S?.useDefaultFlags?.tasks?j.tasksResource:(0,L.$_g)(o,"tasks.json"),snippetsHome:j&&S?.useDefaultFlags?.snippets?j.snippetsHome:(0,L.$_g)(o,"snippets"),extensionsResource:j&&S?.useDefaultFlags?.extensions?j.extensionsResource:(0,L.$_g)(o,"extensions.json"),cacheHome:(0,L.$_g)(u,t),useDefaultFlags:S?.useDefaultFlags,isTransient:S?.transient}}let r=class extends I.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(s,o,u,S){super(),this.t=s,this.u=o,this.w=u,this.y=S,this.f=!0,this.h=this.B(new O.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new O.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new O.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new O.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new y.$Ac,emptyWindows:new Map},this.profilesHome=(0,L.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,L.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(s){this.f!==s&&(this.z=void 0,this.f=s)}isEnabled(){return this.f}get C(){if(!this.z){const s=this.D(),o=[s];if(this.f)try{for(const j of this.O()){if(!j.name||!(0,w.$$f)(j.name)||!j.location){this.y.warn("Skipping the invalid stored profile",j.location||j.name);continue}o.push(n((0,L.$9g)(j.location),j.name,j.location,this.g,{shortName:j.shortName,icon:j.icon,useDefaultFlags:j.useDefaultFlags},s))}}catch(j){this.y.error(j)}const u=new y.$Ac,S=new Map;if(o.length)try{const j=this.Q();if(j.workspaces)for(const[k,D]of Object.entries(j.workspaces)){const F=N.URI.parse(k),C=o.find(J=>J.id===D);C&&u.set(F,C)}if(j.emptyWindows)for(const[k,D]of Object.entries(j.emptyWindows)){const F=o.find(C=>C.id===D);F&&S.set(k,F)}}catch(j){this.y.error(j)}this.z={profiles:o,workspaces:u,emptyWindows:S}}return this.z}D(){const s=n("__default__profile__",(0,P.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...s,extensionsResource:this.S()??s.extensionsResource,isDefault:!0}}async createTransientProfile(s){const o="Temp",u=new RegExp(`${(0,c.$bf)(o)}\\s(\\d+)`);let S=0;for(const k of this.profiles){const D=u.exec(k.name),F=D?parseInt(D[1]):0;S=F>S?F:S}const j=`${o} ${S+1}`;return this.createProfile((0,A.$mj)((0,g.$Ug)()).toString(16),j,{transient:!0},s)}async createNamedProfile(s,o,u){return this.createProfile((0,A.$mj)((0,g.$Ug)()).toString(16),s,o,u)}async createProfile(s,o,u,S){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const j=await this.F(s,o,u);return S&&await this.setProfileForWorkspace(S,j),j}async F(s,o,u){if(!(0,w.$$f)(o)||!o)throw new Error("Name of the profile is mandatory and must be of type `string`");let S=this.r.get(o);return S||(S=(async()=>{try{if(this.profiles.find(F=>F.name===o||F.id===s))throw new Error(`Profile with ${o} name already exists`);const k=n(s,o,(0,L.$_g)(this.profilesHome,s),this.g,u,this.defaultProfile);await this.u.createFolder(k.location);const D=[];return this.j.fire({profile:k,join(F){D.push(F)}}),await R.Promises.settled(D),this.I([k],[],[]),k}finally{this.r.delete(o)}})(),this.r.set(o,S)),S}async updateProfile(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let u=this.profiles.find(S=>S.id===s.id);if(!u)throw new Error(`Profile '${s.name}' does not exist`);return u=n(u.id,o.name??u.name,u.location,this.g,{shortName:o.shortName??u.shortName,icon:o.icon===null?void 0:o.icon??u.icon,transient:o.transient??u.isTransient,useDefaultFlags:o.useDefaultFlags??u.useDefaultFlags},this.defaultProfile),this.I([],[],[u]),u}async removeProfile(s){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(s.isDefault)throw new Error("Cannot remove default profile");const o=this.profiles.find(S=>S.id===s.id);if(!o)throw new Error(`Profile '${s.name}' does not exist`);const u=[];this.m.fire({profile:o,join(S){u.push(S)}});try{await Promise.allSettled(u)}catch(S){this.y.error(S)}for(const S of[...this.C.emptyWindows.keys()])o.id===this.C.emptyWindows.get(S)?.id&&this.C.emptyWindows.delete(S);for(const S of[...this.C.workspaces.keys()])o.id===this.C.workspaces.get(S)?.id&&this.C.workspaces.delete(S);this.M(),this.I([],[o],[]);try{await this.u.del(o.cacheHome,{recursive:!0})}catch(S){(0,a.$jl)(S)!==1&&this.y.error(S)}}async setProfileForWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const u=this.profiles.find(S=>S.id===o.id);if(!u)throw new Error(`Profile '${o.name}' does not exist`);this.L(s,u)}unsetWorkspace(s,o){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(s,void 0,o)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const s=await this.u.resolve(this.profilesHome);await Promise.all((s.children||[]).filter(o=>o.isDirectory&&this.profiles.every(u=>!this.w.extUri.isEqual(u.location,o.resource))).map(o=>this.u.del(o.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const s=this.s.profiles.filter(o=>!this.H(o));await Promise.allSettled(s.map(o=>this.removeProfile(o)))}getProfileForWorkspace(s){const o=this.G(s);return N.URI.isUri(o)?this.s.workspaces.get(o)??this.C.workspaces.get(o):this.s.emptyWindows.get(o)??this.C.emptyWindows.get(o)}G(s){return(0,v.$Ii)(s)?s.uri:(0,v.$Ni)(s)?s.configPath:s.id}H(s){return!!([...this.s.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.s.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.emptyWindows.values()].some(o=>this.w.extUri.isEqual(o.location,s.location))||[...this.C.workspaces.values()].some(o=>this.w.extUri.isEqual(o.location,s.location)))}I(s,o,u){const S=[...this.profiles,...s],j=[];this.s.profiles=[];for(let k of S)k.isDefault||o.some(D=>k.id===D.id)||(k=u.find(D=>k.id===D.id)??k,k.isTransient?this.s.profiles.push(k):j.push({location:k.location,name:k.name,shortName:k.shortName,icon:k.icon,useDefaultFlags:k.useDefaultFlags}));this.P(j),this.z=void 0,this.J(s,o,u)}J(s,o,u){this.h.fire({added:s,removed:o,updated:u,all:this.profiles})}L(s,o,u){u=o?.isTransient?!0:u,u||this.L(s,void 0,!0);const S=this.G(s),j=u?this.s:this.C;N.URI.isUri(S)?(j.workspaces.delete(S),o&&j.workspaces.set(S,o)):(j.emptyWindows.delete(S),o&&j.emptyWindows.set(S,o)),u||this.M()}M(){const s={};for(const[u,S]of this.C.workspaces.entries())s[u.toString()]=S.id;const o={};for(const[u,S]of this.C.emptyWindows.entries())o[u.toString()]=S.id;this.R({workspaces:s,emptyWindows:o}),this.z=void 0}N(s){const o={},u=this.D();if(s.workspaces)for(const[j,k]of Object.entries(s.workspaces)){const D=N.URI.parse(k);o[j]=this.w.extUri.isEqual(D,u.location)?u.id:this.w.extUri.basename(D)}const S={};if(s.emptyWindows)for(const[j,k]of Object.entries(s.emptyWindows)){const D=N.URI.parse(k);S[j]=this.w.extUri.isEqual(D,u.location)?u.id:this.w.extUri.basename(D)}return{workspaces:o,emptyWindows:S}}O(){return[]}P(s){throw new Error("not implemented")}Q(){return{}}R(s){throw new Error("not implemented")}S(){}};e.$Hl=r,e.$Hl=r=$e([oe(0,l.$Fi),oe(1,a.$5k),oe(2,$.$Cl),oe(3,b.$5j)],r);class i extends r{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(s){this.a=s}Q(){return this.X}R(s){this.X=s}}e.$Il=i}),define(se[53],re([0,1,19,8,22,9,5,2,12,3,11,97,20,26,37,6,32,21,23,24]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rq=e.$pq=void 0,e.$qq=f;let m=class extends P.$Uc{get onInstallExtension(){return this.n.event}get onDidInstallExtensions(){return this.s.event}get onUninstallExtension(){return this.t.event}get onDidUninstallExtension(){return this.u.event}get onDidUpdateExtensionMetadata(){return this.w.event}constructor(t,s,o,u,S,j){super(),this.z=t,this.C=s,this.D=o,this.F=u,this.G=S,this.H=j,this.h=0,this.j=new Map,this.m=new Map,this.n=this.B(new N.$fe),this.s=this.B(new N.$fe),this.t=this.B(new N.$fe),this.u=this.B(new N.$fe),this.w=this.B(new N.$fe),this.y=[],this.B((0,P.$Sc)(()=>{this.j.forEach(({task:k})=>k.cancel()),this.m.forEach(k=>k.cancel()),this.j.clear(),this.m.clear()}))}async canInstall(t){const s=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,v.$8o)(o,t.allTargetPlatforms,s))}async installFromGallery(t,s={}){try{const u=(await this.installGalleryExtensions([{extension:t,options:s}])).find(({identifier:S})=>(0,y.$yp)(S,t.identifier));if(u?.local)return u?.local;throw u?.error?u.error:new v.$_o(`Unknown error while installing extension ${t.identifier.id}`,"Unknown")}catch(o){throw f(o)}}async installGalleryExtensions(t){if(!this.z.isEnabled())throw new v.$_o(b.localize(0,null),"NotAllowed");const s=[],o=[];return await Promise.allSettled(t.map(async({extension:u,options:S})=>{try{const j=await this.N(u,!!S?.installGivenVersion,!!S?.installPreReleaseVersion,S.productVersion??{version:this.G.version,date:this.G.date});o.push({...j,options:S})}catch(j){s.push({identifier:u.identifier,operation:2,source:u,error:j})}})),o.length&&s.push(...await this.I(o)),s}async uninstall(t,s={}){return this.F.trace("ExtensionManagementService#uninstall",t.identifier.id),this.P(t,s)}async toggleAppliationScope(t,s){if((0,$.$Wm)(t.manifest)||t.isBuiltin)return t;if(t.isApplicationScoped){let o=await this.updateMetadata(t,{isApplicationScoped:!1},this.H.defaultProfile.extensionsResource);this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)||(o=await this.$(t,this.H.defaultProfile.extensionsResource,s));for(const u of this.H.profiles){const S=(await this.getInstalled(1,u.extensionsResource)).find(j=>(0,y.$yp)(j.identifier,t.identifier));S?this.w.fire(S):this.u.fire({identifier:t.identifier,profileLocation:u.extensionsResource})}return o}else{const o=this.D.extUri.isEqual(s,this.H.defaultProfile.extensionsResource)?await this.updateMetadata(t,{isApplicationScoped:!0},this.H.defaultProfile.extensionsResource):await this.$(t,s,this.H.defaultProfile.extensionsResource,{isApplicationScoped:!0});return this.s.fire([{identifier:o.identifier,operation:2,local:o,profileLocation:this.H.defaultProfile.extensionsResource,applicationScoped:!0}]),o}}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.g||t-this.h>1e3*60*5)&&(this.g=this.W(),this.h=t),this.g}registerParticipant(t){this.y.push(t)}async I(t){const s=new Map,o=new Map,u=[],S=(k,D)=>`${y.$zp.create(k).toString()}-${D.toString()}`,j=(k,D,F,C)=>{const J=this.Y(k,D,F),ne=`${(0,y.$Dp)(k.publisher,k.name)}-${F.profileLocation.toString()}`;o.set(ne,{task:J,root:C}),this.n.fire({identifier:J.identifier,source:D,profileLocation:F.profileLocation}),this.F.info("Installing extension:",J.identifier.id),h.URI.isUri(D)||this.j.set(S(D,F.profileLocation),{task:J,waitingTasks:[]})};try{for(const{manifest:k,extension:D,options:F}of t){const C=F.isApplicationScoped||F.isBuiltin||(0,$.$Wm)(k),J={...F,installOnlyNewlyAddedFromExtensionPack:F.installOnlyNewlyAddedFromExtensionPack??!h.URI.isUri(D),isApplicationScoped:C,profileLocation:C?this.H.defaultProfile.extensionsResource:F.profileLocation??this.X(),productVersion:F.productVersion??{version:this.G.version,date:this.G.date}},ne=h.URI.isUri(D)?void 0:this.j.get(S(D,J.profileLocation));ne?(this.F.info("Extension is already requested to install",ne.task.identifier.id),u.push(ne.task.waitUntilTaskIsFinished())):j(k,D,J,void 0)}return await Promise.all([...o.values()].map(async({task:k})=>{if(k.options.donotIncludePackAndDependencies)this.F.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const D=await this.M(k.identifier,k.manifest,!!k.options.installOnlyNewlyAddedFromExtensionPack,!!k.options.installPreReleaseVersion,k.options.profileLocation,k.options.productVersion),F=await this.getInstalled(void 0,k.options.profileLocation,k.options.productVersion),C={...k.options,context:{...k.options.context,[v.$2o]:!0}};for(const{gallery:J,manifest:ne}of(0,A.$Mb)(D,({gallery:ie})=>ie.identifier.id)){if(o.has(`${J.identifier.id.toLowerCase()}-${C.profileLocation.toString()}`))continue;const ie=this.j.get(S(J,C.profileLocation));if(ie){if(this.J(k,ie.task)){const ue=ie.task.identifier;this.F.info("Waiting for already requested installing extension",ue.id,k.identifier.id),ie.waitingTasks.push(k),u.push(N.Event.toPromise(N.Event.filter(this.onDidInstallExtensions,le=>le.some(ce=>(0,y.$yp)(ce.identifier,ue)))).then(le=>{if(this.F.info("Finished waiting for already requested installing extension",ue.id,k.identifier.id),!le.find(V=>(0,y.$yp)(V.identifier,ue))?.local)throw new Error(`Extension ${ue.id} is not installed`)}))}}else F.some(({identifier:ue})=>(0,y.$yp)(ue,J.identifier))||j(ne,J,C,k)}}catch(D){if(h.URI.isUri(k.source))(0,A.$Lb)(k.manifest.extensionDependencies)&&this.F.warn("Cannot install dependencies of extension:",k.identifier.id,D.message),(0,A.$Lb)(k.manifest.extensionPack)&&this.F.warn("Cannot install packed extensions of extension:",k.identifier.id,D.message);else throw this.F.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),D}})),await this.L([...o.entries()].map(async([k,{task:D}])=>{const F=new Date().getTime();let C;try{C=await D.run(),await this.L(this.y.map(J=>J.postInstall(C,D.source,D.options,I.CancellationToken.None)),"PostInstall")}catch(J){const ne=f(J);throw h.URI.isUri(D.source)||n(this.C,D.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.$Gp)(D.source),error:ne,source:D.options.context?.[v.$1o]}),s.set(k,{error:ne,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.profileLocation,applicationScoped:D.options.isApplicationScoped}),this.F.error("Error while installing the extension",D.identifier.id,(0,L.$0)(ne)),ne}if(!h.URI.isUri(D.source)){const J=D.operation===3,ne=J?void 0:(new Date().getTime()-D.source.lastUpdated)/1e3;if(n(this.C,J?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,y.$Gp)(D.source),verificationStatus:D.verificationStatus,duration:new Date().getTime()-F,durationSinceUpdate:ne,source:D.options.context?.[v.$1o]}),l.$o&&D.operation!==3)try{await this.z.reportStatistic(C.manifest.publisher,C.manifest.name,C.manifest.version,"install")}catch{}}s.set(k,{local:C,identifier:D.identifier,operation:D.operation,source:D.source,context:D.options.context,profileLocation:D.profileLocation,applicationScoped:C.isApplicationScoped})})),u.length&&await this.L(u),[...s.values()]}catch(k){const D=(J,ne,ie)=>{const ue=[];J.manifest.extensionDependencies?.length&&ue.push(...J.manifest.extensionDependencies),J.manifest.extensionPack?.length&&ue.push(...J.manifest.extensionPack);for(const le of ue){if(ie.includes(le.toLowerCase()))continue;ie.push(le.toLowerCase());const ce=s.get(`${le.toLowerCase()}-${ne.toString()}`);ce?.local&&(ie=D(ce.local,ne,ie))}return ie},F=J=>({identifier:J.identifier,operation:2,source:J.source,context:J.options.context,profileLocation:J.profileLocation,error:k}),C=[];for(const[J,{task:ne,root:ie}]of o){const ue=s.get(J);ue?ue.local&&ie&&!s.get(`${ie.identifier.id.toLowerCase()}-${ne.profileLocation.toString()}`)?.local&&(C.push(this.Z(ue.local,{versionOnly:!0,profileLocation:ne.profileLocation})),s.set(J,F(ne))):(ne.cancel(),s.set(J,F(ne)))}for(const[J,{task:ne}]of o){const ie=s.get(J);if(!ie?.local||ne.options.donotIncludePackAndDependencies)continue;D(ie.local,ne.profileLocation,[ie.local.identifier.id.toLowerCase()]).slice(1).some(le=>o.has(`${le.toLowerCase()}-${ne.profileLocation.toString()}`)&&!s.get(`${le.toLowerCase()}-${ne.profileLocation.toString()}`)?.local)&&(C.push(this.Z(ie.local,{versionOnly:!0,profileLocation:ne.profileLocation})),s.set(J,F(ne)))}throw C.length&&await Promise.allSettled(C.map(async J=>{try{await J.run(),this.F.info("Rollback: Uninstalled extension",J.extension.identifier.id)}catch(ne){this.F.warn("Rollback: Error while uninstalling extension",J.extension.identifier.id,(0,L.$0)(ne))}})),k}finally{for(const{task:k}of o.values())k.source&&!h.URI.isUri(k.source)&&this.j.delete(S(k.source,k.profileLocation));if(s.size){const k=[...s.values()];for(const D of k)D.local&&this.F.info("Extension installed successfully:",D.identifier.id);this.s.fire(k)}}}J(t,s){for(const[,{task:o,waitingTasks:u}]of this.j.entries())if(o===t&&(u.includes(s)||u.some(S=>this.J(S,s)))||o===s&&u[0]&&!this.J(t,u[0]))return!1;return!0}async L(t,s){const o=[],u=[],S=await Promise.allSettled(t);for(const k of S)k.status==="fulfilled"?o.push(k.value):u.push(f(k.reason,s));if(!u.length)return o;if(u.length===1)throw u[0];let j=new v.$_o("","Unknown");for(const k of u)j=new v.$_o(j.message?`${j.message}, ${k.message}`:k.message,k.code!=="Unknown"&&k.code!=="Internal"?k.code:j.code);throw j}async M(t,s,o,u,S,j){if(!this.z.isEnabled())return[];const k=await this.getInstalled(void 0,S,j),D=[],F=[],C=async(J,ne)=>{D.push(J);const ie=ne.extensionDependencies||[],ue=[...ie];if(ne.extensionPack){const le=o?k.find(ce=>(0,y.$yp)(ce.identifier,J)):void 0;for(const ce of ne.extensionPack)le&&le.manifest.extensionPack&&le.manifest.extensionPack.some(V=>(0,y.$yp)({id:V},{id:ce}))||ue.every(V=>!(0,y.$yp)({id:V},{id:ce}))&&ue.push(ce)}if(ue.length){const le=ue.filter(ce=>D.every(V=>!(0,y.$yp)(V,{id:ce})));if(le.length){const ce=await this.z.getExtensions(le.map(V=>({id:V,preRelease:u})),I.CancellationToken.None);for(const V of ce){if(D.find(T=>(0,y.$yp)(T,V.identifier)))continue;const Z=ie.some(T=>(0,y.$yp)({id:T},V.identifier));let B;try{B=await this.N(V,!1,u,j)}catch(T){if(Z)throw T;this.F.info("Skipping the packed extension as it cannot be installed",V.identifier.id,(0,L.$0)(T));continue}F.push({gallery:B.extension,manifest:B.manifest}),await C(B.extension.identifier,B.manifest)}}}};return await C(t,s),F}async N(t,s,o,u){let S;const j=await this.getExtensionsControlManifest();if(j.malicious.some(F=>(0,y.$yp)(t.identifier,F)))throw new v.$_o(b.localize(1,null,t.identifier.id),"Malicious");const k=j.deprecated[t.identifier.id.toLowerCase()];if(k?.extension?.autoMigrate){if(this.F.info(`The '${t.identifier.id}' extension is deprecated, fetching the compatible '${k.extension.id}' extension instead.`),S=(await this.z.getExtensions([{id:k.extension.id,preRelease:k.extension.preRelease}],{targetPlatform:await this.getTargetPlatform(),compatible:!0,productVersion:u},I.CancellationToken.None))[0],!S)throw new v.$_o(b.localize(2,null,t.identifier.id,k.extension.id),"Deprecated")}else{if(!await this.canInstall(t)){const F=await this.getTargetPlatform();throw new v.$_o(b.localize(3,null,t.identifier.id,this.G.nameLong,(0,v.$4o)(F)),"IncompatibleTargetPlatform")}if(S=await this.O(t,s,o,u),!S)throw!o&&t.properties.isPreReleaseVersion&&(await this.z.getExtensions([t.identifier],I.CancellationToken.None))[0]?new v.$_o(b.localize(4,null,t.displayName??t.identifier.id),"ReleaseVersionNotFound"):new v.$_o(b.localize(5,null,t.identifier.id,this.G.nameLong,this.G.version),"Incompatible")}this.F.info("Getting Manifest...",S.identifier.id);const D=await this.z.getManifest(S,I.CancellationToken.None);if(D===null)throw new v.$_o(`Missing manifest for extension ${S.identifier.id}`,"Invalid");if(D.version!==S.version)throw new v.$_o(`Cannot install '${S.identifier.id}' extension because of version mismatch in Marketplace`,"Invalid");return{extension:S,manifest:D}}async O(t,s,o,u){const S=await this.getTargetPlatform();let j=null;return!s&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(j=(await this.z.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:S,compatible:!0,productVersion:u},I.CancellationToken.None))[0]||null),!j&&await this.z.isExtensionCompatible(t,o,S,u)&&(j=t),j||(s?j=(await this.z.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:S,compatible:!0,productVersion:u},I.CancellationToken.None))[0]||null:j=await this.z.getCompatibleExtension(t,o,S,u)),j}async P(t,s){const o={...s,profileLocation:t.isApplicationScoped?this.H.defaultProfile.extensionsResource:s.profileLocation??this.X()},u=C=>`${C.id.toLowerCase()}${o.versionOnly?`-${t.manifest.version}`:""}${o.profileLocation?`@${o.profileLocation.toString()}`:""}`,S=this.m.get(u(t.identifier));if(S)return this.F.info("Extensions is already requested to uninstall",t.identifier.id),S.waitUntilTaskIsFinished();const j=C=>{const J=this.Z(C,o);return this.m.set(u(J.extension.identifier),J),o.profileLocation?this.F.info("Uninstalling extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Uninstalling extension:",`${C.identifier.id}@${C.manifest.version}`),this.t.fire({identifier:C.identifier,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped}),J},k=(C,J)=>{J?o.profileLocation?this.F.error("Failed to uninstall extension from the profile:",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString(),J.message):this.F.error("Failed to uninstall extension:",`${C.identifier.id}@${C.manifest.version}`,J.message):o.profileLocation?this.F.info("Successfully uninstalled extension from the profile",`${C.identifier.id}@${C.manifest.version}`,o.profileLocation.toString()):this.F.info("Successfully uninstalled extension:",`${C.identifier.id}@${C.manifest.version}`),n(this.C,"extensionGallery:uninstall",{extensionData:(0,y.$Fp)(C),error:J}),this.u.fire({identifier:C.identifier,error:J?.code,profileLocation:o.profileLocation,applicationScoped:C.isApplicationScoped})},D=[],F=[];try{D.push(j(t));const C=await this.getInstalled(1,o.profileLocation);if(o.donotIncludePack)this.F.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const J=this.S(t,C);for(const ne of J)this.m.has(u(ne.identifier))?this.F.info("Extensions is already requested to uninstall",ne.identifier.id):D.push(j(ne))}o.donotCheckDependents?this.F.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.Q(D.map(J=>J.extension),C,t),await this.L(D.map(async J=>{try{if(await J.run(),await this.L(this.y.map(ne=>ne.postUninstall(J.extension,o,I.CancellationToken.None))),J.extension.identifier.uuid)try{await this.z.reportStatistic(J.extension.manifest.publisher,J.extension.manifest.name,J.extension.manifest.version,"uninstall")}catch{}k(J.extension)}catch(ne){const ie=f(ne);throw k(J.extension,ie),ie}finally{F.push(J)}}))}catch(C){const J=f(C);for(const ne of D){try{ne.cancel()}catch{}F.includes(ne)||k(ne.extension,J)}throw J}finally{for(const C of D)this.m.delete(u(C.extension.identifier))||this.F.warn("Uninstallation task is not found in the cache",C.extension.identifier.id)}}Q(t,s,o){for(const u of t){const S=this.U(u,s);if(S.length){const j=S.filter(k=>!t.some(D=>(0,y.$yp)(D.identifier,k.identifier)));if(j.length)throw new Error(this.R(u,j,o))}}}R(t,s,o){return o===t?s.length===1?b.localize(6,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(7,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(8,null,o.manifest.displayName||o.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):s.length===1?b.localize(9,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name):s.length===2?b.localize(10,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name):b.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,s[0].manifest.displayName||s[0].manifest.name,s[1].manifest.displayName||s[1].manifest.name)}S(t,s,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const u=t.manifest.extensionPack?t.manifest.extensionPack:[];if(u.length){const S=s.filter(k=>!k.isBuiltin&&u.some(D=>(0,y.$yp)({id:D},k.identifier))),j=[];for(const k of S)j.push(...this.S(k,s,o));return[...S,...j]}return[]}U(t,s){return s.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(u=>(0,y.$yp)({id:u},t.identifier)))}async W(){try{return this.F.trace("ExtensionManagementService.updateControlCache"),await this.z.getExtensionsControlManifest()}catch(t){return this.F.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest",(0,L.$0)(t)),{malicious:[],deprecated:{},search:[]}}}};e.$pq=m,e.$pq=m=$e([oe(0,v.$0o),oe(1,c.$4l),oe(2,w.$Cl),oe(3,R.$5j),oe(4,g.$lk),oe(5,p.$El)],m);function f(i,t){if(i instanceof v.$_o)return i;let s;return i instanceof v.$$o?s=new v.$_o(i.message,i.code==="DownloadFailedWriting"?"DownloadFailedWriting":"Gallery"):s=new v.$_o(i.message,(0,L.$4)(i)?"Cancelled":t??"Internal"),s.stack=i.stack,s}function n(i,t,{extensionData:s,verificationStatus:o,duration:u,error:S,source:j,durationSinceUpdate:k}){let D,F;(0,a.$gg)(o)&&(o===!0?o="Verified":(o===!1||(D="Signature",F=o),o="Unverified")),S&&(D=S.code,S.code==="Signature"&&(F=S.message)),i.publicLog(t,{...s,verificationStatus:o,success:!S,duration:u,errorcode:D,errorcodeDetail:F,durationSinceUpdate:k,source:j})}class r{constructor(){this.d=new O.$xh}async waitUntilTaskIsFinished(){return await this.d.wait(),this.g}run(){return this.g||(this.g=(0,O.$lh)(t=>this.h(t))),this.d.open(),this.g}cancel(){this.g||(this.g=(0,O.$lh)(t=>new Promise((s,o)=>{const u=t.onCancellationRequested(()=>{u.dispose(),o(new L.$5)})})),this.d.open()),this.g.cancel()}}e.$rq=r}),define(se[42],re([0,1,8,14,2,5,30,11,20,26,13,10,6,24,23,3,9,21]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uq=e.$tq=e.$sq=e.ExtensionsProfileScanningErrorCode=void 0;var w;(function(r){r.ERROR_PROFILE_NOT_FOUND="ERROR_PROFILE_NOT_FOUND",r.ERROR_INVALID_CONTENT="ERROR_INVALID_CONTENT"})(w||(e.ExtensionsProfileScanningErrorCode=w={}));class p extends Error{constructor(i,t){super(i),this.code=t}}e.$sq=p,e.$tq=(0,b.$yi)("IExtensionsProfileScannerService");let m=class extends I.$Uc{constructor(i,t,s,o,u,S){super(),this.j=i,this.m=t,this.n=s,this.r=o,this.s=u,this.t=S,this.b=this.B(new L.$fe),this.onAddExtensions=this.b.event,this.c=this.B(new L.$fe),this.onDidAddExtensions=this.c.event,this.f=this.B(new L.$fe),this.onRemoveExtensions=this.f.event,this.g=this.B(new L.$fe),this.onDidRemoveExtensions=this.g.event,this.h=new N.$Ac}scanProfileExtensions(i,t){return this.u(i,void 0,t)}async addExtensionsToProfile(i,t,s){const o=[],u=[];try{return await this.u(t,S=>{const j=[];if(s)j.push(...S);else for(const k of S)i.some(([D])=>(0,a.$yp)(D.identifier,k.identifier)&&D.manifest.version!==k.version)?o.push(k):j.push(k);for(const[k,D]of i){const F=j.findIndex(J=>(0,a.$yp)(J.identifier,k.identifier)&&J.version===k.manifest.version),C={identifier:k.identifier,version:k.manifest.version,location:k.location,metadata:D};F===-1?(u.push(C),j.push(C)):j.splice(F,1,C)}return u.length&&this.b.fire({extensions:u,profileLocation:t}),o.length&&this.f.fire({extensions:o,profileLocation:t}),j}),u.length&&this.c.fire({extensions:u,profileLocation:t}),o.length&&this.g.fire({extensions:o,profileLocation:t}),u}catch(S){throw u.length&&this.c.fire({extensions:u,error:S,profileLocation:t}),o.length&&this.g.fire({extensions:o,error:S,profileLocation:t}),S}}async updateMetadata(i,t){const s=[];return await this.u(t,o=>{const u=[];for(const S of o){const j=i.find(([k])=>(0,a.$yp)(k.identifier,S.identifier)&&k.manifest.version===S.version);j&&(S.metadata={...S.metadata,...j[1]},s.push(S)),u.push(S)}return u}),s}async removeExtensionFromProfile(i,t){const s=[];try{await this.u(t,o=>{const u=[];for(const S of o)(0,a.$yp)(S.identifier,i.identifier)?s.push(S):u.push(S);return s.length&&this.f.fire({extensions:s,profileLocation:t}),u}),s.length&&this.g.fire({extensions:s,profileLocation:t})}catch(o){throw s.length&&this.g.fire({extensions:s,error:o,profileLocation:t}),o}}async u(i,t,s){return this.F(i).queue(async()=>{let o=[],u;try{const S=await this.m.readFile(i);u=JSON.parse(S.value.toString().trim()||"[]")}catch(S){if((0,h.$jl)(S)!==1)throw S;if(this.r.extUri.isEqual(i,this.n.defaultProfile.extensionsResource)&&(u=await this.D()),!u&&s?.bailOutWhenFileNotFound)throw new p((0,g.$0)(S),"ERROR_PROFILE_NOT_FOUND")}if(u){Array.isArray(u)||this.w(i);let S=!1;for(const j of u){f(j)||this.w(i);let k;if((0,R.$$f)(j.relativeLocation)&&j.relativeLocation)k=this.z(j.relativeLocation);else if((0,R.$$f)(j.location)){this.t.warn(`Extensions profile: Ignoring extension with invalid location: ${j.location}`);continue}else{k=P.URI.revive(j.location);const D=this.y(k);D&&(S=!0,j.relativeLocation=D)}(0,R.$fg)(j.metadata?.hasPreReleaseVersion)&&j.metadata?.preRelease&&(S=!0,j.metadata.hasPreReleaseVersion=!0),o.push({identifier:j.identifier,location:k,version:j.version,metadata:j.metadata})}S&&await this.m.writeFile(i,O.$He.fromString(JSON.stringify(u)))}if(t){o=t(o);const S=o.map(j=>({identifier:j.identifier,version:j.version,location:j.location.toJSON(),relativeLocation:this.y(j.location),metadata:j.metadata}));await this.m.writeFile(i,O.$He.fromString(JSON.stringify(S)))}return o})}w(i){const t=new p(`Invalid extensions content in ${i.toString()}`,"ERROR_INVALID_CONTENT");throw this.s.publicLogError2("extensionsProfileScanningError",{code:t.code}),t}y(i){return this.r.extUri.isEqual(this.r.extUri.dirname(i),this.j)?this.r.extUri.basename(i):void 0}z(i){return this.r.extUri.joinPath(this.j,i)}async D(){return this.C||(this.C=(async()=>{const i=this.r.extUri.joinPath(this.n.defaultProfile.location,"extensions.json"),t=this.r.extUri.joinPath(this.j,".init-default-profile-extensions");let s;try{s=(await this.m.readFile(i)).value.toString()}catch(u){if((0,h.$jl)(u)===1)return;throw u}this.t.info("Migrating extensions from old default profile location",i.toString());let o;try{const u=JSON.parse(s);Array.isArray(u)&&u.every(S=>f(S))?o=u:this.t.warn("Skipping migrating from old default profile locaiton: Found invalid data",u)}catch(u){this.t.error(u)}if(o)try{await this.m.createFile(this.n.defaultProfile.extensionsResource,O.$He.fromString(JSON.stringify(o)),{overwrite:!1}),this.t.info("Migrated extensions from old default profile location to new location",i.toString(),this.n.defaultProfile.extensionsResource.toString())}catch(u){if((0,h.$jl)(u)===3)this.t.info("Migration from old default profile location to new location is done by another window",i.toString(),this.n.defaultProfile.extensionsResource.toString());else throw u}try{await this.m.del(i)}catch(u){(0,h.$jl)(u)!==1&&this.t.error(u)}try{await this.m.del(t)}catch(u){(0,h.$jl)(u)!==1&&this.t.error(u)}return o})()),this.C}F(i){let t=this.h.get(i);return t||(t=new A.$Fh,this.h.set(i,t)),t}};e.$uq=m,e.$uq=m=$e([oe(1,h.$5k),oe(2,y.$El),oe(3,$.$Cl),oe(4,c.$4l),oe(5,v.$5j)],m);function f(r){return(0,R.$ag)(r)&&(0,l.$9o)(r.identifier)&&(n(r.location)||(0,R.$$f)(r.location)&&r.location)&&((0,R.$fg)(r.relativeLocation)||(0,R.$$f)(r.relativeLocation))&&r.version&&(0,R.$$f)(r.version)}function n(r){return r?(0,R.$$f)(r.path)&&(0,R.$$f)(r.scheme):!1}}),define(se[54],re([0,1,19,8,27,14,9,38,85,2,15,16,12,17,44,56,3,11,101,18,26,37,50,13,10,6,32,5,47,42,24,23,119]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w,p,m,f,n,r,i,t,s,o,u,S,j,k,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bq=e.$zq=e.$yq=e.$xq=e.Translations=void 0,e.$Aq=ue;var F;(function(ce){function V(Z,B){if(Z===B)return!0;const T=Object.keys(Z),H=new Set;for(const Q of Object.keys(B))H.add(Q);if(T.length!==H.size)return!1;for(const Q of T){if(Z[Q]!==B[Q])return!1;H.delete(Q)}return H.size===0}ce.equals=V})(F||(e.Translations=F={})),e.$xq=(0,i.$yi)("IExtensionsScannerService");let C=class extends a.$Uc{constructor(V,Z,B,T,H,Q,Y,_,U,q,d,E){super(),this.systemExtensionsLocation=V,this.userExtensionsLocation=Z,this.r=B,this.s=T,this.t=H,this.u=Q,this.w=Y,this.y=_,this.z=U,this.C=q,this.D=d,this.F=E,this.g=this.B(new o.$fe),this.onDidChangeCache=this.g.event,this.h=(0,y.$_g)(this.userExtensionsLocation,".obsolete"),this.j=this.B(this.F.createInstance(ie,this.s,this.h)),this.m=this.B(this.F.createInstance(ie,this.s,this.h)),this.n=this.B(this.F.createInstance(ne,this.h)),this.H=void 0,this.B(this.j.onDidChangeCache(()=>this.g.fire(0))),this.B(this.m.onDidChangeCache(()=>this.g.fire(1)))}getTargetPlatform(){return this.G||(this.G=(0,m.$Jp)(this.w,this.y)),this.G}async scanAllExtensions(V,Z,B){const[T,H]=await Promise.all([this.scanSystemExtensions(V),this.scanUserExtensions(Z)]),Q=B?await this.scanExtensionsUnderDevelopment(V,[...T,...H]):[];return this.L(T,H,Q,await this.getTargetPlatform(),!0)}async scanSystemExtensions(V){const Z=[];Z.push(this.M(!!V.useCache,V.language)),Z.push(this.N(V.language,!!V.checkControlFile));const[B,T]=await Promise.all(Z);return this.J([...B,...T],0,V,!1)}async scanUserExtensions(V){const Z=V.profileLocation??this.userExtensionsLocation;this.y.trace("Started scanning user extensions",Z);const B=this.D.extUri.isEqual(V.profileLocation,this.t.defaultProfile.extensionsResource)?{bailOutWhenFileNotFound:!0}:void 0,T=await this.P(Z,!!V.profileLocation,1,!V.includeUninstalled,V.language,!0,B,V.productVersion??this.R()),H=V.useCache&&!T.devMode&&T.excludeObsolete?this.m:this.n;let Q;try{Q=await H.scanExtensions(T)}catch(Y){if(Y instanceof S.$sq&&Y.code==="ERROR_PROFILE_NOT_FOUND")await this.I(),Q=await H.scanExtensions(T);else throw Y}return Q=await this.J(Q,1,V,!0),this.y.trace("Scanned user extensions:",Q.length),Q}async scanExtensionsUnderDevelopment(V,Z){if(this.z.isExtensionDevelopment&&this.z.extensionDevelopmentLocationURI){const B=(await Promise.all(this.z.extensionDevelopmentLocationURI.filter(T=>T.scheme===h.Schemas.file).map(async T=>{const H=await this.P(T,!1,1,!0,V.language,!1,void 0,V.productVersion??this.R());return(await this.n.scanOneOrMultipleExtensions(H)).map(Y=>(Y.type=Z.find(_=>(0,m.$yp)(_.identifier,Y.identifier))?.type??Y.type,this.n.validate(Y,H)))}))).flat();return this.J(B,"development",V,!0)}return[]}async scanExistingExtension(V,Z,B){const T=await this.P(V,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),H=await this.n.scanExtension(T);return!H||!B.includeInvalid&&!H.isValid?null:H}async scanOneOrMultipleExtensions(V,Z,B){const T=await this.P(V,!1,Z,!0,B.language,!0,void 0,B.productVersion??this.R()),H=await this.n.scanOneOrMultipleExtensions(T);return this.J(H,Z,B,!0)}async scanMultipleExtensions(V,Z,B){const T=[];return await Promise.all(V.map(async H=>{const Q=await this.scanOneOrMultipleExtensions(H,Z,B);T.push(...Q)})),this.J(T,Z,B,!0)}async scanMetadata(V){const Z=(0,y.$_g)(V,"package.json"),B=(await this.w.readFile(Z)).value.toString();return JSON.parse(B).__metadata}async updateMetadata(V,Z){const B=(0,y.$_g)(V,"package.json"),T=(await this.w.readFile(B)).value.toString(),H=JSON.parse(T);Z.isMachineScoped===!1&&delete Z.isMachineScoped,Z.isBuiltin===!1&&delete Z.isBuiltin,H.__metadata={...H.__metadata,...Z},await this.w.writeFile((0,y.$_g)(V,"package.json"),L.$He.fromString(JSON.stringify(H,null,"	")))}async initializeDefaultProfileExtensions(){try{await this.u.scanProfileExtensions(this.t.defaultProfile.extensionsResource,{bailOutWhenFileNotFound:!0})}catch(V){if(V instanceof S.$sq&&V.code==="ERROR_PROFILE_NOT_FOUND")await this.I();else throw V}}async I(){return this.H||(this.H=(async()=>{try{this.y.info("Started initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString());const V=await this.scanUserExtensions({includeInvalid:!0});if(V.length)await this.u.addExtensionsToProfile(V.map(Z=>[Z,Z.metadata]),this.t.defaultProfile.extensionsResource);else try{await this.w.createFile(this.t.defaultProfile.extensionsResource,L.$He.fromString(JSON.stringify([])))}catch(Z){(0,r.$jl)(Z)!==1&&this.y.warn("Failed to create default profile extensions manifest in extensions installation folder.",this.userExtensionsLocation.toString(),(0,N.$0)(Z))}this.y.info("Completed initializing default profile extensions in extensions installation folder.",this.userExtensionsLocation.toString())}catch(V){this.y.error(V)}finally{this.H=void 0}})()),this.H}async J(V,Z,B,T){return B.includeAllVersions||(V=this.L(Z===0?V:void 0,Z===1?V:void 0,Z==="development"?V:void 0,await this.getTargetPlatform(),T)),B.includeInvalid||(V=V.filter(H=>H.isValid)),V.sort((H,Q)=>{const Y=b.$nc(H.location.fsPath),_=b.$nc(Q.location.fsPath);return Y<_?-1:Y>_?1:0})}L(V,Z,B,T,H){const Q=(_,U,q)=>{if(_.isValid&&!U.isValid)return!1;if(_.isValid===U.isValid){if(H&&$.gt(_.manifest.version,U.manifest.version))return this.y.debug(`Skipping extension ${U.location.path} with lower version ${U.manifest.version} in favour of ${_.location.path} with version ${_.manifest.version}`),!1;if($.eq(_.manifest.version,U.manifest.version)){if(_.type===0)return this.y.debug(`Skipping extension ${U.location.path} in favour of system extension ${_.location.path} with same version`),!1;if(_.targetPlatform===T)return this.y.debug(`Skipping extension ${U.location.path} from different target platform ${U.targetPlatform}`),!1}}return q?this.y.warn(`Overwriting user extension ${_.location.path} with ${U.location.path}.`):this.y.debug(`Overwriting user extension ${_.location.path} with ${U.location.path}.`),!0},Y=new f.$Vm;return V?.forEach(_=>{const U=Y.get(_.identifier.id);(!U||Q(U,_,!1))&&Y.set(_.identifier.id,_)}),Z?.forEach(_=>{const U=Y.get(_.identifier.id);if(!U&&V&&_.type===0){this.y.debug(`Skipping obsolete system extension ${_.location.path}.`);return}(!U||Q(U,_,!1))&&Y.set(_.identifier.id,_)}),B?.forEach(_=>{const U=Y.get(_.identifier.id);(!U||Q(U,_,!0))&&Y.set(_.identifier.id,_),Y.set(_.identifier.id,_)}),[...Y.values()]}async M(V,Z){this.y.trace("Started scanning system extensions");const B=await this.P(this.systemExtensionsLocation,!1,0,!0,Z,!0,void 0,this.R()),H=await(V&&!B.devMode?this.j:this.n).scanExtensions(B);return this.y.trace("Scanned system extensions:",H.length),H}async N(V,Z){const B=this.z.isBuilt?[]:this.C.builtInExtensions;if(!B?.length)return[];this.y.trace("Started scanning dev system extensions");const T=Z?await this.O():{},H=[],Q=c.URI.file(b.$hc(b.$jc(h.$Sg.asFileUri("").fsPath,"..",".build","builtInExtensions")));for(const _ of B){const U=T[_.name]||"marketplace";switch(U){case"disabled":break;case"marketplace":H.push((0,y.$_g)(Q,_.name));break;default:H.push(c.URI.file(U));break}}const Y=await Promise.all(H.map(async _=>this.n.scanExtension(await this.P(_,!1,0,!0,V,!0,void 0,this.R()))));return this.y.trace("Scanned dev system extensions:",Y.length),(0,A.$Hb)(Y)}async O(){try{const V=await this.w.readFile(this.r);return JSON.parse(V.value.toString())}catch{return{}}}async P(V,Z,B,T,H,Q,Y,_){const U=await this.f(H??v.$w),q=await this.Q(V),d=Z&&!this.D.extUri.isEqual(V,this.t.defaultProfile.extensionsResource)?this.t.defaultProfile.extensionsResource:void 0,E=d?await this.Q(d):void 0;return new J(V,q,d,E,Z,Y,B,T,Q,_.version,_.date,this.C.commit,!this.z.isBuilt,H,U)}async Q(V){try{const Z=await this.w.stat(V);if(typeof Z.mtime=="number")return Z.mtime}catch{}}R(){return{version:this.C.version,date:this.C.date}}};e.$yq=C,e.$yq=C=$e([oe(4,j.$El),oe(5,S.$tq),oe(6,r.$5k),oe(7,t.$5j),oe(8,p.$Fi),oe(9,s.$lk),oe(10,k.$Cl),oe(11,i.$xi)],C);class J{constructor(V,Z,B,T,H,Q,Y,_,U,q,d,E,z,M,G){this.location=V,this.mtime=Z,this.applicationExtensionslocation=B,this.applicationExtensionslocationMtime=T,this.profile=H,this.profileScanOptions=Q,this.type=Y,this.excludeObsolete=_,this.validate=U,this.productVersion=q,this.productDate=d,this.productCommit=E,this.devMode=z,this.language=M,this.translations=G}static createNlsConfiguration(V){return{language:V.language,pseudo:V.language==="pseudo",devMode:V.devMode,translations:V.translations}}static equals(V,Z){return(0,y.$5g)(V.location,Z.location)&&V.mtime===Z.mtime&&(0,y.$5g)(V.applicationExtensionslocation,Z.applicationExtensionslocation)&&V.applicationExtensionslocationMtime===Z.applicationExtensionslocationMtime&&V.profile===Z.profile&&I.$9n(V.profileScanOptions,Z.profileScanOptions)&&V.type===Z.type&&V.excludeObsolete===Z.excludeObsolete&&V.validate===Z.validate&&V.productVersion===Z.productVersion&&V.productDate===Z.productDate&&V.productCommit===Z.productCommit&&V.devMode===Z.devMode&&V.language===Z.language&&F.equals(V.translations,Z.translations)}}e.$zq=J;let ne=class extends a.$Uc{constructor(V,Z,B,T,H){super(),this.f=V,this.g=Z,this.h=B,this.j=T,this.m=H}async scanExtensions(V){const Z=V.profile?await this.r(V):await this.n(V);let B={};if(V.excludeObsolete&&V.type===1)try{const T=(await this.j.readFile(this.f)).value.toString();B=JSON.parse(T)}catch{}return(0,g.$lg)(B)?Z:Z.filter(T=>!B[m.$zp.create(T).toString()])}async n(V){const Z=await this.j.resolve(V.location);if(!Z.children?.length)return[];const B=await Promise.all(Z.children.map(async T=>{if(!T.isDirectory||V.type===1&&(0,y.$9g)(T.resource).indexOf(".")===0)return null;const H=new J(T.resource,V.mtime,V.applicationExtensionslocation,V.applicationExtensionslocationMtime,V.profile,V.profileScanOptions,V.type,V.excludeObsolete,V.validate,V.productVersion,V.productDate,V.productCommit,V.devMode,V.language,V.translations);return this.scanExtension(H)}));return(0,A.$Hb)(B).sort((T,H)=>T.location.path<H.location.path?-1:1)}async r(V){let Z=await this.s(V.location,()=>!0,V);if(V.applicationExtensionslocation&&!this.h.extUri.isEqual(V.location,V.applicationExtensionslocation)){Z=Z.filter(T=>!T.metadata?.isApplicationScoped);const B=await this.s(V.applicationExtensionslocation,T=>!!T.metadata?.isBuiltin||!!T.metadata?.isApplicationScoped,V);Z.push(...B)}return Z}async s(V,Z,B){const T=await this.g.scanProfileExtensions(V,B.profileScanOptions);if(!T.length)return[];const H=await Promise.all(T.map(async Q=>{if(Z(Q)){const Y=new J(Q.location,B.mtime,B.applicationExtensionslocation,B.applicationExtensionslocationMtime,B.profile,B.profileScanOptions,B.type,B.excludeObsolete,B.validate,B.productVersion,B.productDate,B.productCommit,B.devMode,B.language,B.translations);return this.scanExtension(Y,Q.metadata)}return null}));return(0,A.$Hb)(H)}async scanOneOrMultipleExtensions(V){try{if(await this.j.exists((0,y.$_g)(V.location,"package.json"))){const Z=await this.scanExtension(V);return Z?[Z]:[]}else return await this.scanExtensions(V)}catch(Z){return this.m.error(`Error scanning extensions at ${V.location.path}:`,(0,N.$0)(Z)),[]}}async scanExtension(V,Z){try{let B=await this.scanExtensionManifest(V.location);if(B){B.publisher||(B.publisher=f.$Pm),Z=Z??B.__metadata,delete B.__metadata;const T=(0,m.$Dp)(B.publisher,B.name),H=Z?.id?{id:T,uuid:Z.id}:{id:T},Q=Z?.isSystem?0:V.type,Y=Q===0||!!Z?.isBuiltin;B=await this.t(V.location,B,J.createNlsConfiguration(V));const _={type:Q,identifier:H,manifest:B,location:V.location,isBuiltin:Y,targetPlatform:Z?.targetPlatform??"undefined",publisherDisplayName:Z?.publisherDisplayName,metadata:Z,isValid:!0,validations:[]};return V.validate?this.validate(_,V):_}}catch(B){V.type!==0&&this.m.error(B)}return null}validate(V,Z){let B=!0;const T=(0,n.$Op)(Z.productVersion,Z.productDate,Z.location,V.manifest,V.isBuiltin);for(const[H,Q]of T)H===R.default.Error&&(B=!1,this.m.error(this.z(Z.location,Q)));return V.isValid=B,V.validations=T,V}async scanExtensionManifest(V){const Z=(0,y.$_g)(V,"package.json");let B;try{B=(await this.j.readFile(Z)).value.toString()}catch(H){return(0,r.$jl)(H)!==1&&this.m.error(this.z(V,(0,w.localize)(0,null,Z.path,H.message))),null}let T;try{T=JSON.parse(B)}catch{const Q=[];(0,P.$Ln)(B,Q);for(const Y of Q)this.m.error(this.z(V,(0,w.localize)(1,null,Z.path,Y.offset,Y.length,(0,l.$vq)(Y.error))));return null}return(0,P.$Un)(T)!=="object"?(this.m.error(this.z(V,(0,w.localize)(2,null,Z.path))),null):T}async t(V,Z,B){const T=await this.u(V,Z,B);if(T)try{const H=[],Q=await this.w(T.default,H);if(H.length>0)return H.forEach(_=>{this.m.error(this.z(V,(0,w.localize)(3,null,T.default?.path,(0,l.$vq)(_.error))))}),Z;if((0,P.$Un)(T)!=="object")return this.m.error(this.z(V,(0,w.localize)(4,null,T.default?.path))),Z;const Y=T.values||Object.create(null);return(0,D.$wq)(this.m,Z,Y,Q)}catch{}return Z}async u(V,Z,B){const T=(0,y.$_g)(V,"package.nls.json"),H=(U,q)=>{q.forEach(d=>{this.m.error(this.z(V,(0,w.localize)(5,null,U?.path,(0,l.$vq)(d.error))))})},Q=U=>{this.m.error(this.z(V,(0,w.localize)(6,null,U?.path)))},Y=`${Z.publisher}.${Z.name}`,_=B.translations[Y];if(_)try{const U=c.URI.file(_),q=(await this.j.readFile(U)).value.toString(),d=[],E=(0,P.$Ln)(q,d);return d.length>0?(H(U,d),{values:void 0,default:T}):(0,P.$Un)(E)!=="object"?(Q(U),{values:void 0,default:T}):{values:E.contents?E.contents.package:void 0,default:T}}catch{return{values:void 0,default:T}}else{if(!await this.j.exists(T))return;let q;try{q=await this.y(V,B)}catch{return}if(!q.localized)return{values:void 0,default:q.original};try{const d=(await this.j.readFile(q.localized)).value.toString(),E=[],z=(0,P.$Ln)(d,E);return E.length>0?(H(q.localized,E),{values:void 0,default:q.original}):(0,P.$Un)(z)!=="object"?(Q(q.localized),{values:void 0,default:q.original}):{values:z,default:q.original}}catch{return{values:void 0,default:q.original}}}}async w(V,Z){if(V)try{const B=(await this.j.readFile(V)).value.toString();return(0,P.$Ln)(B,Z)}catch{}}y(V,Z){return new Promise((B,T)=>{const H=Q=>{const Y=(0,y.$_g)(V,`package.nls.${Q}.json`);this.j.exists(Y).then(_=>{_&&B({localized:Y,original:(0,y.$_g)(V,"package.nls.json")});const U=Q.lastIndexOf("-");U===-1?B({localized:(0,y.$_g)(V,"package.nls.json"),original:null}):(Q=Q.substring(0,U),H(Q))})};if(Z.devMode||Z.pseudo||!Z.language)return B({localized:(0,y.$_g)(V,"package.nls.json"),original:null});H(Z.language)})}z(V,Z){return`[${V.path}]: ${Z}`}};ne=$e([oe(1,S.$tq),oe(2,k.$Cl),oe(3,r.$5k),oe(4,t.$5j)],ne);let ie=class extends ne{constructor(V,Z,B,T,H,Q,Y){super(Z,T,H,Q,Y),this.G=V,this.H=B,this.D=this.B(new O.$wh(3e3)),this.F=this.B(new o.$fe),this.onDidChangeCache=this.F.event}async scanExtensions(V){const Z=this.M(V),B=await this.I(Z);if(this.C=V,B&&B.input&&J.equals(B.input,this.C))return this.m.debug("Using cached extensions scan result",V.location.toString()),this.D.trigger(()=>this.L()),B.result.map(H=>(H.location=c.URI.revive(H.location),H));const T=await super.scanExtensions(V);return await this.J(Z,{input:V,result:T}),T}async I(V){try{const Z=await this.j.readFile(V),B=JSON.parse(Z.value.toString());return{result:B.result,input:(0,u.$8h)(B.input)}}catch(Z){this.m.debug("Error while reading the extension cache file:",V.path,(0,N.$0)(Z))}return null}async J(V,Z){try{await this.j.writeFile(V,L.$He.fromString(JSON.stringify(Z)))}catch(B){this.m.debug("Error while writing the extension cache file:",V.path,(0,N.$0)(B))}}async L(){if(!this.C)return;const V=this.M(this.C),Z=await this.I(V);if(!Z)return;const B=Z.result,T=JSON.parse(JSON.stringify(await super.scanExtensions(this.C)));if(!I.$9n(T,B))try{this.m.info("Invalidating Cache",B,T),await this.j.del(V),this.F.fire()}catch(H){this.m.error(H)}}M(V){const Z=this.N(V);return this.h.extUri.joinPath(Z.cacheHome,V.type===0?f.$Om:f.$Nm)}N(V){return V.type===0?this.H.defaultProfile:V.profile?this.h.extUri.isEqual(V.location,this.G.extensionsResource)?this.G:this.H.profiles.find(Z=>this.h.extUri.isEqual(V.location,Z.extensionsResource))??this.G:this.H.defaultProfile}};ie=$e([oe(2,j.$El),oe(3,S.$tq),oe(4,k.$Cl),oe(5,r.$5k),oe(6,t.$5j)],ie);function ue(ce,V){const Z=(0,m.$Bp)(ce.manifest.publisher,ce.manifest.name);return{id:Z,identifier:new f.$Tm(Z),isBuiltin:ce.type===0,isUserBuiltin:ce.type===1&&ce.isBuiltin,isUnderDevelopment:V,extensionLocation:ce.location,uuid:ce.identifier.uuid,targetPlatform:ce.targetPlatform,publisherDisplayName:ce.publisherDisplayName,...ce.manifest}}class le extends C{constructor(V,Z,B,T,H,Q,Y,_,U,q,d,E){super(V,Z,(0,y.$_g)(B,".vscode-oss-dev","extensions","control.json"),T,H,Q,Y,_,U,q,d,E),this.S=(async()=>{if(v.$z)try{const z=await this.w.readFile(c.URI.file(v.$z));return JSON.parse(z.value.toString())}catch{}return Object.create(null)})()}f(V){return this.S}}e.$Bq=le}),define(se[160],re([0,1,60,8,34,5,2,15,16,25,6,24]),function(X,e,A,O,I,L,N,P,l,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fq=void 0;let v=class extends N.$Uc{constructor($,R){super(),this.b=$,this.f=R,this.a=new O.$Eh(5)}async postUninstall($){const R=this.g($,"uninstall");R&&(this.f.info($.identifier.id,$.manifest.version,"Running post uninstall script"),await this.a.queue(async()=>{try{await this.h(R.script,"uninstall",R.args,!0,$),this.f.info("Finished running post uninstall script",$.identifier.id,$.manifest.version)}catch(g){this.f.error("Failed to run post uninstall script",$.identifier.id,$.manifest.version),this.f.error(g)}}));try{await a.Promises.rm(this.m($))}catch(g){this.f.error("Error while removing extension storage path",$.identifier.id),this.f.error(g)}}g($,R){const g=`vscode:${R}`;if($.location.scheme===P.Schemas.file&&$.manifest&&$.manifest.scripts&&typeof $.manifest.scripts[g]=="string"){const c=$.manifest.scripts[g].split(" ");return c.length<2||c[0]!=="node"||!c[1]?(this.f.warn($.identifier.id,$.manifest.version,`${g} should be a node script`),null):{script:(0,l.$jc)($.location.fsPath,c[1]),args:c.slice(2)||[]}}return null}h($,R,g,c,w){return new Promise((p,m)=>{const f=this.j($,R,g,w);let n;const r=i=>{n&&(clearTimeout(n),n=null),i?m(i):p(void 0)};f.on("error",i=>{r((0,I.$jj)(i)||"Unknown")}),f.on("exit",(i,t)=>{r(i?`post-${R} process exited with code ${i}`:void 0)}),c&&(n=setTimeout(()=>{n=null,f.kill(),m("timed out")},5e3))})}j($,R,g,c){const w={silent:!0,execArgv:void 0},p=(0,A.fork)($,[`--type=extension-post-${R}`,...g],w);p.stdout.setEncoding("utf8"),p.stderr.setEncoding("utf8");const m=L.Event.fromNodeEventEmitter(p.stdout,"data"),f=L.Event.fromNodeEventEmitter(p.stderr,"data");this.B(m(i=>this.f.info(c.identifier.id,c.manifest.version,`post-${R}`,i))),this.B(f(i=>this.f.error(c.identifier.id,c.manifest.version,`post-${R}`,i)));const n=L.Event.any(L.Event.map(m,i=>({data:`%c${i}`,format:[""]}),this.q),L.Event.map(f,i=>({data:`%c${i}`,format:["color: red"]}),this.q));return L.Event.debounce(n,(i,t)=>i?{data:i.data+t.data,format:[...i.format,...t.format]}:{data:t.data,format:t.format},100,void 0,void 0,void 0,this.q)(i=>{console.group(c.identifier.id),console.log(i.data,...i.format),console.groupEnd()}),p}m($){return(0,l.$jc)(this.b.defaultProfile.globalStorageHome.fsPath,$.identifier.id.toLowerCase())}};e.$Fq=v,e.$Fq=v=$e([oe(0,b.$El),oe(1,h.$5j)],v)}),define(se[73],re([0,1,49,103,53,20]),function(X,e,A,O,I,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cq=N,e.$Dq=P;function N(l){let a="Extract";return l instanceof A.$lq&&(l.type==="CorruptZip"?a="CorruptZip":l.type==="Incomplete"&&(a="IncompleteZip")),(0,I.$qq)(l,a)}async function P(l){let a;try{a=await(0,A.$oq)(l,"extension/package.json")}catch(h){throw N(h)}try{return JSON.parse(a.toString("utf8"))}catch{throw new L.$_o((0,O.localize)(0,null),"Invalid")}}}),define(se[161],re([0,1,8,9,2,15,17,44,3,28,25,49,29,18,53,20,26,73,72,13,6,21]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w,p,m,f){"use strict";var n;Object.defineProperty(e,"__esModule",{value:!0}),e.$Eq=void 0;let r=class extends I.$Uc{static{n=this}static{this.c=".sigzip"}constructor(t,s,o,u,S,j,k){super(),this.h=s,this.j=o,this.m=u,this.n=S,this.r=j,this.t=k,this.extensionsDownloadDir=t.extensionsDownloadLocation,this.f=20,this.g=this.F()}async download(t,s,o,u){await this.g;const S=await this.w(t,s);let j=!1;if(o&&this.u(t)){let k;try{k=await this.y(t)}catch(D){try{await this.delete(S)}catch(F){this.t.error(F)}throw D}try{j=await this.n.verify(t,S.fsPath,k.fsPath,u)}catch(D){if(j=D.code,j==="PackageIsInvalidZip"||j==="SignatureArchiveIsInvalidZip"){try{await this.delete(S)}catch(F){this.t.error(F)}throw new R.$_o(b.$kq,"CorruptZip")}}finally{try{await this.delete(k)}catch(D){this.t.error(D)}}}return{location:S,verificationStatus:j}}u(t){if(!t.isSigned)return this.t.info(`Extension is not signed: ${t.identifier.id}`),!1;const s=this.m.getValue("extensions.verifySignature");return(0,l.$eg)(s)?s:!0}async w(t,s){try{const o=(0,N.$_g)(this.extensionsDownloadDir,this.G(t)),u=await this.C(t,"vsix",async()=>{await this.z(t,o,S=>this.j.download(t,S,s));try{await this.D(o.fsPath,"extension/package.json")}catch(S){try{await this.h.del(o)}catch(j){this.t.warn(`Error while deleting: ${o.path}`,(0,O.$0)(j))}throw S}},2);return u>1&&this.r.publicLog2("extensiongallery:downloadvsix:retry",{extensionId:t.identifier.id,attempts:u}),o}catch(o){throw(0,$.$qq)(o,"Download")}}async y(t){try{const s=(0,N.$_g)(this.extensionsDownloadDir,`.${(0,a.$Ug)()}`),o=await this.C(t,"sigzip",async()=>{await this.j.downloadSignatureArchive(t,s);try{await this.D(s.fsPath,".signature.p7s")}catch(u){try{await this.h.del(s)}catch(S){this.t.warn(`Error while deleting: ${s.path}`,(0,O.$0)(S))}throw u}},2);return o>1&&this.r.publicLog2("extensiongallery:downloadsigzip:retry",{extensionId:t.identifier.id,attempts:o}),s}catch(s){throw(0,$.$qq)(s,"DownloadSignature")}}async z(t,s,o){if(await this.h.exists(s))return;if(s.scheme!==L.Schemas.file){await o(s);return}const u=(0,N.$_g)(this.extensionsDownloadDir,`.${(0,a.$Ug)()}`);try{await o(u)}catch(S){try{await this.h.del(u)}catch{}throw S}try{await h.Promises.rename(u.fsPath,s.fsPath,2*60*1e3)}catch(S){try{await this.h.del(u)}catch{}let j=!1;try{j=await this.h.exists(s)}catch{}if(j)this.t.info("Rename failed because the file was downloaded by another source. So ignoring renaming.",t.identifier.id,s.path);else throw this.t.info(`Rename failed because of ${(0,O.$0)(S)}. Deleted the file from downloaded location`,u.path),S}}async C(t,s,o,u){let S=1;for(;;)try{return await o(),S}catch(j){if(S++>u)throw j;this.t.warn(`Failed downloading ${s}. ${(0,O.$0)(j)}. Retry again...`,t.identifier.id)}}async D(t,s){try{await(0,b.$oq)(t,s)}catch(o){throw(0,c.$Cq)(o)}}async delete(t){await this.g,await this.h.del(t)}async F(){try{if(!await this.h.exists(this.extensionsDownloadDir)){this.t.trace("Extension VSIX downloads cache dir does not exist");return}const t=await this.h.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(t.children){const s=[],o=[],u=[];for(const k of t.children)if(k.name.endsWith(n.c))u.push(k.resource);else{const D=g.$zp.parse(k.name);D&&o.push([D,k])}const S=(0,g.$Ep)(o,([k])=>k),j=[];for(const k of S)k.sort((D,F)=>P.rcompare(D[0].version,F[0].version)),s.push(...k.slice(1).map(D=>D[1].resource)),j.push(k[0][1]);j.sort((k,D)=>k.mtime-D.mtime),s.push(...j.slice(0,Math.max(0,j.length-this.f)).map(k=>k.resource)),s.push(...u),await A.Promises.settled(s.map(k=>(this.t.trace("Deleting from cache",k.path),this.h.del(k))))}}catch(t){this.t.error(t)}}G(t){return this.f?g.$zp.create(t).toString().toLowerCase():(0,a.$Ug)()}};e.$Eq=r,e.$Eq=r=n=$e([oe(0,y.$Gi),oe(1,p.$5k),oe(2,R.$0o),oe(3,v.$5i),oe(4,w.$dq),oe(5,f.$4l),oe(6,m.$5j)],r)}),define(se[162],re([0,1,8,14,22,34,9,5,43,2,30,15,16,17,44,3,11,28,25,49,102,62,18,53,20,26,42,54,161,160,73,141,148,50,13,10,6,32,21,23,24]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w,p,m,f,n,r,i,t,s,o,u,S,j,k,D,F,C,J,ne,ie,ue,le,ce){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lq=e.$Kq=e.$Jq=e.$Iq=void 0,e.$Iq=(0,J.$zi)(i.$ap);const V=".vsctmp";let Z=class extends r.$pq{constructor(U,q,d,E,z,M,G,W,te,ae,he,pe){super(U,q,he,d,ae,pe),this.eb=z,this.fb=M,this.gb=G,this.hb=te,this.db=new Map,this.qb=new h.$Bc;const ye=this.B(W.createInstance(S.$Fq));this.ab=this.B(W.createInstance(B,me=>ye.postUninstall(me))),this.bb=this.B(new k.$Gq(pe,te,he,this,this.F)),this.cb=this.B(W.createInstance(u.$Eq));const fe=this.B(new D.$Hq(this,this.eb,pe,M,he,te,d));this.B(fe.onDidChangeExtensionsByAnotherSource(me=>this.pb(me))),this.rb()}getTargetPlatform(){return this.ib||(this.ib=(0,t.$Jp)(this.hb,this.F)),this.ib}async zip(U){this.F.trace("ExtensionManagementService#zip",U.identifier.id);const q=await this.ob(U),d=await(0,p.zip)((0,y.$_g)(this.cb.extensionsDownloadDir,(0,c.$Ug)()).fsPath,q);return g.URI.file(d)}async unzip(U){return this.F.trace("ExtensionManagementService#unzip",U.toString()),(await this.install(U)).identifier}async getManifest(U){const{location:q,cleanup:d}=await this.kb(U),E=v.$kc(q.fsPath);try{return await(0,j.$Dq)(E)}finally{await d()}}getInstalled(U,q=this.H.defaultProfile.extensionsResource,d={version:this.G.version,date:this.G.date}){return this.ab.scanExtensions(U??null,q,d)}scanAllUserInstalledExtensions(){return this.ab.scanAllUserExtensions(!1)}scanInstalledExtensionAtLocation(U){return this.ab.scanUserExtensionAtLocation(U)}async install(U,q={}){this.F.trace("ExtensionManagementService#install",U.toString());const{location:d,cleanup:E}=await this.kb(U);try{const z=await(0,j.$Dq)(v.$kc(d.fsPath)),M=(0,t.$Dp)(z.publisher,z.name);if(z.engines&&z.engines.vscode&&!(0,F.$Qp)(z.engines.vscode,this.G.version,this.G.date))throw new Error(m.localize(0,null,M,this.G.version));const W=(await this.I([{manifest:z,extension:d,options:q}])).find(({identifier:te})=>(0,t.$yp)(te,{id:M}));if(W?.local)return W.local;throw W?.error?W.error:(0,r.$qq)(new Error(`Unknown error while installing extension ${M}`))}finally{await E()}}async installFromLocation(U,q){this.F.trace("ExtensionManagementService#installFromLocation",U.toString());const d=await this.ab.scanUserExtensionAtLocation(U);if(!d||!d.manifest.name||!d.manifest.version)throw new Error(`Cannot find a valid extension from the location ${U.toString()}`);return await this.tb([[d,{source:"resource"}]],q),this.F.info("Successfully installed extension",d.identifier.id,q.toString()),d}async installExtensionsFromProfile(U,q,d){this.F.trace("ExtensionManagementService#installExtensionsFromProfile",U,q.toString(),d.toString());const E=(await this.getInstalled(1,q)).filter(z=>U.some(M=>(0,t.$yp)(M,z.identifier)));if(E.length){const z=await Promise.all(E.map(M=>this.ab.scanMetadata(M,q)));await this.tb(E.map((M,G)=>[M,z[G]]),d),this.F.info("Successfully installed extensions",E.map(M=>M.identifier.id),d.toString())}return E}async updateMetadata(U,q,d=this.H.defaultProfile.extensionsResource){return this.F.trace("ExtensionManagementService#updateMetadata",U.identifier.id),q.isPreReleaseVersion&&(q.preRelease=!0,q.hasPreReleaseVersion=!0),q.isMachineScoped===!1&&(q.isMachineScoped=void 0),q.isBuiltin===!1&&(q.isBuiltin=void 0),q.pinned===!1&&(q.pinned=void 0),U=await this.ab.updateMetadata(U,q,d),this.bb.invalidate(d),this.w.fire(U),U}async reinstallFromGallery(U){if(this.F.trace("ExtensionManagementService#reinstallFromGallery",U.identifier.id),!this.z.isEnabled())throw new Error(m.localize(1,null));const q=await this.getTargetPlatform(),[d]=await this.z.getExtensions([{...U.identifier,preRelease:U.preRelease}],{targetPlatform:q,compatible:!0},I.CancellationToken.None);if(!d)throw new Error(m.localize(2,null));await this.ab.setUninstalled(U);try{await this.ab.removeUninstalledExtension(U)}catch(E){throw new Error(m.localize(3,null,(0,L.$jj)(E)))}return this.installFromGallery(d)}$(U,q,d,E){return this.ab.copyExtension(U,q,d,E)}copyExtensions(U,q){return this.ab.copyExtensions(U,q,{version:this.G.version,date:this.G.date})}markAsUninstalled(...U){return this.ab.setUninstalled(...U)}async cleanUp(){this.F.trace("ExtensionManagementService#cleanUp");try{await this.ab.cleanUp()}catch(U){this.F.error(U)}}async download(U,q,d){const{location:E}=await this.cb.download(U,q,!d);return E}async kb(U){if(U.scheme===b.Schemas.file)return{location:U,async cleanup(){}};this.F.trace("Downloading extension from",U.toString());const q=(0,y.$_g)(this.cb.extensionsDownloadDir,(0,c.$Ug)());return await this.gb.download(U,q),this.F.info("Downloaded extension to",q.toString()),{location:q,cleanup:async()=>{try{await this.hb.del(q)}catch(E){this.F.error(E)}}}}X(){return this.H.defaultProfile.extensionsResource}Y(U,q,d){if(g.URI.isUri(q))return new Q(U,q,d,this.z,this.ab,this.D,this.H,this.eb,this.fb,this.F);const E=t.$zp.create(q).toString();let z=this.db.get(E);return z||(this.db.set(E,z=new H(U,q,d,this.cb,this.ab,this.D,this.H,this.eb,this.fb,this.F)),z.waitUntilTaskIsFinished().finally(()=>this.db.delete(E))),z}Z(U,q){return new Y(U,q.profileLocation,this.fb)}async ob(U){const q=async E=>{let z=await w.Promises.readdir(E);z=z.map(W=>v.$jc(E,W));const M=await Promise.all(z.map(W=>w.Promises.stat(W)));let G=Promise.resolve([]);return M.forEach((W,te)=>{const ae=z[te];W.isFile()&&(G=G.then(he=>[...he,ae])),W.isDirectory()&&(G=G.then(he=>q(ae).then(pe=>[...he,...pe])))}),G};return(await q(U.location.fsPath)).map(E=>({path:`extension/${v.$lc(U.location.fsPath,E)}`,localPath:E}))}async pb({added:U,removed:q}){if(q){const d=U&&this.D.extUri.isEqual(q.profileLocation,U.profileLocation)?q.extensions.filter(E=>U.extensions.every(z=>!(0,t.$yp)(z,E))):q.extensions;for(const E of d)this.F.info("Extensions removed from another source",E.id,q.profileLocation.toString()),this.u.fire({identifier:E,profileLocation:q.profileLocation})}if(U){const E=(await this.getInstalled(1,U.profileLocation)).filter(z=>U.extensions.some(M=>(0,t.$yp)(M,z.identifier)));this.s.fire(E.map(z=>(this.F.info("Extensions added from another source",z.identifier.id,U.profileLocation.toString()),{identifier:z.identifier,local:z,profileLocation:U.profileLocation,operation:1})))}}async rb(){this.B(this.ab.onExtract(q=>this.qb.add(q)));const U=await this.hb.resolve(this.eb.userExtensionsLocation);for(const q of U.children??[])q.isDirectory&&this.qb.add(q.resource);this.B(this.hb.watch(this.eb.userExtensionsLocation)),this.B(this.hb.onDidFilesChange(q=>this.sb(q)))}async sb(U){if(!U.affects(this.eb.userExtensionsLocation,1))return;const q=[];for(const d of U.rawAdded){if(this.qb.has(d)||!this.D.extUri.isEqual(this.D.extUri.dirname(d),this.eb.userExtensionsLocation)||this.D.extUri.isEqual(d,this.D.extUri.joinPath(this.eb.userExtensionsLocation,".obsolete"))||this.D.extUri.basename(d).startsWith(".")||!(await this.hb.stat(d)).isDirectory)continue;const E=await this.ab.scanUserExtensionAtLocation(d);E&&E.installedTimestamp===void 0&&(this.qb.add(d),q.push(E))}q.length&&(await this.tb(q.map(d=>[d,void 0]),this.H.defaultProfile.extensionsResource),this.F.info("Added extensions to default profile from external source",q.map(d=>d.identifier.id)))}async tb(U,q){const d=U.map(E=>E[0]);await this.ub(d),await this.fb.addExtensionsToProfile(U,q),this.s.fire(d.map(E=>({local:E,identifier:E.identifier,operation:1,profileLocation:q})))}async ub(U){const q=await this.ab.getUninstalledExtensions();for(const d of U){const E=t.$zp.create(d);q[E.toString()]&&(this.F.trace("Removing the extension from uninstalled list:",E.id),await this.ab.setInstalled(E),this.F.info("Removed the extension from uninstalled list:",E.id))}}};e.$Jq=Z,e.$Jq=Z=$e([oe(0,i.$0o),oe(1,ue.$4l),oe(2,ne.$5j),oe(3,n.$Gi),oe(4,o.$xq),oe(5,s.$tq),oe(6,f.$No),oe(7,J.$xi),oe(8,C.$5k),oe(9,ie.$lk),oe(10,le.$Cl),oe(11,ce.$El)],Z);let B=class extends a.$Uc{constructor(U,q,d,E,z,M){super(),this.j=U,this.m=q,this.n=d,this.s=E,this.t=z,this.u=M,this.h=this.B(new P.$fe),this.onExtract=this.h.event,this.c=(0,y.$_g)(this.n.userExtensionsLocation,".obsolete"),this.g=new A.$Fh}async cleanUp(){await this.H(),await this.G()}async scanExtensions(U,q,d){try{const E={includeInvalid:!0,profileLocation:q,productVersion:d};let z=[];return U===null||U===0?z.push(...await this.n.scanAllExtensions({includeInvalid:!0},E,!1)):U===1&&z.push(...await this.n.scanUserExtensions(E)),z=U!==null?z.filter(M=>M.type===U):z,await Promise.all(z.map(M=>this.F(M)))}catch(E){throw(0,r.$qq)(E,"Scanning")}}async scanAllUserExtensions(U){try{const q=await this.n.scanUserExtensions({includeAllVersions:!U,includeInvalid:!0});return await Promise.all(q.map(d=>this.F(d)))}catch(q){throw(0,r.$qq)(q,"Scanning")}}async scanUserExtensionAtLocation(U){try{const q=await this.n.scanExistingExtension(U,1,{includeInvalid:!0});if(q)return await this.F(q)}catch(q){this.u.error(q)}return null}async extractUserExtension(U,q,d,E,z){const M=U.toString(),G=g.URI.file(v.$jc(this.n.userExtensionsLocation.fsPath,`.${(0,c.$Ug)()}`)),W=g.URI.file(v.$jc(this.n.userExtensionsLocation.fsPath,M));let te=await this.m.exists(W);if(te&&E){try{await this.y(U.id,W,"removeExisting")}catch{throw new i.$_o(m.localize(4,null,W.fsPath,U.id),"Delete")}te=!1}if(te)try{await this.n.updateMetadata(W,d)}catch(ae){throw(0,r.$qq)(ae,"UpdateMetadata")}else try{try{this.u.trace(`Started extracting the extension from ${q} to ${W.fsPath}`),await(0,p.$nq)(q,G.fsPath,{sourcePath:"extension",overwrite:!0},z),this.u.info(`Extracted extension to ${W}:`,U.id)}catch(ae){throw(0,j.$Cq)(ae)}try{await this.n.updateMetadata(G,d)}catch(ae){throw(0,r.$qq)(ae,"UpdateMetadata")}try{this.u.trace(`Started renaming the extension from ${G.fsPath} to ${W.fsPath}`),await this.C(G.fsPath,W.fsPath),this.u.info("Renamed to",W.fsPath)}catch(ae){if(ae.code==="ENOTEMPTY")this.u.info("Rename failed because extension was installed by another source. So ignoring renaming.",U.id);else throw this.u.info(`Rename failed because of ${(0,N.$0)(ae)}. Deleted from extracted location`,G),ae}this.h.fire(W)}catch(ae){try{await this.m.del(G,{recursive:!0})}catch{}throw ae}return this.D(W,1)}async scanMetadata(U,q){return q?(await this.w(U,q))?.metadata:this.n.scanMetadata(U.location)}async w(U,q){return(await this.s.scanProfileExtensions(q)).find(E=>(0,t.$yp)(E.identifier,U.identifier))}async updateMetadata(U,q,d){try{d?await this.s.updateMetadata([[U,q]],d):await this.n.updateMetadata(U.location,q)}catch(E){throw(0,r.$qq)(E,"UpdateMetadata")}return this.D(U.location,U.type,d)}async getUninstalledExtensions(){try{return await this.z()}catch(U){throw(0,r.$qq)(U,"ReadUninstalled")}}async setUninstalled(...U){const q=U.map(d=>t.$zp.create(d));await this.z(d=>q.forEach(E=>{d[E.toString()]=!0,this.u.info("Marked extension as uninstalled",E.toString())}))}async setInstalled(U){try{await this.z(q=>delete q[U.toString()])}catch(q){throw(0,r.$qq)(q,"UnsetUninstalled")}}async removeExtension(U,q){if(this.t.extUri.isEqualOrParent(U.location,this.n.userExtensionsLocation))return this.y(U.identifier.id,U.location,q)}async removeUninstalledExtension(U){await this.removeExtension(U,"uninstalled"),await this.z(q=>delete q[t.$zp.create(U).toString()])}async copyExtension(U,q,d,E){const z=await this.w(U,q),M=await this.w(U,d);if(E={...z?.metadata,...E},M)if(this.t.extUri.isEqual(M.location,U.location))await this.s.updateMetadata([[U,{...M.metadata,...E}]],d);else{const G=await this.D(M.location,U.type,d);await this.s.removeExtensionFromProfile(G,d),await this.s.addExtensionsToProfile([[U,{...M.metadata,...E}]],d)}else await this.s.addExtensionsToProfile([[U,E]],d);return this.D(U.location,U.type,d)}async copyExtensions(U,q,d){const E=await this.scanExtensions(1,U,d),z=await Promise.all(E.filter(M=>!M.isApplicationScoped).map(async M=>[M,await this.scanMetadata(M,U)]));await this.s.addExtensionsToProfile(z,q)}async y(U,q,d){this.u.trace(`Deleting ${d} extension from disk`,U,q.fsPath);const E=this.t.extUri.joinPath(this.t.extUri.dirname(q),`${this.t.extUri.basename(q)}.${(0,l.$mj)((0,c.$Ug)()).toString(16)}${V}`);await this.C(q.fsPath,E.fsPath),await this.m.del(E,{recursive:!0}),this.u.info(`Deleted ${d} extension from disk`,U,q.fsPath)}z(U){return this.g.queue(async()=>{let q;try{q=(await this.m.readFile(this.c,"utf8")).value.toString()}catch(E){if((0,C.$jl)(E)!==1)throw E}let d={};if(q)try{d=JSON.parse(q)}catch{}return U&&(U(d),Object.keys(d).length?await this.m.writeFile(this.c,O.$He.fromString(JSON.stringify(d))):await this.m.del(this.c)),d})}async C(U,q){try{await w.Promises.rename(U,q,2*60*1e3)}catch(d){throw(0,r.$qq)(d,"Rename")}}async D(U,q,d){try{if(d){const z=(await this.n.scanUserExtensions({profileLocation:d})).find(M=>this.t.extUri.isEqual(M.location,U));if(z)return await this.F(z)}else{const E=await this.n.scanExistingExtension(U,q,{includeInvalid:!0});if(E)return await this.F(E)}throw new i.$_o(m.localize(5,null,U.path),"ScanningExtension")}catch(E){throw(0,r.$qq)(E,"ScanningExtension")}}async F(U){const q=await this.m.resolve(U.location);let d,E;return q.children&&(d=q.children.find(({name:z})=>/^readme(\.txt|\.md|)$/i.test(z))?.resource,E=q.children.find(({name:z})=>/^changelog(\.txt|\.md|)$/i.test(z))?.resource),{identifier:U.identifier,type:U.type,isBuiltin:U.isBuiltin||!!U.metadata?.isBuiltin,location:U.location,manifest:U.manifest,targetPlatform:U.targetPlatform,validations:U.validations,isValid:U.isValid,readmeUrl:d,changelogUrl:E,publisherDisplayName:U.metadata?.publisherDisplayName,publisherId:U.metadata?.publisherId||null,isApplicationScoped:!!U.metadata?.isApplicationScoped,isMachineScoped:!!U.metadata?.isMachineScoped,isPreReleaseVersion:!!U.metadata?.isPreReleaseVersion,hasPreReleaseVersion:!!U.metadata?.hasPreReleaseVersion,preRelease:!!U.metadata?.preRelease,installedTimestamp:U.metadata?.installedTimestamp,updated:!!U.metadata?.updated,pinned:!!U.metadata?.pinned,isWorkspaceScoped:!1,source:U.metadata?.source??(U.identifier.uuid?"gallery":"vsix")}}async G(){const U=await this.getUninstalledExtensions();if(Object.keys(U).length===0){this.u.debug("No uninstalled extensions found.");return}this.u.debug("Removing uninstalled extensions:",Object.keys(U));const q=await this.n.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),d=new Set;for(const z of q)U[t.$zp.create(z).toString()]||d.add(z.identifier.id.toLowerCase());try{const z=(0,t.$Ep)(q,M=>M.identifier);await A.Promises.settled(z.map(async M=>{const G=M.sort((W,te)=>$.rcompare(W.manifest.version,te.manifest.version))[0];d.has(G.identifier.id.toLowerCase())||await this.j(await this.F(G))}))}catch(z){this.u.error(z)}const E=q.filter(z=>z.metadata&&U[t.$zp.create(z).toString()]);await Promise.allSettled(E.map(z=>this.removeUninstalledExtension(z)))}async H(){this.u.trace("ExtensionManagementService#removeTempDeleteFolders");let U;try{U=await this.m.resolve(this.n.userExtensionsLocation)}catch(q){(0,C.$jl)(q)!==1&&this.u.error(q);return}if(U?.children)try{await Promise.allSettled(U.children.map(async q=>{if(!(!q.isDirectory||!q.name.endsWith(V))){this.u.trace("Deleting the temporarily deleted folder",q.resource.toString());try{await this.m.del(q.resource,{recursive:!0}),this.u.trace("Deleted the temporarily deleted folder",q.resource.toString())}catch(d){(0,C.$jl)(d)!==1&&this.u.error(d)}}}))}catch{}}};e.$Kq=B,e.$Kq=B=$e([oe(1,C.$5k),oe(2,o.$xq),oe(3,s.$tq),oe(4,le.$Cl),oe(5,ne.$5j)],B);class T extends r.$rq{get profileLocation(){return this.j}get verificationStatus(){return this.k}get operation(){return(0,R.$fg)(this.options.operation)?this.l:this.options.operation}constructor(U,q,d,E,z,M,G,W,te,ae){super(),this.manifest=U,this.identifier=q,this.source=d,this.options=E,this.m=z,this.n=M,this.o=G,this.p=W,this.q=te,this.s=ae,this.j=this.options.profileLocation,this.k=!1,this.l=2}async h(U){const[q,d]=await this.w(U);if(this.j=q.isBuiltin||q.isApplicationScoped?this.o.defaultProfile.extensionsResource:this.options.profileLocation,this.n.extUri.isEqual(this.o.defaultProfile.extensionsResource,this.j))try{await this.p.initializeDefaultProfileExtensions()}catch(E){throw(0,r.$qq)(E,"IntializeDefaultProfile")}try{await this.q.addExtensionsToProfile([[q,d]],this.j,!q.isValid)}catch(E){throw(0,r.$qq)(E,"AddToProfile")}return q}async u({zipPath:U,key:q,metadata:d},E,z){let M=await this.v(q);return M?M=await this.m.updateMetadata(M,d):(this.s.trace("Extracting extension...",q.id),M=await this.m.extractUserExtension(q,U,d,E,z),this.s.info("Extracting extension completed.",q.id)),M}async v(U){return(await this.m.getUninstalledExtensions())[U.toString()]?(this.s.trace("Removing the extension from uninstalled list:",U.id),await this.m.setInstalled(U),this.s.info("Removed the extension from uninstalled list:",U.id),(await this.m.scanAllUserExtensions(!0)).find(E=>t.$zp.create(E).equals(U))):void 0}}class H extends T{constructor(U,q,d,E,z,M,G,W,te,ae){super(U,q.identifier,q,d,z,M,G,W,te,ae),this.x=q,this.y=E}async w(U){const d=(await this.m.scanExtensions(null,this.options.profileLocation,this.options.productVersion)).find(G=>(0,t.$yp)(G.identifier,this.x.identifier));d&&(this.l=3);const E={id:this.x.identifier.uuid,publisherId:this.x.publisherId,publisherDisplayName:this.x.publisherDisplayName,targetPlatform:this.x.properties.targetPlatform,isApplicationScoped:this.options.isApplicationScoped||d?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||d?.isMachineScoped,isBuiltin:this.options.isBuiltin||d?.isBuiltin,isSystem:d?.type===0?!0:void 0,updated:!!d,isPreReleaseVersion:this.x.properties.isPreReleaseVersion,hasPreReleaseVersion:d?.hasPreReleaseVersion||this.x.properties.isPreReleaseVersion,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??d?.pinned,preRelease:(0,R.$eg)(this.options.preRelease)?this.options.preRelease:this.options.installPreReleaseVersion||this.x.properties.isPreReleaseVersion||d?.preRelease,source:"gallery"};if(d&&d.type!==0&&d.manifest.version===this.x.version)return[await this.m.updateMetadata(d,E),E];const{verificationStatus:z,location:M}=await this.y.download(this.x,this.l,!this.options.donotVerifySignature,this.options.context?.[i.$3o]);try{return this.k=z,await this.A(M.fsPath),[await this.u({zipPath:M.fsPath,key:t.$zp.create(this.x),metadata:E},!1,U),E]}catch(G){try{await this.y.delete(M)}catch(W){this.s.warn("Error while deleting the downloaded file",M.toString(),(0,N.$0)(W))}throw G}}async A(U){await(0,j.$Dq)(U)}}e.$Lq=H;class Q extends T{constructor(U,q,d,E,z,M,G,W,te,ae){super(U,{id:(0,t.$Dp)(U.publisher,U.name)},q,d,z,M,G,W,te,ae),this.x=q,this.y=E}async h(U){const q=await super.h(U);return this.B(q,U),q}async w(U){const q=new t.$zp(this.identifier,this.manifest.version),E=(await this.m.scanExtensions(1,this.options.profileLocation,this.options.productVersion)).find(G=>(0,t.$yp)(this.identifier,G.identifier)),z={isApplicationScoped:this.options.isApplicationScoped||E?.isApplicationScoped,isMachineScoped:this.options.isMachineScoped||E?.isMachineScoped,isBuiltin:this.options.isBuiltin||E?.isBuiltin,installedTimestamp:Date.now(),pinned:this.options.installGivenVersion?!0:this.options.pinned??E?.pinned,source:"vsix"};if(E)if(this.l=3,q.equals(new t.$zp(E.identifier,E.manifest.version)))try{await this.m.removeExtension(E,"existing")}catch{throw new Error(m.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&$.gt(E.manifest.version,this.manifest.version)&&await this.m.setUninstalled(E);else{const G=await this.v(q);if(G)try{await this.m.removeExtension(G,"existing")}catch{throw new Error(m.localize(7,null,this.manifest.displayName||this.manifest.name))}}return[await this.u({zipPath:v.$kc(this.x.fsPath),key:q,metadata:z},!0,U),z]}async B(U,q){try{let[d]=await this.y.getExtensions([{id:U.identifier.id,version:U.manifest.version}],q);if(d||([d]=await this.y.getExtensions([{id:U.identifier.id}],q)),d){const E={id:d.identifier.uuid,publisherDisplayName:d.publisherDisplayName,publisherId:d.publisherId,isPreReleaseVersion:d.properties.isPreReleaseVersion,hasPreReleaseVersion:U.hasPreReleaseVersion||d.properties.isPreReleaseVersion,preRelease:d.properties.isPreReleaseVersion||this.options.installPreReleaseVersion};await this.m.updateMetadata(U,E,this.options.profileLocation)}}catch{}}}class Y extends r.$rq{constructor(U,q,d){super(),this.extension=U,this.j=q,this.k=d}async h(U){await this.k.removeExtensionFromProfile(this.extension,this.j)}}}),define(se[163],re([0,1,6,24,23,21,42,13,18,11]),function(X,e,A,O,I,L,N,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cQ=void 0;let h=class extends N.$uq{constructor(v,y,$,R,g,c){super(a.URI.file(v.extensionsPath),y,$,R,g,c)}};e.$cQ=h,e.$cQ=h=$e([oe(0,l.$Gi),oe(1,P.$5k),oe(2,O.$El),oe(3,I.$Cl),oe(4,L.$4l),oe(5,A.$5j)],h)}),define(se[164],re([0,1,11,18,42,54,13,10,6,32,23,24]),function(X,e,A,O,I,L,N,P,l,a,h,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eec=void 0;let v=class extends L.$Bq{constructor($,R,g,c,w,p,m,f){super(A.URI.file(w.builtinExtensionsPath),A.URI.file(w.extensionsPath),w.userHome,$.defaultProfile,$,R,g,c,w,p,m,f)}};e.$eec=v,e.$eec=v=$e([oe(0,b.$El),oe(1,I.$tq),oe(2,N.$5k),oe(3,l.$5j),oe(4,O.$Gi),oe(5,a.$lk),oe(6,h.$Cl),oe(7,P.$xi)],v)}),define(se[165],re([0,1,8,5,2,131,3,92,10,24]),function(X,e,A,O,I,L,N,P,l,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$7p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$5p=e.$4p=e.$3p=void 0,e.$6p=y,e.$8p=R,e.$0p=c,e.$3p="__$__isNewStorageMarker",e.$4p="__$__targetStorageMarker",e.$5p=(0,l.$yi)("storageService");var h;(function(w){w[w.NONE=0]="NONE",w[w.SHUTDOWN=1]="SHUTDOWN"})(h||(e.WillSaveStateReason=h={}));var b;(function(w){w[w.APPLICATION=-1]="APPLICATION",w[w.PROFILE=0]="PROFILE",w[w.WORKSPACE=1]="WORKSPACE"})(b||(e.StorageScope=b={}));var v;(function(w){w[w.USER=0]="USER",w[w.MACHINE=1]="MACHINE"})(v||(e.StorageTarget=v={}));function y(w){const p=w.get(e.$4p);if(p)try{return JSON.parse(p)}catch{}return Object.create(null)}class $ extends I.$Uc{static{this.a=60*1e3}constructor(p={flushInterval:$.a}){super(),this.m=p,this.b=this.B(new O.$ie),this.c=this.B(new O.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new O.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new A.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new I.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(p,m,f){return O.Event.filter(this.b.event,n=>n.scope===p&&(m===void 0||n.key===m),f)}n(){this.j.value=(0,A.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,I.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.O()}finally{(0,L.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(p,m){const{key:f,external:n}=m;if(f===e.$4p){switch(p){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:p})}else this.b.fire({scope:p,key:f,target:this.J(p)[f],external:n})}w(p){this.f.fire({reason:p})}get(p,m,f){return this.P(m)?.get(p,f)}getBoolean(p,m,f){return this.P(m)?.getBoolean(p,f)}getNumber(p,m,f){return this.P(m)?.getNumber(p,f)}getObject(p,m,f){return this.P(m)?.getObject(p,f)}storeAll(p,m){this.y(()=>{for(const f of p)this.store(f.key,f.value,f.scope,f.target,m)})}store(p,m,f,n,r=!1){if((0,N.$hg)(m)){this.remove(p,f,r);return}this.y(()=>{this.z(p,f,n),this.P(f)?.set(p,m,r)})}remove(p,m,f=!1){this.y(()=>{this.z(p,m,void 0),this.P(m)?.delete(p,f)})}y(p){this.b.pause(),this.c.pause();try{p()}finally{this.b.resume(),this.c.resume()}}keys(p,m){const f=[],n=this.J(p);for(const r of Object.keys(n))n[r]===m&&f.push(r);return f}z(p,m,f,n=!1){const r=this.J(m);typeof f=="number"?r[p]!==f&&(r[p]=f,this.P(m)?.set(e.$4p,JSON.stringify(r),n)):typeof r[p]=="number"&&(delete r[p],this.P(m)?.set(e.$4p,JSON.stringify(r),n))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(p){switch(p){case-1:return this.I;case 0:return this.G;default:return this.D}}L(p){const m=this.P(p);return m?y(m):Object.create(null)}isNew(p){return this.getBoolean(e.$3p,p)===!0}async flush(p=h.NONE){this.f.fire({reason:p});const m=this.P(-1),f=this.P(0),n=this.P(1);switch(p){case h.NONE:await A.Promises.settled([m?.whenFlushed()??Promise.resolve(),f?.whenFlushed()??Promise.resolve(),n?.whenFlushed()??Promise.resolve()]);break;case h.SHUTDOWN:await A.Promises.settled([m?.flush(0)??Promise.resolve(),f?.flush(0)??Promise.resolve(),n?.flush(0)??Promise.resolve()]);break}}async log(){const p=this.P(-1)?.items??new Map,m=this.P(0)?.items??new Map,f=this.P(1)?.items??new Map;return c(p,m,f,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(p){return await this.flush(),this.P(p)?.optimize()}async switch(p,m){return this.w(h.NONE),(0,a.$Dl)(p)?this.R(p,m):this.S(p,m)}M(p,m){return!(p.id===m.id||R(m)&&R(p))}N(p,m,f){this.y(()=>{const n=new Set;for(const[r,i]of p)n.add(r),m.get(r)!==i&&this.u(f,{key:r,external:!0});for(const[r]of m.items)n.has(r)||this.u(f,{key:r,external:!0})})}}e.$7p=$;function R(w){return w.isDefault||!!w.useDefaultFlags?.globalState}class g extends ${constructor(){super(),this.U=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new P.$1p(new P.$2p,{hint:P.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(p=>this.u(1,p))),this.B(this.W.onDidChangeStorage(p=>this.u(0,p))),this.B(this.U.onDidChangeStorage(p=>this.u(-1,p)))}P(p){switch(p){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(p){switch(p){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(p){return!1}}e.$9p=g;async function c(w,p,m,f,n,r){const i=F=>{try{return JSON.parse(F)}catch{return F}},t=new Map,s=new Map;w.forEach((F,C)=>{t.set(C,F),s.set(C,i(F))});const o=new Map,u=new Map;p.forEach((F,C)=>{o.set(C,F),u.set(C,i(F))});const S=new Map,j=new Map;m.forEach((F,C)=>{S.set(C,F),j.set(C,i(F))}),console.group(f!==n?`Storage: Application (path: ${f})`:`Storage: Application & Profile (path: ${f}, default profile)`);const k=[];if(t.forEach((F,C)=>{k.push({key:C,value:F})}),console.table(k),console.groupEnd(),console.log(s),f!==n){console.group(`Storage: Profile (path: ${n}, profile specific)`);const F=[];o.forEach((C,J)=>{F.push({key:J,value:C})}),console.table(F),console.groupEnd(),console.log(u)}console.group(`Storage: Workspace (path: ${r})`);const D=[];S.forEach((F,C)=>{D.push({key:C,value:F})}),console.table(D),console.groupEnd(),console.log(j)}}),define(se[166],re([0,1,19,22,9,12,35,3,11,29,18,20,26,50,13,6,32,45,149,165,21,178]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w,p,m,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cq=e.$bq=void 0,e.$aq=Q;const n=L.$o?"web":(0,b.$6o)(L.$u,N.$ec),r="X-Market-Search-Activity-Id";var i;(function(E){E[E.None=0]="None",E[E.IncludeVersions=1]="IncludeVersions",E[E.IncludeFiles=2]="IncludeFiles",E[E.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",E[E.IncludeSharedAccounts=8]="IncludeSharedAccounts",E[E.IncludeVersionProperties=16]="IncludeVersionProperties",E[E.ExcludeNonValidated=32]="ExcludeNonValidated",E[E.IncludeInstallationTargets=64]="IncludeInstallationTargets",E[E.IncludeAssetUri=128]="IncludeAssetUri",E[E.IncludeStatistics=256]="IncludeStatistics",E[E.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",E[E.Unpublished=4096]="Unpublished",E[E.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function t(...E){return String(E.reduce((z,M)=>z|M,0))}var s;(function(E){E[E.Tag=1]="Tag",E[E.ExtensionId=4]="ExtensionId",E[E.Category=5]="Category",E[E.ExtensionName=7]="ExtensionName",E[E.Target=8]="Target",E[E.Featured=9]="Featured",E[E.SearchText=10]="SearchText",E[E.ExcludeWithFlags=12]="ExcludeWithFlags"})(s||(s={}));const o={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source",Signature:"Microsoft.VisualStudio.Services.VsixSignature"},u={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink",SupportLink:"Microsoft.VisualStudio.Services.Links.Support"},j={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class k{constructor(z=j){this.d=z}get pageNumber(){return this.d.pageNumber}get pageSize(){return this.d.pageSize}get sortBy(){return this.d.sortBy}get sortOrder(){return this.d.sortOrder}get flags(){return this.d.flags}get criteria(){return this.d.criteria}withPage(z,M=this.d.pageSize){return new k({...this.d,pageNumber:z,pageSize:M})}withFilter(z,...M){const G=[...this.d.criteria,...M.length?M.map(W=>({filterType:z,value:W})):[{filterType:z}]];return new k({...this.d,criteria:G})}withSortBy(z){return new k({...this.d,sortBy:z})}withSortOrder(z){return new k({...this.d,sortOrder:z})}withFlags(...z){return new k({...this.d,flags:z.reduce((M,G)=>M|G,0)})}withAssetTypes(...z){return new k({...this.d,assetTypes:z})}withSource(z){return new k({...this.d,source:z})}get raw(){const{criteria:z,pageNumber:M,pageSize:G,sortBy:W,sortOrder:te,flags:ae,assetTypes:he}=this.d;return{filters:[{criteria:z,pageNumber:M,pageSize:G,sortBy:W,sortOrder:te}],assetTypes:he,flags:ae}}get searchText(){const z=this.d.criteria.filter(M=>M.filterType===s.SearchText)[0];return z&&z.value?z.value:""}get telemetryData(){return{filterTypes:this.d.criteria.map(z=>String(z.filterType)),flags:this.d.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.d.source,searchTextLength:this.searchText.length}}}function D(E,z){const M=(E||[]).filter(G=>G.statisticName===z)[0];return M?M.value:0}function F(E){const z="Microsoft.VisualStudio.Code.Translation.";return E.files.filter(G=>G.assetType.indexOf(z)===0).reduce((G,W)=>{const te=ne(E,W.assetType);return te&&G.push([W.assetType.substring(z.length),te]),G},[])}function C(E){if(E.properties){const z=E.properties.filter(W=>W.key===o.Repository),M=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),G=z.filter(W=>M.test(W.value))[0];return G?{uri:G.value,fallbackUri:G.value}:null}return ne(E,o.Repository)}function J(E){return{uri:`${E.fallbackAssetUri}/${o.VSIX}?redirect=true${E.targetPlatform?`&targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${o.VSIX}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}}function ne(E,z){return E.files.filter(G=>G.assetType===z)[0]?{uri:`${E.assetUri}/${z}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`,fallbackUri:`${E.fallbackAssetUri}/${z}${E.targetPlatform?`?targetPlatform=${E.targetPlatform}`:""}`}:null}function ie(E,z){const M=E.properties?E.properties.filter(W=>W.key===z):[],G=M.length>0&&M[0].value;return G?G.split(",").map(W=>(0,v.$Cp)(W)):[]}function ue(E){const z=E.properties?E.properties.filter(M=>M.key===u.Engine):[];return z.length>0&&z[0].value||""}function le(E){const z=E.properties?E.properties.filter(M=>M.key===u.PreRelease):[];return z.length>0&&z[0].value==="true"}function ce(E){const z=E.properties?E.properties.filter(G=>G.key===u.LocalizedLanguages):[],M=z.length>0&&z[0].value||"";return M?M.split(","):[]}function V(E){return E.properties?.find(z=>z.key===u.SponsorLink)?.value}function Z(E){return E.properties?.find(z=>z.key===u.SupportLink)?.value}function B(E){return E.indexOf("preview")!==-1}function T(E){return E.targetPlatform?(0,b.$5o)(E.targetPlatform):"undefined"}function H(E){const z=(0,A.$Mb)(E.versions.map(T)),M=!!E.tags?.includes(b.$Yo),G=z.indexOf("web");return M?G===-1&&z.push("web"):G!==-1&&z.splice(G,1),z}function Q(E,z){for(let M=0;M<E.length;M++){const G=E[M];if(G.version===E[M-1]?.version){let W=M;if(T(G)===z)for(;W>0&&E[W-1].version===G.version;)W--;W!==M&&(E.splice(M,1),E.splice(W,0,G))}}return E}function Y(E,z,M){E.telemetryData={index:z,querySource:M,queryActivityId:E.queryContext?.[r]}}function _(E,z,M,G){const W=E.versions[0],te={manifest:ne(z,o.Manifest),readme:ne(z,o.Details),changelog:ne(z,o.Changelog),license:ne(z,o.License),repository:C(z),download:J(z),icon:ne(z,o.Icon),signature:ne(z,o.Signature),coreTranslations:F(z)};return{type:"gallery",identifier:{id:(0,v.$Dp)(E.publisher.publisherName,E.extensionName),uuid:E.extensionId},name:E.extensionName,version:z.version,displayName:E.displayName,publisherId:E.publisher.publisherId,publisher:E.publisher.publisherName,publisherDisplayName:E.publisher.displayName,publisherDomain:E.publisher.domain?{link:E.publisher.domain,verified:!!E.publisher.isDomainVerified}:void 0,publisherSponsorLink:V(W),description:E.shortDescription??"",installCount:D(E.statistics,"install"),rating:D(E.statistics,"averagerating"),ratingCount:D(E.statistics,"ratingcount"),categories:E.categories||[],tags:E.tags||[],releaseDate:Date.parse(E.releaseDate),lastUpdated:Date.parse(E.lastUpdated),allTargetPlatforms:M,assets:te,properties:{dependencies:ie(z,u.Dependency),extensionPack:ie(z,u.ExtensionPack),engine:ue(z),localizedLanguages:ce(z),targetPlatform:T(z),isPreReleaseVersion:le(z)},hasPreReleaseVersion:le(W),hasReleaseVersion:!0,preview:B(E.flags),isSigned:!!te.signature,queryContext:G,supportLink:Z(W)}}let U=class{constructor(z,M,G,W,te,ae,he,pe){this.k=M,this.l=G,this.n=W,this.o=te,this.q=ae,this.u=he,this.w=pe;const ye=he.extensionsGallery,fe=ye?.servicePPEUrl&&pe.getValue("_extensionsGallery.enablePPE");this.d=fe?ye.servicePPEUrl:ye?.serviceUrl,this.g=fe?void 0:ye?.searchUrl,this.h=ye?.controlUrl,this.j=(0,w.$_p)(he.version,he,this.n,this.w,this.q,z,this.o)}x(z=""){return`${this.d}${z}`}isEnabled(){return!!this.d}async getExtensions(z,M,G){const W=O.CancellationToken.isCancellationToken(M)?{}:M,te=O.CancellationToken.isCancellationToken(M)?M:G,ae=[],he=[],pe=[],ye=[];let fe=!0;for(const we of z){we.uuid?he.push(we.uuid):ae.push(we.id);const Ee=!!(we.version||we.preRelease);pe.push({id:we.id,uuid:we.uuid,includePreRelease:Ee}),we.version&&ye.push({id:we.id,uuid:we.uuid,version:we.version}),fe=fe&&!!we.hasPreRelease&&!Ee}if(!he.length&&!ae.length)return[];let me=new k().withPage(1,z.length);he.length&&(me=me.withFilter(s.ExtensionId,...he)),ae.length&&(me=me.withFilter(s.ExtensionName,...ae)),(W.queryAllVersions||fe)&&(me=me.withFlags(me.flags,i.IncludeVersions)),W.source&&(me=me.withSource(W.source));const{extensions:de}=await this.z(me,{targetPlatform:W.targetPlatform??n,includePreRelease:pe,versions:ye,compatible:!!W.compatible,productVersion:W.productVersion??{version:this.u.version,date:this.u.date}},te);return W.source&&de.forEach((we,Ee)=>Y(we,Ee,W.source)),de}async getCompatibleExtension(z,M,G,W={version:this.u.version,date:this.u.date}){if((0,b.$7o)(z.allTargetPlatforms,G))return null;if(await this.isExtensionCompatible(z,M,G))return z;const te=new k().withFlags(i.IncludeVersions).withPage(1,1).withFilter(s.ExtensionId,z.identifier.uuid),{extensions:ae}=await this.z(te,{targetPlatform:G,compatible:!0,includePreRelease:M,productVersion:W},O.CancellationToken.None);return ae[0]||null}async isExtensionCompatible(z,M,G,W={version:this.u.version,date:this.u.date}){if(!(0,b.$8o)(z.properties.targetPlatform,z.allTargetPlatforms,G)||!M&&z.properties.isPreReleaseVersion)return!1;let te=z.properties.engine;if(!te){const ae=await this.getManifest(z,O.CancellationToken.None);if(!ae)throw new Error("Manifest was not found");te=ae.engines.vscode}return(0,y.$Qp)(te,W.version,W.date)}async y(z,M,G,W,te,ae,he={version:this.u.version,date:this.u.date}){if(!(0,b.$8o)(T(M),te,ae)||G!=="any"&&le(M)!==(G==="prerelease"))return!1;if(W)try{const pe=await this.E(z,M);if(!(0,y.$Qp)(pe,he.version,he.date))return!1}catch(pe){return this.l.error(`Error while getting the engine for the version ${M.version}.`,(0,I.$0)(pe)),!1}return!0}async query(z,M){let G=z.text||"";const W=z.pageSize??50;let te=new k().withPage(1,W);G?(G=G.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Category,de||me),"")),G=G.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(fe,me,de)=>(te=te.withFilter(s.Tag,de||me),"")),G=G.replace(/\bfeatured(\s+|\b|$)/g,()=>(te=te.withFilter(s.Featured),"")),G=G.trim(),G&&(G=G.length<200?G:G.substring(0,200),te=te.withFilter(s.SearchText,G)),te=te.withSortBy(0)):z.ids?te=te.withFilter(s.ExtensionId,...z.ids):z.names?te=te.withFilter(s.ExtensionName,...z.names):te=te.withSortBy(4),typeof z.sortBy=="number"&&(te=te.withSortBy(z.sortBy)),typeof z.sortOrder=="number"&&(te=te.withSortOrder(z.sortOrder)),z.source&&(te=te.withSource(z.source));const ae=async(fe,me)=>{const{extensions:de,total:we}=await this.z(fe,{targetPlatform:n,compatible:!1,includePreRelease:!!z.includePreRelease,productVersion:z.productVersion??{version:this.u.version,date:this.u.date}},me);return de.forEach((Ee,Ie)=>Y(Ee,(fe.pageNumber-1)*fe.pageSize+Ie,z.source)),{extensions:de,total:we}},{extensions:he,total:pe}=await ae(te,M),ye=async(fe,me)=>{if(me.isCancellationRequested)throw new I.$5;const{extensions:de}=await ae(te.withPage(fe+1),me);return de};return{firstPage:he,total:pe,pageSize:te.pageSize,getPage:ye}}async z(z,M,G){const W=z.flags;z.flags&i.IncludeLatestVersionOnly&&z.flags&i.IncludeVersions&&(z=z.withFlags(z.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(z.flags&i.IncludeLatestVersionOnly)&&!(z.flags&i.IncludeVersions)&&(z=z.withFlags(z.flags,i.IncludeLatestVersionOnly)),M.versions?.length&&(z=z.withFlags(z.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),z=z.withFlags(z.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:te,total:ae,context:he}=await this.B(z,G);if(!(z.flags&i.IncludeLatestVersionOnly)){const me=[];for(const de of te){const we=await this.A(de,M,he);we&&me.push(we)}return{extensions:me,total:ae}}const ye=[],fe=new Map;for(let me=0;me<te.length;me++){const de=te[me],we={id:(0,v.$Dp)(de.publisher.publisherName,de.extensionName),uuid:de.extensionId},Ee=(0,P.$eg)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(x=>(0,v.$yp)(x,we))?.includePreRelease;if(M.compatible&&(0,b.$7o)(H(de),M.targetPlatform))continue;const Ie=await this.A(de,M,he);!Ie||Ie.properties.isPreReleaseVersion&&(!Ee||!Ie.hasReleaseVersion)||!Ie.properties.isPreReleaseVersion&&Ie.properties.targetPlatform!==M.targetPlatform&&Ie.hasPreReleaseVersion?fe.set(de.extensionId,me):ye.push([me,Ie])}if(fe.size){const me=new f.$be,de=new k().withFlags(W&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,fe.size).withFilter(s.ExtensionId,...fe.keys()),{extensions:we}=await this.z(de,M,G);this.o.publicLog2("galleryService:additionalQuery",{duration:me.elapsed(),count:fe.size});for(const Ee of we){const Ie=fe.get(Ee.identifier.uuid);ye.push([Ie,Ee])}}return{extensions:ye.sort((me,de)=>me[0]-de[0]).map(([,me])=>me),total:ae}}async A(z,M,G){const W={id:(0,v.$Dp)(z.publisher.publisherName,z.extensionName),uuid:z.extensionId},te=M.versions?.find(ye=>(0,v.$yp)(ye,W))?.version,ae=(0,P.$eg)(M.includePreRelease)?M.includePreRelease:!!M.includePreRelease.find(ye=>(0,v.$yp)(ye,W))?.includePreRelease,he=H(z),pe=Q(z.versions,M.targetPlatform);if(M.compatible&&(0,b.$7o)(he,M.targetPlatform))return null;for(let ye=0;ye<pe.length;ye++){const fe=pe[ye];if(!(te&&fe.version!==te)){if(await this.y((0,v.$Dp)(z.publisher.publisherName,z.extensionName),fe,ae?"any":"release",M.compatible,he,M.targetPlatform,M.productVersion))return _(z,fe,he,G);if(te&&fe.version===te)return null}}return te||M.compatible?null:_(z,z.versions[0],he)}async B(z,M){if(!this.isEnabled())throw new Error("No extension gallery service configured.");z=z.withFlags(z.flags,i.ExcludeNonValidated).withFilter(s.Target,"Microsoft.VisualStudio.Code").withFilter(s.ExcludeWithFlags,t(i.Unpublished));const G=await this.j,W=JSON.stringify(z.raw),te={...G,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(W.length)},ae=new f.$be;let he,pe,ye=0;try{if(he=await this.k.request({type:"POST",url:this.g&&z.criteria.some(me=>me.filterType===s.SearchText)?this.g:this.x("/extensionquery"),data:W,headers:te},M),he.res.statusCode&&he.res.statusCode>=400&&he.res.statusCode<500)return{galleryExtensions:[],total:ye};const fe=await(0,c.$Xp)(he);if(fe){const me=fe.results[0],de=me.extensions,we=me.resultMetadata&&me.resultMetadata.filter(Ee=>Ee.metadataType==="ResultCount")[0];return ye=we&&we.metadataItems.filter(Ee=>Ee.name==="TotalCount")[0].count||0,{galleryExtensions:de,total:ye,context:{[r]:he.res.headers.activityid}}}return{galleryExtensions:[],total:ye}}catch(fe){const me=(0,I.$4)(fe)?"Cancelled":(0,I.$0)(fe).startsWith("XHR timeout")?"Timeout":"Failed";throw pe=new b.$$o((0,I.$0)(fe),me),pe}finally{this.o.publicLog2("galleryService:query",{...z.telemetryData,requestBodySize:String(W.length),duration:ae.elapsed(),success:!!he&&(0,c.$Tp)(he),responseBodySize:he?.res.headers["Content-Length"],statusCode:he?String(he.res.statusCode):void 0,errorCode:pe?.code,count:String(ye)})}}async reportStatistic(z,M,G,W){if(!this.isEnabled())return;const te=L.$o?this.x(`/itemName/${z}.${M}/version/${G}/statType/${W==="install"?"1":"3"}/vscodewebextension`):this.x(`/publishers/${z}/extensions/${M}/${G}/stats?statType=${W}`),ae=L.$o?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.j,Accept:ae};try{await this.k.request({type:"POST",url:te,headers:pe},O.CancellationToken.None)}catch{}}async download(z,M,G){this.l.trace("ExtensionGalleryService#download",z.identifier.id);const W=(0,v.$Gp)(z),te=new Date().getTime(),ae=G===2?"install":G===3?"update":"",he=ae?{uri:`${z.assets.download.uri}${l.URI.parse(z.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${z.assets.download.fallbackUri}${l.URI.parse(z.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:z.assets.download,pe=z.queryContext?.[r]?{[r]:z.queryContext[r]}:void 0,ye=await this.D(z.identifier.id,he,o.VSIX,pe?{headers:pe}:void 0);try{await this.q.writeFile(M,ye.stream)}catch(fe){try{await this.q.del(M)}catch(me){this.l.warn(`Error while deleting the file ${M.toString()}`,(0,I.$0)(me))}throw new b.$$o((0,I.$0)(fe),"DownloadFailedWriting")}this.o.publicLog("galleryService:downloadVSIX",{...W,duration:new Date().getTime()-te})}async downloadSignatureArchive(z,M){if(!z.assets.signature)throw new Error("No signature asset found");this.l.trace("ExtensionGalleryService#downloadSignatureArchive",z.identifier.id);const G=await this.D(z.identifier.id,z.assets.signature,o.Signature);try{await this.q.writeFile(M,G.stream)}catch(W){try{await this.q.del(M)}catch(te){this.l.warn(`Error while deleting the file ${M.toString()}`,(0,I.$0)(te))}throw new b.$$o((0,I.$0)(W),"DownloadFailedWriting")}}async getReadme(z,M){if(z.assets.readme){const G=await this.D(z.identifier.id,z.assets.readme,o.Details,{},M);return await(0,c.$Wp)(G)||""}return""}async getManifest(z,M){if(z.assets.manifest){const G=await this.D(z.identifier.id,z.assets.manifest,o.Manifest,{},M),W=await(0,c.$Wp)(G);return W?JSON.parse(W):null}return null}async C(z,M,G){const W=ne(M,o.Manifest);if(!W)throw new Error("Manifest was not found");const te={"Accept-Encoding":"gzip"},ae=await this.D(z,W,o.Manifest,{headers:te});return await(0,c.$Xp)(ae)}async getCoreTranslation(z,M){const G=z.assets.coreTranslations.filter(W=>W[0]===M.toUpperCase())[0];if(G){const W=await this.D(z.identifier.id,G[1],G[0]),te=await(0,c.$Wp)(W);return te?JSON.parse(te):null}return null}async getChangelog(z,M){if(z.assets.changelog){const G=await this.D(z.identifier.id,z.assets.changelog,o.Changelog,{},M);return await(0,c.$Wp)(G)||""}return""}async getAllCompatibleVersions(z,M,G){let W=new k().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);z.identifier.uuid?W=W.withFilter(s.ExtensionId,z.identifier.uuid):W=W.withFilter(s.ExtensionName,z.identifier.id);const{galleryExtensions:te}=await this.B(W,O.CancellationToken.None);if(!te.length)return[];const ae=H(te[0]);if((0,b.$7o)(ae,G))return[];const he=[];await Promise.all(te[0].versions.map(async fe=>{try{await this.y(z.identifier.id,fe,M?"any":"release",!0,ae,G)&&he.push(fe)}catch{}}));const pe=[],ye=new Set;for(const fe of Q(he,G))ye.has(fe.version)||(ye.add(fe.version),pe.push({version:fe.version,date:fe.lastUpdated,isPreReleaseVersion:le(fe)}));return pe}async D(z,M,G,W={},te=O.CancellationToken.None){const ae=await this.j,he={type:"GET"},pe={...ae,...W.headers||{}};W={...W,...he,headers:pe};const ye=M.uri,fe=M.fallbackUri,me={...W,url:ye};try{const de=await this.k.request(me,te);if(de.res.statusCode===200)return de;const we=await(0,c.$Wp)(de);throw new Error(`Expected 200, got back ${de.res.statusCode} instead.

${we}`)}catch(de){if((0,I.$4)(de))throw de;const we=(0,I.$0)(de);this.o.publicLog2("galleryService:cdnFallback",{extension:z,assetType:G,message:we});const Ee={...W,url:fe};return this.k.request(Ee,te)}}async E(z,M){let G=ue(M);if(!G){this.o.publicLog2("galleryService:engineFallback",{extension:z,version:M.version});const W=await this.C(z,M,O.CancellationToken.None);if(!W)throw new Error("Manifest was not found");G=W.engines.vscode}return G}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.h)return{malicious:[],deprecated:{},search:[]};const z=await this.k.request({type:"GET",url:this.h},O.CancellationToken.None);if(z.res.statusCode!==200)throw new Error("Could not get extensions report.");const M=await(0,c.$Xp)(z),G=[],W={},te=[];if(M){for(const ae of M.malicious)G.push({id:ae});if(M.migrateToPreRelease)for(const[ae,he]of Object.entries(M.migrateToPreRelease))(!he.engine||(0,y.$Qp)(he.engine,this.u.version,this.u.date))&&(W[ae.toLowerCase()]={disallowInstall:!0,extension:{id:he.id,displayName:he.displayName,autoMigrate:{storage:!!he.migrateStorage},preRelease:!0}});if(M.deprecated)for(const[ae,he]of Object.entries(M.deprecated))he&&(W[ae.toLowerCase()]=(0,P.$eg)(he)?{}:he);if(M.search)for(const ae of M.search)te.push(ae)}return{malicious:G,deprecated:W,search:te}}};U=$e([oe(1,c.$Rp),oe(2,R.$5j),oe(3,h.$Fi),oe(4,m.$4l),oe(5,$.$5k),oe(6,g.$lk),oe(7,a.$5i)],U);let q=class extends U{constructor(z,M,G,W,te,ae,he,pe){super(z,M,G,W,te,ae,he,pe)}};e.$bq=q,e.$bq=q=$e([oe(0,p.$5p),oe(1,c.$Rp),oe(2,R.$5j),oe(3,h.$Fi),oe(4,m.$4l),oe(5,$.$5k),oe(6,g.$lk),oe(7,a.$5i)],q);let d=class extends U{constructor(z,M,G,W,te,ae,he){super(void 0,z,M,G,W,te,ae,he)}};e.$cq=d,e.$cq=d=$e([oe(0,c.$Rp),oe(1,R.$5j),oe(2,h.$Fi),oe(3,m.$4l),oe(4,$.$5k),oe(5,g.$lk),oe(6,a.$5i)],d)}),define(se[167],re([0,1,11,18,13,6,146,23,24,3,70]),function(X,e,A,O,I,L,N,P,l,a,h){"use strict";var b,v;Object.defineProperty(e,"__esModule",{value:!0}),e.$bQ=e.$aQ=e.$_P=void 0;let y=class extends l.$Hl{static{b=this}static{this.a="profileAssociationsMigration"}constructor(c,w,p,m,f){super(p,m,w,f),this.U=c,this.W=p}O(){return this.U.getItem(b.b,[]).map(w=>({...w,location:(0,a.$$f)(w.location)?this.w.extUri.joinPath(this.profilesHome,w.location):A.URI.revive(w.location)}))}Q(){const c=this.U.getItem(b.c,{});return this.U.getItem(b.a,!1)?c:this.N(c)}S(){return this.w.extUri.joinPath(A.URI.file(this.W.extensionsPath).with({scheme:this.profilesHome.scheme}),"extensions.json")}};e.$_P=y,e.$_P=y=b=$e([oe(0,N.$7P),oe(1,P.$Cl),oe(2,O.$Gi),oe(3,I.$5k),oe(4,L.$5j)],y);let $=v=class extends y{constructor(c,w,p,m,f){super(c,w,p,m,f),this.$=c}P(c){c.length?this.$.setItem(v.b,c.map(w=>({...w,location:this.w.extUri.basename(w.location)}))):this.$.removeItem(v.b)}O(){const c=super.O();return this.$.getItem("userDataProfilesMigration",!1)||(this.P(c),this.$.setItem("userDataProfilesMigration",!0)),c}R(c){c.emptyWindows||c.workspaces?this.$.setItem(v.c,c):this.$.removeItem(v.c)}Q(){const c="workspaceAndProfileInfo",w=this.$.getItem(c,void 0);if(w){this.$.removeItem(c);const m=w.reduce((f,{workspace:n,profile:r})=>(f[A.URI.revive(n).toString()]=A.URI.revive(r).toString(),f),{});this.$.setItem(v.c,{workspaces:m})}const p=super.Q();return this.$.getItem(v.a,!1)||(this.R(p),this.$.setItem(v.a,!0)),p}};e.$aQ=$,e.$aQ=$=v=$e([oe(0,N.$8P),oe(1,P.$Cl),oe(2,O.$Gi),oe(3,I.$5k),oe(4,L.$5j)],$);let R=class extends ${constructor(c,w,p,m){super(new h.$$P(0,w,m,p),c,w,p,m)}async init(){return await this.$.init(),super.init()}};e.$bQ=R,e.$bQ=R=$e([oe(0,P.$Cl),oe(1,O.$Gi),oe(2,I.$5k),oe(3,L.$5j)],R)}),define(se[168],re([0,1,144,8,14,9,3,29,18,145,6,45,143,179]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3r=void 0,e.$4r=g;let $=class extends b.$Sp{constructor(w,p,m,f){super(f),this.m=w,this.n=p,this.r=m,this.s(),this.B(w.onDidChangeConfiguration(n=>{n.affectsConfiguration("http")&&this.s()}))}s(){const w=this.m.getValue("http");this.f=w?.proxy,this.g=!!w?.proxyStrictSSL,this.h=w?.proxyAuthorization}async request(w,p){const{f:m,g:f}=this;let n;try{n=await(0,a.$Im)(this.m,this.r,this.n.args,process.env)}catch(t){this.j||(this.j=!0,this.r.error("resolving shell environment failed",(0,L.$0)(t)))}const r={...process.env,...n},i=w.agent?w.agent:await(0,v.$2r)(w.url||"",r,{proxyUrl:m,strictSSL:f});return w.agent=i,w.strictSSL=f,this.h&&(w.headers={...w.headers||{},"Proxy-Authorization":this.h}),this.c(w.isChromiumNetwork?"electron":"node",w,()=>g(w,p))}async resolveProxy(w){}async loadCertificates(){return(await new Promise((p,m)=>{X(["@vscode/proxy-agent"],p,m)})).loadSystemCertificates({log:this.r})}};e.$3r=$,e.$3r=$=$e([oe(0,P.$5i),oe(1,l.$Gi),oe(2,h.$5j),oe(3,h.$6j)],$);async function R(c){return((0,A.parse)(c.url).protocol==="https:"?await new Promise((m,f)=>{X(["https"],m,f)}):await new Promise((m,f)=>{X(["http"],m,f)})).request}async function g(c,w){return O.Promises.withAsyncBody(async(p,m)=>{const f=(0,A.parse)(c.url),n=c.getRawRequest?c.getRawRequest(c):await R(c),r={hostname:f.hostname,port:f.port?parseInt(f.port):f.protocol==="https:"?443:80,protocol:f.protocol,path:f.path,method:c.type||"GET",headers:c.headers,agent:c.agent,rejectUnauthorized:(0,N.$eg)(c.strictSSL)?c.strictSSL:!0};c.user&&c.password&&(r.auth=c.user+":"+c.password);const i=n(r,t=>{const s=(0,N.$cg)(c.followRedirects)?c.followRedirects:3;if(t.statusCode&&t.statusCode>=300&&t.statusCode<400&&s>0&&t.headers.location)g({...c,url:t.headers.location,followRedirects:s-1},w).then(p,m);else{let o=t;!c.isChromiumNetwork&&t.headers["content-encoding"]==="gzip"&&(o=t.pipe((0,y.createGunzip)())),p({res:t,stream:(0,I.$We)(o)})}});i.on("error",m),c.timeout&&i.setTimeout(c.timeout),c.isChromiumNetwork&&i.removeHeader("Content-Length"),c.data&&typeof c.data=="string"&&i.write(c.data),i.end(),w.onCancellationRequested(()=>{i.abort(),m(new L.$5)})})}}),define(se[180],re([0,1,33,8,34,9,2,15,16,12,35,11,25,29,140,62,142,18,118,166,20,72,147,42,54,162,164,13,130,132,51,128,65,66,150,6,136,39,137,153,32,45,168,70,71,21,152,41,154,155,23,157,24,167,156,163,133,135,4,158,181]),function(X,e,A,O,I,L,N,P,l,a,h,b,v,y,$,R,g,c,w,p,m,f,n,r,i,t,s,o,u,S,j,k,D,F,C,J,ne,ie,ue,le,ce,V,Z,B,T,H,Q,Y,_,U,q,d,E,z,M,G,W,te,ae,he,pe){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=fe;class ye extends N.$Uc{constructor(de){super(),this.b=de,this.c()}c(){process.once("exit",()=>this.dispose())}async run(){const[de,we]=await this.f();return de.invokeFunction(async Ee=>{const Ie=Ee.get(J.$5j),x=Ee.get(o.$5k),K=Ee.get(c.$Gi),ee=Ee.get(E.$El);Ie.info("CLI main",this.b),this.h(Ie),await this.j(K,x,ee,de),await Promise.all(we.map(ge=>{(0,O.$ph)(ge.flush(),1e3)}))})}async f(){const de=new D.$wi,we={_serviceBrand:void 0,...le.default};de.set(ce.$lk,we);const Ee=new w.$$m(this.b,we);de.set(c.$Gi,Ee),await Promise.all([this.g(Ee.appSettingsHome.with({scheme:P.Schemas.file}).fsPath),this.g(Ee.extensionsPath)].map(ve=>ve?v.Promises.mkdir(ve,{recursive:!0}):void 0));const Ie=new te.$6P((0,J.$gk)(Ee),Ee.logsHome);de.set(J.$6j,Ie);const x=this.B(Ie.createLogger("cli",{name:(0,ae.localize)(0,null)})),K=[];Ie.getLogLevel()===J.LogLevel.Trace&&K.push(new J.$ak(Ie.getLogLevel()));const ee=this.B(new W.$dQ(x,K));de.set(J.$5j,ee);const ge=this.B(new u.$Nq(ee));de.set(o.$5k,ge);const be=this.B(new S.$er(ee));ge.registerProvider(P.Schemas.file,be);const Oe=new d.$Fs(ge);de.set(q.$Cl,Oe);const Se=new B.$0P(1,Ee,ee,ge),Le=new z.$_P(Se,Oe,Ee,ge,ee);de.set(E.$El,Le),ge.registerProvider(P.Schemas.vscodeUserData,new he.$Fec(P.Schemas.file,be,P.Schemas.vscodeUserData,Le,Oe,ee));const je=a.$i&&we.win32RegValueName?this.B(new ue.$Dec(ee,we.win32RegValueName)):Ee.policyFile?this.B(new ne.$Eec(Ee.policyFile,ge,ee)):new ie.$jo;de.set(ie.$ho,je);const Ae=this.B(new $.$Jo(Le.defaultProfile.settingsResource,ge,je,ee));de.set(y.$5i,Ae),await Promise.all([Se.init(),Ae.initialize()]);let qe;try{qe=await(0,M.$hec)(Se,ee)}catch(ve){ve.code!=="ENOENT"&&ee.error(ve)}const De=await(0,M.$iec)(Se,ee);Le.init(),de.set(q.$Cl,new d.$Fs(ge));const Ne=new Z.$3r(Ae,Ee,ee,Ie);de.set(V.$Rp,Ne),de.set(R.$No,new j.$vi(g.$sQ,void 0,!0)),de.set(r.$tq,new j.$vi(G.$cQ,void 0,!0)),de.set(i.$xq,new j.$vi(s.$eec,void 0,!0)),de.set(f.$dq,new j.$vi(f.$fq,void 0,!0)),de.set(t.$Iq,new j.$vi(t.$Jq,void 0,!0)),de.set(m.$0o,new j.$vi(p.$cq,void 0,!0)),de.set(F.$Wr,new j.$vi(C.$Yr,void 0,!1));const ze=[],Ue=(0,Y.$vp)(we,Ae);if((0,Y.$qp)(we,Ee)){we.aiConfig&&we.aiConfig.ariaKey&&ze.push(new _.$4P(Ne,Ue,"monacoworkbench",null,we.aiConfig.ariaKey));const ve={appenders:ze,sendErrorTelemetry:!1,commonProperties:(0,T.$hp)((0,A.release)(),(0,A.hostname)(),process.arch,we.commit,we.version,qe,De,Ue),piiPaths:(0,Y.$wp)(Ee)};de.set(H.$4l,new j.$vi(Q.$5r,[ve],!1))}else de.set(H.$4l,Y.$lp);return[new k.$hr(de),ze]}g(de){if(a.$i){const we=(0,pe.getUNCHost)(de);we&&(0,pe.addUNCHostToAllowlist)(we)}return de}h(de){(0,L.setUnexpectedErrorHandler)(we=>{const Ee=(0,I.$jj)(we,!0);Ee&&de.error(`[uncaught exception in CLI]: ${Ee}`)}),process.on("uncaughtException",we=>{(0,L.$Z)(we)||(0,L.$1)(we)}),process.on("unhandledRejection",we=>(0,L.$1)(we))}async j(de,we,Ee,Ie){let x;if(de.args.profile&&(x=Ee.profiles.find(ee=>ee.name===de.args.profile),!x))throw new Error(`Profile '${de.args.profile}' not found.`);const K=(x??Ee.defaultProfile).extensionsResource;if(this.b["list-extensions"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).listExtensions(!!this.b["show-versions"],this.b.category,K);if(this.b["install-extension"]||this.b["install-builtin-extension"]){const ee={isMachineScoped:!!this.b["do-not-sync"],installPreReleaseVersion:!!this.b["pre-release"],profileLocation:K};return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).installExtensions(this.m(this.b["install-extension"]||[]),this.m(this.b["install-builtin-extension"]||[]),ee,!!this.b.force)}else{if(this.b["uninstall-extension"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).uninstallExtensions(this.m(this.b["uninstall-extension"]),!!this.b.force,K);if(this.b["update-extensions"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).updateExtensions(K);if(this.b["locate-extension"])return Ie.createInstance(n.$gq,new J.$ak(J.LogLevel.Info,!1)).locateExtension(this.b["locate-extension"]);this.b.telemetry&&console.log(await(0,U.$4ec)(de.appRoot,de.extensionsPath))}}m(de){return de.map(we=>/\.vsix$/i.test(we)?b.URI.file((0,l.$ic)(we)?we:(0,l.$jc)((0,h.cwd)(),we)):we)}}async function fe(me){const de=new ye(me);try{await de.run()}finally{de.dispose()}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5e68ffd760038bb156894a87f896910be510accd/core/vs/code/node/cliProcessMain.js.map
