/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Se=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/workbench/api/common/extHost.protocol","vs/base/common/event","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypes","vs/workbench/api/common/extHostTypeConverters","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/async","vs/platform/log/common/log","vs/base/common/strings","vs/base/common/errors","vs/base/common/types","vs/base/common/network","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/base/common/path","vs/base/common/cancellation","vs/platform/extensions/common/extensions","vs/base/common/buffer","vs/base/common/platform","vs/base/common/resources","vs/workbench/services/extensions/common/extensions","vs/base/common/objects","vs/workbench/api/common/extHostInitDataService","vs/base/common/map","vs/platform/registry/common/platform","vs/editor/common/core/range","vs/platform/contextkey/common/contextkey","vs/base/common/severity","vs/base/common/uuid","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/api/common/extHostCommands","vs/base/common/themables","vs/base/common/glob","vs/platform/files/common/files","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/iterator","vs/base/common/lazy","vs/base/common/errorMessage","vs/base/common/marshalling","vs/platform/workspace/common/workspace","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/services/search/common/search","vs/base/common/extpath","vs/platform/configuration/common/configuration","vs/platform/configuration/common/configurationRegistry","vs/workbench/contrib/testing/common/testId","vs/workbench/api/common/extHostTerminalService","vs/base/common/ternarySearchTree","vs/base/common/htmlContent","vs/platform/instantiation/common/extensions","vs/base/common/assert","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/base/common/performance","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/contrib/testing/common/testTypes","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostWebview","vs/workbench/api/common/extHostFileSystemConsumer","vs/base/common/stopwatch","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostDocumentsAndEditors","vs/base/common/decorators","vs/base/common/mime","vs/platform/instantiation/common/descriptors","vs/platform/instantiation/common/serviceCollection","vs/base/common/hash","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/base/common/process","vs/workbench/api/common/cache","vs/workbench/contrib/testing/common/testItemCollection","vs/workbench/contrib/webview/common/webview","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostLocalizationService","vs/workbench/api/common/extHostManagedSockets","vs/workbench/api/common/extHostSecretState","vs/workbench/api/common/extHostStorage","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostStoragePaths","vs/workbench/api/common/extHostTunnelService","vs/editor/common/languages","vs/workbench/api/common/extHostLanguageModels","vs/base/common/idGenerator","vs/base/common/codicons","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeBase","vs/editor/common/core/position","vs/editor/common/model","vs/editor/common/model/textModelSearch","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/environment/common/environment","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/implicitActivationEvents","vs/workbench/common/editor","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/authentication/common/authentication","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostDecorations","vs/workbench/api/common/extHostDocumentData","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTerminalShellIntegration","vs/workbench/api/common/extHostTextEditor","vs/workbench/api/common/extHostOutput","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/equals","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/naturalLanguage/korean","vs/base/common/numbers","vs/base/common/observableInternal/debugName","vs/base/common/observableInternal/logging","vs/base/common/observableInternal/base","vs/base/common/prefixTree","vs/base/common/stream","vs/base/common/filters","vs/base/common/symbols","vs/base/common/iconLabels","vs/base/common/dataTransfer","vs/editor/common/core/eolCounter","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/editor/common/model/pieceTreeTextBuffer/rbTreeBase","vs/editor/common/services/treeViewsDnd","vs/nls!vs/base/common/actions","vs/base/common/actions","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/comparers","vs/base/common/uriIpc","vs/base/parts/storage/common/storage","vs/editor/common/core/stringBuilder","vs/editor/common/core/textChange","vs/editor/common/languageSelector","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBuffer","vs/editor/common/model/pieceTreeTextBuffer/pieceTreeTextBufferBuilder","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/contextkey/common/contextkey","vs/nls!vs/platform/contextkey/common/scanner","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/log/common/log","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/theme/common/iconRegistry","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostLanguageFeatures","vs/nls!vs/workbench/api/common/extHostLanguageModels","vs/nls!vs/workbench/api/common/extHostLogService","vs/nls!vs/workbench/api/common/extHostNotebook","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTelemetry","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostTunnelService","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/configuration","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/common/views","vs/nls!vs/workbench/contrib/chat/common/chatContextKeys","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/editor/common/editorResolverService","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/contextkey/common/scanner","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/instantiation/common/instantiationService","vs/base/common/linkedList","vs/platform/log/common/logService","vs/platform/notification/common/notification","vs/platform/configuration/common/configurationModels","vs/platform/request/common/request","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetry","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/environmentVariableShared","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/iconRegistry","vs/platform/tunnel/common/tunnel","vs/platform/uriIdentity/common/uriIdentity","vs/platform/workspace/common/editSessions","vs/platform/workspace/common/virtualWorkspace","vs/platform/userDataProfile/common/userDataProfile","vs/platform/storage/common/storage","vs/workbench/api/common/extHostLogService","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/views","vs/workbench/contrib/chat/common/chatContextKeys","vs/workbench/contrib/chat/common/chatAgents","vs/workbench/contrib/chat/common/chatService","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/notebook/common/notebookKernelService","vs/workbench/contrib/search/common/cellSearchModel","vs/workbench/api/common/extHostCodeInsets","vs/workbench/services/configurationResolver/common/configurationResolver","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/workbench/services/environment/common/environmentService","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostEmbedding","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostProfileContentHandler","vs/workbench/api/common/extHostSpeech","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/notebook/common/notebookDocumentService","vs/workbench/api/common/extHostAiRelatedInformation","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostEmbeddingVector","vs/workbench/api/common/extHostTheming","vs/base/common/functional","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostChatAgents2","vs/workbench/api/common/extHostChatVariables","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostDocuments","vs/base/common/collections","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostLanguageFeatures","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostProgress","vs/workbench/api/common/extHostQuickDiff","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostShare","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/services/output/common/output","vs/workbench/common/configuration","vs/workbench/services/editor/common/editorResolverService","vs/workbench/services/path/common/pathService","vs/workbench/contrib/search/common/searchNotebookHelpers","vs/workbench/api/common/extHostNotebook","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/common/extHost.common.services","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/base/common/codiconsUtil","vs/editor/common/model/mirrorTextModel","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/workbench/api/worker/extensionHostWorker"],Ie=function(le){for(var e=[],C=0,N=le.length;C<N;C++)e[C]=Se[le[C]];return e};define(Se[69],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3h=N,e.$4h=M,e.$5h=T;function C(A){return(p,m,D)=>{let O=null,S=null;if(typeof D.value=="function"?(O="value",S=D.value):typeof D.get=="function"&&(O="get",S=D.get),!S)throw new Error("not supported");D[O]=A(S,m)}}function N(A,p,m){let D=null,O=null;if(typeof m.value=="function"?(D="value",O=m.value,O.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof m.get=="function"&&(D="get",O=m.get),!O)throw new Error("not supported");const S=`$memoize$${p}`;m[D]=function(...d){return this.hasOwnProperty(S)||Object.defineProperty(this,S,{configurable:!1,enumerable:!1,writable:!1,value:O.apply(this,d)}),this[S]}}function M(A,p,m){return C((D,O)=>{const S=`$debounce$${O}`,d=`$debounce$result$${O}`;return function(...w){this[d]||(this[d]=m?m():void 0),clearTimeout(this[S]),p&&(this[d]=p(this[d],...w),w=[this[d]]),this[S]=setTimeout(()=>{D.apply(this,w),this[d]=m?m():void 0},A)}})}function T(A,p,m){return C((D,O)=>{const S=`$throttle$timer$${O}`,d=`$throttle$result$${O}`,w=`$throttle$lastRun$${O}`,f=`$throttle$pending$${O}`;return function(...o){if(this[d]||(this[d]=m?m():void 0),(this[w]===null||this[w]===void 0)&&(this[w]=-Number.MAX_VALUE),p&&(this[d]=p(this[d],...o)),this[f])return;const r=this[w]+A;r<=Date.now()?(this[w]=Date.now(),D.apply(this,[this[d]]),this[d]=m?m():void 0):(this[f]=!0,this[S]=setTimeout(()=>{this[f]=!1,this[w]=Date.now(),D.apply(this,[this[d]]),this[d]=m?m():void 0},r-Date.now()))}})}}),define(Se[125],Ie([1,0,18]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6c=void 0,e.$7c=M,e.$8c=T,e.$9c=A,e.$0c=p,e.$$c=m,e.$_c=D;const N=(w,f)=>w===f;e.$6c=N;function M(w=e.$6c){return(f,o)=>C.$ub(f,o,w)}function T(){return(w,f)=>JSON.stringify(w)===JSON.stringify(f)}function A(){return(w,f)=>w.equals(f)}function p(w,f,o){return!w||!f?w===f:o(w,f)}function m(w,f){if(w===f)return!0;if(Array.isArray(w)&&Array.isArray(f)){if(w.length!==f.length)return!1;for(let o=0;o<w.length;o++)if(!m(w[o],f[o]))return!1;return!0}if(w&&typeof w=="object"&&f&&typeof f=="object"&&Object.getPrototypeOf(w)===Object.prototype&&Object.getPrototypeOf(f)===Object.prototype){const o=w,r=f,s=Object.keys(o),n=Object.keys(r),t=new Set(n);if(s.length!==n.length)return!1;for(const c of s)if(!t.has(c)||!m(o[c],r[c]))return!1;return!0}return!1}function D(w){return JSON.stringify(d(w))}let O=0;const S=new WeakMap;function d(w){if(Array.isArray(w))return w.map(d);if(w&&typeof w=="object")if(Object.getPrototypeOf(w)===Object.prototype){const f=w,o=Object.create(null);for(const r of Object.keys(f).sort())o[r]=d(f[r]);return o}else{let f=S.get(w);return f===void 0&&(f=O++,S.set(w,f)),f+"----2b76a038c20c4bcc"}return w}}),define(Se[91],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$VO=e.$UO=void 0;class C{constructor(M){this.a=M,this.b=0}nextId(){return this.a+ ++this.b}}e.$UO=C,e.$VO=new C("id#")}),define(Se[126],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0,e.$Jn=A,e.$Kn=S,e.$Ln=d,e.$Mn=w,e.$Nn=f,e.$On=o,e.$Pn=r,e.$Qn=s,e.$Rn=n,e.$Sn=t,e.$Tn=c,e.$Un=u;var C;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(C||(e.ScanError=C={}));var N;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(N||(e.SyntaxKind=N={}));var M;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(M||(e.ParseErrorCode=M={}));var T;(function(i){i.DEFAULT={allowTrailingComma:!0}})(T||(e.ParseOptions=T={}));function A(i,b=!1){let a=0;const l=i.length;let g="",$=0,v=16,y=0;function h(q){let R=0,z=0;for(;R<q;){const K=i.charCodeAt(a);if(K>=48&&K<=57)z=z*16+K-48;else if(K>=65&&K<=70)z=z*16+K-65+10;else if(K>=97&&K<=102)z=z*16+K-97+10;else break;a++,R++}return R<q&&(z=-1),z}function E(q){a=q,g="",$=0,v=16,y=0}function k(){const q=a;if(i.charCodeAt(a)===48)a++;else for(a++;a<i.length&&D(i.charCodeAt(a));)a++;if(a<i.length&&i.charCodeAt(a)===46)if(a++,a<i.length&&D(i.charCodeAt(a)))for(a++;a<i.length&&D(i.charCodeAt(a));)a++;else return y=3,i.substring(q,a);let R=a;if(a<i.length&&(i.charCodeAt(a)===69||i.charCodeAt(a)===101))if(a++,(a<i.length&&i.charCodeAt(a)===43||i.charCodeAt(a)===45)&&a++,a<i.length&&D(i.charCodeAt(a))){for(a++;a<i.length&&D(i.charCodeAt(a));)a++;R=a}else y=3;return i.substring(q,R)}function I(){let q="",R=a;for(;;){if(a>=l){q+=i.substring(R,a),y=2;break}const z=i.charCodeAt(a);if(z===34){q+=i.substring(R,a),a++;break}if(z===92){if(q+=i.substring(R,a),a++,a>=l){y=2;break}switch(i.charCodeAt(a++)){case 34:q+='"';break;case 92:q+="\\";break;case 47:q+="/";break;case 98:q+="\b";break;case 102:q+="\f";break;case 110:q+=`
`;break;case 114:q+="\r";break;case 116:q+="	";break;case 117:{const ie=h(4);ie>=0?q+=String.fromCharCode(ie):y=4;break}default:y=5}R=a;continue}if(z>=0&&z<=31)if(m(z)){q+=i.substring(R,a),y=2;break}else y=6;a++}return q}function P(){if(g="",y=0,$=a,a>=l)return $=l,v=17;let q=i.charCodeAt(a);if(p(q)){do a++,g+=String.fromCharCode(q),q=i.charCodeAt(a);while(p(q));return v=15}if(m(q))return a++,g+=String.fromCharCode(q),q===13&&i.charCodeAt(a)===10&&(a++,g+=`
`),v=14;switch(q){case 123:return a++,v=1;case 125:return a++,v=2;case 91:return a++,v=3;case 93:return a++,v=4;case 58:return a++,v=6;case 44:return a++,v=5;case 34:return a++,g=I(),v=10;case 47:{const R=a-1;if(i.charCodeAt(a+1)===47){for(a+=2;a<l&&!m(i.charCodeAt(a));)a++;return g=i.substring(R,a),v=12}if(i.charCodeAt(a+1)===42){a+=2;const z=l-1;let K=!1;for(;a<z;){if(i.charCodeAt(a)===42&&i.charCodeAt(a+1)===47){a+=2,K=!0;break}a++}return K||(a++,y=1),g=i.substring(R,a),v=13}return g+=String.fromCharCode(q),a++,v=16}case 45:if(g+=String.fromCharCode(q),a++,a===l||!D(i.charCodeAt(a)))return v=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return g+=k(),v=11;default:for(;a<l&&V(q);)a++,q=i.charCodeAt(a);if($!==a){switch(g=i.substring($,a),g){case"true":return v=8;case"false":return v=9;case"null":return v=7}return v=16}return g+=String.fromCharCode(q),a++,v=16}}function V(q){if(p(q)||m(q))return!1;switch(q){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function W(){let q;do q=P();while(q>=12&&q<=15);return q}return{setPosition:E,getPosition:()=>a,scan:b?W:P,getToken:()=>v,getTokenValue:()=>g,getTokenOffset:()=>$,getTokenLength:()=>a-$,getTokenError:()=>y}}function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function m(i){return i===10||i===13||i===8232||i===8233}function D(i){return i>=48&&i<=57}var O;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(O||(O={}));function S(i,b){const a=[],l=new Object;let g;const $={value:{},offset:0,length:0,type:"object",parent:void 0};let v=!1;function y(h,E,k,I){$.value=h,$.offset=E,$.length=k,$.type=I,$.colonOffset=void 0,g=$}try{t(i,{onObjectBegin:(h,E)=>{if(b<=h)throw l;g=void 0,v=b>h,a.push("")},onObjectProperty:(h,E,k)=>{if(b<E||(y(h,E,k,"property"),a[a.length-1]=h,b<=E+k))throw l},onObjectEnd:(h,E)=>{if(b<=h)throw l;g=void 0,a.pop()},onArrayBegin:(h,E)=>{if(b<=h)throw l;g=void 0,a.push(0)},onArrayEnd:(h,E)=>{if(b<=h)throw l;g=void 0,a.pop()},onLiteralValue:(h,E,k)=>{if(b<E||(y(h,E,k,u(h)),b<=E+k))throw l},onSeparator:(h,E,k)=>{if(b<=E)throw l;if(h===":"&&g&&g.type==="property")g.colonOffset=E,v=!1,g=void 0;else if(h===","){const I=a[a.length-1];typeof I=="number"?a[a.length-1]=I+1:(v=!0,a[a.length-1]=""),g=void 0}}})}catch(h){if(h!==l)throw h}return{path:a,previousNode:g,isAtPropertyKey:v,matches:h=>{let E=0;for(let k=0;E<h.length&&k<a.length;k++)if(h[E]===a[k]||h[E]==="*")E++;else if(h[E]!=="**")return!1;return E===h.length}}}function d(i,b=[],a=T.DEFAULT){let l=null,g=[];const $=[];function v(h){Array.isArray(g)?g.push(h):l!==null&&(g[l]=h)}return t(i,{onObjectBegin:()=>{const h={};v(h),$.push(g),g=h,l=null},onObjectProperty:h=>{l=h},onObjectEnd:()=>{g=$.pop()},onArrayBegin:()=>{const h=[];v(h),$.push(g),g=h,l=null},onArrayEnd:()=>{g=$.pop()},onLiteralValue:v,onError:(h,E,k)=>{b.push({error:h,offset:E,length:k})}},a),g[0]}function w(i,b=[],a=T.DEFAULT){let l={type:"array",offset:-1,length:-1,children:[],parent:void 0};function g(h){l.type==="property"&&(l.length=h-l.offset,l=l.parent)}function $(h){return l.children.push(h),h}t(i,{onObjectBegin:h=>{l=$({type:"object",offset:h,length:-1,parent:l,children:[]})},onObjectProperty:(h,E,k)=>{l=$({type:"property",offset:E,length:-1,parent:l,children:[]}),l.children.push({type:"string",value:h,offset:E,length:k,parent:l})},onObjectEnd:(h,E)=>{l.length=h+E-l.offset,l=l.parent,g(h+E)},onArrayBegin:(h,E)=>{l=$({type:"array",offset:h,length:-1,parent:l,children:[]})},onArrayEnd:(h,E)=>{l.length=h+E-l.offset,l=l.parent,g(h+E)},onLiteralValue:(h,E,k)=>{$({type:u(h),offset:E,length:k,parent:l,value:h}),g(E+k)},onSeparator:(h,E,k)=>{l.type==="property"&&(h===":"?l.colonOffset=E:h===","&&g(E))},onError:(h,E,k)=>{b.push({error:h,offset:E,length:k})}},a);const y=l.children[0];return y&&delete y.parent,y}function f(i,b){if(!i)return;let a=i;for(const l of b)if(typeof l=="string"){if(a.type!=="object"||!Array.isArray(a.children))return;let g=!1;for(const $ of a.children)if(Array.isArray($.children)&&$.children[0].value===l){a=$.children[1],g=!0;break}if(!g)return}else{const g=l;if(a.type!=="array"||g<0||!Array.isArray(a.children)||g>=a.children.length)return;a=a.children[g]}return a}function o(i){if(!i.parent||!i.parent.children)return[];const b=o(i.parent);if(i.parent.type==="property"){const a=i.parent.children[0].value;b.push(a)}else if(i.parent.type==="array"){const a=i.parent.children.indexOf(i);a!==-1&&b.push(a)}return b}function r(i){switch(i.type){case"array":return i.children.map(r);case"object":{const b=Object.create(null);for(const a of i.children){const l=a.children[1];l&&(b[a.children[0].value]=r(l))}return b}case"null":case"string":case"number":case"boolean":return i.value;default:return}}function s(i,b,a=!1){return b>=i.offset&&b<i.offset+i.length||a&&b===i.offset+i.length}function n(i,b,a=!1){if(s(i,b,a)){const l=i.children;if(Array.isArray(l))for(let g=0;g<l.length&&l[g].offset<=b;g++){const $=n(l[g],b,a);if($)return $}return i}}function t(i,b,a=T.DEFAULT){const l=A(i,!1);function g(Ce){return Ce?()=>Ce(l.getTokenOffset(),l.getTokenLength()):()=>!0}function $(Ce){return Ce?se=>Ce(se,l.getTokenOffset(),l.getTokenLength()):()=>!0}const v=g(b.onObjectBegin),y=$(b.onObjectProperty),h=g(b.onObjectEnd),E=g(b.onArrayBegin),k=g(b.onArrayEnd),I=$(b.onLiteralValue),P=$(b.onSeparator),V=g(b.onComment),W=$(b.onError),q=a&&a.disallowComments,R=a&&a.allowTrailingComma;function z(){for(;;){const Ce=l.scan();switch(l.getTokenError()){case 4:K(14);break;case 5:K(15);break;case 3:K(13);break;case 1:q||K(11);break;case 2:K(12);break;case 6:K(16);break}switch(Ce){case 12:case 13:q?K(10):V();break;case 16:K(1);break;case 15:case 14:break;default:return Ce}}}function K(Ce,se=[],Ne=[]){if(W(Ce),se.length+Ne.length>0){let ne=l.getToken();for(;ne!==17;){if(se.indexOf(ne)!==-1){z();break}else if(Ne.indexOf(ne)!==-1)break;ne=z()}}}function ie(Ce){const se=l.getTokenValue();return Ce?I(se):y(se),z(),!0}function de(){switch(l.getToken()){case 11:{let Ce=0;try{Ce=JSON.parse(l.getTokenValue()),typeof Ce!="number"&&(K(2),Ce=0)}catch{K(2)}I(Ce);break}case 7:I(null);break;case 8:I(!0);break;case 9:I(!1);break;default:return!1}return z(),!0}function ye(){return l.getToken()!==10?(K(3,[],[2,5]),!1):(ie(!1),l.getToken()===6?(P(":"),z(),ue()||K(4,[],[2,5])):K(5,[],[2,5]),!0)}function De(){v(),z();let Ce=!1;for(;l.getToken()!==2&&l.getToken()!==17;){if(l.getToken()===5){if(Ce||K(4,[],[]),P(","),z(),l.getToken()===2&&R)break}else Ce&&K(6,[],[]);ye()||K(4,[],[2,5]),Ce=!0}return h(),l.getToken()!==2?K(7,[2],[]):z(),!0}function ge(){E(),z();let Ce=!1;for(;l.getToken()!==4&&l.getToken()!==17;){if(l.getToken()===5){if(Ce||K(4,[],[]),P(","),z(),l.getToken()===4&&R)break}else Ce&&K(6,[],[]);ue()||K(4,[],[4,5]),Ce=!0}return k(),l.getToken()!==4?K(8,[4],[]):z(),!0}function ue(){switch(l.getToken()){case 3:return ge();case 1:return De();case 10:return ie(!0);default:return de()}}return z(),l.getToken()===17?a.allowEmptyContent?!0:(K(4,[],[]),!1):ue()?(l.getToken()!==17&&K(9,[],[]),!0):(K(4,[],[]),!1)}function c(i,b){const a=A(i),l=[];let g,$=0,v;do switch(v=a.getPosition(),g=a.scan(),g){case 12:case 13:case 17:$!==v&&l.push(i.substring($,v)),b!==void 0&&l.push(a.getTokenValue().replace(/[^\r\n]/g,b)),$=a.getPosition();break}while(g!==17);return l.join("")}function u(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}}),function(le,e){typeof define=="function"&&define.amd?define(Se[127],Ie([0]),e):typeof exports=="object"&&typeof module<"u"?e(exports):(le=typeof globalThis<"u"?globalThis:le||self,e(le.marked={}))}(this,function(le){"use strict";function e(ke,be){for(var me=0;me<be.length;me++){var Q=be[me];Q.enumerable=Q.enumerable||!1,Q.configurable=!0,"value"in Q&&(Q.writable=!0),Object.defineProperty(ke,Q.key,Q)}}function C(ke,be,me){return be&&e(ke.prototype,be),me&&e(ke,me),Object.defineProperty(ke,"prototype",{writable:!1}),ke}function N(ke,be){if(ke){if(typeof ke=="string")return M(ke,be);var me=Object.prototype.toString.call(ke).slice(8,-1);if(me==="Object"&&ke.constructor&&(me=ke.constructor.name),me==="Map"||me==="Set")return Array.from(ke);if(me==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(me))return M(ke,be)}}function M(ke,be){(be==null||be>ke.length)&&(be=ke.length);for(var me=0,Q=new Array(be);me<be;me++)Q[me]=ke[me];return Q}function T(ke,be){var me=typeof Symbol<"u"&&ke[Symbol.iterator]||ke["@@iterator"];if(me)return(me=me.call(ke)).next.bind(me);if(Array.isArray(ke)||(me=N(ke))||be&&ke&&typeof ke.length=="number"){me&&(ke=me);var Q=0;return function(){return Q>=ke.length?{done:!0}:{done:!1,value:ke[Q++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function A(){return{async:!1,baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}le.defaults=A();function p(ke){le.defaults=ke}var m=/[&<>"']/,D=/[&<>"']/g,O=/[<>"']|&(?!#?\w+;)/,S=/[<>"']|&(?!#?\w+;)/g,d={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},w=function(be){return d[be]};function f(ke,be){if(be){if(m.test(ke))return ke.replace(D,w)}else if(O.test(ke))return ke.replace(S,w);return ke}var o=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function r(ke){return ke.replace(o,function(be,me){return me=me.toLowerCase(),me==="colon"?":":me.charAt(0)==="#"?me.charAt(1)==="x"?String.fromCharCode(parseInt(me.substring(2),16)):String.fromCharCode(+me.substring(1)):""})}var s=/(^|[^\[])\^/g;function n(ke,be){ke=typeof ke=="string"?ke:ke.source,be=be||"";var me={replace:function(Y,he){return he=he.source||he,he=he.replace(s,"$1"),ke=ke.replace(Y,he),me},getRegex:function(){return new RegExp(ke,be)}};return me}var t=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function u(ke,be,me){if(ke){var Q;try{Q=decodeURIComponent(r(me)).replace(t,"").toLowerCase()}catch{return null}if(Q.indexOf("javascript:")===0||Q.indexOf("vbscript:")===0||Q.indexOf("data:")===0)return null}be&&!c.test(me)&&(me=g(be,me));try{me=encodeURI(me).replace(/%25/g,"%")}catch{return null}return me}var i={},b=/^[^:]+:\/*[^/]*$/,a=/^([^:]+:)[\s\S]*$/,l=/^([^:]+:\/*[^/]*)[\s\S]*$/;function g(ke,be){i[" "+ke]||(b.test(ke)?i[" "+ke]=ke+"/":i[" "+ke]=h(ke,"/",!0)),ke=i[" "+ke];var me=ke.indexOf(":")===-1;return be.substring(0,2)==="//"?me?be:ke.replace(a,"$1")+be:be.charAt(0)==="/"?me?be:ke.replace(l,"$1")+be:ke+be}var $={exec:function(){}};function v(ke){for(var be=1,me,Q;be<arguments.length;be++){me=arguments[be];for(Q in me)Object.prototype.hasOwnProperty.call(me,Q)&&(ke[Q]=me[Q])}return ke}function y(ke,be){var me=ke.replace(/\|/g,function(he,ce,Te){for(var fe=!1,Pe=ce;--Pe>=0&&Te[Pe]==="\\";)fe=!fe;return fe?"|":" |"}),Q=me.split(/ \|/),Y=0;if(Q[0].trim()||Q.shift(),Q.length>0&&!Q[Q.length-1].trim()&&Q.pop(),Q.length>be)Q.splice(be);else for(;Q.length<be;)Q.push("");for(;Y<Q.length;Y++)Q[Y]=Q[Y].trim().replace(/\\\|/g,"|");return Q}function h(ke,be,me){var Q=ke.length;if(Q===0)return"";for(var Y=0;Y<Q;){var he=ke.charAt(Q-Y-1);if(he===be&&!me)Y++;else if(he!==be&&me)Y++;else break}return ke.slice(0,Q-Y)}function E(ke,be){if(ke.indexOf(be[1])===-1)return-1;for(var me=ke.length,Q=0,Y=0;Y<me;Y++)if(ke[Y]==="\\")Y++;else if(ke[Y]===be[0])Q++;else if(ke[Y]===be[1]&&(Q--,Q<0))return Y;return-1}function k(ke){ke&&ke.sanitize&&!ke.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function I(ke,be){if(be<1)return"";for(var me="";be>1;)be&1&&(me+=ke),be>>=1,ke+=ke;return me+ke}function P(ke,be,me,Q){var Y=be.href,he=be.title?f(be.title):null,ce=ke[1].replace(/\\([\[\]])/g,"$1");if(ke[0].charAt(0)!=="!"){Q.state.inLink=!0;var Te={type:"link",raw:me,href:Y,title:he,text:ce,tokens:Q.inlineTokens(ce)};return Q.state.inLink=!1,Te}return{type:"image",raw:me,href:Y,title:he,text:f(ce)}}function V(ke,be){var me=ke.match(/^(\s+)(?:```)/);if(me===null)return be;var Q=me[1];return be.split(`
`).map(function(Y){var he=Y.match(/^\s+/);if(he===null)return Y;var ce=he[0];return ce.length>=Q.length?Y.slice(Q.length):Y}).join(`
`)}var W=function(){function ke(me){this.options=me||le.defaults}var be=ke.prototype;return be.space=function(Q){var Y=this.rules.block.newline.exec(Q);if(Y&&Y[0].length>0)return{type:"space",raw:Y[0]}},be.code=function(Q){var Y=this.rules.block.code.exec(Q);if(Y){var he=Y[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:Y[0],codeBlockStyle:"indented",text:this.options.pedantic?he:h(he,`
`)}}},be.fences=function(Q){var Y=this.rules.block.fences.exec(Q);if(Y){var he=Y[0],ce=V(he,Y[3]||"");return{type:"code",raw:he,lang:Y[2]?Y[2].trim():Y[2],text:ce}}},be.heading=function(Q){var Y=this.rules.block.heading.exec(Q);if(Y){var he=Y[2].trim();if(/#$/.test(he)){var ce=h(he,"#");(this.options.pedantic||!ce||/ $/.test(ce))&&(he=ce.trim())}return{type:"heading",raw:Y[0],depth:Y[1].length,text:he,tokens:this.lexer.inline(he)}}},be.hr=function(Q){var Y=this.rules.block.hr.exec(Q);if(Y)return{type:"hr",raw:Y[0]}},be.blockquote=function(Q){var Y=this.rules.block.blockquote.exec(Q);if(Y){var he=Y[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:Y[0],tokens:this.lexer.blockTokens(he,[]),text:he}}},be.list=function(Q){var Y=this.rules.block.list.exec(Q);if(Y){var he,ce,Te,fe,Pe,Re,je,B,F,H,G,te,re=Y[1].trim(),Oe=re.length>1,Be={type:"list",raw:"",ordered:Oe,start:Oe?+re.slice(0,-1):"",loose:!1,items:[]};re=Oe?"\\d{1,9}\\"+re.slice(-1):"\\"+re,this.options.pedantic&&(re=Oe?re:"[*+-]");for(var Ge=new RegExp("^( {0,3}"+re+")((?:[	 ][^\\n]*)?(?:\\n|$))");Q&&(te=!1,!(!(Y=Ge.exec(Q))||this.rules.block.hr.test(Q)));){if(he=Y[0],Q=Q.substring(he.length),B=Y[2].split(`
`,1)[0],F=Q.split(`
`,1)[0],this.options.pedantic?(fe=2,G=B.trimLeft()):(fe=Y[2].search(/[^ ]/),fe=fe>4?1:fe,G=B.slice(fe),fe+=Y[1].length),Re=!1,!B&&/^ *$/.test(F)&&(he+=F+`
`,Q=Q.substring(F.length+1),te=!0),!te)for(var _e=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),xe=new RegExp("^ {0,"+Math.min(3,fe-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)"),et=new RegExp("^ {0,"+Math.min(3,fe-1)+"}(?:```|~~~)"),tt=new RegExp("^ {0,"+Math.min(3,fe-1)+"}#");Q&&(H=Q.split(`
`,1)[0],B=H,this.options.pedantic&&(B=B.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(et.test(B)||tt.test(B)||_e.test(B)||xe.test(Q)));){if(B.search(/[^ ]/)>=fe||!B.trim())G+=`
`+B.slice(fe);else if(!Re)G+=`
`+B;else break;!Re&&!B.trim()&&(Re=!0),he+=H+`
`,Q=Q.substring(H.length+1)}Be.loose||(je?Be.loose=!0:/\n *\n *$/.test(he)&&(je=!0)),this.options.gfm&&(ce=/^\[[ xX]\] /.exec(G),ce&&(Te=ce[0]!=="[ ] ",G=G.replace(/^\[[ xX]\] +/,""))),Be.items.push({type:"list_item",raw:he,task:!!ce,checked:Te,loose:!1,text:G}),Be.raw+=he}Be.items[Be.items.length-1].raw=he.trimRight(),Be.items[Be.items.length-1].text=G.trimRight(),Be.raw=Be.raw.trimRight();var it=Be.items.length;for(Pe=0;Pe<it;Pe++){this.lexer.state.top=!1,Be.items[Pe].tokens=this.lexer.blockTokens(Be.items[Pe].text,[]);var at=Be.items[Pe].tokens.filter(function(Ue){return Ue.type==="space"}),gt=at.every(function(Ue){for(var rt=Ue.raw.split(""),Z=0,X=T(rt),$e;!($e=X()).done;){var He=$e.value;if(He===`
`&&(Z+=1),Z>1)return!0}return!1});!Be.loose&&at.length&&gt&&(Be.loose=!0,Be.items[Pe].loose=!0)}return Be}},be.html=function(Q){var Y=this.rules.block.html.exec(Q);if(Y){var he={type:"html",raw:Y[0],pre:!this.options.sanitizer&&(Y[1]==="pre"||Y[1]==="script"||Y[1]==="style"),text:Y[0]};if(this.options.sanitize){var ce=this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]);he.type="paragraph",he.text=ce,he.tokens=this.lexer.inline(ce)}return he}},be.def=function(Q){var Y=this.rules.block.def.exec(Q);if(Y){Y[3]&&(Y[3]=Y[3].substring(1,Y[3].length-1));var he=Y[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:he,raw:Y[0],href:Y[2],title:Y[3]}}},be.table=function(Q){var Y=this.rules.block.table.exec(Q);if(Y){var he={type:"table",header:y(Y[1]).map(function(je){return{text:je}}),align:Y[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:Y[3]&&Y[3].trim()?Y[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(he.header.length===he.align.length){he.raw=Y[0];var ce=he.align.length,Te,fe,Pe,Re;for(Te=0;Te<ce;Te++)/^ *-+: *$/.test(he.align[Te])?he.align[Te]="right":/^ *:-+: *$/.test(he.align[Te])?he.align[Te]="center":/^ *:-+ *$/.test(he.align[Te])?he.align[Te]="left":he.align[Te]=null;for(ce=he.rows.length,Te=0;Te<ce;Te++)he.rows[Te]=y(he.rows[Te],he.header.length).map(function(je){return{text:je}});for(ce=he.header.length,fe=0;fe<ce;fe++)he.header[fe].tokens=this.lexer.inline(he.header[fe].text);for(ce=he.rows.length,fe=0;fe<ce;fe++)for(Re=he.rows[fe],Pe=0;Pe<Re.length;Pe++)Re[Pe].tokens=this.lexer.inline(Re[Pe].text);return he}}},be.lheading=function(Q){var Y=this.rules.block.lheading.exec(Q);if(Y)return{type:"heading",raw:Y[0],depth:Y[2].charAt(0)==="="?1:2,text:Y[1],tokens:this.lexer.inline(Y[1])}},be.paragraph=function(Q){var Y=this.rules.block.paragraph.exec(Q);if(Y){var he=Y[1].charAt(Y[1].length-1)===`
`?Y[1].slice(0,-1):Y[1];return{type:"paragraph",raw:Y[0],text:he,tokens:this.lexer.inline(he)}}},be.text=function(Q){var Y=this.rules.block.text.exec(Q);if(Y)return{type:"text",raw:Y[0],text:Y[0],tokens:this.lexer.inline(Y[0])}},be.escape=function(Q){var Y=this.rules.inline.escape.exec(Q);if(Y)return{type:"escape",raw:Y[0],text:f(Y[1])}},be.tag=function(Q){var Y=this.rules.inline.tag.exec(Q);if(Y)return!this.lexer.state.inLink&&/^<a /i.test(Y[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(Y[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(Y[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(Y[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:Y[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(Y[0]):f(Y[0]):Y[0]}},be.link=function(Q){var Y=this.rules.inline.link.exec(Q);if(Y){var he=Y[2].trim();if(!this.options.pedantic&&/^</.test(he)){if(!/>$/.test(he))return;var ce=h(he.slice(0,-1),"\\");if((he.length-ce.length)%2===0)return}else{var Te=E(Y[2],"()");if(Te>-1){var fe=Y[0].indexOf("!")===0?5:4,Pe=fe+Y[1].length+Te;Y[2]=Y[2].substring(0,Te),Y[0]=Y[0].substring(0,Pe).trim(),Y[3]=""}}var Re=Y[2],je="";if(this.options.pedantic){var B=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(Re);B&&(Re=B[1],je=B[3])}else je=Y[3]?Y[3].slice(1,-1):"";return Re=Re.trim(),/^</.test(Re)&&(this.options.pedantic&&!/>$/.test(he)?Re=Re.slice(1):Re=Re.slice(1,-1)),P(Y,{href:Re&&Re.replace(this.rules.inline._escapes,"$1"),title:je&&je.replace(this.rules.inline._escapes,"$1")},Y[0],this.lexer)}},be.reflink=function(Q,Y){var he;if((he=this.rules.inline.reflink.exec(Q))||(he=this.rules.inline.nolink.exec(Q))){var ce=(he[2]||he[1]).replace(/\s+/g," ");if(ce=Y[ce.toLowerCase()],!ce||!ce.href){var Te=he[0].charAt(0);return{type:"text",raw:Te,text:Te}}return P(he,ce,he[0],this.lexer)}},be.emStrong=function(Q,Y,he){he===void 0&&(he="");var ce=this.rules.inline.emStrong.lDelim.exec(Q);if(ce&&!(ce[3]&&he.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var Te=ce[1]||ce[2]||"";if(!Te||Te&&(he===""||this.rules.inline.punctuation.exec(he))){var fe=ce[0].length-1,Pe,Re,je=fe,B=0,F=ce[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(F.lastIndex=0,Y=Y.slice(-1*Q.length+fe);(ce=F.exec(Y))!=null;)if(Pe=ce[1]||ce[2]||ce[3]||ce[4]||ce[5]||ce[6],!!Pe){if(Re=Pe.length,ce[3]||ce[4]){je+=Re;continue}else if((ce[5]||ce[6])&&fe%3&&!((fe+Re)%3)){B+=Re;continue}if(je-=Re,!(je>0)){if(Re=Math.min(Re,Re+je+B),Math.min(fe,Re)%2){var H=Q.slice(1,fe+ce.index+Re);return{type:"em",raw:Q.slice(0,fe+ce.index+Re+1),text:H,tokens:this.lexer.inlineTokens(H)}}var G=Q.slice(2,fe+ce.index+Re-1);return{type:"strong",raw:Q.slice(0,fe+ce.index+Re+1),text:G,tokens:this.lexer.inlineTokens(G)}}}}}},be.codespan=function(Q){var Y=this.rules.inline.code.exec(Q);if(Y){var he=Y[2].replace(/\n/g," "),ce=/[^ ]/.test(he),Te=/^ /.test(he)&&/ $/.test(he);return ce&&Te&&(he=he.substring(1,he.length-1)),he=f(he,!0),{type:"codespan",raw:Y[0],text:he}}},be.br=function(Q){var Y=this.rules.inline.br.exec(Q);if(Y)return{type:"br",raw:Y[0]}},be.del=function(Q){var Y=this.rules.inline.del.exec(Q);if(Y)return{type:"del",raw:Y[0],text:Y[2],tokens:this.lexer.inlineTokens(Y[2])}},be.autolink=function(Q,Y){var he=this.rules.inline.autolink.exec(Q);if(he){var ce,Te;return he[2]==="@"?(ce=f(this.options.mangle?Y(he[1]):he[1]),Te="mailto:"+ce):(ce=f(he[1]),Te=ce),{type:"link",raw:he[0],text:ce,href:Te,tokens:[{type:"text",raw:ce,text:ce}]}}},be.url=function(Q,Y){var he;if(he=this.rules.inline.url.exec(Q)){var ce,Te;if(he[2]==="@")ce=f(this.options.mangle?Y(he[0]):he[0]),Te="mailto:"+ce;else{var fe;do fe=he[0],he[0]=this.rules.inline._backpedal.exec(he[0])[0];while(fe!==he[0]);ce=f(he[0]),he[1]==="www."?Te="http://"+ce:Te=ce}return{type:"link",raw:he[0],text:ce,href:Te,tokens:[{type:"text",raw:ce,text:ce}]}}},be.inlineText=function(Q,Y){var he=this.rules.inline.text.exec(Q);if(he){var ce;return this.lexer.state.inRawBlock?ce=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(he[0]):f(he[0]):he[0]:ce=f(this.options.smartypants?Y(he[0]):he[0]),{type:"text",raw:he[0],text:ce}}},ke}(),q={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:$,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};q._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,q._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,q.def=n(q.def).replace("label",q._label).replace("title",q._title).getRegex(),q.bullet=/(?:[*+-]|\d{1,9}[.)])/,q.listItemStart=n(/^( *)(bull) */).replace("bull",q.bullet).getRegex(),q.list=n(q.list).replace(/bull/g,q.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+q.def.source+")").getRegex(),q._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",q._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,q.html=n(q.html,"i").replace("comment",q._comment).replace("tag",q._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),q.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.blockquote=n(q.blockquote).replace("paragraph",q.paragraph).getRegex(),q.normal=v({},q),q.gfm=v({},q.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),q.gfm.table=n(q.gfm.table).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.gfm.paragraph=n(q._paragraph).replace("hr",q.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",q.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",q._tag).getRegex(),q.pedantic=v({},q.normal,{html:n(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",q._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:$,paragraph:n(q.normal._paragraph).replace("hr",q.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",q.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var R={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:$,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:$,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};R._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",R.punctuation=n(R.punctuation).replace(/punctuation/g,R._punctuation).getRegex(),R.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,R.escapedEmSt=/\\\*|\\_/g,R._comment=n(q._comment).replace("(?:-->|$)","-->").getRegex(),R.emStrong.lDelim=n(R.emStrong.lDelim).replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimAst=n(R.emStrong.rDelimAst,"g").replace(/punct/g,R._punctuation).getRegex(),R.emStrong.rDelimUnd=n(R.emStrong.rDelimUnd,"g").replace(/punct/g,R._punctuation).getRegex(),R._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,R._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,R._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,R.autolink=n(R.autolink).replace("scheme",R._scheme).replace("email",R._email).getRegex(),R._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,R.tag=n(R.tag).replace("comment",R._comment).replace("attribute",R._attribute).getRegex(),R._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,R._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,R._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,R.link=n(R.link).replace("label",R._label).replace("href",R._href).replace("title",R._title).getRegex(),R.reflink=n(R.reflink).replace("label",R._label).replace("ref",q._label).getRegex(),R.nolink=n(R.nolink).replace("ref",q._label).getRegex(),R.reflinkSearch=n(R.reflinkSearch,"g").replace("reflink",R.reflink).replace("nolink",R.nolink).getRegex(),R.normal=v({},R),R.pedantic=v({},R.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:n(/^!?\[(label)\]\((.*?)\)/).replace("label",R._label).getRegex(),reflink:n(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",R._label).getRegex()}),R.gfm=v({},R.normal,{escape:n(R.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),R.gfm.url=n(R.gfm.url,"i").replace("email",R.gfm._extended_email).getRegex(),R.breaks=v({},R.gfm,{br:n(R.br).replace("{2,}","*").getRegex(),text:n(R.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function z(ke){return ke.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function K(ke){var be="",me,Q,Y=ke.length;for(me=0;me<Y;me++)Q=ke.charCodeAt(me),Math.random()>.5&&(Q="x"+Q.toString(16)),be+="&#"+Q+";";return be}var ie=function(){function ke(me){this.tokens=[],this.tokens.links=Object.create(null),this.options=me||le.defaults,this.options.tokenizer=this.options.tokenizer||new W,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var Q={block:q.normal,inline:R.normal};this.options.pedantic?(Q.block=q.pedantic,Q.inline=R.pedantic):this.options.gfm&&(Q.block=q.gfm,this.options.breaks?Q.inline=R.breaks:Q.inline=R.gfm),this.tokenizer.rules=Q}ke.lex=function(Q,Y){var he=new ke(Y);return he.lex(Q)},ke.lexInline=function(Q,Y){var he=new ke(Y);return he.inlineTokens(Q)};var be=ke.prototype;return be.lex=function(Q){Q=Q.replace(/\r\n|\r/g,`
`),this.blockTokens(Q,this.tokens);for(var Y;Y=this.inlineQueue.shift();)this.inlineTokens(Y.src,Y.tokens);return this.tokens},be.blockTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]),this.options.pedantic?Q=Q.replace(/\t/g,"    ").replace(/^ +$/gm,""):Q=Q.replace(/^( *)(\t+)/gm,function(je,B,F){return B+"    ".repeat(F.length)});for(var ce,Te,fe,Pe;Q;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(je){return(ce=je.call({lexer:he},Q,Y))?(Q=Q.substring(ce.raw.length),Y.push(ce),!0):!1}))){if(ce=this.tokenizer.space(Q)){Q=Q.substring(ce.raw.length),ce.raw.length===1&&Y.length>0?Y[Y.length-1].raw+=`
`:Y.push(ce);continue}if(ce=this.tokenizer.code(Q)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ce.raw,Te.text+=`
`+ce.text,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(ce);continue}if(ce=this.tokenizer.fences(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.heading(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.hr(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.blockquote(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.list(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.html(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.def(Q)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&(Te.type==="paragraph"||Te.type==="text")?(Te.raw+=`
`+ce.raw,Te.text+=`
`+ce.raw,this.inlineQueue[this.inlineQueue.length-1].src=Te.text):this.tokens.links[ce.tag]||(this.tokens.links[ce.tag]={href:ce.href,title:ce.title});continue}if(ce=this.tokenizer.table(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.lheading(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(fe=Q,this.options.extensions&&this.options.extensions.startBlock&&function(){var je=1/0,B=Q.slice(1),F=void 0;he.options.extensions.startBlock.forEach(function(H){F=H.call({lexer:this},B),typeof F=="number"&&F>=0&&(je=Math.min(je,F))}),je<1/0&&je>=0&&(fe=Q.substring(0,je+1))}(),this.state.top&&(ce=this.tokenizer.paragraph(fe))){Te=Y[Y.length-1],Pe&&Te.type==="paragraph"?(Te.raw+=`
`+ce.raw,Te.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(ce),Pe=fe.length!==Q.length,Q=Q.substring(ce.raw.length);continue}if(ce=this.tokenizer.text(Q)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=`
`+ce.raw,Te.text+=`
`+ce.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=Te.text):Y.push(ce);continue}if(Q){var Re="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(Re);break}else throw new Error(Re)}}return this.state.top=!0,Y},be.inline=function(Q,Y){return Y===void 0&&(Y=[]),this.inlineQueue.push({src:Q,tokens:Y}),Y},be.inlineTokens=function(Q,Y){var he=this;Y===void 0&&(Y=[]);var ce,Te,fe,Pe=Q,Re,je,B;if(this.tokens.links){var F=Object.keys(this.tokens.links);if(F.length>0)for(;(Re=this.tokenizer.rules.inline.reflinkSearch.exec(Pe))!=null;)F.includes(Re[0].slice(Re[0].lastIndexOf("[")+1,-1))&&(Pe=Pe.slice(0,Re.index)+"["+I("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(Re=this.tokenizer.rules.inline.blockSkip.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"["+I("a",Re[0].length-2)+"]"+Pe.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(Re=this.tokenizer.rules.inline.escapedEmSt.exec(Pe))!=null;)Pe=Pe.slice(0,Re.index)+"++"+Pe.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;Q;)if(je||(B=""),je=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(G){return(ce=G.call({lexer:he},Q,Y))?(Q=Q.substring(ce.raw.length),Y.push(ce),!0):!1}))){if(ce=this.tokenizer.escape(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.tag(Q)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&ce.type==="text"&&Te.type==="text"?(Te.raw+=ce.raw,Te.text+=ce.text):Y.push(ce);continue}if(ce=this.tokenizer.link(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.reflink(Q,this.tokens.links)){Q=Q.substring(ce.raw.length),Te=Y[Y.length-1],Te&&ce.type==="text"&&Te.type==="text"?(Te.raw+=ce.raw,Te.text+=ce.text):Y.push(ce);continue}if(ce=this.tokenizer.emStrong(Q,Pe,B)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.codespan(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.br(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.del(Q)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(ce=this.tokenizer.autolink(Q,K)){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(!this.state.inLink&&(ce=this.tokenizer.url(Q,K))){Q=Q.substring(ce.raw.length),Y.push(ce);continue}if(fe=Q,this.options.extensions&&this.options.extensions.startInline&&function(){var G=1/0,te=Q.slice(1),re=void 0;he.options.extensions.startInline.forEach(function(Oe){re=Oe.call({lexer:this},te),typeof re=="number"&&re>=0&&(G=Math.min(G,re))}),G<1/0&&G>=0&&(fe=Q.substring(0,G+1))}(),ce=this.tokenizer.inlineText(fe,z)){Q=Q.substring(ce.raw.length),ce.raw.slice(-1)!=="_"&&(B=ce.raw.slice(-1)),je=!0,Te=Y[Y.length-1],Te&&Te.type==="text"?(Te.raw+=ce.raw,Te.text+=ce.text):Y.push(ce);continue}if(Q){var H="Infinite loop on byte: "+Q.charCodeAt(0);if(this.options.silent){console.error(H);break}else throw new Error(H)}}return Y},C(ke,null,[{key:"rules",get:function(){return{block:q,inline:R}}}]),ke}(),de=function(){function ke(me){this.options=me||le.defaults}var be=ke.prototype;return be.code=function(Q,Y,he){var ce=(Y||"").match(/\S*/)[0];if(this.options.highlight){var Te=this.options.highlight(Q,ce);Te!=null&&Te!==Q&&(he=!0,Q=Te)}return Q=Q.replace(/\n$/,"")+`
`,ce?'<pre><code class="'+this.options.langPrefix+f(ce,!0)+'">'+(he?Q:f(Q,!0))+`</code></pre>
`:"<pre><code>"+(he?Q:f(Q,!0))+`</code></pre>
`},be.blockquote=function(Q){return`<blockquote>
`+Q+`</blockquote>
`},be.html=function(Q){return Q},be.heading=function(Q,Y,he,ce){if(this.options.headerIds){var Te=this.options.headerPrefix+ce.slug(he);return"<h"+Y+' id="'+Te+'">'+Q+"</h"+Y+`>
`}return"<h"+Y+">"+Q+"</h"+Y+`>
`},be.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},be.list=function(Q,Y,he){var ce=Y?"ol":"ul",Te=Y&&he!==1?' start="'+he+'"':"";return"<"+ce+Te+`>
`+Q+"</"+ce+`>
`},be.listitem=function(Q){return"<li>"+Q+`</li>
`},be.checkbox=function(Q){return"<input "+(Q?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},be.paragraph=function(Q){return"<p>"+Q+`</p>
`},be.table=function(Q,Y){return Y&&(Y="<tbody>"+Y+"</tbody>"),`<table>
<thead>
`+Q+`</thead>
`+Y+`</table>
`},be.tablerow=function(Q){return`<tr>
`+Q+`</tr>
`},be.tablecell=function(Q,Y){var he=Y.header?"th":"td",ce=Y.align?"<"+he+' align="'+Y.align+'">':"<"+he+">";return ce+Q+("</"+he+`>
`)},be.strong=function(Q){return"<strong>"+Q+"</strong>"},be.em=function(Q){return"<em>"+Q+"</em>"},be.codespan=function(Q){return"<code>"+Q+"</code>"},be.br=function(){return this.options.xhtml?"<br/>":"<br>"},be.del=function(Q){return"<del>"+Q+"</del>"},be.link=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ce='<a href="'+f(Q)+'"';return Y&&(ce+=' title="'+Y+'"'),ce+=">"+he+"</a>",ce},be.image=function(Q,Y,he){if(Q=u(this.options.sanitize,this.options.baseUrl,Q),Q===null)return he;var ce='<img src="'+Q+'" alt="'+he+'"';return Y&&(ce+=' title="'+Y+'"'),ce+=this.options.xhtml?"/>":">",ce},be.text=function(Q){return Q},ke}(),ye=function(){function ke(){}var be=ke.prototype;return be.strong=function(Q){return Q},be.em=function(Q){return Q},be.codespan=function(Q){return Q},be.del=function(Q){return Q},be.html=function(Q){return Q},be.text=function(Q){return Q},be.link=function(Q,Y,he){return""+he},be.image=function(Q,Y,he){return""+he},be.br=function(){return""},ke}(),De=function(){function ke(){this.seen={}}var be=ke.prototype;return be.serialize=function(Q){return Q.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},be.getNextSafeSlug=function(Q,Y){var he=Q,ce=0;if(this.seen.hasOwnProperty(he)){ce=this.seen[Q];do ce++,he=Q+"-"+ce;while(this.seen.hasOwnProperty(he))}return Y||(this.seen[Q]=ce,this.seen[he]=0),he},be.slug=function(Q,Y){Y===void 0&&(Y={});var he=this.serialize(Q);return this.getNextSafeSlug(he,Y.dryrun)},ke}(),ge=function(){function ke(me){this.options=me||le.defaults,this.options.renderer=this.options.renderer||new de,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ye,this.slugger=new De}ke.parse=function(Q,Y){var he=new ke(Y);return he.parse(Q)},ke.parseInline=function(Q,Y){var he=new ke(Y);return he.parseInline(Q)};var be=ke.prototype;return be.parse=function(Q,Y){Y===void 0&&(Y=!0);var he="",ce,Te,fe,Pe,Re,je,B,F,H,G,te,re,Oe,Be,Ge,_e,xe,et,tt,it=Q.length;for(ce=0;ce<it;ce++){if(G=Q[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[G.type]&&(tt=this.options.extensions.renderers[G.type].call({parser:this},G),tt!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(G.type))){he+=tt||"";continue}switch(G.type){case"space":continue;case"hr":{he+=this.renderer.hr();continue}case"heading":{he+=this.renderer.heading(this.parseInline(G.tokens),G.depth,r(this.parseInline(G.tokens,this.textRenderer)),this.slugger);continue}case"code":{he+=this.renderer.code(G.text,G.lang,G.escaped);continue}case"table":{for(F="",B="",Pe=G.header.length,Te=0;Te<Pe;Te++)B+=this.renderer.tablecell(this.parseInline(G.header[Te].tokens),{header:!0,align:G.align[Te]});for(F+=this.renderer.tablerow(B),H="",Pe=G.rows.length,Te=0;Te<Pe;Te++){for(je=G.rows[Te],B="",Re=je.length,fe=0;fe<Re;fe++)B+=this.renderer.tablecell(this.parseInline(je[fe].tokens),{header:!1,align:G.align[fe]});H+=this.renderer.tablerow(B)}he+=this.renderer.table(F,H);continue}case"blockquote":{H=this.parse(G.tokens),he+=this.renderer.blockquote(H);continue}case"list":{for(te=G.ordered,re=G.start,Oe=G.loose,Pe=G.items.length,H="",Te=0;Te<Pe;Te++)Ge=G.items[Te],_e=Ge.checked,xe=Ge.task,Be="",Ge.task&&(et=this.renderer.checkbox(_e),Oe?Ge.tokens.length>0&&Ge.tokens[0].type==="paragraph"?(Ge.tokens[0].text=et+" "+Ge.tokens[0].text,Ge.tokens[0].tokens&&Ge.tokens[0].tokens.length>0&&Ge.tokens[0].tokens[0].type==="text"&&(Ge.tokens[0].tokens[0].text=et+" "+Ge.tokens[0].tokens[0].text)):Ge.tokens.unshift({type:"text",text:et}):Be+=et),Be+=this.parse(Ge.tokens,Oe),H+=this.renderer.listitem(Be,xe,_e);he+=this.renderer.list(H,te,re);continue}case"html":{he+=this.renderer.html(G.text);continue}case"paragraph":{he+=this.renderer.paragraph(this.parseInline(G.tokens));continue}case"text":{for(H=G.tokens?this.parseInline(G.tokens):G.text;ce+1<it&&Q[ce+1].type==="text";)G=Q[++ce],H+=`
`+(G.tokens?this.parseInline(G.tokens):G.text);he+=Y?this.renderer.paragraph(H):H;continue}default:{var at='Token with "'+G.type+'" type was not found.';if(this.options.silent){console.error(at);return}else throw new Error(at)}}}return he},be.parseInline=function(Q,Y){Y=Y||this.renderer;var he="",ce,Te,fe,Pe=Q.length;for(ce=0;ce<Pe;ce++){if(Te=Q[ce],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[Te.type]&&(fe=this.options.extensions.renderers[Te.type].call({parser:this},Te),fe!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(Te.type))){he+=fe||"";continue}switch(Te.type){case"escape":{he+=Y.text(Te.text);break}case"html":{he+=Y.html(Te.text);break}case"link":{he+=Y.link(Te.href,Te.title,this.parseInline(Te.tokens,Y));break}case"image":{he+=Y.image(Te.href,Te.title,Te.text);break}case"strong":{he+=Y.strong(this.parseInline(Te.tokens,Y));break}case"em":{he+=Y.em(this.parseInline(Te.tokens,Y));break}case"codespan":{he+=Y.codespan(Te.text);break}case"br":{he+=Y.br();break}case"del":{he+=Y.del(this.parseInline(Te.tokens,Y));break}case"text":{he+=Y.text(Te.text);break}default:{var Re='Token with "'+Te.type+'" type was not found.';if(this.options.silent){console.error(Re);return}else throw new Error(Re)}}}return he},ke}();function ue(ke,be,me){if(typeof ke>"u"||ke===null)throw new Error("marked(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");if(typeof be=="function"&&(me=be,be=null),be=v({},ue.defaults,be||{}),k(be),me){var Q=be.highlight,Y;try{Y=ie.lex(ke,be)}catch(Pe){return me(Pe)}var he=function(Re){var je;if(!Re)try{be.walkTokens&&ue.walkTokens(Y,be.walkTokens),je=ge.parse(Y,be)}catch(B){Re=B}return be.highlight=Q,Re?me(Re):me(null,je)};if(!Q||Q.length<3||(delete be.highlight,!Y.length))return he();var ce=0;ue.walkTokens(Y,function(Pe){Pe.type==="code"&&(ce++,setTimeout(function(){Q(Pe.text,Pe.lang,function(Re,je){if(Re)return he(Re);je!=null&&je!==Pe.text&&(Pe.text=je,Pe.escaped=!0),ce--,ce===0&&he()})},0))}),ce===0&&he();return}function Te(Pe){if(Pe.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+f(Pe.message+"",!0)+"</pre>";throw Pe}try{var fe=ie.lex(ke,be);if(be.walkTokens){if(be.async)return Promise.all(ue.walkTokens(fe,be.walkTokens)).then(function(){return ge.parse(fe,be)}).catch(Te);ue.walkTokens(fe,be.walkTokens)}return ge.parse(fe,be)}catch(Pe){Te(Pe)}}ue.options=ue.setOptions=function(ke){return v(ue.defaults,ke),p(ue.defaults),ue},ue.getDefaults=A,ue.defaults=le.defaults,ue.use=function(){for(var ke=arguments.length,be=new Array(ke),me=0;me<ke;me++)be[me]=arguments[me];var Q=v.apply(void 0,[{}].concat(be)),Y=ue.defaults.extensions||{renderers:{},childTokens:{}},he;be.forEach(function(ce){if(ce.extensions&&(he=!0,ce.extensions.forEach(function(fe){if(!fe.name)throw new Error("extension name required");if(fe.renderer){var Pe=Y.renderers?Y.renderers[fe.name]:null;Pe?Y.renderers[fe.name]=function(){for(var Re=arguments.length,je=new Array(Re),B=0;B<Re;B++)je[B]=arguments[B];var F=fe.renderer.apply(this,je);return F===!1&&(F=Pe.apply(this,je)),F}:Y.renderers[fe.name]=fe.renderer}if(fe.tokenizer){if(!fe.level||fe.level!=="block"&&fe.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");Y[fe.level]?Y[fe.level].unshift(fe.tokenizer):Y[fe.level]=[fe.tokenizer],fe.start&&(fe.level==="block"?Y.startBlock?Y.startBlock.push(fe.start):Y.startBlock=[fe.start]:fe.level==="inline"&&(Y.startInline?Y.startInline.push(fe.start):Y.startInline=[fe.start]))}fe.childTokens&&(Y.childTokens[fe.name]=fe.childTokens)})),ce.renderer&&function(){var fe=ue.defaults.renderer||new de,Pe=function(B){var F=fe[B];fe[B]=function(){for(var H=arguments.length,G=new Array(H),te=0;te<H;te++)G[te]=arguments[te];var re=ce.renderer[B].apply(fe,G);return re===!1&&(re=F.apply(fe,G)),re}};for(var Re in ce.renderer)Pe(Re);Q.renderer=fe}(),ce.tokenizer&&function(){var fe=ue.defaults.tokenizer||new W,Pe=function(B){var F=fe[B];fe[B]=function(){for(var H=arguments.length,G=new Array(H),te=0;te<H;te++)G[te]=arguments[te];var re=ce.tokenizer[B].apply(fe,G);return re===!1&&(re=F.apply(fe,G)),re}};for(var Re in ce.tokenizer)Pe(Re);Q.tokenizer=fe}(),ce.walkTokens){var Te=ue.defaults.walkTokens;Q.walkTokens=function(fe){var Pe=[];return Pe.push(ce.walkTokens.call(this,fe)),Te&&(Pe=Pe.concat(Te.call(this,fe))),Pe}}he&&(Q.extensions=Y),ue.setOptions(Q)})},ue.walkTokens=function(ke,be){for(var me=[],Q=function(){var Te=he.value;switch(me=me.concat(be.call(ue,Te)),Te.type){case"table":{for(var fe=T(Te.header),Pe;!(Pe=fe()).done;){var Re=Pe.value;me=me.concat(ue.walkTokens(Re.tokens,be))}for(var je=T(Te.rows),B;!(B=je()).done;)for(var F=B.value,H=T(F),G;!(G=H()).done;){var te=G.value;me=me.concat(ue.walkTokens(te.tokens,be))}break}case"list":{me=me.concat(ue.walkTokens(Te.items,be));break}default:ue.defaults.extensions&&ue.defaults.extensions.childTokens&&ue.defaults.extensions.childTokens[Te.type]?ue.defaults.extensions.childTokens[Te.type].forEach(function(re){me=me.concat(ue.walkTokens(Te[re],be))}):Te.tokens&&(me=me.concat(ue.walkTokens(Te.tokens,be)))}},Y=T(ke),he;!(he=Y()).done;)Q();return me},ue.parseInline=function(ke,be){if(typeof ke>"u"||ke===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof ke!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(ke)+", string expected");be=v({},ue.defaults,be||{}),k(be);try{var me=ie.lexInline(ke,be);return be.walkTokens&&ue.walkTokens(me,be.walkTokens),ge.parseInline(me,be)}catch(Q){if(Q.message+=`
Please report this to https://github.com/markedjs/marked.`,be.silent)return"<p>An error occurred:</p><pre>"+f(Q.message+"",!0)+"</pre>";throw Q}},ue.Parser=ge,ue.parser=ge.parse,ue.Renderer=de,ue.TextRenderer=ye,ue.Lexer=ie,ue.lexer=ie.lex,ue.Tokenizer=W,ue.Slugger=De,ue.parse=ue;var Ce=ue.options,se=ue.setOptions,Ne=ue.use,ne=ue.walkTokens,U=ue.parseInline,x=ue,ve=ge.parse,Le=ie.lex;le.Lexer=ie,le.Parser=ge,le.Renderer=de,le.Slugger=De,le.TextRenderer=ye,le.Tokenizer=W,le.getDefaults=A,le.lexer=Le,le.marked=ue,le.options=Ce,le.parse=x,le.parseInline=U,le.parser=ve,le.setOptions=se,le.use=Ne,le.walkTokens=ne,Object.defineProperty(le,"__esModule",{value:!0})}),define(Se[128],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xk=C;function C(o){const r=T(o);if(r&&r.length>0)return new Uint32Array(r)}let N=0;const M=new Uint32Array(10);function T(o){if(N=0,A(o,S,4352),N>0||(A(o,d,4449),N>0)||(A(o,w,4520),N>0)||(A(o,f,12593),N))return M.subarray(0,N);if(o>=44032&&o<=55203){const r=o-44032,s=r%588,n=Math.floor(r/588),t=Math.floor(s/28),c=s%28-1;if(n<S.length?A(n,S,0):4352+n-12593<f.length&&A(4352+n,f,12593),t<d.length?A(t,d,0):4449+t-12593<f.length&&A(4449+t-12593,f,12593),c>=0&&(c<w.length?A(c,w,0):4520+c-12593<f.length&&A(4520+c-12593,f,12593)),N>0)return M.subarray(0,N)}}function A(o,r,s){o>=s&&o<s+r.length&&p(r[o-s])}function p(o){o!==0&&(M[N++]=o&255,o>>8&&(M[N++]=o>>8&255),o>>16&&(M[N++]=o>>16&255))}var m;(function(o){o[o.InitialConsonant=4352]="InitialConsonant",o[o.Vowel=4449]="Vowel",o[o.FinalConsonant=4520]="FinalConsonant",o[o.CompatibilityJamo=12593]="CompatibilityJamo"})(m||(m={}));var D;(function(o){o[o.NUL=0]="NUL",o[o.A=65]="A",o[o.B=66]="B",o[o.C=67]="C",o[o.D=68]="D",o[o.E=69]="E",o[o.F=70]="F",o[o.G=71]="G",o[o.H=72]="H",o[o.I=73]="I",o[o.J=74]="J",o[o.K=75]="K",o[o.L=76]="L",o[o.M=77]="M",o[o.N=78]="N",o[o.O=79]="O",o[o.P=80]="P",o[o.Q=81]="Q",o[o.R=82]="R",o[o.S=83]="S",o[o.T=84]="T",o[o.U=85]="U",o[o.V=86]="V",o[o.W=87]="W",o[o.X=88]="X",o[o.Y=89]="Y",o[o.Z=90]="Z",o[o.a=97]="a",o[o.b=98]="b",o[o.c=99]="c",o[o.d=100]="d",o[o.e=101]="e",o[o.f=102]="f",o[o.g=103]="g",o[o.h=104]="h",o[o.i=105]="i",o[o.j=106]="j",o[o.k=107]="k",o[o.l=108]="l",o[o.m=109]="m",o[o.n=110]="n",o[o.o=111]="o",o[o.p=112]="p",o[o.q=113]="q",o[o.r=114]="r",o[o.s=115]="s",o[o.t=116]="t",o[o.u=117]="u",o[o.v=118]="v",o[o.w=119]="w",o[o.x=120]="x",o[o.y=121]="y",o[o.z=122]="z"})(D||(D={}));var O;(function(o){o[o.fa=24934]="fa",o[o.fg=26470]="fg",o[o.fq=29030]="fq",o[o.fr=29286]="fr",o[o.ft=29798]="ft",o[o.fv=30310]="fv",o[o.fx=30822]="fx",o[o.hk=27496]="hk",o[o.hl=27752]="hl",o[o.ho=28520]="ho",o[o.ml=27757]="ml",o[o.nj=27246]="nj",o[o.nl=27758]="nl",o[o.np=28782]="np",o[o.qt=29809]="qt",o[o.rt=29810]="rt",o[o.sg=26483]="sg",o[o.sw=30579]="sw"})(O||(O={}));const S=new Uint8Array([114,82,115,101,69,102,97,113,81,116,84,100,119,87,99,122,120,118,103]),d=new Uint16Array([107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108]),w=new Uint16Array([114,82,29810,115,30579,26483,101,102,29286,24934,29030,29798,30822,30310,26470,97,113,29809,116,84,100,119,99,122,120,118,103]),f=new Uint16Array([114,82,29810,115,30579,26483,101,69,102,29286,24934,29030,29798,30822,30310,26470,97,113,81,29809,116,84,100,119,87,99,122,120,118,103,107,111,105,79,106,112,117,80,104,27496,28520,27752,121,110,27246,28782,27758,98,109,27757,108])}),define(Se[129],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hm=e.$Gm=e.$Fm=void 0,e.$Dm=C,e.rot=N;function C(p,m,D){return Math.min(Math.max(p,m),D)}function N(p,m){return(m+p%m)%m}class M{constructor(){this.a=0}getNext(){return this.a++}}e.$Fm=M;class T{constructor(){this.a=1,this.b=0}update(m){return this.b=this.b+(m-this.b)/this.a,this.a+=1,this.b}get value(){return this.b}}e.$Gm=T;class A{constructor(m){this.a=0,this.b=0,this.c=[],this.d=0,this.e=0,this.c=new Array(m),this.c.fill(0,0,m)}update(m){const D=this.c[this.d];return this.c[this.d]=m,this.d=(this.d+1)%this.c.length,this.e-=D,this.e+=m,this.a<this.c.length&&(this.a+=1),this.b=this.e/this.a,this.b}get value(){return this.b}}e.$Hm=A}),define(Se[130],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ad=void 0,e.$bd=T,e.$cd=d;class C{constructor(f,o,r){this.owner=f,this.debugNameSource=o,this.referenceFn=r}getDebugName(f){return T(f,this)}}e.$ad=C;const N=new Map,M=new WeakMap;function T(w,f){const o=M.get(w);if(o)return o;const r=A(w,f);if(r){let s=N.get(r)??0;s++,N.set(r,s);const n=s===1?r:`${r}#${s}`;return M.set(w,n),n}}function A(w,f){const o=M.get(w);if(o)return o;const r=f.owner?O(f.owner)+".":"";let s;const n=f.debugNameSource;if(n!==void 0)if(typeof n=="function"){if(s=n(),s!==void 0)return r+s}else return r+n;const t=f.referenceFn;if(t!==void 0&&(s=d(t),s!==void 0))return r+s;if(f.owner!==void 0){const c=p(f.owner,w);if(c!==void 0)return r+c}}function p(w,f){for(const o in w)if(w[o]===f)return o}const m=new Map,D=new WeakMap;function O(w){const f=D.get(w);if(f)return f;const o=S(w);let r=m.get(o)??0;r++,m.set(o,r);const s=r===1?o:`${o}#${r}`;return D.set(w,s),s}function S(w){const f=w.constructor;return f?f.name:"Object"}function d(w){const f=w.toString(),r=/\/\*\*\s*@description\s*([^*]*)\*\//.exec(f);return(r?r[1]:void 0)?.trim()}}),define(Se[131],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jd=void 0,e.$Hd=N,e.$Id=M;let C;function N(o){C=o}function M(){return C}class T{constructor(){this.a=0,this.d=new WeakMap}b(r){return A([p(w("|  ",this.a)),r])}c(r){return r.hadValue?r.didChange?[p(" "),D(O(r.oldValue,70),{color:"red",strikeThrough:!0}),p(" "),D(O(r.newValue,60),{color:"green"})]:[p(" (unchanged)")]:[p(" "),D(O(r.newValue,60),{color:"green"}),p(" (initial)")]}handleObservableChanged(r,s){console.log(...this.b([m("observable value changed"),D(r.debugName,{color:"BlueViolet"}),...this.c(s)]))}formatChanges(r){if(r.size!==0)return D(" (changed deps: "+[...r].map(s=>s.debugName).join(", ")+")",{color:"gray"})}handleDerivedCreated(r){const s=r.handleChange;this.d.set(r,new Set),r.handleChange=(n,t)=>(this.d.get(r).add(n),s.apply(r,[n,t]))}handleDerivedRecomputed(r,s){const n=this.d.get(r);console.log(...this.b([m("derived recomputed"),D(r.debugName,{color:"BlueViolet"}),...this.c(s),this.formatChanges(n),{data:[{fn:r._computeFn}]}])),n.clear()}handleFromEventObservableTriggered(r,s){console.log(...this.b([m("observable from event triggered"),D(r.debugName,{color:"BlueViolet"}),...this.c(s),{data:[{fn:r._getValue}]}]))}handleAutorunCreated(r){const s=r.handleChange;this.d.set(r,new Set),r.handleChange=(n,t)=>(this.d.get(r).add(n),s.apply(r,[n,t]))}handleAutorunTriggered(r){const s=this.d.get(r);console.log(...this.b([m("autorun"),D(r.debugName,{color:"BlueViolet"}),this.formatChanges(s),{data:[{fn:r._runFn}]}])),s.clear(),this.a++}handleAutorunFinished(r){this.a--}handleBeginTransaction(r){let s=r.getDebugName();s===void 0&&(s=""),console.log(...this.b([m("transaction"),D(s,{color:"BlueViolet"}),{data:[{fn:r._fn}]}])),this.a++}handleEndTransaction(){this.a--}}e.$Jd=T;function A(o){const r=new Array,s=[];let n="";function t(u){if("length"in u)for(const i of u)i&&t(i);else"text"in u?(n+=`%c${u.text}`,r.push(u.style),u.data&&s.push(...u.data)):"data"in u&&s.push(...u.data)}t(o);const c=[n,...r];return c.push(...s),c}function p(o){return D(o,{color:"black"})}function m(o){return D(f(`${o}: `,10),{color:"black",bold:!0})}function D(o,r={color:"black"}){function s(t){return Object.entries(t).reduce((c,[u,i])=>`${c}${u}:${i};`,"")}const n={color:r.color};return r.strikeThrough&&(n["text-decoration"]="line-through"),r.bold&&(n["font-weight"]="bold"),{text:o,style:s(n)}}function O(o,r){switch(typeof o){case"number":return""+o;case"string":return o.length+2<=r?`"${o}"`:`"${o.substr(0,r-7)}"+...`;case"boolean":return o?"true":"false";case"undefined":return"undefined";case"object":return o===null?"null":Array.isArray(o)?S(o,r):d(o,r);case"symbol":return o.toString();case"function":return`[[Function${o.name?" "+o.name:""}]]`;default:return""+o}}function S(o,r){let s="[ ",n=!0;for(const t of o){if(n||(s+=", "),s.length-5>r){s+="...";break}n=!1,s+=`${O(t,r-s.length)}`}return s+=" ]",s}function d(o,r){let s="{ ",n=!0;for(const[t,c]of Object.entries(o)){if(n||(s+=", "),s.length-5>r){s+="...";break}n=!1,s+=`${t}: ${O(c,r-s.length)}`}return s+=" }",s}function w(o,r){let s="";for(let n=1;n<=r;n++)s+=o;return s}function f(o,r){for(;o.length<r;)o+=" ";return o}}),define(Se[132],Ie([1,0,125,130,131]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7d=e.$5d=e.$2d=e.$Wd=e.$Vd=void 0,e.$Sd=A,e.$Td=m,e.$Ud=O,e.$Xd=w,e.$Yd=o,e.$Zd=r,e.$1d=s,e.$3d=t,e.$4d=c,e.$6d=i;let T;function A(a){T=a}let p;function m(a){p=a}let D;function O(a){D=a}class S{get TChange(){return null}reportChanges(){this.get()}read(l){return l?l.readObservable(this):this.get()}map(l,g){const $=g===void 0?void 0:l,v=g===void 0?l:g;return D({owner:$,debugName:()=>{const y=(0,N.$cd)(v);if(y!==void 0)return y;const E=/^\s*\(?\s*([a-zA-Z_$][a-zA-Z_$0-9]*)\s*\)?\s*=>\s*\1(?:\??)\.([a-zA-Z_$][a-zA-Z_$0-9]*)\s*$/.exec(v.toString());if(E)return`${this.debugName}.${E[2]}`;if(!$)return`${this.debugName} (mapped)`},debugReferenceFn:v},y=>v(this.read(y),y))}recomputeInitiallyAndOnChange(l,g){return l.add(T(this,g)),this}keepObserved(l){return l.add(p(this)),this}get a(){return this.get()}}e.$Vd=S;class d extends S{constructor(){super(...arguments),this.b=new Set}addObserver(l){const g=this.b.size;this.b.add(l),g===0&&this.c()}removeObserver(l){this.b.delete(l)&&this.b.size===0&&this.f()}c(){}f(){}}e.$Wd=d;function w(a,l){const g=new n(a,l);try{a(g)}finally{g.finish()}}let f;function o(a){if(f)a(f);else{const l=new n(a,void 0);f=l;try{a(l)}finally{l.finish(),f=void 0}}}async function r(a,l){const g=new n(a,l);try{await a(g)}finally{g.finish()}}function s(a,l,g){a?l(a):w(l,g)}class n{constructor(l,g){this._fn=l,this.b=g,this.a=[],(0,M.$Id)()?.handleBeginTransaction(this)}getDebugName(){return this.b?this.b():(0,N.$cd)(this._fn)}updateObserver(l,g){this.a.push({observer:l,observable:g}),l.beginUpdate(g)}finish(){const l=this.a;for(let g=0;g<l.length;g++){const{observer:$,observable:v}=l[g];$.endUpdate(v)}this.a=null,(0,M.$Id)()?.handleEndTransaction()}}e.$2d=n;function t(a,l){let g;return typeof a=="string"?g=new N.$ad(void 0,a,void 0):g=new N.$ad(a,void 0,void 0),new u(g,l,C.$6c)}function c(a,l){return new u(new N.$ad(a.owner,a.debugName,void 0),l,a.equalsFn??C.$6c)}class u extends d{get debugName(){return this.e.getDebugName(this)??"ObservableValue"}constructor(l,g,$){super(),this.e=l,this.g=$,this.d=g}get(){return this.d}set(l,g,$){if($===void 0&&this.g(this.d,l))return;let v;g||(g=v=new n(()=>{},()=>`Setting ${this.debugName}`));try{const y=this.d;this.h(l),(0,M.$Id)()?.handleObservableChanged(this,{oldValue:y,newValue:l,change:$,didChange:!0,hadValue:!0});for(const h of this.b)g.updateObserver(h,this),h.handleChange(this,$)}finally{v&&v.finish()}}toString(){return`${this.debugName}: ${this.d}`}h(l){this.d=l}}e.$5d=u;function i(a,l){let g;return typeof a=="string"?g=new N.$ad(void 0,a,void 0):g=new N.$ad(a,void 0,void 0),new b(g,l,C.$6c)}class b extends u{h(l){this.d!==l&&(this.d&&this.d.dispose(),this.d=l)}dispose(){this.d?.dispose()}}e.$7d=b}),function(){function le(M){const T=[];typeof M=="number"&&T.push("code/timeOrigin",M);function A(m){T.push(m,Date.now())}function p(){const m=[];for(let D=0;D<T.length;D+=2)m.push({name:T[D],startTime:T[D+1]});return m}return{mark:A,getMarks:p}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?le():{mark(M){performance.mark(M)},getMarks(){let M=performance.timeOrigin;typeof M!="number"&&(M=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const T=[{name:"code/timeOrigin",startTime:Math.round(M)}];for(const A of performance.getEntriesByType("mark"))T.push({name:A.name,startTime:Math.round(M+A.startTime)});return T}};if(typeof process=="object"){const M=performance?.timeOrigin??Math.round((require.__$__nodeRequire||require)("perf_hooks").performance.timeOrigin);return le(M)}else return console.trace("perf-util loaded in UNKNOWN environment"),le()}function C(M){return M.MonacoPerformanceMarks||(M.MonacoPerformanceMarks=e()),M.MonacoPerformanceMarks}var N;typeof global=="object"?N=global:typeof self=="object"?N=self:N={},typeof define=="function"?define("vs/base/common/performance",[],function(){return C(N)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=C(N):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),N.perf=C(N))}(),define(Se[133],Ie([1,0,42]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EO=void 0;const N=Symbol("unset");class M{constructor(){this.a=new A,this.b=0}get size(){return this.b}get nodes(){return this.a.children?.values()||C.Iterable.empty()}insert(m,D,O){this.d(m,S=>S._value=D,O)}mutate(m,D){this.d(m,O=>O._value=D(O._value===N?void 0:O._value))}mutatePath(m,D){this.d(m,()=>{},O=>D(O))}delete(m){const D=this.c(m);if(!D)return;let O=D.length-1;const S=D[O].node._value;if(S!==N){for(this.b--,D[O].node._value=N;O>0;O--){const{node:d,part:w}=D[O];if(d.children?.size||d._value!==N)break;D[O-1].node.children.delete(w)}return S}}*deleteRecursive(m){const D=this.c(m);if(!D)return;const O=D[D.length-1].node;for(let S=D.length-1;S>0;S--){const d=D[S-1];if(d.node.children.delete(D[S].part),d.node.children.size>0||d.node._value!==N)break}for(const S of T(O))S._value!==N&&(this.b--,yield S._value)}find(m){let D=this.a;for(const O of m){const S=D.children?.get(O);if(!S)return;D=S}return D._value===N?void 0:D._value}hasKeyOrParent(m){let D=this.a;for(const O of m){const S=D.children?.get(O);if(!S)return!1;if(S._value!==N)return!0;D=S}return!1}hasKeyOrChildren(m){let D=this.a;for(const O of m){const S=D.children?.get(O);if(!S)return!1;D=S}return!0}hasKey(m){let D=this.a;for(const O of m){const S=D.children?.get(O);if(!S)return!1;D=S}return D._value!==N}c(m){const D=[{part:"",node:this.a}];let O=0;for(const S of m){const d=D[O].node.children?.get(S);if(!d)return;D.push({part:S,node:d}),O++}return D}d(m,D,O){let S=this.a;for(const f of m){if(S.children)if(S.children.has(f))S=S.children.get(f);else{const o=new A;S.children.set(f,o),S=o}else{const o=new A;S.children=new Map([[f,o]]),S=o}O?.(S)}const d=S._value===N?0:1;D(S);const w=S._value===N?0:1;this.b+=w-d}*values(){for(const{_value:m}of T(this.a))m!==N&&(yield m)}}e.$EO=M;function*T(p){const m=[p];for(;m.length>0;){const D=m.pop();if(yield D,D.children)for(const O of D.children.values())m.push(O)}}class A{constructor(){this._value=N}get value(){return this._value===N?void 0:this._value}set value(m){this._value=m===void 0?N:m}}}),function(le,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var C=e();for(var N in C)(typeof exports=="object"?exports:le)[N]=C[N]}}(typeof self<"u"?self:this,function(){return function(le){var e={};function C(N){if(e[N])return e[N].exports;var M=e[N]={i:N,l:!1,exports:{}};return le[N].call(M.exports,M,M.exports,C),M.l=!0,M.exports}return C.m=le,C.c=e,C.d=function(N,M,T){C.o(N,M)||Object.defineProperty(N,M,{enumerable:!0,get:T})},C.r=function(N){typeof Symbol<"u"&&Symbol.toStringTag&&Object.defineProperty(N,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(N,"__esModule",{value:!0})},C.t=function(N,M){if(1&M&&(N=C(N)),8&M||4&M&&typeof N=="object"&&N&&N.__esModule)return N;var T=Object.create(null);if(C.r(T),Object.defineProperty(T,"default",{enumerable:!0,value:N}),2&M&&typeof N!="string")for(var A in N)C.d(T,A,function(p){return N[p]}.bind(null,A));return T},C.n=function(N){var M=N&&N.__esModule?function(){return N.default}:function(){return N};return C.d(M,"a",M),M},C.o=function(N,M){return Object.prototype.hasOwnProperty.call(N,M)},C.p="",C(C.s=0)}([function(le,e,C){(function(N){var M;e=le.exports=Ne,M=typeof N=="object"&&N.env&&N.env.NODE_DEBUG&&/\bsemver\b/i.test(N.env.NODE_DEBUG)?function(){var F=Array.prototype.slice.call(arguments,0);F.unshift("SEMVER"),console.log.apply(console,F)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var T=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,p=e.re=[],m=e.src=[],D=0,O=D++;m[O]="0|[1-9]\\d*";var S=D++;m[S]="[0-9]+";var d=D++;m[d]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var w=D++;m[w]="("+m[O]+")\\.("+m[O]+")\\.("+m[O]+")";var f=D++;m[f]="("+m[S]+")\\.("+m[S]+")\\.("+m[S]+")";var o=D++;m[o]="(?:"+m[O]+"|"+m[d]+")";var r=D++;m[r]="(?:"+m[S]+"|"+m[d]+")";var s=D++;m[s]="(?:-("+m[o]+"(?:\\."+m[o]+")*))";var n=D++;m[n]="(?:-?("+m[r]+"(?:\\."+m[r]+")*))";var t=D++;m[t]="[0-9A-Za-z-]+";var c=D++;m[c]="(?:\\+("+m[t]+"(?:\\."+m[t]+")*))";var u=D++,i="v?"+m[w]+m[s]+"?"+m[c]+"?";m[u]="^"+i+"$";var b="[v=\\s]*"+m[f]+m[n]+"?"+m[c]+"?",a=D++;m[a]="^"+b+"$";var l=D++;m[l]="((?:<|>)?=?)";var g=D++;m[g]=m[S]+"|x|X|\\*";var $=D++;m[$]=m[O]+"|x|X|\\*";var v=D++;m[v]="[v=\\s]*("+m[$]+")(?:\\.("+m[$]+")(?:\\.("+m[$]+")(?:"+m[s]+")?"+m[c]+"?)?)?";var y=D++;m[y]="[v=\\s]*("+m[g]+")(?:\\.("+m[g]+")(?:\\.("+m[g]+")(?:"+m[n]+")?"+m[c]+"?)?)?";var h=D++;m[h]="^"+m[l]+"\\s*"+m[v]+"$";var E=D++;m[E]="^"+m[l]+"\\s*"+m[y]+"$";var k=D++;m[k]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var I=D++;m[I]="(?:~>?)";var P=D++;m[P]="(\\s*)"+m[I]+"\\s+",p[P]=new RegExp(m[P],"g");var V=D++;m[V]="^"+m[I]+m[v]+"$";var W=D++;m[W]="^"+m[I]+m[y]+"$";var q=D++;m[q]="(?:\\^)";var R=D++;m[R]="(\\s*)"+m[q]+"\\s+",p[R]=new RegExp(m[R],"g");var z=D++;m[z]="^"+m[q]+m[v]+"$";var K=D++;m[K]="^"+m[q]+m[y]+"$";var ie=D++;m[ie]="^"+m[l]+"\\s*("+b+")$|^$";var de=D++;m[de]="^"+m[l]+"\\s*("+i+")$|^$";var ye=D++;m[ye]="(\\s*)"+m[l]+"\\s*("+b+"|"+m[v]+")",p[ye]=new RegExp(m[ye],"g");var De=D++;m[De]="^\\s*("+m[v]+")\\s+-\\s+("+m[v]+")\\s*$";var ge=D++;m[ge]="^\\s*("+m[y]+")\\s+-\\s+("+m[y]+")\\s*$";var ue=D++;m[ue]="(<|>)?=?\\s*\\*";for(var Ce=0;Ce<35;Ce++)M(Ce,m[Ce]),p[Ce]||(p[Ce]=new RegExp(m[Ce]));function se(F,H){if(F instanceof Ne)return F;if(typeof F!="string"||F.length>T||!(H?p[a]:p[u]).test(F))return null;try{return new Ne(F,H)}catch{return null}}function Ne(F,H){if(F instanceof Ne){if(F.loose===H)return F;F=F.version}else if(typeof F!="string")throw new TypeError("Invalid Version: "+F);if(F.length>T)throw new TypeError("version is longer than "+T+" characters");if(!(this instanceof Ne))return new Ne(F,H);M("SemVer",F,H),this.loose=H;var G=F.trim().match(H?p[a]:p[u]);if(!G)throw new TypeError("Invalid Version: "+F);if(this.raw=F,this.major=+G[1],this.minor=+G[2],this.patch=+G[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");G[4]?this.prerelease=G[4].split(".").map(function(te){if(/^[0-9]+$/.test(te)){var re=+te;if(re>=0&&re<A)return re}return te}):this.prerelease=[],this.build=G[5]?G[5].split("."):[],this.format()}e.parse=se,e.valid=function(F,H){var G=se(F,H);return G?G.version:null},e.clean=function(F,H){var G=se(F.trim().replace(/^[=v]+/,""),H);return G?G.version:null},e.SemVer=Ne,Ne.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},Ne.prototype.toString=function(){return this.version},Ne.prototype.compare=function(F){return M("SemVer.compare",this.version,this.loose,F),F instanceof Ne||(F=new Ne(F,this.loose)),this.compareMain(F)||this.comparePre(F)},Ne.prototype.compareMain=function(F){return F instanceof Ne||(F=new Ne(F,this.loose)),U(this.major,F.major)||U(this.minor,F.minor)||U(this.patch,F.patch)},Ne.prototype.comparePre=function(F){if(F instanceof Ne||(F=new Ne(F,this.loose)),this.prerelease.length&&!F.prerelease.length)return-1;if(!this.prerelease.length&&F.prerelease.length)return 1;if(!this.prerelease.length&&!F.prerelease.length)return 0;var H=0;do{var G=this.prerelease[H],te=F.prerelease[H];if(M("prerelease compare",H,G,te),G===void 0&&te===void 0)return 0;if(te===void 0)return 1;if(G===void 0)return-1;if(G!==te)return U(G,te)}while(++H)},Ne.prototype.inc=function(F,H){switch(F){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",H);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",H);break;case"prepatch":this.prerelease.length=0,this.inc("patch",H),this.inc("pre",H);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",H),this.inc("pre",H);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var G=this.prerelease.length;--G>=0;)typeof this.prerelease[G]=="number"&&(this.prerelease[G]++,G=-2);G===-1&&this.prerelease.push(0)}H&&(this.prerelease[0]===H?isNaN(this.prerelease[1])&&(this.prerelease=[H,0]):this.prerelease=[H,0]);break;default:throw new Error("invalid increment argument: "+F)}return this.format(),this.raw=this.version,this},e.inc=function(F,H,G,te){typeof G=="string"&&(te=G,G=void 0);try{return new Ne(F,G).inc(H,te).version}catch{return null}},e.diff=function(F,H){if(ke(F,H))return null;var G=se(F),te=se(H);if(G.prerelease.length||te.prerelease.length){for(var re in G)if((re==="major"||re==="minor"||re==="patch")&&G[re]!==te[re])return"pre"+re;return"prerelease"}for(var re in G)if((re==="major"||re==="minor"||re==="patch")&&G[re]!==te[re])return re},e.compareIdentifiers=U;var ne=/^[0-9]+$/;function U(F,H){var G=ne.test(F),te=ne.test(H);return G&&te&&(F=+F,H=+H),G&&!te?-1:te&&!G?1:F<H?-1:F>H?1:0}function x(F,H,G){return new Ne(F,G).compare(new Ne(H,G))}function ve(F,H,G){return x(F,H,G)>0}function Le(F,H,G){return x(F,H,G)<0}function ke(F,H,G){return x(F,H,G)===0}function be(F,H,G){return x(F,H,G)!==0}function me(F,H,G){return x(F,H,G)>=0}function Q(F,H,G){return x(F,H,G)<=0}function Y(F,H,G,te){var re;switch(H){case"===":typeof F=="object"&&(F=F.version),typeof G=="object"&&(G=G.version),re=F===G;break;case"!==":typeof F=="object"&&(F=F.version),typeof G=="object"&&(G=G.version),re=F!==G;break;case"":case"=":case"==":re=ke(F,G,te);break;case"!=":re=be(F,G,te);break;case">":re=ve(F,G,te);break;case">=":re=me(F,G,te);break;case"<":re=Le(F,G,te);break;case"<=":re=Q(F,G,te);break;default:throw new TypeError("Invalid operator: "+H)}return re}function he(F,H){if(F instanceof he){if(F.loose===H)return F;F=F.value}if(!(this instanceof he))return new he(F,H);M("comparator",F,H),this.loose=H,this.parse(F),this.semver===ce?this.value="":this.value=this.operator+this.semver.version,M("comp",this)}e.rcompareIdentifiers=function(F,H){return U(H,F)},e.major=function(F,H){return new Ne(F,H).major},e.minor=function(F,H){return new Ne(F,H).minor},e.patch=function(F,H){return new Ne(F,H).patch},e.compare=x,e.compareLoose=function(F,H){return x(F,H,!0)},e.rcompare=function(F,H,G){return x(H,F,G)},e.sort=function(F,H){return F.sort(function(G,te){return e.compare(G,te,H)})},e.rsort=function(F,H){return F.sort(function(G,te){return e.rcompare(G,te,H)})},e.gt=ve,e.lt=Le,e.eq=ke,e.neq=be,e.gte=me,e.lte=Q,e.cmp=Y,e.Comparator=he;var ce={};function Te(F,H){if(F instanceof Te)return F.loose===H?F:new Te(F.raw,H);if(F instanceof he)return new Te(F.value,H);if(!(this instanceof Te))return new Te(F,H);if(this.loose=H,this.raw=F,this.set=F.split(/\s*\|\|\s*/).map(function(G){return this.parseRange(G.trim())},this).filter(function(G){return G.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+F);this.format()}function fe(F){return!F||F.toLowerCase()==="x"||F==="*"}function Pe(F,H,G,te,re,Oe,Be,Ge,_e,xe,et,tt,it){return((H=fe(G)?"":fe(te)?">="+G+".0.0":fe(re)?">="+G+"."+te+".0":">="+H)+" "+(Ge=fe(_e)?"":fe(xe)?"<"+(+_e+1)+".0.0":fe(et)?"<"+_e+"."+(+xe+1)+".0":tt?"<="+_e+"."+xe+"."+et+"-"+tt:"<="+Ge)).trim()}function Re(F,H){for(var G=0;G<F.length;G++)if(!F[G].test(H))return!1;if(H.prerelease.length){for(G=0;G<F.length;G++)if(M(F[G].semver),F[G].semver!==ce&&F[G].semver.prerelease.length>0){var te=F[G].semver;if(te.major===H.major&&te.minor===H.minor&&te.patch===H.patch)return!0}return!1}return!0}function je(F,H,G){try{H=new Te(H,G)}catch{return!1}return H.test(F)}function B(F,H,G,te){var re,Oe,Be,Ge,_e;switch(F=new Ne(F,te),H=new Te(H,te),G){case">":re=ve,Oe=Q,Be=Le,Ge=">",_e=">=";break;case"<":re=Le,Oe=me,Be=ve,Ge="<",_e="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(je(F,H,te))return!1;for(var xe=0;xe<H.set.length;++xe){var et=H.set[xe],tt=null,it=null;if(et.forEach(function(at){at.semver===ce&&(at=new he(">=0.0.0")),tt=tt||at,it=it||at,re(at.semver,tt.semver,te)?tt=at:Be(at.semver,it.semver,te)&&(it=at)}),tt.operator===Ge||tt.operator===_e||(!it.operator||it.operator===Ge)&&Oe(F,it.semver)||it.operator===_e&&Be(F,it.semver))return!1}return!0}he.prototype.parse=function(F){var H=this.loose?p[ie]:p[de],G=F.match(H);if(!G)throw new TypeError("Invalid comparator: "+F);this.operator=G[1],this.operator==="="&&(this.operator=""),G[2]?this.semver=new Ne(G[2],this.loose):this.semver=ce},he.prototype.toString=function(){return this.value},he.prototype.test=function(F){return M("Comparator.test",F,this.loose),this.semver===ce||(typeof F=="string"&&(F=new Ne(F,this.loose)),Y(F,this.operator,this.semver,this.loose))},he.prototype.intersects=function(F,H){if(!(F instanceof he))throw new TypeError("a Comparator is required");var G;if(this.operator==="")return G=new Te(F.value,H),je(this.value,G,H);if(F.operator==="")return G=new Te(this.value,H),je(F.semver,G,H);var te=!(this.operator!==">="&&this.operator!==">"||F.operator!==">="&&F.operator!==">"),re=!(this.operator!=="<="&&this.operator!=="<"||F.operator!=="<="&&F.operator!=="<"),Oe=this.semver.version===F.semver.version,Be=!(this.operator!==">="&&this.operator!=="<="||F.operator!==">="&&F.operator!=="<="),Ge=Y(this.semver,"<",F.semver,H)&&(this.operator===">="||this.operator===">")&&(F.operator==="<="||F.operator==="<"),_e=Y(this.semver,">",F.semver,H)&&(this.operator==="<="||this.operator==="<")&&(F.operator===">="||F.operator===">");return te||re||Oe&&Be||Ge||_e},e.Range=Te,Te.prototype.format=function(){return this.range=this.set.map(function(F){return F.join(" ").trim()}).join("||").trim(),this.range},Te.prototype.toString=function(){return this.range},Te.prototype.parseRange=function(F){var H=this.loose;F=F.trim(),M("range",F,H);var G=H?p[ge]:p[De];F=F.replace(G,Pe),M("hyphen replace",F),F=F.replace(p[ye],"$1$2$3"),M("comparator trim",F,p[ye]),F=(F=(F=F.replace(p[P],"$1~")).replace(p[R],"$1^")).split(/\s+/).join(" ");var te=H?p[ie]:p[de],re=F.split(" ").map(function(Oe){return function(Be,Ge){return M("comp",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){M("caret",tt,it);var at=it?p[K]:p[z];return tt.replace(at,function(gt,Ue,rt,Z,X){var $e;return M("caret",tt,gt,Ue,rt,Z,X),fe(Ue)?$e="":fe(rt)?$e=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":fe(Z)?$e=Ue==="0"?">="+Ue+"."+rt+".0 <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+".0 <"+(+Ue+1)+".0.0":X?(M("replaceCaret pr",X),X.charAt(0)!=="-"&&(X="-"+X),$e=Ue==="0"?rt==="0"?">="+Ue+"."+rt+"."+Z+X+" <"+Ue+"."+rt+"."+(+Z+1):">="+Ue+"."+rt+"."+Z+X+" <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+"."+Z+X+" <"+(+Ue+1)+".0.0"):(M("no pr"),$e=Ue==="0"?rt==="0"?">="+Ue+"."+rt+"."+Z+" <"+Ue+"."+rt+"."+(+Z+1):">="+Ue+"."+rt+"."+Z+" <"+Ue+"."+(+rt+1)+".0":">="+Ue+"."+rt+"."+Z+" <"+(+Ue+1)+".0.0"),M("caret return",$e),$e})}(et,xe)}).join(" ")}(Be,Ge),M("caret",Be),Be=function(_e,xe){return _e.trim().split(/\s+/).map(function(et){return function(tt,it){var at=it?p[W]:p[V];return tt.replace(at,function(gt,Ue,rt,Z,X){var $e;return M("tilde",tt,gt,Ue,rt,Z,X),fe(Ue)?$e="":fe(rt)?$e=">="+Ue+".0.0 <"+(+Ue+1)+".0.0":fe(Z)?$e=">="+Ue+"."+rt+".0 <"+Ue+"."+(+rt+1)+".0":X?(M("replaceTilde pr",X),X.charAt(0)!=="-"&&(X="-"+X),$e=">="+Ue+"."+rt+"."+Z+X+" <"+Ue+"."+(+rt+1)+".0"):$e=">="+Ue+"."+rt+"."+Z+" <"+Ue+"."+(+rt+1)+".0",M("tilde return",$e),$e})}(et,xe)}).join(" ")}(Be,Ge),M("tildes",Be),Be=function(_e,xe){return M("replaceXRanges",_e,xe),_e.split(/\s+/).map(function(et){return function(tt,it){tt=tt.trim();var at=it?p[E]:p[h];return tt.replace(at,function(gt,Ue,rt,Z,X,$e){M("xRange",tt,gt,Ue,rt,Z,X,$e);var He=fe(rt),we=He||fe(Z),st=we||fe(X);return Ue==="="&&st&&(Ue=""),He?gt=Ue===">"||Ue==="<"?"<0.0.0":"*":Ue&&st?(we&&(Z=0),st&&(X=0),Ue===">"?(Ue=">=",we?(rt=+rt+1,Z=0,X=0):st&&(Z=+Z+1,X=0)):Ue==="<="&&(Ue="<",we?rt=+rt+1:Z=+Z+1),gt=Ue+rt+"."+Z+"."+X):we?gt=">="+rt+".0.0 <"+(+rt+1)+".0.0":st&&(gt=">="+rt+"."+Z+".0 <"+rt+"."+(+Z+1)+".0"),M("xRange return",gt),gt})}(et,xe)}).join(" ")}(Be,Ge),M("xrange",Be),Be=function(_e,xe){return M("replaceStars",_e,xe),_e.trim().replace(p[ue],"")}(Be,Ge),M("stars",Be),Be}(Oe,H)}).join(" ").split(/\s+/);return this.loose&&(re=re.filter(function(Oe){return!!Oe.match(te)})),re=re.map(function(Oe){return new he(Oe,H)})},Te.prototype.intersects=function(F,H){if(!(F instanceof Te))throw new TypeError("a Range is required");return this.set.some(function(G){return G.every(function(te){return F.set.some(function(re){return re.every(function(Oe){return te.intersects(Oe,H)})})})})},e.toComparators=function(F,H){return new Te(F,H).set.map(function(G){return G.map(function(te){return te.value}).join(" ").trim().split(" ")})},Te.prototype.test=function(F){if(!F)return!1;typeof F=="string"&&(F=new Ne(F,this.loose));for(var H=0;H<this.set.length;H++)if(Re(this.set[H],F))return!0;return!1},e.satisfies=je,e.maxSatisfying=function(F,H,G){var te=null,re=null;try{var Oe=new Te(H,G)}catch{return null}return F.forEach(function(Be){Oe.test(Be)&&(te&&re.compare(Be)!==-1||(re=new Ne(te=Be,G)))}),te},e.minSatisfying=function(F,H,G){var te=null,re=null;try{var Oe=new Te(H,G)}catch{return null}return F.forEach(function(Be){Oe.test(Be)&&(te&&re.compare(Be)!==1||(re=new Ne(te=Be,G)))}),te},e.validRange=function(F,H){try{return new Te(F,H).range||"*"}catch{return null}},e.ltr=function(F,H,G){return B(F,H,"<",G)},e.gtr=function(F,H,G){return B(F,H,">",G)},e.outside=B,e.prerelease=function(F,H){var G=se(F,H);return G&&G.prerelease.length?G.prerelease:null},e.intersects=function(F,H,G){return F=new Te(F,G),H=new Te(H,G),F.intersects(H)},e.coerce=function(F){if(F instanceof Ne)return F;if(typeof F!="string")return null;var H=F.match(p[k]);return H==null?null:se((H[1]||"0")+"."+(H[2]||"0")+"."+(H[3]||"0"))}}).call(this,C(1))},function(le,e){var C,N,M=le.exports={};function T(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function p(r){if(C===setTimeout)return setTimeout(r,0);if((C===T||!C)&&setTimeout)return C=setTimeout,setTimeout(r,0);try{return C(r,0)}catch{try{return C.call(null,r,0)}catch{return C.call(this,r,0)}}}(function(){try{C=typeof setTimeout=="function"?setTimeout:T}catch{C=T}try{N=typeof clearTimeout=="function"?clearTimeout:A}catch{N=A}})();var m,D=[],O=!1,S=-1;function d(){O&&m&&(O=!1,m.length?D=m.concat(D):S=-1,D.length&&w())}function w(){if(!O){var r=p(d);O=!0;for(var s=D.length;s;){for(m=D,D=[];++S<s;)m&&m[S].run();S=-1,s=D.length}m=null,O=!1,function(n){if(N===clearTimeout)return clearTimeout(n);if((N===A||!N)&&clearTimeout)return N=clearTimeout,clearTimeout(n);try{N(n)}catch{try{return N.call(null,n)}catch{return N.call(this,n)}}}(r)}}function f(r,s){this.fun=r,this.array=s}function o(){}M.nextTick=function(r){var s=new Array(arguments.length-1);if(arguments.length>1)for(var n=1;n<arguments.length;n++)s[n-1]=arguments[n];D.push(new f(r,s)),D.length!==1||O||p(w)},f.prototype.run=function(){this.fun.apply(null,this.array)},M.title="browser",M.browser=!0,M.env={},M.argv=[],M.version="",M.versions={},M.on=o,M.addListener=o,M.once=o,M.off=o,M.removeListener=o,M.removeAllListeners=o,M.emit=o,M.prependListener=o,M.prependOnceListener=o,M.listeners=function(r){return[]},M.binding=function(r){throw new Error("process.binding is not supported")},M.cwd=function(){return"/"},M.chdir=function(r){throw new Error("process.chdir is not supported")},M.umask=function(){return 0}}])}),define(Se[134],Ie([1,0,14,6]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$se=M,e.$te=T,e.$ue=A,e.$ve=p,e.$we=D,e.$xe=O,e.$ye=S,e.$ze=d,e.$Ae=w,e.$Be=f,e.$Ce=o,e.$De=r,e.$Ee=s,e.$Fe=n,e.$Ge=t;function M(c){const u=c;return u?typeof u.read=="function":!1}function T(c){const u=c;return u?[u.on,u.pause,u.resume,u.destroy].every(i=>typeof i=="function"):!1}function A(c){const u=c;return u?T(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}function p(c,u){return new m(c,u)}class m{constructor(u,i){this.e=u,this.f=i,this.a={flowing:!1,ended:!1,destroyed:!1},this.b={data:[],error:[]},this.c={data:[],error:[],end:[]},this.d=[]}pause(){this.a.destroyed||(this.a.flowing=!1)}resume(){this.a.destroyed||this.a.flowing||(this.a.flowing=!0,this.j(),this.k(),this.l())}write(u){if(!this.a.destroyed){if(this.a.flowing)this.g(u);else if(this.b.data.push(u),typeof this.f?.highWaterMark=="number"&&this.b.data.length>this.f.highWaterMark)return new Promise(i=>this.d.push(i))}}error(u){this.a.destroyed||(this.a.flowing?this.h(u):this.b.error.push(u))}end(u){this.a.destroyed||(typeof u<"u"&&this.write(u),this.a.flowing?(this.i(),this.destroy()):this.a.ended=!0)}g(u){this.c.data.slice(0).forEach(i=>i(u))}h(u){this.c.error.length===0?(0,C.$1)(u):this.c.error.slice(0).forEach(i=>i(u))}i(){this.c.end.slice(0).forEach(u=>u())}on(u,i){if(!this.a.destroyed)switch(u){case"data":this.c.data.push(i),this.resume();break;case"end":this.c.end.push(i),this.a.flowing&&this.l()&&this.destroy();break;case"error":this.c.error.push(i),this.a.flowing&&this.k();break}}removeListener(u,i){if(this.a.destroyed)return;let b;switch(u){case"data":b=this.c.data;break;case"end":b=this.c.end;break;case"error":b=this.c.error;break}if(b){const a=b.indexOf(i);a>=0&&b.splice(a,1)}}j(){if(this.b.data.length>0){const u=this.e(this.b.data);this.g(u),this.b.data.length=0;const i=[...this.d];this.d.length=0,i.forEach(b=>b())}}k(){if(this.c.error.length>0){for(const u of this.b.error)this.h(u);this.b.error.length=0}}l(){return this.a.ended?(this.i(),this.c.end.length>0):!1}destroy(){this.a.destroyed||(this.a.destroyed=!0,this.a.ended=!0,this.b.data.length=0,this.b.error.length=0,this.c.data.length=0,this.c.error.length=0,this.c.end.length=0,this.d.length=0)}}function D(c,u){const i=[];let b;for(;(b=c.read())!==null;)i.push(b);return u(i)}function O(c,u,i){const b=[];let a;for(;(a=c.read())!==null&&b.length<i;)b.push(a);return a===null&&b.length>0?u(b):{read:()=>{if(b.length>0)return b.shift();if(typeof a<"u"){const l=a;return a=void 0,l}return c.read()}}}function S(c,u){return new Promise((i,b)=>{const a=[];d(c,{onData:l=>{u&&a.push(l)},onError:l=>{u?b(l):i(void 0)},onEnd:()=>{i(u?u(a):void 0)}})})}function d(c,u,i){c.on("error",b=>{i?.isCancellationRequested||u.onError(b)}),c.on("end",()=>{i?.isCancellationRequested||u.onEnd()}),c.on("data",b=>{i?.isCancellationRequested||u.onData(b)})}function w(c,u){return new Promise((i,b)=>{const a=new N.$Tc,l=[],g=y=>{if(l.push(y),l.length>u)return a.dispose(),c.pause(),i({stream:c,buffer:l,ended:!1})},$=y=>(a.dispose(),b(y)),v=()=>(a.dispose(),i({stream:c,buffer:l,ended:!0}));a.add((0,N.$Sc)(()=>c.removeListener("error",$))),c.on("error",$),a.add((0,N.$Sc)(()=>c.removeListener("end",v))),c.on("end",v),a.add((0,N.$Sc)(()=>c.removeListener("data",g))),c.on("data",g)})}function f(c,u){const i=p(u);return i.end(c),i}function o(){const c=p(()=>{throw new Error("not supported")});return c.end(),c}function r(c){let u=!1;return{read:()=>u?null:(u=!0,c)}}function s(c,u,i){const b=p(i);return d(c,{onData:a=>b.write(u.data(a)),onError:a=>b.error(u.error?u.error(a):a),onEnd:()=>b.end()}),b}function n(c,u,i){let b=!1;return{read:()=>{const a=u.read();return b?a:(b=!0,a!==null?i([c,a]):c)}}}function t(c,u,i){let b=!1;const a=p(i);return d(u,{onData:l=>b?a.write(l):(b=!0,a.write(i([c,l]))),onError:l=>a.error(l),onEnd:()=>{b||(b=!0,a.write(c)),a.end()}}),a}}),define(Se[22],Ie([1,0,43,134]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$He=void 0,e.$Ie=D,e.$Je=O,e.$Ke=S,e.$Le=d,e.$Me=w,e.$Ne=f,e.$Oe=o,e.$Pe=r,e.$Qe=s,e.$Re=n,e.$Se=t,e.$Te=c,e.$Ue=u,e.$Ve=i,e.$We=b,e.$Xe=a,e.$Ye=l,e.$Ze=g,e.$1e=$,e.$2e=h;const M=typeof Buffer<"u",T=new C.$V(()=>new Uint8Array(256));let A,p;class m{static alloc(k){return M?new m(Buffer.allocUnsafe(k)):new m(new Uint8Array(k))}static wrap(k){return M&&!Buffer.isBuffer(k)&&(k=Buffer.from(k.buffer,k.byteOffset,k.byteLength)),new m(k)}static fromString(k,I){return!(I?.dontUseNodeBuffer||!1)&&M?new m(Buffer.from(k)):(A||(A=new TextEncoder),new m(A.encode(k)))}static fromByteArray(k){const I=m.alloc(k.length);for(let P=0,V=k.length;P<V;P++)I.buffer[P]=k[P];return I}static concat(k,I){if(typeof I>"u"){I=0;for(let W=0,q=k.length;W<q;W++)I+=k[W].byteLength}const P=m.alloc(I);let V=0;for(let W=0,q=k.length;W<q;W++){const R=k[W];P.set(R,V),V+=R.byteLength}return P}constructor(k){this.buffer=k,this.byteLength=this.buffer.byteLength}clone(){const k=m.alloc(this.byteLength);return k.set(this),k}toString(){return M?this.buffer.toString():(p||(p=new TextDecoder),p.decode(this.buffer))}slice(k,I){return new m(this.buffer.subarray(k,I))}set(k,I){if(k instanceof m)this.buffer.set(k.buffer,I);else if(k instanceof Uint8Array)this.buffer.set(k,I);else if(k instanceof ArrayBuffer)this.buffer.set(new Uint8Array(k),I);else if(ArrayBuffer.isView(k))this.buffer.set(new Uint8Array(k.buffer,k.byteOffset,k.byteLength),I);else throw new Error("Unknown argument 'array'")}readUInt32BE(k){return d(this.buffer,k)}writeUInt32BE(k,I){w(this.buffer,k,I)}readUInt32LE(k){return f(this.buffer,k)}writeUInt32LE(k,I){o(this.buffer,k,I)}readUInt8(k){return r(this.buffer,k)}writeUInt8(k,I){s(this.buffer,k,I)}indexOf(k,I=0){return D(this.buffer,k instanceof m?k.buffer:k,I)}}e.$He=m;function D(E,k,I=0){const P=k.byteLength,V=E.byteLength;if(P===0)return 0;if(P===1)return E.indexOf(k[0]);if(P>V-I)return-1;const W=T.value;W.fill(k.length);for(let K=0;K<k.length;K++)W[k[K]]=k.length-K-1;let q=I+k.length-1,R=q,z=-1;for(;q<V;)if(E[q]===k[R]){if(R===0){z=q;break}q--,R--}else q+=Math.max(k.length-R,W[E[q]]),R=k.length-1;return z}function O(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0}function S(E,k,I){E[I+0]=k&255,k=k>>>8,E[I+1]=k&255}function d(E,k){return E[k]*2**24+E[k+1]*2**16+E[k+2]*2**8+E[k+3]}function w(E,k,I){E[I+3]=k,k=k>>>8,E[I+2]=k,k=k>>>8,E[I+1]=k,k=k>>>8,E[I]=k}function f(E,k){return E[k+0]<<0>>>0|E[k+1]<<8>>>0|E[k+2]<<16>>>0|E[k+3]<<24>>>0}function o(E,k,I){E[I+0]=k&255,k=k>>>8,E[I+1]=k&255,k=k>>>8,E[I+2]=k&255,k=k>>>8,E[I+3]=k&255}function r(E,k){return E[k]}function s(E,k,I){E[I]=k}function n(E){return N.$we(E,k=>m.concat(k))}function t(E){return N.$De(E)}function c(E){return N.$ye(E,k=>m.concat(k))}async function u(E){return E.ended?m.concat(E.buffer):m.concat([...E.buffer,await c(E.stream)])}function i(E){return N.$Be(E,k=>m.concat(k))}function b(E){return N.$Ee(E,{data:k=>typeof k=="string"?m.fromString(k):m.wrap(k)},k=>m.concat(k))}function a(E){return N.$ve(k=>m.concat(k),E)}function l(E,k){return N.$Fe(E,k,I=>m.concat(I))}function g(E,k){return N.$Ge(E,k,I=>m.concat(I))}function $(E){let k=0,I=0,P=0;const V=new Uint8Array(Math.floor(E.length/4*3)),W=R=>{switch(I){case 3:V[P++]=k|R,I=0;break;case 2:V[P++]=k|R>>>2,k=R<<6,I=3;break;case 1:V[P++]=k|R>>>4,k=R<<4,I=2;break;default:k=R<<2,I=1}};for(let R=0;R<E.length;R++){const z=E.charCodeAt(R);if(z>=65&&z<=90)W(z-65);else if(z>=97&&z<=122)W(z-97+26);else if(z>=48&&z<=57)W(z-48+52);else if(z===43||z===45)W(62);else if(z===47||z===95)W(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${E[R]}`)}}const q=P;for(;I>0;)W(0);return m.wrap(V).slice(0,q)}const v="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",y="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function h({buffer:E},k=!0,I=!1){const P=I?y:v;let V="";const W=E.byteLength%3;let q=0;for(;q<E.byteLength-W;q+=3){const R=E[q+0],z=E[q+1],K=E[q+2];V+=P[R>>>2],V+=P[(R<<4|z>>>4)&63],V+=P[(z<<2|K>>>6)&63],V+=P[K&63]}if(W===1){const R=E[q+0];V+=P[R>>>2],V+=P[R<<4&63],k&&(V+="==")}else if(W===2){const R=E[q+0],z=E[q+1];V+=P[R>>>2],V+=P[(R<<4|z>>>4)&63],V+=P[z<<2&63],k&&(V+="=")}return V}}),define(Se[135],Ie([1,0,28,128,13]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lk=e.FuzzyScore=e.$Ak=e.$zk=void 0,e.or=T,e.$Bk=p,e.$Ck=m,e.$Dk=S,e.$Ek=$,e.$Fk=v,e.$Gk=P,e.$Hk=V,e.$Ik=W,e.$Jk=q,e.$Kk=x,e.$Mk=be,e.$Nk=Y,e.$Ok=he;function T(...fe){return function(Pe,Re){for(let je=0,B=fe.length;je<B;je++){const F=fe[je](Pe,Re);if(F)return F}return null}}e.$zk=A.bind(void 0,!1),e.$Ak=A.bind(void 0,!0);function A(fe,Pe,Re){if(!Re||Re.length<Pe.length)return null;let je;return fe?je=M.$Af(Re,Pe):je=Re.indexOf(Pe)===0,je?Pe.length>0?[{start:0,end:Pe.length}]:[]:null}function p(fe,Pe){const Re=Pe.toLowerCase().indexOf(fe.toLowerCase());return Re===-1?null:[{start:Re,end:Re+fe.length}]}function m(fe,Pe){return D(fe.toLowerCase(),Pe.toLowerCase(),0,0)}function D(fe,Pe,Re,je){if(Re===fe.length)return[];if(je===Pe.length)return null;if(fe[Re]===Pe[je]){let B=null;return(B=D(fe,Pe,Re+1,je+1))?c({start:je,end:je+1},B):null}return D(fe,Pe,Re,je+1)}function O(fe){return 97<=fe&&fe<=122}function S(fe){return 65<=fe&&fe<=90}function d(fe){return 48<=fe&&fe<=57}function w(fe){return fe===32||fe===9||fe===10||fe===13}const f=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(fe=>f.add(fe.charCodeAt(0)));function o(fe){return w(fe)||f.has(fe)}function r(fe,Pe){return fe===Pe||o(fe)&&o(Pe)}const s=new Map;function n(fe){if(s.has(fe))return s.get(fe);let Pe;const Re=(0,N.$xk)(fe);return Re&&(Pe=Re),s.set(fe,Pe),Pe}function t(fe){return O(fe)||S(fe)||d(fe)}function c(fe,Pe){return Pe.length===0?Pe=[fe]:fe.end===Pe[0].start?Pe[0].start=fe.start:Pe.unshift(fe),Pe}function u(fe,Pe){for(let Re=Pe;Re<fe.length;Re++){const je=fe.charCodeAt(Re);if(S(je)||d(je)||Re>0&&!t(fe.charCodeAt(Re-1)))return Re}return fe.length}function i(fe,Pe,Re,je){if(Re===fe.length)return[];if(je===Pe.length)return null;if(fe[Re]!==Pe[je].toLowerCase())return null;{let B=null,F=je+1;for(B=i(fe,Pe,Re+1,je+1);!B&&(F=u(Pe,F))<Pe.length;)B=i(fe,Pe,Re+1,F),F++;return B===null?null:c({start:je,end:je+1},B)}}function b(fe){let Pe=0,Re=0,je=0,B=0,F=0;for(let Oe=0;Oe<fe.length;Oe++)F=fe.charCodeAt(Oe),S(F)&&Pe++,O(F)&&Re++,t(F)&&je++,d(F)&&B++;const H=Pe/fe.length,G=Re/fe.length,te=je/fe.length,re=B/fe.length;return{upperPercent:H,lowerPercent:G,alphaPercent:te,numericPercent:re}}function a(fe){const{upperPercent:Pe,lowerPercent:Re}=fe;return Re===0&&Pe>.6}function l(fe){const{upperPercent:Pe,lowerPercent:Re,alphaPercent:je,numericPercent:B}=fe;return Re>.2&&Pe<.8&&je>.6&&B<.2}function g(fe){let Pe=0,Re=0,je=0,B=0;for(let F=0;F<fe.length;F++)je=fe.charCodeAt(F),S(je)&&Pe++,O(je)&&Re++,w(je)&&B++;return(Pe===0||Re===0)&&B===0?fe.length<=30:Pe<=5}function $(fe,Pe){if(!Pe||(Pe=Pe.trim(),Pe.length===0)||!g(fe))return null;Pe.length>60&&(Pe=Pe.substring(0,60));const Re=b(Pe);if(!l(Re)){if(!a(Re))return null;Pe=Pe.toLowerCase()}let je=null,B=0;for(fe=fe.toLowerCase();B<Pe.length&&(je=i(fe,Pe,0,B))===null;)B=u(Pe,B+1);return je}function v(fe,Pe,Re=!1){if(!Pe||Pe.length===0)return null;let je=null,B=0;for(fe=fe.toLowerCase(),Pe=Pe.toLowerCase();B<Pe.length&&(je=y(fe,Pe,0,B,Re),je===null);)B=h(Pe,B+1);return je}function y(fe,Pe,Re,je,B){let F=0;if(Re===fe.length)return[];if(je===Pe.length)return null;if(!r(fe.charCodeAt(Re),Pe.charCodeAt(je))){const te=n(fe.charCodeAt(Re));if(!te)return null;for(let re=0;re<te.length;re++)if(!r(te[re],Pe.charCodeAt(je+re)))return null;F+=te.length-1}let H=null,G=je+F+1;if(H=y(fe,Pe,Re+1,G,B),!B)for(;!H&&(G=h(Pe,G))<Pe.length;)H=y(fe,Pe,Re+1,G,B),G++;if(!H)return null;if(fe.charCodeAt(Re)!==Pe.charCodeAt(je)){const te=n(fe.charCodeAt(Re));if(!te)return H;for(let re=0;re<te.length;re++)if(te[re]!==Pe.charCodeAt(je+re))return H}return c({start:je,end:je+F+1},H)}function h(fe,Pe){for(let Re=Pe;Re<fe.length;Re++)if(o(fe.charCodeAt(Re))||Re>0&&o(fe.charCodeAt(Re-1)))return Re;return fe.length}const E=T(e.$Ak,$,p),k=T(e.$Ak,$,m),I=new C.$Dc(1e4);function P(fe,Pe,Re=!1){if(typeof fe!="string"||typeof Pe!="string")return null;let je=I.get(fe);je||(je=new RegExp(M.$if(fe),"i"),I.set(fe,je));const B=je.exec(Pe);return B?[{start:B.index,end:B.index+B[0].length}]:Re?k(fe,Pe):E(fe,Pe)}function V(fe,Pe){const Re=be(fe,fe.toLowerCase(),0,Pe,Pe.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return Re?q(Re):null}function W(fe,Pe,Re,je,B,F){const H=Math.min(13,fe.length);for(;Re<H;Re++){const G=be(fe,Pe,Re,je,B,F,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(G)return G}return[0,F]}function q(fe){if(typeof fe>"u")return[];const Pe=[],Re=fe[1];for(let je=fe.length-1;je>1;je--){const B=fe[je]+Re,F=Pe[Pe.length-1];F&&F.end===B?F.end=B+1:Pe.push({start:B,end:B+1})}return Pe}const R=128;function z(){const fe=[],Pe=[];for(let Re=0;Re<=R;Re++)Pe[Re]=0;for(let Re=0;Re<=R;Re++)fe.push(Pe.slice(0));return fe}function K(fe){const Pe=[];for(let Re=0;Re<=fe;Re++)Pe[Re]=0;return Pe}const ie=K(2*R),de=K(2*R),ye=z(),De=z(),ge=z(),ue=!1;function Ce(fe,Pe,Re,je,B){function F(G,te,re=" "){for(;G.length<te;)G=re+G;return G}let H=` |   |${je.split("").map(G=>F(G,3)).join("|")}
`;for(let G=0;G<=Re;G++)G===0?H+=" |":H+=`${Pe[G-1]}|`,H+=fe[G].slice(0,B+1).map(te=>F(te.toString(),3)).join("|")+`
`;return H}function se(fe,Pe,Re,je){fe=fe.substr(Pe),Re=Re.substr(je),console.log(Ce(De,fe,fe.length,Re,Re.length)),console.log(Ce(ge,fe,fe.length,Re,Re.length)),console.log(Ce(ye,fe,fe.length,Re,Re.length))}function Ne(fe,Pe){if(Pe<0||Pe>=fe.length)return!1;const Re=fe.codePointAt(Pe);switch(Re){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!M.$Sf(Re)}}function ne(fe,Pe){if(Pe<0||Pe>=fe.length)return!1;switch(fe.charCodeAt(Pe)){case 32:case 9:return!0;default:return!1}}function U(fe,Pe,Re){return Pe[fe]!==Re[fe]}function x(fe,Pe,Re,je,B,F,H=!1){for(;Pe<Re&&B<F;)fe[Pe]===je[B]&&(H&&(ie[Pe]=B),Pe+=1),B+=1;return Pe===Re}var ve;(function(fe){fe[fe.Diag=1]="Diag",fe[fe.Left=2]="Left",fe[fe.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Le;(function(fe){fe.Default=[-100,0];function Pe(Re){return!Re||Re.length===2&&Re[0]===-100&&Re[1]===0}fe.isDefault=Pe})(Le||(e.FuzzyScore=Le={}));class ke{static{this.default={boostFullMatch:!0,firstMatchCanBeWeak:!1}}constructor(Pe,Re){this.firstMatchCanBeWeak=Pe,this.boostFullMatch=Re}}e.$Lk=ke;function be(fe,Pe,Re,je,B,F,H=ke.default){const G=fe.length>R?R:fe.length,te=je.length>R?R:je.length;if(Re>=G||F>=te||G-Re>te-F||!x(Pe,Re,G,B,F,te,!0))return;me(G,te,Re,F,Pe,B);let re=1,Oe=1,Be=Re,Ge=F;const _e=[!1];for(re=1,Be=Re;Be<G;re++,Be++){const at=ie[Be],gt=de[Be],Ue=Be+1<G?de[Be+1]:te;for(Oe=at-F+1,Ge=at;Ge<Ue;Oe++,Ge++){let rt=Number.MIN_SAFE_INTEGER,Z=!1;Ge<=gt&&(rt=Q(fe,Pe,Be,Re,je,B,Ge,te,F,ye[re-1][Oe-1]===0,_e));let X=0;rt!==Number.MAX_SAFE_INTEGER&&(Z=!0,X=rt+De[re-1][Oe-1]);const $e=Ge>at,He=$e?De[re][Oe-1]+(ye[re][Oe-1]>0?-5:0):0,we=Ge>at+1&&ye[re][Oe-1]>0,st=we?De[re][Oe-2]+(ye[re][Oe-2]>0?-5:0):0;if(we&&(!$e||st>=He)&&(!Z||st>=X))De[re][Oe]=st,ge[re][Oe]=3,ye[re][Oe]=0;else if($e&&(!Z||He>=X))De[re][Oe]=He,ge[re][Oe]=2,ye[re][Oe]=0;else if(Z)De[re][Oe]=X,ge[re][Oe]=1,ye[re][Oe]=ye[re-1][Oe-1]+1;else throw new Error("not possible")}}if(ue&&se(fe,Re,je,F),!_e[0]&&!H.firstMatchCanBeWeak)return;re--,Oe--;const xe=[De[re][Oe],F];let et=0,tt=0;for(;re>=1;){let at=Oe;do{const gt=ge[re][at];if(gt===3)at=at-2;else if(gt===2)at=at-1;else break}while(at>=1);et>1&&Pe[Re+re-1]===B[F+Oe-1]&&!U(at+F-1,je,B)&&et+1>ye[re][at]&&(at=Oe),at===Oe?et++:et=1,tt||(tt=at),re--,Oe=at-1,xe.push(Oe)}te-F===G&&H.boostFullMatch&&(xe[0]+=2);const it=tt-G;return xe[0]-=it,xe}function me(fe,Pe,Re,je,B,F){let H=fe-1,G=Pe-1;for(;H>=Re&&G>=je;)B[H]===F[G]&&(de[H]=G,H--),G--}function Q(fe,Pe,Re,je,B,F,H,G,te,re,Oe){if(Pe[Re]!==F[H])return Number.MIN_SAFE_INTEGER;let Be=1,Ge=!1;return H===Re-je?Be=fe[Re]===B[H]?7:5:U(H,B,F)&&(H===0||!U(H-1,B,F))?(Be=fe[Re]===B[H]?7:5,Ge=!0):Ne(F,H)&&(H===0||!Ne(F,H-1))?Be=5:(Ne(F,H-1)||ne(F,H-1))&&(Be=5,Ge=!0),Be>1&&Re===je&&(Oe[0]=!0),Ge||(Ge=U(H,B,F)||Ne(F,H-1)||ne(F,H-1)),Re===je?H>te&&(Be-=Ge?3:5):re?Be+=Ge?2:0:Be+=Ge?0:1,H+1===G&&(Be-=Ge?3:5),Be}function Y(fe,Pe,Re,je,B,F,H){return ce(fe,Pe,Re,je,B,F,!0,H)}function he(fe,Pe,Re,je,B,F,H){return ce(fe,Pe,Re,je,B,F,!1,H)}function ce(fe,Pe,Re,je,B,F,H,G){let te=be(fe,Pe,Re,je,B,F,G);if(te&&!H)return te;if(fe.length>=3){const re=Math.min(7,fe.length-1);for(let Oe=Re+1;Oe<re;Oe++){const Be=Te(fe,Oe);if(Be){const Ge=be(Be,Be.toLowerCase(),Re,je,B,F,G);Ge&&(Ge[0]-=3,(!te||Ge[0]>te[0])&&(te=Ge))}}}return te}function Te(fe,Pe){if(Pe+1>=fe.length)return;const Re=fe[Pe],je=fe[Pe+1];if(Re!==je)return fe.slice(0,Pe)+je+Re+fe.slice(Pe+2)}}),define(Se[32],Ie([1,0,13]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var N;(function(M){M[M.Ignore=0]="Ignore",M[M.Info=1]="Info",M[M.Warning=2]="Warning",M[M.Error=3]="Error"})(N||(N={})),function(M){const T="error",A="warning",p="warn",m="info",D="ignore";function O(d){return d?C.$zf(T,d)?M.Error:C.$zf(A,d)||C.$zf(p,d)?M.Warning:C.$zf(m,d)?M.Info:M.Ignore:M.Ignore}M.fromValue=O;function S(d){switch(d){case M.Error:return T;case M.Warning:return A;case M.Info:return m;default:return D}}M.toString=S}(N||(N={})),e.default=N}),define(Se[136],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ce=void 0,e.$ce=Symbol("MicrotaskDelay")}),define(Se[54],Ie([1,0,18,13]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ei=e.$Di=e.$Ci=e.$Bi=e.$Ai=void 0;class M{constructor(){this.b="",this.c=0}reset(w){return this.b=w,this.c=0,this}next(){return this.c+=1,this}hasNext(){return this.c<this.b.length-1}cmp(w){const f=w.charCodeAt(0),o=this.b.charCodeAt(this.c);return f-o}value(){return this.b[this.c]}}e.$Ai=M;class T{constructor(w=!0){this.e=w}reset(w){return this.b=w,this.c=0,this.d=0,this.next()}hasNext(){return this.d<this.b.length}next(){this.c=this.d;let w=!0;for(;this.d<this.b.length;this.d++)if(this.b.charCodeAt(this.d)===46)if(w)this.c++;else break;else w=!1;return this}cmp(w){return this.e?(0,N.$tf)(w,this.b,0,w.length,this.c,this.d):(0,N.$vf)(w,this.b,0,w.length,this.c,this.d)}value(){return this.b.substring(this.c,this.d)}}e.$Bi=T;class A{constructor(w=!0,f=!0){this.f=w,this.g=f}reset(w){this.d=0,this.e=0,this.b=w,this.c=w.length;for(let f=w.length-1;f>=0;f--,this.c--){const o=this.b.charCodeAt(f);if(!(o===47||this.f&&o===92))break}return this.next()}hasNext(){return this.e<this.c}next(){this.d=this.e;let w=!0;for(;this.e<this.c;this.e++){const f=this.b.charCodeAt(this.e);if(f===47||this.f&&f===92)if(w)this.d++;else break;else w=!1}return this}cmp(w){return this.g?(0,N.$tf)(w,this.b,0,w.length,this.d,this.e):(0,N.$vf)(w,this.b,0,w.length,this.d,this.e)}value(){return this.b.substring(this.d,this.e)}}e.$Ci=A;var p;(function(d){d[d.Scheme=1]="Scheme",d[d.Authority=2]="Authority",d[d.Path=3]="Path",d[d.Query=4]="Query",d[d.Fragment=5]="Fragment"})(p||(p={}));class m{constructor(w,f){this.f=w,this.g=f,this.d=[],this.e=0}reset(w){return this.c=w,this.d=[],this.c.scheme&&this.d.push(1),this.c.authority&&this.d.push(2),this.c.path&&(this.b=new A(!1,!this.f(w)),this.b.reset(w.path),this.b.value()&&this.d.push(3)),this.g(w)||(this.c.query&&this.d.push(4),this.c.fragment&&this.d.push(5)),this.e=0,this}next(){return this.d[this.e]===3&&this.b.hasNext()?this.b.next():this.e+=1,this}hasNext(){return this.d[this.e]===3&&this.b.hasNext()||this.e<this.d.length-1}cmp(w){if(this.d[this.e]===1)return(0,N.$uf)(w,this.c.scheme);if(this.d[this.e]===2)return(0,N.$uf)(w,this.c.authority);if(this.d[this.e]===3)return this.b.cmp(w);if(this.d[this.e]===4)return(0,N.$sf)(w,this.c.query);if(this.d[this.e]===5)return(0,N.$sf)(w,this.c.fragment);throw new Error}value(){if(this.d[this.e]===1)return this.c.scheme;if(this.d[this.e]===2)return this.c.authority;if(this.d[this.e]===3)return this.b.value();if(this.d[this.e]===4)return this.c.query;if(this.d[this.e]===5)return this.c.fragment;throw new Error}}e.$Di=m;class D{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const w=this.right;return this.right=w.left,w.left=this,this.updateHeight(),w.updateHeight(),w}rotateRight(){const w=this.left;return this.left=w.right,w.right=this,this.updateHeight(),w.updateHeight(),w}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var O;(function(d){d[d.Left=-1]="Left",d[d.Mid=0]="Mid",d[d.Right=1]="Right"})(O||(O={}));class S{static forUris(w=()=>!1,f=()=>!1){return new S(new m(w,f))}static forPaths(w=!1){return new S(new A(void 0,!w))}static forStrings(){return new S(new M)}static forConfigKeys(){return new S(new T)}constructor(w){this.b=w}clear(){this.c=void 0}fill(w,f){if(f){const o=f.slice(0);(0,C.$Wb)(o);for(const r of o)this.set(r,w)}else{const o=w.slice(0);(0,C.$Wb)(o);for(const r of o)this.set(r[0],r[1])}}set(w,f){const o=this.b.reset(w);let r;this.c||(this.c=new D,this.c.segment=o.value());const s=[];for(r=this.c;;){const t=o.cmp(r.segment);if(t>0)r.left||(r.left=new D,r.left.segment=o.value()),s.push([-1,r]),r=r.left;else if(t<0)r.right||(r.right=new D,r.right.segment=o.value()),s.push([1,r]),r=r.right;else if(o.hasNext())o.next(),r.mid||(r.mid=new D,r.mid.segment=o.value()),s.push([0,r]),r=r.mid;else break}const n=r.value;r.value=f,r.key=w;for(let t=s.length-1;t>=0;t--){const c=s[t][1];c.updateHeight();const u=c.balanceFactor();if(u<-1||u>1){const i=s[t][0],b=s[t+1][0];if(i===1&&b===1)s[t][1]=c.rotateLeft();else if(i===-1&&b===-1)s[t][1]=c.rotateRight();else if(i===1&&b===-1)c.right=s[t+1][1]=s[t+1][1].rotateRight(),s[t][1]=c.rotateLeft();else if(i===-1&&b===1)c.left=s[t+1][1]=s[t+1][1].rotateLeft(),s[t][1]=c.rotateRight();else throw new Error;if(t>0)switch(s[t-1][0]){case-1:s[t-1][1].left=s[t][1];break;case 1:s[t-1][1].right=s[t][1];break;case 0:s[t-1][1].mid=s[t][1];break}else this.c=s[0][1]}}return n}get(w){return this.d(w)?.value}d(w){const f=this.b.reset(w);let o=this.c;for(;o;){const r=f.cmp(o.segment);if(r>0)o=o.left;else if(r<0)o=o.right;else if(f.hasNext())f.next(),o=o.mid;else break}return o}has(w){const f=this.d(w);return!(f?.value===void 0&&f?.mid===void 0)}delete(w){return this.e(w,!1)}deleteSuperstr(w){return this.e(w,!0)}e(w,f){const o=this.b.reset(w),r=[];let s=this.c;for(;s;){const n=o.cmp(s.segment);if(n>0)r.push([-1,s]),s=s.left;else if(n<0)r.push([1,s]),s=s.right;else if(o.hasNext())o.next(),r.push([0,s]),s=s.mid;else break}if(s){if(f?(s.left=void 0,s.mid=void 0,s.right=void 0,s.height=1):(s.key=void 0,s.value=void 0),!s.mid&&!s.value)if(s.left&&s.right){const n=this.f(s.right);if(n.key){const{key:t,value:c,segment:u}=n;this.e(n.key,!1),s.key=t,s.value=c,s.segment=u}}else{const n=s.left??s.right;if(r.length>0){const[t,c]=r[r.length-1];switch(t){case-1:c.left=n;break;case 0:c.mid=n;break;case 1:c.right=n;break}}else this.c=n}for(let n=r.length-1;n>=0;n--){const t=r[n][1];t.updateHeight();const c=t.balanceFactor();if(c>1?(t.right.balanceFactor()>=0||(t.right=t.right.rotateRight()),r[n][1]=t.rotateLeft()):c<-1&&(t.left.balanceFactor()<=0||(t.left=t.left.rotateLeft()),r[n][1]=t.rotateRight()),n>0)switch(r[n-1][0]){case-1:r[n-1][1].left=r[n][1];break;case 1:r[n-1][1].right=r[n][1];break;case 0:r[n-1][1].mid=r[n][1];break}else this.c=r[0][1]}}}f(w){for(;w.left;)w=w.left;return w}findSubstr(w){const f=this.b.reset(w);let o=this.c,r;for(;o;){const s=f.cmp(o.segment);if(s>0)o=o.left;else if(s<0)o=o.right;else if(f.hasNext())f.next(),r=o.value||r,o=o.mid;else break}return o&&o.value||r}findSuperstr(w){return this.g(w,!1)}g(w,f){const o=this.b.reset(w);let r=this.c;for(;r;){const s=o.cmp(r.segment);if(s>0)r=r.left;else if(s<0)r=r.right;else if(o.hasNext())o.next(),r=r.mid;else return r.mid?this.h(r.mid):f?r.value:void 0}}hasElementOrSubtree(w){return this.g(w,!0)!==void 0}forEach(w){for(const[f,o]of this)w(o,f)}*[Symbol.iterator](){yield*this.h(this.c)}h(w){const f=[];return this.j(w,f),f[Symbol.iterator]()}j(w,f){w&&(w.left&&this.j(w.left,f),w.value&&f.push([w.key,w.value]),w.mid&&this.j(w.mid,f),w.right&&this.j(w.right,f))}_isBalanced(){const w=f=>{if(!f)return!0;const o=f.balanceFactor();return o<-1||o>1?!1:w(f.left)&&w(f.right)};return w(this.c)}}e.$Ei=S}),define(Se[36],Ie([1,0,92]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeIcon=e.ThemeColor=void 0,e.$Yj=M;var N;(function(A){function p(m){return m&&typeof m=="object"&&typeof m.id=="string"}A.isThemeColor=p})(N||(e.ThemeColor=N={}));function M(A){return{id:A}}var T;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const p=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function m(n){const t=p.exec(n.id);if(!t)return m(C.$Xj.error);const[,c,u]=t,i=["codicon","codicon-"+c];return u&&i.push("codicon-modifier-"+u.substring(1)),i}A.asClassNameArray=m;function D(n){return m(n).join(" ")}A.asClassName=D;function O(n){return"."+m(n).join(".")}A.asCSSSelector=O;function S(n){return n&&typeof n=="object"&&typeof n.id=="string"&&(typeof n.color>"u"||N.isThemeColor(n.color))}A.isThemeIcon=S;const d=new RegExp(`^\\$\\((${A.iconNameExpression}(?:${A.iconModifierExpression})?)\\)$`);function w(n){const t=d.exec(n);if(!t)return;const[,c]=t;return{id:c}}A.fromString=w;function f(n){return{id:n}}A.fromId=f;function o(n,t){let c=n.id;const u=c.lastIndexOf("~");return u!==-1&&(c=c.substring(0,u)),t&&(c=`${c}~${t}`),{id:c}}A.modify=o;function r(n){const t=n.id.lastIndexOf("~");if(t!==-1)return n.id.substring(t+1)}A.getModifier=r;function s(n,t){return n.id===t.id&&n.color?.id===t.color?.id}A.isEqual=s})(T||(e.ThemeIcon=T={}))}),define(Se[137],Ie([1,0,135,13,36]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pk=m,e.$Qk=O,e.$Rk=d,e.$Sk=w,e.$Tk=o,e.$Uk=r;const T="$(",A=new RegExp(`\\$\\(${M.ThemeIcon.iconNameExpression}(?:${M.ThemeIcon.iconModifierExpression})?\\)`,"g"),p=new RegExp(`(\\\\)?${A.source}`,"g");function m(s){return s.replace(p,(n,t)=>t?n:`\\${n}`)}const D=new RegExp(`\\\\${A.source}`,"g");function O(s){return s.replace(D,n=>`\\${n}`)}const S=new RegExp(`(\\s)?(\\\\)?${A.source}(\\s)?`,"g");function d(s){return s.indexOf(T)===-1?s:s.replace(S,(n,t,c,u)=>c?n:t||u||"")}function w(s){return s?s.replace(/\$\((.*?)\)/g,(n,t)=>` ${t} `).trim():""}const f=new RegExp(`\\$\\(${M.ThemeIcon.iconNameCharacter}+\\)`,"g");function o(s){f.lastIndex=0;let n="";const t=[];let c=0;for(;;){const u=f.lastIndex,i=f.exec(s),b=s.substring(u,i?.index);if(b.length>0){n+=b;for(let a=0;a<b.length;a++)t.push(c)}if(!i)break;c+=i[0].length}return{text:n,iconOffsets:t}}function r(s,n,t=!1){const{text:c,iconOffsets:u}=n;if(!u||u.length===0)return(0,C.$Gk)(s,c,t);const i=(0,N.$gf)(c," "),b=c.length-i.length,a=(0,C.$Gk)(s,i,t);if(a)for(const l of a){const g=u[l.start+b]+b;l.start+=g,l.end+=g}return a}}),define(Se[33],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ug=void 0,e.$Tg=N;const C=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function N(M){return C.test(M)}e.$Ug=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let M;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?M=crypto.getRandomValues.bind(crypto):M=function(p){for(let m=0;m<p.length;m++)p[m]=Math.floor(Math.random()*256);return p};const T=new Uint8Array(16),A=[];for(let p=0;p<256;p++)A.push(p.toString(16).padStart(2,"0"));return function(){M(T),T[6]=T[6]&15|64,T[8]=T[8]&63|128;let m=0,D="";return D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+="-",D+=A[T[m++]],D+=A[T[m++]],D+="-",D+=A[T[m++]],D+=A[T[m++]],D+="-",D+=A[T[m++]],D+=A[T[m++]],D+="-",D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D+=A[T[m++]],D}}()}),define(Se[138],Ie([1,0,18,42,33]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$du=e.$bu=void 0,e.$_t=T,e.$au=A,e.$cu=D;function T(S){return{asString:async()=>S,asFile:()=>{},value:typeof S=="string"?S:void 0}}function A(S,d,w){const f={id:(0,M.$Ug)(),name:S,uri:d,data:w};return{asString:async()=>"",asFile:()=>f,value:void 0}}class p{constructor(){this.a=new Map}get size(){let d=0;for(const w of this.a)d++;return d}has(d){return this.a.has(this.b(d))}matches(d){const w=[...this.a.keys()];return N.Iterable.some(this,([f,o])=>o.asFile())&&w.push("files"),O(m(d),w)}get(d){return this.a.get(this.b(d))?.[0]}append(d,w){const f=this.a.get(d);f?f.push(w):this.a.set(this.b(d),[w])}replace(d,w){this.a.set(this.b(d),[w])}delete(d){this.a.delete(this.b(d))}*[Symbol.iterator](){for(const[d,w]of this.a)for(const f of w)yield[d,f]}b(d){return m(d)}}e.$bu=p;function m(S){return S.toLowerCase()}function D(S,d){return O(m(S),d.map(m))}function O(S,d){if(S==="*/*")return d.length>0;if(d.includes(S))return!0;const w=S.match(/^([a-z]+)\/([a-z]+|\*)$/i);if(!w)return!1;const[f,o,r]=w;return r==="*"?d.some(s=>s.startsWith(o+"/")):!1}e.$du=Object.freeze({create:S=>(0,C.$Mb)(S.map(d=>d.toString())).join(`\r
`),split:S=>S.split(`\r
`),parse:S=>e.$du.split(S).filter(d=>!d.startsWith("#"))})}),define(Se[139],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringEOL=void 0,e.$ju=N;var C;(function(M){M[M.Unknown=0]="Unknown",M[M.Invalid=3]="Invalid",M[M.LF=1]="LF",M[M.CRLF=2]="CRLF"})(C||(e.StringEOL=C={}));function N(M){let T=0,A=0,p=0,m=0;for(let D=0,O=M.length;D<O;D++){const S=M.charCodeAt(D);S===13?(T===0&&(A=D),T++,D+1<O&&M.charCodeAt(D+1)===10?(m|=2,D++):m|=3,p=D+1):S===10&&(m|=1,T===0&&(A=D),T++,p=D+1)}return T===0&&(A=M.length),[T,A,M.length-p,m]}}),define(Se[140],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9s=void 0,e.$9s={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(Se[141],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gu=e.$Fu=e.IndentAction=void 0;var C;(function(A){A[A.None=0]="None",A[A.Indent=1]="Indent",A[A.IndentOutdent=2]="IndentOutdent",A[A.Outdent=3]="Outdent"})(C||(e.IndentAction=C={}));class N{constructor(p){if(this.e=null,this.f=!1,this.open=p.open,this.close=p.close,this.b=!0,this.c=!0,this.d=!0,Array.isArray(p.notIn))for(let m=0,D=p.notIn.length;m<D;m++)switch(p.notIn[m]){case"string":this.b=!1;break;case"comment":this.c=!1;break;case"regex":this.d=!1;break}}isOK(p){switch(p){case 0:return!0;case 1:return this.c;case 2:return this.b;case 3:return this.d}}shouldAutoClose(p,m){if(p.getTokenCount()===0)return!0;const D=p.findTokenIndexAtOffset(m-2),O=p.getStandardTokenType(D);return this.isOK(O)}g(p,m){for(let D=p;D<=m;D++){const O=String.fromCharCode(D);if(!this.open.includes(O)&&!this.close.includes(O))return O}return null}findNeutralCharacter(){return this.f||(this.f=!0,this.e||(this.e=this.g(48,57)),this.e||(this.e=this.g(97,122)),this.e||(this.e=this.g(65,90))),this.e}}e.$Fu=N;class M{constructor(p){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const m of p)T(this.autoClosingPairsOpenByStart,m.open.charAt(0),m),T(this.autoClosingPairsOpenByEnd,m.open.charAt(m.open.length-1),m),T(this.autoClosingPairsCloseByStart,m.close.charAt(0),m),T(this.autoClosingPairsCloseByEnd,m.close.charAt(m.close.length-1),m),m.close.length===1&&m.open.length===1&&T(this.autoClosingPairsCloseSingleChar,m.close,m)}}e.$Gu=M;function T(A,p,m){A.has(p)?A.get(p).push(m):A.set(p,[m])}}),define(Se[142],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LC=e.NodeColor=e.$KC=void 0,e.$MC=M,e.$NC=T,e.$OC=D,e.$PC=O,e.$QC=S,e.$RC=d,e.$SC=w,e.$TC=f;class C{constructor(r,s){this.piece=r,this.color=s,this.size_left=0,this.lf_left=0,this.parent=this,this.left=this,this.right=this}next(){if(this.right!==e.$LC)return M(this.right);let r=this;for(;r.parent!==e.$LC&&r.parent.left!==r;)r=r.parent;return r.parent===e.$LC?e.$LC:r.parent}prev(){if(this.left!==e.$LC)return T(this.left);let r=this;for(;r.parent!==e.$LC&&r.parent.right!==r;)r=r.parent;return r.parent===e.$LC?e.$LC:r.parent}detach(){this.parent=null,this.left=null,this.right=null}}e.$KC=C;var N;(function(o){o[o.Black=0]="Black",o[o.Red=1]="Red"})(N||(e.NodeColor=N={})),e.$LC=new C(null,0),e.$LC.parent=e.$LC,e.$LC.left=e.$LC,e.$LC.right=e.$LC,e.$LC.color=0;function M(o){for(;o.left!==e.$LC;)o=o.left;return o}function T(o){for(;o.right!==e.$LC;)o=o.right;return o}function A(o){return o===e.$LC?0:o.size_left+o.piece.length+A(o.right)}function p(o){return o===e.$LC?0:o.lf_left+o.piece.lineFeedCnt+p(o.right)}function m(){e.$LC.parent=e.$LC}function D(o,r){const s=r.right;s.size_left+=r.size_left+(r.piece?r.piece.length:0),s.lf_left+=r.lf_left+(r.piece?r.piece.lineFeedCnt:0),r.right=s.left,s.left!==e.$LC&&(s.left.parent=r),s.parent=r.parent,r.parent===e.$LC?o.root=s:r.parent.left===r?r.parent.left=s:r.parent.right=s,s.left=r,r.parent=s}function O(o,r){const s=r.left;r.left=s.right,s.right!==e.$LC&&(s.right.parent=r),s.parent=r.parent,r.size_left-=s.size_left+(s.piece?s.piece.length:0),r.lf_left-=s.lf_left+(s.piece?s.piece.lineFeedCnt:0),r.parent===e.$LC?o.root=s:r===r.parent.right?r.parent.right=s:r.parent.left=s,s.right=r,r.parent=s}function S(o,r){let s,n;if(r.left===e.$LC?(n=r,s=n.right):r.right===e.$LC?(n=r,s=n.left):(n=M(r.right),s=n.right),n===o.root){o.root=s,s.color=0,r.detach(),m(),o.root.parent=e.$LC;return}const t=n.color===1;if(n===n.parent.left?n.parent.left=s:n.parent.right=s,n===r?(s.parent=n.parent,f(o,s)):(n.parent===r?s.parent=n:s.parent=n.parent,f(o,s),n.left=r.left,n.right=r.right,n.parent=r.parent,n.color=r.color,r===o.root?o.root=n:r===r.parent.left?r.parent.left=n:r.parent.right=n,n.left!==e.$LC&&(n.left.parent=n),n.right!==e.$LC&&(n.right.parent=n),n.size_left=r.size_left,n.lf_left=r.lf_left,f(o,n)),r.detach(),s.parent.left===s){const u=A(s),i=p(s);if(u!==s.parent.size_left||i!==s.parent.lf_left){const b=u-s.parent.size_left,a=i-s.parent.lf_left;s.parent.size_left=u,s.parent.lf_left=i,w(o,s.parent,b,a)}}if(f(o,s.parent),t){m();return}let c;for(;s!==o.root&&s.color===0;)s===s.parent.left?(c=s.parent.right,c.color===1&&(c.color=0,s.parent.color=1,D(o,s.parent),c=s.parent.right),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.right.color===0&&(c.left.color=0,c.color=1,O(o,c),c=s.parent.right),c.color=s.parent.color,s.parent.color=0,c.right.color=0,D(o,s.parent),s=o.root)):(c=s.parent.left,c.color===1&&(c.color=0,s.parent.color=1,O(o,s.parent),c=s.parent.left),c.left.color===0&&c.right.color===0?(c.color=1,s=s.parent):(c.left.color===0&&(c.right.color=0,c.color=1,D(o,c),c=s.parent.left),c.color=s.parent.color,s.parent.color=0,c.left.color=0,O(o,s.parent),s=o.root));s.color=0,m()}function d(o,r){for(f(o,r);r!==o.root&&r.parent.color===1;)if(r.parent===r.parent.parent.left){const s=r.parent.parent.right;s.color===1?(r.parent.color=0,s.color=0,r.parent.parent.color=1,r=r.parent.parent):(r===r.parent.right&&(r=r.parent,D(o,r)),r.parent.color=0,r.parent.parent.color=1,O(o,r.parent.parent))}else{const s=r.parent.parent.left;s.color===1?(r.parent.color=0,s.color=0,r.parent.parent.color=1,r=r.parent.parent):(r===r.parent.left&&(r=r.parent,O(o,r)),r.parent.color=0,r.parent.parent.color=1,D(o,r.parent.parent))}o.root.color=0}function w(o,r,s,n){for(;r!==o.root&&r!==e.$LC;)r.parent.left===r&&(r.parent.size_left+=s,r.parent.lf_left+=n),r=r.parent}function f(o,r){let s=0,n=0;if(r!==o.root){for(;r!==o.root&&r===r.parent.right;)r=r.parent;if(r!==o.root)for(r=r.parent,s=A(r.left)-r.size_left,n=p(r.left)-r.lf_left,r.size_left+=s,r.lf_left+=n;r!==o.root&&(s!==0||n!==0);)r.parent.left===r&&(r.parent.size_left+=s,r.parent.lf_left+=n),r=r.parent}}}),define(Se[93],Ie([1,0,94,30,95,142,96]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5C=e.$4C=e.$3C=void 0,e.$1C=O,e.$2C=S;const p=65535;function m(s){let n;return s[s.length-1]<65536?n=new Uint16Array(s.length):n=new Uint32Array(s.length),n.set(s,0),n}class D{constructor(n,t,c,u,i){this.lineStarts=n,this.cr=t,this.lf=c,this.crlf=u,this.isBasicASCII=i}}function O(s,n=!0){const t=[0];let c=1;for(let u=0,i=s.length;u<i;u++){const b=s.charCodeAt(u);b===13?u+1<i&&s.charCodeAt(u+1)===10?(t[c++]=u+2,u++):t[c++]=u+1:b===10&&(t[c++]=u+1)}return n?m(t):t}function S(s,n){s.length=0,s[0]=0;let t=1,c=0,u=0,i=0,b=!0;for(let l=0,g=n.length;l<g;l++){const $=n.charCodeAt(l);$===13?l+1<g&&n.charCodeAt(l+1)===10?(i++,s[t++]=l+2,l++):(c++,s[t++]=l+1):$===10?(u++,s[t++]=l+1):b&&$!==9&&($<32||$>126)&&(b=!1)}const a=new D(m(s),c,u,i,b);return s.length=0,a}class d{constructor(n,t,c,u,i){this.bufferIndex=n,this.start=t,this.end=c,this.lineFeedCnt=u,this.length=i}}e.$3C=d;class w{constructor(n,t){this.buffer=n,this.lineStarts=t}}e.$4C=w;class f{constructor(n,t){this.a=[],this.c=n,this.d=t,this.b=0,n.root!==T.$LC&&n.iterate(n.root,c=>(c!==T.$LC&&this.a.push(c.piece),!0))}read(){return this.a.length===0?this.b===0?(this.b++,this.d):null:this.b>this.a.length-1?null:this.b===0?this.d+this.c.getPieceContent(this.a[this.b++]):this.c.getPieceContent(this.a[this.b++])}}class o{constructor(n){this.a=n,this.b=[]}get(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartOffset<=n&&c.nodeStartOffset+c.node.piece.length>=n)return c}return null}get2(n){for(let t=this.b.length-1;t>=0;t--){const c=this.b[t];if(c.nodeStartLineNumber&&c.nodeStartLineNumber<n&&c.nodeStartLineNumber+c.node.piece.lineFeedCnt>=n)return c}return null}set(n){this.b.length>=this.a&&this.b.shift(),this.b.push(n)}validate(n){let t=!1;const c=this.b;for(let u=0;u<c.length;u++){const i=c[u];if(i.node.parent===null||i.nodeStartOffset>=n){c[u]=null,t=!0;continue}}if(t){const u=[];for(const i of c)i!==null&&u.push(i);this.b=u}}}class r{constructor(n,t,c){this.create(n,t,c)}create(n,t,c){this.a=[new w("",[0])],this.g={line:0,column:0},this.root=T.$LC,this.b=1,this.c=0,this.d=t,this.e=t.length,this.f=c;let u=null;for(let i=0,b=n.length;i<b;i++)if(n[i].buffer.length>0){n[i].lineStarts||(n[i].lineStarts=O(n[i].buffer));const a=new d(i+1,{line:0,column:0},{line:n[i].lineStarts.length-1,column:n[i].buffer.length-n[i].lineStarts[n[i].lineStarts.length-1]},n[i].lineStarts.length-1,n[i].buffer.length);this.a.push(n[i]),u=this.S(u,a)}this.h=new o(1),this.j={lineNumber:0,value:""},this.y()}normalizeEOL(n){const t=p,c=t-Math.floor(t/3),u=c*2;let i="",b=0;const a=[];if(this.iterate(this.root,l=>{const g=this.R(l),$=g.length;if(b<=c||b+$<u)return i+=g,b+=$,!0;const v=i.replace(/\r\n|\r|\n/g,n);return a.push(new w(v,O(v))),i=g,b=$,!0}),b>0){const l=i.replace(/\r\n|\r|\n/g,n);a.push(new w(l,O(l)))}this.create(a,n,!0)}getEOL(){return this.d}setEOL(n){this.d=n,this.e=this.d.length,this.normalizeEOL(n)}createSnapshot(n){return new f(this,n)}equal(n){if(this.getLength()!==n.getLength()||this.getLineCount()!==n.getLineCount())return!1;let t=0;return this.iterate(this.root,u=>{if(u===T.$LC)return!0;const i=this.R(u),b=i.length,a=n.G(t),l=n.G(t+b),g=n.getValueInRange2(a,l);return t+=b,i===g})}getOffsetAt(n,t){let c=0,u=this.root;for(;u!==T.$LC;)if(u.left!==T.$LC&&u.lf_left+1>=n)u=u.left;else if(u.lf_left+u.piece.lineFeedCnt+1>=n){c+=u.size_left;const i=this.B(u,n-u.lf_left-2);return c+=i+t-1}else n-=u.lf_left+u.piece.lineFeedCnt,c+=u.size_left+u.piece.length,u=u.right;return c}getPositionAt(n){n=Math.floor(n),n=Math.max(0,n);let t=this.root,c=0;const u=n;for(;t!==T.$LC;)if(t.size_left!==0&&t.size_left>=n)t=t.left;else if(t.size_left+t.piece.length>=n){const i=this.A(t,n-t.size_left);if(c+=t.lf_left+i.index,i.index===0){const b=this.getOffsetAt(c+1,1),a=u-b;return new C.$yt(c+1,a+1)}return new C.$yt(c+1,i.remainder+1)}else if(n-=t.size_left+t.piece.length,c+=t.lf_left+t.piece.lineFeedCnt,t.right===T.$LC){const i=this.getOffsetAt(c+1,1),b=u-n-i;return new C.$yt(c+1,b+1)}else t=t.right;return new C.$yt(1,1)}getValueInRange(n,t){if(n.startLineNumber===n.endLineNumber&&n.startColumn===n.endColumn)return"";const c=this.H(n.startLineNumber,n.startColumn),u=this.H(n.endLineNumber,n.endColumn),i=this.getValueInRange2(c,u);return t?t!==this.d||!this.f?i.replace(/\r\n|\r|\n/g,t):t===this.getEOL()&&this.f?i:i.replace(/\r\n|\r|\n/g,t):i}getValueInRange2(n,t){if(n.node===t.node){const a=n.node,l=this.a[a.piece.bufferIndex].buffer,g=this.u(a.piece.bufferIndex,a.piece.start);return l.substring(g+n.remainder,g+t.remainder)}let c=n.node;const u=this.a[c.piece.bufferIndex].buffer,i=this.u(c.piece.bufferIndex,c.piece.start);let b=u.substring(i+n.remainder,i+c.piece.length);for(c=c.next();c!==T.$LC;){const a=this.a[c.piece.bufferIndex].buffer,l=this.u(c.piece.bufferIndex,c.piece.start);if(c===t.node){b+=a.substring(l,l+t.remainder);break}else b+=a.substr(l,c.piece.length);c=c.next()}return b}getLinesContent(){const n=[];let t=0,c="",u=!1;return this.iterate(this.root,i=>{if(i===T.$LC)return!0;const b=i.piece;let a=b.length;if(a===0)return!0;const l=this.a[b.bufferIndex].buffer,g=this.a[b.bufferIndex].lineStarts,$=b.start.line,v=b.end.line;let y=g[$]+b.start.column;if(u&&(l.charCodeAt(y)===10&&(y++,a--),n[t++]=c,c="",u=!1,a===0))return!0;if($===v)return!this.f&&l.charCodeAt(y+a-1)===13?(u=!0,c+=l.substr(y,a-1)):c+=l.substr(y,a),!0;c+=this.f?l.substring(y,Math.max(y,g[$+1]-this.e)):l.substring(y,g[$+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;for(let h=$+1;h<v;h++)c=this.f?l.substring(g[h],g[h+1]-this.e):l.substring(g[h],g[h+1]).replace(/(\r\n|\r|\n)$/,""),n[t++]=c;return!this.f&&l.charCodeAt(g[v]+b.end.column-1)===13?(u=!0,b.end.column===0?t--:c=l.substr(g[v],b.end.column-1)):c=l.substr(g[v],b.end.column),!0}),u&&(n[t++]=c,c=""),n[t++]=c,n}getLength(){return this.c}getLineCount(){return this.b}getLineContent(n){return this.j.lineNumber===n?this.j.value:(this.j.lineNumber=n,n===this.b?this.j.value=this.getLineRawContent(n):this.f?this.j.value=this.getLineRawContent(n,this.e):this.j.value=this.getLineRawContent(n).replace(/(\r\n|\r|\n)$/,""),this.j.value)}l(n){if(n.remainder===n.node.piece.length){const t=n.node.next();if(!t)return 0;const c=this.a[t.piece.bufferIndex],u=this.u(t.piece.bufferIndex,t.piece.start);return c.buffer.charCodeAt(u)}else{const t=this.a[n.node.piece.bufferIndex],u=this.u(n.node.piece.bufferIndex,n.node.piece.start)+n.remainder;return t.buffer.charCodeAt(u)}}getLineCharCode(n,t){const c=this.H(n,t+1);return this.l(c)}getLineLength(n){if(n===this.getLineCount()){const t=this.getOffsetAt(n,1);return this.getLength()-t}return this.getOffsetAt(n+1,1)-this.getOffsetAt(n,1)-this.e}getCharCode(n){const t=this.G(n);return this.l(t)}findMatchesInNode(n,t,c,u,i,b,a,l,g,$,v){const y=this.a[n.piece.bufferIndex],h=this.u(n.piece.bufferIndex,n.piece.start),E=this.u(n.piece.bufferIndex,i),k=this.u(n.piece.bufferIndex,b);let I;const P={line:0,column:0};let V,W;t._wordSeparators?(V=y.buffer.substring(E,k),W=q=>q+E,t.reset(0)):(V=y.buffer,W=q=>q,t.reset(E));do if(I=t.next(V),I){if(W(I.index)>=k)return $;this.s(n,W(I.index)-h,P);const q=this.t(n.piece.bufferIndex,i,P),R=P.line===i.line?P.column-i.column+u:P.column+1,z=R+I[0].length;if(v[$++]=(0,A.$WC)(new N.$zt(c+q,R,c+q,z),I,l),W(I.index)+I[0].length>=k||$>=g)return $}while(I);return $}findMatchesLineByLine(n,t,c,u){const i=[];let b=0;const a=new A.$ZC(t.wordSeparators,t.regex);let l=this.H(n.startLineNumber,n.startColumn);if(l===null)return[];const g=this.H(n.endLineNumber,n.endColumn);if(g===null)return[];let $=this.s(l.node,l.remainder);const v=this.s(g.node,g.remainder);if(l.node===g.node)return this.findMatchesInNode(l.node,a,n.startLineNumber,n.startColumn,$,v,t,c,u,b,i),i;let y=n.startLineNumber,h=l.node;for(;h!==g.node;){const k=this.t(h.piece.bufferIndex,$,h.piece.end);if(k>=1){const P=this.a[h.piece.bufferIndex].lineStarts,V=this.u(h.piece.bufferIndex,h.piece.start),W=P[$.line+k],q=y===n.startLineNumber?n.startColumn:1;if(b=this.findMatchesInNode(h,a,y,q,$,this.s(h,W-V),t,c,u,b,i),b>=u)return i;y+=k}const I=y===n.startLineNumber?n.startColumn-1:0;if(y===n.endLineNumber){const P=this.getLineContent(y).substring(I,n.endColumn-1);return b=this.n(t,a,P,n.endLineNumber,I,b,i,c,u),i}if(b=this.n(t,a,this.getLineContent(y).substr(I),y,I,b,i,c,u),b>=u)return i;y++,l=this.H(y,1),h=l.node,$=this.s(l.node,l.remainder)}if(y===n.endLineNumber){const k=y===n.startLineNumber?n.startColumn-1:0,I=this.getLineContent(y).substring(k,n.endColumn-1);return b=this.n(t,a,I,n.endLineNumber,k,b,i,c,u),i}const E=y===n.startLineNumber?n.startColumn:1;return b=this.findMatchesInNode(g.node,a,y,E,$,v,t,c,u,b,i),i}n(n,t,c,u,i,b,a,l,g){const $=n.wordSeparators;if(!l&&n.simpleSearch){const y=n.simpleSearch,h=y.length,E=c.length;let k=-h;for(;(k=c.indexOf(y,k+h))!==-1;)if((!$||(0,A.$YC)($,c,E,k,h))&&(a[b++]=new M.$Zv(new N.$zt(u,k+1+i,u,k+1+h+i),null),b>=g))return b;return b}let v;t.reset(0);do if(v=t.next(c),v&&(a[b++]=(0,A.$WC)(new N.$zt(u,v.index+1+i,u,v.index+1+v[0].length+i),v,l),b>=g))return b;while(v);return b}insert(n,t,c=!1){if(this.f=this.f&&c,this.j.lineNumber=0,this.j.value="",this.root!==T.$LC){const{node:u,remainder:i,nodeStartOffset:b}=this.G(n),a=u.piece,l=a.bufferIndex,g=this.s(u,i);if(u.piece.bufferIndex===0&&a.end.line===this.g.line&&a.end.column===this.g.column&&b+a.length===n&&t.length<p){this.F(u,t),this.y();return}if(b===n)this.o(t,u),this.h.validate(n);else if(b+u.piece.length>n){const $=[];let v=new d(a.bufferIndex,g,a.end,this.t(a.bufferIndex,g,a.end),this.u(l,a.end)-this.u(l,g));if(this.K()&&this.M(t)&&this.I(u,i)===10){const k={line:v.start.line+1,column:0};v=new d(v.bufferIndex,k,v.end,this.t(v.bufferIndex,k,v.end),v.length-1),t+=`
`}if(this.K()&&this.L(t))if(this.I(u,i-1)===13){const k=this.s(u,i-1);this.C(u,k),t="\r"+t,u.piece.length===0&&$.push(u)}else this.C(u,g);else this.C(u,g);const y=this.w(t);v.length>0&&this.S(u,v);let h=u;for(let E=0;E<y.length;E++)h=this.S(h,y[E]);this.v($)}else this.q(t,u)}else{const u=this.w(t);let i=this.T(null,u[0]);for(let b=1;b<u.length;b++)i=this.S(i,u[b])}this.y()}delete(n,t){if(this.j.lineNumber=0,this.j.value="",t<=0||this.root===T.$LC)return;const c=this.G(n),u=this.G(n+t),i=c.node,b=u.node;if(i===b){const y=this.s(i,c.remainder),h=this.s(i,u.remainder);if(c.nodeStartOffset===n){if(t===i.piece.length){const E=i.next();(0,T.$QC)(this,i),this.N(E),this.y();return}this.D(i,h),this.h.validate(n),this.N(i),this.y();return}if(c.nodeStartOffset+i.piece.length===n+t){this.C(i,y),this.O(i),this.y();return}this.E(i,y,h),this.y();return}const a=[],l=this.s(i,c.remainder);this.C(i,l),this.h.validate(n),i.piece.length===0&&a.push(i);const g=this.s(b,u.remainder);this.D(b,g),b.piece.length===0&&a.push(b);const $=i.next();for(let y=$;y!==T.$LC&&y!==b;y=y.next())a.push(y);const v=i.piece.length===0?i.prev():i;this.v(a),this.O(v),this.y()}o(n,t){const c=[];if(this.K()&&this.M(n)&&this.L(t)){const b=t.piece,a={line:b.start.line+1,column:0},l=new d(b.bufferIndex,a,b.end,this.t(b.bufferIndex,a,b.end),b.length-1);t.piece=l,n+=`
`,(0,T.$SC)(this,t,-1,-1),t.piece.length===0&&c.push(t)}const u=this.w(n);let i=this.T(t,u[u.length-1]);for(let b=u.length-2;b>=0;b--)i=this.T(i,u[b]);this.N(i),this.v(c)}q(n,t){this.Q(n,t)&&(n+=`
`);const c=this.w(n),u=this.S(t,c[0]);let i=u;for(let b=1;b<c.length;b++)i=this.S(i,c[b]);this.N(u)}s(n,t,c){const u=n.piece,i=n.piece.bufferIndex,b=this.a[i].lineStarts,l=b[u.start.line]+u.start.column+t;let g=u.start.line,$=u.end.line,v=0,y=0,h=0;for(;g<=$&&(v=g+($-g)/2|0,h=b[v],v!==$);)if(y=b[v+1],l<h)$=v-1;else if(l>=y)g=v+1;else break;return c?(c.line=v,c.column=l-h,null):{line:v,column:l-h}}t(n,t,c){if(c.column===0)return c.line-t.line;const u=this.a[n].lineStarts;if(c.line===u.length-1)return c.line-t.line;const i=u[c.line+1],b=u[c.line]+c.column;if(i>b+1)return c.line-t.line;const a=b-1;return this.a[n].buffer.charCodeAt(a)===13?c.line-t.line+1:c.line-t.line}u(n,t){return this.a[n].lineStarts[t.line]+t.column}v(n){for(let t=0;t<n.length;t++)(0,T.$QC)(this,n[t])}w(n){if(n.length>p){const $=[];for(;n.length>p;){const y=n.charCodeAt(p-1);let h;y===13||y>=55296&&y<=56319?(h=n.substring(0,p-1),n=n.substring(p-1)):(h=n.substring(0,p),n=n.substring(p));const E=O(h);$.push(new d(this.a.length,{line:0,column:0},{line:E.length-1,column:h.length-E[E.length-1]},E.length-1,h.length)),this.a.push(new w(h,E))}const v=O(n);return $.push(new d(this.a.length,{line:0,column:0},{line:v.length-1,column:n.length-v[v.length-1]},v.length-1,n.length)),this.a.push(new w(n,v)),$}let t=this.a[0].buffer.length;const c=O(n,!1);let u=this.g;if(this.a[0].lineStarts[this.a[0].lineStarts.length-1]===t&&t!==0&&this.L(n)&&this.M(this.a[0].buffer)){this.g={line:this.g.line,column:this.g.column+1},u=this.g;for(let $=0;$<c.length;$++)c[$]+=t+1;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+="_"+n,t+=1}else{if(t!==0)for(let $=0;$<c.length;$++)c[$]+=t;this.a[0].lineStarts=this.a[0].lineStarts.concat(c.slice(1)),this.a[0].buffer+=n}const i=this.a[0].buffer.length,b=this.a[0].lineStarts.length-1,a=i-this.a[0].lineStarts[b],l={line:b,column:a},g=new d(0,u,l,this.t(0,u,l),i-t);return this.g=l,[g]}getLinesRawContent(){return this.U(this.root)}getLineRawContent(n,t=0){let c=this.root,u="";const i=this.h.get2(n);if(i){c=i.node;const b=this.B(c,n-i.nodeStartLineNumber-1),a=this.a[c.piece.bufferIndex].buffer,l=this.u(c.piece.bufferIndex,c.piece.start);if(i.nodeStartLineNumber+c.piece.lineFeedCnt===n)u=a.substring(l+b,l+c.piece.length);else{const g=this.B(c,n-i.nodeStartLineNumber);return a.substring(l+b,l+g-t)}}else{let b=0;const a=n;for(;c!==T.$LC;)if(c.left!==T.$LC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const l=this.B(c,n-c.lf_left-2),g=this.B(c,n-c.lf_left-1),$=this.a[c.piece.bufferIndex].buffer,v=this.u(c.piece.bufferIndex,c.piece.start);return b+=c.size_left,this.h.set({node:c,nodeStartOffset:b,nodeStartLineNumber:a-(n-1-c.lf_left)}),$.substring(v+l,v+g-t)}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const l=this.B(c,n-c.lf_left-2),g=this.a[c.piece.bufferIndex].buffer,$=this.u(c.piece.bufferIndex,c.piece.start);u=g.substring($+l,$+c.piece.length);break}else n-=c.lf_left+c.piece.lineFeedCnt,b+=c.size_left+c.piece.length,c=c.right}for(c=c.next();c!==T.$LC;){const b=this.a[c.piece.bufferIndex].buffer;if(c.piece.lineFeedCnt>0){const a=this.B(c,0),l=this.u(c.piece.bufferIndex,c.piece.start);return u+=b.substring(l,l+a-t),u}else{const a=this.u(c.piece.bufferIndex,c.piece.start);u+=b.substr(a,c.piece.length)}c=c.next()}return u}y(){let n=this.root,t=1,c=0;for(;n!==T.$LC;)t+=n.lf_left+n.piece.lineFeedCnt,c+=n.size_left+n.piece.length,n=n.right;this.b=t,this.c=c,this.h.validate(this.c)}A(n,t){const c=n.piece,u=this.s(n,t),i=u.line-c.start.line;if(this.u(c.bufferIndex,c.end)-this.u(c.bufferIndex,c.start)===t){const b=this.t(n.piece.bufferIndex,c.start,u);if(b!==i)return{index:b,remainder:0}}return{index:i,remainder:u.column}}B(n,t){if(t<0)return 0;const c=n.piece,u=this.a[c.bufferIndex].lineStarts,i=c.start.line+t+1;return i>c.end.line?u[c.end.line]+c.end.column-u[c.start.line]-c.start.column:u[i]-u[c.start.line]-c.start.column}C(n,t){const c=n.piece,u=c.lineFeedCnt,i=this.u(c.bufferIndex,c.end),b=t,a=this.u(c.bufferIndex,b),l=this.t(c.bufferIndex,c.start,b),g=l-u,$=a-i,v=c.length+$;n.piece=new d(c.bufferIndex,c.start,b,l,v),(0,T.$SC)(this,n,$,g)}D(n,t){const c=n.piece,u=c.lineFeedCnt,i=this.u(c.bufferIndex,c.start),b=t,a=this.t(c.bufferIndex,b,c.end),l=this.u(c.bufferIndex,b),g=a-u,$=i-l,v=c.length+$;n.piece=new d(c.bufferIndex,b,c.end,a,v),(0,T.$SC)(this,n,$,g)}E(n,t,c){const u=n.piece,i=u.start,b=u.end,a=u.length,l=u.lineFeedCnt,g=t,$=this.t(u.bufferIndex,u.start,g),v=this.u(u.bufferIndex,t)-this.u(u.bufferIndex,i);n.piece=new d(u.bufferIndex,u.start,g,$,v),(0,T.$SC)(this,n,v-a,$-l);const y=new d(u.bufferIndex,c,b,this.t(u.bufferIndex,c,b),this.u(u.bufferIndex,b)-this.u(u.bufferIndex,c)),h=this.S(n,y);this.N(h)}F(n,t){this.Q(t,n)&&(t+=`
`);const c=this.K()&&this.L(t)&&this.M(n),u=this.a[0].buffer.length;this.a[0].buffer+=t;const i=O(t,!1);for(let h=0;h<i.length;h++)i[h]+=u;if(c){const h=this.a[0].lineStarts[this.a[0].lineStarts.length-2];this.a[0].lineStarts.pop(),this.g={line:this.g.line-1,column:u-h}}this.a[0].lineStarts=this.a[0].lineStarts.concat(i.slice(1));const b=this.a[0].lineStarts.length-1,a=this.a[0].buffer.length-this.a[0].lineStarts[b],l={line:b,column:a},g=n.piece.length+t.length,$=n.piece.lineFeedCnt,v=this.t(0,n.piece.start,l),y=v-$;n.piece=new d(n.piece.bufferIndex,n.piece.start,l,v,g),this.g=l,(0,T.$SC)(this,n,t.length,y)}G(n){let t=this.root;const c=this.h.get(n);if(c)return{node:c.node,nodeStartOffset:c.nodeStartOffset,remainder:n-c.nodeStartOffset};let u=0;for(;t!==T.$LC;)if(t.size_left>n)t=t.left;else if(t.size_left+t.piece.length>=n){u+=t.size_left;const i={node:t,remainder:n-t.size_left,nodeStartOffset:u};return this.h.set(i),i}else n-=t.size_left+t.piece.length,u+=t.size_left+t.piece.length,t=t.right;return null}H(n,t){let c=this.root,u=0;for(;c!==T.$LC;)if(c.left!==T.$LC&&c.lf_left>=n-1)c=c.left;else if(c.lf_left+c.piece.lineFeedCnt>n-1){const i=this.B(c,n-c.lf_left-2),b=this.B(c,n-c.lf_left-1);return u+=c.size_left,{node:c,remainder:Math.min(i+t-1,b),nodeStartOffset:u}}else if(c.lf_left+c.piece.lineFeedCnt===n-1){const i=this.B(c,n-c.lf_left-2);if(i+t-1<=c.piece.length)return{node:c,remainder:i+t-1,nodeStartOffset:u};t-=c.piece.length-i;break}else n-=c.lf_left+c.piece.lineFeedCnt,u+=c.size_left+c.piece.length,c=c.right;for(c=c.next();c!==T.$LC;){if(c.piece.lineFeedCnt>0){const i=this.B(c,0),b=this.J(c);return{node:c,remainder:Math.min(t-1,i),nodeStartOffset:b}}else if(c.piece.length>=t-1){const i=this.J(c);return{node:c,remainder:t-1,nodeStartOffset:i}}else t-=c.piece.length;c=c.next()}return null}I(n,t){if(n.piece.lineFeedCnt<1)return-1;const c=this.a[n.piece.bufferIndex],u=this.u(n.piece.bufferIndex,n.piece.start)+t;return c.buffer.charCodeAt(u)}J(n){if(!n)return 0;let t=n.size_left;for(;n!==this.root;)n.parent.right===n&&(t+=n.parent.size_left+n.parent.piece.length),n=n.parent;return t}K(){return!(this.f&&this.d===`
`)}L(n){if(typeof n=="string")return n.charCodeAt(0)===10;if(n===T.$LC||n.piece.lineFeedCnt===0)return!1;const t=n.piece,c=this.a[t.bufferIndex].lineStarts,u=t.start.line,i=c[u]+t.start.column;return u===c.length-1||c[u+1]>i+1?!1:this.a[t.bufferIndex].buffer.charCodeAt(i)===10}M(n){return typeof n=="string"?n.charCodeAt(n.length-1)===13:n===T.$LC||n.piece.lineFeedCnt===0?!1:this.I(n,n.piece.length-1)===13}N(n){if(this.K()&&this.L(n)){const t=n.prev();this.M(t)&&this.P(t,n)}}O(n){if(this.K()&&this.M(n)){const t=n.next();this.L(t)&&this.P(n,t)}}P(n,t){const c=[],u=this.a[n.piece.bufferIndex].lineStarts;let i;n.piece.end.column===0?i={line:n.piece.end.line-1,column:u[n.piece.end.line]-u[n.piece.end.line-1]-1}:i={line:n.piece.end.line,column:n.piece.end.column-1};const b=n.piece.length-1,a=n.piece.lineFeedCnt-1;n.piece=new d(n.piece.bufferIndex,n.piece.start,i,a,b),(0,T.$SC)(this,n,-1,-1),n.piece.length===0&&c.push(n);const l={line:t.piece.start.line+1,column:0},g=t.piece.length-1,$=this.t(t.piece.bufferIndex,l,t.piece.end);t.piece=new d(t.piece.bufferIndex,l,t.piece.end,$,g),(0,T.$SC)(this,t,-1,-1),t.piece.length===0&&c.push(t);const v=this.w(`\r
`);this.S(n,v[0]);for(let y=0;y<c.length;y++)(0,T.$QC)(this,c[y])}Q(n,t){if(this.K()&&this.M(n)){const c=t.next();if(this.L(c)){if(n+=`
`,c.piece.length===1)(0,T.$QC)(this,c);else{const u=c.piece,i={line:u.start.line+1,column:0},b=u.length-1,a=this.t(u.bufferIndex,i,u.end);c.piece=new d(u.bufferIndex,i,u.end,a,b),(0,T.$SC)(this,c,-1,-1)}return!0}}return!1}iterate(n,t){if(n===T.$LC)return t(T.$LC);const c=this.iterate(n.left,t);return c&&t(n)&&this.iterate(n.right,t)}R(n){if(n===T.$LC)return"";const t=this.a[n.piece.bufferIndex],c=n.piece,u=this.u(c.bufferIndex,c.start),i=this.u(c.bufferIndex,c.end);return t.buffer.substring(u,i)}getPieceContent(n){const t=this.a[n.bufferIndex],c=this.u(n.bufferIndex,n.start),u=this.u(n.bufferIndex,n.end);return t.buffer.substring(c,u)}S(n,t){const c=new T.$KC(t,1);if(c.left=T.$LC,c.right=T.$LC,c.parent=T.$LC,c.size_left=0,c.lf_left=0,this.root===T.$LC)this.root=c,c.color=0;else if(n.right===T.$LC)n.right=c,c.parent=n;else{const i=(0,T.$MC)(n.right);i.left=c,c.parent=i}return(0,T.$RC)(this,c),c}T(n,t){const c=new T.$KC(t,1);if(c.left=T.$LC,c.right=T.$LC,c.parent=T.$LC,c.size_left=0,c.lf_left=0,this.root===T.$LC)this.root=c,c.color=0;else if(n.left===T.$LC)n.left=c,c.parent=n;else{const u=(0,T.$NC)(n.left);u.right=c,c.parent=u}return(0,T.$RC)(this,c),c}U(n){let t="";return this.iterate(n,c=>(t+=this.R(c),!0)),t}}e.$5C=r}),define(Se[143],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$M0=e.$L0=void 0;class C{constructor(){this.a=new Map}removeDragOperationTransfer(T){if(T&&this.a.has(T)){const A=this.a.get(T);return this.a.delete(T),A}}addDragOperationTransfer(T,A){this.a.set(T,A)}}e.$L0=C;class N{constructor(T){this.identifier=T}}e.$M0=N}),define(Se[144],Ie([9,10]),function(le,e){return le.create("vs/base/common/actions",e)}),define(Se[145],Ie([1,0,5,6,144]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hj=e.$gj=e.$fj=e.$ej=e.$dj=void 0,e.$ij=O;class T extends N.$Uc{constructor(d,w="",f="",o=!0,r){super(),this.j=this.B(new C.$fe),this.onDidChange=this.j.event,this.z=!0,this.m=d,this.n=w,this.w=f,this.z=o,this.D=r}get id(){return this.m}get label(){return this.n}set label(d){this.F(d)}F(d){this.n!==d&&(this.n=d,this.j.fire({label:d}))}get tooltip(){return this.u||""}set tooltip(d){this.G(d)}G(d){this.u!==d&&(this.u=d,this.j.fire({tooltip:d}))}get class(){return this.w}set class(d){this.H(d)}H(d){this.w!==d&&(this.w=d,this.j.fire({class:d}))}get enabled(){return this.z}set enabled(d){this.I(d)}I(d){this.z!==d&&(this.z=d,this.j.fire({enabled:d}))}get checked(){return this.C}set checked(d){this.J(d)}J(d){this.C!==d&&(this.C=d,this.j.fire({checked:d}))}async run(d,w){this.D&&await this.D(d)}}e.$dj=T;class A extends N.$Uc{constructor(){super(...arguments),this.f=this.B(new C.$fe),this.onWillRun=this.f.event,this.m=this.B(new C.$fe),this.onDidRun=this.m.event}async run(d,w){if(!d.enabled)return;this.f.fire({action:d});let f;try{await this.u(d,w)}catch(o){f=o}this.m.fire({action:d,error:f})}async u(d,w){await d.run(w)}}e.$ej=A;class p{constructor(){this.id=p.ID,this.label="",this.tooltip="",this.class="separator",this.enabled=!1,this.checked=!1}static join(...d){let w=[];for(const f of d)f.length&&(w.length?w=[...w,new p,...f]:w=f);return w}static{this.ID="vs.actions.separator"}async run(){}}e.$fj=p;class m{get actions(){return this.a}constructor(d,w,f,o){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=d,this.label=w,this.class=o,this.a=f}async run(){}}e.$gj=m;class D extends T{static{this.ID="vs.actions.empty"}constructor(){super(D.ID,M.localize(0,null),void 0,!1)}}e.$hj=D;function O(S){return{id:S.id,label:S.label,class:S.class,enabled:S.enabled??!0,checked:S.checked,run:async(...d)=>S.run(...d),tooltip:S.label}}}),define(Se[146],Ie([9,10]),function(le,e){return le.create("vs/base/common/date",e)}),define(Se[147],Ie([1,0,146]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$4m=D,e.$5m=O,e.$6m=S;const N=60,M=N*60,T=M*24,A=T*7,p=T*30,m=T*365;function D(d,w,f,o){typeof d!="number"&&(d=d.getTime());const r=Math.round((new Date().getTime()-d)/1e3);if(r<-30)return(0,C.localize)(0,null,D(new Date().getTime()+r*1e3,!1));if(!o&&r<30)return(0,C.localize)(1,null);let s;return r<N?(s=r,w?s===1?f?(0,C.localize)(2,null,s):(0,C.localize)(3,null,s):f?(0,C.localize)(4,null,s):(0,C.localize)(5,null,s):s===1?f?(0,C.localize)(6,null,s):(0,C.localize)(7,null,s):f?(0,C.localize)(8,null,s):(0,C.localize)(9,null,s)):r<M?(s=Math.floor(r/N),w?s===1?f?(0,C.localize)(10,null,s):(0,C.localize)(11,null,s):f?(0,C.localize)(12,null,s):(0,C.localize)(13,null,s):s===1?f?(0,C.localize)(14,null,s):(0,C.localize)(15,null,s):f?(0,C.localize)(16,null,s):(0,C.localize)(17,null,s)):r<T?(s=Math.floor(r/M),w?s===1?f?(0,C.localize)(18,null,s):(0,C.localize)(19,null,s):f?(0,C.localize)(20,null,s):(0,C.localize)(21,null,s):s===1?f?(0,C.localize)(22,null,s):(0,C.localize)(23,null,s):f?(0,C.localize)(24,null,s):(0,C.localize)(25,null,s)):r<A?(s=Math.floor(r/T),w?s===1?(0,C.localize)(26,null,s):(0,C.localize)(27,null,s):s===1?(0,C.localize)(28,null,s):(0,C.localize)(29,null,s)):r<p?(s=Math.floor(r/A),w?s===1?f?(0,C.localize)(30,null,s):(0,C.localize)(31,null,s):f?(0,C.localize)(32,null,s):(0,C.localize)(33,null,s):s===1?f?(0,C.localize)(34,null,s):(0,C.localize)(35,null,s):f?(0,C.localize)(36,null,s):(0,C.localize)(37,null,s)):r<m?(s=Math.floor(r/p),w?s===1?f?(0,C.localize)(38,null,s):(0,C.localize)(39,null,s):f?(0,C.localize)(40,null,s):(0,C.localize)(41,null,s):s===1?f?(0,C.localize)(42,null,s):(0,C.localize)(43,null,s):f?(0,C.localize)(44,null,s):(0,C.localize)(45,null,s)):(s=Math.floor(r/m),w?s===1?f?(0,C.localize)(46,null,s):(0,C.localize)(47,null,s):f?(0,C.localize)(48,null,s):(0,C.localize)(49,null,s):s===1?f?(0,C.localize)(50,null,s):(0,C.localize)(51,null,s):f?(0,C.localize)(52,null,s):(0,C.localize)(53,null,s))}function O(d,w){const f=Math.abs(d/1e3);return f<1?w?(0,C.localize)(54,null,d):(0,C.localize)(55,null,d):f<N?w?(0,C.localize)(56,null,Math.round(d)/1e3):(0,C.localize)(57,null,Math.round(d)/1e3):f<M?w?(0,C.localize)(58,null,Math.round(d/(1e3*N))):(0,C.localize)(59,null,Math.round(d/(1e3*N))):f<T?w?(0,C.localize)(60,null,Math.round(d/(1e3*M))):(0,C.localize)(61,null,Math.round(d/(1e3*M))):(0,C.localize)(62,null,Math.round(d/(1e3*T)))}function S(d){return d.getFullYear()+"-"+String(d.getMonth()+1).padStart(2,"0")+"-"+String(d.getDate()).padStart(2,"0")+"T"+String(d.getHours()).padStart(2,"0")+":"+String(d.getMinutes()).padStart(2,"0")+":"+String(d.getSeconds()).padStart(2,"0")+"."+(d.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}}),define(Se[148],Ie([9,10]),function(le,e){return le.create("vs/base/common/errorMessage",e)}),define(Se[44],Ie([1,0,18,15,148]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jj=m,e.$kj=D,e.$lj=O;function T(S,d){return d&&(S.stack||S.stacktrace)?M.localize(0,null,p(S),A(S.stack)||A(S.stacktrace)):p(S)}function A(S){return Array.isArray(S)?S.join(`
`):S}function p(S){return S.code==="ERR_UNC_HOST_NOT_ALLOWED"?`${S.message}. Please update the 'security.allowedUNCHosts' setting if you want to allow this host.`:typeof S.code=="string"&&typeof S.errno=="number"&&typeof S.syscall=="string"?M.localize(1,null,S.message):S.message||M.localize(2,null)}function m(S=null,d=!1){if(!S)return M.localize(3,null);if(Array.isArray(S)){const w=C.$Hb(S),f=m(w[0],d);return w.length>1?M.localize(4,null,f,w.length):f}if(N.$$f(S))return S;if(S.detail){const w=S.detail;if(w.error)return T(w.error,d);if(w.exception)return T(w.exception,d)}return S.stack?T(S,d):S.message?S.message:M.localize(5,null)}function D(S){const d=S;return d instanceof Error&&Array.isArray(d.actions)}function O(S,d){let w;return typeof S=="string"?w=new Error(S):w=S,w.actions=d,w}}),define(Se[149],Ie([1,0,43,19]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lr=p,e.$mr=m,e.$nr=D,e.$or=O,e.$pr=S,e.$qr=d,e.$rr=w,e.$sr=f,e.$tr=o,e.$ur=r,e.$vr=g,e.$wr=$,e.$xr=v;const M=new C.$V(()=>{const y=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:y,collatorIsNumeric:y.resolvedOptions().numeric}}),T=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),A=new C.$V(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function p(y,h,E=!1){const k=y||"",I=h||"",P=M.value.collator.compare(k,I);return M.value.collatorIsNumeric&&P===0&&k!==I?k<I?-1:1:P}function m(y,h){const E=T.value.collator;return y=y||"",h=h||"",c(E,y,h)}function D(y,h){const E=T.value.collator;return y=y||"",h=h||"",a(y,h)||c(E,y,h)}function O(y,h){const E=T.value.collator;return y=y||"",h=h||"",b(y,h)||c(E,y,h)}function S(y,h){return y=y||"",h=h||"",y===h?0:y<h?-1:1}function d(y,h){const[E,k]=n(y),[I,P]=n(h);let V=M.value.collator.compare(k,P);if(V===0){if(M.value.collatorIsNumeric&&k!==P)return k<P?-1:1;if(V=M.value.collator.compare(E,I),M.value.collatorIsNumeric&&V===0&&E!==I)return E<I?-1:1}return V}function w(y,h){y=y||"",h=h||"";const E=t(y),k=t(h),I=T.value.collator,P=A.value.collator;return c(P,E,k)||c(I,y,h)}function f(y,h){y=y||"",h=h||"";const E=t(y),k=t(h),I=T.value.collator,P=A.value.collator;return c(P,E,k)||a(y,h)||c(I,y,h)}function o(y,h){y=y||"",h=h||"";const E=t(y),k=t(h),I=T.value.collator,P=A.value.collator;return c(P,E,k)||b(y,h)||c(I,y,h)}function r(y,h){y=y||"",h=h||"";const E=t(y).toLowerCase(),k=t(h).toLowerCase();return E!==k?E<k?-1:1:y!==h?y<h?-1:1:0}const s=/^(.*?)(\.([^.]*))?$/;function n(y,h=!1){const E=y?s.exec(y):[];let k=[E&&E[1]||"",E&&E[3]||""];return h&&(!k[0]&&k[1]||k[0]&&k[0].charAt(0)===".")&&(k=[k[0]+"."+k[1],""]),k}function t(y){const h=y?s.exec(y):[];return h&&h[1]&&h[1].charAt(0)!=="."&&h[3]||""}function c(y,h,E){const k=y.compare(h,E);return k!==0?k:h.length!==E.length?h.length<E.length?-1:1:0}function u(y){const h=y.charAt(0);return h.toLocaleUpperCase()!==h}function i(y){const h=y.charAt(0);return h.toLocaleLowerCase()!==h}function b(y,h){return u(y)&&i(h)?-1:i(y)&&u(h)?1:0}function a(y,h){return i(y)&&u(h)?-1:u(y)&&i(h)?1:0}function l(y,h,E=!1){return E||(y=y&&y.toLowerCase(),h=h&&h.toLowerCase()),y===h?0:y<h?-1:1}function g(y,h,E=!1){const k=y.split(N.sep),I=h.split(N.sep),P=k.length-1,V=I.length-1;let W,q;for(let R=0;;R++){if(W=P===R,q=V===R,W&&q)return p(k[R],I[R],E);if(W)return-1;if(q)return 1;const z=l(k[R],I[R],E);if(z!==0)return z}}function $(y,h,E){const k=y.toLowerCase(),I=h.toLowerCase(),P=v(y,h,E);if(P)return P;const V=k.endsWith(E),W=I.endsWith(E);if(V!==W)return V?-1:1;const q=p(k,I);return q!==0?q:k.localeCompare(I)}function v(y,h,E){const k=y.toLowerCase(),I=h.toLowerCase(),P=k.startsWith(E),V=I.startsWith(E);if(P!==V)return P?-1:1;if(P&&V){if(k.length<I.length)return-1;if(k.length>I.length)return 1}return 0}}),define(Se[49],Ie([1,0,19,23,13,15]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qg=A,e.$rg=p,e.$sg=m,e.$tg=D,e.$ug=O,e.$vg=f,e.$wg=o,e.$xg=r,e.$yg=s,e.$zg=n,e.$Ag=t,e.$Bg=c,e.$Cg=u,e.$Dg=i,e.$Eg=b,e.$Fg=a,e.$Gg=$;function A(v){return v===47||v===92}function p(v){return v.replace(/[\\/]/g,C.$gc.sep)}function m(v){return v.indexOf("/")===-1&&(v=p(v)),/^[a-zA-Z]:(\/|$)/.test(v)&&(v="/"+v),v}function D(v,y=C.$gc.sep){if(!v)return"";const h=v.length,E=v.charCodeAt(0);if(A(E)){if(A(v.charCodeAt(1))&&!A(v.charCodeAt(2))){let I=3;const P=I;for(;I<h&&!A(v.charCodeAt(I));I++);if(P!==I&&!A(v.charCodeAt(I+1))){for(I+=1;I<h;I++)if(A(v.charCodeAt(I)))return v.slice(0,I+1).replace(/[\\/]/g,y)}}return y}else if(s(E)&&v.charCodeAt(1)===58)return A(v.charCodeAt(2))?v.slice(0,2)+y:v.slice(0,2);let k=v.indexOf("://");if(k!==-1){for(k+=3;k<h;k++)if(A(v.charCodeAt(k)))return v.slice(0,k+1)}return""}function O(v){if(!N.$i||!v||v.length<5)return!1;let y=v.charCodeAt(0);if(y!==92||(y=v.charCodeAt(1),y!==92))return!1;let h=2;const E=h;for(;h<v.length&&(y=v.charCodeAt(h),y!==92);h++);return!(E===h||(y=v.charCodeAt(h+1),isNaN(y)||y===92))}const S=/[\\/:\*\?"<>\|]/g,d=/[\\/]/g,w=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(v,y=N.$i){const h=y?S:d;return!(!v||v.length===0||/^\s+$/.test(v)||(h.lastIndex=0,h.test(v))||y&&w.test(v)||v==="."||v===".."||y&&v[v.length-1]==="."||y&&v.length!==v.trim().length||v.length>255)}function o(v,y,h){const E=v===y;return!h||E?E:!v||!y?!1:(0,M.$zf)(v,y)}function r(v,y,h,E=C.sep){if(v===y)return!0;if(!v||!y||y.length>v.length)return!1;if(h){if(!(0,M.$Af)(v,y))return!1;if(y.length===v.length)return!0;let I=y.length;return y.charAt(y.length-1)===E&&I--,v.charAt(I)===E}return y.charAt(y.length-1)!==E&&(y+=E),v.indexOf(y)===0}function s(v){return v>=65&&v<=90||v>=97&&v<=122}function n(v,y){return N.$i&&v.endsWith(":")&&(v+=C.sep),(0,C.$ic)(v)||(v=(0,C.$jc)(y,v)),v=(0,C.$hc)(v),t(v)}function t(v){return N.$i?(v=(0,M.$hf)(v,C.sep),v.endsWith(":")&&(v+=C.sep)):(v=(0,M.$hf)(v,C.sep),v||(v=C.sep)),v}function c(v){const y=(0,C.$hc)(v);return N.$i?v.length>3?!1:u(y)&&(v.length===2||y.charCodeAt(2)===92):y===C.$gc.sep}function u(v,y=N.$i){return y?s(v.charCodeAt(0))&&v.charCodeAt(1)===58:!1}function i(v,y=N.$i){return u(v,y)?v[0]:void 0}function b(v,y,h){return y.length>v.length?-1:v===y?0:(h&&(v=v.toLowerCase(),y=y.toLowerCase()),v.indexOf(y))}function a(v){const y=v.split(":");let h,E,k;for(const I of y){const P=Number(I);(0,T.$cg)(P)?E===void 0?E=P:k===void 0&&(k=P):h=h?[h,I].join(":"):I}if(!h)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:h,line:E!==void 0?E:void 0,column:k!==void 0?k:E!==void 0?1:void 0}}const l="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789",g="BDEFGHIJKMOQRSTUVWXYZbdefghijkmoqrstuvwxyz0123456789";function $(v,y,h=8){let E="";for(let I=0;I<h;I++){let P;I===0&&N.$i&&!y&&(h===3||h===4)?P=g:P=l,E+=P.charAt(Math.floor(Math.random()*P.length))}let k;return y?k=`${y}-${E}`:k=E,v?(0,C.$jc)(v,k):k}}),define(Se[70],Ie([1,0,19]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vs=void 0,e.$Ws=T,e.$Xs=A,e.$Ys=p,e.$Zs=D,e.$Vs=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const N={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function T(O){const S=(0,C.$oc)(O),d=N[S.toLowerCase()];return d!==void 0?d:A(O)}function A(O){const S=(0,C.$oc)(O);return M[S.toLowerCase()]}function p(O){for(const S in M)if(M[S]===O)return S}const m=/^(.+)\/(.+?)(;.+)?$/;function D(O,S){const d=m.exec(O);return d?`${d[1].toLowerCase()}/${d[2].toLowerCase()}${d[3]??""}`:S?void 0:O}}),define(Se[45],Ie([1,0,22,2]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6h=M,e.$7h=T,e.$8h=p;function M(m){return JSON.stringify(m,A)}function T(m){let D=JSON.parse(m);return D=p(D),D}function A(m,D){return D instanceof RegExp?{$mid:2,source:D.source,flags:D.flags}:D}function p(m,D=0){if(!m||D>200)return m;if(typeof m=="object"){switch(m.$mid){case 1:return N.URI.revive(m);case 2:return new RegExp(m.source,m.flags);case 17:return new Date(m.source)}if(m instanceof C.$He||m instanceof Uint8Array)return m;if(Array.isArray(m))for(let O=0;O<m.length;++O)m[O]=p(m[O],D+1);else for(const O in m)Object.hasOwnProperty.call(m,O)&&(m[O]=p(m[O],D+1))}return m}}),define(Se[16],Ie([1,0,14,23,13,2,19]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.COI=e.$Sg=e.$Rg=e.$Qg=e.$Pg=e.$Og=e.$Ng=e.$Lg=e.$Kg=e.$Jg=e.Schemas=void 0,e.$Hg=m,e.$Ig=D,e.$Mg=S;var p;(function(f){f.inMemory="inmemory",f.vscode="vscode",f.internal="private",f.walkThrough="walkThrough",f.walkThroughSnippet="walkThroughSnippet",f.http="http",f.https="https",f.file="file",f.mailto="mailto",f.untitled="untitled",f.data="data",f.command="command",f.vscodeRemote="vscode-remote",f.vscodeRemoteResource="vscode-remote-resource",f.vscodeManagedRemoteResource="vscode-managed-remote-resource",f.vscodeUserData="vscode-userdata",f.vscodeCustomEditor="vscode-custom-editor",f.vscodeNotebookCell="vscode-notebook-cell",f.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",f.vscodeNotebookCellOutput="vscode-notebook-cell-output",f.vscodeInteractiveInput="vscode-interactive-input",f.vscodeSettings="vscode-settings",f.vscodeWorkspaceTrust="vscode-workspace-trust",f.vscodeTerminal="vscode-terminal",f.vscodeChatCodeBlock="vscode-chat-code-block",f.vscodeChatCodeCompareBlock="vscode-chat-code-compare-block",f.vscodeChatSesssion="vscode-chat-editor",f.webviewPanel="webview-panel",f.vscodeWebview="vscode-webview",f.extension="extension",f.vscodeFileResource="vscode-file",f.tmp="tmp",f.vsls="vsls",f.vscodeSourceControl="vscode-scm",f.commentsInput="comment",f.codeSetting="code-setting"})(p||(e.Schemas=p={}));function m(f,o){return T.URI.isUri(f)?(0,M.$zf)(f.scheme,o):(0,M.$Af)(f,o+":")}function D(f,...o){return o.some(r=>m(f,r))}e.$Jg="vscode-tkn",e.$Kg="tkn";class O{constructor(){this.a=Object.create(null),this.b=Object.create(null),this.c=Object.create(null),this.d="http",this.e=null,this.f="/"}setPreferredWebSchema(o){this.d=o}setDelegate(o){this.e=o}setServerRootPath(o,r){this.f=S(o,r)}getServerRootPath(){return this.f}get g(){return A.$gc.join(this.f,p.vscodeRemoteResource)}set(o,r,s){this.a[o]=r,this.b[o]=s}setConnectionToken(o,r){this.c[o]=r}getPreferredWebSchema(){return this.d}rewrite(o){if(this.e)try{return this.e(o)}catch(u){return C.$1(u),o}const r=o.authority;let s=this.a[r];s&&s.indexOf(":")!==-1&&s.indexOf("[")===-1&&(s=`[${s}]`);const n=this.b[r],t=this.c[r];let c=`path=${encodeURIComponent(o.path)}`;return typeof t=="string"&&(c+=`&${e.$Kg}=${encodeURIComponent(t)}`),T.URI.from({scheme:N.$o?this.d:p.vscodeRemoteResource,authority:`${s}:${n}`,path:this.g,query:c})}}e.$Lg=new O;function S(f,o){return A.$gc.join(o??"/",`${f.quality??"oss"}-${f.commit??"dev"}`)}e.$Ng="vs/../../extensions",e.$Og="vs/../../node_modules",e.$Pg="vs/../../node_modules.asar",e.$Qg="vs/../../node_modules.asar.unpacked",e.$Rg="vscode-app";class d{static{this.a=e.$Rg}asBrowserUri(o){const r=this.b(o,le);return this.uriToBrowserUri(r)}uriToBrowserUri(o){return o.scheme===p.vscodeRemote?e.$Lg.rewrite(o):o.scheme===p.file&&(N.$m||N.$q===`${p.vscodeFileResource}://${d.a}`)?o.with({scheme:p.vscodeFileResource,authority:o.authority||d.a,query:null,fragment:null}):o}asFileUri(o){const r=this.b(o,le);return this.uriToFileUri(r)}uriToFileUri(o){return o.scheme===p.vscodeFileResource?o.with({scheme:p.file,authority:o.authority!==d.a?o.authority:null,query:null,fragment:null}):o}b(o,r){return T.URI.isUri(o)?o:T.URI.parse(r.toUrl(o))}}e.$Sg=new d;var w;(function(f){const o=new Map([["1",{"Cross-Origin-Opener-Policy":"same-origin"}],["2",{"Cross-Origin-Embedder-Policy":"require-corp"}],["3",{"Cross-Origin-Opener-Policy":"same-origin","Cross-Origin-Embedder-Policy":"require-corp"}]]);f.CoopAndCoep=Object.freeze(o.get("3"));const r="vscode-coi";function s(t){let c;typeof t=="string"?c=new URL(t).searchParams:t instanceof URL?c=t.searchParams:T.URI.isUri(t)&&(c=new URL(t.toString(!0)).searchParams);const u=c?.get(r);if(u)return o.get(u)}f.getHeadersFromQuery=s;function n(t,c,u){if(!globalThis.crossOriginIsolated)return;const i=c&&u?"3":u?"2":"1";t instanceof URLSearchParams?t.set(r,i):t[r]=i}f.addSearchParam=n})(w||(e.COI=w={}))}),define(Se[24],Ie([1,0,49,16,19,23,13,2]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataUri=e.$hh=e.$gh=e.$fh=e.$eh=e.$dh=e.$ch=e.$bh=e.$ah=e.$_g=e.$$g=e.$0g=e.$9g=e.$8g=e.$7g=e.$6g=e.$5g=e.$4g=e.$3g=e.$2g=e.$1g=void 0,e.$Zg=m,e.$ih=O,e.$jh=d;function m(w){return(0,p.$wc)(w,!0)}class D{constructor(f){this.a=f}compare(f,o,r=!1){return f===o?0:(0,A.$sf)(this.getComparisonKey(f,r),this.getComparisonKey(o,r))}isEqual(f,o,r=!1){return f===o?!0:!f||!o?!1:this.getComparisonKey(f,r)===this.getComparisonKey(o,r)}getComparisonKey(f,o=!1){return f.with({path:this.a(f)?f.path.toLowerCase():void 0,fragment:o?null:void 0}).toString()}ignorePathCasing(f){return this.a(f)}isEqualOrParent(f,o,r=!1){if(f.scheme===o.scheme){if(f.scheme===N.Schemas.file)return C.$xg(m(f),m(o),this.a(f))&&f.query===o.query&&(r||f.fragment===o.fragment);if((0,e.$eh)(f.authority,o.authority))return C.$xg(f.path,o.path,this.a(f),"/")&&f.query===o.query&&(r||f.fragment===o.fragment)}return!1}joinPath(f,...o){return p.URI.joinPath(f,...o)}basenameOrAuthority(f){return(0,e.$9g)(f)||f.authority}basename(f){return M.$gc.basename(f.path)}extname(f){return M.$gc.extname(f.path)}dirname(f){if(f.path.length===0)return f;let o;return f.scheme===N.Schemas.file?o=p.URI.file(M.$mc(m(f))).path:(o=M.$gc.dirname(f.path),f.authority&&o.length&&o.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),o="/")),f.with({path:o})}normalizePath(f){if(!f.path.length)return f;let o;return f.scheme===N.Schemas.file?o=p.URI.file(M.$hc(m(f))).path:o=M.$gc.normalize(f.path),f.with({path:o})}relativePath(f,o){if(f.scheme!==o.scheme||!(0,e.$eh)(f.authority,o.authority))return;if(f.scheme===N.Schemas.file){const n=M.$lc(m(f),m(o));return T.$i?C.$rg(n):n}let r=f.path||"/";const s=o.path||"/";if(this.a(f)){let n=0;for(const t=Math.min(r.length,s.length);n<t&&!(r.charCodeAt(n)!==s.charCodeAt(n)&&r.charAt(n).toLowerCase()!==s.charAt(n).toLowerCase());n++);r=s.substr(0,n)+r.substr(n)}return M.$gc.relative(r,s)}resolvePath(f,o){if(f.scheme===N.Schemas.file){const r=p.URI.file(M.$kc(m(f),o));return f.with({authority:r.authority,path:r.path})}return o=C.$sg(o),f.with({path:M.$gc.resolve(f.path,o)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,o){return f===o||f!==void 0&&o!==void 0&&(0,A.$zf)(f,o)}hasTrailingPathSeparator(f,o=M.sep){if(f.scheme===N.Schemas.file){const r=m(f);return r.length>C.$tg(r).length&&r[r.length-1]===o}else{const r=f.path;return r.length>1&&r.charCodeAt(r.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,o=M.sep){return(0,e.$fh)(f,o)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,o=M.sep){let r=!1;if(f.scheme===N.Schemas.file){const s=m(f);r=s!==void 0&&s.length===C.$tg(s).length&&s[s.length-1]===o}else{o="/";const s=f.path;r=s.length===1&&s.charCodeAt(s.length-1)===47}return!r&&!(0,e.$fh)(f,o)?f.with({path:f.path+"/"}):f}}e.$1g=D,e.$2g=new D(()=>!1),e.$3g=new D(w=>w.scheme===N.Schemas.file?!T.$k:!0),e.$4g=new D(w=>!0),e.$5g=e.$2g.isEqual.bind(e.$2g),e.$6g=e.$2g.isEqualOrParent.bind(e.$2g),e.$7g=e.$2g.getComparisonKey.bind(e.$2g),e.$8g=e.$2g.basenameOrAuthority.bind(e.$2g),e.$9g=e.$2g.basename.bind(e.$2g),e.$0g=e.$2g.extname.bind(e.$2g),e.$$g=e.$2g.dirname.bind(e.$2g),e.$_g=e.$2g.joinPath.bind(e.$2g),e.$ah=e.$2g.normalizePath.bind(e.$2g),e.$bh=e.$2g.relativePath.bind(e.$2g),e.$ch=e.$2g.resolvePath.bind(e.$2g),e.$dh=e.$2g.isAbsolutePath.bind(e.$2g),e.$eh=e.$2g.isEqualAuthority.bind(e.$2g),e.$fh=e.$2g.hasTrailingPathSeparator.bind(e.$2g),e.$gh=e.$2g.removeTrailingPathSeparator.bind(e.$2g),e.$hh=e.$2g.addTrailingPathSeparator.bind(e.$2g);function O(w,f){const o=[];for(let r=0;r<w.length;r++){const s=f(w[r]);w.some((n,t)=>t===r?!1:(0,e.$6g)(s,f(n)))||o.push(w[r])}return o}var S;(function(w){w.META_DATA_LABEL="label",w.META_DATA_DESCRIPTION="description",w.META_DATA_SIZE="size",w.META_DATA_MIME="mime";function f(o){const r=new Map;o.path.substring(o.path.indexOf(";")+1,o.path.lastIndexOf(";")).split(";").forEach(t=>{const[c,u]=t.split(":");c&&u&&r.set(c,u)});const n=o.path.substring(0,o.path.indexOf(";"));return n&&r.set(w.META_DATA_MIME,n),r}w.parseMetaData=f})(S||(e.DataUri=S={}));function d(w,f,o){if(f){let r=w.path;return r&&r[0]!==M.$gc.sep&&(r=M.$gc.sep+r),w.with({scheme:o,authority:f,path:r})}return w.with({scheme:o})}}),define(Se[11],Ie([1,0,20,14,5,6,24,23,136,43]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2h=e.$Zh=e.$Yh=e.$Xh=e.$Wh=e.Promises=e.$Vh=e.$Uh=e.$Th=e.$Rh=e.$Qh=e.$Ph=e.$Oh=e.$Nh=e.$Mh=e.$Lh=e.$Kh=e.$Jh=e.$Ih=e.$Hh=e.$Gh=e.$Fh=e.$Eh=e.$yh=e.$xh=e.$wh=e.$vh=e.$uh=e.$th=e.$sh=void 0,e.$kh=O,e.$lh=S,e.$mh=d,e.$nh=w,e.$oh=f,e.$ph=o,e.$qh=r,e.$rh=s,e.$zh=$,e.$Ah=v,e.$Bh=y,e.$Ch=h,e.$Dh=E,e.$Sh=De,e.$1h=ke;function O(me){return!!me&&typeof me.then=="function"}function S(me){const Q=new C.$qe,Y=me(Q.token),he=new Promise((ce,Te)=>{const fe=Q.token.onCancellationRequested(()=>{fe.dispose(),Te(new N.$5)});Promise.resolve(Y).then(Pe=>{fe.dispose(),Q.dispose(),ce(Pe)},Pe=>{fe.dispose(),Q.dispose(),Te(Pe)})});return new class{cancel(){Q.cancel(),Q.dispose()}then(ce,Te){return he.then(ce,Te)}catch(ce){return this.then(void 0,ce)}finally(ce){return he.finally(ce)}}}function d(me,Q,Y){return new Promise((he,ce)=>{const Te=Q.onCancellationRequested(()=>{Te.dispose(),he(Y)});me.then(he,ce).finally(()=>Te.dispose())})}function w(me,Q){return new Promise((Y,he)=>{const ce=Q.onCancellationRequested(()=>{ce.dispose(),he(new N.$5)});me.then(Y,he).finally(()=>ce.dispose())})}async function f(me){let Q=-1;const Y=me.map((he,ce)=>he.then(Te=>(Q=ce,Te)));try{return await Promise.race(Y)}finally{me.forEach((he,ce)=>{ce!==Q&&he.cancel()})}}function o(me,Q,Y){let he;const ce=setTimeout(()=>{he?.(void 0),Y?.()},Q);return Promise.race([me.finally(()=>clearTimeout(ce)),new Promise(Te=>he=Te)])}function r(me){return new Promise((Q,Y)=>{const he=me();O(he)?he.then(Q,Y):Q(he)})}function s(){let me,Q;return{promise:new Promise((he,ce)=>{me=he,Q=ce}),resolve:me,reject:Q}}class n{constructor(){this.f=!1,this.a=null,this.b=null,this.d=null}queue(Q){if(this.f)return Promise.reject(new Error("Throttler is disposed"));if(this.a){if(this.d=Q,!this.b){const Y=()=>{if(this.b=null,this.f)return;const he=this.queue(this.d);return this.d=null,he};this.b=new Promise(he=>{this.a.then(Y,Y).then(he)})}return new Promise((Y,he)=>{this.b.then(Y,he)})}return this.a=Q(),new Promise((Y,he)=>{this.a.then(ce=>{this.a=null,Y(ce)},ce=>{this.a=null,he(ce)})})}dispose(){this.f=!0}}e.$sh=n;class t{constructor(){this.a=Promise.resolve(null)}queue(Q){return this.a=this.a.then(()=>Q(),()=>Q())}}e.$th=t;class c{constructor(){this.a=new Map}queue(Q,Y){const ce=(this.a.get(Q)??Promise.resolve()).catch(()=>{}).then(Y).finally(()=>{this.a.get(Q)===ce&&this.a.delete(Q)});return this.a.set(Q,ce),ce}}e.$uh=c;const u=(me,Q)=>{let Y=!0;const he=setTimeout(()=>{Y=!1,Q()},me);return{isTriggered:()=>Y,dispose:()=>{clearTimeout(he),Y=!1}}},i=me=>{let Q=!0;return queueMicrotask(()=>{Q&&(Q=!1,me())}),{isTriggered:()=>Q,dispose:()=>{Q=!1}}};class b{constructor(Q){this.defaultDelay=Q,this.a=null,this.b=null,this.d=null,this.f=null,this.g=null}trigger(Q,Y=this.defaultDelay){this.g=Q,this.h(),this.b||(this.b=new Promise((ce,Te)=>{this.d=ce,this.f=Te}).then(()=>{if(this.b=null,this.d=null,this.g){const ce=this.g;return this.g=null,ce()}}));const he=()=>{this.a=null,this.d?.(null)};return this.a=Y===m.$ce?i(he):u(Y,he),this.b}isTriggered(){return!!this.a?.isTriggered()}cancel(){this.h(),this.b&&(this.f?.(new N.$5),this.b=null)}h(){this.a?.dispose(),this.a=null}dispose(){this.cancel()}}e.$vh=b;class a{constructor(Q){this.a=new b(Q),this.b=new n}trigger(Q,Y){return this.a.trigger(()=>this.b.queue(Q),Y)}isTriggered(){return this.a.isTriggered()}cancel(){this.a.cancel()}dispose(){this.a.dispose(),this.b.dispose()}}e.$wh=a;class l{constructor(){this.a=!1,this.b=new Promise((Q,Y)=>{this.d=Q})}isOpen(){return this.a}open(){this.a=!0,this.d(!0)}wait(){return this.b}}e.$xh=l;class g extends l{constructor(Q){super(),this.f=setTimeout(()=>this.open(),Q)}open(){clearTimeout(this.f),super.open()}}e.$yh=g;function $(me,Q){return Q?new Promise((Y,he)=>{const ce=setTimeout(()=>{Te.dispose(),Y()},me),Te=Q.onCancellationRequested(()=>{clearTimeout(ce),Te.dispose(),he(new N.$5)})}):S(Y=>$(me,Y))}function v(me,Q=0,Y){const he=setTimeout(()=>{me(),Y&&ce.dispose()},Q),ce=(0,T.$Sc)(()=>{clearTimeout(he),Y?.deleteAndLeak(ce)});return Y?.add(ce),ce}function y(me){const Q=[];let Y=0;const he=me.length;function ce(){return Y<he?me[Y++]():null}function Te(fe){fe!=null&&Q.push(fe);const Pe=ce();return Pe?Pe.then(Te):Promise.resolve(Q)}return Promise.resolve(null).then(Te)}function h(me,Q=he=>!!he,Y=null){let he=0;const ce=me.length,Te=()=>{if(he>=ce)return Promise.resolve(Y);const fe=me[he++];return Promise.resolve(fe()).then(Re=>Q(Re)?Promise.resolve(Re):Te())};return Te()}function E(me,Q=he=>!!he,Y=null){if(me.length===0)return Promise.resolve(Y);let he=me.length;const ce=()=>{he=-1;for(const Te of me)Te.cancel?.()};return new Promise((Te,fe)=>{for(const Pe of me)Pe.then(Re=>{--he>=0&&Q(Re)?(ce(),Te(Re)):he===0&&Te(Y)}).catch(Re=>{--he>=0&&(ce(),fe(Re))})})}class k{constructor(Q){this.a=0,this.b=!1,this.f=Q,this.g=[],this.d=0,this.h=new M.$fe}whenIdle(){return this.size>0?M.Event.toPromise(this.onDrained):Promise.resolve()}get onDrained(){return this.h.event}get size(){return this.a}queue(Q){if(this.b)throw new Error("Object has been disposed");return this.a++,new Promise((Y,he)=>{this.g.push({factory:Q,c:Y,e:he}),this.j()})}j(){for(;this.g.length&&this.d<this.f;){const Q=this.g.shift();this.d++;const Y=Q.factory();Y.then(Q.c,Q.e),Y.then(()=>this.k(),()=>this.k())}}k(){this.b||(this.d--,--this.a===0&&this.h.fire(),this.g.length>0&&this.j())}clear(){if(this.b)throw new Error("Object has been disposed");this.g.length=0,this.a=this.d}dispose(){this.b=!0,this.g.length=0,this.a=0,this.h.dispose()}}e.$Eh=k;class I extends k{constructor(){super(1)}}e.$Fh=I;class P{constructor(){this.a=new ge,this.b=0}queue(Q){return this.a.isRunning()?this.a.queue(()=>this.a.run(this.b++,Q())):this.a.run(this.b++,Q())}}e.$Gh=P;class V{constructor(){this.a=new Map,this.b=new Set,this.d=void 0,this.f=0}async whenDrained(){if(this.g())return;const Q=new se;return this.b.add(Q),Q.p}g(){for(const[,Q]of this.a)if(Q.size>0)return!1;return!0}queueSize(Q,Y=A.$2g){const he=Y.getComparisonKey(Q);return this.a.get(he)?.size??0}queueFor(Q,Y,he=A.$2g){const ce=he.getComparisonKey(Q);let Te=this.a.get(ce);if(!Te){Te=new I;const fe=this.f++,Pe=M.Event.once(Te.onDrained)(()=>{Te?.dispose(),this.a.delete(ce),this.h(),this.d?.deleteAndDispose(fe),this.d?.size===0&&(this.d.dispose(),this.d=void 0)});this.d||(this.d=new T.$4c),this.d.set(fe,Pe),this.a.set(ce,Te)}return Te.queue(Y)}h(){this.g()&&this.j()}j(){for(const Q of this.b)Q.complete();this.b.clear()}dispose(){for(const[,Q]of this.a)Q.dispose();this.a.clear(),this.j(),this.d?.dispose()}}e.$Hh=V;class W{constructor(Q,Y){this.a=-1,typeof Q=="function"&&typeof Y=="number"&&this.setIfNotSet(Q,Y)}dispose(){this.cancel()}cancel(){this.a!==-1&&(clearTimeout(this.a),this.a=-1)}cancelAndSet(Q,Y){this.cancel(),this.a=setTimeout(()=>{this.a=-1,Q()},Y)}setIfNotSet(Q,Y){this.a===-1&&(this.a=setTimeout(()=>{this.a=-1,Q()},Y))}}e.$Ih=W;class q{constructor(){this.d=void 0}cancel(){this.d?.dispose(),this.d=void 0}cancelAndSet(Q,Y,he=globalThis){this.cancel();const ce=he.setInterval(()=>{Q()},Y);this.d=(0,T.$Sc)(()=>{he.clearInterval(ce),this.d=void 0})}dispose(){this.cancel()}}e.$Jh=q;class R{constructor(Q,Y){this.b=-1,this.a=Q,this.d=Y,this.f=this.g.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearTimeout(this.b),this.b=-1)}schedule(Q=this.d){this.cancel(),this.b=setTimeout(this.f,Q)}get delay(){return this.d}set delay(Q){this.d=Q}isScheduled(){return this.b!==-1}flush(){this.isScheduled()&&(this.cancel(),this.h())}g(){this.b=-1,this.a&&this.h()}h(){this.a?.()}}e.$Kh=R;class z{constructor(Q,Y){Y%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Y}ms is not a multiple of 1000ms.`),this.a=Q,this.b=Y,this.d=0,this.f=-1,this.g=this.h.bind(this)}dispose(){this.cancel(),this.a=null}cancel(){this.isScheduled()&&(clearInterval(this.f),this.f=-1)}schedule(Q=this.b){Q%1e3!==0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${Q}ms is not a multiple of 1000ms.`),this.cancel(),this.d=Math.ceil(Q/1e3),this.f=setInterval(this.g,1e3)}isScheduled(){return this.f!==-1}h(){this.d--,!(this.d>0)&&(clearInterval(this.f),this.f=-1,this.a?.())}}e.$Lh=z;class K extends R{constructor(Q,Y){super(Q,Y),this.j=[]}work(Q){this.j.push(Q),this.isScheduled()||this.schedule()}h(){const Q=this.j;this.j=[],this.a?.(Q)}dispose(){this.j=[],super.dispose()}}e.$Mh=K;class ie extends T.$Uc{constructor(Q,Y){super(),this.g=Q,this.h=Y,this.a=[],this.b=this.B(new T.$Vc),this.f=!1}get pending(){return this.a.length}work(Q){if(this.f)return!1;if(typeof this.g.maxBufferedWork=="number"){if(this.b.value){if(this.pending+Q.length>this.g.maxBufferedWork)return!1}else if(this.pending+Q.length-this.g.maxWorkChunkSize>this.g.maxBufferedWork)return!1}for(const Y of Q)this.a.push(Y);return this.b.value||this.j(),!0}j(){this.h(this.a.splice(0,this.g.maxWorkChunkSize)),this.a.length>0&&(this.b.value=new R(()=>{this.b.clear(),this.j()},this.g.throttleDelay),this.b.value.schedule())}dispose(){super.dispose(),this.f=!0}}e.$Nh=ie,function(){typeof globalThis.requestIdleCallback!="function"||typeof globalThis.cancelIdleCallback!="function"?e.$Ph=(me,Q)=>{(0,p.$B)(()=>{if(Y)return;const he=Date.now()+15;Q(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,he-Date.now())}}))});let Y=!1;return{dispose(){Y||(Y=!0)}}}:e.$Ph=(me,Q,Y)=>{const he=me.requestIdleCallback(Q,typeof Y=="number"?{timeout:Y}:void 0);let ce=!1;return{dispose(){ce||(ce=!0,me.cancelIdleCallback(he))}}},e.$Oh=me=>(0,e.$Ph)(globalThis,me)}();class de{constructor(Q,Y){this.g=!1,this.d=()=>{try{this.j=Y()}catch(he){this.l=he}finally{this.g=!0}},this.f=(0,e.$Ph)(Q,()=>this.d())}dispose(){this.f.dispose()}get value(){if(this.g||(this.f.dispose(),this.d()),this.l)throw this.l;return this.j}get isInitialized(){return this.g}}e.$Qh=de;class ye extends de{constructor(Q){super(globalThis,Q)}}e.$Rh=ye;async function De(me,Q,Y){let he;for(let ce=0;ce<Y;ce++)try{return await me()}catch(Te){he=Te,await $(Q)}throw he}class ge{isRunning(Q){return typeof Q=="number"?this.a?.taskId===Q:!!this.a}get running(){return this.a?.promise}cancelRunning(){this.a?.cancel()}run(Q,Y,he){return this.a={taskId:Q,cancel:()=>he?.(),promise:Y},Y.then(()=>this.d(Q),()=>this.d(Q)),Y}d(Q){this.a&&Q===this.a.taskId&&(this.a=void 0,this.f())}f(){if(this.b){const Q=this.b;this.b=void 0,Q.run().then(Q.promiseResolve,Q.promiseReject)}}queue(Q){if(this.b)this.b.run=Q;else{const{promise:Y,resolve:he,reject:ce}=s();this.b={run:Q,promise:Y,promiseResolve:he,promiseReject:ce}}return this.b.promise}hasQueued(){return!!this.b}async join(){return this.b?.promise??this.a?.promise}}e.$Th=ge;class ue{constructor(Q,Y=()=>Date.now()){this.d=Q,this.f=Y,this.a=0,this.b=0}increment(){const Q=this.f();return Q-this.a>this.d&&(this.a=Q,this.b=0),this.b++,this.b}}e.$Uh=ue;var Ce;(function(me){me[me.Resolved=0]="Resolved",me[me.Rejected=1]="Rejected"})(Ce||(Ce={}));class se{get isRejected(){return this.d?.outcome===1}get isResolved(){return this.d?.outcome===0}get isSettled(){return!!this.d}get value(){return this.d?.outcome===0?this.d?.value:void 0}constructor(){this.p=new Promise((Q,Y)=>{this.a=Q,this.b=Y})}complete(Q){return new Promise(Y=>{this.a(Q),this.d={outcome:0,value:Q},Y()})}error(Q){return new Promise(Y=>{this.b(Q),this.d={outcome:1,value:Q},Y()})}cancel(){return this.error(new N.$5)}}e.$Vh=se;var Ne;(function(me){async function Q(he){let ce;const Te=await Promise.all(he.map(fe=>fe.then(Pe=>Pe,Pe=>{ce||(ce=Pe)})));if(typeof ce<"u")throw ce;return Te}me.settled=Q;function Y(he){return new Promise(async(ce,Te)=>{try{await he(ce,Te)}catch(fe){Te(fe)}})}me.withAsyncBody=Y})(Ne||(e.Promises=Ne={}));class ne{get value(){return this.a}get error(){return this.b}get isResolved(){return this.d}constructor(Q){this.a=void 0,this.b=void 0,this.d=!1,this.promise=Q.then(Y=>(this.a=Y,this.d=!0,Y),Y=>{throw this.b=Y,this.d=!0,Y})}requireValue(){if(!this.d)throw new N.$cb("Promise is not resolved yet");if(this.b)throw this.b;return this.a}}e.$Wh=ne;class U{constructor(Q){this.b=Q,this.a=new D.$V(()=>new ne(this.b()))}requireValue(){return this.a.value.requireValue()}getPromise(){return this.a.value.promise}get currentValue(){return this.a.rawValue?.value}}e.$Xh=U;var x;(function(me){me[me.Initial=0]="Initial",me[me.DoneOK=1]="DoneOK",me[me.DoneError=2]="DoneError"})(x||(x={}));class ve{static fromArray(Q){return new ve(Y=>{Y.emitMany(Q)})}static fromPromise(Q){return new ve(async Y=>{Y.emitMany(await Q)})}static fromPromises(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>Y.emitOne(await he)))})}static merge(Q){return new ve(async Y=>{await Promise.all(Q.map(async he=>{for await(const ce of he)Y.emitOne(ce)}))})}static{this.EMPTY=ve.fromArray([])}constructor(Q,Y){this.a=0,this.b=[],this.d=null,this.f=Y,this.g=new M.$fe,queueMicrotask(async()=>{const he={emitOne:ce=>this.h(ce),emitMany:ce=>this.j(ce),reject:ce=>this.l(ce)};try{await Promise.resolve(Q(he)),this.k()}catch(ce){this.l(ce)}finally{he.emitOne=void 0,he.emitMany=void 0,he.reject=void 0}})}[Symbol.asyncIterator](){let Q=0;return{next:async()=>{do{if(this.a===2)throw this.d;if(Q<this.b.length)return{done:!1,value:this.b[Q++]};if(this.a===1)return{done:!0,value:void 0};await M.Event.toPromise(this.g.event)}while(!0)},return:async()=>(this.f?.(),{done:!0,value:void 0})}}static map(Q,Y){return new ve(async he=>{for await(const ce of Q)he.emitOne(Y(ce))})}map(Q){return ve.map(this,Q)}static filter(Q,Y){return new ve(async he=>{for await(const ce of Q)Y(ce)&&he.emitOne(ce)})}filter(Q){return ve.filter(this,Q)}static coalesce(Q){return ve.filter(Q,Y=>!!Y)}coalesce(){return ve.coalesce(this)}static async toPromise(Q){const Y=[];for await(const he of Q)Y.push(he);return Y}toPromise(){return ve.toPromise(this)}h(Q){this.a===0&&(this.b.push(Q),this.g.fire())}j(Q){this.a===0&&(this.b=this.b.concat(Q),this.g.fire())}k(){this.a===0&&(this.a=1,this.g.fire())}l(Q){this.a===0&&(this.a=2,this.d=Q,this.g.fire())}}e.$Yh=ve;class Le extends ve{constructor(Q,Y){super(Y),this.m=Q}cancel(){this.m.cancel()}}e.$Zh=Le;function ke(me){const Q=new C.$qe,Y=me(Q.token);return new Le(Q,async he=>{const ce=Q.token.onCancellationRequested(()=>{ce.dispose(),Q.dispose(),he.reject(new N.$5)});try{for await(const Te of Y){if(Q.token.isCancellationRequested)return;he.emitOne(Te)}ce.dispose(),Q.dispose()}catch(Te){ce.dispose(),Q.dispose(),he.reject(Te)}})}class be{constructor(Q){this.a=new se,this.b=new ve(ce=>{if(Y){ce.reject(Y);return}return he&&ce.emitMany(he),this.d=Te=>ce.reject(Te),this.f=Te=>ce.emitOne(Te),this.a.p},Q);let Y,he;this.f=ce=>{he||(he=[]),he.push(ce)},this.d=ce=>{Y||(Y=ce)}}get asyncIterable(){return this.b}resolve(){this.a.complete()}reject(Q){this.d(Q),this.a.complete()}emitOne(Q){this.f(Q)}}e.$2h=be}),define(Se[37],Ie([1,0,18,11,49,28,19,23,13]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pk=e.$ok=void 0,e.$nk=D,e.$qk=f,e.$rk=I,e.$sk=P,e.$tk=V,e.$uk=W,e.$vk=q,e.$wk=ie;function D(){return Object.create(null)}e.$ok="**",e.$pk="/";const O="[/\\\\]",S="[^/\\\\]",d=/\//g;function w(de,ye){switch(de){case 0:return"";case 1:return`${S}*?`;default:return`(?:${O}|${S}+${O}${ye?`|${O}${S}+`:""})*?`}}function f(de,ye){if(!de)return[];const De=[];let ge=!1,ue=!1,Ce="";for(const se of de){switch(se){case ye:if(!ge&&!ue){De.push(Ce),Ce="";continue}break;case"{":ge=!0;break;case"}":ge=!1;break;case"[":ue=!0;break;case"]":ue=!1;break}Ce+=se}return Ce&&De.push(Ce),De}function o(de){if(!de)return"";let ye="";const De=f(de,e.$pk);if(De.every(ge=>ge===e.$ok))ye=".*";else{let ge=!1;De.forEach((ue,Ce)=>{if(ue===e.$ok){if(ge)return;ye+=w(2,Ce===De.length-1)}else{let se=!1,Ne="",ne=!1,U="";for(const x of ue){if(x!=="}"&&se){Ne+=x;continue}if(ne&&(x!=="]"||!U)){let ve;x==="-"?ve=x:(x==="^"||x==="!")&&!U?ve="^":x===e.$pk?ve="":ve=(0,m.$bf)(x),U+=ve;continue}switch(x){case"{":se=!0;continue;case"[":ne=!0;continue;case"}":{const Le=`(?:${f(Ne,",").map(ke=>o(ke)).join("|")})`;ye+=Le,se=!1,Ne="";break}case"]":{ye+="["+U+"]",ne=!1,U="";break}case"?":ye+=S;continue;case"*":ye+=w(1);continue;default:ye+=(0,m.$bf)(x)}}Ce<De.length-1&&(De[Ce+1]!==e.$ok||Ce+2<De.length)&&(ye+=O)}ge=ue===e.$ok})}return ye}const r=/^\*\*\/\*\.[\w\.-]+$/,s=/^\*\*\/([\w\.-]+)\/?$/,n=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,t=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,c=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,i=new T.$Dc(1e4),b=function(){return!1},a=function(){return null};function l(de,ye){if(!de)return a;let De;typeof de!="string"?De=de.pattern:De=de,De=De.trim();const ge=`${De}_${!!ye.trimForExclusions}`;let ue=i.get(ge);if(ue)return g(ue,de);let Ce;return r.test(De)?ue=v(De.substr(4),De):(Ce=s.exec($(De,ye)))?ue=y(Ce[1],De):(ye.trimForExclusions?t:n).test(De)?ue=h(De,ye):(Ce=c.exec($(De,ye)))?ue=E(Ce[1].substr(1),De,!0):(Ce=u.exec($(De,ye)))?ue=E(Ce[1],De,!1):ue=k(De),i.set(ge,ue),g(ue,de)}function g(de,ye){if(typeof ye=="string")return de;const De=function(ge,ue){return(0,M.$xg)(ge,ye.base,!p.$k)?de((0,m.$gf)(ge.substr(ye.base.length),A.sep),ue):null};return De.allBasenames=de.allBasenames,De.allPaths=de.allPaths,De.basenames=de.basenames,De.patterns=de.patterns,De}function $(de,ye){return ye.trimForExclusions&&de.endsWith("/**")?de.substr(0,de.length-2):de}function v(de,ye){return function(De,ge){return typeof De=="string"&&De.endsWith(de)?ye:null}}function y(de,ye){const De=`/${de}`,ge=`\\${de}`,ue=function(se,Ne){return typeof se!="string"?null:Ne?Ne===de?ye:null:se===de||se.endsWith(De)||se.endsWith(ge)?ye:null},Ce=[de];return ue.basenames=Ce,ue.patterns=[ye],ue.allBasenames=Ce,ue}function h(de,ye){const De=K(de.slice(1,-1).split(",").map(Ne=>l(Ne,ye)).filter(Ne=>Ne!==a),de),ge=De.length;if(!ge)return a;if(ge===1)return De[0];const ue=function(Ne,ne){for(let U=0,x=De.length;U<x;U++)if(De[U](Ne,ne))return de;return null},Ce=De.find(Ne=>!!Ne.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const se=De.reduce((Ne,ne)=>ne.allPaths?Ne.concat(ne.allPaths):Ne,[]);return se.length&&(ue.allPaths=se),ue}function E(de,ye,De){const ge=A.sep===A.$gc.sep,ue=ge?de:de.replace(d,A.sep),Ce=A.sep+ue,se=A.$gc.sep+de;let Ne;return De?Ne=function(ne,U){return typeof ne=="string"&&(ne===ue||ne.endsWith(Ce)||!ge&&(ne===de||ne.endsWith(se)))?ye:null}:Ne=function(ne,U){return typeof ne=="string"&&(ne===ue||!ge&&ne===de)?ye:null},Ne.allPaths=[(De?"*/":"./")+de],Ne}function k(de){try{const ye=new RegExp(`^${o(de)}$`);return function(De){return ye.lastIndex=0,typeof De=="string"&&ye.test(De)?de:null}}catch{return a}}function I(de,ye,De){return!de||typeof ye!="string"?!1:P(de)(ye,void 0,De)}function P(de,ye={}){if(!de)return b;if(typeof de=="string"||V(de)){const De=l(de,ye);if(De===a)return b;const ge=function(ue,Ce){return!!De(ue,Ce)};return De.allBasenames&&(ge.allBasenames=De.allBasenames),De.allPaths&&(ge.allPaths=De.allPaths),ge}return R(de,ye)}function V(de){const ye=de;return ye?typeof ye.base=="string"&&typeof ye.pattern=="string":!1}function W(de){return de.allBasenames||[]}function q(de){return de.allPaths||[]}function R(de,ye){const De=K(Object.getOwnPropertyNames(de).map(Ne=>z(Ne,de[Ne],ye)).filter(Ne=>Ne!==a)),ge=De.length;if(!ge)return a;if(!De.some(Ne=>!!Ne.requiresSiblings)){if(ge===1)return De[0];const Ne=function(x,ve){let Le;for(let ke=0,be=De.length;ke<be;ke++){const me=De[ke](x,ve);if(typeof me=="string")return me;(0,N.$kh)(me)&&(Le||(Le=[]),Le.push(me))}return Le?(async()=>{for(const ke of Le){const be=await ke;if(typeof be=="string")return be}return null})():null},ne=De.find(x=>!!x.allBasenames);ne&&(Ne.allBasenames=ne.allBasenames);const U=De.reduce((x,ve)=>ve.allPaths?x.concat(ve.allPaths):x,[]);return U.length&&(Ne.allPaths=U),Ne}const ue=function(Ne,ne,U){let x,ve;for(let Le=0,ke=De.length;Le<ke;Le++){const be=De[Le];be.requiresSiblings&&U&&(ne||(ne=(0,A.$nc)(Ne)),x||(x=ne.substr(0,ne.length-(0,A.$oc)(Ne).length)));const me=be(Ne,ne,x,U);if(typeof me=="string")return me;(0,N.$kh)(me)&&(ve||(ve=[]),ve.push(me))}return ve?(async()=>{for(const Le of ve){const ke=await Le;if(typeof ke=="string")return ke}return null})():null},Ce=De.find(Ne=>!!Ne.allBasenames);Ce&&(ue.allBasenames=Ce.allBasenames);const se=De.reduce((Ne,ne)=>ne.allPaths?Ne.concat(ne.allPaths):Ne,[]);return se.length&&(ue.allPaths=se),ue}function z(de,ye,De){if(ye===!1)return a;const ge=l(de,De);if(ge===a)return a;if(typeof ye=="boolean")return ge;if(ye){const ue=ye.when;if(typeof ue=="string"){const Ce=(se,Ne,ne,U)=>{if(!U||!ge(se,Ne))return null;const x=ue.replace("$(basename)",()=>ne),ve=U(x);return(0,N.$kh)(ve)?ve.then(Le=>Le?de:null):ve?de:null};return Ce.requiresSiblings=!0,Ce}}return ge}function K(de,ye){const De=de.filter(Ne=>!!Ne.basenames);if(De.length<2)return de;const ge=De.reduce((Ne,ne)=>{const U=ne.basenames;return U?Ne.concat(U):Ne},[]);let ue;if(ye){ue=[];for(let Ne=0,ne=ge.length;Ne<ne;Ne++)ue.push(ye)}else ue=De.reduce((Ne,ne)=>{const U=ne.patterns;return U?Ne.concat(U):Ne},[]);const Ce=function(Ne,ne){if(typeof Ne!="string")return null;if(!ne){let x;for(x=Ne.length;x>0;x--){const ve=Ne.charCodeAt(x-1);if(ve===47||ve===92)break}ne=Ne.substr(x)}const U=ge.indexOf(ne);return U!==-1?ue[U]:null};Ce.basenames=ge,Ce.patterns=ue,Ce.allBasenames=ge;const se=de.filter(Ne=>!Ne.basenames);return se.push(Ce),se}function ie(de,ye){return(0,C.$ub)(de,ye,(De,ge)=>typeof De=="string"&&typeof ge=="string"?De===ge:typeof De!="string"&&typeof ge!="string"?De.base===ge.base&&De.pattern===ge.pattern:!1)}}),define(Se[55],Ie([1,0,14,137,24,13,2]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vk=e.MarkdownStringTextNewlineStyle=void 0,e.$Wk=D,e.$Xk=O,e.$Yk=S,e.$Zk=d,e.$1k=w,e.$2k=f,e.$3k=o,e.$4k=r;var p;(function(s){s[s.Paragraph=0]="Paragraph",s[s.Break=1]="Break"})(p||(e.MarkdownStringTextNewlineStyle=p={}));class m{constructor(n="",t=!1){if(this.value=n,typeof this.value!="string")throw(0,C.$7)("value");typeof t=="boolean"?(this.isTrusted=t,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=t.isTrusted??void 0,this.supportThemeIcons=t.supportThemeIcons??!1,this.supportHtml=t.supportHtml??!1)}appendText(n,t=0){return this.value+=d(this.supportThemeIcons?(0,N.$Pk)(n):n).replace(/([ \t]+)/g,(c,u)=>"&nbsp;".repeat(u.length)).replace(/\>/gm,"\\>").replace(/\n/g,t===1?`\\
`:`

`),this}appendMarkdown(n){return this.value+=n,this}appendCodeblock(n,t){return this.value+=`
${w(t,n)}
`,this}appendLink(n,t,c){return this.value+="[",this.value+=this.c(t,"]"),this.value+="](",this.value+=this.c(String(n),")"),c&&(this.value+=` "${this.c(this.c(c,'"'),")")}"`),this.value+=")",this}c(n,t){const c=new RegExp((0,T.$bf)(t),"g");return n.replace(c,(u,i)=>n.charAt(i-1)!=="\\"?`\\${u}`:u)}}e.$Vk=m;function D(s){return O(s)?!s.value:Array.isArray(s)?s.every(D):!0}function O(s){return s instanceof m?!0:s&&typeof s=="object"?typeof s.value=="string"&&(typeof s.isTrusted=="boolean"||typeof s.isTrusted=="object"||s.isTrusted===void 0)&&(typeof s.supportThemeIcons=="boolean"||s.supportThemeIcons===void 0):!1}function S(s,n){return s===n?!0:!s||!n?!1:s.value===n.value&&s.isTrusted===n.isTrusted&&s.supportThemeIcons===n.supportThemeIcons&&s.supportHtml===n.supportHtml&&(s.baseUri===n.baseUri||!!s.baseUri&&!!n.baseUri&&(0,M.$5g)(A.URI.from(s.baseUri),A.URI.from(n.baseUri)))}function d(s){return s.replace(/[\\`*_{}[\]()#+\-!~]/g,"\\$&")}function w(s,n){const t=s.match(/^`+/gm)?.reduce((u,i)=>u.length>i.length?u:i).length??0,c=t>=3?t+1:3;return[`${"`".repeat(c)}${n}`,s,`${"`".repeat(c)}`].join(`
`)}function f(s){return s.replace(/"/g,"&quot;")}function o(s){return s&&s.replace(/\\([\\`*_{}[\]()#+\-.!~])/g,"$1")}function r(s){const n=[],t=s.split("|").map(u=>u.trim());s=t[0];const c=t[1];if(c){const u=/height=(\d+)/.exec(c),i=/width=(\d+)/.exec(c),b=u?u[1]:"",a=i?i[1]:"",l=isFinite(parseInt(a)),g=isFinite(parseInt(b));l&&n.push(`width="${a}"`),g&&n.push(`height="${b}"`)}return{href:s,dimensions:n}}}),define(Se[97],Ie([1,0,18,49,19,23,24,13]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Iw=m,e.$Jw=O,e.$Kw=d,e.$Lw=w,e.$Mw=s,e.$Nw=t,e.$Ow=c,e.$Pw=u,e.$Qw=i,e.$Rw=b;function m(l,g){const{os:$,tildify:v,relative:y}=g;if(y){const k=D(l,y,$);if(typeof k=="string")return k}let h=l.fsPath;if($===1&&!T.$i?h=h.replace(/\//g,"\\"):$!==1&&T.$i&&(h=h.replace(/\\/g,"/")),$!==1&&v?.userHome){const k=v.userHome.fsPath;let I;l.scheme!==v.userHome.scheme&&l.path[0]===M.$gc.sep&&l.path[1]!==M.$gc.sep?I=v.userHome.with({path:l.path}).fsPath:I=h,h=d(I,k,$)}return($===1?M.$fc:M.$gc).normalize(O(h,$===1))}function D(l,g,$){const v=$===1?M.$fc:M.$gc,y=$===3?A.$2g:A.$4g,h=g.getWorkspace(),E=(0,C.$Ob)(h.folders);if(!E)return;l.scheme!==E.uri.scheme&&l.path[0]===M.$gc.sep&&l.path[1]!==M.$gc.sep&&(l=E.uri.with({path:l.path}));const k=g.getWorkspaceFolder(l);if(!k)return;let I;if(y.isEqual(k.uri,l)?I="":I=y.relativePath(k.uri,l)??"",I&&(I=v.normalize(I)),h.folders.length>1&&!g.noPrefix){const P=k.name?k.name:y.basenameOrAuthority(k.uri);I=I?`${P} \u2022 ${I}`:P}return I}function O(l,g=T.$i){return(0,N.$Cg)(l,g)?l.charAt(0).toUpperCase()+l.slice(1):l}let S=Object.create(null);function d(l,g,$=T.OS){if($===1||!l||!g)return l;let v=S.original===g?S.normalized:void 0;v||(v=g,T.$i&&(v=(0,N.$rg)(v)),v=`${(0,p.$hf)(v,M.$gc.sep)}${M.$gc.sep}`,S={original:g,normalized:v});let y=l;return T.$i&&(y=(0,N.$rg)(y)),($===3?y.startsWith(v):(0,p.$Af)(y,v))?`~/${y.substr(v.length)}`:l}function w(l,g){return l.replace(/^~($|\/|\\)/,`${g}$1`)}const f="\u2026",o="\\\\",r="~";function s(l,g=M.sep){const $=new Array(l.length);let v=!1;for(let y=0;y<l.length;y++){const h=l[y];if(h===""){$[y]=`.${g}`;continue}if(!h){$[y]=h;continue}v=!0;let E="",k=h;k.indexOf(o)===0?(E=k.substr(0,k.indexOf(o)+o.length),k=k.substr(k.indexOf(o)+o.length)):k.indexOf(g)===0?(E=k.substr(0,k.indexOf(g)+g.length),k=k.substr(k.indexOf(g)+g.length)):k.indexOf(r)===0&&(E=k.substr(0,k.indexOf(r)+r.length),k=k.substr(k.indexOf(r)+r.length));const I=k.split(g);for(let P=1;v&&P<=I.length;P++)for(let V=I.length-P;v&&V>=0;V--){v=!1;let W=I.slice(V,V+P).join(g);for(let q=0;!v&&q<l.length;q++)if(q!==y&&l[q]&&l[q].indexOf(W)>-1){const R=V+P===I.length,z=V>0&&l[q].indexOf(g)>-1?g+W:W,K=l[q].endsWith(z);v=!R||K}if(!v){let q="";(I[0].endsWith(":")||E!=="")&&(V===1&&(V=0,P++,W=I[0]+g+W),V>0&&(q=I[0]+g),q=E+q),V>0&&(q=q+f+g),q=q+W,V+P<I.length&&(q=q+g+f),$[y]=q}}v&&($[y]=h)}return $}var n;(function(l){l[l.TEXT=0]="TEXT",l[l.VARIABLE=1]="VARIABLE",l[l.SEPARATOR=2]="SEPARATOR"})(n||(n={}));function t(l,g=Object.create(null)){const $=[];let v=!1,y="";for(const h of l)if(h==="$"||v&&h==="{")y&&$.push({value:y,type:n.TEXT}),y="",v=!0;else if(h==="}"&&v){const E=g[y];if(typeof E=="string")E.length&&$.push({value:E,type:n.VARIABLE});else if(E){const k=$[$.length-1];(!k||k.type!==n.SEPARATOR)&&$.push({value:E.label,type:n.SEPARATOR})}y="",v=!1}else y+=h;return y&&!v&&$.push({value:y,type:n.TEXT}),$.filter((h,E)=>{if(h.type===n.SEPARATOR){const k=$[E-1],I=$[E+1];return[k,I].every(P=>P&&(P.type===n.VARIABLE||P.type===n.TEXT)&&P.value.length>0)}return!0}).map(h=>h.value).join("")}function c(l,g){return T.$j||g?l.replace(/\(&&\w\)|&&/g,"").replace(/&/g,T.$j?"&":"&&"):l.replace(/&&|&/g,$=>$==="&"?"&&":"&")}function u(l,g){return T.$j||g?l.replace(/\(&&\w\)|&&/g,""):T.$i?l.replace(/&&|&/g,$=>$==="&"?"&&":"&"):l.replace(/&&/g,"_")}function i(l){return l.replace(/&/g,"&&")}function b(l){if(l.endsWith("]")){const g=l.lastIndexOf(" [",l.length-2);if(g!==-1){const $=a(l.substring(0,g)),v=l.substring(g);return{name:$.name+v,parentPath:$.parentPath}}}return a(l)}function a(l){const g=l.indexOf("/")!==-1?M.$gc:M.$fc,$=g.basename(l),v=g.dirname(l);return $.length?{name:$,parentPath:v}:{name:v,parentPath:""}}}),define(Se[150],Ie([1,0,22,2]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bn=e.$An=void 0,e.$Cn=p,e.$Dn=D,e.$En=O;function M(S){return S.toJSON()}class T{constructor(d){this.a=d}transformIncoming(d){const w=this.a.transformIncoming(d);return w===d?d:M(N.URI.from(w))}transformOutgoing(d){const w=this.a.transformOutgoing(d);return w===d?d:M(N.URI.from(w))}transformOutgoingURI(d){const w=this.a.transformOutgoing(d);return w===d?d:N.URI.from(w)}transformOutgoingScheme(d){return this.a.transformOutgoingScheme(d)}}e.$An=T,e.$Bn=new class{transformIncoming(S){return S}transformOutgoing(S){return S}transformOutgoingURI(S){return S}transformOutgoingScheme(S){return S}};function A(S,d,w){if(!S||w>200)return null;if(typeof S=="object"){if(S instanceof N.URI)return d.transformOutgoing(S);for(const f in S)if(Object.hasOwnProperty.call(S,f)){const o=A(S[f],d,w+1);o!==null&&(S[f]=o)}}return null}function p(S,d){const w=A(S,d,0);return w===null?S:w}function m(S,d,w,f){if(!S||f>200)return null;if(typeof S=="object"){if(S.$mid===1)return w?N.URI.revive(d.transformIncoming(S)):d.transformIncoming(S);if(S instanceof C.$He)return null;for(const o in S)if(Object.hasOwnProperty.call(S,o)){const r=m(S[o],d,w,f+1);r!==null&&(S[o]=r)}}return null}function D(S,d){const w=m(S,d,!1,0);return w===null?S:w}function O(S,d){const w=m(S,d,!0,0);return w===null?S:w}}),define(Se[151],Ie([1,0,11,5,6,45,15]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2p=e.$1p=e.StorageState=e.StorageHint=void 0,e.$Zp=m;var p;(function(d){d[d.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST",d[d.STORAGE_IN_MEMORY=1]="STORAGE_IN_MEMORY"})(p||(e.StorageHint=p={}));function m(d){const w=d;return w?.changed instanceof Map||w?.deleted instanceof Set}var D;(function(d){d[d.None=0]="None",d[d.Initialized=1]="Initialized",d[d.Closed=2]="Closed"})(D||(e.StorageState=D={}));class O extends M.$Uc{static{this.a=100}constructor(w,f=Object.create(null)){super(),this.r=w,this.s=f,this.b=this.B(new N.$ie),this.onDidChangeStorage=this.b.event,this.c=D.None,this.f=new Map,this.g=this.B(new C.$wh(O.a)),this.h=new Set,this.j=new Map,this.m=void 0,this.n=[],this.t()}t(){this.B(this.r.onDidChangeItemsExternal(w=>this.u(w)))}u(w){this.b.pause();try{w.changed?.forEach((f,o)=>this.w(o,f)),w.deleted?.forEach(f=>this.w(f,void 0))}finally{this.b.resume()}}w(w,f){if(this.c===D.Closed)return;let o=!1;(0,A.$hg)(f)?o=this.f.delete(w):this.f.get(w)!==f&&(this.f.set(w,f),o=!0),o&&this.b.fire({key:w,external:!0})}get items(){return this.f}get size(){return this.f.size}async init(){this.c===D.None&&(this.c=D.Initialized,this.s.hint!==p.STORAGE_DOES_NOT_EXIST&&(this.f=await this.r.getItems()))}get(w,f){const o=this.f.get(w);return(0,A.$hg)(o)?f:o}getBoolean(w,f){const o=this.get(w);return(0,A.$hg)(o)?f:o==="true"}getNumber(w,f){const o=this.get(w);return(0,A.$hg)(o)?f:parseInt(o,10)}getObject(w,f){const o=this.get(w);return(0,A.$hg)(o)?f:(0,T.$7h)(o)}async set(w,f,o=!1){if(this.c===D.Closed)return;if((0,A.$hg)(f))return this.delete(w,o);const r=(0,A.$ag)(f)||Array.isArray(f)?(0,T.$6h)(f):String(f);if(this.f.get(w)!==r)return this.f.set(w,r),this.j.set(w,r),this.h.delete(w),this.b.fire({key:w,external:o}),this.D()}async delete(w,f=!1){if(!(this.c===D.Closed||!this.f.delete(w)))return this.h.has(w)||this.h.add(w),this.j.delete(w),this.b.fire({key:w,external:f}),this.D()}async optimize(){if(this.c!==D.Closed)return await this.flush(0),this.r.optimize()}async close(){return this.m||(this.m=this.y()),this.m}async y(){this.c=D.Closed;try{await this.D(0)}catch{}await this.r.close(()=>this.f)}get z(){return this.j.size>0||this.h.size>0}async C(){if(!this.z)return;const w={insert:this.j,delete:this.h};return this.h=new Set,this.j=new Map,this.r.updateItems(w).finally(()=>{if(!this.z)for(;this.n.length;)this.n.pop()?.()})}async flush(w){if(!(this.c===D.Closed||this.m))return this.D(w)}async D(w){return this.s.hint===p.STORAGE_IN_MEMORY?this.C():this.g.trigger(()=>this.C(),w)}async whenFlushed(){if(this.z)return new Promise(w=>this.n.push(w))}isInMemory(){return this.s.hint===p.STORAGE_IN_MEMORY}}e.$1p=O;class S{constructor(){this.onDidChangeItemsExternal=N.Event.None,this.a=new Map}async getItems(){return this.a}async updateItems(w){w.insert?.forEach((f,o)=>this.a.set(o,f)),w.delete?.forEach(f=>this.a.delete(f))}async optimize(){}async close(){}}e.$2p=S}),define(Se[152],Ie([1,0,13,23,22]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1t=void 0,e.$Yt=O,e.$Zt=S;let T;function A(){return T||(T=new TextDecoder("UTF-16LE")),T}let p;function m(){return p||(p=new TextDecoder("UTF-16BE")),p}let D;function O(){return D||(D=N.$D()?A():m()),D}function S(f,o,r){const s=new Uint16Array(f.buffer,o,r);return r>0&&(s[0]===65279||s[0]===65534)?d(f,o,r):A().decode(s)}function d(f,o,r){const s=[];let n=0;for(let t=0;t<r;t++){const c=M.$Je(f,o);o+=2,s[n++]=String.fromCharCode(c)}return s.join("")}class w{constructor(o){this.a=o|0,this.b=new Uint16Array(this.a),this.c=null,this.d=0}reset(){this.c=null,this.d=0}build(){return this.c!==null?(this.f(),this.c.join("")):this.e()}e(){if(this.d===0)return"";const o=new Uint16Array(this.b.buffer,0,this.d);return O().decode(o)}f(){const o=this.e();this.d=0,this.c===null?this.c=[o]:this.c[this.c.length]=o}appendCharCode(o){const r=this.a-this.d;r<=1&&(r===0||C.$Df(o))&&this.f(),this.b[this.d++]=o}appendASCIICharCode(o){this.d===this.a&&this.f(),this.b[this.d++]=o}appendString(o){const r=o.length;if(this.d+r>=this.a){this.f(),this.c[this.c.length]=o;return}for(let s=0;s<r;s++)this.b[this.d++]=o.charCodeAt(s)}}e.$1t=w}),define(Se[153],Ie([1,0,22,152]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2t=void 0,e.$3t=A;function M(m){return m.replace(/\n/g,"\\n").replace(/\r/g,"\\r")}class T{get oldLength(){return this.oldText.length}get oldEnd(){return this.oldPosition+this.oldText.length}get newLength(){return this.newText.length}get newEnd(){return this.newPosition+this.newText.length}constructor(D,O,S,d){this.oldPosition=D,this.oldText=O,this.newPosition=S,this.newText=d}toString(){return this.oldText.length===0?`(insert@${this.oldPosition} "${M(this.newText)}")`:this.newText.length===0?`(delete@${this.oldPosition} "${M(this.oldText)}")`:`(replace@${this.oldPosition} "${M(this.oldText)}" with "${M(this.newText)}")`}static a(D){return 4+2*D.length}static c(D,O,S){const d=O.length;C.$Me(D,d,S),S+=4;for(let w=0;w<d;w++)C.$Ke(D,O.charCodeAt(w),S),S+=2;return S}static d(D,O){const S=C.$Le(D,O);return O+=4,(0,N.$Zt)(D,O,S)}writeSize(){return 8+T.a(this.oldText)+T.a(this.newText)}write(D,O){return C.$Me(D,this.oldPosition,O),O+=4,C.$Me(D,this.newPosition,O),O+=4,O=T.c(D,this.oldText,O),O=T.c(D,this.newText,O),O}static read(D,O,S){const d=C.$Le(D,O);O+=4;const w=C.$Le(D,O);O+=4;const f=T.d(D,O);O+=T.a(f);const o=T.d(D,O);return O+=T.a(o),S.push(new T(d,f,w,o)),O}}e.$2t=T;function A(m,D){return m===null||m.length===0?D:new p(m,D).compress()}class p{constructor(D,O){this.a=D,this.c=O,this.d=[],this.e=0,this.f=this.a.length,this.g=0,this.h=this.c.length,this.j=0}compress(){let D=0,O=0,S=this.n(D),d=this.l(O);for(;D<this.f||O<this.h;){if(S===null){this.k(d),d=this.l(++O);continue}if(d===null){this.m(S),S=this.n(++D);continue}if(d.oldEnd<=S.newPosition){this.k(d),d=this.l(++O);continue}if(S.newEnd<=d.oldPosition){this.m(S),S=this.n(++D);continue}if(d.oldPosition<S.newPosition){const[s,n]=p.r(d,S.newPosition-d.oldPosition);this.k(s),d=n;continue}if(S.newPosition<d.oldPosition){const[s,n]=p.q(S,d.oldPosition-S.newPosition);this.m(s),S=n;continue}let o,r;if(d.oldEnd===S.newEnd)o=S,r=d,S=this.n(++D),d=this.l(++O);else if(d.oldEnd<S.newEnd){const[s,n]=p.q(S,d.oldLength);o=s,r=d,S=n,d=this.l(++O)}else{const[s,n]=p.r(d,S.newLength);o=S,r=s,S=this.n(++D),d=n}this.d[this.e++]=new T(o.oldPosition,o.oldText,r.newPosition,r.newText),this.g+=o.newLength-o.oldLength,this.j+=r.newLength-r.oldLength}const w=p.s(this.d);return p.t(w)}k(D){this.d[this.e++]=p.o(this.g,D),this.j+=D.newLength-D.oldLength}l(D){return D<this.h?this.c[D]:null}m(D){this.d[this.e++]=p.p(this.j,D),this.g+=D.newLength-D.oldLength}n(D){return D<this.f?this.a[D]:null}static o(D,O){return new T(O.oldPosition-D,O.oldText,O.newPosition,O.newText)}static p(D,O){return new T(O.oldPosition,O.oldText,O.newPosition+D,O.newText)}static q(D,O){const S=D.newText.substr(0,O),d=D.newText.substr(O);return[new T(D.oldPosition,D.oldText,D.newPosition,S),new T(D.oldEnd,"",D.newPosition+O,d)]}static r(D,O){const S=D.oldText.substr(0,O),d=D.oldText.substr(O);return[new T(D.oldPosition,S,D.newPosition,D.newText),new T(D.oldPosition+O,d,D.newEnd,"")]}static s(D){if(D.length===0)return D;const O=[];let S=0,d=D[0];for(let w=1;w<D.length;w++){const f=D[w];d.oldEnd===f.oldPosition?d=new T(d.oldPosition,d.oldText+f.oldText,d.newPosition,d.newText+f.newText):(O[S++]=d,d=f)}return O[S++]=d,O}static t(D){if(D.length===0)return D;const O=[];let S=0;for(let d=0;d<D.length;d++){const w=D[d];w.oldText!==w.newText&&(O[S++]=w)}return O}}}),define(Se[154],Ie([1,0,37,19]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gu=M,e.$hu=T;function M(A,p,m,D,O,S){if(Array.isArray(A)){let d=0;for(const w of A){const f=M(w,p,m,D,O,S);if(f===10)return f;f>d&&(d=f)}return d}else{if(typeof A=="string")return D?A==="*"?5:A===m?10:0:0;if(A){const{language:d,pattern:w,scheme:f,hasAccessToAllModels:o,notebookType:r}=A;if(!D&&!o)return 0;r&&O&&(p=O);let s=0;if(f)if(f===p.scheme)s=10;else if(f==="*")s=5;else return 0;if(d)if(d===m)s=10;else if(d==="*")s=Math.max(s,5);else return 0;if(r)if(r===S)s=10;else if(r==="*"&&S!==void 0)s=Math.max(s,5);else return 0;if(w){let n;if(typeof w=="string"?n=w:n={...w,base:(0,N.$hc)(w.base)},n===p.fsPath||(0,C.$rk)(n,p.fsPath))s=10;else return 0}return s}else return 0}}function T(A){return typeof A=="string"?!1:Array.isArray(A)?A.some(T):!!A.notebookType}}),define(Se[155],Ie([1,0,5,13,30,95,93,139,153,6]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6C=void 0;class O extends D.$Uc{constructor(d,w,f,o,r,s,n){super(),this.m=this.B(new C.$fe),this.onDidChangeContent=this.m.event,this.f=w,this.j=!s,this.g=o,this.h=r,this.c=new A.$5C(d,f,n)}equals(d){return!(d instanceof O)||this.f!==d.f||this.getEOL()!==d.getEOL()?!1:this.c.equal(d.c)}mightContainRTL(){return this.g}mightContainUnusualLineTerminators(){return this.h}resetMightContainUnusualLineTerminators(){this.h=!1}mightContainNonBasicASCII(){return this.j}getBOM(){return this.f}getEOL(){return this.c.getEOL()}createSnapshot(d){return this.c.createSnapshot(d?this.f:"")}getOffsetAt(d,w){return this.c.getOffsetAt(d,w)}getPositionAt(d){return this.c.getPositionAt(d)}getRangeAt(d,w){const f=d+w,o=this.getPositionAt(d),r=this.getPositionAt(f);return new M.$zt(o.lineNumber,o.column,r.lineNumber,r.column)}getValueInRange(d,w=0){if(d.isEmpty())return"";const f=this.n(w);return this.c.getValueInRange(d,f)}getValueLengthInRange(d,w=0){if(d.isEmpty())return 0;if(d.startLineNumber===d.endLineNumber)return d.endColumn-d.startColumn;const f=this.getOffsetAt(d.startLineNumber,d.startColumn),o=this.getOffsetAt(d.endLineNumber,d.endColumn);let r=0;const s=this.n(w),n=this.getEOL();if(s.length!==n.length){const t=s.length-n.length,c=d.endLineNumber-d.startLineNumber;r=t*c}return o-f+r}getCharacterCountInRange(d,w=0){if(this.j){let f=0;const o=d.startLineNumber,r=d.endLineNumber;for(let s=o;s<=r;s++){const n=this.getLineContent(s),t=s===o?d.startColumn-1:0,c=s===r?d.endColumn-1:n.length;for(let u=t;u<c;u++)N.$Df(n.charCodeAt(u))?(f=f+1,u=u+1):f=f+1}return f+=this.n(w).length*(r-o),f}return this.getValueLengthInRange(d,w)}getLength(){return this.c.getLength()}getLineCount(){return this.c.getLineCount()}getLinesContent(){return this.c.getLinesContent()}getLineContent(d){return this.c.getLineContent(d)}getLineCharCode(d,w){return this.c.getLineCharCode(d,w)}getCharCode(d){return this.c.getCharCode(d)}getLineLength(d){return this.c.getLineLength(d)}getLineMinColumn(d){return 1}getLineMaxColumn(d){return this.getLineLength(d)+1}getLineFirstNonWhitespaceColumn(d){const w=N.$of(this.getLineContent(d));return w===-1?0:w+1}getLineLastNonWhitespaceColumn(d){const w=N.$qf(this.getLineContent(d));return w===-1?0:w+2}n(d){switch(d){case 1:return`
`;case 2:return`\r
`;case 0:return this.getEOL();default:throw new Error("Unknown EOL preference")}}setEOL(d){this.c.setEOL(d)}applyEdits(d,w,f){let o=this.g,r=this.h,s=this.j,n=!0,t=[];for(let g=0;g<d.length;g++){const $=d[g];n&&$._isTracked&&(n=!1);const v=$.range;if($.text){let I=!0;s||(I=!N.$Of($.text),s=I),!o&&I&&(o=N.$Nf($.text)),!r&&I&&(r=N.$Qf($.text))}let y="",h=0,E=0,k=0;if($.text){let I;[h,E,k,I]=(0,p.$ju)($.text);const P=this.getEOL();I===0||I===(P===`\r
`?2:1)?y=$.text:y=$.text.replace(/\r\n|\r|\n/g,P)}t[g]={sortIndex:g,identifier:$.identifier||null,range:v,rangeOffset:this.getOffsetAt(v.startLineNumber,v.startColumn),rangeLength:this.getValueLengthInRange(v),text:y,eolCount:h,firstLineLength:E,lastLineLength:k,forceMoveMarkers:!!$.forceMoveMarkers,isAutoWhitespaceEdit:$.isAutoWhitespaceEdit||!1}}t.sort(O.u);let c=!1;for(let g=0,$=t.length-1;g<$;g++){const v=t[g].range.getEndPosition(),y=t[g+1].range.getStartPosition();if(y.isBeforeOrEqual(v)){if(y.isBefore(v))throw new Error("Overlapping ranges are not allowed!");c=!0}}n&&(t=this.s(t));const u=f||w?O._getInverseEditRanges(t):[],i=[];if(w)for(let g=0;g<t.length;g++){const $=t[g],v=u[g];if($.isAutoWhitespaceEdit&&$.range.isEmpty())for(let y=v.startLineNumber;y<=v.endLineNumber;y++){let h="";y===v.startLineNumber&&(h=this.getLineContent($.range.startLineNumber),N.$of(h)!==-1)||i.push({lineNumber:y,oldContent:h})}}let b=null;if(f){let g=0;b=[];for(let $=0;$<t.length;$++){const v=t[$],y=u[$],h=this.getValueInRange(v.range),E=v.rangeOffset+g;g+=v.text.length-h.length,b[$]={sortIndex:v.sortIndex,identifier:v.identifier,range:y,text:h,textChange:new m.$2t(v.rangeOffset,h,E,v.text)}}c||b.sort(($,v)=>$.sortIndex-v.sortIndex)}this.g=o,this.h=r,this.j=s;const a=this.t(t);let l=null;if(w&&i.length>0){i.sort((g,$)=>$.lineNumber-g.lineNumber),l=[];for(let g=0,$=i.length;g<$;g++){const v=i[g].lineNumber;if(g>0&&i[g-1].lineNumber===v)continue;const y=i[g].oldContent,h=this.getLineContent(v);h.length===0||h===y||N.$of(h)!==-1||l.push(v)}}return this.m.fire(),new T.$4v(b,a,l)}s(d){return d.length<1e3?d:[this._toSingleEditOperation(d)]}_toSingleEditOperation(d){let w=!1;const f=d[0].range,o=d[d.length-1].range,r=new M.$zt(f.startLineNumber,f.startColumn,o.endLineNumber,o.endColumn);let s=f.startLineNumber,n=f.startColumn;const t=[];for(let a=0,l=d.length;a<l;a++){const g=d[a],$=g.range;w=w||g.forceMoveMarkers,t.push(this.getValueInRange(new M.$zt(s,n,$.startLineNumber,$.startColumn))),g.text.length>0&&t.push(g.text),s=$.endLineNumber,n=$.endColumn}const c=t.join(""),[u,i,b]=(0,p.$ju)(c);return{sortIndex:0,identifier:d[0].identifier,range:r,rangeOffset:this.getOffsetAt(r.startLineNumber,r.startColumn),rangeLength:this.getValueLengthInRange(r,0),text:c,eolCount:u,firstLineLength:i,lastLineLength:b,forceMoveMarkers:w,isAutoWhitespaceEdit:!1}}t(d){d.sort(O.w);const w=[];for(let f=0;f<d.length;f++){const o=d[f],r=o.range.startLineNumber,s=o.range.startColumn,n=o.range.endLineNumber,t=o.range.endColumn;if(r===n&&s===t&&o.text.length===0)continue;o.text?(this.c.delete(o.rangeOffset,o.rangeLength),this.c.insert(o.rangeOffset,o.text,!0)):this.c.delete(o.rangeOffset,o.rangeLength);const c=new M.$zt(r,s,n,t);w.push({range:c,rangeLength:o.rangeLength,text:o.text,rangeOffset:o.rangeOffset,forceMoveMarkers:o.forceMoveMarkers})}return w}findMatchesLineByLine(d,w,f,o){return this.c.findMatchesLineByLine(d,w,f,o)}getPieceTree(){return this.c}static _getInverseEditRange(d,w){const f=d.startLineNumber,o=d.startColumn,[r,s,n]=(0,p.$ju)(w);let t;if(w.length>0){const c=r+1;c===1?t=new M.$zt(f,o,f,o+s):t=new M.$zt(f,o,f+c-1,n+1)}else t=new M.$zt(f,o,f,o);return t}static _getInverseEditRanges(d){const w=[];let f=0,o=0,r=null;for(let s=0,n=d.length;s<n;s++){const t=d[s];let c,u;r?r.range.endLineNumber===t.range.startLineNumber?(c=f,u=o+(t.range.startColumn-r.range.endColumn)):(c=f+(t.range.startLineNumber-r.range.endLineNumber),u=t.range.startColumn):(c=t.range.startLineNumber,u=t.range.startColumn);let i;if(t.text.length>0){const b=t.eolCount+1;b===1?i=new M.$zt(c,u,c,u+t.firstLineLength):i=new M.$zt(c,u,c+b-1,t.lastLineLength+1)}else i=new M.$zt(c,u,c,u);f=i.endLineNumber,o=i.endColumn,w.push(i),r=t}return w}static u(d,w){const f=M.$zt.compareRangesUsingEnds(d.range,w.range);return f===0?d.sortIndex-w.sortIndex:f}static w(d,w){const f=M.$zt.compareRangesUsingEnds(d.range,w.range);return f===0?w.sortIndex-d.sortIndex:-f}}e.$6C=O}),define(Se[156],Ie([1,0,13,93,155]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7C=void 0;class T{constructor(m,D,O,S,d,w,f,o,r){this.a=m,this.b=D,this.c=O,this.d=S,this.e=d,this.f=w,this.g=f,this.h=o,this.j=r}k(m){const D=this.c+this.d+this.e,O=this.c+this.e;return D===0?m===1?`
`:`\r
`:O>D/2?`\r
`:`
`}create(m){const D=this.k(m),O=this.a;if(this.j&&(D===`\r
`&&(this.c>0||this.d>0)||D===`
`&&(this.c>0||this.e>0)))for(let d=0,w=O.length;d<w;d++){const f=O[d].buffer.replace(/\r\n|\r|\n/g,D),o=(0,N.$1C)(f);O[d]=new N.$4C(f,o)}const S=new M.$6C(O,this.b,D,this.f,this.g,this.h,this.j);return{textBuffer:S,disposable:S}}getFirstLineText(m){return this.a[0].buffer.substr(0,m).split(/\r\n|\r|\n/)[0]}}class A{constructor(){this.a=[],this.b="",this.c=!1,this.d=0,this.e=[],this.f=0,this.g=0,this.h=0,this.j=!1,this.k=!1,this.l=!0}acceptChunk(m){if(m.length===0)return;this.a.length===0&&C.$Yf(m)&&(this.b=C.$Xf,m=m.substr(1));const D=m.charCodeAt(m.length-1);D===13||D>=55296&&D<=56319?(this.m(m.substr(0,m.length-1),!1),this.c=!0,this.d=D):(this.m(m,!1),this.c=!1,this.d=D)}m(m,D){!D&&m.length===0||(this.c?this.n(String.fromCharCode(this.d)+m):this.n(m))}n(m){const D=(0,N.$2C)(this.e,m);this.a.push(new N.$4C(m,D.lineStarts)),this.f+=D.cr,this.g+=D.lf,this.h+=D.crlf,D.isBasicASCII||(this.l=!1,this.j||(this.j=C.$Nf(m)),this.k||(this.k=C.$Qf(m)))}finish(m=!0){return this.o(),new T(this.a,this.b,this.f,this.g,this.h,this.j,this.k,this.l,m)}o(){if(this.a.length===0&&this.m("",!0),this.c){this.c=!1;const m=this.a[this.a.length-1];m.buffer+=String.fromCharCode(this.d);const D=(0,N.$1C)(m.buffer);m.lineStarts=D,this.d===13&&this.f++}}}e.$7C=A}),define(Se[98],Ie([1,0,22,23]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cbb=m,e.$Dbb=O;var M;(function(S){S[S.Full=1]="Full",S[S.Delta=2]="Delta"})(M||(M={}));function T(S){for(let d=0,w=S.length;d<w;d+=4){const f=S[d+0],o=S[d+1],r=S[d+2],s=S[d+3];S[d+0]=s,S[d+1]=r,S[d+2]=o,S[d+3]=f}}function A(S){const d=new Uint8Array(S.buffer,S.byteOffset,S.length*4);return N.$D()||T(d),C.$He.wrap(d)}function p(S){const d=S.buffer;if(N.$D()||T(d),d.byteOffset%4===0)return new Uint32Array(d.buffer,d.byteOffset,d.length/4);{const w=new Uint8Array(d.byteLength);return w.set(d),new Uint32Array(w.buffer,w.byteOffset,w.length/4)}}function m(S){const d=new Uint32Array(D(S));let w=0;if(d[w++]=S.id,S.type==="full")d[w++]=1,d[w++]=S.data.length,d.set(S.data,w),w+=S.data.length;else{d[w++]=2,d[w++]=S.deltas.length;for(const f of S.deltas)d[w++]=f.start,d[w++]=f.deleteCount,f.data?(d[w++]=f.data.length,d.set(f.data,w),w+=f.data.length):d[w++]=0}return A(d)}function D(S){let d=0;if(d+=2,S.type==="full")d+=1+S.data.length;else{d+=1,d+=3*S.deltas.length;for(const w of S.deltas)w.data&&(d+=w.data.length)}return d}function O(S){const d=p(S);let w=0;const f=d[w++];if(d[w++]===1){const n=d[w++],t=d.subarray(w,w+n);return w+=n,{id:f,type:"full",data:t}}const r=d[w++],s=[];for(let n=0;n<r;n++){const t=d[w++],c=d[w++],u=d[w++];let i;u>0&&(i=d.subarray(w,w+u),w+=u),s[n]={start:t,deleteCount:c,data:i}}return{id:f,type:"delta",deltas:s}}}),define(Se[157],Ie([9,10]),function(le,e){return le.create("vs/editor/common/config/editorOptions",e)}),define(Se[158],Ie([1,0,18,26,23,140,159,157]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.RenderLineNumbersType=e.ShowLightbulbIconMode=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontVariations=e.EditorFontLigatures=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0,e.boolean=r,e.clampedInt=n,e.clampedFloat=c,e.stringSet=b,e.cursorStyleToString=k,e.filterValidationDecorations=ce;var m;(function(Z){Z[Z.None=0]="None",Z[Z.Keep=1]="Keep",Z[Z.Brackets=2]="Brackets",Z[Z.Advanced=3]="Advanced",Z[Z.Full=4]="Full"})(m||(e.EditorAutoIndentStrategy=m={})),e.MINIMAP_GUTTER_WIDTH=8;class D{constructor(X){this.c=X}hasChanged(X){return this.c[X]}}e.ConfigurationChangedEvent=D;class O{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=O;class S{constructor(X,$e,He,we){this.id=X,this.name=$e,this.defaultValue=He,this.schema=we}applyUpdate(X,$e){return w(X,$e)}compute(X,$e,He){return He}}class d{constructor(X,$e){this.newValue=X,this.didChange=$e}}e.ApplyUpdateResult=d;function w(Z,X){if(typeof Z!="object"||typeof X!="object"||!Z||!X)return new d(X,Z!==X);if(Array.isArray(Z)||Array.isArray(X)){const He=Array.isArray(Z)&&Array.isArray(X)&&C.$ub(Z,X);return new d(X,!He)}let $e=!1;for(const He in X)if(X.hasOwnProperty(He)){const we=w(Z[He],X[He]);we.didChange&&(Z[He]=we.newValue,$e=!0)}return new d(Z,$e)}class f{constructor(X){this.schema=void 0,this.id=X,this.name="_never_",this.defaultValue=void 0}applyUpdate(X,$e){return w(X,$e)}validate(X){return this.defaultValue}}class o{constructor(X,$e,He,we){this.id=X,this.name=$e,this.defaultValue=He,this.schema=we}applyUpdate(X,$e){return w(X,$e)}validate(X){return typeof X>"u"?this.defaultValue:X}compute(X,$e,He){return He}}function r(Z,X){return typeof Z>"u"?X:Z==="false"?!1:!!Z}class s extends o{constructor(X,$e,He,we=void 0){typeof we<"u"&&(we.type="boolean",we.default=He),super(X,$e,He,we)}validate(X){return r(X,this.defaultValue)}}function n(Z,X,$e,He){if(typeof Z>"u")return X;let we=parseInt(Z,10);return isNaN(we)?X:(we=Math.max($e,we),we=Math.min(He,we),we|0)}class t extends o{static clampedInt(X,$e,He,we){return n(X,$e,He,we)}constructor(X,$e,He,we,st,dt=void 0){typeof dt<"u"&&(dt.type="integer",dt.default=He,dt.minimum=we,dt.maximum=st),super(X,$e,He,dt),this.minimum=we,this.maximum=st}validate(X){return t.clampedInt(X,this.defaultValue,this.minimum,this.maximum)}}function c(Z,X,$e,He){if(typeof Z>"u")return X;const we=u.float(Z,X);return u.clamp(we,$e,He)}class u extends o{static clamp(X,$e,He){return X<$e?$e:X>He?He:X}static float(X,$e){if(typeof X=="number")return X;if(typeof X>"u")return $e;const He=parseFloat(X);return isNaN(He)?$e:He}constructor(X,$e,He,we,st){typeof st<"u"&&(st.type="number",st.default=He),super(X,$e,He,st),this.validationFn=we}validate(X){return this.validationFn(u.float(X,this.defaultValue))}}class i extends o{static string(X,$e){return typeof X!="string"?$e:X}constructor(X,$e,He,we=void 0){typeof we<"u"&&(we.type="string",we.default=He),super(X,$e,He,we)}validate(X){return i.string(X,this.defaultValue)}}function b(Z,X,$e,He){return typeof Z!="string"?X:He&&Z in He?He[Z]:$e.indexOf(Z)===-1?X:Z}class a extends o{constructor(X,$e,He,we,st=void 0){typeof st<"u"&&(st.type="string",st.enum=we,st.default=He),super(X,$e,He,st),this.c=we}validate(X){return b(X,this.defaultValue,this.c)}}class l extends S{constructor(X,$e,He,we,st,dt,Ct=void 0){typeof Ct<"u"&&(Ct.type="string",Ct.enum=st,Ct.default=we),super(X,$e,He,Ct),this.c=st,this.d=dt}validate(X){return typeof X!="string"?this.defaultValue:this.c.indexOf(X)===-1?this.defaultValue:this.d(X)}}function g(Z){switch(Z){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class $ extends S{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[p.localize(0,null),p.localize(1,null),p.localize(2,null)],default:"auto",tags:["accessibility"],description:p.localize(3,null)})}validate(X){switch(X){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(X,$e,He){return He===0?X.accessibilitySupport:He}}class v extends S{constructor(){const X={insertSpace:!0,ignoreEmptyLines:!0};super(23,"comments",X,{"editor.comments.insertSpace":{type:"boolean",default:X.insertSpace,description:p.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:X.ignoreEmptyLines,description:p.localize(5,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertSpace:r($e.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:r($e.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var y;(function(Z){Z[Z.Hidden=0]="Hidden",Z[Z.Blink=1]="Blink",Z[Z.Smooth=2]="Smooth",Z[Z.Phase=3]="Phase",Z[Z.Expand=4]="Expand",Z[Z.Solid=5]="Solid"})(y||(e.TextEditorCursorBlinkingStyle=y={}));function h(Z){switch(Z){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var E;(function(Z){Z[Z.Line=1]="Line",Z[Z.Block=2]="Block",Z[Z.Underline=3]="Underline",Z[Z.LineThin=4]="LineThin",Z[Z.BlockOutline=5]="BlockOutline",Z[Z.UnderlineThin=6]="UnderlineThin"})(E||(e.TextEditorCursorStyle=E={}));function k(Z){switch(Z){case E.Line:return"line";case E.Block:return"block";case E.Underline:return"underline";case E.LineThin:return"line-thin";case E.BlockOutline:return"block-outline";case E.UnderlineThin:return"underline-thin"}}function I(Z){switch(Z){case"line":return E.Line;case"block":return E.Block;case"underline":return E.Underline;case"line-thin":return E.LineThin;case"block-outline":return E.BlockOutline;case"underline-thin":return E.UnderlineThin}}class P extends f{constructor(){super(142)}compute(X,$e,He){const we=["monaco-editor"];return $e.get(39)&&we.push($e.get(39)),X.extraEditorClassName&&we.push(X.extraEditorClassName),$e.get(74)==="default"?we.push("mouse-default"):$e.get(74)==="copy"&&we.push("mouse-copy"),$e.get(111)&&we.push("showUnused"),$e.get(140)&&we.push("showDeprecated"),we.join(" ")}}class V extends s{constructor(){super(37,"emptySelectionClipboard",!0,{description:p.localize(6,null)})}compute(X,$e,He){return He&&X.emptySelectionClipboard}}class W extends S{constructor(){const X={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(41,"find",X,{"editor.find.cursorMoveOnType":{type:"boolean",default:X.cursorMoveOnType,description:p.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:X.seedSearchStringFromSelection,enumDescriptions:[p.localize(8,null),p.localize(9,null),p.localize(10,null)],description:p.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:X.autoFindInSelection,enumDescriptions:[p.localize(12,null),p.localize(13,null),p.localize(14,null)],description:p.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:X.globalFindClipboard,description:p.localize(16,null),included:M.$j},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:X.addExtraSpaceOnTop,description:p.localize(17,null)},"editor.find.loop":{type:"boolean",default:X.loop,description:p.localize(18,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{cursorMoveOnType:r($e.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof X.seedSearchStringFromSelection=="boolean"?X.seedSearchStringFromSelection?"always":"never":b($e.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof X.autoFindInSelection=="boolean"?X.autoFindInSelection?"always":"never":b($e.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:r($e.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:r($e.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:r($e.loop,this.defaultValue.loop)}}}class q extends S{static{this.OFF='"liga" off, "calt" off'}static{this.ON='"liga" on, "calt" on'}constructor(){super(51,"fontLigatures",q.OFF,{anyOf:[{type:"boolean",description:p.localize(19,null)},{type:"string",description:p.localize(20,null)}],description:p.localize(21,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"||X.length===0?q.OFF:X==="true"?q.ON:X:X?q.ON:q.OFF}}e.EditorFontLigatures=q;class R extends S{static{this.OFF="normal"}static{this.TRANSLATE="translate"}constructor(){super(54,"fontVariations",R.OFF,{anyOf:[{type:"boolean",description:p.localize(22,null)},{type:"string",description:p.localize(23,null)}],description:p.localize(24,null),default:!1})}validate(X){return typeof X>"u"?this.defaultValue:typeof X=="string"?X==="false"?R.OFF:X==="true"?R.TRANSLATE:X:X?R.TRANSLATE:R.OFF}compute(X,$e,He){return X.fontInfo.fontVariationSettings}}e.EditorFontVariations=R;class z extends f{constructor(){super(50)}compute(X,$e,He){return X.fontInfo}}class K extends o{constructor(){super(52,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:p.localize(25,null)})}validate(X){const $e=u.float(X,this.defaultValue);return $e===0?e.EDITOR_FONT_DEFAULTS.fontSize:u.clamp($e,6,100)}compute(X,$e,He){return X.fontInfo.fontSize}}class ie extends S{static{this.c=["normal","bold","100","200","300","400","500","600","700","800","900"]}static{this.d=1}static{this.e=1e3}constructor(){super(53,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:ie.d,maximum:ie.e,errorMessage:p.localize(26,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:ie.c}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:p.localize(27,null)})}validate(X){return X==="normal"||X==="bold"?X:String(t.clampedInt(X,e.EDITOR_FONT_DEFAULTS.fontWeight,ie.d,ie.e))}}class de extends S{constructor(){const X={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},$e={type:"string",enum:["peek","gotoAndPeek","goto"],default:X.multiple,enumDescriptions:[p.localize(28,null),p.localize(29,null),p.localize(30,null)]},He=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(58,"gotoLocation",X,{"editor.gotoLocation.multiple":{deprecationMessage:p.localize(31,null)},"editor.gotoLocation.multipleDefinitions":{description:p.localize(32,null),...$e},"editor.gotoLocation.multipleTypeDefinitions":{description:p.localize(33,null),...$e},"editor.gotoLocation.multipleDeclarations":{description:p.localize(34,null),...$e},"editor.gotoLocation.multipleImplementations":{description:p.localize(35,null),...$e},"editor.gotoLocation.multipleReferences":{description:p.localize(36,null),...$e},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:X.alternativeDefinitionCommand,enum:He,description:p.localize(37,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:X.alternativeTypeDefinitionCommand,enum:He,description:p.localize(38,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:X.alternativeDeclarationCommand,enum:He,description:p.localize(39,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:X.alternativeImplementationCommand,enum:He,description:p.localize(40,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:X.alternativeReferenceCommand,enum:He,description:p.localize(41,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{multiple:b($e.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:$e.multipleDefinitions??b($e.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:$e.multipleTypeDefinitions??b($e.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:$e.multipleDeclarations??b($e.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:$e.multipleImplementations??b($e.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:$e.multipleReferences??b($e.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:i.string($e.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:i.string($e.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:i.string($e.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:i.string($e.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:i.string($e.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class ye extends S{constructor(){const X={enabled:!0,delay:300,hidingDelay:300,sticky:!0,above:!0};super(60,"hover",X,{"editor.hover.enabled":{type:"boolean",default:X.enabled,description:p.localize(42,null)},"editor.hover.delay":{type:"number",default:X.delay,minimum:0,maximum:1e4,description:p.localize(43,null)},"editor.hover.sticky":{type:"boolean",default:X.sticky,description:p.localize(44,null)},"editor.hover.hidingDelay":{type:"integer",minimum:0,default:X.hidingDelay,description:p.localize(45,null)},"editor.hover.above":{type:"boolean",default:X.above,description:p.localize(46,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),delay:t.clampedInt($e.delay,this.defaultValue.delay,0,1e4),sticky:r($e.sticky,this.defaultValue.sticky),hidingDelay:t.clampedInt($e.hidingDelay,this.defaultValue.hidingDelay,0,6e5),above:r($e.above,this.defaultValue.above)}}}var De;(function(Z){Z[Z.None=0]="None",Z[Z.Text=1]="Text",Z[Z.Blocks=2]="Blocks"})(De||(e.RenderMinimap=De={}));class ge extends f{constructor(){super(145)}compute(X,$e,He){return ge.computeLayout($e,{memory:X.memory,outerWidth:X.outerWidth,outerHeight:X.outerHeight,isDominatedByLongLines:X.isDominatedByLongLines,lineHeight:X.fontInfo.lineHeight,viewLineCount:X.viewLineCount,lineNumbersDigitCount:X.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:X.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:X.fontInfo.maxDigitWidth,pixelRatio:X.pixelRatio,glyphMarginDecorationLaneCount:X.glyphMarginDecorationLaneCount})}static computeContainedMinimapLineCount(X){const $e=X.height/X.lineHeight,He=Math.floor(X.paddingTop/X.lineHeight);let we=Math.floor(X.paddingBottom/X.lineHeight);X.scrollBeyondLastLine&&(we=Math.max(we,$e-1));const st=(He+X.viewLineCount+we)/(X.pixelRatio*X.height),dt=Math.floor(X.viewLineCount/st);return{typicalViewportLineCount:$e,extraLinesBeforeFirstLine:He,extraLinesBeyondLastLine:we,desiredRatio:st,minimapLineCount:dt}}static c(X,$e){const He=X.outerWidth,we=X.outerHeight,st=X.pixelRatio;if(!X.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(st*we),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:we};const dt=$e.stableMinimapLayoutInput,Ct=dt&&X.outerHeight===dt.outerHeight&&X.lineHeight===dt.lineHeight&&X.typicalHalfwidthCharacterWidth===dt.typicalHalfwidthCharacterWidth&&X.pixelRatio===dt.pixelRatio&&X.scrollBeyondLastLine===dt.scrollBeyondLastLine&&X.paddingTop===dt.paddingTop&&X.paddingBottom===dt.paddingBottom&&X.minimap.enabled===dt.minimap.enabled&&X.minimap.side===dt.minimap.side&&X.minimap.size===dt.minimap.size&&X.minimap.showSlider===dt.minimap.showSlider&&X.minimap.renderCharacters===dt.minimap.renderCharacters&&X.minimap.maxColumn===dt.minimap.maxColumn&&X.minimap.scale===dt.minimap.scale&&X.verticalScrollbarWidth===dt.verticalScrollbarWidth&&X.isViewportWrapping===dt.isViewportWrapping,Vt=X.lineHeight,Qt=X.typicalHalfwidthCharacterWidth,ii=X.scrollBeyondLastLine,Xt=X.minimap.renderCharacters;let Et=st>=2?Math.round(X.minimap.scale*2):X.minimap.scale;const Zt=X.minimap.maxColumn,Yt=X.minimap.size,Ze=X.minimap.side,si=X.verticalScrollbarWidth,Gt=X.viewLineCount,ht=X.remainingWidth,mt=X.isViewportWrapping,xt=Xt?2:3;let Kt=Math.floor(st*we);const Tt=Kt/st;let ft=!1,Bt=!1,_t=xt*Et,zt=Et/st,Qe=1;if(Yt==="fill"||Yt==="fit"){const{typicalViewportLineCount:At,extraLinesBeforeFirstLine:ei,extraLinesBeyondLastLine:Wt,desiredRatio:oi,minimapLineCount:Nt}=ge.computeContainedMinimapLineCount({viewLineCount:Gt,scrollBeyondLastLine:ii,paddingTop:X.paddingTop,paddingBottom:X.paddingBottom,height:we,lineHeight:Vt,pixelRatio:st});if(Gt/Nt>1)ft=!0,Bt=!0,Et=1,_t=1,zt=Et/st;else{let Rt=!1,St=Et+1;if(Yt==="fit"){const $t=Math.ceil((ei+Gt+Wt)*_t);mt&&Ct&&ht<=$e.stableFitRemainingWidth?(Rt=!0,St=$e.stableFitMaxMinimapScale):Rt=$t>Kt}if(Yt==="fill"||Rt){ft=!0;const $t=Et;_t=Math.min(Vt*st,Math.max(1,Math.floor(1/oi))),mt&&Ct&&ht<=$e.stableFitRemainingWidth&&(St=$e.stableFitMaxMinimapScale),Et=Math.min(St,Math.max(1,Math.floor(_t/xt))),Et>$t&&(Qe=Math.min(2,Et/$t)),zt=Et/st/Qe,Kt=Math.ceil(Math.max(At,ei+Gt+Wt)*_t),mt?($e.stableMinimapLayoutInput=X,$e.stableFitRemainingWidth=ht,$e.stableFitMaxMinimapScale=Et):($e.stableMinimapLayoutInput=null,$e.stableFitRemainingWidth=0)}}}const ui=Math.floor(Zt*zt),Jt=Math.min(ui,Math.max(0,Math.floor((ht-si-2)*zt/(Qt+zt)))+e.MINIMAP_GUTTER_WIDTH);let Ut=Math.floor(st*Jt);const bt=Ut/st;Ut=Math.floor(Ut*Qe);const jt=Xt?1:2,Mt=Ze==="left"?0:He-Jt-si;return{renderMinimap:jt,minimapLeft:Mt,minimapWidth:Jt,minimapHeightIsEditorHeight:ft,minimapIsSampling:Bt,minimapScale:Et,minimapLineHeight:_t,minimapCanvasInnerWidth:Ut,minimapCanvasInnerHeight:Kt,minimapCanvasOuterWidth:bt,minimapCanvasOuterHeight:Tt}}static computeLayout(X,$e){const He=$e.outerWidth|0,we=$e.outerHeight|0,st=$e.lineHeight|0,dt=$e.lineNumbersDigitCount|0,Ct=$e.typicalHalfwidthCharacterWidth,Vt=$e.maxDigitWidth,Qt=$e.pixelRatio,ii=$e.viewLineCount,Xt=X.get(137),Et=Xt==="inherit"?X.get(136):Xt,Zt=Et==="inherit"?X.get(132):Et,Yt=X.get(135),Ze=$e.isDominatedByLongLines,si=X.get(57),Gt=X.get(68).renderType!==0,ht=X.get(69),mt=X.get(105),xt=X.get(84),Kt=X.get(73),Tt=X.get(103),ft=Tt.verticalScrollbarSize,Bt=Tt.verticalHasArrows,_t=Tt.arrowSize,zt=Tt.horizontalScrollbarSize,Qe=X.get(43),ui=X.get(110)!=="never";let Jt=X.get(66);Qe&&ui&&(Jt+=16);let Ut=0;if(Gt){const ai=Math.max(dt,ht);Ut=Math.round(ai*Vt)}let bt=0;si&&(bt=st*$e.glyphMarginDecorationLaneCount);let jt=0,Mt=jt+bt,At=Mt+Ut,ei=At+Jt;const Wt=He-bt-Ut-Jt;let oi=!1,Nt=!1,qt=-1;Et==="inherit"&&Ze?(oi=!0,Nt=!0):Zt==="on"||Zt==="bounded"?Nt=!0:Zt==="wordWrapColumn"&&(qt=Yt);const Rt=ge.c({outerWidth:He,outerHeight:we,lineHeight:st,typicalHalfwidthCharacterWidth:Ct,pixelRatio:Qt,scrollBeyondLastLine:mt,paddingTop:xt.top,paddingBottom:xt.bottom,minimap:Kt,verticalScrollbarWidth:ft,viewLineCount:ii,remainingWidth:Wt,isViewportWrapping:Nt},$e.memory||new O);Rt.renderMinimap!==0&&Rt.minimapLeft===0&&(jt+=Rt.minimapWidth,Mt+=Rt.minimapWidth,At+=Rt.minimapWidth,ei+=Rt.minimapWidth);const St=Wt-Rt.minimapWidth,$t=Math.max(1,Math.floor((St-ft-2)/Ct)),Dt=Bt?_t:0;return Nt&&(qt=Math.max(1,$t),Zt==="bounded"&&(qt=Math.min(qt,Yt))),{width:He,height:we,glyphMarginLeft:jt,glyphMarginWidth:bt,glyphMarginDecorationLaneCount:$e.glyphMarginDecorationLaneCount,lineNumbersLeft:Mt,lineNumbersWidth:Ut,decorationsLeft:At,decorationsWidth:Jt,contentLeft:ei,contentWidth:St,minimap:Rt,viewportColumn:$t,isWordWrapMinified:oi,isViewportWrapping:Nt,wrappingColumn:qt,verticalScrollbarWidth:ft,horizontalScrollbarHeight:zt,overviewRuler:{top:Dt,width:ft,height:we-2*Dt,right:0}}}}e.EditorLayoutInfoComputer=ge;class ue extends S{constructor(){super(139,"wrappingStrategy","simple",{"editor.wrappingStrategy":{enumDescriptions:[p.localize(47,null),p.localize(48,null)],type:"string",enum:["simple","advanced"],default:"simple",description:p.localize(49,null)}})}validate(X){return b(X,"simple",["simple","advanced"])}compute(X,$e,He){return $e.get(2)===2?"advanced":He}}var Ce;(function(Z){Z.Off="off",Z.OnCode="onCode",Z.On="on"})(Ce||(e.ShowLightbulbIconMode=Ce={}));class se extends S{constructor(){const X={enabled:Ce.On};super(65,"lightbulb",X,{"editor.lightbulb.enabled":{type:"string",tags:["experimental"],enum:[Ce.Off,Ce.OnCode,Ce.On],default:X.enabled,enumDescriptions:[p.localize(50,null),p.localize(51,null),p.localize(52,null)],description:p.localize(53,null)}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{enabled:b(X.enabled,this.defaultValue.enabled,[Ce.Off,Ce.OnCode,Ce.On])}}}class Ne extends S{constructor(){const X={enabled:!0,maxLineCount:5,defaultModel:"outlineModel",scrollWithEditor:!0};super(115,"stickyScroll",X,{"editor.stickyScroll.enabled":{type:"boolean",default:X.enabled,description:p.localize(54,null),tags:["experimental"]},"editor.stickyScroll.maxLineCount":{type:"number",default:X.maxLineCount,minimum:1,maximum:20,description:p.localize(55,null)},"editor.stickyScroll.defaultModel":{type:"string",enum:["outlineModel","foldingProviderModel","indentationModel"],default:X.defaultModel,description:p.localize(56,null)},"editor.stickyScroll.scrollWithEditor":{type:"boolean",default:X.scrollWithEditor,description:p.localize(57,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),maxLineCount:t.clampedInt($e.maxLineCount,this.defaultValue.maxLineCount,1,20),defaultModel:b($e.defaultModel,this.defaultValue.defaultModel,["outlineModel","foldingProviderModel","indentationModel"]),scrollWithEditor:r($e.scrollWithEditor,this.defaultValue.scrollWithEditor)}}}class ne extends S{constructor(){const X={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(141,"inlayHints",X,{"editor.inlayHints.enabled":{type:"string",default:X.enabled,description:p.localize(58,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[p.localize(59,null),p.localize(60,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(61,null,M.$j?"Ctrl+Option":"Ctrl+Alt"),p.localize(62,null)]},"editor.inlayHints.fontSize":{type:"number",default:X.fontSize,markdownDescription:p.localize(63,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:X.fontFamily,markdownDescription:p.localize(64,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:X.padding,description:p.localize(65,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return typeof $e.enabled=="boolean"&&($e.enabled=$e.enabled?"on":"off"),{enabled:b($e.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:t.clampedInt($e.fontSize,this.defaultValue.fontSize,0,100),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),padding:r($e.padding,this.defaultValue.padding)}}}class U extends S{constructor(){super(66,"lineDecorationsWidth",10)}validate(X){return typeof X=="string"&&/^\d+(\.\d+)?ch$/.test(X)?-parseFloat(X.substring(0,X.length-2)):t.clampedInt(X,this.defaultValue,0,1e3)}compute(X,$e,He){return He<0?t.clampedInt(-He*X.fontInfo.typicalHalfwidthCharacterWidth,this.defaultValue,0,1e3):He}}class x extends u{constructor(){super(67,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,X=>u.clamp(X,0,150),{markdownDescription:p.localize(66,null)})}compute(X,$e,He){return X.fontInfo.lineHeight}}class ve extends S{constructor(){const X={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1,showRegionSectionHeaders:!0,showMarkSectionHeaders:!0,sectionHeaderFontSize:9};super(73,"minimap",X,{"editor.minimap.enabled":{type:"boolean",default:X.enabled,description:p.localize(67,null)},"editor.minimap.autohide":{type:"boolean",default:X.autohide,description:p.localize(68,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[p.localize(69,null),p.localize(70,null),p.localize(71,null)],default:X.size,description:p.localize(72,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:X.side,description:p.localize(73,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:X.showSlider,description:p.localize(74,null)},"editor.minimap.scale":{type:"number",default:X.scale,minimum:1,maximum:3,enum:[1,2,3],description:p.localize(75,null)},"editor.minimap.renderCharacters":{type:"boolean",default:X.renderCharacters,description:p.localize(76,null)},"editor.minimap.maxColumn":{type:"number",default:X.maxColumn,description:p.localize(77,null)},"editor.minimap.showRegionSectionHeaders":{type:"boolean",default:X.showRegionSectionHeaders,description:p.localize(78,null)},"editor.minimap.showMarkSectionHeaders":{type:"boolean",default:X.showMarkSectionHeaders,description:p.localize(79,null)},"editor.minimap.sectionHeaderFontSize":{type:"number",default:X.sectionHeaderFontSize,description:p.localize(80,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),autohide:r($e.autohide,this.defaultValue.autohide),size:b($e.size,this.defaultValue.size,["proportional","fill","fit"]),side:b($e.side,this.defaultValue.side,["right","left"]),showSlider:b($e.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:r($e.renderCharacters,this.defaultValue.renderCharacters),scale:t.clampedInt($e.scale,1,1,3),maxColumn:t.clampedInt($e.maxColumn,this.defaultValue.maxColumn,1,1e4),showRegionSectionHeaders:r($e.showRegionSectionHeaders,this.defaultValue.showRegionSectionHeaders),showMarkSectionHeaders:r($e.showMarkSectionHeaders,this.defaultValue.showMarkSectionHeaders),sectionHeaderFontSize:u.clamp($e.sectionHeaderFontSize??this.defaultValue.sectionHeaderFontSize,4,32)}}}function Le(Z){return Z==="ctrlCmd"?M.$j?"metaKey":"ctrlKey":"altKey"}class ke extends S{constructor(){super(84,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(81,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:p.localize(82,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{top:t.clampedInt($e.top,0,0,1e3),bottom:t.clampedInt($e.bottom,0,0,1e3)}}}class be extends S{constructor(){const X={enabled:!0,cycle:!0};super(86,"parameterHints",X,{"editor.parameterHints.enabled":{type:"boolean",default:X.enabled,description:p.localize(83,null)},"editor.parameterHints.cycle":{type:"boolean",default:X.cycle,description:p.localize(84,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),cycle:r($e.cycle,this.defaultValue.cycle)}}}class me extends f{constructor(){super(143)}compute(X,$e,He){return X.pixelRatio}}class Q extends S{constructor(){const X={other:"on",comments:"off",strings:"off"},$e=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[p.localize(85,null),p.localize(86,null),p.localize(87,null)]}];super(89,"quickSuggestions",X,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:$e,default:X.strings,description:p.localize(88,null)},comments:{anyOf:$e,default:X.comments,description:p.localize(89,null)},other:{anyOf:$e,default:X.other,description:p.localize(90,null)}},default:X,markdownDescription:p.localize(91,null,"#editor.suggestOnTriggerCharacters#")}),this.defaultValue=X}validate(X){if(typeof X=="boolean"){const Qt=X?"on":"off";return{comments:Qt,strings:Qt,other:Qt}}if(!X||typeof X!="object")return this.defaultValue;const{other:$e,comments:He,strings:we}=X,st=["on","inline","off"];let dt,Ct,Vt;return typeof $e=="boolean"?dt=$e?"on":"off":dt=b($e,this.defaultValue.other,st),typeof He=="boolean"?Ct=He?"on":"off":Ct=b(He,this.defaultValue.comments,st),typeof we=="boolean"?Vt=we?"on":"off":Vt=b(we,this.defaultValue.strings,st),{other:dt,comments:Ct,strings:Vt}}}var Y;(function(Z){Z[Z.Off=0]="Off",Z[Z.On=1]="On",Z[Z.Relative=2]="Relative",Z[Z.Interval=3]="Interval",Z[Z.Custom=4]="Custom"})(Y||(e.RenderLineNumbersType=Y={}));class he extends S{constructor(){super(68,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[p.localize(92,null),p.localize(93,null),p.localize(94,null),p.localize(95,null)],default:"on",description:p.localize(96,null)})}validate(X){let $e=this.defaultValue.renderType,He=this.defaultValue.renderFn;return typeof X<"u"&&(typeof X=="function"?($e=4,He=X):X==="interval"?$e=3:X==="relative"?$e=2:X==="on"?$e=1:$e=0),{renderType:$e,renderFn:He}}}function ce(Z){const X=Z.get(98);return X==="editable"?Z.get(91):X!=="on"}class Te extends S{constructor(){const X=[],$e={type:"number",description:p.localize(97,null)};super(102,"rulers",X,{type:"array",items:{anyOf:[$e,{type:["object"],properties:{column:$e,color:{type:"string",description:p.localize(98,null),format:"color-hex"}}}]},default:X,description:p.localize(99,null)})}validate(X){if(Array.isArray(X)){const $e=[];for(const He of X)if(typeof He=="number")$e.push({column:t.clampedInt(He,0,0,1e4),color:null});else if(He&&typeof He=="object"){const we=He;$e.push({column:t.clampedInt(we.column,0,0,1e4),color:we.color})}return $e.sort((He,we)=>He.column-we.column),$e}return this.defaultValue}}class fe extends S{constructor(){super(92,"readOnlyMessage",void 0)}validate(X){return!X||typeof X!="object"?this.defaultValue:X}}function Pe(Z,X){if(typeof Z!="string")return X;switch(Z){case"hidden":return 2;case"visible":return 3;default:return 1}}class Re extends S{constructor(){const X={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1,ignoreHorizontalScrollbarInContentHeight:!1};super(103,"scrollbar",X,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(100,null),p.localize(101,null),p.localize(102,null)],default:"auto",description:p.localize(103,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[p.localize(104,null),p.localize(105,null),p.localize(106,null)],default:"auto",description:p.localize(107,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:X.verticalScrollbarSize,description:p.localize(108,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:X.horizontalScrollbarSize,description:p.localize(109,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:X.scrollByPage,description:p.localize(110,null)},"editor.scrollbar.ignoreHorizontalScrollbarInContentHeight":{type:"boolean",default:X.ignoreHorizontalScrollbarInContentHeight,description:p.localize(111,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X,He=t.clampedInt($e.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),we=t.clampedInt($e.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:t.clampedInt($e.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:Pe($e.vertical,this.defaultValue.vertical),horizontal:Pe($e.horizontal,this.defaultValue.horizontal),useShadows:r($e.useShadows,this.defaultValue.useShadows),verticalHasArrows:r($e.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:r($e.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:r($e.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:r($e.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:He,horizontalSliderSize:t.clampedInt($e.horizontalSliderSize,He,0,1e3),verticalScrollbarSize:we,verticalSliderSize:t.clampedInt($e.verticalSliderSize,we,0,1e3),scrollByPage:r($e.scrollByPage,this.defaultValue.scrollByPage),ignoreHorizontalScrollbarInContentHeight:r($e.ignoreHorizontalScrollbarInContentHeight,this.defaultValue.ignoreHorizontalScrollbarInContentHeight)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class je extends S{constructor(){const X={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(125,"unicodeHighlight",X,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.nonBasicASCII,description:p.localize(112,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:X.invisibleCharacters,description:p.localize(113,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:X.ambiguousCharacters,description:p.localize(114,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeComments,description:p.localize(115,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:X.includeStrings,description:p.localize(116,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:X.allowedCharacters,description:p.localize(117,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:X.allowedLocales,description:p.localize(118,null)}})}applyUpdate(X,$e){let He=!1;$e.allowedCharacters&&X&&(N.$9n(X.allowedCharacters,$e.allowedCharacters)||(X={...X,allowedCharacters:$e.allowedCharacters},He=!0)),$e.allowedLocales&&X&&(N.$9n(X.allowedLocales,$e.allowedLocales)||(X={...X,allowedLocales:$e.allowedLocales},He=!0));const we=super.applyUpdate(X,$e);return He?new d(we.newValue,!0):we}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{nonBasicASCII:te($e.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:r($e.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:r($e.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:te($e.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:te($e.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.c(X.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.c(X.allowedLocales,this.defaultValue.allowedLocales)}}c(X,$e){if(typeof X!="object"||!X)return $e;const He={};for(const[we,st]of Object.entries(X))st===!0&&(He[we]=!0);return He}}class B extends S{constructor(){const X={enabled:!0,mode:"subwordSmart",showToolbar:"onHover",suppressSuggestions:!1,keepOnBlur:!1,fontFamily:"default"};super(62,"inlineSuggest",X,{"editor.inlineSuggest.enabled":{type:"boolean",default:X.enabled,description:p.localize(119,null)},"editor.inlineSuggest.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(120,null),p.localize(121,null),p.localize(122,null)],description:p.localize(123,null)},"editor.inlineSuggest.suppressSuggestions":{type:"boolean",default:X.suppressSuggestions,description:p.localize(124,null)},"editor.inlineSuggest.fontFamily":{type:"string",default:X.fontFamily,description:p.localize(125,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),mode:b($e.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"]),showToolbar:b($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),suppressSuggestions:r($e.suppressSuggestions,this.defaultValue.suppressSuggestions),keepOnBlur:r($e.keepOnBlur,this.defaultValue.keepOnBlur),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily)}}}class F extends S{constructor(){const X={enabled:!1,showToolbar:"onHover",fontFamily:"default",keepOnBlur:!1,backgroundColoring:!1};super(63,"experimentalInlineEdit",X,{"editor.experimentalInlineEdit.enabled":{type:"boolean",default:X.enabled,description:p.localize(126,null)},"editor.experimentalInlineEdit.showToolbar":{type:"string",default:X.showToolbar,enum:["always","onHover","never"],enumDescriptions:[p.localize(127,null),p.localize(128,null),p.localize(129,null)],description:p.localize(130,null)},"editor.experimentalInlineEdit.fontFamily":{type:"string",default:X.fontFamily,description:p.localize(131,null)},"editor.experimentalInlineEdit.backgroundColoring":{type:"boolean",default:X.backgroundColoring,description:p.localize(132,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),showToolbar:b($e.showToolbar,this.defaultValue.showToolbar,["always","onHover","never"]),fontFamily:i.string($e.fontFamily,this.defaultValue.fontFamily),keepOnBlur:r($e.keepOnBlur,this.defaultValue.keepOnBlur),backgroundColoring:r($e.backgroundColoring,this.defaultValue.backgroundColoring)}}}class H extends S{constructor(){const X={enabled:T.$9s.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.$9s.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(15,"bracketPairColorization",X,{"editor.bracketPairColorization.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(133,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:X.independentColorPoolPerBracketType,description:p.localize(134,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:r($e.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class G extends S{constructor(){const X={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(16,"guides",X,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(135,null),p.localize(136,null),p.localize(137,null)],default:X.bracketPairs,description:p.localize(138,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[p.localize(139,null),p.localize(140,null),p.localize(141,null)],default:X.bracketPairsHorizontal,description:p.localize(142,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:X.highlightActiveBracketPair,description:p.localize(143,null)},"editor.guides.indentation":{type:"boolean",default:X.indentation,description:p.localize(144,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[p.localize(145,null),p.localize(146,null),p.localize(147,null)],default:X.highlightActiveIndentation,description:p.localize(148,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{bracketPairs:te($e.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:te($e.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:r($e.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:r($e.indentation,this.defaultValue.indentation),highlightActiveIndentation:te($e.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function te(Z,X,$e){const He=$e.indexOf(Z);return He===-1?X:$e[He]}class re extends S{constructor(){const X={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!1,localityBonus:!1,shareSuggestSelections:!1,selectionMode:"always",showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,matchOnWordStartOnly:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(118,"suggest",X,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[p.localize(149,null),p.localize(150,null)],default:X.insertMode,description:p.localize(151,null)},"editor.suggest.filterGraceful":{type:"boolean",default:X.filterGraceful,description:p.localize(152,null)},"editor.suggest.localityBonus":{type:"boolean",default:X.localityBonus,description:p.localize(153,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:X.shareSuggestSelections,markdownDescription:p.localize(154,null)},"editor.suggest.selectionMode":{type:"string",enum:["always","never","whenTriggerCharacter","whenQuickSuggestion"],enumDescriptions:[p.localize(155,null),p.localize(156,null),p.localize(157,null),p.localize(158,null)],default:X.selectionMode,markdownDescription:p.localize(159,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:X.snippetsPreventQuickSuggestions,description:p.localize(160,null)},"editor.suggest.showIcons":{type:"boolean",default:X.showIcons,description:p.localize(161,null)},"editor.suggest.showStatusBar":{type:"boolean",default:X.showStatusBar,description:p.localize(162,null)},"editor.suggest.preview":{type:"boolean",default:X.preview,description:p.localize(163,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:X.showInlineDetails,description:p.localize(164,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:p.localize(165,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:p.localize(166,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:p.localize(167,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:p.localize(168,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:p.localize(169,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:p.localize(170,null)},"editor.suggest.matchOnWordStartOnly":{type:"boolean",default:!0,markdownDescription:p.localize(171,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:p.localize(172,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:p.localize(173,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:p.localize(174,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:p.localize(175,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:p.localize(176,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:p.localize(177,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:p.localize(178,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:p.localize(179,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:p.localize(180,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:p.localize(181,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:p.localize(182,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:p.localize(183,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:p.localize(184,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:p.localize(185,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:p.localize(186,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:p.localize(187,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:p.localize(188,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:p.localize(189,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:p.localize(190,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:p.localize(191,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:p.localize(192,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:p.localize(193,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:p.localize(194,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:p.localize(195,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:p.localize(196,null)}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{insertMode:b($e.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:r($e.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:r($e.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:r($e.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:r($e.shareSuggestSelections,this.defaultValue.shareSuggestSelections),selectionMode:b($e.selectionMode,this.defaultValue.selectionMode,["always","never","whenQuickSuggestion","whenTriggerCharacter"]),showIcons:r($e.showIcons,this.defaultValue.showIcons),showStatusBar:r($e.showStatusBar,this.defaultValue.showStatusBar),preview:r($e.preview,this.defaultValue.preview),previewMode:b($e.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:r($e.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:r($e.showMethods,this.defaultValue.showMethods),showFunctions:r($e.showFunctions,this.defaultValue.showFunctions),showConstructors:r($e.showConstructors,this.defaultValue.showConstructors),showDeprecated:r($e.showDeprecated,this.defaultValue.showDeprecated),matchOnWordStartOnly:r($e.matchOnWordStartOnly,this.defaultValue.matchOnWordStartOnly),showFields:r($e.showFields,this.defaultValue.showFields),showVariables:r($e.showVariables,this.defaultValue.showVariables),showClasses:r($e.showClasses,this.defaultValue.showClasses),showStructs:r($e.showStructs,this.defaultValue.showStructs),showInterfaces:r($e.showInterfaces,this.defaultValue.showInterfaces),showModules:r($e.showModules,this.defaultValue.showModules),showProperties:r($e.showProperties,this.defaultValue.showProperties),showEvents:r($e.showEvents,this.defaultValue.showEvents),showOperators:r($e.showOperators,this.defaultValue.showOperators),showUnits:r($e.showUnits,this.defaultValue.showUnits),showValues:r($e.showValues,this.defaultValue.showValues),showConstants:r($e.showConstants,this.defaultValue.showConstants),showEnums:r($e.showEnums,this.defaultValue.showEnums),showEnumMembers:r($e.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:r($e.showKeywords,this.defaultValue.showKeywords),showWords:r($e.showWords,this.defaultValue.showWords),showColors:r($e.showColors,this.defaultValue.showColors),showFiles:r($e.showFiles,this.defaultValue.showFiles),showReferences:r($e.showReferences,this.defaultValue.showReferences),showFolders:r($e.showFolders,this.defaultValue.showFolders),showTypeParameters:r($e.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:r($e.showSnippets,this.defaultValue.showSnippets),showUsers:r($e.showUsers,this.defaultValue.showUsers),showIssues:r($e.showIssues,this.defaultValue.showIssues)}}}class Oe extends S{constructor(){super(113,"smartSelect",{selectLeadingAndTrailingWhitespace:!0,selectSubwords:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:p.localize(197,null),default:!0,type:"boolean"},"editor.smartSelect.selectSubwords":{description:p.localize(198,null),default:!0,type:"boolean"}})}validate(X){return!X||typeof X!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:r(X.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace),selectSubwords:r(X.selectSubwords,this.defaultValue.selectSubwords)}}}class Be extends S{constructor(){const X=[];super(130,"wordSegmenterLocales",X,{anyOf:[{description:p.localize(199,null),type:"string"},{description:p.localize(200,null),type:"array",items:{type:"string"}}]})}validate(X){if(typeof X=="string"&&(X=[X]),Array.isArray(X)){const $e=[];for(const He of X)if(typeof He=="string")try{Intl.Segmenter.supportedLocalesOf(He).length>0&&$e.push(He)}catch{}return $e}return this.defaultValue}}var Ge;(function(Z){Z[Z.None=0]="None",Z[Z.Same=1]="Same",Z[Z.Indent=2]="Indent",Z[Z.DeepIndent=3]="DeepIndent"})(Ge||(e.WrappingIndent=Ge={}));class _e extends S{constructor(){super(138,"wrappingIndent",1,{"editor.wrappingIndent":{type:"string",enum:["none","same","indent","deepIndent"],enumDescriptions:[p.localize(201,null),p.localize(202,null),p.localize(203,null),p.localize(204,null)],description:p.localize(205,null),default:"same"}})}validate(X){switch(X){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}return 1}compute(X,$e,He){return $e.get(2)===2?0:He}}class xe extends f{constructor(){super(146)}compute(X,$e,He){const we=$e.get(145);return{isDominatedByLongLines:X.isDominatedByLongLines,isWordWrapMinified:we.isWordWrapMinified,isViewportWrapping:we.isViewportWrapping,wrappingColumn:we.wrappingColumn}}}class et extends S{constructor(){const X={enabled:!0,showDropSelector:"afterDrop"};super(36,"dropIntoEditor",X,{"editor.dropIntoEditor.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(206,null)},"editor.dropIntoEditor.showDropSelector":{type:"string",markdownDescription:p.localize(207,null),enum:["afterDrop","never"],enumDescriptions:[p.localize(208,null),p.localize(209,null)],default:"afterDrop"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),showDropSelector:b($e.showDropSelector,this.defaultValue.showDropSelector,["afterDrop","never"])}}}class tt extends S{constructor(){const X={enabled:!0,showPasteSelector:"afterPaste"};super(85,"pasteAs",X,{"editor.pasteAs.enabled":{type:"boolean",default:X.enabled,markdownDescription:p.localize(210,null)},"editor.pasteAs.showPasteSelector":{type:"string",markdownDescription:p.localize(211,null),enum:["afterPaste","never"],enumDescriptions:[p.localize(212,null),p.localize(213,null)],default:"afterPaste"}})}validate(X){if(!X||typeof X!="object")return this.defaultValue;const $e=X;return{enabled:r($e.enabled,this.defaultValue.enabled),showPasteSelector:b($e.showPasteSelector,this.defaultValue.showPasteSelector,["afterPaste","never"])}}}const it="Consolas, 'Courier New', monospace",at="Menlo, Monaco, 'Courier New', monospace",gt="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:M.$j?at:M.$k?gt:it,fontWeight:"normal",fontSize:M.$j?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function Ue(Z){return e.editorOptionsRegistry[Z.id]=Z,Z}var rt;(function(Z){Z[Z.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",Z[Z.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",Z[Z.accessibilitySupport=2]="accessibilitySupport",Z[Z.accessibilityPageSize=3]="accessibilityPageSize",Z[Z.ariaLabel=4]="ariaLabel",Z[Z.ariaRequired=5]="ariaRequired",Z[Z.autoClosingBrackets=6]="autoClosingBrackets",Z[Z.autoClosingComments=7]="autoClosingComments",Z[Z.screenReaderAnnounceInlineSuggestion=8]="screenReaderAnnounceInlineSuggestion",Z[Z.autoClosingDelete=9]="autoClosingDelete",Z[Z.autoClosingOvertype=10]="autoClosingOvertype",Z[Z.autoClosingQuotes=11]="autoClosingQuotes",Z[Z.autoIndent=12]="autoIndent",Z[Z.automaticLayout=13]="automaticLayout",Z[Z.autoSurround=14]="autoSurround",Z[Z.bracketPairColorization=15]="bracketPairColorization",Z[Z.guides=16]="guides",Z[Z.codeLens=17]="codeLens",Z[Z.codeLensFontFamily=18]="codeLensFontFamily",Z[Z.codeLensFontSize=19]="codeLensFontSize",Z[Z.colorDecorators=20]="colorDecorators",Z[Z.colorDecoratorsLimit=21]="colorDecoratorsLimit",Z[Z.columnSelection=22]="columnSelection",Z[Z.comments=23]="comments",Z[Z.contextmenu=24]="contextmenu",Z[Z.copyWithSyntaxHighlighting=25]="copyWithSyntaxHighlighting",Z[Z.cursorBlinking=26]="cursorBlinking",Z[Z.cursorSmoothCaretAnimation=27]="cursorSmoothCaretAnimation",Z[Z.cursorStyle=28]="cursorStyle",Z[Z.cursorSurroundingLines=29]="cursorSurroundingLines",Z[Z.cursorSurroundingLinesStyle=30]="cursorSurroundingLinesStyle",Z[Z.cursorWidth=31]="cursorWidth",Z[Z.disableLayerHinting=32]="disableLayerHinting",Z[Z.disableMonospaceOptimizations=33]="disableMonospaceOptimizations",Z[Z.domReadOnly=34]="domReadOnly",Z[Z.dragAndDrop=35]="dragAndDrop",Z[Z.dropIntoEditor=36]="dropIntoEditor",Z[Z.emptySelectionClipboard=37]="emptySelectionClipboard",Z[Z.experimentalWhitespaceRendering=38]="experimentalWhitespaceRendering",Z[Z.extraEditorClassName=39]="extraEditorClassName",Z[Z.fastScrollSensitivity=40]="fastScrollSensitivity",Z[Z.find=41]="find",Z[Z.fixedOverflowWidgets=42]="fixedOverflowWidgets",Z[Z.folding=43]="folding",Z[Z.foldingStrategy=44]="foldingStrategy",Z[Z.foldingHighlight=45]="foldingHighlight",Z[Z.foldingImportsByDefault=46]="foldingImportsByDefault",Z[Z.foldingMaximumRegions=47]="foldingMaximumRegions",Z[Z.unfoldOnClickAfterEndOfLine=48]="unfoldOnClickAfterEndOfLine",Z[Z.fontFamily=49]="fontFamily",Z[Z.fontInfo=50]="fontInfo",Z[Z.fontLigatures=51]="fontLigatures",Z[Z.fontSize=52]="fontSize",Z[Z.fontWeight=53]="fontWeight",Z[Z.fontVariations=54]="fontVariations",Z[Z.formatOnPaste=55]="formatOnPaste",Z[Z.formatOnType=56]="formatOnType",Z[Z.glyphMargin=57]="glyphMargin",Z[Z.gotoLocation=58]="gotoLocation",Z[Z.hideCursorInOverviewRuler=59]="hideCursorInOverviewRuler",Z[Z.hover=60]="hover",Z[Z.inDiffEditor=61]="inDiffEditor",Z[Z.inlineSuggest=62]="inlineSuggest",Z[Z.inlineEdit=63]="inlineEdit",Z[Z.letterSpacing=64]="letterSpacing",Z[Z.lightbulb=65]="lightbulb",Z[Z.lineDecorationsWidth=66]="lineDecorationsWidth",Z[Z.lineHeight=67]="lineHeight",Z[Z.lineNumbers=68]="lineNumbers",Z[Z.lineNumbersMinChars=69]="lineNumbersMinChars",Z[Z.linkedEditing=70]="linkedEditing",Z[Z.links=71]="links",Z[Z.matchBrackets=72]="matchBrackets",Z[Z.minimap=73]="minimap",Z[Z.mouseStyle=74]="mouseStyle",Z[Z.mouseWheelScrollSensitivity=75]="mouseWheelScrollSensitivity",Z[Z.mouseWheelZoom=76]="mouseWheelZoom",Z[Z.multiCursorMergeOverlapping=77]="multiCursorMergeOverlapping",Z[Z.multiCursorModifier=78]="multiCursorModifier",Z[Z.multiCursorPaste=79]="multiCursorPaste",Z[Z.multiCursorLimit=80]="multiCursorLimit",Z[Z.occurrencesHighlight=81]="occurrencesHighlight",Z[Z.overviewRulerBorder=82]="overviewRulerBorder",Z[Z.overviewRulerLanes=83]="overviewRulerLanes",Z[Z.padding=84]="padding",Z[Z.pasteAs=85]="pasteAs",Z[Z.parameterHints=86]="parameterHints",Z[Z.peekWidgetDefaultFocus=87]="peekWidgetDefaultFocus",Z[Z.definitionLinkOpensInPeek=88]="definitionLinkOpensInPeek",Z[Z.quickSuggestions=89]="quickSuggestions",Z[Z.quickSuggestionsDelay=90]="quickSuggestionsDelay",Z[Z.readOnly=91]="readOnly",Z[Z.readOnlyMessage=92]="readOnlyMessage",Z[Z.renameOnType=93]="renameOnType",Z[Z.renderControlCharacters=94]="renderControlCharacters",Z[Z.renderFinalNewline=95]="renderFinalNewline",Z[Z.renderLineHighlight=96]="renderLineHighlight",Z[Z.renderLineHighlightOnlyWhenFocus=97]="renderLineHighlightOnlyWhenFocus",Z[Z.renderValidationDecorations=98]="renderValidationDecorations",Z[Z.renderWhitespace=99]="renderWhitespace",Z[Z.revealHorizontalRightPadding=100]="revealHorizontalRightPadding",Z[Z.roundedSelection=101]="roundedSelection",Z[Z.rulers=102]="rulers",Z[Z.scrollbar=103]="scrollbar",Z[Z.scrollBeyondLastColumn=104]="scrollBeyondLastColumn",Z[Z.scrollBeyondLastLine=105]="scrollBeyondLastLine",Z[Z.scrollPredominantAxis=106]="scrollPredominantAxis",Z[Z.selectionClipboard=107]="selectionClipboard",Z[Z.selectionHighlight=108]="selectionHighlight",Z[Z.selectOnLineNumbers=109]="selectOnLineNumbers",Z[Z.showFoldingControls=110]="showFoldingControls",Z[Z.showUnused=111]="showUnused",Z[Z.snippetSuggestions=112]="snippetSuggestions",Z[Z.smartSelect=113]="smartSelect",Z[Z.smoothScrolling=114]="smoothScrolling",Z[Z.stickyScroll=115]="stickyScroll",Z[Z.stickyTabStops=116]="stickyTabStops",Z[Z.stopRenderingLineAfter=117]="stopRenderingLineAfter",Z[Z.suggest=118]="suggest",Z[Z.suggestFontSize=119]="suggestFontSize",Z[Z.suggestLineHeight=120]="suggestLineHeight",Z[Z.suggestOnTriggerCharacters=121]="suggestOnTriggerCharacters",Z[Z.suggestSelection=122]="suggestSelection",Z[Z.tabCompletion=123]="tabCompletion",Z[Z.tabIndex=124]="tabIndex",Z[Z.unicodeHighlighting=125]="unicodeHighlighting",Z[Z.unusualLineTerminators=126]="unusualLineTerminators",Z[Z.useShadowDOM=127]="useShadowDOM",Z[Z.useTabStops=128]="useTabStops",Z[Z.wordBreak=129]="wordBreak",Z[Z.wordSegmenterLocales=130]="wordSegmenterLocales",Z[Z.wordSeparators=131]="wordSeparators",Z[Z.wordWrap=132]="wordWrap",Z[Z.wordWrapBreakAfterCharacters=133]="wordWrapBreakAfterCharacters",Z[Z.wordWrapBreakBeforeCharacters=134]="wordWrapBreakBeforeCharacters",Z[Z.wordWrapColumn=135]="wordWrapColumn",Z[Z.wordWrapOverride1=136]="wordWrapOverride1",Z[Z.wordWrapOverride2=137]="wordWrapOverride2",Z[Z.wrappingIndent=138]="wrappingIndent",Z[Z.wrappingStrategy=139]="wrappingStrategy",Z[Z.showDeprecated=140]="showDeprecated",Z[Z.inlayHints=141]="inlayHints",Z[Z.editorClassName=142]="editorClassName",Z[Z.pixelRatio=143]="pixelRatio",Z[Z.tabFocusMode=144]="tabFocusMode",Z[Z.layoutInfo=145]="layoutInfo",Z[Z.wrappingInfo=146]="wrappingInfo",Z[Z.defaultColorDecorators=147]="defaultColorDecorators",Z[Z.colorDecoratorsActivatedOn=148]="colorDecoratorsActivatedOn",Z[Z.inlineCompletionsAccessibilityVerbose=149]="inlineCompletionsAccessibilityVerbose"})(rt||(e.EditorOption=rt={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:Ue(new s(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:p.localize(214,null)})),acceptSuggestionOnEnter:Ue(new a(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",p.localize(215,null),""],markdownDescription:p.localize(216,null)})),accessibilitySupport:Ue(new $),accessibilityPageSize:Ue(new t(3,"accessibilityPageSize",10,1,1073741824,{description:p.localize(217,null),tags:["accessibility"]})),ariaLabel:Ue(new i(4,"ariaLabel",p.localize(218,null))),ariaRequired:Ue(new s(5,"ariaRequired",!1,void 0)),screenReaderAnnounceInlineSuggestion:Ue(new s(8,"screenReaderAnnounceInlineSuggestion",!0,{description:p.localize(219,null),tags:["accessibility"]})),autoClosingBrackets:Ue(new a(6,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(220,null),p.localize(221,null),""],description:p.localize(222,null)})),autoClosingComments:Ue(new a(7,"autoClosingComments","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(223,null),p.localize(224,null),""],description:p.localize(225,null)})),autoClosingDelete:Ue(new a(9,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",p.localize(226,null),""],description:p.localize(227,null)})),autoClosingOvertype:Ue(new a(10,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",p.localize(228,null),""],description:p.localize(229,null)})),autoClosingQuotes:Ue(new a(11,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",p.localize(230,null),p.localize(231,null),""],description:p.localize(232,null)})),autoIndent:Ue(new l(12,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],g,{enumDescriptions:[p.localize(233,null),p.localize(234,null),p.localize(235,null),p.localize(236,null),p.localize(237,null)],description:p.localize(238,null)})),automaticLayout:Ue(new s(13,"automaticLayout",!1)),autoSurround:Ue(new a(14,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[p.localize(239,null),p.localize(240,null),p.localize(241,null),""],description:p.localize(242,null)})),bracketPairColorization:Ue(new H),bracketPairGuides:Ue(new G),stickyTabStops:Ue(new s(116,"stickyTabStops",!1,{description:p.localize(243,null)})),codeLens:Ue(new s(17,"codeLens",!0,{description:p.localize(244,null)})),codeLensFontFamily:Ue(new i(18,"codeLensFontFamily","",{description:p.localize(245,null)})),codeLensFontSize:Ue(new t(19,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:p.localize(246,null)})),colorDecorators:Ue(new s(20,"colorDecorators",!0,{description:p.localize(247,null)})),colorDecoratorActivatedOn:Ue(new a(148,"colorDecoratorsActivatedOn","clickAndHover",["clickAndHover","hover","click"],{enumDescriptions:[p.localize(248,null),p.localize(249,null),p.localize(250,null)],description:p.localize(251,null)})),colorDecoratorsLimit:Ue(new t(21,"colorDecoratorsLimit",500,1,1e6,{markdownDescription:p.localize(252,null)})),columnSelection:Ue(new s(22,"columnSelection",!1,{description:p.localize(253,null)})),comments:Ue(new v),contextmenu:Ue(new s(24,"contextmenu",!0)),copyWithSyntaxHighlighting:Ue(new s(25,"copyWithSyntaxHighlighting",!0,{description:p.localize(254,null)})),cursorBlinking:Ue(new l(26,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],h,{description:p.localize(255,null)})),cursorSmoothCaretAnimation:Ue(new a(27,"cursorSmoothCaretAnimation","off",["off","explicit","on"],{enumDescriptions:[p.localize(256,null),p.localize(257,null),p.localize(258,null)],description:p.localize(259,null)})),cursorStyle:Ue(new l(28,"cursorStyle",E.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],I,{description:p.localize(260,null)})),cursorSurroundingLines:Ue(new t(29,"cursorSurroundingLines",0,0,1073741824,{description:p.localize(261,null)})),cursorSurroundingLinesStyle:Ue(new a(30,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[p.localize(262,null),p.localize(263,null)],markdownDescription:p.localize(264,null)})),cursorWidth:Ue(new t(31,"cursorWidth",0,0,1073741824,{markdownDescription:p.localize(265,null)})),disableLayerHinting:Ue(new s(32,"disableLayerHinting",!1)),disableMonospaceOptimizations:Ue(new s(33,"disableMonospaceOptimizations",!1)),domReadOnly:Ue(new s(34,"domReadOnly",!1)),dragAndDrop:Ue(new s(35,"dragAndDrop",!0,{description:p.localize(266,null)})),emptySelectionClipboard:Ue(new V),dropIntoEditor:Ue(new et),stickyScroll:Ue(new Ne),experimentalWhitespaceRendering:Ue(new a(38,"experimentalWhitespaceRendering","svg",["svg","font","off"],{enumDescriptions:[p.localize(267,null),p.localize(268,null),p.localize(269,null)],description:p.localize(270,null)})),extraEditorClassName:Ue(new i(39,"extraEditorClassName","")),fastScrollSensitivity:Ue(new u(40,"fastScrollSensitivity",5,Z=>Z<=0?5:Z,{markdownDescription:p.localize(271,null)})),find:Ue(new W),fixedOverflowWidgets:Ue(new s(42,"fixedOverflowWidgets",!1)),folding:Ue(new s(43,"folding",!0,{description:p.localize(272,null)})),foldingStrategy:Ue(new a(44,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[p.localize(273,null),p.localize(274,null)],description:p.localize(275,null)})),foldingHighlight:Ue(new s(45,"foldingHighlight",!0,{description:p.localize(276,null)})),foldingImportsByDefault:Ue(new s(46,"foldingImportsByDefault",!1,{description:p.localize(277,null)})),foldingMaximumRegions:Ue(new t(47,"foldingMaximumRegions",5e3,10,65e3,{description:p.localize(278,null)})),unfoldOnClickAfterEndOfLine:Ue(new s(48,"unfoldOnClickAfterEndOfLine",!1,{description:p.localize(279,null)})),fontFamily:Ue(new i(49,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:p.localize(280,null)})),fontInfo:Ue(new z),fontLigatures2:Ue(new q),fontSize:Ue(new K),fontWeight:Ue(new ie),fontVariations:Ue(new R),formatOnPaste:Ue(new s(55,"formatOnPaste",!1,{description:p.localize(281,null)})),formatOnType:Ue(new s(56,"formatOnType",!1,{description:p.localize(282,null)})),glyphMargin:Ue(new s(57,"glyphMargin",!0,{description:p.localize(283,null)})),gotoLocation:Ue(new de),hideCursorInOverviewRuler:Ue(new s(59,"hideCursorInOverviewRuler",!1,{description:p.localize(284,null)})),hover:Ue(new ye),inDiffEditor:Ue(new s(61,"inDiffEditor",!1)),letterSpacing:Ue(new u(64,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,Z=>u.clamp(Z,-5,20),{description:p.localize(285,null)})),lightbulb:Ue(new se),lineDecorationsWidth:Ue(new U),lineHeight:Ue(new x),lineNumbers:Ue(new he),lineNumbersMinChars:Ue(new t(69,"lineNumbersMinChars",5,1,300)),linkedEditing:Ue(new s(70,"linkedEditing",!1,{description:p.localize(286,null)})),links:Ue(new s(71,"links",!0,{description:p.localize(287,null)})),matchBrackets:Ue(new a(72,"matchBrackets","always",["always","near","never"],{description:p.localize(288,null)})),minimap:Ue(new ve),mouseStyle:Ue(new a(74,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:Ue(new u(75,"mouseWheelScrollSensitivity",1,Z=>Z===0?1:Z,{markdownDescription:p.localize(289,null)})),mouseWheelZoom:Ue(new s(76,"mouseWheelZoom",!1,{markdownDescription:M.$j?p.localize(290,null):p.localize(291,null)})),multiCursorMergeOverlapping:Ue(new s(77,"multiCursorMergeOverlapping",!0,{description:p.localize(292,null)})),multiCursorModifier:Ue(new l(78,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],Le,{markdownEnumDescriptions:[p.localize(293,null),p.localize(294,null)],markdownDescription:p.localize(295,null)})),multiCursorPaste:Ue(new a(79,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[p.localize(296,null),p.localize(297,null)],markdownDescription:p.localize(298,null)})),multiCursorLimit:Ue(new t(80,"multiCursorLimit",1e4,1,1e5,{markdownDescription:p.localize(299,null)})),occurrencesHighlight:Ue(new a(81,"occurrencesHighlight","singleFile",["off","singleFile","multiFile"],{markdownEnumDescriptions:[p.localize(300,null),p.localize(301,null),p.localize(302,null)],markdownDescription:p.localize(303,null)})),overviewRulerBorder:Ue(new s(82,"overviewRulerBorder",!0,{description:p.localize(304,null)})),overviewRulerLanes:Ue(new t(83,"overviewRulerLanes",3,0,3)),padding:Ue(new ke),pasteAs:Ue(new tt),parameterHints:Ue(new be),peekWidgetDefaultFocus:Ue(new a(87,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[p.localize(305,null),p.localize(306,null)],description:p.localize(307,null)})),definitionLinkOpensInPeek:Ue(new s(88,"definitionLinkOpensInPeek",!1,{description:p.localize(308,null)})),quickSuggestions:Ue(new Q),quickSuggestionsDelay:Ue(new t(90,"quickSuggestionsDelay",10,0,1073741824,{description:p.localize(309,null)})),readOnly:Ue(new s(91,"readOnly",!1)),readOnlyMessage:Ue(new fe),renameOnType:Ue(new s(93,"renameOnType",!1,{description:p.localize(310,null),markdownDeprecationMessage:p.localize(311,null)})),renderControlCharacters:Ue(new s(94,"renderControlCharacters",!0,{description:p.localize(312,null),restricted:!0})),renderFinalNewline:Ue(new a(95,"renderFinalNewline",M.$k?"dimmed":"on",["off","on","dimmed"],{description:p.localize(313,null)})),renderLineHighlight:Ue(new a(96,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",p.localize(314,null)],description:p.localize(315,null)})),renderLineHighlightOnlyWhenFocus:Ue(new s(97,"renderLineHighlightOnlyWhenFocus",!1,{description:p.localize(316,null)})),renderValidationDecorations:Ue(new a(98,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:Ue(new a(99,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",p.localize(317,null),p.localize(318,null),p.localize(319,null),""],description:p.localize(320,null)})),revealHorizontalRightPadding:Ue(new t(100,"revealHorizontalRightPadding",15,0,1e3)),roundedSelection:Ue(new s(101,"roundedSelection",!0,{description:p.localize(321,null)})),rulers:Ue(new Te),scrollbar:Ue(new Re),scrollBeyondLastColumn:Ue(new t(104,"scrollBeyondLastColumn",4,0,1073741824,{description:p.localize(322,null)})),scrollBeyondLastLine:Ue(new s(105,"scrollBeyondLastLine",!0,{description:p.localize(323,null)})),scrollPredominantAxis:Ue(new s(106,"scrollPredominantAxis",!0,{description:p.localize(324,null)})),selectionClipboard:Ue(new s(107,"selectionClipboard",!0,{description:p.localize(325,null),included:M.$k})),selectionHighlight:Ue(new s(108,"selectionHighlight",!0,{description:p.localize(326,null)})),selectOnLineNumbers:Ue(new s(109,"selectOnLineNumbers",!0)),showFoldingControls:Ue(new a(110,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[p.localize(327,null),p.localize(328,null),p.localize(329,null)],description:p.localize(330,null)})),showUnused:Ue(new s(111,"showUnused",!0,{description:p.localize(331,null)})),showDeprecated:Ue(new s(140,"showDeprecated",!0,{description:p.localize(332,null)})),inlayHints:Ue(new ne),snippetSuggestions:Ue(new a(112,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[p.localize(333,null),p.localize(334,null),p.localize(335,null),p.localize(336,null)],description:p.localize(337,null)})),smartSelect:Ue(new Oe),smoothScrolling:Ue(new s(114,"smoothScrolling",!1,{description:p.localize(338,null)})),stopRenderingLineAfter:Ue(new t(117,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:Ue(new re),inlineSuggest:Ue(new B),inlineEdit:Ue(new F),inlineCompletionsAccessibilityVerbose:Ue(new s(149,"inlineCompletionsAccessibilityVerbose",!1,{description:p.localize(339,null)})),suggestFontSize:Ue(new t(119,"suggestFontSize",0,0,1e3,{markdownDescription:p.localize(340,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:Ue(new t(120,"suggestLineHeight",0,0,1e3,{markdownDescription:p.localize(341,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:Ue(new s(121,"suggestOnTriggerCharacters",!0,{description:p.localize(342,null)})),suggestSelection:Ue(new a(122,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[p.localize(343,null),p.localize(344,null),p.localize(345,null)],description:p.localize(346,null)})),tabCompletion:Ue(new a(123,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[p.localize(347,null),p.localize(348,null),p.localize(349,null)],description:p.localize(350,null)})),tabIndex:Ue(new t(124,"tabIndex",0,-1,1073741824)),unicodeHighlight:Ue(new je),unusualLineTerminators:Ue(new a(126,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[p.localize(351,null),p.localize(352,null),p.localize(353,null)],description:p.localize(354,null)})),useShadowDOM:Ue(new s(127,"useShadowDOM",!0)),useTabStops:Ue(new s(128,"useTabStops",!0,{description:p.localize(355,null)})),wordBreak:Ue(new a(129,"wordBreak","normal",["normal","keepAll"],{markdownEnumDescriptions:[p.localize(356,null),p.localize(357,null)],description:p.localize(358,null)})),wordSegmenterLocales:Ue(new Be),wordSeparators:Ue(new i(131,"wordSeparators",A.$0s,{description:p.localize(359,null)})),wordWrap:Ue(new a(132,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[p.localize(360,null),p.localize(361,null),p.localize(362,null),p.localize(363,null)],description:p.localize(364,null)})),wordWrapBreakAfterCharacters:Ue(new i(133,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:Ue(new i(134,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:Ue(new t(135,"wordWrapColumn",80,1,1073741824,{markdownDescription:p.localize(365,null)})),wordWrapOverride1:Ue(new a(136,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:Ue(new a(137,"wordWrapOverride2","inherit",["off","on","inherit"])),editorClassName:Ue(new P),defaultColorDecorators:Ue(new s(147,"defaultColorDecorators",!1,{markdownDescription:p.localize(366,null)})),pixelRatio:Ue(new me),tabFocusMode:Ue(new s(144,"tabFocusMode",!1,{markdownDescription:p.localize(367,null)})),layoutInfo:Ue(new ge),wrappingInfo:Ue(new xe),wrappingIndent:Ue(new _e),wrappingStrategy:Ue(new ue)}}),define(Se[160],Ie([9,10]),function(le,e){return le.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Se[161],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/contextkey",e)}),define(Se[162],Ie([9,10]),function(le,e){return le.create("vs/platform/contextkey/common/scanner",e)}),define(Se[163],Ie([9,10]),function(le,e){return le.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Se[164],Ie([9,10]),function(le,e){return le.create("vs/platform/extensions/common/extensionValidator",e)}),define(Se[165],Ie([9,10]),function(le,e){return le.create("vs/platform/files/common/files",e)}),define(Se[166],Ie([9,10]),function(le,e){return le.create("vs/platform/log/common/log",e)}),define(Se[167],Ie([9,10]),function(le,e){return le.create("vs/platform/markers/common/markers",e)}),define(Se[168],Ie([9,10]),function(le,e){return le.create("vs/platform/request/common/request",e)}),define(Se[169],Ie([9,10]),function(le,e){return le.create("vs/platform/theme/common/iconRegistry",e)}),define(Se[170],Ie([9,10]),function(le,e){return le.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(Se[171],Ie([9,10]),function(le,e){return le.create("vs/platform/workspace/common/workspace",e)}),define(Se[172],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(Se[173],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostExtensionService",e)}),define(Se[174],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageFeatures",e)}),define(Se[175],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLanguageModels",e)}),define(Se[176],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostLogService",e)}),define(Se[177],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostNotebook",e)}),define(Se[178],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostStatusBar",e)}),define(Se[179],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTelemetry",e)}),define(Se[180],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTerminalService",e)}),define(Se[181],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTreeViews",e)}),define(Se[182],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostTunnelService",e)}),define(Se[183],Ie([9,10]),function(le,e){return le.create("vs/workbench/api/common/extHostWorkspace",e)}),define(Se[184],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/configuration",e)}),define(Se[185],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/editor",e)}),define(Se[186],Ie([9,10]),function(le,e){return le.create("vs/workbench/common/views",e)}),define(Se[187],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/chat/common/chatContextKeys",e)}),define(Se[188],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(Se[189],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/debug/common/debug",e)}),define(Se[190],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(Se[191],Ie([9,10]),function(le,e){return le.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(Se[192],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(Se[193],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/editor/common/editorResolverService",e)}),define(Se[194],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(Se[195],Ie([9,10]),function(le,e){return le.create("vs/workbench/services/search/common/queryBuilder",e)}),define(Se[196],Ie([1,0,14,162]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$tj=e.TokenType=void 0;var M;(function(D){D[D.LParen=0]="LParen",D[D.RParen=1]="RParen",D[D.Neg=2]="Neg",D[D.Eq=3]="Eq",D[D.NotEq=4]="NotEq",D[D.Lt=5]="Lt",D[D.LtEq=6]="LtEq",D[D.Gt=7]="Gt",D[D.GtEq=8]="GtEq",D[D.RegexOp=9]="RegexOp",D[D.RegexStr=10]="RegexStr",D[D.True=11]="True",D[D.False=12]="False",D[D.In=13]="In",D[D.Not=14]="Not",D[D.And=15]="And",D[D.Or=16]="Or",D[D.Str=17]="Str",D[D.QuotedStr=18]="QuotedStr",D[D.Error=19]="Error",D[D.EOF=20]="EOF"})(M||(e.TokenType=M={}));function T(...D){switch(D.length){case 1:return(0,N.localize)(0,null,D[0]);case 2:return(0,N.localize)(1,null,D[0],D[1]);case 3:return(0,N.localize)(2,null,D[0],D[1],D[2]);default:return}}const A=(0,N.localize)(3,null),p=(0,N.localize)(4,null);class m{constructor(){this.c="",this.d=0,this.e=0,this.f=[],this.g=[],this.m=/[a-zA-Z0-9_<>\-\./\\:\*\?\+\[\]\^,#@;"%\$\p{L}-]+/uy}static getLexeme(O){switch(O.type){case 0:return"(";case 1:return")";case 2:return"!";case 3:return O.isTripleEq?"===":"==";case 4:return O.isTripleEq?"!==":"!=";case 5:return"<";case 6:return"<=";case 7:return">=";case 8:return">=";case 9:return"=~";case 10:return O.lexeme;case 11:return"true";case 12:return"false";case 13:return"in";case 14:return"not";case 15:return"&&";case 16:return"||";case 17:return O.lexeme;case 18:return O.lexeme;case 19:return O.lexeme;case 20:return"EOF";default:throw(0,C.$8)(`unhandled token type: ${JSON.stringify(O)}; have you forgotten to add a case?`)}}static{this.a=new Set(["i","g","s","m","y","u"].map(O=>O.charCodeAt(0)))}static{this.b=new Map([["not",14],["in",13],["false",12],["true",11]])}get errors(){return this.g}reset(O){return this.c=O,this.d=0,this.e=0,this.f=[],this.g=[],this}scan(){for(;!this.r();)switch(this.d=this.e,this.i()){case 40:this.k(0);break;case 41:this.k(1);break;case 33:if(this.h(61)){const S=this.h(61);this.f.push({type:4,offset:this.d,isTripleEq:S})}else this.k(2);break;case 39:this.o();break;case 47:this.q();break;case 61:if(this.h(61)){const S=this.h(61);this.f.push({type:3,offset:this.d,isTripleEq:S})}else this.h(126)?this.k(9):this.l(T("==","=~"));break;case 60:this.k(this.h(61)?6:5);break;case 62:this.k(this.h(61)?8:7);break;case 38:this.h(38)?this.k(15):this.l(T("&&"));break;case 124:this.h(124)?this.k(16):this.l(T("||"));break;case 32:case 13:case 9:case 10:case 160:break;default:this.n()}return this.d=this.e,this.k(20),Array.from(this.f)}h(O){return this.r()||this.c.charCodeAt(this.e)!==O?!1:(this.e++,!0)}i(){return this.c.charCodeAt(this.e++)}j(){return this.r()?0:this.c.charCodeAt(this.e)}k(O){this.f.push({type:O,offset:this.d})}l(O){const S=this.d,d=this.c.substring(this.d,this.e),w={type:19,offset:this.d,lexeme:d};this.g.push({offset:S,lexeme:d,additionalInfo:O}),this.f.push(w)}n(){this.m.lastIndex=this.d;const O=this.m.exec(this.c);if(O){this.e=this.d+O[0].length;const S=this.c.substring(this.d,this.e),d=m.b.get(S);d?this.k(d):this.f.push({type:17,lexeme:S,offset:this.d})}}o(){for(;this.j()!==39&&!this.r();)this.i();if(this.r()){this.l(A);return}this.i(),this.f.push({type:18,lexeme:this.c.substring(this.d+1,this.e-1),offset:this.d+1})}q(){let O=this.e,S=!1,d=!1;for(;;){if(O>=this.c.length){this.e=O,this.l(p);return}const f=this.c.charCodeAt(O);if(S)S=!1;else if(f===47&&!d){O++;break}else f===91?d=!0:f===92?S=!0:f===93&&(d=!1);O++}for(;O<this.c.length&&m.a.has(this.c.charCodeAt(O));)O++;this.e=O;const w=this.c.substring(this.d,this.e);this.f.push({type:10,lexeme:w,offset:this.d})}r(){return this.e>=this.c.length}}e.$tj=m}),define(Se[197],Ie([1,0,24,32,164,311]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Kp=m,e.$Lp=D,e.$Mp=O,e.$Np=S,e.$Op=d,e.$Pp=w,e.$Qp=f;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function m(s){return s=s.trim(),s==="*"||A.test(s)}function D(s){if(!m(s))return null;if(s=s.trim(),s==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const n=s.match(A);return n?{hasCaret:n[1]==="^",hasGreaterEquals:n[1]===">=",majorBase:n[2]==="x"?0:parseInt(n[2],10),majorMustEqual:n[2]!=="x",minorBase:n[4]==="x"?0:parseInt(n[4],10),minorMustEqual:n[4]!=="x",patchBase:n[6]==="x"?0:parseInt(n[6],10),patchMustEqual:n[6]!=="x",preRelease:n[8]||null}:null}function O(s){if(!s)return null;const n=s.majorBase,t=s.majorMustEqual,c=s.minorBase;let u=s.minorMustEqual;const i=s.patchBase;let b=s.patchMustEqual;s.hasCaret&&(n===0||(u=!1),b=!1);let a=0;if(s.preRelease){const l=p.exec(s.preRelease);if(l){const[,g,$,v]=l;a=Date.UTC(Number(g),Number($)-1,Number(v))}}return{majorBase:n,majorMustEqual:t,minorBase:c,minorMustEqual:u,patchBase:i,patchMustEqual:b,isMinimum:s.hasGreaterEquals,notBefore:a}}function S(s,n,t){let c;typeof s=="string"?c=O(D(s)):c=s;let u;n instanceof Date?u=n.getTime():typeof n=="string"&&(u=new Date(n).getTime());let i;if(typeof t=="string"?i=O(D(t)):i=t,!c||!i)return!1;const b=c.majorBase,a=c.minorBase,l=c.patchBase;let g=i.majorBase,$=i.minorBase,v=i.patchBase;const y=i.notBefore;let h=i.majorMustEqual,E=i.minorMustEqual,k=i.patchMustEqual;return i.isMinimum?b>g?!0:b<g?!1:a>$?!0:a<$||u&&u<y?!1:l>=v:(b===1&&g===0&&(!h||!E||!k)&&(g=1,$=0,v=0,h=!0,E=!1,k=!1),b<g?!1:b>g?!h:a<$?!1:a>$?!E:l<v?!1:l>v?!k:!(u&&u<y))}function d(s,n,t,c,u){const i=[];if(typeof c.publisher<"u"&&typeof c.publisher!="string")return i.push([N.default.Error,M.localize(0,null)]),i;if(typeof c.name!="string")return i.push([N.default.Error,M.localize(1,null,"name")]),i;if(typeof c.version!="string")return i.push([N.default.Error,M.localize(2,null,"version")]),i;if(!c.engines)return i.push([N.default.Error,M.localize(3,null,"engines")]),i;if(typeof c.engines.vscode!="string")return i.push([N.default.Error,M.localize(4,null,"engines.vscode")]),i;if(typeof c.extensionDependencies<"u"&&!r(c.extensionDependencies))return i.push([N.default.Error,M.localize(5,null,"extensionDependencies")]),i;if(typeof c.activationEvents<"u"){if(!r(c.activationEvents))return i.push([N.default.Error,M.localize(6,null,"activationEvents")]),i;if(typeof c.main>"u"&&typeof c.browser>"u")return i.push([N.default.Error,M.localize(7,null,"activationEvents","main","browser")]),i}if(typeof c.extensionKind<"u"&&typeof c.main>"u"&&i.push([N.default.Warning,M.localize(8,null,"extensionKind")]),typeof c.main<"u"){if(typeof c.main!="string")return i.push([N.default.Error,M.localize(9,null,"main")]),i;{const l=(0,C.$_g)(t,c.main);(0,C.$6g)(l,t)||i.push([N.default.Warning,M.localize(10,null,l.path,t.path)])}}if(typeof c.browser<"u"){if(typeof c.browser!="string")return i.push([N.default.Error,M.localize(11,null,"browser")]),i;{const l=(0,C.$_g)(t,c.browser);(0,C.$6g)(l,t)||i.push([N.default.Warning,M.localize(12,null,l.path,t.path)])}}if(!T.valid(c.version))return i.push([N.default.Error,M.localize(13,null)]),i;const b=[];if(!w(s,n,c,u,b))for(const l of b)i.push([N.default.Error,l]);return i}function w(s,n,t,c,u){return c||typeof t.main>"u"&&typeof t.browser>"u"?!0:o(s,n,t.engines.vscode,u)}function f(s,n,t){return s==="*"||o(n,t,s)}function o(s,n,t,c=[]){const u=O(D(t));if(!u)return c.push(M.localize(14,null,t)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return c.push(M.localize(15,null,t)),!1}else if(!u.majorMustEqual)return c.push(M.localize(16,null,t)),!1;return S(s,n,u)?!0:(c.push(M.localize(17,null,s,t)),!1)}function r(s){if(!Array.isArray(s))return!1;for(let n=0,t=s.length;n<t;n++)if(typeof s[n]!="string")return!1;return!0}}),define(Se[71],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vi=void 0;class C{constructor(M,T=[],A=!1){this.ctor=M,this.staticArguments=T,this.supportsDelayedInstantiation=A}}e.$vi=C}),define(Se[56],Ie([1,0,71]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationType=void 0,e.$Cs=T,e.$Ds=A;const N=[];var M;(function(p){p[p.Eager=0]="Eager",p[p.Delayed=1]="Delayed"})(M||(e.InstantiationType=M={}));function T(p,m,D){m instanceof C.$vi||(m=new C.$vi(m,[],!!D)),N.push([p,m])}function A(){return N}}),define(Se[198],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gr=e.$fr=void 0;class C{constructor(T,A){this.key=T,this.data=A,this.incoming=new Map,this.outgoing=new Map}}e.$fr=C;class N{constructor(T){this.b=T,this.a=new Map}roots(){const T=[];for(const A of this.a.values())A.outgoing.size===0&&T.push(A);return T}insertEdge(T,A){const p=this.lookupOrInsertNode(T),m=this.lookupOrInsertNode(A);p.outgoing.set(m.key,m),m.incoming.set(p.key,p)}removeNode(T){const A=this.b(T);this.a.delete(A);for(const p of this.a.values())p.outgoing.delete(A),p.incoming.delete(A)}lookupOrInsertNode(T){const A=this.b(T);let p=this.a.get(A);return p||(p=new C(A,T),this.a.set(A,p)),p}lookup(T){return this.a.get(this.b(T))}isEmpty(){return this.a.size===0}toString(){const T=[];for(const[A,p]of this.a)T.push(`${A}
	(-> incoming)[${[...p.incoming.keys()].join(", ")}]
	(outgoing ->)[${[...p.outgoing.keys()].join(",")}]
`);return T.join(`
`)}findCycleSlow(){for(const[T,A]of this.a){const p=new Set([T]),m=this.c(A,p);if(m)return m}}c(T,A){for(const[p,m]of T.outgoing){if(A.has(p))return[...A,p].join(" -> ");A.add(p);const D=this.c(m,A);if(D)return D;A.delete(p)}}}e.$gr=N}),define(Se[3],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xi=e._util=void 0,e.$yi=M,e.$zi=T;var C;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function p(m){return m[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=p})(C||(e._util=C={})),e.$xi=M("instantiationService");function N(A,p,m){p[C.DI_TARGET]===p?p[C.DI_DEPENDENCIES].push({id:A,index:m}):(p[C.DI_DEPENDENCIES]=[{id:A,index:m}],p[C.DI_TARGET]=p)}function M(A){if(C.serviceIds.has(A))return C.serviceIds.get(A);const p=function(m,D,O){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");N(p,m,O)};return p.toString=()=>A,C.serviceIds.set(A,p),p}function T(A){return A}}),define(Se[50],Ie([1,0,15,2,3]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationTarget=e.$5i=void 0,e.$6i=T,e.$7i=A,e.$8i=m,e.$9i=D,e.$0i=O,e.$$i=S,e.$_i=d,e.$aj=f,e.$bj=o,e.$cj=r,e.$5i=(0,M.$yi)("configurationService");function T(s){return s&&typeof s=="object"&&(!s.overrideIdentifier||typeof s.overrideIdentifier=="string")&&(!s.resource||s.resource instanceof N.URI)}function A(s){return s&&typeof s=="object"&&(!s.overrideIdentifiers||Array.isArray(s.overrideIdentifiers))&&!s.overrideIdentifier&&(!s.resource||s.resource instanceof N.URI)}var p;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.USER=2]="USER",s[s.USER_LOCAL=3]="USER_LOCAL",s[s.USER_REMOTE=4]="USER_REMOTE",s[s.WORKSPACE=5]="WORKSPACE",s[s.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",s[s.DEFAULT=7]="DEFAULT",s[s.MEMORY=8]="MEMORY"})(p||(e.ConfigurationTarget=p={}));function m(s){switch(s){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}function D(s){return s.applicationValue!==void 0||s.userValue!==void 0||s.userLocalValue!==void 0||s.userRemoteValue!==void 0||s.workspaceValue!==void 0||s.workspaceFolderValue!==void 0}function O(s,n){const t=Object.create(null);for(const c in s)S(t,c,s[c],n);return t}function S(s,n,t,c){const u=n.split("."),i=u.pop();let b=s;for(let a=0;a<u.length;a++){const l=u[a];let g=b[l];switch(typeof g){case"undefined":g=b[l]=Object.create(null);break;case"object":if(g===null){c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is null`);return}break;default:c(`Ignoring ${n} as ${u.slice(0,a+1).join(".")} is ${JSON.stringify(g)}`);return}b=g}if(typeof b=="object"&&b!==null)try{b[i]=t}catch{c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(b)}`)}else c(`Ignoring ${n} as ${u.join(".")} is ${JSON.stringify(b)}`)}function d(s,n){const t=n.split(".");w(s,t)}function w(s,n){const t=n.shift();if(n.length===0){delete s[t];return}if(Object.keys(s).indexOf(t)!==-1){const c=s[t];typeof c=="object"&&!Array.isArray(c)&&(w(c,n),Object.keys(c).length===0&&delete s[t])}}function f(s,n,t){function c(b,a){let l=b;for(const g of a){if(typeof l!="object"||l===null)return;l=l[g]}return l}const u=n.split("."),i=c(s,u);return typeof i>"u"?t:i}function o(s,n,t){Object.keys(n).forEach(c=>{c!=="__proto__"&&(c in s?C.$ag(s[c])&&C.$ag(n[c])?o(s[c],n[c],t):t&&(s[c]=n[c]):s[c]=n[c])})}function r(s){return s.replace(/[\[\]]/g,"")}}),define(Se[31],Ie([1,0,23,13,196,3,161,14]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Qj=e.$Pj=e.$Oj=e.$Nj=e.$Mj=e.$Lj=e.$Kj=e.$Jj=e.$Ij=e.$Hj=e.$Gj=e.$Fj=e.$Ej=e.$Dj=e.$Cj=e.$Bj=e.$Aj=e.$zj=e.$wj=e.$vj=e.ContextKeyExprType=void 0,e.$uj=D,e.$xj=b,e.$yj=a,e.$Rj=Ce;const m=new Map;m.set("false",!1),m.set("true",!0),m.set("isMac",C.$j),m.set("isLinux",C.$k),m.set("isWindows",C.$i),m.set("isWeb",C.$o),m.set("isMacNative",C.$j&&!C.$o),m.set("isEdge",C.$H),m.set("isFirefox",C.$F),m.set("isChrome",C.$E),m.set("isSafari",C.$G);function D(ne,U){if(m.get(ne)!==void 0)throw(0,p.$7)("contextkey.setConstant(k, v) invoked with already set constant `k`");m.set(ne,U)}const O=Object.prototype.hasOwnProperty;var S;(function(ne){ne[ne.False=0]="False",ne[ne.True=1]="True",ne[ne.Defined=2]="Defined",ne[ne.Not=3]="Not",ne[ne.Equals=4]="Equals",ne[ne.NotEquals=5]="NotEquals",ne[ne.And=6]="And",ne[ne.Regex=7]="Regex",ne[ne.NotRegex=8]="NotRegex",ne[ne.Or=9]="Or",ne[ne.In=10]="In",ne[ne.NotIn=11]="NotIn",ne[ne.Greater=12]="Greater",ne[ne.GreaterEquals=13]="GreaterEquals",ne[ne.Smaller=14]="Smaller",ne[ne.SmallerEquals=15]="SmallerEquals"})(S||(e.ContextKeyExprType=S={}));const d={regexParsingWithErrorRecovery:!0},w=(0,A.localize)(0,null),f=(0,A.localize)(1,null),o=(0,A.localize)(2,null),r=(0,A.localize)(3,null),s=(0,A.localize)(4,null),n=(0,A.localize)(5,null),t=(0,A.localize)(6,null),c=(0,A.localize)(7,null);class u{static{this.c=new Error}get lexingErrors(){return this.d.errors}get parsingErrors(){return this.h}constructor(U=d){this.k=U,this.d=new M.$tj,this.f=[],this.g=0,this.h=[],this.v=/g|y/g}parse(U){if(U===""){this.h.push({message:w,offset:0,lexeme:"",additionalInfo:f});return}this.f=this.d.reset(U).scan(),this.g=0,this.h=[];try{const x=this.l();if(!this.E()){const ve=this.D(),Le=ve.type===17?n:void 0;throw this.h.push({message:s,offset:ve.offset,lexeme:M.$tj.getLexeme(ve),additionalInfo:Le}),u.c}return x}catch(x){if(x!==u.c)throw x;return}}l(){return this.m()}m(){const U=[this.o()];for(;this.y(16);){const x=this.o();U.push(x)}return U.length===1?U[0]:i.or(...U)}o(){const U=[this.s()];for(;this.y(15);){const x=this.s();U.push(x)}return U.length===1?U[0]:i.and(...U)}s(){if(this.y(2)){const U=this.D();switch(U.type){case 11:return this.z(),g.INSTANCE;case 12:return this.z(),$.INSTANCE;case 0:{this.z();const x=this.l();return this.A(1,r),x?.negate()}case 17:return this.z(),I.create(U.lexeme);default:throw this.B("KEY | true | false | '(' expression ')'",U)}}return this.t()}t(){const U=this.D();switch(U.type){case 11:return this.z(),i.true();case 12:return this.z(),i.false();case 0:{this.z();const x=this.l();return this.A(1,r),x}case 17:{const x=U.lexeme;if(this.z(),this.y(9)){const Le=this.D();if(!this.k.regexParsingWithErrorRecovery){if(this.z(),Le.type!==10)throw this.B("REGEX",Le);const ke=Le.lexeme,be=ke.lastIndexOf("/"),me=be===ke.length-1?void 0:this.w(ke.substring(be+1));let Q;try{Q=new RegExp(ke.substring(1,be),me)}catch{throw this.B("REGEX",Le)}return z.create(x,Q)}switch(Le.type){case 10:case 19:{const ke=[Le.lexeme];this.z();let be=this.D(),me=0;for(let Te=0;Te<Le.lexeme.length;Te++)Le.lexeme.charCodeAt(Te)===40?me++:Le.lexeme.charCodeAt(Te)===41&&me--;for(;!this.E()&&be.type!==15&&be.type!==16;){switch(be.type){case 0:me++;break;case 1:me--;break;case 10:case 18:for(let Te=0;Te<be.lexeme.length;Te++)be.lexeme.charCodeAt(Te)===40?me++:Le.lexeme.charCodeAt(Te)===41&&me--}if(me<0)break;ke.push(M.$tj.getLexeme(be)),this.z(),be=this.D()}const Q=ke.join(""),Y=Q.lastIndexOf("/"),he=Y===Q.length-1?void 0:this.w(Q.substring(Y+1));let ce;try{ce=new RegExp(Q.substring(1,Y),he)}catch{throw this.B("REGEX",Le)}return i.regex(x,ce)}case 18:{const ke=Le.lexeme;this.z();let be=null;if(!(0,N.$9e)(ke)){const me=ke.indexOf("/"),Q=ke.lastIndexOf("/");if(me!==Q&&me>=0){const Y=ke.slice(me+1,Q),he=ke[Q+1]==="i"?"i":"";try{be=new RegExp(Y,he)}catch{throw this.B("REGEX",Le)}}}if(be===null)throw this.B("REGEX",Le);return z.create(x,be)}default:throw this.B("REGEX",this.D())}}if(this.y(14)){this.A(13,o);const Le=this.u();return i.notIn(x,Le)}switch(this.D().type){case 3:{this.z();const Le=this.u();if(this.x().type===18)return i.equals(x,Le);switch(Le){case"true":return i.has(x);case"false":return i.not(x);default:return i.equals(x,Le)}}case 4:{this.z();const Le=this.u();if(this.x().type===18)return i.notEquals(x,Le);switch(Le){case"true":return i.not(x);case"false":return i.has(x);default:return i.notEquals(x,Le)}}case 5:return this.z(),q.create(x,this.u());case 6:return this.z(),R.create(x,this.u());case 7:return this.z(),V.create(x,this.u());case 8:return this.z(),W.create(x,this.u());case 13:return this.z(),i.in(x,this.u());default:return i.has(x)}}case 20:throw this.h.push({message:t,offset:U.offset,lexeme:"",additionalInfo:c}),u.c;default:throw this.B(`true | false | KEY 
	| KEY '=~' REGEX 
	| KEY ('==' | '!=' | '<' | '<=' | '>' | '>=' | 'in' | 'not' 'in') value`,this.D())}}u(){const U=this.D();switch(U.type){case 17:case 18:return this.z(),U.lexeme;case 11:return this.z(),"true";case 12:return this.z(),"false";case 13:return this.z(),"in";default:return""}}w(U){return U.replaceAll(this.v,"")}x(){return this.f[this.g-1]}y(U){return this.C(U)?(this.z(),!0):!1}z(){return this.E()||this.g++,this.x()}A(U,x){if(this.C(U))return this.z();throw this.B(x,this.D())}B(U,x,ve){const Le=(0,A.localize)(8,null,U,M.$tj.getLexeme(x)),ke=x.offset,be=M.$tj.getLexeme(x);return this.h.push({message:Le,offset:ke,lexeme:be,additionalInfo:ve}),u.c}C(U){return this.D().type===U}D(){return this.f[this.g]}E(){return this.D().type===20}}e.$vj=u;class i{static false(){return g.INSTANCE}static true(){return $.INSTANCE}static has(U){return v.create(U)}static equals(U,x){return y.create(U,x)}static notEquals(U,x){return k.create(U,x)}static regex(U,x){return z.create(U,x)}static in(U,x){return h.create(U,x)}static notIn(U,x){return E.create(U,x)}static not(U){return I.create(U)}static and(...U){return de.create(U,null,!0)}static or(...U){return ye.create(U,null,!0)}static greater(U,x){return V.create(U,x)}static greaterEquals(U,x){return W.create(U,x)}static smaller(U,x){return q.create(U,x)}static smallerEquals(U,x){return R.create(U,x)}static{this.c=new u({regexParsingWithErrorRecovery:!1})}static deserialize(U){return U==null?void 0:this.c.parse(U)}}e.$wj=i;function b(ne){const U=new u({regexParsingWithErrorRecovery:!1});return ne.map(x=>(U.parse(x),U.lexingErrors.length>0?U.lexingErrors.map(ve=>({errorMessage:ve.additionalInfo?(0,A.localize)(9,null,ve.additionalInfo):(0,A.localize)(10,null),offset:ve.offset,length:ve.lexeme.length})):U.parsingErrors.length>0?U.parsingErrors.map(ve=>({errorMessage:ve.additionalInfo?`${ve.message}. ${ve.additionalInfo}`:ve.message,offset:ve.offset,length:ve.lexeme.length})):[]))}function a(ne,U){const x=ne?ne.substituteConstants():void 0,ve=U?U.substituteConstants():void 0;return!x&&!ve?!0:!x||!ve?!1:x.equals(ve)}function l(ne,U){return ne.cmp(U)}class g{static{this.INSTANCE=new g}constructor(){this.type=0}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!1}serialize(){return"false"}keys(){return[]}map(U){return this}negate(){return $.INSTANCE}}e.$zj=g;class ${static{this.INSTANCE=new $}constructor(){this.type=1}cmp(U){return this.type-U.type}equals(U){return U.type===this.type}substituteConstants(){return this}evaluate(U){return!0}serialize(){return"true"}keys(){return[]}map(U){return this}negate(){return g.INSTANCE}}e.$Aj=$;class v{static create(U,x=null){const ve=m.get(U);return typeof ve=="boolean"?ve?$.INSTANCE:g.INSTANCE:new v(U,x)}constructor(U,x){this.key=U,this.c=x,this.type=2}cmp(U){return U.type!==this.type?this.type-U.type:ge(this.key,U.key)}equals(U){return U.type===this.type?this.key===U.key:!1}substituteConstants(){const U=m.get(this.key);return typeof U=="boolean"?U?$.INSTANCE:g.INSTANCE:this}evaluate(U){return!!U.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(U){return U.mapDefined(this.key)}negate(){return this.c||(this.c=I.create(this.key,this)),this.c}}e.$Bj=v;class y{static create(U,x,ve=null){if(typeof x=="boolean")return x?v.create(U,ve):I.create(U,ve);const Le=m.get(U);return typeof Le=="boolean"?x===(Le?"true":"false")?$.INSTANCE:g.INSTANCE:new y(U,x,ve)}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=4}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?$.INSTANCE:g.INSTANCE}return this}evaluate(U){return U.getValue(this.c)==this.d}serialize(){return`${this.c} == '${this.d}'`}keys(){return[this.c]}map(U){return U.mapEquals(this.c,this.d)}negate(){return this.f||(this.f=k.create(this.c,this.d,this)),this.f}}e.$Cj=y;class h{static create(U,x){return new h(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=10,this.c=null}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.d,this.f,U.d,U.f)}equals(U){return U.type===this.type?this.d===U.d&&this.f===U.f:!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.f),ve=U.getValue(this.d);return Array.isArray(x)?x.includes(ve):typeof ve=="string"&&typeof x=="object"&&x!==null?O.call(x,ve):!1}serialize(){return`${this.d} in '${this.f}'`}keys(){return[this.d,this.f]}map(U){return U.mapIn(this.d,this.f)}negate(){return this.c||(this.c=E.create(this.d,this.f)),this.c}}e.$Dj=h;class E{static create(U,x){return new E(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=11,this.c=h.create(U,x)}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`${this.d} not in '${this.f}'`}keys(){return this.c.keys()}map(U){return U.mapNotIn(this.d,this.f)}negate(){return this.c}}e.$Ej=E;class k{static create(U,x,ve=null){if(typeof x=="boolean")return x?I.create(U,ve):v.create(U,ve);const Le=m.get(U);return typeof Le=="boolean"?x===(Le?"true":"false")?g.INSTANCE:$.INSTANCE:new k(U,x,ve)}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=5}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){const U=m.get(this.c);if(typeof U=="boolean"){const x=U?"true":"false";return this.d===x?g.INSTANCE:$.INSTANCE}return this}evaluate(U){return U.getValue(this.c)!=this.d}serialize(){return`${this.c} != '${this.d}'`}keys(){return[this.c]}map(U){return U.mapNotEquals(this.c,this.d)}negate(){return this.f||(this.f=y.create(this.c,this.d,this)),this.f}}e.$Fj=k;class I{static create(U,x=null){const ve=m.get(U);return typeof ve=="boolean"?ve?g.INSTANCE:$.INSTANCE:new I(U,x)}constructor(U,x){this.c=U,this.d=x,this.type=3}cmp(U){return U.type!==this.type?this.type-U.type:ge(this.c,U.c)}equals(U){return U.type===this.type?this.c===U.c:!1}substituteConstants(){const U=m.get(this.c);return typeof U=="boolean"?U?g.INSTANCE:$.INSTANCE:this}evaluate(U){return!U.getValue(this.c)}serialize(){return`!${this.c}`}keys(){return[this.c]}map(U){return U.mapNot(this.c)}negate(){return this.d||(this.d=v.create(this.c,this)),this.d}}e.$Gj=I;function P(ne,U){if(typeof ne=="string"){const x=parseFloat(ne);isNaN(x)||(ne=x)}return typeof ne=="string"||typeof ne=="number"?U(ne):g.INSTANCE}class V{static create(U,x,ve=null){return P(x,Le=>new V(U,Le,ve))}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=12}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>this.d}serialize(){return`${this.c} > ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreater(this.c,this.d)}negate(){return this.f||(this.f=R.create(this.c,this.d,this)),this.f}}e.$Hj=V;class W{static create(U,x,ve=null){return P(x,Le=>new W(U,Le,ve))}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=13}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))>=this.d}serialize(){return`${this.c} >= ${this.d}`}keys(){return[this.c]}map(U){return U.mapGreaterEquals(this.c,this.d)}negate(){return this.f||(this.f=q.create(this.c,this.d,this)),this.f}}e.$Ij=W;class q{static create(U,x,ve=null){return P(x,Le=>new q(U,Le,ve))}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=14}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<this.d}serialize(){return`${this.c} < ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmaller(this.c,this.d)}negate(){return this.f||(this.f=W.create(this.c,this.d,this)),this.f}}e.$Jj=q;class R{static create(U,x,ve=null){return P(x,Le=>new R(U,Le,ve))}constructor(U,x,ve){this.c=U,this.d=x,this.f=ve,this.type=15}cmp(U){return U.type!==this.type?this.type-U.type:ue(this.c,this.d,U.c,U.d)}equals(U){return U.type===this.type?this.c===U.c&&this.d===U.d:!1}substituteConstants(){return this}evaluate(U){return typeof this.d=="string"?!1:parseFloat(U.getValue(this.c))<=this.d}serialize(){return`${this.c} <= ${this.d}`}keys(){return[this.c]}map(U){return U.mapSmallerEquals(this.c,this.d)}negate(){return this.f||(this.f=V.create(this.c,this.d,this)),this.f}}e.$Kj=R;class z{static create(U,x){return new z(U,x)}constructor(U,x){this.d=U,this.f=x,this.type=7,this.c=null}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.d<U.d)return-1;if(this.d>U.d)return 1;const x=this.f?this.f.source:"",ve=U.f?U.f.source:"";return x<ve?-1:x>ve?1:0}equals(U){if(U.type===this.type){const x=this.f?this.f.source:"",ve=U.f?U.f.source:"";return this.d===U.d&&x===ve}return!1}substituteConstants(){return this}evaluate(U){const x=U.getValue(this.d);return this.f?this.f.test(x):!1}serialize(){const U=this.f?`/${this.f.source}/${this.f.flags}`:"/invalid/";return`${this.d} =~ ${U}`}keys(){return[this.d]}map(U){return U.mapRegex(this.d,this.f)}negate(){return this.c||(this.c=K.create(this)),this.c}}e.$Lj=z;class K{static create(U){return new K(U)}constructor(U){this.c=U,this.type=8}cmp(U){return U.type!==this.type?this.type-U.type:this.c.cmp(U.c)}equals(U){return U.type===this.type?this.c.equals(U.c):!1}substituteConstants(){return this}evaluate(U){return!this.c.evaluate(U)}serialize(){return`!(${this.c.serialize()})`}keys(){return this.c.keys()}map(U){return new K(this.c.map(U))}negate(){return this.c}}e.$Mj=K;function ie(ne){let U=null;for(let x=0,ve=ne.length;x<ve;x++){const Le=ne[x].substituteConstants();if(ne[x]!==Le&&U===null){U=[];for(let ke=0;ke<x;ke++)U[ke]=ne[ke]}U!==null&&(U[x]=Le)}return U===null?ne:U}class de{static create(U,x,ve){return de.d(U,x,ve)}constructor(U,x){this.expr=U,this.c=x,this.type=6}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Le=l(this.expr[x],U.expr[x]);if(Le!==0)return Le}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:de.create(U,this.c,!1)}evaluate(U){for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].evaluate(U))return!1;return!0}static d(U,x,ve){const Le=[];let ke=!1;for(const be of U)if(be){if(be.type===1){ke=!0;continue}if(be.type===0)return g.INSTANCE;if(be.type===6){Le.push(...be.expr);continue}Le.push(be)}if(Le.length===0&&ke)return $.INSTANCE;if(Le.length!==0){if(Le.length===1)return Le[0];Le.sort(l);for(let be=1;be<Le.length;be++)Le[be-1].equals(Le[be])&&(Le.splice(be,1),be--);if(Le.length===1)return Le[0];for(;Le.length>1;){const be=Le[Le.length-1];if(be.type!==9)break;Le.pop();const me=Le.pop(),Q=Le.length===0,Y=ye.create(be.expr.map(he=>de.create([he,me],null,ve)),null,Q);Y&&(Le.push(Y),Le.sort(l))}if(Le.length===1)return Le[0];if(ve){for(let be=0;be<Le.length;be++)for(let me=be+1;me<Le.length;me++)if(Le[be].negate().equals(Le[me]))return g.INSTANCE;if(Le.length===1)return Le[0]}return new de(Le,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" && ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new de(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());this.c=ye.create(U,this,!0)}return this.c}}e.$Nj=de;class ye{static create(U,x,ve){return ye.d(U,x,ve)}constructor(U,x){this.expr=U,this.c=x,this.type=9}cmp(U){if(U.type!==this.type)return this.type-U.type;if(this.expr.length<U.expr.length)return-1;if(this.expr.length>U.expr.length)return 1;for(let x=0,ve=this.expr.length;x<ve;x++){const Le=l(this.expr[x],U.expr[x]);if(Le!==0)return Le}return 0}equals(U){if(U.type===this.type){if(this.expr.length!==U.expr.length)return!1;for(let x=0,ve=this.expr.length;x<ve;x++)if(!this.expr[x].equals(U.expr[x]))return!1;return!0}return!1}substituteConstants(){const U=ie(this.expr);return U===this.expr?this:ye.create(U,this.c,!1)}evaluate(U){for(let x=0,ve=this.expr.length;x<ve;x++)if(this.expr[x].evaluate(U))return!0;return!1}static d(U,x,ve){let Le=[],ke=!1;if(U){for(let be=0,me=U.length;be<me;be++){const Q=U[be];if(Q){if(Q.type===0){ke=!0;continue}if(Q.type===1)return $.INSTANCE;if(Q.type===9){Le=Le.concat(Q.expr);continue}Le.push(Q)}}if(Le.length===0&&ke)return g.INSTANCE;Le.sort(l)}if(Le.length!==0){if(Le.length===1)return Le[0];for(let be=1;be<Le.length;be++)Le[be-1].equals(Le[be])&&(Le.splice(be,1),be--);if(Le.length===1)return Le[0];if(ve){for(let be=0;be<Le.length;be++)for(let me=be+1;me<Le.length;me++)if(Le[be].negate().equals(Le[me]))return $.INSTANCE;if(Le.length===1)return Le[0]}return new ye(Le,x)}}serialize(){return this.expr.map(U=>U.serialize()).join(" || ")}keys(){const U=[];for(const x of this.expr)U.push(...x.keys());return U}map(U){return new ye(this.expr.map(x=>x.map(U)),null)}negate(){if(!this.c){const U=[];for(const x of this.expr)U.push(x.negate());for(;U.length>1;){const x=U.shift(),ve=U.shift(),Le=[];for(const ke of Ne(x))for(const be of Ne(ve))Le.push(de.create([ke,be],null,!1));U.unshift(ye.create(Le,null,!1))}this.c=ye.create(U,this,!0)}return this.c}}e.$Oj=ye;class De extends v{static{this.d=[]}static all(){return De.d.values()}constructor(U,x,ve){super(U,null),this.f=x,typeof ve=="object"?De.d.push({...ve,key:U}):ve!==!0&&De.d.push({key:U,description:ve,type:x!=null?typeof x:void 0})}bindTo(U){return U.createKey(this.key,this.f)}getValue(U){return U.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(U){return y.create(this.key,U)}notEqualsTo(U){return k.create(this.key,U)}}e.$Pj=De,e.$Qj=(0,T.$yi)("contextKeyService");function ge(ne,U){return ne<U?-1:ne>U?1:0}function ue(ne,U,x,ve){return ne<x?-1:ne>x?1:U<ve?-1:U>ve?1:0}function Ce(ne,U){if(ne.type===0||U.type===1)return!0;if(ne.type===9)return U.type===9?se(ne.expr,U.expr):!1;if(U.type===9){for(const x of U.expr)if(Ce(ne,x))return!0;return!1}if(ne.type===6){if(U.type===6)return se(U.expr,ne.expr);for(const x of ne.expr)if(Ce(x,U))return!0;return!1}return ne.equals(U)}function se(ne,U){let x=0,ve=0;for(;x<ne.length&&ve<U.length;){const Le=ne[x].cmp(U[ve]);if(Le<0)return!1;Le===0&&x++,ve++}return x===ne.length}function Ne(ne){return ne.type===9?ne.expr:[ne]}}),define(Se[99],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gi=e.$Fi=void 0,e.$Fi=(0,C.$yi)("environmentService"),e.$Gi=(0,C.$zi)(e.$Fi)}),define(Se[100],Ie([1,0,163,3]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gp=e.$fp=e.$ep=e.$dp=e.$cp=e.$bp=e.$ap=e.$_o=e.ExtensionManagementErrorCode=e.$$o=e.ExtensionGalleryErrorCode=e.$0o=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.ExtensionInstallSource=e.$3o=e.$2o=e.$1o=e.$Zo=e.$Yo=e.$Xo=e.$Wo=void 0,e.$4o=T,e.$5o=A,e.$6o=p,e.$7o=m,e.$8o=D,e.$9o=O,e.$Wo="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.$Xo=new RegExp(e.$Wo),e.$Yo="__web_extension",e.$Zo="skipWalkthrough",e.$1o="extensionInstallSource",e.$2o="dependecyOrPackExtensionInstall",e.$3o="clientTargetPlatform";var M;(function(t){t.COMMAND="command",t.SETTINGS_SYNC="settingsSync"})(M||(e.ExtensionInstallSource=M={}));function T(t){switch(t){case"win32-x64":return"Windows 64 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}function A(t){switch(t){case"win32-x64":return"win32-x64";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}function p(t,c){switch(t){case 3:return c==="x64"?"win32-x64":c==="arm64"?"win32-arm64":"unknown";case 2:return c==="x64"?"linux-x64":c==="arm64"?"linux-arm64":c==="arm"?"linux-armhf":"unknown";case"alpine":return c==="x64"?"alpine-x64":c==="arm64"?"alpine-arm64":"unknown";case 1:return c==="x64"?"darwin-x64":c==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}function m(t,c){return c==="web"&&!t.includes("web")}function D(t,c,u){return m(c,u)?!1:t==="undefined"||t==="universal"?!0:t==="unknown"?!1:t===u}function O(t){return t&&typeof t=="object"&&typeof t.id=="string"&&(!t.uuid||typeof t.uuid=="string")}var S;(function(t){t[t.NoneOrRelevance=0]="NoneOrRelevance",t[t.LastUpdatedDate=1]="LastUpdatedDate",t[t.Title=2]="Title",t[t.PublisherName=3]="PublisherName",t[t.InstallCount=4]="InstallCount",t[t.PublishedDate=10]="PublishedDate",t[t.AverageRating=6]="AverageRating",t[t.WeightedRating=12]="WeightedRating"})(S||(e.SortBy=S={}));var d;(function(t){t[t.Default=0]="Default",t[t.Ascending=1]="Ascending",t[t.Descending=2]="Descending"})(d||(e.SortOrder=d={}));var w;(function(t){t.Install="install",t.Uninstall="uninstall"})(w||(e.StatisticType=w={}));var f;(function(t){t[t.None=1]="None",t[t.Install=2]="Install",t[t.Update=3]="Update",t[t.Migrate=4]="Migrate"})(f||(e.InstallOperation=f={})),e.$0o=(0,N.$yi)("extensionGalleryService");var o;(function(t){t.Timeout="Timeout",t.Cancelled="Cancelled",t.Failed="Failed",t.DownloadFailedWriting="DownloadFailedWriting"})(o||(e.ExtensionGalleryErrorCode=o={}));class r extends Error{constructor(c,u){super(c),this.code=u,this.name=u}}e.$$o=r;var s;(function(t){t.Unsupported="Unsupported",t.Deprecated="Deprecated",t.Malicious="Malicious",t.Incompatible="Incompatible",t.IncompatibleTargetPlatform="IncompatibleTargetPlatform",t.ReleaseVersionNotFound="ReleaseVersionNotFound",t.Invalid="Invalid",t.Download="Download",t.DownloadSignature="DownloadSignature",t.DownloadFailedWriting="DownloadFailedWriting",t.UpdateMetadata="UpdateMetadata",t.Extract="Extract",t.Scanning="Scanning",t.ScanningExtension="ScanningExtension",t.ReadUninstalled="ReadUninstalled",t.UnsetUninstalled="UnsetUninstalled",t.Delete="Delete",t.Rename="Rename",t.IntializeDefaultProfile="IntializeDefaultProfile",t.AddToProfile="AddToProfile",t.PostInstall="PostInstall",t.CorruptZip="CorruptZip",t.IncompleteZip="IncompleteZip",t.Signature="Signature",t.NotAllowed="NotAllowed",t.Gallery="Gallery",t.Cancelled="Cancelled",t.Unknown="Unknown",t.Internal="Internal"})(s||(e.ExtensionManagementErrorCode=s={}));class n extends Error{constructor(c,u){super(c),this.code=u,this.name=u}}e.$_o=n,e.$ap=(0,N.$yi)("extensionManagementService"),e.$bp="extensionsIdentifiers/disabled",e.$cp="extensionsIdentifiers/enabled",e.$dp=(0,N.$yi)("IGlobalExtensionEnablementService"),e.$ep=(0,N.$yi)("IExtensionTipsService"),e.$fp=(0,C.localize2)(0,"Extensions"),e.$gp=(0,C.localize2)(1,"Preferences")}),define(Se[38],Ie([1,0,54,19,13,15,2,165,3,23,16,43]),function(le,e,C,N,M,T,A,p,m,D,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Al=e.$xl=e.FileKind=e.$wl=e.$vl=e.$ul=e.$tl=e.$sl=e.$rl=e.$ql=e.FileOperationResult=e.$pl=e.$ol=e.$nl=e.$ll=e.FileChangeType=e.$kl=e.FileOperation=e.$el=e.FileSystemProviderErrorCode=e.FileSystemProviderCapabilities=e.FileChangeFilter=e.FilePermission=e.FileType=e.$5k=void 0,e.$6k=d,e.$7k=r,e.$8k=n,e.$9k=t,e.$0k=c,e.$$k=u,e.$_k=i,e.$al=b,e.$bl=a,e.$cl=l,e.$dl=g,e.$fl=y,e.$gl=h,e.$hl=E,e.$il=k,e.$jl=I,e.$ml=R,e.$yl=De,e.$zl=ge,e.$Bl=Ce,e.$5k=(0,m.$yi)("fileService");function d(se){return se.create===!0}var w;(function(se){se[se.Unknown=0]="Unknown",se[se.File=1]="File",se[se.Directory=2]="Directory",se[se.SymbolicLink=64]="SymbolicLink"})(w||(e.FileType=w={}));var f;(function(se){se[se.Readonly=1]="Readonly",se[se.Locked=2]="Locked"})(f||(e.FilePermission=f={}));var o;(function(se){se[se.UPDATED=2]="UPDATED",se[se.ADDED=4]="ADDED",se[se.DELETED=8]="DELETED"})(o||(e.FileChangeFilter=o={}));function r(se){const Ne=se;return!!Ne&&typeof Ne.onDidChange=="function"}var s;(function(se){se[se.None=0]="None",se[se.FileReadWrite=2]="FileReadWrite",se[se.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",se[se.FileReadStream=16]="FileReadStream",se[se.FileFolderCopy=8]="FileFolderCopy",se[se.PathCaseSensitive=1024]="PathCaseSensitive",se[se.Readonly=2048]="Readonly",se[se.Trash=4096]="Trash",se[se.FileWriteUnlock=8192]="FileWriteUnlock",se[se.FileAtomicRead=16384]="FileAtomicRead",se[se.FileAtomicWrite=32768]="FileAtomicWrite",se[se.FileAtomicDelete=65536]="FileAtomicDelete",se[se.FileClone=131072]="FileClone"})(s||(e.FileSystemProviderCapabilities=s={}));function n(se){return!!(se.capabilities&2)}function t(se){return!!(se.capabilities&8)}function c(se){return!!(se.capabilities&131072)}function u(se){return!!(se.capabilities&4)}function i(se){return!!(se.capabilities&16)}function b(se){return n(se)?!!(se.capabilities&16384):!1}function a(se){return n(se)?!!(se.capabilities&32768):!1}function l(se){return!!(se.capabilities&65536)}function g(se){return!!(se.capabilities&2048)}var $;(function(se){se.FileExists="EntryExists",se.FileNotFound="EntryNotFound",se.FileNotADirectory="EntryNotADirectory",se.FileIsADirectory="EntryIsADirectory",se.FileExceedsStorageQuota="EntryExceedsStorageQuota",se.FileTooLarge="EntryTooLarge",se.FileWriteLocked="EntryWriteLocked",se.NoPermissions="NoPermissions",se.Unavailable="Unavailable",se.Unknown="Unknown"})($||(e.FileSystemProviderErrorCode=$={}));class v extends Error{static create(Ne,ne){const U=new v(Ne.toString(),ne);return E(U,ne),U}constructor(Ne,ne){super(Ne),this.code=ne}}e.$el=v;function y(se,Ne){return v.create(se,Ne)}function h(se){return se||y((0,p.localize)(0,null),$.Unknown)}function E(se,Ne){return se.name=Ne?`${Ne} (FileSystemError)`:"FileSystemError",se}function k(se){if(!se)return $.Unknown;if(se instanceof v)return se.code;const Ne=/^(.+) \(FileSystemError\)$/.exec(se.name);if(!Ne)return $.Unknown;switch(Ne[1]){case $.FileExists:return $.FileExists;case $.FileIsADirectory:return $.FileIsADirectory;case $.FileNotADirectory:return $.FileNotADirectory;case $.FileNotFound:return $.FileNotFound;case $.FileTooLarge:return $.FileTooLarge;case $.FileWriteLocked:return $.FileWriteLocked;case $.NoPermissions:return $.NoPermissions;case $.Unavailable:return $.Unavailable}return $.Unknown}function I(se){if(se instanceof z)return se.fileOperationResult;switch(k(se)){case $.FileNotFound:return 1;case $.FileIsADirectory:return 0;case $.FileNotADirectory:return 9;case $.FileWriteLocked:return 5;case $.NoPermissions:return 6;case $.FileExists:return 4;case $.FileTooLarge:return 7;default:return 10}}var P;(function(se){se[se.CREATE=0]="CREATE",se[se.DELETE=1]="DELETE",se[se.MOVE=2]="MOVE",se[se.COPY=3]="COPY",se[se.WRITE=4]="WRITE"})(P||(e.FileOperation=P={}));class V{constructor(Ne,ne,U){this.resource=Ne,this.operation=ne,this.target=U}isOperation(Ne){return this.operation===Ne}}e.$kl=V;var W;(function(se){se[se.UPDATED=0]="UPDATED",se[se.ADDED=1]="ADDED",se[se.DELETED=2]="DELETED"})(W||(e.FileChangeType=W={}));class q{static{this.a=null}constructor(Ne,ne){this.c=ne,this.b=void 0,this.d=new S.$V(()=>{const U=C.$Ei.forUris(()=>this.c);return U.fill(this.rawAdded.map(x=>[x,!0])),U}),this.f=new S.$V(()=>{const U=C.$Ei.forUris(()=>this.c);return U.fill(this.rawUpdated.map(x=>[x,!0])),U}),this.g=new S.$V(()=>{const U=C.$Ei.forUris(()=>this.c);return U.fill(this.rawDeleted.map(x=>[x,!0])),U}),this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[];for(const U of Ne){switch(U.type){case 1:this.rawAdded.push(U.resource);break;case 0:this.rawUpdated.push(U.resource);break;case 2:this.rawDeleted.push(U.resource);break}this.b!==q.a&&(typeof U.cId=="number"?this.b===void 0?this.b=U.cId:this.b!==U.cId&&(this.b=q.a):this.b!==void 0&&(this.b=q.a))}}contains(Ne,...ne){return this.h(Ne,{includeChildren:!1},...ne)}affects(Ne,...ne){return this.h(Ne,{includeChildren:!0},...ne)}h(Ne,ne,...U){if(!Ne)return!1;const x=U.length>0;return!!((!x||U.includes(1))&&(this.d.value.get(Ne)||ne.includeChildren&&this.d.value.findSuperstr(Ne))||(!x||U.includes(0))&&(this.f.value.get(Ne)||ne.includeChildren&&this.f.value.findSuperstr(Ne))||(!x||U.includes(2))&&(this.g.value.findSubstr(Ne)||ne.includeChildren&&this.g.value.findSuperstr(Ne)))}gotAdded(){return this.rawAdded.length>0}gotDeleted(){return this.rawDeleted.length>0}gotUpdated(){return this.rawUpdated.length>0}correlates(Ne){return this.b===Ne}hasCorrelation(){return typeof this.b=="number"}}e.$ll=q;function R(se,Ne,ne){return!se||!Ne||se===Ne||Ne.length>se.length?!1:(Ne.charAt(Ne.length-1)!==N.sep&&(Ne+=N.sep),ne?(0,M.$Af)(se,Ne):se.indexOf(Ne)===0)}class z extends Error{constructor(Ne,ne,U){super(Ne),this.fileOperationResult=ne,this.options=U}}e.$nl=z;class K extends z{constructor(Ne,ne,U,x){super(Ne,ne,x),this.fileOperationResult=ne,this.size=U}}e.$ol=K;class ie extends z{constructor(Ne,ne,U){super(Ne,2,U),this.stat=ne}}e.$pl=ie;var de;(function(se){se[se.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",se[se.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",se[se.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",se[se.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",se[se.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",se[se.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",se[se.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",se[se.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",se[se.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",se[se.FILE_NOT_DIRECTORY=9]="FILE_NOT_DIRECTORY",se[se.FILE_OTHER_ERROR=10]="FILE_OTHER_ERROR"})(de||(e.FileOperationResult=de={})),e.$ql={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.$rl={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.$sl="files.associations",e.$tl="files.exclude",e.$ul="files.readonlyInclude",e.$vl="files.readonlyExclude",e.$wl="files.readonlyFromPermissions";var ye;(function(se){se[se.FILE=0]="FILE",se[se.FOLDER=1]="FOLDER",se[se.ROOT_FOLDER=2]="ROOT_FOLDER"})(ye||(e.FileKind=ye={})),e.$xl="";function De(se){if(!(typeof se.size!="number"||typeof se.mtime!="number"))return se.mtime.toString(29)+se.size.toString(31)}async function ge(se,Ne){if(!Ne.hasProvider(A.URI.from({scheme:se.scheme})))return new Promise(ne=>{const U=Ne.onDidChangeFileSystemProviderRegistrations(x=>{x.scheme===se.scheme&&x.added&&(U.dispose(),ne())})})}class ue{static{this.KB=1024}static{this.MB=ue.KB*ue.KB}static{this.GB=ue.MB*ue.KB}static{this.TB=ue.GB*ue.KB}static formatSize(Ne){return(0,T.$cg)(Ne)||(Ne=0),Ne<ue.KB?(0,p.localize)(1,null,Ne.toFixed(0)):Ne<ue.MB?(0,p.localize)(2,null,(Ne/ue.KB).toFixed(2)):Ne<ue.GB?(0,p.localize)(3,null,(Ne/ue.MB).toFixed(2)):Ne<ue.TB?(0,p.localize)(4,null,(Ne/ue.GB).toFixed(2)):(0,p.localize)(5,null,(Ne/ue.TB).toFixed(2))}}e.$Al=ue;function Ce(se){const Ne=typeof se=="string"||se?.scheme===O.Schemas.vscodeRemote;return typeof se!="string"&&se?.scheme===O.Schemas.file?1024*ue.MB:Ne?10*ue.MB:D.$o?50*ue.MB:1024*ue.MB}}),define(Se[72],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$wi=void 0;class C{constructor(...M){this.a=new Map;for(const[T,A]of M)this.set(T,A)}set(M,T){const A=this.a.get(M);return this.a.set(M,T),A}has(M){return this.a.has(M)}get(M){return this.a.get(M)}}e.$wi=C}),define(Se[199],Ie([1,0,11,14,6,71,198,3,72,200]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ir=e.$hr=void 0;const O=!1;class S extends Error{constructor(r){super("cyclic dependency between services"),this.message=r.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${r.toString()}`}}class d{constructor(r=new m.$wi,s=!1,n,t=O){this.i=r,this.j=s,this.k=n,this.l=t,this.f=!1,this.g=new Set,this.h=new Set,this.t=new Set,this.i.set(p.$xi,this),this._globalGraph=t?n?._globalGraph??new A.$gr(c=>c):void 0}dispose(){if(!this.f){this.f=!0,(0,M.$Pc)(this.h),this.h.clear();for(const r of this.g)(0,M.$Oc)(r)&&r.dispose();this.g.clear()}}m(){if(this.f)throw new Error("InstantiationService has been disposed")}createChild(r){this.m();const s=new class extends d{dispose(){this.h.delete(s),super.dispose()}}(r,this.j,this,this.l);return this.h.add(s),s}invokeFunction(r,...s){this.m();const n=f.traceInvocation(this.l,r);let t=!1;try{return r({get:u=>{if(t)throw(0,N.$8)("service accessor is only valid during the invocation of its target method");const i=this.s(u,n);if(!i)throw new Error(`[invokeFunction] unknown service '${u}'`);return i}},...s)}finally{t=!0,n.stop()}}createInstance(r,...s){this.m();let n,t;return r instanceof T.$vi?(n=f.traceCreation(this.l,r.ctor),t=this.o(r.ctor,r.staticArguments.concat(s),n)):(n=f.traceCreation(this.l,r),t=this.o(r,s,n)),n.stop(),t}o(r,s=[],n){const t=p._util.getServiceDependencies(r).sort((i,b)=>i.index-b.index),c=[];for(const i of t){const b=this.s(i.id,n);b||this.y(`[createInstance] ${r.name} depends on UNKNOWN service ${i.id}.`,!1),c.push(b)}const u=t.length>0?t[0].index:s.length;if(s.length!==u){console.trace(`[createInstance] First service dependency of ${r.name} at position ${u+1} conflicts with ${s.length} static arguments`);const i=u-s.length;i>0?s=s.concat(new Array(i)):s=s.slice(0,u)}return Reflect.construct(r,s.concat(c))}q(r,s){if(this.i.get(r)instanceof T.$vi)this.i.set(r,s);else if(this.k)this.k.q(r,s);else throw new Error("illegalState - setting UNKNOWN service instance")}r(r){const s=this.i.get(r);return!s&&this.k?this.k.r(r):s}s(r,s){this._globalGraph&&this.c&&this._globalGraph.insertEdge(this.c,String(r));const n=this.r(r);return n instanceof T.$vi?this.u(r,n,s.branch(r,!0)):(s.branch(r,!1),n)}u(r,s,n){if(this.t.has(r))throw new Error(`illegal state - RECURSIVELY instantiating service '${r}'`);this.t.add(r);try{return this.v(r,s,n)}finally{this.t.delete(r)}}v(r,s,n){const t=new A.$gr(i=>i.id.toString());let c=0;const u=[{id:r,desc:s,_trace:n}];for(;u.length;){const i=u.pop();if(t.lookupOrInsertNode(i),c++>1e3)throw new S(t);for(const b of p._util.getServiceDependencies(i.desc.ctor)){const a=this.r(b.id);if(a||this.y(`[createInstance] ${r} depends on ${b.id} which is NOT registered.`,!0),this._globalGraph?.insertEdge(String(i.id),String(b.id)),a instanceof T.$vi){const l={id:b.id,desc:a,_trace:i._trace.branch(b.id,!0)};t.insertEdge(i,l),u.push(l)}}}for(;;){const i=t.roots();if(i.length===0){if(!t.isEmpty())throw new S(t);break}for(const{data:b}of i){if(this.r(b.id)instanceof T.$vi){const l=this.w(b.id,b.desc.ctor,b.desc.staticArguments,b.desc.supportsDelayedInstantiation,b._trace);this.q(b.id,l)}t.removeNode(b)}}return this.r(r)}w(r,s,n=[],t,c){if(this.i.get(r)instanceof T.$vi)return this.x(r,s,n,t,c,this.g);if(this.k)return this.k.w(r,s,n,t,c);throw new Error(`illegalState - creating UNKNOWN service instance ${s.name}`)}x(r,s,n=[],t,c,u){if(t){const i=new d(void 0,this.j,this,this.l);i.c=String(r);const b=new Map,a=new C.$Rh(()=>{const l=i.o(s,n,c);for(const[g,$]of b){const v=l[g];if(typeof v=="function")for(const y of $)y.disposable=v.apply(l,y.listener)}return b.clear(),u.add(l),l});return new Proxy(Object.create(null),{get(l,g){if(!a.isInitialized&&typeof g=="string"&&(g.startsWith("onDid")||g.startsWith("onWill"))){let y=b.get(g);return y||(y=new D.$5c,b.set(g,y)),(E,k,I)=>{if(a.isInitialized)return a.value[g](E,k,I);{const P={listener:[E,k,I],disposable:void 0},V=y.push(P);return(0,M.$Sc)(()=>{V(),P.disposable?.dispose()})}}}if(g in l)return l[g];const $=a.value;let v=$[g];return typeof v!="function"||(v=v.bind($),l[g]=v),v},set(l,g,$){return a.value[g]=$,!0},getPrototypeOf(l){return s.prototype}})}else{const i=this.o(s,n,c);return u.add(i),i}}y(r,s){if(s&&console.warn(r),this.j)throw new Error(r)}}e.$hr=d;var w;(function(o){o[o.None=0]="None",o[o.Creation=1]="Creation",o[o.Invocation=2]="Invocation",o[o.Branch=3]="Branch"})(w||(w={}));class f{static{this.all=new Set}static{this.c=new class extends f{constructor(){super(0,null)}stop(){}branch(){return this}}}static traceInvocation(r,s){return r?new f(2,s.name||new Error().stack.split(`
`).slice(3,4).join(`
`)):f.c}static traceCreation(r,s){return r?new f(1,s.name):f.c}static{this.f=0}constructor(r,s){this.type=r,this.name=s,this.g=Date.now(),this.h=[]}branch(r,s){const n=new f(3,r.toString());return this.h.push([r,s,n]),n}stop(){const r=Date.now()-this.g;f.f+=r;let s=!1;function n(c,u){const i=[],b=new Array(c+1).join("	");for(const[a,l,g]of u.h)if(l&&g){s=!0,i.push(`${b}CREATES -> ${a}`);const $=n(c+1,g);$&&i.push($)}else i.push(`${b}uses -> ${a}`);return i.join(`
`)}const t=[`${this.type===1?"CREATE":"CALL"} ${this.name}`,`${n(1,this)}`,`DONE, took ${r.toFixed(2)}ms (grand total ${f.f.toFixed(2)}ms)`];(r>2||s)&&f.all.add(t.join(`
`))}}e.$ir=f}),define(Se[12],Ie([1,0,166,44,5,73,6,28,23,24,15,2,31,3]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kk=e.$fk=e.$ek=e.$dk=e.$ck=e.$bk=e.$ak=e.$_j=e.$$j=e.$0j=e.$8j=e.LogLevel=e.$6j=e.$5j=void 0,e.$7j=o,e.log=s,e.$gk=v,e.$hk=y,e.$ik=h,e.$jk=E,e.$5j=(0,w.$yi)("logService"),e.$6j=(0,w.$yi)("loggerService");function f(){return new Date().toISOString()}function o(k){return(0,O.$cg)(k)}var r;(function(k){k[k.Off=0]="Off",k[k.Trace=1]="Trace",k[k.Debug=2]="Debug",k[k.Info=3]="Info",k[k.Warning=4]="Warning",k[k.Error=5]="Error"})(r||(e.LogLevel=r={})),e.$8j=r.Info;function s(k,I,P){switch(I){case r.Trace:k.trace(P);break;case r.Debug:k.debug(P);break;case r.Info:k.info(P);break;case r.Warning:k.warn(P);break;case r.Error:k.error(P);break;case r.Off:break;default:throw new Error(`Invalid log level ${I}`)}}function n(k,I=!1){let P="";for(let V=0;V<k.length;V++){let W=k[V];if(W instanceof Error&&(W=(0,N.$jj)(W,I)),typeof W=="object")try{W=JSON.stringify(W)}catch{}P+=(V>0?" ":"")+W}return P}class t extends A.$Uc{constructor(){super(...arguments),this.b=e.$8j,this.c=this.B(new M.$fe),this.onDidChangeLogLevel=this.c.event}setLevel(I){this.b!==I&&(this.b=I,this.c.fire(this.b))}getLevel(){return this.b}f(I){return this.b!==r.Off&&this.b<=I}}e.$0j=t;class c extends t{constructor(I){super(),this.h=I}f(I){return this.h||super.f(I)}trace(I,...P){this.f(r.Trace)&&this.g(r.Trace,n([I,...P],!0))}debug(I,...P){this.f(r.Debug)&&this.g(r.Debug,n([I,...P]))}info(I,...P){this.f(r.Info)&&this.g(r.Info,n([I,...P]))}warn(I,...P){this.f(r.Warning)&&this.g(r.Warning,n([I,...P]))}error(I,...P){if(this.f(r.Error))if(I instanceof Error){const V=Array.prototype.slice.call(arguments);V[0]=I.stack,this.g(r.Error,n(V))}else this.g(r.Error,n([I,...P]))}flush(){}}e.$$j=c;class u extends t{constructor(I=e.$8j){super(),this.setLevel(I),this.g=!m.$i}trace(I,...P){this.f(r.Trace)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}debug(I,...P){this.f(r.Debug)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}info(I,...P){this.f(r.Info)&&(this.g?console.log(`\x1B[90m[main ${f()}]\x1B[0m`,I,...P):console.log(`[main ${f()}]`,I,...P))}warn(I,...P){this.f(r.Warning)&&(this.g?console.warn(`\x1B[93m[main ${f()}]\x1B[0m`,I,...P):console.warn(`[main ${f()}]`,I,...P))}error(I,...P){this.f(r.Error)&&(this.g?console.error(`\x1B[91m[main ${f()}]\x1B[0m`,I,...P):console.error(`[main ${f()}]`,I,...P))}flush(){}}e.$_j=u;class i extends t{constructor(I=e.$8j,P=!0){super(),this.g=P,this.setLevel(I)}trace(I,...P){this.f(r.Trace)&&(this.g?console.log("%cTRACE","color: #888",I,...P):console.log(I,...P))}debug(I,...P){this.f(r.Debug)&&(this.g?console.log("%cDEBUG","background: #eee; color: #888",I,...P):console.log(I,...P))}info(I,...P){this.f(r.Info)&&(this.g?console.log("%c INFO","color: #33f",I,...P):console.log(I,...P))}warn(I,...P){this.f(r.Warning)&&(this.g?console.log("%c WARN","color: #993",I,...P):console.log(I,...P))}error(I,...P){this.f(r.Error)&&(this.g?console.log("%c  ERR","color: #f33",I,...P):console.error(I,...P))}flush(){}}e.$ak=i;class b extends t{constructor(I,P=e.$8j){super(),this.g=I,this.setLevel(P)}trace(I,...P){this.f(r.Trace)&&this.g.log(r.Trace,[this.h(I),...P])}debug(I,...P){this.f(r.Debug)&&this.g.log(r.Debug,[this.h(I),...P])}info(I,...P){this.f(r.Info)&&this.g.log(r.Info,[this.h(I),...P])}warn(I,...P){this.f(r.Warning)&&this.g.log(r.Warning,[this.h(I),...P])}error(I,...P){this.f(r.Error)&&this.g.log(r.Error,[this.h(I),...P])}h(I){return typeof I=="string"?I:(0,N.$jj)(I,this.f(r.Trace))}flush(){}}e.$bk=b;class a extends t{constructor(I){super(),this.g=I,I.length&&this.setLevel(I[0].getLevel())}setLevel(I){for(const P of this.g)P.setLevel(I);super.setLevel(I)}trace(I,...P){for(const V of this.g)V.trace(I,...P)}debug(I,...P){for(const V of this.g)V.debug(I,...P)}info(I,...P){for(const V of this.g)V.info(I,...P)}warn(I,...P){for(const V of this.g)V.warn(I,...P)}error(I,...P){for(const V of this.g)V.error(I,...P)}flush(){for(const I of this.g)I.flush()}dispose(){for(const I of this.g)I.dispose();super.dispose()}}e.$ck=a;class l extends A.$Uc{constructor(I,P,V){if(super(),this.h=I,this.j=P,this.b=new p.$Ac,this.c=this.B(new M.$fe),this.onDidChangeLoggers=this.c.event,this.f=this.B(new M.$fe),this.onDidChangeLogLevel=this.f.event,this.g=this.B(new M.$fe),this.onDidChangeVisibility=this.g.event,V)for(const W of V)this.b.set(W.resource,{logger:void 0,info:W})}m(I){return(0,O.$$f)(I)?[...this.b.values()].find(P=>P.info.id===I):this.b.get(I)}getLogger(I){return this.m(I)?.logger}createLogger(I,P){const V=this.n(I),W=(0,O.$$f)(I)?I:P?.id??(0,T.$mj)(V.toString()).toString(16);let q=this.b.get(V)?.logger;const R=P?.logLevel==="always"?r.Trace:P?.logLevel;q||(q=this.s(V,R??this.getLogLevel(V)??this.h,{...P,id:W}));const z={logger:q,info:{resource:V,id:W,logLevel:R,name:P?.name,hidden:P?.hidden,extensionId:P?.extensionId,when:P?.when}};return this.registerLogger(z.info),this.b.set(V,z),q}n(I){return(0,O.$$f)(I)?(0,D.$_g)(this.j,`${I}.log`):I}setLogLevel(I,P){if(S.URI.isUri(I)){const V=I,W=P,q=this.b.get(V);q&&W!==q.info.logLevel&&(q.info.logLevel=W===this.h?void 0:W,q.logger?.setLevel(W),this.b.set(q.info.resource,q),this.f.fire([V,W]))}else{this.h=I;for(const[V,W]of this.b.entries())this.b.get(V)?.info.logLevel===void 0&&W.logger?.setLevel(this.h);this.f.fire(this.h)}}setVisibility(I,P){const V=this.m(I);V&&P!==!V.info.hidden&&(V.info.hidden=!P,this.b.set(V.info.resource,V),this.g.fire([V.info.resource,P]))}getLogLevel(I){let P;return I&&(P=this.b.get(I)?.info.logLevel),P??this.h}registerLogger(I){const P=this.b.get(I.resource);P?P.info.hidden!==I.hidden&&this.setVisibility(I.resource,!I.hidden):(this.b.set(I.resource,{info:I,logger:void 0}),this.c.fire({added:[I],removed:[]}))}deregisterLogger(I){const P=this.b.get(I);P&&(P.logger&&P.logger.dispose(),this.b.delete(I),this.c.fire({added:[],removed:[P.info]}))}*getRegisteredLoggers(){for(const I of this.b.values())yield I.info}getRegisteredLogger(I){return this.b.get(I)?.info}dispose(){this.b.forEach(I=>I.logger?.dispose()),this.b.clear(),super.dispose()}}e.$dk=l;class g{constructor(){this.onDidChangeLogLevel=new M.$fe().event}setLevel(I){}getLevel(){return r.Info}trace(I,...P){}debug(I,...P){}info(I,...P){}warn(I,...P){}error(I,...P){}critical(I,...P){}dispose(){}flush(){}}e.$ek=g;class $ extends g{}e.$fk=$;function v(k){if(k.verbose)return r.Trace;if(typeof k.logLevel=="string"){const I=E(k.logLevel.toLowerCase());if(I!==void 0)return I}return e.$8j}function y(k){switch(k){case r.Trace:return"trace";case r.Debug:return"debug";case r.Info:return"info";case r.Warning:return"warn";case r.Error:return"error";case r.Off:return"off"}}function h(k){switch(k){case r.Trace:return{original:"Trace",value:C.localize(0,null)};case r.Debug:return{original:"Debug",value:C.localize(1,null)};case r.Info:return{original:"Info",value:C.localize(2,null)};case r.Warning:return{original:"Warning",value:C.localize(3,null)};case r.Error:return{original:"Error",value:C.localize(4,null)};case r.Off:return{original:"Off",value:C.localize(5,null)}}}function E(k){switch(k){case"trace":return r.Trace;case"debug":return r.Debug;case"info":return r.Info;case"warn":return r.Warning;case"error":return r.Error;case"critical":return r.Error;case"off":return r.Off}}e.$kk=new d.$Pj("logLevel",y(r.Info))}),define(Se[201],Ie([1,0,6,12]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dQ=void 0;class M extends C.$Uc{constructor(A,p=[]){super(),this.a=new N.$ck([A,...p]),this.B(A.onDidChangeLogLevel(m=>this.setLevel(m)))}get onDidChangeLogLevel(){return this.a.onDidChangeLogLevel}setLevel(A){this.a.setLevel(A)}getLevel(){return this.a.getLevel()}trace(A,...p){this.a.trace(A,...p)}debug(A,...p){this.a.debug(A,...p)}info(A,...p){this.a.info(A,...p)}warn(A,...p){this.a.warn(A,...p)}error(A,...p){this.a.error(A,...p)}flush(){this.a.flush()}}e.$dQ=M}),define(Se[101],Ie([1,0,32,167,3]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pu=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var T;(function(m){m[m.Unnecessary=1]="Unnecessary",m[m.Deprecated=2]="Deprecated"})(T||(e.MarkerTag=T={}));var A;(function(m){m[m.Hint=1]="Hint",m[m.Info=2]="Info",m[m.Warning=4]="Warning",m[m.Error=8]="Error"})(A||(e.MarkerSeverity=A={})),function(m){function D(f,o){return o-f}m.compare=D;const O=Object.create(null);O[m.Error]=(0,N.localize)(0,null),O[m.Warning]=(0,N.localize)(1,null),O[m.Info]=(0,N.localize)(2,null);function S(f){return O[f]||""}m.toString=S;function d(f){switch(f){case C.default.Error:return m.Error;case C.default.Warning:return m.Warning;case C.default.Info:return m.Info;case C.default.Ignore:return m.Hint}}m.fromSeverity=d;function w(f){switch(f){case m.Error:return C.default.Error;case m.Warning:return C.default.Warning;case m.Info:return C.default.Info;case m.Hint:return C.default.Ignore}}m.toSeverity=w}(A||(e.MarkerSeverity=A={}));var p;(function(m){const D="";function O(d){return S(d,!0)}m.makeKey=O;function S(d,w){const f=[D];return d.source?f.push(d.source.replace("\xA6","\\\xA6")):f.push(D),d.code?typeof d.code=="string"?f.push(d.code.replace("\xA6","\\\xA6")):f.push(d.code.value.replace("\xA6","\\\xA6")):f.push(D),d.severity!==void 0&&d.severity!==null?f.push(A.toString(d.severity)):f.push(D),d.message&&w?f.push(d.message.replace("\xA6","\\\xA6")):f.push(D),d.startLineNumber!==void 0&&d.startLineNumber!==null?f.push(d.startLineNumber.toString()):f.push(D),d.startColumn!==void 0&&d.startColumn!==null?f.push(d.startColumn.toString()):f.push(D),d.endLineNumber!==void 0&&d.endLineNumber!==null?f.push(d.endLineNumber.toString()):f.push(D),d.endColumn!==void 0&&d.endColumn!==null?f.push(d.endColumn.toString()):f.push(D),f.push(D),f.join("\xA6")}m.makeKeyOptionalMessage=S})(p||(e.IMarkerData=p={})),e.$pu=(0,M.$yi)("markerService")}),define(Se[202],Ie([1,0,5,32,3]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fw=e.$ew=e.NotificationsFilter=e.NeverShowAgainScope=e.NotificationPriority=e.$cw=e.Severity=void 0,e.$dw=p,e.Severity=N.default,e.$cw=(0,M.$yi)("notificationService");var T;(function(S){S[S.DEFAULT=0]="DEFAULT",S[S.SILENT=1]="SILENT",S[S.URGENT=2]="URGENT"})(T||(e.NotificationPriority=T={}));var A;(function(S){S[S.WORKSPACE=0]="WORKSPACE",S[S.PROFILE=1]="PROFILE",S[S.APPLICATION=2]="APPLICATION"})(A||(e.NeverShowAgainScope=A={}));function p(S){if(S){const d=S;return typeof d.id=="string"&&typeof d.label=="string"}return!1}var m;(function(S){S[S.OFF=0]="OFF",S[S.ERROR=1]="ERROR"})(m||(e.NotificationsFilter=m={}));class D{constructor(){this.progress=new O,this.onDidClose=C.Event.None,this.onDidChangeVisibility=C.Event.None}updateSeverity(d){}updateMessage(d){}updateActions(d){}close(){}}e.$ew=D;class O{infinite(){}done(){}total(d){}worked(d){}}e.$fw=O}),define(Se[102],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mk=e.$lk=void 0,e.$lk=(0,C.$yi)("productService"),e.$mk="vscode://schemas/vscode-product"});var Je=this&&this.__decorate||function(le,e,C,N){var M=arguments.length,T=M<3?e:N===null?N=Object.getOwnPropertyDescriptor(e,C):N,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")T=Reflect.decorate(le,e,C,N);else for(var p=le.length-1;p>=0;p--)(A=le[p])&&(T=(M<3?A(T):M>3?A(e,C,T):A(e,C))||T);return M>3&&T&&Object.defineProperty(e,C,T),T},We=this&&this.__param||function(le,e){return function(C,N){e(C,N,le)}};define(Se[103],Ie([1,0,11,20,6,3]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mw=e.$lw=e.$kw=e.$jw=e.$iw=e.$hw=e.ProgressLocation=e.$gw=void 0,e.$gw=(0,T.$yi)("progressService");var A;(function(S){S[S.Explorer=1]="Explorer",S[S.Scm=3]="Scm",S[S.Extensions=5]="Extensions",S[S.Window=10]="Window",S[S.Notification=15]="Notification",S[S.Dialog=20]="Dialog"})(A||(e.ProgressLocation=A={})),e.$hw=Object.freeze({total(){},worked(){},done(){}});class p{static{this.None=Object.freeze({report(){}})}get value(){return this.a}constructor(d){this.b=d}report(d){this.a=d,this.b(this.a)}}e.$iw=p;class m{get value(){return this.a}constructor(d){this.e=d}report(d){this.b?this.b.push(d):this.b=[d],this.f()}async f(){if(!this.c)try{for(this.c=!0;this.b&&this.b.length;){const d=this.b.shift();this.a=d,await this.e(this.a)}}finally{this.c=!1;const d=this.d;this.d=void 0,d?.()}}drain(){return this.c?new Promise(d=>{const w=this.d;this.d=()=>{w?.(),d()}}):Promise.resolve()}}e.$jw=m;let D=class extends M.$Uc{constructor(d,w){super(),this.a=new C.$Vh,w.withProgress(d,f=>(this.b=f,this.c&&f.report(this.c),this.a.p)),this.B((0,M.$Sc)(()=>this.a.complete()))}report(d){this.b?this.b.report(d):this.c=d}};e.$kw=D,e.$kw=D=Je([We(1,e.$gw)],D);class O extends M.$Uc{constructor(d){super(),this.g=d,this.a=0,this.b=this.B(new M.$Tc)}start(d){this.stop();const w=++this.a,f=new N.$qe;return this.f=setTimeout(()=>{w===this.a&&(this.c=this.g.show(!0))},d),this.b.add((0,M.$Sc)(()=>clearTimeout(this.f))),this.b.add((0,M.$Sc)(()=>f.cancel())),this.b.add((0,M.$Sc)(()=>this.c?this.c.done():void 0)),{id:w,token:f.token,stop:()=>this.h(w),isCurrent:()=>this.a===w}}stop(){this.h(this.a)}h(d){this.a===d&&this.b.clear()}}e.$lw=O,e.$mw=(0,T.$yi)("editorProgressService")}),define(Se[29],Ie([1,0,57,15]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fo=void 0;class M{constructor(){this.a=new Map}add(A,p){C.ok(N.$$f(A)),C.ok(N.$ag(p)),C.ok(!this.a.has(A),"There is already an extension with this id"),this.a.set(A,p)}knows(A){return this.a.has(A)}as(A){return this.a.get(A)||null}}e.$fo=new M}),define(Se[74],Ie([1,0,5,29]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$go=void 0,e.$go={JSONContribution:"base.contributions.json"};function M(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class T{constructor(){this.b=new C.$fe,this.onDidChangeSchema=this.b.event,this.a={}}registerSchema(m,D){this.a[M(m)]=D,this.b.fire(m)}notifySchemaChanged(m){this.b.fire(m)}getSchemaContributions(){return{schemas:this.a}}}const A=new T;N.$fo.add(e.$go.JSONContribution,A)}),define(Se[51],Ie([1,0,18,5,15,160,50,74,29]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$uo=e.$to=e.$so=e.$ro=e.$qo=e.$po=e.$oo=e.$no=e.$mo=e.$lo=e.ConfigurationScope=e.$ko=e.EditPresentationTypes=void 0,e.$vo=o,e.$wo=r,e.$xo=s,e.$yo=t,e.$zo=c;var D;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(D||(e.EditPresentationTypes=D={})),e.$ko={Configuration:"base.contributions.configuration"};var O;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(O||(e.ConfigurationScope=O={})),e.$lo={properties:{},patternProperties:{}},e.$mo={properties:{},patternProperties:{}},e.$no={properties:{},patternProperties:{}},e.$oo={properties:{},patternProperties:{}},e.$po={properties:{},patternProperties:{}},e.$qo={properties:{},patternProperties:{}},e.$ro="vscode://schemas/settings/resourceLanguage",e.$so="vscode://schemas/settings/configurationDefaults";const S=m.$fo.as(p.$go.JSONContribution);class d{constructor(){this.h=new Set,this.i=new N.$fe,this.onDidSchemaChange=this.i.event,this.j=new N.$fe,this.onDidUpdateConfiguration=this.j.event,this.a=new Map,this.b={id:"defaultOverrides",title:T.localize(0,null),properties:{}},this.c=[this.b],this.g={properties:{},patternProperties:{},additionalProperties:!0,allowTrailingCommas:!0,allowComments:!0},this.d={},this.e=new Map,this.f={},S.registerSchema(e.$ro,this.g),this.v()}registerConfiguration(i,b=!0){this.registerConfigurations([i],b)}registerConfigurations(i,b=!0){const a=new Set;this.n(i,b,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}deregisterConfigurations(i){const b=new Set;this.o(i,b),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:b})}updateConfigurations({add:i,remove:b}){const a=new Set;this.o(b,a),this.n(i,!1,a),S.registerSchema(e.$ro,this.g),this.i.fire(),this.j.fire({properties:a})}registerDefaultConfigurations(i){const b=new Set;this.k(i,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}k(i,b){const a=[];for(const{overrides:l,source:g}of i)for(const $ in l)if(b.add($),e.$uo.test($)){const v=this.a.get($),y=v?.valuesSources??new Map;if(g)for(const I of Object.keys(l[$]))y.set(I,g);const h={...v?.value||{},...l[$]};this.a.set($,{source:g,value:h,valuesSources:y});const E=(0,A.$cj)($),k={type:"object",default:h,description:T.localize(1,null,E),$ref:e.$ro,defaultDefaultValue:h,source:M.$$f(g)?void 0:g,defaultValueSource:g};a.push(...o($)),this.d[$]=k,this.b.properties[$]=k}else{this.a.set($,{value:l[$],source:g});const v=this.d[$];v&&(this.w($,v),this.r($,v))}this.m(a)}deregisterDefaultConfigurations(i){const b=new Set;this.l(i,b),this.i.fire(),this.j.fire({properties:b,defaultsOverrides:!0})}l(i,b){for(const{overrides:a,source:l}of i)for(const g in a){const $=this.a.get(g),v=M.$$f(l)?l:l?.id,y=M.$$f($?.source)?$?.source:$?.source?.id;if(v===y)if(b.add(g),this.a.delete(g),e.$uo.test(g))delete this.d[g],delete this.b.properties[g];else{const h=this.d[g];h&&(this.w(g,h),this.r(g,h))}}this.u()}deltaConfiguration(i){let b=!1;const a=new Set;i.removedDefaults&&(this.l(i.removedDefaults,a),b=!0),i.addedDefaults&&(this.k(i.addedDefaults,a),b=!0),i.removedConfigurations&&this.o(i.removedConfigurations,a),i.addedConfigurations&&this.n(i.addedConfigurations,!1,a),this.i.fire(),this.j.fire({properties:a,defaultsOverrides:b})}notifyConfigurationSchemaUpdated(...i){this.i.fire()}registerOverrideIdentifiers(i){this.m(i),this.i.fire()}m(i){for(const b of i)this.h.add(b);this.u()}n(i,b,a){i.forEach(l=>{this.p(l,b,l.extensionInfo,l.restrictedProperties,void 0,a),this.c.push(l),this.q(l)})}o(i,b){const a=l=>{if(l.properties)for(const g in l.properties){b.add(g);const $=this.d[g];$?.policy?.name&&this.e.delete($.policy.name),delete this.d[g],this.s(g,l.properties[g])}l.allOf?.forEach(g=>a(g))};for(const l of i){a(l);const g=this.c.indexOf(l);g!==-1&&this.c.splice(g,1)}}p(i,b=!0,a,l,g=3,$){g=M.$hg(i.scope)?g:i.scope;const v=i.properties;if(v)for(const h in v){const E=v[h];if(b&&t(h,E)){delete v[h];continue}if(E.source=a,E.defaultDefaultValue=v[h].default,this.w(h,E),e.$uo.test(h)?E.scope=void 0:(E.scope=M.$hg(E.scope)?g:E.scope,E.restricted=M.$hg(E.restricted)?!!l?.includes(h):E.restricted),v[h].hasOwnProperty("included")&&!v[h].included){this.f[h]=v[h],delete v[h];continue}else this.d[h]=v[h],v[h].policy?.name&&this.e.set(v[h].policy.name,h);!v[h].deprecationMessage&&v[h].markdownDeprecationMessage&&(v[h].deprecationMessage=v[h].markdownDeprecationMessage),$.add(h)}const y=i.allOf;if(y)for(const h of y)this.p(h,b,a,l,g,$)}getConfigurations(){return this.c}getConfigurationProperties(){return this.d}getPolicyConfigurations(){return this.e}getExcludedConfigurationProperties(){return this.f}getConfigurationDefaultsOverrides(){return this.a}q(i){const b=a=>{const l=a.properties;if(l)for(const $ in l)this.r($,l[$]);a.allOf?.forEach(b)};b(i)}r(i,b){switch(e.$lo.properties[i]=b,b.scope){case 1:e.$mo.properties[i]=b;break;case 2:e.$no.properties[i]=b;break;case 6:e.$oo.properties[i]=b;break;case 3:e.$po.properties[i]=b;break;case 4:e.$qo.properties[i]=b;break;case 5:e.$qo.properties[i]=b,this.g.properties[i]=b;break}}s(i,b){switch(delete e.$lo.properties[i],b.scope){case 1:delete e.$mo.properties[i];break;case 2:delete e.$no.properties[i];break;case 6:delete e.$oo.properties[i];break;case 3:delete e.$po.properties[i];break;case 4:case 5:delete e.$qo.properties[i],delete this.g.properties[i];break}}u(){for(const i of this.h.values()){const b=`[${i}]`,a={type:"object",description:T.localize(2,null),errorMessage:T.localize(3,null),$ref:e.$ro};this.w(b,a),e.$lo.properties[b]=a,e.$mo.properties[b]=a,e.$no.properties[b]=a,e.$oo.properties[b]=a,e.$po.properties[b]=a,e.$qo.properties[b]=a}}v(){const i={type:"object",description:T.localize(4,null),errorMessage:T.localize(5,null),$ref:e.$ro};e.$lo.patternProperties[e.$to]=i,e.$mo.patternProperties[e.$to]=i,e.$no.patternProperties[e.$to]=i,e.$oo.patternProperties[e.$to]=i,e.$po.patternProperties[e.$to]=i,e.$qo.patternProperties[e.$to]=i,this.i.fire()}w(i,b){const a=this.a.get(i);let l=a?.value,g=a?.source;M.$fg(l)&&(l=b.defaultDefaultValue,g=void 0),M.$fg(l)&&(l=s(b.type)),b.default=l,b.defaultValueSource=g}}const w="\\[([^\\]]+)\\]",f=new RegExp(w,"g");e.$to=`^(${w})+$`,e.$uo=new RegExp(e.$to);function o(u){const i=[];if(e.$uo.test(u)){let b=f.exec(u);for(;b?.length;){const a=b[1].trim();a&&i.push(a),b=f.exec(u)}}return(0,C.$Mb)(i)}function r(u){return u.reduce((i,b)=>`${i}[${b}]`,"")}function s(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}const n=new d;m.$fo.add(e.$ko.Configuration,n);function t(u,i){return u.trim()?e.$uo.test(u)?T.localize(7,null,u):n.getConfigurationProperties()[u]!==void 0?T.localize(8,null,u):i.policy?.name&&n.getPolicyConfigurations().get(i.policy?.name)!==void 0?T.localize(9,null,u,i.policy?.name,n.getPolicyConfigurations().get(i.policy?.name)):null:T.localize(6,null)}function c(){const u=[],i=n.getConfigurationProperties();for(const b of Object.keys(i))u.push([b,i[b].scope]);return u.push(["launch",4]),u.push(["task",4]),u}}),define(Se[203],Ie([1,0,18,5,126,6,28,26,15,2,50,51,29]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fo=e.$Do=e.$Co=e.$Bo=e.$Ao=void 0,e.$Eo=t;function w(b){return Object.isFrozen(b)?b:p.$6n(b)}class f{static createEmptyModel(a){return new f({},[],[],void 0,a)}constructor(a,l,g,$,v){this.b=a,this.c=l,this.d=g,this.raw=$,this.f=v,this.a=new Map}get rawConfiguration(){if(!this.g)if(this.raw?.length){const a=this.raw.map(l=>{if(l instanceof f)return l;const g=new o("",this.f);return g.parseRaw(l),g.configurationModel});this.g=a.reduce((l,g)=>g===l?g:l.merge(g),a[0])}else this.g=this;return this.g}get contents(){return this.b}get overrides(){return this.d}get keys(){return this.c}isEmpty(){return this.c.length===0&&Object.keys(this.b).length===0&&this.d.length===0}getValue(a){return a?(0,O.$aj)(this.contents,a):this.contents}inspect(a,l){const g=this;return{get value(){return w(g.rawConfiguration.getValue(a))},get override(){return l?w(g.rawConfiguration.getOverrideValue(a,l)):void 0},get merged(){return w(l?g.rawConfiguration.override(l).getValue(a):g.rawConfiguration.getValue(a))},get overrides(){const $=[];for(const{contents:v,identifiers:y,keys:h}of g.rawConfiguration.overrides){const E=new f(v,h,[],void 0,g.f).getValue(a);E!==void 0&&$.push({identifiers:y,value:E})}return $.length?w($):void 0}}}getOverrideValue(a,l){const g=this.j(l);return g?a?(0,O.$aj)(g,a):g:void 0}getKeysForOverrideIdentifier(a){const l=[];for(const g of this.overrides)g.identifiers.includes(a)&&l.push(...g.keys);return C.$Mb(l)}getAllOverrideIdentifiers(){const a=[];for(const l of this.overrides)a.push(...l.identifiers);return C.$Mb(a)}override(a){let l=this.a.get(a);return l||(l=this.h(a),this.a.set(a,l)),l}merge(...a){const l=p.$5n(this.contents),g=p.$5n(this.overrides),$=[...this.keys],v=this.raw?.length?[...this.raw]:[this];for(const y of a)if(v.push(...y.raw?.length?y.raw:[y]),!y.isEmpty()){this.i(l,y.contents);for(const h of y.overrides){const[E]=g.filter(k=>C.$ub(k.identifiers,h.identifiers));E?(this.i(E.contents,h.contents),E.keys.push(...h.keys),E.keys=C.$Mb(E.keys)):g.push(p.$5n(h))}for(const h of y.keys)$.indexOf(h)===-1&&$.push(h)}return new f(l,$,g,v.every(y=>y instanceof f)?void 0:v,this.f)}h(a){const l=this.j(a);if(!l||typeof l!="object"||!Object.keys(l).length)return this;const g={};for(const $ of C.$Mb([...Object.keys(this.contents),...Object.keys(l)])){let v=this.contents[$];const y=l[$];y&&(typeof v=="object"&&typeof y=="object"?(v=p.$5n(v),this.i(v,y)):v=y),g[$]=v}return new f(g,this.keys,this.overrides,void 0,this.f)}i(a,l){for(const g of Object.keys(l)){if(g in a&&m.$ag(a[g])&&m.$ag(l[g])){this.i(a[g],l[g]);continue}a[g]=p.$5n(l[g])}}j(a){let l=null,g=null;const $=v=>{v&&(g?this.i(g,v):g=p.$5n(v))};for(const v of this.overrides)v.identifiers.length===1&&v.identifiers[0]===a?l=v.contents:v.identifiers.includes(a)&&$(v.contents);return $(l),g}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}addValue(a,l){this.k(a,l,!0)}setValue(a,l){this.k(a,l,!1)}removeValue(a){const l=this.keys.indexOf(a);l!==-1&&(this.keys.splice(l,1),(0,O.$_i)(this.contents,a),S.$uo.test(a)&&this.overrides.splice(this.overrides.findIndex(g=>C.$ub(g.identifiers,(0,S.$vo)(a))),1))}k(a,l,g){(0,O.$$i)(this.contents,a,l,$=>this.f.error($)),g=g||this.keys.indexOf(a)===-1,g&&this.keys.push(a),S.$uo.test(a)&&this.overrides.push({identifiers:(0,S.$vo)(a),keys:Object.keys(this.contents[a]),contents:(0,O.$0i)(this.contents[a],$=>this.f.error($))})}}e.$Ao=f;class o{constructor(a,l){this.f=a,this.g=l,this.a=null,this.b=null,this.c=[],this.d=[]}get configurationModel(){return this.b||f.createEmptyModel(this.g)}get restrictedConfigurations(){return this.c}get errors(){return this.d}parse(a,l){if(!m.$hg(a)){const g=this.h(a);this.parseRaw(g,l)}}reparse(a){this.a&&this.parseRaw(this.a,a)}parseRaw(a,l){this.a=a;const{contents:g,keys:$,overrides:v,restricted:y,hasExcludedProperties:h}=this.i(a,l);this.b=new f(g,$,v,h?[a]:void 0,this.g),this.c=y||[]}h(a){let l={},g=null,$=[];const v=[],y=[];function h(k){Array.isArray($)?$.push(k):g!==null&&($[g]=k)}const E={onObjectBegin:()=>{const k={};h(k),v.push($),$=k,g=null},onObjectProperty:k=>{g=k},onObjectEnd:()=>{$=v.pop()},onArrayBegin:()=>{const k=[];h(k),v.push($),$=k,g=null},onArrayEnd:()=>{$=v.pop()},onLiteralValue:h,onError:(k,I,P)=>{y.push({error:k,offset:I,length:P})}};if(a)try{M.$Sn(a,E),l=$[0]||{}}catch(k){this.g.error(`Error while parsing settings file ${this.f}: ${k}`),this.d=[k]}return l}i(a,l){const g=d.$fo.as(S.$ko.Configuration).getConfigurationProperties(),$=this.j(a,g,!0,l);a=$.raw;const v=(0,O.$0i)(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`)),y=Object.keys(a),h=this.l(a,E=>this.g.error(`Conflict in settings file ${this.f}: ${E}`));return{contents:v,keys:y,overrides:h,restricted:$.restricted,hasExcludedProperties:$.hasExcludedProperties}}j(a,l,g,$){let v=!1;if(!$?.scopes&&!$?.skipRestricted&&!$?.exclude?.length)return{raw:a,restricted:[],hasExcludedProperties:v};const y={},h=[];for(const E in a)if(S.$uo.test(E)&&g){const k=this.j(a[E],l,!1,$);y[E]=k.raw,v=v||k.hasExcludedProperties,h.push(...k.restricted)}else{const k=l[E],I=k?typeof k.scope<"u"?k.scope:3:void 0;k?.restricted&&h.push(E),!$.exclude?.includes(E)&&($.include?.includes(E)||(I===void 0||$.scopes===void 0||$.scopes.includes(I))&&!($.skipRestricted&&k?.restricted))?y[E]=a[E]:v=!0}return{raw:y,restricted:h,hasExcludedProperties:v}}l(a,l){const g=[];for(const $ of Object.keys(a))if(S.$uo.test($)){const v={};for(const y in a[$])v[y]=a[$][y];g.push({identifiers:(0,S.$vo)($),keys:Object.keys(v),contents:(0,O.$0i)(v,l)})}return g}}e.$Bo=o;class r extends T.$Uc{constructor(a,l,g,$,v){super(),this.c=a,this.f=l,this.g=$,this.h=v,this.b=this.B(new N.$fe),this.onDidChange=this.b.event,this.a=new o(this.c.toString(),v),this.B(this.g.watch(g.dirname(this.c))),this.B(this.g.watch(this.c)),this.B(N.Event.any(N.Event.filter(this.g.onDidFilesChange,y=>y.contains(this.c)),N.Event.filter(this.g.onDidRunOperation,y=>(y.isOperation(0)||y.isOperation(3)||y.isOperation(1)||y.isOperation(4))&&g.isEqual(y.resource,a)))(()=>this.b.fire()))}async loadConfiguration(){try{const a=await this.g.readFile(this.c);return this.a.parse(a.value.toString()||"{}",this.f),this.a.configurationModel}catch{return f.createEmptyModel(this.h)}}reparse(a){return a&&(this.f=a),this.a.reparse(this.f),this.a.configurationModel}getRestrictedSettings(){return this.a.restrictedConfigurations}}e.$Co=r;class s{constructor(a,l,g,$,v,y,h,E,k,I,P,V,W){this.a=a,this.b=l,this.c=g,this.overrideIdentifiers=$,this.d=v,this.f=y,this.g=h,this.h=E,this.i=k,this.j=I,this.k=P,this.l=V,this.m=W}get value(){return w(this.c)}n(a){return a?.value!==void 0||a?.override!==void 0||a?.overrides!==void 0?a:void 0}get q(){return this.p||(this.p=this.d.inspect(this.a,this.b.overrideIdentifier)),this.p}get defaultValue(){return this.q.merged}get default(){return this.n(this.q)}get s(){return this.r===void 0&&(this.r=this.f?this.f.inspect(this.a):null),this.r}get policyValue(){return this.s?.merged}get policy(){return this.s?.value!==void 0?{value:this.s.value}:void 0}get u(){return this.t===void 0&&(this.t=this.g?this.g.inspect(this.a):null),this.t}get applicationValue(){return this.u?.merged}get application(){return this.n(this.u)}get w(){return this.v||(this.v=this.h.inspect(this.a,this.b.overrideIdentifier)),this.v}get userValue(){return this.w.merged}get user(){return this.n(this.w)}get y(){return this.x||(this.x=this.i.inspect(this.a,this.b.overrideIdentifier)),this.x}get userLocalValue(){return this.y.merged}get userLocal(){return this.n(this.y)}get A(){return this.z||(this.z=this.j.inspect(this.a,this.b.overrideIdentifier)),this.z}get userRemoteValue(){return this.A.merged}get userRemote(){return this.n(this.A)}get D(){return this.B===void 0&&(this.B=this.k?this.k.inspect(this.a,this.b.overrideIdentifier):null),this.B}get workspaceValue(){return this.D?.merged}get workspace(){return this.n(this.D)}get F(){return this.E===void 0&&(this.E=this.l?this.l.inspect(this.a,this.b.overrideIdentifier):null),this.E}get workspaceFolderValue(){return this.F?.merged}get workspaceFolder(){return this.n(this.F)}get H(){return this.G===void 0&&(this.G=this.m.inspect(this.a,this.b.overrideIdentifier)),this.G}get memoryValue(){return this.H.merged}get memory(){return this.n(this.H)}}class n{constructor(a,l,g,$,v,y,h,E,k,I){this.j=a,this.l=l,this.m=g,this.n=$,this.p=v,this.q=y,this.r=h,this.s=E,this.t=k,this.u=I,this.h=null,this.i=new A.$Ac,this.v=null}getValue(a,l,g){return this.w(a,l,g).getValue(a)}updateValue(a,l,g={}){let $;g.resource?($=this.t.get(g.resource),$||($=f.createEmptyModel(this.u),this.t.set(g.resource,$))):$=this.s,l===void 0?$.removeValue(a):$.setValue(a,l),g.resource||(this.h=null)}inspect(a,l,g){const $=this.w(a,l,g),v=this.A(l.resource,g),y=l.resource?this.t.get(l.resource)||this.s:this.s,h=new Set;for(const E of $.overrides)for(const k of E.identifiers)$.getOverrideValue(a,k)!==void 0&&h.add(k);return new s(a,l,$.getValue(a),h.size?[...h]:void 0,this.j,this.l.isEmpty()?void 0:this.l,this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration,this.userConfiguration,this.localUserConfiguration,this.remoteUserConfiguration,g?this.q:void 0,v||void 0,y)}keys(a){const l=this.A(void 0,a);return{default:this.j.keys.slice(0),user:this.userConfiguration.keys.slice(0),workspace:this.q.keys.slice(0),workspaceFolder:l?l.keys.slice(0):[]}}updateDefaultConfiguration(a){this.j=a,this.h=null,this.i.clear()}updatePolicyConfiguration(a){this.l=a}updateApplicationConfiguration(a){this.m=a,this.h=null,this.i.clear()}updateLocalUserConfiguration(a){this.n=a,this.v=null,this.h=null,this.i.clear()}updateRemoteUserConfiguration(a){this.p=a,this.v=null,this.h=null,this.i.clear()}updateWorkspaceConfiguration(a){this.q=a,this.h=null,this.i.clear()}updateFolderConfiguration(a,l){this.r.set(a,l),this.i.delete(a)}deleteFolderConfiguration(a){this.folderConfigurations.delete(a),this.i.delete(a)}compareAndUpdateDefaultConfiguration(a,l){const g=[];if(!l){const{added:$,updated:v,removed:y}=u(this.j,a);l=[...$,...v,...y]}for(const $ of l)for(const v of(0,S.$vo)($)){const y=this.j.getKeysForOverrideIdentifier(v),h=a.getKeysForOverrideIdentifier(v),E=[...h.filter(k=>y.indexOf(k)===-1),...y.filter(k=>h.indexOf(k)===-1),...y.filter(k=>!p.$9n(this.j.override(v).getValue(k),a.override(v).getValue(k)))];g.push([v,E])}return this.updateDefaultConfiguration(a),{keys:l,overrides:g}}compareAndUpdatePolicyConfiguration(a){const{added:l,updated:g,removed:$}=u(this.l,a),v=[...l,...g,...$];return v.length&&this.updatePolicyConfiguration(a),{keys:v,overrides:[]}}compareAndUpdateApplicationConfiguration(a){const{added:l,updated:g,removed:$,overrides:v}=u(this.applicationConfiguration,a),y=[...l,...g,...$];return y.length&&this.updateApplicationConfiguration(a),{keys:y,overrides:v}}compareAndUpdateLocalUserConfiguration(a){const{added:l,updated:g,removed:$,overrides:v}=u(this.localUserConfiguration,a),y=[...l,...g,...$];return y.length&&this.updateLocalUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateRemoteUserConfiguration(a){const{added:l,updated:g,removed:$,overrides:v}=u(this.remoteUserConfiguration,a),y=[...l,...g,...$];return y.length&&this.updateRemoteUserConfiguration(a),{keys:y,overrides:v}}compareAndUpdateWorkspaceConfiguration(a){const{added:l,updated:g,removed:$,overrides:v}=u(this.workspaceConfiguration,a),y=[...l,...g,...$];return y.length&&this.updateWorkspaceConfiguration(a),{keys:y,overrides:v}}compareAndUpdateFolderConfiguration(a,l){const g=this.folderConfigurations.get(a),{added:$,updated:v,removed:y,overrides:h}=u(g,l),E=[...$,...v,...y];return(E.length||!g)&&this.updateFolderConfiguration(a,l),{keys:E,overrides:h}}compareAndDeleteFolderConfiguration(a){const l=this.folderConfigurations.get(a);if(!l)throw new Error("Unknown folder");this.deleteFolderConfiguration(a);const{added:g,updated:$,removed:v,overrides:y}=u(l,void 0);return{keys:[...g,...$,...v],overrides:y}}get defaults(){return this.j}get applicationConfiguration(){return this.m}get userConfiguration(){return this.v||(this.v=this.p.isEmpty()?this.n:this.n.merge(this.p)),this.v}get localUserConfiguration(){return this.n}get remoteUserConfiguration(){return this.p}get workspaceConfiguration(){return this.q}get folderConfigurations(){return this.r}w(a,l,g){let $=this.x(l,g);return l.overrideIdentifier&&($=$.override(l.overrideIdentifier)),!this.l.isEmpty()&&this.l.getValue(a)!==void 0&&($=$.merge(this.l)),$}x({resource:a},l){let g=this.y();if(l&&a){const $=l.getFolder(a);$&&(g=this.z($.uri)||g);const v=this.t.get(a);v&&(g=g.merge(v))}return g}y(){return this.h||(this.h=this.j.merge(this.applicationConfiguration,this.userConfiguration,this.q,this.s)),this.h}z(a){let l=this.i.get(a);if(!l){const g=this.y(),$=this.r.get(a);$?(l=g.merge($),this.i.set(a,l)):l=g}return l}A(a,l){if(l&&a){const g=l.getFolder(a);if(g)return this.r.get(g.uri)}}toData(){return{defaults:{contents:this.j.contents,overrides:this.j.overrides,keys:this.j.keys},policy:{contents:this.l.contents,overrides:this.l.overrides,keys:this.l.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this.q.contents,overrides:this.q.overrides,keys:this.q.keys},folders:[...this.r.keys()].reduce((a,l)=>{const{contents:g,overrides:$,keys:v}=this.r.get(l);return a.push([l,{contents:g,overrides:$,keys:v}]),a},[])}}allKeys(){const a=new Set;return this.j.keys.forEach(l=>a.add(l)),this.userConfiguration.keys.forEach(l=>a.add(l)),this.q.keys.forEach(l=>a.add(l)),this.r.forEach(l=>l.keys.forEach(g=>a.add(g))),[...a.values()]}B(){const a=new Set;return this.j.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.userConfiguration.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.q.getAllOverrideIdentifiers().forEach(l=>a.add(l)),this.r.forEach(l=>l.getAllOverrideIdentifiers().forEach(g=>a.add(g))),[...a.values()]}D(a){const l=new Set;return this.j.getKeysForOverrideIdentifier(a).forEach(g=>l.add(g)),this.userConfiguration.getKeysForOverrideIdentifier(a).forEach(g=>l.add(g)),this.q.getKeysForOverrideIdentifier(a).forEach(g=>l.add(g)),this.r.forEach(g=>g.getKeysForOverrideIdentifier(a).forEach($=>l.add($))),[...l.values()]}static parse(a,l){const g=this.E(a.defaults,l),$=this.E(a.policy,l),v=this.E(a.application,l),y=this.E(a.user,l),h=this.E(a.workspace,l),E=a.folders.reduce((k,I)=>(k.set(D.URI.revive(I[0]),this.E(I[1],l)),k),new A.$Ac);return new n(g,$,v,y,f.createEmptyModel(l),h,E,f.createEmptyModel(l),new A.$Ac,l)}static E(a,l){return new f(a.contents,a.keys,a.overrides,void 0,l)}}e.$Do=n;function t(...b){if(b.length===0)return{keys:[],overrides:[]};if(b.length===1)return b[0];const a=new Set,l=new Map;for(const $ of b)$.keys.forEach(v=>a.add(v)),$.overrides.forEach(([v,y])=>{const h=(0,A.$xc)(l,v,new Set);y.forEach(E=>h.add(E))});const g=[];return l.forEach(($,v)=>g.push([v,[...$.values()]])),{keys:[...a.values()],overrides:g}}class c{constructor(a,l,g,$,v){this.change=a,this.f=l,this.g=g,this.h=$,this.i=v,this.a=`
`,this.b=this.a.charCodeAt(0),this.c=46,this.affectedKeys=new Set,this.j=void 0;for(const y of a.keys)this.affectedKeys.add(y);for(const[,y]of a.overrides)for(const h of y)this.affectedKeys.add(h);this.d=this.a;for(const y of this.affectedKeys)this.d+=y+this.a}get previousConfiguration(){return!this.j&&this.f&&(this.j=n.parse(this.f.data,this.i)),this.j}affectsConfiguration(a,l){const g=this.a+a,$=this.d.indexOf(g);if($<0)return!1;const v=$+g.length;if(v>=this.d.length)return!1;const y=this.d.charCodeAt(v);if(y!==this.b&&y!==this.c)return!1;if(l){const h=this.previousConfiguration?this.previousConfiguration.getValue(a,l,this.f?.workspace):void 0,E=this.g.getValue(a,l,this.h);return!p.$9n(h,E)}return!0}}e.$Fo=c;function u(b,a){const{added:l,removed:g,updated:$}=i(a?.rawConfiguration,b?.rawConfiguration),v=[],y=b?.getAllOverrideIdentifiers()||[],h=a?.getAllOverrideIdentifiers()||[];if(a){const E=h.filter(k=>!y.includes(k));for(const k of E)v.push([k,a.getKeysForOverrideIdentifier(k)])}if(b){const E=y.filter(k=>!h.includes(k));for(const k of E)v.push([k,b.getKeysForOverrideIdentifier(k)])}if(a&&b){for(const E of y)if(h.includes(E)){const k=i({contents:b.getOverrideValue(void 0,E)||{},keys:b.getKeysForOverrideIdentifier(E)},{contents:a.getOverrideValue(void 0,E)||{},keys:a.getKeysForOverrideIdentifier(E)});v.push([E,[...k.added,...k.removed,...k.updated]])}}return{added:l,removed:g,updated:$,overrides:v}}function i(b,a){const l=b?a?b.keys.filter(v=>a.keys.indexOf(v)===-1):[...b.keys]:[],g=a?b?a.keys.filter(v=>b.keys.indexOf(v)===-1):[...a.keys]:[],$=[];if(b&&a){for(const v of a.keys)if(b.keys.indexOf(v)!==-1){const y=(0,O.$aj)(a.contents,v),h=(0,O.$aj)(b.contents,v);p.$9n(y,h)||$.push(v)}}return{added:l,removed:g,updated:$}}}),define(Se[104],Ie([1,0,14,3]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ml=e.RemoteAuthorityResolverErrorCode=e.$Ll=e.$Kl=e.RemoteConnectionType=e.$Jl=void 0,e.$Nl=D,e.$Jl=(0,N.$yi)("remoteAuthorityResolverService");var M;(function(O){O[O.WebSocket=0]="WebSocket",O[O.Managed=1]="Managed"})(M||(e.RemoteConnectionType=M={}));class T{constructor(S){this.id=S,this.type=1}toString(){return`Managed(${this.id})`}}e.$Kl=T;class A{constructor(S,d){this.host=S,this.port=d,this.type=0}toString(){return`WebSocket(${this.host}:${this.port})`}}e.$Ll=A;var p;(function(O){O.Unknown="Unknown",O.NotAvailable="NotAvailable",O.TemporarilyNotAvailable="TemporarilyNotAvailable",O.NoResolverFound="NoResolverFound",O.InvalidAuthority="InvalidAuthority"})(p||(e.RemoteAuthorityResolverErrorCode=p={}));class m extends C.$bb{static isNotAvailable(S){return S instanceof m&&S._code===p.NotAvailable}static isTemporarilyNotAvailable(S){return S instanceof m&&S._code===p.TemporarilyNotAvailable}static isNoResolverFound(S){return S instanceof m&&S._code===p.NoResolverFound}static isInvalidAuthority(S){return S instanceof m&&S._code===p.InvalidAuthority}static isHandled(S){return S instanceof m&&S.isHandled}constructor(S,d=p.Unknown,w){super(S),this._message=S,this._code=d,this._detail=w,this.isHandled=d===p.NotAvailable&&w===!0,Object.setPrototypeOf(this,m.prototype)}}e.$Ml=m;function D(O){const S=O.indexOf("+");return S===-1?O:O.substring(0,S)}}),define(Se[58],Ie([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jm=N,e.$Km=M,e.$Lm=T,e.$Mm=A;function N(m){return m.scheme===C.Schemas.vscodeRemote?m.authority:void 0}function M(m){if(!m)return;const D=m.indexOf("+");return D<0?m:m.substr(0,D)}function T(m){const{host:D,port:O}=p(m);if(typeof O>"u")throw new Error(`Invalid remote authority: ${m}. It must either be a remote of form <remoteName>+<arg> or a remote host of form <host>:<port>.`);return{host:D,port:O}}function A(m,D){let{host:O,port:S}=p(m);return typeof S>"u"&&(S=D),{host:O,port:S}}function p(m){const D=m.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(D)return{host:D[1],port:parseInt(D[2],10)};const O=m.match(/^(\[[0-9a-z:]+\])$/);if(O)return{host:O[1],port:void 0};const S=m.match(/(.*):(\d+)$/);return S?{host:S[1],port:parseInt(S[2],10)}:{host:m,port:void 0}}}),define(Se[21],Ie([1,0,13,3,58]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1m=e.$Vm=e.$Um=e.$Tm=e.TargetPlatform=e.ExtensionType=e.$Sm=e.$Qm=e.$Pm=e.$Om=e.$Nm=void 0,e.$Rm=T,e.$Wm=S,e.$Xm=d,e.$Ym=w,e.$Zm=f,e.$Nm="extensions.user.cache",e.$Om="extensions.builtin.cache",e.$Pm="undefined_publisher",e.$Qm=["ui","workspace","web"];function T(o){if(typeof o=="object"&&o!==null&&o.supported!==!0)return o.description}e.$Sm=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","AI","Chat","Other"];var A;(function(o){o[o.System=0]="System",o[o.User=1]="User"})(A||(e.ExtensionType=A={}));var p;(function(o){o.WIN32_X64="win32-x64",o.WIN32_ARM64="win32-arm64",o.LINUX_X64="linux-x64",o.LINUX_ARM64="linux-arm64",o.LINUX_ARMHF="linux-armhf",o.ALPINE_X64="alpine-x64",o.ALPINE_ARM64="alpine-arm64",o.DARWIN_X64="darwin-x64",o.DARWIN_ARM64="darwin-arm64",o.WEB="web",o.UNIVERSAL="universal",o.UNKNOWN="unknown",o.UNDEFINED="undefined"})(p||(e.TargetPlatform=p={}));class m{constructor(r){this.value=r,this._lower=r.toLowerCase()}static equals(r,s){if(typeof r>"u"||r===null)return typeof s>"u"||s===null;if(typeof s>"u"||s===null)return!1;if(typeof r=="string"||typeof s=="string"){const n=typeof r=="string"?r:r.value,t=typeof s=="string"?s:s.value;return C.$zf(n,t)}return r._lower===s._lower}static toKey(r){return typeof r=="string"?r.toLowerCase():r._lower}}e.$Tm=m;class D{get size(){return this.c.size}constructor(r){if(this.c=new Set,r)for(const s of r)this.add(s)}add(r){this.c.add(m.toKey(r))}delete(r){return this.c.delete(m.toKey(r))}has(r){return this.c.has(m.toKey(r))}}e.$Um=D;class O{constructor(){this.c=new Map}clear(){this.c.clear()}delete(r){this.c.delete(m.toKey(r))}get(r){return this.c.get(m.toKey(r))}has(r){return this.c.has(m.toKey(r))}set(r,s){this.c.set(m.toKey(r),s)}values(){return this.c.values()}forEach(r){this.c.forEach(r)}[Symbol.iterator](){return this.c[Symbol.iterator]()}}e.$Vm=O;function S(o){return d(o)}function d(o){return o.contributes&&o.contributes.localizations?o.contributes.localizations.length>0:!1}function w(o){return o.contributes&&o.contributes.authentication?o.contributes.authentication.length>0:!1}function f(o,r){if(r){const s=`onResolveRemoteAuthority:${(0,M.$Km)(r)}`;return!!o.activationEvents?.includes(s)}return!1}e.$1m=(0,N.$yi)("IBuiltinExtensionsScannerService")}),define(Se[105],Ie([1,0,14,21]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rG=e.$qG=void 0;class M{constructor(){this.a=new Map,this.b=new WeakMap}register(A,p){this.a.set(A,p)}readActivationEvents(A){return this.b.has(A)||this.b.set(A,this.c(A)),this.b.get(A)}createActivationEventsMap(A){const p=Object.create(null);for(const m of A){const D=this.readActivationEvents(m);D.length>0&&(p[N.$Tm.toKey(m.identifier)]=D)}return p}c(A){if(typeof A.main>"u"&&typeof A.browser>"u")return[];const p=Array.isArray(A.activationEvents)?A.activationEvents.slice(0):[];for(let m=0;m<p.length;m++)p[m]==="onUri"&&(p[m]=`onUri:${N.$Tm.toKey(A.identifier)}`);if(!A.contributes)return p;for(const m in A.contributes){const D=this.a.get(m);if(!D)continue;const O=A.contributes[m],S=Array.isArray(O)?O:[O];try{D(S,p)}catch(d){(0,C.$1)(d)}}return p}}e.$qG=M,e.$rG=new M}),define(Se[204],Ie([1,0,22,14,6,168,51,3,12,29]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Sp=e.$Rp=void 0,e.$Tp=d,e.$Up=w,e.$Vp=f,e.$Wp=o,e.$Xp=r,e.$Yp=s,e.$Rp=(0,p.$yi)("requestService");class O{constructor(u){this.b=u}toJSON(){if(!this.a){const u=Object.create(null);for(const i in this.b)i.toLowerCase()==="authorization"||i.toLowerCase()==="proxy-authorization"?u[i]="*****":u[i]=this.b[i];this.a=u}return this.a}}class S extends M.$Uc{constructor(u){super(),this.b=0,this.a=u.createLogger("network",{name:(0,T.localize)(0,null),when:m.$kk.isEqualTo((0,m.$hk)(m.LogLevel.Trace)).serialize()})}async c(u,i,b){const a=`${u} #${++this.b}: ${i.url}`;this.a.trace(`${a} - begin`,i.type,new O(i.headers??{}));try{const l=await b();return this.a.trace(`${a} - end`,i.type,l.res.statusCode,l.res.headers),l}catch(l){throw this.a.error(`${a} - error`,i.type,(0,N.$0)(l)),l}}}e.$Sp=S;function d(c){return c.res.statusCode&&c.res.statusCode>=200&&c.res.statusCode<300||c.res.statusCode===1223}function w(c){return c.res.statusCode===204}async function f(c){return w(c)?null:(await(0,C.$Te)(c.stream)).toString()}async function o(c){if(!d(c))throw new Error("Server returned "+c.res.statusCode);return f(c)}async function r(c){if(!d(c))throw new Error("Server returned "+c.res.statusCode);if(w(c))return null;const i=(await(0,C.$Te)(c.stream)).toString();try{return JSON.parse(i)}catch(b){throw b.message+=`:
`+i,b}}function s(c){t(c)}let n;function t(c){const u=D.$fo.as(A.$ko.Configuration),i=n;n={id:"http",order:15,title:(0,T.localize)(1,null),type:"object",scope:c,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks|socks4a?|socks5h?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,T.localize)(2,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,T.localize)(3,null),restricted:!0},"http.proxyKerberosServicePrincipal":{type:"string",markdownDescription:(0,T.localize)(4,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,T.localize)(5,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,T.localize)(6,null),(0,T.localize)(7,null),(0,T.localize)(8,null),(0,T.localize)(9,null)],default:"override",description:(0,T.localize)(10,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,T.localize)(11,null),restricted:!0},"http.experimental.systemCertificatesV2":{type:"boolean",tags:["experimental"],default:!1,description:(0,T.localize)(12,null),restricted:!0}}},u.updateConfigurations({add:[n],remove:i?[i]:[]})}t(1)}),define(Se[205],Ie([1,0,23,75,33]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hp=A,e.$ip=p;function T(m){if(C.$u===2&&/^penguin(\.|$)/i.test(m))return"chromebook"}function A(m,D,O,S,d,w,f,o,r){const s=Object.create(null);s["common.machineId"]=w,s["common.sqmId"]=f,s.sessionID=(0,M.$Ug)()+Date.now(),s.commitHash=S,s.version=d,s["common.platformVersion"]=(m||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),s["common.platform"]=(0,C.$h)(C.$u),s["common.nodePlatform"]=N.$dc,s["common.nodeArch"]=O,s["common.product"]=r||"desktop",o&&(s["common.msftInternal"]=o);let n=0;const t=Date.now();Object.defineProperties(s,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-t,enumerable:!0},"common.sequence":{get:()=>n++,enumerable:!0}}),C.$l&&(s["common.snap"]="true");const c=T(D);return c&&(s["common.platformDetail"]=c),s}function p(m){const D=N.env.USERDNSDOMAIN;if(!D)return!1;const O=D.toLowerCase();return m.some(S=>O===S)}}),define(Se[206],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.$bm=e.$am=e.$_l=e.$$l=e.$0l=e.$9l=e.$8l=e.$7l=e.$6l=e.$5l=e.$4l=void 0,e.$4l=(0,C.$yi)("telemetryService"),e.$5l=(0,C.$yi)("customEndpointTelemetryService"),e.$6l="telemetry.currentSessionDate",e.$7l="telemetry.firstSessionDate",e.$8l="telemetry.lastSessionDate",e.$9l="telemetry.machineId",e.$0l="telemetry.sqmId",e.$$l="telemetry",e.$_l="telemetry.telemetryLevel",e.$am="telemetry.enableCrashReporter",e.$bm="telemetry.enableTelemetry";var N;(function(T){T[T.NONE=0]="NONE",T[T.CRASH=1]="CRASH",T[T.ERROR=2]="ERROR",T[T.USAGE=3]="USAGE"})(N||(e.TelemetryLevel=N={}));var M;(function(T){T.OFF="off",T.CRASH="crash",T.ERROR="error",T.ON="all"})(M||(e.TelemetryConfiguration=M={}))}),define(Se[59],Ie([1,0,26,15,58,205,206]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pp=e.$op=e.$np=e.$mp=e.$lp=e.$kp=e.$jp=void 0,e.$qp=O,e.$rp=S,e.$sp=d,e.$tp=w,e.$up=o,e.$vp=s,e.$wp=n,e.$xp=u;class p{constructor(b){this.value=b,this.isTrustedTelemetryValue=!0}}e.$jp=p;class m{constructor(){this.telemetryLevel=0,this.sessionId="someValue.sessionId",this.machineId="someValue.machineId",this.sqmId="someValue.sqmId",this.firstSessionDate="someValue.firstSessionDate",this.sendErrorTelemetry=!1}publicLog(){}publicLog2(){}publicLogError(){}publicLogError2(){}setExperimentProperty(){}}e.$kp=m,e.$lp=new m;class D{async publicLog(b,a,l){}async publicLogError(b,a,l){}}e.$mp=D,e.$np="telemetry",e.$op="extensionTelemetryLog",e.$pp={log:()=>null,flush:()=>Promise.resolve(null)};function O(i,b){return!b.isBuilt&&!b.disableTelemetry?!0:!(b.disableTelemetry||!i.enableTelemetry)}function S(i,b){return b.extensionTestsLocationURI?!0:!(b.isBuilt||b.disableTelemetry||i.enableTelemetry&&i.aiConfig?.ariaKey)}function d(i){const b=i.getValue(A.$_l),a=i.getValue(A.$am);if(i.getValue(A.$bm)===!1||a===!1)return 0;switch(b??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}function w(i){const b={},a={},l={};r(i,l);for(let g in l){g=g.length>150?g.substr(g.length-149):g;const $=l[g];typeof $=="number"?a[g]=$:typeof $=="boolean"?a[g]=$?1:0:typeof $=="string"?($.length>8192&&console.warn(`Telemetry property: ${g} has been trimmed to 8192, the original length is ${$.length}`),b[g]=$.substring(0,8191)):typeof $<"u"&&$!==null&&(b[g]=$)}return{properties:b,measurements:a}}const f=new Set(["ssh-remote","dev-container","attached-container","wsl","tunnel","codespaces","amlext"]);function o(i){if(!i)return"none";const b=(0,M.$Km)(i);return f.has(b)?b:"other"}function r(i,b,a=0,l){if(i)for(const g of Object.getOwnPropertyNames(i)){const $=i[g],v=l?l+g:g;Array.isArray($)?b[v]=(0,C.$0n)($):$ instanceof Date?b[v]=$.toISOString():(0,N.$ag)($)?a<2?r($,b,a+1,v+"."):b[v]=(0,C.$0n)($):b[v]=$}}function s(i,b){const a=i.msftInternalDomains||[],l=b.getValue("telemetry.internalTesting");return(0,T.$ip)(a)||l}function n(i){return[i.appRoot,i.extensionsPath,i.userHome.fsPath,i.tmpDir.fsPath,i.userDataPath]}function t(i,b){if(!i||!i.includes("/")&&!i.includes("\\"))return i;let a=i;const l=[];for(const y of b)for(;;){const h=y.exec(i);if(!h)break;l.push([h.index,y.lastIndex])}const g=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,$=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let v=0;for(a="";;){const y=$.exec(i);if(!y)break;const h=l.some(([E,k])=>y.index<k&&E<$.lastIndex);!g.test(y[0])&&!h&&(a+=i.substring(v,y.index)+"<REDACTED: user-file-path>",v=$.lastIndex)}return v<i.length&&(a+=i.substr(v)),a}function c(i){if(!i)return i;const b=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"GitHub Token",regex:/(gh[psuro]_[a-zA-Z0-9]{36}|github_pat_[a-zA-Z0-9]{22}_[a-zA-Z0-9]{59})/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/i},{label:"CLI Credentials",regex:/((login|psexec|(certutil|psexec)\.exe).{1,50}(\s-u(ser(name)?)?\s+.{3,100})?\s-(admin|user|vm|root)?p(ass(word)?)?\s+["']?[^$\-\/\s]|(^|[\s\r\n\\])net(\.exe)?.{1,5}(user\s+|share\s+\/user:| user -? secrets ? set) \s + [^ $\s \/])/},{label:"Email",regex:/@[a-zA-Z0-9-]+\.[a-zA-Z0-9-]+/}];for(const a of b)if(a.regex.test(i))return`<REDACTED: ${a.label}>`;return i}function u(i,b){return(0,C.$7n)(i,a=>{if(a instanceof p||Object.hasOwnProperty.call(a,"isTrustedTelemetryValue"))return a.value;if(typeof a=="string"){let l=a.replaceAll("%20"," ");l=t(l,b);for(const g of b)l=l.replace(g,"");return l=c(l),l}})}}),define(Se[207],Ie([1,0,13,100,21,23,2,14,75,59]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hp=e.$zp=void 0,e.$yp=O,e.$Ap=f,e.$Bp=o,e.$Cp=r,e.$Dp=s,e.$Ep=n,e.$Fp=t,e.$Gp=c,e.$Ip=u,e.$Jp=b;function O(a,l){return a.uuid&&l.uuid?a.uuid===l.uuid:a.id===l.id?!0:(0,C.$uf)(a.id,l.id)===0}const S=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class d{static create(l){const g=l.manifest?l.manifest.version:l.version,$=l.manifest?l.targetPlatform:l.properties.targetPlatform;return new d(l.identifier,g,$)}static parse(l){const g=S.exec(l);return g&&g[1]&&g[2]?new d({id:g[1]},g[2],g[4]||void 0):null}constructor(l,g,$="undefined"){this.version=g,this.targetPlatform=$,this.id=l.id}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(l){return l instanceof d?O(this,l)&&this.version===l.version&&this.targetPlatform===l.targetPlatform:!1}}e.$zp=d;const w=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function f(a){const l=w.exec(a);return l&&l[1]?[r(l[1]),l[2]]:[r(a),void 0]}function o(a,l){return`${a}.${l}`}function r(a){return a.toLowerCase()}function s(a,l){return r(o(a??M.$Pm,l))}function n(a,l){const g=[],$=v=>{for(const y of g)if(y.some(h=>O(l(h),l(v))))return y;return null};for(const v of a){const y=$(v);y?y.push(v):g.push([v])}return g}function t(a){return{id:a.identifier.id,name:a.manifest.name,galleryId:null,publisherId:a.publisherId,publisherName:a.manifest.publisher,publisherDisplayName:a.publisherDisplayName,dependencies:a.manifest.extensionDependencies&&a.manifest.extensionDependencies.length>0}}function c(a){return{id:new D.$jp(a.identifier.id),name:new D.$jp(a.name),version:a.version,galleryId:a.identifier.uuid,publisherId:a.publisherId,publisherName:a.publisher,publisherDisplayName:a.publisherDisplayName,isPreReleaseVersion:a.properties.isPreReleaseVersion,dependencies:!!(a.properties.dependencies&&a.properties.dependencies.length>0),isSigned:a.isSigned,...a.telemetryData}}e.$Hp=new M.$Tm("pprice.better-merge");function u(a,l){const g=[],$=l.manifest.extensionDependencies?.slice(0)??[];for(;$.length;){const v=$.shift();if(v&&g.every(y=>!O(y.identifier,{id:v}))){const y=a.filter(h=>O(h.identifier,{id:v}));y.length===1&&(g.push(y[0]),$.push(...y[0].manifest.extensionDependencies?.slice(0)??[]))}}return g}async function i(a,l){if(!T.$k)return!1;let g;try{g=(await a.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{g=(await a.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(v){l.debug("Error while getting the os-release file.",(0,p.$0)(v))}}return!!g&&(g.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}async function b(a,l){const g=await i(a,l),$=(0,N.$6o)(g?"alpine":T.$u,m.$ec);return l.debug("ComputeTargetPlatform:",$),$}}),define(Se[208],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qs=C,e.$rs=N,e.$ss=M,e.$ts=T,e.$us=A,e.$vs=p;function C(m){return[...m.entries()]}function N(m){return m?[...m.entries()]:[]}function M(m){return new Map(m)}function T(m){return new Map(m??[])}function A(m){return Array.from(m.entries()).map(D=>[D[0],C(D[1].map),N(D[1].descriptionMap)])}function p(m){return new Map(m.map(D=>[D[0],{map:M(D[1]),descriptionMap:T(D[2])}]))}}),define(Se[209],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fwb=void 0;class C{constructor(M){this.b=M,this.a=new Map}dispose(){for(const M of this.a.values())M.dispose()}startBuffering(M,T,A=5){const p=T(m=>{const D=typeof m=="string"?m:m.data;let O=this.a.get(M);if(O){O.data.push(D);return}const S=setTimeout(()=>this.flushBuffer(M),A);O={data:[D],timeoutId:S,dispose:()=>{clearTimeout(S),this.flushBuffer(M),p.dispose()}},this.a.set(M,O)});return p}stopBuffering(M){this.a.get(M)?.dispose()}flushBuffer(M){const T=this.a.get(M);T&&(this.a.delete(M),this.b(M,T.data.join("")))}}e.$fwb=C}),define(Se[210],Ie([1,0,11,92,312,36,5,15,2,169,74,29]),function(le,e,C,N,M,T,A,p,m,D,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rx=e.$qx=e.$px=e.$ox=e.$nx=e.$mx=e.IconFontDefinition=e.IconContribution=e.$jx=void 0,e.$kx=r,e.$lx=s,e.$jx={IconContribution:"base.contributions.icons"};var d;(function(u){function i(b,a){let l=b.defaults;for(;T.ThemeIcon.isThemeIcon(l);){const g=o.getIcon(l.id);if(!g)return;l=g.defaults}return l}u.getDefinition=i})(d||(e.IconContribution=d={}));var w;(function(u){function i(a){return{weight:a.weight,style:a.style,src:a.src.map(l=>({format:l.format,location:l.location.toString()}))}}u.toJSONObject=i;function b(a){const l=g=>(0,p.$$f)(g)?g:void 0;if(a&&Array.isArray(a.src)&&a.src.every(g=>(0,p.$$f)(g.format)&&(0,p.$$f)(g.location)))return{weight:l(a.weight),style:l(a.style),src:a.src.map(g=>({format:g.format,location:m.URI.parse(g.location)}))}}u.fromJSONObject=b})(w||(e.IconFontDefinition=w={}));class f{constructor(){this.a=new A.$fe,this.onDidChange=this.a.event,this.d={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,D.localize)(0,null)},fontCharacter:{type:"string",description:(0,D.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.e={type:"string",pattern:`^${T.ThemeIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.b={},this.f={}}registerIcon(i,b,a,l){const g=this.b[i];if(g){if(a&&!g.description){g.description=a,this.d.properties[i].markdownDescription=`${a} $(${i})`;const y=this.e.enum.indexOf(i);y!==-1&&(this.e.enumDescriptions[y]=a),this.a.fire()}return g}const $={id:i,description:a,defaults:b,deprecationMessage:l};this.b[i]=$;const v={$ref:"#/definitions/icons"};return l&&(v.deprecationMessage=l),a&&(v.markdownDescription=`${a}: $(${i})`),this.d.properties[i]=v,this.e.enum.push(i),this.e.enumDescriptions.push(a||""),this.a.fire(),{id:i}}deregisterIcon(i){delete this.b[i],delete this.d.properties[i];const b=this.e.enum.indexOf(i);b!==-1&&(this.e.enum.splice(b,1),this.e.enumDescriptions.splice(b,1)),this.a.fire()}getIcons(){return Object.keys(this.b).map(i=>this.b[i])}getIcon(i){return this.b[i]}getIconSchema(){return this.d}getIconReferenceSchema(){return this.e}registerIconFont(i,b){const a=this.f[i];return a||(this.f[i]=b,this.a.fire(),b)}deregisterIconFont(i){delete this.f[i]}getIconFont(i){return this.f[i]}toString(){const i=(g,$)=>g.id.localeCompare($.id),b=g=>{for(;T.ThemeIcon.isThemeIcon(g.defaults);)g=this.b[g.defaults.id];return`codicon codicon-${g?g.id:""}`},a=[];a.push("| preview     | identifier                        | default codicon ID                | description"),a.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const l=Object.keys(this.b).map(g=>this.b[g]);for(const g of l.filter($=>!!$.description).sort(i))a.push(`|<i class="${b(g)}"></i>|${g.id}|${T.ThemeIcon.isThemeIcon(g.defaults)?g.defaults.id:g.id}|${g.description||""}|`);a.push("| preview     | identifier                        "),a.push("| ----------- | --------------------------------- |");for(const g of l.filter($=>!T.ThemeIcon.isThemeIcon($.defaults)).sort(i))a.push(`|<i class="${b(g)}"></i>|${g.id}|`);return a.join(`
`)}}const o=new f;S.$fo.add(e.$jx.IconContribution,o);function r(u,i,b,a){return o.registerIcon(u,i,b,a)}function s(){return o}function n(){const u=(0,M.$Tj)();for(const i in u){const b="\\"+u[i].toString(16);o.registerIcon(i,{fontCharacter:b})}}n(),e.$mx="vscode://schemas/icons";const t=S.$fo.as(O.$go.JSONContribution);t.registerSchema(e.$mx,o.getIconSchema());const c=new C.$Kh(()=>t.notifySchemaChanged(e.$mx),200);o.onDidChange(()=>{c.isScheduled()||c.schedule()}),e.$nx=r("widget-close",N.$Xj.close,(0,D.localize)(2,null)),e.$ox=r("goto-previous-location",N.$Xj.arrowUp,(0,D.localize)(3,null)),e.$px=r("goto-next-location",N.$Xj.arrowDown,(0,D.localize)(4,null)),e.$qx=T.ThemeIcon.modify(N.$Xj.sync,"spin"),e.$rx=T.ThemeIcon.modify(N.$Xj.loading,"spin")}),define(Se[211],Ie([1,0,5,2,50,3,12]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$yw=e.$xw=e.$uw=e.$sw=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.$ow=e.$nw=void 0,e.$pw=D,e.$qw=S,e.$rw=d,e.$tw=w,e.$vw=f,e.$ww=o,e.$nw=(0,T.$yi)("tunnelService"),e.$ow=(0,T.$yi)("sharedTunnelsService");var p;(function(n){n.Http="http",n.Https="https"})(p||(e.TunnelProtocol=p={}));var m;(function(n){n.ConstantPrivate="constantPrivate",n.Private="private",n.Public="public"})(m||(e.TunnelPrivacyId=m={}));function D(n){return!!n.forwardPort}var O;(function(n){n[n.Notify=1]="Notify",n[n.OpenBrowser=2]="OpenBrowser",n[n.OpenPreview=3]="OpenPreview",n[n.Silent=4]="Silent",n[n.Ignore=5]="Ignore",n[n.OpenBrowserOnce=6]="OpenBrowserOnce"})(O||(e.ProvidedOnAutoForward=O={}));function S(n){if(n.scheme!=="http"&&n.scheme!=="https")return;const t=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(n.authority);if(t)return{address:t[1],port:+t[2]}}function d(n){if(n.scheme!=="http"&&n.scheme!=="https"||!n.query)return;const t=n.query.split("&");for(const c of t){const u=c.split("=")[1];if(/^https?:/.exec(u)){const i=S(N.URI.parse(u));if(i)return i}}}e.$sw=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function w(n){return e.$sw.indexOf(n)>=0}e.$uw=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function f(n){return e.$uw.indexOf(n)>=0}function o(n,t,c,u){if(c===1)return!1;if(c===2&&f(t)){const i=/(\d+)\.(\d+)\.(\d+)/g.exec(u);if(i?.length===4&&parseInt(i[1])>=18)return!1}return n<1024}class r{constructor(t,c,u){this.remoteAddress=t,this.localAddress=c,this.b=u,this.a=new C.$fe,this.onDidDispose=this.a.event}dispose(){return this.a.fire(),this.b()}}e.$xw=r;let s=class{constructor(t,c){this.k=t,this.l=c,this.a=new C.$fe,this.onTunnelOpened=this.a.event,this.b=new C.$fe,this.onTunnelClosed=this.b.event,this.c=new C.$fe,this.onAddedTunnelProvider=this.c.event,this.e=new Map,this.g=!1,this.h=!0,this.i=[],this.j=new Set}get hasTunnelProvider(){return!!this.f}get m(){const t=this.l.getValue("remote.localPortHost");return!t||t==="localhost"?"127.0.0.1":"0.0.0.0"}setTunnelProvider(t){return this.f=t,t?(this.c.fire(),{dispose:()=>{this.f=void 0,this.g=!1,this.i=[]}}):(this.g=!1,this.i=[],this.c.fire(),{dispose:()=>{}})}setTunnelFeatures(t){this.g=t.elevation,this.i=t.privacyOptions,this.h=t.protocol}get canChangeProtocol(){return this.h}get canElevate(){return this.g}get canChangePrivacy(){return this.i.length>0}get privacyOptions(){return this.i}get tunnels(){return this.n()}async n(){const t=[],c=Array.from(this.e.values());for(const u of c){const i=Array.from(u.values());for(const b of i){const a=await b.value;a&&typeof a!="string"&&t.push(a)}}return t}async dispose(){for(const t of this.e.values()){for(const{value:c}of t.values())await c.then(u=>typeof u!="string"?u?.dispose():void 0);t.clear()}this.e.clear()}setEnvironmentTunnel(t,c,u,i,b){this.q(t,c,Promise.resolve({tunnelRemoteHost:t,tunnelRemotePort:c,localAddress:u,privacy:i,protocol:b,dispose:()=>Promise.resolve()}))}async getExistingTunnel(t,c){(f(t)||w(t))&&(t=e.$sw[0]);const u=this.s(t,c);if(u)return++u.refcount,u.value}openTunnel(t,c,u,i,b,a=!1,l,g){this.k.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${c}:${u} on local port ${b}.`);const $=this.f??t;if(!$)return;if(c||(c="localhost"),i||(i=this.m),this.f&&this.j.has(u)){this.k.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const v=this.t($,c,u,i,b,a,l,g);return v?v.then(y=>{if(y){if(typeof y=="string")return this.k.trace("ForwardedPorts: (TunnelService) The tunnel provider returned an error when creating the tunnel."),this.r(c,u),y}else{this.k.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.r(c,u);return}this.k.trace("ForwardedPorts: (TunnelService) New tunnel established.");const h=this.o(y);return(y.tunnelRemoteHost!==c||y.tunnelRemotePort!==u)&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),l&&y.privacy!==l&&this.k.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Privacy mismatch."),this.a.fire(h),h}):(this.k.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),v)}o(t){return{tunnelRemotePort:t.tunnelRemotePort,tunnelRemoteHost:t.tunnelRemoteHost,tunnelLocalPort:t.tunnelLocalPort,localAddress:t.localAddress,privacy:t.privacy,protocol:t.protocol,dispose:async()=>{this.k.trace(`ForwardedPorts: (TunnelService) dispose request for ${t.tunnelRemoteHost}:${t.tunnelRemotePort} `);const c=this.e.get(t.tunnelRemoteHost);if(c){const u=c.get(t.tunnelRemotePort);u&&(u.refcount--,await this.p(t.tunnelRemoteHost,t.tunnelRemotePort,u))}}}}async p(t,c,u){if(u.refcount<=0){this.k.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${t}:${c}.`);const i=u.value.then(async b=>{b&&typeof b!="string"&&(await b.dispose(!0),this.b.fire({host:b.tunnelRemoteHost,port:b.tunnelRemotePort}))});return this.e.has(t)&&this.e.get(t).delete(c),i}}async closeTunnel(t,c){this.k.trace(`ForwardedPorts: (TunnelService) close request for ${t}:${c} `);const u=this.e.get(t);if(u&&u.has(c)){const i=u.get(c);i.refcount=0,await this.p(t,c,i)}}q(t,c,u){this.e.has(t)||this.e.set(t,new Map),this.e.get(t).set(c,{refcount:1,value:u})}async r(t,c){const u=this.e.get(t);if(u){const i=u.get(c),b=i?await i.value:void 0;(!b||typeof b=="string")&&u.delete(c),u.size===0&&this.e.delete(t)}}s(t,c){const u=[t];w(t)?(u.push(...e.$sw),u.push(...e.$uw)):f(t)&&u.push(...e.$uw);const i=u.map(b=>this.e.get(b));for(const b of i){const a=b?.get(c);if(a)return a}}canTunnel(t){return!!S(t)}u(t,c,u,i,b,a,l){this.k.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${c}:${u} on local port ${i}.`);const g=u;this.j.add(g);const $=i===void 0?u:i,v={elevationRequired:b?this.isPortPrivileged($):!1},y={remoteAddress:{host:c,port:u},localAddressPort:i,privacy:a,public:a?a!==m.Private:void 0,protocol:l},h=t.forwardPort(y,v);return h?(this.q(c,u,h),h.finally(()=>{this.k.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this.j.delete(g)})):this.j.delete(g),h}};e.$yw=s,e.$yw=s=Je([We(0,A.$5j),We(1,M.$5i)],s)}),define(Se[212],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cl=void 0,e.$Cl=(0,C.$yi)("IUriIdentityService")}),define(Se[213],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditSessionIdentityMatch=e.$zw=void 0,e.$zw=(0,C.$yi)("editSessionIdentityService");var N;(function(M){M[M.Complete=100]="Complete",M[M.Partial=50]="Partial",M[M.None=0]="None"})(N||(e.EditSessionIdentityMatch=N={}))}),define(Se[214],Ie([1,0,16]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$UL=N,e.$VL=M,e.$WL=T,e.$XL=A,e.$YL=p;function N(m){return m.scheme!==C.Schemas.file&&m.scheme!==C.Schemas.vscodeRemote}function M(m){if(m.folders.length)return m.folders.every(D=>N(D.uri))?m.folders[0].uri:void 0;if(m.configuration&&N(m.configuration))return m.configuration}function T(m){return M(m)?.scheme}function A(m){return M(m)?.authority}function p(m){return M(m)!==void 0}}),define(Se[46],Ie([1,0,171,19,54,24,2,3,16]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1i=e.$Xi=e.$Wi=e.$Vi=e.$Ui=e.$Si=e.$Ri=e.WorkbenchState=e.$Li=e.$Ki=e.$Hi=void 0,e.$Ii=D,e.$Ji=O,e.$Mi=S,e.$Ni=d,e.$Oi=w,e.$Pi=o,e.$Qi=r,e.$Ti=t,e.$Yi=c,e.$Zi=u,e.$2i=i,e.$3i=b,e.$4i=a,e.$Hi=(0,p.$yi)("contextService");function D(l){const g=l;return typeof g?.id=="string"&&A.URI.isUri(g.uri)}function O(l){return typeof l?.id=="string"&&!D(l)&&!d(l)}e.$Ki={id:"ext-dev"},e.$Li={id:"empty-window"};function S(l,g){if(typeof l=="string"||typeof l>"u")return typeof l=="string"?{id:(0,N.$nc)(l)}:g?e.$Ki:e.$Li;const $=l;return $.configuration?{id:$.id,configPath:$.configuration}:$.folders.length===1?{id:$.id,uri:$.folders[0].uri}:{id:$.id}}function d(l){const g=l;return typeof g?.id=="string"&&A.URI.isUri(g.configPath)}function w(l){const g=l;if(g?.uri)return{id:g.id,uri:A.URI.revive(g.uri)};const $=l;if($?.configPath)return{id:$.id,configPath:A.URI.revive($.configPath)};if(l?.id)return{id:l.id}}var f;(function(l){l[l.EMPTY=1]="EMPTY",l[l.FOLDER=2]="FOLDER",l[l.WORKSPACE=3]="WORKSPACE"})(f||(e.WorkbenchState=f={}));function o(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&Array.isArray(g.folders))}function r(l){const g=l;return!!(g&&typeof g=="object"&&A.URI.isUri(g.uri)&&typeof g.name=="string"&&typeof g.toResource=="function")}class s{constructor(g,$,v,y,h){this.h=g,this.j=v,this.k=y,this.l=h,this.c=M.$Ei.forUris(this.l,()=>!0),this.folders=$}update(g){this.h=g.id,this.k=g.configuration,this.j=g.transient,this.l=g.l,this.folders=g.folders}get folders(){return this.g}set folders(g){this.g=g,this.n()}get id(){return this.h}get transient(){return this.j}get configuration(){return this.k}set configuration(g){this.k=g}getFolder(g){return g&&this.c.findSubstr(g)||null}n(){this.c=M.$Ei.forUris(this.l,()=>!0);for(const g of this.folders)this.c.set(g.uri,g)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.$Ri=s;class n{constructor(g,$){this.raw=$,this.uri=g.uri,this.index=g.index,this.name=g.name}toResource(g){return(0,T.$_g)(this.uri,g)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.$Si=n;function t(l){return new n({uri:l,index:0,name:(0,T.$8g)(l)},{uri:l.toString()})}e.$Ui="code-workspace",e.$Vi=`.${e.$Ui}`,e.$Wi=[{name:(0,C.localize)(0,null),extensions:[e.$Ui]}],e.$Xi="workspace.json";function c(l,g){return T.$3g.isEqualOrParent(l,g.untitledWorkspacesHome)}function u(l){let g;return A.URI.isUri(l)?g=l:g=l.configuration,g?.scheme===m.Schemas.tmp}e.$1i="4064f6ec-cb38-4ad0-af64-ee6467e63c82";function i(l){return l.id===e.$1i}function b(l,g){return!c(l,g)&&!u(l)}function a(l){return(typeof l=="string"?(0,N.$oc)(l):(0,T.$0g)(l))===e.$Vi}}),define(Se[215],Ie([1,0,73,5,6,24,2,170,99,38,3,12,46,28,212,11,33,13,15]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Il=e.$Hl=e.$El=e.ProfileResourceType=void 0,e.$Dl=c,e.$Fl=u,e.$Gl=i;var t;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(t||(e.ProfileResourceType=t={}));function c(l){const g=l;return!!(g&&typeof g=="object"&&typeof g.id=="string"&&typeof g.isDefault=="boolean"&&typeof g.name=="string"&&A.URI.isUri(g.location)&&A.URI.isUri(g.globalStorageHome)&&A.URI.isUri(g.settingsResource)&&A.URI.isUri(g.keybindingsResource)&&A.URI.isUri(g.tasksResource)&&A.URI.isUri(g.snippetsHome)&&A.URI.isUri(g.extensionsResource))}e.$El=(0,O.$yi)("IUserDataProfilesService");function u(l,g){return{id:l.id,isDefault:l.isDefault,name:l.name,shortName:l.shortName,icon:l.icon,location:A.URI.revive(l.location).with({scheme:g}),globalStorageHome:A.URI.revive(l.globalStorageHome).with({scheme:g}),settingsResource:A.URI.revive(l.settingsResource).with({scheme:g}),keybindingsResource:A.URI.revive(l.keybindingsResource).with({scheme:g}),tasksResource:A.URI.revive(l.tasksResource).with({scheme:g}),snippetsHome:A.URI.revive(l.snippetsHome).with({scheme:g}),extensionsResource:A.URI.revive(l.extensionsResource).with({scheme:g}),cacheHome:A.URI.revive(l.cacheHome).with({scheme:g}),useDefaultFlags:l.useDefaultFlags,isTransient:l.isTransient}}function i(l,g,$,v,y,h){return{id:l,name:g,location:$,isDefault:!1,shortName:y?.shortName,icon:y?.icon,globalStorageHome:h&&y?.useDefaultFlags?.globalState?h.globalStorageHome:(0,T.$_g)($,"globalStorage"),settingsResource:h&&y?.useDefaultFlags?.settings?h.settingsResource:(0,T.$_g)($,"settings.json"),keybindingsResource:h&&y?.useDefaultFlags?.keybindings?h.keybindingsResource:(0,T.$_g)($,"keybindings.json"),tasksResource:h&&y?.useDefaultFlags?.tasks?h.tasksResource:(0,T.$_g)($,"tasks.json"),snippetsHome:h&&y?.useDefaultFlags?.snippets?h.snippetsHome:(0,T.$_g)($,"snippets"),extensionsResource:h&&y?.useDefaultFlags?.extensions?h.extensionsResource:(0,T.$_g)($,"extensions.json"),cacheHome:(0,T.$_g)(v,l),useDefaultFlags:y?.useDefaultFlags,isTransient:y?.transient}}let b=class extends M.$Uc{static{this.b="userDataProfiles"}static{this.c="profileAssociations"}get defaultProfile(){return this.profiles[0]}get profiles(){return[...this.C.profiles,...this.s.profiles]}constructor(g,$,v,y){super(),this.t=g,this.u=$,this.w=v,this.y=y,this.f=!0,this.h=this.B(new N.$fe),this.onDidChangeProfiles=this.h.event,this.j=this.B(new N.$fe),this.onWillCreateProfile=this.j.event,this.m=this.B(new N.$fe),this.onWillRemoveProfile=this.m.event,this.n=this.B(new N.$fe),this.onDidResetWorkspaces=this.n.event,this.r=new Map,this.s={profiles:[],workspaces:new w.$Ac,emptyWindows:new Map},this.profilesHome=(0,T.$_g)(this.t.userRoamingDataHome,"profiles"),this.g=(0,T.$_g)(this.t.cacheHome,"CachedProfilesData")}init(){this.z=void 0}setEnablement(g){this.f!==g&&(this.z=void 0,this.f=g)}isEnabled(){return this.f}get C(){if(!this.z){const g=this.D(),$=[g];if(this.f)try{for(const h of this.O()){if(!h.name||!(0,n.$$f)(h.name)||!h.location){this.y.warn("Skipping the invalid stored profile",h.location||h.name);continue}$.push(i((0,T.$9g)(h.location),h.name,h.location,this.g,{shortName:h.shortName,icon:h.icon,useDefaultFlags:h.useDefaultFlags},g))}}catch(h){this.y.error(h)}const v=new w.$Ac,y=new Map;if($.length)try{const h=this.Q();if(h.workspaces)for(const[E,k]of Object.entries(h.workspaces)){const I=A.URI.parse(E),P=$.find(V=>V.id===k);P&&v.set(I,P)}if(h.emptyWindows)for(const[E,k]of Object.entries(h.emptyWindows)){const I=$.find(P=>P.id===k);I&&y.set(E,I)}}catch(h){this.y.error(h)}this.z={profiles:$,workspaces:v,emptyWindows:y}}return this.z}D(){const g=i("__default__profile__",(0,p.localize)(0,null),this.t.userRoamingDataHome,this.g);return{...g,extensionsResource:this.S()??g.extensionsResource,isDefault:!0}}async createTransientProfile(g){const $="Temp",v=new RegExp(`${(0,s.$bf)($)}\\s(\\d+)`);let y=0;for(const E of this.profiles){const k=v.exec(E.name),I=k?parseInt(k[1]):0;y=I>y?I:y}const h=`${$} ${y+1}`;return this.createProfile((0,C.$mj)((0,r.$Ug)()).toString(16),h,{transient:!0},g)}async createNamedProfile(g,$,v){return this.createProfile((0,C.$mj)((0,r.$Ug)()).toString(16),g,$,v)}async createProfile(g,$,v,y){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const h=await this.F(g,$,v);return y&&await this.setProfileForWorkspace(y,h),h}async F(g,$,v){if(!(0,n.$$f)($)||!$)throw new Error("Name of the profile is mandatory and must be of type `string`");let y=this.r.get($);return y||(y=(async()=>{try{if(this.profiles.find(I=>I.name===$||I.id===g))throw new Error(`Profile with ${$} name already exists`);const E=i(g,$,(0,T.$_g)(this.profilesHome,g),this.g,v,this.defaultProfile);await this.u.createFolder(E.location);const k=[];return this.j.fire({profile:E,join(I){k.push(I)}}),await o.Promises.settled(k),this.I([E],[],[]),E}finally{this.r.delete($)}})(),this.r.set($,y)),y}async updateProfile(g,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");let v=this.profiles.find(y=>y.id===g.id);if(!v)throw new Error(`Profile '${g.name}' does not exist`);return v=i(v.id,$.name??v.name,v.location,this.g,{shortName:$.shortName??v.shortName,icon:$.icon===null?void 0:$.icon??v.icon,transient:$.transient??v.isTransient,useDefaultFlags:$.useDefaultFlags??v.useDefaultFlags},this.defaultProfile),this.I([],[],[v]),v}async removeProfile(g){if(!this.f)throw new Error("Profiles are disabled in the current environment.");if(g.isDefault)throw new Error("Cannot remove default profile");const $=this.profiles.find(y=>y.id===g.id);if(!$)throw new Error(`Profile '${g.name}' does not exist`);const v=[];this.m.fire({profile:$,join(y){v.push(y)}});try{await Promise.allSettled(v)}catch(y){this.y.error(y)}for(const y of[...this.C.emptyWindows.keys()])$.id===this.C.emptyWindows.get(y)?.id&&this.C.emptyWindows.delete(y);for(const y of[...this.C.workspaces.keys()])$.id===this.C.workspaces.get(y)?.id&&this.C.workspaces.delete(y);this.M(),this.I([],[$],[]);try{await this.u.del($.cacheHome,{recursive:!0})}catch(y){(0,D.$jl)(y)!==1&&this.y.error(y)}}async setProfileForWorkspace(g,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");const v=this.profiles.find(y=>y.id===$.id);if(!v)throw new Error(`Profile '${$.name}' does not exist`);this.L(g,v)}unsetWorkspace(g,$){if(!this.f)throw new Error("Profiles are disabled in the current environment.");this.L(g,void 0,$)}async resetWorkspaces(){this.s.workspaces.clear(),this.s.emptyWindows.clear(),this.C.workspaces.clear(),this.C.emptyWindows.clear(),this.M(),this.n.fire()}async cleanUp(){if(this.f&&await this.u.exists(this.profilesHome)){const g=await this.u.resolve(this.profilesHome);await Promise.all((g.children||[]).filter($=>$.isDirectory&&this.profiles.every(v=>!this.w.extUri.isEqual(v.location,$.resource))).map($=>this.u.del($.resource,{recursive:!0})))}}async cleanUpTransientProfiles(){if(!this.f)return;const g=this.s.profiles.filter($=>!this.H($));await Promise.allSettled(g.map($=>this.removeProfile($)))}getProfileForWorkspace(g){const $=this.G(g);return A.URI.isUri($)?this.s.workspaces.get($)??this.C.workspaces.get($):this.s.emptyWindows.get($)??this.C.emptyWindows.get($)}G(g){return(0,d.$Ii)(g)?g.uri:(0,d.$Ni)(g)?g.configPath:g.id}H(g){return!!([...this.s.emptyWindows.values()].some($=>this.w.extUri.isEqual($.location,g.location))||[...this.s.workspaces.values()].some($=>this.w.extUri.isEqual($.location,g.location))||[...this.C.emptyWindows.values()].some($=>this.w.extUri.isEqual($.location,g.location))||[...this.C.workspaces.values()].some($=>this.w.extUri.isEqual($.location,g.location)))}I(g,$,v){const y=[...this.profiles,...g],h=[];this.s.profiles=[];for(let E of y)E.isDefault||$.some(k=>E.id===k.id)||(E=v.find(k=>E.id===k.id)??E,E.isTransient?this.s.profiles.push(E):h.push({location:E.location,name:E.name,shortName:E.shortName,icon:E.icon,useDefaultFlags:E.useDefaultFlags}));this.P(h),this.z=void 0,this.J(g,$,v)}J(g,$,v){this.h.fire({added:g,removed:$,updated:v,all:this.profiles})}L(g,$,v){v=$?.isTransient?!0:v,v||this.L(g,void 0,!0);const y=this.G(g),h=v?this.s:this.C;A.URI.isUri(y)?(h.workspaces.delete(y),$&&h.workspaces.set(y,$)):(h.emptyWindows.delete(y),$&&h.emptyWindows.set(y,$)),v||this.M()}M(){const g={};for(const[v,y]of this.C.workspaces.entries())g[v.toString()]=y.id;const $={};for(const[v,y]of this.C.emptyWindows.entries())$[v.toString()]=y.id;this.R({workspaces:g,emptyWindows:$}),this.z=void 0}N(g){const $={},v=this.D();if(g.workspaces)for(const[h,E]of Object.entries(g.workspaces)){const k=A.URI.parse(E);$[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}const y={};if(g.emptyWindows)for(const[h,E]of Object.entries(g.emptyWindows)){const k=A.URI.parse(E);y[h]=this.w.extUri.isEqual(k,v.location)?v.id:this.w.extUri.basename(k)}return{workspaces:$,emptyWindows:y}}O(){return[]}P(g){throw new Error("not implemented")}Q(){return{}}R(g){throw new Error("not implemented")}S(){}};e.$Hl=b,e.$Hl=b=Je([We(0,m.$Fi),We(1,D.$5k),We(2,f.$Cl),We(3,S.$5j)],b);class a extends b{constructor(){super(...arguments),this.a=[],this.X={}}O(){return this.a}P(g){this.a=g}Q(){return this.X}R(g){this.X=g}}e.$Il=a}),define(Se[216],Ie([1,0,11,5,6,60,15,151,3,215]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9p=e.$7p=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.$5p=e.$4p=e.$3p=void 0,e.$6p=w,e.$8p=o,e.$0p=s,e.$3p="__$__isNewStorageMarker",e.$4p="__$__targetStorageMarker",e.$5p=(0,m.$yi)("storageService");var O;(function(n){n[n.NONE=0]="NONE",n[n.SHUTDOWN=1]="SHUTDOWN"})(O||(e.WillSaveStateReason=O={}));var S;(function(n){n[n.APPLICATION=-1]="APPLICATION",n[n.PROFILE=0]="PROFILE",n[n.WORKSPACE=1]="WORKSPACE"})(S||(e.StorageScope=S={}));var d;(function(n){n[n.USER=0]="USER",n[n.MACHINE=1]="MACHINE"})(d||(e.StorageTarget=d={}));function w(n){const t=n.get(e.$4p);if(t)try{return JSON.parse(t)}catch{}return Object.create(null)}class f extends M.$Uc{static{this.a=60*1e3}constructor(t={flushInterval:f.a}){super(),this.m=t,this.b=this.B(new N.$ie),this.c=this.B(new N.$ie),this.onDidChangeTarget=this.c.event,this.f=this.B(new N.$fe),this.onWillSaveState=this.f.event,this.h=this.B(new C.$Kh(()=>this.n(),this.m.flushInterval)),this.j=this.B(new M.$Vc),this.C=void 0,this.F=void 0,this.H=void 0}onDidChangeValue(t,c,u){return N.Event.filter(this.b.event,i=>i.scope===t&&(c===void 0||i.key===c),u)}n(){this.j.value=(0,C.$Oh)(()=>{this.r()&&this.flush(),this.h.schedule()})}r(){return!0}t(){(0,M.$Pc)([this.j,this.h])}initialize(){return this.g||(this.g=(async()=>{(0,T.mark)("code/willInitStorage");try{await this.O()}finally{(0,T.mark)("code/didInitStorage")}this.h.schedule()})()),this.g}u(t,c){const{key:u,external:i}=c;if(u===e.$4p){switch(t){case-1:this.H=void 0;break;case 0:this.F=void 0;break;case 1:this.C=void 0;break}this.c.fire({scope:t})}else this.b.fire({scope:t,key:u,target:this.J(t)[u],external:i})}w(t){this.f.fire({reason:t})}get(t,c,u){return this.P(c)?.get(t,u)}getBoolean(t,c,u){return this.P(c)?.getBoolean(t,u)}getNumber(t,c,u){return this.P(c)?.getNumber(t,u)}getObject(t,c,u){return this.P(c)?.getObject(t,u)}storeAll(t,c){this.y(()=>{for(const u of t)this.store(u.key,u.value,u.scope,u.target,c)})}store(t,c,u,i,b=!1){if((0,A.$hg)(c)){this.remove(t,u,b);return}this.y(()=>{this.z(t,u,i),this.P(u)?.set(t,c,b)})}remove(t,c,u=!1){this.y(()=>{this.z(t,c,void 0),this.P(c)?.delete(t,u)})}y(t){this.b.pause(),this.c.pause();try{t()}finally{this.b.resume(),this.c.resume()}}keys(t,c){const u=[],i=this.J(t);for(const b of Object.keys(i))i[b]===c&&u.push(b);return u}z(t,c,u,i=!1){const b=this.J(c);typeof u=="number"?b[t]!==u&&(b[t]=u,this.P(c)?.set(e.$4p,JSON.stringify(b),i)):typeof b[t]=="number"&&(delete b[t],this.P(c)?.set(e.$4p,JSON.stringify(b),i))}get D(){return this.C||(this.C=this.L(1)),this.C}get G(){return this.F||(this.F=this.L(0)),this.F}get I(){return this.H||(this.H=this.L(-1)),this.H}J(t){switch(t){case-1:return this.I;case 0:return this.G;default:return this.D}}L(t){const c=this.P(t);return c?w(c):Object.create(null)}isNew(t){return this.getBoolean(e.$3p,t)===!0}async flush(t=O.NONE){this.f.fire({reason:t});const c=this.P(-1),u=this.P(0),i=this.P(1);switch(t){case O.NONE:await C.Promises.settled([c?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case O.SHUTDOWN:await C.Promises.settled([c?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const t=this.P(-1)?.items??new Map,c=this.P(0)?.items??new Map,u=this.P(1)?.items??new Map;return s(t,c,u,this.Q(-1)??"",this.Q(0)??"",this.Q(1)??"")}async optimize(t){return await this.flush(),this.P(t)?.optimize()}async switch(t,c){return this.w(O.NONE),(0,D.$Dl)(t)?this.R(t,c):this.S(t,c)}M(t,c){return!(t.id===c.id||o(c)&&o(t))}N(t,c,u){this.y(()=>{const i=new Set;for(const[b,a]of t)i.add(b),c.get(b)!==a&&this.u(u,{key:b,external:!0});for(const[b]of c.items)i.has(b)||this.u(u,{key:b,external:!0})})}}e.$7p=f;function o(n){return n.isDefault||!!n.useDefaultFlags?.globalState}class r extends f{constructor(){super(),this.U=this.B(new p.$1p(new p.$2p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.W=this.B(new p.$1p(new p.$2p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.X=this.B(new p.$1p(new p.$2p,{hint:p.StorageHint.STORAGE_IN_MEMORY})),this.B(this.X.onDidChangeStorage(t=>this.u(1,t))),this.B(this.W.onDidChangeStorage(t=>this.u(0,t))),this.B(this.U.onDidChangeStorage(t=>this.u(-1,t)))}P(t){switch(t){case-1:return this.U;case 0:return this.W;default:return this.X}}Q(t){switch(t){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async O(){}async R(){}async S(){}r(){return!1}hasScope(t){return!1}}e.$9p=r;async function s(n,t,c,u,i,b){const a=I=>{try{return JSON.parse(I)}catch{return I}},l=new Map,g=new Map;n.forEach((I,P)=>{l.set(P,I),g.set(P,a(I))});const $=new Map,v=new Map;t.forEach((I,P)=>{$.set(P,I),v.set(P,a(I))});const y=new Map,h=new Map;c.forEach((I,P)=>{y.set(P,I),h.set(P,a(I))}),console.group(u!==i?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const E=[];if(l.forEach((I,P)=>{E.push({key:P,value:I})}),console.table(E),console.groupEnd(),console.log(g),u!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const I=[];$.forEach((P,V)=>{I.push({key:V,value:P})}),console.table(I),console.groupEnd(),console.log(v)}console.group(`Storage: Workspace (path: ${b})`);const k=[];y.forEach((I,P)=>{k.push({key:P,value:I})}),console.table(k),console.groupEnd(),console.log(h)}}),define(Se[76],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6lc=void 0;class C{static{this.a=!1}constructor(M){this.d=M,this.b=new Map,this.c=1}add(M){const T=this.c++;return this.b.set(T,M),this.e(),T}get(M,T){return this.b.has(M)?this.b.get(M)[T]:void 0}delete(M){this.b.delete(M),this.e()}e(){C.a&&console.log(`${this.d} cache size - ${this.b.size}`)}}e.$6lc=C}),define(Se[47],Ie([1,0,16,24,3]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_lc=e.$$lc=void 0;class T{constructor(){this.a=new Set(Object.keys(C.Schemas)),this.b=new Map,this.extUri=new N.$1g(p=>{const m=this.b.get(p.scheme);return!(m===void 0||m&1024)})}$acceptProviderInfos(p,m){m===null?this.b.delete(p.scheme):this.b.set(p.scheme,m)}isFreeScheme(p){return!this.b.has(p)&&!this.a.has(p)}getCapabilities(p){return this.b.get(p)}}e.$$lc=T,e.$_lc=(0,M.$yi)("IExtHostFileSystemInfo")}),define(Se[27],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6O=void 0,e.$6O=(0,C.$yi)("IExtHostInitDataService")}),define(Se[217],Ie([1,0,176,12,201,27]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$foc=void 0;let A=class extends M.$dQ{constructor(m,D,O){const S=O.remote.isRemote?"remoteexthost":m?"workerexthost":"exthost",d=O.remote.isRemote?(0,C.localize)(0,null):m?(0,C.localize)(1,null):(0,C.localize)(2,null);super(D.createLogger(S,{name:d}))}};e.$foc=A,e.$foc=A=Je([We(1,N.$6j),We(2,T.$6O)],A)}),define(Se[218],Ie([1,0,11]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Rmc=e.$Qmc=void 0;class N{constructor(A,p,m){this.h=new Map,this.a=A,this.b=p,this.c=m,this.d=this.c.initializeExtensionStorage(this.b,this.a,Object.create(null)).then(D=>(this.f=D,this)),this.g=this.c.onDidChangeStorage(D=>{D.shared===this.b&&D.key===this.a&&(this.f=D.value)}),this.i=new C.$Kh(()=>{const D=this.h;this.h=new Map,(async()=>{try{await this.c.setValue(this.b,this.a,this.f);for(const O of D.values())O.complete()}catch(O){for(const S of D.values())S.error(O)}})()},0)}keys(){return Object.entries(this.f??{}).filter(([,A])=>A!==void 0).map(([A])=>A)}get whenReady(){return this.d}get(A,p){let m=this.f[A];return typeof m>"u"&&(m=p),m}update(A,p){this.f[A]=p;const m=this.h.get(A);if(m!==void 0)return m.p;const D=new C.$Vh;return this.h.set(A,D),this.i.isScheduled()||this.i.schedule(),D.p}dispose(){this.g.dispose()}}e.$Qmc=N;class M extends N{setKeysForSync(A){this.c.registerExtensionStorageKeysToSync({id:this.a,version:this.j.version},A)}constructor(A,p){super(A.identifier.value,!0,p),this.j=A}}e.$Rmc=M}),define(Se[219],Ie([1,0,5,2]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fnc=void 0;class M{constructor(A){this.c=A,this.a=new C.$fe,this.onDidSaveNotebookDocument=this.a.event,this.b=new C.$fe,this.onDidChangeNotebookDocument=this.b.event}$acceptModelChanged(A,p,m,D){const S=this.c.getNotebookDocument(N.URI.revive(A)).acceptModelChanged(p.value,m,D);this.b.fire(S)}$acceptDirtyStateChanged(A,p){this.c.getNotebookDocument(N.URI.revive(A)).acceptDirty(p)}$acceptModelSaved(A){const p=this.c.getNotebookDocument(N.URI.revive(A));this.a.fire(p.apiNotebook)}}e.$Fnc=M}),define(Se[17],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$QO=e.$PO=void 0,e.$PO=(0,C.$yi)("IExtHostRpcService");class N{constructor(T){this.getProxy=T.getProxy.bind(T),this.set=T.set.bind(T),this.dispose=T.dispose.bind(T),this.assertRegistered=T.assertRegistered.bind(T),this.drain=T.drain.bind(T)}}e.$QO=N}),define(Se[220],Ie([1,0,21,5]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1mc=void 0;class M{#e;constructor(A,p){this.b=new N.$fe,this.onDidChange=this.b.event,this.a=C.$Tm.toKey(A.identifier),this.#e=p,this.#e.onDidChangePassword(m=>{m.extensionId===this.a&&this.b.fire({key:m.key})})}get(A){return this.#e.get(this.a,A)}store(A,p){return this.#e.store(this.a,A,p)}delete(A){return this.#e.delete(this.a,A)}}e.$1mc=M}),define(Se[61],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pmc=e.$omc=void 0,e.$omc=(0,C.$yi)("IURITransformerService");class N{constructor(T){T?(this.transformIncoming=T.transformIncoming.bind(T),this.transformOutgoing=T.transformOutgoing.bind(T),this.transformOutgoingURI=T.transformOutgoingURI.bind(T),this.transformOutgoingScheme=T.transformOutgoingScheme.bind(T)):(this.transformIncoming=A=>A,this.transformOutgoing=A=>A,this.transformOutgoingURI=A=>A,this.transformOutgoingScheme=A=>A)}}e.$pmc=N}),define(Se[221],Ie([1,0,22]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$fsb=M,e.$gsb=A;class N{constructor(){this.buffers=[]}add(m){let D=this.buffers.indexOf(m);return D<0&&(D=this.buffers.length,this.buffers.push(m)),D}}function M(p,m){if(m.serializeBuffersForPostMessage){const D=new N,S=JSON.stringify(p,(w,f)=>{if(f instanceof ArrayBuffer)return{$$vscode_array_buffer_reference$$:!0,index:D.add(f)};if(ArrayBuffer.isView(f)){const o=T(f);if(o)return{$$vscode_array_buffer_reference$$:!0,index:D.add(f.buffer),view:{type:o,byteLength:f.byteLength,byteOffset:f.byteOffset}}}return f}),d=D.buffers.map(w=>{const f=new Uint8Array(w);return C.$He.wrap(f)});return{message:S,buffers:d}}else return{message:JSON.stringify(p),buffers:[]}}function T(p){switch(p.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function A(p,m){const D=m.map(d=>{const w=new ArrayBuffer(d.byteLength);return new Uint8Array(w).set(d.buffer),w}),O=m.length?(d,w)=>{if(w&&typeof w=="object"&&w.$$vscode_array_buffer_reference$$){const f=w,{index:o}=f,r=D[o];if(f.view)switch(f.view.type){case 1:return new Int8Array(r,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(r,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(r,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(r,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(r,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(r,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(r,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(r,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(r,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(r,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(r,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return r}return w}:void 0;return{message:JSON.parse(p,O),arrayBuffers:D}}}),define(Se[106],Ie([1,0,185,15,2,6,3,29,38,16,44,145,32]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorsOrder=e.CloseDirection=e.$WF=e.EditorCloseMethod=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.$NF=e.EditorInputCapabilities=e.$MF=e.SaveReason=e.Verbosity=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.$CF=e.$BF=e.$AF=e.$zF=e.$yF=void 0,e.$DF=o,e.$EF=r,e.$FF=s,e.$GF=n,e.$HF=t,e.$IF=c,e.$JF=u,e.$KF=i,e.$LF=b,e.$OF=y,e.$PF=E,e.$QF=k,e.$RF=I,e.$SF=P,e.$TF=V,e.$UF=W,e.$VF=de,e.$XF=ge,e.$YF=Ce,e.$ZF=se,e.$1F=Ne,e.$yF={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.$zF={id:"default",displayName:(0,C.localize)(0,null),providerDisplayName:(0,C.localize)(1,null)},e.$AF="workbench.editor.sidebysideEditor",e.$BF="workbench.editors.textDiffEditor",e.$CF="workbench.editors.binaryResourceDiffEditor";var w;(function(ne){ne[ne.PROGRAMMATIC=1]="PROGRAMMATIC",ne[ne.USER=2]="USER",ne[ne.EDIT=3]="EDIT",ne[ne.NAVIGATION=4]="NAVIGATION",ne[ne.JUMP=5]="JUMP"})(w||(e.EditorPaneSelectionChangeReason=w={}));var f;(function(ne){ne[ne.IDENTICAL=1]="IDENTICAL",ne[ne.SIMILAR=2]="SIMILAR",ne[ne.DIFFERENT=3]="DIFFERENT"})(f||(e.EditorPaneSelectionCompareResult=f={}));function o(ne){const U=ne;return!!U&&typeof U.getSelection=="function"&&!!U.onDidChangeSelection}function r(ne){const U=ne;return!!U&&typeof U.getScrollPosition=="function"&&typeof U.setScrollPosition=="function"&&!!U.onDidChangeScroll}function s(ne,U,x){for(const ve of x.visibleEditorPanes)if(ve.group.id===U&&ne.matches(ve.input))return ve.getViewState()}function n(ne){if(y(ne))return!1;const U=ne;return M.URI.isUri(U?.resource)}function t(ne){if(y(ne))return!1;const U=ne;return U?.original!==void 0&&U.modified!==void 0}function c(ne){if(y(ne))return!1;const U=ne;return!U||U.resources&&!Array.isArray(U.resources)?!1:!!U.resources||!!U.multiDiffSource}function u(ne){if(y(ne)||t(ne))return!1;const U=ne;return U?.primary!==void 0&&U.secondary!==void 0}function i(ne){if(y(ne))return!1;const U=ne;return U?U.resource===void 0||U.resource.scheme===D.Schemas.untitled||U.forceUntitled===!0:!1}function b(ne){if(y(ne))return!1;const U=ne;return M.URI.isUri(U?.base?.resource)&&M.URI.isUri(U?.input1?.resource)&&M.URI.isUri(U?.input2?.resource)&&M.URI.isUri(U?.result?.resource)}var a;(function(ne){ne[ne.SHORT=0]="SHORT",ne[ne.MEDIUM=1]="MEDIUM",ne[ne.LONG=2]="LONG"})(a||(e.Verbosity=a={}));var l;(function(ne){ne[ne.EXPLICIT=1]="EXPLICIT",ne[ne.AUTO=2]="AUTO",ne[ne.FOCUS_CHANGE=3]="FOCUS_CHANGE",ne[ne.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(l||(e.SaveReason=l={}));class g{constructor(){this.a=new Map}registerSource(U,x){let ve=this.a.get(U);return ve||(ve={source:U,label:x},this.a.set(U,ve)),ve.source}getSourceLabel(U){return this.a.get(U)?.label??U}}e.$MF=new g;var $;(function(ne){ne[ne.None=0]="None",ne[ne.Readonly=2]="Readonly",ne[ne.Untitled=4]="Untitled",ne[ne.Singleton=8]="Singleton",ne[ne.RequiresTrust=16]="RequiresTrust",ne[ne.CanSplitInGroup=32]="CanSplitInGroup",ne[ne.ForceDescription=64]="ForceDescription",ne[ne.CanDropIntoEditor=128]="CanDropIntoEditor",ne[ne.MultipleEditors=256]="MultipleEditors",ne[ne.Scratchpad=512]="Scratchpad"})($||(e.EditorInputCapabilities=$={}));class v extends T.$Uc{}e.$NF=v;function y(ne){return ne instanceof v}function h(ne){const U=ne;return M.URI.isUri(U?.preferredResource)}function E(ne){const U=ne;return y(U?.primary)&&y(U?.secondary)}function k(ne){const U=ne;return y(U?.modified)&&y(U?.original)}function I(ne,U,x,ve,Le){return Ne(ve,[(0,S.$ij)({id:"workbench.action.openLargeFile",label:(0,C.localize)(2,null),run:()=>{const ke={...x,limits:{size:Number.MAX_VALUE}};ne.openEditor(U,ke)}}),(0,S.$ij)({id:"workbench.action.configureEditorLargeFileConfirmation",label:(0,C.localize)(3,null),run:()=>Le.openUserSettings({query:"workbench.editorLargeFileConfirmation"})})],{forceMessage:!0,forceSeverity:d.default.Warning})}function P(ne){return y(ne?.editor)}function V(ne){const U=ne;return P(ne)&&U?.group!==void 0}function W(ne){const U=ne;return typeof U?.groupId=="number"&&y(U.editor)}var q;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.REPLACE=1]="REPLACE",ne[ne.MOVE=2]="MOVE",ne[ne.UNPIN=3]="UNPIN"})(q||(e.EditorCloseContext=q={}));var R;(function(ne){ne[ne.GROUP_ACTIVE=0]="GROUP_ACTIVE",ne[ne.GROUP_INDEX=1]="GROUP_INDEX",ne[ne.GROUP_LABEL=2]="GROUP_LABEL",ne[ne.GROUP_LOCKED=3]="GROUP_LOCKED",ne[ne.EDITOR_OPEN=4]="EDITOR_OPEN",ne[ne.EDITOR_CLOSE=5]="EDITOR_CLOSE",ne[ne.EDITOR_MOVE=6]="EDITOR_MOVE",ne[ne.EDITOR_ACTIVE=7]="EDITOR_ACTIVE",ne[ne.EDITOR_LABEL=8]="EDITOR_LABEL",ne[ne.EDITOR_CAPABILITIES=9]="EDITOR_CAPABILITIES",ne[ne.EDITOR_PIN=10]="EDITOR_PIN",ne[ne.EDITOR_TRANSIENT=11]="EDITOR_TRANSIENT",ne[ne.EDITOR_SELECTION=12]="EDITOR_SELECTION",ne[ne.EDITOR_STICKY=13]="EDITOR_STICKY",ne[ne.EDITOR_DIRTY=14]="EDITOR_DIRTY",ne[ne.EDITOR_WILL_DISPOSE=15]="EDITOR_WILL_DISPOSE"})(R||(e.GroupModelChangeKind=R={}));var z;(function(ne){ne[ne.PRIMARY=1]="PRIMARY",ne[ne.SECONDARY=2]="SECONDARY",ne[ne.BOTH=3]="BOTH",ne[ne.ANY=4]="ANY"})(z||(e.SideBySideEditor=z={}));class K{getOriginalUri(U,x){if(!U)return;if(b(U))return e.$WF.getOriginalUri(U.result,x);if(x?.supportSideBySide){const{primary:Le,secondary:ke}=this.a(U);if(Le&&ke){if(x?.supportSideBySide===z.BOTH)return{primary:this.getOriginalUri(Le,{filterByScheme:x.filterByScheme}),secondary:this.getOriginalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getOriginalUri(Le,{filterByScheme:x.filterByScheme})??this.getOriginalUri(ke,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===z.PRIMARY?Le:ke}}if(t(U)||c(U)||u(U)||b(U))return;const ve=h(U)?U.preferredResource:U.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}a(U){return E(U)||u(U)?{primary:U.primary,secondary:U.secondary}:k(U)||t(U)?{primary:U.modified,secondary:U.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(U,x){if(!U)return;if(b(U))return e.$WF.getCanonicalUri(U.result,x);if(x?.supportSideBySide){const{primary:Le,secondary:ke}=this.a(U);if(Le&&ke){if(x?.supportSideBySide===z.BOTH)return{primary:this.getCanonicalUri(Le,{filterByScheme:x.filterByScheme}),secondary:this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme})};if(x?.supportSideBySide===z.ANY)return this.getCanonicalUri(Le,{filterByScheme:x.filterByScheme})??this.getCanonicalUri(ke,{filterByScheme:x.filterByScheme});U=x.supportSideBySide===z.PRIMARY?Le:ke}}if(t(U)||c(U)||u(U)||b(U))return;const ve=U.resource;return!ve||!x||!x.filterByScheme?ve:this.b(ve,x.filterByScheme)}b(U,x){if(Array.isArray(x)){if(x.some(ve=>U.scheme===ve))return U}else if(x===U.scheme)return U}}var ie;(function(ne){ne[ne.UNKNOWN=0]="UNKNOWN",ne[ne.KEYBOARD=1]="KEYBOARD",ne[ne.MOUSE=2]="MOUSE"})(ie||(e.EditorCloseMethod=ie={}));function de(ne,U,x,ve){if(!ne.isSticky(U))return!1;switch(ve.preventPinnedEditorClose){case"keyboardAndMouse":return x===ie.MOUSE||x===ie.KEYBOARD;case"mouse":return x===ie.MOUSE;case"keyboard":return x===ie.KEYBOARD}return!1}e.$WF=new K;var ye;(function(ne){ne[ne.LEFT=0]="LEFT",ne[ne.RIGHT=1]="RIGHT"})(ye||(e.CloseDirection=ye={}));class De{constructor(){this.c=new Map,this.d=new Map}start(U){const x=this.a=U.get(A.$xi);for(const[ve,Le]of this.c)this.e(ve,Le,x);this.c.clear()}e(U,x,ve){const Le=ve.createInstance(x);this.d.set(U,Le)}registerFileEditorFactory(U){if(this.b)throw new Error("Can only register one file editor factory.");this.b=U}getFileEditorFactory(){return(0,N.$jg)(this.b)}registerEditorSerializer(U,x){if(this.c.has(U)||this.d.has(U))throw new Error(`A editor serializer with type ID '${U}' was already registered.`);return this.a?this.e(U,x,this.a):this.c.set(U,x),(0,T.$Sc)(()=>{this.c.delete(U),this.d.delete(U)})}getEditorSerializer(U){return this.d.get(typeof U=="string"?U:U.typeId)}}p.$fo.add(e.$yF.EditorFactory,new De);async function ge(ne,U,x){return!ne||!ne.length?[]:await Promise.all(ne.map(async ve=>{const Le=M.URI.revive(ve.fileUri);if(!Le){x.info("Cannot resolve the path because it is not valid.",ve);return}if(!await U.canHandleResource(Le)){x.info("Cannot resolve the path because it cannot be handled",ve);return}let be=ve.exists,me=ve.type;if(typeof be!="boolean"||typeof me!="number")try{me=(await U.stat(Le)).isDirectory?m.FileType.Directory:m.FileType.Unknown,be=!0}catch(Y){x.error(Y),be=!1}if(!be&&ve.openOnlyIfExists){x.info("Cannot resolve the path because it does not exist",ve);return}if(me===m.FileType.Directory){x.info("Cannot resolve the path because it is a directory",ve);return}const Q={...ve.options,pinned:!0};return be?{resource:Le,options:Q}:{resource:Le,options:Q,forceUntitled:!0}}))}var ue;(function(ne){ne[ne.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",ne[ne.SEQUENTIAL=1]="SEQUENTIAL"})(ue||(e.EditorsOrder=ue={}));function Ce(ne){const U=ne;if(!U)return!1;const x=U;if(x.modified)return Ce(x.modified);const ve=U;return!!(ve.contributionsState&&ve.viewState&&Array.isArray(ve.cursorState))}function se(ne){return(0,O.$kj)(ne)}function Ne(ne,U,x){const ve=(0,O.$lj)(ne,U);return ve.forceMessage=x?.forceMessage,ve.forceSeverity=x?.forceSeverity,ve.allowDialog=x?.allowDialog,ve}}),define(Se[222],Ie([1,0,5,186,3,6,28,29,26,92,210]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9F=e.$8F=e.TreeItemCollapsibleState=e.ViewVisibilityState=e.$7F=e.ViewContentGroups=e.$5F=e.ViewContainerLocation=e.Extensions=e.$4F=e.$3F=e.$2F=void 0,e.$6F=w,e.$2F="views",e.$3F=(0,N.localize)(0,null),e.$4F=(0,O.$kx)("default-view-icon",D.$Xj.window,(0,N.localize)(1,null));var S;(function(i){i.ViewContainersRegistry="workbench.registry.view.containers",i.ViewsRegistry="workbench.registry.view"})(S||(e.Extensions=S={}));var d;(function(i){i[i.Sidebar=0]="Sidebar",i[i.Panel=1]="Panel",i[i.AuxiliaryBar=2]="AuxiliaryBar"})(d||(e.ViewContainerLocation=d={})),e.$5F=[0,1,2];function w(i){switch(i){case 0:return"sidebar";case 1:return"panel";case 2:return"auxiliarybar"}}class f extends T.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$fe),this.onDidRegister=this.c.event,this.f=this.B(new C.$fe),this.onDidDeregister=this.f.event,this.g=new Map,this.h=[]}get all(){return[...this.g.values()].flat()}registerViewContainer(b,a,l){const g=this.get(b.id);if(g)return g;const $=b;return $.openCommandActionDescriptor=l?.doNotRegisterOpenCommand?void 0:$.openCommandActionDescriptor??{id:$.id},(0,A.$xc)(this.g,a,[]).push($),l?.isDefault&&this.h.push($),this.c.fire({viewContainer:$,viewContainerLocation:a}),$}deregisterViewContainer(b){for(const a of this.g.keys()){const l=this.g.get(a),g=l?.indexOf(b);if(g!==-1){l?.splice(g,1),l.length===0&&this.g.delete(a),this.f.fire({viewContainer:b,viewContainerLocation:a});return}}}get(b){return this.all.filter(a=>a.id===b)[0]}getViewContainers(b){return[...this.g.get(b)||[]]}getViewContainerLocation(b){return[...this.g.keys()].filter(a=>this.getViewContainers(a).filter(l=>l?.id===b.id).length>0)[0]}getDefaultViewContainer(b){return this.h.find(a=>this.getViewContainerLocation(a)===b)}}p.$fo.add(S.ViewContainersRegistry,new f);var o;(function(i){i.Open="2_open",i.Debug="4_debug",i.SCM="5_scm",i.More="9_more"})(o||(e.ViewContentGroups=o={}));function r(i,b){const a=i.group??o.More,l=b.group??o.More;return a!==l?a.localeCompare(l):(i.order??5)-(b.order??5)}class s extends T.$Uc{constructor(){super(...arguments),this.c=this.B(new C.$fe),this.onViewsRegistered=this.c.event,this.f=this.B(new C.$fe),this.onViewsDeregistered=this.f.event,this.g=this.B(new C.$fe),this.onDidChangeContainer=this.g.event,this.h=this.B(new C.$fe),this.onDidChangeViewWelcomeContent=this.h.event,this.j=[],this.m=new Map,this.n=new A.$Hc}registerViews(b,a){this.registerViews2([{views:b,viewContainer:a}])}registerViews2(b){b.forEach(({views:a,viewContainer:l})=>this.r(a,l)),this.c.fire(b)}deregisterViews(b,a){const l=this.s(b,a);l.length&&this.f.fire({views:l,viewContainer:a})}moveViews(b,a){for(const l of this.m.keys())if(l!==a){const g=this.s(b,l);g.length&&(this.r(g,a),this.g.fire({views:g,from:l,to:a}))}}getViews(b){return this.m.get(b)||[]}getView(b){for(const a of this.j){const l=(this.m.get(a)||[]).filter(g=>g.id===b)[0];if(l)return l}return null}getViewContainer(b){for(const a of this.j)if((this.m.get(a)||[]).filter(g=>g.id===b)[0])return a;return null}registerViewWelcomeContent(b,a){return this.n.add(b,a),this.h.fire(b),(0,T.$Sc)(()=>{this.n.delete(b,a),this.h.fire(b)})}registerViewWelcomeContent2(b,a){const l=new Map;for(const[g,$]of a)this.n.add(b,$),l.set(g,(0,T.$Sc)(()=>{this.n.delete(b,$),this.h.fire(b)}));return this.h.fire(b),l}getViewWelcomeContent(b){const a=[];return this.n.forEach(b,l=>a.push(l)),a.sort(r)}r(b,a){let l=this.m.get(a);l||(l=[],this.m.set(a,l),this.j.push(a));for(const g of b){if(this.getView(g.id)!==null)throw new Error((0,N.localize)(2,null,g.id));l.push(g)}}s(b,a){const l=this.m.get(a);if(!l)return[];const g=[],$=[];for(const v of l)b.includes(v)?g.push(v):$.push(v);return g.length&&($.length?this.m.set(a,$):(this.m.delete(a),this.j.splice(this.j.indexOf(a),1))),g}}p.$fo.add(S.ViewsRegistry,new s),e.$7F=(0,M.$yi)("viewDescriptorService");var n;(function(i){i[i.Default=0]="Default",i[i.Expand=1]="Expand"})(n||(e.ViewVisibilityState=n={}));var t;(function(i){i[i.None=0]="None",i[i.Collapsed=1]="Collapsed",i[i.Expanded=2]="Expanded"})(t||(e.TreeItemCollapsibleState=t={}));class c{constructor(b,a){this.c=!1,this.d=!1,(0,m.$8n)(this,b),this.d=!!a,this.resolve=async l=>{if(a&&!this.c){const g=await a(l);g&&(this.tooltip=this.tooltip??g.tooltip,this.command=this.command??g.command)}l.isCancellationRequested||(this.c=!0)}}get hasResolve(){return this.d}resetResolve(){this.c=!1}asTreeItem(){return{handle:this.handle,parentHandle:this.parentHandle,collapsibleState:this.collapsibleState,label:this.label,description:this.description,icon:this.icon,iconDark:this.iconDark,themeIcon:this.themeIcon,resourceUri:this.resourceUri,tooltip:this.tooltip,contextValue:this.contextValue,command:this.command,children:this.children,accessibilityInformation:this.accessibilityInformation}}}e.$8F=c;class u extends Error{constructor(b){super((0,N.localize)(3,null,b)),this.name="NoTreeViewError"}static is(b){return b.name==="NoTreeViewError"}}e.$9F=u}),define(Se[223],Ie([1,0,187,31]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pG=e.$oG=e.$nG=e.$mG=e.$lG=e.$kG=e.$jG=e.$iG=e.$hG=e.$gG=e.$fG=e.$eG=e.$dG=e.$cG=e.$bG=e.$aG=void 0,e.$aG=new N.$Pj("chatSessionResponseVote","",{type:"string",description:(0,C.localize)(0,null)}),e.$bG=new N.$Pj("chatSessionResponseDetectedAgentOrCommand",!1,{type:"boolean",description:(0,C.localize)(1,null)}),e.$cG=new N.$Pj("chatResponseSupportsIssueReporting",!1,{type:"boolean",description:(0,C.localize)(2,null)}),e.$dG=new N.$Pj("chatSessionResponseFiltered",!1,{type:"boolean",description:(0,C.localize)(3,null)}),e.$eG=new N.$Pj("chatSessionRequestInProgress",!1,{type:"boolean",description:(0,C.localize)(4,null)}),e.$fG=new N.$Pj("chatResponse",!1,{type:"boolean",description:(0,C.localize)(5,null)}),e.$gG=new N.$Pj("chatRequest",!1,{type:"boolean",description:(0,C.localize)(6,null)}),e.$hG=new N.$Pj("chatEditApplied",!1,{type:"boolean",description:(0,C.localize)(7,null)}),e.$iG=new N.$Pj("chatInputHasText",!1,{type:"boolean",description:(0,C.localize)(8,null)}),e.$jG=new N.$Pj("chatInputHasFocus",!1,{type:"boolean",description:(0,C.localize)(9,null)}),e.$kG=new N.$Pj("inChatInput",!1,{type:"boolean",description:(0,C.localize)(10,null)}),e.$lG=new N.$Pj("inChat",!1,{type:"boolean",description:(0,C.localize)(11,null)}),e.$mG=new N.$Pj("chatIsEnabled",!1,{type:"boolean",description:(0,C.localize)(12,null)}),e.$nG=new N.$Pj("chatCursorAtTop",!1),e.$oG=new N.$Pj("chatInputHasAgent",!1),e.$pG=new N.$Pj("chatLocation",void 0)}),define(Se[224],Ie([1,0,11,20,5,42,6,45,132,13,31,3,12,102,204,216,223]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$sH=e.$rH=e.$qH=e.$pH=e.$oH=e.ChatAgentLocation=void 0,e.$tH=i,e.$uH=b;var n;(function(a){a.Panel="panel",a.Terminal="terminal",a.Notebook="notebook",a.Editor="editor"})(n||(e.ChatAgentLocation=n={})),function(a){function l(g){switch(g){case"panel":return a.Panel;case"terminal":return a.Terminal;case"notebook":return a.Notebook;case"editor":return a.Editor}return a.Panel}a.fromRaw=l}(n||(e.ChatAgentLocation=n={})),e.$oH=(0,S.$yi)("chatAgentService");let t=class{static{this.AGENT_LEADER="@"}constructor(l){this.f=l,this.b=[],this.d=new M.$fe,this.onDidChangeAgents=this.d.event,this.e=r.$mG.bindTo(this.f)}registerAgent(l,g){if(this.getAgent(l))throw new Error(`Agent already registered: ${JSON.stringify(l)}`);const v=this,y=g.slashCommands;g={...g,get slashCommands(){return y.filter(E=>!E.when||v.f.contextMatchesRules(O.$wj.deserialize(E.when)))}};const h={data:g};return this.b.push(h),(0,A.$Sc)(()=>{this.b=this.b.filter(E=>E!==h),this.d.fire(void 0)})}registerAgentImplementation(l,g){const $=this.g(l);if(!$)throw new Error(`Unknown agent: ${JSON.stringify(l)}`);if($.impl)throw new Error(`Agent already has implementation: ${JSON.stringify(l)}`);return $.data.isDefault&&this.e.set(!0),$.impl=g,this.d.fire(new c($.data,g)),(0,A.$Sc)(()=>{$.impl=void 0,this.d.fire(void 0),$.data.isDefault&&this.e.set(!1)})}registerDynamicAgent(l,g){l.isDynamic=!0;const $={data:l,impl:g};return this.b.push($),this.d.fire(new c(l,g)),(0,A.$Sc)(()=>{this.b=this.b.filter(v=>v!==$),this.d.fire(void 0)})}updateAgent(l,g){const $=this.g(l);if(!$?.impl)throw new Error(`No activated agent with id ${JSON.stringify(l)} registered`);$.data.metadata={...$.data.metadata,...g},this.d.fire(new c($.data,$.impl))}getDefaultAgent(l){return this.getActivatedAgents().find(g=>!!g.isDefault&&g.locations.includes(l))}getContributedDefaultAgent(l){return this.getAgents().find(g=>!!g.isDefault&&g.locations.includes(l))}getSecondaryAgent(){return T.Iterable.find(this.b.values(),l=>!!l.data.metadata.isSecondary)?.data}g(l){return this.b.find(g=>g.data.id===l)}getAgent(l){return this.g(l)?.data}getAgentByFullyQualifiedId(l){return this.b.find(g=>i(g.data)===l)?.data}getAgents(){return this.b.map(l=>l.data)}getActivatedAgents(){return Array.from(this.b.values()).filter(l=>!!l.impl).map(l=>new c(l.data,l.impl))}getAgentsByName(l){return this.getAgents().filter(g=>g.name===l)}async invokeAgent(l,g,$,v,y){const h=this.g(l);if(!h?.impl)throw new Error(`No activated agent with id ${l}`);return await h.impl.invoke(g,$,v,y)}async getFollowups(l,g,$,v,y){const h=this.g(l);if(!h?.impl)throw new Error(`No activated agent with id ${l}`);return h.impl?.provideFollowups?h.impl.provideFollowups(g,$,v,y):[]}};e.$pH=t,e.$pH=t=Je([We(0,O.$Qj)],t);class c{constructor(l,g){this.b=l,this.d=g}get id(){return this.b.id}get name(){return this.b.name??""}get fullName(){return this.b.fullName??""}get description(){return this.b.description??""}get extensionId(){return this.b.extensionId}get extensionPublisherId(){return this.b.extensionPublisherId}get extensionPublisherDisplayName(){return this.b.publisherDisplayName}get extensionDisplayName(){return this.b.extensionDisplayName}get isDefault(){return this.b.isDefault}get metadata(){return this.b.metadata}get slashCommands(){return this.b.slashCommands}get defaultImplicitVariables(){return this.b.defaultImplicitVariables}get locations(){return this.b.locations}async invoke(l,g,$,v){return this.d.invoke(l,g,$,v)}async provideFollowups(l,g,$,v){return this.d.provideFollowups?this.d.provideFollowups(l,g,$,v):[]}provideWelcomeMessage(l,g){if(this.d.provideWelcomeMessage)return this.d.provideWelcomeMessage(l,g)}provideSampleQuestions(l,g){if(this.d.provideSampleQuestions)return this.d.provideSampleQuestions(l,g)}}e.$qH=c,e.$rH=(0,S.$yi)("chatAgentNameService");let u=class{static{s=this}static{this.b="chat.participantNameRegistry"}constructor(l,g,$,v){if(this.g=g,this.h=$,this.i=v,this.e=(0,m.$3d)(this,Object.create(null)),this.f=!1,!l.chatParticipantRegistry)return;this.d=l.chatParticipantRegistry;const y=v.get(s.b,-1);try{this.e.set(JSON.parse(y??"{}"),void 0)}catch{v.remove(s.b,-1)}this.j()}j(){this.f||this.k().catch(l=>this.h.warn("Failed to fetch chat participant registry",l)).then(()=>(0,C.$zh)(5*60*1e3)).then(()=>this.j())}async k(){const l=await this.g.request({type:"GET",url:this.d},N.CancellationToken.None);if(l.res.statusCode!==200)throw new Error("Could not get extensions report.");const g=await(0,f.$Xp)(l);if(!g||g.version!==1)throw new Error("Unexpected chat participant registry response.");const $=g.restrictedChatParticipants;this.e.set($,void 0),this.i.store(s.b,JSON.stringify($),-1,1)}getAgentNameRestriction(l){return this.e.map($=>$[l.name.toLowerCase()]).map($=>$?$.some(v=>(0,D.$zf)(v,v.includes(".")?l.extensionId.value:l.extensionPublisherId)):!0)}dispose(){this.f=!0}};e.$sH=u,e.$sH=u=s=Je([We(0,w.$lk),We(1,f.$Rp),We(2,d.$5j),We(3,o.$5p)],u);function i(a){return`${a.extensionId.value}.${a.id}`}function b(a){const l="name"in a?a:{...a,name:a.id};return"extensionPublisherId"in l||(l.extensionPublisherId=l.extensionPublisher??""),"extensionDisplayName"in l||(l.extensionDisplayName=""),(0,p.$8h)(l)}}),define(Se[225],Ie([1,0,2,30,3]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1G=e.$ZG=e.ChatCopyKind=e.ChatAgentVoteDirection=void 0,e.$XG=T,e.$YG=A;function T(D){return!!D&&typeof D=="object"&&"uri"in D&&D.uri instanceof C.URI&&"version"in D&&typeof D.version=="number"&&"ranges"in D&&Array.isArray(D.ranges)&&D.ranges.every(N.$zt.isIRange)}function A(D){return!!D&&typeof D=="object"&&"documents"in D&&Array.isArray(D.documents)&&D.documents.every(T)}var p;(function(D){D[D.Down=0]="Down",D[D.Up=1]="Up"})(p||(e.ChatAgentVoteDirection=p={}));var m;(function(D){D[D.Action=1]="Action",D[D.Toolbar=2]="Toolbar"})(m||(e.ChatCopyKind=m={})),e.$ZG=(0,M.$yi)("IChatService"),e.$1G="accessibility.voice.keywordActivation"}),define(Se[226],Ie([1,0,5,11,188]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ssb=void 0;class T{constructor(){this.f=new Map,this.m=[],this.n=new C.$fe,this.o=new C.$fe,this.d=1}get onError(){return this.n.event}get onExit(){return this.o.event}onMessage(p){this.k&&this.n.fire(new Error("attempt to set more than one 'Message' callback")),this.k=p}onEvent(p){this.j&&this.n.fire(new Error("attempt to set more than one 'Event' callback")),this.j=p}onRequest(p){this.g&&this.n.fire(new Error("attempt to set more than one 'Request' callback")),this.g=p}sendResponse(p){p.seq>0?this.n.fire(new Error(`attempt to send more than one response for command ${p.command}`)):this.u("response",p)}sendRequest(p,m,D,O){const S={command:p};if(m&&Object.keys(m).length>0&&(S.arguments=m),this.u("request",S),typeof O=="number"){const d=setTimeout(()=>{clearTimeout(d);const w=this.f.get(S.seq);if(w){this.f.delete(S.seq);const f={type:"response",seq:0,request_seq:S.seq,success:!1,command:p,message:(0,M.localize)(0,null,O,p)};w(f)}},O)}return D&&this.f.set(S.seq,D),S.seq}acceptMessage(p){this.k?this.k(p):(this.m.push(p),this.m.length===1&&this.s())}q(p,m){return p.type!=="event"||m.type!=="event"}async s(){let p;for(;this.m.length;){if((!p||this.q(this.m[0],p))&&await(0,N.$zh)(0),p=this.m.shift(),!p)return;switch(p.type){case"event":this.j?.(p);break;case"request":this.g?.(p);break;case"response":{const m=p,D=this.f.get(m.request_seq);D&&(this.f.delete(m.request_seq),D(m));break}}}}u(p,m){m.type=p,m.seq=this.d++,this.sendMessage(m)}async w(){if(this.f.size===0)return Promise.resolve();const p=new Map;this.f.forEach((m,D)=>p.set(D,m)),await(0,N.$zh)(500),p.forEach((m,D)=>{m({type:"response",seq:0,request_seq:D,success:!1,command:"canceled",message:"canceled"}),this.f.delete(D)})}getPendingRequestIds(){return Array.from(this.f.keys())}dispose(){this.m=[]}}e.$ssb=T}),define(Se[227],Ie([1,0,2,189,31,3]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDebugVisualization=e.IDebugVisualizationTreeItem=e.DebugTreeItemCollapsibleState=e.DebugVisualizationType=e.BreakpointWidgetContext=e.$KJ=e.DebuggerString=e.DebugConfigurationProviderTriggerKind=e.DataBreakpointSetType=e.$IJ=e.MemoryRangeType=e.State=e.$GJ=e.$FJ=e.$EJ=e.$DJ=e.$CJ=e.$BJ=e.$AJ=e.$zJ=e.$yJ=e.$xJ=e.$wJ=e.$vJ=e.$uJ=e.$tJ=e.$sJ=e.$rJ=e.$qJ=e.$pJ=e.$oJ=e.$nJ=e.$mJ=e.$lJ=e.$kJ=e.$jJ=e.$iJ=e.$hJ=e.$gJ=e.$fJ=e.$eJ=e.$dJ=e.$cJ=e.$bJ=e.$aJ=e.$_I=e.$$I=e.$0I=e.$9I=e.$8I=e.$7I=e.$6I=e.$5I=e.$4I=e.$3I=e.$2I=e.$1I=e.$ZI=e.$YI=e.$XI=e.$WI=e.$VI=e.$UI=e.$TI=e.$SI=e.$RI=e.$QI=e.$PI=e.$OI=e.$NI=e.$MI=e.$LI=e.$KI=e.$JI=e.$II=e.$HI=e.$GI=e.$FI=e.$EI=e.$DI=e.$CI=e.$BI=e.$AI=e.$zI=e.$yI=e.$xI=e.$wI=e.$vI=void 0,e.$HJ=m,e.$JJ=O,e.$vI="workbench.view.debug",e.$wI="workbench.debug.variablesView",e.$xI="workbench.debug.watchExpressionsView",e.$yI="workbench.debug.callStackView",e.$zI="workbench.debug.loadedScriptsView",e.$AI="workbench.debug.breakPointsView",e.$BI="workbench.debug.disassemblyView",e.$CI="workbench.panel.repl",e.$DI="workbench.panel.repl.view",e.$EI=new M.$Pj("debugType",void 0,{type:"string",description:N.localize(0,null)}),e.$FI=new M.$Pj("debugConfigurationType",void 0,{type:"string",description:N.localize(1,null)}),e.$GI=new M.$Pj("debugState","inactive",{type:"string",description:N.localize(2,null)}),e.$HI="debugUx",e.$II=new M.$Pj(e.$HI,"default",{type:"string",description:N.localize(3,null)}),e.$JI=new M.$Pj("hasDebugged",!1,{type:"boolean",description:N.localize(4,null)}),e.$KI=new M.$Pj("inDebugMode",!1,{type:"boolean",description:N.localize(5,null)}),e.$LI=new M.$Pj("inDebugRepl",!1,{type:"boolean",description:N.localize(6,null)}),e.$MI=new M.$Pj("breakpointWidgetVisible",!1,{type:"boolean",description:N.localize(7,null)}),e.$NI=new M.$Pj("inBreakpointWidget",!1,{type:"boolean",description:N.localize(8,null)}),e.$OI=new M.$Pj("breakpointsFocused",!0,{type:"boolean",description:N.localize(9,null)}),e.$PI=new M.$Pj("watchExpressionsFocused",!0,{type:"boolean",description:N.localize(10,null)}),e.$QI=new M.$Pj("watchExpressionsExist",!1,{type:"boolean",description:N.localize(11,null)}),e.$RI=new M.$Pj("variablesFocused",!0,{type:"boolean",description:N.localize(12,null)}),e.$SI=new M.$Pj("expressionSelected",!1,{type:"boolean",description:N.localize(13,null)}),e.$TI=new M.$Pj("breakpointInputFocused",!1,{type:"boolean",description:N.localize(14,null)}),e.$UI=new M.$Pj("callStackItemType",void 0,{type:"string",description:N.localize(15,null)}),e.$VI=new M.$Pj("callStackSessionIsAttach",!1,{type:"boolean",description:N.localize(16,null)}),e.$WI=new M.$Pj("callStackItemStopped",!1,{type:"boolean",description:N.localize(17,null)}),e.$XI=new M.$Pj("callStackSessionHasOneThread",!1,{type:"boolean",description:N.localize(18,null)}),e.$YI=new M.$Pj("watchItemType",void 0,{type:"string",description:N.localize(19,null)}),e.$ZI=new M.$Pj("canViewMemory",void 0,{type:"boolean",description:N.localize(20,null)}),e.$1I=new M.$Pj("breakpointItemType",void 0,{type:"string",description:N.localize(21,null)}),e.$2I=new M.$Pj("breakpointItemBytes",void 0,{type:"boolean",description:N.localize(22,null)}),e.$3I=new M.$Pj("breakpointHasModes",!1,{type:"boolean",description:N.localize(23,null)}),e.$4I=new M.$Pj("breakpointSupportsCondition",!1,{type:"boolean",description:N.localize(24,null)}),e.$5I=new M.$Pj("loadedScriptsSupported",!1,{type:"boolean",description:N.localize(25,null)}),e.$6I=new M.$Pj("loadedScriptsItemType",void 0,{type:"string",description:N.localize(26,null)}),e.$7I=new M.$Pj("focusedSessionIsAttach",!1,{type:"boolean",description:N.localize(27,null)}),e.$8I=new M.$Pj("focusedSessionIsNoDebug",!1,{type:"boolean",description:N.localize(28,null)}),e.$9I=new M.$Pj("stepBackSupported",!1,{type:"boolean",description:N.localize(29,null)}),e.$0I=new M.$Pj("restartFrameSupported",!1,{type:"boolean",description:N.localize(30,null)}),e.$$I=new M.$Pj("stackFrameSupportsRestart",!1,{type:"boolean",description:N.localize(31,null)}),e.$_I=new M.$Pj("jumpToCursorSupported",!1,{type:"boolean",description:N.localize(32,null)}),e.$aJ=new M.$Pj("stepIntoTargetsSupported",!1,{type:"boolean",description:N.localize(33,null)}),e.$bJ=new M.$Pj("breakpointsExist",!1,{type:"boolean",description:N.localize(34,null)}),e.$cJ=new M.$Pj("debuggersAvailable",!1,{type:"boolean",description:N.localize(35,null)}),e.$dJ=new M.$Pj("debugExtensionAvailable",!0,{type:"boolean",description:N.localize(36,null)}),e.$eJ=new M.$Pj("debugProtocolVariableMenuContext",void 0,{type:"string",description:N.localize(37,null)}),e.$fJ=new M.$Pj("debugSetVariableSupported",!1,{type:"boolean",description:N.localize(38,null)}),e.$gJ=new M.$Pj("debugSetDataBreakpointAddressSupported",!1,{type:"boolean",description:N.localize(39,null)}),e.$hJ=new M.$Pj("debugSetExpressionSupported",!1,{type:"boolean",description:N.localize(40,null)}),e.$iJ=new M.$Pj("breakWhenValueChangesSupported",!1,{type:"boolean",description:N.localize(41,null)}),e.$jJ=new M.$Pj("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:N.localize(42,null)}),e.$kJ=new M.$Pj("breakWhenValueIsReadSupported",!1,{type:"boolean",description:N.localize(43,null)}),e.$lJ=new M.$Pj("terminateDebuggeeSupported",!1,{type:"boolean",description:N.localize(44,null)}),e.$mJ=new M.$Pj("suspendDebuggeeSupported",!1,{type:"boolean",description:N.localize(45,null)}),e.$nJ=new M.$Pj("variableEvaluateNamePresent",!1,{type:"boolean",description:N.localize(46,null)}),e.$oJ=new M.$Pj("variableIsReadonly",!1,{type:"boolean",description:N.localize(47,null)}),e.$pJ=new M.$Pj("variableValue",!1,{type:"string",description:N.localize(48,null)}),e.$qJ=new M.$Pj("variableType",!1,{type:"string",description:N.localize(49,null)}),e.$rJ=new M.$Pj("variableInterfaces",!1,{type:"array",description:N.localize(50,null)}),e.$sJ=new M.$Pj("variableName",!1,{type:"string",description:N.localize(51,null)}),e.$tJ=new M.$Pj("variableLanguage",!1,{type:"string",description:N.localize(52,null)}),e.$uJ=new M.$Pj("variableExtensionId",!1,{type:"string",description:N.localize(53,null)}),e.$vJ=new M.$Pj("exceptionWidgetVisible",!1,{type:"boolean",description:N.localize(54,null)}),e.$wJ=new M.$Pj("multiSessionRepl",!1,{type:"boolean",description:N.localize(55,null)}),e.$xJ=new M.$Pj("multiSessionDebug",!1,{type:"boolean",description:N.localize(56,null)}),e.$yJ=new M.$Pj("disassembleRequestSupported",!1,{type:"boolean",description:N.localize(57,null)}),e.$zJ=new M.$Pj("disassemblyViewFocus",!1,{type:"boolean",description:N.localize(58,null)}),e.$AJ=new M.$Pj("languageSupportsDisassembleRequest",!1,{type:"boolean",description:N.localize(59,null)}),e.$BJ=new M.$Pj("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:N.localize(60,null)});const A=t=>N.localize(61,null,t);e.$CJ=A,e.$DJ="editor.contrib.debug",e.$EJ="editor.contrib.breakpoint",e.$FJ="debug",e.$GJ={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:N.localize(62,null)};var p;(function(t){t[t.Inactive=0]="Inactive",t[t.Initializing=1]="Initializing",t[t.Stopped=2]="Stopped",t[t.Running=3]="Running"})(p||(e.State=p={}));function m(t){switch(t){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}var D;(function(t){t[t.Valid=0]="Valid",t[t.Unreadable=1]="Unreadable",t[t.Error=2]="Error"})(D||(e.MemoryRangeType=D={})),e.$IJ="vscode-debug-memory";function O(t){return t.source.presentationHint==="deemphasize"||t.presentationHint==="deemphasize"||t.presentationHint==="subtle"}var S;(function(t){t[t.Variable=0]="Variable",t[t.Address=1]="Address"})(S||(e.DataBreakpointSetType=S={}));var d;(function(t){t[t.Initial=1]="Initial",t[t.Dynamic=2]="Dynamic"})(d||(e.DebugConfigurationProviderTriggerKind=d={}));var w;(function(t){t.UnverifiedBreakpoints="unverifiedBreakpoints"})(w||(e.DebuggerString=w={})),e.$KJ=(0,T.$yi)("debugService");var f;(function(t){t[t.CONDITION=0]="CONDITION",t[t.HIT_COUNT=1]="HIT_COUNT",t[t.LOG_MESSAGE=2]="LOG_MESSAGE",t[t.TRIGGER_POINT=3]="TRIGGER_POINT"})(f||(e.BreakpointWidgetContext=f={}));var o;(function(t){t[t.Command=0]="Command",t[t.Tree=1]="Tree"})(o||(e.DebugVisualizationType=o={}));var r;(function(t){t[t.None=0]="None",t[t.Collapsed=1]="Collapsed",t[t.Expanded=2]="Expanded"})(r||(e.DebugTreeItemCollapsibleState=r={}));var s;(function(t){t.deserialize=c=>c,t.serialize=c=>c})(s||(e.IDebugVisualizationTreeItem=s={}));var n;(function(t){t.deserialize=c=>({id:c.id,name:c.name,iconPath:c.iconPath&&{light:C.URI.revive(c.iconPath.light),dark:C.URI.revive(c.iconPath.dark)},iconClass:c.iconClass,visualization:c.visualization}),t.serialize=c=>c})(n||(e.IDebugVisualization=n={}))}),define(Se[228],Ie([1,0,13,2,19,26,16,30,20,18]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JH=void 0,e.$xH=S,e.$yH=d,e.$zH=w,e.$AH=f,e.$BH=o,e.$CH=r,e.$DH=s,e.$EH=t,e.$FH=i,e.$GH=b,e.$HH=l,e.$IH=$;const O=/{([^}]+)}/g;function S(y,h,E){return y.replace(O,function(k,I){return h&&I.length>0&&I[0]!=="_"?k:E&&E.hasOwnProperty(I)?E[I]:k})}function d(y){const h={};for(const E of Object.keys(y))E.startsWith("!")||(h[E]=y[E]);return h}function w(y){return y.configuration.request==="attach"&&!f(y)&&(!y.parentSession||w(y.parentSession))}function f(y){let h=y.configuration.type;if(h)return h==="vslsShare"&&(h=y.configuration.adapterProxy.configuration.type),(0,C.$zf)(h,"extensionhost")||(0,C.$zf)(h,"pwa-extensionhost")?y:y.parentSession?f(y.parentSession):void 0}function o(y){return y.type&&(y.label||y.program||y.runtime)}function r(y,h,E){let k,I=0;const P=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let V=null;for(;V=P.exec(y);){const W=V.index+1,q=W+V[0].length;if(W<=h&&q>=E){k=V[0],I=W;break}}if(k){const W=/\w+/g;let q=null;for(;(q=W.exec(k))&&!(q.index+1+I+q[0].length>=E););q&&(k=k.substring(0,W.lastIndex))}return k?{start:I,end:I+k.length-1}:{start:0,end:0}}async function s(y,h,E,k){if(y.evaluatableExpressionProvider.has(h)){const I=y.evaluatableExpressionProvider.ordered(h),P=(0,D.$Hb)(await Promise.all(I.map(async V=>{try{return await V.provideEvaluatableExpression(h,E,k??m.CancellationToken.None)}catch{return}})));if(P.length>0){let V=P[0].expression;const W=P[0].range;return V||(V=h.getLineContent(E.lineNumber).substring(W.startColumn-1,W.endColumn-1)),{range:W,matchingExpression:V}}}else{const I=h.getLineContent(E.lineNumber),{start:P,end:V}=r(I,E.column,E.column),W=I.substring(P-1,V);return{matchingExpression:W,range:new p.$zt(E.lineNumber,P,E.lineNumber,P+W.length)}}return null}const n=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function t(y){return!!(y&&y.match(n))}function c(y){if(typeof y.path=="string"&&!(typeof y.sourceReference=="number"&&y.sourceReference>0)){if(t(y.path))return N.URI.parse(y.path);if((0,M.$ic)(y.path))return N.URI.file(y.path)}return y.path}function u(y){if(typeof y.path=="object"){const h=N.URI.revive(y.path);if(h)return h.scheme===A.Schemas.file?h.fsPath:h.toString()}return y.path}function i(y,h){const E=h?c:u,k=(0,T.$5n)(y);return a(k,(I,P)=>{I&&P&&(P.path=E(P))}),k}function b(y,h){const E=h?c:u,k=(0,T.$5n)(y);return a(k,(I,P)=>{!I&&P&&(P.path=E(P))}),k}function a(y,h){switch(y.type){case"event":{const E=y;switch(E.event){case"output":h(!1,E.body.source);break;case"loadedSource":h(!1,E.body.source);break;case"breakpoint":h(!1,E.body.breakpoint.source);break;default:break}break}case"request":{const E=y;switch(E.command){case"setBreakpoints":h(!0,E.arguments.source);break;case"breakpointLocations":h(!0,E.arguments.source);break;case"source":h(!0,E.arguments.source);break;case"gotoTargets":h(!0,E.arguments.source);break;case"launchVSCode":E.arguments.args.forEach(k=>h(!1,k));break;default:break}break}case"response":{const E=y;if(E.success&&E.body)switch(E.command){case"stackTrace":E.body.stackFrames.forEach(k=>h(!1,k.source));break;case"loadedSources":E.body.sources.forEach(k=>h(!1,k));break;case"scopes":E.body.scopes.forEach(k=>h(!1,k.source));break;case"setFunctionBreakpoints":E.body.breakpoints.forEach(k=>h(!1,k.source));break;case"setBreakpoints":E.body.breakpoints.forEach(k=>h(!1,k.source));break;case"disassemble":E.body?.instructions.forEach(I=>h(!1,I.location));break;default:break}break}}}function l(y){return y.filter(h=>!h.presentation?.hidden).sort((h,E)=>h.presentation?E.presentation?h.presentation.group?E.presentation.group?h.presentation.group!==E.presentation.group?h.presentation.group.localeCompare(E.presentation.group):g(h.presentation.order,E.presentation.order):-1:E.presentation.group?1:g(h.presentation.order,E.presentation.order):-1:E.presentation?1:0)}function g(y,h){return typeof y!="number"?typeof h!="number"?0:1:typeof h!="number"?-1:y-h}async function $(y,h){const E=y.getValue("debug.saveBeforeStart",{overrideIdentifier:h.activeTextEditorLanguageId});if(E!=="none"&&(await h.saveAll(),E==="allEditorsInActiveGroup")){const k=h.activeEditorPane;k&&k.input.resource?.scheme===A.Schemas.untitled&&await h.save({editor:k.input,groupId:k.group.id})}await y.reloadConfiguration()}const v=(y,h)=>!y||!h?y===h:y.name===h.name&&y.path===h.path&&y.sourceReference===h.sourceReference;e.$JH=v}),define(Se[229],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3J=e.CellExecutionUpdateType=void 0;var N;(function(M){M[M.Output=1]="Output",M[M.OutputItems=2]="OutputItems",M[M.ExecutionState=3]="ExecutionState"})(N||(e.CellExecutionUpdateType=N={})),e.$3J=(0,C.$yi)("INotebookExecutionService")}),define(Se[230],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3ib=e.$2ib=e.ProxyKernelState=e.$1ib=void 0,e.$1ib=100;var N;(function(M){M[M.Disconnected=1]="Disconnected",M[M.Connected=2]="Connected",M[M.Initializing=3]="Initializing"})(N||(e.ProxyKernelState=N={})),e.$2ib=(0,C.$yi)("INotebookKernelService"),e.$3ib=(0,C.$yi)("INotebookKernelHistoryService")}),define(Se[231],Ie([1,0,6,30,156,96]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$NXb=void 0;class A extends C.$Uc{constructor(m,D,O){super(),this._source=m,this.b=D,this.c=O,this.a=void 0}f(m){const D=m.getLineCount();return new N.$zt(1,1,D,this.g(m,D))}g(m,D){if(D<1||D>m.getLineCount())throw new Error("Illegal value for lineNumber");return m.getLineLength(D)+1}get inputTextBuffer(){if(!this.b){const m=new M.$7C;m.acceptChunk(this._source);const D=m.finish(!0),{textBuffer:O,disposable:S}=D.create(1);this.b=O,this.B(S)}return this.b}get outputTextBuffers(){return this.a||(this.a=this.c.map(m=>{const D=new M.$7C;D.acceptChunk(m);const O=D.finish(!0),{textBuffer:S,disposable:d}=O.create(1);return this.B(d),S})),this.a}findInInputs(m){const O=new T.$UC(m,!1,!1,null).parseSearchRequest();if(!O)return[];const S=this.f(this.inputTextBuffer);return this.inputTextBuffer.findMatchesLineByLine(S,O,!0,5e3)}findInOutputs(m){const O=new T.$UC(m,!1,!1,null).parseSearchRequest();return O?this.outputTextBuffers.map(S=>{const d=S.findMatchesLineByLine(this.f(S),O,!0,5e3);if(d.length!==0)return{textBuffer:S,matches:d}}).filter(S=>!!S):[]}}e.$NXb=A}),define(Se[52],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0K=e.TestPosition=e.TestIdPathParts=void 0;var C;(function(T){T.Delimiter="\0"})(C||(e.TestIdPathParts=C={}));var N;(function(T){T[T.IsSame=0]="IsSame",T[T.Disconnected=1]="Disconnected",T[T.IsChild=2]="IsChild",T[T.IsParent=3]="IsParent"})(N||(e.TestPosition=N={}));class M{static fromExtHostTestItem(A,p,m=A.parent){if(A._isRoot)return new M([p]);const D=[A.id];for(let O=m;O&&O.id!==p;O=O.parent)D.push(O.id);return D.push(p),new M(D.reverse())}static isRoot(A){return!A.includes("\0")}static root(A){const p=A.indexOf("\0");return p===-1?A:A.slice(0,p)}static fromString(A){return new M(A.split("\0"))}static join(A,p){return new M([...A.path,p])}static joinToString(A,p){return A.toString()+"\0"+p}static parentId(A){const p=A.lastIndexOf("\0");return p===-1?void 0:A.slice(0,p)}static localId(A){const p=A.lastIndexOf("\0");return p===-1?A:A.slice(p+1)}static isChild(A,p){return p.startsWith(A)&&p[A.length]==="\0"}static compare(A,p){return A===p?0:M.isChild(A,p)?2:M.isChild(p,A)?3:1}static getLengthOfCommonPrefix(A,p){if(A===0)return 0;let m=0;for(;m<A-1;){for(let D=1;D<A;D++){const O=p(D-1),S=p(D);if(O.path[m]!==S.path[m])return m}m++}return m}constructor(A,p=A.length){if(this.path=A,this.d=p,A.length===0||p<1)throw new Error("cannot create test with empty path")}get rootId(){return new M(this.path,1)}get parentId(){return this.d>1?new M(this.path,this.d-1):void 0}get localId(){return this.path[this.d-1]}get controllerId(){return this.path[0]}get isRoot(){return this.d===1}*idsFromRoot(){for(let A=1;A<=this.d;A++)yield new M(this.path,A)}*idsToRoot(){for(let A=this.d;A>0;A--)yield new M(this.path,A)}compare(A){if(typeof A=="string")return M.compare(this.toString(),A);for(let p=0;p<A.d&&p<this.d;p++)if(A.path[p]!==this.path[p])return 1;return A.d>this.d?2:A.d<this.d?3:0}toJSON(){return this.toString()}toString(){if(!this.c){this.c=this.path[0];for(let A=1;A<this.d;A++)this.c+="\0",this.c+=this.path[A]}return this.c}}e.$0K=M}),define(Se[62],Ie([1,0,2,94,30,52]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gL=e.TestsDiffOp=e.TestDiffOpType=e.IStatementCoverage=e.IDeclarationCoverage=e.IBranchCoverage=e.CoverageDetails=e.DetailType=e.$fL=e.IFileCoverage=e.ICoverageCount=e.TestResultItem=e.$eL=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.$dL=e.$cL=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.$bL=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.$aL=e.$_K=e.TestRunProfileBitset=e.ExtTestRunProfileKind=e.$$K=e.TestResultState=void 0;var A;(function(R){R[R.Unset=0]="Unset",R[R.Queued=1]="Queued",R[R.Running=2]="Running",R[R.Passed=3]="Passed",R[R.Failed=4]="Failed",R[R.Skipped=5]="Skipped",R[R.Errored=6]="Errored"})(A||(e.TestResultState=A={})),e.$$K={0:"unset",1:"queued",2:"running",3:"passed",4:"failed",5:"skipped",6:"errored"};var p;(function(R){R[R.Run=1]="Run",R[R.Debug=2]="Debug",R[R.Coverage=3]="Coverage"})(p||(e.ExtTestRunProfileKind=p={}));var m;(function(R){R[R.Run=2]="Run",R[R.Debug=4]="Debug",R[R.Coverage=8]="Coverage",R[R.HasNonDefaultProfile=16]="HasNonDefaultProfile",R[R.HasConfigurable=32]="HasConfigurable",R[R.SupportsContinuousRun=64]="SupportsContinuousRun"})(m||(e.TestRunProfileBitset=m={})),e.$_K=[2,4,8,16,32,64];const D=R=>"runId"in R;e.$aL=D;var O;(function(R){R.serialize=z=>({range:z.range.toJSON(),uri:z.uri.toJSON()}),R.deserialize=(z,K)=>({range:M.$zt.lift(K.range),uri:z.asCanonicalUri(C.URI.revive(K.uri))})})(O||(e.IRichLocation=O={}));var S;(function(R){R[R.Error=0]="Error",R[R.Output=1]="Output"})(S||(e.TestMessageType=S={}));var d;(function(R){R.serialize=z=>({message:z.message,type:0,expected:z.expected,actual:z.actual,contextValue:z.contextValue,location:z.location&&O.serialize(z.location)}),R.deserialize=(z,K)=>({message:K.message,type:0,expected:K.expected,actual:K.actual,contextValue:K.contextValue,location:K.location&&O.deserialize(z,K.location)})})(d||(e.ITestErrorMessage=d={}));const w=(R,z)=>`${z?"s":"e"}${R}`;e.$bL=w;var f;(function(R){R.serialize=z=>({message:z.message,type:1,offset:z.offset,length:z.length,location:z.location&&O.serialize(z.location)}),R.deserialize=(z,K)=>({message:K.message,type:1,offset:K.offset,length:K.length,location:K.location&&O.deserialize(z,K.location)})})(f||(e.ITestOutputMessage=f={}));var o;(function(R){R.serialize=z=>z.type===0?d.serialize(z):f.serialize(z),R.deserialize=(z,K)=>K.type===0?d.deserialize(z,K):f.deserialize(z,K)})(o||(e.ITestMessage=o={}));var r;(function(R){R.serializeWithoutMessages=z=>({state:z.state,duration:z.duration,messages:[]}),R.serialize=z=>({state:z.state,duration:z.duration,messages:z.messages.map(o.serialize)}),R.deserialize=(z,K)=>({state:K.state,duration:K.duration,messages:K.messages.map(ie=>o.deserialize(z,ie))})})(r||(e.ITestTaskState=r={}));const s="\0",n=(R,z)=>R+s+z;e.$cL=n;const t=R=>{const z=R.indexOf(s);return{ctrlId:R.slice(0,z),tagId:R.slice(z+1)}};e.$dL=t;var c;(function(R){R.serialize=z=>({extId:z.extId,label:z.label,tags:z.tags,busy:z.busy,children:void 0,uri:z.uri?.toJSON(),range:z.range?.toJSON()||null,description:z.description,error:z.error,sortText:z.sortText}),R.deserialize=(z,K)=>({extId:K.extId,label:K.label,tags:K.tags,busy:K.busy,children:void 0,uri:K.uri?z.asCanonicalUri(C.URI.revive(K.uri)):void 0,range:K.range?M.$zt.lift(K.range):null,description:K.description,error:K.error,sortText:K.sortText})})(c||(e.ITestItem=c={}));var u;(function(R){R[R.NotExpandable=0]="NotExpandable",R[R.Expandable=1]="Expandable",R[R.BusyExpanding=2]="BusyExpanding",R[R.Expanded=3]="Expanded"})(u||(e.TestItemExpandState=u={}));var i;(function(R){R.serialize=z=>({expand:z.expand,item:c.serialize(z.item)}),R.deserialize=(z,K)=>({controllerId:T.$0K.root(K.item.extId),expand:K.expand,item:c.deserialize(z,K.item)})})(i||(e.InternalTestItem=i={}));var b;(function(R){R.serialize=z=>{let K;return z.item&&(K={},z.item.label!==void 0&&(K.label=z.item.label),z.item.tags!==void 0&&(K.tags=z.item.tags),z.item.busy!==void 0&&(K.busy=z.item.busy),z.item.uri!==void 0&&(K.uri=z.item.uri?.toJSON()),z.item.range!==void 0&&(K.range=z.item.range?.toJSON()),z.item.description!==void 0&&(K.description=z.item.description),z.item.error!==void 0&&(K.error=z.item.error),z.item.sortText!==void 0&&(K.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:K}},R.deserialize=z=>{let K;return z.item&&(K={},z.item.label!==void 0&&(K.label=z.item.label),z.item.tags!==void 0&&(K.tags=z.item.tags),z.item.busy!==void 0&&(K.busy=z.item.busy),z.item.range!==void 0&&(K.range=z.item.range?M.$zt.lift(z.item.range):null),z.item.description!==void 0&&(K.description=z.item.description),z.item.error!==void 0&&(K.error=z.item.error),z.item.sortText!==void 0&&(K.sortText=z.item.sortText)),{extId:z.extId,expand:z.expand,item:K}}})(b||(e.ITestItemUpdate=b={}));const a=(R,z)=>{z.expand!==void 0&&(R.expand=z.expand),z.item!==void 0&&(R.item=R.item?Object.assign(R.item,z.item):z.item)};e.$eL=a;var l;(function(R){R.serializeWithoutMessages=z=>({...i.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(r.serializeWithoutMessages)}),R.serialize=z=>({...i.serialize(z),ownComputedState:z.ownComputedState,computedState:z.computedState,tasks:z.tasks.map(r.serialize)}),R.deserialize=(z,K)=>({...i.deserialize(z,K),ownComputedState:K.ownComputedState,computedState:K.computedState,tasks:K.tasks.map(ie=>r.deserialize(z,ie)),retired:!0})})(l||(e.TestResultItem=l={}));var g;(function(R){R.empty=()=>({covered:0,total:0}),R.sum=(z,K)=>{z.covered+=K.covered,z.total+=K.total}})(g||(e.ICoverageCount=g={}));var $;(function(R){R.serialize=z=>({id:z.id,statement:z.statement,branch:z.branch,declaration:z.declaration,testId:z.testId?.toString(),uri:z.uri.toJSON()}),R.deserialize=(z,K)=>({id:K.id,statement:K.statement,branch:K.branch,declaration:K.declaration,testId:K.testId?T.$0K.fromString(K.testId):void 0,uri:z.asCanonicalUri(C.URI.revive(K.uri))}),R.empty=(z,K)=>({id:z,uri:K,testId:void 0,statement:g.empty()})})($||(e.IFileCoverage=$={}));function v(R){return{...R,location:R.location?.toJSON()}}function y(R){return R.location=R.location?N.$yt.isIPosition(R.location)?N.$yt.lift(R.location):M.$zt.lift(R.location):void 0,R}e.$fL=3;var h;(function(R){R[R.Declaration=0]="Declaration",R[R.Statement=1]="Statement",R[R.Branch=2]="Branch"})(h||(e.DetailType=h={}));var E;(function(R){R.serialize=z=>z.type===0?I.serialize(z):P.serialize(z),R.deserialize=z=>z.type===0?I.deserialize(z):P.deserialize(z)})(E||(e.CoverageDetails=E={}));var k;(function(R){R.serialize=v,R.deserialize=y})(k||(e.IBranchCoverage=k={}));var I;(function(R){R.serialize=v,R.deserialize=y})(I||(e.IDeclarationCoverage=I={}));var P;(function(R){R.serialize=z=>({...v(z),branches:z.branches?.map(k.serialize)}),R.deserialize=z=>({...y(z),branches:z.branches?.map(k.deserialize)})})(P||(e.IStatementCoverage=P={}));var V;(function(R){R[R.Add=0]="Add",R[R.Update=1]="Update",R[R.DocumentSynced=2]="DocumentSynced",R[R.Remove=3]="Remove",R[R.IncrementPendingExtHosts=4]="IncrementPendingExtHosts",R[R.Retire=5]="Retire",R[R.AddTag=6]="AddTag",R[R.RemoveTag=7]="RemoveTag"})(V||(e.TestDiffOpType=V={}));var W;(function(R){R.deserialize=(z,K)=>K.op===0?{op:K.op,item:i.deserialize(z,K.item)}:K.op===1?{op:K.op,item:b.deserialize(K.item)}:K.op===2?{op:K.op,uri:z.asCanonicalUri(C.URI.revive(K.uri)),docv:K.docv}:K,R.serialize=z=>z.op===0?{op:z.op,item:i.serialize(z.item)}:z.op===1?{op:z.op,item:b.serialize(z.item)}:z})(W||(e.TestsDiffOp=W={}));class q{constructor(z){this.k=z,this.c=new Map,this.f=new Map,this.g=new Set,this.h=0,this.j=0,this.tags=this.c}apply(z){const K=this.v();for(const ie of z)switch(ie.op){case 0:this.l(i.deserialize(this.k,ie.item),K);break;case 1:this.o(b.deserialize(ie.item),K);break;case 3:this.p(ie.itemId,K);break;case 5:this.q(ie.itemId);break;case 4:this.updatePendingRoots(ie.amount);break;case 6:this.c.set(ie.tag.id,ie.tag);break;case 7:this.c.delete(ie.id);break}K.complete?.()}l(z,K){const ie=T.$0K.parentId(z.item.extId)?.toString();let de;if(!ie)de=this.w(z),this.g.add(de),this.f.set(z.item.extId,de);else if(this.f.has(ie)){const ye=this.f.get(ie);ye.children.add(z.item.extId),de=this.w(z,ye),this.f.set(z.item.extId,de)}else{console.error(`Test with unknown parent ID: ${JSON.stringify(z)}`);return}return K.add?.(de),z.expand===2&&this.h++,de}o(z,K){const ie=this.f.get(z.extId);if(ie)return z.expand!==void 0&&(ie.expand===2&&this.h--,z.expand===2&&this.h++),(0,e.$eL)(ie,z),K.update?.(ie),ie}p(z,K){const ie=this.f.get(z);if(!ie)return;const de=T.$0K.parentId(ie.item.extId)?.toString();de?this.f.get(de).children.delete(ie.item.extId):this.g.delete(ie);const ye=[[z]];for(;ye.length;)for(const De of ye.pop()){const ge=this.f.get(De);ge&&(ye.push(ge.children),this.f.delete(De),K.remove?.(ge,ge!==ie),ge.expand===2&&this.h--)}}q(z){}updatePendingRoots(z){this.j+=z}v(){return{}}}e.$gL=q}),define(Se[77],Ie([1,0,11,5,6,57,62,52]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$JO=e.$IO=e.$HO=e.$GO=e.$FO=e.TestItemEventOp=void 0;var m;(function(n){n[n.Upsert=0]="Upsert",n[n.SetTags=1]="SetTags",n[n.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",n[n.RemoveChild=3]="RemoveChild",n[n.SetProp=4]="SetProp",n[n.Bulk=5]="Bulk",n[n.DocumentSynced=6]="DocumentSynced"})(m||(e.TestItemEventOp=m={}));const D=(n,t)=>n===t,S=Object.entries({range:(n,t)=>n===t?!0:!n||!t?!1:n.equalsRange(t),busy:D,label:D,description:D,error:D,sortText:D,tags:(n,t)=>!(n.length!==t.length||n.some(c=>!t.includes(c)))}),d=(n,t)=>{let c;for(const[u,i]of S)i(n[u],t[u])||(c?c[u]=t[u]:c={[u]:t[u]});return c};class w extends M.$Uc{get root(){return this.s.root}constructor(t){super(),this.s=t,this.f=this.B(new C.$Kh(()=>this.flushDiff(),200)),this.g=this.B(new N.$fe),this.tree=new Map,this.j=new Map,this.m=[],this.onDidGenerateDiff=this.g.event,this.root.canResolveChildren=!0,this.z(this.root,void 0)}set resolveHandler(t){this.h=t;for(const c of this.tree.values())this.J(c)}get resolveHandler(){return this.h}collectDiff(){const t=this.m;return this.m=[],t}pushDiff(t){switch(t.op){case 2:{for(const c of this.m)if(c.op===2&&c.uri===t.uri){c.docv=t.docv;return}break}case 1:{const c=this.m[this.m.length-1];if(c){if(c.op===1&&c.item.extId===t.item.extId){(0,A.$eL)(c.item,t.item);return}if(c.op===0&&c.item.item.extId===t.item.extId){(0,A.$eL)(c.item,t.item);return}}break}}this.m.push(t),this.f.isScheduled()||this.f.schedule()}expand(t,c){const u=this.tree.get(t);if(u){if((u.expandLevels===void 0||c>u.expandLevels)&&(u.expandLevels=c),u.expand===1){const i=this.M(u);return i.isOpen()?this.L(u,c-1):i.wait().then(()=>this.L(u,c-1))}else if(u.expand===3)return u.resolveBarrier?.isOpen()===!1?u.resolveBarrier.wait().then(()=>this.L(u,c-1)):this.L(u,c-1)}}dispose(){for(const t of this.tree.values())this.s.getApiFor(t.actual).listener=void 0;this.tree.clear(),this.m=[],super.dispose()}w(t,c){switch(c.op){case 3:this.O(p.$0K.joinToString(t.fullId,c.id));break;case 0:this.z(c.item,t);break;case 5:for(const u of c.ops)this.w(t,u);break;case 1:this.C(c.new,c.old,t.fullId.toString());break;case 2:this.J(t);break;case 4:this.pushDiff({op:1,item:{extId:t.fullId.toString(),item:c.update}});break;case 6:this.y(t.actual.uri);break;default:(0,T.$ed)(c)}}y(t){t&&this.pushDiff({op:2,uri:t,docv:this.s.getDocumentVersion(t)})}z(t,c){const u=p.$0K.fromExtHostTestItem(t,this.root.id,c?.actual),i=this.s.getApiFor(t);i.parent&&i.parent!==c?.actual&&this.s.getChildren(i.parent).delete(t.id);let b=this.tree.get(u.toString());if(!b){b={fullId:u,actual:t,expandLevels:c?.expandLevels?c.expandLevels-1:void 0,expand:0},t.tags.forEach(this.D,this),this.tree.set(b.fullId.toString(),b),this.G(t,c),this.pushDiff({op:0,item:{controllerId:this.s.controllerId,expand:b.expand,item:this.s.toITestItem(t)}}),this.I(t,b,c);return}if(b.actual===t){this.H(t,b,c);return}if(b.actual.uri?.toString()!==t.uri?.toString())return this.O(u.toString()),this.z(t,c);const a=this.s.getChildren(b.actual),l=b.actual,g=d(this.s.toITestItem(l),this.s.toITestItem(t));this.s.getApiFor(l).listener=void 0,b.actual=t,b.resolveBarrier=void 0,b.expand=0,g&&(g.hasOwnProperty("tags")&&(this.C(t.tags,l.tags,u.toString()),delete g.tags),this.w(b,{op:4,update:g})),this.I(t,b,c);for(const[v,y]of a)this.s.getChildren(t).get(y.id)||this.O(p.$0K.joinToString(u,y.id));const $=b.expandLevels;$!==void 0&&queueMicrotask(()=>{b.expand===1&&(b.expandLevels=void 0,this.expand(u.toString(),$))}),this.y(b.actual.uri)}C(t,c,u){const i=new Set(c.map(b=>b.id));for(const b of t)i.delete(b.id)||this.D(b);this.pushDiff({op:1,item:{extId:u,item:{tags:t.map(b=>(0,A.$cL)(this.s.controllerId,b.id))}}}),i.forEach(this.F,this)}D(t){const c=this.j.get(t.id);c?c.refCount++:(this.j.set(t.id,{refCount:1}),this.pushDiff({op:6,tag:{id:(0,A.$cL)(this.s.controllerId,t.id)}}))}F(t){const c=this.j.get(t);c&&!--c.refCount&&(this.j.delete(t),this.pushDiff({op:7,id:(0,A.$cL)(this.s.controllerId,t)}))}G(t,c){this.s.getApiFor(t).parent=c&&c.actual!==this.root?c.actual:void 0}H(t,c,u){this.G(t,u);const i=this.s.getApiFor(t);i.parent=u?.actual,i.listener=b=>this.w(c,b),this.J(c)}I(t,c,u){this.H(t,c,u);for(const[i,b]of this.s.getChildren(t))this.z(b,c)}J(t){let c;this.h?t.resolveBarrier?c=t.resolveBarrier.isOpen()?3:2:c=t.actual.canResolveChildren?1:0:c=0,c!==t.expand&&(t.expand=c,this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:c}}),c===1&&t.expandLevels!==void 0&&this.M(t))}L(t,c){if(c<0)return;const u=[];for(const[i,b]of this.s.getChildren(t.actual)){const a=this.expand(p.$0K.joinToString(t.fullId,b.id),c);(0,C.$kh)(a)&&u.push(a)}if(u.length)return Promise.all(u).then(()=>{})}M(t){if(t.resolveBarrier)return t.resolveBarrier;if(!this.h){const b=new C.$xh;return b.open(),b}t.expand=2,this.N(t);const c=t.resolveBarrier=new C.$xh,u=b=>{console.error(`Unhandled error in resolveHandler of test controller "${this.s.controllerId}"`,b)};let i;try{i=this.h(t.actual===this.root?void 0:t.actual)}catch(b){u(b)}return(0,C.$kh)(i)?i.catch(u).then(()=>{c.open(),this.J(t)}):(c.open(),this.J(t)),t.resolveBarrier}N(t){this.pushDiff({op:1,item:{extId:t.fullId.toString(),expand:t.expand}})}O(t){const c=this.tree.get(t);if(!c)throw new Error("attempting to remove non-existent child");this.pushDiff({op:3,itemId:t});const u=[c];for(;u.length;){const i=u.pop();if(i){this.s.getApiFor(i.actual).listener=void 0;for(const b of i.actual.tags)this.F(b.id);this.tree.delete(i.fullId.toString());for(const[b,a]of this.s.getChildren(i.actual))u.push(this.tree.get(p.$0K.joinToString(i.fullId,a.id)))}}}flushDiff(){const t=this.collectDiff();t.length&&this.g.fire(t)}}e.$FO=w;class f extends Error{constructor(t){super(`Attempted to insert a duplicate test item ID ${t}`)}}e.$GO=f;class o extends Error{constructor(t){super(`TestItem with ID "${t}" is invalid. Make sure to create it from the createTestItem method.`)}}e.$HO=o;class r extends Error{constructor(t,c,u){super(`TestItem with ID "${t}" is from controller "${c}" and cannot be added as a child of an item from controller "${u}".`)}}e.$IO=r;const s=(n,t,c)=>{let u=new Map;return{get size(){return u.size},forEach(i,b){for(const a of u.values())i.call(b,a,this)},[Symbol.iterator](){return u.entries()},replace(i){const b=new Map,a=new Set(u.keys()),l={op:5,ops:[]};for(const g of i){if(!(g instanceof c))throw new o(g.id);const $=t(g).controllerId;if($!==n.controllerId)throw new r(g.id,$,n.controllerId);if(b.has(g.id))throw new f(g.id);b.set(g.id,g),a.delete(g.id),l.ops.push({op:0,item:g})}for(const g of a.keys())l.ops.push({op:3,id:g});n.listener?.(l),u=b},add(i){if(!(i instanceof c))throw new o(i.id);u.set(i.id,i),n.listener?.({op:0,item:i})},delete(i){u.delete(i)&&n.listener?.({op:3,id:i})},get(i){return u.get(i)},toJSON(){return Array.from(u.values())}}};e.$JO=s}),define(Se[107],Ie([1,0,77]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$LO=e.$KO=void 0;const N=new WeakMap,M=(A,p)=>{const m={controllerId:p};return N.set(A,m),m};e.$KO=M;const T=A=>{const p=N.get(A);if(!p)throw new C.$HO(A?.id||"<unknown>");return p};e.$LO=T}),define(Se[78],Ie([1,0,16,2]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gBb=e.$fBb=e.$eBb=void 0,e.$hBb=M,e.$iBb=A,e.$eBb="vscode-cdn.net",e.$fBb=`vscode-resource.${e.$eBb}`,e.$gBb=`'self' https://*.${e.$eBb}`;function M(p,m){return p.scheme===C.Schemas.http||p.scheme===C.Schemas.https?p:(m&&m.authority&&m.isRemote&&p.scheme===C.Schemas.file&&(p=N.URI.from({scheme:C.Schemas.vscodeRemote,authority:m.authority,path:p.path})),N.URI.from({scheme:C.Schemas.https,authority:`${p.scheme}+${T(p.authority)}.${e.$fBb}`,path:p.path,fragment:p.fragment,query:p.query}))}function T(p){return p.replace(/./g,m=>{const D=m.charCodeAt(0);return D>=97&&D<=122||D>=65&&D<=90||D>=48&&D<=57?m:"-"+D.toString(16).padStart(4,"0")})}function A(p){return p.replace(/-([0-9a-f]{4})/g,(m,D)=>String.fromCharCode(parseInt(D,16)))}}),define(Se[232],Ie([1,0,5,6,78]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mmc=void 0;class T{constructor(p,m,D){this.d=p,this.e=m,this.f=D,this.a=0,this.b=new N.$Tc,this.c=new Map,this.b.add(m.onDidChangeVisibleTextEditors(()=>{const O=m.getVisibleTextEditors();for(const S of this.c.values())O.indexOf(S.editor)<0&&S.inset.dispose()}))}dispose(){this.c.forEach(p=>p.inset.dispose()),this.b.dispose()}createWebviewEditorInset(p,m,D,O,S){let d;for(const t of this.e.getVisibleTextEditors(!0))if(t.value===p){d=t;break}if(!d)throw new Error("not a visible editor");const w=this,f=this.a++,o=new C.$fe,r=new C.$fe,s=new class{constructor(){this.a="",this.b=Object.create(null)}asWebviewUri(t){return(0,M.$hBb)(t,w.f)}get cspSource(){return M.$gBb}set options(t){this.b=t,w.d.$setOptions(f,t)}get options(){return this.b}set html(t){this.a=t,w.d.$setHtml(f,t)}get html(){return this.a}get onDidReceiveMessage(){return o.event}postMessage(t){return w.d.$postMessage(f,t)}},n=new class{constructor(){this.editor=p,this.line=m,this.height=D,this.webview=s,this.onDidDispose=r.event}dispose(){w.c.has(f)&&(w.c.delete(f),w.d.$disposeEditorInset(f),r.fire(),r.dispose(),o.dispose())}};return this.d.$createEditorInset(f,d.id,d.value.document.uri,m+1,D,O||{},S.identifier,S.extensionLocation),this.c.set(f,{editor:p,inset:n,onDidReceiveMessage:o}),n}$onDidDispose(p){const m=this.c.get(p);m&&m.inset.dispose()}$onDidReceiveMessage(p,m){this.c.get(p)?.onDidReceiveMessage.fire(m)}}e.$mmc=T}),define(Se[108],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pL=e.$oL=e.$nL=void 0,e.$nL="__",e.$oL=(0,C.$yi)("IAuthenticationService"),e.$pL=(0,C.$yi)("IAuthenticationExtensionsService")}),define(Se[233],Ie([1,0,3]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$EP=e.VariableKind=e.$DP=void 0,e.$DP=(0,C.$yi)("configurationResolverService");var N;(function(T){T.Unknown="unknown",T.Env="env",T.Config="config",T.Command="command",T.Input="input",T.ExtensionInstallFolder="extensionInstallFolder",T.WorkspaceFolder="workspaceFolder",T.Cwd="cwd",T.WorkspaceFolderBasename="workspaceFolderBasename",T.UserHome="userHome",T.LineNumber="lineNumber",T.SelectedText="selectedText",T.File="file",T.FileWorkspaceFolder="fileWorkspaceFolder",T.FileWorkspaceFolderBasename="fileWorkspaceFolderBasename",T.RelativeFile="relativeFile",T.RelativeFileDirname="relativeFileDirname",T.FileDirname="fileDirname",T.FileExtname="fileExtname",T.FileBasename="fileBasename",T.FileBasenameNoExtension="fileBasenameNoExtension",T.FileDirnameBasename="fileDirnameBasename",T.ExecPath="execPath",T.ExecInstallFolder="execInstallFolder",T.PathSeparator="pathSeparator",T.PathSeparatorAlias="/"})(N||(e.VariableKind=N={}));class M extends Error{constructor(A,p){super(p),this.variable=A}}e.$EP=M}),define(Se[234],Ie([1,0,19,75,15,26,23,97,192,233,13]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TP=void 0;class S{static{this.VARIABLE_LHS="${"}static{this.VARIABLE_REGEXP=/\$\{(.*?)\}/g}constructor(w,f,o,r){this.h=new Map,this.a=w,this.b=f,this.g=o,r&&(this.c=r.then(s=>this.i(s)))}i(w){if(A.$i){const f=Object.create(null);return Object.keys(w).forEach(o=>{f[o.toLowerCase()]=w[o]}),f}return w}resolveWithEnvironment(w,f,o){return this.l({env:this.i(w),userHome:void 0},f?f.uri:void 0,o)}async resolveAsync(w,f){const o={env:await this.c,userHome:await this.g};return this.l(o,w?w.uri:void 0,f)}async j(w,f,o,r){const s=T.$5n(f);A.$i&&s.windows?Object.keys(s.windows).forEach(t=>s[t]=s.windows[t]):A.$j&&s.osx?Object.keys(s.osx).forEach(t=>s[t]=s.osx[t]):A.$k&&s.linux&&Object.keys(s.linux).forEach(t=>s[t]=s.linux[t]),delete s.windows,delete s.osx,delete s.linux;const n={env:await this.c,userHome:await this.g};return this.l(n,w?w.uri:void 0,s,o,r)}async resolveAnyAsync(w,f,o){return this.j(w,f,o)}async resolveAnyMap(w,f,o){const r=new Map;return{newConfig:await this.j(w,f,o,r),resolvedVariables:r}}resolveWithInteractionReplace(w,f,o,r){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(w,f,o,r){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(w,f){if(this.h.has(w))throw new Error("Variable "+w+" is contributed twice.");this.h.set(w,f)}async l(w,f,o,r,s){if(M.$$f(o))return this.m(w,f,o,r,s);if(Array.isArray(o))return Promise.all(o.map(n=>this.l(w,f,n,r,s)));if(M.$ag(o)){const n=Object.create(null),t=await Promise.all(Object.keys(o).map(async c=>[await this.m(w,f,c,r,s),await this.l(w,f,o[c],r,s)]));for(const[c,u]of t)n[c]=u;return n}return o}m(w,f,o,r,s){return(0,O.$rf)(o,S.VARIABLE_REGEXP,async(n,t)=>{if(t.includes(S.VARIABLE_LHS))return n;let c=await this.o(w,n,t,f,r);return s?.set(t,c),c!==n&&M.$$f(c)&&c.match(S.VARIABLE_REGEXP)&&(c=await this.m(w,f,c,r,s)),c})}n(w){return this.b?this.b.getUriLabel(w,{noPrefix:!0}):w.fsPath}async o(w,f,o,r,s){let n;const t=o.split(":");t.length>1&&(o=t[0],n=t[1]);const c=b=>{const a=this.a.getFilePath();if(a)return(0,p.$Jw)(a);throw new D.$EP(b,(0,m.localize)(0,null,f))},u=b=>{const a=c(b);if(this.a.getWorkspaceFolderPathForFile){const l=this.a.getWorkspaceFolderPathForFile();if(l)return(0,p.$Jw)(l)}throw new D.$EP(b,(0,m.localize)(1,null,f,C.$nc(a)))},i=b=>{if(n){const a=this.a.getFolderUri(n);if(a)return a;throw new D.$EP(b,(0,m.localize)(2,null,f,n))}if(r)return r;throw this.a.getWorkspaceFolderCount()>1?new D.$EP(b,(0,m.localize)(3,null,f)):new D.$EP(b,(0,m.localize)(4,null,f))};switch(o){case"env":if(n){if(w.env){const b=w.env[A.$i?n.toLowerCase():n];if(M.$$f(b))return b}return""}throw new D.$EP(D.VariableKind.Env,(0,m.localize)(5,null,f));case"config":if(n){const b=this.a.getConfigurationValue(r,n);if(M.$hg(b))throw new D.$EP(D.VariableKind.Config,(0,m.localize)(6,null,f,n));if(M.$ag(b))throw new D.$EP(D.VariableKind.Config,(0,m.localize)(7,null,f,n));return b}throw new D.$EP(D.VariableKind.Config,(0,m.localize)(8,null,f));case"command":return this.p(D.VariableKind.Command,f,n,s,"command");case"input":return this.p(D.VariableKind.Input,f,n,s,"input");case"extensionInstallFolder":if(n){const b=await this.a.getExtension(n);if(!b)throw new D.$EP(D.VariableKind.ExtensionInstallFolder,(0,m.localize)(9,null,f,n));return this.n(b.extensionLocation)}throw new D.$EP(D.VariableKind.ExtensionInstallFolder,(0,m.localize)(10,null,f));default:switch(o){case"workspaceRoot":case"workspaceFolder":return(0,p.$Jw)(this.n(i(D.VariableKind.WorkspaceFolder)));case"cwd":return r||n?(0,p.$Jw)(this.n(i(D.VariableKind.Cwd))):N.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return(0,p.$Jw)(C.$nc(this.n(i(D.VariableKind.WorkspaceFolderBasename))));case"userHome":{if(w.userHome)return w.userHome;throw new D.$EP(D.VariableKind.UserHome,(0,m.localize)(11,null,f))}case"lineNumber":{const b=this.a.getLineNumber();if(b)return b;throw new D.$EP(D.VariableKind.LineNumber,(0,m.localize)(12,null,f))}case"selectedText":{const b=this.a.getSelectedText();if(b)return b;throw new D.$EP(D.VariableKind.SelectedText,(0,m.localize)(13,null,f))}case"file":return c(D.VariableKind.File);case"fileWorkspaceFolder":return u(D.VariableKind.FileWorkspaceFolder);case"fileWorkspaceFolderBasename":return C.$nc(u(D.VariableKind.FileWorkspaceFolderBasename));case"relativeFile":return r||n?C.$lc(this.n(i(D.VariableKind.RelativeFile)),c(D.VariableKind.RelativeFile)):c(D.VariableKind.RelativeFile);case"relativeFileDirname":{const b=C.$mc(c(D.VariableKind.RelativeFileDirname));if(r||n){const a=C.$lc(this.n(i(D.VariableKind.RelativeFileDirname)),b);return a.length===0?".":a}return b}case"fileDirname":return C.$mc(c(D.VariableKind.FileDirname));case"fileExtname":return C.$oc(c(D.VariableKind.FileExtname));case"fileBasename":return C.$nc(c(D.VariableKind.FileBasename));case"fileBasenameNoExtension":{const b=C.$nc(c(D.VariableKind.FileBasenameNoExtension));return b.slice(0,b.length-C.$oc(b).length)}case"fileDirnameBasename":return C.$nc(C.$mc(c(D.VariableKind.FileDirnameBasename)));case"execPath":{const b=this.a.getExecPath();return b||f}case"execInstallFolder":{const b=this.a.getAppRoot();return b||f}case"pathSeparator":case"/":return C.sep;default:try{const b=n?`${o}:${n}`:o;return this.p(D.VariableKind.Unknown,f,b,s,void 0)}catch{return f}}}}p(w,f,o,r,s){if(o&&r){const n=s===void 0?r[o]:r[s+":"+o];if(typeof n=="string")return n;throw new D.$EP(w,(0,m.localize)(14,null,f))}return f}}e.$TP=S}),define(Se[109],Ie([1,0,3,106]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OpenEditorContext=e.GroupsOrder=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.$4D=void 0,e.$5D=D,e.$6D=d,e.$7D=w,e.$4D=(0,C.$yi)("editorGroupsService");var M;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(M||(e.GroupDirection=M={}));var T;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(T||(e.GroupOrientation=T={}));var A;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(A||(e.GroupLocation=A={}));var p;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EXPAND=1]="EXPAND",f[f.EVEN=2]="EVEN"})(p||(e.GroupsArrangement=p={}));var m;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(m||(e.MergeGroupMode=m={}));function D(f){const o=f;return(0,N.$OF)(o?.editor)&&(0,N.$OF)(o?.replacement)}var O;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(O||(e.GroupsOrder=O={}));var S;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(S||(e.OpenEditorContext=S={}));function d(f){const o=f;return!!o&&typeof o.id=="number"&&Array.isArray(o.editors)}function w(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}}),define(Se[235],Ie([1,0,3,109]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$D=e.$0D=e.$9D=e.$8D=void 0,e.$_D=M,e.$8D=(0,C.$yi)("editorService"),e.$9D=-1,e.$0D=-2,e.$$D=-3;function M(T){const A=T;return typeof T=="number"||(0,N.$6D)(A)}}),define(Se[236],Ie([1,0,3,99]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$IL=void 0,e.$IL=(0,C.$zi)(N.$Fi)}),define(Se[110],Ie([1,0,21,5,19,6,11]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jac=e.$Iac=e.$Hac=e.$Gac=e.$Fac=void 0;class p{constructor(n,t){this.versionId=n,this.removedDueToLooping=t}}e.$Fac=p;class m{static isHostExtension(n,t,c){if(t.getExtensionDescription(n))return!1;const u=c.getExtensionDescription(n);return u?!!((u.main||u.browser)&&u.api==="none"):!1}constructor(n,t){this.j=n,this.c=new N.$fe,this.onDidChange=this.c.event,this.d=0,this.e=t,this.k()}k(){this.e.sort(o),this.f=new C.$Vm,this.g=[],this.h=new Map;for(const n of this.e){if(this.f.has(n.identifier)){console.error("Extension `"+n.identifier.value+"` is already registered");continue}this.f.set(n.identifier,n),this.g.push(n);const t=this.j.readActivationEvents(n);for(const c of t)this.h.has(c)||this.h.set(c,[]),this.h.get(c).push(n)}}set(n){return this.e=n,this.k(),this.d++,this.c.fire(void 0),{versionId:this.d}}deltaExtensions(n,t){this.e=r(this.e,t),this.e=this.e.concat(n);const c=m.l(this.e);return this.e=r(this.e,c.map(u=>u.identifier)),this.k(),this.d++,this.c.fire(void 0),new p(this.d,c)}static l(n){const t=new class{constructor(){this.c=new Map,this.d=new Set,this.e=[]}addNode(a){this.d.has(a)||(this.d.add(a),this.e.push(a))}addArc(a,l){this.addNode(a),this.addNode(l),this.c.has(a)?this.c.get(a).push(l):this.c.set(a,[l])}getArcs(a){return this.c.has(a)?this.c.get(a):[]}hasOnlyGoodArcs(a,l){const g=t.getArcs(a);for(let $=0;$<g.length;$++)if(!l.has(g[$]))return!1;return!0}getNodes(){return this.e}},c=new C.$Vm;for(const a of n)if(c.set(a.identifier,a),a.extensionDependencies)for(const l of a.extensionDependencies)t.addArc(C.$Tm.toKey(a.identifier),C.$Tm.toKey(l));const u=new Set;t.getNodes().filter(a=>t.getArcs(a).length===0).forEach(a=>u.add(a));const i=t.getNodes().filter(a=>!u.has(a));let b;do{b=!1;for(let a=0;a<i.length;a++){const l=i[a];t.hasOnlyGoodArcs(l,u)&&(i.splice(a,1),a--,u.add(l),b=!0)}}while(b);return i.map(a=>c.get(a))}containsActivationEvent(n){return this.h.has(n)}containsExtension(n){return this.f.has(n)}getExtensionDescriptionsForActivationEvent(n){const t=this.h.get(n);return t?t.slice(0):[]}getAllExtensionDescriptions(){return this.g.slice(0)}getSnapshot(){return new D(this.d,this.getAllExtensionDescriptions())}getExtensionDescription(n){const t=this.f.get(n);return t||void 0}getExtensionDescriptionByUUID(n){for(const t of this.g)if(t.uuid===n)return t}getExtensionDescriptionByIdOrUUID(n,t){return this.getExtensionDescription(n)??(t?this.getExtensionDescriptionByUUID(t):void 0)}}e.$Gac=m;class D{constructor(n,t){this.versionId=n,this.extensions=t}}e.$Hac=D;class O{constructor(n){this.d=new w,this.c=new m(n,[])}async acquireLock(n){const t=await this.d.acquire(n);return new S(this,t)}deltaExtensions(n,t,c){if(!n.isAcquiredFor(this))throw new Error("Lock is not held");return this.c.deltaExtensions(t,c)}containsActivationEvent(n){return this.c.containsActivationEvent(n)}containsExtension(n){return this.c.containsExtension(n)}getExtensionDescriptionsForActivationEvent(n){return this.c.getExtensionDescriptionsForActivationEvent(n)}getAllExtensionDescriptions(){return this.c.getAllExtensionDescriptions()}getSnapshot(){return this.c.getSnapshot()}getExtensionDescription(n){return this.c.getExtensionDescription(n)}getExtensionDescriptionByUUID(n){return this.c.getExtensionDescriptionByUUID(n)}getExtensionDescriptionByIdOrUUID(n,t){return this.c.getExtensionDescriptionByIdOrUUID(n,t)}}e.$Iac=O;class S extends T.$Uc{constructor(n,t){super(),this.f=n,this.c=!1,this.B(t)}isAcquiredFor(n){return!this.c&&this.f===n}}e.$Jac=S;class d{constructor(n){this.name=n;const t=(0,A.$rh)();this.promise=t.promise,this.c=t.resolve}resolve(n){this.c(n)}}class w{constructor(){this.c=[],this.d=!1}async acquire(n){const t=new d(n);return this.c.push(t),this.e(),t.promise}e(){if(this.d||this.c.length===0)return;const n=this.c.shift();this.d=!0;let t=!0;const c=setTimeout(()=>{t&&console.warn(`The customer named ${n.name} has been holding on to the lock for 30s. This might be a problem.`)},30*1e3),u=()=>{t&&(clearTimeout(c),t=!1,this.d=!1,this.e())};n.resolve((0,T.$Sc)(u))}}var f;(function(s){s[s.Builtin=0]="Builtin",s[s.User=1]="User",s[s.Dev=2]="Dev"})(f||(f={}));function o(s,n){const t=s.isBuiltin?0:s.isUnderDevelopment?2:1,c=n.isBuiltin?0:n.isUnderDevelopment?2:1;if(t!==c)return t-c;const u=M.$gc.basename(s.extensionLocation.path),i=M.$gc.basename(n.extensionLocation.path);return u<i?-1:u>i?1:0}function r(s,n){const t=new C.$Um(n);return s.filter(c=>!t.has(c.identifier))}}),define(Se[79],Ie([1,0,22]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0,e.$2m=A,e.$3m=p;var N;(function(D){D[D.Desktop=1]="Desktop",D[D.Web=2]="Web"})(N||(e.UIKind=N={}));var M;(function(D){D[D.VersionMismatch=55]="VersionMismatch",D[D.UnexpectedError=81]="UnexpectedError"})(M||(e.ExtensionHostExitCode=M={}));var T;(function(D){D[D.Initialized=0]="Initialized",D[D.Ready=1]="Ready",D[D.Terminate=2]="Terminate"})(T||(e.MessageType=T={}));function A(D){const O=C.$He.alloc(1);switch(D){case 0:O.writeUInt8(1,0);break;case 1:O.writeUInt8(2,0);break;case 2:O.writeUInt8(3,0);break}return O}function p(D,O){if(D.byteLength!==1)return!1;switch(D.readUInt8(0)){case 1:return O===0;case 2:return O===1;case 3:return O===2;default:return!1}}var m;(function(D){D.Start="START_NATIVE_LOG",D.End="END_NATIVE_LOG"})(m||(e.NativeLogMarkers=m={}))}),define(Se[63],Ie([1,0,3,5,12,27,79,58,59,26,2,6,179]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0O=e.$8O=e.$7O=void 0,e.$9O=o;let w=class extends S.$Uc{constructor(s,n){super(),this.s=s,this.t=n,this.a=this.B(new N.$fe),this.onDidChangeTelemetryEnabled=this.a.event,this.b=this.B(new N.$fe),this.onDidChangeTelemetryConfiguration=this.b.event,this.c={usage:!0,error:!0},this.f=0,this.g=!1,this.j=!1,this.r=new Map,this.m=O.URI.revive(this.s.environment.extensionTelemetryLogResource),this.j=this.s.environment.isExtensionTelemetryLoggingOnly,this.n=n.createLogger(this.m,{id:m.$op,name:(0,d.localize)(0,null,this.j?" (Not Sent)":""),hidden:!0}),this.B(this.n),this.B(n.onDidChangeLogLevel(t=>{(0,M.$7j)(t)&&this.u()})),this.n.info("Below are logs for extension telemetry events sent to the telemetry output channel API once the log level is set to trace."),this.n.info("===========================================================")}u(){this.t.setVisibility(this.m,this.g&&this.t.getLogLevel()===M.LogLevel.Trace)}getTelemetryConfiguration(){return this.f===3}getTelemetryDetails(){return{isCrashEnabled:this.f>=1,isErrorsEnabled:this.c.error?this.f>=2:!1,isUsageEnabled:this.c.usage?this.f>=3:!1}}instantiateLogger(s,n,t){const c=this.getTelemetryDetails(),u=new f(n,t,s,this.n,this.j,this.getBuiltInCommonProperties(s),{isUsageEnabled:c.isUsageEnabled,isErrorsEnabled:c.isErrorsEnabled}),i=this.r.get(s.identifier.value)??[];return this.r.set(s.identifier.value,[...i,u]),u.apiTelemetryLogger}$initializeTelemetryLevel(s,n,t){this.f=s,this.g=n,this.c=t??{usage:!0,error:!0},this.u()}getBuiltInCommonProperties(s){const n=Object.create(null);switch(n["common.extname"]=`${s.publisher}.${s.name}`,n["common.extversion"]=s.version,n["common.vscodemachineid"]=this.s.telemetryInfo.machineId,n["common.vscodesessionid"]=this.s.telemetryInfo.sessionId,n["common.sqmid"]=this.s.telemetryInfo.sqmId,n["common.vscodeversion"]=this.s.version,n["common.isnewappinstall"]=o(this.s.telemetryInfo.firstSessionDate),n["common.product"]=this.s.environment.appHost,this.s.uiKind){case A.UIKind.Web:n["common.uikind"]="web";break;case A.UIKind.Desktop:n["common.uikind"]="desktop";break;default:n["common.uikind"]="unknown"}return n["common.remotename"]=(0,p.$Km)((0,m.$up)(this.s.remote.authority)),n}$onDidChangeTelemetryLevel(s){this.h=this.getTelemetryConfiguration(),this.f=s;const n=this.getTelemetryDetails();this.r.forEach((t,c)=>{const u=t.filter(i=>!i.isDisposed);u.length===0?this.r.delete(c):this.r.set(c,u)}),this.r.forEach(t=>{for(const c of t)c.updateTelemetryEnablements(n.isUsageEnabled,n.isErrorsEnabled)}),this.h!==this.getTelemetryConfiguration()&&this.a.fire(this.getTelemetryConfiguration()),this.b.fire(this.getTelemetryDetails()),this.u()}onExtensionError(s,n){const c=this.r.get(s.value)?.filter(i=>!i.isDisposed);if(!c)return this.r.delete(s.value),!1;let u=!1;for(const i of c)i.ignoreUnhandledExtHostErrors||(i.logError(n),u=!0);return u}};e.$7O=w,e.$7O=w=Je([We(0,T.$6O),We(1,M.$6j)],w);class f{static validateSender(s){if(typeof s!="object")throw new TypeError("TelemetrySender argument is invalid");if(typeof s.sendEventData!="function")throw new TypeError("TelemetrySender.sendEventData must be a function");if(typeof s.sendErrorData!="function")throw new TypeError("TelemetrySender.sendErrorData must be a function");if(typeof s.flush<"u"&&typeof s.flush!="function")throw new TypeError("TelemetrySender.flush must be a function or undefined")}constructor(s,n,t,c,u,i,b){this.g=t,this.h=c,this.i=u,this.j=i,this.a=new N.$fe,this.ignoreUnhandledExtHostErrors=n?.ignoreUnhandledErrors??!1,this.b=n?.ignoreBuiltInCommonProperties??!1,this.c=n?.additionalCommonProperties,this.f=s,this.d={isUsageEnabled:b.isUsageEnabled,isErrorsEnabled:b.isErrorsEnabled}}updateTelemetryEnablements(s,n){this.e&&(this.d={isUsageEnabled:s,isErrorsEnabled:n},this.a.fire(this.e))}mixInCommonPropsAndCleanData(s){let n="properties"in s?s.properties??{}:s;return n=(0,m.$xp)(n,[]),this.c&&(n=(0,D.$8n)(n,this.c)),this.b||(n=(0,D.$8n)(n,this.j)),"properties"in s?s.properties=n:s=n,s}k(s,n){this.f&&(this.g.publisher==="vscode"?s=this.g.name+"/"+s:s=this.g.identifier.value+"/"+s,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f?.sendEventData(s,n),this.h.trace(s,n))}logUsage(s,n){this.d.isUsageEnabled&&this.k(s,n)}logError(s,n){if(!(!this.d.isErrorsEnabled||!this.f))if(typeof s=="string")this.k(s,n);else{const t={name:s.name,message:s.message,stack:s.stack,cause:s.cause},c=(0,m.$xp)(t,[]),u=new Error(c.message,{cause:c.cause});u.stack=c.stack,u.name=c.name,n=this.mixInCommonPropsAndCleanData(n||{}),this.i||this.f.sendErrorData(u,n),this.h.trace("exception",n)}}get apiTelemetryLogger(){if(!this.e){const s=this,n={logUsage:s.logUsage.bind(s),get isUsageEnabled(){return s.d.isUsageEnabled},get isErrorsEnabled(){return s.d.isErrorsEnabled},logError:s.logError.bind(s),dispose:s.dispose.bind(s),onDidChangeEnableStates:s.a.event.bind(s)};this.e=Object.freeze(n)}return this.e}get isDisposed(){return!this.f}dispose(){if(this.f?.flush){let s=this.f;this.f=void 0,Promise.resolve(s.flush()).then(s=void 0),this.e=void 0}else this.f=void 0}}e.$8O=f;function o(r){const s=Date.now()-new Date(r).getTime();return isNaN(s)?!1:s<1e3*60*60*24}e.$0O=(0,C.$yi)("IExtHostTelemetry")}),define(Se[25],Ie([1,0,5,2,207,105,21,3]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RG=e.ActivationKind=e.$OG=e.$NG=e.$KG=e.ExtensionHostStartup=e.$JG=e.$IG=e.$HG=e.$GG=void 0,e.$LG=d,e.$MG=w,e.$PG=s,e.$QG=n,e.$GG=Object.freeze({identifier:new A.$Tm("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:N.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.$HG="extensions.webWorker",e.$IG=(0,p.$yi)("extensionService");class m{constructor(u){this.dependency=u}}e.$JG=m;var D;(function(c){c[c.EagerAutoStart=1]="EagerAutoStart",c[c.EagerManualStart=2]="EagerManualStart",c[c.Lazy=3]="Lazy"})(D||(e.ExtensionHostStartup=D={}));class O{get versionId(){return this.c}get allExtensions(){return this.d}get myExtensions(){return this.e}constructor(u,i,b){this.c=u,this.d=i.slice(0),this.e=b.slice(0),this.f=null}toSnapshot(){return{versionId:this.c,allExtensions:this.d,myExtensions:this.e,activationEvents:T.$rG.createActivationEventsMap(this.d)}}set(u,i,b){if(this.c>u)throw new Error(`ExtensionHostExtensions: invalid versionId ${u} (current: ${this.c})`);const a=[],l=[],g=[],$=[],v=S(this.d),y=S(i),h=(V,W)=>V.extensionLocation.toString()===W.extensionLocation.toString()||V.isBuiltin===W.isBuiltin||V.isUserBuiltin===W.isUserBuiltin||V.isUnderDevelopment===W.isUnderDevelopment;for(const V of this.d){const W=y.get(V.identifier);if(!W){a.push(V.identifier),v.delete(V.identifier);continue}if(!h(V,W)){a.push(V.identifier),v.delete(V.identifier);continue}}for(const V of i){const W=v.get(V.identifier);if(!W){l.push(V);continue}if(!h(W,V)){a.push(W.identifier),v.delete(W.identifier);continue}}const E=new A.$Um(this.e),k=new A.$Um(b);for(const V of this.e)k.has(V)||g.push(V);for(const V of b)E.has(V)||$.push(V);const I=T.$rG.createActivationEventsMap(l),P={versionId:u,toRemove:a,toAdd:l,addActivationEvents:I,myToRemove:g,myToAdd:$};return this.delta(P),P}delta(u){if(this.c>=u.versionId)return null;const{toRemove:i,toAdd:b,myToRemove:a,myToAdd:l}=u,g=new A.$Um(i),$=new A.$Um(a);for(let v=0;v<this.d.length;v++)g.has(this.d[v].identifier)&&(this.d.splice(v,1),v--);for(let v=0;v<this.e.length;v++)$.has(this.e[v])&&(this.e.splice(v,1),v--);for(const v of b)this.d.push(v);for(const v of l)this.e.push(v);return this.f=null,u}containsExtension(u){for(const i of this.e)if(A.$Tm.equals(i,u))return!0;return!1}containsActivationEvent(u){return this.f||(this.f=this.g()),this.f.has(u)}g(){const u=new Set;for(const i of this.d){if(!this.containsExtension(i.identifier))continue;const b=T.$rG.readActivationEvents(i);for(const a of b)u.add(a)}return u}}e.$KG=O;function S(c){const u=new A.$Vm;for(const i of c)u.set(i.identifier,i);return u}function d(c,u){return c.enabledApiProposals?c.enabledApiProposals.includes(u):!1}function w(c,u){if(!d(c,u))throw new Error(`Extension '${c.identifier.value}' CANNOT use API proposal: ${u}.
Its package.json#enabledApiProposals-property declares: ${c.enabledApiProposals?.join(", ")??"[]"} but NOT ${u}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${c.identifier.value}`)}class f{constructor(u,i,b,a){this.codeLoadingTime=u,this.activateCallTime=i,this.activateResolvedTime=b,this.activationReason=a}}e.$NG=f;class o{constructor(u,i){this.description=u,this.value=i}}e.$OG=o;var r;(function(c){c[c.Normal=0]="Normal",c[c.Immediate=1]="Immediate"})(r||(e.ActivationKind=r={}));function s(c){return{type:c.isBuiltin?0:1,isBuiltin:c.isBuiltin||c.isUserBuiltin,identifier:{id:(0,M.$Dp)(c.publisher,c.name),uuid:c.uuid},manifest:c,location:c.extensionLocation,targetPlatform:c.targetPlatform,validations:[],isValid:!0}}function n(c,u){return{identifier:new A.$Tm((0,M.$Bp)(c.manifest.publisher,c.manifest.name)),isBuiltin:c.type===0,isUserBuiltin:c.type===1&&c.isBuiltin,isUnderDevelopment:!!u,extensionLocation:c.location,...c.manifest,uuid:c.identifier.uuid,targetPlatform:c.targetPlatform,publisherDisplayName:c.publisherDisplayName}}class t{constructor(){this.onDidRegisterExtensions=C.Event.None,this.onDidChangeExtensionsStatus=C.Event.None,this.onDidChangeExtensions=C.Event.None,this.onWillActivateByEvent=C.Event.None,this.onDidChangeResponsiveChange=C.Event.None,this.onWillStop=C.Event.None,this.extensions=[]}activateByEvent(u){return Promise.resolve(void 0)}activateById(u,i){return Promise.resolve(void 0)}activationEventIsDone(u){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(u){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPorts(u,i){return Promise.resolve([])}stopExtensionHosts(){}async startExtensionHosts(){}async setRemoteEnvironment(u){}canAddExtension(){return!1}canRemoveExtension(){return!1}}e.$RG=t}),define(Se[237],Ie([1,0,14,110,21,25,12,11]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nmc=e.$Mmc=e.$Lmc=e.$Kmc=e.$Jmc=e.$Imc=void 0;class m{static{this.NONE=new m(!1,-1,-1,-1)}constructor(s,n,t,c){this.startup=s,this.codeLoadingTime=n,this.activateCallTime=t,this.activateResolvedTime=c}}e.$Imc=m;class D{constructor(s){this.a=s,this.b=-1,this.c=-1,this.d=-1,this.f=-1,this.g=-1,this.h=-1}j(s,n){return s===-1||n===-1?-1:n-s}build(){return new m(this.a,this.j(this.b,this.c),this.j(this.d,this.f),this.j(this.g,this.h))}codeLoadingStart(){this.b=Date.now()}codeLoadingStop(){this.c=Date.now()}activateCallStart(){this.d=Date.now()}activateCallStop(){this.f=Date.now()}activateResolveStart(){this.g=Date.now()}activateResolveStop(){this.h=Date.now()}}e.$Jmc=D;class O{constructor(s,n,t,c,u,i){this.activationFailed=s,this.activationFailedError=n,this.activationTimes=t,this.module=c,this.exports=u,this.subscriptions=i}}e.$Kmc=O;class S extends O{constructor(s){super(!1,null,s,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Lmc=S;class d extends O{constructor(){super(!1,null,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.$Mmc=d;class w extends O{constructor(s){super(!0,s,m.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}let f=class{constructor(s,n,t,c){this.g=c,this.a=s,this.b=n,this.c=t,this.d=new M.$Vm,this.f=Object.create(null)}dispose(){for(const[s,n]of this.d)n.dispose()}async waitForActivatingExtensions(){const s=[];for(const[n,t]of this.d)s.push(t.wait());await Promise.all(s)}isActivated(s){const n=this.d.get(s);return!!(n&&n.value)}getActivatedExtension(s){const n=this.d.get(s);if(!n||!n.value)throw new Error(`Extension '${s.value}' is not known or not activated`);return n.value}async activateByEvent(s,n){if(this.f[s])return;const t=this.a.getExtensionDescriptionsForActivationEvent(s);await this.h(t.map(c=>({id:c.identifier,reason:{startup:n,extensionId:c.identifier,activationEvent:s}}))),this.f[s]=!0}activateById(s,n){const t=this.a.getExtensionDescription(s);if(!t)throw new Error(`Extension '${s.value}' is not known`);return this.h([{id:t.identifier,reason:n}])}async h(s){const n=s.filter(t=>!this.isActivated(t.id)).map(t=>this.j(t));await Promise.all(n.map(t=>t.wait()))}j(s){if(this.d.has(s.id))return this.d.get(s.id);if(this.l(s.id))return this.k(s,null,[],null);const n=this.a.getExtensionDescription(s.id);if(!n){const u=new Error(`Cannot activate unknown extension '${s.id.value}'`),i=this.k(s,null,[],new w(u));return this.c.onExtensionActivationError(s.id,u,new T.$JG(s.id.value)),i}const t=[],c=typeof n.extensionDependencies>"u"?[]:n.extensionDependencies;for(const u of c){if(this.m(u))continue;const i=this.d.get(u);if(i){t.push(i);continue}if(this.l(u)){t.push(this.j({id:this.b.getExtensionDescription(u).identifier,reason:s.reason}));continue}const b=this.a.getExtensionDescription(u);if(b){if(!b.main&&!b.browser)continue;t.push(this.j({id:b.identifier,reason:s.reason}));continue}const a=n.displayName||n.identifier.value,l=new Error(`Cannot activate the '${a}' extension because it depends on unknown extension '${u}'`),g=this.k(s,n.displayName,[],new w(l));return this.c.onExtensionActivationError(n.identifier,l,new T.$JG(u)),g}return this.k(s,n.displayName,t,null)}k(s,n,t,c){const u=new o(s.id,n,s.reason,t,c,this.c,this.g);return this.d.set(s.id,u),u}l(s){return N.$Gac.isHostExtension(s,this.a,this.b)}m(s){const n=this.b.getExtensionDescription(s);return n?!n.main&&!n.browser:!1}};e.$Nmc=f,e.$Nmc=f=Je([We(3,A.$5j)],f);let o=class{get value(){return this.h}get friendlyName(){return this.d||this.c.value}constructor(s,n,t,c,u,i,b){this.c=s,this.d=n,this.f=t,this.g=c,this.h=u,this.j=i,this.k=b,this.a=new p.$xh,this.b=!1,this.l()}dispose(){this.b=!0}wait(){return this.a.wait()}async l(){await this.m(),this.a.open()}async m(){if(!this.h){for(;this.g.length>0;){for(let s=0;s<this.g.length;s++){const n=this.g[s];if(n.value&&!n.value.activationFailed){this.g.splice(s,1),s--;continue}if(n.value&&n.value.activationFailed){const t=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${n.friendlyName}' failed to activate`);t.detail=n.value.activationFailedError,this.h=new w(t),this.j.onExtensionActivationError(this.c,t,null);return}}this.g.length>0&&await Promise.race(this.g.map(s=>s.wait()))}await this.n()}}async n(){try{this.h=await this.j.actualActivateExtension(this.c,this.f)}catch(s){const n=new Error;if(s&&s.name&&(n.name=s.name),s&&s.message?n.message=`Activating extension '${this.c.value}' failed: ${s.message}.`:n.message=`Activating extension '${this.c.value}' failed: ${s}.`,s&&s.stack&&(n.stack=s.stack),this.h=new w(n),this.b&&C.$4(s))return;this.j.onExtensionActivationError(this.c,n,null),this.k.error(`Activating extension ${this.c.value} failed due to an error:`),this.k.error(s)}}};o=Je([We(6,A.$5j)],o)}),define(Se[238],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({activeComment:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.activeComment.d.ts",aiRelatedInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiRelatedInformation.d.ts",aiTextSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.aiTextSearchProvider.d.ts",attributableCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.attributableCoverage.d.ts",authGetSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authGetSessions.d.ts",authLearnMore:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authLearnMore.d.ts",authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",canonicalUriProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.canonicalUriProvider.d.ts",chatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipant.d.ts",chatParticipantAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatParticipantAdditions.d.ts",chatProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatProvider.d.ts",chatTab:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatTab.d.ts",chatVariableResolver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.chatVariableResolver.d.ts",codeActionAI:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionAI.d.ts",codeActionRanges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codeActionRanges.d.ts",codiconDecoration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.codiconDecoration.d.ts",commentReactor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentReactor.d.ts",commentThreadApplicability:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentThreadApplicability.d.ts",commentingRangeHint:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentingRangeHint.d.ts",commentsDraftState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsDraftState.d.ts",contribAccessibilityHelpContent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribAccessibilityHelpContent.d.ts",contribCommentEditorActionsMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentEditorActionsMenu.d.ts",contribCommentPeekContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentPeekContext.d.ts",contribCommentThreadAdditionalMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentThreadAdditionalMenu.d.ts",contribCommentsViewThreadMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribCommentsViewThreadMenus.d.ts",contribDiffEditorGutterToolBarMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribDiffEditorGutterToolBarMenus.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribEditorContentMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditorContentMenu.d.ts",contribIssueReporter:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribIssueReporter.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorMenus.d.ts",contribMultiDiffEditorMenus:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMultiDiffEditorMenus.d.ts",contribNotebookStaticPreloads:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribNotebookStaticPreloads.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribSourceControlHistoryItemGroupMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemGroupMenu.d.ts",contribSourceControlHistoryItemMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlHistoryItemMenu.d.ts",contribSourceControlInputBoxMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlInputBoxMenu.d.ts",contribSourceControlTitleMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribSourceControlTitleMenu.d.ts",contribStatusBarItems:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribStatusBarItems.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",createFileSystemWatcher:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.createFileSystemWatcher.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",debugVisualization:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.debugVisualization.d.ts",defaultChatParticipant:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.defaultChatParticipant.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",diffContentOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffContentOptions.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editSessionIdentityProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editSessionIdentityProvider.d.ts",editorHoverVerbosityLevel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorHoverVerbosityLevel.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",embeddings:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.embeddings.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileComments:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileComments.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findFiles2:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findFiles2.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineEdit.d.ts",interactive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactive.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",languageModelSystem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModelSystem.d.ts",languageModels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageModels.d.ts",languageStatusText:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.languageStatusText.d.ts",mappedEditsProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.mappedEditsProvider.d.ts",multiDocumentHighlightProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.multiDocumentHighlightProvider.d.ts",newSymbolNamesProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.newSymbolNamesProvider.d.ts",notebookCellExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecution.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookControllerAffinityHidden:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerAffinityHidden.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookExecution:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookExecution.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookVariableProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookVariableProvider.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",profileContentHandlers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.profileContentHandlers.d.ts",quickDiffProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickDiffProvider.d.ts",quickPickItemTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickItemTooltip.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmHistoryProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmHistoryProvider.d.ts",scmMultiDiffEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmMultiDiffEditor.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmTextDocument:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmTextDocument.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",shareProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.shareProvider.d.ts",showLocal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.showLocal.d.ts",speech:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.speech.d.ts",tabInputMultiDiff:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputMultiDiff.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExecuteCommandEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExecuteCommandEvent.d.ts",terminalQuickFixProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalQuickFixProvider.d.ts",terminalSelection:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalSelection.d.ts",terminalShellIntegration:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalShellIntegration.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewActiveItem:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewActiveItem.d.ts",treeViewMarkdownMessage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewMarkdownMessage.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnelFactory:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnelFactory.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(Se[239],Ie([1,0,194,14,32,100,74,29,21,238,102,105]),function(le,e,C,N,M,T,A,p,m,D,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$FG=e.$EG=e.$DG=e.$CG=e.$BG=e.$AG=void 0;const d=p.$fo.as(A.$go.JSONContribution);class w{constructor(u,i,b){this.a=u,this.b=i,this.c=b}d(u,i){this.a({type:u,message:i,extensionId:this.b.identifier,extensionPointId:this.c})}error(u){this.d(M.default.Error,u)}warn(u){this.d(M.default.Warning,u)}info(u){this.d(M.default.Info,u)}}e.$AG=w;class f{static a(u){const i=new m.$Um;for(let b=0,a=u.length;b<a;b++)i.add(u[b].description.identifier);return i}static compute(u,i){if(!u||!u.length)return new f(i,[]);if(!i||!i.length)return new f([],u);const b=this.a(u),a=this.a(i),l=i.filter($=>!b.has($.description.identifier)),g=u.filter($=>!a.has($.description.identifier));return new f(l,g)}constructor(u,i){this.added=u,this.removed=i}}e.$BG=f;class o{constructor(u,i){this.name=u,this.defaultExtensionKind=i,this.a=null,this.b=null,this.c=null}setHandler(u){if(this.a!==null)throw new Error("Handler already set!");this.a=u,this.d()}acceptUsers(u){this.c=f.compute(this.b,u),this.b=u,this.d()}d(){if(!(this.a===null||this.b===null||this.c===null))try{this.a(this.b,this.c)}catch(u){(0,N.$1)(u)}}}e.$CG=o;const r={type:"string",enum:["ui","workspace"],enumDescriptions:[C.localize(0,null),C.localize(1,null)]},s="vscode://schemas/vscode-extensions";e.$DG={properties:{engines:{type:"object",description:C.localize(2,null),properties:{vscode:{type:"string",description:C.localize(3,null),default:"^1.22.0"}}},publisher:{description:C.localize(4,null),type:"string"},displayName:{description:C.localize(5,null),type:"string"},categories:{description:C.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:m.$Sm},{type:"string",const:"Languages",deprecationMessage:C.localize(7,null)}]}},galleryBanner:{type:"object",description:C.localize(8,null),properties:{color:{description:C.localize(9,null),type:"string"},theme:{description:C.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:C.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:C.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:C.localize(13,null)},enabledApiProposals:{markdownDescription:C.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}},api:{markdownDescription:C.localize(15,null),type:"string",enum:["none"],enumDescriptions:[C.localize(16,null)]},activationEvents:{description:C.localize(17,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:C.localize(18,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:C.localize(19,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:C.localize(20,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:C.localize(21,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:C.localize(22,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:C.localize(23,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:C.localize(24,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:C.localize(25,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:C.localize(26,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:C.localize(27,null),body:"onStartupFinished"},{label:"onTaskType",description:C.localize(28,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:C.localize(29,null),body:"onFileSystem:${1:scheme}"},{label:"onEditSession",description:C.localize(30,null),body:"onEditSession:${1:scheme}"},{label:"onSearch",description:C.localize(31,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:C.localize(32,null)},{label:"onUri",body:"onUri",description:C.localize(33,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:C.localize(34,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:C.localize(35,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:C.localize(36,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:C.localize(37,null)},{label:"onRenderer",description:C.localize(38,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:C.localize(39,null)},{label:"onTerminalQuickFixRequest",body:"onTerminalQuickFixRequest:${1:quickFixId}",description:C.localize(40,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:C.localize(41,null)},{label:"onIssueReporterOpened",body:"onIssueReporterOpened",description:C.localize(42,null)},{label:"*",description:C.localize(43,null),body:"*"}]}},badges:{type:"array",description:C.localize(44,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:C.localize(45,null)},href:{type:"string",description:C.localize(46,null)},description:{type:"string",description:C.localize(47,null)}}}},markdown:{type:"string",description:C.localize(48,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:C.localize(49,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:C.localize(50,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Wo}},extensionPack:{description:C.localize(51,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:T.$Wo}},extensionKind:{description:C.localize(52,null),type:"array",items:r,default:["workspace"],defaultSnippets:[{body:["ui"],description:C.localize(53,null)},{body:["workspace"],description:C.localize(54,null)},{body:["ui","workspace"],description:C.localize(55,null)},{body:["workspace","ui"],description:C.localize(56,null)},{body:[],description:C.localize(57,null)}]},capabilities:{description:C.localize(58,null),type:"object",properties:{virtualWorkspaces:{description:C.localize(59,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:C.localize(60,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(61,null),C.localize(62,null),C.localize(63,null)]},description:{type:"string",markdownDescription:C.localize(64,null)}}},untrustedWorkspaces:{description:C.localize(65,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:C.localize(66,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[C.localize(67,null),C.localize(68,null),C.localize(69,null)]},restrictedConfigurations:{description:C.localize(70,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:C.localize(71,null)}}}}},sponsor:{description:C.localize(72,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:C.localize(73,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:C.localize(74,null),type:"string"},"vscode:uninstall":{description:C.localize(75,null),type:"string"}}},icon:{type:"string",description:C.localize(76,null)},l10n:{type:"string",description:C.localize(77,null)},pricing:{type:"string",markdownDescription:C.localize(78,null),enum:["Free","Trial"],default:"Free"}}};class n{constructor(){this.a=new Map}registerExtensionPoint(u){if(this.a.has(u.extensionPoint))throw new Error("Duplicate extension point: "+u.extensionPoint);const i=new o(u.extensionPoint,u.defaultExtensionKind);return this.a.set(u.extensionPoint,i),u.activationEventsGenerator&&S.$rG.register(u.extensionPoint,u.activationEventsGenerator),e.$DG.properties.contributes.properties[u.extensionPoint]=u.jsonSchema,d.registerSchema(s,e.$DG),i}getExtensionPoints(){return Array.from(this.a.values())}}e.$EG=n;const t={ExtensionsRegistry:"ExtensionsRegistry"};p.$fo.add(t.ExtensionsRegistry,new n),e.$FG=p.$fo.as(t.ExtensionsRegistry),d.registerSchema(s,e.$DG),d.registerSchema(O.$mk,{properties:{extensionEnabledApiProposals:{description:C.localize(79,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(D.allApiProposals),markdownEnumDescriptions:Object.values(D.allApiProposals)}}]}}}})}),define(Se[240],Ie([1,0,190,15,26,239,31,5]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kI=void 0;const m={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:C.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:C.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:C.localize(2,null),default:""}}};var D;(function(d){function w(f,o,r){if(!f)return;const s=N.$$f(f.type)?f.type:void 0;if(!s||s.length===0){r.error(C.localize(3,null));return}const n=[];if(Array.isArray(f.required))for(const t of f.required)N.$$f(t)&&n.push(t);return{extensionId:o.value,taskType:s,required:n,properties:f.properties?M.$5n(f.properties):{},when:f.when?A.$wj.deserialize(f.when):void 0}}d.from=w})(D||(D={}));const O=T.$FG.registerExtensionPoint({extensionPoint:"taskDefinitions",activationEventsGenerator:(d,w)=>{for(const f of d)f.type&&w.push(`onTaskType:${f.type}`)},jsonSchema:{description:C.localize(4,null),type:"array",items:m}});class S{constructor(){this.d=new p.$fe,this.onDefinitionsChanged=this.d.event,this.a=Object.create(null),this.b=new Promise((w,f)=>{O.setHandler((o,r)=>{this.c=void 0;try{for(const s of r.removed){const n=s.value;for(const t of n)this.a&&t.type&&this.a[t.type]&&delete this.a[t.type]}for(const s of r.added){const n=s.value;for(const t of n){const c=D.from(t,s.description.identifier,s.collector);c&&(this.a[c.taskType]=c)}}(r.removed.length>0||r.added.length>0)&&this.d.fire()}catch{}w(void 0)})})}onReady(){return this.b}get(w){return this.a[w]}all(){return Object.keys(this.a).map(w=>this.a[w])}getJsonSchema(){if(this.c===void 0){const w=[];for(const f of this.all()){const o={type:"object",additionalProperties:!1};f.required.length>0&&(o.required=f.required.slice(0)),f.properties!==void 0?o.properties=M.$5n(f.properties):o.properties=Object.create(null),o.properties.type={type:"string",enum:[f.taskType]},w.push(o)}this.c={oneOf:w}}return this.c}}e.$kI=new S}),define(Se[241],Ie([1,0,191,15,24,26,31,240]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.$uI=e.JsonSchemaVersion=e.ExecutionEngine=e.$tI=e.$sI=e.$rI=e.$qI=e.$pI=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.$oI=e.ShellQuoting=e.$nI=e.$mI=e.$lI=void 0,e.$lI="settings",e.$mI=new A.$Pj("taskRunning",!1,C.localize(0,null)),e.$nI=C.localize2(2,"Tasks");var m;(function(R){R[R.Escape=1]="Escape",R[R.Strong=2]="Strong",R[R.Weak=3]="Weak"})(m||(e.ShellQuoting=m={})),e.$oI="$customized",function(R){function z(K){if(!K)return R.Strong;switch(K.toLowerCase()){case"escape":return R.Escape;case"strong":return R.Strong;case"weak":return R.Weak;default:return R.Strong}}R.from=z}(m||(e.ShellQuoting=m={}));var D;(function(R){R.defaults={cwd:"${workspaceFolder}"}})(D||(e.CommandOptions=D={}));var O;(function(R){R[R.Always=1]="Always",R[R.Silent=2]="Silent",R[R.Never=3]="Never"})(O||(e.RevealKind=O={})),function(R){function z(K){switch(K.toLowerCase()){case"always":return R.Always;case"silent":return R.Silent;case"never":return R.Never;default:return R.Always}}R.fromString=z}(O||(e.RevealKind=O={}));var S;(function(R){R[R.Never=1]="Never",R[R.OnProblem=2]="OnProblem",R[R.Always=3]="Always"})(S||(e.RevealProblemKind=S={})),function(R){function z(K){switch(K.toLowerCase()){case"always":return R.Always;case"never":return R.Never;case"onproblem":return R.OnProblem;default:return R.OnProblem}}R.fromString=z}(S||(e.RevealProblemKind=S={}));var d;(function(R){R[R.Shared=1]="Shared",R[R.Dedicated=2]="Dedicated",R[R.New=3]="New"})(d||(e.PanelKind=d={})),function(R){function z(K){switch(K.toLowerCase()){case"shared":return R.Shared;case"dedicated":return R.Dedicated;case"new":return R.New;default:return R.Shared}}R.fromString=z}(d||(e.PanelKind=d={}));var w;(function(R){R.defaults={echo:!0,reveal:O.Always,revealProblems:S.Never,focus:!1,panel:d.Shared,showReuseMessage:!0,clear:!1}})(w||(e.PresentationOptions=w={}));var f;(function(R){R[R.Shell=1]="Shell",R[R.Process=2]="Process",R[R.CustomExecution=3]="CustomExecution"})(f||(e.RuntimeType=f={})),function(R){function z(ie){switch(ie.toLowerCase()){case"shell":return R.Shell;case"process":return R.Process;case"customExecution":return R.CustomExecution;default:return R.Process}}R.fromString=z;function K(ie){switch(ie){case R.Shell:return"shell";case R.Process:return"process";case R.CustomExecution:return"customExecution";default:return"process"}}R.toString=K}(f||(e.RuntimeType=f={}));var o;(function(R){function z(K){return N.$$f(K)?K:K.value}R.value=z})(o||(e.CommandString=o={}));var r;(function(R){R.Clean={_id:"clean",isDefault:!1},R.Build={_id:"build",isDefault:!1},R.Rebuild={_id:"rebuild",isDefault:!1},R.Test={_id:"test",isDefault:!1};function z(ie){return ie===R.Clean._id||ie===R.Build._id||ie===R.Rebuild._id||ie===R.Test._id}R.is=z;function K(ie){if(ie!==void 0)return N.$$f(ie)?z(ie)?{_id:ie,isDefault:!1}:void 0:ie}R.from=K})(r||(e.TaskGroup=r={}));var s;(function(R){R[R.Global=1]="Global",R[R.Workspace=2]="Workspace",R[R.Folder=3]="Folder"})(s||(e.TaskScope=s={}));var n;(function(R){R.Workspace="workspace",R.Extension="extension",R.InMemory="inMemory",R.WorkspaceFile="workspaceFile",R.User="user";function z(K){switch(K){case R.User:return 2;case R.WorkspaceFile:return 5;default:return 6}}R.toConfigurationTarget=z})(n||(e.TaskSourceKind=n={}));var t;(function(R){R.parallel="parallel",R.sequence="sequence"})(t||(e.DependsOrder=t={}));var c;(function(R){R[R.default=1]="default",R[R.folderOpen=2]="folderOpen"})(c||(e.RunOnOptions=c={}));var u;(function(R){R.defaults={reevaluateOnRerun:!0,runOn:c.default,instanceLimit:1}})(u||(e.RunOptions=u={}));class i{constructor(z,K,ie,de,ye,De){this._label="",this._id=z,K&&(this._label=K),ie&&(this.type=ie),this.runOptions=de,this.configurationProperties=ye,this._source=De}getDefinition(z){}getMapKey(){return this._id}getKey(){}getCommonTaskId(){const z={folder:this.d(),id:this._id};return JSON.stringify(z)}clone(){return this.f(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(z,K=!1){if(z===void 0)return!1;if(N.$$f(z))return z===this._label||z===this.configurationProperties.identifier||K&&z===this._id;const ie=this.getDefinition(!0);return ie!==void 0&&ie._key===z._key}getQualifiedLabel(){const z=this.getWorkspaceFolder();return z?`${this._label} (${z.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(z){this.c===void 0&&(this.c=[]),z&&(this.c=this.c.concat(z))}get taskLoadMessages(){return this.c}}e.$pI=i;class b extends i{constructor(z,K,ie,de,ye,De,ge,ue){super(z,ie,void 0,ge,ue,K),this.command={},this._source=K,this.hasDefinedMatchers=De,ye&&(this.command=ye)}clone(){return new b(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(z=!1){if(z&&this._source.customizes!==void 0)return this._source.customizes;{let K;switch(this.command?this.command.runtime:void 0){case f.Shell:K="shell";break;case f.Process:K="process";break;case f.CustomExecution:K="customExecution";break;case void 0:K="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:K,_key:this._id,id:this._id}}}static is(z){return z instanceof b}getMapKey(){const z=this._source.config.workspaceFolder;return z?`${z.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}d(){return this._source.kind===n.User?e.$lI:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getKey()??super.getCommonTaskId()}getKey(){const z=this.d();if(!z)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$oI,folder:z,id:K};return JSON.stringify(ie)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$9g(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}f(z){return new b(z._id,z._source,z._label,z.type,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$qI=b;class a extends i{constructor(z,K,ie,de,ye,De,ge){super(z,ie,de,De,ge,K),this._source=K,this.configures=ye}static is(z){return z instanceof a}f(z){return z}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?M.$9g(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}d(){return this._source.kind===n.User?e.$lI:this._source.config.workspaceFolder?.uri.toString()}getKey(){const z=this.d();if(!z)return;let K=this.configurationProperties.identifier;this._source.kind!==n.Workspace&&(K+=this._source.kind);const ie={type:e.$oI,folder:z,id:K};return JSON.stringify(ie)}}e.$rI=a;class l extends i{constructor(z,K,ie,de,ye,De,ge,ue,Ce){super(z,ie,de,ue,Ce,K),this.defines=ye,this.hasDefinedMatchers=ge,this.command=De,this.icon=Ce.icon,this.hide=Ce.hide}clone(){return new l(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(z){return z instanceof l}getMapKey(){const z=this._source.workspaceFolder;return z?`${this._source.scope.toString()}|${z.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}d(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getKey(){const z={type:"contributed",scope:this._source.scope,id:this._id};return z.folder=this.d(),JSON.stringify(z)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}f(z){return new l(z._id,z._source,z._label,z.type,z.defines,z.command,z.hasDefinedMatchers,z.runOptions,z.configurationProperties)}}e.$sI=l;class g extends i{constructor(z,K,ie,de,ye,De){super(z,ie,de,ye,De,K),this._source=K}clone(){return new g(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(z){return z instanceof g}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}d(){}f(z){return new g(z._id,z._source,z._label,z.type,z.runOptions,z.configurationProperties)}}e.$tI=g;var $;(function(R){R[R.Process=1]="Process",R[R.Terminal=2]="Terminal"})($||(e.ExecutionEngine=$={})),function(R){R._default=R.Terminal}($||(e.ExecutionEngine=$={}));var v;(function(R){R[R.V0_1_0=1]="V0_1_0",R[R.V2_0_0=2]="V2_0_0"})(v||(e.JsonSchemaVersion=v={}));class y{constructor(z){this.c=new Map;for(let K=0;K<z.length;K++)this.c.set(z[K].uri.toString(),K)}compare(z,K){const ie=z.getWorkspaceFolder(),de=K.getWorkspaceFolder();if(ie&&de){let ye=this.c.get(ie.uri.toString());ye=ye===void 0?0:ye+1;let De=this.c.get(de.uri.toString());return De=De===void 0?0:De+1,ye===De?z._label.localeCompare(K._label):ye-De}else return!ie&&de?-1:ie&&!de?1:0}}e.$uI=y;var h;(function(R){R.DependsOnStarted="dependsOnStarted",R.AcquiredInput="acquiredInput",R.Start="start",R.ProcessStarted="processStarted",R.Active="active",R.Inactive="inactive",R.Changed="changed",R.Terminated="terminated",R.ProcessEnded="processEnded",R.End="end"})(h||(e.TaskEventKind=h={}));var E;(function(R){R.SingleRun="singleRun",R.Background="background"})(E||(e.TaskRunType=E={}));var k;(function(R){R[R.System=0]="System",R[R.User=1]="User",R[R.FolderOpen=2]="FolderOpen",R[R.ConfigurationChange=3]="ConfigurationChange",R[R.Reconnect=4]="Reconnect"})(k||(e.TaskRunSource=k={}));var I;(function(R){function z(ue){return{taskId:ue._id,taskName:ue.configurationProperties.name,runType:ue.configurationProperties.isBackground?"background":"singleRun",group:ue.configurationProperties.group,__task:ue}}function K(ue,Ce,se){return{...z(ue),kind:"start",terminalId:Ce,resolvedVariables:se}}R.start=K;function ie(ue,Ce,se){return{...z(ue),kind:"processStarted",terminalId:Ce,processId:se}}R.processStarted=ie;function de(ue,Ce,se){return{...z(ue),kind:"processEnded",terminalId:Ce,exitCode:se}}R.processEnded=de;function ye(ue,Ce,se){return{...z(ue),kind:"terminated",exitReason:se,terminalId:Ce}}R.terminated=ye;function De(ue,Ce,se){return{...z(Ce),kind:ue,terminalId:se}}R.general=De;function ge(){return{kind:"changed"}}R.changed=ge})(I||(e.TaskEvent=I={}));var P;(function(R){function z(ie){const de=Object.keys(ie).sort();let ye="";for(const De of de){let ge=ie[De];ge instanceof Object?ge=z(ge):typeof ge=="string"&&(ge=ge.replace(/,/g,",,")),ye+=De+","+ge+","}return ye}function K(ie){const ye={_key:z(ie),type:ie.taskType};return Object.assign(ye,ie),ye}R.create=K})(P||(e.KeyedTaskIdentifier=P={}));var V;(function(R){R.AutoDetect="task.autoDetect",R.SaveBeforeRun="task.saveBeforeRun",R.ShowDecorations="task.showDecorations",R.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",R.SlowProviderWarning="task.slowProviderWarning",R.QuickOpenHistory="task.quickOpen.history",R.QuickOpenDetail="task.quickOpen.detail",R.QuickOpenSkip="task.quickOpen.skip",R.QuickOpenShowAll="task.quickOpen.showAll",R.AllowAutomaticTasks="task.allowAutomaticTasks",R.Reconnection="task.reconnection",R.VerboseLogging="task.verboseLogging"})(V||(e.TaskSettingId=V={}));var W;(function(R){R.Tasks="tasks",R.SuppressTaskName="tasks.suppressTaskName",R.Windows="tasks.windows",R.Osx="tasks.osx",R.Linux="tasks.linux",R.ShowOutput="tasks.showOutput",R.IsShellCommand="tasks.isShellCommand",R.ServiceTestSetting="tasks.service.testSetting"})(W||(e.TasksSchemaProperties=W={}));var q;(function(R){function z(K,ie){const de=p.$kI.get(K.type);if(de===void 0){const ue=T.$5n(K);return delete ue._key,P.create(ue)}const ye=Object.create(null);ye.type=de.taskType;const De=new Set;de.required.forEach(ue=>De.add(ue));const ge=de.properties;for(const ue of Object.keys(ge)){const Ce=K[ue];if(Ce!=null)ye[ue]=Ce;else if(De.has(ue)){const se=ge[ue];if(se.default!==void 0)ye[ue]=T.$5n(se.default);else switch(se.type){case"boolean":ye[ue]=!1;break;case"number":case"integer":ye[ue]=0;break;case"string":ye[ue]="";break;default:ie.error(C.localize(1,null,JSON.stringify(K,void 0,0),ue));return}}}return P.create(ye)}R.createTaskIdentifier=z})(q||(e.TaskDefinition=q={}))}),define(Se[242],Ie([1,0,14]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lac=e.$Kac=void 0;class N{constructor(){this.a=null,this.b=null,this.d=null,this.f=!1,this.g=null,this.h=!1,this.i=null}get[Symbol.toStringTag](){return this.toString()}j(){return this.a||(this.a=new Promise((A,p)=>{this.b=A,this.d=p,this.f&&this.b(this.g),this.h&&this.d(this.i)})),this.a}resolveOk(A){this.f||this.h||(this.f=!0,this.g=A,this.a&&this.b(A))}resolveErr(A){this.f||this.h||(this.h=!0,this.i=A,this.a?this.d(A):(0,C.$1)(A))}then(A,p){return this.j().then(A,p)}catch(A){return this.j().then(void 0,A)}finally(A){return this.j().finally(A)}}e.$Kac=N;class M extends N{constructor(){super(),this.h=!0,this.i=new C.$5}}e.$Lac=M}),define(Se[34],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gw=e.$Dw=void 0,e.$Ew=M,e.$Fw=T;class C{static{this.count=0}constructor(m){this._proxyIdentifierBrand=void 0,this.sid=m,this.nid=++C.count}}e.$Dw=C;const N=[];function M(p){const m=new C(p);return N[m.nid]=m,m}function T(p){return N[p].sid}class A{constructor(m){this.value=m}}e.$Gw=A}),define(Se[4],Ie([1,0,34]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mM=e.$lM=e.ExtHostTestingResource=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.$kM=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var N;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(N||(e.TextEditorRevealType=N={}));var M;(function(o){o[o.UnknownInput=0]="UnknownInput",o[o.TextInput=1]="TextInput",o[o.TextDiffInput=2]="TextDiffInput",o[o.TextMergeInput=3]="TextMergeInput",o[o.NotebookInput=4]="NotebookInput",o[o.NotebookDiffInput=5]="NotebookDiffInput",o[o.CustomEditorInput=6]="CustomEditorInput",o[o.WebviewEditorInput=7]="WebviewEditorInput",o[o.TerminalEditorInput=8]="TerminalEditorInput",o[o.InteractiveEditorInput=9]="InteractiveEditorInput",o[o.ChatEditorInput=10]="ChatEditorInput",o[o.MultiDiffEditorInput=11]="MultiDiffEditorInput"})(M||(e.TabInputKind=M={}));var T;(function(o){o[o.TAB_OPEN=0]="TAB_OPEN",o[o.TAB_CLOSE=1]="TAB_CLOSE",o[o.TAB_UPDATE=2]="TAB_UPDATE",o[o.TAB_MOVE=3]="TAB_MOVE"})(T||(e.TabModelOperationKind=T={}));var A;(function(o){o[o.Editable=0]="Editable",o[o.SupportsHotExit=1]="SupportsHotExit"})(A||(e.WebviewEditorCapabilities=A={}));var p;(function(o){o[o.Int8Array=1]="Int8Array",o[o.Uint8Array=2]="Uint8Array",o[o.Uint8ClampedArray=3]="Uint8ClampedArray",o[o.Int16Array=4]="Int16Array",o[o.Uint16Array=5]="Uint16Array",o[o.Int32Array=6]="Int32Array",o[o.Uint32Array=7]="Uint32Array",o[o.Float32Array=8]="Float32Array",o[o.Float64Array=9]="Float64Array",o[o.BigInt64Array=10]="BigInt64Array",o[o.BigUint64Array=11]="BigUint64Array"})(p||(e.WebviewMessageArrayBufferViewType=p={}));var m;(function(o){o[o.Text=1]="Text",o[o.Error=2]="Error",o[o.Rich=3]="Rich"})(m||(e.CellOutputKind=m={}));var D;(function(o){o[o.Default=0]="Default",o[o.InCenter=1]="InCenter",o[o.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",o[o.AtTop=3]="AtTop"})(D||(e.NotebookEditorRevealType=D={}));var O;(function(o){o[o.None=0]="None",o[o.Process=1]="Process",o[o.Output=2]="Output",o[o.Hybrid=3]="Hybrid"})(O||(e.CandidatePortSource=O={}));class S{static{this.a=0}static mixin(r){return r._id=S.a++,r}}e.$kM=S;var d;(function(o){o.label="a",o.kind="b",o.detail="c",o.documentation="d",o.sortText="e",o.filterText="f",o.preselect="g",o.insertText="h",o.insertTextRules="i",o.range="j",o.commitCharacters="k",o.additionalTextEdits="l",o.kindModifier="m",o.commandIdent="n",o.commandId="o",o.commandArguments="p"})(d||(e.ISuggestDataDtoField=d={}));var w;(function(o){o.defaultRanges="a",o.completions="b",o.isIncomplete="c",o.duration="d"})(w||(e.ISuggestResultDtoField=w={}));var f;(function(o){o[o.Workspace=0]="Workspace",o[o.TextDocument=1]="TextDocument"})(f||(e.ExtHostTestingResource=f={})),e.$lM={MainThreadAuthentication:(0,C.$Ew)("MainThreadAuthentication"),MainThreadBulkEdits:(0,C.$Ew)("MainThreadBulkEdits"),MainThreadLanguageModels:(0,C.$Ew)("MainThreadLanguageModels"),MainThreadEmbeddings:(0,C.$Ew)("MainThreadEmbeddings"),MainThreadChatAgents2:(0,C.$Ew)("MainThreadChatAgents2"),MainThreadChatVariables:(0,C.$Ew)("MainThreadChatVariables"),MainThreadClipboard:(0,C.$Ew)("MainThreadClipboard"),MainThreadCommands:(0,C.$Ew)("MainThreadCommands"),MainThreadComments:(0,C.$Ew)("MainThreadComments"),MainThreadConfiguration:(0,C.$Ew)("MainThreadConfiguration"),MainThreadConsole:(0,C.$Ew)("MainThreadConsole"),MainThreadDebugService:(0,C.$Ew)("MainThreadDebugService"),MainThreadDecorations:(0,C.$Ew)("MainThreadDecorations"),MainThreadDiagnostics:(0,C.$Ew)("MainThreadDiagnostics"),MainThreadDialogs:(0,C.$Ew)("MainThreadDiaglogs"),MainThreadDocuments:(0,C.$Ew)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,C.$Ew)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,C.$Ew)("MainThreadTextEditors"),MainThreadEditorInsets:(0,C.$Ew)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,C.$Ew)("MainThreadEditorTabs"),MainThreadErrors:(0,C.$Ew)("MainThreadErrors"),MainThreadTreeViews:(0,C.$Ew)("MainThreadTreeViews"),MainThreadDownloadService:(0,C.$Ew)("MainThreadDownloadService"),MainThreadLanguageFeatures:(0,C.$Ew)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,C.$Ew)("MainThreadLanguages"),MainThreadLogger:(0,C.$Ew)("MainThreadLogger"),MainThreadMessageService:(0,C.$Ew)("MainThreadMessageService"),MainThreadOutputService:(0,C.$Ew)("MainThreadOutputService"),MainThreadProgress:(0,C.$Ew)("MainThreadProgress"),MainThreadQuickDiff:(0,C.$Ew)("MainThreadQuickDiff"),MainThreadQuickOpen:(0,C.$Ew)("MainThreadQuickOpen"),MainThreadStatusBar:(0,C.$Ew)("MainThreadStatusBar"),MainThreadSecretState:(0,C.$Ew)("MainThreadSecretState"),MainThreadStorage:(0,C.$Ew)("MainThreadStorage"),MainThreadSpeech:(0,C.$Ew)("MainThreadSpeechProvider"),MainThreadTelemetry:(0,C.$Ew)("MainThreadTelemetry"),MainThreadTerminalService:(0,C.$Ew)("MainThreadTerminalService"),MainThreadTerminalShellIntegration:(0,C.$Ew)("MainThreadTerminalShellIntegration"),MainThreadWebviews:(0,C.$Ew)("MainThreadWebviews"),MainThreadWebviewPanels:(0,C.$Ew)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,C.$Ew)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,C.$Ew)("MainThreadCustomEditors"),MainThreadUrls:(0,C.$Ew)("MainThreadUrls"),MainThreadUriOpeners:(0,C.$Ew)("MainThreadUriOpeners"),MainThreadProfileContentHandlers:(0,C.$Ew)("MainThreadProfileContentHandlers"),MainThreadWorkspace:(0,C.$Ew)("MainThreadWorkspace"),MainThreadFileSystem:(0,C.$Ew)("MainThreadFileSystem"),MainThreadFileSystemEventService:(0,C.$Ew)("MainThreadFileSystemEventService"),MainThreadExtensionService:(0,C.$Ew)("MainThreadExtensionService"),MainThreadSCM:(0,C.$Ew)("MainThreadSCM"),MainThreadSearch:(0,C.$Ew)("MainThreadSearch"),MainThreadShare:(0,C.$Ew)("MainThreadShare"),MainThreadTask:(0,C.$Ew)("MainThreadTask"),MainThreadWindow:(0,C.$Ew)("MainThreadWindow"),MainThreadLabelService:(0,C.$Ew)("MainThreadLabelService"),MainThreadNotebook:(0,C.$Ew)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,C.$Ew)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,C.$Ew)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,C.$Ew)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,C.$Ew)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,C.$Ew)("MainThreadInteractive"),MainThreadTheming:(0,C.$Ew)("MainThreadTheming"),MainThreadTunnelService:(0,C.$Ew)("MainThreadTunnelService"),MainThreadManagedSockets:(0,C.$Ew)("MainThreadManagedSockets"),MainThreadTimeline:(0,C.$Ew)("MainThreadTimeline"),MainThreadTesting:(0,C.$Ew)("MainThreadTesting"),MainThreadLocalization:(0,C.$Ew)("MainThreadLocalizationShape"),MainThreadAiRelatedInformation:(0,C.$Ew)("MainThreadAiRelatedInformation"),MainThreadAiEmbeddingVector:(0,C.$Ew)("MainThreadAiEmbeddingVector")},e.$mM={ExtHostCommands:(0,C.$Ew)("ExtHostCommands"),ExtHostConfiguration:(0,C.$Ew)("ExtHostConfiguration"),ExtHostDiagnostics:(0,C.$Ew)("ExtHostDiagnostics"),ExtHostDebugService:(0,C.$Ew)("ExtHostDebugService"),ExtHostDecorations:(0,C.$Ew)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,C.$Ew)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,C.$Ew)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,C.$Ew)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,C.$Ew)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,C.$Ew)("ExtHostEditors"),ExtHostTreeViews:(0,C.$Ew)("ExtHostTreeViews"),ExtHostFileSystem:(0,C.$Ew)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,C.$Ew)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,C.$Ew)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,C.$Ew)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,C.$Ew)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,C.$Ew)("ExtHostQuickOpen"),ExtHostQuickDiff:(0,C.$Ew)("ExtHostQuickDiff"),ExtHostStatusBar:(0,C.$Ew)("ExtHostStatusBar"),ExtHostShare:(0,C.$Ew)("ExtHostShare"),ExtHostExtensionService:(0,C.$Ew)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,C.$Ew)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,C.$Ew)("ExtHostTerminalService"),ExtHostTerminalShellIntegration:(0,C.$Ew)("ExtHostTerminalShellIntegration"),ExtHostSCM:(0,C.$Ew)("ExtHostSCM"),ExtHostSearch:(0,C.$Ew)("ExtHostSearch"),ExtHostTask:(0,C.$Ew)("ExtHostTask"),ExtHostWorkspace:(0,C.$Ew)("ExtHostWorkspace"),ExtHostWindow:(0,C.$Ew)("ExtHostWindow"),ExtHostWebviews:(0,C.$Ew)("ExtHostWebviews"),ExtHostWebviewPanels:(0,C.$Ew)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,C.$Ew)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,C.$Ew)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,C.$Ew)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,C.$Ew)("ExtHostEditorTabs"),ExtHostProgress:(0,C.$Ew)("ExtHostProgress"),ExtHostComments:(0,C.$Ew)("ExtHostComments"),ExtHostSecretState:(0,C.$Ew)("ExtHostSecretState"),ExtHostStorage:(0,C.$Ew)("ExtHostStorage"),ExtHostUrls:(0,C.$Ew)("ExtHostUrls"),ExtHostUriOpeners:(0,C.$Ew)("ExtHostUriOpeners"),ExtHostProfileContentHandlers:(0,C.$Ew)("ExtHostProfileContentHandlers"),ExtHostOutputService:(0,C.$Ew)("ExtHostOutputService"),ExtHostLabelService:(0,C.$Ew)("ExtHostLabelService"),ExtHostNotebook:(0,C.$Ew)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,C.$Ew)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,C.$Ew)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,C.$Ew)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,C.$Ew)("ExtHostNotebookRenderers"),ExtHostNotebookDocumentSaveParticipant:(0,C.$Ew)("ExtHostNotebookDocumentSaveParticipant"),ExtHostInteractive:(0,C.$Ew)("ExtHostInteractive"),ExtHostChatAgents2:(0,C.$Ew)("ExtHostChatAgents"),ExtHostChatVariables:(0,C.$Ew)("ExtHostChatVariables"),ExtHostChatProvider:(0,C.$Ew)("ExtHostChatProvider"),ExtHostSpeech:(0,C.$Ew)("ExtHostSpeech"),ExtHostEmbeddings:(0,C.$Ew)("ExtHostEmbeddings"),ExtHostAiRelatedInformation:(0,C.$Ew)("ExtHostAiRelatedInformation"),ExtHostAiEmbeddingVector:(0,C.$Ew)("ExtHostAiEmbeddingVector"),ExtHostTheming:(0,C.$Ew)("ExtHostTheming"),ExtHostTunnelService:(0,C.$Ew)("ExtHostTunnelService"),ExtHostManagedSockets:(0,C.$Ew)("ExtHostManagedSockets"),ExtHostAuthentication:(0,C.$Ew)("ExtHostAuthentication"),ExtHostTimeline:(0,C.$Ew)("ExtHostTimeline"),ExtHostTesting:(0,C.$Ew)("ExtHostTesting"),ExtHostTelemetry:(0,C.$Ew)("ExtHostTelemetry"),ExtHostLocalization:(0,C.$Ew)("ExtHostLocalization")}}),define(Se[80],Ie([1,0,3,12,4,17]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0lc=e.$9lc=e.$8lc=void 0,e.$8lc=(0,C.$yi)("IExtHostApiDeprecationService");let A=class{constructor(m,D){this.c=D,this.a=new Set,this.b=m.getProxy(M.$lM.MainThreadTelemetry)}report(m,D,O){const S=this.d(m,D);this.a.has(S)||(this.a.add(S),D.isUnderDevelopment&&this.c.warn(`[Deprecation Warning] '${m}' is deprecated. ${O}`),this.b.$publicLog2("extHostDeprecatedApiUsage",{extensionId:D.identifier.value,apiId:m}))}d(m,D){return`${m}-${D.identifier.value}`}};e.$9lc=A,e.$9lc=A=Je([We(0,T.$PO),We(1,N.$5j)],A),e.$0lc=Object.freeze(new class{report(p,m,D){}})}),define(Se[243],Ie([1,0,4]),function(le,e,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$kmc=void 0;class N{constructor(T){const A=T.getProxy(C.$lM.MainThreadClipboard);this.value=Object.freeze({readText(){return A.$readText()},writeText(p){return A.$writeText(p)}})}}e.$kmc=N}),define(Se[244],Ie([1,0,26,4,27,17]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$eoc=void 0;let A=class{constructor(O,S){this.a=O.getProxy(N.$lM.MainThreadConsole),this.b=S.consoleForward.includeStack,this.c=S.consoleForward.logNative,this.d("info","log"),this.d("log","log"),this.d("warn","warn"),this.d("debug","debug"),this.d("error","error")}d(O,S){const d=this,w=console[O];Object.defineProperty(console,O,{set:()=>{},get:()=>function(){d.e(O,S,w,arguments)}})}e(O,S,d,w){this.a.$logExtensionHostMessage({type:"__$console",severity:S,arguments:m(w,this.b)}),this.c&&this.f(O,d,w)}};e.$eoc=A,e.$eoc=A=Je([We(0,T.$PO),We(1,M.$6O)],A);const p=1e5;function m(D,O){const S=[];if(D.length)for(let d=0;d<D.length;d++){let w=D[d];if(typeof w>"u")w="undefined";else if(w instanceof Error){const f=w;f.stack?w=f.stack:w=f.toString()}S.push(w)}if(O){const d=new Error().stack;d&&S.push({__$stack:d.split(`
`).slice(3).join(`
`)})}try{const d=(0,C.$0n)(S);return d.length>p?"Output omitted for a large object that exceeds the limits":d}catch(d){return`Output omitted for an object that cannot be inspected ('${d.toString()}')`}}}),define(Se[245],Ie([1,0,2,4,25]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hnc=void 0;class T{constructor(p){this.a=p.getProxy(N.$lM.MainThreadDialogs)}showOpenDialog(p,m){return m?.allowUIResources&&(0,M.$MG)(p,"showLocal"),this.a.$showOpenDialog(m).then(D=>D?D.map(O=>C.URI.revive(O)):void 0)}showSaveDialog(p){return this.a.$showSaveDialog(p).then(m=>m?C.URI.revive(m):void 0)}}e.$hnc=T}),define(Se[246],Ie([1,0,20,5,6,4]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$knc=void 0;class A{constructor(m){this.b=new Map,this.c=new N.$fe,this.onDidChange=this.c.event,this.d=new Set,this.e=0,this.a=m.getProxy(T.$lM.MainThreadEmbeddings)}registerEmbeddingsProvider(m,D,O){if(this.d.has(D))throw new Error("An embeddings provider for this model is already registered");const S=this.e++;return this.a.$registerEmbeddingProvider(S,D),this.b.set(S,{id:D,provider:O}),(0,M.$Sc)(()=>{this.a.$unregisterEmbeddingProvider(S),this.b.delete(S)})}async computeEmbeddings(m,D,O){O??=C.CancellationToken.None;let S=!1;typeof D=="string"&&(D=[D],S=!0);const d=await this.a.$computeEmbeddings(m,D,O);if(d.length!==D.length)throw new Error;if(S){if(d.length!==1)throw new Error;return d[0]}return d}async $provideEmbeddings(m,D,O){const S=this.b.get(m);if(!S)return[];const d=await S.provider.provideEmbeddings(D,O);return d||[]}get embeddingsModels(){return Array.from(this.d)}$acceptEmbeddingModels(m){this.d=new Set(m),this.c.fire()}}e.$knc=A}),define(Se[247],Ie([1,0,6,4]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bnc=void 0;class M{constructor(A){this.b=0,this.a=A.getProxy(N.$lM.MainThreadLabelService)}$registerResourceLabelFormatter(A){const p=this.b++;return this.a.$registerResourceLabelFormatter(p,A),(0,C.$Sc)(()=>{this.a.$unregisterResourceLabelFormatter(p)})}}e.$Bnc=M}),define(Se[81],Ie([1,0,23,13,2,3,12,4,27,17]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$3mc=e.$2mc=void 0;let O=class{constructor(d,w,f){this.f=f,this.d=new Map,this.a=w.getProxy(p.$lM.MainThreadLocalization),this.b=d.environment.appLanguage,this.c=this.b===C.$g}getMessage(d,w){const{message:f,args:o,comment:r}=w;if(this.c)return(0,N.$$e)(f,o??{});let s=f;r&&r.length>0&&(s+=`/${Array.isArray(r)?r.join(""):r}`);const n=this.d.get(d)?.contents[s];return n||this.f.warn(`Using default string since no string found in i18n bundle that has the key: ${s}`),(0,N.$$e)(n??f,o??{})}getBundle(d){return this.d.get(d)?.contents}getBundleUri(d){return this.d.get(d)?.uri}async initializeLocalizedMessages(d){if(this.c||!d.l10n&&!d.isBuiltin||this.d.has(d.identifier.value))return;let w;const f=await this.g(d);if(!f){this.f.error(`No bundle location found for extension ${d.identifier.value}`);return}try{const o=await this.a.$fetchBundleContents(f),r=JSON.parse(o);w=d.isBuiltin?r.contents?.bundle:r}catch(o){this.f.error(`Failed to load translations for ${d.identifier.value} from ${f}: ${o.message}`);return}w&&this.d.set(d.identifier.value,{contents:w,uri:f})}async g(d){if(d.isBuiltin){const w=await this.a.$fetchBuiltInBundleUri(d.identifier.value,this.b);return M.URI.revive(w)}return d.l10n?M.URI.joinPath(d.extensionLocation,d.l10n,`bundle.l10n.${this.b}.json`):void 0}};e.$2mc=O,e.$2mc=O=Je([We(0,m.$6O),We(1,D.$PO),We(2,A.$5j)],O),e.$3mc=(0,T.$yi)("IExtHostLocalizationService")}),define(Se[248],Ie([1,0,12,4,27,17,2,45]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$doc=void 0;let m=class extends C.$dk{constructor(S,d){super(d.logLevel,d.logsLocation,d.loggers.map(w=>(0,p.$8h)(w))),this.r=S.getProxy(N.$lM.MainThreadLogger)}$setLogLevel(S,d){d?this.setLogLevel(A.URI.revive(d),S):this.setLogLevel(S)}setVisibility(S,d){super.setVisibility(S,d),this.r.$setVisibility(S,d)}s(S,d,w){return new D(this.r,S,d,w)}};e.$doc=m,e.$doc=m=Je([We(0,T.$PO),We(1,M.$6O)],m);class D extends C.$$j{constructor(S,d,w,f){super(f?.logLevel==="always"),this.r=S,this.s=d,this.m=!1,this.n=[],this.setLevel(w),this.r.$createLogger(d,f).then(()=>{this.u(this.n),this.m=!0})}g(S,d){const w=[[S,d]];this.m?this.u(w):this.n.push(...w)}u(S){this.r.$log(this.s,S)}flush(){this.r.$flush(this.s)}}}),define(Se[82],Ie([1,0,4,3,6,17,22]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5mc=e.$4mc=void 0,e.$4mc=(0,N.$yi)("IExtHostManagedSockets");let p=class{constructor(S){this.b=0,this.c=null,this.d=new Map,this.a=S.getProxy(C.$lM.MainThreadManagedSockets)}setFactory(S,d){for(const w of this.d.values())w.dispose();this.c&&this.a.$unregisterSocketFactory(this.c.socketFactoryId),this.c=new m(S,d),this.a.$registerSocketFactory(this.c.socketFactoryId)}async $openRemoteSocket(S){if(!this.c||this.c.socketFactoryId!==S)throw new Error(`No socket factory with id ${S}`);const d=++this.b,w=await this.c.makeConnection(),f=new M.$Tc;return this.d.set(d,new D(d,w,f)),f.add((0,M.$Sc)(()=>this.d.delete(d))),f.add(w.onDidEnd(()=>{this.a.$onDidManagedSocketEnd(d),f.dispose()})),f.add(w.onDidClose(o=>{this.a.$onDidManagedSocketClose(d,o?.stack??o?.message),f.dispose()})),f.add(w.onDidReceiveMessage(o=>this.a.$onDidManagedSocketHaveData(d,A.$He.wrap(o)))),d}$remoteSocketWrite(S,d){this.d.get(S)?.actual.send(d.buffer)}$remoteSocketEnd(S){const d=this.d.get(S);d&&(d.actual.end(),d.dispose())}async $remoteSocketDrain(S){await this.d.get(S)?.actual.drain?.()}};e.$5mc=p,e.$5mc=p=Je([We(0,T.$PO)],p);class m{constructor(S,d){this.socketFactoryId=S,this.makeConnection=d}}class D extends M.$Uc{constructor(S,d,w){super(),this.socketId=S,this.actual=d,this.B(w)}}}),define(Se[249],Ie([1,0,4,12,25]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Dnc=void 0;function T(p){return p&&p.title}let A=class{constructor(m,D){this.b=D,this.a=m.getProxy(C.$lM.MainThreadMessageService)}showMessage(m,D,O,S,d){const w={source:{identifier:m.identifier,label:m.displayName||m.name}};let f;typeof S=="string"||T(S)?f=[S,...d]:(w.modal=S?.modal,w.useCustom=S?.useCustom,w.detail=S?.detail,f=d),w.useCustom&&(0,M.$MG)(m,"resolvers");const o=[];let r=!1;for(let s=0;s<f.length;s++){const n=f[s];if(typeof n=="string")o.push({title:n,handle:s,isCloseAffordance:!1});else if(typeof n=="object"){const{title:t,isCloseAffordance:c}=n;o.push({title:t,isCloseAffordance:!!c,handle:s}),c&&(r?this.b.warn(`[${m.identifier}] Only one message item can have 'isCloseAffordance':`,n):r=!0)}else this.b.warn(`[${m.identifier}] Invalid message item:`,n)}return this.a.$showMessage(D,O,w,o).then(s=>{if(typeof s=="number")return f[s]})}};e.$Dnc=A,e.$Dnc=A=Je([We(1,N.$5j)],A)}),define(Se[250],Ie([1,0,6,15,2,25,4]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Mnc=void 0;class p{constructor(D){this.b=new Map,this.a=D.getProxy(A.$lM.MainThreadProfileContentHandlers)}registerProfileContentHandler(D,O,S){if((0,T.$MG)(D,"profileContentHandlers"),this.b.has(O))throw new Error(`Handler with id '${O}' already registered`);return this.b.set(O,S),this.a.$registerProfileContentHandler(O,S.name,S.description,D.identifier.value),(0,C.$Sc)(()=>{this.b.delete(O),this.a.$unregisterProfileContentHandler(O)})}async $saveProfile(D,O,S,d){const w=this.b.get(D);if(!w)throw new Error(`Unknown handler with id: ${D}`);return w.saveProfile(O,S,d)}async $readProfile(D,O,S){const d=this.b.get(D);if(!d)throw new Error(`Unknown handler with id: ${D}`);return d.readProfile((0,N.$$f)(O)?O:M.URI.revive(O),S)}}e.$Mnc=p}),define(Se[83],Ie([1,0,4,5,3]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Zmc=e.$Ymc=void 0;class T{constructor(p){this.b=new N.$fe,this.onDidChangePassword=this.b.event,this.a=p.getProxy(C.$lM.MainThreadSecretState)}async $onDidChangePassword(p){this.b.fire(p)}get(p,m){return this.a.$getPassword(p,m)}store(p,m,D){return this.a.$setPassword(p,m,D)}delete(p,m){return this.a.$deletePassword(p,m)}}e.$Ymc=T,e.$Zmc=(0,M.$yi)("IExtHostSecretState")}),define(Se[251],Ie([1,0,20,6,4]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Tnc=void 0;class T{static{this.a=1}constructor(p){this.c=new Map,this.d=new Map,this.f=new Map,this.b=p.getProxy(M.$lM.MainThreadSpeech)}async $createSpeechToTextSession(p,m,D){const O=this.c.get(p);if(!O)return;const S=new N.$Tc,d=new C.$qe;this.d.set(m,d);const w=await O.provideSpeechToTextSession(d.token,D?{language:D}:void 0);w&&(S.add(w.onDidChange(f=>{d.token.isCancellationRequested||this.b.$emitSpeechToTextEvent(m,f)})),S.add(d.token.onCancellationRequested(()=>S.dispose())))}async $cancelSpeechToTextSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}async $createTextToSpeechSession(p,m,D){const O=this.c.get(p);if(!O)return;const S=new N.$Tc,d=new C.$qe;this.d.set(m,d);const w=await O.provideTextToSpeechSession(d.token,D?{language:D}:void 0);w&&(this.f.set(m,w),S.add(w.onDidChange(f=>{d.token.isCancellationRequested||this.b.$emitTextToSpeechEvent(m,f)})),S.add(d.token.onCancellationRequested(()=>S.dispose())))}async $synthesizeSpeech(p,m){this.f.get(p)?.synthesize(m)}async $cancelTextToSpeechSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p),this.f.delete(p)}async $createKeywordRecognitionSession(p,m){const D=this.c.get(p);if(!D)return;const O=new N.$Tc,S=new C.$qe;this.d.set(m,S);const d=await D.provideKeywordRecognitionSession(S.token);d&&(O.add(d.onDidChange(w=>{S.token.isCancellationRequested||this.b.$emitKeywordRecognitionEvent(m,w)})),O.add(S.token.onCancellationRequested(()=>O.dispose())))}async $cancelKeywordRecognitionSession(p){this.d.get(p)?.dispose(!0),this.d.delete(p)}registerProvider(p,m,D){const O=T.a++;return this.c.set(O,D),this.b.$registerProvider(O,m,{extension:p,displayName:p.value}),(0,N.$Sc)(()=>{this.b.$unregisterProvider(O),this.c.delete(O)})}}e.$Tnc=T}),define(Se[84],Ie([1,0,4,5,3]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pmc=e.$Omc=void 0;class T{constructor(p,m){this.c=m,this.b=new N.$fe,this.onDidChangeStorage=this.b.event,this.a=p.getProxy(C.$lM.MainThreadStorage)}registerExtensionStorageKeysToSync(p,m){this.a.$registerExtensionStorageKeysToSync(p,m)}async initializeExtensionStorage(p,m,D){const O=await this.a.$initializeExtensionStorage(p,m);let S;return O&&(S=this.d(p,m,O)),S||D}setValue(p,m,D){return this.a.$setValue(p,m,D)}$acceptValue(p,m,D){const O=this.d(p,m,D);O&&this.b.fire({shared:p,key:m,value:O})}d(p,m,D){try{return JSON.parse(D)}catch(O){this.c.error(`[extHostStorage] unexpected error parsing storage contents (extensionId: ${m}, global: ${p}): ${O}`)}}}e.$Omc=T,e.$Pmc=(0,M.$yi)("IExtHostStorage")}),define(Se[252],Ie([1,0,6,16,2,4]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$0nc=void 0;class A{static{this.a=new Set([N.Schemas.http,N.Schemas.https])}constructor(m){this.c=new Map,this.b=m.getProxy(T.$lM.MainThreadUriOpeners)}registerExternalUriOpener(m,D,O,S){if(this.c.has(D))throw new Error(`Opener with id '${D}' already registered`);const d=S.schemes.find(w=>!A.a.has(w));if(d)throw new Error(`Scheme '${d}' is not supported. Only http and https are currently supported.`);return this.c.set(D,O),this.b.$registerUriOpener(D,S.schemes,m,S.label),(0,C.$Sc)(()=>{this.c.delete(D),this.b.$unregisterUriOpener(D)})}async $canOpenUri(m,D,O){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener with id: ${m}`);const d=M.URI.revive(D);return S.canOpenExternalUri(d,O)}async $openUri(m,D,O){const S=this.c.get(m);if(!S)throw new Error(`Unknown opener id: '${m}'`);return S.openExternalUri(M.URI.revive(D.resolvedUri),{sourceUri:M.URI.revive(D.sourceUri)},O)}}e.$0nc=A}),define(Se[253],Ie([1,0,4,2,6,14,21]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$$nc=void 0;class p{static{this.a=0}constructor(D){this.c=new A.$Um,this.d=new Map,this.b=D.getProxy(C.$lM.MainThreadUrls)}registerUriHandler(D,O){const S=D.identifier;if(this.c.has(S))throw new Error(`Protocol handler already registered for extension ${S}`);const d=p.a++;return this.c.add(S),this.d.set(d,O),this.b.$registerUriHandler(d,S,D.displayName||D.name),(0,M.$Sc)(()=>{this.c.delete(S),this.d.delete(d),this.b.$unregisterUriHandler(d)})}$handleExternalUri(D,O){const S=this.d.get(D);if(!S)return Promise.resolve(void 0);try{S.handleUri(N.URI.revive(O))}catch(d){(0,T.$1)(d)}return Promise.resolve(void 0)}async createAppUri(D){return N.URI.revive(await this.b.$createAppUri(D))}}e.$$nc=p}),define(Se[64],Ie([1,0,5,6,16,26,2,197,221,78,4]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Bmc=e.$zmc=void 0,e.$Amc=d,e.$Cmc=o,e.$Dmc=r;class S{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;constructor(c,u,i,b,a,l,g){this.#a="",this.#c=!1,this.#u=!1,this._onMessageEmitter=new C.$fe,this.onDidReceiveMessage=this._onMessageEmitter.event,this.#h=new C.$fe,this._onDidDispose=this.#h.event,this.#e=c,this.#t=u,this.#o=i,this.#n=b,this.#s=a,this.#r=l,this.#l=d(l),this.#d=w(l),this.#i=g}#h;dispose(){this.#c=!0,this.#h.fire(),this.#h.dispose(),this._onMessageEmitter.dispose()}asWebviewUri(c){return this.#u=!0,(0,D.$hBb)(c,this.#n)}get cspSource(){const c=this.#r.extensionLocation;if(c.scheme===M.Schemas.https||c.scheme===M.Schemas.http){let u=c.toString();return u.endsWith("/")||(u+="/"),u+" "+D.$gBb}return D.$gBb}get html(){return this.a(),this.#a}set html(c){this.a(),this.#a!==c&&(this.#a=c,this.#d&&!this.#u&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(c)&&(this.#u=!0,this.#i.report("Webview vscode-resource: uris",this.#r,"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),this.#t.$setHtml(this.#e,this.b(c)))}get options(){return this.a(),this.#o}set options(c){this.a(),T.$9n(this.#o,c)||this.#t.$setOptions(this.#e,r(this.#r,this.#s,c)),this.#o=c}async postMessage(c){if(this.#c)return!1;const u=(0,m.$fsb)(c,{serializeBuffersForPostMessage:this.#l});return this.#t.$postMessage(this.#e,u.message,...u.buffers)}a(){if(this.#c)throw new Error("Webview is disposed")}b(c){if(!this.#d)return c;const u=this.#r.extensionLocation?.scheme===M.Schemas.vscodeRemote,i=this.#r.extensionLocation.scheme===M.Schemas.vscodeRemote?this.#r.extensionLocation.authority:void 0;return c.replace(/(["'])(?:vscode-resource):(\/\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,a,l,g,$,v)=>{const y=A.URI.from({scheme:g||"file",path:decodeURIComponent($)}),h=(0,D.$hBb)(y,{isRemote:u,authority:i}).toString();return`${a}${h}${v}`}).replace(/(["'])(?:vscode-webview-resource):(\/\/[^\s\/'"]+\/([^\s\/'"]+?)(?=\/))?([^\s'"]+?)(["'])/gi,(b,a,l,g,$,v)=>{const y=A.URI.from({scheme:g||"file",path:decodeURIComponent($)}),h=(0,D.$hBb)(y,{isRemote:u,authority:i}).toString();return`${a}${h}${v}`})}}e.$zmc=S;function d(t){try{const c=(0,p.$Mp)((0,p.$Lp)(t.engines.vscode));return!!c&&c.majorBase>=1&&c.minorBase>=57}catch{return!1}}function w(t){try{const c=(0,p.$Mp)((0,p.$Lp)(t.engines.vscode));return c?c.majorBase<1||c.majorBase===1&&c.minorBase<60:!1}catch{return!1}}class f extends N.$Uc{constructor(c,u,i,b,a){super(),this.c=u,this.f=i,this.g=b,this.h=a,this.b=new Map,this.a=c.getProxy(O.$lM.MainThreadWebviews)}dispose(){super.dispose();for(const c of this.b.values())c.dispose();this.b.clear()}$onMessage(c,u,i){const b=this.j(c);if(b){const{message:a}=(0,m.$gsb)(u,i.value);b._onMessageEmitter.fire(a)}}$onMissingCsp(c,u){this.g.warn(`${u} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(c,u,i){const b=new S(c,this.a,s(u),this.c,this.f,i,this.h);this.b.set(c,b);const a=b._onDidDispose(()=>{a.dispose(),this.deleteWebview(c)});return b}deleteWebview(c){this.b.delete(c)}j(c){return this.b.get(c)}}e.$Bmc=f;function o(t){return{id:t.identifier,location:t.extensionLocation}}function r(t,c,u){return{enableCommandUris:u.enableCommandUris,enableScripts:u.enableScripts,enableForms:u.enableForms,portMapping:u.portMapping,localResourceRoots:u.localResourceRoots||n(t,c)}}function s(t){return{enableCommandUris:t.enableCommandUris,enableScripts:t.enableScripts,enableForms:t.enableForms,portMapping:t.portMapping,localResourceRoots:t.localResourceRoots?.map(c=>A.URI.from(c))}}function n(t,c){return[...(c?.getWorkspaceFolders()||[]).map(u=>u.uri),t.extensionLocation]}}),define(Se[111],Ie([1,0,5,16,13,2,3,17,4]),function(le,e,C,N,M,T,A,p,m){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.$boc=e.$aoc=void 0;let O=class{static{D=this}static{this.a={focused:!0,active:!0}}getState(){const d=this.d;return{get focused(){return d.focused},get active(){return d.active}}}constructor(d){this.c=new C.$fe,this.onDidChangeWindowState=this.c.event,this.d=D.a,this.b=d.getProxy(m.$lM.MainThreadWindow),this.b.$getInitialState().then(({isFocused:w,isActive:f})=>{this.onDidChangeWindowProperty("focused",w),this.onDidChangeWindowProperty("active",f)})}$onDidChangeWindowFocus(d){this.onDidChangeWindowProperty("focused",d)}$onDidChangeWindowActive(d){this.onDidChangeWindowProperty("active",d)}onDidChangeWindowProperty(d,w){w!==this.d[d]&&(this.d={...this.d,[d]:w},this.c.fire(this.d))}openUri(d,w){let f;if(typeof d=="string"){f=d;try{d=T.URI.parse(d)}catch{return Promise.reject(`Invalid uri - '${d}'`)}}return(0,M.$9e)(d.scheme)?Promise.reject("Invalid scheme - cannot be empty"):d.scheme===N.Schemas.command?Promise.reject(`Invalid scheme '${d.scheme}'`):this.b.$openUri(d,f,w)}async asExternalUri(d,w){if((0,M.$9e)(d.scheme))return Promise.reject("Invalid scheme - cannot be empty");const f=await this.b.$asExternalUri(d,w);return T.URI.from(f)}};e.$aoc=O,e.$aoc=O=D=Je([We(0,p.$PO)],O),e.$boc=(0,A.$yi)("IExtHostWindow")}),define(Se[254],Ie([1,0,244,27,17]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mqc=void 0;let T=class extends C.$eoc{constructor(p,m){super(p,m)}f(p,m,D){m.apply(console,D)}};e.$mqc=T,e.$mqc=T=Je([We(0,M.$PO),We(1,N.$6O)],T)}),define(Se[255],Ie([1,0,11,22,20,14,5,6,150,242,34]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";var S;Object.defineProperty(e,"__esModule",{value:!0}),e.$Oac=e.ResponsiveState=e.RequestInitiator=void 0,e.$Mac=r,e.$Nac=s;function d(k,I){try{return JSON.stringify(k,I)}catch{return"null"}}const w="$$ref$$",f={[w]:-1};class o{constructor(I,P){this.jsonString=I,this.referencedBuffers=P}}function r(k,I=null,P=!1){const V=[];return{jsonString:(P?d:JSON.stringify)(k,(q,R)=>{if(typeof R>"u")return f;if(typeof R=="object"){if(R instanceof N.$He){const z=V.push(R)-1;return{[w]:z}}if(I)return I(q,R)}return R}),referencedBuffers:V}}function s(k,I,P){return JSON.parse(k,(V,W)=>{if(W){const q=W[w];if(typeof q=="number")return I[q];if(P&&W.$mid===1)return P.transformIncoming(W)}return W})}function n(k,I){return JSON.stringify(k,I)}function t(k){return k?(I,P)=>P&&P.$mid===1?k.transformOutgoing(P):P:null}var c;(function(k){k[k.LocalSide=0]="LocalSide",k[k.OtherSide=1]="OtherSide"})(c||(e.RequestInitiator=c={}));var u;(function(k){k[k.Responsive=0]="Responsive",k[k.Unresponsive=1]="Unresponsive"})(u||(e.ResponsiveState=u={}));const i=()=>{},b=Symbol.for("rpcProtocol"),a=Symbol.for("rpcProxy");class l extends p.$Uc{static{S=b}static{this.a=3*1e3}constructor(I,P=null,V=null){super(),this[S]=!0,this.b=this.B(new A.$fe),this.onDidChangeResponsiveState=this.b.event,this.c=I,this.f=P,this.g=V,this.h=t(this.g),this.j=!1,this.m=[],this.s=[];for(let W=0,q=O.$Dw.count;W<q;W++)this.m[W]=null,this.s[W]=null;this.t=0,this.u=Object.create(null),this.w={},this.y=0,this.z=0,this.C=0,this.D=this.B(new C.$Kh(()=>this.H(),1e3)),this.c.onMessage(W=>this.L(W))}dispose(){this.j=!0,Object.keys(this.w).forEach(I=>{const P=this.w[I];delete this.w[I],P.resolveErr(T.$6())}),super.dispose()}drain(){return typeof this.c.drain=="function"?this.c.drain():Promise.resolve()}F(I){this.z===0&&(this.C=Date.now()+l.a),this.z++,this.D.isScheduled()||this.D.schedule()}G(I){this.C=Date.now()+l.a,this.z--,this.z===0&&this.D.cancel(),this.I(0)}H(){this.z!==0&&(Date.now()>this.C?this.I(1):this.D.schedule())}I(I){this.y!==I&&(this.y=I,this.b.fire(this.y))}get responsiveState(){return this.y}transformIncomingURIs(I){return this.g?(0,m.$Dn)(I,this.g):I}getProxy(I){const{nid:P,sid:V}=I;return this.s[P]||(this.s[P]=this.J(P,V)),this.s[P]}J(I,P){const V={get:(W,q)=>(typeof q=="string"&&!W[q]&&q.charCodeAt(0)===36&&(W[q]=(...R)=>this.U(I,q,R)),q===a?P:W[q])};return new Proxy(Object.create(null),V)}set(I,P){return this.m[I.nid]=P,P}assertRegistered(I){for(let P=0,V=I.length;P<V;P++){const W=I[P];if(!this.m[W.nid])throw new Error(`Missing proxy instance ${W.sid}`)}}L(I){if(this.j)return;const P=I.byteLength,V=$.read(I,0),W=V.readUInt8(),q=V.readUInt32();switch(W){case 1:case 2:{let{rpcId:R,method:z,args:K}=y.deserializeRequestJSONArgs(V);this.g&&(K=(0,m.$Dn)(K,this.g)),this.M(P,q,R,z,K,W===2);break}case 3:case 4:{let{rpcId:R,method:z,args:K}=y.deserializeRequestMixedArgs(V);this.g&&(K=(0,m.$Dn)(K,this.g)),this.M(P,q,R,z,K,W===4);break}case 5:{this.f?.logIncoming(P,q,0,"ack"),this.G(q);break}case 6:{this.N(P,q);break}case 7:{this.O(P,q,void 0);break}case 9:{let R=y.deserializeReplyOKJSON(V);this.g&&(R=(0,m.$Dn)(R,this.g)),this.O(P,q,R);break}case 10:{const R=y.deserializeReplyOKJSONWithBuffers(V,this.g);this.O(P,q,R);break}case 8:{const R=y.deserializeReplyOKVSBuffer(V);this.O(P,q,R);break}case 11:{let R=y.deserializeReplyErrError(V);this.g&&(R=(0,m.$Dn)(R,this.g)),this.P(P,q,R);break}case 12:{this.P(P,q,void 0);break}default:console.error("received unexpected message"),console.error(I)}}M(I,P,V,W,q,R){this.f?.logIncoming(I,P,1,`receiveRequest ${(0,O.$Fw)(V)}.${W}(`,q);const z=String(P);let K,ie;if(R){const ye=new M.$qe;q.push(ye.token),K=this.Q(V,W,q),ie=()=>ye.cancel()}else K=this.Q(V,W,q),ie=i;this.u[z]=ie;const de=y.serializeAcknowledged(P);this.f?.logOutgoing(de.byteLength,P,1,"ack"),this.c.send(de),K.then(ye=>{delete this.u[z];const De=y.serializeReplyOK(P,ye,this.h);this.f?.logOutgoing(De.byteLength,P,1,"reply:",ye),this.c.send(De)},ye=>{delete this.u[z];const De=y.serializeReplyErr(P,ye);this.f?.logOutgoing(De.byteLength,P,1,"replyErr:",ye),this.c.send(De)})}N(I,P){this.f?.logIncoming(I,P,1,"receiveCancel");const V=String(P);this.u[V]?.()}O(I,P,V){this.f?.logIncoming(I,P,0,"receiveReply:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W],q.resolveOk(V)}P(I,P,V){this.f?.logIncoming(I,P,0,"receiveReplyErr:",V);const W=String(P);if(!this.w.hasOwnProperty(W))return;const q=this.w[W];delete this.w[W];let R;V&&(V.$isError?(R=new Error,R.name=V.name,R.message=V.message,R.stack=V.stack):R=V),q.resolveErr(R)}Q(I,P,V){try{return Promise.resolve(this.S(I,P,V))}catch(W){return Promise.reject(W)}}S(I,P,V){const W=this.m[I];if(!W)throw new Error("Unknown actor "+(0,O.$Fw)(I));const q=W[P];if(typeof q!="function")throw new Error("Unknown method "+P+" on actor "+(0,O.$Fw)(I));return q.apply(W,V)}U(I,P,V){if(this.j)return new D.$Lac;let W=null;if(V.length>0&&M.CancellationToken.isCancellationToken(V[V.length-1])&&(W=V.pop()),W&&W.isCancellationRequested)return Promise.reject(T.$6());const q=y.serializeRequestArguments(V,this.h),R=++this.t,z=String(R),K=new D.$Kac,ie=new p.$Tc;W&&ie.add(W.onCancellationRequested(()=>{const ye=y.serializeCancel(R);this.f?.logOutgoing(ye.byteLength,R,0,"cancel"),this.c.send(y.serializeCancel(R))})),this.w[z]=new g(K,ie),this.F(R);const de=y.serializeRequest(R,I,P,q,!!W);return this.f?.logOutgoing(de.byteLength,R,0,`request: ${(0,O.$Fw)(I)}.${P}(`,V),this.c.send(de),K}}e.$Oac=l;class g{constructor(I,P){this.a=I,this.b=P}resolveOk(I){this.a.resolveOk(I),this.b.dispose()}resolveErr(I){this.a.resolveErr(I),this.b.dispose()}}class ${static alloc(I,P,V){const W=new $(N.$He.alloc(V+1+4),0);return W.writeUInt8(I),W.writeUInt32(P),W}static read(I,P){return new $(I,P)}get buffer(){return this.a}constructor(I,P){this.a=I,this.b=P}static sizeUInt8(){return 1}static{this.sizeUInt32=4}writeUInt8(I){this.a.writeUInt8(I,this.b),this.b+=1}readUInt8(){const I=this.a.readUInt8(this.b);return this.b+=1,I}writeUInt32(I){this.a.writeUInt32BE(I,this.b),this.b+=4}readUInt32(){const I=this.a.readUInt32BE(this.b);return this.b+=4,I}static sizeShortString(I){return 1+I.byteLength}writeShortString(I){this.a.writeUInt8(I.byteLength,this.b),this.b+=1,this.a.set(I,this.b),this.b+=I.byteLength}readShortString(){const I=this.a.readUInt8(this.b);this.b+=1;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}static sizeLongString(I){return 4+I.byteLength}writeLongString(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readLongString(){const I=this.a.readUInt32BE(this.b);this.b+=4;const V=this.a.slice(this.b,this.b+I).toString();return this.b+=I,V}writeBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}static sizeVSBuffer(I){return 4+I.byteLength}writeVSBuffer(I){this.a.writeUInt32BE(I.byteLength,this.b),this.b+=4,this.a.set(I,this.b),this.b+=I.byteLength}readVSBuffer(){const I=this.a.readUInt32BE(this.b);this.b+=4;const P=this.a.slice(this.b,this.b+I);return this.b+=I,P}static sizeMixedArray(I){let P=0;P+=1;for(let V=0,W=I.length;V<W;V++){const q=I[V];switch(P+=1,q.type){case 1:P+=this.sizeLongString(q.value);break;case 2:P+=this.sizeVSBuffer(q.value);break;case 3:P+=this.sizeUInt32,P+=this.sizeLongString(q.value);for(let R=0;R<q.buffers.length;++R)P+=this.sizeVSBuffer(q.buffers[R]);break;case 4:break}}return P}writeMixedArray(I){this.a.writeUInt8(I.length,this.b),this.b+=1;for(let P=0,V=I.length;P<V;P++){const W=I[P];switch(W.type){case 1:this.writeUInt8(1),this.writeLongString(W.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(W.value);break;case 3:this.writeUInt8(3),this.writeUInt32(W.buffers.length),this.writeLongString(W.value);for(let q=0;q<W.buffers.length;++q)this.writeBuffer(W.buffers[q]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const I=this.a.readUInt8(this.b);this.b+=1;const P=new Array(I);for(let V=0;V<I;V++)switch(this.readUInt8()){case 1:P[V]=this.readLongString();break;case 2:P[V]=this.readVSBuffer();break;case 3:{const q=this.readUInt32(),R=this.readLongString(),z=[];for(let K=0;K<q;++K)z.push(this.readVSBuffer());P[V]=new O.$Gw(s(R,z,null));break}case 4:P[V]=void 0;break}return P}}var v;(function(k){k[k.Simple=0]="Simple",k[k.Mixed=1]="Mixed"})(v||(v={}));class y{static a(I){for(let P=0,V=I.length;P<V;P++)if(I[P]instanceof N.$He||I[P]instanceof O.$Gw||typeof I[P]>"u")return!0;return!1}static serializeRequestArguments(I,P){if(this.a(I)){const V=[];for(let W=0,q=I.length;W<q;W++){const R=I[W];if(R instanceof N.$He)V[W]={type:2,value:R};else if(typeof R>"u")V[W]={type:4};else if(R instanceof O.$Gw){const{jsonString:z,referencedBuffers:K}=r(R.value,P);V[W]={type:3,value:N.$He.fromString(z),buffers:K}}else V[W]={type:1,value:N.$He.fromString(n(R,P))}}return{type:1,args:V}}return{type:0,args:n(I,P)}}static serializeRequest(I,P,V,W,q){switch(W.type){case 0:return this.b(I,P,V,W.args,q);case 1:return this.c(I,P,V,W.args,q)}}static b(I,P,V,W,q){const R=N.$He.fromString(V),z=N.$He.fromString(W);let K=0;K+=$.sizeUInt8(),K+=$.sizeShortString(R),K+=$.sizeLongString(z);const ie=$.alloc(q?2:1,I,K);return ie.writeUInt8(P),ie.writeShortString(R),ie.writeLongString(z),ie.buffer}static deserializeRequestJSONArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readLongString();return{rpcId:P,method:V,args:JSON.parse(W)}}static c(I,P,V,W,q){const R=N.$He.fromString(V);let z=0;z+=$.sizeUInt8(),z+=$.sizeShortString(R),z+=$.sizeMixedArray(W);const K=$.alloc(q?4:3,I,z);return K.writeUInt8(P),K.writeShortString(R),K.writeMixedArray(W),K.buffer}static deserializeRequestMixedArgs(I){const P=I.readUInt8(),V=I.readShortString(),W=I.readMixedArray(),q=new Array(W.length);for(let R=0,z=W.length;R<z;R++){const K=W[R];typeof K=="string"?q[R]=JSON.parse(K):q[R]=K}return{rpcId:P,method:V,args:q}}static serializeAcknowledged(I){return $.alloc(5,I,0).buffer}static serializeCancel(I){return $.alloc(6,I,0).buffer}static serializeReplyOK(I,P,V){if(typeof P>"u")return this.d(I);if(P instanceof N.$He)return this.e(I,P);if(P instanceof O.$Gw){const{jsonString:W,referencedBuffers:q}=r(P.value,V,!0);return this.g(I,W,q)}else return this.f(I,d(P,V))}static d(I){return $.alloc(7,I,0).buffer}static e(I,P){let V=0;V+=$.sizeVSBuffer(P);const W=$.alloc(8,I,V);return W.writeVSBuffer(P),W.buffer}static deserializeReplyOKVSBuffer(I){return I.readVSBuffer()}static f(I,P){const V=N.$He.fromString(P);let W=0;W+=$.sizeLongString(V);const q=$.alloc(9,I,W);return q.writeLongString(V),q.buffer}static g(I,P,V){const W=N.$He.fromString(P);let q=0;q+=$.sizeUInt32,q+=$.sizeLongString(W);for(const z of V)q+=$.sizeVSBuffer(z);const R=$.alloc(10,I,q);R.writeUInt32(V.length),R.writeLongString(W);for(const z of V)R.writeBuffer(z);return R.buffer}static deserializeReplyOKJSON(I){const P=I.readLongString();return JSON.parse(P)}static deserializeReplyOKJSONWithBuffers(I,P){const V=I.readUInt32(),W=I.readLongString(),q=[];for(let R=0;R<V;++R)q.push(I.readVSBuffer());return new O.$Gw(s(W,q,P))}static serializeReplyErr(I,P){const V=P?d(T.$3(P),null):void 0;if(typeof V!="string")return this.h(I);const W=N.$He.fromString(V);let q=0;q+=$.sizeLongString(W);const R=$.alloc(11,I,q);return R.writeLongString(W),R.buffer}static deserializeReplyErrError(I){const P=I.readLongString();return JSON.parse(P)}static h(I){return $.alloc(12,I,0).buffer}}var h;(function(k){k[k.RequestJSONArgs=1]="RequestJSONArgs",k[k.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",k[k.RequestMixedArgs=3]="RequestMixedArgs",k[k.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",k[k.Acknowledged=5]="Acknowledged",k[k.Cancel=6]="Cancel",k[k.ReplyOKEmpty=7]="ReplyOKEmpty",k[k.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",k[k.ReplyOKJSON=9]="ReplyOKJSON",k[k.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",k[k.ReplyErrError=11]="ReplyErrError",k[k.ReplyErrEmpty=12]="ReplyErrEmpty"})(h||(h={}));var E;(function(k){k[k.String=1]="String",k[k.VSBuffer=2]="VSBuffer",k[k.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",k[k.Undefined=4]="Undefined"})(E||(E={}))}),define(Se[256],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$oqc=void 0;const C=function(T){const A=p=>{globalThis.removeEventListener("message",A);const m=p.data;Object.defineProperties(globalThis,{postMessage:{value(D,O){m.postMessage(D,O)}},onmessage:{get(){return m.onmessage},set(D){m.onmessage=D}}}),m.addEventListener("message",D=>{globalThis.dispatchEvent(new MessageEvent("message",{data:D.data,ports:D.ports?[...D.ports]:void 0}))}),m.start(),globalThis.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(T)};globalThis.addEventListener("message",A)}.toString();class N extends EventTarget{constructor(T,A,p){super(),this.onmessage=null,this.onmessageerror=null,this.onerror=null;const m=`((${C})('${A}'))`,D=new Blob([m],{type:"application/javascript"}),O=URL.createObjectURL(D),S=new MessageChannel,d=O,w={type:"_newWorker",id:d,port:S.port2,url:O,options:p};T(w,[S.port2]),this.postMessage=S.port1.postMessage.bind(S.port1),this.terminate=()=>{T({type:"_terminateWorker",id:d}),URL.revokeObjectURL(O),S.port1.close(),S.port2.close()},Object.defineProperties(this,{onmessage:{get(){return S.port1.onmessage},set(f){S.port1.onmessage=f}},onmessageerror:{get(){return S.port1.onmessageerror},set(f){S.port1.onmessageerror=f}}}),S.port1.addEventListener("messageerror",f=>{const o=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(o)}),S.port1.addEventListener("message",f=>{const o=new MessageEvent("message",{data:f.data});this.dispatchEvent(o)}),S.port1.start()}}e.$oqc=N}),define(Se[257],Ie([1,0,22,28,16,56,3]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2J=e.$YJ=void 0,e.$ZJ=O,e.$1J=S,e.$YJ=(0,A.$yi)("notebookDocumentService");const p=["W","X","Y","Z","a","b","c","d","e","f"],m=new RegExp(`^[${p.join("")}]+`),D=7;function O(w){if(w.scheme!==M.Schemas.vscodeNotebookCell)return;const f=w.fragment.indexOf("s");if(f<0)return;const o=parseInt(w.fragment.substring(0,f).replace(m,""),D),r=(0,C.$1e)(w.fragment.substring(f+1)).toString();if(!isNaN(o))return{handle:o,notebook:w.with({scheme:r,fragment:null})}}function S(w,f){const o=f.toString(D),s=`${o.length<p.length?p[o.length-1]:"z"}${o}s${(0,C.$2e)(C.$He.fromString(w.scheme),!0,!0)}`;return w.with({scheme:M.Schemas.vscodeNotebookCell,fragment:s})}class d{constructor(){this.a=new N.$Ac}getNotebook(f){if(f.scheme===M.Schemas.vscodeNotebookCell){const o=O(f);if(o){const r=this.a.get(o.notebook);if(r)return r}}return this.a.get(f)}addNotebookDocument(f){this.a.set(f.uri,f)}removeNotebookDocument(f){this.a.delete(f.uri)}}e.$2J=d,(0,T.$Cs)(e.$YJ,d,1)}),define(Se[85],Ie([1,0,22,37,42,70,16,19,23,31,257]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jK=e.$gK=e.CellStatusbarAlignment=e.$fK=e.NotebookEditorPriority=e.$cK=e.$bK=e.$_J=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookExecutionState=e.NotebookCellExecutionState=e.NotebookRunState=e.$$J=e.$0J=e.$9J=e.$8J=e.CellKind=e.$7J=e.$6J=e.$5J=void 0,e.$aK=b,e.$dK=l,e.$eK=g,e.$hK=y,e.$iK=E,e.$5J="workbench.editor.notebook",e.$6J="workbench.editor.notebookTextDiffEditor",e.$7J="workbench.editor.interactive";var S;(function(K){K[K.Markup=1]="Markup",K[K.Code=2]="Code"})(S||(e.CellKind=S={})),e.$8J=["application/json","application/javascript","text/html","image/svg+xml",T.$Vs.latex,T.$Vs.markdown,"image/png","image/jpeg",T.$Vs.text],e.$9J=[T.$Vs.latex,T.$Vs.markdown,"application/json","text/html","image/svg+xml","image/png","image/jpeg",T.$Vs.text],e.$0J=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.$$J="_notAvailable";var d;(function(K){K[K.Running=1]="Running",K[K.Idle=2]="Idle"})(d||(e.NotebookRunState=d={}));var w;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(w||(e.NotebookCellExecutionState=w={}));var f;(function(K){K[K.Unconfirmed=1]="Unconfirmed",K[K.Pending=2]="Pending",K[K.Executing=3]="Executing"})(f||(e.NotebookExecutionState=f={}));var o;(function(K){K[K.WithHardKernelDependency=0]="WithHardKernelDependency",K[K.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",K[K.Pure=2]="Pure",K[K.Never=3]="Never"})(o||(e.NotebookRendererMatch=o={}));var r;(function(K){K.Always="always",K.Never="never",K.Optional="optional"})(r||(e.RendererMessagingSpec=r={}));var s;(function(K){K[K.ModelChange=1]="ModelChange",K[K.Move=2]="Move",K[K.ChangeCellLanguage=5]="ChangeCellLanguage",K[K.Initialize=6]="Initialize",K[K.ChangeCellMetadata=7]="ChangeCellMetadata",K[K.Output=8]="Output",K[K.OutputItem=9]="OutputItem",K[K.ChangeCellContent=10]="ChangeCellContent",K[K.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",K[K.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",K[K.ChangeCellMime=13]="ChangeCellMime",K[K.Unknown=100]="Unknown"})(s||(e.NotebookCellsChangeType=s={}));var n;(function(K){K[K.Handle=0]="Handle",K[K.Index=1]="Index"})(n||(e.SelectionStateType=n={}));var t;(function(K){K[K.Replace=1]="Replace",K[K.Output=2]="Output",K[K.Metadata=3]="Metadata",K[K.CellLanguage=4]="CellLanguage",K[K.DocumentMetadata=5]="DocumentMetadata",K[K.Move=6]="Move",K[K.OutputItems=7]="OutputItems",K[K.PartialMetadata=8]="PartialMetadata",K[K.PartialInternalMetadata=9]="PartialInternalMetadata"})(t||(e.CellEditType=t={}));var c;(function(K){K.scheme=A.Schemas.vscodeNotebookCell;function ie(Ce,se){return(0,O.$1J)(Ce,se)}K.generate=ie;function de(Ce){return(0,O.$ZJ)(Ce)}K.parse=de;function ye(Ce,se){return Ce.with({scheme:A.Schemas.vscodeNotebookCellOutput,fragment:`op${se??""},${Ce.scheme!==A.Schemas.file?Ce.scheme:""}`})}K.generateCellOutputUri=ye;function De(Ce){if(Ce.scheme!==A.Schemas.vscodeNotebookCellOutput)return;const se=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(Ce.fragment);if(!se)return;const Ne=se[1]&&se[1]!==""?se[1]:void 0,ne=se[2];return{outputId:Ne,notebook:Ce.with({scheme:ne||A.Schemas.file,fragment:null})}}K.parseCellOutputUri=De;function ge(Ce,se,Ne){return K.generate(Ce,se).with({scheme:Ne})}K.generateCellPropertyUri=ge;function ue(Ce,se){if(Ce.scheme===se)return K.parse(Ce.with({scheme:K.scheme}))}K.parseCellPropertyUri=ue})(c||(e.CellUri=c={}));const u=K=>m.$i?K.replace(/\//g,"\\"):K;class i{constructor(ie=[],de=e.$8J){this.e=de,this.d=[...new Set(ie)].map(ye=>({pattern:ye,matches:N.$sk(u(ye))}))}sort(ie){const de=new Map(M.Iterable.map(ie,De=>[De,u(De)]));let ye=[];for(const{matches:De}of this.d)for(const[ge,ue]of de)if(De(ue)){ye.push(ge),de.delete(ge);break}return de.size&&(ye=ye.concat([...de.keys()].sort((De,ge)=>this.e.indexOf(De)-this.e.indexOf(ge)))),ye}prioritize(ie,de){const ye=this.f(ie);if(ye===-1){this.d.unshift({pattern:ie,matches:N.$sk(u(ie))});return}const De=new Set(de.map(ue=>this.f(ue,ye)));De.delete(-1);const ge=Array.from(De).sort();this.d.splice(ye+1,0,...ge.map(ue=>this.d[ue]));for(let ue=ge.length-1;ue>=0;ue--)this.d.splice(ge[ue],1)}toArray(){return this.d.map(ie=>ie.pattern)}f(ie,de=this.d.length){const ye=u(ie);for(let De=0;De<de;De++)if(this.d[De].matches(ye))return De;return-1}}e.$_J=i;function b(K,ie,de,ye=(De,ge)=>De===ge){const De=[];function ge(se,Ne,ne){if(Ne===0&&ne.length===0)return;const U=De[De.length-1];U&&U.start+U.deleteCount===se?(U.deleteCount+=Ne,U.toInsert.push(...ne)):De.push({start:se,deleteCount:Ne,toInsert:ne})}let ue=0,Ce=0;for(;;){if(ue===K.length){ge(ue,0,ie.slice(Ce));break}if(Ce===ie.length){ge(ue,K.length-ue,[]);break}const se=K[ue],Ne=ie[Ce];if(ye(se,Ne)){ue+=1,Ce+=1;continue}de(Ne)?(ge(ue,1,[]),ue+=1):(ge(ue,0,[Ne]),Ce+=1)}return De}e.$bK=new D.$Pj("notebookEditorCursorAtBoundary","none"),e.$cK=new D.$Pj("notebookEditorCursorAtLineBoundary","none");var a;(function(K){K.default="default",K.option="option"})(a||(e.NotebookEditorPriority=a={}));function l(K){const ie=K;return!!((typeof ie.include=="string"||N.$tk(ie.include))&&(typeof ie.exclude=="string"||N.$tk(ie.exclude)))}function g(K,ie,de){if(Array.isArray(K.viewType)&&K.viewType.indexOf(ie)>=0||K.viewType===ie)return!0;if(K.filenamePattern){const ye=l(K.filenamePattern)?K.filenamePattern.include:K.filenamePattern,De=l(K.filenamePattern)?K.filenamePattern.exclude:void 0;if(N.$rk(ye,(0,p.$nc)(de.fsPath).toLowerCase()))return!(De&&N.$rk(De,(0,p.$nc)(de.fsPath).toLowerCase()))}return!1}e.$fK={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",diffOverviewRuler:"notebook.diff.overviewRuler",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",stickyScrollEnabled:"notebook.stickyScroll.enabled",stickyScrollMode:"notebook.stickyScroll.mode",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",markdownLineHeight:"notebook.markdown.lineHeight",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputScrollingDeprecated:"notebook.experimental.outputScrolling",outputScrolling:"notebook.output.scrolling",textOutputLineLimit:"notebook.output.textLineLimit",LinkifyOutputFilePaths:"notebook.output.linkifyFilePaths",minimalErrorRendering:"notebook.output.minimalErrorRendering",formatOnSave:"notebook.formatOnSave.enabled",insertFinalNewline:"notebook.insertFinalNewline",formatOnCellExecution:"notebook.formatOnCellExecution",codeActionsOnSave:"notebook.codeActionsOnSave",outputWordWrap:"notebook.output.wordWrap",outputLineHeightDeprecated:"notebook.outputLineHeight",outputLineHeight:"notebook.output.lineHeight",outputFontSizeDeprecated:"notebook.outputFontSize",outputFontSize:"notebook.output.fontSize",outputFontFamilyDeprecated:"notebook.outputFontFamily",outputFontFamily:"notebook.output.fontFamily",findScope:"notebook.find.scope",logging:"notebook.logging",confirmDeleteRunningCell:"notebook.confirmDeleteRunningCell",remoteSaving:"notebook.experimental.remoteSave",gotoSymbolsAllSymbols:"notebook.gotoSymbols.showAllSymbols",outlineShowMarkdownHeadersOnly:"notebook.outline.showMarkdownHeadersOnly",outlineShowCodeCells:"notebook.outline.showCodeCells",outlineShowCodeCellSymbols:"notebook.outline.showCodeCellSymbols",breadcrumbsShowCodeCells:"notebook.breadcrumbs.showCodeCells",scrollToRevealCell:"notebook.scrolling.revealNextCellOnExecute",cellChat:"notebook.experimental.cellChat",cellGenerate:"notebook.experimental.generate",notebookVariablesView:"notebook.experimental.variablesView",InteractiveWindowPromptToSave:"interactiveWindow.promptToSaveOnClose",cellFailureDiagnostics:"notebook.cellFailureDiagnostics",outputBackupSizeLimit:"notebook.backup.sizeLimit"};var $;(function(K){K[K.Left=1]="Left",K[K.Right=2]="Right"})($||(e.CellStatusbarAlignment=$={}));class v{static{this.d="notebook/"}static create(ie){return`${v.d}${ie}`}static parse(ie){if(ie.startsWith(v.d))return ie.substring(v.d.length)}}e.$gK=v;function y(K){return["application/vnd.code.notebook.stdout","application/vnd.code.notebook.stderr"].includes(K)}const h=new TextDecoder;function E(K){const ie=[];let de=!1;for(const ue of K)(ie.length===0||de)&&(ie.push(ue),de=!0);let ye=P(ie);const De=C.$He.concat(ie.map(ue=>C.$He.wrap(ue))),ge=z(De);return ye=ye||ge.byteLength!==De.byteLength,{data:ge,didCompression:ye}}e.$jK="\x1B[A";const k=e.$jK.split("").map(K=>K.charCodeAt(0)),I=10;function P(K){let ie=!1;return K.forEach((de,ye)=>{if(ye===0||de.length<e.$jK.length)return;const De=K[ye-1],ge=de.subarray(0,e.$jK.length);if(ge[0]===k[0]&&ge[1]===k[1]&&ge[2]===k[2]){const ue=De.lastIndexOf(I);if(ue===-1)return;ie=!0,K[ye-1]=De.subarray(0,ue),K[ye]=de.subarray(e.$jK.length)}}),ie}function V(K){let ie=K;do K=ie,ie=K.replace(/[^\n]\x08/gm,"");while(ie.length<K.length);return K}function W(K){for(K=K.replace(/\r+\n/gm,`
`);K.search(/\r[^$]/g)>-1;){const ie=K.match(/^(.*)\r+/m)[1];let de=K.match(/\r+(.*)$/m)[1];de=de+ie.slice(de.length,ie.length),K=K.replace(/\r+.*$/m,"\r").replace(/^.*\r/m,de)}return K}const q=8,R=13;function z(K){return!K.buffer.includes(q)&&!K.buffer.includes(R)?K:C.$He.fromString(W(V(h.decode(K.buffer))))}}),define(Se[7],Ie([1,0,18,14,55,28,70,13,15,2,33,21,38,104,85]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f){"use strict";var o,r,s,n,t,c,u,i,b,a,l,g,$,v,y,h,E;Object.defineProperty(e,"__esModule",{value:!0}),e.InlineEditTriggerKind=e.$DO=e.KeywordRecognitionStatus=e.TextToSpeechStatus=e.SpeechToTextStatus=e.RelatedInformationType=e.$CO=e.$BO=e.$AO=e.$zO=e.$yO=e.LanguageModelChatMessageRole=e.ChatLocation=e.$xO=e.$wO=e.$vO=e.$uO=e.$tO=e.$sO=e.$rO=e.$qO=e.$pO=e.$oO=e.$nO=e.$mO=e.$lO=e.$kO=e.ChatResultFeedbackKind=e.InteractiveEditorResponseFeedbackKind=e.$jO=e.ChatVariableLevel=e.ChatCopyKind=e.InteractiveSessionVoteDirection=e.$iO=e.$hO=e.$gO=e.$fO=e.$eO=e.$dO=e.$cO=e.$bO=e.$aO=e.$_N=e.$$N=e.$0N=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.$9N=e.$8N=e.$7N=e.$6N=e.$4N=e.$3N=e.$2N=e.$1N=e.TestRunProfileKind=e.TestResultState=e.$ZN=e.$YN=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.$XN=e.NotebookVariablesRequestKind=e.$WN=e.$VN=e.NotebookControllerAffinity2=e.NotebookControllerAffinity=e.$UN=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.$TN=e.$SN=e.$RN=e.$QN=e.$PN=e.ColorThemeKind=e.$ON=e.$NN=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.$MN=e.$LN=e.DebugConsoleMode=e.$KN=e.$JN=e.$IN=e.$HN=e.$GN=e.CommentThreadApplicability=e.CommentThreadState=e.CommentState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.$FN=e.$EN=e.FileChangeType=e.$DN=e.NewSymbolNameTriggerKind=e.NewSymbolNameTag=e.$CN=e.$BN=e.$AN=e.$zN=e.InlineCompletionTriggerKind=e.$yN=e.$xN=e.$wN=e.$vN=e.$uN=e.$tN=e.$sN=e.$rN=e.$qN=e.$pN=e.$oN=e.$mN=e.ConfigurationTarget=e.$lN=e.$kN=e.$jN=e.$iN=e.DocumentPasteTriggerKind=e.$hN=e.$gN=e.$fN=e.$eN=e.$dN=e.$cN=e.TreeItemCheckboxState=e.TreeItemCollapsibleState=e.$bN=e.ViewBadge=e.ProgressLocation=e.$aN=e.$_M=e.TaskScope=e.ShellQuoting=e.$$M=e.$0M=e.$9M=e.TaskPanelKind=e.TaskRevealKind=e.$8M=e.TerminalLocation=e.$7M=e.$6M=e.$5M=e.TerminalShellExecutionCommandLineConfidence=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.$4M=e.$3M=e.$2M=e.$1M=e.SyntaxTokenType=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.PartialAcceptTriggerKind=e.$YM=e.$XM=e.$WM=e.$VM=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.$UM=e.$TM=e.InlayHintKind=e.SignatureHelpTriggerKind=e.$SM=e.$RM=e.$QM=e.$PM=e.$OM=e.LanguageStatusSeverity=e.$NM=e.$MM=e.$LM=e.$KM=e.$JM=e.$IM=e.CodeActionTriggerKind=e.$HM=e.$GM=e.SymbolTag=e.SymbolKind=e.$FM=e.$EM=e.DocumentHighlightKind=e.HoverVerbosityAction=e.$DM=e.$CM=e.$BM=e.$AM=e.$zM=e.DiagnosticSeverity=e.DiagnosticTag=e.$yM=e.$xM=e.FileEditType=e.$wM=e.$vM=e.$uM=e.EnvironmentVariableMutatorType=e.EndOfLine=e.$tM=e.$sM=e.$rM=e.$qM=e.$pM=e.$oM=e.$nM=e.TerminalQuickFixType=e.TerminalOutputAnchor=void 0,e.$ZM=Vt,e.$nN=Me,e.$5N=En;function k(j){return Object.assign(j,{apply:function(...ee){if(ee.length===0)return Reflect.construct(j,[]);{const Ee=ee.length===1?[]:ee[1];return Reflect.construct(j,Ee,ee[0].constructor)}},call:function(...ee){if(ee.length===0)return Reflect.construct(j,[]);{const[Ee,...Ke]=ee;return Reflect.construct(j,Ke,Ee.constructor)}}})}var I;(function(j){j[j.Top=0]="Top",j[j.Bottom=1]="Bottom"})(I||(e.TerminalOutputAnchor=I={}));var P;(function(j){j[j.TerminalCommand=0]="TerminalCommand",j[j.Opener=1]="Opener",j[j.Command=3]="Command"})(P||(e.TerminalQuickFixType=P={}));let V=o=class{static from(...L){let ee=L;return new o(function(){if(ee){for(const Ee of ee)Ee&&typeof Ee.dispose=="function"&&Ee.dispose();ee=void 0}})}#e;constructor(L){this.#e=L}dispose(){typeof this.#e=="function"&&(this.#e(),this.#e=void 0)}};e.$nM=V,e.$nM=V=o=Je([k],V);let W=r=class{static Min(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ke=L[Ee];Ke.isBefore(ee)&&(ee=Ke)}return ee}static Max(...L){if(L.length===0)throw new TypeError;let ee=L[0];for(let Ee=1;Ee<L.length;Ee++){const Ke=L[Ee];Ke.isAfter(ee)&&(ee=Ke)}return ee}static isPosition(L){if(!L)return!1;if(L instanceof r)return!0;const{line:ee,character:Ee}=L;return typeof ee=="number"&&typeof Ee=="number"}static of(L){if(L instanceof r)return L;if(this.isPosition(L))return new r(L.line,L.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this.c}get character(){return this.e}constructor(L,ee){if(L<0)throw(0,N.$7)("line must be non-negative");if(ee<0)throw(0,N.$7)("character must be non-negative");this.c=L,this.e=ee}isBefore(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<L.e}isBeforeOrEqual(L){return this.c<L.c?!0:L.c<this.c?!1:this.e<=L.e}isAfter(L){return!this.isBeforeOrEqual(L)}isAfterOrEqual(L){return!this.isBefore(L)}isEqual(L){return this.c===L.c&&this.e===L.e}compareTo(L){return this.c<L.c?-1:this.c>L.line?1:this.e<L.e?-1:this.e>L.e?1:0}translate(L,ee=0){if(L===null||ee===null)throw(0,N.$7)();let Ee;return typeof L>"u"?Ee=0:typeof L=="number"?Ee=L:(Ee=typeof L.lineDelta=="number"?L.lineDelta:0,ee=typeof L.characterDelta=="number"?L.characterDelta:0),Ee===0&&ee===0?this:new r(this.line+Ee,this.character+ee)}with(L,ee=this.character){if(L===null||ee===null)throw(0,N.$7)();let Ee;return typeof L>"u"?Ee=this.line:typeof L=="number"?Ee=L:(Ee=typeof L.line=="number"?L.line:this.line,ee=typeof L.character=="number"?L.character:this.character),Ee===this.line&&ee===this.character?this:new r(Ee,ee)}toJSON(){return{line:this.line,character:this.character}}};e.$oM=W,e.$oM=W=r=Je([k],W);let q=s=class{static isRange(L){return L instanceof s?!0:L?W.isPosition(L.start)&&W.isPosition(L.end):!1}static of(L){if(L instanceof s)return L;if(this.isRange(L))return new s(L.start,L.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this.c}get end(){return this.e}constructor(L,ee,Ee,Ke){let Ye,lt;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new W(L,ee),lt=new W(Ee,Ke)):W.isPosition(L)&&W.isPosition(ee)&&(Ye=W.of(L),lt=W.of(ee)),!Ye||!lt)throw new Error("Invalid arguments");Ye.isBefore(lt)?(this.c=Ye,this.e=lt):(this.c=lt,this.e=Ye)}contains(L){return s.isRange(L)?this.contains(L.start)&&this.contains(L.end):W.isPosition(L)?!(W.of(L).isBefore(this.c)||this.e.isBefore(L)):!1}isEqual(L){return this.c.isEqual(L.c)&&this.e.isEqual(L.e)}intersection(L){const ee=W.Max(L.start,this.c),Ee=W.Min(L.end,this.e);if(!ee.isAfter(Ee))return new s(ee,Ee)}union(L){if(this.contains(L))return this;if(L.contains(this))return L;const ee=W.Min(L.start,this.c),Ee=W.Max(L.end,this.end);return new s(ee,Ee)}get isEmpty(){return this.c.isEqual(this.e)}get isSingleLine(){return this.c.line===this.e.line}with(L,ee=this.end){if(L===null||ee===null)throw(0,N.$7)();let Ee;return L?W.isPosition(L)?Ee=L:(Ee=L.start||this.start,ee=L.end||this.end):Ee=this.start,Ee.isEqual(this.c)&&ee.isEqual(this.end)?this:new s(Ee,ee)}toJSON(){return[this.start,this.end]}};e.$pM=q,e.$pM=q=s=Je([k],q);let R=n=class extends q{static isSelection(L){return L instanceof n?!0:L?q.isRange(L)&&W.isPosition(L.anchor)&&W.isPosition(L.active)&&typeof L.isReversed=="boolean":!1}get anchor(){return this.f}get active(){return this.g}constructor(L,ee,Ee,Ke){let Ye,lt;if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ke=="number"?(Ye=new W(L,ee),lt=new W(Ee,Ke)):W.isPosition(L)&&W.isPosition(ee)&&(Ye=W.of(L),lt=W.of(ee)),!Ye||!lt)throw new Error("Invalid arguments");super(Ye,lt),this.f=Ye,this.g=lt}get isReversed(){return this.f===this.e}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};e.$qM=R,e.$qM=R=n=Je([k],R);const z=j=>{if(typeof j!="string"||j.length===0||!/^[0-9A-Za-z_\-]+$/.test(j))throw(0,N.$7)("connectionToken")};class K{static isResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.host=="string"&&typeof L.port=="number"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ee,Ee){if(typeof L!="string"||L.length===0)throw(0,N.$7)("host");if(typeof ee!="number"||ee===0||Math.round(ee)!==ee)throw(0,N.$7)("port");typeof Ee<"u"&&z(Ee),this.host=L,this.port=Math.round(ee),this.connectionToken=Ee}}e.$rM=K;class ie{static isManagedResolvedAuthority(L){return L&&typeof L=="object"&&typeof L.makeConnection=="function"&&(L.connectionToken===void 0||typeof L.connectionToken=="string")}constructor(L,ee){this.makeConnection=L,this.connectionToken=ee,typeof ee<"u"&&z(ee)}}e.$sM=ie;class de extends Error{static NotAvailable(L,ee){return new de(L,w.RemoteAuthorityResolverErrorCode.NotAvailable,ee)}static TemporarilyNotAvailable(L){return new de(L,w.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}constructor(L,ee=w.RemoteAuthorityResolverErrorCode.Unknown,Ee){super(L),this._message=L,this._code=ee,this._detail=Ee,Object.setPrototypeOf(this,de.prototype)}}e.$tM=de;var ye;(function(j){j[j.LF=1]="LF",j[j.CRLF=2]="CRLF"})(ye||(e.EndOfLine=ye={}));var De;(function(j){j[j.Replace=1]="Replace",j[j.Append=2]="Append",j[j.Prepend=3]="Prepend"})(De||(e.EnvironmentVariableMutatorType=De={}));let ge=t=class{static isTextEdit(L){return L instanceof t?!0:L?q.isRange(L)&&typeof L.newText=="string":!1}static replace(L,ee){return new t(L,ee)}static insert(L,ee){return t.replace(new q(L,L),ee)}static delete(L){return t.replace(L,"")}static setEndOfLine(L){const ee=new t(new q(new W(0,0),new W(0,0)),"");return ee.newEol=L,ee}get range(){return this.c}set range(L){if(L&&!q.isRange(L))throw(0,N.$7)("range");this.c=L}get newText(){return this.e||""}set newText(L){if(L&&typeof L!="string")throw(0,N.$7)("newText");this.e=L}get newEol(){return this.f}set newEol(L){if(L&&typeof L!="number")throw(0,N.$7)("newEol");this.f=L}constructor(L,ee){this.c=L,this.e=ee}toJSON(){return{range:this.range,newText:this.newText,newEol:this.f}}};e.$uM=ge,e.$uM=ge=t=Je([k],ge);let ue=c=class{static isNotebookCellEdit(L){return L instanceof c?!0:L?gi.isNotebookRange(L)&&Array.isArray(L.newCells):!1}static replaceCells(L,ee){return new c(L,ee)}static insertCells(L,ee){return new c(new gi(L,L),ee)}static deleteCells(L){return new c(L,[])}static updateCellMetadata(L,ee){const Ee=new c(new gi(L,L),[]);return Ee.newCellMetadata=ee,Ee}static updateNotebookMetadata(L){const ee=new c(new gi(0,0),[]);return ee.newNotebookMetadata=L,ee}constructor(L,ee){this.range=L,this.newCells=ee}};e.$vM=ue,e.$vM=ue=c=Je([k],ue);class Ce{static isSnippetTextEdit(L){return L instanceof Ce?!0:L?q.isRange(L.range)&&ne.isSnippetString(L.snippet):!1}static replace(L,ee){return new Ce(L,ee)}static insert(L,ee){return Ce.replace(new q(L,L),ee)}constructor(L,ee){this.range=L,this.snippet=ee}}e.$wM=Ce;var se;(function(j){j[j.File=1]="File",j[j.Text=2]="Text",j[j.Cell=3]="Cell",j[j.CellReplace=5]="CellReplace",j[j.Snippet=6]="Snippet"})(se||(e.FileEditType=se={}));let Ne=class{constructor(){this.c=[]}_allEntries(){return this.c}renameFile(L,ee,Ee,Ke){this.c.push({_type:1,from:L,to:ee,options:Ee,metadata:Ke})}createFile(L,ee,Ee){this.c.push({_type:1,from:void 0,to:L,options:ee,metadata:Ee})}deleteFile(L,ee,Ee){this.c.push({_type:1,from:L,to:void 0,options:ee,metadata:Ee})}e(L,ee,Ee){this.c.push({_type:3,metadata:Ee,uri:L,edit:{editType:5,metadata:ee},notebookMetadata:ee})}f(L,ee,Ee,Ke){const Ye=ee.start,lt=ee.end;(Ye!==lt||Ee.length>0)&&this.c.push({_type:5,uri:L,index:Ye,count:lt-Ye,cells:Ee,metadata:Ke})}g(L,ee,Ee,Ke){this.c.push({_type:3,metadata:Ke,uri:L,edit:{editType:3,index:ee,metadata:Ee}})}replace(L,ee,Ee,Ke){this.c.push({_type:2,uri:L,edit:new ge(ee,Ee),metadata:Ke})}insert(L,ee,Ee,Ke){this.replace(L,new q(ee,ee),Ee,Ke)}delete(L,ee,Ee){this.replace(L,ee,"",Ee)}has(L){return this.c.some(ee=>ee._type===2&&ee.uri.toString()===L.toString())}set(L,ee){if(ee)for(const Ee of ee){if(!Ee)continue;let Ke,Ye;Array.isArray(Ee)?(Ke=Ee[0],Ye=Ee[1]):Ke=Ee,ue.isNotebookCellEdit(Ke)?Ke.newCellMetadata?this.g(L,Ke.range.start,Ke.newCellMetadata,Ye):Ke.newNotebookMetadata?this.e(L,Ke.newNotebookMetadata,Ye):this.f(L,Ke.range,Ke.newCells,Ye):Ce.isSnippetTextEdit(Ke)?this.c.push({_type:6,uri:L,range:Ke.range,edit:Ke.snippet,metadata:Ye}):this.c.push({_type:2,uri:L,edit:Ke,metadata:Ye})}else{for(let Ee=0;Ee<this.c.length;Ee++){const Ke=this.c[Ee];switch(Ke._type){case 2:case 6:case 3:case 5:Ke.uri.toString()===L.toString()&&(this.c[Ee]=void 0);break}}(0,C.$Ib)(this.c)}}get(L){const ee=[];for(const Ee of this.c)Ee._type===2&&Ee.uri.toString()===L.toString()&&ee.push(Ee.edit);return ee}entries(){const L=new T.$Ac;for(const ee of this.c)if(ee._type===2){let Ee=L.get(ee.uri);Ee||(Ee=[ee.uri,[]],L.set(ee.uri,Ee)),Ee[1].push(ee.edit)}return[...L.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};e.$xM=Ne,e.$xM=Ne=Je([k],Ne);let ne=u=class{static isSnippetString(L){return L instanceof u?!0:L?typeof L.value=="string":!1}static c(L){return L.replace(/\$|}|\\/g,"\\$&")}constructor(L){this.e=1,this.value=L||""}appendText(L){return this.value+=u.c(L),this}appendTabstop(L=this.e++){return this.value+="$",this.value+=L,this}appendPlaceholder(L,ee=this.e++){if(typeof L=="function"){const Ee=new u;Ee.e=this.e,L(Ee),this.e=Ee.e,L=Ee.value}else L=u.c(L);return this.value+="${",this.value+=ee,this.value+=":",this.value+=L,this.value+="}",this}appendChoice(L,ee=this.e++){const Ee=L.map(Ke=>Ke.replaceAll(/[|\\,]/g,"\\$&")).join(",");return this.value+="${",this.value+=ee,this.value+="|",this.value+=Ee,this.value+="|}",this}appendVariable(L,ee){if(typeof ee=="function"){const Ee=new u;Ee.e=this.e,ee(Ee),this.e=Ee.e,ee=Ee.value}else typeof ee=="string"&&(ee=ee.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=L,ee&&(this.value+=":",this.value+=ee),this.value+="}",this}};e.$yM=ne,e.$yM=ne=u=Je([k],ne);var U;(function(j){j[j.Unnecessary=1]="Unnecessary",j[j.Deprecated=2]="Deprecated"})(U||(e.DiagnosticTag=U={}));var x;(function(j){j[j.Hint=3]="Hint",j[j.Information=2]="Information",j[j.Warning=1]="Warning",j[j.Error=0]="Error"})(x||(e.DiagnosticSeverity=x={}));let ve=i=class{static isLocation(L){return L instanceof i?!0:L?q.isRange(L.range)&&D.URI.isUri(L.uri):!1}constructor(L,ee){if(this.uri=L,ee)if(q.isRange(ee))this.range=q.of(ee);else if(W.isPosition(ee))this.range=new q(ee,ee);else throw new Error("Illegal argument")}toJSON(){return{uri:this.uri,range:this.range}}};e.$zM=ve,e.$zM=ve=i=Je([k],ve);let Le=class{static is(L){return L?typeof L.message=="string"&&L.location&&q.isRange(L.location.range)&&D.URI.isUri(L.location.uri):!1}constructor(L,ee){this.location=L,this.message=ee}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.location.range.isEqual(ee.location.range)&&L.location.uri.toString()===ee.location.uri.toString()}};e.$AM=Le,e.$AM=Le=Je([k],Le);let ke=class{constructor(L,ee,Ee=x.Error){if(!q.isRange(L))throw new TypeError("range must be set");if(!ee)throw new TypeError("message must be set");this.range=L,this.message=ee,this.severity=Ee}toJSON(){return{severity:x[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(L,ee){return L===ee?!0:!L||!ee?!1:L.message===ee.message&&L.severity===ee.severity&&L.code===ee.code&&L.severity===ee.severity&&L.source===ee.source&&L.range.isEqual(ee.range)&&(0,C.$ub)(L.tags,ee.tags)&&(0,C.$ub)(L.relatedInformation,ee.relatedInformation,Le.isEqual)}};e.$BM=ke,e.$BM=ke=Je([k],ke);let be=class{constructor(L,ee){if(!L)throw new Error("Illegal argument, contents must be defined");Array.isArray(L)?this.contents=L:this.contents=[L],this.range=ee}};e.$CM=be,e.$CM=be=Je([k],be);let me=class extends be{constructor(L,ee,Ee,Ke){super(L,ee),this.canIncreaseHover=Ee,this.canDecreaseHover=Ke}};e.$DM=me,e.$DM=me=Je([k],me);var Q;(function(j){j[j.Increase=0]="Increase",j[j.Decrease=1]="Decrease"})(Q||(e.HoverVerbosityAction=Q={}));var Y;(function(j){j[j.Text=0]="Text",j[j.Read=1]="Read",j[j.Write=2]="Write"})(Y||(e.DocumentHighlightKind=Y={}));let he=class{constructor(L,ee=Y.Text){this.range=L,this.kind=ee}toJSON(){return{range:this.range,kind:Y[this.kind]}}};e.$EM=he,e.$EM=he=Je([k],he);let ce=class{constructor(L,ee){this.uri=L,this.highlights=ee}toJSON(){return{uri:this.uri,highlights:this.highlights.map(L=>L.toJSON())}}};e.$FM=ce,e.$FM=ce=Je([k],ce);var Te;(function(j){j[j.File=0]="File",j[j.Module=1]="Module",j[j.Namespace=2]="Namespace",j[j.Package=3]="Package",j[j.Class=4]="Class",j[j.Method=5]="Method",j[j.Property=6]="Property",j[j.Field=7]="Field",j[j.Constructor=8]="Constructor",j[j.Enum=9]="Enum",j[j.Interface=10]="Interface",j[j.Function=11]="Function",j[j.Variable=12]="Variable",j[j.Constant=13]="Constant",j[j.String=14]="String",j[j.Number=15]="Number",j[j.Boolean=16]="Boolean",j[j.Array=17]="Array",j[j.Object=18]="Object",j[j.Key=19]="Key",j[j.Null=20]="Null",j[j.EnumMember=21]="EnumMember",j[j.Struct=22]="Struct",j[j.Event=23]="Event",j[j.Operator=24]="Operator",j[j.TypeParameter=25]="TypeParameter"})(Te||(e.SymbolKind=Te={}));var fe;(function(j){j[j.Deprecated=1]="Deprecated"})(fe||(e.SymbolTag=fe={}));let Pe=b=class{static validate(L){if(!L.name)throw new Error("name must not be falsy")}constructor(L,ee,Ee,Ke,Ye){this.name=L,this.kind=ee,this.containerName=Ye,typeof Ee=="string"&&(this.containerName=Ee),Ke instanceof ve?this.location=Ke:Ee instanceof q&&(this.location=new ve(Ke,Ee)),b.validate(this)}toJSON(){return{name:this.name,kind:Te[this.kind],location:this.location,containerName:this.containerName}}};e.$GM=Pe,e.$GM=Pe=b=Je([k],Pe);let Re=a=class{static validate(L){if(!L.name)throw new Error("name must not be falsy");if(!L.range.contains(L.selectionRange))throw new Error("selectionRange must be contained in fullRange");L.children?.forEach(a.validate)}constructor(L,ee,Ee,Ke,Ye){this.name=L,this.detail=ee,this.kind=Ee,this.range=Ke,this.selectionRange=Ye,this.children=[],a.validate(this)}};e.$HM=Re,e.$HM=Re=a=Je([k],Re);var je;(function(j){j[j.Invoke=1]="Invoke",j[j.Automatic=2]="Automatic"})(je||(e.CodeActionTriggerKind=je={}));let B=class{constructor(L,ee){this.title=L,this.kind=ee}};e.$IM=B,e.$IM=B=Je([k],B);let F=class{static{l=this}static{this.c="."}constructor(L){this.value=L}append(L){return new l(this.value?this.value+l.c+L:L)}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+l.c)}};e.$JM=F,e.$JM=F=l=Je([k],F),F.Empty=new F(""),F.QuickFix=F.Empty.append("quickfix"),F.Refactor=F.Empty.append("refactor"),F.RefactorExtract=F.Refactor.append("extract"),F.RefactorInline=F.Refactor.append("inline"),F.RefactorMove=F.Refactor.append("move"),F.RefactorRewrite=F.Refactor.append("rewrite"),F.Source=F.Empty.append("source"),F.SourceOrganizeImports=F.Source.append("organizeImports"),F.SourceFixAll=F.Source.append("fixAll"),F.Notebook=F.Empty.append("notebook");let H=class{constructor(L,ee){if(this.range=L,this.parent=ee,ee&&!ee.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};e.$KM=H,e.$KM=H=Je([k],H);class G{constructor(L,ee,Ee,Ke,Ye,lt){this.kind=L,this.name=ee,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$LM=G;class te{constructor(L,ee){this.fromRanges=ee,this.from=L}}e.$MM=te;class re{constructor(L,ee){this.fromRanges=ee,this.to=L}}e.$NM=re;var Oe;(function(j){j[j.Information=0]="Information",j[j.Warning=1]="Warning",j[j.Error=2]="Error"})(Oe||(e.LanguageStatusSeverity=Oe={}));let Be=class{constructor(L,ee){this.range=L,this.command=ee}get isResolved(){return!!this.command}};e.$OM=Be,e.$OM=Be=Je([k],Be);let Ge=g=class{#e;static isMarkdownString(L){return L instanceof g?!0:L&&L.appendCodeblock&&L.appendMarkdown&&L.appendText&&L.value!==void 0}constructor(L,ee=!1){this.#e=new M.$Vk(L,{supportThemeIcons:ee})}get value(){return this.#e.value}set value(L){this.#e.value=L}get isTrusted(){return this.#e.isTrusted}set isTrusted(L){this.#e.isTrusted=L}get supportThemeIcons(){return this.#e.supportThemeIcons}set supportThemeIcons(L){this.#e.supportThemeIcons=L}get supportHtml(){return this.#e.supportHtml}set supportHtml(L){this.#e.supportHtml=L}get baseUri(){return this.#e.baseUri}set baseUri(L){this.#e.baseUri=L}appendText(L){return this.#e.appendText(L),this}appendMarkdown(L){return this.#e.appendMarkdown(L),this}appendCodeblock(L,ee){return this.#e.appendCodeblock(ee??"",L),this}};e.$PM=Ge,e.$PM=Ge=g=Je([k],Ge);let _e=class{constructor(L,ee){this.label=L,this.documentation=ee}};e.$QM=_e,e.$QM=_e=Je([k],_e);let xe=class{constructor(L,ee){this.label=L,this.documentation=ee,this.parameters=[]}};e.$RM=xe,e.$RM=xe=Je([k],xe);let et=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};e.$SM=et,e.$SM=et=Je([k],et);var tt;(function(j){j[j.Invoke=1]="Invoke",j[j.TriggerCharacter=2]="TriggerCharacter",j[j.ContentChange=3]="ContentChange"})(tt||(e.SignatureHelpTriggerKind=tt={}));var it;(function(j){j[j.Type=1]="Type",j[j.Parameter=2]="Parameter"})(it||(e.InlayHintKind=it={}));let at=class{constructor(L){this.value=L}};e.$TM=at,e.$TM=at=Je([k],at);let gt=class{constructor(L,ee,Ee){this.position=L,this.label=ee,this.kind=Ee}};e.$UM=gt,e.$UM=gt=Je([k],gt);var Ue;(function(j){j[j.Invoke=0]="Invoke",j[j.TriggerCharacter=1]="TriggerCharacter",j[j.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(Ue||(e.CompletionTriggerKind=Ue={}));var rt;(function(j){j[j.Text=0]="Text",j[j.Method=1]="Method",j[j.Function=2]="Function",j[j.Constructor=3]="Constructor",j[j.Field=4]="Field",j[j.Variable=5]="Variable",j[j.Class=6]="Class",j[j.Interface=7]="Interface",j[j.Module=8]="Module",j[j.Property=9]="Property",j[j.Unit=10]="Unit",j[j.Value=11]="Value",j[j.Enum=12]="Enum",j[j.Keyword=13]="Keyword",j[j.Snippet=14]="Snippet",j[j.Color=15]="Color",j[j.File=16]="File",j[j.Reference=17]="Reference",j[j.Folder=18]="Folder",j[j.EnumMember=19]="EnumMember",j[j.Constant=20]="Constant",j[j.Struct=21]="Struct",j[j.Event=22]="Event",j[j.Operator=23]="Operator",j[j.TypeParameter=24]="TypeParameter",j[j.User=25]="User",j[j.Issue=26]="Issue"})(rt||(e.CompletionItemKind=rt={}));var Z;(function(j){j[j.Deprecated=1]="Deprecated"})(Z||(e.CompletionItemTag=Z={}));let X=class{constructor(L,ee){this.label=L,this.kind=ee}toJSON(){return{label:this.label,kind:this.kind&&rt[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};e.$VM=X,e.$VM=X=Je([k],X);let $e=class{constructor(L=[],ee=!1){this.items=L,this.isIncomplete=ee}};e.$WM=$e,e.$WM=$e=Je([k],$e);let He=class{constructor(L,ee,Ee){this.insertText=L,this.range=ee,this.command=Ee}};e.$XM=He,e.$XM=He=Je([k],He);let we=class{constructor(L){this.commands=void 0,this.suppressSuggestions=void 0,this.items=L}};e.$YM=we,e.$YM=we=Je([k],we);var st;(function(j){j[j.Unknown=0]="Unknown",j[j.Word=1]="Word",j[j.Line=2]="Line",j[j.Suggest=3]="Suggest"})(st||(e.PartialAcceptTriggerKind=st={}));var dt;(function(j){j[j.Active=-1]="Active",j[j.Beside=-2]="Beside",j[j.One=1]="One",j[j.Two=2]="Two",j[j.Three=3]="Three",j[j.Four=4]="Four",j[j.Five=5]="Five",j[j.Six=6]="Six",j[j.Seven=7]="Seven",j[j.Eight=8]="Eight",j[j.Nine=9]="Nine"})(dt||(e.ViewColumn=dt={}));var Ct;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(Ct||(e.StatusBarAlignment=Ct={}));function Vt(j,L){return`${S.$Tm.toKey(j)}.${L}`}var Qt;(function(j){j[j.Off=0]="Off",j[j.On=1]="On",j[j.Relative=2]="Relative",j[j.Interval=3]="Interval"})(Qt||(e.TextEditorLineNumbersStyle=Qt={}));var ii;(function(j){j[j.Manual=1]="Manual",j[j.AfterDelay=2]="AfterDelay",j[j.FocusOut=3]="FocusOut"})(ii||(e.TextDocumentSaveReason=ii={}));var Xt;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(Xt||(e.TextEditorRevealType=Xt={}));var Et;(function(j){j[j.Keyboard=1]="Keyboard",j[j.Mouse=2]="Mouse",j[j.Command=3]="Command"})(Et||(e.TextEditorSelectionChangeKind=Et={}));var Zt;(function(j){j[j.Undo=1]="Undo",j[j.Redo=2]="Redo"})(Zt||(e.TextDocumentChangeReason=Zt={}));var Yt;(function(j){j[j.OpenOpen=0]="OpenOpen",j[j.ClosedClosed=1]="ClosedClosed",j[j.OpenClosed=2]="OpenClosed",j[j.ClosedOpen=3]="ClosedOpen"})(Yt||(e.DecorationRangeBehavior=Yt={})),function(j){function L(ee){switch(ee){case"keyboard":return j.Keyboard;case"mouse":return j.Mouse;case"api":return j.Command}}j.fromValue=L}(Et||(e.TextEditorSelectionChangeKind=Et={}));var Ze;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(Ze||(e.SyntaxTokenType=Ze={})),function(j){function L(ee){switch(ee){case j.Other:return"other";case j.Comment:return"comment";case j.String:return"string";case j.RegEx:return"regex"}return"other"}j.toString=L}(Ze||(e.SyntaxTokenType=Ze={}));let si=class{constructor(L,ee){if(ee&&!D.URI.isUri(ee))throw(0,N.$7)("target");if(!q.isRange(L)||L.isEmpty)throw(0,N.$7)("range");this.range=L,this.target=ee}};e.$1M=si,e.$1M=si=Je([k],si);let Gt=class{constructor(L,ee,Ee,Ke){this.red=L,this.green=ee,this.blue=Ee,this.alpha=Ke}};e.$2M=Gt,e.$2M=Gt=Je([k],Gt);let ht=class{constructor(L,ee){if(ee&&!(ee instanceof Gt))throw(0,N.$7)("color");if(!q.isRange(L)||L.isEmpty)throw(0,N.$7)("range");this.range=L,this.color=ee}};e.$3M=ht,e.$3M=ht=Je([k],ht);let mt=class{constructor(L){if(!L||typeof L!="string")throw(0,N.$7)("label");this.label=L}};e.$4M=mt,e.$4M=mt=Je([k],mt);var xt;(function(j){j[j.RGB=0]="RGB",j[j.HEX=1]="HEX",j[j.HSL=2]="HSL"})(xt||(e.ColorFormat=xt={}));var Kt;(function(j){j[j.Error=0]="Error",j[j.Warning=1]="Warning",j[j.Information=2]="Information"})(Kt||(e.SourceControlInputBoxValidationType=Kt={}));var Tt;(function(j){j[j.Unknown=0]="Unknown",j[j.Shutdown=1]="Shutdown",j[j.Process=2]="Process",j[j.User=3]="User",j[j.Extension=4]="Extension"})(Tt||(e.TerminalExitReason=Tt={}));var ft;(function(j){j[j.Low=0]="Low",j[j.Medium=1]="Medium",j[j.High=2]="High"})(ft||(e.TerminalShellExecutionCommandLineConfidence=ft={}));class Bt{constructor(L,ee,Ee){if(this.startIndex=L,this.length=ee,this.tooltip=Ee,typeof L!="number"||L<0)throw(0,N.$7)("startIndex");if(typeof ee!="number"||ee<1)throw(0,N.$7)("length");if(Ee!==void 0&&typeof Ee!="string")throw(0,N.$7)("tooltip")}}e.$5M=Bt;class _t{constructor(L){this.uri=L}}e.$6M=_t;class zt{constructor(L){this.terminalCommand=L}}e.$7M=zt;var Qe;(function(j){j[j.Panel=1]="Panel",j[j.Editor=2]="Editor"})(Qe||(e.TerminalLocation=Qe={}));class ui{constructor(L){if(this.options=L,typeof L!="object")throw(0,N.$7)("options")}}e.$8M=ui;var Jt;(function(j){j[j.Always=1]="Always",j[j.Silent=2]="Silent",j[j.Never=3]="Never"})(Jt||(e.TaskRevealKind=Jt={}));var Ut;(function(j){j[j.Shared=1]="Shared",j[j.Dedicated=2]="Dedicated",j[j.New=3]="New"})(Ut||(e.TaskPanelKind=Ut={}));let bt=class{static{$=this}static{this.Clean=new $("clean","Clean")}static{this.Build=new $("build","Build")}static{this.Rebuild=new $("rebuild","Rebuild")}static{this.Test=new $("test","Test")}static from(L){switch(L){case"clean":return $.Clean;case"build":return $.Build;case"rebuild":return $.Rebuild;case"test":return $.Test;default:return}}constructor(L,ee){if(this.label=ee,typeof L!="string"||typeof ee!="string")throw(0,N.$7)("name");this.c=L}get id(){return this.c}};e.$9M=bt,e.$9M=bt=$=Je([k],bt);function jt(j){let L="";for(let ee=0;ee<j.length;ee++)L+=j[ee].replace(/,/g,",,")+",";return L}let Mt=class{constructor(L,ee,Ee){if(typeof L!="string")throw(0,N.$7)("process");this.e=[],this.c=L,ee!==void 0&&(Array.isArray(ee)?(this.e=ee,this.f=Ee):this.f=ee)}get process(){return this.c}set process(L){if(typeof L!="string")throw(0,N.$7)("process");this.c=L}get args(){return this.e}set args(L){Array.isArray(L)||(L=[]),this.e=L}get options(){return this.f}set options(L){this.f=L}computeId(){const L=[];if(L.push("process"),this.c!==void 0&&L.push(this.c),this.e&&this.e.length>0)for(const ee of this.e)L.push(ee);return jt(L)}};e.$0M=Mt,e.$0M=Mt=Je([k],Mt);let At=class{constructor(L,ee,Ee){if(this.f=[],Array.isArray(ee)){if(!L)throw(0,N.$7)("command can't be undefined or null");if(typeof L!="string"&&typeof L.value!="string")throw(0,N.$7)("command");this.e=L,this.f=ee,this.g=Ee}else{if(typeof L!="string")throw(0,N.$7)("commandLine");this.c=L,this.g=ee}}get commandLine(){return this.c}set commandLine(L){if(typeof L!="string")throw(0,N.$7)("commandLine");this.c=L}get command(){return this.e?this.e:""}set command(L){if(typeof L!="string"&&typeof L.value!="string")throw(0,N.$7)("command");this.e=L}get args(){return this.f}set args(L){this.f=L||[]}get options(){return this.g}set options(L){this.g=L}computeId(){const L=[];if(L.push("shell"),this.c!==void 0&&L.push(this.c),this.e!==void 0&&L.push(typeof this.e=="string"?this.e:this.e.value),this.f&&this.f.length>0)for(const ee of this.f)L.push(typeof ee=="string"?ee:ee.value);return jt(L)}};e.$$M=At,e.$$M=At=Je([k],At);var ei;(function(j){j[j.Escape=1]="Escape",j[j.Strong=2]="Strong",j[j.Weak=3]="Weak"})(ei||(e.ShellQuoting=ei={}));var Wt;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace"})(Wt||(e.TaskScope=Wt={}));class oi{constructor(L){this.c=L}computeId(){return"customExecution"+(0,O.$Ug)()}set callback(L){this.c=L}get callback(){return this.c}}e.$_M=oi;let Nt=class{static{v=this}static{this.c="customExecution"}static{this.e="process"}static{this.f="shell"}static{this.g="$empty"}constructor(L,ee,Ee,Ke,Ye,lt){this.k=!1,this.l=this.definition=L;let pt;typeof ee=="string"?(this.o=this.name=ee,this.w=this.source=Ee,this.execution=Ke,pt=Ye,this.k=!0):ee===Wt.Global||ee===Wt.Workspace?(this.target=ee,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,pt=lt):(this.target=ee,this.o=this.name=Ee,this.w=this.source=Ke,this.execution=Ye,pt=lt),typeof pt=="string"?(this.r=[pt],this.t=!0):Array.isArray(pt)?(this.r=pt,this.t=!0):(this.r=[],this.t=!1),this.u=!1,this.y=Object.create(null),this.z=Object.create(null)}get _id(){return this.j}set _id(L){this.j=L}get _deprecated(){return this.k}B(){this.j!==void 0&&(this.j=void 0,this.m=void 0,this.C())}C(){this.q instanceof Mt?this.l={type:v.e,id:this.q.computeId()}:this.q instanceof At?this.l={type:v.f,id:this.q.computeId()}:this.q instanceof oi?this.l={type:v.c,id:this.q.computeId()}:this.l={type:v.g,id:(0,O.$Ug)()}}get definition(){return this.l}set definition(L){if(L==null)throw(0,N.$7)("Kind can't be undefined or null");this.B(),this.l=L}get scope(){return this.m}set target(L){this.B(),this.m=L}get name(){return this.o}set name(L){if(typeof L!="string")throw(0,N.$7)("name");this.B(),this.o=L}get execution(){return this.q}set execution(L){L===null&&(L=void 0),this.B(),this.q=L;const ee=this.l.type;(v.g===ee||v.e===ee||v.f===ee||v.c===ee)&&this.C()}get problemMatchers(){return this.r}set problemMatchers(L){if(Array.isArray(L))this.B(),this.r=L,this.t=!0;else{this.B(),this.r=[],this.t=!1;return}}get hasDefinedMatchers(){return this.t}get isBackground(){return this.u}set isBackground(L){L!==!0&&L!==!1&&(L=!1),this.B(),this.u=L}get source(){return this.w}set source(L){if(typeof L!="string"||L.length===0)throw(0,N.$7)("source must be a string of length > 0");this.B(),this.w=L}get group(){return this.x}set group(L){L===null&&(L=void 0),this.B(),this.x=L}get detail(){return this.A}set detail(L){L===null&&(L=void 0),this.A=L}get presentationOptions(){return this.y}set presentationOptions(L){L==null&&(L=Object.create(null)),this.B(),this.y=L}get runOptions(){return this.z}set runOptions(L){L==null&&(L=Object.create(null)),this.B(),this.z=L}};e.$aN=Nt,e.$aN=Nt=v=Je([k],Nt);var qt;(function(j){j[j.SourceControl=1]="SourceControl",j[j.Window=10]="Window",j[j.Notification=15]="Notification"})(qt||(e.ProgressLocation=qt={}));var Rt;(function(j){function L(ee){const Ee=ee;return(0,m.$cg)(Ee.value)?Ee.tooltip&&!(0,m.$$f)(Ee.tooltip)?(console.log("INVALID view badge, invalid tooltip",Ee.tooltip),!1):!0:(console.log("INVALID view badge, invalid value",Ee.value),!1)}j.isViewBadge=L})(Rt||(e.ViewBadge=Rt={}));let St=y=class{static isTreeItem(L,ee){const Ee=L;if(Ee.checkboxState!==void 0){const Ke=(0,m.$cg)(Ee.checkboxState)?Ee.checkboxState:(0,m.$ag)(Ee.checkboxState)&&(0,m.$cg)(Ee.checkboxState.state)?Ee.checkboxState.state:void 0,Ye=!(0,m.$cg)(Ee.checkboxState)&&(0,m.$ag)(Ee.checkboxState)?Ee.checkboxState.tooltip:void 0;if(Ke===void 0||Ke!==Dt.Checked&&Ke!==Dt.Unchecked||Ye!==void 0&&!(0,m.$$f)(Ye))return console.log("INVALID tree item, invalid checkboxState",Ee.checkboxState),!1}if(L instanceof y)return!0;if(Ee.label!==void 0&&!(0,m.$$f)(Ee.label)&&!Ee.label?.label)return console.log("INVALID tree item, invalid label",Ee.label),!1;if(Ee.id!==void 0&&!(0,m.$$f)(Ee.id))return console.log("INVALID tree item, invalid id",Ee.id),!1;if(Ee.iconPath!==void 0&&!(0,m.$$f)(Ee.iconPath)&&!D.URI.isUri(Ee.iconPath)&&(!Ee.iconPath||!(0,m.$$f)(Ee.iconPath.id))){const Ke=Ee.iconPath;if(!Ke||!(0,m.$$f)(Ke.light)&&!D.URI.isUri(Ke.light)&&!(0,m.$$f)(Ke.dark)&&!D.URI.isUri(Ke.dark))return console.log("INVALID tree item, invalid iconPath",Ee.iconPath),!1}return Ee.description!==void 0&&!(0,m.$$f)(Ee.description)&&typeof Ee.description!="boolean"?(console.log("INVALID tree item, invalid description",Ee.description),!1):Ee.resourceUri!==void 0&&!D.URI.isUri(Ee.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",Ee.resourceUri),!1):Ee.tooltip!==void 0&&!(0,m.$$f)(Ee.tooltip)&&!(Ee.tooltip instanceof Ge)?(console.log("INVALID tree item, invalid tooltip",Ee.tooltip),!1):Ee.command!==void 0&&!Ee.command.command?(console.log("INVALID tree item, invalid command",Ee.command),!1):Ee.collapsibleState!==void 0&&Ee.collapsibleState<$t.None&&Ee.collapsibleState>$t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",Ee.collapsibleState),!1):Ee.contextValue!==void 0&&!(0,m.$$f)(Ee.contextValue)?(console.log("INVALID tree item, invalid contextValue",Ee.contextValue),!1):Ee.accessibilityInformation!==void 0&&!Ee.accessibilityInformation?.label?(console.log("INVALID tree item, invalid accessibilityInformation",Ee.accessibilityInformation),!1):!0}constructor(L,ee=$t.None){this.collapsibleState=ee,D.URI.isUri(L)?this.resourceUri=L:this.label=L}};e.$bN=St,e.$bN=St=y=Je([k],St);var $t;(function(j){j[j.None=0]="None",j[j.Collapsed=1]="Collapsed",j[j.Expanded=2]="Expanded"})($t||(e.TreeItemCollapsibleState=$t={}));var Dt;(function(j){j[j.Unchecked=0]="Unchecked",j[j.Checked=1]="Checked"})(Dt||(e.TreeItemCheckboxState=Dt={}));let ai=class{async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}constructor(L){this.value=L}};e.$cN=ai,e.$cN=ai=Je([k],ai);class kt extends ai{}e.$dN=kt;class fi extends kt{#e;constructor(L){super(""),this.#e=L}asFile(){return this.#e}}e.$eN=fi;class ni{constructor(L,ee,Ee,Ke){this.name=L,this.uri=ee,this._itemId=Ee,this.c=Ke}data(){return this.c()}}e.$fN=ni;let $i=class{#e=new Map;constructor(L){for(const[ee,Ee]of L??[]){const Ke=this.#e.get(this.#t(ee));Ke?Ke.push(Ee):this.#e.set(this.#t(ee),[Ee])}}get(L){return this.#e.get(this.#t(L))?.[0]}set(L,ee){this.#e.set(this.#t(L),[ee])}forEach(L,ee){for(const[Ee,Ke]of this.#e)for(const Ye of Ke)L.call(ee,Ye,Ee,this)}*[Symbol.iterator](){for(const[L,ee]of this.#e)for(const Ee of ee)yield[L,Ee]}#t(L){return L.toLowerCase()}};e.$gN=$i,e.$gN=$i=Je([k],$i);let li=class{constructor(L,ee,Ee){this.insertText=L,this.title=ee,this.kind=Ee}};e.$hN=li,e.$hN=li=Je([k],li);var wi;(function(j){j[j.Automatic=0]="Automatic",j[j.PasteAs=1]="PasteAs"})(wi||(e.DocumentPasteTriggerKind=wi={}));class It{static{this.c="."}constructor(L){this.value=L}append(...L){return new It((this.value?[this.value,...L]:L).join(It.c))}intersects(L){return this.contains(L)||L.contains(this)}contains(L){return this.value===L.value||L.value.startsWith(this.value+It.c)}}e.$iN=It,It.Empty=new It("");class Ei{constructor(L,ee,Ee){this.title=ee,this.insertText=L,this.kind=Ee}}e.$jN=Ei;let ri=class{constructor(L,ee){this.id=L,this.color=ee}static isThemeIcon(L){return typeof L.id!="string"?(console.log("INVALID ThemeIcon, invalid id",L.id),!1):!0}};e.$kN=ri,e.$kN=ri=Je([k],ri),ri.File=new ri("file"),ri.Folder=new ri("folder");let pe=class{constructor(L){this.id=L}};e.$lN=pe,e.$lN=pe=Je([k],pe);var Ae;(function(j){j[j.Global=1]="Global",j[j.Workspace=2]="Workspace",j[j.WorkspaceFolder=3]="WorkspaceFolder"})(Ae||(e.ConfigurationTarget=Ae={}));let ae=class{get base(){return this.c}set base(L){this.c=L,this.e=D.URI.file(L)}get baseUri(){return this.e}set baseUri(L){this.e=L,this.c=L.fsPath}constructor(L,ee){if(typeof L!="string"&&(!L||!D.URI.isUri(L)&&!D.URI.isUri(L.uri)))throw(0,N.$7)("base");if(typeof ee!="string")throw(0,N.$7)("pattern");typeof L=="string"?this.baseUri=D.URI.file(L):D.URI.isUri(L)?this.baseUri=L:this.baseUri=L.uri,this.pattern=ee}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};e.$mN=ae,e.$mN=ae=Je([k],ae);const J=new WeakMap;function Me(j,L){J.set(j,L)}let Ve=class{constructor(L,ee,Ee,Ke,Ye){this.enabled=typeof L=="boolean"?L:!0,typeof ee=="string"&&(this.condition=ee),typeof Ee=="string"&&(this.hitCondition=Ee),typeof Ke=="string"&&(this.logMessage=Ke),typeof Ye=="string"&&(this.mode=Ye)}get id(){return this.c||(this.c=J.get(this)??(0,O.$Ug)()),this.c}};e.$oN=Ve,e.$oN=Ve=Je([k],Ve);let Xe=class extends Ve{constructor(L,ee,Ee,Ke,Ye,lt){if(super(ee,Ee,Ke,Ye,lt),L===null)throw(0,N.$7)("location");this.location=L}};e.$pN=Xe,e.$pN=Xe=Je([k],Xe);let qe=class extends Ve{constructor(L,ee,Ee,Ke,Ye,lt){super(ee,Ee,Ke,Ye,lt),this.functionName=L}};e.$qN=qe,e.$qN=qe=Je([k],qe);let ut=class extends Ve{constructor(L,ee,Ee,Ke,Ye,lt,pt,Ht){if(super(Ke,Ye,lt,pt,Ht),!ee)throw(0,N.$7)("dataId");this.label=L,this.dataId=ee,this.canPersist=Ee}};e.$rN=ut,e.$rN=ut=Je([k],ut);let yt=class{constructor(L,ee,Ee){this.command=L,this.args=ee||[],this.options=Ee}};e.$sN=yt,e.$sN=yt=Je([k],yt);let Lt=class{constructor(L,ee){this.port=L,this.host=ee}};e.$tN=Lt,e.$tN=Lt=Je([k],Lt);let ct=class{constructor(L){this.path=L}};e.$uN=ct,e.$uN=ct=Je([k],ct);let Ot=class{constructor(L){this.implementation=L}};e.$vN=Ot,e.$vN=Ot=Je([k],Ot);class Ft{constructor(L,ee,Ee){this.session=L,this.threadId=ee,this.frameId=Ee}}e.$wN=Ft;class Di{constructor(L,ee){this.session=L,this.threadId=ee}}e.$xN=Di;let Ii=class{constructor(L,ee){this.range=L,this.expression=ee}};e.$yN=Ii,e.$yN=Ii=Je([k],Ii);var Ji;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Ji||(e.InlineCompletionTriggerKind=Ji={}));let Ni=class{constructor(L,ee){this.range=L,this.text=ee}};e.$zN=Ni,e.$zN=Ni=Je([k],Ni);let Oi=class{constructor(L,ee,Ee=!0){this.range=L,this.variableName=ee,this.caseSensitiveLookup=Ee}};e.$AN=Oi,e.$AN=Oi=Je([k],Oi);let Ci=class{constructor(L,ee){this.range=L,this.expression=ee}};e.$BN=Ci,e.$BN=Ci=Je([k],Ci);let Ti=class{constructor(L,ee){this.frameId=L,this.stoppedLocation=ee}};e.$CN=Ti,e.$CN=Ti=Je([k],Ti);var Li;(function(j){j[j.AIGenerated=1]="AIGenerated"})(Li||(e.NewSymbolNameTag=Li={}));var Qi;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Qi||(e.NewSymbolNameTriggerKind=Qi={}));class Fi{constructor(L,ee){this.newSymbolName=L,this.tags=ee}}e.$DN=Fi;var Pi;(function(j){j[j.Changed=1]="Changed",j[j.Created=2]="Created",j[j.Deleted=3]="Deleted"})(Pi||(e.FileChangeType=Pi={}));let zi=h=class extends Error{static FileExists(L){return new h(L,d.FileSystemProviderErrorCode.FileExists,h.FileExists)}static FileNotFound(L){return new h(L,d.FileSystemProviderErrorCode.FileNotFound,h.FileNotFound)}static FileNotADirectory(L){return new h(L,d.FileSystemProviderErrorCode.FileNotADirectory,h.FileNotADirectory)}static FileIsADirectory(L){return new h(L,d.FileSystemProviderErrorCode.FileIsADirectory,h.FileIsADirectory)}static NoPermissions(L){return new h(L,d.FileSystemProviderErrorCode.NoPermissions,h.NoPermissions)}static Unavailable(L){return new h(L,d.FileSystemProviderErrorCode.Unavailable,h.Unavailable)}constructor(L,ee=d.FileSystemProviderErrorCode.Unknown,Ee){super(D.URI.isUri(L)?L.toString(!0):L),this.code=Ee?.name??"Unknown",(0,d.$hl)(this,ee),Object.setPrototypeOf(this,h.prototype),typeof Error.captureStackTrace=="function"&&typeof Ee=="function"&&Error.captureStackTrace(this,Ee)}};e.$EN=zi,e.$EN=zi=h=Je([k],zi);let Ui=class{constructor(L,ee,Ee){this.start=L,this.end=ee,this.kind=Ee}};e.$FN=Ui,e.$FN=Ui=Je([k],Ui);var vi;(function(j){j[j.Comment=1]="Comment",j[j.Imports=2]="Imports",j[j.Region=3]="Region"})(vi||(e.FoldingRangeKind=vi={}));var Xi;(function(j){j[j.Collapsed=0]="Collapsed",j[j.Expanded=1]="Expanded"})(Xi||(e.CommentThreadCollapsibleState=Xi={}));var Zi;(function(j){j[j.Editing=0]="Editing",j[j.Preview=1]="Preview"})(Zi||(e.CommentMode=Zi={}));var Mi;(function(j){j[j.Published=0]="Published",j[j.Draft=1]="Draft"})(Mi||(e.CommentState=Mi={}));var Yi;(function(j){j[j.Unresolved=0]="Unresolved",j[j.Resolved=1]="Resolved"})(Yi||(e.CommentThreadState=Yi={}));var ji;(function(j){j[j.Current=0]="Current",j[j.Outdated=1]="Outdated"})(ji||(e.CommentThreadApplicability=ji={}));class gn{constructor(L,ee=[]){this.tokenTypes=L,this.tokenModifiers=ee}}e.$GN=gn;function xi(j){return typeof j>"u"||(0,m.$_f)(j)}class Bi{constructor(L){if(this.c=0,this.e=0,this.f=!0,this.g=[],this.j=0,this.k=new Map,this.l=new Map,this.m=!1,L){this.m=!0;for(let ee=0,Ee=L.tokenTypes.length;ee<Ee;ee++)this.k.set(L.tokenTypes[ee],ee);for(let ee=0,Ee=L.tokenModifiers.length;ee<Ee;ee++)this.l.set(L.tokenModifiers[ee],ee)}}push(L,ee,Ee,Ke,Ye){if(typeof L=="number"&&typeof ee=="number"&&typeof Ee=="number"&&typeof Ke=="number"&&(typeof Ye=="number"||typeof Ye>"u"))return typeof Ye>"u"&&(Ye=0),this.q(L,ee,Ee,Ke,Ye);if(q.isRange(L)&&typeof ee=="string"&&xi(Ee))return this.o(L,ee,Ee);throw(0,N.$7)()}o(L,ee,Ee){if(!this.m)throw new Error("Legend must be provided in constructor");if(L.start.line!==L.end.line)throw new Error("`range` cannot span multiple lines");if(!this.k.has(ee))throw new Error("`tokenType` is not in the provided legend");const Ke=L.start.line,Ye=L.start.character,lt=L.end.character-L.start.character,pt=this.k.get(ee);let Ht=0;if(Ee)for(const ci of Ee){if(!this.l.has(ci))throw new Error("`tokenModifier` is not in the provided legend");const di=this.l.get(ci);Ht|=1<<di>>>0}this.q(Ke,Ye,lt,pt,Ht)}q(L,ee,Ee,Ke,Ye){if(this.f&&(L<this.c||L===this.c&&ee<this.e)){this.f=!1;const Ht=this.g.length/5|0;let ci=0,di=0;for(let mi=0;mi<Ht;mi++){let bi=this.g[5*mi],Gi=this.g[5*mi+1];bi===0?(bi=ci,Gi+=di):bi+=ci,this.g[5*mi]=bi,this.g[5*mi+1]=Gi,ci=bi,di=Gi}}let lt=L,pt=ee;this.f&&this.j>0&&(lt-=this.c,lt===0&&(pt-=this.e)),this.g[this.j++]=lt,this.g[this.j++]=pt,this.g[this.j++]=Ee,this.g[this.j++]=Ke,this.g[this.j++]=Ye,this.c=L,this.e=ee}static r(L){const ee=[],Ee=L.length/5|0;for(let pt=0;pt<Ee;pt++)ee[pt]=pt;ee.sort((pt,Ht)=>{const ci=L[5*pt],di=L[5*Ht];if(ci===di){const mi=L[5*pt+1],bi=L[5*Ht+1];return mi-bi}return ci-di});const Ke=new Uint32Array(L.length);let Ye=0,lt=0;for(let pt=0;pt<Ee;pt++){const Ht=5*ee[pt],ci=L[Ht+0],di=L[Ht+1],mi=L[Ht+2],bi=L[Ht+3],Gi=L[Ht+4],zn=ci-Ye,br=zn===0?di-lt:di,Ki=5*pt;Ke[Ki+0]=zn,Ke[Ki+1]=br,Ke[Ki+2]=mi,Ke[Ki+3]=bi,Ke[Ki+4]=Gi,Ye=ci,lt=di}return Ke}build(L){return this.f?new pi(new Uint32Array(this.g),L):new pi(Bi.r(this.g),L)}}e.$HN=Bi;class pi{constructor(L,ee){this.resultId=ee,this.data=L}}e.$IN=pi;class mn{constructor(L,ee,Ee){this.start=L,this.deleteCount=ee,this.data=Ee}}e.$JN=mn;class $n{constructor(L,ee){this.resultId=ee,this.edits=L}}e.$KN=$n;var _i;(function(j){j[j.Separate=0]="Separate",j[j.MergeWithParent=1]="MergeWithParent"})(_i||(e.DebugConsoleMode=_i={}));class Vi{constructor(L){this.name=L}}e.$LN=Vi;let Ri=class{static{this.Back={iconPath:new ri("arrow-left")}}constructor(){}};e.$MN=Ri,e.$MN=Ri=Je([k],Ri);var ze;(function(j){j[j.Separator=-1]="Separator",j[j.Default=0]="Default"})(ze||(e.QuickPickItemKind=ze={}));var hi;(function(j){j[j.Info=1]="Info",j[j.Warning=2]="Warning",j[j.Error=3]="Error"})(hi||(e.InputBoxValidationSeverity=hi={}));var Wi;(function(j){j[j.UI=1]="UI",j[j.Workspace=2]="Workspace"})(Wi||(e.ExtensionKind=Wi={}));class nt{static validate(L){if(typeof L.badge=="string"){let ee=(0,p.$Jf)(L.badge,0);if(ee<L.badge.length&&(ee+=(0,p.$Jf)(L.badge,ee)),L.badge.length>ee)throw new Error("The 'badge'-property must be undefined or a short character")}else if(L.badge&&!ri.isThemeIcon(L.badge))throw new Error("The 'badge'-property is not a valid ThemeIcon");if(!L.color&&!L.badge&&!L.tooltip)throw new Error("The decoration is empty");return!0}constructor(L,ee,Ee){this.badge=L,this.tooltip=ee,this.color=Ee}}e.$NN=nt;let wt=class{constructor(L){this.kind=L}};e.$ON=wt,e.$ON=wt=Je([k],wt);var en;(function(j){j[j.Light=1]="Light",j[j.Dark=2]="Dark",j[j.HighContrast=3]="HighContrast",j[j.HighContrastLight=4]="HighContrastLight"})(en||(e.ColorThemeKind=en={}));class gi{static isNotebookRange(L){return L instanceof gi?!0:L?typeof L.start=="number"&&typeof L.end=="number":!1}get start(){return this.c}get end(){return this.e}get isEmpty(){return this.c===this.e}constructor(L,ee){if(L<0)throw(0,N.$7)("start must be positive");if(ee<0)throw(0,N.$7)("end must be positive");L<=ee?(this.c=L,this.e=ee):(this.c=ee,this.e=L)}with(L){let ee=this.c,Ee=this.e;return L.start!==void 0&&(ee=L.start),L.end!==void 0&&(Ee=L.end),ee===this.c&&Ee===this.e?this:new gi(ee,Ee)}}e.$PN=gi;class ki{static validate(L){if(typeof L.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof L.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof L.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(L){return Array.isArray(L)&&L.every(ee=>ki.isNotebookCellData(ee))}static isNotebookCellData(L){return!0}constructor(L,ee,Ee,Ke,Ye,lt,pt){this.kind=L,this.value=ee,this.languageId=Ee,this.mime=Ke,this.outputs=Ye??[],this.metadata=lt,this.executionSummary=pt,ki.validate(this)}}e.$QN=ki;class pn{constructor(L){this.cells=L}}e.$RN=pn;class ti{static isNotebookCellOutputItem(L){return L instanceof ti?!0:L?typeof L.mime=="string"&&L.data instanceof Uint8Array:!1}static error(L){const ee={name:L.name,message:L.message,stack:L.stack};return ti.json(ee,"application/vnd.code.notebook.error")}static stdout(L){return ti.text(L,"application/vnd.code.notebook.stdout")}static stderr(L){return ti.text(L,"application/vnd.code.notebook.stderr")}static bytes(L,ee="application/octet-stream"){return new ti(L,ee)}static#e=new TextEncoder;static text(L,ee=A.$Vs.text){const Ee=ti.#e.encode(String(L));return new ti(Ee,ee)}static json(L,ee="text/x-json"){const Ee=JSON.stringify(L,void 0,"	");return ti.text(Ee,ee)}constructor(L,ee){this.data=L,this.mime=ee;const Ee=(0,A.$Zs)(ee,!0);if(!Ee)throw new Error(`INVALID mime type: ${ee}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=Ee}}e.$SN=ti;class Ai{static isNotebookCellOutput(L){return L instanceof Ai?!0:!L||typeof L!="object"?!1:typeof L.id=="string"&&Array.isArray(L.items)}static ensureUniqueMimeTypes(L,ee=!1){const Ee=new Set,Ke=new Set;for(let Ye=0;Ye<L.length;Ye++){const lt=L[Ye],pt=(0,A.$Zs)(lt.mime);if(!Ee.has(pt)||(0,f.$hK)(pt)){Ee.add(pt);continue}Ke.add(Ye),ee&&console.warn(`DUPLICATED mime type '${lt.mime}' will be dropped`)}return Ke.size===0?L:L.filter((Ye,lt)=>!Ke.has(lt))}constructor(L,ee,Ee){this.items=Ai.ensureUniqueMimeTypes(L,!0),typeof ee=="string"?(this.id=ee,this.metadata=Ee):(this.id=(0,O.$Ug)(),this.metadata=ee??Ee)}}e.$TN=Ai;var tn;(function(j){j[j.Markup=1]="Markup",j[j.Code=2]="Code"})(tn||(e.NotebookCellKind=tn={}));var nn;(function(j){j[j.Idle=1]="Idle",j[j.Pending=2]="Pending",j[j.Executing=3]="Executing"})(nn||(e.NotebookCellExecutionState=nn={}));var qi;(function(j){j[j.Left=1]="Left",j[j.Right=2]="Right"})(qi||(e.NotebookCellStatusBarAlignment=qi={}));var rn;(function(j){j[j.Default=0]="Default",j[j.InCenter=1]="InCenter",j[j.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",j[j.AtTop=3]="AtTop"})(rn||(e.NotebookEditorRevealType=rn={}));class bn{constructor(L,ee){this.text=L,this.alignment=ee}}e.$UN=bn;var sn;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred"})(sn||(e.NotebookControllerAffinity=sn={}));var on;(function(j){j[j.Default=1]="Default",j[j.Preferred=2]="Preferred",j[j.Hidden=-1]="Hidden"})(on||(e.NotebookControllerAffinity2=on={}));class wn{constructor(L,ee=[]){this.uri=L,this.provides=(0,C.$2b)(ee)}}e.$VN=wn;class vn{constructor(L){this.label=L}}e.$WN=vn;var an;(function(j){j[j.Named=1]="Named",j[j.Indexed=2]="Indexed"})(an||(e.NotebookVariablesRequestKind=an={}));let Hi=class{constructor(L,ee){this.label=L,this.timestamp=ee}};e.$XN=Hi,e.$XN=Hi=Je([k],Hi);var cn;(function(j){j[j.Production=1]="Production",j[j.Development=2]="Development",j[j.Test=3]="Test"})(cn||(e.ExtensionMode=cn={}));var un;(function(j){j[j.Node=1]="Node",j[j.Webworker=2]="Webworker"})(un||(e.ExtensionRuntime=un={}));var ln;(function(j){j[j.Other=0]="Other",j[j.Comment=1]="Comment",j[j.String=2]="String",j[j.RegEx=3]="RegEx"})(ln||(e.StandardTokenType=ln={}));class _{constructor(L,ee){this.ranges=L,this.wordPattern=ee}}e.$YN=_;class oe{constructor(L){this.c=L}get autoForwardAction(){return this.c}}e.$ZN=oe;var Fe;(function(j){j[j.Queued=1]="Queued",j[j.Running=2]="Running",j[j.Passed=3]="Passed",j[j.Failed=4]="Failed",j[j.Skipped=5]="Skipped",j[j.Errored=6]="Errored"})(Fe||(e.TestResultState=Fe={}));var ot;(function(j){j[j.Run=1]="Run",j[j.Debug=2]="Debug",j[j.Coverage=3]="Coverage"})(ot||(e.TestRunProfileKind=ot={}));let vt=class{constructor(L=void 0,ee=void 0,Ee=void 0,Ke=!1,Ye=!0){this.include=L,this.exclude=ee,this.profile=Ee,this.continuous=Ke,this.preserveFocus=Ye}};e.$1N=vt,e.$1N=vt=Je([k],vt);let Pt=E=class{static diff(L,ee,Ee){const Ke=new E(L);return Ke.expectedOutput=ee,Ke.actualOutput=Ee,Ke}constructor(L){this.message=L}};e.$2N=Pt,e.$2N=Pt=E=Je([k],Pt);let Si=class{constructor(L){this.id=L}};e.$3N=Si,e.$3N=Si=Je([k],Si);class hn{constructor(L,ee){this.covered=L,this.total=ee,En(this)}}e.$4N=hn;function En(j){if(j){if(j.covered>j.total)throw new Error(`The total number of covered items (${j.covered}) cannot be greater than the total (${j.total})`);if(j.total<0)throw new Error(`The number of covered items (${j.total}) cannot be negative`)}}class yn{static fromDetails(L,ee){const Ee=new hn(0,0),Ke=new hn(0,0),Ye=new hn(0,0);for(const pt of ee)if("branches"in pt){Ee.total+=1,Ee.covered+=pt.executed?1:0;for(const Ht of pt.branches)Ke.total+=1,Ke.covered+=Ht.executed?1:0}else Ye.total+=1,Ye.covered+=pt.executed?1:0;const lt=new yn(L,Ee,Ke.total>0?Ke:void 0,Ye.total>0?Ye:void 0);return lt.detailedCoverage=ee,lt}constructor(L,ee,Ee,Ke,Ye){this.uri=L,this.statementCoverage=ee,this.branchCoverage=Ee,this.declarationCoverage=Ke,this.testItem=Ye}}e.$6N=yn;class Un{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,Ee=[]){this.executed=L,this.location=ee,this.branches=Ee}}e.$7N=Un;class jn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,Ee){this.executed=L,this.location=ee,this.label=Ee}}e.$8N=jn;class Bn{get executionCount(){return+this.executed}set executionCount(L){this.executed=L}constructor(L,ee,Ee){this.name=L,this.executed=ee,this.location=Ee}}e.$9N=Bn;var Dn;(function(j){j[j.None=0]="None",j[j.Option=1]="Option",j[j.Default=2]="Default",j[j.Preferred=3]="Preferred"})(Dn||(e.ExternalUriOpenerPriority=Dn={}));var kn;(function(j){j[j.Untrusted=0]="Untrusted",j[j.Trusted=1]="Trusted",j[j.Unspecified=2]="Unspecified"})(kn||(e.WorkspaceTrustState=kn={}));var Sn;(function(j){j[j.Notify=1]="Notify",j[j.OpenBrowser=2]="OpenBrowser",j[j.OpenPreview=3]="OpenPreview",j[j.Silent=4]="Silent",j[j.Ignore=5]="Ignore",j[j.OpenBrowserOnce=6]="OpenBrowserOnce"})(Sn||(e.PortAutoForwardAction=Sn={}));class Vn{constructor(L,ee,Ee,Ke,Ye,lt){this.kind=L,this.name=ee,this.detail=Ee,this.uri=Ke,this.range=Ye,this.selectionRange=lt}}e.$0N=Vn;class Wn{constructor(L){this.uri=L}}e.$$N=Wn;class qn{constructor(L,ee){this.original=L,this.modified=ee}}e.$_N=qn;class Hn{constructor(L,ee,Ee,Ke){this.base=L,this.input1=ee,this.input2=Ee,this.result=Ke}}e.$aO=Hn;class Gn{constructor(L,ee){this.uri=L,this.viewType=ee}}e.$bO=Gn;class Kn{constructor(L){this.viewType=L}}e.$cO=Kn;class Jn{constructor(L,ee){this.uri=L,this.notebookType=ee}}e.$dO=Jn;class Qn{constructor(L,ee,Ee){this.original=L,this.modified=ee,this.notebookType=Ee}}e.$eO=Qn;class Xn{constructor(){}}e.$fO=Xn;class Zn{constructor(L,ee){this.uri=L,this.inputBoxUri=ee}}e.$gO=Zn;class Yn{constructor(){}}e.$hO=Yn;class xn{constructor(L){this.textDiffs=L}}e.$iO=xn;var In;(function(j){j[j.Down=0]="Down",j[j.Up=1]="Up"})(In||(e.InteractiveSessionVoteDirection=In={}));var Cn;(function(j){j[j.Action=1]="Action",j[j.Toolbar=2]="Toolbar"})(Cn||(e.ChatCopyKind=Cn={}));var Pn;(function(j){j[j.Short=1]="Short",j[j.Medium=2]="Medium",j[j.Full=3]="Full"})(Pn||(e.ChatVariableLevel=Pn={}));class _n{constructor(L,ee,Ee){this.id=L,this.label=ee,this.values=Ee}}e.$jO=_n;var Mn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful",j[j.Undone=2]="Undone",j[j.Accepted=3]="Accepted",j[j.Bug=4]="Bug"})(Mn||(e.InteractiveEditorResponseFeedbackKind=Mn={}));var Rn;(function(j){j[j.Unhelpful=0]="Unhelpful",j[j.Helpful=1]="Helpful"})(Rn||(e.ChatResultFeedbackKind=Rn={}));class er{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ge(L):L}}e.$kO=er;class tr{constructor(L,ee){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ge(L):L,this.vulnerabilities=ee}}e.$lO=tr;class ir{constructor(L,ee){this.participant=L,this.command=ee}}e.$mO=ir;class nr{constructor(L,ee,Ee){this.title=L,this.message=ee,this.data=Ee}}e.$nO=nr;class rr{constructor(L,ee){this.value=L,this.baseUri=ee}}e.$oO=rr;class sr{constructor(L,ee){this.value=L,this.title=ee}}e.$pO=sr;class or{constructor(L){this.value=L}}e.$qO=or;class ar{constructor(L,ee){this.value=L,this.task=ee}}e.$rO=ar;class cr{constructor(L){if(typeof L!="string"&&L.isTrusted===!0)throw new Error("The boolean form of MarkdownString.isTrusted is NOT supported for chat participants.");this.value=typeof L=="string"?new Ge(L):L}}e.$sO=cr;class ur{constructor(L){this.value=L}}e.$tO=ur;class lr{constructor(L,ee){this.value=L,this.iconPath=ee}}e.$uO=lr;class hr{constructor(L,ee){this.uri=L,this.edits=Array.isArray(ee)?ee:[ee]}}e.$vO=hr;class dr{constructor(L,ee,Ee,Ke){this.prompt=L,this.command=ee,this.references=Ee,this.participant=Ke}}e.$wO=dr;class fr{constructor(L,ee,Ee,Ke){this.response=L,this.result=ee,this.participant=Ee,this.command=Ke}}e.$xO=fr;var An;(function(j){j[j.Panel=1]="Panel",j[j.Terminal=2]="Terminal",j[j.Notebook=3]="Notebook",j[j.Editor=4]="Editor"})(An||(e.ChatLocation=An={}));var dn;(function(j){j[j.User=1]="User",j[j.Assistant=2]="Assistant",j[j.System=3]="System"})(dn||(e.LanguageModelChatMessageRole=dn={}));class fn{static User(L,ee){return new fn(dn.User,L,ee)}static Assistant(L,ee){return new fn(dn.Assistant,L,ee)}constructor(L,ee,Ee){this.role=L,this.content=ee,this.name=Ee}}e.$yO=fn;class gr{constructor(L){this.content=L}}e.$zO=gr;class mr{constructor(L,ee){this.content=L,this.name=ee}}e.$AO=mr;class $r{constructor(L,ee){this.content=L,this.name=ee}}e.$BO=$r;class yi extends Error{static NotFound(L){return new yi(L,yi.NotFound.name)}static NoPermissions(L){return new yi(L,yi.NoPermissions.name)}static Blocked(L){return new yi(L,yi.Blocked.name)}constructor(L,ee,Ee){super(L,{cause:Ee}),this.name="LanguageModelError",this.code=ee??""}}e.$CO=yi;var Nn;(function(j){j[j.SymbolInformation=1]="SymbolInformation",j[j.CommandInformation=2]="CommandInformation",j[j.SearchInformation=3]="SearchInformation",j[j.SettingInformation=4]="SettingInformation"})(Nn||(e.RelatedInformationType=Nn={}));var On;(function(j){j[j.Started=1]="Started",j[j.Recognizing=2]="Recognizing",j[j.Recognized=3]="Recognized",j[j.Stopped=4]="Stopped",j[j.Error=5]="Error"})(On||(e.SpeechToTextStatus=On={}));var Tn;(function(j){j[j.Started=1]="Started",j[j.Stopped=2]="Stopped",j[j.Error=3]="Error"})(Tn||(e.TextToSpeechStatus=Tn={}));var Ln;(function(j){j[j.Recognized=1]="Recognized",j[j.Stopped=2]="Stopped"})(Ln||(e.KeywordRecognitionStatus=Ln={}));class pr{constructor(L,ee){this.text=L,this.range=ee}}e.$DO=pr;var Fn;(function(j){j[j.Invoke=0]="Invoke",j[j.Automatic=1]="Automatic"})(Fn||(e.InlineEditTriggerKind=Fn={}))}),define(Se[258],Ie([1,0,4,7]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$7lc=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$lM.MainThreadAiRelatedInformation)}async $provideAiRelatedInformation(A,p,m){if(this.a.size===0)throw new Error("No related information providers registered");const D=this.a.get(A);if(!D)throw new Error("related information provider not found");return await D.provideRelatedInformation(p,m)??[]}getRelatedInformation(A,p,m){return this.c.$getAiRelatedInformation(p,m)}registerRelatedInformationProvider(A,p,m){const D=this.b;return this.b++,this.a.set(D,m),this.c.$registerAiRelatedInformationProvider(D,p),new N.$nM(()=>{this.c.$unregisterAiRelatedInformationProvider(D),this.a.delete(D)})}}e.$7lc=M}),define(Se[86],Ie([1,0,5,4,7,21,108,3,17]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$gmc=e.$fmc=void 0,e.$fmc=(0,p.$yi)("IExtHostAuthentication");let D=class{constructor(d){this.b=new Map,this.c=new C.$fe,this.onDidChangeSessions=this.c.event,this.d=new O,this.f=new O,this.a=d.getProxy(N.$lM.MainThreadAuthentication)}async getSession(d,w,f,o={}){const r=T.$Tm.toKey(d.identifier),s=[...f].sort().join(" ");return await this.d.getOrCreate(`${r} ${w} ${s}`,async()=>{await this.a.$ensureProvider(w);const n=d.displayName||d.name;return this.a.$getSession(w,f,r,n,o)})}async getSessions(d,w,f){const o=T.$Tm.toKey(d.identifier),r=[...f].sort().join(" ");return await this.f.getOrCreate(`${o} ${r}`,async()=>{await this.a.$ensureProvider(w);const s=d.displayName||d.name;return this.a.$getSessions(w,f,o,s)})}async removeSession(d,w){const f=this.b.get(d);return f?f.provider.removeSession(w):this.a.$removeSession(d,w)}registerAuthenticationProvider(d,w,f,o){if(this.b.get(d))throw new Error(`An authentication provider with id '${d}' is already registered.`);this.b.set(d,{label:w,provider:f,options:o??{supportsMultipleAccounts:!1}});const r=f.onDidChangeSessions(s=>this.a.$sendDidChangeSessions(d,s));return this.a.$registerAuthenticationProvider(d,w,o?.supportsMultipleAccounts??!1),new M.$nM(()=>{r.dispose(),this.b.delete(d),this.a.$unregisterAuthenticationProvider(d)})}async $createSession(d,w,f){const o=this.b.get(d);if(o)return await o.provider.createSession(w,f);throw new Error(`Unable to find authentication provider with handle: ${d}`)}async $removeSession(d,w){const f=this.b.get(d);if(f)return await f.provider.removeSession(w);throw new Error(`Unable to find authentication provider with handle: ${d}`)}async $getSessions(d,w){const f=this.b.get(d);if(f)return await f.provider.getSessions(w);throw new Error(`Unable to find authentication provider with handle: ${d}`)}$onDidChangeAuthenticationSessions(d,w){return d.startsWith(A.$nL)||this.c.fire({provider:{id:d,label:w}}),Promise.resolve()}};e.$gmc=D,e.$gmc=D=Je([We(0,m.$PO)],D);class O{constructor(){this.a=new Map}getOrCreate(d,w){const f=this.a.get(d);if(f)return f;const o=w().finally(()=>this.a.delete(d));return this.a.set(d,o),o}}}),define(Se[112],Ie([1,0,2,4,7,3,17,12,18,13,19,25]),function(le,e,C,N,M,T,A,p,m,D,O,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$gnc=e.$fnc=void 0;let w=class{static{d=this}static{this.c=0}static{this.d=250}constructor(o,r){this.h=r,this.f=new Map,this.g=o.getProxy(N.$lM.MainThreadDecorations)}registerFileDecorationProvider(o,r){const s=d.c++;this.f.set(s,{provider:o,extensionDescription:r}),this.g.$registerDecorationProvider(s,r.identifier.value);const n=o.onDidChangeFileDecorations&&o.onDidChangeFileDecorations(t=>{if(!t){this.g.$onDidChange(s,null);return}const c=(0,m.$2b)(t);if(c.length<=d.d){this.g.$onDidChange(s,c);return}this.h.warn("[Decorations] CAPPING events from decorations provider",r.identifier.value,c.length);const u=c.map(a=>({uri:a,rank:(0,D.$cf)(a.path,"/")})),i=(0,m.$zb)(u,(a,l)=>a.rank-l.rank||(0,D.$sf)(a.uri.path,l.uri.path)),b=[];e:for(const a of i){let l;for(const g of a){const $=(0,O.$mc)(g.uri.path);if(l!==$&&(l=$,b.push(g.uri)>=d.d))break e}}this.g.$onDidChange(s,b)});return new M.$nM(()=>{n?.dispose(),this.g.$unregisterDecorationProvider(s),this.f.delete(s)})}async $provideDecorations(o,r,s){if(!this.f.has(o))return Object.create(null);const n=Object.create(null),{provider:t,extensionDescription:c}=this.f.get(o);return await Promise.all(r.map(async u=>{try{const{uri:i,id:b}=u,a=await Promise.resolve(t.provideFileDecoration(C.URI.revive(i),s));if(!a)return;try{M.$NN.validate(a),a.badge&&typeof a.badge!="string"&&(0,S.$MG)(c,"codiconDecoration"),n[b]=[a.propagate,a.tooltip,a.badge,a.color]}catch(l){this.h.warn(`INVALID decoration from extension '${c.identifier.value}': ${l}`)}}catch(i){this.h.error(i)}})),n}};e.$fnc=w,e.$fnc=w=d=Je([We(0,A.$PO),We(1,p.$5j)],w),e.$gnc=(0,T.$yi)("IExtHostDecorations")}),define(Se[259],Ie([1,0,14,2,7,4,16,20,13]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$inc=void 0;class D{static{this.a=0}constructor(S,d,w){this.d=d,this.e=w,this.b=new Map,this.c=S.getProxy(T.$lM.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(S,d){if(Object.keys(A.Schemas).indexOf(S)>=0)throw new Error(`scheme '${S}' already registered`);const w=D.a++;this.b.set(w,d),this.c.$registerTextContentProvider(w,S);let f;if(typeof d.onDidChange=="function"){let o;f=d.onDidChange(async r=>{if(r.scheme!==S){this.e.warn(`Provider for scheme '${S}' is firing event for schema '${r.scheme}' which will be IGNORED`);return}if(!this.d.getDocument(r))return;o&&await o;const s=this.$provideTextDocumentContent(w,r).then(async n=>{if(!n&&typeof n!="string")return;const t=this.d.getDocument(r);if(!t)return;const c=(0,m.$mf)(n);if(!t.equalLines(c))return this.c.$onVirtualDocumentChange(r,n)}).catch(C.$1).finally(()=>{o===s&&(o=void 0)});o=s})}return new M.$nM(()=>{this.b.delete(w)&&this.c.$unregisterTextContentProvider(w),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(S,d){const w=this.b.get(S);return w?Promise.resolve(w.provideTextDocumentContent(N.URI.revive(d),p.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${d.scheme}`))}}e.$inc=D}),define(Se[113],Ie([1,0,57,16,13,313,159,7,18]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$TO=e.$SO=void 0,e.$RO=O;const D=new Map;function O(f,o){o?D.set(f,o):D.delete(f)}function S(f){return D.get(f)}class d extends T.$$v{constructor(o,r,s,n,t,c,u){super(r,s,n,t),this.c=o,this.m=c,this.q=u,this.b=!1}dispose(){(0,C.ok)(!this.b),this.b=!0,this.q=!1}equalLines(o){return(0,m.$ub)(this.f,o)}get document(){if(!this.a){const o=this;this.a={get uri(){return o.d},get fileName(){return o.d.fsPath},get isUntitled(){return o.d.scheme===N.Schemas.untitled},get languageId(){return o.m},get version(){return o.h},get isClosed(){return o.b},get isDirty(){return o.q},save(){return o.r()},getText(r){return r?o.s(r):o.getText()},get eol(){return o.g===`
`?p.EndOfLine.LF:p.EndOfLine.CRLF},get lineCount(){return o.f.length},lineAt(r){return o.t(r)},offsetAt(r){return o.u(r)},positionAt(r){return o.v(r)},validateRange(r){return o.w(r)},validatePosition(r){return o.x(r)},getWordRangeAtPosition(r,s){return o.y(r,s)}}}return Object.freeze(this.a)}_acceptLanguageId(o){(0,C.ok)(!this.b),this.m=o}_acceptIsDirty(o){(0,C.ok)(!this.b),this.q=o}r(){return this.b?Promise.reject(new Error("Document has been closed")):this.c.$trySaveDocument(this.d)}s(o){const r=this.w(o);if(r.isEmpty)return"";if(r.isSingleLine)return this.f[r.start.line].substring(r.start.character,r.end.character);const s=this.g,n=r.start.line,t=r.end.line,c=[];c.push(this.f[n].substring(r.start.character));for(let u=n+1;u<t;u++)c.push(this.f[u]);return c.push(this.f[t].substring(0,r.end.character)),c.join(s)}t(o){let r;if(o instanceof p.$oM?r=o.line:typeof o=="number"&&(r=o),typeof r!="number"||r<0||r>=this.f.length||Math.floor(r)!==r)throw new Error("Illegal value for `line`");return new w(r,this.f[r],r===this.f.length-1)}u(o){return o=this.x(o),this.l(),this.j.getPrefixSum(o.line-1)+o.character}v(o){o=Math.floor(o),o=Math.max(0,o),this.l();const r=this.j.getIndexOf(o),s=this.f[r.index].length;return new p.$oM(r.index,Math.min(r.remainder,s))}w(o){if(!(o instanceof p.$pM))throw new Error("Invalid argument");const r=this.x(o.start),s=this.x(o.end);return r===o.start&&s===o.end?o:new p.$pM(r.line,r.character,s.line,s.character)}x(o){if(!(o instanceof p.$oM))throw new Error("Invalid argument");if(this.f.length===0)return o.with(0,0);let{line:r,character:s}=o,n=!1;if(r<0)r=0,s=0,n=!0;else if(r>=this.f.length)r=this.f.length-1,s=this.f[r].length,n=!0;else{const t=this.f[r].length;s<0?(s=0,n=!0):s>t&&(s=t,n=!0)}return n?new p.$oM(r,s):o}y(o,r){const s=this.x(o);if(!r)r=S(this.m);else if((0,M.$lf)(r))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${r.source}' because it matches the empty string.`);const n=(0,A.$bt)(s.character+1,(0,A.$_s)(r),this.f[s.line],0);if(n)return new p.$pM(s.line,n.startColumn-1,s.line,n.endColumn-1)}}e.$SO=d;class w{constructor(o,r,s){this.a=o,this.b=r,this.c=s}get lineNumber(){return this.a}get text(){return this.b}get range(){return new p.$pM(this.a,0,this.a,this.b.length)}get rangeIncludingLineBreak(){return this.c?this.range:new p.$pM(this.a,0,this.a+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this.b)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this.b.length}}e.$TO=w}),define(Se[260],Ie([1,0,4,7]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lnc=void 0;class M{constructor(A){this.a=new Map,this.b=0,this.c=A.getProxy(C.$lM.MainThreadAiEmbeddingVector)}async $provideAiEmbeddingVector(A,p,m){if(this.a.size===0)throw new Error("No embedding vector providers registered");const D=this.a.get(A);if(!D)throw new Error("Embedding vector provider not found");const O=await D.provideEmbeddingVector(p,m);if(!O)throw new Error("Embedding vector provider returned undefined");return O}registerEmbeddingVectorProvider(A,p,m){const D=this.b;return this.b++,this.a.set(D,m),this.c.$registerAiEmbeddingVectorProvider(p,D),new N.$nM(()=>{this.c.$unregisterAiEmbeddingVectorProvider(D),this.a.delete(D)})}}e.$lnc=M}),define(Se[65],Ie([1,0,4,38,7,22,3,17,47,6,11,24,16]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$wmc=e.$vmc=void 0;let f=w=class{constructor(r,s){this.b=new Map,this.c=new O.$Hh,this.a=r.getProxy(C.$lM.MainThreadFileSystem);const n=this;this.value=Object.freeze({async stat(t){try{let c;const u=n.b.get(t.scheme);return u?(await n.a.$ensureActivation(t.scheme),c=await u.impl.stat(t)):c=await n.a.$stat(t),{type:c.type,ctime:c.ctime,mtime:c.mtime,size:c.size,permissions:c.permissions===N.FilePermission.Readonly?1:void 0}}catch(c){w.e(c)}},async readDirectory(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readDirectory(t)).slice()):await n.a.$readdir(t)}catch(c){return w.e(c)}},async createDirectory(t){try{const c=n.b.get(t.scheme);return c&&!c.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(c.impl,c.extUri,t)):await n.a.$mkdir(t)}catch(c){return w.e(c)}},async readFile(t){try{const c=n.b.get(t.scheme);return c?(await n.a.$ensureActivation(t.scheme),(await c.impl.readFile(t)).slice()):(await n.a.$readFile(t)).buffer}catch(c){return w.e(c)}},async writeFile(t,c){try{const u=n.b.get(t.scheme);return u&&!u.isReadonly?(await n.a.$ensureActivation(t.scheme),await n.d(u.impl,u.extUri,u.extUri.dirname(t)),await n.c.queueFor(t,()=>Promise.resolve(u.impl.writeFile(t,c,{create:!0,overwrite:!0})))):await n.a.$writeFile(t,T.$He.wrap(c))}catch(u){return w.e(u)}},async delete(t,c){try{const u=n.b.get(t.scheme);return u&&!u.isReadonly&&!c?.useTrash?(await n.a.$ensureActivation(t.scheme),await u.impl.delete(t,{recursive:!1,...c})):await n.a.$delete(t,{recursive:!1,useTrash:!1,atomic:!1,...c})}catch(u){return w.e(u)}},async rename(t,c,u){try{return await n.a.$rename(t,c,{overwrite:!1,...u})}catch(i){return w.e(i)}},async copy(t,c,u){try{return await n.a.$copy(t,c,{overwrite:!1,...u})}catch(i){return w.e(i)}},isWritableFileSystem(t){const c=s.getCapabilities(t);if(typeof c=="number")return!(c&2048)}})}async d(r,s,n){const t=[];for(;!s.isEqual(n,s.dirname(n));)try{if(!((await r.stat(n)).type&N.FileType.Directory))throw M.$EN.FileExists(`Unable to create folder '${n.scheme===d.Schemas.file?n.fsPath:n.toString(!0)}' that already exists but is not a directory`);break}catch(c){if(N.$il(c)!==N.FileSystemProviderErrorCode.FileNotFound)throw c;t.push(s.basename(n)),n=s.dirname(n)}for(let c=t.length-1;c>=0;c--){n=s.joinPath(n,t[c]);try{await r.createDirectory(n)}catch(u){if(N.$il(u)!==N.FileSystemProviderErrorCode.FileExists)throw u}}}static e(r){if(r instanceof M.$EN)throw r;if(r instanceof N.$el)switch(r.code){case N.FileSystemProviderErrorCode.FileExists:throw M.$EN.FileExists(r.message);case N.FileSystemProviderErrorCode.FileNotFound:throw M.$EN.FileNotFound(r.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw M.$EN.FileNotADirectory(r.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw M.$EN.FileIsADirectory(r.message);case N.FileSystemProviderErrorCode.NoPermissions:throw M.$EN.NoPermissions(r.message);case N.FileSystemProviderErrorCode.Unavailable:throw M.$EN.Unavailable(r.message);default:throw new M.$EN(r.message,r.name)}if(!(r instanceof Error))throw new M.$EN(String(r));if(r.name==="ENOPRO"||r.message.includes("ENOPRO"))throw M.$EN.Unavailable(r.message);switch(r.name){case N.FileSystemProviderErrorCode.FileExists:throw M.$EN.FileExists(r.message);case N.FileSystemProviderErrorCode.FileNotFound:throw M.$EN.FileNotFound(r.message);case N.FileSystemProviderErrorCode.FileNotADirectory:throw M.$EN.FileNotADirectory(r.message);case N.FileSystemProviderErrorCode.FileIsADirectory:throw M.$EN.FileIsADirectory(r.message);case N.FileSystemProviderErrorCode.NoPermissions:throw M.$EN.NoPermissions(r.message);case N.FileSystemProviderErrorCode.Unavailable:throw M.$EN.Unavailable(r.message);default:throw new M.$EN(r.message,r.name)}}addFileSystemProvider(r,s,n){return this.b.set(r,{impl:s,extUri:n?.isCaseSensitive?S.$2g:S.$4g,isReadonly:!!n?.isReadonly}),(0,D.$Sc)(()=>this.b.delete(r))}getFileSystemProviderExtUri(r){return this.b.get(r)?.extUri??S.$2g}};e.$vmc=f,e.$vmc=f=w=Je([We(0,p.$PO),We(1,m.$_lc)],f),e.$wmc=(0,A.$yi)("IExtHostConsumerFileSystem")}),define(Se[87],Ie([1,0,3,27,12,65,2]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ymc=e.$xmc=void 0,e.$xmc=(0,C.$yi)("IExtensionStoragePaths");let p=class{constructor(D,O,S){this.d=O,this.f=S,this.a=D.workspace??void 0,this.b=D.environment,this.whenReady=this.h().then(d=>this.c=d)}async g(D){return A.URI.joinPath(this.b.workspaceStorageHome,D)}async h(){if(!this.a)return Promise.resolve(void 0);const D=this.a.id,O=await this.g(D);try{return await this.f.value.stat(O),this.d.trace("[ExtHostStorage] storage dir already exists",O),O}catch{}try{return this.d.trace("[ExtHostStorage] creating dir and metadata-file",O),await this.f.value.createDirectory(O),await this.f.value.writeFile(A.URI.joinPath(O,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this.a.id,configuration:A.URI.revive(this.a.configuration)?.toString(),name:this.a.name},void 0,2))),O}catch(S){this.d.error("[ExtHostStorage]",S);return}}workspaceValue(D){if(this.c)return A.URI.joinPath(this.c,D.identifier.value)}globalValue(D){return A.URI.joinPath(this.b.globalStorageHome,D.identifier.value.toLowerCase())}onWillDeactivateAll(){}};e.$ymc=p,e.$ymc=p=Je([We(0,N.$6O),We(1,M.$5j),We(2,T.$wmc)],p)}),define(Se[261],Ie([1,0,7,17,5]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$6nc=void 0;let T=class{constructor(p){this.a=new C.$ON(C.ColorThemeKind.Dark),this.b=new M.$fe}get activeColorTheme(){return this.a}$onColorThemeChange(p){let m;switch(p){case"light":m=C.ColorThemeKind.Light;break;case"hcDark":m=C.ColorThemeKind.HighContrast;break;case"hcLight":m=C.ColorThemeKind.HighContrastLight;break;default:m=C.ColorThemeKind.Dark}this.a=new C.$ON(m),this.b.fire(this.a)}get onDidChangeActiveColorTheme(){return this.b.event}};e.$6nc=T,e.$6nc=T=Je([We(0,N.$PO)],T)}),define(Se[88],Ie([1,0,20,5,6,182,3,12,211,4,27,17,7]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2Db=e.$1Db=e.TunnelDtoConverter=void 0;class w extends m.$xw{}var f;(function(r){function s(t){return{remoteAddress:t.remoteAddress,localAddress:t.localAddress,public:!!t.public,privacy:t.privacy??(t.public?m.TunnelPrivacyId.Public:m.TunnelPrivacyId.Private),protocol:t.protocol}}r.fromApiTunnel=s;function n(t){return{remoteAddress:{host:t.tunnelRemoteHost,port:t.tunnelRemotePort},localAddress:t.localAddress,public:t.privacy!==m.TunnelPrivacyId.ConstantPrivate&&t.privacy!==m.TunnelPrivacyId.ConstantPrivate,privacy:t.privacy,protocol:t.protocol}}r.fromServiceTunnel=n})(f||(e.TunnelDtoConverter=f={})),e.$1Db=(0,A.$yi)("IExtHostTunnelService");let o=class extends M.$Uc{constructor(s,n,t){super(),this.s=t,this.f=()=>Promise.resolve(!0),this.g=new Map,this.h=new N.$fe,this.onDidChangeTunnels=this.h.event,this.n=0,this.r=new Map,this.a=s.getProxy(D.$lM.MainThreadTunnelService)}async openTunnel(s,n){this.s.trace(`ForwardedPorts: (ExtHostTunnelService) ${s.identifier.value} called openTunnel API for ${n.remoteAddress.host}:${n.remoteAddress.port}.`);const t=await this.a.$openTunnel(n,s.displayName);if(t){const c=new w(t.remoteAddress,t.localAddress,()=>this.a.$closeTunnel(t.remoteAddress));return this.B(c),c}}async getTunnels(){return this.a.$getTunnels()}u(){return this.n++}registerPortsAttributesProvider(s,n){s.portRange===void 0&&s.commandPattern===void 0&&this.s.error("PortAttributesProvider must specify either a portRange or a commandPattern");const t=this.u();return this.r.set(t,{selector:s,provider:n}),this.a.$registerPortsAttributesProvider(s,t),new d.$nM(()=>{this.r.delete(t),this.a.$unregisterPortsAttributesProvider(t)})}async $providePortAttributes(s,n,t,c,u){const i=[];for(const a of s){const l=this.r.get(a);if(!l)return[];i.push(...await Promise.all(n.map(async g=>{let $;try{$=await l.provider.providePortAttributes({port:g,pid:t,commandLine:c},u)}catch{$=await l.provider.providePortAttributes(g,t,c,u)}return{providedAttributes:$,port:g}})))}const b=i.filter(a=>!!a.providedAttributes);return b.length>0?b.map(a=>({autoForwardAction:a.providedAttributes.autoForwardAction,port:a.port})):[]}async $registerCandidateFinder(s){}registerTunnelProvider(s,n){if(this.b)throw new Error("A tunnel provider has already been registered. Only the first tunnel provider to be registered will be used.");this.b=async(c,u)=>await s.provideTunnel(c,u,C.CancellationToken.None)??void 0;const t=n.tunnelFeatures?{elevation:!!n.tunnelFeatures?.elevation,privacyOptions:n.tunnelFeatures?.privacyOptions,protocol:n.tunnelFeatures.protocol===void 0?!0:n.tunnelFeatures.protocol}:void 0;return this.a.$setTunnelProvider(t),Promise.resolve((0,M.$Sc)(()=>{this.b=void 0,this.a.$setTunnelProvider(void 0)}))}async setTunnelFactory(s,n){if(s){s.candidatePortSource!==void 0&&this.a.$setCandidatePortSource(s.candidatePortSource),s.showCandidatePort&&(this.f=s.showCandidatePort,this.a.$setCandidateFilter());const t=s.tunnelFactory??(n?this.w(n):void 0);if(t){this.b=t;let c=s.tunnelFeatures?.privacyOptions??[];s.tunnelFeatures?.public&&c.length===0&&(c=[{id:"private",label:T.localize(0,null),themeIcon:"lock"},{id:"public",label:T.localize(1,null),themeIcon:"eye"}]);const u=s.tunnelFeatures?{elevation:!!s.tunnelFeatures?.elevation,public:!!s.tunnelFeatures?.public,privacyOptions:c,protocol:!0}:void 0;this.a.$setTunnelProvider(u)}}else this.b=void 0;return(0,M.$Sc)(()=>{this.b=void 0})}w(s){}async $closeTunnel(s,n){if(this.g.has(s.host)){const t=this.g.get(s.host);t.has(s.port)&&(n&&t.get(s.port).disposeListener.dispose(),await t.get(s.port).tunnel.dispose(),t.delete(s.port))}}async $onDidTunnelsChange(){this.h.fire()}async $forwardPort(s,n){if(this.b)try{this.s.trace("ForwardedPorts: (ExtHostTunnelService) Getting tunnel from provider.");const t=this.b(s,n);if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Got tunnel promise from provider."),t!==void 0){const c=await t;if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Successfully awaited tunnel from provider."),c===void 0){this.s.error("ForwardedPorts: (ExtHostTunnelService) Resolved tunnel is undefined");return}this.g.has(s.remoteAddress.host)||this.g.set(s.remoteAddress.host,new Map);const u=this.B(c.onDidDispose(()=>(this.s.trace("ForwardedPorts: (ExtHostTunnelService) Extension fired tunnel's onDidDispose."),this.a.$closeTunnel(c.remoteAddress))));return this.g.get(s.remoteAddress.host).set(s.remoteAddress.port,{tunnel:c,disposeListener:u}),f.fromApiTunnel(c)}else this.s.trace("ForwardedPorts: (ExtHostTunnelService) Tunnel is undefined")}catch(t){if(this.s.trace("ForwardedPorts: (ExtHostTunnelService) tunnel provider error"),t instanceof Error)return t.message}}async $applyCandidateFilter(s){const n=await Promise.all(s.map(c=>this.f(c.host,c.port,c.detail??""))),t=s.filter((c,u)=>n[u]);return this.s.trace(`ForwardedPorts: (ExtHostTunnelService) filtered from ${s.map(c=>c.port).join(", ")} to ${t.map(c=>c.port).join(", ")}`),t}};e.$2Db=o,e.$2Db=o=Je([We(0,S.$PO),We(1,O.$6O),We(2,p.$5j)],o)}),define(Se[8],Ie([1,0,18,22,138,262,55,28,127,45,70,26,133,24,36,15,2,30,89,101,107,106,224,85,52,62,235,7]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u,i,b,a,l,g,$){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DebugTreeItem=e.PartialAcceptTriggerKind=e.PartialAcceptInfo=e.TerminalQuickFix=e.ChatAgentUserActionEvent=e.ChatAgentResult=e.ChatAgentCompletionItem=e.ChatAgentValueReference=e.ChatLocation=e.ChatAgentRequest=e.ChatResponsePart=e.ChatResponseReferencePart=e.ChatResponseTextEditPart=e.ChatResponseCommandButtonPart=e.ChatTaskResult=e.ChatTask=e.ChatResponseWarningPart=e.ChatResponseProgressPart=e.ChatResponseAnchorPart=e.ChatResponseFilesPart=e.ChatResponseConfirmationPart=e.ChatResponseDetectedParticipantPart=e.ChatResponseMarkdownWithVulnerabilitiesPart=e.ChatResponseMarkdownPart=e.LanguageModelChatMessage=e.ChatFollowup=e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookKernelSourceAction=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.MappedEditsContext=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.MultiDocumentHighlight=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.MarkdownString=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Location=e.Range=e.Selection=void 0,e.$MO=K,e.$NO=de,e.$OO=ye;var v;(function(pe){function Ae(J){const{selectionStartLineNumber:Me,selectionStartColumn:Ve,positionLineNumber:Xe,positionColumn:qe}=J,ut=new $.$oM(Me-1,Ve-1),yt=new $.$oM(Xe-1,qe-1);return new $.$qM(ut,yt)}pe.to=Ae;function ae(J){const{anchor:Me,active:Ve}=J;return{selectionStartLineNumber:Me.line+1,selectionStartColumn:Me.character+1,positionLineNumber:Ve.line+1,positionColumn:Ve.character+1}}pe.from=ae})(v||(e.Selection=v={}));var y;(function(pe){function Ae(J){if(!J)return;const{start:Me,end:Ve}=J;return{startLineNumber:Me.line+1,startColumn:Me.character+1,endLineNumber:Ve.line+1,endColumn:Ve.character+1}}pe.from=Ae;function ae(J){if(!J)return;const{startLineNumber:Me,startColumn:Ve,endLineNumber:Xe,endColumn:qe}=J;return new $.$pM(Me-1,Ve-1,Xe-1,qe-1)}pe.to=ae})(y||(e.Range=y={}));var h;(function(pe){function Ae(J){return{uri:J.uri,range:y.from(J.range)}}pe.from=Ae;function ae(J){return new $.$zM(r.URI.revive(J.uri),y.to(J.range))}pe.to=ae})(h||(e.Location=h={}));var E;(function(pe){function Ae(ae){switch(ae){case 1:return $.StandardTokenType.Comment;case 0:return $.StandardTokenType.Other;case 3:return $.StandardTokenType.RegEx;case 2:return $.StandardTokenType.String}}pe.to=Ae})(E||(e.TokenType=E={}));var k;(function(pe){function Ae(J){return new $.$oM(J.lineNumber-1,J.column-1)}pe.to=Ae;function ae(J){return{lineNumber:J.line+1,column:J.character+1}}pe.from=ae})(k||(e.Position=k={}));var I;(function(pe){function Ae(Me,Ve,Xe){return(0,C.$Hb)((0,C.$2b)(Me).map(qe=>ae(qe,Ve,Xe)))}pe.from=Ae;function ae(Me,Ve,Xe){if(typeof Me=="string")return{$serialized:!0,language:Me,isBuiltin:Xe?.isBuiltin};if(Me)return{$serialized:!0,language:Me.language,scheme:J(Me.scheme,Ve),pattern:$e.from(Me.pattern)??void 0,exclusive:Me.exclusive,notebookType:Me.notebookType,isBuiltin:Xe?.isBuiltin}}function J(Me,Ve){return Ve&&typeof Me=="string"?Ve.transformOutgoingScheme(Me):Me}})(I||(e.DocumentSelector=I={}));var P;(function(pe){function Ae(J){switch(J){case $.DiagnosticTag.Unnecessary:return 1;case $.DiagnosticTag.Deprecated:return 2}}pe.from=Ae;function ae(J){switch(J){case 1:return $.DiagnosticTag.Unnecessary;case 2:return $.DiagnosticTag.Deprecated;default:return}}pe.to=ae})(P||(e.DiagnosticTag=P={}));var V;(function(pe){function Ae(J){let Me;return J.code&&((0,o.$$f)(J.code)||(0,o.$cg)(J.code)?Me=String(J.code):Me={value:String(J.code.value),target:J.code.target}),{...y.from(J.range),message:J.message,source:J.source,code:Me,severity:q.from(J.severity),relatedInformation:J.relatedInformation&&J.relatedInformation.map(W.from),tags:Array.isArray(J.tags)?(0,C.$Hb)(J.tags.map(P.from)):void 0}}pe.from=Ae;function ae(J){const Me=new $.$BM(y.to(J),J.message,q.to(J.severity));return Me.source=J.source,Me.code=(0,o.$$f)(J.code)?J.code:J.code?.value,Me.relatedInformation=J.relatedInformation&&J.relatedInformation.map(W.to),Me.tags=J.tags&&(0,C.$Hb)(J.tags.map(P.to)),Me}pe.to=ae})(V||(e.Diagnostic=V={}));var W;(function(pe){function Ae(J){return{...y.from(J.location.range),message:J.message,resource:J.location.uri}}pe.from=Ae;function ae(J){return new $.$AM(new $.$zM(J.resource,y.to(J)),J.message)}pe.to=ae})(W||(e.DiagnosticRelatedInformation=W={}));var q;(function(pe){function Ae(J){switch(J){case $.DiagnosticSeverity.Error:return t.MarkerSeverity.Error;case $.DiagnosticSeverity.Warning:return t.MarkerSeverity.Warning;case $.DiagnosticSeverity.Information:return t.MarkerSeverity.Info;case $.DiagnosticSeverity.Hint:return t.MarkerSeverity.Hint}return t.MarkerSeverity.Error}pe.from=Ae;function ae(J){switch(J){case t.MarkerSeverity.Info:return $.DiagnosticSeverity.Information;case t.MarkerSeverity.Warning:return $.DiagnosticSeverity.Warning;case t.MarkerSeverity.Error:return $.DiagnosticSeverity.Error;case t.MarkerSeverity.Hint:return $.DiagnosticSeverity.Hint;default:return $.DiagnosticSeverity.Error}}pe.to=ae})(q||(e.DiagnosticSeverity=q={}));var R;(function(pe){function Ae(J){return typeof J=="number"&&J>=$.ViewColumn.One?J-1:J===$.ViewColumn.Beside?g.$0D:g.$9D}pe.from=Ae;function ae(J){if(typeof J=="number"&&J>=0)return J+1;throw new Error("invalid 'EditorGroupColumn'")}pe.to=ae})(R||(e.ViewColumn=R={}));function z(pe){return typeof pe.range<"u"}function K(pe){return pe.length===0?!0:!!z(pe[0])}var ie;(function(pe){function Ae(qe){return qe.map(pe.from)}pe.fromMany=Ae;function ae(qe){return qe&&typeof qe=="object"&&typeof qe.language=="string"&&typeof qe.value=="string"}function J(qe){let ut;if(ae(qe)){const{language:Ot,value:Ft}=qe;ut={value:"```"+Ot+`
`+Ft+"\n```\n"}}else $.$PM.isMarkdownString(qe)?ut={value:qe.value,isTrusted:qe.isTrusted,supportThemeIcons:qe.supportThemeIcons,supportHtml:qe.supportHtml,baseUri:qe.baseUri}:typeof qe=="string"?ut={value:qe}:ut={value:""};const yt=Object.create(null);ut.uris=yt;const Lt=Ot=>{try{let Ft=r.URI.parse(Ot,!0);Ft=Ft.with({query:Me(Ft.query,yt)}),yt[Ot]=Ft}catch{}return""},ct=new m.marked.Renderer;return ct.link=Lt,ct.image=Ot=>typeof Ot=="string"?Lt(A.$4k(Ot).href):"",(0,m.marked)(ut.value,{renderer:ct}),ut}pe.from=J;function Me(qe,ut){if(!qe)return qe;let yt;try{yt=(0,D.$7h)(qe)}catch{}if(!yt)return qe;let Lt=!1;return yt=(0,S.$7n)(yt,ct=>{if(r.URI.isUri(ct)){const Ot=`__uri_${Math.random().toString(16).slice(2,8)}`;return ut[Ot]=ct,Lt=!0,Ot}else return}),Lt?JSON.stringify(yt):qe}function Ve(qe){const ut=new $.$PM(qe.value,qe.supportThemeIcons);return ut.isTrusted=qe.isTrusted,ut.supportHtml=qe.supportHtml,ut.baseUri=qe.baseUri?r.URI.from(qe.baseUri):void 0,ut}pe.to=Ve;function Xe(qe){if(qe)return typeof qe=="string"?qe:pe.from(qe)}pe.fromStrict=Xe})(ie||(e.MarkdownString=ie={}));function de(pe){return K(pe)?pe.map(Ae=>({range:y.from(Ae.range),hoverMessage:Array.isArray(Ae.hoverMessage)?ie.fromMany(Ae.hoverMessage):Ae.hoverMessage?ie.from(Ae.hoverMessage):void 0,renderOptions:Ae.renderOptions})):pe.map(Ae=>({range:y.from(Ae)}))}function ye(pe){return typeof pe>"u"?pe:typeof pe=="string"?r.URI.file(pe):pe}var De;(function(pe){function Ae(ae){return typeof ae>"u"?ae:{contentText:ae.contentText,contentIconPath:ae.contentIconPath?ye(ae.contentIconPath):void 0,border:ae.border,borderColor:ae.borderColor,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,color:ae.color,backgroundColor:ae.backgroundColor,margin:ae.margin,width:ae.width,height:ae.height}}pe.from=Ae})(De||(e.ThemableDecorationAttachmentRenderOptions=De={}));var ge;(function(pe){function Ae(ae){return typeof ae>"u"?ae:{backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ye(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?De.from(ae.before):void 0,after:ae.after?De.from(ae.after):void 0}}pe.from=Ae})(ge||(e.ThemableDecorationRenderOptions=ge={}));var ue;(function(pe){function Ae(ae){if(typeof ae>"u")return ae;switch(ae){case $.DecorationRangeBehavior.OpenOpen:return 0;case $.DecorationRangeBehavior.ClosedClosed:return 1;case $.DecorationRangeBehavior.OpenClosed:return 2;case $.DecorationRangeBehavior.ClosedOpen:return 3}}pe.from=Ae})(ue||(e.DecorationRangeBehavior=ue={}));var Ce;(function(pe){function Ae(ae){return{isWholeLine:ae.isWholeLine,rangeBehavior:ae.rangeBehavior?ue.from(ae.rangeBehavior):void 0,overviewRulerLane:ae.overviewRulerLane,light:ae.light?ge.from(ae.light):void 0,dark:ae.dark?ge.from(ae.dark):void 0,backgroundColor:ae.backgroundColor,outline:ae.outline,outlineColor:ae.outlineColor,outlineStyle:ae.outlineStyle,outlineWidth:ae.outlineWidth,border:ae.border,borderColor:ae.borderColor,borderRadius:ae.borderRadius,borderSpacing:ae.borderSpacing,borderStyle:ae.borderStyle,borderWidth:ae.borderWidth,fontStyle:ae.fontStyle,fontWeight:ae.fontWeight,textDecoration:ae.textDecoration,cursor:ae.cursor,color:ae.color,opacity:ae.opacity,letterSpacing:ae.letterSpacing,gutterIconPath:ae.gutterIconPath?ye(ae.gutterIconPath):void 0,gutterIconSize:ae.gutterIconSize,overviewRulerColor:ae.overviewRulerColor,before:ae.before?De.from(ae.before):void 0,after:ae.after?De.from(ae.after):void 0}}pe.from=Ae})(Ce||(e.DecorationRenderOptions=Ce={}));var se;(function(pe){function Ae(J){return{text:J.newText,eol:J.newEol&&gt.from(J.newEol),range:y.from(J.range)}}pe.from=Ae;function ae(J){const Me=new $.$uM(y.to(J.range),J.text);return Me.newEol=typeof J.eol>"u"?void 0:gt.to(J.eol),Me}pe.to=ae})(se||(e.TextEdit=se={}));var Ne;(function(pe){function Ae(J,Me){const Ve={edits:[]};if(J instanceof $.$xM){const Xe=new p.$Bc;for(const qe of J._allEntries())qe._type===1&&r.URI.isUri(qe.to)&&qe.from===void 0&&Xe.add(qe.to);for(const qe of J._allEntries())if(qe._type===1){let ut;qe.options?.contents&&(ArrayBuffer.isView(qe.options.contents)?ut={type:"base64",value:(0,N.$2e)(N.$He.wrap(qe.options.contents))}:ut={type:"dataTransferItem",id:qe.options.contents._itemId}),Ve.edits.push({oldResource:qe.from,newResource:qe.to,options:{...qe.options,contents:ut},metadata:qe.metadata})}else qe._type===2?Ve.edits.push({resource:qe.uri,textEdit:se.from(qe.edit),versionId:Xe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===6?Ve.edits.push({resource:qe.uri,textEdit:{range:y.from(qe.range),text:qe.edit.value,insertAsSnippet:!0},versionId:Xe.has(qe.uri)?void 0:Me?.getTextDocumentVersion(qe.uri),metadata:qe.metadata}):qe._type===3?Ve.edits.push({metadata:qe.metadata,resource:qe.uri,cellEdit:qe.edit,notebookMetadata:qe.notebookMetadata,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri)}):qe._type===5&&Ve.edits.push({metadata:qe.metadata,resource:qe.uri,notebookVersionId:Me?.getNotebookDocumentVersion(qe.uri),cellEdit:{editType:1,index:qe.index,count:qe.count,cells:qe.cells.map(ii.from)}})}return Ve}pe.from=Ae;function ae(J){const Me=new $.$xM,Ve=new p.$Ac;for(const Xe of J.edits)if(Xe.textEdit){const qe=Xe,ut=r.URI.revive(qe.resource),yt=y.to(qe.textEdit.range),Lt=qe.textEdit.text,ct=qe.textEdit.insertAsSnippet;let Ot;ct?Ot=$.$wM.replace(yt,new $.$yM(Lt)):Ot=$.$uM.replace(yt,Lt);const Ft=Ve.get(ut);Ft?Ft.push(Ot):Ve.set(ut,[Ot])}else Me.renameFile(r.URI.revive(Xe.oldResource),r.URI.revive(Xe.newResource),Xe.options);for(const[Xe,qe]of Ve)Me.set(Xe,qe);return Me}pe.to=ae})(Ne||(e.WorkspaceEdit=Ne={}));var ne;(function(pe){const Ae=Object.create(null);Ae[$.SymbolKind.File]=0,Ae[$.SymbolKind.Module]=1,Ae[$.SymbolKind.Namespace]=2,Ae[$.SymbolKind.Package]=3,Ae[$.SymbolKind.Class]=4,Ae[$.SymbolKind.Method]=5,Ae[$.SymbolKind.Property]=6,Ae[$.SymbolKind.Field]=7,Ae[$.SymbolKind.Constructor]=8,Ae[$.SymbolKind.Enum]=9,Ae[$.SymbolKind.Interface]=10,Ae[$.SymbolKind.Function]=11,Ae[$.SymbolKind.Variable]=12,Ae[$.SymbolKind.Constant]=13,Ae[$.SymbolKind.String]=14,Ae[$.SymbolKind.Number]=15,Ae[$.SymbolKind.Boolean]=16,Ae[$.SymbolKind.Array]=17,Ae[$.SymbolKind.Object]=18,Ae[$.SymbolKind.Key]=19,Ae[$.SymbolKind.Null]=20,Ae[$.SymbolKind.EnumMember]=21,Ae[$.SymbolKind.Struct]=22,Ae[$.SymbolKind.Event]=23,Ae[$.SymbolKind.Operator]=24,Ae[$.SymbolKind.TypeParameter]=25;function ae(Me){return typeof Ae[Me]=="number"?Ae[Me]:6}pe.from=ae;function J(Me){for(const Ve in Ae)if(Ae[Ve]===Me)return Number(Ve);return $.SymbolKind.Property}pe.to=J})(ne||(e.SymbolKind=ne={}));var U;(function(pe){function Ae(J){switch(J){case $.SymbolTag.Deprecated:return 1}}pe.from=Ae;function ae(J){switch(J){case 1:return $.SymbolTag.Deprecated}}pe.to=ae})(U||(e.SymbolTag=U={}));var x;(function(pe){function Ae(J){return{name:J.name,kind:ne.from(J.kind),tags:J.tags&&J.tags.map(U.from),containerName:J.containerName,location:me.from(J.location)}}pe.from=Ae;function ae(J){const Me=new $.$GM(J.name,ne.to(J.kind),J.containerName,me.to(J.location));return Me.tags=J.tags&&J.tags.map(U.to),Me}pe.to=ae})(x||(e.WorkspaceSymbol=x={}));var ve;(function(pe){function Ae(J){const Me={name:J.name||"!!MISSING: name!!",detail:J.detail,range:y.from(J.range),selectionRange:y.from(J.selectionRange),kind:ne.from(J.kind),tags:J.tags?.map(U.from)??[]};return J.children&&(Me.children=J.children.map(Ae)),Me}pe.from=Ae;function ae(J){const Me=new $.$HM(J.name,J.detail,ne.to(J.kind),y.to(J.range),y.to(J.selectionRange));return(0,C.$Lb)(J.tags)&&(Me.tags=J.tags.map(U.to)),J.children&&(Me.children=J.children.map(ae)),Me}pe.to=ae})(ve||(e.DocumentSymbol=ve={}));var Le;(function(pe){function Ae(J){const Me=new $.$LM(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}pe.to=Ae;function ae(J,Me,Ve){if(Me=Me??J._sessionId,Ve=Ve??J._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,name:J.name,detail:J.detail,kind:ne.from(J.kind),uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(U.from)}}pe.from=ae})(Le||(e.CallHierarchyItem=Le={}));var ke;(function(pe){function Ae(ae){return new $.$MM(Le.to(ae.from),ae.fromRanges.map(J=>y.to(J)))}pe.to=Ae})(ke||(e.CallHierarchyIncomingCall=ke={}));var be;(function(pe){function Ae(ae){return new $.$NM(Le.to(ae.to),ae.fromRanges.map(J=>y.to(J)))}pe.to=Ae})(be||(e.CallHierarchyOutgoingCall=be={}));var me;(function(pe){function Ae(J){return{range:J.range&&y.from(J.range),uri:J.uri}}pe.from=Ae;function ae(J){return new $.$zM(r.URI.revive(J.uri),y.to(J.range))}pe.to=ae})(me||(e.location=me={}));var Q;(function(pe){function Ae(J){const Me=J,Ve=J;return{originSelectionRange:Me.originSelectionRange?y.from(Me.originSelectionRange):void 0,uri:Me.targetUri?Me.targetUri:Ve.uri,range:y.from(Me.targetRange?Me.targetRange:Ve.range),targetSelectionRange:Me.targetSelectionRange?y.from(Me.targetSelectionRange):void 0}}pe.from=Ae;function ae(J){return{targetUri:r.URI.revive(J.uri),targetRange:y.to(J.range),targetSelectionRange:J.targetSelectionRange?y.to(J.targetSelectionRange):void 0,originSelectionRange:J.originSelectionRange?y.to(J.originSelectionRange):void 0}}pe.to=ae})(Q||(e.DefinitionLink=Q={}));var Y;(function(pe){function Ae(J){return{range:y.from(J.range),contents:ie.fromMany(J.contents),canIncreaseVerbosity:J.canIncreaseVerbosity,canDecreaseVerbosity:J.canDecreaseVerbosity}}pe.from=Ae;function ae(J){const Me=J.contents.map(ie.to),Ve=y.to(J.range),Xe=J.canIncreaseVerbosity,qe=J.canDecreaseVerbosity;return new $.$DM(Me,Ve,Xe,qe)}pe.to=ae})(Y||(e.Hover=Y={}));var he;(function(pe){function Ae(J){return{range:y.from(J.range),expression:J.expression}}pe.from=Ae;function ae(J){return new $.$yN(y.to(J.range),J.expression)}pe.to=ae})(he||(e.EvaluatableExpression=he={}));var ce;(function(pe){function Ae(J){if(J instanceof $.$zN)return{type:"text",range:y.from(J.range),text:J.text};if(J instanceof $.$AN)return{type:"variable",range:y.from(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};if(J instanceof $.$BN)return{type:"expression",range:y.from(J.range),expression:J.expression};throw new Error("Unknown 'InlineValue' type")}pe.from=Ae;function ae(J){switch(J.type){case"text":return{range:y.to(J.range),text:J.text};case"variable":return{range:y.to(J.range),variableName:J.variableName,caseSensitiveLookup:J.caseSensitiveLookup};case"expression":return{range:y.to(J.range),expression:J.expression}}}pe.to=ae})(ce||(e.InlineValue=ce={}));var Te;(function(pe){function Ae(J){return{frameId:J.frameId,stoppedLocation:y.from(J.stoppedLocation)}}pe.from=Ae;function ae(J){return new $.$CN(J.frameId,y.to(J.stoppedLocation))}pe.to=ae})(Te||(e.InlineValueContext=Te={}));var fe;(function(pe){function Ae(J){return{range:y.from(J.range),kind:J.kind}}pe.from=Ae;function ae(J){return new $.$EM(y.to(J.range),J.kind)}pe.to=ae})(fe||(e.DocumentHighlight=fe={}));var Pe;(function(pe){function Ae(J){return{uri:J.uri,highlights:J.highlights.map(fe.from)}}pe.from=Ae;function ae(J){return new $.$FM(r.URI.revive(J.uri),J.highlights.map(fe.to))}pe.to=ae})(Pe||(e.MultiDocumentHighlight=Pe={}));var Re;(function(pe){function Ae(ae){switch(ae){case 1:return $.CompletionTriggerKind.TriggerCharacter;case 2:return $.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return $.CompletionTriggerKind.Invoke}}pe.to=Ae})(Re||(e.CompletionTriggerKind=Re={}));var je;(function(pe){function Ae(ae){return{triggerKind:Re.to(ae.triggerKind),triggerCharacter:ae.triggerCharacter}}pe.to=Ae})(je||(e.CompletionContext=je={}));var B;(function(pe){function Ae(J){switch(J){case $.CompletionItemTag.Deprecated:return 1}}pe.from=Ae;function ae(J){switch(J){case 1:return $.CompletionItemTag.Deprecated}}pe.to=ae})(B||(e.CompletionItemTag=B={}));var F;(function(pe){const Ae=new Map([[$.CompletionItemKind.Method,0],[$.CompletionItemKind.Function,1],[$.CompletionItemKind.Constructor,2],[$.CompletionItemKind.Field,3],[$.CompletionItemKind.Variable,4],[$.CompletionItemKind.Class,5],[$.CompletionItemKind.Interface,7],[$.CompletionItemKind.Struct,6],[$.CompletionItemKind.Module,8],[$.CompletionItemKind.Property,9],[$.CompletionItemKind.Unit,12],[$.CompletionItemKind.Value,13],[$.CompletionItemKind.Constant,14],[$.CompletionItemKind.Enum,15],[$.CompletionItemKind.EnumMember,16],[$.CompletionItemKind.Keyword,17],[$.CompletionItemKind.Snippet,27],[$.CompletionItemKind.Text,18],[$.CompletionItemKind.Color,19],[$.CompletionItemKind.File,20],[$.CompletionItemKind.Reference,21],[$.CompletionItemKind.Folder,23],[$.CompletionItemKind.Event,10],[$.CompletionItemKind.Operator,11],[$.CompletionItemKind.TypeParameter,24],[$.CompletionItemKind.Issue,26],[$.CompletionItemKind.User,25]]);function ae(Ve){return Ae.get(Ve)??9}pe.from=ae;const J=new Map([[0,$.CompletionItemKind.Method],[1,$.CompletionItemKind.Function],[2,$.CompletionItemKind.Constructor],[3,$.CompletionItemKind.Field],[4,$.CompletionItemKind.Variable],[5,$.CompletionItemKind.Class],[7,$.CompletionItemKind.Interface],[6,$.CompletionItemKind.Struct],[8,$.CompletionItemKind.Module],[9,$.CompletionItemKind.Property],[12,$.CompletionItemKind.Unit],[13,$.CompletionItemKind.Value],[14,$.CompletionItemKind.Constant],[15,$.CompletionItemKind.Enum],[16,$.CompletionItemKind.EnumMember],[17,$.CompletionItemKind.Keyword],[27,$.CompletionItemKind.Snippet],[18,$.CompletionItemKind.Text],[19,$.CompletionItemKind.Color],[20,$.CompletionItemKind.File],[21,$.CompletionItemKind.Reference],[23,$.CompletionItemKind.Folder],[10,$.CompletionItemKind.Event],[11,$.CompletionItemKind.Operator],[24,$.CompletionItemKind.TypeParameter],[25,$.CompletionItemKind.User],[26,$.CompletionItemKind.Issue]]);function Me(Ve){return J.get(Ve)??$.CompletionItemKind.Property}pe.to=Me})(F||(e.CompletionItemKind=F={}));var H;(function(pe){function Ae(ae,J){const Me=new $.$VM(ae.label);return Me.insertText=ae.insertText,Me.kind=F.to(ae.kind),Me.tags=ae.tags?.map(B.to),Me.detail=ae.detail,Me.documentation=A.$Xk(ae.documentation)?ie.to(ae.documentation):ae.documentation,Me.sortText=ae.sortText,Me.filterText=ae.filterText,Me.preselect=ae.preselect,Me.commitCharacters=ae.commitCharacters,s.$zt.isIRange(ae.range)?Me.range=y.to(ae.range):typeof ae.range=="object"&&(Me.range={inserting:y.to(ae.range.insert),replacing:y.to(ae.range.replace)}),Me.keepWhitespace=typeof ae.insertTextRules>"u"?!1:!!(ae.insertTextRules&1),typeof ae.insertTextRules<"u"&&ae.insertTextRules&4?Me.insertText=new $.$yM(ae.insertText):(Me.insertText=ae.insertText,Me.textEdit=Me.range instanceof $.$pM?new $.$uM(Me.range,Me.insertText):void 0),ae.additionalTextEdits&&ae.additionalTextEdits.length>0&&(Me.additionalTextEdits=ae.additionalTextEdits.map(Ve=>se.to(Ve))),Me.command=J&&ae.command?J.fromInternal(ae.command):void 0,Me}pe.to=Ae})(H||(e.CompletionItem=H={}));var G;(function(pe){function Ae(J){if(typeof J.label!="string"&&!Array.isArray(J.label))throw new TypeError("Invalid label");return{label:J.label,documentation:ie.fromStrict(J.documentation)}}pe.from=Ae;function ae(J){return{label:J.label,documentation:A.$Xk(J.documentation)?ie.to(J.documentation):J.documentation}}pe.to=ae})(G||(e.ParameterInformation=G={}));var te;(function(pe){function Ae(J){return{label:J.label,documentation:ie.fromStrict(J.documentation),parameters:Array.isArray(J.parameters)?J.parameters.map(G.from):[],activeParameter:J.activeParameter}}pe.from=Ae;function ae(J){return{label:J.label,documentation:A.$Xk(J.documentation)?ie.to(J.documentation):J.documentation,parameters:Array.isArray(J.parameters)?J.parameters.map(G.to):[],activeParameter:J.activeParameter}}pe.to=ae})(te||(e.SignatureInformation=te={}));var re;(function(pe){function Ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(te.from):[]}}pe.from=Ae;function ae(J){return{activeSignature:J.activeSignature,activeParameter:J.activeParameter,signatures:Array.isArray(J.signatures)?J.signatures.map(te.to):[]}}pe.to=ae})(re||(e.SignatureHelp=re={}));var Oe;(function(pe){function Ae(ae,J){const Me=new $.$UM(k.to(J.position),typeof J.label=="string"?J.label:J.label.map(Be.to.bind(void 0,ae)),J.kind&&Ge.to(J.kind));return Me.textEdits=J.textEdits&&J.textEdits.map(se.to),Me.tooltip=A.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,Me.paddingLeft=J.paddingLeft,Me.paddingRight=J.paddingRight,Me}pe.to=Ae})(Oe||(e.InlayHint=Oe={}));var Be;(function(pe){function Ae(ae,J){const Me=new $.$TM(J.label);return Me.tooltip=A.$Xk(J.tooltip)?ie.to(J.tooltip):J.tooltip,n.Command.is(J.command)&&(Me.command=ae.fromInternal(J.command)),J.location&&(Me.location=me.to(J.location)),Me}pe.to=Ae})(Be||(e.InlayHintLabelPart=Be={}));var Ge;(function(pe){function Ae(J){return J}pe.from=Ae;function ae(J){return J}pe.to=ae})(Ge||(e.InlayHintKind=Ge={}));var _e;(function(pe){function Ae(J){return{range:y.from(J.range),url:J.target,tooltip:J.tooltip}}pe.from=Ae;function ae(J){let Me;if(J.url)try{Me=typeof J.url=="string"?r.URI.parse(J.url,!0):r.URI.revive(J.url)}catch{}return new $.$1M(y.to(J.range),Me)}pe.to=ae})(_e||(e.DocumentLink=_e={}));var xe;(function(pe){function Ae(J){const Me=new $.$4M(J.label);return J.textEdit&&(Me.textEdit=se.to(J.textEdit)),J.additionalTextEdits&&(Me.additionalTextEdits=J.additionalTextEdits.map(Ve=>se.to(Ve))),Me}pe.to=Ae;function ae(J){return{label:J.label,textEdit:J.textEdit?se.from(J.textEdit):void 0,additionalTextEdits:J.additionalTextEdits?J.additionalTextEdits.map(Me=>se.from(Me)):void 0}}pe.from=ae})(xe||(e.ColorPresentation=xe={}));var et;(function(pe){function Ae(J){return new $.$2M(J[0],J[1],J[2],J[3])}pe.to=Ae;function ae(J){return[J.red,J.green,J.blue,J.alpha]}pe.from=ae})(et||(e.Color=et={}));var tt;(function(pe){function Ae(J){return{range:y.from(J.range)}}pe.from=Ae;function ae(J){return new $.$KM(y.to(J.range))}pe.to=ae})(tt||(e.SelectionRange=tt={}));var it;(function(pe){function Ae(ae){switch(ae){case 2:return $.TextDocumentSaveReason.AfterDelay;case 1:return $.TextDocumentSaveReason.Manual;case 3:case 4:return $.TextDocumentSaveReason.FocusOut}}pe.to=Ae})(it||(e.TextDocumentSaveReason=it={}));var at;(function(pe){function Ae(J){switch(J){case $.TextEditorLineNumbersStyle.Off:return 0;case $.TextEditorLineNumbersStyle.Relative:return 2;case $.TextEditorLineNumbersStyle.Interval:return 3;case $.TextEditorLineNumbersStyle.On:default:return 1}}pe.from=Ae;function ae(J){switch(J){case 0:return $.TextEditorLineNumbersStyle.Off;case 2:return $.TextEditorLineNumbersStyle.Relative;case 3:return $.TextEditorLineNumbersStyle.Interval;case 1:default:return $.TextEditorLineNumbersStyle.On}}pe.to=ae})(at||(e.TextEditorLineNumbersStyle=at={}));var gt;(function(pe){function Ae(J){if(J===$.EndOfLine.CRLF)return 1;if(J===$.EndOfLine.LF)return 0}pe.from=Ae;function ae(J){if(J===1)return $.EndOfLine.CRLF;if(J===0)return $.EndOfLine.LF}pe.to=ae})(gt||(e.EndOfLine=gt={}));var Ue;(function(pe){function Ae(ae){if(typeof ae=="object")return ae.viewId;switch(ae){case $.ProgressLocation.SourceControl:return 3;case $.ProgressLocation.Window:return 10;case $.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}pe.from=Ae})(Ue||(e.ProgressLocation=Ue={}));var rt;(function(pe){function Ae(J){const Me={start:J.start+1,end:J.end+1};return J.kind&&(Me.kind=Z.from(J.kind)),Me}pe.from=Ae;function ae(J){const Me={start:J.start-1,end:J.end-1};return J.kind&&(Me.kind=Z.to(J.kind)),Me}pe.to=ae})(rt||(e.FoldingRange=rt={}));var Z;(function(pe){function Ae(J){if(J)switch(J){case $.FoldingRangeKind.Comment:return n.$yu.Comment;case $.FoldingRangeKind.Imports:return n.$yu.Imports;case $.FoldingRangeKind.Region:return n.$yu.Region}}pe.from=Ae;function ae(J){if(J)switch(J.value){case n.$yu.Comment.value:return $.FoldingRangeKind.Comment;case n.$yu.Imports.value:return $.FoldingRangeKind.Imports;case n.$yu.Region.value:return $.FoldingRangeKind.Region}}pe.to=ae})(Z||(e.FoldingRangeKind=Z={}));var X;(function(pe){function Ae(ae){if(ae)return{pinned:typeof ae.preview=="boolean"?!ae.preview:void 0,inactive:ae.background,preserveFocus:ae.preserveFocus,selection:typeof ae.selection=="object"?y.from(ae.selection):void 0,override:typeof ae.override=="boolean"?u.$zF.id:void 0}}pe.from=Ae})(X||(e.TextEditorOpenOptions=X={}));var $e;(function(pe){function Ae(Ve){return Ve instanceof $.$mN?Ve.toJSON():typeof Ve=="string"?Ve:ae(Ve)||J(Ve)?new $.$mN(Ve.baseUri??Ve.base,Ve.pattern).toJSON():Ve}pe.from=Ae;function ae(Ve){const Xe=Ve;return Xe?r.URI.isUri(Xe.baseUri)&&typeof Xe.pattern=="string":!1}function J(Ve){const Xe=Ve;return Xe?typeof Xe.base=="string"&&typeof Xe.pattern=="string":!1}function Me(Ve){return typeof Ve=="string"?Ve:new $.$mN(r.URI.revive(Ve.baseUri),Ve.pattern)}pe.to=Me})($e||(e.GlobPattern=$e={}));var He;(function(pe){function Ae(ae){if(ae){if(Array.isArray(ae))return ae.map(Ae);if(typeof ae=="string")return ae;{const J=ae;return{language:J.language,scheme:J.scheme,pattern:$e.from(J.pattern),exclusive:J.exclusive,notebookType:J.notebookType}}}else return}pe.from=Ae})(He||(e.LanguageSelector=He={}));var we;(function(pe){function Ae(J){return!!J&&typeof J=="object"&&"documents"in J&&Array.isArray(J.documents)&&J.documents.every(Me=>Array.isArray(Me)&&Me.every(Ve=>Ve&&typeof Ve=="object"&&"uri"in Ve&&r.URI.isUri(Ve.uri)&&"version"in Ve&&typeof Ve.version=="number"&&"ranges"in Ve&&Array.isArray(Ve.ranges)&&Ve.ranges.every(Xe=>Xe instanceof $.$pM)))}pe.is=Ae;function ae(J){return{documents:J.documents.map(Me=>Me.map(Ve=>({uri:r.URI.from(Ve.uri),version:Ve.version,ranges:Ve.ranges.map(Xe=>y.from(Xe))})))}}pe.from=ae})(we||(e.MappedEditsContext=we={}));var st;(function(pe){function Ae(J){return{start:J.start,end:J.end}}pe.from=Ae;function ae(J){return new $.$PN(J.start,J.end)}pe.to=ae})(st||(e.NotebookRange=st={}));var dt;(function(pe){function Ae(J){return{timing:typeof J.runStartTime=="number"&&typeof J.runEndTime=="number"?{startTime:J.runStartTime,endTime:J.runEndTime}:void 0,executionOrder:J.executionOrder,success:J.lastRunSuccess}}pe.to=Ae;function ae(J){return{lastRunSuccess:J.success,runStartTime:J.timing?.startTime,runEndTime:J.timing?.endTime,executionOrder:J.executionOrder}}pe.from=ae})(dt||(e.NotebookCellExecutionSummary=dt={}));var Ct;(function(pe){function Ae(ae){if(ae===b.NotebookCellExecutionState.Unconfirmed)return $.NotebookCellExecutionState.Pending;if(ae===b.NotebookCellExecutionState.Pending)return;if(ae===b.NotebookCellExecutionState.Executing)return $.NotebookCellExecutionState.Executing;throw new Error(`Unknown state: ${ae}`)}pe.to=Ae})(Ct||(e.NotebookCellExecutionState=Ct={}));var Vt;(function(pe){function Ae(J){switch(J){case $.NotebookCellKind.Markup:return b.CellKind.Markup;case $.NotebookCellKind.Code:default:return b.CellKind.Code}}pe.from=Ae;function ae(J){switch(J){case b.CellKind.Markup:return $.NotebookCellKind.Markup;case b.CellKind.Code:default:return $.NotebookCellKind.Code}}pe.to=ae})(Vt||(e.NotebookCellKind=Vt={}));var Qt;(function(pe){function Ae(J){const Me={metadata:J.metadata??Object.create(null),cells:[]};for(const Ve of J.cells)$.$QN.validate(Ve),Me.cells.push(ii.from(Ve));return Me}pe.from=Ae;function ae(J){const Me=new $.$RN(J.cells.map(ii.to));return(0,o.$lg)(J.metadata)||(Me.metadata=J.metadata),Me}pe.to=ae})(Qt||(e.NotebookData=Qt={}));var ii;(function(pe){function Ae(J){return{cellKind:Vt.from(J.kind),language:J.languageId,mime:J.mime,source:J.value,metadata:J.metadata,internalMetadata:dt.from(J.executionSummary??{}),outputs:J.outputs?J.outputs.map(Et.from):[]}}pe.from=Ae;function ae(J){return new $.$QN(Vt.to(J.cellKind),J.source,J.language,J.mime,J.outputs?J.outputs.map(Et.to):void 0,J.metadata,J.internalMetadata?dt.to(J.internalMetadata):void 0)}pe.to=ae})(ii||(e.NotebookCellData=ii={}));var Xt;(function(pe){function Ae(J){return{mime:J.mime,valueBytes:N.$He.wrap(J.data)}}pe.from=Ae;function ae(J){return new $.$SN(J.valueBytes.buffer,J.mime)}pe.to=ae})(Xt||(e.NotebookCellOutputItem=Xt={}));var Et;(function(pe){function Ae(J){return{outputId:J.id,items:J.items.map(Xt.from),metadata:J.metadata}}pe.from=Ae;function ae(J){const Me=J.items.map(Xt.to);return new $.$TN(Me,J.outputId,J.metadata)}pe.to=ae})(Et||(e.NotebookCellOutput=Et={}));var Zt;(function(pe){function Ae(Me){return J(Me)?{include:$e.from(Me.include)??void 0,exclude:$e.from(Me.exclude)??void 0}:$e.from(Me)??void 0}pe.from=Ae;function ae(Me){return J(Me)?{include:$e.to(Me.include),exclude:$e.to(Me.exclude)}:$e.to(Me)}pe.to=ae;function J(Me){const Ve=Me;return Ve?!(0,o.$hg)(Ve.include)&&!(0,o.$hg)(Ve.exclude):!1}})(Zt||(e.NotebookExclusiveDocumentPattern=Zt={}));var Yt;(function(pe){function Ae(ae,J,Me){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{alignment:ae.alignment===$.NotebookCellStatusBarAlignment.Left?1:2,command:J.toInternal(Ve,Me),text:ae.text,tooltip:ae.tooltip,accessibilityInformation:ae.accessibilityInformation,priority:ae.priority}}pe.from=Ae})(Yt||(e.NotebookStatusBarItem=Yt={}));var Ze;(function(pe){function Ae(ae,J,Me){const Ve=typeof ae.command=="string"?{title:"",command:ae.command}:ae.command;return{command:J.toInternal(Ve,Me),label:ae.label,description:ae.description,detail:ae.detail,documentation:ae.documentation}}pe.from=Ae})(Ze||(e.NotebookKernelSourceAction=Ze={}));var si;(function(pe){function Ae(ae){return{transientOutputs:ae?.transientOutputs??!1,transientCellMetadata:ae?.transientCellMetadata??{},transientDocumentMetadata:ae?.transientDocumentMetadata??{},cellContentMetadata:ae?.cellContentMetadata??{}}}pe.from=Ae})(si||(e.NotebookDocumentContentOptions=si={}));var Gt;(function(pe){function Ae(J){return{uri:J.uri,provides:J.provides}}pe.from=Ae;function ae(J){return new $.$VN(r.URI.revive(J.uri),J.provides)}pe.to=ae})(Gt||(e.NotebookRendererScript=Gt={}));var ht;(function(pe){function Ae(J){return{message:ie.fromStrict(J.message)||"",type:0,expected:J.expectedOutput,actual:J.actualOutput,contextValue:J.contextValue,location:J.location&&{range:y.from(J.location.range),uri:J.location.uri}}}pe.from=Ae;function ae(J){const Me=new $.$2N(typeof J.message=="string"?J.message:ie.to(J.message));return Me.actualOutput=J.actual,Me.expectedOutput=J.expected,Me.contextValue=J.contextValue,Me.location=J.location?me.to(J.location):void 0,Me}pe.to=ae})(ht||(e.TestMessage=ht={}));var mt;(function(pe){pe.namespace=l.$cL,pe.denamespace=l.$dL})(mt||(e.TestTag=mt={}));var xt;(function(pe){function Ae(J){const Me=(0,c.$LO)(J).controllerId;return{extId:a.$0K.fromExtHostTestItem(J,Me).toString(),label:J.label,uri:r.URI.revive(J.uri),busy:J.busy,tags:J.tags.map(Ve=>mt.namespace(Me,Ve.id)),range:s.$zt.lift(y.from(J.range)),description:J.description||null,sortText:J.sortText||null,error:J.error&&ie.fromStrict(J.error)||null}}pe.from=Ae;function ae(J){return{parent:void 0,error:void 0,id:a.$0K.fromString(J.extId).localId,label:J.label,uri:r.URI.revive(J.uri),tags:(J.tags||[]).map(Me=>{const{tagId:Ve}=mt.denamespace(Me);return new $.$3N(Ve)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:y.to(J.range||void 0),canResolveChildren:!1,busy:J.busy,description:J.description||void 0,sortText:J.sortText||void 0}}pe.toPlain=ae})(xt||(e.TestItem=xt={})),function(pe){function Ae(J){return{id:J.id}}pe.from=Ae;function ae(J){return new $.$3N(J.id)}pe.to=ae}(mt||(e.TestTag=mt={}));var Kt;(function(pe){const Ae=(J,Me)=>{const Ve=J.value;if(!Ve)return;const Xe={...xt.toPlain(Ve.item),parent:Me,taskStates:Ve.tasks.map(qe=>({state:qe.state,duration:qe.duration,messages:qe.messages.filter(ut=>ut.type===0).map(ht.to)})),children:[]};if(J.children)for(const qe of J.children.values()){const ut=Ae(qe,Xe);ut&&Xe.children.push(ut)}return Xe};function ae(J){const Me=new d.$EO;for(const qe of J.items)Me.insert(a.$0K.fromString(qe.item.extId).path,qe);const Ve=[Me.nodes],Xe=[];for(;Ve.length;)for(const qe of Ve.pop())qe.value?Xe.push(qe):qe.children&&Ve.push(qe.children.values());return{completedAt:J.completedAt,results:Xe.map(qe=>Ae(qe)).filter(o.$gg)}}pe.to=ae})(Kt||(e.TestResults=Kt={}));var Tt;(function(pe){function Ae(Ve){return{covered:Ve.covered,total:Ve.total}}function ae(Ve){return"line"in Ve?k.from(Ve):y.from(Ve)}function J(Ve){if(typeof Ve.executed=="number"&&Ve.executed<0)throw new Error(`Invalid coverage count ${Ve.executed}`);return"branches"in Ve?{count:Ve.executed,location:ae(Ve.location),type:1,branches:Ve.branches.length?Ve.branches.map(Xe=>({count:Xe.executed,location:Xe.location&&ae(Xe.location),label:Xe.label})):void 0}:{type:0,name:Ve.name,count:Ve.executed,location:ae(Ve.location)}}pe.fromDetails=J;function Me(Ve,Xe,qe){return $.$5N(qe.statementCoverage),$.$5N(qe.branchCoverage),$.$5N(qe.declarationCoverage),{id:Xe,uri:qe.uri,statement:Ae(qe.statementCoverage),branch:qe.branchCoverage&&Ae(qe.branchCoverage),declaration:qe.declarationCoverage&&Ae(qe.declarationCoverage),testId:qe instanceof $.$6N&&qe.testItem?a.$0K.fromExtHostTestItem(qe.testItem,Ve).toString():void 0}}pe.fromFile=Me})(Tt||(e.TestCoverage=Tt={}));var ft;(function(pe){function Ae(ae){switch(ae){case 1:return $.CodeActionTriggerKind.Invoke;case 2:return $.CodeActionTriggerKind.Automatic}}pe.to=Ae})(ft||(e.CodeActionTriggerKind=ft={}));var Bt;(function(pe){function Ae(J){const Me=new $.$0N(ne.to(J.kind),J.name,J.detail||"",r.URI.revive(J.uri),y.to(J.range),y.to(J.selectionRange));return Me._sessionId=J._sessionId,Me._itemId=J._itemId,Me}pe.to=Ae;function ae(J,Me,Ve){if(Me=Me??J._sessionId,Ve=Ve??J._itemId,Me===void 0||Ve===void 0)throw new Error("invalid item");return{_sessionId:Me,_itemId:Ve,kind:ne.from(J.kind),name:J.name,detail:J.detail??"",uri:J.uri,range:y.from(J.range),selectionRange:y.from(J.selectionRange),tags:J.tags?.map(U.from)}}pe.from=ae})(Bt||(e.TypeHierarchyItem=Bt={}));var _t;(function(pe){function Ae(ae){if(ae)return{value:ae.value,tooltip:ae.tooltip}}pe.from=Ae})(_t||(e.ViewBadge=_t={}));var zt;(function(pe){function Ae(Ve,Xe,qe){const ut=Xe.fileData;return ut?new $.$eN(new $.$fN(ut.name,r.URI.revive(ut.uri),ut.id,(0,T.$db)(()=>qe(ut.id)))):Ve===O.$Vs.uriList&&Xe.uriListData?new $.$dN(Me(Xe.uriListData)):new $.$dN(Xe.asString)}pe.to=Ae;async function ae(Ve,Xe){const qe=await Xe.asString();if(Ve===O.$Vs.uriList)return{asString:qe,fileData:void 0,uriListData:J(qe)};const ut=Xe.asFile();return{asString:qe,fileData:ut?{name:ut.name,uri:ut.uri,id:ut._itemId??ut.id}:void 0}}pe.from=ae;function J(Ve){return M.$du.split(Ve).map(Xe=>{if(Xe.startsWith("#"))return Xe;try{return r.URI.parse(Xe)}catch{}return Xe})}function Me(Ve){return M.$du.create(Ve.map(Xe=>typeof Xe=="string"?Xe:r.URI.revive(Xe)))}})(zt||(e.DataTransferItem=zt={}));var Qe;(function(pe){function Ae(J,Me){const Ve=J.items.map(([Xe,qe])=>[Xe,zt.to(Xe,qe,Me)]);return new $.$gN(Ve)}pe.toDataTransfer=Ae;async function ae(J){const Me={items:[]},Ve=[];for(const[Xe,qe]of J)Ve.push((async()=>{Me.items.push([Xe,await zt.from(Xe,qe)])})());return await Promise.all(Ve),Me}pe.from=ae})(Qe||(e.DataTransfer=Qe={}));var ui;(function(pe){function Ae(J,Me){return{kind:"reply",agentId:J.participant??Me?.agentId??"",subCommand:J.command??Me?.command,message:J.prompt,title:J.label}}pe.from=Ae;function ae(J){return{prompt:J.message,label:J.title,participant:J.agentId,command:J.subCommand}}pe.to=ae})(ui||(e.ChatFollowup=ui={}));var Jt;(function(pe){function Ae(J){switch(J.role){case 0:return new $.$yO($.LanguageModelChatMessageRole.System,J.content);case 1:return new $.$yO($.LanguageModelChatMessageRole.User,J.content);case 2:return new $.$yO($.LanguageModelChatMessageRole.Assistant,J.content)}}pe.to=Ae;function ae(J){switch(J.role){case $.LanguageModelChatMessageRole.System:return{role:0,content:J.content};case $.LanguageModelChatMessageRole.User:return{role:1,content:J.content};case $.LanguageModelChatMessageRole.Assistant:return{role:2,content:J.content}}}pe.from=ae})(Jt||(e.LanguageModelChatMessage=Jt={}));var Ut;(function(pe){function Ae(J){return{kind:"markdownContent",content:ie.from(J.value)}}pe.from=Ae;function ae(J){return new $.$kO(ie.to(J.content))}pe.to=ae})(Ut||(e.ChatResponseMarkdownPart=Ut={}));var bt;(function(pe){function Ae(J){return{kind:"markdownVuln",content:ie.from(J.value),vulnerabilities:J.vulnerabilities}}pe.from=Ae;function ae(J){return new $.$lO(ie.to(J.content),J.vulnerabilities)}pe.to=ae})(bt||(e.ChatResponseMarkdownWithVulnerabilitiesPart=bt={}));var jt;(function(pe){function Ae(J){return{kind:"agentDetection",agentId:J.participant,command:J.command}}pe.from=Ae;function ae(J){return new $.$mO(J.agentId,J.command)}pe.to=ae})(jt||(e.ChatResponseDetectedParticipantPart=jt={}));var Mt;(function(pe){function Ae(ae){return{kind:"confirmation",title:ae.title,message:ae.message,data:ae.data}}pe.from=Ae})(Mt||(e.ChatResponseConfirmationPart=Mt={}));var At;(function(pe){function Ae(J){const{value:Me,baseUri:Ve}=J;function Xe(qe,ut){return qe.map(yt=>{const Lt=r.URI.joinPath(ut,yt.name);return{label:yt.name,uri:Lt,children:yt.children&&Xe(yt.children,Lt)}})}return{kind:"treeData",treeData:{label:(0,w.$9g)(Ve),uri:Ve,children:Xe(Me,Ve)}}}pe.from=Ae;function ae(J){const Me=(0,D.$8h)(J.treeData);function Ve(ut){return ut.map(yt=>({name:yt.label,children:yt.children&&Ve(yt.children)}))}const Xe=Me.uri,qe=Me.children?Ve(Me.children):[];return new $.$oO(qe,Xe)}pe.to=ae})(At||(e.ChatResponseFilesPart=At={}));var ei;(function(pe){function Ae(J){const Me=Ve=>r.URI.isUri(Ve);return{kind:"inlineReference",name:J.title,inlineReference:Me(J.value)?J.value:h.from(J.value)}}pe.from=Ae;function ae(J){const Me=(0,D.$8h)(J);return new $.$pO(r.URI.isUri(Me.inlineReference)?Me.inlineReference:h.to(Me.inlineReference),J.name)}pe.to=ae})(ei||(e.ChatResponseAnchorPart=ei={}));var Wt;(function(pe){function Ae(J){return{kind:"progressMessage",content:ie.from(J.value)}}pe.from=Ae;function ae(J){return new $.$qO(J.content.value)}pe.to=ae})(Wt||(e.ChatResponseProgressPart=Wt={}));var oi;(function(pe){function Ae(J){return{kind:"warning",content:ie.from(J.value)}}pe.from=Ae;function ae(J){return new $.$sO(J.content.value)}pe.to=ae})(oi||(e.ChatResponseWarningPart=oi={}));var Nt;(function(pe){function Ae(ae){return{kind:"progressTask",content:ie.from(ae.value)}}pe.from=Ae})(Nt||(e.ChatTask=Nt={}));var qt;(function(pe){function Ae(ae){return{kind:"progressTaskResult",content:typeof ae=="string"?ie.from(ae):void 0}}pe.from=Ae})(qt||(e.ChatTaskResult=qt={}));var Rt;(function(pe){function Ae(J,Me,Ve){return{kind:"command",command:Me.toInternal(J.value,Ve)??{command:J.value.command,title:J.value.title}}}pe.from=Ae;function ae(J,Me){return new $.$tO(Me.fromInternal(J.command)??{command:J.command.id,title:J.command.title})}pe.to=ae})(Rt||(e.ChatResponseCommandButtonPart=Rt={}));var St;(function(pe){function Ae(J){return{kind:"textEdit",uri:J.uri,edits:J.edits.map(Me=>se.from(Me))}}pe.from=Ae;function ae(J){return new $.$vO(r.URI.revive(J.uri),J.edits.map(Me=>se.to(Me)))}pe.to=ae})(St||(e.ChatResponseTextEditPart=St={}));var $t;(function(pe){function Ae(J){const Me=f.ThemeIcon.isThemeIcon(J.iconPath)?J.iconPath:r.URI.isUri(J.iconPath)?{light:r.URI.revive(J.iconPath)}:J.iconPath&&"light"in J.iconPath&&"dark"in J.iconPath&&r.URI.isUri(J.iconPath.light)&&r.URI.isUri(J.iconPath.dark)?{light:r.URI.revive(J.iconPath.light),dark:r.URI.revive(J.iconPath.dark)}:void 0;return"variableName"in J.value?{kind:"reference",reference:{variableName:J.value.variableName,value:r.URI.isUri(J.value.value)||!J.value.value?J.value.value:h.from(J.value.value)},iconPath:Me}:{kind:"reference",reference:r.URI.isUri(J.value)?J.value:h.from(J.value),iconPath:Me}}pe.from=Ae;function ae(J){const Me=(0,D.$8h)(J),Ve=Xe=>r.URI.isUri(Xe)?Xe:h.to(Xe);return new $.$uO("variableName"in Me.reference?{variableName:Me.reference.variableName,value:Me.reference.value&&Ve(Me.reference.value)}:Ve(Me.reference))}pe.to=ae})($t||(e.ChatResponseReferencePart=$t={}));var Dt;(function(pe){function Ae(Me,Ve,Xe){return Me instanceof $.$kO?Ut.from(Me):Me instanceof $.$pO?ei.from(Me):Me instanceof $.$uO?$t.from(Me):Me instanceof $.$qO?Wt.from(Me):Me instanceof $.$oO?At.from(Me):Me instanceof $.$tO?Rt.from(Me,Ve,Xe):Me instanceof $.$vO?St.from(Me):Me instanceof $.$lO?bt.from(Me):Me instanceof $.$mO?jt.from(Me):Me instanceof $.$sO?oi.from(Me):{kind:"markdownContent",content:ie.from("")}}pe.from=Ae;function ae(Me,Ve){switch(Me.kind){case"reference":return $t.to(Me);case"markdownContent":case"inlineReference":case"progressMessage":case"treeData":case"command":return J(Me,Ve)}}pe.to=ae;function J(Me,Ve){switch(Me.kind){case"markdownContent":return Ut.to(Me);case"inlineReference":return ei.to(Me);case"progressMessage":return;case"treeData":return At.to(Me);case"command":return Rt.to(Me,Ve)}}pe.toContent=J})(Dt||(e.ChatResponsePart=Dt={}));var ai;(function(pe){function Ae(ae){return{prompt:ae.message,command:ae.command,attempt:ae.attempt??0,enableCommandDetection:ae.enableCommandDetection??!0,references:ae.variables.variables.map(fi.to),location:kt.to(ae.location),acceptedConfirmationData:ae.acceptedConfirmationData,rejectedConfirmationData:ae.rejectedConfirmationData}}pe.to=Ae})(ai||(e.ChatAgentRequest=ai={}));var kt;(function(pe){function Ae(ae){switch(ae){case i.ChatAgentLocation.Notebook:return $.ChatLocation.Notebook;case i.ChatAgentLocation.Terminal:return $.ChatLocation.Terminal;case i.ChatAgentLocation.Panel:return $.ChatLocation.Panel;case i.ChatAgentLocation.Editor:return $.ChatLocation.Editor}}pe.to=Ae})(kt||(e.ChatLocation=kt={}));var fi;(function(pe){function Ae(ae){const J=ae.value;if(!J)throw new Error("Invalid value reference");return{id:ae.id,name:ae.name,range:ae.range&&[ae.range.start,ae.range.endExclusive],value:(0,r.$vc)(J)?r.URI.revive(J):J,modelDescription:ae.modelDescription}}pe.to=Ae})(fi||(e.ChatAgentValueReference=fi={}));var ni;(function(pe){function Ae(ae,J,Me){return{id:ae.id,label:ae.label,value:ae.values[0].value,insertText:ae.insertText,detail:ae.detail,documentation:ae.documentation,command:J.toInternal(ae.command,Me)}}pe.from=Ae})(ni||(e.ChatAgentCompletionItem=ni={}));var $i;(function(pe){function Ae(ae){return{errorDetails:ae.errorDetails,metadata:ae.metadata}}pe.to=Ae})($i||(e.ChatAgentResult=$i={}));var li;(function(pe){function Ae(ae,J,Me){if(J.action.kind==="vote")return;const Ve=$i.to(ae);if(J.action.kind==="command"){const Xe=J.action.commandButton.command;return{action:{kind:"command",commandButton:{command:Me.fromInternal(Xe)??{command:Xe.id,title:Xe.title}}},result:Ve}}else return J.action.kind==="followUp"?{action:{kind:"followUp",followup:ui.to(J.action.followup)},result:Ve}:J.action.kind==="inlineChat"?{action:{kind:"editor",accepted:J.action.action==="accepted"},result:Ve}:{action:J.action,result:Ve}}pe.to=Ae})(li||(e.ChatAgentUserActionEvent=li={}));var wi;(function(pe){function Ae(ae,J,Me){return"terminalCommand"in ae?{terminalCommand:ae.terminalCommand,shouldExecute:ae.shouldExecute}:"uri"in ae?{uri:ae.uri}:J.toInternal(ae,Me)}pe.from=Ae})(wi||(e.TerminalQuickFix=wi={}));var It;(function(pe){function Ae(ae){return{kind:Ei.to(ae.kind)}}pe.to=Ae})(It||(e.PartialAcceptInfo=It={}));var Ei;(function(pe){function Ae(ae){switch(ae){case 0:return $.PartialAcceptTriggerKind.Word;case 1:return $.PartialAcceptTriggerKind.Line;case 2:return $.PartialAcceptTriggerKind.Suggest;default:return $.PartialAcceptTriggerKind.Unknown}}pe.to=Ae})(Ei||(e.PartialAcceptTriggerKind=Ei={}));var ri;(function(pe){function Ae(ae,J){return{id:J,label:ae.label,description:ae.description,canEdit:ae.canEdit,collapsibleState:ae.collapsibleState||0,contextValue:ae.contextValue}}pe.from=Ae})(ri||(e.DebugTreeItem=ri={}))}),define(Se[263],Ie([1,0,4,17,8,34]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$hmc=void 0;let A=class{constructor(m,D){this.a=m.getProxy(C.$lM.MainThreadBulkEdits),this.b={getTextDocumentVersion:O=>D.getDocument(O)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(m,D,O){const S=new T.$Gw(M.WorkspaceEdit.from(m,this.b));return this.a.$tryApplyWorkspaceEdit(S,void 0,O?.isRefactoring??!1)}};e.$hmc=A,e.$hmc=A=Je([We(0,N.$PO)],A)}),define(Se[264],Ie([1,0,18,11,44,5,42,6,66,15,2,21,4,8,7,225,25]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$imc=void 0;class s{constructor(u,i,b,a,l){this.j=u,this.k=i,this.l=b,this.m=a,this.n=l,this.b=m.$be.create(!1),this.c=!1}close(){this.c=!0}get timings(){return{firstProgress:this.d,totalElapsed:this.b.elapsed()}}get apiObject(){if(!this.g){let i=function(a){if(u.c){const l=new Error("Response stream has been closed");throw Error.captureStackTrace(l,a),l}};const u=this;this.b.reset();const b=(a,l)=>{typeof this.d>"u"&&"content"in a&&(this.d=this.b.elapsed()),this.l.$handleProgressChunk(this.k.requestId,a).then(g=>{g&&l?.({report:$=>{if(f.$PM.isMarkdownString($.value)){this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseWarningPart.from($),g);return}else this.l.$handleProgressChunk(this.k.requestId,w.ChatResponseReferencePart.from($),g)}}).then($=>{typeof g=="number"&&this.l.$handleProgressChunk(this.k.requestId,w.ChatTaskResult.from($),g)})})};this.g={markdown(a){i(this.markdown);const l=new f.$kO(a),g=w.ChatResponseMarkdownPart.from(l);return b(g),this},markdownWithVulnerabilities(a,l){i(this.markdown),l&&(0,r.$MG)(u.j,"chatParticipantAdditions");const g=new f.$lO(a,l),$=w.ChatResponseMarkdownWithVulnerabilitiesPart.from(g);return b($),this},filetree(a,l){i(this.filetree);const g=new f.$oO(a,l),$=w.ChatResponseFilesPart.from(g);return b($),this},anchor(a,l){i(this.anchor);const g=new f.$pO(a,l),$=w.ChatResponseAnchorPart.from(g);return b($),this},button(a){i(this.anchor);const l=new f.$tO(a),g=w.ChatResponseCommandButtonPart.from(l,u.m,u.n);return b(g),this},progress(a,l){i(this.progress);const g=new f.$rO(a,l),$=l?w.ChatTask.from(g):w.ChatResponseProgressPart.from(g);return b($,l),this},warning(a){i(this.progress),(0,r.$MG)(u.j,"chatParticipantAdditions");const l=new f.$sO(a),g=w.ChatResponseWarningPart.from(l);return b(g),this},reference(a,l){if(i(this.reference),"variableName"in a&&(0,r.$MG)(u.j,"chatParticipantAdditions"),"variableName"in a&&!a.value){const g=u.k.variables.variables.find($=>$.name===a.variableName);if(g){let $;if(g.references?.length)$=g.references.map(v=>({kind:"reference",reference:{variableName:a.variableName,value:v.reference}}));else{const v=new f.$uO(a,l);$=[w.ChatResponseReferencePart.from(v)]}return $.forEach(v=>b(v)),this}}else{const g=new f.$uO(a,l),$=w.ChatResponseReferencePart.from(g);b($)}return this},textEdit(a,l){i(this.textEdit),(0,r.$MG)(u.j,"chatParticipantAdditions");const g=new f.$vO(a,l),$=w.ChatResponseTextEditPart.from(g);return b($),this},detectedParticipant(a,l){i(this.detectedParticipant),(0,r.$MG)(u.j,"chatParticipantAdditions");const g=new f.$mO(a,l),$=w.ChatResponseDetectedParticipantPart.from(g);return b($),this},confirmation(a,l,g){i(this.confirmation),(0,r.$MG)(u.j,"chatParticipantAdditions");const $=new f.$nO(a,l,g),v=w.ChatResponseConfirmationPart.from($);return b(v),this},push(a){if(i(this.push),(a instanceof f.$vO||a instanceof f.$lO||a instanceof f.$mO||a instanceof f.$sO||a instanceof f.$nO)&&(0,r.$MG)(u.j,"chatParticipantAdditions"),a instanceof f.$uO)this.reference(a.value,a.iconPath);else{const l=w.ChatResponsePart.from(a,u.m,u.n);b(l)}return this}}}return this.g}}class n extends p.$Uc{static{this.b=0}constructor(u,i,b){super(),this.n=i,this.s=b,this.c=new Map,this.j=this.B(new p.$4c),this.m=this.B(new p.$4c),this.g=u.getProxy(d.$lM.MainThreadChatAgents2)}transferActiveChat(u){this.g.$transferActiveChatSession(u)}createChatAgent(u,i,b){const a=n.b++,l=new t(u,i,this.g,a,b);return this.c.set(a,l),this.g.$registerAgent(a,u.identifier,i,{},void 0),l.apiAgent}createDynamicChatAgent(u,i,b,a){const l=n.b++,g=new t(u,i,this.g,l,a);return this.c.set(l,g),this.g.$registerAgent(l,u.identifier,i,{isSticky:!0},b),g.apiAgent}async $invokeAgent(u,i,b,a){const l=this.c.get(u);if(!l)throw new Error(`[CHAT](${u}) CANNOT invoke agent because the agent is not registered`);let g=this.j.get(i.sessionId);g||(g=new p.$Tc,this.j.set(i.sessionId,g));const $=new s(l.extension,i,this.g,this.s.converter,g);try{const v=await this.t(i.agentId,b),y=l.invoke(w.ChatAgentRequest.to(i),{history:v},$.apiObject,a);return await(0,N.$mh)(Promise.resolve(y).then(h=>{if(h?.metadata)try{JSON.stringify(h.metadata)}catch(k){const I=`result.metadata MUST be JSON.stringify-able. Got error: ${k.message}`;return this.n.error(`[${l.extension.identifier.value}] [@${l.id}] ${I}`,l.extension),{errorDetails:{message:I},timings:$.timings}}let E;return h?.errorDetails&&(E={...h.errorDetails,responseIsIncomplete:!0}),{errorDetails:E,timings:$.timings,metadata:h?.metadata}}),a)}catch(v){return this.n.error(v,l.extension),{errorDetails:{message:(0,M.$jj)(v),responseIsIncomplete:!0}}}finally{$.close()}}async t(u,i){const b=[];for(const a of i.history){const l=w.ChatAgentResult.to(a.result),g=u===a.request.agentId?l:{...l,metadata:void 0};b.push(new f.$wO(a.request.message,a.request.command,a.request.variables.variables.map(w.ChatAgentValueReference.to),a.request.agentId));const $=(0,C.$Hb)(a.response.map(v=>w.ChatResponsePart.toContent(v,this.s.converter)));b.push(new f.$xO($,g,a.request.agentId,a.request.command))}return b}$releaseSession(u){this.j.deleteAndDispose(u)}async $provideFollowups(u,i,b,a,l){const g=this.c.get(i);if(!g)return Promise.resolve([]);const $=await this.t(g.id,a),v=w.ChatAgentResult.to(b);return(await g.provideFollowups(v,{history:$},l)).filter(y=>{const h=!y.participant||A.Iterable.some(this.c.values(),E=>E.id===y.participant&&S.$Tm.equals(E.extension.identifier,g.extension.identifier));return h||this.n.warn(`[@${g.id}] ChatFollowup refers to an unknown participant: ${y.participant}`),h}).map(y=>w.ChatFollowup.from(y,u))}$acceptFeedback(u,i,b,a){const l=this.c.get(u);if(!l)return;const g=w.ChatAgentResult.to(i);let $;switch(b){case o.ChatAgentVoteDirection.Down:$=f.ChatResultFeedbackKind.Unhelpful;break;case o.ChatAgentVoteDirection.Up:$=f.ChatResultFeedbackKind.Helpful;break}l.acceptFeedback(Object.freeze(a?{result:g,kind:$,reportIssue:a}:{result:g,kind:$}))}$acceptAction(u,i,b){const a=this.c.get(u);if(!a||b.action.kind==="vote")return;const l=w.ChatAgentUserActionEvent.to(i,b,this.s.converter);l&&a.acceptAction(Object.freeze(l))}async $invokeCompletionProvider(u,i,b){const a=this.c.get(u);if(!a)return[];let l=this.m.get(u);return l?l.clear():(l=new p.$Tc,this.m.set(u,l)),(await a.invokeCompletionProvider(i,b)).map($=>w.ChatAgentCompletionItem.from($,this.s.converter,l))}async $provideWelcomeMessage(u,i,b){const a=this.c.get(u);if(a)return await a.provideWelcomeMessage(w.ChatLocation.to(i),b)}async $provideSampleQuestions(u,i,b){const a=this.c.get(u);if(a)return(await a.provideSampleQuestions(w.ChatLocation.to(i),b)).map(l=>w.ChatFollowup.from(l,void 0))}}e.$imc=n;class t{constructor(u,i,b,a,l){this.extension=u,this.id=i,this.u=b,this.w=a,this.x=l,this.m=new T.$fe,this.n=new T.$fe}acceptFeedback(u){this.m.fire(u)}acceptAction(u){this.n.fire(u)}async invokeCompletionProvider(u,i){return this.q?await this.q.provider.provideCompletionItems(u,i)??[]:[]}async provideFollowups(u,i,b){if(!this.b)return[];const a=await this.b.provideFollowups(u,i,b);return a?a.filter(l=>!(l&&"commandId"in l)).filter(l=>!(l&&"message"in l)):[]}async provideWelcomeMessage(u,i){if(!this.s)return[];const b=await this.s.provideWelcomeMessage(u,i);return b?b.map(a=>typeof a=="string"?a:w.MarkdownString.from(a)):[]}async provideSampleQuestions(u,i){if(!this.s||!this.s.provideSampleQuestions)return[];const b=await this.s.provideSampleQuestions(u,i);return b||[]}get apiAgent(){let u=!1,i=!1;const b=()=>{u||i||(i=!0,queueMicrotask(()=>{this.u.$updateAgent(this.w,{icon:this.c?this.c instanceof O.URI?this.c:"light"in this.c?this.c.light:void 0:void 0,iconDark:this.c&&"dark"in this.c?this.c.dark:void 0,themeIcon:this.c instanceof f.$kN?this.c:void 0,hasFollowups:this.b!==void 0,isSecondary:this.l,helpTextPrefix:!this.g||typeof this.g=="string"?this.g:w.MarkdownString.from(this.g),helpTextVariablesPrefix:!this.j||typeof this.j=="string"?this.j:w.MarkdownString.from(this.j),helpTextPostfix:!this.k||typeof this.k=="string"?this.k:w.MarkdownString.from(this.k),supportIssueReporting:this.o,requester:this.t}),i=!1}))},a=this;return{get id(){return a.id},get iconPath(){return a.c},set iconPath(l){a.c=l,b()},get requestHandler(){return a.x},set requestHandler(l){(0,D.$ig)(typeof l=="function","Invalid request handler"),a.x=l},get followupProvider(){return a.b},set followupProvider(l){a.b=l,b()},get isDefault(){return(0,r.$MG)(a.extension,"defaultChatParticipant"),a.d},set isDefault(l){(0,r.$MG)(a.extension,"defaultChatParticipant"),a.d=l,b()},get helpTextPrefix(){return(0,r.$MG)(a.extension,"defaultChatParticipant"),a.g},set helpTextPrefix(l){(0,r.$MG)(a.extension,"defaultChatParticipant"),a.g=l,b()},get helpTextVariablesPrefix(){return(0,r.$MG)(a.extension,"defaultChatParticipant"),a.j},set helpTextVariablesPrefix(l){(0,r.$MG)(a.extension,"defaultChatParticipant"),a.j=l,b()},get helpTextPostfix(){return(0,r.$MG)(a.extension,"defaultChatParticipant"),a.k},set helpTextPostfix(l){(0,r.$MG)(a.extension,"defaultChatParticipant"),a.k=l,b()},get isSecondary(){return(0,r.$MG)(a.extension,"defaultChatParticipant"),a.l},set isSecondary(l){(0,r.$MG)(a.extension,"defaultChatParticipant"),a.l=l,b()},get supportIssueReporting(){return(0,r.$MG)(a.extension,"chatParticipantAdditions"),a.o},set supportIssueReporting(l){(0,r.$MG)(a.extension,"chatParticipantAdditions"),a.o=l,b()},get onDidReceiveFeedback(){return a.m.event},set participantVariableProvider(l){if((0,r.$MG)(a.extension,"chatParticipantAdditions"),a.q=l,l){if(!l.triggerCharacters.length)throw new Error("triggerCharacters are required");a.u.$registerAgentCompletionsProvider(a.w,l.triggerCharacters)}else a.u.$unregisterAgentCompletionsProvider(a.w)},get participantVariableProvider(){return(0,r.$MG)(a.extension,"chatParticipantAdditions"),a.q},set welcomeMessageProvider(l){(0,r.$MG)(a.extension,"defaultChatParticipant"),a.s=l,b()},get welcomeMessageProvider(){return(0,r.$MG)(a.extension,"defaultChatParticipant"),a.s},onDidPerformAction:(0,r.$LG)(this.extension,"chatParticipantAdditions")?this.n.event:void 0,set requester(l){a.t=l,b()},get requester(){return a.t},dispose(){u=!0,a.b=void 0,a.m.dispose(),a.u.$unregisterAgent(a.w)}}}invoke(u,i,b,a){return this.x(u,i,b,a)}}}),define(Se[265],Ie([1,0,14,6,4,8,7,25]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jmc=void 0;class m{static{this.a=0}constructor(S){this.b=new Map,this.c=S.getProxy(M.$lM.MainThreadChatVariables)}async $resolveVariable(S,d,w,f){const o=this.b.get(S);if(o)try{if(o.resolver.resolve2){(0,p.$MG)(o.extension,"chatParticipantAdditions");const r=new D(d,this.c),s=await o.resolver.resolve2(o.data.name,{prompt:w},r.apiObject,f);if(s&&s[0])return s[0].value}else{const r=await o.resolver.resolve(o.data.name,{prompt:w},f);if(r&&r[0])return r[0].value}}catch(r){(0,C.$2)(r)}}registerVariableResolver(S,d,w,f,o,r){const s=m.a++;return this.b.set(s,{extension:S,data:{id:d,name:w,description:f,modelDescription:o},resolver:r}),this.c.$registerVariable(s,{id:d,name:w,description:f,modelDescription:o}),(0,N.$Sc)(()=>{this.b.delete(s),this.c.$unregisterVariable(s)})}}e.$jmc=m;class D{constructor(S,d){this.c=S,this.d=d,this.a=!1}close(){this.a=!0}get apiObject(){if(!this.b){let d=function(f){if(S.a){const o=new Error("Response stream has been closed");throw Error.captureStackTrace(o,f),o}};const S=this,w=f=>{this.d.$handleProgressChunk(this.c,f)};this.b={progress(f){d(this.progress);const o=new A.$qO(f),r=T.ChatResponseProgressPart.from(o);return w(r),this},reference(f){d(this.reference);const o=new A.$uO(f),r=T.ChatResponseReferencePart.from(o);return w(r),this},push(f){return d(this.push),f instanceof A.$uO?w(T.ChatResponseReferencePart.from(f)):f instanceof A.$qO&&w(T.ChatResponseProgressPart.from(f)),this}}}return this.b}}}),define(Se[266],Ie([1,0,11,69,5,6,2,89,21,8,7,4,25]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nmc=w;function w(f,o,r){const s=f.getProxy(S.$lM.MainThreadComments);class n{static{this.a=0}constructor(){this.b=new Map,this.c=new m.$Vm,o.registerArgumentProcessor({processArgument:v=>{if(v&&v.$mid===6){const y=this.b.get(v.handle);return y?y.value:v}else if(v&&v.$mid===7){const y=v,h=this.b.get(y.commentControlHandle);if(!h)return y;const E=h.getCommentThread(y.commentThreadHandle);return E?E.value:y}else if(v&&(v.$mid===9||v.$mid===8)){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);return h?v.$mid===8?h.value:{thread:h.value,text:v.text}:v}else if(v&&v.$mid===10){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const E=v.commentUniqueId,k=h.getCommentByUniqueId(E);return k||v}else if(v&&v.$mid===11){const y=this.b.get(v.thread.commentControlHandle);if(!y)return v;const h=y.getCommentThread(v.thread.commentThreadHandle);if(!h)return v;const E=v.text,k=v.commentUniqueId,I=h.getCommentByUniqueId(k);return I?(typeof I.body=="string"?I.body=E:I.body=new O.$PM(E),I):v}return v}})}createCommentController(v,y,h){const E=n.a++,k=new c(v,E,y,h);this.b.set(k.handle,k);const I=this.c.get(v.identifier)||[];return I.push(k),this.c.set(v.identifier,I),k.value}async $createCommentThreadTemplate(v,y,h,E){const k=this.b.get(v);k&&k.$createCommentThreadTemplate(y,h,E)}async $setActiveComment(v,y){const h=this.b.get(v);h&&h.$setActiveComment(y??void 0)}async $updateCommentThreadTemplate(v,y,h){const E=this.b.get(v);E&&E.$updateCommentThreadTemplate(y,h)}$deleteCommentThread(v,y){this.b.get(v)?.$deleteCommentThread(y)}async $provideCommentingRanges(v,y,h){const E=this.b.get(v);if(!E||!E.commentingRangeProvider)return Promise.resolve(void 0);const k=await r.ensureDocumentData(A.URI.revive(y));return(0,C.$qh)(async()=>{const I=await E.commentingRangeProvider.provideCommentingRanges(k.document,h);let P;return Array.isArray(I)?P={ranges:I,fileComments:!1}:I?P={ranges:I.ranges||[],fileComments:I.fileComments||!1}:P=I??void 0,P}).then(I=>{let P;return I&&(P={ranges:I.ranges.map(V=>D.Range.from(V)),fileComments:I.fileComments}),P})}$toggleReaction(v,y,h,E,k){const I=this.b.get(v);return!I||!I.reactionHandler?Promise.resolve(void 0):(0,C.$qh)(()=>{const P=I.getCommentThread(y);if(P){const V=P.getCommentByUniqueId(E.uniqueIdInThread);if(I!==void 0&&V&&I.reactionHandler)return I.reactionHandler(V,b(k))}return Promise.resolve(void 0)})}}class t{static{this.a=0}set threadId(v){this.n=v}get threadId(){return this.n}get id(){return this.n}get resource(){return this.o}get uri(){return this.o}set range(v){(v===void 0!=(this.p===void 0)||!v||!this.p||!v.isEqual(this.p))&&(this.p=v,this.b.range=v,this.c.fire())}get range(){return this.p}set canReply(v){this.d!==v&&(this.d=v,this.b.canReply=v,this.c.fire())}get canReply(){return this.d}get label(){return this.e}set label(v){this.e=v,this.b.label=v,this.c.fire()}get contextValue(){return this.f}set contextValue(v){this.f=v,this.b.contextValue=v,this.c.fire()}get comments(){return this.q}set comments(v){this.q=v,this.b.comments=v,this.c.fire()}get collapsibleState(){return this.g}set collapsibleState(v){this.g=v,this.b.collapsibleState=v,this.c.fire()}get state(){return this.h}set state(v){this.h=v,typeof v=="object"?((0,d.$MG)(this.extensionDescription,"commentThreadApplicability"),this.b.state=v.resolved,this.b.applicability=v.applicability):this.b.state=v,this.c.fire()}get isDisposed(){return this.j}constructor(v,y,h,E,k,I,P,V,W){this.m=y,this.n=h,this.o=E,this.p=k,this.q=I,this.extensionDescription=P,this.r=V,this.handle=t.a++,this.commentHandle=0,this.b=Object.create(null),this.c=new M.$fe,this.onDidUpdateCommentThread=this.c.event,this.d=!0,this.k=new Map,this.l=new T.$Vc,this.l.value=new T.$Tc,this.n===void 0&&(this.n=`${v}.${this.handle}`),s.$createCommentThread(y,this.handle,this.n,this.o,D.Range.from(this.p),P.identifier,this.r,W),this.i=[],this.j=!1,this.i.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=I,this.i.push({dispose:()=>{s.$deleteCommentThread(y,this.handle)}});const q=this;this.value={get uri(){return q.uri},get range(){return q.range},set range(R){q.range=R},get comments(){return q.comments},set comments(R){q.comments=R},get collapsibleState(){return q.collapsibleState},set collapsibleState(R){q.collapsibleState=R},get canReply(){return q.canReply},set canReply(R){q.canReply=R},get contextValue(){return q.contextValue},set contextValue(R){q.contextValue=R},get label(){return q.label},set label(R){q.label=R},get state(){return q.state},set state(R){q.state=R},dispose:()=>{q.dispose()}}}s(){this.r&&(this.r=!1,this.b.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this.j)return;this.s(),this.l.value||(this.l.value=new T.$Tc);const v=h=>Object.prototype.hasOwnProperty.call(this.b,h),y={};v("range")&&(y.range=D.Range.from(this.p)),v("label")&&(y.label=this.label),v("contextValue")&&(y.contextValue=this.contextValue??null),v("comments")&&(y.comments=this.q.map(h=>u(this,h,this.k,this.extensionDescription))),v("collapsibleState")&&(y.collapseState=a(this.g)),v("canReply")&&(y.canReply=this.canReply),v("state")&&(y.state=l(this.h)),v("applicability")&&(y.applicability=g(this.h)),v("isTemplate")&&(y.isTemplate=this.r),this.b={},s.$updateCommentThread(this.m,this.handle,this.n,this.o,y)}getCommentByUniqueId(v){for(const y of this.k){const h=y[0],E=y[1];if(v===E)return h}}dispose(){this.j=!0,this.l.dispose(),this.i.forEach(v=>v.dispose())}}Je([(0,N.$4h)(100)],t.prototype,"eventuallyUpdateCommentThread",null);class c{get id(){return this.j}get label(){return this.k}get handle(){return this.i}get commentingRangeProvider(){return this.b}set commentingRangeProvider(v){this.b=v,v?.resourceHints&&(0,d.$MG)(this.h,"commentingRangeHint"),s.$updateCommentingRanges(this.handle,v?.resourceHints)}get reactionHandler(){return this.c}set reactionHandler(v){this.c=v,s.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!v})}get options(){return this.d}set options(v){this.d=v,s.$updateCommentControllerFeatures(this.handle,{options:this.d})}get activeComment(){return(0,d.$MG)(this.h,"activeComment"),this.e}get activeCommentThread(){return(0,d.$MG)(this.h,"activeComment"),this.f}constructor(v,y,h,E){this.h=v,this.i=y,this.j=h,this.k=E,this.a=new Map,s.$registerCommentController(this.handle,h,E,this.h.identifier.value);const k=this;this.value=Object.freeze({id:k.id,label:k.label,get options(){return k.options},set options(I){k.options=I},get commentingRangeProvider(){return k.commentingRangeProvider},set commentingRangeProvider(I){k.commentingRangeProvider=I},get reactionHandler(){return k.reactionHandler},set reactionHandler(I){k.reactionHandler=I},get activeCommentThread(){return k.activeCommentThread},createCommentThread(I,P,V){return k.createCommentThread(I,P,V).value},dispose:()=>{k.dispose()}}),this.g=[],this.g.push({dispose:()=>{s.$unregisterCommentController(this.handle)}})}createCommentThread(v,y,h){y===void 0&&(0,d.$MG)(this.h,"fileComments");const E=new t(this.id,this.handle,void 0,v,y,h,this.h,!1);return this.a.set(E.handle,E),E}$setActiveComment(v){if(!v){this.e=void 0,this.f=void 0;return}const y=this.a.get(v.commentThreadHandle);y&&(this.e=v.uniqueIdInThread?y.getCommentByUniqueId(v.uniqueIdInThread):void 0,this.f=y)}$createCommentThreadTemplate(v,y,h){const E=new t(this.id,this.handle,void 0,A.URI.revive(v),D.Range.to(y),[],this.h,!0,h);return E.collapsibleState=p.CommentThreadCollapsibleState.Expanded,this.a.set(E.handle,E),E}$updateCommentThreadTemplate(v,y){const h=this.a.get(v);h&&(h.range=D.Range.to(y))}$deleteCommentThread(v){this.a.get(v)?.dispose(),this.a.delete(v)}getCommentThread(v){return this.a.get(v)}dispose(){this.a.forEach(v=>{v.dispose()}),this.g.forEach(v=>v.dispose())}}function u($,v,y,h){let E=y.get(v);return E||(E=++$.commentHandle,y.set(v,E)),v.state!==void 0&&(0,d.$MG)(h,"commentsDraftState"),v.reactions?.some(k=>k.reactors!==void 0)&&(0,d.$MG)(h,"commentReactor"),{mode:v.mode,contextValue:v.contextValue,uniqueIdInThread:E,body:typeof v.body=="string"?v.body:D.MarkdownString.from(v.body),userName:v.author.name,userIconPath:v.author.iconPath,label:v.label,commentReactions:v.reactions?v.reactions.map(k=>i(k)):void 0,state:v.state,timestamp:v.timestamp?.toJSON()}}function i($){return{label:$.label,iconPath:$.iconPath?D.$OO($.iconPath):void 0,count:$.count,hasReacted:$.authorHasReacted,reactors:$.reactors&&$.reactors.length>0&&typeof $.reactors[0]!="string"?$.reactors.map(v=>v.name):$.reactors}}function b($){return{label:$.label||"",count:$.count||0,iconPath:$.iconPath?A.URI.revive($.iconPath):"",authorHasReacted:$.hasReacted||!1,reactors:$.reactors?.map(v=>({name:v}))}}function a($){if($!==void 0)switch($){case O.CommentThreadCollapsibleState.Expanded:return p.CommentThreadCollapsibleState.Expanded;case O.CommentThreadCollapsibleState.Collapsed:return p.CommentThreadCollapsibleState.Collapsed}return p.CommentThreadCollapsibleState.Collapsed}function l($){let v;if(typeof $=="object"?v=$.resolved:v=$,v!==void 0)switch(v){case O.CommentThreadState.Unresolved:return p.CommentThreadState.Unresolved;case O.CommentThreadState.Resolved:return p.CommentThreadState.Resolved}return p.CommentThreadState.Unresolved}function g($){let v;if(typeof $=="object"&&(v=$.applicability),v!==void 0)switch(v){case O.CommentThreadApplicability.Current:return p.CommentThreadApplicability.Current;case O.CommentThreadApplicability.Outdated:return p.CommentThreadApplicability.Outdated}return p.CommentThreadApplicability.Current}return new n}}),define(Se[267],Ie([1,0,20,73,6,16,24,2,8,64,76,4,7]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Fmc=void 0;class w{constructor(b,a){this.document=b,this.b=a,this.a=1,this.c=new O.$6lc("custom documents")}addEdit(b){return this.c.add([b])}async undo(b,a){await this.f(b).undo(),a||this.disposeBackup()}async redo(b,a){await this.f(b).redo(),a||this.disposeBackup()}disposeEdits(b){for(const a of b)this.c.delete(a)}getNewBackupUri(){if(!this.b)throw new Error("Backup requires a valid storage path");const b=u(this.document.uri)+this.a++;return(0,A.$_g)(this.b,b)}updateBackup(b){this.d?.delete(),this.d=b}disposeBackup(){this.d?.delete(),this.d=void 0}f(b){const a=this.c.get(b,0);if(!a)throw new Error("No edit found");return a}}class f{constructor(){this.a=new Map}get(b,a){return this.a.get(this.b(b,a))}add(b,a,l){const g=this.b(b,a.uri);if(this.a.has(g))throw new Error(`Document already exists for viewType:${b} resource:${a.uri}`);const $=new w(a,l);return this.a.set(g,$),$}delete(b,a){const l=this.b(b,a.uri);this.a.delete(l)}b(b,a){return`${b}@@@${a}`}}var o;(function(i){i[i.Text=0]="Text",i[i.Custom=1]="Custom"})(o||(o={}));class r{constructor(){this.a=new Map}addTextProvider(b,a,l){return this.b(b,{type:0,extension:a,provider:l})}addCustomProvider(b,a,l){return this.b(b,{type:1,extension:a,provider:l})}get(b){return this.a.get(b)}b(b,a){if(this.a.has(b))throw new Error(`Provider for viewType:${b} already registered`);return this.a.set(b,a),new d.$nM(()=>this.a.delete(b))}}class s{constructor(b,a,l,g,$){this.d=a,this.f=l,this.g=g,this.h=$,this.b=new r,this.c=new f,this.a=b.getProxy(S.$lM.MainThreadCustomEditors)}registerCustomEditorProvider(b,a,l,g){const $=new M.$Tc;return t(l)?($.add(this.b.addTextProvider(a,b,l)),this.a.$registerTextEditorProvider((0,D.$Cmc)(b),a,g.webviewOptions||{},{supportsMove:!!l.moveCustomTextEditor},(0,D.$Amc)(b))):($.add(this.b.addCustomProvider(a,b,l)),n(l)&&$.add(l.onDidChangeCustomDocument(v=>{const y=this.i(a,v.document.uri);if(c(v)){const h=y.addEdit(v);this.a.$onDidEdit(v.document.uri,a,h,v.label)}else this.a.$onContentChange(v.document.uri,a)})),this.a.$registerCustomEditorProvider((0,D.$Cmc)(b),a,g.webviewOptions||{},!!g.supportsMultipleEditorsPerDocument,(0,D.$Amc)(b))),d.$nM.from($,new d.$nM(()=>{this.a.$unregisterEditorProvider(a)}))}async $createCustomDocument(b,a,l,g,$){const v=this.b.get(a);if(!v)throw new Error(`No provider found for '${a}'`);if(v.type!==1)throw new Error(`Invalid provide type for '${a}'`);const y=p.URI.revive(b),h=await v.provider.openCustomDocument(y,{backupId:l,untitledDocumentData:g?.buffer},$);let E;return n(v.provider)&&this.f&&(E=this.f.workspaceValue(v.extension)??this.f.globalValue(v.extension)),this.c.add(a,h,E),{editable:n(v.provider)}}async $disposeCustomDocument(b,a){const l=this.b.get(a);if(!l)throw new Error(`No provider found for '${a}'`);if(l.type!==1)throw new Error(`Invalid provider type for '${a}'`);const g=p.URI.revive(b),{document:$}=this.i(a,g);this.c.delete(a,$),$.dispose()}async $resolveCustomEditor(b,a,l,g,$,v){const y=this.b.get(l);if(!y)throw new Error(`No provider found for '${l}'`);const h=m.ViewColumn.to($),E=this.g.createNewWebview(a,g.contentOptions,y.extension),k=this.h.createNewWebviewPanel(a,l,g.title,h,g.options,E,g.active),I=p.URI.revive(b);switch(y.type){case 1:{const{document:P}=this.i(l,I);return y.provider.resolveCustomEditor(P,k,v)}case 0:{const P=this.d.getDocument(I);return y.provider.resolveCustomTextEditor(P,k,v)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(b,a,l){this.i(a,b).disposeEdits(l)}async $onMoveCustomEditor(b,a,l){const g=this.b.get(l);if(!g)throw new Error(`No provider found for '${l}'`);if(!g.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${l}'`);const $=this.h.getWebviewPanel(b);if(!$)throw new Error("No webview found");const v=p.URI.revive(a),y=this.d.getDocument(v);await g.provider.moveCustomTextEditor(y,$,C.CancellationToken.None)}async $undo(b,a,l,g){return this.i(a,b).undo(l,g)}async $redo(b,a,l,g){return this.i(a,b).redo(l,g)}async $revert(b,a,l){const g=this.i(a,b);await this.j(a).revertCustomDocument(g.document,l),g.disposeBackup()}async $onSave(b,a,l){const g=this.i(a,b);await this.j(a).saveCustomDocument(g.document,l),g.disposeBackup()}async $onSaveAs(b,a,l,g){const $=this.i(a,b);return this.j(a).saveCustomDocumentAs($.document,p.URI.revive(l),g)}async $backup(b,a,l){const g=this.i(a,b),v=await this.j(a).backupCustomDocument(g.document,{destination:g.getNewBackupUri()},l);return g.updateBackup(v),v.id}i(b,a){const l=this.c.get(b,p.URI.revive(a));if(!l)throw new Error("No custom document found");return l}j(b){const l=this.b.get(b)?.provider;if(!l||!n(l))throw new Error("Custom document is not editable");return l}}e.$Fmc=s;function n(i){return!!i.onDidChangeCustomDocument}function t(i){return typeof i.resolveCustomTextEditor=="function"}function c(i){return typeof i.undo=="function"&&typeof i.redo=="function"}function u(i){const b=i.scheme===T.Schemas.file||i.scheme===T.Schemas.untitled?i.fsPath:i.toString();return(0,N.$mj)(b)+""}}),define(Se[268],Ie([1,0,172,101,2,4,7,8,5,12,28,47]),function(le,e,C,N,M,T,A,p,m,D,O,S){"use strict";var d;Object.defineProperty(e,"__esModule",{value:!0}),e.$bmc=e.$amc=void 0;class w{#e;#t;#i;constructor(r,s,n,t,c,u,i,b){this.d=r,this.e=s,this.f=n,this.g=t,this.h=c,this.c=!1,this.f=Math.max(t,n),this.#i=new O.$Ac(a=>u.getComparisonKey(a)),this.#e=i,this.#t=b}dispose(){this.c||(this.#t.fire([...this.#i.keys()]),this.#e?.$clear(this.e),this.#i.clear(),this.c=!0)}get name(){return this.j(),this.d}set(r,s){if(!r){this.clear();return}this.j();let n=[];if(M.URI.isUri(r)){if(!s){this.delete(r);return}this.#i.set(r,s.slice()),n=[r]}else if(Array.isArray(r)){n=[];let u;r=[...r].sort(w.k);for(const i of r){const[b,a]=i;if((!u||b.toString()!==u.toString())&&(u&&this.#i.get(u).length===0&&this.#i.delete(u),u=b,n.push(b),this.#i.set(b,[])),a)this.#i.get(b)?.push(...a);else{const l=this.#i.get(b);l&&(l.length=0)}}}if(this.#t.fire(n),!this.#e)return;const t=[];let c=0;for(const u of n){let i=[];const b=this.#i.get(u);if(b)if(b.length>this.g){i=[];const a=[A.DiagnosticSeverity.Error,A.DiagnosticSeverity.Warning,A.DiagnosticSeverity.Information,A.DiagnosticSeverity.Hint];e:for(let l=0;l<4;l++)for(const g of b)if(g.severity===a[l]&&i.push({...p.Diagnostic.from(g),modelVersionId:this.h(u)})===this.g)break e;i.push({severity:N.MarkerSeverity.Info,message:(0,C.localize)(0,null,b.length-this.g),startLineNumber:i[i.length-1].startLineNumber,startColumn:i[i.length-1].startColumn,endLineNumber:i[i.length-1].endLineNumber,endColumn:i[i.length-1].endColumn})}else i=b.map(a=>({...p.Diagnostic.from(a),modelVersionId:this.h(u)}));if(t.push([u,i]),c+=i.length,c>this.f)break}this.#e.$changeMany(this.e,t)}delete(r){this.j(),this.#t.fire([r]),this.#i.delete(r),this.#e?.$changeMany(this.e,[[r,void 0]])}clear(){this.j(),this.#t.fire([...this.#i.keys()]),this.#i.clear(),this.#e?.$clear(this.e)}forEach(r,s){this.j();for(const[n,t]of this)r.call(s,n,t,this)}*[Symbol.iterator](){this.j();for(const r of this.#i.keys())yield[r,this.get(r)]}get(r){this.j();const s=this.#i.get(r);return Array.isArray(s)?Object.freeze(s.slice(0)):[]}has(r){return this.j(),Array.isArray(this.#i.get(r))}j(){if(this.c)throw new Error("illegal state - object is disposed")}static k(r,s){return r[0].toString()<s[0].toString()?-1:r[0].toString()>s[0].toString()?1:0}}e.$amc=w;let f=class{static{d=this}static{this.c=0}static{this.d=1e3}static{this.e=1.1*d.d}static _mapper(r){const s=new O.$Ac;for(const n of r)s.set(n,n);return{uris:Object.freeze(Array.from(s.values()))}}constructor(r,s,n,t){this.j=s,this.k=n,this.l=t,this.g=new Map,this.h=new m.$je({merge:c=>c.flat(),delay:50}),this.onDidChangeDiagnostics=m.Event.map(this.h.event,d._mapper),this.f=r.getProxy(T.$lM.MainThreadDiagnostics)}createDiagnosticCollection(r,s){const{g:n,f:t,h:c,j:u,k:i,l:b}=this,a=new class{$changeMany($,v){t.$changeMany($,v),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",r.value,$,v.length===0?"CLEARING":v)}$clear($){t.$clear($),u.trace("[DiagnosticCollection] remove all (extension, owner)",r.value,$)}dispose(){t.dispose()}};let l;if(!s)s="_generated_diagnostic_collection_name_#"+d.c++,l=s;else if(!n.has(s))l=s;else{this.j.warn(`DiagnosticCollection with name '${s}' does already exist.`);do l=s+d.c++;while(n.has(l))}return new class extends w{constructor(){super(s,l,d.e,d.d,$=>b.getDocument($)?.version,i.extUri,a,c),n.set(l,this)}dispose(){super.dispose(),n.delete(l)}}}getDiagnostics(r){if(r)return this.m(r);{const s=new Map,n=[];for(const t of this.g.values())t.forEach((c,u)=>{let i=s.get(c.toString());typeof i>"u"&&(i=n.length,s.set(c.toString(),i),n.push([c,[]])),n[i][1]=n[i][1].concat(...u)});return n}}m(r){let s=[];for(const n of this.g.values())n.has(r)&&(s=s.concat(n.get(r)));return s}$acceptMarkersChange(r){if(!this.n){const s="_generated_mirror",n=new w(s,s,Number.MAX_SAFE_INTEGER,Number.MAX_SAFE_INTEGER,t=>{},this.k.extUri,void 0,this.h);this.g.set(s,n),this.n=n}for(const[s,n]of r)this.n.set(M.URI.revive(s),n.map(p.Diagnostic.to))}};e.$bmc=f,e.$bmc=f=d=Je([We(1,D.$5j),We(2,S.$_lc)],f)}),define(Se[269],Ie([1,0,2,14,7,8,200,34]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jnc=void 0;class m{constructor(O,S,d,w={timeout:1500,errors:3}){this.c=O,this.d=S,this.f=d,this.g=w,this.a=new A.$5c,this.b=new WeakMap}dispose(){this.a.clear()}getOnWillSaveTextDocumentEvent(O){return(S,d,w)=>{const o={dispose:this.a.push([S,d,O])};return Array.isArray(w)&&w.push(o),o}}async $participateInSave(O,S){const d=C.URI.revive(O);let w=!1;const f=setTimeout(()=>w=!0,this.g.timeout),o=[];try{for(const r of[...this.a]){if(w)break;const s=this.d.getDocument(d),n=await this.h(r,{document:s,reason:T.TextDocumentSaveReason.to(S)});o.push(n)}}finally{clearTimeout(f)}return o}h([O,S,d],w){const f=this.b.get(O);return typeof f=="number"&&f>this.g.errors?Promise.resolve(!1):this.i(d,O,S,w).then(()=>!0,o=>{if(this.c.error(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' threw ERROR`),this.c.error(o),!(o instanceof Error)||o.message!=="concurrent_edits"){const r=this.b.get(O);this.b.set(O,r?r+1:1),typeof r=="number"&&r>this.g.errors&&this.c.info(`onWillSaveTextDocument-listener from extension '${d.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}i(O,S,d,w){const f=[],o=Date.now(),{document:r,reason:s}=w,{version:n}=r,t=Object.freeze({document:r,reason:s,waitUntil(c){if(Object.isFrozen(f))throw(0,N.$8)("waitUntil can not be called async");f.push(Promise.resolve(c))}});try{S.apply(d,[t])}catch(c){return Promise.reject(c)}return Object.freeze(f),new Promise((c,u)=>{const i=setTimeout(()=>u(new Error("timeout")),this.g.timeout);return Promise.all(f).then(b=>{this.c.debug(`onWillSaveTextDocument-listener from extension '${O.identifier.value}' finished after ${Date.now()-o}ms`),clearTimeout(i),c(b)}).catch(b=>{clearTimeout(i),u(b)})}).then(c=>{const u={edits:[]};for(const i of c)if(Array.isArray(i)&&i.every(b=>b instanceof M.$uM))for(const{newText:b,newEol:a,range:l}of i)u.edits.push({resource:r.uri,versionId:void 0,textEdit:{range:l&&T.Range.from(l),text:b,eol:a&&T.EndOfLine.from(a)}});if(u.edits.length!==0)return n===r.version?this.f.$tryApplyWorkspaceEdit(new p.$Gw(u)):Promise.reject(new Error("concurrent_edits"))})}}e.$jnc=m}),define(Se[270],Ie([1,0,5,6,2,4,113,8,15,26,7]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$cmc=void 0;class S{constructor(w,f){this.a=new C.$fe,this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.onDidAddDocument=this.a.event,this.onDidRemoveDocument=this.b.event,this.onDidChangeDocument=this.c.event,this.onDidSaveDocument=this.d.event,this.e=new N.$Tc,this.h=new Map,this.f=w.getProxy(T.$lM.MainThreadDocuments),this.g=f,this.g.onDidRemoveDocuments(o=>{for(const r of o)this.b.fire(r.document)},void 0,this.e),this.g.onDidAddDocuments(o=>{for(const r of o)this.a.fire(r.document)},void 0,this.e)}dispose(){this.e.dispose()}getAllDocumentData(){return[...this.g.allDocuments()]}getDocumentData(w){if(!w)return;const f=this.g.getDocument(w);if(f)return f}getDocument(w){const f=this.getDocumentData(w);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${w}'`);return f.document}ensureDocumentData(w){const f=this.g.getDocument(w);if(f)return Promise.resolve(f);let o=this.h.get(w.toString());return o||(o=this.f.$tryOpenDocument(w).then(r=>{this.h.delete(w.toString());const s=M.URI.revive(r);return(0,m.$jg)(this.g.getDocument(s))},r=>(this.h.delete(w.toString()),Promise.reject(r))),this.h.set(w.toString(),o)),o}createDocumentData(w){return this.f.$tryCreateDocument(w).then(f=>M.URI.revive(f))}$acceptModelLanguageChanged(w,f){const o=M.URI.revive(w),r=this.g.getDocument(o);if(!r)throw new Error("unknown document");this.b.fire(r.document),r._acceptLanguageId(f),this.a.fire(r.document)}$acceptModelSaved(w){const f=M.URI.revive(w),o=this.g.getDocument(f);if(!o)throw new Error("unknown document");this.$acceptDirtyStateChanged(w,!1),this.d.fire(o.document)}$acceptDirtyStateChanged(w,f){const o=M.URI.revive(w),r=this.g.getDocument(o);if(!r)throw new Error("unknown document");r._acceptIsDirty(f),this.c.fire({document:r.document,contentChanges:[],reason:void 0})}$acceptModelChanged(w,f,o){const r=M.URI.revive(w),s=this.g.getDocument(r);if(!s)throw new Error("unknown document");s._acceptIsDirty(o),s.onEvents(f);let n;f.isUndoing?n=O.TextDocumentChangeReason.Undo:f.isRedoing&&(n=O.TextDocumentChangeReason.Redo),this.c.fire((0,D.$6n)({document:s.document,contentChanges:f.changes.map(t=>({range:p.Range.to(t.range),rangeOffset:t.rangeOffset,rangeLength:t.rangeLength,text:t.text})),reason:n}))}setWordDefinitionFor(w,f){(0,A.$RO)(w,f)}}e.$cmc=S}),define(Se[67],Ie([1,0,271,5,15,2,3,4,17,8,7]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hmc=e.$Gmc=void 0,e.$Gmc=(0,A.$yi)("IExtHostEditorTabs");class S{constructor(r,s,n){this.e=n,this.d=s,this.acceptDtoUpdate(r)}get apiObject(){if(!this.a){const r=this,s={get isActive(){return r.b.id===r.e()},get label(){return r.b.label},get input(){return r.c},get isDirty(){return r.b.isDirty},get isPinned(){return r.b.isPinned},get isPreview(){return r.b.isPreview},get group(){return r.d.apiObject}};this.a=Object.freeze(s)}return this.a}get tabId(){return this.b.id}acceptDtoUpdate(r){this.b=r,this.c=this.f()}f(){switch(this.b.input.kind){case 1:return new O.$$N(T.URI.revive(this.b.input.uri));case 2:return new O.$_N(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified));case 3:return new O.$aO(T.URI.revive(this.b.input.base),T.URI.revive(this.b.input.input1),T.URI.revive(this.b.input.input2),T.URI.revive(this.b.input.result));case 6:return new O.$bO(T.URI.revive(this.b.input.uri),this.b.input.viewType);case 7:return new O.$cO(this.b.input.viewType);case 4:return new O.$dO(T.URI.revive(this.b.input.uri),this.b.input.notebookType);case 5:return new O.$eO(T.URI.revive(this.b.input.original),T.URI.revive(this.b.input.modified),this.b.input.notebookType);case 8:return new O.$fO;case 9:return new O.$gO(T.URI.revive(this.b.input.uri),T.URI.revive(this.b.input.inputBoxUri));case 10:return new O.$hO;case 11:return new O.$iO(this.b.input.diffEditors.map(r=>new O.$_N(T.URI.revive(r.original),T.URI.revive(r.modified))));default:return}}}class d{constructor(r,s){this.c=[],this.d="",this.b=r,this.e=s;for(const n of r.tabs)n.isActive&&(this.d=n.id),this.c.push(new S(n,this,()=>this.activeTabId()))}get apiObject(){if(!this.a){const r=this,s={get isActive(){return r.b.groupId===r.e()},get viewColumn(){return D.ViewColumn.to(r.b.viewColumn)},get activeTab(){return r.c.find(n=>n.tabId===r.d)?.apiObject},get tabs(){return Object.freeze(r.c.map(n=>n.apiObject))}};this.a=Object.freeze(s)}return this.a}get groupId(){return this.b.groupId}get tabs(){return this.c}acceptGroupDtoUpdate(r){this.b=r}acceptTabOperation(r){if(r.kind===0){const n=new S(r.tabDto,this,()=>this.activeTabId());return this.c.splice(r.index,0,n),r.tabDto.isActive&&(this.d=n.tabId),n}else if(r.kind===1){const n=this.c.splice(r.index,1)[0];if(!n)throw new Error(`Tab close updated received for index ${r.index} which does not exist`);return n.tabId===this.d&&(this.d=""),n}else if(r.kind===3){if(r.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const n=this.c.splice(r.oldIndex,1)[0];if(!n)throw new Error(`Tab move updated received for index ${r.oldIndex} which does not exist`);return this.c.splice(r.index,0,n),n}const s=this.c.find(n=>n.tabId===r.tabDto.id);if(!s)throw new Error("INVALID tab");return r.tabDto.isActive?this.d=r.tabDto.id:this.d===r.tabDto.id&&!r.tabDto.isActive&&(this.d=""),s.acceptDtoUpdate(r.tabDto),s}activeTabId(){return this.d}}let w=class{constructor(r){this.b=new N.$fe,this.c=new N.$fe,this.e=[],this.a=r.getProxy(p.$lM.MainThreadEditorTabs)}get tabGroups(){if(!this.f){const r=this,s={onDidChangeTabGroups:r.c.event,onDidChangeTabs:r.b.event,get all(){return Object.freeze(r.e.map(n=>n.apiObject))},get activeTabGroup(){const n=r.d;return(0,M.$jg)(r.e.find(c=>c.groupId===n)?.apiObject)},close:async(n,t)=>{const c=Array.isArray(n)?n:[n];return c.length?f(c[0])?this.j(c,t):this.i(c,t):!0}};this.f=Object.freeze(s)}return this.f}$acceptEditorTabModel(r){const s=new Set(this.e.map(a=>a.groupId)),n=new Set(r.map(a=>a.groupId)),t=(0,C.$L)(s,n),c=this.e.filter(a=>t.removed.includes(a.groupId)).map(a=>a.apiObject),u=[],i=[];this.e=r.map(a=>{const l=new d(a,()=>this.d);return t.added.includes(l.groupId)?u.push(l.apiObject):i.push(l.apiObject),l});const b=(0,M.$jg)(r.find(a=>a.isActive===!0)?.groupId);b!==void 0&&this.d!==b&&(this.d=b),this.c.fire(Object.freeze({opened:u,closed:c,changed:i}))}$acceptTabGroupUpdate(r){const s=this.e.find(n=>n.groupId===r.groupId);if(!s)throw new Error("Update Group IPC call received before group creation.");s.acceptGroupDtoUpdate(r),r.isActive&&(this.d=r.groupId),this.c.fire(Object.freeze({changed:[s.apiObject],opened:[],closed:[]}))}$acceptTabOperation(r){const s=this.e.find(t=>t.groupId===r.groupId);if(!s)throw new Error("Update Tabs IPC call received before group creation.");const n=s.acceptTabOperation(r);switch(r.kind){case 0:this.b.fire(Object.freeze({opened:[n.apiObject],closed:[],changed:[]}));return;case 1:this.b.fire(Object.freeze({opened:[],closed:[n.apiObject],changed:[]}));return;case 3:case 2:this.b.fire(Object.freeze({opened:[],closed:[],changed:[n.apiObject]}));return}}g(r){for(const s of this.e)for(const n of s.tabs)if(n.apiObject===r)return n}h(r){return this.e.find(s=>s.apiObject===r)}async i(r,s){const n=[];for(const t of r){const c=this.g(t);if(!c)throw new Error("Tab close: Invalid tab not found!");n.push(c.tabId)}return this.a.$closeTab(n,s)}async j(r,s){const n=[];for(const t of r){const c=this.h(t);if(!c)throw new Error("Group close: Invalid group not found!");n.push(c.groupId)}return this.a.$closeGroup(n,s)}};e.$Hmc=w,e.$Hmc=w=Je([We(0,m.$PO)],w);function f(o){return o.tabs!==void 0}}),define(Se[272],Ie([1,0,2,4,6,7,8,314,13,22,25,55]),function(le,e,C,N,M,T,A,p,m,D,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$mnc=void 0;class d{constructor(){this.a=[]}add(o){this.b=void 0,this.a.push(o)}delete(o){const r=this.a.indexOf(o);r>=0&&(this.a.splice(r,1),this.b=void 0)}c(){if(!this.b){const o=this.a.sort(),r=[];let s,n,t=14,c=14;for(const u of o){let i=s?(0,m.$Bf)(s,u):0;for(i===0?n=1:n=c;i<u.length;i++)i+1===u.length?(t=c,c=9):c+=1,r.push([n,u.toUpperCase().charCodeAt(i),c]),r.push([n,u.toLowerCase().charCodeAt(i),c]),n=c;s=u,c=t}r.push([9,58,10]),r.push([10,47,12]),this.b=new p.$L2(r)}}provideDocumentLinks(o){this.c();const r=[],s=p.$M2.computeLinks({getLineContent(n){return o.lineAt(n-1).text},getLineCount(){return o.lineCount}},this.b);for(const n of s){const t=A.DocumentLink.to(n);t.target&&r.push(t)}return r}}class w{constructor(o,r){this.i=r,this.b=new d,this.c=new Map,this.d=new Set,this.f=new Map,this.h=0,this.a=o.getProxy(N.$lM.MainThreadFileSystem)}dispose(){this.g?.dispose()}registerFileSystemProvider(o,r,s,n={}){if(w.j(s),this.d.has(r))throw new Error(`a provider for the scheme '${r}' is already registered`);this.g||(this.g=this.i.registerDocumentLinkProvider(o,"*",this.b));const t=this.h++;this.b.add(r),this.d.add(r),this.c.set(t,s);let c=2;n.isCaseSensitive&&(c+=1024),n.isReadonly&&(c+=2048),typeof s.copy=="function"&&(c+=8),typeof s.open=="function"&&typeof s.close=="function"&&typeof s.read=="function"&&typeof s.write=="function"&&((0,O.$MG)(o,"fsChunks"),c+=4);let u;n.isReadonly&&(0,S.$Xk)(n.isReadonly)&&n.isReadonly.value!==""&&(u={value:n.isReadonly.value,isTrusted:n.isReadonly.isTrusted,supportThemeIcons:n.isReadonly.supportThemeIcons,supportHtml:n.isReadonly.supportHtml,baseUri:n.isReadonly.baseUri,uris:n.isReadonly.uris}),this.a.$registerFileSystemProvider(t,r,c,u).catch(b=>{console.error(`FAILED to register filesystem provider of ${o.identifier.value}-extension for the scheme ${r}`),console.error(b)});const i=s.onDidChangeFile(b=>{const a=[];for(const l of b){const{uri:g,type:$}=l;if(g.scheme!==r)continue;let v;switch($){case T.FileChangeType.Changed:v=0;break;case T.FileChangeType.Created:v=1;break;case T.FileChangeType.Deleted:v=2;break;default:throw new Error("Unknown FileChangeType")}a.push({resource:g,type:v})}this.a.$onFileSystemChange(t,a)});return(0,M.$Sc)(()=>{i.dispose(),this.b.delete(r),this.d.delete(r),this.c.delete(t),this.a.$unregisterProvider(t)})}static j(o){if(!o)throw new Error("MISSING provider");if(typeof o.watch!="function")throw new Error("Provider does NOT implement watch");if(typeof o.stat!="function")throw new Error("Provider does NOT implement stat");if(typeof o.readDirectory!="function")throw new Error("Provider does NOT implement readDirectory");if(typeof o.createDirectory!="function")throw new Error("Provider does NOT implement createDirectory");if(typeof o.readFile!="function")throw new Error("Provider does NOT implement readFile");if(typeof o.writeFile!="function")throw new Error("Provider does NOT implement writeFile");if(typeof o.delete!="function")throw new Error("Provider does NOT implement delete");if(typeof o.rename!="function")throw new Error("Provider does NOT implement rename")}static k(o){const{type:r,ctime:s,mtime:n,size:t,permissions:c}=o;return{type:r,ctime:s,mtime:n,size:t,permissions:c}}$stat(o,r){return Promise.resolve(this.l(o).stat(C.URI.revive(r))).then(s=>w.k(s))}$readdir(o,r){return Promise.resolve(this.l(o).readDirectory(C.URI.revive(r)))}$readFile(o,r){return Promise.resolve(this.l(o).readFile(C.URI.revive(r))).then(s=>D.$He.wrap(s))}$writeFile(o,r,s,n){return Promise.resolve(this.l(o).writeFile(C.URI.revive(r),s.buffer,n))}$delete(o,r,s){return Promise.resolve(this.l(o).delete(C.URI.revive(r),s))}$rename(o,r,s,n){return Promise.resolve(this.l(o).rename(C.URI.revive(r),C.URI.revive(s),n))}$copy(o,r,s,n){const t=this.l(o);if(!t.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(t.copy(C.URI.revive(r),C.URI.revive(s),n))}$mkdir(o,r){return Promise.resolve(this.l(o).createDirectory(C.URI.revive(r)))}$watch(o,r,s,n){const t=this.l(o).watch(C.URI.revive(s),n);this.f.set(r,t)}$unwatch(o,r){const s=this.f.get(r);s&&(s.dispose(),this.f.delete(r))}$open(o,r,s){const n=this.l(o);if(!n.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(n.open(C.URI.revive(r),s))}$close(o,r){const s=this.l(o);if(!s.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(s.close(r))}$read(o,r,s,n){const t=this.l(o);if(!t.read)throw new Error('FileSystemProvider does not implement "read"');const c=D.$He.alloc(n);return Promise.resolve(t.read(r,s,c.buffer,0,n)).then(u=>c.slice(0,u))}$write(o,r,s,n){const t=this.l(o);if(!t.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(t.write(r,s,n.buffer,0,n.byteLength))}l(o){const r=this.c.get(o);if(!r){const s=new Error;throw s.name="ENOPRO",s.message="no provider",s}return r}}e.$mnc=w}),define(Se[273],Ie([1,0,5,37,2,4,8,7,43]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nnc=void 0;class D{get ignoreCreateEvents(){return!!(this.h&1)}get ignoreChangeEvents(){return!!(this.h&2)}get ignoreDeleteEvents(){return!!(this.h&4)}constructor(w,f,o,r,s,n){this.a=Math.random(),this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.h=0,n?.ignoreCreateEvents&&(this.h+=1),n?.ignoreChangeEvents&&(this.h+=2),n?.ignoreDeleteEvents&&(this.h+=4);const t=(0,N.$sk)(s),c=typeof s=="string",u=n?.correlate,i=r(b=>{if(!(typeof b.session=="number"&&b.session!==this.a)&&!(u&&typeof b.session>"u")){if(!n?.ignoreCreateEvents)for(const a of b.created){const l=M.URI.revive(a);t(l.fsPath)&&(!c||f.getWorkspaceFolder(l))&&this.b.fire(l)}if(!n?.ignoreChangeEvents)for(const a of b.changed){const l=M.URI.revive(a);t(l.fsPath)&&(!c||f.getWorkspaceFolder(l))&&this.c.fire(l)}if(!n?.ignoreDeleteEvents)for(const a of b.deleted){const l=M.URI.revive(a);t(l.fsPath)&&(!c||f.getWorkspaceFolder(l))&&this.d.fire(l)}}});this.g=p.$nM.from(this.i(w,o,s,n,n?.correlate),this.b,this.c,this.d,i)}i(w,f,o,r,s){const n=p.$nM.from();if(typeof o=="string"||r?.ignoreChangeEvents&&r?.ignoreCreateEvents&&r?.ignoreDeleteEvents)return n;const t=w.getProxy(T.$lM.MainThreadFileSystemEventService);let c=!1;(o.pattern.includes(N.$ok)||o.pattern.includes(N.$pk))&&(c=!0);let u;return s&&(r?.ignoreChangeEvents||r?.ignoreCreateEvents||r?.ignoreDeleteEvents)&&(u=14,r?.ignoreChangeEvents&&(u&=-3),r?.ignoreCreateEvents&&(u&=-5),r?.ignoreDeleteEvents&&(u&=-9)),t.$watch(f.identifier.value,this.a,o.baseUri,{recursive:c,excludes:r?.excludes??[],filter:u},!!s),p.$nM.from({dispose:()=>t.$unwatch(this.a)})}dispose(){this.g.dispose()}get onDidCreate(){return this.b.event}get onDidChange(){return this.c.event}get onDidDelete(){return this.d.event}}class O{constructor(w){this.a=w,this.session=this.a.session,this.b=new m.$V(()=>this.a.created.map(M.URI.revive)),this.c=new m.$V(()=>this.a.changed.map(M.URI.revive)),this.d=new m.$V(()=>this.a.deleted.map(M.URI.revive))}get created(){return this.b.value}get changed(){return this.c.value}get deleted(){return this.d.value}}class S{constructor(w,f,o){this.j=w,this.k=f,this.l=o,this.a=new C.$fe,this.b=new C.$fe,this.c=new C.$fe,this.d=new C.$fe,this.g=new C.$he,this.h=new C.$he,this.i=new C.$he,this.onDidRenameFile=this.b.event,this.onDidCreateFile=this.c.event,this.onDidDeleteFile=this.d.event}createFileSystemWatcher(w,f,o,r){return new D(this.j,w,f,this.a.event,A.GlobPattern.from(o),r)}$onFileEvent(w){this.a.fire(new O(w))}$onDidRunFileOperation(w,f){switch(w){case 2:this.b.fire(Object.freeze({files:f.map(o=>({oldUri:M.URI.revive(o.source),newUri:M.URI.revive(o.target)}))}));break;case 1:this.d.fire(Object.freeze({files:f.map(o=>M.URI.revive(o.target))}));break;case 0:case 3:this.c.fire(Object.freeze({files:f.map(o=>M.URI.revive(o.target))}));break;default:}}getOnWillRenameFileEvent(w){return this.m(w,this.g)}getOnWillCreateFileEvent(w){return this.m(w,this.h)}getOnWillDeleteFileEvent(w){return this.m(w,this.i)}m(w,f){return(o,r,s)=>{const n=function(c){o.call(r,c)};return n.extension=w,f.event(n,void 0,s)}}async $onWillRunFileOperation(w,f,o,r){switch(w){case 2:return await this.n(this.g,{files:f.map(s=>({oldUri:M.URI.revive(s.source),newUri:M.URI.revive(s.target)}))},o,r);case 1:return await this.n(this.i,{files:f.map(s=>M.URI.revive(s.target))},o,r);case 0:case 3:return await this.n(this.h,{files:f.map(s=>M.URI.revive(s.target))},o,r)}}async n(w,f,o,r){const s=new Set,n=[];if(await w.fireAsync(f,r,async(c,u)=>{const i=Date.now(),b=await Promise.resolve(c);b instanceof p.$xM&&(n.push([u.extension,b]),s.add(u.extension.displayName??u.extension.identifier.value)),Date.now()-i>o&&this.k.warn("SLOW file-participant",u.extension.identifier)}),r.isCancellationRequested||n.length===0)return;const t={edits:[]};for(const[,c]of n){const{edits:u}=A.WorkspaceEdit.from(c,{getTextDocumentVersion:i=>this.l.getDocument(i)?.version,getNotebookDocumentVersion:()=>{}});t.edits=t.edits.concat(u)}return{edit:t,extensionNames:Array.from(s)}}}e.$nnc=S}),define(Se[274],Ie([1,0,18,11,20,14,91,6,26,66,13,15,2,30,315,89,98,174,21,8,7,25,76,4]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dmc=void 0;class a{constructor(B,F){this.d=B,this.e=F}async provideDocumentSymbols(B,F){const H=this.d.getDocument(B),G=await this.e.provideDocumentSymbols(H,F);if(!(0,C.$Kb)(G))return G[0]instanceof c.$HM?G.map(t.DocumentSymbol.from):a.f(G)}static f(B){B=B.slice(0).sort((G,te)=>{let re=G.location.range.start.compareTo(te.location.range.start);return re===0&&(re=te.location.range.end.compareTo(G.location.range.end)),re});const F=[],H=[];for(const G of B){const te={name:G.name||"!!MISSING: name!!",kind:t.SymbolKind.from(G.kind),tags:G.tags?.map(t.SymbolTag.from)||[],detail:"",containerName:G.containerName,range:t.Range.from(G.location.range),selectionRange:t.Range.from(G.location.range),children:[]};for(;;){if(H.length===0){H.push(te),F.push(te);break}const re=H[H.length-1];if(w.$zt.containsRange(re.range,te.range)&&!w.$zt.equalsRange(re.range,te.range)){re.children?.push(te),H.push(te);break}H.pop()}}return F}}class l{constructor(B,F,H,G,te,re){this.f=B,this.g=F,this.h=H,this.j=G,this.k=te,this.l=re,this.d=new i.$6lc("CodeLens"),this.e=new Map}async provideCodeLenses(B,F){const H=this.f.getDocument(B),G=await this.h.provideCodeLenses(H,F);if(!G||F.isCancellationRequested)return;const te=this.d.add(G),re=new p.$Tc;this.e.set(te,re);const Oe={cacheId:te,lenses:[]};for(let Be=0;Be<G.length;Be++)Oe.lenses.push({cacheId:[te,Be],range:t.Range.from(G[Be].range),command:this.g.toInternal(G[Be].command,re)});return Oe}async resolveCodeLens(B,F){const H=B.cacheId&&this.d.get(...B.cacheId);if(!H)return;let G;if(typeof this.h.resolveCodeLens!="function"||H.isResolved?G=H:G=await this.h.resolveCodeLens(H,F),G||(G=H),F.isCancellationRequested)return;const te=B.cacheId&&this.e.get(B.cacheId[0]);if(te){if(!G.command){const re=new Error("INVALID code lens resolved, lacks command: "+this.j.identifier.value);this.k.onExtensionError(this.j.identifier,re),this.l.error(re);return}return B.command=this.g.toInternal(G.command,te),B}}releaseCodeLenses(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}}function g(je){return Array.isArray(je)?je.map(t.DefinitionLink.from):je?[t.DefinitionLink.from(je)]:[]}class ${constructor(B,F){this.d=B,this.e=F}async provideDefinition(B,F,H){const G=this.d.getDocument(B),te=t.Position.to(F),re=await this.e.provideDefinition(G,te,H);return g(re)}}class v{constructor(B,F){this.d=B,this.e=F}async provideDeclaration(B,F,H){const G=this.d.getDocument(B),te=t.Position.to(F),re=await this.e.provideDeclaration(G,te,H);return g(re)}}class y{constructor(B,F){this.d=B,this.e=F}async provideImplementation(B,F,H){const G=this.d.getDocument(B),te=t.Position.to(F),re=await this.e.provideImplementation(G,te,H);return g(re)}}class h{constructor(B,F){this.d=B,this.e=F}async provideTypeDefinition(B,F,H){const G=this.d.getDocument(B),te=t.Position.to(F),re=await this.e.provideTypeDefinition(G,te,H);return g(re)}}class E{static{this.f=10}constructor(B,F){this.g=B,this.h=F,this.d=0,this.e=new Map}async provideHover(B,F,H,G){const te=this.g.getDocument(B),re=t.Position.to(F);let Oe;if(H&&H.verbosityRequest){const xe=H.verbosityRequest.previousHover.id,et=this.e.get(xe);if(!et)throw new Error(`Hover with id ${xe} not found`);const tt={action:H.verbosityRequest.action,previousHover:et};Oe=await this.h.provideHover(te,re,G,tt)}else Oe=await this.h.provideHover(te,re,G);if(!Oe||(0,C.$Kb)(Oe.contents))return;Oe.range||(Oe.range=te.getWordRangeAtPosition(re)),Oe.range||(Oe.range=new c.$pM(re,re));const Be=t.Hover.from(Oe),Ge=this.d;if(this.e.size===E.f){const xe=Math.min(...this.e.keys());this.e.delete(xe)}return this.e.set(Ge,Oe),this.d+=1,{...Be,id:Ge}}releaseHover(B){this.e.delete(B)}}class k{constructor(B,F){this.d=B,this.e=F}async provideEvaluatableExpression(B,F,H){const G=this.d.getDocument(B),te=t.Position.to(F),re=await this.e.provideEvaluatableExpression(G,te,H);if(re)return t.EvaluatableExpression.from(re)}}class I{constructor(B,F){this.d=B,this.e=F}async provideInlineValues(B,F,H,G){const te=this.d.getDocument(B),re=await this.e.provideInlineValues(te,t.Range.to(F),t.InlineValueContext.to(H),G);if(Array.isArray(re))return re.map(Oe=>t.InlineValue.from(Oe))}}class P{constructor(B,F){this.d=B,this.e=F}async provideDocumentHighlights(B,F,H){const G=this.d.getDocument(B),te=t.Position.to(F),re=await this.e.provideDocumentHighlights(G,te,H);if(Array.isArray(re))return re.map(t.DocumentHighlight.from)}}class V{constructor(B,F){this.d=B,this.e=F}async provideMultiDocumentHighlights(B,F,H,G){const te=this.d.getDocument(B),re=H.map(Ge=>this.d.getDocument(Ge)),Oe=t.Position.to(F),Be=await this.e.provideMultiDocumentHighlights(te,Oe,re,G);if(Array.isArray(Be))return Be.map(t.MultiDocumentHighlight.from)}}class W{constructor(B,F){this.d=B,this.e=F}async provideLinkedEditingRanges(B,F,H){const G=this.d.getDocument(B),te=t.Position.to(F),re=await this.e.provideLinkedEditingRanges(G,te,H);if(re&&Array.isArray(re.ranges))return{ranges:(0,C.$Hb)(re.ranges.map(t.Range.from)),wordPattern:re.wordPattern}}}class q{constructor(B,F){this.d=B,this.e=F}async provideReferences(B,F,H,G){const te=this.d.getDocument(B),re=t.Position.to(F),Oe=await this.e.provideReferences(te,re,H,G);if(Array.isArray(Oe))return Oe.map(t.location.from)}}class R{static{this.d=1e3}constructor(B,F,H,G,te,re,Oe){this.g=B,this.h=F,this.j=H,this.k=G,this.l=te,this.m=re,this.n=Oe,this.e=new i.$6lc("CodeAction"),this.f=new Map}async provideCodeActions(B,F,H,G){const te=this.g.getDocument(B),re=f.$Bt.isISelection(F)?t.Selection.to(F):t.Range.to(F),Oe=[];for(const tt of this.j.getDiagnostics(B))if(re.intersection(tt.range)&&Oe.push(tt)>R.d)break;const Be={diagnostics:Oe,only:H.only?new c.$JM(H.only):void 0,triggerKind:t.CodeActionTriggerKind.to(H.trigger)},Ge=await this.k.provideCodeActions(te,re,Be,G);if(!(0,C.$Lb)(Ge)||G.isCancellationRequested)return;const _e=this.e.add(Ge),xe=new p.$Tc;this.f.set(_e,xe);const et=[];for(let tt=0;tt<Ge.length;tt++){const it=Ge[tt];if(it)if(R.o(it))this.n.report("CodeActionProvider.provideCodeActions - return commands",this.m,"Return 'CodeAction' instances instead."),et.push({_isSynthetic:!0,title:it.title,command:this.h.toInternal(it,xe)});else{Be.only&&(it.kind?Be.only.contains(it.kind)||this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action is of kind '${it.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this.l.warn(`${this.m.identifier.value} - Code actions of kind '${Be.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`));const at=it.ranges??[];et.push({cacheId:[_e,tt],title:it.title,command:it.command&&this.h.toInternal(it.command,xe),diagnostics:it.diagnostics&&it.diagnostics.map(t.Diagnostic.from),edit:it.edit&&t.WorkspaceEdit.from(it.edit,void 0),kind:it.kind&&it.kind.value,isPreferred:it.isPreferred,isAI:(0,u.$LG)(this.m,"codeActionAI")?it.isAI:!1,ranges:(0,u.$LG)(this.m,"codeActionRanges")?(0,C.$Hb)(at.map(t.Range.from)):void 0,disabled:it.disabled?.reason})}}return{cacheId:_e,actions:et}}async resolveCodeAction(B,F){const[H,G]=B,te=this.e.get(H,G);if(!te||R.o(te))return{};if(!this.k.resolveCodeAction)return{};const re=await this.k.resolveCodeAction(te,F)??te;let Oe;re.edit&&(Oe=t.WorkspaceEdit.from(re.edit,void 0));let Be;if(re.command){const Ge=this.f.get(H);Ge&&(Be=this.h.toInternal(re.command,Ge))}return{edit:Oe,command:Be}}releaseCodeActions(B){this.f.get(B)?.dispose(),this.f.delete(B),this.e.delete(B)}static o(B){return typeof B.command=="string"&&typeof B.title=="string"}}class z{constructor(B,F,H,G,te){this.e=B,this.f=F,this.g=H,this.h=G,this.j=te,this.d=new i.$6lc("DocumentPasteEdit")}async prepareDocumentPaste(B,F,H,G){if(!this.g.prepareDocumentPaste)return;const te=this.f.getDocument(B),re=F.map(Ge=>t.Range.to(Ge)),Oe=t.DataTransfer.toDataTransfer(H,()=>{throw new T.$$});if(await this.g.prepareDocumentPaste(te,re,Oe,G),G.isCancellationRequested)return;const Be=Array.from(Oe).filter(([,Ge])=>!(Ge instanceof c.$dN));return t.DataTransfer.from(Be)}async providePasteEdits(B,F,H,G,te,re){if(!this.g.provideDocumentPasteEdits)return[];const Oe=this.f.getDocument(F),Be=H.map(et=>t.Range.to(et)),Ge=t.DataTransfer.toDataTransfer(G,async et=>(await this.e.$resolvePasteFileData(this.h,B,et)).buffer),_e=await this.g.provideDocumentPasteEdits(Oe,Be,Ge,{only:te.only?new c.$iN(te.only):void 0,triggerKind:te.triggerKind},re);if(!_e||re.isCancellationRequested)return[];const xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,s.localize)(0,null,this.j.displayName||this.j.name),kind:et.kind,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?t.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolvePasteEdit(B,F){const[H,G]=B,te=this.d.get(H,G);if(!te||!this.g.resolveDocumentPasteEdit)return{};const re=await this.g.resolveDocumentPasteEdit(te,F)??te;return{additionalEdit:re.additionalEdit?t.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releasePasteEdits(B){this.d.delete(B)}}class K{constructor(B,F){this.d=B,this.e=F}async provideDocumentFormattingEdits(B,F,H){const G=this.d.getDocument(B),te=await this.e.provideDocumentFormattingEdits(G,F,H);if(Array.isArray(te))return te.map(t.TextEdit.from)}}class ie{constructor(B,F){this.d=B,this.e=F}async provideDocumentRangeFormattingEdits(B,F,H,G){const te=this.d.getDocument(B),re=t.Range.to(F),Oe=await this.e.provideDocumentRangeFormattingEdits(te,re,H,G);if(Array.isArray(Oe))return Oe.map(t.TextEdit.from)}async provideDocumentRangesFormattingEdits(B,F,H,G){(0,S.$ig)(typeof this.e.provideDocumentRangesFormattingEdits=="function","INVALID invocation of `provideDocumentRangesFormattingEdits`");const te=this.d.getDocument(B),re=F.map(t.Range.to),Oe=await this.e.provideDocumentRangesFormattingEdits(te,re,H,G);if(Array.isArray(Oe))return Oe.map(t.TextEdit.from)}}class de{constructor(B,F){this.d=B,this.e=F,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(B,F,H,G,te){const re=this.d.getDocument(B),Oe=t.Position.to(F),Be=await this.e.provideOnTypeFormattingEdits(re,Oe,H,G,te);if(Array.isArray(Be))return Be.map(t.TextEdit.from)}}class ye{constructor(B,F){this.e=B,this.f=F,this.d=new i.$6lc("WorkspaceSymbols")}async provideWorkspaceSymbols(B,F){const H=await this.e.provideWorkspaceSymbols(B,F);if(!(0,C.$Lb)(H))return{symbols:[]};const G=this.d.add(H),te={cacheId:G,symbols:[]};for(let re=0;re<H.length;re++){const Oe=H[re];if(!Oe||!Oe.name){this.f.warn("INVALID SymbolInformation",Oe);continue}te.symbols.push({...t.WorkspaceSymbol.from(Oe),cacheId:[G,re]})}return te}async resolveWorkspaceSymbol(B,F){if(typeof this.e.resolveWorkspaceSymbol!="function"||!B.cacheId)return B;const H=this.d.get(...B.cacheId);if(H){const G=await this.e.resolveWorkspaceSymbol(H,F);return G&&(0,m.$8n)(B,t.WorkspaceSymbol.from(G),!0)}}releaseWorkspaceSymbols(B){this.d.delete(B)}}class De{static supportsResolving(B){return typeof B.prepareRename=="function"}constructor(B,F,H){this.d=B,this.e=F,this.f=H}async provideRenameEdits(B,F,H,G){const te=this.d.getDocument(B),re=t.Position.to(F);try{const Oe=await this.e.provideRenameEdits(te,re,H,G);return Oe?t.WorkspaceEdit.from(Oe):void 0}catch(Oe){const Be=De.g(Oe);return Be?{rejectReason:Be,edits:void 0}:Promise.reject(Oe)}}async resolveRenameLocation(B,F,H){if(typeof this.e.prepareRename!="function")return Promise.resolve(void 0);const G=this.d.getDocument(B),te=t.Position.to(F);try{const re=await this.e.prepareRename(G,te,H);let Oe,Be;if(c.$pM.isRange(re)?(Oe=re,Be=G.getText(re)):(0,S.$ag)(re)&&(Oe=re.range,Be=re.placeholder),!Oe||!Be)return;if(Oe.start.line>te.line||Oe.end.line<te.line){this.f.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:t.Range.from(Oe),text:Be}}catch(re){const Oe=De.g(re);return Oe?{rejectReason:Oe,range:void 0,text:void 0}:Promise.reject(re)}}static g(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ge{static{this.d={[o.NewSymbolNameTriggerKind.Invoke]:c.NewSymbolNameTriggerKind.Invoke,[o.NewSymbolNameTriggerKind.Automatic]:c.NewSymbolNameTriggerKind.Automatic}}constructor(B,F,H){this.e=B,this.f=F,this.g=H}async supportsAutomaticNewSymbolNamesTriggerKind(){return this.f.supportsAutomaticTriggerKind}async provideNewSymbolNames(B,F,H,G){const te=this.e.getDocument(B),re=t.Range.to(F);try{const Oe=ge.d[H],Be=await this.f.provideNewSymbolNames(te,re,Oe,G);return Be?Be.map(Ge=>typeof Ge=="string"?{newSymbolName:Ge}:{newSymbolName:Ge.newSymbolName,tags:Ge.tags}):void 0}catch(Oe){this.g.error(ge.h(Oe)??JSON.stringify(Oe,null,"	"));return}}static h(B){return typeof B=="string"?B:B instanceof Error&&typeof B.message=="string"?B.message:void 0}}class ue{constructor(B,F){this.resultId=B,this.tokens=F}}class Ce{constructor(B,F){this.f=B,this.g=F,this.e=1,this.d=new Map}async provideDocumentSemanticTokens(B,F,H){const G=this.f.getDocument(B),te=F!==0?this.d.get(F):null;let re=typeof te?.resultId=="string"&&typeof this.g.provideDocumentSemanticTokensEdits=="function"?await this.g.provideDocumentSemanticTokensEdits(G,te.resultId,H):await this.g.provideDocumentSemanticTokens(G,H);return te&&this.d.delete(F),re?(re=Ce.h(re),this.o(Ce.n(te,re),re)):null}async releaseDocumentSemanticColoring(B){this.d.delete(B)}static h(B){return Ce.j(B)?Ce.k(B)?B:new c.$IN(new Uint32Array(B.data),B.resultId):Ce.l(B)?Ce.m(B)?B:new c.$KN(B.edits.map(F=>new c.$JN(F.start,F.deleteCount,F.data?new Uint32Array(F.data):F.data)),B.resultId):B}static j(B){return B&&!!B.data}static k(B){return B.data instanceof Uint32Array}static l(B){return B&&Array.isArray(B.edits)}static m(B){for(const F of B.edits)if(!(F.data instanceof Uint32Array))return!1;return!0}static n(B,F){if(!Ce.j(F)||!B||!B.tokens)return F;const H=B.tokens,G=H.length,te=F.data,re=te.length;let Oe=0;const Be=Math.min(G,re);for(;Oe<Be&&H[Oe]===te[Oe];)Oe++;if(Oe===G&&Oe===re)return new c.$KN([],F.resultId);let Ge=0;const _e=Be-Oe;for(;Ge<_e&&H[G-Ge-1]===te[re-Ge-1];)Ge++;return new c.$KN([{start:Oe,deleteCount:G-Oe-Ge,data:te.subarray(Oe,re-Ge)}],F.resultId)}o(B,F){if(Ce.j(B)){const H=this.e++;return this.d.set(H,new ue(B.resultId,B.data)),(0,r.$Cbb)({id:H,type:"full",data:B.data})}if(Ce.l(B)){const H=this.e++;return Ce.j(F)?this.d.set(H,new ue(F.resultId,F.data)):this.d.set(H,new ue(B.resultId)),(0,r.$Cbb)({id:H,type:"delta",deltas:(B.edits||[]).map(G=>({start:G.start,deleteCount:G.deleteCount,data:G.data}))})}return null}}class se{constructor(B,F){this.d=B,this.e=F}async provideDocumentRangeSemanticTokens(B,F,H){const G=this.d.getDocument(B),te=await this.e.provideDocumentRangeSemanticTokens(G,t.Range.to(F),H);return te?this.f(te):null}f(B){return(0,r.$Cbb)({id:0,type:"full",data:B.data})}}class Ne{static supportsResolving(B){return typeof B.resolveCompletionItem=="function"}constructor(B,F,H,G,te){this.f=B,this.g=F,this.h=H,this.j=G,this.k=te,this.d=new i.$6lc("CompletionItem"),this.e=new Map}async provideCompletionItems(B,F,H,G){const te=this.f.getDocument(B),re=t.Position.to(F),Oe=te.getWordRangeAtPosition(re)||new c.$pM(re,re),Be=Oe.with({end:re}),Ge=new D.$be,_e=await this.h.provideCompletionItems(te,re,G,t.CompletionContext.to(H));if(!_e||G.isCancellationRequested)return;const xe=Array.isArray(_e)?new c.$WM(_e):_e,et=Ne.supportsResolving(this.h)?this.d.add(xe.items):this.d.add([]),tt=new p.$Tc;this.e.set(et,tt);const it=[],at={x:et,b:it,a:{replace:t.Range.from(Oe),insert:t.Range.from(Be)},c:xe.isIncomplete||void 0,d:Ge.elapsed()};for(let gt=0;gt<xe.items.length;gt++){const Ue=xe.items[gt],rt=this.l(Ue,[et,gt],Be,Oe);it.push(rt)}return at}async resolveCompletionItem(B,F){if(typeof this.h.resolveCompletionItem!="function")return;const H=this.d.get(...B);if(!H)return;const G=this.l(H,B),te=await this.h.resolveCompletionItem(H,F);if(!te)return;const re=this.l(te,B);return(G.h!==re.h||G.i!==re.i)&&this.j.report("CompletionItem.insertText",this.k,"extension MAY NOT change 'insertText' of a CompletionItem during resolve"),(G.n!==re.n||G.o!==re.o||!(0,m.$9n)(G.p,re.p))&&this.j.report("CompletionItem.command",this.k,"extension MAY NOT change 'command' of a CompletionItem during resolve"),{...G,d:re.d,c:re.c,l:re.l,h:re.h,i:re.i,n:re.n,o:re.o,p:re.p}}releaseCompletionItems(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,F,H,G){const te=this.e.get(F[0]);if(!te)throw Error("DisposableStore is missing...");const re=this.g.toInternal(B.command,te),Oe={x:F,a:B.label,b:B.kind!==void 0?t.CompletionItemKind.from(B.kind):void 0,m:B.tags&&B.tags.map(t.CompletionItemTag.from),c:B.detail,d:typeof B.documentation>"u"?void 0:t.MarkdownString.fromStrict(B.documentation),e:B.sortText!==B.label?B.sortText:void 0,f:B.filterText!==B.label?B.filterText:void 0,g:B.preselect||void 0,i:B.keepWhitespace?1:0,k:B.commitCharacters?.join(""),l:B.additionalTextEdits&&B.additionalTextEdits.map(t.TextEdit.from),n:re?.$ident,o:re?.id,p:re?.$ident?void 0:re?.arguments};B.textEdit?(this.j.report("CompletionItem.textEdit",this.k,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),Oe.h=B.textEdit.newText):typeof B.insertText=="string"?Oe.h=B.insertText:B.insertText instanceof c.$yM&&(Oe.h=B.insertText.value,Oe.i|=4);let Be;return B.textEdit?Be=B.textEdit.range:B.range&&(Be=B.range),c.$pM.isRange(Be)?Oe.j=t.Range.from(Be):Be&&(!H?.isEqual(Be.inserting)||!G?.isEqual(Be.replacing))&&(Oe.j={insert:t.Range.from(Be.inserting),replace:t.Range.from(Be.replacing)}),Oe}}class ne{async provideInlineCompletions(B,F,H,G){}disposeCompletions(B){}handleDidShowCompletionItem(B,F,H){}handlePartialAccept(B,F,H,G){}}class U extends ne{constructor(B,F,H,G){super(),this.f=B,this.g=F,this.h=H,this.j=G,this.d=new ve,this.e=(0,u.$LG)(this.f,"inlineCompletionsAdditions"),this.k={[o.InlineCompletionTriggerKind.Automatic]:c.InlineCompletionTriggerKind.Automatic,[o.InlineCompletionTriggerKind.Explicit]:c.InlineCompletionTriggerKind.Invoke}}get supportsHandleEvents(){return(0,u.$LG)(this.f,"inlineCompletionsAdditions")&&(typeof this.h.handleDidShowCompletionItem=="function"||typeof this.h.handleDidPartiallyAcceptCompletionItem=="function")}async provideInlineCompletions(B,F,H,G){const te=this.g.getDocument(B),re=t.Position.to(F),Oe=await this.h.provideInlineCompletionItems(te,re,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:t.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.k[H.triggerKind]},G);if(!Oe||G.isCancellationRequested)return;const Be=Array.isArray(Oe)?Oe:Oe.items,Ge=this.e?Array.isArray(Oe)?[]:Oe.commands||[]:[],_e=this.e&&!Array.isArray(Oe)?Oe.enableForwardStability:void 0;let xe;return{pid:this.d.createReferenceId({dispose(){xe?.dispose()},items:Be}),items:Be.map((tt,it)=>{let at;tt.command&&(xe||(xe=new p.$Tc),at=this.j.toInternal(tt.command,xe));const gt=tt.insertText;return{insertText:typeof gt=="string"?gt:{snippet:gt.value},filterText:tt.filterText,range:tt.range?t.Range.from(tt.range):void 0,command:at,idx:it,completeBracketPairs:this.e?tt.completeBracketPairs:!1}}),commands:Ge.map(tt=>(xe||(xe=new p.$Tc),this.j.toInternal(tt,xe))),suppressSuggestions:!1,enableForwardStability:_e}}disposeCompletions(B){this.d.disposeReferenceId(B)?.dispose()}handleDidShowCompletionItem(B,F,H){const G=this.d.get(B)?.items[F];G&&this.h.handleDidShowCompletionItem&&this.e&&this.h.handleDidShowCompletionItem(G,H)}handlePartialAccept(B,F,H,G){const te=this.d.get(B)?.items[F];te&&this.h.handleDidPartiallyAcceptCompletionItem&&this.e&&(this.h.handleDidPartiallyAcceptCompletionItem(te,H),this.h.handleDidPartiallyAcceptCompletionItem(te,t.PartialAcceptInfo.to(G)))}}class x{async provideInlineEdits(B,F,H){const G=this.f.getDocument(B),te=await this.g.provideInlineEdit(G,{triggerKind:this.e[F.triggerKind]},H);if(!te||H.isCancellationRequested)return;let re;const Oe=this.d.createReferenceId({dispose(){re?.dispose()},item:te});let Be;te.accepted&&(re||(re=new p.$Tc),Be=this.h.toInternal(te.accepted,re));let Ge;return te.rejected&&(re||(re=new p.$Tc),Ge=this.h.toInternal(te.rejected,re)),{pid:Oe,text:te.text,range:t.Range.from(te.range),accepted:Be,rejected:Ge}}disposeEdit(B){this.d.disposeReferenceId(B)?.dispose()}constructor(B,F,H,G){this.f=F,this.g=H,this.h=G,this.d=new ve,this.e={[o.InlineEditTriggerKind.Automatic]:c.InlineEditTriggerKind.Automatic,[o.InlineEditTriggerKind.Invoke]:c.InlineEditTriggerKind.Invoke}}}class ve{constructor(){this.d=new Map,this.e=1}createReferenceId(B){const F=this.e++;return this.d.set(F,B),F}disposeReferenceId(B){const F=this.d.get(B);return this.d.delete(B),F}get(B){return this.d.get(B)}}class Le{constructor(B,F){this.e=B,this.f=F,this.d=new i.$6lc("SignatureHelp")}async provideSignatureHelp(B,F,H,G){const te=this.e.getDocument(B),re=t.Position.to(F),Oe=this.g(H),Be=await this.f.provideSignatureHelp(te,re,G,Oe);if(Be){const Ge=this.d.add([Be]);return{...t.SignatureHelp.from(Be),id:Ge}}}g(B){let F;if(B.activeSignatureHelp){const H=t.SignatureHelp.to(B.activeSignatureHelp),G=this.d.get(B.activeSignatureHelp.id,0);G?(F=G,F.activeSignature=H.activeSignature,F.activeParameter=H.activeParameter):F=H}return{...B,activeSignatureHelp:F}}releaseSignatureHelp(B){this.d.delete(B)}}class ke{constructor(B,F,H,G,te){this.f=B,this.g=F,this.h=H,this.j=G,this.k=te,this.d=new i.$6lc("InlayHints"),this.e=new Map}async provideInlayHints(B,F,H){const G=this.f.getDocument(B),te=t.Range.to(F),re=await this.h.provideInlayHints(G,te,H);if(!Array.isArray(re)||re.length===0){this.j.trace(`[InlayHints] NO inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`);return}if(H.isCancellationRequested)return;const Oe=this.d.add(re);this.e.set(Oe,new p.$Tc);const Be={hints:[],cacheId:Oe};for(let Ge=0;Ge<re.length;Ge++)this.l(re[Ge],te)&&Be.hints.push(this.m(re[Ge],[Oe,Ge]));return this.j.trace(`[InlayHints] ${Be.hints.length} inlay hints from '${this.k.identifier.value}' for range ${JSON.stringify(F)}`),Be}async resolveInlayHint(B,F){if(typeof this.h.resolveInlayHint!="function")return;const H=this.d.get(...B);if(!H)return;const G=await this.h.resolveInlayHint(H,F);if(G&&this.l(G))return this.m(G,B)}releaseHints(B){this.e.get(B)?.dispose(),this.e.delete(B),this.d.delete(B)}l(B,F){return B.label.length===0||Array.isArray(B.label)&&B.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",B),!1):!(F&&!F.contains(B.position))}m(B,F){const H=this.e.get(F[0]);if(!H)throw Error("DisposableStore is missing...");const G={label:"",cacheId:F,tooltip:t.MarkdownString.fromStrict(B.tooltip),position:t.Position.from(B.position),textEdits:B.textEdits&&B.textEdits.map(t.TextEdit.from),kind:B.kind&&t.InlayHintKind.from(B.kind),paddingLeft:B.paddingLeft,paddingRight:B.paddingRight};if(typeof B.label=="string")G.label=B.label;else{const te=[];G.label=te;for(const re of B.label){if(!re.value){console.warn("INVALID inlay hint, empty label part",this.k.identifier.value);continue}const Oe={label:re.value,tooltip:t.MarkdownString.fromStrict(re.tooltip)};c.$zM.isLocation(re.location)&&(Oe.location=t.location.from(re.location)),re.command&&(Oe.command=this.g.toInternal(re.command,H)),te.push(Oe)}}return G}}class be{constructor(B,F){this.e=B,this.f=F,this.d=new i.$6lc("DocumentLink")}async provideLinks(B,F){const H=this.e.getDocument(B),G=await this.f.provideDocumentLinks(H,F);if(!(!Array.isArray(G)||G.length===0)&&!F.isCancellationRequested){if(typeof this.f.resolveDocumentLink!="function")return{links:G.filter(be.g).map(t.DocumentLink.from)};{const te=this.d.add(G),re={links:[],cacheId:te};for(let Oe=0;Oe<G.length;Oe++){if(!be.g(G[Oe]))continue;const Be=t.DocumentLink.from(G[Oe]);Be.cacheId=[te,Oe],re.links.push(Be)}return re}}}static g(B){return B.target&&B.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(B,F){if(typeof this.f.resolveDocumentLink!="function")return;const H=this.d.get(...B);if(!H)return;const G=await this.f.resolveDocumentLink(H,F);if(!(!G||!be.g(G)))return t.DocumentLink.from(G)}releaseLinks(B){this.d.delete(B)}}class me{constructor(B,F){this.d=B,this.e=F}async provideColors(B,F){const H=this.d.getDocument(B),G=await this.e.provideDocumentColors(H,F);return Array.isArray(G)?G.map(re=>({color:t.Color.from(re.color),range:t.Range.from(re.range)})):[]}async provideColorPresentations(B,F,H){const G=this.d.getDocument(B),te=t.Range.to(F.range),re=t.Color.to(F.color),Oe=await this.e.provideColorPresentations(re,{document:G,range:te},H);if(Array.isArray(Oe))return Oe.map(t.ColorPresentation.from)}}class Q{constructor(B,F){this.d=B,this.e=F}async provideFoldingRanges(B,F,H){const G=this.d.getDocument(B),te=await this.e.provideFoldingRanges(G,F,H);if(Array.isArray(te))return te.map(t.FoldingRange.from)}}class Y{constructor(B,F,H){this.d=B,this.e=F,this.f=H}async provideSelectionRanges(B,F,H){const G=this.d.getDocument(B),te=F.map(t.Position.to),re=await this.e.provideSelectionRanges(G,te,H);if(!(0,C.$Lb)(re))return[];if(re.length!==te.length)return this.f.warn("BAD selection ranges, provider must return ranges for each position"),[];const Oe=[];for(let Be=0;Be<te.length;Be++){const Ge=[];Oe.push(Ge);let _e=te[Be],xe=re[Be];for(;;){if(!xe.range.contains(_e))throw new Error("INVALID selection range, must contain the previous range");if(Ge.push(t.SelectionRange.from(xe)),!xe.parent)break;_e=xe.range,xe=xe.parent}}return Oe}}class he{constructor(B,F){this.f=B,this.g=F,this.d=new A.$UO(""),this.e=new Map}async prepareSession(B,F,H){const G=this.f.getDocument(B),te=t.Position.to(F),re=await this.g.prepareCallHierarchy(G,te,H);if(!re)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(re)?re.map(Be=>this.h(Oe,Be)):[this.h(Oe,re)]}async provideCallsTo(B,F,H){const G=this.j(B,F);if(!G)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyIncomingCalls(G,H);if(te)return te.map(re=>({from:this.h(B,re.from),fromRanges:re.fromRanges.map(Oe=>t.Range.from(Oe))}))}async provideCallsFrom(B,F,H){const G=this.j(B,F);if(!G)throw new Error("missing call hierarchy item");const te=await this.g.provideCallHierarchyOutgoingCalls(G,H);if(te)return te.map(re=>({to:this.h(B,re.to),fromRanges:re.fromRanges.map(Oe=>t.Range.from(Oe))}))}releaseSession(B){this.e.delete(B)}h(B,F){const H=this.e.get(B),G=t.CallHierarchyItem.from(F,B,H.size.toString(36));return H.set(G._itemId,F),G}j(B,F){return this.e.get(B)?.get(F)}}class ce{constructor(B,F){this.f=B,this.g=F,this.d=new A.$UO(""),this.e=new Map}async prepareSession(B,F,H){const G=this.f.getDocument(B),te=t.Position.to(F),re=await this.g.prepareTypeHierarchy(G,te,H);if(!re)return;const Oe=this.d.nextId();return this.e.set(Oe,new Map),Array.isArray(re)?re.map(Be=>this.h(Oe,Be)):[this.h(Oe,re)]}async provideSupertypes(B,F,H){const G=this.j(B,F);if(!G)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySupertypes(G,H);if(te)return te.map(re=>this.h(B,re))}async provideSubtypes(B,F,H){const G=this.j(B,F);if(!G)throw new Error("missing type hierarchy item");const te=await this.g.provideTypeHierarchySubtypes(G,H);if(te)return te.map(re=>this.h(B,re))}releaseSession(B){this.e.delete(B)}h(B,F){const H=this.e.get(B),G=t.TypeHierarchyItem.from(F,B,H.size.toString(36));return H.set(G._itemId,F),G}j(B,F){return this.e.get(B)?.get(F)}}class Te{constructor(B,F,H,G,te){this.e=B,this.f=F,this.g=H,this.h=G,this.j=te,this.d=new i.$6lc("DocumentDropEdit")}async provideDocumentOnDropEdits(B,F,H,G,te){const re=this.f.getDocument(F),Oe=t.Position.to(H),Be=t.DataTransfer.toDataTransfer(G,async et=>(await this.e.$resolveDocumentOnDropFileData(this.h,B,et)).buffer),Ge=await this.g.provideDocumentDropEdits(re,Oe,Be,te);if(!Ge)return;const _e=(0,C.$2b)(Ge),xe=this.d.add(_e);return _e.map((et,tt)=>({_cacheId:[xe,tt],title:et.title??(0,s.localize)(1,null,this.j.displayName||this.j.name),kind:et.kind?.value,yieldTo:et.yieldTo?.map(it=>it.value),insertText:typeof et.insertText=="string"?et.insertText:{snippet:et.insertText.value},additionalEdit:et.additionalEdit?t.WorkspaceEdit.from(et.additionalEdit,void 0):void 0}))}async resolveDropEdit(B,F){const[H,G]=B,te=this.d.get(H,G);if(!te||!this.g.resolveDocumentDropEdit)return{};const re=await this.g.resolveDocumentDropEdit(te,F)??te;return{additionalEdit:re.additionalEdit?t.WorkspaceEdit.from(re.additionalEdit,void 0):void 0}}releaseDropEdits(B){this.d.delete(B)}}class fe{constructor(B,F){this.d=B,this.e=F}async provideMappedEdits(B,F,H,G){const te=d.URI.revive(B),re=this.d.getDocument(te),Oe=H.documents.map(_e=>_e.map(xe=>({uri:d.URI.revive(xe.uri),version:xe.version,ranges:xe.ranges.map(et=>t.Range.to(et))}))),Be={documents:Oe,selections:Oe[0]?.[0]?.ranges??[]},Ge=await this.e.provideMappedEdits(re,F,Be,G);return Ge?t.WorkspaceEdit.from(Ge):null}}class Pe{constructor(B,F){this.adapter=B,this.extension=F}}class Re{static{this.d=0}constructor(B,F,H,G,te,re,Oe,Be){this.g=F,this.h=H,this.j=G,this.k=te,this.l=re,this.m=Oe,this.n=Be,this.f=new Map,this.e=B.getProxy(b.$lM.MainThreadLanguageFeatures)}o(B,F){return t.DocumentSelector.from(B,this.g,F)}p(B){return new c.$nM(()=>{this.f.delete(B),this.e.$unregister(B)})}q(){return Re.d++}async s(B,F,H,G,te,re=!1){const Oe=this.f.get(B);if(!Oe||!(Oe.adapter instanceof F))return G;const Be=Date.now();re||this.l.trace(`[${Oe.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const Ge=H(Oe.adapter,Oe.extension);return Promise.resolve(Ge).catch(_e=>{(0,T.$4)(_e)||(this.l.error(`[${Oe.extension.identifier.value}] provider FAILED`),this.l.error(_e),this.n.onExtensionError(Oe.extension.identifier,_e))}).finally(()=>{re||this.l.trace(`[${Oe.extension.identifier.value}] provider DONE after ${Date.now()-Be}ms`)}),M.CancellationToken.isCancellationToken(te)?(0,N.$nh)(Ge,te):Ge}t(B,F){const H=this.q();return this.f.set(H,new Pe(B,F)),H}static u(B){return B.displayName||B.name}registerDocumentSymbolProvider(B,F,H,G){const te=this.t(new a(this.h,H),B),re=G&&G.label||Re.u(B);return this.e.$registerDocumentSymbolProvider(te,this.o(F,B),re),this.p(te)}$provideDocumentSymbols(B,F,H){return this.s(B,a,G=>G.provideDocumentSymbols(d.URI.revive(F),H),void 0,H)}registerCodeLensProvider(B,F,H){const G=this.q(),te=typeof H.onDidChangeCodeLenses=="function"?this.q():void 0;this.f.set(G,new Pe(new l(this.h,this.j.converter,H,B,this.n,this.l),B)),this.e.$registerCodeLensSupport(G,this.o(F,B),te);let re=this.p(G);if(te!==void 0){const Oe=H.onDidChangeCodeLenses(Be=>this.e.$emitCodeLensEvent(te));re=c.$nM.from(re,Oe)}return re}$provideCodeLenses(B,F,H){return this.s(B,l,G=>G.provideCodeLenses(d.URI.revive(F),H),void 0,H)}$resolveCodeLens(B,F,H){return this.s(B,l,G=>G.resolveCodeLens(F,H),void 0,void 0)}$releaseCodeLenses(B,F){this.s(B,l,H=>Promise.resolve(H.releaseCodeLenses(F)),void 0,void 0)}registerDefinitionProvider(B,F,H){const G=this.t(new $(this.h,H),B);return this.e.$registerDefinitionSupport(G,this.o(F,B)),this.p(G)}$provideDefinition(B,F,H,G){return this.s(B,$,te=>te.provideDefinition(d.URI.revive(F),H,G),[],G)}registerDeclarationProvider(B,F,H){const G=this.t(new v(this.h,H),B);return this.e.$registerDeclarationSupport(G,this.o(F,B)),this.p(G)}$provideDeclaration(B,F,H,G){return this.s(B,v,te=>te.provideDeclaration(d.URI.revive(F),H,G),[],G)}registerImplementationProvider(B,F,H){const G=this.t(new y(this.h,H),B);return this.e.$registerImplementationSupport(G,this.o(F,B)),this.p(G)}$provideImplementation(B,F,H,G){return this.s(B,y,te=>te.provideImplementation(d.URI.revive(F),H,G),[],G)}registerTypeDefinitionProvider(B,F,H){const G=this.t(new h(this.h,H),B);return this.e.$registerTypeDefinitionSupport(G,this.o(F,B)),this.p(G)}$provideTypeDefinition(B,F,H,G){return this.s(B,h,te=>te.provideTypeDefinition(d.URI.revive(F),H,G),[],G)}registerHoverProvider(B,F,H,G){const te=this.t(new E(this.h,H),B);return this.e.$registerHoverProvider(te,this.o(F,B)),this.p(te)}$provideHover(B,F,H,G,te){return this.s(B,E,re=>re.provideHover(d.URI.revive(F),H,G,te),void 0,te)}$releaseHover(B,F){this.s(B,E,H=>Promise.resolve(H.releaseHover(F)),void 0,void 0)}registerEvaluatableExpressionProvider(B,F,H,G){const te=this.t(new k(this.h,H),B);return this.e.$registerEvaluatableExpressionProvider(te,this.o(F,B)),this.p(te)}$provideEvaluatableExpression(B,F,H,G){return this.s(B,k,te=>te.provideEvaluatableExpression(d.URI.revive(F),H,G),void 0,G)}registerInlineValuesProvider(B,F,H,G){const te=typeof H.onDidChangeInlineValues=="function"?this.q():void 0,re=this.t(new I(this.h,H),B);this.e.$registerInlineValuesProvider(re,this.o(F,B),te);let Oe=this.p(re);if(te!==void 0){const Be=H.onDidChangeInlineValues(Ge=>this.e.$emitInlineValuesEvent(te));Oe=c.$nM.from(Oe,Be)}return Oe}$provideInlineValues(B,F,H,G,te){return this.s(B,I,re=>re.provideInlineValues(d.URI.revive(F),H,G,te),void 0,te)}registerDocumentHighlightProvider(B,F,H){const G=this.t(new P(this.h,H),B);return this.e.$registerDocumentHighlightProvider(G,this.o(F,B)),this.p(G)}registerMultiDocumentHighlightProvider(B,F,H){const G=this.t(new V(this.h,H),B);return this.e.$registerMultiDocumentHighlightProvider(G,this.o(F,B)),this.p(G)}$provideDocumentHighlights(B,F,H,G){return this.s(B,P,te=>te.provideDocumentHighlights(d.URI.revive(F),H,G),void 0,G)}$provideMultiDocumentHighlights(B,F,H,G,te){return this.s(B,V,re=>re.provideMultiDocumentHighlights(d.URI.revive(F),H,G.map(Oe=>d.URI.revive(Oe)),te),void 0,te)}registerLinkedEditingRangeProvider(B,F,H){const G=this.t(new W(this.h,H),B);return this.e.$registerLinkedEditingRangeProvider(G,this.o(F,B)),this.p(G)}$provideLinkedEditingRanges(B,F,H,G){return this.s(B,W,async te=>{const re=await te.provideLinkedEditingRanges(d.URI.revive(F),H,G);if(re)return{ranges:re.ranges,wordPattern:re.wordPattern?Re.w(re.wordPattern):void 0}},void 0,G)}registerReferenceProvider(B,F,H){const G=this.t(new q(this.h,H),B);return this.e.$registerReferenceSupport(G,this.o(F,B)),this.p(G)}$provideReferences(B,F,H,G,te){return this.s(B,q,re=>re.provideReferences(d.URI.revive(F),H,G,te),void 0,te)}registerCodeActionProvider(B,F,H,G){const te=new p.$Tc,re=this.t(new R(this.h,this.j.converter,this.k,H,this.l,B,this.m),B);return this.e.$registerQuickFixSupport(re,this.o(F,B),{providedKinds:G?.providedCodeActionKinds?.map(Oe=>Oe.value),documentation:G?.documentation?.map(Oe=>({kind:Oe.kind.value,command:this.j.converter.toInternal(Oe.command,te)}))},Re.u(B),!!H.resolveCodeAction),te.add(this.p(re)),te}$provideCodeActions(B,F,H,G,te){return this.s(B,R,re=>re.provideCodeActions(d.URI.revive(F),H,G,te),void 0,te)}$resolveCodeAction(B,F,H){return this.s(B,R,G=>G.resolveCodeAction(F,H),{},void 0)}$releaseCodeActions(B,F){this.s(B,R,H=>Promise.resolve(H.releaseCodeActions(F)),void 0,void 0)}registerDocumentFormattingEditProvider(B,F,H){const G=this.t(new K(this.h,H),B);return this.e.$registerDocumentFormattingSupport(G,this.o(F,B),B.identifier,B.displayName||B.name),this.p(G)}$provideDocumentFormattingEdits(B,F,H,G){return this.s(B,K,te=>te.provideDocumentFormattingEdits(d.URI.revive(F),H,G),void 0,G)}registerDocumentRangeFormattingEditProvider(B,F,H){const G=typeof H.provideDocumentRangesFormattingEdits=="function",te=this.t(new ie(this.h,H),B);return this.e.$registerRangeFormattingSupport(te,this.o(F,B),B.identifier,B.displayName||B.name,G),this.p(te)}$provideDocumentRangeFormattingEdits(B,F,H,G,te){return this.s(B,ie,re=>re.provideDocumentRangeFormattingEdits(d.URI.revive(F),H,G,te),void 0,te)}$provideDocumentRangesFormattingEdits(B,F,H,G,te){return this.s(B,ie,re=>re.provideDocumentRangesFormattingEdits(d.URI.revive(F),H,G,te),void 0,te)}registerOnTypeFormattingEditProvider(B,F,H,G){const te=this.t(new de(this.h,H),B);return this.e.$registerOnTypeFormattingSupport(te,this.o(F,B),G,B.identifier),this.p(te)}$provideOnTypeFormattingEdits(B,F,H,G,te,re){return this.s(B,de,Oe=>Oe.provideOnTypeFormattingEdits(d.URI.revive(F),H,G,te,re),void 0,re)}registerWorkspaceSymbolProvider(B,F){const H=this.t(new ye(F,this.l),B);return this.e.$registerNavigateTypeSupport(H,typeof F.resolveWorkspaceSymbol=="function"),this.p(H)}$provideWorkspaceSymbols(B,F,H){return this.s(B,ye,G=>G.provideWorkspaceSymbols(F,H),{symbols:[]},H)}$resolveWorkspaceSymbol(B,F,H){return this.s(B,ye,G=>G.resolveWorkspaceSymbol(F,H),void 0,void 0)}$releaseWorkspaceSymbols(B,F){this.s(B,ye,H=>H.releaseWorkspaceSymbols(F),void 0,void 0)}registerRenameProvider(B,F,H){const G=this.t(new De(this.h,H,this.l),B);return this.e.$registerRenameSupport(G,this.o(F,B),De.supportsResolving(H)),this.p(G)}$provideRenameEdits(B,F,H,G,te){return this.s(B,De,re=>re.provideRenameEdits(d.URI.revive(F),H,G,te),void 0,te)}$resolveRenameLocation(B,F,H,G){return this.s(B,De,te=>te.resolveRenameLocation(d.URI.revive(F),H,G),void 0,G)}registerNewSymbolNamesProvider(B,F,H){const G=this.t(new ge(this.h,H,this.l),B);return this.e.$registerNewSymbolNamesProvider(G,this.o(F,B)),this.p(G)}$supportsAutomaticNewSymbolNamesTriggerKind(B){return this.s(B,ge,F=>F.supportsAutomaticNewSymbolNamesTriggerKind(),!1,void 0)}$provideNewSymbolNames(B,F,H,G,te){return this.s(B,ge,re=>re.provideNewSymbolNames(d.URI.revive(F),H,G,te),void 0,te)}registerDocumentSemanticTokensProvider(B,F,H,G){const te=this.t(new Ce(this.h,H),B),re=typeof H.onDidChangeSemanticTokens=="function"?this.q():void 0;this.e.$registerDocumentSemanticTokensProvider(te,this.o(F,B),G,re);let Oe=this.p(te);if(re){const Be=H.onDidChangeSemanticTokens(Ge=>this.e.$emitDocumentSemanticTokensEvent(re));Oe=c.$nM.from(Oe,Be)}return Oe}$provideDocumentSemanticTokens(B,F,H,G){return this.s(B,Ce,te=>te.provideDocumentSemanticTokens(d.URI.revive(F),H,G),null,G)}$releaseDocumentSemanticTokens(B,F){this.s(B,Ce,H=>H.releaseDocumentSemanticColoring(F),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(B,F,H,G){const te=this.t(new se(this.h,H),B);return this.e.$registerDocumentRangeSemanticTokensProvider(te,this.o(F,B),G),this.p(te)}$provideDocumentRangeSemanticTokens(B,F,H,G){return this.s(B,se,te=>te.provideDocumentRangeSemanticTokens(d.URI.revive(F),H,G),null,G)}registerCompletionItemProvider(B,F,H,G){const te=this.t(new Ne(this.h,this.j.converter,H,this.m,B),B);return this.e.$registerCompletionsProvider(te,this.o(F,B),G,Ne.supportsResolving(H),B.identifier),this.p(te)}$provideCompletionItems(B,F,H,G,te){return this.s(B,Ne,re=>re.provideCompletionItems(d.URI.revive(F),H,G,te),void 0,te)}$resolveCompletionItem(B,F,H){return this.s(B,Ne,G=>G.resolveCompletionItem(F,H),void 0,H)}$releaseCompletionItems(B,F){this.s(B,Ne,H=>H.releaseCompletionItems(F),void 0,void 0)}registerInlineCompletionsProvider(B,F,H,G){const te=new U(B,this.h,H,this.j.converter),re=this.t(te,B);return this.e.$registerInlineCompletionsSupport(re,this.o(F,B),te.supportsHandleEvents,n.$Tm.toKey(B.identifier.value),G?.yieldTo?.map(Oe=>n.$Tm.toKey(Oe))||[]),this.p(re)}$provideInlineCompletions(B,F,H,G,te){return this.s(B,ne,re=>re.provideInlineCompletions(d.URI.revive(F),H,G,te),void 0,te)}$handleInlineCompletionDidShow(B,F,H,G){this.s(B,ne,async te=>{te.handleDidShowCompletionItem(F,H,G)},void 0,void 0)}$handleInlineCompletionPartialAccept(B,F,H,G,te){this.s(B,ne,async re=>{re.handlePartialAccept(F,H,G,te)},void 0,void 0)}$freeInlineCompletionsList(B,F){this.s(B,ne,async H=>{H.disposeCompletions(F)},void 0,void 0)}registerInlineEditProvider(B,F,H){const G=new x(B,this.h,H,this.j.converter),te=this.t(G,B);return this.e.$registerInlineEditProvider(te,this.o(F,B),B.identifier),this.p(te)}$provideInlineEdit(B,F,H,G){return this.s(B,x,te=>te.provideInlineEdits(d.URI.revive(F),H,G),void 0,G)}$freeInlineEdit(B,F){this.s(B,x,async H=>{H.disposeEdit(F)},void 0,void 0)}registerSignatureHelpProvider(B,F,H,G){const te=Array.isArray(G)?{triggerCharacters:G,retriggerCharacters:[]}:G,re=this.t(new Le(this.h,H),B);return this.e.$registerSignatureHelpProvider(re,this.o(F,B),te),this.p(re)}$provideSignatureHelp(B,F,H,G,te){return this.s(B,Le,re=>re.provideSignatureHelp(d.URI.revive(F),H,G,te),void 0,te)}$releaseSignatureHelp(B,F){this.s(B,Le,H=>H.releaseSignatureHelp(F),void 0,void 0)}registerInlayHintsProvider(B,F,H){const G=typeof H.onDidChangeInlayHints=="function"?this.q():void 0,te=this.t(new ke(this.h,this.j.converter,H,this.l,B),B);this.e.$registerInlayHintsProvider(te,this.o(F,B),typeof H.resolveInlayHint=="function",G,Re.u(B));let re=this.p(te);if(G!==void 0){const Oe=H.onDidChangeInlayHints(Be=>this.e.$emitInlayHintsEvent(G));re=c.$nM.from(re,Oe)}return re}$provideInlayHints(B,F,H,G){return this.s(B,ke,te=>te.provideInlayHints(d.URI.revive(F),H,G),void 0,G)}$resolveInlayHint(B,F,H){return this.s(B,ke,G=>G.resolveInlayHint(F,H),void 0,H)}$releaseInlayHints(B,F){this.s(B,ke,H=>H.releaseHints(F),void 0,void 0)}registerDocumentLinkProvider(B,F,H){const G=this.t(new be(this.h,H),B);return this.e.$registerDocumentLinkProvider(G,this.o(F,B),typeof H.resolveDocumentLink=="function"),this.p(G)}$provideDocumentLinks(B,F,H){return this.s(B,be,G=>G.provideLinks(d.URI.revive(F),H),void 0,H,F.scheme==="output")}$resolveDocumentLink(B,F,H){return this.s(B,be,G=>G.resolveLink(F,H),void 0,void 0,!0)}$releaseDocumentLinks(B,F){this.s(B,be,H=>H.releaseLinks(F),void 0,void 0,!0)}registerColorProvider(B,F,H){const G=this.t(new me(this.h,H),B);return this.e.$registerDocumentColorProvider(G,this.o(F,B)),this.p(G)}$provideDocumentColors(B,F,H){return this.s(B,me,G=>G.provideColors(d.URI.revive(F),H),[],H)}$provideColorPresentations(B,F,H,G){return this.s(B,me,te=>te.provideColorPresentations(d.URI.revive(F),H,G),void 0,G)}registerFoldingRangeProvider(B,F,H){const G=this.q(),te=typeof H.onDidChangeFoldingRanges=="function"?this.q():void 0;this.f.set(G,new Pe(new Q(this.h,H),B)),this.e.$registerFoldingRangeProvider(G,this.o(F,B),B.identifier,te);let re=this.p(G);if(te!==void 0){const Oe=H.onDidChangeFoldingRanges(()=>this.e.$emitFoldingRangeEvent(te));re=c.$nM.from(re,Oe)}return re}$provideFoldingRanges(B,F,H,G){return this.s(B,Q,te=>te.provideFoldingRanges(d.URI.revive(F),H,G),void 0,G)}registerSelectionRangeProvider(B,F,H){const G=this.t(new Y(this.h,H,this.l),B);return this.e.$registerSelectionRangeProvider(G,this.o(F,B)),this.p(G)}$provideSelectionRanges(B,F,H,G){return this.s(B,Y,te=>te.provideSelectionRanges(d.URI.revive(F),H,G),[],G)}registerCallHierarchyProvider(B,F,H){const G=this.t(new he(this.h,H),B);return this.e.$registerCallHierarchyProvider(G,this.o(F,B)),this.p(G)}$prepareCallHierarchy(B,F,H,G){return this.s(B,he,te=>Promise.resolve(te.prepareSession(d.URI.revive(F),H,G)),void 0,G)}$provideCallHierarchyIncomingCalls(B,F,H,G){return this.s(B,he,te=>te.provideCallsTo(F,H,G),void 0,G)}$provideCallHierarchyOutgoingCalls(B,F,H,G){return this.s(B,he,te=>te.provideCallsFrom(F,H,G),void 0,G)}$releaseCallHierarchy(B,F){this.s(B,he,H=>Promise.resolve(H.releaseSession(F)),void 0,void 0)}registerTypeHierarchyProvider(B,F,H){const G=this.t(new ce(this.h,H),B);return this.e.$registerTypeHierarchyProvider(G,this.o(F,B)),this.p(G)}$prepareTypeHierarchy(B,F,H,G){return this.s(B,ce,te=>Promise.resolve(te.prepareSession(d.URI.revive(F),H,G)),void 0,G)}$provideTypeHierarchySupertypes(B,F,H,G){return this.s(B,ce,te=>te.provideSupertypes(F,H,G),void 0,G)}$provideTypeHierarchySubtypes(B,F,H,G){return this.s(B,ce,te=>te.provideSubtypes(F,H,G),void 0,G)}$releaseTypeHierarchy(B,F){this.s(B,ce,H=>Promise.resolve(H.releaseSession(F)),void 0,void 0)}registerDocumentOnDropEditProvider(B,F,H,G){const te=this.q();return this.f.set(te,new Pe(new Te(this.e,this.h,H,te,B),B)),this.e.$registerDocumentOnDropEditProvider(te,this.o(F,B),(0,u.$LG)(B,"documentPaste")&&G?{supportsResolve:!!H.resolveDocumentDropEdit,dropMimeTypes:G.dropMimeTypes}:void 0),this.p(te)}$provideDocumentOnDropEdits(B,F,H,G,te,re){return this.s(B,Te,Oe=>Promise.resolve(Oe.provideDocumentOnDropEdits(F,d.URI.revive(H),G,te,re)),void 0,void 0)}$resolveDropEdit(B,F,H){return this.s(B,Te,G=>G.resolveDropEdit(F,H),{},void 0)}$releaseDropEdits(B,F){this.s(B,Te,H=>Promise.resolve(H.releaseDropEdits(F)),void 0,void 0)}registerMappedEditsProvider(B,F,H){const G=this.t(new fe(this.h,H),B);return this.e.$registerMappedEditsProvider(G,this.o(F,B)),this.p(G)}$provideMappedEdits(B,F,H,G,te){return this.s(B,fe,re=>Promise.resolve(re.provideMappedEdits(F,H,G,te)),null,te)}registerDocumentPasteEditProvider(B,F,H,G){const te=this.q();return this.f.set(te,new Pe(new z(this.e,this.h,H,te,B),B)),this.e.$registerPasteEditProvider(te,this.o(F,B),{supportsCopy:!!H.prepareDocumentPaste,supportsPaste:!!H.provideDocumentPasteEdits,supportsResolve:!!H.resolveDocumentPasteEdit,providedPasteEditKinds:G.providedPasteEditKinds?.map(re=>re.value),copyMimeTypes:G.copyMimeTypes,pasteMimeTypes:G.pasteMimeTypes}),this.p(te)}$prepareDocumentPaste(B,F,H,G,te){return this.s(B,z,re=>re.prepareDocumentPaste(d.URI.revive(F),H,G,te),void 0,te)}$providePasteEdits(B,F,H,G,te,re,Oe){return this.s(B,z,Be=>Be.providePasteEdits(F,d.URI.revive(H),G,te,re,Oe),void 0,Oe)}$resolvePasteEdit(B,F,H){return this.s(B,z,G=>G.resolvePasteEdit(F,H),{},void 0)}$releasePasteEdits(B,F){this.s(B,z,H=>Promise.resolve(H.releasePasteEdits(F)),void 0,void 0)}static w(B){return{pattern:B.source,flags:B.flags}}static y(B){return{decreaseIndentPattern:Re.w(B.decreaseIndentPattern),increaseIndentPattern:Re.w(B.increaseIndentPattern),indentNextLinePattern:B.indentNextLinePattern?Re.w(B.indentNextLinePattern):void 0,unIndentedLinePattern:B.unIndentedLinePattern?Re.w(B.unIndentedLinePattern):void 0}}static z(B){return{beforeText:Re.w(B.beforeText),afterText:B.afterText?Re.w(B.afterText):void 0,previousLineText:B.previousLineText?Re.w(B.previousLineText):void 0,action:B.action}}static B(B){return B.map(Re.z)}static C(B){return{open:B.open,close:B.close,notIn:B.notIn?B.notIn.map(F=>c.SyntaxTokenType.toString(F)):void 0}}static D(B){return B.map(Re.C)}setLanguageConfiguration(B,F,H){const{wordPattern:G}=H;if(G&&(0,O.$lf)(G))throw new Error(`Invalid language configuration: wordPattern '${G}' is not allowed to match the empty string.`);G?this.h.setWordDefinitionFor(F,G):this.h.setWordDefinitionFor(F,void 0),H.__electricCharacterSupport&&this.m.report("LanguageConfiguration.__electricCharacterSupport",B,"Do not use."),H.__characterPairSupport&&this.m.report("LanguageConfiguration.__characterPairSupport",B,"Do not use.");const te=this.q(),re={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?Re.w(H.wordPattern):void 0,indentationRules:H.indentationRules?Re.y(H.indentationRules):void 0,onEnterRules:H.onEnterRules?Re.B(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport,autoClosingPairs:H.autoClosingPairs?Re.D(H.autoClosingPairs):void 0};return this.e.$setLanguageConfiguration(te,F,re),this.p(te)}$setWordDefinitions(B){for(const F of B)this.h.setWordDefinitionFor(F.languageId,new RegExp(F.regexSource,F.regexFlags))}}e.$dmc=Re}),define(Se[90],Ie([1,0,11,20,14,5,42,6,175,21,3,12,103,4,86,17,8,7,108,25]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t){"use strict";var c;Object.defineProperty(e,"__esModule",{value:!0}),e.$Xmc=e.$Wmc=void 0,e.$Wmc=(0,O.$yi)("IExtHostLanguageModels");class u{constructor(l,g){this.option=l,this.stream=new C.$2h,this.stream=g??new C.$2h}}class i{constructor(){this.a=new Map,this.b=new C.$2h,this.c=!1,this.d=!1;const l=this;this.apiObject={stream:l.b.asyncIterable}}*f(){if(this.a.size>0)for(const[,l]of this.a)yield l.stream;else yield this.b}handleFragment(l){if(this.c)return;this.d=!0;let g=this.a.get(l.index);g||(this.a.size===0?g=new u(l.index,this.b):g=new u(l.index),this.a.set(l.index,g)),g.stream.emitOne(l.part)}get isStreaming(){return this.d}reject(l){this.c=!0;for(const g of this.f())g.reject(l)}resolve(){this.c=!0;for(const l of this.f())l.resolve()}}let b=class{static{c=this}static{this.a=1}constructor(l,g,$){this.j=g,this.k=$,this.c=new T.$fe,this.d=new T.$fe,this.onDidChangeProviders=this.d.event,this.f=new Map,this.g=new Map,this.h=new D.$Vm,this.i=new Map,this.r=new Set,this.b=l.getProxy(w.$lM.MainThreadLanguageModels)}dispose(){this.c.dispose(),this.d.dispose()}registerLanguageModel(l,g,$,v){const y=c.a++;this.f.set(y,{extension:l.identifier,provider:$,languageModelId:g});let h;v.auth&&(h={providerLabel:l.displayName||l.name,accountLabel:typeof v.auth=="object"?v.auth.label:void 0}),this.b.$registerLanguageModelProvider(y,`${D.$Tm.toKey(l.identifier)}/${y}/${g}`,{extension:l.identifier,id:g,vendor:v.vendor??D.$Tm.toKey(l.identifier),name:v.name??"",family:v.family??"",version:v.version,maxInputTokens:v.maxInputTokens??v.tokens,maxOutputTokens:v.maxOutputTokens??v.tokens,auth:h,targetExtensions:v.extensions});const E=$.onDidReceiveLanguageModelResponse2?.(({extensionId:k,participant:I,tokenCount:P})=>{this.b.$whenLanguageModelChatRequestMade(g,new D.$Tm(k),I,P)});return(0,p.$Sc)(()=>{this.f.delete(y),this.b.$unregisterProvider(y),E?.dispose()})}async $provideLanguageModelResponse(l,g,$,v,y,h){const E=this.f.get(l);if(!E)return;const k=new d.$iw(async I=>{if(h.isCancellationRequested){this.j.warn(`[CHAT](${E.extension.value}) CANNOT send progress because the REQUEST IS CANCELLED`);return}this.b.$handleProgressChunk(g,{index:I.index,part:I.part})});return E.provider.provideLanguageModelResponse(v.map(r.LanguageModelChatMessage.to),y,D.$Tm.toKey($),k,h)}$provideTokenLength(l,g,$){const v=this.f.get(l);return v?Promise.resolve(v.provider.provideTokenCount(g,$)):Promise.resolve(0)}$acceptChatModelMetadata(l){if(l.added)for(const{identifier:g,metadata:$}of l.added)this.g.set(g,{metadata:$,apiObjects:new D.$Vm});if(l.removed)for(const g of l.removed){this.g.delete(g);for(const[$,v]of this.i)v.languageModelId===g&&(v.res.reject(new M.$5),this.i.delete($))}l.added?.forEach(g=>this.p(g.metadata)),this.d.fire(void 0)}async selectLanguageModels(l,g){const $=await this.b.$selectChatModels({...g,extension:l.identifier}),v=[],y=this;for(const h of $){const E=this.g.get(h);if(!E)continue;let k=E.apiObjects.get(l.identifier);k||(k={id:h,vendor:E.metadata.vendor,family:E.metadata.family,version:E.metadata.version,name:E.metadata.name,maxInputTokens:E.metadata.maxInputTokens,maxOutputTokens:E.metadata.maxOutputTokens,countTokens(I,P){if(!y.g.has(h))throw s.$CO.NotFound(h);return y.q(h,I,P??N.CancellationToken.None)},sendRequest(I,P,V){if(!y.g.has(h))throw s.$CO.NotFound(h);return y.l(l,h,I,P??{},V??N.CancellationToken.None)}},Object.freeze(k),E.apiObjects.set(l.identifier,k)),v.push(k)}return v}async l(l,g,$,v,y){const h=this.m(l,$),E=l.identifier,k=this.g.get(g)?.metadata;if(!k||!this.g.has(g))throw s.$CO.NotFound(`Language model '${g}' is unknown.`);if(this.o(E,k)&&(!await this.n(l,{identifier:k.extension,displayName:k.auth.providerLabel},v.justification,!1)||!this.h.get(E)?.has(k.extension)))throw s.$CO.NoPermissions(`Language model '${g}' cannot be used by '${E.value}'.`);const I=Math.random()*1e6|0,P=this.b.$fetchResponse(E,g,I,h,v.modelOptions??{},y),V=new C.$xh,W=new i;this.i.set(I,{languageModelId:g,res:W});let q;if(P.catch(R=>{V.isOpen()?W.reject(R):q=R}).finally(()=>{this.i.delete(I),W.resolve(),V.open()}),await V.wait(),q)throw q.name===s.$CO.name?q:new s.$CO(`Language model '${g}' errored, check cause for more details`,"Unknown",q);return W.apiObject}m(l,g){const $=[];for(const v of g)v.role===s.LanguageModelChatMessageRole.System&&(0,t.$MG)(l,"languageModelSystem"),$.push(r.LanguageModelChatMessage.from(v));return $}async $handleResponseFragment(l,g){const $=this.i.get(l);$&&$.res.handleFragment(g)}async n(l,g,$,v){const y=n.$nL+g.identifier.value;if(await this.k.getSession(l,y,[],{silent:!0}))return this.$updateModelAccesslist([{from:l.identifier,to:g.identifier,enabled:!0}]),!0;if(v)return!1;try{const E=$?(0,m.localize)(0,null,g.displayName,$):(0,m.localize)(1,null,g.displayName);return await this.k.getSession(l,y,[],{forceNewSession:{detail:E}}),this.$updateModelAccesslist([{from:l.identifier,to:g.identifier,enabled:!0}]),!0}catch{return!1}}o(l,g){return!!g.auth&&!D.$Tm.equals(g.extension,l)}async p(l){for(const g of this.r)try{await this.n(g,{identifier:l.extension,displayName:""},void 0,!0)}catch($){this.j.error("Fake Auth request failed"),this.j.error($)}}async q(l,g,$){if(!this.g.get(l))throw s.$CO.NotFound(`Language model '${l}' is unknown.`);const y=A.Iterable.find(this.f.values(),h=>h.languageModelId===l);return y?y.provider.provideTokenCount(g,$):this.b.$countTokens(l,typeof g=="string"?g:r.LanguageModelChatMessage.from(g),$)}$updateModelAccesslist(l){const g=new Array;for(const{from:$,to:v,enabled:y}of l){const h=this.h.get($)??new D.$Um;if(h.has(v)!==y){y?h.add(v):h.delete(v),this.h.set($,h);const k={from:$,to:v};g.push(k),this.c.fire(k)}}}createLanguageModelAccessInformation(l){this.r.add(l);const g=this,$=T.Event.signal(T.Event.filter(this.c.event,y=>D.$Tm.equals(y.from,l.identifier))),v=T.Event.signal(this.d.event);return{get onDidChange(){return T.Event.any($,v)},canSendRequest(y){let h;e:for(const[k,I]of g.g)for(const P of I.apiObjects.values())if(P===y){h=I.metadata;break e}if(!h)return;if(!g.o(l.identifier,h))return!0;const E=g.h.get(l.identifier);if(E)return E.has(h.extension)}}}};e.$Xmc=b,e.$Xmc=b=c=Je([We(0,o.$PO),We(1,S.$5j),We(2,f.$fmc)],b)}),define(Se[275],Ie([1,0,4,8,7,32,11,6,25]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Cnc=void 0;class D{constructor(S,d,w,f){this.c=d,this.d=w,this.e=f,this.b=[],this.f=0,this.g=new Set,this.a=S.getProxy(C.$lM.MainThreadLanguages)}$acceptLanguageIds(S){this.b=S}async getLanguages(){return this.b.slice(0)}async changeLanguage(S,d){await this.a.$changeLanguage(S,d);const w=this.c.getDocumentData(S);if(!w)throw new Error(`document '${S.toString()}' NOT found`);return w.document}async tokenAtPosition(S,d){const w=S.version,f=N.Position.from(d),o=await this.a.$tokensAtPosition(S.uri,f),r={type:M.StandardTokenType.Other,range:S.getWordRangeAtPosition(d)??new M.$pM(d.line,d.character,d.line,d.character)};if(!o)return r;const s={range:N.Range.to(o.range),type:N.TokenType.to(o.type)};return!s.range.contains(d)||w!==S.version?r:s}createLanguageStatusItem(S,d,w){const f=this.f++,o=this.a,r=this.g,s=`${S.identifier.value}/${d}`;if(r.has(s))throw new Error(`LanguageStatusItem with id '${d}' ALREADY exists`);r.add(s);const n={selector:w,id:d,name:S.displayName??S.name,severity:M.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let t;const c=new p.$Tc,u=()=>{if(t?.dispose(),!r.has(s)){console.warn(`LanguageStatusItem (${d}) from ${S.identifier.value} has been disposed and CANNOT be updated anymore`);return}t=(0,A.$Ah)(()=>{c.clear(),this.a.$setLanguageStatus(f,{id:s,name:n.name??S.displayName??S.name,source:S.displayName??S.name,selector:N.DocumentSelector.from(n.selector,this.e),label:n.text,detail:n.detail??"",severity:n.severity===M.LanguageStatusSeverity.Error?T.default.Error:n.severity===M.LanguageStatusSeverity.Warning?T.default.Warning:T.default.Info,command:n.command&&this.d.toInternal(n.command,c),accessibilityInfo:n.accessibilityInformation,busy:n.busy})},0)},i={dispose(){c.dispose(),t?.dispose(),o.$removeLanguageStatus(f),r.delete(s)},get id(){return n.id},get name(){return n.name},set name(b){n.name=b,u()},get selector(){return n.selector},set selector(b){n.selector=b,u()},get text(){return n.text},set text(b){n.text=b,u()},set text2(b){(0,m.$MG)(S,"languageStatusText"),n.text=b,u()},get text2(){return(0,m.$MG)(S,"languageStatusText"),n.text},get detail(){return n.detail},set detail(b){n.detail=b,u()},get severity(){return n.severity},set severity(b){n.severity=b,u()},get accessibilityInformation(){return n.accessibilityInformation},set accessibilityInformation(b){n.accessibilityInformation=b,u()},get command(){return n.command},set command(b){n.command=b,u()},get busy(){return n.busy},set busy(b){n.busy=b,u()}};return u(),i}}e.$Cnc=D}),define(Se[276],Ie([1,0,16,2,8,7,85]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$pnc=e.$onc=void 0;class p{constructor(S,d,w,f){this.start=S,this.deletedCount=d,this.deletedItems=w,this.items=f}asApiEvent(){return{range:new T.$PN(this.start,this.start+this.deletedCount),addedCells:this.items.map(S=>S.apiCell),removedCells:this.deletedItems}}}class m{static asModelAddData(S){return{EOL:S.eol,lines:S.source,languageId:S.language,uri:S.uri,isDirty:!1,versionId:1}}constructor(S,d,w){this.notebook=S,this.h=d,this.j=w,this.handle=w.handle,this.uri=N.URI.revive(w.uri),this.cellKind=w.cellKind,this.a=w.outputs.map(M.NotebookCellOutput.to),this.e=w.internalMetadata??{},this.b=Object.freeze(w.metadata??{}),this.d=Object.freeze(M.NotebookCellExecutionSummary.to(w.internalMetadata??{}))}get internalMetadata(){return this.e}get apiCell(){if(!this.f){const S=this,d=this.h.getDocument(this.uri);if(!d)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const w={get index(){return S.notebook.getCellIndex(S)},notebook:S.notebook.apiNotebook,kind:M.NotebookCellKind.to(this.j.cellKind),document:d.document,get mime(){return S.g},set mime(f){S.g=f},get outputs(){return S.a.slice(0)},get metadata(){return S.b},get executionSummary(){return S.d}};this.f=Object.freeze(w)}return this.f}setOutputs(S){this.a=S.map(M.NotebookCellOutput.to)}setOutputItems(S,d,w){const f=w.map(M.NotebookCellOutputItem.to),o=this.a.find(r=>r.id===S);if(o&&(d||(o.items.length=0),o.items.push(...f),o.items.length>1&&o.items.every(r=>A.$hK(r.mime)))){const r=new Map,s=[];o.items.forEach(n=>{let t;r.has(n.mime)?t=r.get(n.mime):(t=[],r.set(n.mime,t),s.push(n.mime)),t.push(n.data)}),o.items.length=0,s.forEach(n=>{const t=A.$iK(r.get(n));o.items.push({mime:n,data:t.data.buffer})})}}setMetadata(S){this.b=Object.freeze(S)}setInternalMetadata(S){this.e=S,this.d=Object.freeze(M.NotebookCellExecutionSummary.to(S))}setMime(S){}}e.$onc=m;class D{static{this.a=0}constructor(S,d,w,f,o){this.k=S,this.l=d,this.m=w,this.uri=f,this.handle=D.a++,this.b=[],this.g=0,this.h=!1,this.j=!1,this.d=o.viewType,this.f=Object.freeze(o.metadata??Object.create(null)),this.r([[0,0,o.cells]],!0,void 0),this.g=o.versionId}dispose(){this.j=!0}get versionId(){return this.g}get apiNotebook(){if(!this.e){const S=this,d={get uri(){return S.uri},get version(){return S.g},get notebookType(){return S.d},get isDirty(){return S.h},get isUntitled(){return S.uri.scheme===C.Schemas.untitled},get isClosed(){return S.j},get metadata(){return S.f},get cellCount(){return S.b.length},cellAt(w){return w=S.n(w),S.b[w].apiCell},getCells(w){return(w?S.p(w):S.b).map(o=>o.apiCell)},save(){return S.q()}};this.e=Object.freeze(d)}return this.e}acceptDocumentPropertiesChanged(S){S.metadata&&(this.f=Object.freeze({...this.f,...S.metadata}))}acceptDirty(S){this.h=S}acceptModelChanged(S,d,w){this.g=S.versionId,this.h=d,this.acceptDocumentPropertiesChanged({metadata:w});const f={notebook:this.apiNotebook,metadata:w,cellChanges:[],contentChanges:[]},o=[];for(const s of S.rawEvents)s.kind===A.NotebookCellsChangeType.ModelChange?this.r(s.changes,!1,f.contentChanges):s.kind===A.NotebookCellsChangeType.Move?this.s(s.index,s.length,s.newIdx,f.contentChanges):s.kind===A.NotebookCellsChangeType.Output?(this.t(s.index,s.outputs),o.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.OutputItem?(this.u(s.index,s.outputId,s.append,s.outputItems),o.push({cell:this.b[s.index].apiCell,outputs:this.b[s.index].apiCell.outputs})):s.kind===A.NotebookCellsChangeType.ChangeCellLanguage?(this.v(s.index,s.language),o.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document})):s.kind===A.NotebookCellsChangeType.ChangeCellContent?o.push({cell:this.b[s.index].apiCell,document:this.b[s.index].apiCell.document}):s.kind===A.NotebookCellsChangeType.ChangeCellMime?this.w(s.index,s.mime):s.kind===A.NotebookCellsChangeType.ChangeCellMetadata?(this.x(s.index,s.metadata),o.push({cell:this.b[s.index].apiCell,metadata:this.b[s.index].apiCell.metadata})):s.kind===A.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this.y(s.index,s.internalMetadata),o.push({cell:this.b[s.index].apiCell,executionSummary:this.b[s.index].apiCell.executionSummary}));const r=new Map;for(let s=0;s<o.length;s++){const n=o[s],t=r.get(n.cell);if(t===void 0){const c=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...n});r.set(n.cell,c-1)}else f.cellChanges[t]={...f.cellChanges[t],...n}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}n(S){return S=S|0,S<0?0:S>=this.b.length?this.b.length-1:S}o(S){let d=S.start|0,w=S.end|0;return d<0&&(d=0),w>this.b.length&&(w=this.b.length),S.with({start:d,end:w})}p(S){S=this.o(S);const d=[];for(let w=S.start;w<S.end;w++)d.push(this.b[w]);return d}async q(){return this.j?Promise.reject(new Error("Notebook has been closed")):this.k.$trySaveNotebook(this.uri)}r(S,d,w){if(this.j)return;const f=[],o=[],r=[];if(S.reverse().forEach(s=>{const t=s[2].map(i=>{const b=new m(this,this.l,i);return d||o.push(m.asModelAddData(i)),b}),c=new p(s[0],s[1],[],t),u=this.b.splice(s[0],s[1],...t);for(const i of u)r.push(i.uri),c.deletedItems.push(i.apiCell);f.push(c)}),this.l.acceptDocumentsAndEditorsDelta({addedDocuments:o,removedDocuments:r}),w)for(const s of f)w.push(s.asApiEvent())}s(S,d,w,f){const o=this.b.splice(S,d);this.b.splice(w,0,...o);const r=[new p(S,d,o.map(s=>s.apiCell),[]),new p(w,0,[],o)];for(const s of r)f.push(s.asApiEvent())}t(S,d){this.b[S].setOutputs(d)}u(S,d,w,f){this.b[S].setOutputItems(d,w,f)}v(S,d){const w=this.b[S];w.apiCell.document.languageId!==d&&this.m.$acceptModelLanguageChanged(w.uri,d)}w(S,d){const w=this.b[S];w.apiCell.mime=d}x(S,d){this.b[S].setMetadata(d)}y(S,d){this.b[S].setInternalMetadata(d)}getCellFromApiCell(S){return this.b.find(d=>d.apiCell===S)}getCellFromIndex(S){return this.b[S]}getCell(S){return this.b.find(d=>d.handle===S)}getCellIndex(S){return this.b.indexOf(S)}}e.$pnc=D}),define(Se[277],Ie([1,0,5,2,8,7,34]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Enc=void 0;class p{constructor(D,O,S,d={timeout:1500,errors:3}){this.b=D,this.c=O,this.d=S,this.f=d,this.a=new C.$he}dispose(){}getOnWillSaveNotebookDocumentEvent(D){return(O,S,d)=>{const w=function(o){O.call(S,o)};return w.extension=D,this.a.event(w,void 0,d)}}async $participateInSave(D,O,S){const d=N.URI.revive(D),w=this.c.getNotebookDocument(d);if(!w)throw new Error("Unable to resolve notebook document");const f=[];if(await this.a.fireAsync({notebook:w.apiNotebook,reason:M.TextDocumentSaveReason.to(O)},S,async(r,s)=>{const n=Date.now(),t=await await Promise.resolve(r);Date.now()-n>this.f.timeout&&this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier),!S.isCancellationRequested&&t&&(t instanceof T.$xM?f.push(t):this.b.warn("onWillSaveNotebookDocument-listener from extension",s.extension.identifier,"ignored due to invalid data"))}),S.isCancellationRequested)return!1;if(f.length===0)return!0;const o={edits:[]};for(const r of f){const{edits:s}=M.WorkspaceEdit.from(r);o.edits=o.edits.concat(s)}return this.d.$tryApplyWorkspaceEdit(new A.$Gw(o))}}e.$Enc=p}),define(Se[114],Ie([1,0,14,8,7]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$qnc=void 0;class T{static{this.apiEditorsToExtHost=new WeakMap}constructor(p,m,D,O,S,d){this.id=p,this.f=m,this.notebookData=D,this.a=[],this.b=[],this.d=!1,this.a=S,this.b=O,this.c=d}get apiEditor(){if(!this.e){const p=this;this.e={get notebook(){return p.notebookData.apiNotebook},get selection(){return p.a[0]},set selection(m){this.selections=[m]},get selections(){return p.a},set selections(m){if(!Array.isArray(m)||!m.every(M.$PN.isNotebookRange))throw(0,C.$7)("selections");p.a=m,p.g(m)},get visibleRanges(){return p.b},revealRange(m,D){p.f.$tryRevealRange(p.id,N.NotebookRange.from(m),D??M.NotebookEditorRevealType.Default)},get viewColumn(){return p.c}},T.apiEditorsToExtHost.set(this.e,this)}return this.e}get visible(){return this.d}_acceptVisibility(p){this.d=p}_acceptVisibleRanges(p){this.b=p}_acceptSelections(p){this.a=p}g(p){this.f.$trySetSelections(this.id,p.map(N.NotebookRange.from))}_acceptViewColumn(p){this.c=p}}e.$qnc=T}),define(Se[278],Ie([1,0,5,12,8]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Gnc=void 0;let T=class{constructor(p,m){this.c=p,this.d=m,this.a=new C.$fe,this.b=new C.$fe,this.onDidChangeNotebookEditorSelection=this.a.event,this.onDidChangeNotebookEditorVisibleRanges=this.b.event}$acceptEditorPropertiesChanged(p,m){this.c.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",p,m);const D=this.d.getEditorById(p);m.visibleRanges&&D._acceptVisibleRanges(m.visibleRanges.ranges.map(M.NotebookRange.to)),m.selections&&D._acceptSelections(m.selections.selections.map(M.NotebookRange.to)),m.visibleRanges&&this.b.fire({notebookEditor:D.apiEditor,visibleRanges:D.apiEditor.visibleRanges}),m.selections&&this.a.fire(Object.freeze({notebookEditor:D.apiEditor,selections:D.apiEditor.selections}))}$acceptEditorViewColumns(p){for(const m in p)this.d.getEditorById(m)._acceptViewColumn(M.ViewColumn.to(p[m]))}};e.$Gnc=T,e.$Gnc=T=Je([We(0,N.$5j)],T)}),define(Se[279],Ie([1,0,5,4,114]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Jnc=void 0;class T{constructor(p,m){this.c=m,this.a=new Map,this.b=p.getProxy(N.$lM.MainThreadNotebookRenderers)}$postRendererMessage(p,m,D){const O=this.c.getEditorById(p);this.a.get(m)?.fire({editor:O.apiEditor,message:D})}createRendererMessaging(p,m){if(!p.contributes?.notebookRenderer?.some(O=>O.id===m))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${m})`);return{onDidReceiveMessage:(O,S,d)=>this.d(m).event(O,S,d),postMessage:(O,S)=>{M.$qnc.apiEditorsToExtHost.has(O)&&([O,S]=[S,O]);const d=S&&M.$qnc.apiEditorsToExtHost.get(S);return this.b.$postMessage(d?.id,m,O)}}}d(p){let m=this.a.get(p);return m||(m=new C.$fe({onDidRemoveLastListener:()=>{m?.dispose(),this.a.delete(p)}}),this.a.set(p,m),m)}}e.$Jnc=T}),define(Se[280],Ie([1,0,8,103,20,69,14]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Nnc=void 0;class p{constructor(S){this.b=0,this.c=new Map,this.a=S}async withProgress(S,d,w){const f=this.b++,{title:o,location:r,cancellable:s}=d,n={label:S.displayName||S.name,id:S.identifier.value};return this.a.$startProgress(f,{location:C.ProgressLocation.from(r),title:o,source:n,cancellable:s},S.isUnderDevelopment?void 0:S.identifier.value).catch(A.$2),this.d(f,w,!!s)}d(S,d,w){let f;w&&(f=new M.$qe,this.c.set(S,f));const o=s=>{this.a.$progressEnd(s),this.c.delete(s),f?.dispose()};let r;try{r=d(new D(this.a,S),w&&f?f.token:M.CancellationToken.None)}catch(s){throw o(S),s}return r.then(s=>o(S),s=>o(S)),r}$acceptProgressCanceled(S){const d=this.c.get(S);d&&(d.cancel(),this.c.delete(S))}}e.$Nnc=p;function m(O,S){return O.message=S.message,typeof S.increment=="number"&&(typeof O.increment=="number"?O.increment+=S.increment:O.increment=S.increment),O}class D extends N.$iw{constructor(S,d){super(w=>this.throttledReport(w)),this.c=S,this.d=d}throttledReport(S){this.c.$progressReport(this.d,S)}}Je([(0,T.$5h)(100,(O,S)=>m(O,S),()=>Object.create(null))],D.prototype,"throttledReport",null)}),define(Se[281],Ie([1,0,2,4,11,8]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Onc=void 0;class A{static{this.a=0}constructor(m,D){this.d=D,this.c=new Map,this.b=m.getProxy(N.$lM.MainThreadQuickDiff)}$provideOriginalResource(m,D,O){const S=C.URI.revive(D),d=this.c.get(m);return d?(0,M.$qh)(()=>d.provideOriginalResource(S,O)).then(w=>w||null):Promise.resolve(null)}registerQuickDiffProvider(m,D,O,S){const d=A.a++;return this.c.set(d,D),this.b.$registerQuickDiffProvider(d,T.DocumentSelector.from(m,this.d),O,S),{dispose:()=>{this.b.$unregisterQuickDiffProvider(d),this.c.delete(d)}}}}e.$Onc=A}),define(Se[282],Ie([1,0,20,5,6,4,2,7,14,18,32,36,25,8]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Pnc=f;function f(o,r,s){const n=o.getProxy(T.$lM.MainThreadQuickOpen);class t{constructor(v,y){this.e=new Map,this.f=0,this.a=v,this.b=y}showQuickPick(v,y,h,E=C.CancellationToken.None){this.c=void 0;const k=Promise.resolve(y),I=++this.f,P=n.$show(I,{title:h?.title,placeHolder:h?.placeHolder,matchOnDescription:h?.matchOnDescription,matchOnDetail:h?.matchOnDetail,ignoreFocusLost:h?.ignoreFocusOut,canPickMany:h?.canPickMany},E),V={},W=P.then(()=>V);return Promise.race([W,k]).then(q=>{if(q===V)return;const R=(0,d.$LG)(v,"quickPickItemTooltip");return k.then(z=>{const K=[];for(let ie=0;ie<z.length;ie++){const de=z[ie];if(typeof de=="string")K.push({label:de,handle:ie});else if(de.kind===p.QuickPickItemKind.Separator)K.push({type:"separator",label:de.label});else{de.tooltip&&!R&&console.warn(`Extension '${v.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${v.identifier.value}`);const ye=de.iconPath?a(de.iconPath):void 0;K.push({label:de.label,iconPath:ye?.iconPath,iconClass:ye?.iconClass,description:de.description,detail:de.detail,picked:de.picked,alwaysShow:de.alwaysShow,tooltip:R?w.MarkdownString.fromStrict(de.tooltip):void 0,handle:ie})}}return h&&typeof h.onDidSelectItem=="function"&&(this.c=ie=>{h.onDidSelectItem(z[ie])}),n.$setItems(I,K),P.then(ie=>{if(typeof ie=="number")return z[ie];if(Array.isArray(ie))return ie.map(de=>z[de])})})}).then(void 0,q=>{if(!(0,m.$4)(q))return n.$setError(I,q),Promise.reject(q)})}$onItemSelected(v){this.c?.(v)}showInput(v,y=C.CancellationToken.None){return this.d=v?.validateInput,n.$input(v,typeof this.d=="function",y).then(void 0,h=>{if(!(0,m.$4)(h))return Promise.reject(h)})}async $validateInput(v){if(!this.d)return;const y=await this.d(v);if(!y||typeof y=="string")return y;let h;switch(y.severity){case p.InputBoxValidationSeverity.Info:h=O.default.Info;break;case p.InputBoxValidationSeverity.Warning:h=O.default.Warning;break;case p.InputBoxValidationSeverity.Error:h=O.default.Error;break;default:h=y.message?O.default.Error:O.default.Ignore;break}return{content:y.message,severity:h}}async showWorkspaceFolderPick(v,y=C.CancellationToken.None){const h=await this.b.executeCommand("_workbench.pickWorkspaceFolder",[v]);if(!h)return;const E=await this.a.getWorkspaceFolders2();if(E)return E.find(k=>k.uri.toString()===h.uri.toString())}createQuickPick(v){const y=new l(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}createInputBox(v){const y=new g(v,()=>this.e.delete(y._id));return this.e.set(y._id,y),y}$onDidChangeValue(v,y){this.e.get(v)?._fireDidChangeValue(y)}$onDidAccept(v){this.e.get(v)?._fireDidAccept()}$onDidChangeActive(v,y){const h=this.e.get(v);h instanceof l&&h._fireDidChangeActive(y)}$onDidChangeSelection(v,y){const h=this.e.get(v);h instanceof l&&h._fireDidChangeSelection(y)}$onDidTriggerButton(v,y){this.e.get(v)?._fireDidTriggerButton(y)}$onDidTriggerItemButton(v,y,h){const E=this.e.get(v);E instanceof l&&E._fireDidTriggerItemButton(y,h)}$onDidHide(v){this.e.get(v)?._fireDidHide()}}class c{static{this.a=1}constructor(v,y){this.x=v,this.y=y,this._id=l.a++,this.e=!1,this.f=!1,this.g=!0,this.j=!1,this.k=!0,this.l="",this.n=[],this.o=new Map,this.p=new N.$fe,this.q=new N.$fe,this.r=new N.$fe,this.s=new N.$fe,this.u={id:this._id},this.v=!1,this.w=[this.r,this.s,this.p,this.q],this.onDidChangeValue=this.q.event,this.onDidAccept=this.p.event,this.onDidTriggerButton=this.r.event,this.onDidHide=this.s.event}get title(){return this.b}set title(v){this.b=v,this.z({title:v})}get step(){return this.c}set step(v){this.c=v,this.z({step:v})}get totalSteps(){return this.d}set totalSteps(v){this.d=v,this.z({totalSteps:v})}get enabled(){return this.g}set enabled(v){this.g=v,this.z({enabled:v})}get busy(){return this.j}set busy(v){this.j=v,this.z({busy:v})}get ignoreFocusOut(){return this.k}set ignoreFocusOut(v){this.k=v,this.z({ignoreFocusOut:v})}get value(){return this.l}set value(v){this.l=v,this.z({value:v})}get placeholder(){return this.m}set placeholder(v){this.m=v,this.z({placeholder:v})}get buttons(){return this.n}set buttons(v){this.n=v.slice(),this.o.clear(),v.forEach((y,h)=>{const E=y===p.$MN.Back?-1:h;this.o.set(E,y)}),this.z({buttons:v.map((y,h)=>({...a(y.iconPath),tooltip:y.tooltip,handle:y===p.$MN.Back?-1:h}))})}show(){this.e=!0,this.f=!0,this.z({visible:!0})}hide(){this.e=!1,this.z({visible:!1})}_fireDidAccept(){this.p.fire()}_fireDidChangeValue(v){this.l=v,this.q.fire(v)}_fireDidTriggerButton(v){const y=this.o.get(v);y&&this.r.fire(y)}_fireDidHide(){this.f&&(this.f=this.e,this.s.fire())}dispose(){this.v||(this.v=!0,this._fireDidHide(),this.w=(0,M.$Pc)(this.w),this.t&&(clearTimeout(this.t),this.t=void 0),this.y(),n.$dispose(this._id))}z(v){if(!this.v){for(const y of Object.keys(v)){const h=v[y];this.u[y]=h===void 0?null:h}"visible"in this.u?(this.t&&(clearTimeout(this.t),this.t=void 0),this.A()):this.e&&!this.t&&(this.t=setTimeout(()=>{this.t=void 0,this.A()},0))}}A(){n.$createOrUpdate(this.u),this.u={id:this._id}}}function u($){if($ instanceof p.$kN)return{id:$.id};const v=b($),y=i($);return{dark:typeof v=="string"?A.URI.file(v):v,light:typeof y=="string"?A.URI.file(y):y}}function i($){return typeof $=="object"&&"light"in $?$.light:$}function b($){return typeof $=="object"&&"dark"in $?$.dark:$}function a($){const v=u($);let y,h;return"id"in v?h=S.ThemeIcon.asClassName(v):y=v,{iconPath:y,iconClass:h}}class l extends c{constructor(v,y){super(v.identifier,y),this.O=v,this.B=[],this.C=new Map,this.D=new Map,this.E=!1,this.F=!0,this.G=!0,this.H=!0,this.I=!1,this.J=[],this.K=new N.$fe,this.L=[],this.M=new N.$fe,this.N=new N.$fe,this.onDidChangeActive=this.K.event,this.onDidChangeSelection=this.M.event,this.onDidTriggerItemButton=this.N.event,this.w.push(this.K,this.M,this.N),this.z({type:"quickPick"})}get items(){return this.B}set items(v){this.B=v.slice(),this.C.clear(),this.D.clear(),v.forEach((E,k)=>{this.C.set(k,E),this.D.set(E,k)});const y=(0,d.$LG)(this.O,"quickPickItemTooltip"),h=[];for(let E=0;E<v.length;E++){const k=v[E];if(k.kind===p.QuickPickItemKind.Separator)h.push({type:"separator",label:k.label});else{k.tooltip&&!y&&console.warn(`Extension '${this.O.identifier.value}' uses a tooltip which is proposed API that is only available when running out of dev or with the following command line switch: --enable-proposed-api ${this.O.identifier.value}`);const I=k.iconPath?a(k.iconPath):void 0;h.push({handle:E,label:k.label,iconPath:I?.iconPath,iconClass:I?.iconClass,description:k.description,detail:k.detail,picked:k.picked,alwaysShow:k.alwaysShow,tooltip:y?w.MarkdownString.fromStrict(k.tooltip):void 0,buttons:k.buttons?.map((P,V)=>({...a(P.iconPath),tooltip:P.tooltip,handle:V}))})}}this.z({items:h})}get canSelectMany(){return this.E}set canSelectMany(v){this.E=v,this.z({canSelectMany:v})}get matchOnDescription(){return this.F}set matchOnDescription(v){this.F=v,this.z({matchOnDescription:v})}get matchOnDetail(){return this.G}set matchOnDetail(v){this.G=v,this.z({matchOnDetail:v})}get sortByLabel(){return this.H}set sortByLabel(v){this.H=v,this.z({sortByLabel:v})}get keepScrollPosition(){return this.I}set keepScrollPosition(v){this.I=v,this.z({keepScrollPosition:v})}get activeItems(){return this.J}set activeItems(v){this.J=v.filter(y=>this.D.has(y)),this.z({activeItems:this.J.map(y=>this.D.get(y))})}get selectedItems(){return this.L}set selectedItems(v){this.L=v.filter(y=>this.D.has(y)),this.z({selectedItems:this.L.map(y=>this.D.get(y))})}_fireDidChangeActive(v){const y=(0,D.$Hb)(v.map(h=>this.C.get(h)));this.J=y,this.K.fire(y)}_fireDidChangeSelection(v){const y=(0,D.$Hb)(v.map(h=>this.C.get(h)));this.L=y,this.M.fire(y)}_fireDidTriggerItemButton(v,y){const h=this.C.get(v);if(!h||!h.buttons||!h.buttons.length)return;const E=h.buttons[y];E&&this.N.fire({button:E,item:h})}}class g extends c{constructor(v,y){super(v.identifier,y),this.B=!1,this.z({type:"inputBox"})}get password(){return this.B}set password(v){this.B=v,this.z({password:v})}get prompt(){return this.C}set prompt(v){this.C=v,this.z({prompt:v})}get valueSelection(){return this.D}set valueSelection(v){this.D=v,this.z({valueSelection:v})}get validationMessage(){return this.E}set validationMessage(v){this.E=v,v?typeof v=="string"?this.z({validationMessage:v,severity:O.default.Error}):this.z({validationMessage:v.message,severity:v.severity??O.default.Error}):this.z({validationMessage:void 0,severity:O.default.Ignore})}}return new t(r,s)}}),define(Se[283],Ie([1,0,2,5,69,6,11,4,18,149,12,21,36,8,25,16,23]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r){"use strict";var s;Object.defineProperty(e,"__esModule",{value:!0}),e.$Rnc=e.$Qnc=void 0;function n(I){return I instanceof C.URI}function t(I,P){return I.scheme===o.Schemas.file&&P.scheme===o.Schemas.file&&r.$k?I.toString()===P.toString():I.toString().toLowerCase()===P.toString().toLowerCase()}function c(I){if(I)return typeof I.iconPath=="string"?C.URI.file(I.iconPath):C.URI.isUri(I.iconPath)||d.ThemeIcon.isThemeIcon(I.iconPath)?I.iconPath:void 0}function u(I){if(I.icon){if(C.URI.isUri(I.icon))return I.icon;if(d.ThemeIcon.isThemeIcon(I.icon))return I.icon;{const P=I.icon;return{light:P.light,dark:P.dark}}}else return}function i(I,P){if(!I.iconPath&&!P.iconPath)return 0;if(I.iconPath){if(!P.iconPath)return 1}else return-1;const V=typeof I.iconPath=="string"?I.iconPath:C.URI.isUri(I.iconPath)?I.iconPath.fsPath:I.iconPath.id,W=typeof P.iconPath=="string"?P.iconPath:C.URI.isUri(P.iconPath)?P.iconPath.fsPath:P.iconPath.id;return(0,D.$vr)(V,W)}function b(I,P){let V=0;if(I.strikeThrough!==P.strikeThrough)return I.strikeThrough?1:-1;if(I.faded!==P.faded)return I.faded?1:-1;if(I.tooltip!==P.tooltip)return(I.tooltip||"").localeCompare(P.tooltip||"");if(V=i(I,P),V!==0)return V;if(I.light&&P.light)V=i(I.light,P.light);else{if(I.light)return 1;if(P.light)return-1}if(V!==0)return V;if(I.dark&&P.dark)V=i(I.dark,P.dark);else{if(I.dark)return 1;if(P.dark)return-1}return V}function a(I,P){if(I.command!==P.command)return I.command<P.command?-1:1;if(I.title!==P.title)return I.title<P.title?-1:1;if(I.tooltip!==P.tooltip){if(I.tooltip!==void 0&&P.tooltip!==void 0)return I.tooltip<P.tooltip?-1:1;if(I.tooltip!==void 0)return 1;if(P.tooltip!==void 0)return-1}if(I.arguments===P.arguments)return 0;if(I.arguments)if(P.arguments){if(I.arguments.length!==P.arguments.length)return I.arguments.length-P.arguments.length}else return 1;else return-1;for(let V=0;V<I.arguments.length;V++){const W=I.arguments[V],q=P.arguments[V];if(W!==q&&!(n(W)&&n(q)&&t(W,q)))return W<q?-1:1}return 0}function l(I,P){let V=(0,D.$vr)(I.resourceUri.fsPath,P.resourceUri.fsPath,!0);if(V!==0)return V;if(I.command&&P.command)V=a(I.command,P.command);else{if(I.command)return 1;if(P.command)return-1}if(V!==0)return V;if(I.decorations&&P.decorations)V=b(I.decorations,P.decorations);else{if(I.decorations)return 1;if(P.decorations)return-1}if(I.multiFileDiffEditorModifiedUri&&P.multiFileDiffEditorModifiedUri)V=(0,D.$vr)(I.multiFileDiffEditorModifiedUri.fsPath,P.multiFileDiffEditorModifiedUri.fsPath,!0);else{if(I.multiFileDiffEditorModifiedUri)return 1;if(P.multiFileDiffEditorModifiedUri)return-1}if(I.multiDiffEditorOriginalUri&&P.multiDiffEditorOriginalUri)V=(0,D.$vr)(I.multiDiffEditorOriginalUri.fsPath,P.multiDiffEditorOriginalUri.fsPath,!0);else{if(I.multiDiffEditorOriginalUri)return 1;if(P.multiDiffEditorOriginalUri)return-1}return V}function g(I,P){for(let V=0;V<I.length;V++)if(I[V]!==P[V])return!1;return!0}function $(I,P){return I.command===P.command&&I.title===P.title&&I.tooltip===P.tooltip&&(I.arguments&&P.arguments?g(I.arguments,P.arguments):I.arguments===P.arguments)}function v(I,P){return(0,m.$ub)(I,P,$)}class y{#e;#t;get value(){return this.d}set value(P){P=P??"",this.#e.$setInputBoxValue(this.l,P),this.n(P)}get onDidChange(){return this.e.event}get placeholder(){return this.f}set placeholder(P){this.#e.$setInputBoxPlaceholder(this.l,P),this.f=P}get validateInput(){return(0,f.$MG)(this.k,"scmValidation"),this.g}set validateInput(P){if((0,f.$MG)(this.k,"scmValidation"),P&&typeof P!="function")throw new Error(`[${this.k.identifier.value}]: Invalid SCM input box validation function`);this.g=P,this.#e.$setValidationProviderIsEnabled(this.l,!!P)}get enabled(){return this.h}set enabled(P){P=!!P,this.h!==P&&(this.h=P,this.#e.$setInputBoxEnablement(this.l,P))}get visible(){return this.j}set visible(P){P=!!P,this.j!==P&&(this.j=P,this.#e.$setInputBoxVisibility(this.l,P))}get document(){return(0,f.$MG)(this.k,"scmTextDocument"),this.#t.getDocument(this.m)}constructor(P,V,W,q,R){this.k=P,this.l=q,this.m=R,this.d="",this.e=new N.$fe,this.f="",this.h=!0,this.j=!0,this.#t=V,this.#e=W}showValidationMessage(P,V){(0,f.$MG)(this.k,"scmValidation"),this.#e.$showValidationMessage(this.l,P,V)}$onInputBoxValueChange(P){this.n(P)}n(P){this.d=P,this.e.fire(P)}}e.$Qnc=y;class h{static{this.d=0}get disposed(){return this.l}get id(){return this.u}get label(){return this.v}set label(P){this.v=P,this.q.$updateGroupLabel(this.t,this.handle,P)}get hideWhenEmpty(){return this.p}set hideWhenEmpty(P){this.p=P,this.q.$updateGroup(this.t,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this.f]}set resourceStates(P){this.f=[...P],this.k.fire()}constructor(P,V,W,q,R,z,K){this.q=P,this.s=V,this.t=W,this.u=q,this.v=R,this.multiDiffEditorEnableViewChanges=z,this.w=K,this.e=0,this.f=[],this.g=new Map,this.h=new Map,this.j=new Map,this.k=new N.$fe,this.onDidUpdateResourceStates=this.k.event,this.l=!1,this.m=new N.$fe,this.onDidDispose=this.m.event,this.n=[],this.o=[],this.p=void 0,this.handle=h.d++}getResourceState(P){return this.g.get(P)}$executeResourceCommand(P,V){const W=this.h.get(P);return W?(0,A.$qh)(()=>this.s.executeCommand(W.command,...W.arguments||[],V)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const P=[...this.f].sort(l),W=(0,m.$Db)(this.o,P,l).map(z=>{const K=z.toInsert.map(ie=>{const de=this.e++;this.g.set(de,ie);const ye=ie.resourceUri;let De;if(ie.command)if(ie.command.command==="vscode.open"||ie.command.command==="vscode.diff"||ie.command.command==="vscode.changes"){const me=new T.$Tc;De=this.s.converter.toInternal(ie.command,me),this.j.set(de,me)}else this.h.set(de,ie.command);const ge=(0,f.$LG)(this.w,"scmMultiDiffEditor"),ue=ge?ie.multiDiffEditorOriginalUri:void 0,Ce=ge?ie.multiFileDiffEditorModifiedUri:void 0,se=c(ie.decorations),Ne=ie.decorations&&c(ie.decorations.light)||se,ne=ie.decorations&&c(ie.decorations.dark)||se,U=[Ne,ne],x=ie.decorations&&ie.decorations.tooltip||"",ve=ie.decorations&&!!ie.decorations.strikeThrough,Le=ie.decorations&&!!ie.decorations.faded,ke=ie.contextValue||"";return{rawResource:[de,ye,U,x,ve,Le,ke,De,ue,Ce],handle:de}});return{start:z.start,deleteCount:z.deleteCount,toInsert:K}}),q=W.map(({start:z,deleteCount:K,toInsert:ie})=>[z,K,ie.map(de=>de.rawResource)]),R=W.reverse();for(const{start:z,deleteCount:K,toInsert:ie}of R){const de=ie.map(De=>De.handle),ye=this.n.splice(z,K,...de);for(const De of ye)this.g.delete(De),this.h.delete(De),this.j.get(De)?.dispose(),this.j.delete(De)}return this.o=P,q}dispose(){this.l=!0,this.m.fire()}}class E{static{this.d=0}#e;get id(){return this.z}get label(){return this.A}get rootUri(){return this.B}get inputBox(){return this.f}get count(){return this.g}set count(P){this.g!==P&&(this.g=P,this.#e.$updateSourceControl(this.w,{count:P}))}get quickDiffProvider(){return this.h}set quickDiffProvider(P){this.h=P;let V;(0,f.$LG)(this.x,"quickDiffProvider")&&(V=P?.label),this.#e.$updateSourceControl(this.w,{hasQuickDiffProvider:!!P,quickDiffLabel:V})}get historyProvider(){return(0,f.$MG)(this.x,"scmHistoryProvider"),this.j}set historyProvider(P){(0,f.$MG)(this.x,"scmHistoryProvider"),this.j=P,this.k.value=new T.$Tc,this.#e.$updateSourceControl(this.w,{hasHistoryProvider:!!P}),P&&this.k.value.add(P.onDidChangeCurrentHistoryItemGroup(()=>{this.l=P?.currentHistoryItemGroup,this.#e.$onDidChangeHistoryProviderCurrentHistoryItemGroup(this.w,this.l)}))}get commitTemplate(){return this.m}set commitTemplate(P){P!==this.m&&(this.m=P,this.#e.$updateSourceControl(this.w,{commitTemplate:P}))}get acceptInputCommand(){return this.o}set acceptInputCommand(P){this.n.value=new T.$Tc,this.o=P;const V=this.y.converter.toInternal(P,this.n.value);this.#e.$updateSourceControl(this.w,{acceptInputCommand:V})}get actionButton(){return(0,f.$MG)(this.x,"scmActionButton"),this.q}set actionButton(P){(0,f.$MG)(this.x,"scmActionButton"),this.p.value=new T.$Tc,this.q=P;const V=P!==void 0?{command:this.y.converter.toInternal(P.command,this.p.value),secondaryCommands:P.secondaryCommands?.map(W=>W.map(q=>this.y.converter.toInternal(q,this.p.value))),description:P.description,enabled:P.enabled}:void 0;this.#e.$updateSourceControl(this.w,{actionButton:V??null})}get statusBarCommands(){return this.t}set statusBarCommands(P){if(this.t&&P&&v(this.t,P))return;this.s.value=new T.$Tc,this.t=P;const V=(P||[]).map(W=>this.y.converter.toInternal(W,this.s.value));this.#e.$updateSourceControl(this.w,{statusBarCommands:V})}get selected(){return this.u}constructor(P,V,W,q,R,z,K){this.x=P,this.y=q,this.z=R,this.A=z,this.B=K,this.e=new Map,this.g=void 0,this.h=void 0,this.k=new T.$Vc,this.m=void 0,this.n=new T.$Vc,this.o=void 0,this.p=new T.$Vc,this.s=new T.$Vc,this.t=void 0,this.u=!1,this.v=new N.$fe,this.onDidChangeSelection=this.v.event,this.w=E.d++,this.C=new Map,this.D=new Set,this.#e=W;const ie=C.URI.from({scheme:o.Schemas.vscodeSourceControl,path:`${R}/scm${this.w}/input`,query:K?`rootUri=${encodeURIComponent(K.toString())}`:void 0});this.f=new y(P,V,this.#e,this.w,ie),this.#e.$registerSourceControl(this.w,R,z,K,ie)}createResourceGroup(P,V,W){const q=(0,f.$LG)(this.x,"scmMultiDiffEditor")&&W?.multiDiffEditorEnableViewChanges===!0,R=new h(this.#e,this.y,this.w,P,V,q,this.x),z=N.Event.once(R.onDidDispose)(()=>this.C.delete(R));return this.C.set(R,z),this.eventuallyAddResourceGroups(),R}eventuallyAddResourceGroups(){const P=[],V=[];for(const[W,q]of this.C){q.dispose();const R=W.onDidUpdateResourceStates(()=>{this.D.add(W),this.eventuallyUpdateResourceStates()});N.Event.once(W.onDidDispose)(()=>{this.D.delete(W),R.dispose(),this.e.delete(W.handle),this.#e.$unregisterGroup(this.w,W.handle)}),P.push([W.handle,W.id,W.label,W.features,W.multiDiffEditorEnableViewChanges]);const z=W._takeResourceStateSnapshot();z.length>0&&V.push([W.handle,z]),this.e.set(W.handle,W)}this.#e.$registerGroups(this.w,P,V),this.C.clear()}eventuallyUpdateResourceStates(){const P=[];this.D.forEach(V=>{const W=V._takeResourceStateSnapshot();W.length!==0&&P.push([V.handle,W])}),P.length>0&&this.#e.$spliceResourceStates(this.w,P),this.D.clear()}getResourceGroup(P){return this.e.get(P)}setSelectionState(P){this.u=P,this.v.fire(P)}dispose(){this.n.dispose(),this.p.dispose(),this.s.dispose(),this.e.forEach(P=>P.dispose()),this.#e.$unregisterSourceControl(this.w)}}Je([(0,M.$4h)(100)],E.prototype,"eventuallyAddResourceGroups",null),Je([(0,M.$4h)(100)],E.prototype,"eventuallyUpdateResourceStates",null);let k=class{static{s=this}static{this.d=0}get onDidChangeActiveProvider(){return this.j.event}constructor(P,V,W,q){this.l=V,this.m=W,this.n=q,this.g=new Map,this.h=new S.$Vm,this.j=new N.$fe,this.e=P.getProxy(p.$lM.MainThreadSCM),this.f=P.getProxy(p.$lM.MainThreadTelemetry),V.registerArgumentProcessor({processArgument:R=>{if(R&&R.$mid===3){const z=this.g.get(R.sourceControlHandle);if(!z)return R;const K=z.getResourceGroup(R.groupHandle);return K?K.getResourceState(R.handle):R}else if(R&&R.$mid===4){const z=this.g.get(R.sourceControlHandle);return z?z.getResourceGroup(R.groupHandle):R}else if(R&&R.$mid===5){const z=this.g.get(R.handle);return z||R}return R}})}createSourceControl(P,V,W,q){this.n.trace("ExtHostSCM#createSourceControl",P.identifier.value,V,W,q),this.f.$publicLog2("api/scm/createSourceControl",{extensionId:P.identifier.value});const R=s.d++,z=new E(P,this.m,this.e,this.l,V,W,q);this.g.set(R,z);const K=this.h.get(P.identifier)||[];return K.push(z),this.h.set(P.identifier,K),z}getLastInputBox(P){this.n.trace("ExtHostSCM#getLastInputBox",P.identifier.value);const V=this.h.get(P.identifier),W=V&&V[V.length-1];return W&&W.inputBox}$provideOriginalResource(P,V,W){const q=C.URI.revive(V);this.n.trace("ExtHostSCM#$provideOriginalResource",P,q.toString());const R=this.g.get(P);return!R||!R.quickDiffProvider||!R.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,A.$qh)(()=>R.quickDiffProvider.provideOriginalResource(q,W)).then(z=>z||null)}$onInputBoxValueChange(P,V){this.n.trace("ExtHostSCM#$onInputBoxValueChange",P);const W=this.g.get(P);return W&&W.inputBox.$onInputBoxValueChange(V),Promise.resolve(void 0)}$executeResourceCommand(P,V,W,q){this.n.trace("ExtHostSCM#$executeResourceCommand",P,V,W);const R=this.g.get(P);if(!R)return Promise.resolve(void 0);const z=R.getResourceGroup(V);return z?z.$executeResourceCommand(W,q):Promise.resolve(void 0)}$validateInput(P,V,W){this.n.trace("ExtHostSCM#$validateInput",P);const q=this.g.get(P);return!q||!q.inputBox.validateInput?Promise.resolve(void 0):(0,A.$qh)(()=>q.inputBox.validateInput(V,W)).then(R=>{if(!R)return Promise.resolve(void 0);const z=w.MarkdownString.fromStrict(R.message);return z?Promise.resolve([z,R.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(P){return this.n.trace("ExtHostSCM#$setSelectedSourceControl",P),P!==void 0&&this.g.get(P)?.setSelectionState(!0),this.k!==void 0&&this.g.get(this.k)?.setSelectionState(!1),this.k=P,Promise.resolve(void 0)}async $resolveHistoryItemGroupCommonAncestor(P,V,W,q){return await this.g.get(P)?.historyProvider?.resolveHistoryItemGroupCommonAncestor(V,W,q)??void 0}async $provideHistoryItems(P,V,W,q){return(await this.g.get(P)?.historyProvider?.provideHistoryItems(V,W,q))?.map(K=>({...K,icon:u(K)}))??void 0}async $provideHistoryItemSummary(P,V,W,q){const R=this.g.get(P)?.historyProvider;if(typeof R?.provideHistoryItemSummary!="function")return;const z=await R.provideHistoryItemSummary(V,W,q);return z?{...z,icon:u(z)}:void 0}async $provideHistoryItemChanges(P,V,W,q){return await this.g.get(P)?.historyProvider?.provideHistoryItemChanges(V,W,q)??void 0}};e.$Rnc=k,e.$Rnc=k=s=Je([We(3,O.$5j)],k)}),define(Se[284],Ie([1,0,4,8,2]),function(le,e,C,N,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Snc=void 0;class T{static{this.a=0}constructor(p,m){this.d=m,this.c=new Map,this.b=p.getProxy(C.$lM.MainThreadShare)}async $provideShare(p,m,D){return await this.c.get(p)?.provideShare({selection:N.Range.to(m.selection),resourceUri:M.URI.revive(m.resourceUri)},D)??void 0}registerShareProvider(p,m){const D=T.a++;return this.c.set(D,m),this.b.$registerShareProvider(D,N.DocumentSelector.from(p,this.d),m.id,m.label,m.priority),{dispose:()=>{this.b.$unregisterShareProvider(D),this.c.delete(D)}}}}e.$Snc=T}),define(Se[285],Ie([1,0,7,4,178,6,8,15]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vnc=e.$Unc=void 0;class m{static{this.a=0}static{this.b=new Map([["statusBarItem.errorBackground",new C.$lN("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new C.$lN("statusBarItem.warningForeground")]])}#e;#t;constructor(d,w,f,o,r,s=C.StatusBarAlignment.Left,n){if(this.i=!1,this.k="",this.q=new T.$Tc,this.#e=d,this.#t=w,r&&o){this.c=(0,C.$ZM)(o.identifier,r);const t=f.get(this.c);t&&(s=t.alignLeft?C.StatusBarAlignment.Left:C.StatusBarAlignment.Right,n=t.priority,this.j=!0,this.name=t.name,this.text=t.text,this.tooltip=t.tooltip,this.command=t.command,this.accessibilityInformation=t.accessibilityInformation)}else this.c=String(m.a++);this.e=o,this.f=r,this.g=s,this.h=this.u(n)}u(d){if((0,p.$cg)(d))return d===Number.POSITIVE_INFINITY?Number.MAX_VALUE:d===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:d}get id(){return this.f??this.e.identifier.value}get alignment(){return this.g}get priority(){return this.h}get text(){return this.k}get name(){return this.m}get tooltip(){return this.l}get color(){return this.n}get backgroundColor(){return this.o}get command(){return this.r?.fromApi}get accessibilityInformation(){return this.t}set text(d){this.k=d,this.v()}set name(d){this.m=d,this.v()}set tooltip(d){this.l=d,this.v()}set color(d){this.n=d,this.v()}set backgroundColor(d){d&&!m.b.has(d.id)&&(d=void 0),this.o=d,this.v()}set command(d){this.r?.fromApi!==d&&(this.p&&this.q.add(this.p),this.p=new T.$Tc,typeof d=="string"?this.r={fromApi:d,internal:this.#t.toInternal({title:"",command:d},this.p)}:d?this.r={fromApi:d,internal:this.#t.toInternal(d,this.p)}:this.r=void 0,this.v())}set accessibilityInformation(d){this.t=d,this.v()}show(){this.j=!0,this.v()}hide(){clearTimeout(this.s),this.j=!1,this.#e.$disposeEntry(this.c)}v(){this.i||!this.j||(clearTimeout(this.s),this.s=setTimeout(()=>{this.s=void 0;let d;this.e?this.f?d=`${this.e.identifier.value}.${this.f}`:d=this.e.identifier.value:d=this.f;let w;this.m?w=this.m:w=(0,M.localize)(0,null,this.e.displayName||this.e.name);let f=this.n;this.o&&(f=m.b.get(this.o.id));const o=A.MarkdownString.fromStrict(this.l);this.#e.$setEntry(this.c,d,this.e?.identifier.value,w,this.k,o,this.r?.internal,f,this.o,this.g===C.StatusBarAlignment.Left,this.h,this.t),this.q.clear()},0))}dispose(){this.hide(),this.i=!0}}e.$Unc=m;class D{constructor(d){this.b=[],this.a=d.createStatusBarEntry(void 0,"status.extensionMessage",C.StatusBarAlignment.Left,Number.MIN_VALUE),this.a.name=(0,M.localize)(1,null)}dispose(){this.b.length=0,this.a.dispose()}setMessage(d){const w={message:d};return this.b.unshift(w),this.c(),new C.$nM(()=>{const f=this.b.indexOf(w);f>=0&&(this.b.splice(f,1),this.c())})}c(){this.b.length>0?(this.a.text=this.b[0].message,this.a.show()):this.a.hide()}}class O{constructor(d,w){this.e=new Map,this.a=d.getProxy(N.$lM.MainThreadStatusBar),this.b=w,this.c=new D(this)}$acceptStaticEntries(d){for(const w of d)this.e.set(w.entryId,w)}createStatusBarEntry(d,w,f,o){return new m(this.a,this.b,this.e,d,w,f,o)}setStatusBarMessage(d,w){const f=this.c.setMessage(d);let o;return typeof w=="number"?o=setTimeout(()=>f.dispose(),w):typeof w<"u"&&w.then(()=>f.dispose(),()=>f.dispose()),new C.$nM(()=>{f.dispose(),clearTimeout(o)})}}e.$Vnc=O}),define(Se[115],Ie([1,0,30,107,52,77,62,8,2]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5O=e.$4O=e.$3O=e.$2O=void 0;const D=(t,c,u,i)=>{let b=c;return{enumerable:!0,configurable:!1,get(){return b},set(a){if(!u(b,a)){const l=b;b=a,t.listener?.(i(a,l))}}}},O=(t,c)=>t===c,S={range:(t,c)=>t===c?!0:!t||!c?!1:t.isEqual(c),label:O,description:O,sortText:O,busy:O,error:O,canResolveChildren:O,tags:(t,c)=>!(t.length!==c.length||t.some(u=>!c.find(i=>u.id===i.id)))},d=t=>c=>({op:4,update:t(c)}),w=(t,c)=>({range:(()=>{let u;const i=d(b=>({range:C.$zt.lift(p.Range.from(b))}));return{enumerable:!0,configurable:!1,get(){return u},set(b){t.listener?.({op:6}),S.range(u,b)||(u=b,t.listener?.(i(b)))}}})(),label:D(t,c,S.label,d(u=>({label:u}))),description:D(t,void 0,S.description,d(u=>({description:u}))),sortText:D(t,void 0,S.sortText,d(u=>({sortText:u}))),canResolveChildren:D(t,!1,S.canResolveChildren,u=>({op:2,state:u})),busy:D(t,!1,S.busy,d(u=>({busy:u}))),error:D(t,void 0,S.error,d(u=>({error:p.MarkdownString.fromStrict(u)||null}))),tags:D(t,[],S.tags,(u,i)=>({op:1,new:u.map(p.TestTag.from),old:i.map(p.TestTag.from)}))}),f=t=>{const c=M.$0K.fromString(t.extId),u=new r(c.controllerId,c.localId,t.label,m.URI.revive(t.uri)||void 0);return u.range=p.Range.to(t.range||void 0),u.description=t.description||void 0,u.sortText=t.sortText||void 0,u.tags=t.tags.map(i=>p.TestTag.to({id:(0,A.$dL)(i).tagId})),u},o=t=>{let c;for(const u of t.tests){const i=f(u.item);(0,N.$LO)(i).parent=c,c=i}return c};e.$2O=o;class r{constructor(c,u,i,b){if(u.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(u)} symbol`);const a=(0,N.$KO)(this,c);Object.defineProperties(this,{id:{value:u,enumerable:!0,writable:!1},uri:{value:b,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return a.parent instanceof s?void 0:a.parent}},children:{value:(0,T.$JO)(a,N.$LO,r),enumerable:!0,writable:!1},...w(a,i)})}}e.$3O=r;class s extends r{constructor(c,u){super(c,c,u,void 0),this._isRoot=!0}}e.$4O=s;class n extends T.$FO{constructor(c,u,i){super({controllerId:c,getDocumentVersion:b=>b&&i.getDocument(b)?.version,getApiFor:N.$LO,getChildren:b=>b.children,root:new s(c,u),toITestItem:p.TestItem.from})}}e.$5O=n}),define(Se[35],Ie([1,0,15,7,8,26,4,18,12,45,30,94,2,6,3,17,115,22,34,44,66,59,63,33]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$dP=e.$cP=e.$bP=e.$aP=e.$_O=e.$$O=void 0;let a=class{#e;#t;#i;constructor(h,E,k){this.b=new Map,this.c=new Map,this.#e=h.getProxy(A.$lM.MainThreadCommands),this.d=E,this.#i=k,this.#t=h.getProxy(A.$lM.MainThreadTelemetry),this.converter=new l(this,I=>{const P=this.c.get(I);return P?.result===$.Void?P:void 0},E),this.f=[{processArgument(I){return(0,D.$8h)(I)}},{processArgument(I){return(0,T.$7n)(I,function(P){if(O.$zt.isIRange(P))return M.Range.to(P);if(S.$yt.isIPosition(P))return M.Position.to(P);if(O.$zt.isIRange(P.range)&&d.URI.isUri(P.uri))return M.location.to(P);if(P instanceof s.$He)return P.buffer.buffer;if(!Array.isArray(P))return P})}}]}registerArgumentProcessor(h){this.f.push(h)}registerApiCommand(h){const E=this.registerCommand(!1,h.id,async(...k)=>{const I=h.args.map((V,W)=>{if(!V.validate(k[W]))throw new Error(`Invalid argument '${V.name}' when running '${h.id}', received: ${typeof k[W]=="object"?JSON.stringify(k[W],null,"	"):k[W]} `);return V.convert(k[W])}),P=await this.executeCommand(h.internalId,...I);return h.result.convert(P,k,this.converter)},void 0,{description:h.description,args:h.args,returns:h.result.description});return this.c.set(h.id,h),new N.$nM(()=>{E.dispose(),this.c.delete(h.id)})}registerCommand(h,E,k,I,P,V){if(this.d.trace("ExtHostCommands#registerCommand",E),!E.trim().length)throw new Error("invalid id");if(this.b.has(E))throw new Error(`command '${E}' already exists`);return this.b.set(E,{callback:k,thisArg:I,metadata:P,extension:V}),h&&this.#e.$registerCommand(E),new N.$nM(()=>{this.b.delete(E)&&h&&this.#e.$unregisterCommand(E)})}executeCommand(h,...E){return this.d.trace("ExtHostCommands#executeCommand",h),this.g(h,E,!0)}async g(h,E,k){if(this.b.has(h))return this.#e.$fireCommandActivationEvent(h),this.h(h,E,!1);{let I=!1;const P=(0,T.$7n)(E,function(V){if(V instanceof N.$oM)return M.Position.from(V);if(V instanceof N.$pM)return M.Range.from(V);if(V instanceof N.$zM)return M.location.from(V);if(N.$PN.isNotebookRange(V))return M.NotebookRange.from(V);if(V instanceof ArrayBuffer)return I=!0,s.$He.wrap(new Uint8Array(V));if(V instanceof Uint8Array)return I=!0,s.$He.wrap(V);if(V instanceof s.$He)return I=!0,V;if(!Array.isArray(V))return V});try{const V=await this.#e.$executeCommand(h,I?new n.$Gw(P):P,k);return(0,D.$8h)(V)}catch(V){if(V instanceof Error&&V.message==="$executeCommand:retry")return this.g(h,E,!1);throw V}}}async h(h,E,k){const I=this.b.get(h);if(!I)throw new Error("Unknown command");const{callback:P,thisArg:V,metadata:W}=I;if(W?.args)for(let R=0;R<W.args.length;R++)try{(0,C.$pg)(E[R],W.args[R].constraint)}catch{throw new Error(`Running the contributed command: '${h}' failed. Illegal argument '${W.args[R].name}' - ${W.args[R].description}`)}const q=c.$be.create();try{return await P.apply(V,E)}catch(R){if(h===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...E);z&&(h=z.command)}if(this.d.error(R,h,I.extension?.identifier),!k)throw R;if(I.extension?.identifier){const z=this.#i.onExtensionError(I.extension.identifier,R);this.d.trace("forwarded error to extension?",z,I.extension?.identifier)}throw new class extends Error{constructor(){super((0,t.$jj)(R)),this.id=h,this.source=I.extension?.displayName??I.extension?.name}}}finally{this.j(I,h,q.elapsed())}}j(h,E,k){h.extension&&this.#t.$publicLog2("Extension:ActionExecuted",{extensionId:h.extension.identifier.value,id:new u.$jp(E),duration:k})}$executeContributedCommand(h,...E){this.d.trace("ExtHostCommands#$executeContributedCommand",h);const k=this.b.get(h);return k?(E=E.map(I=>this.f.reduce((P,V)=>V.processArgument(P,k.extension?.identifier),I)),this.h(h,E,!0)):Promise.reject(new Error(`Contributed command '${h}' does not exist.`))}getCommands(h=!1){return this.d.trace("ExtHostCommands#getCommands",h),this.#e.$getCommands().then(E=>(h&&(E=E.filter(k=>k[0]!=="_")),E))}$getContributedCommandMetadata(){const h=Object.create(null);for(const[E,k]of this.b){const{metadata:I}=k;I&&(h[E]=I)}return Promise.resolve(h)}};e.$$O=a,e.$$O=a=Je([We(0,o.$PO),We(1,m.$5j),We(2,i.$0O)],a),e.$_O=(0,f.$yi)("IExtHostCommands");class l{constructor(h,E,k){this.d=h,this.f=E,this.g=k,this.delegatingCommandId=`__vsc${(0,b.$Ug)()}`,this.b=new Map,this.c=0,this.d.registerCommand(!0,this.delegatingCommandId,this.h,this)}toInternal(h,E){if(!h)return;const k={$ident:void 0,id:h.command,title:h.title,tooltip:h.tooltip};if(!h.command)return k;const I=this.f(h.command);if(I)k.id=I.internalId,k.arguments=I.args.map((P,V)=>P.convert(h.arguments&&h.arguments[V]));else if((0,p.$Lb)(h.arguments)){const P=`${h.command} /${++this.c}`;this.b.set(P,h),E.add((0,w.$Sc)(()=>{this.b.delete(P),this.g.trace("CommandsConverter#DISPOSE",P)})),k.$ident=P,k.id=this.delegatingCommandId,k.arguments=[P],this.g.trace("CommandsConverter#CREATE",h.command,P)}return k}fromInternal(h){return typeof h.$ident=="string"?this.b.get(h.$ident):{command:h.id,title:h.title,arguments:h.arguments}}getActualCommand(...h){return this.b.get(h[0])}h(...h){const E=this.getActualCommand(...h);return this.g.trace("CommandsConverter#EXECUTE",h[0],E?E.command:"MISSING"),E?this.d.executeCommand(E.command,...E.arguments||[]):Promise.reject(`Actual command not found, wanted to execute ${h[0]}`)}}e.$aP=l;class g{static{this.Uri=new g("uri","Uri of a text document",h=>d.URI.isUri(h),h=>h)}static{this.Position=new g("position","A position in a text document",h=>N.$oM.isPosition(h),M.Position.from)}static{this.Range=new g("range","A range in a text document",h=>N.$pM.isRange(h),M.Range.from)}static{this.Selection=new g("selection","A selection in a text document",h=>N.$qM.isSelection(h),M.Selection.from)}static{this.Number=new g("number","",h=>typeof h=="number",h=>h)}static{this.String=new g("string","",h=>typeof h=="string",h=>h)}static{this.StringArray=g.Arr(g.String)}static Arr(h){return new g(`${h.name}_array`,`Array of ${h.name}, ${h.description}`,E=>Array.isArray(E)&&E.every(k=>h.validate(k)),E=>E.map(k=>h.convert(k)))}static{this.CallHierarchyItem=new g("item","A call hierarchy item",h=>h instanceof N.$LM,M.CallHierarchyItem.from)}static{this.TypeHierarchyItem=new g("item","A type hierarchy item",h=>h instanceof N.$0N,M.TypeHierarchyItem.from)}static{this.TestItem=new g("testItem","A VS Code TestItem",h=>h instanceof r.$3O,M.TestItem.from)}constructor(h,E,k,I){this.name=h,this.description=E,this.validate=k,this.convert=I}optional(){return new g(this.name,`(optional) ${this.description}`,h=>h==null||this.validate(h),h=>h===void 0?void 0:h===null?null:this.convert(h))}with(h,E){return new g(h??this.name,E??this.description,this.validate,this.convert)}}e.$bP=g;class ${static{this.Void=new $("no result",h=>h)}constructor(h,E){this.description=h,this.convert=E}}e.$cP=$;class v{constructor(h,E,k,I,P){this.id=h,this.internalId=E,this.description=k,this.args=I,this.result=P}}e.$dP=v}),define(Se[286],Ie([1,0,18,16,2,89,98,31,35,8,7]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$emc=void 0;const S=[new m.$dP("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of DocumentHighlight-instances.",w(D.DocumentHighlight.to))),new m.$dP("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[m.$bP.Uri],new m.$cP("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(o,r)=>{if((0,C.$Kb)(o))return;class s extends O.$GM{static to(t){const c=new s(t.name,D.SymbolKind.to(t.kind),t.containerName||"",new O.$zM(r[0],D.Range.to(t.range)));return c.detail=t.detail,c.range=c.location.range,c.selectionRange=D.Range.to(t.selectionRange),c.children=t.children?t.children.map(s.to):[],c}}return o.map(s.to)})),new m.$dP("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[m.$bP.Uri,new m.$bP("options","Formatting options",o=>!0,o=>o)],new m.$cP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new m.$dP("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[m.$bP.Uri,m.$bP.Range,new m.$bP("options","Formatting options",o=>!0,o=>o)],new m.$cP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new m.$dP("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[m.$bP.Uri,m.$bP.Position,new m.$bP("ch","Trigger character",o=>typeof o=="string",o=>o),new m.$bP("options","Formatting options",o=>!0,o=>o)],new m.$cP("A promise that resolves to an array of TextEdits.",w(D.TextEdit.to))),new m.$dP("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$dP("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$dP("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$dP("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of Location or LocationLink instances.",f)),new m.$dP("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of Location-instances.",w(D.location.to))),new m.$dP("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of Hover-instances.",w(D.Hover.to))),new m.$dP("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[m.$bP.Uri,new m.$bP("position","A position in a text document",o=>Array.isArray(o)&&o.every(r=>O.$oM.isPosition(r)),o=>o.map(D.Position.from))],new m.$cP("A promise that resolves to an array of ranges.",o=>o.map(r=>{let s;for(const n of r.reverse())s=new O.$KM(D.Range.to(n),s);return s}))),new m.$dP("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[m.$bP.String.with("query","Search string")],new m.$cP("A promise that resolves to an array of SymbolInformation-instances.",o=>o.map(D.WorkspaceSymbol.to))),new m.$dP("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of CallHierarchyItem-instances",o=>o.map(D.CallHierarchyItem.to))),new m.$dP("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[m.$bP.CallHierarchyItem],new m.$cP("A promise that resolves to an array of CallHierarchyIncomingCall-instances",o=>o.map(D.CallHierarchyIncomingCall.to))),new m.$dP("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[m.$bP.CallHierarchyItem],new m.$cP("A promise that resolves to an array of CallHierarchyOutgoingCall-instances",o=>o.map(D.CallHierarchyOutgoingCall.to))),new m.$dP("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to a range and placeholder text.",o=>{if(o)return{range:D.Range.to(o.range),placeholder:o.text}})),new m.$dP("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[m.$bP.Uri,m.$bP.Position,m.$bP.String.with("newName","The new symbol name")],new m.$cP("A promise that resolves to a WorkspaceEdit.",o=>{if(o){if(o.rejectReason)throw new Error(o.rejectReason);return D.WorkspaceEdit.to(o)}})),new m.$dP("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[m.$bP.Uri,m.$bP.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new m.$cP("A promise that resolves to an array of DocumentLink-instances.",o=>o.map(D.DocumentLink.to))),new m.$dP("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[m.$bP.Uri],new m.$cP("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new O.$GN(o.tokenTypes,o.tokenModifiers)})),new m.$dP("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[m.$bP.Uri],new m.$cP("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const r=(0,A.$Dbb)(o);if(r.type==="full")return new O.$IN(r.data,void 0)})),new m.$dP("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[m.$bP.Uri,m.$bP.Range.optional()],new m.$cP("A promise that resolves to SemanticTokensLegend.",o=>{if(o)return new O.$GN(o.tokenTypes,o.tokenModifiers)})),new m.$dP("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[m.$bP.Uri,m.$bP.Range],new m.$cP("A promise that resolves to SemanticTokens.",o=>{if(!o)return;const r=(0,A.$Dbb)(o);if(r.type==="full")return new O.$IN(r.data,void 0)})),new m.$dP("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[m.$bP.Uri,m.$bP.Position,m.$bP.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),m.$bP.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new m.$cP("A promise that resolves to a CompletionList-instance.",(o,r,s)=>{if(!o)return new O.$WM([]);const n=o.suggestions.map(t=>D.CompletionItem.to(t,s));return new O.$WM(n,o.incomplete)})),new m.$dP("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[m.$bP.Uri,m.$bP.Position,m.$bP.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new m.$cP("A promise that resolves to SignatureHelp.",o=>{if(o)return D.SignatureHelp.to(o)})),new m.$dP("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[m.$bP.Uri,m.$bP.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new m.$cP("A promise that resolves to an array of CodeLens-instances.",(o,r,s)=>w(n=>new O.$OM(D.Range.to(n.range),n.command&&s.fromInternal(n.command)))(o))),new m.$dP("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[m.$bP.Uri,new m.$bP("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",o=>O.$pM.isRange(o),o=>O.$qM.isSelection(o)?D.Selection.from(o):D.Range.from(o)),m.$bP.String.with("kind","Code action kind to return code actions for").optional(),m.$bP.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new m.$cP("A promise that resolves to an array of Command-instances.",(o,r,s)=>w(n=>{if(n._isSynthetic){if(!n.command)throw new Error("Synthetic code actions must have a command");return s.fromInternal(n.command)}else{const t=new O.$IM(n.title,n.kind?new O.$JM(n.kind):void 0);return n.edit&&(t.edit=D.WorkspaceEdit.to(n.edit)),n.command&&(t.command=s.fromInternal(n.command)),t.isPreferred=n.isPreferred,t}})(o))),new m.$dP("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[m.$bP.Uri],new m.$cP("A promise that resolves to an array of ColorInformation objects.",o=>o?o.map(r=>new O.$3M(D.Range.to(r.range),D.Color.to(r.color))):[])),new m.$dP("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new m.$bP("color","The color to show and insert",o=>o instanceof O.$2M,D.Color.from),new m.$bP("context","Context object with uri and range",o=>!0,o=>({uri:o.uri,range:D.Range.from(o.range)}))],new m.$cP("A promise that resolves to an array of ColorPresentation objects.",o=>o?o.map(D.ColorPresentation.to):[])),new m.$dP("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[m.$bP.Uri,m.$bP.Range],new m.$cP("A promise that resolves to an array of Inlay objects",(o,r,s)=>o.map(D.InlayHint.to.bind(void 0,s)))),new m.$dP("vscode.executeFoldingRangeProvider","_executeFoldingRangeProvider","Execute folding range provider",[m.$bP.Uri],new m.$cP("A promise that resolves to an array of FoldingRange objects",(o,r)=>{if(o)return o.map(D.FoldingRange.to)})),new m.$dP("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new m.$cP("A promise that resolves to an array of NotebookContentProvider static info objects.",w(o=>({viewType:o.viewType,displayName:o.displayName,options:{transientOutputs:o.options.transientOutputs,transientCellMetadata:o.options.transientCellMetadata,transientDocumentMetadata:o.options.transientDocumentMetadata},filenamePattern:o.filenamePattern.map(r=>D.NotebookExclusiveDocumentPattern.to(r))})))),new m.$dP("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[m.$bP.Uri,m.$bP.Range,new m.$bP("context","An InlineValueContext",o=>o&&typeof o.frameId=="number"&&o.stoppedLocation instanceof O.$pM,o=>D.InlineValueContext.from(o))],new m.$cP("A promise that resolves to an array of InlineValue objects",o=>o.map(D.InlineValue.to))),new m.$dP("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new m.$bP("uriOrString","Uri-instance or string (only http/https)",o=>M.URI.isUri(o)||typeof o=="string"&&(0,N.$Ig)(o,N.Schemas.http,N.Schemas.https),o=>o),new m.$bP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[D.ViewColumn.from(o),void 0]:[D.ViewColumn.from(o.viewColumn),D.TextEditorOpenOptions.from(o)])).optional(),m.$bP.String.with("label","").optional()],m.$cP.Void),new m.$dP("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[m.$bP.Uri.with("resource","Resource to open"),m.$bP.String.with("viewId","Custom editor view id. This should be the viewType string for custom editors or the notebookType string for notebooks. Use 'default' to use VS Code's default text editor"),new m.$bP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="number"||typeof o=="object",o=>o&&(typeof o=="number"?[D.ViewColumn.from(o),void 0]:[D.ViewColumn.from(o.viewColumn),D.TextEditorOpenOptions.from(o)])).optional()],m.$cP.Void),new m.$dP("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[m.$bP.Uri.with("left","Left-hand side resource of the diff editor"),m.$bP.Uri.with("right","Right-hand side resource of the diff editor"),m.$bP.String.with("title","Human readable title for the diff editor").optional(),new m.$bP("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",o=>o===void 0||typeof o=="object",o=>o&&[D.ViewColumn.from(o.viewColumn),D.TextEditorOpenOptions.from(o)]).optional()],m.$cP.Void),new m.$dP("vscode.changes","_workbench.changes","Opens a list of resources in the changes editor to compare their contents.",[m.$bP.String.with("title","Human readable title for the changes editor"),new m.$bP("resourceList","List of resources to compare",o=>{for(const r of o){if(r.length!==3)return!1;const[s,n,t]=r;if(!M.URI.isUri(s)||!M.URI.isUri(n)&&n!==void 0&&n!==null||!M.URI.isUri(t)&&t!==void 0&&t!==null)return!1}return!0},o=>o)],m.$cP.Void),new m.$dP("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[m.$bP.Uri,m.$bP.Position],new m.$cP("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(D.TypeHierarchyItem.to))),new m.$dP("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[m.$bP.TypeHierarchyItem],new m.$cP("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(D.TypeHierarchyItem.to))),new m.$dP("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[m.$bP.TypeHierarchyItem],new m.$cP("A promise that resolves to an array of TypeHierarchyItem-instances",o=>o.map(D.TypeHierarchyItem.to))),new m.$dP("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[m.$bP.TestItem],m.$cP.Void),new m.$dP("vscode.experimental.editSession.continue","_workbench.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[m.$bP.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],m.$cP.Void),new m.$dP("setContext","_setContext","Set a custom context key value that can be used in when clauses.",[m.$bP.String.with("name","The context key name"),new m.$bP("value","The context key value",()=>!0,o=>o)],m.$cP.Void),new m.$dP("vscode.executeMappedEditsProvider","_executeMappedEditsProvider","Execute Mapped Edits Provider",[m.$bP.Uri,m.$bP.StringArray,new m.$bP("MappedEditsContext","Mapped Edits Context",o=>D.MappedEditsContext.is(o),o=>D.MappedEditsContext.from(o))],new m.$cP("A promise that resolves to a workspace edit or null",o=>o?D.WorkspaceEdit.to(o):null)),new m.$dP("vscode.editorChat.start","inlineChat.start","Invoke a new editor chat session",[new m.$bP("Run arguments","",o=>!0,o=>{if(o)return{initialRange:o.initialRange?D.Range.from(o.initialRange):void 0,initialSelection:O.$qM.isSelection(o.initialSelection)?D.Selection.from(o.initialSelection):void 0,message:o.message,autoSend:o.autoSend,position:o.position?D.Position.from(o.position):void 0}})],m.$cP.Void)];class d{static register(r){S.forEach(r.registerApiCommand,r),this.a(r)}static a(r){r.registerCommand(!1,"_validateWhenClauses",p.$xj)}}e.$emc=d;function w(o){return r=>{if(Array.isArray(r))return r.map(o)}}function f(o){if(!Array.isArray(o))return;const r=[];for(const s of o)T.$uu(s)?r.push(D.DefinitionLink.to(s)):r.push(D.location.to(s));return r}}),define(Se[287],Ie([1,0,2,35]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Anc=void 0;class M{constructor(A,p,m,D,O){this.a=p,this.b=m,this.c=D;const S=new N.$dP("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new N.$bP("showOptions","Show Options",d=>!0,d=>d),new N.$bP("resource","Interactive resource Uri",d=>!0,d=>d),new N.$bP("controllerId","Notebook controller Id",d=>!0,d=>d),new N.$bP("title","Interactive editor title",d=>!0,d=>d)],new N.$cP("Notebook and input URI",d=>{if(O.debug("[ExtHostInteractive] open iw with notebook editor id",d.notebookEditorId),d.notebookEditorId!==void 0){const w=this.a.getEditorById(d.notebookEditorId);return O.debug("[ExtHostInteractive] notebook editor found",w.id),{notebookUri:C.URI.revive(d.notebookUri),inputUri:C.URI.revive(d.inputUri),notebookEditor:w.apiEditor}}return O.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",d.notebookUri,d.inputUri),{notebookUri:C.URI.revive(d.notebookUri),inputUri:C.URI.revive(d.inputUri)}}));this.c.registerApiCommand(S)}$willAddInteractiveDocument(A,p,m,D){this.b.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:p,lines:[""],languageId:m,uri:A,isDirty:!1,versionId:1}]})}$willRemoveInteractiveDocument(A,p){this.b.acceptDocumentsAndEditorsDelta({removedDocuments:[A]})}}e.$Anc=M}),define(Se[288],Ie([1,0,18,11,20,5,6,28,2,21,12,4,35,8,7,78,229,25,34,230]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Hnc=void 0,e.$Inc=g;let c=class{constructor(v,y,h,E,k){this.m=y,this.n=h,this.o=E,this.q=k,this.b=new p.$Ac,this.c=new p.$Ac,this.f=new Map,this.g=0,this.h=new Map,this.i=0,this.j=new Map,this.k=0,this.l=new T.$fe,this.onDidChangeNotebookCellExecutionState=this.l.event,this.r=0,this.s={},this.a=v.getProxy(S.$lM.MainThreadNotebookKernels);const I=new d.$dP("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new d.$bP("options","Select kernel options",V=>!0,V=>{if(V&&"notebookEditor"in V&&"id"in V){const W=this.n.getIdByEditor(V.notebookEditor);return{id:V.id,extension:V.extension,notebookEditorId:W}}else if(V&&"notebookEditor"in V){const W=this.n.getIdByEditor(V.notebookEditor);if(W===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${V.notebookEditor.notebook.uri.toString()}`);return{notebookEditorId:W}}return V})],d.$cP.Void),P=new d.$dP("vscode.executeNotebookVariableProvider","_executeNotebookVariableProvider","Execute notebook variable provider",[d.$bP.Uri],new d.$cP("A promise that resolves to an array of variables",(V,W)=>V.map(q=>({variable:{name:q.name,value:q.value,expression:q.expression,type:q.type,language:q.language},hasNamedChildren:q.hasNamedChildren,indexedChildrenCount:q.indexedChildrenCount}))));this.o.registerApiCommand(I),this.o.registerApiCommand(P)}createNotebookController(v,y,h,E,k,I){for(const se of this.j.values())if(se.controller.id===y&&D.$Tm.equals(v.identifier,se.extensionId))throw new Error(`notebook controller with id '${y}' ALREADY exist`);const P=this.k++,V=this;this.q.trace(`NotebookController[${P}], CREATED by ${v.identifier.value}, ${y}`);const W=()=>console.warn(`NO execute handler from notebook controller '${K.id}' of extension: '${v.identifier}'`);let q=!1;const R=new T.$fe,z=new T.$fe,K={id:g(v.identifier,y),notebookType:h,extensionId:v.identifier,extensionLocation:v.extensionLocation,label:E||v.identifier.value,preloads:I?I.map(w.NotebookRendererScript.from):[]};let ie=k??W,de,ye;this.a.$addKernel(P,K).catch(se=>{console.log(se),q=!0});let De=0;const ge=()=>{if(q)return;const se=++De;Promise.resolve().then(()=>{se===De&&this.a.$updateKernel(P,K)})},ue=new p.$Ac,Ce={get id(){return y},get notebookType(){return K.notebookType},onDidChangeSelectedNotebooks:R.event,get label(){return K.label},set label(se){K.label=se??v.displayName??v.name,ge()},get detail(){return K.detail??""},set detail(se){K.detail=se,ge()},get description(){return K.description??""},set description(se){K.description=se,ge()},get supportedLanguages(){return K.supportedLanguages},set supportedLanguages(se){K.supportedLanguages=se,ge()},get supportsExecutionOrder(){return K.supportsExecutionOrder??!1},set supportsExecutionOrder(se){K.supportsExecutionOrder=se,ge()},get rendererScripts(){return K.preloads?K.preloads.map(w.NotebookRendererScript.to):[]},get executeHandler(){return ie},set executeHandler(se){ie=se??W},get interruptHandler(){return de},set interruptHandler(se){de=se,K.supportsInterrupt=!!se,ge()},set variableProvider(se){(0,s.$MG)(v,"notebookVariableProvider"),ye=se,K.hasVariableProvider=!!se,se?.onDidChangeVariables(Ne=>V.a.$variablesUpdated(Ne.uri)),ge()},get variableProvider(){return ye},createNotebookCellExecution(se){if(q)throw new Error("notebook controller is DISPOSED");if(!ue.has(se.notebook.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.notebook.uri.toString()}`);return V._createNotebookCellExecution(se,g(v.identifier,this.id))},createNotebookExecution(se){if((0,s.$MG)(v,"notebookExecution"),q)throw new Error("notebook controller is DISPOSED");if(!ue.has(se.uri))throw V.q.trace(`NotebookController[${P}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ue.keys()).map(Ne=>Ne.toString())),new Error(`notebook controller is NOT associated to notebook: ${se.uri.toString()}`);return V._createNotebookExecution(se,g(v.identifier,this.id))},dispose:()=>{q||(this.q.trace(`NotebookController[${P}], DISPOSED`),q=!0,this.j.delete(P),R.dispose(),z.dispose(),this.a.$removeKernel(P))},updateNotebookAffinity(se,Ne){Ne===f.NotebookControllerAffinity2.Hidden&&(0,s.$MG)(v,"notebookControllerAffinityHidden"),V.a.$updateNotebookPriority(P,se.uri,Ne)},onDidReceiveMessage:z.event,postMessage(se,Ne){return(0,s.$MG)(v,"notebookMessaging"),V.a.$postMessage(P,Ne&&V.n.getIdByEditor(Ne),se)},asWebviewUri(se){return(0,s.$MG)(v,"notebookMessaging"),(0,o.$hBb)(se,V.m.remote)}};return this.j.set(P,{extensionId:v.identifier,controller:Ce,onDidReceiveMessage:z,onDidChangeSelection:R,associatedNotebooks:ue}),Ce}getIdByController(v){for(const[y,h]of this.j)if(h.controller===v)return g(h.extensionId,v.id);return null}createNotebookControllerDetectionTask(v,y){const h=this.g++,E=this;this.q.trace(`NotebookControllerDetectionTask[${h}], CREATED by ${v.identifier.value}`),this.a.$addKernelDetectionTask(h,y);const k={dispose:()=>{this.f.delete(h),E.a.$removeKernelDetectionTask(h)}};return this.f.set(h,k),k}registerKernelSourceActionProvider(v,y,h){const E=this.i++,k=typeof h.onDidChangeNotebookKernelSourceActions=="function"?E:void 0,I=this;this.h.set(E,h),this.q.trace(`NotebookKernelSourceActionProvider[${E}], CREATED by ${v.identifier.value}`),this.a.$addKernelSourceActionProvider(E,E,y);let P;return k!==void 0&&(P=h.onDidChangeNotebookKernelSourceActions(V=>this.a.$emitNotebookKernelSourceActionsChangeEvent(k))),{dispose:()=>{this.h.delete(E),I.a.$removeKernelSourceActionProvider(E,E),P?.dispose()}}}async $provideKernelSourceActions(v,y){const h=this.h.get(v);if(h){const E=new A.$Tc;return(await h.provideNotebookKernelSourceActions(y)??[]).map(I=>w.NotebookKernelSourceAction.from(I,this.o.converter,E))}return[]}$acceptNotebookAssociation(v,y,h){const E=this.j.get(v);if(E){const k=this.n.getNotebookDocument(m.URI.revive(y));h?E.associatedNotebooks.set(k.uri,!0):E.associatedNotebooks.delete(k.uri),this.q.trace(`NotebookController[${v}] ASSOCIATE notebook`,k.uri.toString(),h),E.onDidChangeSelection.fire({selected:h,notebook:k.apiNotebook})}}async $executeCells(v,y,h){const E=this.j.get(v);if(!E)return;const k=this.n.getNotebookDocument(m.URI.revive(y)),I=[];for(const P of h){const V=k.getCell(P);V&&I.push(V.apiCell)}try{this.q.trace(`NotebookController[${v}] EXECUTE cells`,k.uri.toString(),I.length),await E.controller.executeHandler.call(E.controller,I,k.apiNotebook,E.controller)}catch(P){this.q.error(`NotebookController[${v}] execute cells FAILED`,P),console.error(P)}}async $cancelCells(v,y,h){const E=this.j.get(v);if(!E)return;const k=this.n.getNotebookDocument(m.URI.revive(y));if(E.controller.interruptHandler)await E.controller.interruptHandler.call(E.controller,k.apiNotebook);else for(const I of h){const P=k.getCell(I);P&&this.b.get(P.uri)?.cancel()}if(E.controller.interruptHandler){const I=this.c.get(k.uri);this.c.delete(k.uri),h.length&&Array.isArray(I)&&I.length&&I.forEach(P=>P.dispose())}}async $provideVariables(v,y,h,E,k,I,P){const V=this.j.get(v);if(!V)return;const W=this.n.getNotebookDocument(m.URI.revive(h)),q=V.controller.variableProvider;if(!q)return;let R;if(E!==void 0){if(R=this.s[E],!R)return}else this.s={};const z=k==="named"?f.NotebookVariablesRequestKind.Named:f.NotebookVariablesRequestKind.Indexed,K=q.provideVariables(W.apiNotebook,R,z,I,P);let ie=0;for await(const de of K){if(P.isCancellationRequested)return;const ye={id:this.r++,name:de.variable.name,value:de.variable.value,type:de.variable.type,interfaces:de.variable.interfaces,language:de.variable.language,expression:de.variable.expression,hasNamedChildren:de.hasNamedChildren,indexedChildrenCount:de.indexedChildrenCount,extensionId:V.extensionId.value};if(this.s[ye.id]=de.variable,this.a.$receiveVariable(y,ye),ie++>=t.$1ib)return}}$acceptKernelMessageFromRenderer(v,y,h){const E=this.j.get(v);if(!E)return;const k=this.n.getEditorById(y);E.onDidReceiveMessage.fire(Object.freeze({editor:k.apiEditor,message:h}))}$cellExecutionChanged(v,y,h){const k=this.n.getNotebookDocument(m.URI.revive(v)).getCell(y);if(k){const I=h?w.NotebookCellExecutionState.to(h):f.NotebookCellExecutionState.Idle;I!==void 0&&this.l.fire({cell:k.apiCell,state:I})}}_createNotebookCellExecution(v,y){if(v.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const E=this.n.getNotebookDocument(v.notebook.uri).getCellFromApiCell(v);if(!E)throw new Error("invalid cell");if(this.b.has(E.uri))throw new Error(`duplicate execution for ${E.uri}`);const k=new i(y,E,this.a);this.b.set(E.uri,k);const I=k.onDidChangeState(()=>{k.state===u.Resolved&&(k.dispose(),I.dispose(),this.b.delete(E.uri))});return k.asApiObject()}_createNotebookExecution(v,y){const h=this.n.getNotebookDocument(v.uri),E=v.getCells().find(P=>{const V=h.getCellFromApiCell(P);return V&&this.b.has(V.uri)});if(E)throw new Error(`duplicate cell execution for ${E.document.uri}`);if(this.c.has(h.uri))throw new Error(`duplicate notebook execution for ${h.uri}`);const k=new a(y,h,this.a),I=k.onDidChangeState(()=>{k.state===b.Resolved&&(k.dispose(),I.dispose(),this.c.delete(h.uri))});return this.c.set(h.uri,[k,I]),k.asApiObject()}};e.$Hnc=c,e.$Hnc=c=Je([We(4,O.$5j)],c);var u;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(u||(u={}));class i extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.m=y,this.n=h,this.b=i.a++,this.c=new T.$fe,this.onDidChangeState=this.c.event,this.f=u.Init,this.g=this.B(new M.$qe),this.h=new l(10,E=>this.s(E)),this.j=y.internalMetadata.executionOrder,this.n.$createExecution(this.b,v,this.m.notebook.uri,this.m.handle)}cancel(){this.g.cancel()}async r(v){await this.h.addItem(v)}async s(v){const y=Array.isArray(v)?v:[v];return this.n.$updateExecution(this.b,new n.$Gw(y))}t(){if(this.f===u.Init)throw new Error("Must call start before modifying cell output");if(this.f===u.Resolved)throw new Error("Cannot modify cell output after calling resolve")}w(v){let y=this.m;if(v&&(y=this.m.notebook.getCellFromApiCell(v)),!y)throw new Error("INVALID cell");return y.handle}y(v){return v.map(y=>{const h=f.$TN.ensureUniqueMimeTypes(y.items,!0);return h===y.items?w.NotebookCellOutput.from(y):w.NotebookCellOutput.from({items:h,id:y.id,metadata:y.metadata})})}async z(v,y,h){const E=this.w(y),k=this.y((0,C.$2b)(v));return this.r({editType:r.CellExecutionUpdateType.Output,cellHandle:E,append:h,outputs:k})}async C(v,y,h){return v=f.$TN.ensureUniqueMimeTypes((0,C.$2b)(v),!0),this.r({editType:r.CellExecutionUpdateType.OutputItems,items:v.map(w.NotebookCellOutputItem.from),outputId:y.id,append:h})}asApiObject(){const v=this;return Object.freeze({get token(){return v.g.token},get cell(){return v.m.apiCell},get executionOrder(){return v.j},set executionOrder(h){v.j=h,v.s([{editType:r.CellExecutionUpdateType.ExecutionState,executionOrder:v.j}])},start(h){if(v.f===u.Resolved||v.f===u.Started)throw new Error("Cannot call start again");v.f=u.Started,v.c.fire(),v.s({editType:r.CellExecutionUpdateType.ExecutionState,runStartTime:h})},end(h,E,k){if(v.f===u.Resolved)throw new Error("Cannot call resolve twice");v.f=u.Resolved,v.c.fire(),v.h.flush();const I=k?{message:k.message,stack:k.stack,location:k?.location?{startLineNumber:k.location.start.line,startColumn:k.location.start.character,endLineNumber:k.location.end.line,endColumn:k.location.end.character}:void 0,uri:k.uri}:void 0;v.n.$completeExecution(v.b,new n.$Gw({runEndTime:E,lastRunSuccess:h,error:I}))},clearOutput(h){return v.t(),v.z([],h,!1)},appendOutput(h,E){return v.t(),v.z(h,E,!0)},replaceOutput(h,E){return v.t(),v.z(h,E,!1)},appendOutputItems(h,E){return v.t(),v.C(h,E,!0)},replaceOutputItems(h,E){return v.t(),v.C(h,E,!1)}})}}var b;(function($){$[$.Init=0]="Init",$[$.Started=1]="Started",$[$.Resolved=2]="Resolved"})(b||(b={}));class a extends A.$Uc{static{this.a=0}get state(){return this.f}constructor(v,y,h){super(),this.h=y,this.j=h,this.b=a.a++,this.c=new T.$fe,this.onDidChangeState=this.c.event,this.f=b.Init,this.g=this.B(new M.$qe),this.j.$createNotebookExecution(this.b,v,this.h.uri)}cancel(){this.g.cancel()}asApiObject(){return Object.freeze({start:()=>{if(this.f===b.Resolved||this.f===b.Started)throw new Error("Cannot call start again");this.f=b.Started,this.c.fire(),this.j.$beginNotebookExecution(this.b)},end:()=>{if(this.f===b.Resolved)throw new Error("Cannot call resolve twice");this.f=b.Resolved,this.c.fire(),this.j.$completeNotebookExecution(this.b)}})}}class l{constructor(v,y){this.f=v,this.g=y,this.a=[],this.b=Date.now()}addItem(v){return this.a.push(v),this.c||(this.c=new N.$Vh,this.b=Date.now(),(0,N.$zh)(this.f).then(()=>this.flush())),Date.now()-this.b>this.f?this.flush():this.c.p}flush(){if(this.a.length===0||!this.c)return Promise.resolve();const v=this.c;this.c=void 0;const y=this.a;return this.a=[],this.g(y).finally(()=>v.complete())}}function g($,v){return`${$.value}/${v}`}}),define(Se[53],Ie([1,0,5,4,3,2,17,6,7,180,14,208,20,33,209,36,11,8,35]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Vmc=e.$Umc=e.$Tmc=e.$Smc=void 0,e.$Smc=(0,M.$yi)("IExtHostTerminalService");class t extends p.$Uc{constructor(h,E,k,I){super(),this.u=h,this._id=E,this.w=k,this.y=I,this.a=!1,this.m={isInteractedWith:!1},this.isOpen=!1,this.s=this.B(new C.$fe),this.onWillDispose=this.s.event,this.w=Object.freeze(this.w),this.b=new Promise(V=>this.g=V);const P=this;this.value={get name(){return P.y||""},get processId(){return P.b},get creationOptions(){return P.w},get exitStatus(){return P.j},get state(){return P.m},get selection(){return P.n},get shellIntegration(){return P.shellIntegration},sendText(V,W=!0){P.C(),P.u.$sendText(P._id,V,W)},show(V){P.C(),P.u.$show(P._id,V)},hide(){P.C(),P.u.$hide(P._id)},dispose(){P.a||(P.a=!0,P.u.$dispose(P._id))},get dimensions(){if(!(P.f===void 0||P.h===void 0))return{columns:P.f,rows:P.h}}}}dispose(){this.s.fire(),super.dispose()}async create(h,E){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this.u.$createTerminal(this._id,{name:h.name,shellPath:h.shellPath??void 0,shellArgs:h.shellArgs??void 0,cwd:h.cwd??E?.cwd??void 0,env:h.env??void 0,icon:g(h.iconPath)??void 0,color:o.ThemeColor.isThemeColor(h.color)?h.color.id:void 0,initialText:h.message??void 0,strictEnv:h.strictEnv??void 0,hideFromUser:h.hideFromUser??void 0,forceShellIntegration:E?.forceShellIntegration??void 0,isFeatureTerminal:E?.isFeatureTerminal??void 0,isExtensionOwnedTerminal:!0,useShellEnvironment:E?.useShellEnvironment??void 0,location:E?.location||this.z(h.location,E?.resolvedExtHostIdentifier),isTransient:h.isTransient??void 0})}async createExtensionTerminal(h,E,k,I,P){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this.u.$createTerminal(this._id,{name:this.y,isExtensionCustomPtyTerminal:!0,icon:I,color:o.ThemeColor.isThemeColor(P)?P.id:void 0,location:E?.location||this.z(h,k),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}z(h,E){return typeof h=="object"?"parentTerminal"in h&&h.parentTerminal&&E?{parentTerminal:E}:"viewColumn"in h?{viewColumn:s.ViewColumn.from(h.viewColumn),preserveFocus:h.preserveFocus}:void 0:h}C(){if(this.a)throw new Error("Terminal has already been disposed")}set name(h){this.y=h}setExitStatus(h,E){this.j=Object.freeze({code:h,reason:E})}setDimensions(h,E){return h===this.f&&E===this.h||h===0||E===0?!1:(this.f=h,this.h=E,!0)}setInteractedWith(){return this.m.isInteractedWith?!1:(this.m={isInteractedWith:!0},!0)}setSelection(h){this.n=h}_setProcessId(h){this.g?(this.g(h),this.g=void 0):this.b.then(E=>{E!==h&&(this.b=Promise.resolve(h))})}}e.$Tmc=t;class c{get onProcessReady(){return this.b.event}constructor(h){this.g=h,this.id=0,this.shouldPersist=!1,this.a=new C.$fe,this.onProcessData=this.a.event,this.b=new C.$fe,this.d=new C.$fe,this.onDidChangeProperty=this.d.event,this.f=new C.$fe,this.onProcessExit=this.f.event}refreshProperty(h){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${h}`)}updateProperty(h,E){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${h}, value: ${E}`)}async start(){}shutdown(){this.g.close()}input(h){this.g.handleInput?.(h)}resize(h,E){this.g.setDimensions?.({columns:h,rows:E})}clearBuffer(){}async processBinary(h){}acknowledgeDataEvent(h){}async setUnicodeVersion(h){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}startSendingEvents(h){this.g.onDidWrite(E=>this.a.fire(E)),this.g.onDidClose?.((E=void 0)=>{this.f.fire(E===void 0?void 0:E)}),this.g.onDidOverrideDimensions?.(E=>{E&&this.d.fire({type:"overrideDimensions",value:{cols:E.columns,rows:E.rows}})}),this.g.onDidChangeName?.(E=>{this.d.fire({type:"title",value:E})}),this.g.open(h||void 0),h&&this.g.setDimensions?.(h),this.b.fire({pid:-1,cwd:"",windowsPty:void 0})}}let u=1,i=class extends p.$Uc{get activeTerminal(){return this.b?.value}get terminals(){return this.f.map(h=>h.value)}constructor(h,E,k){super(),this.Q=E,this.f=[],this.g=new Map,this.h={},this.j={},this.m={},this.n=new Map,this.w=this.B(new p.$Vc),this.z=new Set,this.C=new Map,this.D=new Map,this.F=new Map,this.G=new Map,this.H=new C.$fe,this.onDidCloseTerminal=this.H.event,this.I=new C.$fe,this.onDidOpenTerminal=this.I.event,this.J=new C.$fe,this.onDidChangeActiveTerminal=this.J.event,this.L=new C.$fe,this.onDidChangeTerminalDimensions=this.L.event,this.M=new C.$fe,this.onDidChangeTerminalState=this.M.event,this.N=new C.$fe,this.onDidChangeShell=this.N.event,this.O=new C.$fe({onWillAddFirstListener:()=>this.a.$startSendingDataEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingDataEvents()}),this.onDidWriteTerminalData=this.O.event,this.P=new C.$fe({onWillAddFirstListener:()=>this.a.$startSendingCommandEvents(),onDidRemoveLastListener:()=>this.a.$stopSendingCommandEvents()}),this.onDidExecuteTerminalCommand=this.P.event,this.a=k.getProxy(N.$lM.MainThreadTerminalService),this.y=new f.$fwb(this.a.$sendProcessData),this.a.$registerProcessSupport(h),this.Q.registerArgumentProcessor({processArgument:I=>{const P=V=>{const W=V;return this.getTerminalById(W.instanceId)?.value};switch(I?.$mid){case 15:return P(I);default:{if(Array.isArray(I))for(let V=0;V<I.length&&I[V].$mid===15;V++)I[V]=P(I[V]);return I}}}}),this.B({dispose:()=>{for(const[I,P]of this.g)P.shutdown(!0)}})}getDefaultShell(h){return(h?this.u:this.s)?.path||""}getDefaultShellArgs(h){return(h?this.u:this.s)?.args||[]}createExtensionTerminal(h,E){const k=new t(this.a,(0,w.$Ug)(),h,h.name),I=new c(h.pty);return k.createExtensionTerminal(h.location,E,this.R(h,E).resolvedExtHostIdentifier,g(h.iconPath),$(h.color)).then(P=>{const V=this.S(P,I);this.h[P]=V}),this.f.push(k),k.value}R(h,E){if(E=E||{},h.location&&typeof h.location=="object"&&"parentTerminal"in h.location){const k=h.location.parentTerminal;if(k){const I=this.f.find(P=>P.value===k);I&&(E.resolvedExtHostIdentifier=I._id)}}else h.location&&typeof h.location!="object"?E.location=h.location:E.location&&typeof E.location=="object"&&"splitActiveTerminal"in E.location&&(E.location={splitActiveTerminal:!0});return E}attachPtyToTerminal(h,E){if(!this.getTerminalById(h))throw new Error(`Cannot resolve terminal with id ${h} for virtual process`);const I=new c(E),P=this.S(h,I);this.h[h]=P}async $acceptActiveTerminalChanged(h){const E=this.b;if(h===null){this.b=void 0,E!==this.b&&this.J.fire(this.b);return}const k=this.getTerminalById(h);k&&(this.b=k,E!==this.b&&this.J.fire(this.b.value))}async $acceptTerminalProcessData(h,E){const k=this.getTerminalById(h);k&&this.O.fire({terminal:k.value,data:E})}async $acceptTerminalDimensions(h,E,k){const I=this.getTerminalById(h);I&&I.setDimensions(E,k)&&this.L.fire({terminal:I.value,dimensions:I.value.dimensions})}async $acceptDidExecuteCommand(h,E){const k=this.getTerminalById(h);k&&this.P.fire({terminal:k.value,...E})}async $acceptTerminalMaximumDimensions(h,E,k){this.g.get(h)?.resize(E,k)}async $acceptTerminalTitleChange(h,E){const k=this.getTerminalById(h);k&&(k.name=E)}async $acceptTerminalClosed(h,E,k){const I=this.X(this.f,h);if(I!==null){const P=this.f.splice(I,1)[0];P.setExitStatus(E,k),this.H.fire(P.value)}}$acceptTerminalOpened(h,E,k,I){if(E){const W=this.X(this.f,E);if(W!==null){this.f[W]._id=h,this.I.fire(this.terminals[W]),this.f[W].isOpen=!0;return}}const P={name:I.name,shellPath:I.executable,shellArgs:I.args,cwd:typeof I.cwd=="string"?I.cwd:T.URI.revive(I.cwd),env:I.env,hideFromUser:I.hideFromUser},V=new t(this.a,h,P,k);this.f.push(V),this.I.fire(V.value),V.isOpen=!0}async $acceptTerminalProcessId(h,E){this.getTerminalById(h)?._setProcessId(E)}async $startExtensionTerminal(h,E){const k=this.getTerminalById(h);if(!k)return{message:(0,D.localize)(0,null,h)};k.isOpen||await new Promise(P=>{const V=this.onDidOpenTerminal(async W=>{W===k.value&&(V.dispose(),P())})});const I=this.g.get(h);I?I.startSendingEvents(E):this.j[h]={initialDimensions:E}}S(h,E){const k=new p.$Tc;k.add(E.onProcessReady(P=>this.a.$sendProcessReady(h,P.pid,P.cwd,P.windowsPty))),k.add(E.onDidChangeProperty(P=>this.a.$sendProcessProperty(h,P))),this.y.startBuffering(h,E.onProcessData),k.add(E.onProcessExit(P=>this.U(h,P))),this.g.set(h,E);const I=this.j[h];return I&&E instanceof c&&(E.startSendingEvents(I.initialDimensions),delete this.j[h]),k}$acceptProcessAckDataEvent(h,E){this.g.get(h)?.acknowledgeDataEvent(E)}$acceptProcessInput(h,E){this.g.get(h)?.input(E)}$acceptTerminalInteraction(h){const E=this.getTerminalById(h);E?.setInteractedWith()&&this.M.fire(E.value)}$acceptTerminalSelection(h,E){this.getTerminalById(h)?.setSelection(E)}$acceptProcessResize(h,E,k){try{this.g.get(h)?.resize(E,k)}catch(I){if(I.code!=="EPIPE"&&I.code!=="ERR_IPC_CHANNEL_CLOSED")throw I}}$acceptProcessShutdown(h,E){this.g.get(h)?.shutdown(E)}$acceptProcessRequestInitialCwd(h){this.g.get(h)?.getInitialCwd().then(E=>this.a.$sendProcessProperty(h,{type:"initialCwd",value:E}))}$acceptProcessRequestCwd(h){this.g.get(h)?.getCwd().then(E=>this.a.$sendProcessProperty(h,{type:"cwd",value:E}))}$acceptProcessRequestLatency(h){return Promise.resolve(h)}registerLinkProvider(h){return this.z.add(h),this.z.size===1&&this.a.$startLinkProvider(),new m.$nM(()=>{this.z.delete(h),this.z.size===0&&this.a.$stopLinkProvider()})}registerProfileProvider(h,E,k){if(this.C.has(E))throw new Error(`Terminal profile provider "${E}" already registered`);return this.C.set(E,k),this.a.$registerProfileProvider(E,h.identifier.value),new m.$nM(()=>{this.C.delete(E),this.a.$unregisterProfileProvider(E)})}registerTerminalQuickFixProvider(h,E,k){if(this.D.has(h))throw new Error(`Terminal quick fix provider "${h}" is already registered`);return this.D.set(h,k),this.a.$registerQuickFixProvider(h,E),new m.$nM(()=>{this.D.delete(h),this.a.$unregisterQuickFixProvider(h)})}async $provideTerminalQuickFixes(h,E){const k=new d.$qe().token;if(k.isCancellationRequested)return;const I=this.D.get(h);if(!I)return;const P=await I.provideTerminalQuickFixes(E,k);if(P===null||Array.isArray(P)&&P.length===0)return;const V=new p.$Tc;if(this.w.value=V,!Array.isArray(P))return P?s.TerminalQuickFix.from(P,this.Q.converter,V):void 0;const W=[];for(const q of P){const R=s.TerminalQuickFix.from(q,this.Q.converter,V);R&&W.push(R)}return W}async $createContributedProfileTerminal(h,E){const k=new d.$qe().token;let I=await this.C.get(h)?.provideTerminalProfile(k);if(!k.isCancellationRequested){if(I&&!("options"in I)&&(I={options:I}),!I||!("options"in I))throw new Error(`No terminal profile options provided for id "${h}"`);if("pty"in I.options){this.createExtensionTerminal(I.options,E);return}this.createTerminalFromOptions(I.options,E)}}async $provideLinks(h,E){const k=this.getTerminalById(h);if(!k)return[];this.F.delete(h),this.G.get(h)?.dispose(!0);const P=new d.$qe;this.G.set(h,P);const V=[],W={terminal:k.value,line:E},q=[];for(const K of this.z)q.push(r.Promises.withAsyncBody(async ie=>{P.token.onCancellationRequested(()=>ie({provider:K,links:[]}));const de=await K.provideTerminalLinks(W,P.token)||[];P.token.isCancellationRequested||ie({provider:K,links:de})}));const R=await Promise.all(q);if(P.token.isCancellationRequested)return[];const z=new Map;for(const K of R)K&&K.links.length>0&&V.push(...K.links.map(ie=>{const de={id:u++,startIndex:ie.startIndex,length:ie.length,label:ie.tooltip};return z.set(de.id,{provider:K.provider,link:ie}),de}));return this.F.set(h,z),V}$activateLink(h,E){const k=this.F.get(h)?.get(E);k&&k.provider.handleTerminalLink(k.link)}U(h,E){this.y.stopBuffering(h),this.g.delete(h),delete this.j[h];const k=this.h[h];k&&(k.dispose(),delete this.h[h]),this.a.$sendProcessExit(h,E)}getTerminalById(h){return this.W(this.f,h)}getTerminalIdByApiObject(h){const E=this.f.findIndex(k=>k.value===h);return E>=0?E:null}W(h,E){const k=this.X(h,E);return k!==null?h[k]:null}X(h,E){const k=h.findIndex(I=>I._id===E);return k>=0?k:null}getEnvironmentVariableCollection(h){let E=this.n.get(h.identifier.value);return E||(E=new b,this.Z(h.identifier.value,E)),E.getScopedEnvironmentVariableCollection(void 0)}Y(h,E){const k=(0,S.$qs)(E.map),I=(0,S.$rs)(E.descriptionMap);this.a.$setEnvironmentVariableCollection(h,E.persistent,k.length===0?void 0:k,I)}$initEnvironmentVariableCollections(h){h.forEach(E=>{const k=E[0],I=new b(E[1]);this.Z(k,I)})}$acceptDefaultProfile(h,E){const k=this.s;this.s=h,this.u=E,k?.path!==h.path&&this.N.fire(h.path)}Z(h,E){this.n.set(h,E),E.onDidChangeCollection(()=>{this.Y(h,E)})}};e.$Umc=i,e.$Umc=i=Je([We(1,n.$_O),We(2,A.$PO)],i);class b{get persistent(){return this.b}set persistent(h){this.b=h,this.d.fire()}get onDidChangeCollection(){return this.d&&this.d.event}constructor(h){this.map=new Map,this.a=new Map,this.descriptionMap=new Map,this.b=!0,this.d=new C.$fe,this.map=new Map(h)}getScopedEnvironmentVariableCollection(h){const E=this.h(h);let k=this.a.get(E);return k||(k=new a(this,h),this.a.set(E,k),k.onDidChangeCollection(()=>this.d.fire())),k}replace(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Replace,options:k??{applyAtProcessCreation:!0},scope:I})}append(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Append,options:k??{applyAtProcessCreation:!0},scope:I})}prepend(h,E,k,I){this.f(h,{value:E,type:m.EnvironmentVariableMutatorType.Prepend,options:k??{applyAtProcessCreation:!0},scope:I})}f(h,E){if(E.options&&E.options.applyAtProcessCreation===!1&&!E.options.applyAtShellIntegration)throw new Error("EnvironmentVariableMutatorOptions must apply at either process creation or shell integration");const k=this.g(h,E.scope),I=this.map.get(k),P=E.options?{applyAtProcessCreation:E.options.applyAtProcessCreation??!1,applyAtShellIntegration:E.options.applyAtShellIntegration??!1}:{applyAtProcessCreation:!0};if(!I||I.value!==E.value||I.type!==E.type||I.options?.applyAtProcessCreation!==P.applyAtProcessCreation||I.options?.applyAtShellIntegration!==P.applyAtShellIntegration||I.scope?.workspaceFolder?.index!==E.scope?.workspaceFolder?.index){const V=this.g(h,E.scope),W={variable:h,...E,options:P};this.map.set(V,W),this.d.fire()}}get(h,E){const k=this.g(h,E),I=this.map.get(k);return I?v(I):void 0}g(h,E){const k=this.h(E);return k.length?`${h}:::${k}`:h}h(h){return this.j(h?.workspaceFolder)??""}j(h){return h?h.uri.toString():void 0}getVariableMap(h){const E=new Map;for(const[k,I]of this.map)this.h(I.scope)===this.h(h)&&E.set(I.variable,v(I));return E}delete(h,E){const k=this.g(h,E);this.map.delete(k),this.d.fire()}clear(h){if(h?.workspaceFolder){for(const[E,k]of this.map)k.scope?.workspaceFolder?.index===h.workspaceFolder.index&&this.map.delete(E);this.k(h)}else this.map.clear(),this.descriptionMap.clear();this.d.fire()}setDescription(h,E){const k=this.h(E),I=this.descriptionMap.get(k);if(!I||I.description!==h){let P;typeof h=="string"?P=h:P=h?.value.split(`

`)[0];const V={description:P,scope:E};this.descriptionMap.set(k,V),this.d.fire()}}getDescription(h){const E=this.h(h);return this.descriptionMap.get(E)?.description}k(h){const E=this.h(h);this.descriptionMap.delete(E)}}class a{get persistent(){return this.b.persistent}set persistent(h){this.b.persistent=h}get onDidChangeCollection(){return this.a&&this.a.event}constructor(h,E){this.b=h,this.d=E,this.a=new C.$fe}getScoped(h){return this.b.getScopedEnvironmentVariableCollection(h)}replace(h,E,k){this.b.replace(h,E,k,this.d)}append(h,E,k){this.b.append(h,E,k,this.d)}prepend(h,E,k){this.b.prepend(h,E,k,this.d)}get(h){return this.b.get(h,this.d)}forEach(h,E){this.b.getVariableMap(this.d).forEach((k,I)=>h.call(E,I,k,this),this.d)}[Symbol.iterator](){return this.b.getVariableMap(this.d).entries()}delete(h){this.b.delete(h,this.d),this.a.fire(void 0)}clear(){this.b.clear(this.d)}set description(h){this.b.setDescription(h,this.d)}get description(){return this.b.getDescription(this.d)}}let l=class extends i{constructor(h,E){super(!1,h,E)}createTerminal(h,E,k){throw new O.$_}createTerminalFromOptions(h,E){throw new O.$_}};e.$Vmc=l,e.$Vmc=l=Je([We(0,n.$_O),We(1,A.$PO)],l);function g(y){if(!(!y||typeof y=="string"))return"id"in y?{id:y.id,color:y.color}:y}function $(y){return o.ThemeColor.isThemeColor(y)?y:void 0}function v(y){const h={...y};return delete h.scope,h.options=h.options??void 0,delete h.variable,h}}),define(Se[116],Ie([1,0,7,6,3,4,17,53,5,2,11]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1nc=e.$Znc=void 0,e.$Znc=(0,M.$yi)("IExtHostTerminalShellIntegration");let S=class extends N.$Uc{constructor(r,s){super(),this.h=s,this.b=new Map,this.c=new m.$fe,this.onDidChangeTerminalShellIntegration=this.c.event,this.f=new m.$fe,this.onDidStartTerminalShellExecution=this.f.event,this.g=new m.$fe,this.onDidEndTerminalShellExecution=this.g.event,this.a=r.getProxy(T.$lM.MainThreadTerminalShellIntegration),this.B((0,N.$Sc)(()=>{for(const[n,t]of this.b)t.dispose();this.b.clear()}))}$shellIntegrationChange(r){const s=this.h.getTerminalById(r);if(!s)return;const n=s.value;let t=this.b.get(r);t||(t=new d(s.value,this.f),this.b.set(r,t),t.store.add(s.onWillDispose(()=>this.b.get(r)?.dispose())),t.store.add(t.onDidRequestShellExecution(c=>this.a.$executeCommand(r,c))),t.store.add(t.onDidRequestEndExecution(c=>this.g.fire(c))),t.store.add(t.onDidRequestChangeShellIntegration(c=>this.c.fire(c))),s.shellIntegration=t.value),this.c.fire({terminal:n,shellIntegration:t.value})}$shellExecutionStart(r,s,n,t,c){this.b.has(r)||this.$shellIntegrationChange(r);const u={value:s,confidence:n,isTrusted:t};this.b.get(r)?.startShellExecution(u,c)}$shellExecutionEnd(r,s,n,t,c){const u={value:s,confidence:n,isTrusted:t};this.b.get(r)?.endShellExecution(u,c)}$shellExecutionData(r,s){this.b.get(r)?.emitData(s)}$cwdChange(r,s){this.b.get(r)?.setCwd((0,D.$vc)(s)?D.URI.revive(s):s)}$closeTerminal(r){this.b.get(r)?.dispose(),this.b.delete(r)}};e.$1nc=S,e.$1nc=S=Je([We(0,A.$PO),We(1,p.$Smc)],S);class d extends N.$Uc{get currentExecution(){return this.a}constructor(r,s){super(),this.j=r,this.m=s,this.b=!1,this.store=this.B(new N.$Tc),this.f=this.B(new m.$fe),this.onDidRequestChangeShellIntegration=this.f.event,this.g=this.B(new m.$fe),this.onDidRequestShellExecution=this.g.event,this.h=this.B(new m.$fe),this.onDidRequestEndExecution=this.h.event;const n=this;this.value={get cwd(){return n.c},executeCommand(t,c){let u=t;c&&(u+=` "${c.map(a=>`${a.replaceAll('"','\\"')}`).join('" "')}"`),n.g.fire(u);const i={value:u,confidence:C.TerminalShellExecutionCommandLineConfidence.High,isTrusted:!0},b=n.startShellExecution(i,n.c,!0).value;return n.b=!0,b}}}startShellExecution(r,s,n){if(this.b&&this.a)this.b=!1;else{this.a&&(this.a.endExecution(void 0),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:void 0}));const t=this.a=new w(r,s);n?queueMicrotask(()=>this.m.fire({terminal:this.j,shellIntegration:this.value,execution:t.value})):this.m.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value})}return this.a}emitData(r){this.currentExecution?.emitData(r)}endShellExecution(r,s){this.a&&(this.a.endExecution(r),this.h.fire({terminal:this.j,shellIntegration:this.value,execution:this.a.value,exitCode:s}),this.a=void 0)}setCwd(r){let s=!1;D.URI.isUri(this.c)?s=!D.URI.isUri(r)||this.c.toString()!==r.toString():this.c!==r&&(s=!0),s&&(this.c=r,this.f.fire({terminal:this.j,shellIntegration:this.value}))}}class w{constructor(r,s){this.c=r,this.cwd=s,this.b=!1;const n=this;this.value={get commandLine(){return n.c},get cwd(){return n.cwd},read(){return n.d()}}}d(){if(!this.a){if(this.b)return O.$Yh.EMPTY;this.a=new f}return this.a.createIterable()}emitData(r){this.a?.emitData(r)}endExecution(r){r&&(this.c=r),this.a?.endExecution(),this.a=void 0,this.b=!0}}class f extends N.$Uc{constructor(){super(...arguments),this.b=[]}createIterable(){this.a||(this.a=new O.$xh);const r=this.a;return new O.$Yh(async n=>{this.b.push(n),await r.wait()})}emitData(r){for(const s of this.b)s.emitOne(r)}endExecution(){this.a?.open(),this.a=void 0}}}),define(Se[289],Ie([1,0,11,22,20,5,262,73,6,15,33,12,4,17,115,8,7,52,77,62,25]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$5nc=e.$4nc=e.$3nc=e.$2nc=void 0;let u=class extends m.$Uc{constructor(V,W,q,R){super(),this.w=R,this.f=this.B(new T.$fe),this.g=new Map,this.s=this.B(new T.$fe),this.onResultsChanged=this.f.event,this.results=[],this.h=V.getProxy(d.$lM.MainThreadTesting),this.m=new h(this.h),this.j=new l(this.h,W),q.registerArgumentProcessor({processArgument:z=>{switch(z?.$mid){case 16:{const K=z,ie=K.tests[K.tests.length-1].item.extId;return this.g.get(s.$0K.root(ie))?.collection.tree.get(ie)?.actual??(0,f.$2O)(z)}case 18:{const{test:K,message:ie}=z,de=K.item.extId;return{test:this.g.get(s.$0K.root(de))?.collection.tree.get(de)?.actual??(0,f.$2O)({$mid:16,tests:[K]}),message:o.TestMessage.to(ie)}}default:return z}}}),q.registerCommand(!1,"testing.getExplorerSelection",async()=>{const z=await q.executeCommand("_testing.getExplorerSelection"),K=ie=>{const de=this.g.get(s.$0K.root(ie));if(de)return s.$0K.isRoot(ie)?de.controller:de.collection.tree.get(ie)?.actual};return{include:z?.include.map(K).filter(D.$gg)||[],exclude:z?.exclude.map(K).filter(D.$gg)||[]}})}createTestController(V,W,q,R){if(this.g.has(W))throw new Error(`Attempt to insert a duplicate controller with ID "${W}"`);const z=new m.$Tc,K=z.add(new f.$5O(W,q,this.w));K.root.label=q;const ie=new Map,de=new Set,ye=this.h,De={items:K.root.children,get label(){return q},set label(ue){q=ue,K.root.label=ue,ye.$updateController(W,{label:q})},get refreshHandler(){return R},set refreshHandler(ue){R=ue,ye.$updateController(W,{canRefresh:!!ue})},get id(){return W},createRunProfile:(ue,Ce,se,Ne,ne,U)=>{let x=(0,p.$mj)(ue);for(;ie.has(x);)x++;return new k(this.h,ie,de,this.s.event,W,x,ue,Ce,se,Ne,ne,U)},createTestItem(ue,Ce,se){return new f.$3O(W,ue,Ce,se)},createTestRun:(ue,Ce,se=!0)=>this.j.createTestRun(V,W,K,ue,Ce,se),invalidateTestResults:ue=>{if(ue===void 0)this.h.$markTestRetired(void 0);else{const Ce=ue instanceof Array?ue:[ue];this.h.$markTestRetired(Ce.map(se=>s.$0K.fromExtHostTestItem(se,W).toString()))}},set resolveHandler(ue){K.resolveHandler=ue},get resolveHandler(){return K.resolveHandler},dispose:()=>{z.dispose()}};ye.$registerTestController(W,q,!!R),z.add((0,m.$Sc)(()=>ye.$unregisterTestController(W)));const ge={controller:De,collection:K,profiles:ie,extension:V,activeProfiles:de};return this.g.set(W,ge),z.add((0,m.$Sc)(()=>this.g.delete(W))),z.add(K.onDidGenerateDiff(ue=>ye.$publishDiff(W,ue.map(t.TestsDiffOp.serialize)))),De}createTestObserver(){return this.m.checkout()}async runTests(V,W=M.CancellationToken.None){const q=g(V);if(!q)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const R=this.g.get(q.controllerId);if(!R)throw new Error("Controller not found");await this.h.$runTests({preserveFocus:V.preserveFocus??!0,targets:[{testIds:V.include?.map(z=>s.$0K.fromExtHostTestItem(z,R.collection.root.id).toString())??[R.collection.root.id],profileGroup:I[q.kind],profileId:q.profileId,controllerId:q.controllerId}],exclude:V.exclude?.map(z=>z.id)},W)}$syncTests(){for(const{collection:V}of this.g.values())V.flushDiff();return Promise.resolve()}async $getCoverageDetails(V,W){return(await this.j.getCoverageDetails(V,W))?.map(o.TestCoverage.fromDetails)}async $disposeRun(V){this.j.disposeTestRun(V)}$configureRunProfile(V,W){this.g.get(V)?.profiles.get(W)?.configureHandler?.()}$setDefaultRunProfiles(V){const W=new Map;for(const[q,R]of Object.entries(V)){const z=this.g.get(q);if(!z)continue;const K=new Map,ie=R.filter(ye=>!z.activeProfiles.has(ye)),de=[...z.activeProfiles].filter(ye=>!R.includes(ye));for(const ye of ie)K.set(ye,!0),z.activeProfiles.add(ye);for(const ye of de)K.set(ye,!1),z.activeProfiles.delete(ye);K.size&&W.set(q,K)}this.s.fire(W)}async $refreshTests(V,W){await this.g.get(V)?.controller.refreshHandler?.(W)}$publishTestResults(V){this.results=Object.freeze(V.map(o.TestResults.to).concat(this.results).sort((W,q)=>q.completedAt-W.completedAt).slice(0,32)),this.f.fire()}async $expandTest(V,W){const q=this.g.get(s.$0K.fromString(V).controllerId)?.collection;q&&(await q.expand(V,W<0?1/0:W),q.flushDiff())}$acceptDiff(V){this.m.applyDiff(V.map(W=>t.TestsDiffOp.deserialize({asCanonicalUri:q=>q},W)))}async $runControllerTests(V,W){return Promise.all(V.map(q=>this.y(q,!1,W)))}async $startContinuousRun(V,W){const q=new M.$qe(W),R=await Promise.all(V.map(z=>this.y(z,!0,q.token)));return!W.isCancellationRequested&&!R.some(z=>z.error)&&await new Promise(z=>W.onCancellationRequested(z)),q.dispose(!0),R}async y(V,W,q){const R=this.g.get(V.controllerId);if(!R)return{};const{collection:z,profiles:K,extension:ie}=R,de=K.get(V.profileId);if(!de)return{};const ye=V.testIds.map(Ce=>z.tree.get(Ce)).filter(D.$gg),De=V.excludeExtIds.map(Ce=>R.collection.tree.get(Ce)).filter(D.$gg).filter(Ce=>ye.some(se=>se.fullId.compare(Ce.fullId)===2));if(!ye.length)return{};const ge=new r.$1N(ye.some(Ce=>Ce.actual instanceof f.$4O)?void 0:ye.map(Ce=>Ce.actual),De.map(Ce=>Ce.actual),de,W),ue=(0,t.$aL)(V)&&this.j.prepareForMainThreadTestRun(ie,ge,$.fromInternal(V,R.collection),de,q);try{return await de.runHandler(ge,q),{}}catch(Ce){return{error:String(Ce)}}finally{ue&&ue.hasRunningTasks&&!q.isCancellationRequested&&await T.Event.toPromise(ue.onEnd)}}$cancelExtensionTestRun(V){V===void 0?this.j.cancelAllRuns():this.j.cancelRunById(V)}};e.$2nc=u,e.$2nc=u=Je([We(0,w.$PO),We(1,S.$5j)],u);const i=1e4;var b;(function(P){P[P.Running=0]="Running",P[P.Cancelling=1]="Cancelling",P[P.Ended=2]="Ended"})(b||(b={}));class a extends m.$Uc{get hasRunningTasks(){return this.f>0}get id(){return this.y.id}constructor(V,W,q,R,z,K){super(),this.y=V,this.z=W,this.C=q,this.D=R,this.F=z,this.c=0,this.f=0,this.g=new Map,this.h=new Set,this.m=this.B(new T.$fe),this.w=new Map,this.onEnd=this.m.event,this.j=this.B(new M.$qe(K));const ie=this.B(new C.$Kh(()=>this.G(),i));this.B(this.j.token.onCancellationRequested(()=>ie.schedule()));const de=new T.$fe;this.s=de.event,this.B((0,m.$Sc)(()=>{de.fire(),de.dispose()}))}cancel(){this.c===0?(this.j.cancel(),this.c=1):this.c===1&&this.G()}getCoverageDetails(V,W){const[,q]=s.$0K.fromString(V).path,R=this.w.get(V);if(!R)return[];const z=this.g.get(q);if(!z)throw new Error("unreachable: run task was not found");return this.D?.loadDetailedCoverage?.(z.run,R,W)??[]}createRun(V){const W=this.y.id,q=this.y.controllerId,R=(0,O.$Ug)(),z=De=>(ge,...ue)=>{if(ie){this.C.warn(`Setting the state of test "${ge.id}" is a no-op after the run ends.`);return}this.y.isIncluded(ge)&&(this.I(ge),De(ge,...ue))},K=(De,ge)=>{const ue=ge instanceof Array?ge.map(o.TestMessage.from):[o.TestMessage.from(ge)];if(De.uri&&De.range){const Ce={range:o.Range.from(De.range),uri:De.uri};for(const se of ue)se.location=se.location||Ce}this.z.$appendTestMessagesInRun(W,R,s.$0K.fromExtHostTestItem(De,q).toString(),ue)};let ie=!1;const de=new Map,ye={isPersisted:this.y.isPersisted,token:this.j.token,name:V,onDidDispose:this.s,addCoverage:De=>{if(ie)return;const ge=De instanceof r.$6N?De.testItem:void 0;let ue;if(ge){if((0,c.$MG)(this.F,"attributableCoverage"),!this.y.isIncluded(ge))throw new Error("Attempted to `addCoverage` for a test item not included in the run");this.I(ge),ue=de.get(ge),ue===void 0&&(ue=de.size,de.set(ge,ue))}const Ce=De.uri.toString(),se=new s.$0K(ue!==void 0?[W,R,Ce,String(ue)]:[W,R,Ce]).toString();this.w.set(se,De),this.z.$appendCoverage(W,R,o.TestCoverage.fromFile(q,se,De))},enqueued:z(De=>{this.z.$updateTestStateInRun(W,R,s.$0K.fromExtHostTestItem(De,q).toString(),1)}),skipped:z(De=>{this.z.$updateTestStateInRun(W,R,s.$0K.fromExtHostTestItem(De,q).toString(),5)}),started:z(De=>{this.z.$updateTestStateInRun(W,R,s.$0K.fromExtHostTestItem(De,q).toString(),2)}),errored:z((De,ge,ue)=>{K(De,ge),this.z.$updateTestStateInRun(W,R,s.$0K.fromExtHostTestItem(De,q).toString(),6,ue)}),failed:z((De,ge,ue)=>{K(De,ge),this.z.$updateTestStateInRun(W,R,s.$0K.fromExtHostTestItem(De,q).toString(),4,ue)}),passed:z((De,ge)=>{this.z.$updateTestStateInRun(W,R,s.$0K.fromExtHostTestItem(De,this.y.controllerId).toString(),3,ge)}),appendOutput:(De,ge,ue)=>{ie||(ue&&(this.y.isIncluded(ue)?this.I(ue):ue=void 0),this.z.$appendOutputToRun(W,R,N.$He.fromString(De),ge&&o.location.from(ge),ue&&s.$0K.fromExtHostTestItem(ue,q).toString()))},end:()=>{ie||(ie=!0,de.clear(),this.z.$finishedTestRunTask(W,R),--this.f||this.H())}};return this.f++,this.g.set(R,{run:ye}),this.z.$startedTestRunTask(W,{id:R,name:V,running:!0}),ye}G(){for(const{run:V}of this.g.values())V.end()}H(){this.c!==2&&(this.c=2,this.m.fire())}I(V){if(!(V instanceof f.$3O))throw new n.$HO(V.id);if(this.h.has(s.$0K.fromExtHostTestItem(V,this.y.controllerId).toString()))return;const W=[],q=this.y.colllection.root;for(;;){const R=o.TestItem.from(V);if(W.unshift(R),this.h.has(R.extId)||(this.h.add(R.extId),V===q))break;V=V.parent||q}this.z.$addTestsToRun(this.y.controllerId,this.y.id,W)}dispose(){this.H(),super.dispose()}}class l{get trackers(){return this.c.values()}constructor(V,W){this.g=V,this.h=W,this.c=new Map,this.f=new Map}getCoverageDetails(V,W){const q=s.$0K.root(V);return this.f.get(q)?.getCoverageDetails(V,W)||[]}disposeTestRun(V){this.f.get(V)?.dispose(),this.f.delete(V);for(const[W,{id:q}]of this.c)q===V&&this.c.delete(W)}prepareForMainThreadTestRun(V,W,q,R,z){return this.j(W,q,R,V,z)}cancelRunById(V){this.f.get(V)?.cancel()}cancelAllRuns(){for(const V of this.c.values())V.cancel()}createTestRun(V,W,q,R,z,K){const ie=this.c.get(R);if(ie)return ie.createRun(z);const de=$.fromPublic(W,q,R,K),ye=g(R);this.g.$startedExtensionTestRun({controllerId:W,continuous:!!R.continuous,profile:ye&&{group:I[ye.kind],id:ye.profileId},exclude:R.exclude?.map(ge=>s.$0K.fromExtHostTestItem(ge,q.root.id).toString())??[],id:de.id,include:R.include?.map(ge=>s.$0K.fromExtHostTestItem(ge,q.root.id).toString())??[q.root.id],preserveFocus:R.preserveFocus??!0,persist:K});const De=this.j(R,de,R.profile,V);return T.Event.once(De.onEnd)(()=>{this.g.$finishedExtensionTestRun(de.id)}),De.createRun(z)}j(V,W,q,R,z){const K=new a(W,this.g,this.h,q,R,z);return this.c.set(V,K),this.f.set(K.id,K),K}}e.$3nc=l;const g=P=>{if(P.profile){if(!(P.profile instanceof k))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return P.profile}};class ${static fromPublic(V,W,q,R){return new $(V,(0,O.$Ug)(),q.include?.map(z=>s.$0K.fromExtHostTestItem(z,V).toString())??[V],q.exclude?.map(z=>s.$0K.fromExtHostTestItem(z,V).toString())??[],R,W)}static fromInternal(V,W){return new $(V.controllerId,V.runId,V.testIds,V.excludeExtIds,!0,W)}constructor(V,W,q,R,z,K){this.controllerId=V,this.id=W,this.isPersisted=z,this.colllection=K,this.c=q.map(ie=>ie+"\0"),this.f=R.map(ie=>ie+"\0")}isIncluded(V){const W=s.$0K.fromExtHostTestItem(V,this.controllerId).toString()+"\0";for(const q of this.f)if(W===q||W.startsWith(q))return!1;for(const q of this.c)if(W===q||W.startsWith(q))return!0;return!1}}e.$4nc=$;class v{get isEmpty(){return this.c.size===0&&this.g.size===0&&this.f.size===0}constructor(V){this.j=V,this.c=new Set,this.f=new Set,this.g=new Set,this.h=new Set}add(V){this.c.add(V)}update(V){Object.assign(V.revived,o.TestItem.toPlain(V.item)),this.c.has(V)||this.f.add(V)}remove(V){if(this.c.has(V)){this.c.delete(V);return}this.f.delete(V);const W=s.$0K.parentId(V.item.extId);if(W&&this.h.has(W.toString())){this.h.add(V.item.extId);return}this.g.add(V)}getChangeEvent(){const{c:V,f:W,g:q}=this;return{get added(){return[...V].map(R=>R.revived)},get updated(){return[...W].map(R=>R.revived)},get removed(){return[...q].map(R=>R.revived)}}}complete(){this.isEmpty||this.j.fire(this.getChangeEvent())}}class y extends t.$gL{constructor(){super(...arguments),this.s=new T.$fe,this.onDidChangeTests=this.s.event}get rootTests(){return this.g}getMirroredTestDataById(V){return this.f.get(V)}getMirroredTestDataByReference(V){return this.f.get(V.id)}w(V,W){return{...V,revived:o.TestItem.toPlain(V.item),depth:W?W.depth+1:0,children:new Set}}v(){return new v(this.s)}}class h{constructor(V){this.f=V}checkout(){this.c||(this.c=this.g());const V=this.c;return V.observers++,{onDidChangeTest:V.tests.onDidChangeTests,get tests(){return[...V.tests.rootTests].map(W=>W.revived)},dispose:(0,A.$db)(()=>{--V.observers===0&&(this.f.$unsubscribeFromDiffs(),this.c=void 0)})}}getMirroredTestDataByReference(V){return this.c?.tests.getMirroredTestDataByReference(V)}applyDiff(V){this.c?.tests.apply(V)}g(){const V=new y({asCanonicalUri:W=>W});return this.f.$subscribeToDiffs(),{observers:0,tests:V}}}const E=(P,V,W,q)=>{W?Object.assign(W,q):V.$updateTestRunConfig(P.controllerId,P.profileId,q)};class k{#e;#t;#i;#n;#s;get label(){return this.f}set label(V){V!==this.f&&(this.f=V,E(this,this.#e,this.#n,{label:V}))}get supportsContinuousRun(){return this.g}set supportsContinuousRun(V){V!==this.g&&(this.g=V,E(this,this.#e,this.#n,{supportsContinuousRun:V}))}get isDefault(){return this.#t.has(this.profileId)}set isDefault(V){V!==this.isDefault&&(V?this.#t.add(this.profileId):this.#t.delete(this.profileId),E(this,this.#e,this.#n,{isDefault:V}))}get tag(){return this._tag}set tag(V){V?.id!==this._tag?.id&&(this._tag=V,E(this,this.#e,this.#n,{tag:V?o.TestTag.namespace(this.controllerId,V.id):null}))}get configureHandler(){return this.c}set configureHandler(V){V!==this.c&&(this.c=V,E(this,this.#e,this.#n,{hasConfigurationHandler:!!V}))}get onDidChangeDefault(){return T.Event.chain(this.#i,V=>V.map(W=>W.get(this.controllerId)?.get(this.profileId)).filter(D.$gg))}constructor(V,W,q,R,z,K,ie,de,ye,De=!1,ge=void 0,ue=!1){this.controllerId=z,this.profileId=K,this.f=ie,this.kind=de,this.runHandler=ye,this._tag=ge,this.g=ue,this.#e=V,this.#s=W,this.#t=q,this.#i=R,W.set(K,this);const Ce=I[de];if(typeof Ce!="number")throw new Error(`Unknown TestRunProfile.group ${de}`);De&&q.add(K),this.#n={profileId:K,controllerId:z,tag:ge?o.TestTag.namespace(this.controllerId,ge.id):null,label:ie,group:Ce,isDefault:De,hasConfigurationHandler:!1,supportsContinuousRun:ue},queueMicrotask(()=>{this.#n&&(this.#e.$publishTestRunProfile(this.#n),this.#n=void 0)})}dispose(){this.#s?.delete(this.profileId)&&(this.#s=void 0,this.#e.$removeTestProfile(this.controllerId,this.profileId)),this.#n=void 0}}e.$5nc=k;const I={[r.TestRunProfileKind.Coverage]:8,[r.TestRunProfileKind.Debug]:4,[r.TestRunProfileKind.Run]:2}}),define(Se[117],Ie([1,0,57,14,91,8,7]),function(le,e,C,N,M,T,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$YO=e.$XO=e.$WO=void 0;class p{static{this.c=new M.$UO("TextEditorDecorationType")}constructor(d,w,f){const o=p.c.nextId();d.$registerTextEditorDecorationType(w.identifier,o,T.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:o,dispose(){d.$removeTextEditorDecorationType(o)}})}}e.$WO=p;class m{constructor(d,w){this.g=[],this.h=void 0,this.j=!1,this.c=d,this.d=d.version,this.e=w.undoStopBefore,this.f=w.undoStopAfter}finalize(){return this.j=!0,{documentVersionId:this.d,edits:this.g,setEndOfLine:this.h,undoStopBefore:this.e,undoStopAfter:this.f}}k(){if(this.j)throw new Error("Edit is only valid while callback runs")}replace(d,w){this.k();let f=null;if(d instanceof A.$oM)f=new A.$pM(d,d);else if(d instanceof A.$pM)f=d;else throw new Error("Unrecognized location");this.l(f,w,!1)}insert(d,w){this.k(),this.l(new A.$pM(d,d),w,!0)}delete(d){this.k();let w=null;if(d instanceof A.$pM)w=d;else throw new Error("Unrecognized location");this.l(w,null,!0)}l(d,w,f){const o=this.c.validateRange(d);this.g.push({range:o,text:w,forceMoveMarkers:f})}setEndOfLine(d){if(this.k(),d!==A.EndOfLine.LF&&d!==A.EndOfLine.CRLF)throw(0,N.$7)("endOfLine");this.h=d}}class D{constructor(d,w,f,o){this.c=d,this.d=w,this._accept(f),this.e=o;const r=this;this.value={get tabSize(){return r.f},set tabSize(s){r.n(s)},get indentSize(){return r.g},set indentSize(s){r.p(s)},get insertSpaces(){return r.j},set insertSpaces(s){r.s(s)},get cursorStyle(){return r.k},set cursorStyle(s){r.t(s)},get lineNumbers(){return r.l},set lineNumbers(s){r.u(s)}}}_accept(d){this.f=d.tabSize,this.g=d.indentSize,this.h=d.originalIndentSize,this.j=d.insertSpaces,this.k=d.cursorStyle,this.l=T.TextEditorLineNumbersStyle.to(d.lineNumbers)}m(d){if(d==="auto")return"auto";if(typeof d=="number"){const w=Math.floor(d);return w>0?w:null}if(typeof d=="string"){const w=parseInt(d,10);return isNaN(w)?null:w>0?w:null}return null}n(d){const w=this.m(d);if(w!==null){if(typeof w=="number"){if(this.f===w)return;this.f=w}this.v("setTabSize",this.c.$trySetOptions(this.d,{tabSize:w}))}}o(d){if(d==="tabSize")return"tabSize";if(typeof d=="number"){const w=Math.floor(d);return w>0?w:null}if(typeof d=="string"){const w=parseInt(d,10);return isNaN(w)?null:w>0?w:null}return null}p(d){const w=this.o(d);if(w!==null){if(typeof w=="number"){if(this.h===w)return;this.g=w,this.h=w}this.v("setIndentSize",this.c.$trySetOptions(this.d,{indentSize:w}))}}q(d){return d==="auto"?"auto":d==="false"?!1:!!d}s(d){const w=this.q(d);if(typeof w=="boolean"){if(this.j===w)return;this.j=w}this.v("setInsertSpaces",this.c.$trySetOptions(this.d,{insertSpaces:w}))}t(d){this.k!==d&&(this.k=d,this.v("setCursorStyle",this.c.$trySetOptions(this.d,{cursorStyle:d})))}u(d){this.l!==d&&(this.l=d,this.v("setLineNumbers",this.c.$trySetOptions(this.d,{lineNumbers:T.TextEditorLineNumbersStyle.from(d)})))}assign(d){const w={};let f=!1;if(typeof d.tabSize<"u"){const o=this.m(d.tabSize);o==="auto"?(f=!0,w.tabSize=o):typeof o=="number"&&this.f!==o&&(this.f=o,f=!0,w.tabSize=o)}if(typeof d.indentSize<"u"){const o=this.o(d.indentSize);o==="tabSize"?(f=!0,w.indentSize=o):typeof o=="number"&&this.h!==o&&(this.g=o,this.h=o,f=!0,w.indentSize=o)}if(typeof d.insertSpaces<"u"){const o=this.q(d.insertSpaces);o==="auto"?(f=!0,w.insertSpaces=o):this.j!==o&&(this.j=o,f=!0,w.insertSpaces=o)}typeof d.cursorStyle<"u"&&this.k!==d.cursorStyle&&(this.k=d.cursorStyle,f=!0,w.cursorStyle=d.cursorStyle),typeof d.lineNumbers<"u"&&this.l!==d.lineNumbers&&(this.l=d.lineNumbers,f=!0,w.lineNumbers=T.TextEditorLineNumbersStyle.from(d.lineNumbers)),f&&this.v("setOptions",this.c.$trySetOptions(this.d,w))}v(d,w){w.catch(f=>{this.e.warn(`ExtHostTextEditorOptions '${d}' failed:'`),this.e.warn(f)})}}e.$XO=D;class O{constructor(d,w,f,o,r,s,n,t){this.id=d,this.j=w,this.k=f,this.g=!1,this.h=new Set,this.c=r,this.d=new D(this.j,this.id,s,f),this.e=n,this.f=t;const c=this;this.value=Object.freeze({get document(){return o.value},set document(u){throw new N.$9("document")},get selection(){return c.c&&c.c[0]},set selection(u){if(!(u instanceof A.$qM))throw(0,N.$7)("selection");c.c=[u],c.l()},get selections(){return c.c},set selections(u){if(!Array.isArray(u)||u.some(i=>!(i instanceof A.$qM)))throw(0,N.$7)("selections");c.c=u,c.l()},get visibleRanges(){return c.e},set visibleRanges(u){throw new N.$9("visibleRanges")},get options(){return c.d.value},set options(u){c.g||c.d.assign(u)},get viewColumn(){return c.f},set viewColumn(u){throw new N.$9("viewColumn")},edit(u,i={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const b=new m(o.value,i);return u(b),c.m(b)},insertSnippet(u,i,b={undoStopBefore:!0,undoStopAfter:!0}){if(c.g)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let a;if(!i||Array.isArray(i)&&i.length===0)a=c.c.map(l=>T.Range.from(l));else if(i instanceof A.$oM){const{lineNumber:l,column:g}=T.Position.from(i);a=[{startLineNumber:l,startColumn:g,endLineNumber:l,endColumn:g}]}else if(i instanceof A.$pM)a=[T.Range.from(i)];else{a=[];for(const l of i)if(l instanceof A.$pM)a.push(T.Range.from(l));else{const{lineNumber:g,column:$}=T.Position.from(l);a.push({startLineNumber:g,startColumn:$,endLineNumber:g,endColumn:$})}}return w.$tryInsertSnippet(d,o.value.version,u.value,a,b)},setDecorations(u,i){const b=i.length===0;b&&!c.h.has(u.key)||(b?c.h.delete(u.key):c.h.add(u.key),c.n(()=>{if(T.$MO(i))return w.$trySetDecorations(d,u.key,T.$NO(i));{const a=new Array(4*i.length);for(let l=0,g=i.length;l<g;l++){const $=i[l];a[4*l]=$.start.line+1,a[4*l+1]=$.start.character+1,a[4*l+2]=$.end.line+1,a[4*l+3]=$.end.character+1}return w.$trySetDecorationsFast(d,u.key,a)}}))},revealRange(u,i){c.n(()=>w.$tryRevealRange(d,T.Range.from(u),i||A.TextEditorRevealType.Default))},show(u){w.$tryShowEditor(d,T.ViewColumn.from(u))},hide(){w.$tryHideEditor(d)}})}dispose(){(0,C.ok)(!this.g),this.g=!0}_acceptOptions(d){(0,C.ok)(!this.g),this.d._accept(d)}_acceptVisibleRanges(d){(0,C.ok)(!this.g),this.e=d}_acceptViewColumn(d){(0,C.ok)(!this.g),this.f=d}_acceptSelections(d){(0,C.ok)(!this.g),this.c=d}async l(){const d=this.c.map(T.Selection.from);return await this.n(()=>this.j.$trySetSelections(this.id,d)),this.value}m(d){const w=d.finalize();if(w.edits.length===0&&!w.setEndOfLine)return Promise.resolve(!0);const f=w.edits.map(r=>r.range);f.sort((r,s)=>r.end.line===s.end.line?r.end.character===s.end.character?r.start.line===s.start.line?r.start.character-s.start.character:r.start.line-s.start.line:r.end.character-s.end.character:r.end.line-s.end.line);for(let r=0,s=f.length-1;r<s;r++){const n=f[r].end;if(f[r+1].start.isBefore(n))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const o=w.edits.map(r=>({range:T.Range.from(r.range),text:r.text,forceMoveMarkers:r.forceMoveMarkers}));return this.j.$tryApplyEdits(this.id,w.documentVersionId,o,{setEndOfLine:typeof w.setEndOfLine=="number"?T.EndOfLine.from(w.setEndOfLine):void 0,undoStopBefore:w.undoStopBefore,undoStopAfter:w.undoStopAfter})}n(d){return this.g?(this.k.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):d().then(()=>this,w=>(w instanceof Error&&w.name==="DISPOSED"||this.k.warn(w),null))}}e.$YO=O}),define(Se[68],Ie([1,0,57,5,6,2,3,4,113,17,117,8,12,28,16,42,43]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1O=e.$ZO=void 0;class s{constructor(c){this.value=c,this.a=0}ref(){this.a++}unref(){return--this.a===0}}let n=class{constructor(c,u){this.h=c,this.i=u,this.a=null,this.b=new Map,this.c=new w.$Ac,this.d=new N.$fe,this.e=new N.$fe,this.f=new N.$fe,this.g=new N.$fe,this.onDidAddDocuments=this.d.event,this.onDidRemoveDocuments=this.e.event,this.onDidChangeVisibleTextEditors=this.f.event,this.onDidChangeActiveTextEditor=this.g.event}$acceptDocumentsAndEditorsDelta(c){this.acceptDocumentsAndEditorsDelta(c)}acceptDocumentsAndEditorsDelta(c){const u=[],i=[],b=[];if(c.removedDocuments)for(const a of c.removedDocuments){const l=T.URI.revive(a),g=this.c.get(l);g?.unref()&&(this.c.delete(l),u.push(g.value))}if(c.addedDocuments)for(const a of c.addedDocuments){const l=T.URI.revive(a.uri);let g=this.c.get(l);if(g&&l.scheme!==f.Schemas.vscodeNotebookCell&&l.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${l} already exists!'`);g||(g=new s(new m.$SO(this.h.getProxy(p.$lM.MainThreadDocuments),l,a.lines,a.EOL,a.versionId,a.languageId,a.isDirty)),this.c.set(l,g),i.push(g.value)),g.ref()}if(c.removedEditors)for(const a of c.removedEditors){const l=this.b.get(a);this.b.delete(a),l&&b.push(l)}if(c.addedEditors)for(const a of c.addedEditors){const l=T.URI.revive(a.documentUri);C.ok(this.c.has(l),`document '${l}' does not exist`),C.ok(!this.b.has(a.id),`editor '${a.id}' already exists!`);const g=this.c.get(l).value,$=new O.$YO(a.id,this.h.getProxy(p.$lM.MainThreadTextEditors),this.i,new r.$V(()=>g.document),a.selections.map(S.Selection.to),a.options,a.visibleRanges.map(v=>S.Range.to(v)),typeof a.editorPosition=="number"?S.ViewColumn.to(a.editorPosition):void 0);this.b.set(a.id,$)}c.newActiveEditor!==void 0&&(C.ok(c.newActiveEditor===null||this.b.has(c.newActiveEditor),`active editor '${c.newActiveEditor}' does not exist`),this.a=c.newActiveEditor),(0,M.$Pc)(u),(0,M.$Pc)(b),c.removedDocuments&&this.e.fire(u),c.addedDocuments&&this.d.fire(i),(c.removedEditors||c.addedEditors)&&this.f.fire(this.allEditors().map(a=>a.value)),c.newActiveEditor!==void 0&&this.g.fire(this.activeEditor())}getDocument(c){return this.c.get(c)?.value}allDocuments(){return o.Iterable.map(this.c.values(),c=>c.value)}getEditor(c){return this.b.get(c)}activeEditor(c){if(!this.a)return;const u=this.b.get(this.a);return c?u:u?.value}allEditors(){return[...this.b.values()]}};e.$ZO=n,e.$ZO=n=Je([We(0,D.$PO),We(1,d.$5j)],n),e.$1O=(0,A.$yi)("IExtHostDocumentsAndEditors")}),define(Se[290],Ie([1,0,18,5,4,117,8,7]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$lmc=void 0;class m{constructor(O,S){this.i=S,this.a=new N.$fe,this.b=new N.$fe,this.c=new N.$fe,this.d=new N.$fe,this.f=new N.$fe,this.g=new N.$fe,this.onDidChangeTextEditorSelection=this.a.event,this.onDidChangeTextEditorOptions=this.b.event,this.onDidChangeTextEditorVisibleRanges=this.c.event,this.onDidChangeTextEditorViewColumn=this.d.event,this.onDidChangeActiveTextEditor=this.f.event,this.onDidChangeVisibleTextEditors=this.g.event,this.h=O.getProxy(M.$lM.MainThreadTextEditors),this.i.onDidChangeVisibleTextEditors(d=>this.g.fire(d)),this.i.onDidChangeActiveTextEditor(d=>this.f.fire(d))}getActiveTextEditor(){return this.i.activeEditor()}getVisibleTextEditors(O){const S=this.i.allEditors();return O?S:S.map(d=>d.value)}async showTextDocument(O,S,d){let w;typeof S=="number"?w={position:A.ViewColumn.from(S),preserveFocus:d}:typeof S=="object"?w={position:A.ViewColumn.from(S.viewColumn),preserveFocus:S.preserveFocus,selection:typeof S.selection=="object"?A.Range.from(S.selection):void 0,pinned:typeof S.preview=="boolean"?!S.preview:void 0}:w={preserveFocus:!1};const f=await this.h.$tryShowTextDocument(O.uri,w),o=f&&this.i.getEditor(f);if(o)return o.value;throw f?new Error(`Could NOT open editor for "${O.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${O.uri.toString()}".`)}createTextEditorDecorationType(O,S){return new T.$WO(this.h,O,S).value}$acceptEditorPropertiesChanged(O,S){const d=this.i.getEditor(O);if(!d)throw new Error("unknown text editor");if(S.options&&d._acceptOptions(S.options),S.selections){const w=S.selections.selections.map(A.Selection.to);d._acceptSelections(w)}if(S.visibleRanges){const w=C.$Hb(S.visibleRanges.map(A.Range.to));d._acceptVisibleRanges(w)}if(S.options&&this.b.fire({textEditor:d.value,options:{...S.options,lineNumbers:A.TextEditorLineNumbersStyle.to(S.options.lineNumbers)}}),S.selections){const w=p.TextEditorSelectionChangeKind.fromValue(S.selections.source),f=S.selections.selections.map(A.Selection.to);this.a.fire({textEditor:d.value,selections:f,kind:w})}if(S.visibleRanges){const w=C.$Hb(S.visibleRanges.map(A.Range.to));this.c.fire({textEditor:d.value,visibleRanges:w})}}$acceptEditorPositionData(O){for(const S in O){const d=this.i.getEditor(S);if(!d)throw new Error("Unknown text editor");const w=A.ViewColumn.to(O[S]);d.value.viewColumn!==w&&(d._acceptViewColumn(w),this.d.fire({textEditor:d.value,viewColumn:w}))}}getDiffInformation(O){return Promise.resolve(this.h.$getDiffInformation(O))}}e.$lmc=m}),define(Se[291],Ie([1,0,2,3,4,6,7,8,21,15]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$8nc=e.$7nc=void 0,e.$7nc=(0,N.$yi)("IExtHostTimeline");class O{constructor(w,f){this.b=new Map,this.c=new Map,this.a=w.getProxy(M.$lM.MainThreadTimeline),f.registerArgumentProcessor({processArgument:(o,r)=>{if(o&&o.$mid===12)if(this.b.get(o.source)&&m.$Tm.equals(r,this.b.get(o.source)?.extension)){const s=o.uri===void 0?void 0:C.URI.revive(o.uri);return this.c.get(o.source)?.get(S(s))?.get(o.handle)}else return;return o}})}async $getTimeline(w,f,o,r){return this.b.get(w)?.provider.provideTimeline(C.URI.revive(f),o,r)}registerTimelineProvider(w,f,o,r){const s=new T.$Tc,n=this.d(f.id,r,s).bind(this);let t;f.onDidChange&&(t=f.onDidChange(u=>this.a.$emitTimelineChangeEvent({uri:void 0,reset:!0,...u,id:f.id}),this));const c=this.c;return this.f({...f,scheme:w,onDidChange:void 0,async provideTimeline(u,i,b){i?.resetCache&&(s.clear(),c.get(f.id)?.clear());const a=await f.provideTimeline(u,i,b);if(a==null)return;const l=n(u,i);return{...a,source:f.id,items:a.items.map(l)}},dispose(){for(const u of c.values())u.get(f.id)?.clear();t?.dispose(),s.dispose()}},o)}d(w,f,o){return(r,s)=>{let n;if(s?.cacheResults){let t=this.c.get(w);t===void 0&&(t=new Map,this.c.set(w,t));const c=S(r);n=t.get(c),n===void 0&&(n=new Map,t.set(c,n))}return t=>{const{iconPath:c,...u}=t,i=`${w}|${t.id??t.timestamp}`;n?.set(i,t);let b,a,l;t.iconPath&&(c instanceof A.$kN?l={id:c.id,color:c.color}:C.URI.isUri(c)?(b=c,a=c):{light:b,dark:a}=c);let g;return A.$PM.isMarkdownString(u.tooltip)?g=p.MarkdownString.from(u.tooltip):(0,D.$$f)(u.tooltip)?g=u.tooltip:A.$PM.isMarkdownString(u.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),g=p.MarkdownString.from(u.detail)):(0,D.$$f)(u.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),g=u.detail),{...u,id:u.id??void 0,handle:i,source:w,command:t.command?f.toInternal(t.command,o):void 0,icon:b,iconDark:a,themeIcon:l,tooltip:g,accessibilityInformation:t.accessibilityInformation}}}}f(w,f){if(this.b.get(w.id))throw new Error(`Timeline Provider ${w.id} already exists.`);return this.a.$registerTimelineProvider({id:w.id,label:w.label,scheme:w.scheme}),this.b.set(w.id,{provider:w,extension:f}),(0,T.$Sc)(()=>{for(const r of this.c.values())r.get(w.id)?.clear();this.b.delete(w.id),this.a.$unregisterTimelineProvider(w.id),w.dispose()})}}e.$8nc=O;function S(d){return d?.toString()}}),define(Se[292],Ie([1,0,181,24,2,5,6,222,11,7,15,18,8,55,20,143,25]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$9nc=void 0;function s(c,u){if((0,O.$$f)(c))return{label:c};if(c&&typeof c=="object"&&typeof c.label=="string"){let i;return Array.isArray(c.highlights)&&(i=c.highlights.filter(b=>b.length===2&&typeof b[0]=="number"&&typeof b[1]=="number"),i=i.length?i:void 0),{label:c.label,highlights:i}}}class n extends A.$Uc{constructor(u,i,b){super(),this.f=u,this.g=i,this.h=b,this.a=new Map,this.b=new o.$L0;function a(l){return l&&l.$treeViewId&&(l.$treeItemHandle||l.$selectedTreeItems||l.$focusedTreeItem)}i.registerArgumentProcessor({processArgument:l=>a(l)?this.r(l):Array.isArray(l)&&l.length>0?l.map(g=>a(g)?this.r(g):g):l})}registerTreeDataProvider(u,i,b){const a=this.createTreeView(u,{treeDataProvider:i},b);return{dispose:()=>a.dispose()}}createTreeView(u,i,b){if(!i||!i.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const a=i.dragAndDropController?.dropMimeTypes??[],l=i.dragAndDropController?.dragMimeTypes??[],g=!!i.dragAndDropController?.handleDrag,$=!!i.dragAndDropController?.handleDrop,v=this.m(u,i,b),y={showCollapseAll:!!i.showCollapseAll,canSelectMany:!!i.canSelectMany,dropMimeTypes:a,dragMimeTypes:l,hasHandleDrag:g,hasHandleDrop:$,manuallyManageCheckboxes:!!i.manageCheckboxStateManually},h=this.f.$registerTreeViewDataProvider(u,y),E={get onDidCollapseElement(){return v.onDidCollapseElement},get onDidExpandElement(){return v.onDidExpandElement},get selection(){return v.selectedElements},get onDidChangeSelection(){return v.onDidChangeSelection},get activeItem(){return(0,r.$MG)(b,"treeViewActiveItem"),v.focusedElement},get onDidChangeActiveItem(){return(0,r.$MG)(b,"treeViewActiveItem"),v.onDidChangeActiveItem},get visible(){return v.visible},get onDidChangeVisibility(){return v.onDidChangeVisibility},get onDidChangeCheckboxState(){return v.onDidChangeCheckboxState},get message(){return v.message},set message(k){(0,w.$Xk)(k)&&(0,r.$MG)(b,"treeViewMarkdownMessage"),v.message=k},get title(){return v.title},set title(k){v.title=k},get description(){return v.description},set description(k){v.description=k},get badge(){return v.badge},set badge(k){k!==void 0&&D.ViewBadge.isViewBadge(k)?v.badge={value:Math.floor(Math.abs(k.value)),tooltip:k.tooltip}:k===void 0&&(v.badge=void 0)},reveal:(k,I)=>v.reveal(k,I),dispose:async()=>{await h,this.a.delete(u),v.dispose()}};return this.B(E),E}$getChildren(u,i){const b=this.a.get(u);return b?b.getChildren(i):Promise.reject(new p.$9F(u))}async $handleDrop(u,i,b,a,l,g,$,v){const y=this.a.get(u);if(!y)return Promise.reject(new p.$9F(u));const h=d.DataTransfer.toDataTransfer(b,async E=>(await this.f.$resolveDropFileData(u,i,E)).buffer);return $===u&&v&&await this.j(h,y,v,l,g),y.onDrop(h,a,l)}async j(u,i,b,a,l){const g=this.b.removeDragOperationTransfer(l);if(g)(await g)?.forEach(($,v)=>{$&&u.set(v,$)});else if(l&&i.handleDrag){const $=i.handleDrag(b,u,a);this.b.addDragOperationTransfer(l,$),await $}return u}async $handleDrag(u,i,b,a){const l=this.a.get(u);if(!l)return Promise.reject(new p.$9F(u));const g=await this.j(new D.$gN,l,i,a,b);if(!(!g||a.isCancellationRequested))return d.DataTransfer.from(g)}async $hasResolve(u){const i=this.a.get(u);if(!i)throw new p.$9F(u);return i.hasResolve}$resolve(u,i,b){const a=this.a.get(u);if(!a)throw new p.$9F(u);return a.resolveTreeItem(i,b)}$setExpanded(u,i,b){const a=this.a.get(u);if(!a)throw new p.$9F(u);a.setExpanded(i,b)}$setSelectionAndFocus(u,i,b){const a=this.a.get(u);if(!a)throw new p.$9F(u);a.setSelectionAndFocus(i,b)}$setVisible(u,i){const b=this.a.get(u);if(!b){if(!i)return;throw new p.$9F(u)}b.setVisible(i)}$changeCheckboxState(u,i){const b=this.a.get(u);if(!b)throw new p.$9F(u);b.setCheckboxState(i)}m(u,i,b){const a=this.B(new t(u,i,this.f,this.g.converter,this.h,b));return this.a.set(u,a),a}r(u){const i=this.a.get(u.$treeViewId);return i&&"$treeItemHandle"in u?i.getExtensionElement(u.$treeItemHandle):i&&"$focusedTreeItem"in u&&u.$focusedTreeItem?i.focusedElement:null}}e.$9nc=n;class t extends A.$Uc{static{this.a="0"}static{this.b="1"}get visible(){return this.r}get selectedElements(){return this.s.map(u=>this.getExtensionElement(u)).filter(u=>!(0,O.$hg)(u))}get focusedElement(){return this.t?this.getExtensionElement(this.t):void 0}constructor(u,i,b,a,l,g){if(super(),this.I=u,this.J=b,this.L=a,this.M=l,this.N=g,this.h=void 0,this.j=new Map,this.m=new Map,this.r=!1,this.s=[],this.t=void 0,this.u=this.B(new T.$fe),this.onDidExpandElement=this.u.event,this.w=this.B(new T.$fe),this.onDidCollapseElement=this.w.event,this.y=this.B(new T.$fe),this.onDidChangeSelection=this.y.event,this.z=this.B(new T.$fe),this.onDidChangeActiveItem=this.z.event,this.C=this.B(new T.$fe),this.onDidChangeVisibility=this.C.event,this.D=this.B(new T.$fe),this.onDidChangeCheckboxState=this.D.event,this.F=this.B(new T.$fe),this.G=Promise.resolve(),this.H=Promise.resolve(),this.O="",this.P="",this.Z=new f.$qe,g.contributes&&g.contributes.views)for(const h in g.contributes.views)for(const E of g.contributes.views[h])E.id===u&&(this.P=E.name);this.f=i.treeDataProvider,this.g=i.dragAndDropController,this.f.onDidChangeTreeData&&this.B(this.f.onDidChangeTreeData(h=>{Array.isArray(h)&&h.length===0||this.F.fire({message:!1,element:h})}));let $,v;const y=T.Event.debounce(this.F.event,(h,E)=>(h||(h={message:!1,elements:[]}),E.element!==!1&&($||($=new Promise(k=>v=k),this.G=this.G.then(()=>$)),Array.isArray(E.element)?h.elements.push(...E.element):h.elements.push(E.element)),E.message&&(h.message=!0),h),200,!0);this.B(y(({message:h,elements:E})=>{E.length&&(this.H=this.H.then(()=>{const k=v;return $=null,this.$(E).then(()=>k())})),h&&this.J.$setMessage(this.I,d.MarkdownString.fromStrict(this.O)??"")}))}async getChildren(u){const i=u?this.getExtensionElement(u):void 0;if(u&&!i)return this.M.error(`No tree item with id '${u}' found.`),Promise.resolve([]);let b=this.X(u);return b||(b=await this.Y(i)),b?b.map(a=>a.item):void 0}getExtensionElement(u){return this.j.get(u)}reveal(u,i){i=i||{select:!0,focus:!1};const b=(0,O.$hg)(i.select)?!0:i.select,a=(0,O.$hg)(i.focus)?!1:i.focus,l=(0,O.$hg)(i.expand)?!1:i.expand;return typeof this.f.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):u?this.G.then(()=>this.S(u)).then(g=>this.W(u,g[g.length-1]).then($=>this.J.$reveal(this.I,{item:$.item,parentChain:g.map(v=>v.item)},{select:b,focus:a,expand:l})),g=>this.M.error(g)):this.J.$reveal(this.I,void 0,{select:b,focus:a,expand:l})}get message(){return this.O}set message(u){this.O=u,this.F.fire({message:!0,element:!1})}get title(){return this.P}set title(u){this.P=u,this.J.$setTitle(this.I,u,this.Q)}get description(){return this.Q}set description(u){this.Q=u,this.J.$setTitle(this.I,this.P,u)}get badge(){return this.R}set badge(u){this.R?.value===u?.value&&this.R?.tooltip===u?.tooltip||(this.R=d.ViewBadge.from(u),this.J.$setBadge(this.I,u))}setExpanded(u,i){const b=this.getExtensionElement(u);b&&(i?this.u.fire(Object.freeze({element:b})):this.w.fire(Object.freeze({element:b})))}setSelectionAndFocus(u,i){const b=!(0,S.$ub)(this.s,u);this.s=u;const a=this.t!==i;this.t=i,b&&this.y.fire(Object.freeze({selection:this.selectedElements})),a&&this.z.fire(Object.freeze({activeItem:this.focusedElement}))}setVisible(u){u!==this.r&&(this.r=u,this.C.fire(Object.freeze({visible:this.r})))}async setCheckboxState(u){const i=(await Promise.all(u.map(async b=>{const a=this.getExtensionElement(b.treeItemHandle);return a?{extensionItem:a,treeItem:await this.f.getTreeItem(a),newState:b.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}:Promise.resolve(void 0)}))).filter(b=>b!==void 0);i.forEach(b=>{b.treeItem.checkboxState=b.newState?D.TreeItemCheckboxState.Checked:D.TreeItemCheckboxState.Unchecked}),this.D.fire({items:i.map(b=>[b.extensionItem,b.newState])})}async handleDrag(u,i,b){const a=[];for(const l of u){const g=this.getExtensionElement(l);g&&a.push(g)}if(!(!this.g?.handleDrag||a.length===0))return await this.g.handleDrag(a,i,b),i}get hasHandleDrag(){return!!this.g?.handleDrag}async onDrop(u,i,b){const a=i?this.getExtensionElement(i):void 0;if(!(!a&&i||!this.g?.handleDrop))return(0,m.$qh)(()=>this.g?.handleDrop?this.g.handleDrop(a,u,b):void 0)}get hasResolve(){return!!this.f.resolveTreeItem}async resolveTreeItem(u,i){if(!this.f.resolveTreeItem)return;const b=this.j.get(u);if(b){const a=this.m.get(b);if(a){const l=await this.f.resolveTreeItem(a.extensionItem,b,i)??a.extensionItem;return this.hb(l),a.item.tooltip=this.eb(l.tooltip),a.item.command=this.fb(a.disposableStore,l.command),a.item}}}S(u){return this.U(u).then(i=>i?this.S(i).then(b=>this.W(i,b[b.length-1]).then(a=>(b.push(a),b))):Promise.resolve([]))}U(u){const i=this.m.get(u);return i?Promise.resolve(i.parent?this.j.get(i.parent.item.handle):void 0):(0,m.$qh)(()=>this.f.getParent(u))}W(u,i){const b=this.m.get(u);return b?Promise.resolve(b):(0,m.$qh)(()=>this.f.getTreeItem(u)).then(a=>this.kb(u,a,i,!0)).then(a=>this.getChildren(i?i.item.handle:void 0).then(()=>{const l=this.getExtensionElement(a);if(l){const g=this.m.get(l);if(g)return Promise.resolve(g)}throw new Error(`Cannot resolve tree item for element ${a} from extension ${this.N.identifier.value}`)}))}X(u){if(u){let i;if(typeof u=="string"){const b=this.getExtensionElement(u);i=b?this.m.get(b):void 0}else i=u;return i&&i.children||void 0}return this.h}async Y(u){this.rb(u);const i=new f.$qe(this.Z.token);try{const b=u?this.m.get(u):void 0,a=await this.f.getChildren(u);if(i.token.isCancellationRequested)return;const l=(0,S.$Hb)(a||[]),g=await Promise.all((0,S.$Hb)(l).map(v=>this.f.getTreeItem(v)));if(i.token.isCancellationRequested)return;const $=g.map((v,y)=>v?this.db(l[y],v,b):null);return(0,S.$Hb)($)}finally{i.dispose()}}$(u){if(u.some(b=>!b))return this.Z.dispose(!0),this.Z=new f.$qe,this.tb(),this.J.$refresh(this.I);{const b=this.ab(u);if(b.length)return this.bb(b)}return Promise.resolve(void 0)}ab(u){const i=new Set,b=u.map(l=>this.m.get(l));for(const l of b)if(l&&!i.has(l.item.handle)){let g=l;for(;g&&g.parent&&b.findIndex($=>g&&g.parent&&$&&$.item.handle===g.parent.item.handle)===-1;){const $=this.j.get(g.parent.item.handle);g=$?this.m.get($):void 0}g&&!g.parent&&i.add(l.item.handle)}const a=[];return i.forEach(l=>{const g=this.j.get(l);if(g){const $=this.m.get(g);$&&(!$.parent||!i.has($.parent.item.handle))&&a.push(l)}}),a}bb(u){const i={};return Promise.all(u.map(b=>this.cb(b).then(a=>{a&&(i[b]=a.item)}))).then(()=>Object.keys(i).length?this.J.$refresh(this.I,i):void 0)}cb(u){const i=this.getExtensionElement(u);if(i){const b=this.m.get(i);if(b)return this.rb(i),(0,m.$qh)(()=>this.f.getTreeItem(i)).then(a=>{if(a){const l=this.ib(i,a,b.parent);return this.pb(i,l,b,b.parent),b.dispose(),l}return null})}return Promise.resolve(null)}db(u,i,b){const a=this.ib(u,i,b);if(i.id&&this.j.has(a.item.handle))throw new Error((0,C.localize)(0,null,i.id));return this.ob(u,a),this.qb(a,b),a}eb(u){return D.$PM.isMarkdownString(u)?d.MarkdownString.from(u):u}fb(u,i){return i?{...this.L.toInternal(i,u),originalId:i.command}:void 0}gb(u){if(u.checkboxState===void 0)return;let i,b,a;return typeof u.checkboxState=="number"?i=u.checkboxState:(i=u.checkboxState.state,b=u.checkboxState.tooltip,a=u.checkboxState.accessibilityInformation),{isChecked:i===D.TreeItemCheckboxState.Checked,tooltip:b,accessibilityInformation:a}}hb(u){if(!D.$bN.isTreeItem(u,this.N))throw new Error(`Extension ${this.N.identifier.value} has provided an invalid tree item.`)}ib(u,i,b){this.hb(i);const a=this.B(new A.$Tc),l=this.kb(u,i,b),g=this.lb(i);return{item:{handle:l,parentHandle:b?b.item.handle:void 0,label:s(i.label,this.N),description:i.description,resourceUri:i.resourceUri,tooltip:this.eb(i.tooltip),command:this.fb(a,i.command),contextValue:i.contextValue,icon:g,iconDark:this.mb(i)||g,themeIcon:this.jb(i),collapsibleState:(0,O.$hg)(i.collapsibleState)?D.TreeItemCollapsibleState.None:i.collapsibleState,accessibilityInformation:i.accessibilityInformation,checkbox:this.gb(i)},extensionItem:i,parent:b,children:void 0,disposableStore:a,dispose(){a.dispose()}}}jb(u){return u.iconPath instanceof D.$kN?u.iconPath:void 0}kb(u,{id:i,label:b,resourceUri:a},l,g){if(i)return`${t.b}/${i}`;const $=s(b,this.N),v=l?l.item.handle:t.a;let y=$?$.label:a?(0,N.$9g)(a):"";y=y.indexOf("/")!==-1?y.replace("/","//"):y;const h=this.m.has(u)?this.m.get(u).item.handle:void 0,E=this.X(l)||[];let k,I=0;do{if(k=`${v}/${I}:${y}`,g||!this.j.has(k)||h===k)break;I++}while(I<=E.length);return k}lb(u){if(u.iconPath&&!(u.iconPath instanceof D.$kN))return typeof u.iconPath=="string"||M.URI.isUri(u.iconPath)?this.nb(u.iconPath):this.nb(u.iconPath.light)}mb(u){if(u.iconPath&&!(u.iconPath instanceof D.$kN)&&u.iconPath.dark)return this.nb(u.iconPath.dark)}nb(u){return M.URI.isUri(u)?u:M.URI.file(u)}ob(u,i){this.j.set(i.item.handle,u),this.m.set(u,i)}pb(u,i,b,a){this.j.delete(i.item.handle),this.m.delete(u),i.item.handle!==b.item.handle&&this.j.delete(b.item.handle),this.ob(u,i);const l=this.X(a)||[],g=l.filter($=>$.item.handle===b.item.handle)[0];g&&l.splice(l.indexOf(g),1,i)}qb(u,i){i?(i.children||(i.children=[]),i.children.push(u)):(this.h||(this.h=[]),this.h.push(u))}rb(u){if(u){const i=this.m.get(u);if(i){if(i.children)for(const b of i.children){const a=this.j.get(b.item.handle);a&&this.sb(a)}i.children=void 0}}else this.tb()}sb(u){const i=this.m.get(u);if(i){if(i.children)for(const b of i.children){const a=this.j.get(b.item.handle);a&&this.sb(a)}this.m.delete(u),this.j.delete(i.item.handle),i.dispose()}}tb(){this.h=void 0,this.j.clear(),this.m.forEach(u=>u.dispose()),this.m.clear()}dispose(){super.dispose(),this.Z.dispose(),this.tb(),this.J.$disposeTree(this.I)}}}),define(Se[293],Ie([1,0,5,6,2,33,8,64,4,7]),function(le,e,C,N,M,T,A,p,m,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Emc=void 0;class O extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;#u;#l;#d;#h;constructor(f,o,r,s){super(),this.#o=void 0,this.#c=!0,this.#l=!1,this.#d=this.B(new C.$fe),this.onDidDispose=this.#d.event,this.#h=this.B(new C.$fe),this.onDidChangeViewState=this.#h.event,this.#e=f,this.#t=o,this.#n=r,this.#i=s.viewType,this.#s=s.panelOptions,this.#o=s.viewColumn,this.#r=s.title,this.#u=s.active}dispose(){this.#l||(this.#l=!0,this.#d.fire(),this.#t.$disposeWebview(this.#e),this.#n.dispose(),super.dispose())}get webview(){return this.c(),this.#n}get viewType(){return this.c(),this.#i}get title(){return this.c(),this.#r}set title(f){this.c(),this.#r!==f&&(this.#r=f,this.#t.$setTitle(this.#e,f))}get iconPath(){return this.c(),this.#a}set iconPath(f){this.c(),this.#a!==f&&(this.#a=f,this.#t.$setIconPath(this.#e,M.URI.isUri(f)?{light:f,dark:f}:f))}get options(){return this.#s}get viewColumn(){if(this.c(),!(typeof this.#o=="number"&&this.#o<0))return this.#o}get active(){return this.c(),this.#u}get visible(){return this.c(),this.#c}_updateViewState(f){this.#l||(this.active!==f.active||this.visible!==f.visible||this.viewColumn!==f.viewColumn)&&(this.#u=f.active,this.#c=f.visible,this.#o=f.viewColumn,this.#h.fire({webviewPanel:this}))}reveal(f,o){this.c(),this.#t.$reveal(this.#e,{viewColumn:typeof f>"u"?void 0:A.ViewColumn.from(f),preserveFocus:!!o})}c(){if(this.#l)throw new Error("Webview is disposed")}}class S extends N.$Uc{static c(){return(0,T.$Ug)()}constructor(f,o,r){super(),this.j=o,this.m=r,this.g=new Map,this.h=new Map,this.f=f.getProxy(m.$lM.MainThreadWebviewPanels)}dispose(){super.dispose(),this.g.forEach(f=>f.dispose()),this.g.clear()}createWebviewPanel(f,o,r,s,n={}){const t=typeof s=="object"?s.viewColumn:s,c={viewColumn:A.ViewColumn.from(t),preserveFocus:typeof s=="object"&&!!s.preserveFocus},u=(0,p.$Amc)(f),i=S.c();this.f.$createWebviewPanel((0,p.$Cmc)(f),i,o,{title:r,panelOptions:d(n),webviewOptions:(0,p.$Dmc)(f,this.m,n),serializeBuffersForPostMessage:u},c);const b=this.j.createNewWebview(i,n,f);return this.createNewWebviewPanel(i,o,r,t,n,b,!0)}$onDidChangeWebviewPanelViewStates(f){const o=Object.keys(f);o.sort((r,s)=>{const n=f[r],t=f[s];return n.active?1:t.active?-1:+n.visible-+t.visible});for(const r of o){const s=this.getWebviewPanel(r);if(!s)continue;const n=f[r];s._updateViewState({active:n.active,visible:n.visible,viewColumn:A.ViewColumn.to(n.position)})}}async $onDidDisposeWebviewPanel(f){this.getWebviewPanel(f)?.dispose(),this.g.delete(f),this.j.deleteWebview(f)}registerWebviewPanelSerializer(f,o,r){if(this.h.has(o))throw new Error(`Serializer for '${o}' already registered`);return this.h.set(o,{serializer:r,extension:f}),this.f.$registerSerializer(o,{serializeBuffersForPostMessage:(0,p.$Amc)(f)}),new D.$nM(()=>{this.h.delete(o),this.f.$unregisterSerializer(o)})}async $deserializeWebviewPanel(f,o,r,s){const n=this.h.get(o);if(!n)throw new Error(`No serializer found for '${o}'`);const{serializer:t,extension:c}=n,u=this.j.createNewWebview(f,r.webviewOptions,c),i=this.createNewWebviewPanel(f,o,r.title,s,r.panelOptions,u,r.active);await t.deserializeWebviewPanel(i,r.state)}createNewWebviewPanel(f,o,r,s,n,t,c){const u=new O(f,this.f,t,{viewType:o,title:r,viewColumn:s,panelOptions:n,active:c});return this.g.set(f,u),u}getWebviewPanel(f){return this.g.get(f)}}e.$Emc=S;function d(w){return{enableFindWidget:w.enableFindWidget,retainContextWhenHidden:w.retainContextWhenHidden}}}),define(Se[294],Ie([1,0,5,6,64,8,4,7]),function(le,e,C,N,M,T,A,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_nc=void 0;class m extends N.$Uc{#e;#t;#i;#n;#s;#r;#a;#o;#c;constructor(S,d,w,f,o,r){super(),this.#s=!1,this.#u=this.B(new C.$fe),this.onDidChangeVisibility=this.#u.event,this.#l=this.B(new C.$fe),this.onDidDispose=this.#l.event,this.#i=w,this.#a=f,this.#e=S,this.#t=d,this.#n=o,this.#r=r}dispose(){this.#s||(this.#s=!0,this.#l.fire(),this.#n.dispose(),super.dispose())}#u;#l;get title(){return this.a(),this.#a}set title(S){this.a(),this.#a!==S&&(this.#a=S,this.#t.$setWebviewViewTitle(this.#e,S))}get description(){return this.a(),this.#o}set description(S){this.a(),this.#o!==S&&(this.#o=S,this.#t.$setWebviewViewDescription(this.#e,S))}get visible(){return this.#r}get webview(){return this.#n}get viewType(){return this.#i}_setVisible(S){S===this.#r||this.#s||(this.#r=S,this.#u.fire())}get badge(){return this.a(),this.#c}set badge(S){this.a(),!(S?.value===this.#c?.value&&S?.tooltip===this.#c?.tooltip)&&(this.#c=T.ViewBadge.from(S),this.#t.$setWebviewViewBadge(this.#e,S))}show(S){this.a(),this.#t.$show(this.#e,!!S)}a(){if(this.#s)throw new Error("Webview is disposed")}}class D{constructor(S,d){this.d=d,this.b=new Map,this.c=new Map,this.a=S.getProxy(A.$lM.MainThreadWebviewViews)}registerWebviewViewProvider(S,d,w,f){if(this.b.has(d))throw new Error(`View provider for '${d}' already registered`);return this.b.set(d,{provider:w,extension:S}),this.a.$registerWebviewViewProvider((0,M.$Cmc)(S),d,{retainContextWhenHidden:f?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,M.$Amc)(S)}),new p.$nM(()=>{this.b.delete(d),this.a.$unregisterWebviewViewProvider(d)})}async $resolveWebviewView(S,d,w,f,o){const r=this.b.get(d);if(!r)throw new Error(`No view provider found for '${d}'`);const{provider:s,extension:n}=r,t=this.d.createNewWebview(S,{},n),c=new m(S,this.a,d,w,t,!0);this.c.set(S,c),await s.resolveWebviewView(c,{state:f},o)}async $onDidChangeWebviewViewVisibility(S,d){this.e(S)._setVisible(d)}async $disposeWebviewView(S){const d=this.e(S);this.c.delete(S),d.dispose(),this.d.deleteWebview(S)}e(S){const d=this.c.get(S);if(!d)throw new Error("No webview found");return d}}e.$_nc=D}),define(Se[295],Ie([1,0,5,29,31,3]),function(le,e,C,N,M,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$HL=e.$GL=e.OutputChannelUpdateMode=e.$FL=e.$EL=e.$DL=e.$CL=e.$BL=e.$AL=e.$zL=e.$yL=e.$xL=e.$wL=e.$vL=e.$uL=e.$tL=void 0,e.$tL="text/x-code-output",e.$uL="output",e.$vL="Log",e.$wL="text/x-code-log-output",e.$xL="log",e.$yL="workbench.panel.output",e.$zL=new M.$Pj("inOutput",!1),e.$AL=new M.$Pj("activeLogOutput",!1),e.$BL=new M.$Pj("activeLogOutput.levelSettable",!1),e.$CL=new M.$Pj("activeLogOutput.level",""),e.$DL=new M.$Pj("activeLogOutput.levelIsDefault",!1),e.$EL=new M.$Pj("outputView.scrollLock",!1),e.$FL=(0,T.$yi)("outputService");var A;(function(m){m[m.Append=1]="Append",m[m.Replace=2]="Replace",m[m.Clear=3]="Clear"})(A||(e.OutputChannelUpdateMode=A={})),e.$GL={OutputChannels:"workbench.contributions.outputChannels"};class p{constructor(){this.a=new Map,this.b=new C.$fe,this.onDidRegisterChannel=this.b.event,this.c=new C.$fe,this.onDidRemoveChannel=this.c.event}registerChannel(D){this.a.has(D.id)||(this.a.set(D.id,D),this.b.fire(D.id))}getChannels(){const D=[];return this.a.forEach(O=>D.push(O)),D}getChannel(D){return this.a.get(D)}removeChannel(D){this.a.delete(D),this.c.fire(D)}}N.$fo.add(e.$GL.OutputChannels,new p),e.$HL=new M.$Pj("activeOutputChannel","")}),define(Se[118],Ie([1,0,4,3,17,21,12,295,65,27,47,147,22,15,38,5,6]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Lnc=e.$Knc=void 0;class s extends A.$$j{get disposed(){return this.n}constructor(u,i,b,a,l){super(),this.id=u,this.name=i,this.r=b,this.s=a,this.extension=l,this.m=0,this.n=!1,this.visible=!1,this.setLevel(b.getLevel()),this.B(b.onDidChangeLogLevel(g=>this.setLevel(g)))}get logLevel(){return this.getLevel()}appendLine(u){this.append(u+`
`)}append(u){this.info(u)}clear(){const u=this.m;this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Clear,u)}replace(u){const i=this.m;this.info(u),this.s.$update(this.id,p.OutputChannelUpdateMode.Replace,i),this.visible&&this.r.flush()}show(u,i){this.r.flush(),this.s.$reveal(this.id,!!(typeof u=="boolean"?u:i))}hide(){this.s.$close(this.id)}g(u,i){this.m+=d.$He.fromString(i).byteLength,(0,A.log)(this.r,u,i),this.visible&&(this.r.flush(),this.s.$update(this.id,p.OutputChannelUpdateMode.Append))}dispose(){super.dispose(),this.n||(this.s.$dispose(this.id),this.n=!0)}}class n extends s{appendLine(u){this.append(u)}}let t=class{constructor(u,i,b,a,l,g){this.i=i,this.j=b,this.k=a,this.l=l,this.m=g,this.d=new Map,this.f=1,this.g=new Map,this.h=null,this.a=u.getProxy(C.$lM.MainThreadOutputService),this.b=this.k.extUri.joinPath(i.logsLocation,`output_logging_${(0,S.$6m)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(u){this.h=u;for(const[i,b]of this.g)b.visible=i===this.h}createOutputChannel(u,i,b){if(u=u.trim(),!u)throw new Error("illegal argument `name`. must not be falsy");const a=typeof i=="object"&&i.log,l=(0,w.$$f)(i)?i:void 0;if((0,w.$$f)(l)&&!l.trim())throw new Error("illegal argument `languageId`. must not be empty");let g;const $=this.i.environment.extensionLogLevel?.find(([y])=>T.$Tm.equals(b.identifier,y))?.[1];$&&(g=(0,A.$jk)($));const v=a?this.o(u,g,b):this.n(u,l,b);return v.then(y=>{this.g.set(y.id,y),y.visible=y.id===this.h}),a?this.r(u,g??this.m.getLevel(),v):this.q(u,v)}async n(u,i,b){this.c||(this.c=this.j.value.createDirectory(this.b).then(()=>this.b));const a=await this.c,l=this.k.extUri.joinPath(a,`${this.f++}-${u.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),g=this.l.createLogger(l,{logLevel:"always",donotRotate:!0,donotUseFormatters:!0,hidden:!0}),$=await this.a.$register(u,l,i,b.identifier.value);return new s($,u,g,this.a,b)}async o(u,i,b){const a=await this.p(b),l=u.replace(/[\\/:\*\?"<>\|]/g,""),g=this.k.extUri.joinPath(a,`${l}.log`),$=`${b.identifier.value}.${l}`,v=this.l.createLogger(g,{id:$,name:u,logLevel:i,extensionId:b.identifier.value});return new n($,u,v,this.a,b)}p(u){let i=this.d.get(u.identifier.value);if(!i){const b=this.k.extUri.joinPath(this.i.logsLocation,u.identifier.value);this.d.set(u.identifier.value,i=(async()=>{try{await this.j.value.createDirectory(b)}catch(a){if((0,f.$il)(a)!==f.FileSystemProviderErrorCode.FileExists)throw a}return b})())}return i}q(u,i){let b=!1;const a=()=>{if(b)throw new Error("Channel has been closed")};return{get name(){return u},append(l){a(),i.then(g=>g.append(l))},appendLine(l){a(),i.then(g=>g.appendLine(l))},clear(){a(),i.then(l=>l.clear())},replace(l){a(),i.then(g=>g.replace(l))},show(l,g){a(),i.then($=>$.show(l,g))},hide(){a(),i.then(l=>l.hide())},dispose(){b=!0,i.then(l=>l.dispose())}}}r(u,i,b){const a=new r.$Tc,l=()=>{if(a.isDisposed)throw new Error("Channel has been closed")},g=a.add(new o.$fe);function $(v){i=v,g.fire(v)}return b.then(v=>{a.add(v),v.logLevel!==i&&$(v.logLevel),a.add(v.onDidChangeLogLevel(y=>$(y)))}),{...this.q(u,b),get logLevel(){return i},onDidChangeLogLevel:g.event,trace(v,...y){l(),b.then(h=>h.trace(v,...y))},debug(v,...y){l(),b.then(h=>h.debug(v,...y))},info(v,...y){l(),b.then(h=>h.info(v,...y))},warn(v,...y){l(),b.then(h=>h.warn(v,...y))},error(v,...y){l(),b.then(h=>h.error(v,...y))},dispose(){a.dispose()}}}};e.$Knc=t,e.$Knc=t=Je([We(0,M.$PO),We(1,D.$6O),We(2,m.$wmc),We(3,O.$_lc),We(4,A.$6j),We(5,A.$5j)],t),e.$Lnc=(0,N.$yi)("IExtHostOutputService")}),define(Se[119],Ie([1,0,3,11]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$jn=e.$in=void 0,e.$in=(0,C.$yi)("remoteAgentService"),e.$jn=new class{constructor(){this.maxSampleCount=5,this.sampleDelay=2e3,this.initial=[],this.maxInitialCount=3,this.average=[],this.maxAverageCount=100,this.highLatencyMultiple=2,this.highLatencyMinThreshold=500,this.highLatencyMaxThreshold=1500,this.lastMeasurement=void 0}get latency(){return this.lastMeasurement}async measure(M){let T=1/0;for(let p=0;p<this.maxSampleCount;p++){const m=await M.getRoundTripTime();if(m===void 0)return;T=Math.min(T,m/2),await(0,N.$zh)(this.sampleDelay)}this.average.push(T),this.average.length>this.maxAverageCount&&this.average.shift();let A;return this.initial.length<this.maxInitialCount?this.initial.push(T):A=this.initial.reduce((p,m)=>p+m,0)/this.initial.length,this.lastMeasurement={initial:A,current:T,average:this.average.reduce((p,m)=>p+m,0)/this.average.length,high:typeof A>"u"?!1:T>this.highLatencyMaxThreshold||T>this.highLatencyMinThreshold&&T>A*this.highLatencyMultiple},this.lastMeasurement}}}),define(Se[296],Ie([1,0,184,51,29,46,50,6,5,119,23,26,11]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Wgb=e.$Vgb=e.$Ugb=e.$Tgb=e.$Sgb=e.$Rgb=e.$Qgb=void 0,e.$Qgb=Object.freeze({id:"application",order:100,title:(0,C.localize)(0,null),type:"object"}),e.$Rgb=Object.freeze({id:"workbench",order:7,title:(0,C.localize)(1,null),type:"object"}),e.$Sgb=Object.freeze({id:"security",scope:1,title:(0,C.localize)(2,null),type:"object",order:7}),e.$Tgb=Object.freeze({id:"problems",title:(0,C.localize)(3,null),type:"object",order:101}),e.$Ugb={ConfigurationMigration:"base.contributions.configuration.migration"};class w{constructor(){this.migrations=[],this.a=new m.$fe,this.onDidRegisterConfigurationMigration=this.a.event}registerConfigurationMigrations(n){this.migrations.push(...n)}}const f=new w;M.$fo.add(e.$Ugb.ConfigurationMigration,f);let o=class extends p.$Uc{static{this.ID="workbench.contrib.configurationMigration"}constructor(n,t){super(),this.a=n,this.b=t,this.B(this.b.onDidChangeWorkspaceFolders(async c=>{for(const u of c.added)await this.f(u,f.migrations)})),this.c(f.migrations),this.B(f.onDidRegisterConfigurationMigration(c=>this.c(c)))}async c(n){await this.f(void 0,n);for(const t of this.b.getWorkspace().folders)await this.f(t,n)}async f(n,t){await Promise.all([t.map(c=>this.g(c,n?.uri))])}async g(n,t){const c=this.a.inspect(n.key,{resource:t}),u=this.b.getWorkbenchState()===3?[["user",2],["userLocal",3],["userRemote",4],["workspace",5],["workspaceFolder",6]]:[["user",2],["userLocal",3],["userRemote",4],["workspace",5]];for(const[i,b]of u){const a=c[i];if(!a)continue;const l=[];if(a.value!==void 0){const g=await this.h(n,i,a.value,t,void 0);for(const $ of g??[])l.push([$,[]])}for(const{identifiers:g,value:$}of a.overrides??[])if($!==void 0){const v=await this.h(n,i,$,t,g);for(const y of v??[])l.push([y,g])}l.length&&await Promise.allSettled(l.map(async([[g,$],v])=>this.a.updateValue(g,$.value,{resource:t,overrideIdentifiers:v},b)))}}async h(n,t,c,u,i){const b=l=>{const $=this.a.inspect(l,{resource:u})[t];if($)return i?$.overrides?.find(({identifiers:v})=>(0,S.$9n)(v,i))?.value:$.value},a=await n.migrateFn(c,b);return Array.isArray(a)?a:[[n.key,a]]}};e.$Vgb=o,e.$Vgb=o=Je([We(0,A.$5i),We(1,T.$Hi)],o);let r=class extends p.$Uc{static{this.ID="workbench.contrib.dynamicWorkbenchSecurityConfiguration"}constructor(n){super(),this.b=n,this.a=new d.$Vh,this.ready=this.a.p,this.c()}async c(){try{await this.f()}finally{this.a.complete()}}async f(){if(!O.$i&&(await this.b.getEnvironment())?.os!==1)return;M.$fo.as(N.$ko.Configuration).registerConfiguration({...e.$Sgb,properties:{"security.allowedUNCHosts":{type:"array",items:{type:"string",pattern:"^[^\\\\]+$",patternErrorMessage:(0,C.localize)(4,null)},default:[],markdownDescription:(0,C.localize)(5,null),scope:2},"security.restrictUNCAccess":{type:"boolean",default:!0,markdownDescription:(0,C.localize)(6,null),scope:2}}})}};e.$Wgb=r,e.$Wgb=r=Je([We(0,D.$in)],r)}),define(Se[297],Ie([1,0,37,16,19,24,193,296,51,3,29]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedStatus=e.RegisteredEditorPriority=e.$Ygb=e.$Xgb=void 0,e.$Zgb=o,e.$1gb=r,e.$Xgb=(0,D.$yi)("editorResolverService"),e.$Ygb="workbench.editorAssociations";const S=O.$fo.as(m.$ko.Configuration),d={...p.$Rgb,properties:{"workbench.editorAssociations":{type:"object",markdownDescription:(0,A.localize)(0,null),additionalProperties:{type:"string"}}}};S.registerConfiguration(d);var w;(function(s){s.builtin="builtin",s.option="option",s.exclusive="exclusive",s.default="default"})(w||(e.RegisteredEditorPriority=w={}));var f;(function(s){s[s.ABORT=1]="ABORT",s[s.NONE=2]="NONE"})(f||(e.ResolvedStatus=f={}));function o(s){switch(s){case w.exclusive:return 5;case w.default:return 4;case w.builtin:return 3;case w.option:default:return 1}}function r(s,n){if(new Set([N.Schemas.extension,N.Schemas.webviewPanel,N.Schemas.vscodeWorkspaceTrust,N.Schemas.vscodeSettings]).has(n.scheme))return!1;const u=typeof s=="string"&&s.indexOf(M.$gc.sep)>=0?`${n.scheme}:${n.path}`:(0,T.$9g)(n);return C.$rk(typeof s=="string"?s.toLowerCase():s,u.toLowerCase())}}),define(Se[298],Ie([1,0,49,16,19,23,24,2,3,214,46,236,119]),function(le,e,C,N,M,T,A,p,m,D,O,S,d){"use strict";var w;Object.defineProperty(e,"__esModule",{value:!0}),e.$1L=e.$ZL=void 0,e.$ZL=(0,m.$yi)("pathService");let f=w=class{constructor(r,s,n,t){this.d=r,this.e=s,this.f=n,this.g=t,this.a=(async()=>(await this.e.getEnvironment())?.os||T.OS)(),this.b=(async()=>{const c=await this.e.getEnvironment();return this.c=c?.userHome??r})()}hasValidBasename(r,s,n){return typeof s=="string"||typeof s>"u"?this.a.then(t=>this.h(r,t,s)):this.h(r,s,n)}h(r,s,n){return r.scheme===N.Schemas.file||r.scheme===N.Schemas.vscodeRemote?(0,C.$vg)(n??(0,A.$9g)(r),s===1):!0}get defaultUriScheme(){return w.findDefaultUriScheme(this.f,this.g)}static findDefaultUriScheme(r,s){if(r.remoteAuthority)return N.Schemas.vscodeRemote;const n=(0,D.$WL)(s.getWorkspace());if(n)return n;const t=s.getWorkspace().folders[0];if(t)return t.uri.scheme;const c=s.getWorkspace().configuration;return c?c.scheme:N.Schemas.file}userHome(r){return r?.preferLocal?this.d:this.b}get resolvedUserHome(){return this.c}get path(){return this.a.then(r=>r===1?M.$fc:M.$gc)}async fileURI(r){let s="";if(await this.a===1&&(r=r.replace(/\\/g,"/")),r[0]==="/"&&r[1]==="/"){const t=r.indexOf("/",2);t===-1?(s=r.substring(2),r="/"):(s=r.substring(2,t),r=r.substring(t)||"/")}return p.URI.from({scheme:N.Schemas.file,authority:s,path:r,query:"",fragment:""})}};e.$1L=f,e.$1L=f=w=Je([We(1,d.$in),We(2,S.$IL),We(3,O.$Hi)],f)}),define(Se[120],Ie([1,0]),function(le,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.$sK=e.$rK=void 0;class C{constructor(A,p){this.line=A,this.character=p}isBefore(A){return!1}isBeforeOrEqual(A){return!1}isAfter(A){return!1}isAfterOrEqual(A){return!1}isEqual(A){return!1}compareTo(A){return 0}translate(A,p){return new C(0,0)}with(A){return new C(0,0)}}e.$rK=C;class N{constructor(A,p,m,D){this.isEmpty=!1,this.isSingleLine=!1,this.start=new C(A,p),this.end=new C(m,D)}contains(A){return!1}isEqual(A){return!1}intersection(A){}union(A){return new N(0,0,0,0)}with(A){return new N(0,0,0,0)}}e.$sK=N;var M;(function(T){T[T.Information=1]="Information",T[T.Warning=2]="Warning"})(M||(e.TextSearchCompleteMessageType=M={}))}),define(Se[48],Ie([1,0,18,37,26,49,13,3,19,14,120,11]),function(le,e,C,N,M,T,A,p,m,D,O,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$RK=e.$PK=e.$IK=e.SearchErrorCode=e.SearchSortOrder=e.ViewMode=e.$FK=e.$EK=e.$DK=e.$CK=e.SearchCompletionExitCode=e.QueryType=e.SearchProviderType=e.$yK=e.$xK=e.$wK=e.$vK=e.$uK=e.$tK=e.TextSearchCompleteMessageType=void 0,e.$zK=s,e.$AK=n,e.$BK=t,e.$GK=v,e.$HK=y,e.$JK=k,e.$KK=I,e.$LK=P,e.$MK=V,e.$NK=W,e.$OK=q,e.$QK=z,e.$SK=de,e.$TK=ye,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return O.TextSearchCompleteMessageType}}),e.$tK="workbench.view.search",e.$uK="workbench.panel.search",e.$vK="workbench.view.search",e.$wK="search-result",e.$xK="search.exclude";const d="\u27EA ",w=" characters skipped \u27EB",f=(d.length+w.length+5)*2;e.$yK=(0,p.$yi)("searchService");var o;(function(ge){ge[ge.file=0]="file",ge[ge.text=1]="text",ge[ge.aiText=2]="aiText"})(o||(e.SearchProviderType=o={}));var r;(function(ge){ge[ge.File=1]="File",ge[ge.Text=2]="Text",ge[ge.aiText=3]="aiText"})(r||(e.QueryType=r={}));function s(ge){return!!ge.preview}function n(ge){return!!ge.resource}function t(ge){return!!ge.message}var c;(function(ge){ge[ge.Normal=0]="Normal",ge[ge.NewSearchStarted=1]="NewSearchStarted"})(c||(e.SearchCompletionExitCode=c={}));class u{constructor(ue){this.resource=ue,this.results=[]}}e.$CK=u;class i{constructor(ue,Ce,se,Ne){this.ranges=Ce,this.webviewIndex=Ne;const ne=Array.isArray(Ce)?Ce:[Ce];if(se&&se.matchLines===1&&b(ne)){ue=(0,A.$4f)(ue,se.matchLines);let U="",x=0,ve=0;const Le=Math.floor(se.charsPerLine/5),ke=[];for(const be of ne){const me=Math.max(be.startColumn-Le,0),Q=be.startColumn+se.charsPerLine;if(me>ve+Le+f){const Y=d+(me-ve)+w;U+=Y+ue.slice(me,Q),x+=me-(ve+Y.length)}else U+=ue.slice(ve,Q);ke.push(new l(0,be.startColumn-x,be.endColumn-x)),ve=Q}this.preview={text:U,matches:Array.isArray(this.ranges)?ke:ke[0]}}else{const U=Array.isArray(Ce)?Ce[0].startLineNumber:Ce.startLineNumber;this.preview={text:ue,matches:(0,C.$1b)(Ce,x=>new a(x.startLineNumber-U,x.startColumn,x.endLineNumber-U,x.endColumn))}}}}e.$DK=i;function b(ge){const ue=ge[0].startLineNumber;for(const Ce of ge)if(Ce.startLineNumber!==ue||Ce.endLineNumber!==ue)return!1;return!0}class a{constructor(ue,Ce,se,Ne){this.startLineNumber=ue,this.startColumn=Ce,this.endLineNumber=se,this.endColumn=Ne}}e.$EK=a;class l extends a{constructor(ue,Ce,se){super(ue,Ce,ue,se)}}e.$FK=l;var g;(function(ge){ge.List="list",ge.Tree="tree"})(g||(e.ViewMode=g={}));var $;(function(ge){ge.Default="default",ge.FileNames="fileNames",ge.Type="type",ge.Modified="modified",ge.CountDescending="countDescending",ge.CountAscending="countAscending"})($||(e.SearchSortOrder=$={}));function v(ge,ue=!0){const Ce=ge&&ge.files&&ge.files.exclude,se=ue&&ge&&ge.search&&ge.search.exclude;if(!Ce&&!se)return;if(!Ce||!se)return Ce||se;let Ne=Object.create(null);return Ne=M.$8n(Ne,M.$5n(Ce)),Ne=M.$8n(Ne,M.$5n(se),!0),Ne}function y(ge,ue){return ge.excludePattern&&N.$rk(ge.excludePattern,ue)?!1:ge.includePattern||ge.usingSearchPaths?ge.includePattern&&N.$rk(ge.includePattern,ue)?!0:ge.usingSearchPaths?!!ge.folderQueries&&ge.folderQueries.some(Ce=>{const se=Ce.folder.fsPath;if(T.$xg(ue,se)){const Ne=m.$lc(se,ue);return!Ce.includePattern||!!N.$rk(Ce.includePattern,Ne)}else return!1}):!1:!0}var h;(function(ge){ge[ge.unknownEncoding=1]="unknownEncoding",ge[ge.regexParseError=2]="regexParseError",ge[ge.globParseError=3]="globParseError",ge[ge.invalidLiteral=4]="invalidLiteral",ge[ge.rgProcessError=5]="rgProcessError",ge[ge.other=6]="other",ge[ge.canceled=7]="canceled"})(h||(e.SearchErrorCode=h={}));class E extends Error{constructor(ue,Ce){super(ue),this.code=Ce}}e.$IK=E;function k(ge){const ue=ge.message;if((0,D.$4)(ge))return new E(ue,h.canceled);try{const Ce=JSON.parse(ue);return new E(Ce.message,Ce.code)}catch{return new E(ue,h.other)}}function I(ge){const ue={message:ge.message,code:ge.code};return new Error(JSON.stringify(ue))}function P(ge){return ge.type==="error"?!0:ge.type==="success"}function V(ge){return ge.type==="success"}function W(ge){return!!ge.path}function q(ge,ue,Ce=!0){const se=ge.searchPath?ge.searchPath:ge.relativePath;return Ce?(0,A.$1f)(se,ue):N.$rk(ue,se)}class R{constructor(ue){this.path=ue,this.results=[]}addMatch(ue){this.results.push(ue)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.$PK=R;function z(ge,ue){const Ce={...ge||{},...ue||{}};return Object.keys(Ce).filter(se=>{const Ne=Ce[se];return typeof Ne=="boolean"&&Ne})}class K{constructor(ue,Ce){this.c=null,this.a={...ue.excludePattern||{},...Ce.excludePattern||{}},this.b=N.$sk(this.a);let se=ue.includePattern;Ce.includePattern&&(se?se={...se,...Ce.includePattern}:se=Ce.includePattern),se&&(this.c=N.$sk(se))}matchesExcludesSync(ue,Ce,se){return!!(this.b&&this.b(ue,Ce,se))}includedInQuerySync(ue,Ce,se){return!(this.b&&this.b(ue,Ce,se)||this.c&&!this.c(ue,Ce,se))}includedInQuery(ue,Ce,se){const Ne=this.b(ue,Ce,se),ne=()=>this.c?!!this.c(ue,Ce,se):!0;return(0,S.$kh)(Ne)?Ne.then(U=>U?!1:ne()):ne()}hasSiblingExcludeClauses(){return ie(this.a)}}e.$RK=K;function ie(ge){for(const ue in ge)if(typeof ge[ue]!="boolean")return!0;return!1}function de(ge){if(!ge)return;let ue;return Ce=>(ue||(ue=(ge()||Promise.resolve([])).then(se=>se?De(se):{})),ue.then(se=>!!se[Ce]))}function ye(ge){if(!ge)return;let ue;return Ce=>{if(!ue){const se=ge();ue=se?De(se):{}}return!!ue[Ce]}}function De(ge){const ue={};for(const Ce of ge)ue[Ce]=!0;return ue}}),define(Se[39],Ie([1,0,18,11,20,5,6,54,16,129,24,13,2,183,3,12,202,46,47,27,17,8,7,61,48,4,45]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u,i,b,a,l,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rmc=e.$qmc=void 0;function $(V,W,q){return new O.$1g(R=>E(R,q)).isEqual(V,W)}function v(V,W,q){return $(V.uri,W.uri,q)?0:(0,S.$sf)(V.uri.toString(),W.uri.toString())}function y(V,W,q){return V.index!==W.index?V.index<W.index?-1:1:$(V.uri,W.uri,q)?(0,S.$sf)(V.name,W.name):(0,S.$sf)(V.uri.toString(),W.uri.toString())}function h(V,W,q,R){const z=V.slice(0).sort((ie,de)=>q(ie,de,R)),K=W.slice(0).sort((ie,de)=>q(ie,de,R));return(0,C.$Eb)(z,K,(ie,de)=>q(ie,de,R))}function E(V,W){const q=W.getCapabilities(V.scheme);return!(q&&q&1024)}class k extends s.$Ri{static toExtHostWorkspace(W,q,R,z){if(!W)return{workspace:null,added:[],removed:[]};const{id:K,name:ie,folders:de,configuration:ye,transient:De,isUntitled:ge}=W,ue=[],Ce=q;q?de.forEach((U,x)=>{const ve=d.URI.revive(U.uri),Le=k.o(R||q,ve,z);Le?(Le.name=U.name,Le.index=U.index,ue.push(Le)):ue.push({uri:ve,name:U.name,index:x})}):ue.push(...de.map(({uri:U,name:x,index:ve})=>({uri:d.URI.revive(U),name:x,index:ve}))),ue.sort((U,x)=>U.index<x.index?-1:1);const se=new k(K,ie,ue,!!De,ye?d.URI.revive(ye):null,!!ge,U=>E(U,z)),{added:Ne,removed:ne}=h(Ce?Ce.workspaceFolders:[],se.workspaceFolders,v,z);return{workspace:se,added:Ne,removed:ne}}static o(W,q,R){for(let z=0;z<W.folders.length;z++){const K=W.workspaceFolders[z];if($(K.uri,q,R))return K}}constructor(W,q,R,z,K,ie,de){super(W,R.map(ye=>new s.$Si(ye)),z,K,de),this.t=q,this.u=ie,this.q=[],this.s=p.$Ei.forUris(de),R.forEach(ye=>{this.q.push(ye),this.s.set(ye.uri,ye)})}get name(){return this.t}get isUntitled(){return this.u}get workspaceFolders(){return this.q.slice(0)}getWorkspaceFolder(W,q){return q&&this.s.get(W)&&(W=(0,O.$$g)(W)),this.s.findSubstr(W)}resolveWorkspaceFolder(W){return this.s.get(W)}}let I=class{constructor(W,q,R,z,K){this.c=new T.$fe,this.onDidChangeWorkspace=this.c.event,this.g=new T.$fe,this.onDidGrantWorkspaceTrust=this.g.event,this.u=[],this.v=!1,this.w=new Map,this.A=0,this.B=new T.$he,this.C=new Map,this.h=z,this.s=R,this.t=K,this.j=new D.$Fm,this.k=new N.$xh,this.o=W.getProxy(l.$lM.MainThreadWorkspace),this.q=W.getProxy(l.$lM.MainThreadMessageService);const ie=q.workspace;this.l=ie?new k(ie.id,ie.name,[],!!ie.transient,ie.configuration?d.URI.revive(ie.configuration):null,!!ie.isUntitled,de=>E(de,R)):void 0}$initializeWorkspace(W,q){this.v=q,this.$acceptWorkspaceData(W),this.k.open()}waitForInitializeCall(){return this.k.wait()}get workspace(){return this.x}get name(){return this.x?this.x.name:void 0}get workspaceFile(){if(this.x&&this.x.configuration)return this.x.isUntitled?d.URI.from({scheme:m.Schemas.untitled,path:(0,O.$9g)((0,O.$$g)(this.x.configuration))}):this.x.configuration}get x(){return this.n||this.l}getWorkspaceFolders(){if(this.x)return this.x.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this.k.wait(),!!this.x)return this.x.workspaceFolders.slice(0)}updateWorkspaceFolders(W,q,R,...z){const K=[];if(Array.isArray(z)&&z.forEach(ge=>{d.URI.isUri(ge.uri)&&!K.some(ue=>$(ue.uri,ge.uri,this.s))&&K.push({uri:ge.uri,name:ge.name||(0,O.$8g)(ge.uri)})}),this.n||[q,R].some(ge=>typeof ge!="number"||ge<0)||R===0&&K.length===0)return!1;const ie=this.x?this.x.workspaceFolders:[];if(q+R>ie.length)return!1;const de=ie.slice(0);de.splice(q,R,...K.map(ge=>({uri:ge.uri,name:ge.name||(0,O.$8g)(ge.uri),index:void 0})));for(let ge=0;ge<de.length;ge++){const ue=de[ge];if(de.some((Ce,se)=>se!==ge&&$(ue.uri,Ce.uri,this.s)))return!1}de.forEach((ge,ue)=>ge.index=ue);const{added:ye,removed:De}=h(ie,de,y,this.s);if(ye.length===0&&De.length===0)return!1;if(this.o){const ge=W.displayName||W.name;this.o.$updateWorkspaceFolders(ge,q,R,K).then(void 0,ue=>{this.n=void 0;const Ce={source:{identifier:W.identifier,label:W.displayName||W.name}};this.q.$showMessage(r.Severity.Error,(0,w.localize)(0,null,ge,ue.toString()),Ce,[])})}return this.y(de),!0}getWorkspaceFolder(W,q){if(this.x)return this.x.getWorkspaceFolder(W,q)}async getWorkspaceFolder2(W,q){if(await this.k.wait(),!!this.x)return this.x.getWorkspaceFolder(W,q)}async resolveWorkspaceFolder(W){if(await this.k.wait(),!!this.x)return this.x.resolveWorkspaceFolder(W)}getPath(){if(!this.x)return;const{folders:W}=this.x;if(W.length!==0)return W[0].uri.fsPath}getRelativePath(W,q){let R,z="";if(typeof W=="string"?(R=d.URI.file(W),z=W):typeof W<"u"&&(R=W,z=W.fsPath),!R)return z;const K=this.getWorkspaceFolder(R,!0);if(!K)return z;typeof q>"u"&&this.x&&(q=this.x.folders.length>1);let ie=(0,O.$bh)(K.uri,R);return q&&K.name&&(ie=`${K.name}/${ie}`),ie}y(W){this.x&&(this.n=k.toExtHostWorkspace({id:this.x.id,name:this.x.name,configuration:this.x.configuration,folders:W,isUntitled:this.x.isUntitled},this.x,void 0,this.s).workspace||void 0)}$acceptWorkspaceData(W){const{workspace:q,added:R,removed:z}=k.toExtHostWorkspace(W,this.l,this.n,this.s);this.l=q||void 0,this.n=void 0,this.c.fire(Object.freeze({added:R,removed:z}))}findFiles(W,q,R,z,K=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${z.value}, entryPoint: findFiles`);let ie="",de=!0;return q===null?de=!1:q!==void 0&&(typeof q=="string"?ie=q:ie=q.pattern),this.z(W,void 0,{exclude:ie,maxResults:R,useDefaultExcludes:de,useDefaultSearchExcludes:!1,useIgnoreFiles:!1},K)}findFiles2(W,q={},R,z=M.CancellationToken.None){return this.h.trace(`extHostWorkspace#findFiles2: fileSearch, extension: ${R.value}, entryPoint: findFiles2`),this.z(void 0,W,q,z)}async z(W,q,R,z=M.CancellationToken.None){if(z&&z.isCancellationRequested)return Promise.resolve([]);const K=typeof R.exclude=="string"?R.exclude:R.exclude?R.exclude.pattern:void 0,ie={ignoreSymlinks:typeof R.followSymlinks=="boolean"?!R.followSymlinks:void 0,disregardIgnoreFiles:typeof R.useIgnoreFiles=="boolean"?!R.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof R.useGlobalIgnoreFiles=="boolean"?!R.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof R.useParentIgnoreFiles=="boolean"?!R.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof R.useDefaultExcludes=="boolean"?!R.useDefaultExcludes:!1,disregardSearchExcludeSettings:typeof R.useDefaultSearchExcludes=="boolean"?!R.useDefaultSearchExcludes:!1,maxResults:R.maxResults,excludePattern:K,shouldGlobSearch:typeof R.fuzzy=="boolean"?!R.fuzzy:!0,_reason:"startFileSearch"};let de;if(W){const{includePattern:ye,folder:De}=P(u.GlobPattern.from(W));de=De,ie.includePattern=ye}else{const{includePattern:ye,folder:De}=P(u.GlobPattern.from(q));de=De,ie.filePattern=ye}return this.o.$startFileSearch(de??null,ie,z).then(ye=>Array.isArray(ye)?ye.map(De=>d.URI.revive(De)):[])}async findTextInFiles(W,q,R,z,K=M.CancellationToken.None){this.h.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${z.value}, entryPoint: findTextInFiles`);const ie=this.j.getNext(),de=typeof q.previewOptions>"u"?{matchLines:100,charsPerLine:1e4}:q.previewOptions,{includePattern:ye,folder:De}=P(u.GlobPattern.from(q.include)),ge=typeof q.exclude=="string"?q.exclude:q.exclude?q.exclude.pattern:void 0,ue={ignoreSymlinks:typeof q.followSymlinks=="boolean"?!q.followSymlinks:void 0,disregardIgnoreFiles:typeof q.useIgnoreFiles=="boolean"?!q.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof q.useGlobalIgnoreFiles=="boolean"?!q.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof q.useParentIgnoreFiles=="boolean"?!q.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof q.useDefaultExcludes=="boolean"?!q.useDefaultExcludes:!0,fileEncoding:q.encoding,maxResults:q.maxResults,previewOptions:de,afterContext:q.afterContext,beforeContext:q.beforeContext,includePattern:ye,excludePattern:ge},Ce=!1;if(this.u[ie]=se=>{if(Ce)return;const Ne=d.URI.revive(se.resource);se.results.forEach(ne=>{const U=(0,g.$8h)(ne);(0,a.$zK)(U)?R({uri:Ne,preview:{text:U.preview.text,matches:(0,C.$1b)(U.preview.matches,x=>new i.$pM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))},ranges:(0,C.$1b)(U.ranges,x=>new i.$pM(x.startLineNumber,x.startColumn,x.endLineNumber,x.endColumn))}):R({uri:Ne,text:U.text,lineNumber:U.lineNumber})})},K.isCancellationRequested)return{};try{const se=await this.o.$startTextSearch(W,De??null,ue,ie,K);return delete this.u[ie],se||{}}catch(se){throw delete this.u[ie],se}}$handleTextSearchResult(W,q){this.u[q]?.(W)}async save(W){const q=await this.o.$save(W,{saveAs:!1});return d.URI.revive(q)}async saveAs(W){const q=await this.o.$save(W,{saveAs:!0});return d.URI.revive(q)}saveAll(W){return this.o.$saveAll(W)}resolveProxy(W){return this.o.$resolveProxy(W)}loadCertificates(){return this.o.$loadCertificates()}get trusted(){return this.v}requestWorkspaceTrust(W){return this.o.$requestWorkspaceTrust(W)}$onDidGrantWorkspaceTrust(){this.v||(this.v=!0,this.g.fire())}registerEditSessionIdentityProvider(W,q){if(this.w.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.w.set(W,q);const R=this.t.transformOutgoingScheme(W),z=this.A++;return this.o.$registerEditSessionIdentityProvider(z,R),(0,A.$Sc)(()=>{this.w.delete(W),this.o.$unregisterEditSessionIdentityProvider(z)})}async $getEditSessionIdentifier(W,q){this.h.info("Getting edit session identifier for workspaceFolder",W);const R=await this.resolveWorkspaceFolder(d.URI.revive(W));if(!R){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",R);const z=this.w.get(R.uri.scheme);if(this.h.info(`Provider for scheme ${R.uri.scheme} is defined: `,!!z),!z)return;const K=await z.provideEditSessionIdentity(R,q);if(this.h.info("Provider returned edit session identifier: ",K),!!K)return K}async $provideEditSessionIdentityMatch(W,q,R,z){this.h.info("Getting edit session identifier for workspaceFolder",W);const K=await this.resolveWorkspaceFolder(d.URI.revive(W));if(!K){this.h.warn("Unable to resolve workspace folder");return}this.h.info("Invoking #provideEditSessionIdentity for workspaceFolder",K);const ie=this.w.get(K.uri.scheme);if(this.h.info(`Provider for scheme ${K.uri.scheme} is defined: `,!!ie),!ie)return;const de=await ie.provideEditSessionIdentityMatch?.(q,R,z);if(this.h.info("Provider returned edit session identifier match result: ",de),!!de)return de}getOnWillCreateEditSessionIdentityEvent(W){return(q,R,z)=>{const K=function(de){q.call(R,de)};return K.extension=W,this.B.event(K,void 0,z)}}async $onWillCreateEditSessionIdentity(W,q,R){const z=await this.resolveWorkspaceFolder(d.URI.revive(W));if(z===void 0)throw new Error("Unable to resolve workspace folder");await this.B.fireAsync({workspaceFolder:z},q,async(K,ie)=>{const de=Date.now();await Promise.resolve(K),Date.now()-de>R&&this.h.warn("SLOW edit session create-participant",ie.extension.identifier)}),q.isCancellationRequested}registerCanonicalUriProvider(W,q){if(this.C.has(W))throw new Error(`A provider has already been registered for scheme ${W}`);this.C.set(W,q);const R=this.t.transformOutgoingScheme(W),z=this.A++;return this.o.$registerCanonicalUriProvider(z,R),(0,A.$Sc)(()=>{this.C.delete(W),this.o.$unregisterCanonicalUriProvider(z)})}async provideCanonicalUri(W,q,R){const z=this.C.get(W.scheme);if(!z)return;const K=await z.provideCanonicalUri?.(d.URI.revive(W),q,R);if(K)return K}async $provideCanonicalUri(W,q,R){return this.provideCanonicalUri(d.URI.revive(W),{targetScheme:q},R)}};e.$qmc=I,e.$qmc=I=Je([We(0,c.$PO),We(1,t.$6O),We(2,n.$_lc),We(3,o.$5j),We(4,b.$omc)],I),e.$rmc=(0,f.$yi)("IExtHostWorkspace");function P(V){let W,q;return V&&(typeof V=="string"?W=V:(W=V.pattern,q=d.URI.revive(V.baseUri))),{includePattern:W,folder:q}}}),define(Se[40],Ie([1,0,26,5,39,4,7,203,51,15,11,3,17,12,2]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$umc=e.$tmc=e.$smc=void 0;function o(b,a){if(a){const l=a.split(".");let g=b;for(let $=0;g&&$<l.length;$++)g=g[l[$]];return g}}function r(b){return b instanceof f.URI}function s(b){return b&&b.uri instanceof f.URI&&b.languageId&&typeof b.languageId=="string"}function n(b){return b&&!b.uri&&b.languageId&&typeof b.languageId=="string"}function t(b){return b&&b.uri instanceof f.URI&&(!b.name||typeof b.name=="string")&&(!b.index||typeof b.index=="number")}function c(b){if(r(b))return{resource:b};if(s(b))return{resource:b.uri,overrideIdentifier:b.languageId};if(n(b))return{overrideIdentifier:b.languageId};if(t(b))return{resource:b.uri};if(b===null)return{resource:null}}let u=class{constructor(a,l,g){this.a=a.getProxy(T.$lM.MainThreadConfiguration),this.c=l,this.b=g,this.d=new O.$xh,this.e=null}getConfigProvider(){return this.d.wait().then(a=>this.e)}$initializeConfiguration(a){this.e=new i(this.a,this.c,a,this.b),this.d.open()}$acceptConfigurationChanged(a,l){this.getConfigProvider().then(g=>g.$acceptConfigurationChanged(a,l))}};e.$smc=u,e.$smc=u=Je([We(0,d.$PO),We(1,M.$rmc),We(2,w.$5j)],u);class i{constructor(a,l,g,$){this.a=new N.$fe,this.b=a,this.f=$,this.c=l,this.e=p.$Do.parse(g,$),this.d=this.k(g.configurationScopes)}get onDidChangeConfiguration(){return this.a&&this.a.event}$acceptConfigurationChanged(a,l){const g={data:this.e.toData(),workspace:this.c.workspace};this.e=p.$Do.parse(a,this.f),this.d=this.k(a.configurationScopes),this.a.fire(this.j(l,g))}getConfiguration(a,l,g){const $=c(l)||{},v=this.g(a?o(this.e.getValue(void 0,$,this.c.workspace),a):this.e.getValue(void 0,$,this.c.workspace));a&&this.h(a,$,g?.identifier);function y(E){if(E==null)return null;if(typeof E=="boolean")return E?2:5;switch(E){case A.ConfigurationTarget.Global:return 2;case A.ConfigurationTarget.Workspace:return 5;case A.ConfigurationTarget.WorkspaceFolder:return 6}}const h={has(E){return typeof o(v,E)<"u"},get:(E,k)=>{this.h(a?`${a}.${E}`:E,$,g?.identifier);let I=o(v,E);if(typeof I>"u")I=k;else{let P;const V=(W,q)=>{if((0,D.$ag)(W)){let R;const z=()=>{P=P||(0,C.$5n)(v),R=R||o(P,q)};return new Proxy(W,{get:(K,ie)=>{if(typeof ie=="string"&&ie.toLowerCase()==="tojson")return z(),()=>R;if(P)return R=R||o(P,q),R[ie];const de=K[ie];return typeof ie=="string"?V(de,`${q}.${ie}`):de},set:(K,ie,de)=>(z(),R&&(R[ie]=de),!0),deleteProperty:(K,ie)=>(z(),R&&delete R[ie],!0),defineProperty:(K,ie,de)=>(z(),R&&Object.defineProperty(R,ie,de),!0)})}return Array.isArray(W)?(0,C.$5n)(W):W};I=V(I,E)}return I},update:(E,k,I,P)=>{E=a?`${a}.${E}`:E;const V=y(I);return k!==void 0?this.b.$updateConfigurationOption(V,E,k,$,P):this.b.$removeConfigurationOption(V,E,$,P)},inspect:E=>{E=a?`${a}.${E}`:E;const k=this.e.inspect(E,$,this.c.workspace);if(k)return{key:E,defaultValue:(0,C.$5n)(k.policy?.value??k.default?.value),globalValue:(0,C.$5n)(k.user?.value??k.application?.value),workspaceValue:(0,C.$5n)(k.workspace?.value),workspaceFolderValue:(0,C.$5n)(k.workspaceFolder?.value),defaultLanguageValue:(0,C.$5n)(k.default?.override),globalLanguageValue:(0,C.$5n)(k.user?.override??k.application?.override),workspaceLanguageValue:(0,C.$5n)(k.workspace?.override),workspaceFolderLanguageValue:(0,C.$5n)(k.workspaceFolder?.override),languageIds:(0,C.$5n)(k.overrideIdentifiers)}}};return typeof v=="object"&&(0,C.$8n)(h,v,!1),Object.freeze(h)}g(a){const l=g=>(0,D.$ag)(g)?new Proxy(g,{get:($,v)=>l($[v]),set:($,v,y)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(v)}' of object`)},deleteProperty:($,v)=>{throw new Error(`TypeError: Cannot delete read only property '${String(v)}' of object`)},defineProperty:($,v)=>{throw new Error(`TypeError: Cannot define property '${String(v)}' for a readonly object`)},setPrototypeOf:$=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):g;return l(a)}h(a,l,g){const $=m.$uo.test(a)?4:this.d.get(a),v=g?`[${g.value}] `:"";if($===4){typeof l?.resource>"u"&&this.f.warn(`${v}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${a}', provide the URI of a resource or 'null' for any resource.`);return}if($===3){l?.resource&&this.f.warn(`${v}Accessing a window scoped configuration for a resource is not expected. To associate '${a}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}j(a,l){const g=new p.$Fo(a,l,this.e,this.c.workspace,this.f);return Object.freeze({affectsConfiguration:($,v)=>g.affectsConfiguration($,c(v))})}k(a){return a.reduce((l,g)=>(l.set(g[0],g[1]),l),new Map)}}e.$tmc=i,e.$umc=(0,S.$yi)("IExtHostConfiguration")}),define(Se[121],Ie([1,0,2,11,5,4,7,39,68,40,20,53,17,27,3,16,23,12,80,241,14]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Ync=e.$Xnc=e.$Wnc=e.TaskDTO=e.TaskHandleDTO=e.CustomExecutionDTO=void 0;var u;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(u||(u={}));var i;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(i||(i={}));var b;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(b||(b={}));var a;(function(V){function W(z){if(z){const K=z;return K&&!!K.process}else return!1}V.is=W;function q(z){if(z==null)return;const K={process:z.process,args:z.args};return z.options&&(K.options=b.from(z.options)),K}V.from=q;function R(z){if(z!=null)return new A.$0M(z.process,z.args,z.options)}V.to=R})(a||(a={}));var l;(function(V){function W(R){if(R!=null)return R}V.from=W;function q(R){if(R!=null)return R}V.to=q})(l||(l={}));var g;(function(V){function W(z){if(z){const K=z;return K&&(!!K.commandLine||!!K.command)}else return!1}V.is=W;function q(z){if(z==null)return;const K={};return z.commandLine!==void 0?K.commandLine=z.commandLine:(K.command=z.command,K.args=z.args),z.options&&(K.options=l.from(z.options)),K}V.from=q;function R(z){if(!(z==null||z.command===void 0&&z.commandLine===void 0))return z.commandLine?new A.$$M(z.commandLine,z.options):new A.$$M(z.command,z.args?z.args:[],z.options)}V.to=R})(g||(g={}));var $;(function(V){function W(z){if(z){const K=z;return K&&K.customExecution==="customExecution"}else return!1}V.is=W;function q(z){return{customExecution:"customExecution"}}V.from=q;function R(z,K){return K.get(z)}V.to=R})($||(e.CustomExecutionDTO=$={}));var v;(function(V){function W(q,R){let z;return q.scope!==void 0&&typeof q.scope!="number"?z=q.scope.uri:q.scope!==void 0&&typeof q.scope=="number"&&(q.scope===A.TaskScope.Workspace&&R&&R.workspaceFile?z=R.workspaceFile:z=t.$lI),{id:q._id,workspaceFolder:z}}V.from=W})(v||(e.TaskHandleDTO=v={}));var y;(function(V){function W(q){if(q!=null)return{_id:q.id,isDefault:q.isDefault}}V.from=W})(y||(y={}));var h;(function(V){function W(z,K){if(z==null)return[];const ie=[];for(const de of z){const ye=q(de,K);ye&&ie.push(ye)}return ie}V.fromMany=W;function q(z,K){if(z==null)return;let ie;z.execution instanceof A.$0M?ie=a.from(z.execution):z.execution instanceof A.$$M?ie=g.from(z.execution):z.execution&&z.execution instanceof A.$_M&&(ie=$.from(z.execution));const de=u.from(z.definition);let ye;return z.scope?typeof z.scope=="number"?ye=z.scope:ye=z.scope.uri:ye=A.TaskScope.Workspace,!de||!ye?void 0:{_id:z._id,definition:de,name:z.name,source:{extensionId:K.identifier.value,label:z.source,scope:ye},execution:ie,isBackground:z.isBackground,group:y.from(z.group),presentationOptions:i.from(z.presentationOptions),problemMatchers:z.problemMatchers,hasDefinedMatchers:z.hasDefinedMatchers,runOptions:z.runOptions?z.runOptions:{reevaluateOnRerun:!0},detail:z.detail}}V.from=q;async function R(z,K,ie){if(z==null)return;let de;a.is(z.execution)?de=a.to(z.execution):g.is(z.execution)?de=g.to(z.execution):$.is(z.execution)&&(de=$.to(z._id,ie));const ye=u.to(z.definition);let De;if(z.source&&(z.source.scope!==void 0?typeof z.source.scope=="number"?De=z.source.scope:De=await K.resolveWorkspaceFolder(C.URI.revive(z.source.scope)):De=A.TaskScope.Workspace),!ye||!De)return;const ge=new A.$aN(ye,De,z.name,z.source.label,de,z.problemMatchers);return z.isBackground!==void 0&&(ge.isBackground=z.isBackground),z.group!==void 0&&(ge.group=A.$9M.from(z.group._id),ge.group&&z.group.isDefault&&(ge.group=new A.$9M(ge.group.id,ge.group.label),z.group.isDefault===!0&&(ge.group.isDefault=z.group.isDefault))),z.presentationOptions&&(ge.presentationOptions=i.to(z.presentationOptions)),z._id&&(ge._id=z._id),z.detail&&(ge.detail=z.detail),ge}V.to=R})(h||(e.TaskDTO=h={}));var E;(function(V){function W(R){return R}V.from=W;function q(R){if(R)return Object.assign(Object.create(null),R)}V.to=q})(E||(E={}));class k{#e;constructor(W,q,R){this._id=q,this.a=R,this.#e=W}get task(){return this.a}terminate(){this.#e.terminateTask(this)}fireDidStartProcess(W){}fireDidEndProcess(W){}}let I=class{constructor(W,q,R,z,K,ie,de,ye){this.q=new M.$fe,this.r=new M.$fe,this.s=new M.$fe,this.u=new M.$fe,this.a=W.getProxy(T.$lM.MainThreadTask),this.b=R,this.c=z,this.d=K,this.e=ie,this.h=0,this.j=new Map,this.k=new Map,this.l=new Map,this.m=new Map,this.n=new Set,this.o=new Map,this.f=de,this.g=ye,this.a.$registerSupportedExecutions(!0)}registerTaskProvider(W,q,R){if(!R)return new A.$nM(()=>{});const z=this.x();return this.j.set(z,{type:q,provider:R,extension:W}),this.a.$registerTaskProvider(z,q),new A.$nM(()=>{this.j.delete(z),this.a.$unregisterTaskProvider(z)})}registerTaskSystem(W,q){this.a.$registerTaskSystem(W,q)}fetchTasks(W){return this.a.$fetchTasks(E.from(W)).then(async q=>{const R=[];for(const z of q){const K=await h.to(z,this.b,this.m);K&&R.push(K)}return R})}get taskExecutions(){const W=[];return this.k.forEach(q=>W.push(q)),W}terminateTask(W){if(!(W instanceof k))throw new Error("No valid task execution provided");return this.a.$terminateTask(W._id)}get onDidStartTask(){return this.q.event}async $onDidStartTask(W,q,R){const z=this.m.get(W.id);z&&(this.o.set(W.id,z),this.e.attachPtyToTerminal(q,await z.callback(R))),this.p=W.id,this.q.fire({execution:await this.z(W)})}get onDidEndTask(){return this.r.event}async $OnDidEndTask(W){if(!this.l.has(W.id))return;const q=await this.z(W);this.l.delete(W.id),this.k.delete(W.id),this.B(W),this.r.fire({execution:q})}get onDidStartTaskProcess(){return this.s.event}async $onDidStartTaskProcess(W){const q=await this.z(W.id);this.s.fire({execution:q,processId:W.processId})}get onDidEndTaskProcess(){return this.u.event}async $onDidEndTaskProcess(W){const q=await this.z(W.id);this.u.fire({execution:q,exitCode:W.exitCode})}$provideTasks(W,q){const R=this.j.get(W);if(!R)return Promise.reject(new Error("no handler found"));const z=[],K=(0,N.$qh)(()=>R.provider.provideTasks(O.CancellationToken.None)).then(ie=>this.v(q,z,R,ie));return new Promise(ie=>{K.then(de=>{Promise.all(z).then(()=>{ie(de)})})})}async $resolveTask(W,q){const R=this.j.get(W);if(!R)return Promise.reject(new Error("no handler found"));if(q.definition.type!==R.type)throw new Error(`Unexpected: Task of type [${q.definition.type}] cannot be resolved by provider of type [${R.type}].`);const z=await h.to(q,this.b,this.m);if(!z)throw new Error("Unexpected: Task cannot be resolved.");const K=await R.provider.resolveTask(z,O.CancellationToken.None);if(!K)return;this.A(K,R);const ie=h.from(K,R.extension);if(!ie)throw new Error("Unexpected: Task cannot be resolved.");if(K.definition!==z.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return $.is(ie.execution)&&await this.y(ie,K,!0),await this.w(ie)}x(){return this.h++}async y(W,q,R){const z=await this.a.$createTaskId(W);!R&&!this.m.has(z)&&(this.n.add(z),this.o.set(z,q.execution)),this.m.set(z,q.execution)}async z(W,q){if(typeof W=="string"){const K=this.l.get(W);if(!K)throw new c.$bb("Unexpected: The specified task is missing an execution");return K}const R=this.l.get(W.id);if(R)return R;let z;return q?z=Promise.resolve(new k(this,W.id,q)):z=h.to(W.task,this.b,this.m).then(K=>{if(!K)throw new c.$bb("Unexpected: Task does not exist.");return new k(this,W.id,K)}),this.l.set(W.id,z),z.then(K=>(this.k.set(W.id,K),K))}A(W,q){W._deprecated&&this.g.report("Task.constructor",q.extension,"Use the Task constructor that takes a `scope` instead.")}B(W){this.o.get(W.id)&&this.o.delete(W.id),this.n.has(W.id)&&this.p!==W.id&&(this.m.delete(W.id),this.n.delete(W.id));const R=this.n.values();let z=R.next();for(;!z.done;)!this.o.has(z.value)&&this.p!==z.value&&(this.m.delete(z.value),this.n.delete(z.value)),z=R.next()}};e.$Wnc=I,e.$Wnc=I=Je([We(0,d.$PO),We(1,w.$6O),We(2,p.$rmc),We(3,m.$1O),We(4,D.$umc),We(5,S.$Smc),We(6,s.$5j),We(7,n.$8lc)],I);let P=class extends I{constructor(W,q,R,z,K,ie,de,ye){super(W,q,R,z,K,ie,de,ye),this.registerTaskSystem(o.Schemas.vscodeRemote,{scheme:o.Schemas.vscodeRemote,authority:"",platform:r.$h(0)})}async executeTask(W,q){if(!q.execution)throw new Error("Tasks to execute must include an execution");const R=h.from(q,W);if(R===void 0)throw new Error("Task is not valid");if($.is(R.execution))await this.y(R,q,!1);else throw new c.$_;const z=await this.z(await this.a.$getTaskExecution(R),q);return this.a.$executeTask(R).catch(K=>{throw new Error(K)}),z}v(W,q,R,z){const K=[];if(z)for(const ie of z){if(this.A(ie,R),!ie.definition||!W[ie.definition.type]){const ye=ie.source?ie.source:"No task source";this.f.warn(`The task [${ye}, ${ie.name}] uses an undefined task type. The task will be ignored in the future.`)}const de=h.from(ie,R.extension);de&&$.is(de.execution)?(K.push(de),q.push(this.y(de,ie,!0))):this.f.warn("Only custom execution tasks supported.")}return{tasks:K,extension:R.extension}}async w(W){if($.is(W.execution))return W;this.f.warn("Only custom execution tasks supported.")}async $resolveVariables(W,q){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(W,q,R){}};e.$Xnc=P,e.$Xnc=P=Je([We(0,d.$PO),We(1,w.$6O),We(2,p.$rmc),We(3,m.$1O),We(4,D.$umc),We(5,S.$Smc),We(6,s.$5j),We(7,n.$8lc)],P),e.$Ync=(0,f.$yi)("IExtHostTask")}),define(Se[299],Ie([1,0,48,30]),function(le,e,C,N){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$1K=void 0,e.$ZK=M,e.$2K=T;function M(A){return"cellResults"in A}e.$1K="rawCell#";function T(A,p){let m=-1;const D=[];let O=[];return A.forEach(d=>{d.range.startLineNumber!==m&&O.length>0&&(D.push([...O]),O=[]),O.push(d),m=d.range.endLineNumber}),O.length>0&&D.push([...O]),D.map(d=>{const w=[],f=d[0].range.startLineNumber,o=d[d.length-1].range.endLineNumber;for(let r=f;r<=o;r++)w.push(p.getLineContent(r));return new C.$DK(w.join(`
`)+`
`,d.map(r=>new N.$zt(r.range.startLineNumber-1,r.range.startColumn-1,r.range.endLineNumber-1,r.range.endColumn-1)))})}}),define(Se[300],Ie([1,0,177,22,5,6,28,13,15,2,38,76,4,35,8,7,34,276,114,26,16,231,299,297]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u,i,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$znc=void 0;class a{static{this.a=0}get activeNotebookEditor(){return this.k?.apiEditor}get visibleNotebookEditors(){return this.l.map(g=>g.apiEditor)}constructor(g,$,v,y,h,E){this.q=v,this.r=y,this.s=h,this.t=E,this.f=new Map,this.g=new A.$Ac,this.h=new Map,this.j=new M.$fe,this.onDidChangeActiveNotebookEditor=this.j.event,this.l=[],this.m=new M.$fe,this.onDidOpenNotebookDocument=this.m.event,this.n=new M.$fe,this.onDidCloseNotebookDocument=this.n.event,this.o=new M.$fe,this.onDidChangeVisibleNotebookEditors=this.o.event,this.p=new S.$6lc("NotebookCellStatusBarCache"),this.w=0,this.x=new Map,this.b=g.getProxy(d.$lM.MainThreadNotebook),this.c=g.getProxy(d.$lM.MainThreadNotebookDocuments),this.d=g.getProxy(d.$lM.MainThreadNotebookEditors),this.i=$.converter,$.registerArgumentProcessor({processArgument:k=>{if(k&&k.$mid===13){const I=k.notebookEditor?.notebookUri,P=k.cell.handle,W=this.g.get(I)?.getCell(P);if(W)return W.apiCell}if(k&&k.$mid===14){const I=k.uri,P=this.g.get(I);if(P)return P.apiNotebook}return k}}),a.B($)}getEditorById(g){const $=this.h.get(g);if(!$)throw new Error(`unknown text editor: ${g}. known editors: ${[...this.h.keys()]} `);return $}getIdByEditor(g){for(const[$,v]of this.h)if(v.apiEditor===g)return $}get notebookDocuments(){return[...this.g.values()]}getNotebookDocument(g,$){const v=this.g.get(g);if(!v&&!$)throw new Error(`NO notebook document for '${g}'`);return v}static u(g,$){if(!$)return;const v=$.filenamePattern.map(y=>f.NotebookExclusiveDocumentPattern.from(y)).filter(y=>y!==void 0);if($.filenamePattern&&!v){console.warn(`Notebook content provider view options file name pattern is invalid ${$.filenamePattern}`);return}return{extension:g.identifier,providerDisplayName:g.displayName||g.name,displayName:$.displayName,filenamePattern:v,exclusive:$.exclusive||!1}}registerNotebookCellStatusBarItemProvider(g,$,v){const y=a.a++,h=typeof v.onDidChangeCellStatusBarItems=="function"?a.a++:void 0;this.f.set(y,v),this.b.$registerNotebookCellStatusBarItemProvider(y,h,$);let E;return h!==void 0&&(E=v.onDidChangeCellStatusBarItems(k=>this.b.$emitCellStatusBarEvent(h))),new o.$nM(()=>{this.f.delete(y),this.b.$unregisterNotebookCellStatusBarItemProvider(y,h),E?.dispose()})}async createNotebookDocument(g){const $=await this.c.$tryCreateNotebook({viewType:g.viewType,content:g.content&&f.NotebookData.from(g.content)});return D.URI.revive($)}async openNotebookDocument(g){const $=this.g.get(g);if($)return $.apiNotebook;const v=await this.c.$tryOpenNotebook(g),y=this.g.get(D.URI.revive(v));return(0,m.$jg)(y?.apiNotebook)}async showNotebookDocument(g,$){D.URI.isUri(g)&&(g=await this.openNotebookDocument(g));let v;typeof $=="object"?v={position:f.ViewColumn.from($.viewColumn),preserveFocus:$.preserveFocus,selections:$.selections&&$.selections.map(f.NotebookRange.from),pinned:typeof $.preview=="boolean"?!$.preview:void 0}:v={preserveFocus:!1};const y=await this.d.$tryShowNotebookDocument(g.uri,g.notebookType,v),h=y&&this.h.get(y)?.apiEditor;if(h)return h;throw y?new Error(`Could NOT open editor for "${g.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${g.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(g,$,v,y){const h=this.f.get(g),E=D.URI.revive($),k=this.g.get(E);if(!k||!h)return;const I=k.getCellFromIndex(v);if(!I)return;const P=await h.provideCellStatusBarItems(I.apiCell,y);if(!P)return;const V=new T.$Tc,W=this.p.add([V]),R=(Array.isArray(P)?P:[P]).map(z=>f.NotebookStatusBarItem.from(z,this.i,V));return{cacheId:W,items:R}}$releaseNotebookCellStatusBarItems(g){this.p.delete(g)}registerNotebookSerializer(g,$,v,y,h){if((0,p.$9e)($))throw new Error("viewType cannot be empty or just whitespace");const E=this.w++;return this.x.set(E,{viewType:$,serializer:v,options:y}),this.b.$registerNotebookSerializer(E,{id:g.identifier,location:g.extensionLocation},$,f.NotebookDocumentContentOptions.from(y),a.u(g,h)),(0,T.$Sc)(()=>{this.b.$unregisterNotebookSerializer(E)})}async $dataToNotebook(g,$,v){const y=this.x.get(g);if(!y)throw new Error("NO serializer found");const h=await y.serializer.deserializeNotebook($.buffer,v);return new r.$Gw(f.NotebookData.from(h))}async $notebookToData(g,$,v){const y=this.x.get(g);if(!y)throw new Error("NO serializer found");const h=await y.serializer.serializeNotebook(f.NotebookData.to($.value),v);return N.$He.wrap(h)}async $saveNotebook(g,$,v,y,h){const E=D.URI.revive($),k=this.x.get(g);if(!k)throw new Error("NO serializer found");const I=this.g.get(E);if(!I)throw new Error("Document NOT found");if(I.versionId!==v)throw new Error("Document version mismatch");if(!this.s.value.isWritableFileSystem(E.scheme))throw new O.$nl((0,C.localize)(0,null,this.z(E)),6);const P={metadata:(0,t.$ao)(I.apiNotebook.metadata,z=>!(k.options?.transientDocumentMetadata??{})[z]),cells:[]};for(const z of I.apiNotebook.getCells()){const K=new o.$QN(z.kind,z.document.getText(),z.document.languageId,z.mime,k.options?.transientOutputs?[]:[...z.outputs],z.metadata,z.executionSummary);K.metadata=(0,t.$ao)(z.metadata,ie=>!(k.options?.transientCellMetadata??{})[ie]),P.cells.push(K)}await this.y(E,y);const V=await k.serializer.serializeNotebook(P,h);await this.s.value.writeFile(E,V);const W=this.s.getFileSystemProviderExtUri(E.scheme),q=await this.s.value.stat(E);return{name:W.basename(E),isFile:(q.type&O.FileType.File)!==0,isDirectory:(q.type&O.FileType.Directory)!==0,isSymbolicLink:(q.type&O.FileType.SymbolicLink)!==0,mtime:q.mtime,ctime:q.ctime,size:q.size,readonly:!!((q.permissions??0)&O.FilePermission.Readonly)||!this.s.value.isWritableFileSystem(E.scheme),locked:!!((q.permissions??0)&O.FilePermission.Locked),etag:O.$yl({mtime:q.mtime,size:q.size}),children:void 0}}async $searchInNotebooks(g,$,v,y,h){const E=this.x.get(g)?.serializer;if(!E)return{limitHit:!1,results:[]};const k=new A.$Bc;await(async(q,R,z)=>{await Promise.all(q.map(async K=>await Promise.all(K.filenamePatterns.map(ie=>{const de={_reason:z._reason,folderQueries:z.folderQueries,includePattern:z.includePattern,excludePattern:z.excludePattern,maxResults:z.maxResults,type:1,filePattern:ie};return this.t.doInternalFileSearchWithCustomCallback(de,R,ye=>{ye.forEach(De=>{k.has(De)||y.some(ue=>K.isFromSettings&&!ue.isFromSettings?!1:ue.filenamePatterns.some(Ce=>(0,b.$1gb)(Ce,De)))||k.add(De)})}).catch(ye=>{if(ye.code==="ENOENT")return console.warn("Could not find notebook search results, ignoring notebook results."),{limitHit:!1,messages:[]};throw ye})}))))})(v,h,$);const P=new A.$Ac;let V=!1;const W=Array.from(k).map(async q=>{const R=[];try{if(h.isCancellationRequested)return;if($.maxResults&&[...P.values()].reduce((de,ye)=>de+ye.cellResults.length,0)>$.maxResults){V=!0;return}const z=[],K=this.g.get(q);if(K)K.apiNotebook.getCells().forEach(ye=>z.push({input:ye.document.getText(),outputs:ye.outputs.flatMap(De=>De.items.map(ge=>ge.data.toString()))}));else{const de=await this.s.value.readFile(q),ye=N.$He.fromString(de.toString()),De=await E.deserializeNotebook(ye.buffer,h);if(h.isCancellationRequested)return;f.NotebookData.from(De).cells.forEach(ue=>z.push({input:ue.source,outputs:ue.outputs.flatMap(Ce=>Ce.items.map(se=>se.valueBytes.toString()))}))}if(h.isCancellationRequested)return;z.forEach((de,ye)=>{const De=$.contentPattern.pattern,ge=new u.$NXb(de.input,void 0,de.outputs),ue=ge.findInInputs(De),Ce=ge.findInOutputs(De),se=Ce.flatMap(Ne=>(0,i.$2K)(Ne.matches,Ne.textBuffer)).map((Ne,ne)=>(Ne.webviewIndex=ne,Ne));if(ue.length>0||Ce.length>0){const Ne={index:ye,contentResults:(0,i.$2K)(ue,ge.inputTextBuffer),webviewResults:se};R.push(Ne)}});const ie={resource:q,cellResults:R};P.set(q,ie);return}catch{return}});return await Promise.all(W),{limitHit:V,results:[...P.values()]}}async y(g,$){const v=await this.s.value.stat(g);if(typeof $?.mtime=="number"&&typeof $.etag=="string"&&$.etag!==O.$xl&&typeof v.mtime=="number"&&typeof v.size=="number"&&$.mtime<v.mtime&&$.etag!==O.$yl({mtime:$.mtime,size:v.size}))throw new O.$nl((0,C.localize)(1,null),3,$)}z(g){return g.scheme===c.Schemas.file?g.fsPath:g.toString()}A(g,$,v){if(this.h.has($))throw new Error(`editor with id ALREADY EXSIST: ${$}`);const y=new n.$qnc($,this.d,g,v.visibleRanges.map(f.NotebookRange.to),v.selections.map(f.NotebookRange.to),typeof v.viewColumn=="number"?f.ViewColumn.to(v.viewColumn):void 0);this.h.set($,y)}$acceptDocumentAndEditorsDelta(g){if(g.value.removedDocuments)for(const v of g.value.removedDocuments){const y=D.URI.revive(v),h=this.g.get(y);h&&(h.dispose(),this.g.delete(y),this.q.$acceptDocumentsAndEditorsDelta({removedDocuments:h.apiNotebook.getCells().map(E=>E.document.uri)}),this.n.fire(h.apiNotebook));for(const E of this.h.values())E.notebookData.uri.toString()===y.toString()&&this.h.delete(E.id)}if(g.value.addedDocuments){const v=[];for(const y of g.value.addedDocuments){const h=D.URI.revive(y.uri);if(this.g.has(h))throw new Error(`adding EXISTING notebook ${h} `);const E=new s.$pnc(this.c,this.q,this.r,h,y);v.push(...y.cells.map(k=>s.$onc.asModelAddData(k))),this.g.get(h)?.dispose(),this.g.set(h,E),this.q.$acceptDocumentsAndEditorsDelta({addedDocuments:v}),this.m.fire(E.apiNotebook)}}if(g.value.addedEditors)for(const v of g.value.addedEditors){if(this.h.has(v.id))return;const y=D.URI.revive(v.documentUri),h=this.g.get(y);h&&this.A(h,v.id,v)}const $=[];if(g.value.removedEditors)for(const v of g.value.removedEditors){const y=this.h.get(v);y&&(this.h.delete(v),this.k?.id===y.id&&(this.k=void 0),$.push(y))}if(g.value.visibleEditors){this.l=g.value.visibleEditors.map(y=>this.h.get(y)).filter(y=>!!y);const v=new Set;this.l.forEach(y=>v.add(y.id));for(const y of this.h.values()){const h=v.has(y.id);y._acceptVisibility(h)}this.l=[...this.h.values()].map(y=>y).filter(y=>y.visible),this.o.fire(this.visibleNotebookEditors)}g.value.newActiveEditor===null?this.k=void 0:g.value.newActiveEditor&&(this.h.get(g.value.newActiveEditor)||console.error(`FAILED to find active notebook editor ${g.value.newActiveEditor}`),this.k=this.h.get(g.value.newActiveEditor)),g.value.newActiveEditor!==void 0&&this.j.fire(this.k?.apiEditor)}static B(g){const $=w.$bP.String.with("notebookType","A notebook type"),v=new w.$dP("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[$,new w.$bP("data","Bytes to convert to data",h=>h instanceof Uint8Array,h=>N.$He.wrap(h))],new w.$cP("Notebook Data",h=>f.NotebookData.to(h.value))),y=new w.$dP("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[$,new w.$bP("NotebookData","Notebook data to convert to bytes",h=>!0,h=>new r.$Gw(f.NotebookData.from(h)))],new w.$cP("Bytes",h=>h.buffer));g.registerApiCommand(v),g.registerApiCommand(y)}}e.$znc=a}),define(Se[301],Ie([1,0,19,20,44,37,24,66,48]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$rnc=void 0;class D{constructor(d,w,f){this.k=d,this.l=w,this.o=f,this.e=!1,this.f=0,this.g=!1,this.a=d.filePattern,this.b=d.includePattern&&T.$sk(d.includePattern),this.c=d.maxResults||void 0,this.d=d.exists,this.h=new Set,this.j=d.excludePattern&&T.$sk(d.excludePattern)}cancel(){this.g=!0,this.h.forEach(d=>d.cancel()),this.h=new Set}search(d){const w=this.k.folderQueries||[];return new Promise((f,o)=>{const r=s=>{this.f++,d(s)};if(this.g)return f({limitHit:this.e});this.k.extraFileResources&&this.k.extraFileResources.forEach(s=>{const n=s.toString(),t=C.$nc(n);this.j&&this.j(n,t)||this.v(r,{base:s,basename:t})}),Promise.all(w.map(s=>this.p(s,r))).then(s=>{f({limitHit:this.e,stats:s[0]||void 0})},s=>{o(new Error((0,M.$jj)(s)))})})}async p(d,w){const f=new N.$qe,o=this.q(d),r=this.r(),s=new m.$RK(this.k,d),n=!s.hasSiblingExcludeClauses();let t;try{this.h.add(f),t=p.$be.create();const c=await this.l.provideFileSearchResults({pattern:this.k.filePattern||""},o,f.token),u=t.elapsed(),i=p.$be.create();return this.g&&!this.e||(c&&c.forEach(b=>{const a=C.$gc.relative(d.folder.path,b.path);if(n){const l=C.$nc(b.path);this.v(w,{base:d.folder,relativePath:a,basename:l});return}this.s(r,d.folder,a,w)}),this.g&&!this.e)?null:(this.u(r,s,w),{providerTime:u,postProcessTime:i.elapsed()})}finally{f.dispose(),this.h.delete(f)}}q(d){const w=(0,m.$QK)(this.k.includePattern,d.includePattern),f=(0,m.$QK)(this.k.excludePattern,d.excludePattern);return{folder:d.folder,excludes:f,includes:w,useIgnoreFiles:!d.disregardIgnoreFiles,useGlobalIgnoreFiles:!d.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!d.disregardParentIgnoreFiles,followSymlinks:!d.ignoreSymlinks,maxResults:this.k.maxResults,session:this.o}}r(){const d={rootEntries:[],pathToEntries:Object.create(null)};return d.pathToEntries["."]=d.rootEntries,d}s({pathToEntries:d},w,f,o){if(f===this.a){const s=C.$nc(this.a);this.v(o,{base:w,relativePath:this.a,basename:s})}function r(s){const n=C.$nc(s),t=C.$mc(s);let c=d[t];c||(c=d[t]=[],r(t)),c.push({base:w,relativePath:s,basename:n})}r(f)}u({rootEntries:d,pathToEntries:w},f,o){const r=this,s=this.a;function n(t){const c=(0,m.$TK)(()=>t.map(u=>u.basename));for(let u=0,i=t.length;u<i;u++){const b=t[u],{relativePath:a,basename:l}=b;if(f.matchesExcludesSync(a,l,s!==l?c:void 0))continue;const g=w[a];if(g)n(g);else{if(a===s)continue;r.v(o,b)}if(r.e)break}}n(d)}v(d,w){(!this.b||w.relativePath&&this.b(w.relativePath,w.basename))&&((this.d||this.c&&this.f>=this.c)&&(this.e=!0,this.cancel()),this.e||d(w))}}class O{constructor(){this.b=new Map}static{this.a=512}fileSearch(d,w,f,o){const r=this.c(d.cacheKey),s=new D(d,w,r&&r.token);let n=0;const t=c=>{n+=c.length,f(c.map(u=>this.d(u)))};return this.e(s,O.a,t,o).then(c=>({limitHit:c.limitHit,stats:c.stats?{fromCache:!1,type:"fileSearchProvider",resultCount:n,detailStats:c.stats}:void 0,messages:[]}))}clearCache(d){this.c(d)?.cancel()}c(d){if(d)return this.b.has(d)||this.b.set(d,new N.$qe),this.b.get(d)}d(d){return d.relativePath?{resource:A.$_g(d.base,d.relativePath)}:{resource:d.base}}e(d,w,f,o){const r=o.onCancellationRequested(()=>{d.cancel()}),s=t=>{t&&(n.push(t),w>0&&n.length>=w&&(f(n),n=[]))};let n=[];return d.search(s).then(t=>(n.length&&f(n),r.dispose(),t),t=>(n.length&&f(n),r.dispose(),Promise.reject(t)))}}e.$rnc=O}),define(Se[302],Ie([1,0,18,271,37,97,28,16,19,24,13,15,2,96,195,50,12,46,109,298,48]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$2L=void 0,e.$3L=y;let u=class{constructor(E,k,I,P,V){this.a=E,this.b=k,this.c=I,this.d=P,this.e=V}text(E,k,I={}){E=this.f(E,I);const P=this.a.getValue(),V=k&&k.some(q=>!this.a.getValue({resource:q}).search.useRipgrep);return{...this.h(k?.map(s.$Ti),I),type:2,contentPattern:E,previewOptions:I.previewOptions,maxFileSize:I.maxFileSize,usePCRE2:P.search.usePCRE2||V||!1,beforeContext:I.beforeContext,afterContext:I.afterContext,userDisabledExcludesAndIgnoreFiles:I.disregardExcludeSettings&&I.disregardIgnoreFiles}}f(E,k){const I=this.a.getValue();E.isRegExp&&(E.pattern=E.pattern.replace(/\r?\n/g,"\\n"));const P={...E,wordSeparators:I.editor.wordSeparators};return this.j(E,k)&&(P.isCaseSensitive=!0),this.k(E)&&(P.isMultiline=!0),k.notebookSearchConfig?.includeMarkupInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownInput=k.notebookSearchConfig.includeMarkupInput),k.notebookSearchConfig?.includeMarkupPreview&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookMarkdownPreview=k.notebookSearchConfig.includeMarkupPreview),k.notebookSearchConfig?.includeCodeInput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellInput=k.notebookSearchConfig.includeCodeInput),k.notebookSearchConfig?.includeOutput&&(P.notebookInfo||(P.notebookInfo={}),P.notebookInfo.isInNotebookCellOutput=k.notebookSearchConfig.includeOutput),P}file(E,k={}){return{...this.h(E,k),type:1,filePattern:k.filePattern?k.filePattern.trim():k.filePattern,exists:k.exists,sortByScore:k.sortByScore,cacheKey:k.cacheKey,shouldGlobMatchFilePattern:k.shouldGlobSearch}}g(E,k){return E?(E=Array.isArray(E)?E.map(g):g(E),k?this.parseSearchPaths(E):{pattern:b(...Array.isArray(E)?E:[E])}):{}}h(E=[],k={}){const I=this.g(k.includePattern,k.expandPatterns),P=this.g(k.excludePattern,k.expandPatterns),V=E.length>1,W=(I.searchPaths&&I.searchPaths.length?I.searchPaths.map(z=>this.q(z,k,P)):E.map(z=>this.r(z,k,P,V))).filter(z=>!!z),q={_reason:k._reason,folderQueries:W,usingSearchPaths:!!(I.searchPaths&&I.searchPaths.length),extraFileResources:k.extraFileResources,excludePattern:P.pattern,includePattern:I.pattern,onlyOpenEditors:k.onlyOpenEditors,maxResults:k.maxResults};if(k.onlyOpenEditors){const z=C.$Hb(this.c.groups.flatMap(de=>de.editors.map(ye=>ye.resource)));this.d.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(z));const K=z.filter(de=>(0,c.$HK)(q,de.fsPath)),ie=this.i(K);return this.d.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(ie)),{...q,...ie}}const R=k.extraFileResources&&k.extraFileResources.filter(z=>(0,c.$HK)(q,z.fsPath));return q.extraFileResources=R&&R.length?R:void 0,q}i(E){const k=[],I=new A.$Ac,P={};let V=!1;return E.forEach(W=>{if(W.scheme===p.Schemas.walkThrough)return;if((0,D.$dh)(W)){const R=this.b.getWorkspaceFolder(W)?.uri??W.with({path:m.$mc(W.fsPath)});let z=I.get(R);z||(V=!0,z={folder:R,includePattern:{}},k.push(z),I.set(R,z));const K=m.$lc(R.fsPath,W.fsPath);(0,S.$jg)(z.includePattern)[K.replace(/\\/g,"/")]=!0}else W.fsPath&&(V=!0,P[W.fsPath]=!0)}),{folderQueries:k,includePattern:P,usingSearchPaths:!0,excludePattern:V?void 0:{"**/*":!0}}}j(E,k){if(k.isSmartCase){if(E.isRegExp){if(O.$2f(E.pattern,!0))return!0}else if(O.$2f(E.pattern))return!0}return!!E.isCaseSensitive}k(E){return E.isMultiline||E.isRegExp&&(0,w.$VC)(E.pattern)||E.pattern.indexOf(`
`)>=0?!0:!!E.isMultiline}parseSearchPaths(E){const k=ie=>m.$ic(ie)||/^\.\.?([\/\\]|$)/.test(ie),P=(Array.isArray(E)?E:a(E)).map(ie=>{const de=this.e.resolvedUserHome;return de?(0,T.$Lw)(ie,de.scheme===p.Schemas.file?de.fsPath:de.path):ie}),V=N.$K(P,ie=>k(ie)?"searchPaths":"exprSegments"),W=(V.exprSegments||[]).map(ie=>O.$hf(ie,"/")).map(ie=>O.$hf(ie,"\\")).map(ie=>(ie[0]==="."&&(ie="*"+ie),l(ie))),q={},R=this.m(V.searchPaths||[]);R&&R.length&&(q.searchPaths=R);const z=W.flat(),K=b(...z);return K&&(q.pattern=K),q}l(E,k){return k.disregardExcludeSettings?void 0:(0,c.$GK)(E,!k.disregardSearchExcludeSettings)}m(E){if(!E||!E.length)return[];const k=E.flatMap(P=>{let{pathPortion:V,globPortion:W}=i(P);return W&&(W=$(W)),this.n(V).flatMap(R=>this.o(R,W))}),I=new Map;return k.forEach(P=>{const V=P.searchPath.toString(),W=I.get(V);W?P.pattern&&(W.pattern=W.pattern||{},W.pattern[P.pattern]=!0):I.set(V,{searchPath:P.searchPath,pattern:P.pattern?b(P.pattern):void 0})}),Array.from(I.values())}n(E){if(m.$ic(E)){const k=this.b.getWorkspace().folders;return k[0]&&k[0].uri.scheme!==p.Schemas.file?[{searchPath:k[0].uri.with({path:E})}]:[{searchPath:d.URI.file(m.$hc(E))}]}if(this.b.getWorkbenchState()===2){const k=this.b.getWorkspace().folders[0].uri;if(E=g(E),E.startsWith("../")||E===".."){const P=m.$gc.resolve(k.path,E);return[{searchPath:k.with({path:P})}]}const I=$(E);return[{searchPath:k,pattern:I}]}else{if(E==="./"||E===".\\")return[];{const k=E.replace(/^\.[\/\\]/,""),P=this.b.getWorkspace().folders.map(V=>{const W=k.match(new RegExp(`^${O.$bf(V.name)}(?:/(.*)|$)`));return W?{match:W,folder:V}:null}).filter(S.$gg);if(P.length)return P.map(V=>{const W=V.match[1];return{searchPath:V.folder.uri,pattern:W&&$(W)}});{const V=E.match(/\.[\/\\](.+)[\/\\]?/),W=V?V[1]:E,q=f.localize(0,null,W);throw new Error(q)}}}}o(E,k){const I=E.pattern&&k?`${E.pattern}/${k}`:E.pattern||k,P=[{searchPath:E.searchPath,pattern:I}];return I&&!I.endsWith("**")&&P.push({searchPath:E.searchPath,pattern:I+"/**"}),P}q(E,k,I){const P=this.r((0,s.$Ti)(E.searchPath),k,I,!1);return P?{...P,includePattern:E.pattern}:null}r(E,k,I,P){let V;const W=d.URI.isUri(E)?E:E.uri;if(I.searchPaths){const ie=I.searchPaths.filter(de=>(0,D.$5g)(de.searchPath,W))[0];if(ie&&!ie.pattern)return null;ie&&(V=ie.pattern)}const q=this.a.getValue({resource:W}),z={...this.l(q,k)||{},...V||{}},K=d.URI.isUri(E)?(0,D.$9g)(E):E.name;return{folder:W,folderName:P?K:void 0,excludePattern:Object.keys(z).length>0?z:void 0,fileEncoding:q.files&&q.files.encoding,disregardIgnoreFiles:typeof k.disregardIgnoreFiles=="boolean"?k.disregardIgnoreFiles:!q.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof k.disregardGlobalIgnoreFiles=="boolean"?k.disregardGlobalIgnoreFiles:!q.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof k.disregardParentIgnoreFiles=="boolean"?k.disregardParentIgnoreFiles:!q.search.useParentIgnoreFiles,ignoreSymlinks:typeof k.ignoreSymlinks=="boolean"?k.ignoreSymlinks:!q.search.followSymlinks}}};e.$2L=u,e.$2L=u=Je([We(0,o.$5i),We(1,s.$Hi),We(2,n.$4D),We(3,r.$5j),We(4,t.$ZL)],u);function i(h){const E=h.match(/[\*\{\}\(\)\[\]\?]/);if(E){const k=E.index,I=h.substr(0,k).match(/[/|\\][^/\\]*$/);if(I){let P=h.substr(0,I.index);return P.match(/[/\\]/)||(P+="/"),{pathPortion:P,globPortion:h.substr((I.index||0)+1)}}}return{pathPortion:h}}function b(...h){return h.length?h.reduce((E,k)=>(E[k]=!0,E),Object.create(null)):void 0}function a(h){return M.$qk(h,",").map(E=>E.trim()).filter(E=>!!E.length)}function l(h){return[`**/${h}/**`,`**/${h}`].map(k=>k.replace(/\*\*\/\*\*/g,"**"))}function g(h){return h.replace(/\\/g,"/")}function $(h){return g(h).replace(/^\.\//,"").replace(/\/+$/g,"")}function v(h){return h.replace(/([?*[\]])/g,"[$1]")}function y(h,E){h=C.$Mb(h,P=>P.toString());const k=[],I=E.getWorkspace();return h&&h.forEach(P=>{let V;if(E.getWorkbenchState()===2)V=(0,D.$bh)(I.folders[0].uri,P),V&&V!=="."&&(V="./"+V);else{const W=E.getWorkspaceFolder(P);if(W){const q=W.name;if(I.folders.filter(z=>z.name===q).length===1){const z=(0,D.$bh)(W.uri,P);z===""?V=`./${W.name}`:V=`./${W.name}/${z}`}else V=P.fsPath}}V&&k.push(v(V))}),k}}),define(Se[303],Ie([1,0,24,2,20,14,3,302,48,46,11]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$Xwb=d,e.$Ywb=o;const S=7e3;function d(r,s){const n=s.activationEvents;if(!n)return Promise.resolve(void 0);const t=[],c=[];for(const g of n)if(/^workspaceContains:/.test(g)){const $=g.substr(18);$.indexOf("*")>=0||$.indexOf("?")>=0||r.forceUsingSearch?c.push($):t.push($)}if(t.length===0&&c.length===0)return Promise.resolve(void 0);const{promise:u,resolve:i}=(0,O.$rh)(),b=g=>i({activationEvent:g}),a=Promise.all(t.map(g=>w(r,g,b))).then(()=>{}),l=f(r,s.identifier,c,b);return Promise.all([a,l]).then(()=>{i(void 0)}),u}async function w(r,s,n){for(const t of r.folders)if(await r.exists(C.$_g(N.URI.revive(t),s))){n(`workspaceContains:${s}`);return}}async function f(r,s,n,t){if(n.length===0)return Promise.resolve(void 0);const c=new M.$qe,u=r.checkExists(r.folders,n,c.token),i=setTimeout(async()=>{c.cancel(),r.logService.info(`Not activating extension '${s.value}': Timed out while searching for 'workspaceContains' pattern ${n.join(",")}`)},S);let b=!1;try{b=await u}catch(a){T.$4(a)||T.$1(a)}c.dispose(),clearTimeout(i),b&&t(`workspaceContains:${n.join(",")}`)}function o(r,s,n,t){const c=r.get(A.$xi),u=r.get(m.$yK),b=c.createInstance(p.$2L).file(s.map(a=>(0,D.$Ti)(N.URI.revive(a))),{_reason:"checkExists",includePattern:n,exists:!0});return u.fileSearch(b,t).then(a=>!!a.limitHit,a=>T.$4(a)?!1:Promise.reject(a))}}),define(Se[41],Ie([1,0,173,19,60,24,11,6,54,2,12,4,40,237,84,39,25,110,14,21,22,218,7,104,3,27,87,17,72,88,53,90,5,303,83,220,16,81,66,23,82]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u,i,b,a,l,g,$,v,y,h,E,k,I,P,V,W,q,R,z,K){"use strict";var ie;Object.defineProperty(e,"__esModule",{value:!0}),e.$0mc=e.$9mc=e.$8mc=e.$7mc=e.$6mc=void 0,e.$6mc=(0,a.$yi)("IHostUtils");let de=ie=class extends p.$Uc{constructor(U,x,ve,Le,ke,be,me,Q,Y,he,ce,Te,fe){super(),this.Y=Te,this.Z=fe,this.a=this.B(new k.$fe),this.onDidChangeRemoteConnectionData=this.a.event,this.R=new Map,this.W=!1,this.c=x,this.g=ve,this.f=me,this.j=Le,this.m=ke,this.s=be,this.t=Y,this.u=he,this.w=ce,this.y=this.g.getProxy(S.$lM.MainThreadWorkspace),this.z=this.g.getProxy(S.$lM.MainThreadTelemetry),this.C=this.g.getProxy(S.$lM.MainThreadExtensionService),this.D=new A.$xh,this.F=new A.$xh,this.G=new A.$xh,this.H=new A.$xh,this.I=new Ne(this.f.extensions.activationEvents),this.L=new s.$Gac(this.I,this.f.extensions.allExtensions);const Pe=new t.$Um(this.f.extensions.myExtensions);this.J=new s.$Gac(this.I,Ce(this.L,Pe)),z.$t&&(this.s.info(`Creating extension host with the following global extensions: ${ge(this.L)}`),this.s.info(`Creating extension host with the following local extensions: ${ge(this.J)}`)),this.M=new f.$Omc(this.g,this.s),this.N=new P.$Ymc(this.g),this.O=Q,this.h=U.createChild(new v.$wi([f.$Pmc,this.M],[P.$Zmc,this.N])),this.P=this.B(new w.$Nmc(this.J,this.L,{onExtensionActivationError:(Re,je,B)=>{this.C.$onExtensionActivationError(Re,n.$3(je),B)},actualActivateExtension:async(Re,je)=>{if(s.$Gac.isHostExtension(Re,this.J,this.L))return await this.C.$activateExtension(Re,je),new w.$Mmc;const B=this.J.getExtensionDescription(Re);return this.fb(B,je)}},this.s)),this.Q=null,this.S=Object.create(null),this.U=!1,this.X=this.f.remote.connectionData}getRemoteConnectionData(){return this.X}async initialize(){try{await this.vb(),this.D.open(),await this.j.waitForInitializeCall(),M.mark("code/extHost/ready"),this.F.open(),this.f.autoStart&&this.tb()}catch(U){n.$1(U)}}async $(){this.O.onWillDeactivateAll();let U=[];try{U=this.J.getAllExtensionDescriptions().map(ke=>ke.identifier).filter(ke=>this.isActivated(ke)).map(ke=>this.eb(ke))}catch{}await Promise.all(U)}terminate(U,x=0){if(this.W)return;this.W=!0,this.s.info(`Extension host terminating: ${U}`),this.s.flush(),this.u.dispose(),this.P.dispose(),n.setUnexpectedErrorHandler(Le=>{this.s.error(Le)}),this.g.dispose();const ve=this.$();Promise.race([(0,A.$zh)(5e3),ve]).finally(()=>{this.c.pid?this.s.info(`Extension host with pid ${this.c.pid} exiting with code ${x}`):this.s.info(`Extension host exiting with code ${x}`),this.s.flush(),this.s.dispose(),this.c.exit(x)})}isActivated(U){return this.G.isOpen()?this.P.isActivated(U):!1}async getExtension(U){const x=await this.C.$getExtension(U);return x&&{...x,identifier:new t.$Tm(x.identifier.value),extensionLocation:D.URI.revive(x.extensionLocation)}}ab(U,x){return this.P.activateByEvent(U,x)}bb(U,x){return this.P.activateById(U,x)}activateByIdWithErrors(U,x){return this.bb(U,x).then(()=>{const ve=this.P.getActivatedExtension(U);if(ve.activationFailed)return Promise.reject(ve.activationFailedError)})}getExtensionRegistry(){return this.G.wait().then(U=>this.J)}getExtensionExports(U){if(this.G.isOpen())return this.P.getActivatedExtension(U).exports;try{return this.P.getActivatedExtension(U).exports}catch{return null}}async cb(U){if(U.scheme===W.Schemas.file&&this.c.fsRealpath){const x=U.fsPath;this.R.has(x)||this.R.set(x,this.c.fsRealpath(x));const ve=await this.R.get(x);return D.URI.file(ve)}return U}async getExtensionPathIndex(){return this.Q||(this.Q=this.db(this.J.getAllExtensionDescriptions()).then(U=>new se(U))),this.Q}async db(U){const x=m.$Ei.forUris(ve=>T.$3g.ignorePathCasing(ve));return await Promise.all(U.map(async ve=>{if(this.wb(ve)){const Le=await this.cb(ve.extensionLocation);x.set(Le,ve)}})),x}eb(U){let x=Promise.resolve(void 0);if(!this.G.isOpen()||!this.P.isActivated(U))return x;const ve=this.P.getActivatedExtension(U);if(!ve)return x;try{typeof ve.module.deactivate=="function"&&(x=Promise.resolve(ve.module.deactivate()).then(void 0,Le=>(this.s.error(Le),Promise.resolve(void 0))))}catch(Le){this.s.error(`An error occurred when deactivating the extension '${U.value}':`),this.s.error(Le)}try{(0,p.$Pc)(ve.subscriptions)}catch(Le){this.s.error(`An error occurred when deactivating the subscriptions for extension '${U.value}':`),this.s.error(Le)}return x}async fb(U,x){return this.f.remote.isRemote?this.C.$onWillActivateExtension(U.identifier):await this.C.$onWillActivateExtension(U.identifier),this.hb(U,x).then(ve=>{const Le=ve.activationTimes;return this.C.$onDidActivateExtension(U.identifier,Le.codeLoadingTime,Le.activateCallTime,Le.activateResolvedTime,x),this.gb(U,x,"success",Le),ve},ve=>{throw this.gb(U,x,"failure"),ve})}gb(U,x,ve,Le){const ke=De(U,x);this.z.$publicLog2("extensionActivationTimes",{...ke,...Le||{},outcome:ve})}hb(U,x){const ve=De(U,x);this.z.$publicLog2("activatePlugin",ve);const Le=this.wb(U);if(!Le)return Promise.resolve(new w.$Lmc(w.$Imc.NONE));this.s.info(`ExtensionService#_doActivateExtension ${U.identifier.value}, startup: ${x.startup}, activationEvent: '${x.activationEvent}'${U.identifier.value!==x.extensionId.value?`, root cause: ${x.extensionId.value}`:""}`),this.s.flush();const ke=new w.$Jmc(x.startup);return Promise.all([this.xb(U,(0,T.$_g)(U.extensionLocation,Le),ke),this.ib(U)]).then(be=>(M.mark(`code/extHost/willActivateExtension/${U.identifier.value}`),ie.jb(this.s,U.identifier,be[0],be[1],ke))).then(be=>(M.mark(`code/extHost/didActivateExtension/${U.identifier.value}`),be))}ib(U){const x=this.Z.createLanguageModelAccessInformation(U),ve=new u.$Rmc(U,this.M),Le=new u.$Qmc(U.identifier.value,!1,this.M),ke=new V.$1mc(U,this.N),be=U.isUnderDevelopment?this.f.environment.extensionTestsLocationURI?i.ExtensionMode.Test:i.ExtensionMode.Development:i.ExtensionMode.Production,me=this.f.remote.isRemote?i.ExtensionKind.Workspace:i.ExtensionKind.UI;return this.s.trace(`ExtensionService#loadExtensionContext ${U.identifier.value}`),Promise.all([ve.whenReady,Le.whenReady,this.O.whenReady]).then(()=>{const Q=this;let Y,he;const ce=(0,r.$LG)(U,"ipc")?this.f.messagePorts?.get(t.$Tm.toKey(U.identifier)):void 0;return Object.freeze({globalState:ve,workspaceState:Le,secrets:ke,subscriptions:[],get languageModelAccessInformation(){return x},get extensionUri(){return U.extensionLocation},get extensionPath(){return U.extensionLocation.fsPath},asAbsolutePath(Te){return N.$jc(U.extensionLocation.fsPath,Te)},get storagePath(){return Q.O.workspaceValue(U)?.fsPath},get globalStoragePath(){return Q.O.globalValue(U).fsPath},get logPath(){return N.$jc(Q.f.logsLocation.fsPath,U.identifier.value)},get logUri(){return D.URI.joinPath(Q.f.logsLocation,U.identifier.value)},get storageUri(){return Q.O.workspaceValue(U)},get globalStorageUri(){return Q.O.globalValue(U)},get extensionMode(){return be},get extension(){return Y===void 0&&(Y=new ue(Q,U.identifier,U,me,!1)),Y},get extensionRuntime(){return(0,r.$MG)(U,"extensionRuntime"),Q.extensionRuntime},get environmentVariableCollection(){return Q.u.getEnvironmentVariableCollection(U)},get messagePassingProtocol(){if(!he){if(!ce)return;const Te=k.Event.buffer(k.Event.fromDOMEventEmitter(ce,"message",fe=>fe.data));ce.start(),he={onDidReceiveMessage:Te,postMessage:ce.postMessage.bind(ce)}}return he}})})}static jb(U,x,ve,Le,ke){return ve=ve||{activate:void 0,deactivate:void 0},this.kb(U,x,ve,Le,ke).then(be=>new w.$Kmc(!1,null,ke.build(),ve,be,Le.subscriptions))}static kb(U,x,ve,Le,ke){if(typeof ve.activate=="function")try{ke.activateCallStart(),U.trace(`ExtensionService#_callActivateOptional ${x.value}`);const be=typeof global=="object"?global:self,me=ve.activate.apply(be,[Le]);return ke.activateCallStop(),ke.activateResolveStart(),Promise.resolve(me).then(Q=>(ke.activateResolveStop(),Q))}catch(be){return Promise.reject(be)}else return Promise.resolve(ve)}lb(U,x){this.bb(U.identifier,{startup:!1,extensionId:U.identifier,activationEvent:x}).then(void 0,ve=>{this.s.error(ve)})}mb(U,x=0){const Le=Date.now();(0,z.$B)(()=>{for(let ke=x;ke<U.length;ke+=1){const be=U[ke];for(const me of be.activationEvents??[])if(me==="onStartupFinished")if(Date.now()-Le>50){this.mb(U,ke);break}else this.lb(be,me)}})}nb(){this.C.$setPerformanceMarks(M.getMarks()),this.m.getConfigProvider().then(U=>{const x=U.getConfiguration("extensions.experimental").get("deferredStartupFinishedActivation"),ve=this.J.getAllExtensionDescriptions();if(x)this.mb(ve);else for(const Le of ve)if(Le.activationEvents)for(const ke of Le.activationEvents)ke==="onStartupFinished"&&this.lb(Le,ke)})}ob(){const U=this.ab("*",!0).then(void 0,be=>{this.s.error(be)});this.B(this.j.onDidChangeWorkspace(be=>this.pb(be.added)));const x=this.j.workspace?this.j.workspace.folders:[],ve=this.pb(x),Le=this.rb(),ke=Promise.all([Le,U,ve]).then(()=>{});return Promise.race([ke,(0,A.$zh)(1e4)]).then(()=>{this.nb()}),ke}pb(U){return U.length===0?Promise.resolve(void 0):Promise.all(this.J.getAllExtensionDescriptions().map(x=>this.qb(U,x))).then(()=>{})}async qb(U,x){if(this.isActivated(x.identifier))return;const ve=!this.f.remote.isRemote&&!!this.f.remote.authority,Le={logService:this.s,folders:U.map(be=>be.uri),forceUsingSearch:ve||!this.c.fsExists,exists:be=>this.c.fsExists(be.fsPath),checkExists:(be,me,Q)=>this.y.$checkExists(be,me,Q)},ke=await(0,I.$Xwb)(Le,x);if(ke)return this.bb(x.identifier,{startup:!0,extensionId:x.identifier,activationEvent:ke.activationEvent}).then(void 0,be=>this.s.error(be))}async rb(){if(this.f.remote.authority)return this.ab(`onResolveRemoteAuthority:${this.f.remote.authority}`,!1)}async $extensionTestsExecute(){await this.H.wait();try{return await this.sb()}catch(U){throw console.error(U),U}}async sb(){const{extensionDevelopmentLocationURI:U,extensionTestsLocationURI:x}=this.f.environment;if(!U||!x)throw new Error(C.localize(0,null));const ve=await this.xb(null,x,new w.$Jmc(!1));if(!ve||typeof ve.run!="function")throw new Error(C.localize(1,null,x.toString()));return new Promise((Le,ke)=>{const be=(Y,he)=>{Y?(z.$t&&this.s.error("Test runner called back with error",Y),ke(Y)):(z.$t&&(he?this.s.info(`Test runner called back with ${he} failures.`):this.s.info("Test runner called back with successful outcome.")),Le(typeof he=="number"&&he>0?1:0))},me=(0,T.$Zg)(x),Q=ve.run(me,be);Q&&Q.then&&Q.then(()=>{z.$t&&this.s.info("Test runner finished successfully."),Le(0)}).catch(Y=>{z.$t&&this.s.error("Test runner finished with error",Y),ke(Y instanceof Error&&Y.stack?Y.stack:String(Y))})})}tb(){if(this.U)throw new Error("Extension host is already started!");return this.U=!0,this.F.wait().then(()=>this.G.open()).then(()=>Promise.race([this.P.waitForActivatingExtensions(),(0,A.$zh)(1e3)])).then(()=>this.ob()).then(()=>{this.H.open(),this.s.info("Eager extensions activated")})}registerRemoteAuthorityResolver(U,x){return this.S[U]=x,(0,p.$Sc)(()=>{delete this.S[U]})}async getRemoteExecServer(U){const{resolver:x}=await this.ub(U);return x?.resolveExecServer?.(U,{resolveAttempt:0})}async ub(U){const x=U.indexOf("+");if(x===-1)throw new i.$tM("Not an authority that can be resolved!",b.RemoteAuthorityResolverErrorCode.InvalidAuthority);const ve=U.substr(0,x);return await this.D.wait(),await this.ab(`onResolveRemoteAuthority:${ve}`,!1),{authorityPrefix:ve,resolver:this.S[ve]}}async $resolveAuthority(U,x){const ve=R.$be.create(!1),Le=()=>`[resolveAuthority(${(0,b.$Nl)(U)},${x})][${ve.elapsed()}ms] `,ke=F=>this.s.info(`${Le()}${F}`),be=F=>this.s.warn(`${Le()}${F}`),me=(F,H=void 0)=>this.s.error(`${Le()}${F}`,H),Q=F=>{if(F instanceof i.$tM)return{type:"error",error:{code:F._code,message:F._message,detail:F._detail}};throw F},Y=async F=>{ke(`activating resolver for ${F}...`);const{resolver:H,authorityPrefix:G}=await this.ub(F);if(!H)throw me(`no resolver for ${G}`),new i.$tM(`No remote extension installed to resolve ${G}.`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);return{resolver:H,authorityPrefix:G,remoteAuthority:F}},he=U.split(/@|%40/g).reverse();ke(`activating remote resolvers ${he.join(" -> ")}`);let ce;try{ce=await Promise.all(he.map(Y)).catch(async F=>{if(!(F instanceof i.$tM)||F._code!==b.RemoteAuthorityResolverErrorCode.InvalidAuthority)throw F;return be(`resolving nested authorities failed: ${F.message}`),[await Y(U)]})}catch(F){return Q(F)}const Te=new A.$Jh;Te.cancelAndSet(()=>ke("waiting..."),1e3);let fe,Pe;for(const[F,{authorityPrefix:H,resolver:G,remoteAuthority:te}]of ce.entries())try{if(F===ce.length-1)ke("invoking final resolve()..."),M.mark(`code/extHost/willResolveAuthority/${H}`),fe=await G.resolve(te,{resolveAttempt:x,execServer:Pe}),M.mark(`code/extHost/didResolveAuthorityOK/${H}`),ke("setting tunnel factory..."),this.B(await this.t.setTunnelFactory(G,i.$sM.isManagedResolvedAuthority(fe)?fe:void 0));else{if(ke(`invoking resolveExecServer() for ${te}`),M.mark(`code/extHost/willResolveExecServer/${H}`),Pe=await G.resolveExecServer?.(te,{resolveAttempt:x,execServer:Pe}),!Pe)throw new i.$tM(`Exec server was not available for ${te}`,b.RemoteAuthorityResolverErrorCode.NoResolverFound);M.mark(`code/extHost/didResolveExecServerOK/${H}`)}}catch(re){return M.mark(`code/extHost/didResolveAuthorityError/${H}`),me("returned an error",re),Te.dispose(),Q(re)}Te.dispose();const Re={environmentTunnels:fe.environmentTunnels,features:fe.tunnelFeatures?{elevation:fe.tunnelFeatures.elevation,privacyOptions:fe.tunnelFeatures.privacyOptions,protocol:fe.tunnelFeatures.protocol===void 0?!0:fe.tunnelFeatures.protocol}:void 0},je={extensionHostEnv:fe.extensionHostEnv,isTrusted:fe.isTrusted,authenticationSession:fe.authenticationSessionForInitializingExtensions?{id:fe.authenticationSessionForInitializingExtensions.id,providerId:fe.authenticationSessionForInitializingExtensions.providerId}:void 0};ke(`returned ${i.$sM.isManagedResolvedAuthority(fe)?"managed authority":`${fe.host}:${fe.port}`}`);let B;if(i.$sM.isManagedResolvedAuthority(fe)){const F=x;this.Y.setFactory(F,fe.makeConnection),B={authority:U,connectTo:new b.$Kl(F),connectionToken:fe.connectionToken}}else B={authority:U,connectTo:new b.$Ll(fe.host,fe.port),connectionToken:fe.connectionToken};return{type:"ok",value:{authority:B,options:je,tunnelInformation:Re}}}async $getCanonicalURI(U,x){this.s.info(`$getCanonicalURI invoked for authority (${(0,b.$Nl)(U)})`);const{resolver:ve}=await this.ub(U);if(!ve)return null;const Le=D.URI.revive(x);if(typeof ve.getCanonicalURI>"u")return Le;const ke=await(0,A.$qh)(()=>ve.getCanonicalURI(Le));return ke||Le}async $startExtensionHost(U){U.toAdd.forEach(be=>be.extensionLocation=D.URI.revive(be.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,U),Le=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Le),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$startExtensionHost: global extensions: ${ge(this.L)}`),this.s.info(`$startExtensionHost: local extensions: ${ge(this.J)}`)),this.tb()}$activateByEvent(U,x){return x===1?this.D.wait().then(ve=>this.ab(U,!1)):this.G.wait().then(ve=>this.ab(U,!1))}async $activate(U,x){return await this.G.wait(),this.J.getExtensionDescription(U)?(await this.bb(U,x),!0):!1}async $deltaExtensions(U){U.toAdd.forEach(be=>be.extensionLocation=D.URI.revive(be.extensionLocation));const{globalRegistry:x,myExtensions:ve}=ye(this.I,this.L,this.J,U),Le=await this.db(ve);return(await this.getExtensionPathIndex()).setSearchTree(Le),this.L.set(x.getAllExtensionDescriptions()),this.J.set(ve),z.$t&&(this.s.info(`$deltaExtensions: global extensions: ${ge(this.L)}`),this.s.info(`$deltaExtensions: local extensions: ${ge(this.J)}`)),Promise.resolve(void 0)}async $test_latency(U){return U}async $test_up(U){return U.byteLength}async $test_down(U){const x=c.$He.alloc(U),ve=Math.random()%256;for(let Le=0;Le<U;Le++)x.writeUInt8(ve,Le);return x}async $updateRemoteConnectionData(U){this.X=U,this.a.fire()}};e.$7mc=de,e.$7mc=de=ie=Je([We(0,a.$xi),We(1,e.$6mc),We(2,$.$PO),We(3,o.$rmc),We(4,d.$umc),We(5,O.$5j),We(6,l.$6O),We(7,g.$xmc),We(8,y.$1Db),We(9,h.$Smc),We(10,q.$3mc),We(11,K.$4mc),We(12,E.$Wmc)],de);function ye(ne,U,x,ve){ne.addActivationEvents(ve.addActivationEvents);const Le=new s.$Gac(ne,U.getAllExtensionDescriptions());Le.deltaExtensions(ve.toAdd,ve.toRemove);const ke=new t.$Um(x.getAllExtensionDescriptions().map(me=>me.identifier));for(const me of ve.myToRemove)ke.delete(me);for(const me of ve.myToAdd)ke.add(me);const be=Ce(Le,ke);return{globalRegistry:Le,myExtensions:be}}function De(ne,U){return{id:ne.identifier.value,name:ne.name,extensionVersion:ne.version,publisherDisplayName:ne.publisher,activationEvents:ne.activationEvents?ne.activationEvents.join(","):null,isBuiltin:ne.isBuiltin,reason:U.activationEvent,reasonId:U.extensionId.value}}function ge(ne){return ne.getAllExtensionDescriptions().map(U=>U.identifier.value).join(",")}e.$8mc=(0,a.$yi)("IExtHostExtensionService");class ue{#e;#t;#i;constructor(U,x,ve,Le,ke){this.#e=U,this.#t=x,this.#i=ve.identifier,this.id=ve.identifier.value,this.extensionUri=ve.extensionLocation,this.extensionPath=N.$hc((0,T.$Zg)(ve.extensionLocation)),this.packageJSON=ve,this.extensionKind=Le,this.isFromDifferentExtensionHost=ke}get isActive(){return this.#e.isActivated(this.#i)}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return this.#e.getExtensionExports(this.#i)}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await this.#e.activateByIdWithErrors(this.#i,{startup:!1,extensionId:this.#t,activationEvent:"api"}),this.exports}}e.$9mc=ue;function Ce(ne,U){return ne.getAllExtensionDescriptions().filter(x=>U.has(x.identifier))}class se{constructor(U){this.a=U}setSearchTree(U){this.a=U}findSubstr(U){return this.a.findSubstr(U)}forEach(U){return this.a.forEach(U)}}e.$0mc=se;class Ne{constructor(U){this.a=new t.$Vm,this.addActivationEvents(U)}readActivationEvents(U){return this.a.get(U.identifier)??[]}addActivationEvents(U){for(const x of Object.keys(U))this.a.set(x,U[x])}}}),define(Se[304],Ie([1,0,60,2,4,40,25,21,17,27,3,41,12,13]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w){"use strict";var f;Object.defineProperty(e,"__esModule",{value:!0}),e.$goc=void 0;let o=class{constructor(c,u,i,b,a,l,g){this.c=c,this.d=u,this.e=i,this.f=b,this.g=a,this.h=l,this.i=g,this.a=new Map,this.b=[]}async install(){this.j(),C.mark("code/extHost/willWaitForConfig");const c=await this.f.getConfigProvider();C.mark("code/extHost/didWaitForConfig");const u=await this.g.getExtensionPathIndex();this.register(new s(this.c,u,this.d,c,this.i)),this.register(this.e.createInstance(r)),this.h.remote.isRemote&&this.register(this.e.createInstance(n,u,this.h.environment.appUriScheme))}register(c){if("nodeModuleName"in c)if(Array.isArray(c.nodeModuleName))for(const u of c.nodeModuleName)this.a.set(u,c);else this.a.set(c.nodeModuleName,c);typeof c.alternativeModuleName=="function"&&this.b.push(u=>c.alternativeModuleName(u))}};e.$goc=o,e.$goc=o=Je([We(2,O.$xi),We(3,T.$umc),We(4,S.$8mc),We(5,D.$6O),We(6,d.$5j)],o);let r=class{static{f=this}static{this.a=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]])}constructor(c){if(c.environment.appRoot&&f.a.size){const u=(0,w.$bf)(this.c(c.environment.appRoot.fsPath)),i="[a-z0-9_.-]",b=`@${i}+\\/${i}+|${i}+`,a="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.b=new RegExp(`^(${u}/${a}\\/)(${b})(.*)$`,"i")}}alternativeModuleName(c){if(!this.b)return;const u=this.b.exec(this.c(c));if(!u)return;const[,i,b,a]=u,l=f.a.get(b);if(l!==void 0)return console.warn(`${b} as been renamed to ${l}, please update your imports`),i+l+a}c(c){return c.replace(/\\/g,"/")}};r=f=Je([We(0,D.$6O)],r);class s{constructor(c,u,i,b,a){this.c=c,this.d=u,this.e=i,this.f=b,this.g=a,this.nodeModuleName="vscode",this.a=new p.$Vm}load(c,u){const i=this.d.findSubstr(u);if(i){let b=this.a.get(i.identifier);return b||(b=this.c(i,this.e,this.f),this.a.set(i.identifier,b)),b}if(!this.b){let b="";this.d.forEach((a,l)=>b+=`	${l} -> ${a.identifier.value}
`),this.g.warn(`Could not identify extension for 'vscode' require call from ${u}. These are the extension path mappings: 
${b}`),this.b=this.c(A.$GG,this.e,this.f)}return this.b}}let n=class{constructor(c,u,i){this.e=c,this.f=u,this.nodeModuleName=["open","opn"],this.d=i.getProxy(M.$lM.MainThreadTelemetry);const b=i.getProxy(M.$lM.MainThreadWindow);this.c=(a,l)=>{const g=N.URI.parse(a);return l?this.g(a,l):g.scheme==="http"||g.scheme==="https"?b.$openUri(g,a,{allowTunneling:!0}):g.scheme==="mailto"||g.scheme===this.f?b.$openUri(g,a,{}):this.g(a,l)}}load(c,u,i){const b=this.e.findSubstr(u);return b&&(this.a=b.identifier.value,this.h()),this.b=i(c),this.c}g(c,u){return this.i(),this.b(c,u)}h(){this.a&&this.d.$publicLog2("shimming.open",{extension:this.a})}i(){this.a&&this.d.$publicLog2("shimming.open.call.noForward",{extension:this.a})}};n=Je([We(2,m.$PO)],n)}),define(Se[122],Ie([1,0,43,6,19,75,3,68,67,41,7,39,234,40]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$_mc=e.$$mc=void 0,e.$$mc=(0,A.$yi)("IExtHostVariableResolverProvider");class f extends d.$TP{constructor(s,n,t,c,u,i,b){function a(){if(t){const l=t.activeEditor();if(l)return l.document.uri;const g=c.tabGroups.all.find($=>$.isActive)?.activeTab;if(g!==void 0){if(g.input instanceof O.$_N||g.input instanceof O.$eO)return g.input.modified;if(g.input instanceof O.$$N||g.input instanceof O.$dO||g.input instanceof O.$bO)return g.input.uri}}}super({getFolderUri:l=>{const g=i.folders.filter($=>$.name===l);if(g&&g.length>0)return g[0].uri},getWorkspaceFolderCount:()=>i.folders.length,getConfigurationValue:(l,g)=>u.getConfiguration(void 0,l).get(g),getAppRoot:()=>T.cwd(),getExecPath:()=>T.env.VSCODE_EXEC_PATH,getFilePath:()=>{const l=a();if(l)return M.$hc(l.fsPath)},getWorkspaceFolderPathForFile:()=>{if(n){const l=a();if(l){const g=n.getWorkspaceFolder(l);if(g)return M.$hc(g.uri.fsPath)}}},getSelectedText:()=>{if(t){const l=t.activeEditor();if(l&&!l.selection.isEmpty)return l.document.getText(l.selection)}},getLineNumber:()=>{if(t){const l=t.activeEditor();if(l)return String(l.selection.end.line+1)}},getExtension:l=>s.getExtension(l)},void 0,b?Promise.resolve(b):void 0,Promise.resolve(T.env))}}let o=class extends N.$Uc{constructor(s,n,t,c,u){super(),this.b=s,this.c=n,this.g=t,this.h=c,this.j=u,this.a=new C.$V(async()=>{const i=await this.h.getConfigProvider(),a={folders:await this.c.getWorkspaceFolders2()||[]};return this.B(this.c.onDidChangeWorkspace(async l=>{a.folders=await this.c.getWorkspaceFolders2()||[]})),new f(this.b,this.c,this.g,this.j,i,a,this.m())})}getResolver(){return this.a.value}m(){}};e.$_mc=o,e.$_mc=o=Je([We(0,D.$8mc),We(1,S.$rmc),We(2,p.$1O),We(3,w.$umc),We(4,m.$Gmc)],o)}),define(Se[123],Ie([1,0,11,5,2,21,3,4,67,41,17,7,39,226,228,40,122,6,36,35,8,18]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$enc=e.$dnc=e.$cnc=e.$bnc=e.$anc=void 0,e.$anc=(0,A.$yi)("IExtHostDebugService");let i=class{get onDidStartDebugSession(){return this.n.event}get onDidTerminateDebugSession(){return this.o.event}get onDidChangeActiveDebugSession(){return this.q.event}get activeDebugSession(){return this.u?.api}get onDidReceiveDebugSessionCustomEvent(){return this.w.event}get activeDebugConsole(){return this.y.value}constructor(y,h,E,k,I,P,V){this.N=h,this.O=E,this.P=k,this.Q=I,this.R=P,this.S=V,this.m=new Map,this.F=0,this.G=new Map,this.H=new Map,this.I=new WeakMap,this.J=new Map,this.L=new Map,this.M=0,this.d=0,this.f=[],this.g=0,this.h=[],this.j=0,this.k=[],this.D=new Map,this.E=new Map,this.n=new N.$fe,this.o=new N.$fe,this.q=new N.$fe,this.w=new N.$fe,this.l=y.getProxy(p.$lM.MainThreadDebugService),this.A=new N.$fe,this.C=new N.$fe,this.y=new a(this.l),this.z=new Map,this.O.getExtensionRegistry().then(W=>{W.onDidChange(q=>{this.V(W)}),this.V(W)})}async $getVisualizerTreeItem(y,h){const E=this.W(h);if(!E)return;const k=await this.H.get(y)?.getTreeItem?.(E);return k?this.U(y,k):void 0}registerDebugVisualizationTree(y,h,E){const k=T.$Tm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.H.set(I,E),this.l.$registerDebugVisualizerTree(I,!!E.editItem),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizerTree(I),this.H.delete(h)})}async $getVisualizerTreeItemChildren(y,h){const E=this.J.get(h)?.item;return E?(await this.H.get(y)?.getChildren?.(E))?.map(I=>this.U(y,I))||[]:[]}async $editVisualizerTreeItem(y,h){const E=this.J.get(y);if(!E)return;const k=await this.H.get(E.provider)?.editItem?.(E.item,h);return this.U(E.provider,k||E.item)}$disposeVisualizedTree(y){const h=this.J.get(y);if(!h)return;const E=[h.children];for(const k of E)if(k)for(const I of k)E.push(this.J.get(I)?.children),this.J.delete(I)}U(y,h){let E=this.I.get(h);return E||(E=this.F++,this.I.set(h,E),this.J.set(E,{provider:y,item:h})),c.DebugTreeItem.from(h,E)}asDebugSourceUri(y,h){const E=y;if(typeof E.sourceReference=="number"&&E.sourceReference>0){let k=`debug:${encodeURIComponent(E.path||"")}`,I="?";return h&&(k+=`${I}session=${encodeURIComponent(h.id)}`,I="&"),k+=`${I}ref=${E.sourceReference}`,M.URI.parse(k)}else{if(E.path)return M.URI.file(E.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}V(y){const h=[];for(const E of y.getAllExtensionDescriptions())if(E.contributes){const k=E.contributes.debuggers;if(k&&k.length>0)for(const I of k)(0,f.$BH)(I)&&h.push(I.type)}this.l.$registerDebugTypes(h)}get activeStackItem(){return this.B}get onDidChangeActiveStackItem(){return this.C.event}get onDidChangeBreakpoints(){return this.A.event}get breakpoints(){const y=[];return this.z.forEach(h=>y.push(h)),y}async $resolveDebugVisualizer(y,h){const E=this.L.get(y);if(!E)throw new Error(`No debug visualizer found with id '${y}'`);let{v:k,provider:I,extensionId:P}=E;if(k.visualization||(k=await I.resolveDebugVisualization?.(k,h)||k,E.v=k),!k.visualization)throw new Error(`No visualization returned from resolveDebugVisualization in '${I}'`);return this.kb(P,k.visualization)}async $executeDebugVisualizerCommand(y){const h=this.L.get(y);if(!h)throw new Error(`No debug visualizer found with id '${y}'`);const E=h.v.visualization;E&&"command"in E&&this.S.executeCommand(E.command,...E.arguments||[])}W(y){const h=this.m.get(y.sessionId);return h&&{session:h.api,variable:y.variable,containerId:y.containerId,frameId:y.frameId,threadId:y.threadId}}async $provideDebugVisualizers(y,h,E,k){const I=this.W(E),P=this.jb(y,h),V=this.G.get(P);if(!I||!V)return[];const W=await V.provideDebugVisualization(I,k);return W?W.map(q=>{const R=++this.M;this.L.set(R,{v:q,provider:V,extensionId:y});const z=q.iconPath?this.lb(q.iconPath):void 0;return{id:R,name:q.name,iconClass:z?.iconClass,iconPath:z?.iconPath,visualization:this.kb(y,q.visualization)}}):[]}$disposeDebugVisualizers(y){for(const h of y)this.L.delete(h)}registerDebugVisualizationProvider(y,h,E){if(!y.contributes?.debugVisualizers?.some(P=>P.id===h))throw new Error(`Extensions may only call registerDebugVisualizationProvider() for renderers they contribute (got ${h})`);const k=T.$Tm.toKey(y.identifier),I=this.jb(k,h);if(this.G.has(I))throw new Error(`A debug visualization provider with id '${h}' is already registered`);return this.G.set(I,E),this.l.$registerDebugVisualizer(k,h),(0,s.$Sc)(()=>{this.l.$unregisterDebugVisualizer(k,h),this.G.delete(h)})}addBreakpoints(y){const h=y.filter(I=>{const P=I.id;return this.z.has(P)?!1:(this.z.set(P,I),!0)});this.gb(h,[],[]);const E=[],k=new Map;for(const I of h)if(I instanceof S.$pN){let P=k.get(I.location.uri.toString());P||(P={type:"sourceMulti",uri:I.location.uri,lines:[]},k.set(I.location.uri.toString(),P),E.push(P)),P.lines.push({id:I.id,enabled:I.enabled,condition:I.condition,hitCondition:I.hitCondition,logMessage:I.logMessage,line:I.location.range.start.line,character:I.location.range.start.character,mode:I.mode})}else I instanceof S.$qN&&E.push({type:"function",id:I.id,enabled:I.enabled,hitCondition:I.hitCondition,logMessage:I.logMessage,condition:I.condition,functionName:I.functionName,mode:I.mode});return this.l.$registerBreakpoints(E)}removeBreakpoints(y){const h=y.filter(P=>this.z.delete(P.id));this.gb([],h,[]);const E=h.filter(P=>P instanceof S.$pN).map(P=>P.id),k=h.filter(P=>P instanceof S.$qN).map(P=>P.id),I=h.filter(P=>P instanceof S.$rN).map(P=>P.id);return this.l.$unregisterBreakpoints(E,k,I)}startDebugging(y,h,E){return this.l.$startDebugging(y?y.uri:void 0,h,{parentSessionID:E.parentSession?E.parentSession.id:void 0,lifecycleManagedByParent:E.lifecycleManagedByParent,repl:E.consoleMode===S.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:E.noDebug,compact:E.compact,suppressSaveBeforeStart:E.suppressSaveBeforeStart,suppressDebugStatusbar:E.suppressDebugStatusbar??E.debugUI?.simple,suppressDebugToolbar:E.suppressDebugToolbar??E.debugUI?.simple,suppressDebugView:E.suppressDebugView??E.debugUI?.simple})}stopDebugging(y){return this.l.$stopDebugging(y?y.id:void 0)}registerDebugConfigurationProvider(y,h,E){if(!h)return new S.$nM(()=>{});const k=this.d++;return this.f.push({type:y,handle:k,provider:h}),this.l.$registerDebugConfigurationProvider(y,E,!!h.provideDebugConfigurations,!!h.resolveDebugConfiguration,!!h.resolveDebugConfigurationWithSubstitutedVariables,k),new S.$nM(()=>{this.f=this.f.filter(I=>I.provider!==h),this.l.$unregisterDebugConfigurationProvider(k)})}registerDebugAdapterDescriptorFactory(y,h,E){if(!E)return new S.$nM(()=>{});if(!this.cb(y,h))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${h}' debugger.`);if(this.$(h))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const k=this.g++;return this.h.push({type:h,handle:k,factory:E}),this.l.$registerDebugAdapterDescriptorFactory(h,k),new S.$nM(()=>{this.h=this.h.filter(I=>I.factory!==E),this.l.$unregisterDebugAdapterDescriptorFactory(k)})}registerDebugAdapterTrackerFactory(y,h){if(!h)return new S.$nM(()=>{});const E=this.j++;return this.k.push({type:y,handle:E,factory:h}),new S.$nM(()=>{this.k=this.k.filter(k=>k.factory!==h)})}async $runInTerminal(y,h){return Promise.resolve(void 0)}async $substituteVariables(y,h){let E;const k=await this.ib(y);return k&&(E={uri:k.uri,name:k.name,index:k.index,toResource:()=>{throw new Error("Not implemented")}}),(await this.R.getResolver()).resolveAnyAsync(E,h)}X(y,h){if(y.type==="implementation")return new g(y.implementation)}Y(){}async $startDASession(y,h){const E=this,k=await this.hb(h);return this.eb(this.$(k.type),k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}' (extension might have failed to activate)`);const P=this.Z(I),V=this.X(P,k);if(!V)throw new Error(`Couldn't create a debug adapter for type '${k.type}'.`);const W=V;return this.D.set(y,W),this.db(k).then(q=>(q&&this.E.set(y,q),W.onMessage(async R=>{if(R.type==="request"&&R.command==="handshake"){const z=R,K={type:"response",seq:0,command:z.command,request_seq:z.seq,success:!0};this.K||(this.K=this.Y());try{if(this.K){const ie=await this.K.sign(z.arguments.value);K.body={signature:ie},W.sendResponse(K)}else throw new Error("no signer")}catch(ie){K.success=!1,K.message=ie.message,W.sendResponse(K)}}else q&&q.onDidSendMessage&&q.onDidSendMessage(R),R=(0,f.$GH)(R,!0),E.l.$acceptDAMessage(y,R)}),W.onError(R=>{q&&q.onError&&q.onError(R),this.l.$acceptDAError(y,R.name,R.message,R.stack)}),W.onExit(R=>{q&&q.onExit&&q.onExit(R??void 0,void 0),this.l.$acceptDAExit(y,R??void 0,void 0)}),q&&q.onWillStartSession&&q.onWillStartSession(),W.startSession()))})}$sendDAMessage(y,h){h=(0,f.$FH)(h,!1);const E=this.E.get(y);E&&E.onWillReceiveMessage&&E.onWillReceiveMessage(h),this.D.get(y)?.sendMessage(h)}$stopDASession(y){const h=this.E.get(y);this.E.delete(y),h&&h.onWillStopSession&&h.onWillStopSession();const E=this.D.get(y);return this.D.delete(y),E?E.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(y){const h=[],E=[],k=[];if(y.added)for(const I of y.added){const P=I.id;if(P&&!this.z.has(P)){let V;if(I.type==="function")V=new S.$qN(I.functionName,I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode);else if(I.type==="data")V=new S.$rN(I.label,I.dataId,I.canPersist,I.enabled,I.hitCondition,I.condition,I.logMessage,I.mode);else{const W=M.URI.revive(I.uri);V=new S.$pN(new S.$zM(W,new S.$oM(I.line,I.character)),I.enabled,I.condition,I.hitCondition,I.logMessage,I.mode)}(0,S.$nN)(V,P),this.z.set(P,V),h.push(V)}}if(y.removed)for(const I of y.removed){const P=this.z.get(I);P&&(this.z.delete(I),E.push(P))}if(y.changed){for(const I of y.changed)if(I.id){const P=this.z.get(I.id);if(P){if(P instanceof S.$qN&&I.type==="function"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.functionName=I.functionName}else if(P instanceof S.$pN&&I.type==="source"){const V=P;V.enabled=I.enabled,V.condition=I.condition,V.hitCondition=I.hitCondition,V.logMessage=I.logMessage,V.location=new S.$zM(M.URI.revive(I.uri),new S.$oM(I.line,I.character))}k.push(P)}}}this.gb(h,E,k)}async $acceptStackFrameFocus(y){let h;if(y){const E=await this.hb(y.sessionId);y.kind==="thread"?h=new S.$xN(E.api,y.threadId):h=new S.$wN(E.api,y.threadId,y.frameId)}this.B=h,this.C.fire(this.B)}$provideDebugConfigurations(y,h,E){return(0,C.$qh)(async()=>{const k=this.bb(y);if(!k)throw new Error("no DebugConfigurationProvider found");if(!k.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const I=await this.ib(h);return k.provideDebugConfigurations(I,E)}).then(k=>{if(!k)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return k})}$resolveDebugConfiguration(y,h,E,k){return(0,C.$qh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const P=await this.ib(h);return I.resolveDebugConfiguration(P,E,k)})}$resolveDebugConfigurationWithSubstitutedVariables(y,h,E,k){return(0,C.$qh)(async()=>{const I=this.bb(y);if(!I)throw new Error("no DebugConfigurationProvider found");if(!I.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const P=await this.ib(h);return I.resolveDebugConfigurationWithSubstitutedVariables(P,E,k)})}async $provideDebugAdapter(y,h){const E=this.ab(y);if(!E)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const k=await this.hb(h);return this.eb(E,k).then(I=>{if(!I)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${k.type}'`);return this.Z(I)})}async $acceptDebugSessionStarted(y){const h=await this.hb(y);this.n.fire(h.api)}async $acceptDebugSessionTerminated(y){const h=await this.hb(y);h&&(this.o.fire(h.api),this.m.delete(h.id))}async $acceptDebugSessionActiveChanged(y){this.u=y?await this.hb(y):void 0,this.q.fire(this.u?.api)}async $acceptDebugSessionNameChanged(y,h){(await this.hb(y))?._acceptNameChanged(h)}async $acceptDebugSessionCustomEvent(y,h){const k={session:(await this.hb(y)).api,event:h.event,body:h.body};this.w.fire(k)}Z(y){if(y instanceof S.$sN)return{type:"executable",command:y.command,args:y.args,options:y.options};if(y instanceof S.$tN)return{type:"server",port:y.port,host:y.host};if(y instanceof S.$uN)return{type:"pipeServer",path:y.path};if(y instanceof S.$vN)return{type:"implementation",implementation:y.implementation};throw new Error("convertToDto unexpected type")}$(y){const h=this.h.filter(E=>E.type===y);if(h.length>0)return h[0].factory}ab(y){const h=this.h.filter(E=>E.handle===y);if(h.length>0)return h[0].factory}bb(y){const h=this.f.filter(E=>E.handle===y);if(h.length>0)return h[0].provider}cb(y,h){if(y.contributes){const E=y.contributes.debuggers;if(E&&E.length>0){for(const k of E)if(k.label&&k.type&&k.type===h)return!0}}return!1}db(y){const E=y.configuration.type,k=this.k.filter(I=>I.type===E||I.type==="*").map(I=>(0,C.$qh)(()=>I.factory.createDebugAdapterTracker(y.api)).then(P=>P,P=>null));return Promise.race([Promise.all(k).then(I=>{const P=(0,u.$Hb)(I);if(P.length>0)return new l(P)}),new Promise(I=>setTimeout(()=>I(void 0),1e3))]).catch(I=>{})}async eb(y,h){const E=h.configuration.debugServer;if(typeof E=="number")return Promise.resolve(new S.$tN(E));if(y){const I=await this.O.getExtensionRegistry();return(0,C.$qh)(()=>y.createDebugAdapterDescriptor(h.api,this.fb(h,I))).then(P=>{if(P)return P})}const k=await this.O.getExtensionRegistry();return Promise.resolve(this.fb(h,k))}fb(y,h){}gb(y,h,E){(y.length>0||h.length>0||E.length>0)&&this.A.fire(Object.freeze({added:y,removed:h,changed:E}))}async hb(y){if(y)if(typeof y=="string"){const h=this.m.get(y);if(h)return h}else{let h=this.m.get(y.id);if(!h){const E=await this.ib(y.folderUri),k=y.parent?this.m.get(y.parent):void 0;h=new b(this.l,y.id,y.type,y.name,E,y.configuration,k?.api),this.m.set(h.id,h),this.l.$sessionCached(h.id)}return h}throw new Error("cannot find session")}ib(y){if(y){const h=M.URI.revive(y);return this.N.resolveWorkspaceFolder(h)}return Promise.resolve(void 0)}jb(y,h){return`${y}\0${h}`}kb(y,h){if(h){if("title"in h&&"command"in h)return{type:0};if("treeId"in h)return{type:1,id:`${y}\0${h.treeId}`};throw new Error("Unsupported debug visualization type")}}lb(y){const h=this.mb(y);let E,k;return"id"in h?k=n.ThemeIcon.asClassName(h):E=h,{iconPath:E,iconClass:k}}mb(y){if(y instanceof S.$kN)return{id:y.id};const h=typeof y=="object"&&"dark"in y?y.dark:y,E=typeof y=="object"&&"light"in y?y.light:y;return{dark:typeof h=="string"?M.URI.file(h):h,light:typeof E=="string"?M.URI.file(E):E}}};e.$bnc=i,e.$bnc=i=Je([We(0,O.$PO),We(1,d.$rmc),We(2,D.$8mc),We(3,o.$umc),We(4,m.$Gmc),We(5,r.$$mc),We(6,t.$_O)],i);class b{constructor(y,h,E,k,I,P,V){this.f=y,this.g=h,this.h=E,this.j=k,this.k=I,this.l=P,this.m=V}get api(){const y=this;return this.d??=Object.freeze({id:y.g,type:y.h,get name(){return y.j},set name(h){y.j=h,y.f.$setDebugSessionName(y.g,h)},parentSession:y.m,workspaceFolder:y.k,configuration:y.l,customRequest(h,E){return y.f.$customDebugAdapterRequest(y.g,h,E)},getDebugProtocolBreakpoint(h){return y.f.$getDebugProtocolBreakpoint(y.g,h.id)}})}get id(){return this.g}get type(){return this.h}_acceptNameChanged(y){this.j=y}get configuration(){return this.l}}e.$cnc=b;class a{constructor(y){this.value=Object.freeze({append(h){y.$appendDebugConsole(h)},appendLine(h){this.append(h+`
`)}})}}e.$dnc=a;class l{constructor(y){this.d=y}onWillStartSession(){this.d.forEach(y=>y.onWillStartSession?y.onWillStartSession():void 0)}onWillReceiveMessage(y){this.d.forEach(h=>h.onWillReceiveMessage?h.onWillReceiveMessage(y):void 0)}onDidSendMessage(y){this.d.forEach(h=>h.onDidSendMessage?h.onDidSendMessage(y):void 0)}onWillStopSession(){this.d.forEach(y=>y.onWillStopSession?y.onWillStopSession():void 0)}onError(y){this.d.forEach(h=>h.onError?h.onError(y):void 0)}onExit(y,h){this.d.forEach(E=>E.onExit?E.onExit(y,h):void 0)}}class g extends w.$ssb{constructor(y){super(),this.h=y,y.onDidSendMessage(h=>{this.acceptMessage(h)})}startSession(){return Promise.resolve(void 0)}sendMessage(y){this.h.handleMessage(y)}stopSession(){return this.h.dispose(),Promise.resolve(void 0)}}let $=class extends i{constructor(y,h,E,k,I,P,V){super(y,h,E,k,I,P,V)}};e.$enc=$,e.$enc=$=Je([We(0,O.$PO),We(1,d.$rmc),We(2,D.$8mc),We(3,o.$umc),We(4,m.$Gmc),We(5,r.$$mc),We(6,t.$_O)],$)}),define(Se[305],Ie([1,0,14,60,2,4,255,12,56,72,27,199,17,61,41,63]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$ioc=e.$hoc=void 0;class r{static async installEarlyHandler(t){Error.stackTraceLimit=100;const c=t.get(p.$5j),i=t.get(d.$PO).getProxy(T.$lM.MainThreadErrors);C.setUnexpectedErrorHandler(b=>{c.error(b);const a=C.$3(b);i.$onUnexpectedError(a)})}static async installFullHandler(t){const c=t.get(p.$5j),u=t.get(d.$PO),i=t.get(f.$8mc),b=t.get(o.$0O),a=u.getProxy(T.$lM.MainThreadExtensionService),l=u.getProxy(T.$lM.MainThreadErrors),g=await i.getExtensionPathIndex(),$=new WeakMap;function v(E,k){if($.has(E))return $.get(E).stack;let I="",P,V;for(const q of k)I+=`
	at ${q.toString()}`,V=q.getFileName(),!P&&V&&(P=g.findSubstr(M.URI.file(V)));const W=`${E.name||"Error"}: ${E.message||""}${I}`;return $.set(E,{extensionIdentifier:P?.identifier,stack:W}),W}const y=Symbol("prepareStackTrace wrapped");let h=v;Object.defineProperty(Error,"prepareStackTrace",{configurable:!1,get(){return h},set(E){if(E===v||!E||E[y]){h=E||v;return}h=function(k,I){return v(k,I),E.call(Error,k,I)},Object.assign(h,{[y]:!0})}}),C.setUnexpectedErrorHandler(E=>{c.error(E);const k=C.$3(E),I=$.get(E);if(!I?.extensionIdentifier){l.$onUnexpectedError(k);return}a.$onExtensionRuntimeError(I.extensionIdentifier,k);const P=b.onExtensionError(I.extensionIdentifier,E);c.trace("forwarded error to extension?",P,I)})}}e.$hoc=r;class s{constructor(t,c,u,i,b){this.a=u,this.b=new A.$Oac(t,null,i),c=s.e(c,this.b);const a=new D.$wi(...(0,m.$Ds)());a.set(O.$6O,{_serviceBrand:void 0,...c,messagePorts:b}),a.set(d.$PO,new d.$QO(this.b)),a.set(w.$omc,new w.$pmc(i)),a.set(f.$6mc,u);const l=new S.$hr(a,!0);l.invokeFunction(r.installEarlyHandler),this.d=l.invokeFunction(g=>g.get(p.$5j)),N.mark("code/extHost/didCreateServices"),this.a.pid?this.d.info(`Extension host with pid ${this.a.pid} started`):this.d.info("Extension host started"),this.d.trace("initData",c),this.c=l.invokeFunction(g=>g.get(f.$8mc)),this.c.initialize(),l.invokeFunction(r.installFullHandler)}async asBrowserUri(t){const c=this.b.getProxy(T.$lM.MainThreadExtensionService);return M.URI.revive(await c.$asBrowserUri(t))}terminate(t){this.c.terminate(t)}static e(t,c){t.extensions.allExtensions.forEach(i=>{i.extensionLocation=M.URI.revive(c.transformIncomingURIs(i.extensionLocation))}),t.environment.appRoot=M.URI.revive(c.transformIncomingURIs(t.environment.appRoot));const u=t.environment.extensionDevelopmentLocationURI;return u&&(t.environment.extensionDevelopmentLocationURI=u.map(i=>M.URI.revive(c.transformIncomingURIs(i)))),t.environment.extensionTestsLocationURI=M.URI.revive(c.transformIncomingURIs(t.environment.extensionTestsLocationURI)),t.environment.globalStorageHome=M.URI.revive(c.transformIncomingURIs(t.environment.globalStorageHome)),t.environment.workspaceStorageHome=M.URI.revive(c.transformIncomingURIs(t.environment.workspaceStorageHome)),t.environment.extensionTelemetryLogResource=M.URI.revive(c.transformIncomingURIs(t.environment.extensionTelemetryLogResource)),t.nlsBaseUrl=M.URI.revive(c.transformIncomingURIs(t.nlsBaseUrl)),t.logsLocation=M.URI.revive(c.transformIncomingURIs(t.logsLocation)),t.workspace=c.transformIncomingURIs(t.workspace),t}}e.$ioc=s}),define(Se[306],Ie([1,0,18,11,20,44,16,19,24,2,48]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$vnc=e.$tnc=e.$snc=void 0,e.$unc=o;class S{constructor(n,t,c){this.d=n,this.e=t,this.f=c,this.a=null,this.b=!1,this.c=0}get g(){return this.d.query}search(n,t){const c=this.g.folderQueries||[],u=new M.$qe(t);return new Promise((i,b)=>{this.a=new w(n);let a=!1;const l=(g,$)=>{if(!a&&!this.b){const v=this.h(g);o(g)&&typeof this.g.maxResults=="number"&&this.c+v>this.g.maxResults&&(this.b=!0,a=!0,u.cancel(),g=this.j(g,this.g.maxResults-this.c));const y=this.h(g);this.c+=y,(y>0||!o(g))&&this.a.add(g,$)}};Promise.all(c.map((g,$)=>this.k(g,v=>l(v,$),u.token))).then(g=>{u.dispose(),this.a.flush();const $=g.some(v=>!!v&&!!v.limitHit);i({limitHit:this.b||$,messages:g.flatMap(v=>v?.message?Array.isArray(v.message)?v.message:[v.message]:[]),stats:{type:this.f}})},g=>{u.dispose();const $=(0,T.$jj)(g);b(new Error($))})})}h(n){return o(n)?Array.isArray(n.ranges)?n.ranges.length:1:0}j(n,t){const c=Array.isArray(n.ranges)?n.ranges:[n.ranges],u=Array.isArray(n.preview.matches)?n.preview.matches:[n.preview.matches];return{ranges:c.slice(0,t),preview:{matches:u.slice(0,t),text:n.preview.text},uri:n.uri}}async k(n,t,c){const u=new O.$RK(this.g,n),i=[],b={report:g=>{if(!this.l(g))return;const $=n.folder.scheme===A.Schemas.file?(0,O.$SK)(()=>this.e.readdir(m.$$g(g.uri))):void 0,v=m.$bh(n.folder,g.uri);if(v){const y=u.includedInQuery(v,p.$nc(v),$);(0,N.$kh)(y)?i.push(y.then(h=>{h&&t(g)})):y&&t(g)}}},a=this.n(n);let l;return this.d.query.type===3?l=await this.d.provider.provideAITextSearchResults(this.d.query.contentPattern,a,b,c):l=await this.d.provider.provideTextSearchResults(d(this.d.query.contentPattern),a,b,c),i.length&&await Promise.all(i),l}l(n){if(o(n)){if(Array.isArray(n.ranges)){if(!Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(n.preview.matches.length!==n.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(n.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}n(n){const t=(0,O.$QK)(this.g.includePattern,n.includePattern),c=(0,O.$QK)(this.g.excludePattern,n.excludePattern),u={folder:D.URI.from(n.folder),excludes:c,includes:t,useIgnoreFiles:!n.disregardIgnoreFiles,useGlobalIgnoreFiles:!n.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!n.disregardParentIgnoreFiles,followSymlinks:!n.ignoreSymlinks,encoding:n.fileEncoding&&this.e.toCanonicalName(n.fileEncoding),maxFileSize:this.g.maxFileSize,maxResults:this.g.maxResults??Number.MAX_SAFE_INTEGER,previewOptions:this.g.previewOptions,afterContext:this.g.afterContext,beforeContext:this.g.beforeContext};return"usePCRE2"in this.g&&(u.usePCRE2=this.g.usePCRE2),u}}e.$snc=S;function d(s){return{isCaseSensitive:s.isCaseSensitive||!1,isRegExp:s.isRegExp||!1,isWordMatch:s.isWordMatch||!1,isMultiline:s.isMultiline||!1,pattern:s.pattern}}class w{constructor(n){this.e=n,this.b=-1,this.d=null,this.a=new r(512,t=>this.g(t))}add(n,t){this.d&&(this.b!==t||!m.$5g(this.c,n.uri))&&(this.f(),this.d=null),this.d||(this.b=t,this.d={resource:n.uri,results:[]}),this.d.results.push(f(n))}f(){const n=this.d&&this.d.results?this.d.results.length:0;this.a.addItem(this.d,n)}flush(){this.f(),this.a.flush()}g(n){this.e(n)}}e.$tnc=w;function f(s){return o(s)?{preview:{matches:(0,C.$1b)(s.preview.matches,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character})),text:s.preview.text},ranges:(0,C.$1b)(s.ranges,n=>({startLineNumber:n.start.line,startColumn:n.start.character,endLineNumber:n.end.line,endColumn:n.end.character}))}:{text:s.text,lineNumber:s.lineNumber}}function o(s){return!!s.preview}class r{static{this.a=4e3}static{this.b=50}constructor(n,t){this.g=n,this.h=t,this.c=0,this.d=[],this.e=0}addItem(n,t){n&&this.j(n,t)}addItems(n,t){n&&this.k(n,t)}j(n,t){this.d.push(n),this.e+=t,this.l()}k(n,t){this.d=this.d.concat(n),this.e+=t,this.l()}l(){this.c<r.b?this.flush():this.e>=this.g?this.flush():this.f||(this.f=setTimeout(()=>{this.flush()},r.a))}flush(){this.e&&(this.c+=this.e,this.h(this.d),this.d=[],this.e=0,this.f&&(clearTimeout(this.f),this.f=0))}}e.$vnc=r}),define(Se[124],Ie([1,0,6,4,3,301,17,61,12,2,306]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$xnc=e.$wnc=void 0,e.$ync=d,e.$wnc=(0,M.$yi)("IExtHostSearch");let S=class{constructor(o,r,s){this.n=o,this.o=r,this.q=s,this.c=this.n.getProxy(N.$lM.MainThreadSearch),this.d=0,this.e=new Map,this.g=new Set,this.h=new Map,this.i=new Set,this.j=new Map,this.k=new Set,this.l=new T.$rnc}s(o){return this.o.transformOutgoingScheme(o)}registerTextSearchProvider(o,r){if(this.g.has(o))throw new Error(`a text search provider for the scheme '${o}' is already registered`);this.g.add(o);const s=this.d++;return this.e.set(s,r),this.c.$registerTextSearchProvider(s,this.s(o)),(0,C.$Sc)(()=>{this.g.delete(o),this.e.delete(s),this.c.$unregisterProvider(s)})}registerAITextSearchProvider(o,r){if(this.i.has(o))throw new Error(`an AI text search provider for the scheme '${o}'is already registered`);this.i.add(o);const s=this.d++;return this.h.set(s,r),this.c.$registerAITextSearchProvider(s,this.s(o)),(0,C.$Sc)(()=>{this.i.delete(o),this.h.delete(s),this.c.$unregisterProvider(s)})}registerFileSearchProvider(o,r){if(this.k.has(o))throw new Error(`a file search provider for the scheme '${o}' is already registered`);this.k.add(o);const s=this.d++;return this.j.set(s,r),this.c.$registerFileSearchProvider(s,this.s(o)),(0,C.$Sc)(()=>{this.k.delete(o),this.j.delete(s),this.c.$unregisterProvider(s)})}$provideFileSearchResults(o,r,s,n){const t=d(s),c=this.j.get(o);if(c)return this.l.fileSearch(t,c,u=>{this.c.$handleFileMatch(o,r,u.map(i=>i.resource))},n);throw new Error("3 unknown provider: "+o)}async doInternalFileSearchWithCustomCallback(o,r,s){return{messages:[]}}$clearCache(o){return this.l.clearCache(o),Promise.resolve(void 0)}$provideTextSearchResults(o,r,s,n){const t=this.e.get(o);if(!t||!t.provideTextSearchResults)throw new Error(`2 Unknown provider ${o}`);const c=d(s);return this.t(c,t).search(i=>this.c.$handleTextMatch(o,r,i),n)}$provideAITextSearchResults(o,r,s,n){const t=this.h.get(o);if(!t||!t.provideAITextSearchResults)throw new Error(`1 Unknown provider ${o}`);const c=d(s);return this.v(c,t).search(i=>this.c.$handleTextMatch(o,r,i),n)}$enableExtensionHostSearch(){}t(o,r){return new O.$snc({query:o,provider:r},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"textSearchProvider")}v(o,r){return new O.$snc({query:o,provider:r},{readdir:s=>Promise.resolve([]),toCanonicalName:s=>s},"aiTextSearchProvider")}};e.$xnc=S,e.$xnc=S=Je([We(0,A.$PO),We(1,p.$omc),We(2,m.$5j)],S);function d(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(w),extraFileResources:f.extraFileResources&&f.extraFileResources.map(o=>D.URI.revive(o))}}function w(f){return{...f,folder:D.URI.revive(f.folder)}}}),define(Se[307],Ie([1,0,20,14,5,6,16,32,2,158,154,141,95,21,38,12,58,59,213,4,258,286,80,86,263,264,265,243,232,35,266,40,267,123,112,268,245,259,269,270,68,67,246,260,41,272,65,273,47,27,287,247,274,90,275,81,82,249,300,277,219,278,288,279,118,250,280,281,282,17,283,124,83,284,251,285,84,87,121,63,53,116,289,290,261,291,292,88,8,7,252,61,253,64,293,294,111,39,227,79,25,120]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u,i,b,a,l,g,$,v,y,h,E,k,I,P,V,W,q,R,z,K,ie,de,ye,De,ge,ue,Ce,se,Ne,ne,U,x,ve,Le,ke,be,me,Q,Y,he,ce,Te,fe,Pe,Re,je,B,F,H,G,te,re,Oe,Be,Ge,_e,xe,et,tt,it,at,gt,Ue,rt,Z,X,$e,He,we,st,dt,Ct,Vt,Qt,ii,Xt,Et,Zt,Yt,Ze,si){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$coc=Gt;function Gt(ht){const mt=ht.get(Ne.$6O),xt=ht.get(se.$_lc),Kt=ht.get(ue.$wmc),Tt=ht.get(De.$8mc),ft=ht.get(Et.$rmc),Bt=ht.get(tt.$0O),_t=ht.get(E.$umc),zt=ht.get(dt.$omc),Qe=ht.get(H.$PO),ui=ht.get(_e.$Pmc),Jt=ht.get(xe.$xmc),Ut=ht.get(o.$6j),bt=ht.get(o.$5j),jt=ht.get($e.$1Db),Mt=ht.get(i.$8lc),At=ht.get(Xt.$boc),ei=ht.get(re.$Zmc),Wt=ht.get(ie.$Gmc),oi=ht.get(be.$4mc),Nt=ht.get(b.$fmc),qt=ht.get(ve.$Wmc);Qe.set(t.$mM.ExtHostFileSystemInfo,xt),Qe.set(t.$mM.ExtHostLogLevelServiceShape,Ut),Qe.set(t.$mM.ExtHostWorkspace,ft),Qe.set(t.$mM.ExtHostConfiguration,_t),Qe.set(t.$mM.ExtHostExtensionService,Tt),Qe.set(t.$mM.ExtHostStorage,ui),Qe.set(t.$mM.ExtHostTunnelService,jt),Qe.set(t.$mM.ExtHostWindow,At),Qe.set(t.$mM.ExtHostSecretState,ei),Qe.set(t.$mM.ExtHostTelemetry,Bt),Qe.set(t.$mM.ExtHostEditorTabs,Wt),Qe.set(t.$mM.ExtHostManagedSockets,oi),Qe.set(t.$mM.ExtHostAuthentication,Nt),Qe.set(t.$mM.ExtHostChatProvider,qt);const Rt=Qe.set(t.$mM.ExtHostDecorations,ht.get(P.$gnc)),St=Qe.set(t.$mM.ExtHostDocumentsAndEditors,ht.get(K.$1O)),$t=Qe.set(t.$mM.ExtHostCommands,ht.get(y.$_O)),Dt=Qe.set(t.$mM.ExtHostTerminalService,ht.get(it.$Smc)),ai=Qe.set(t.$mM.ExtHostTerminalShellIntegration,ht.get(at.$Znc)),kt=Qe.set(t.$mM.ExtHostDebugService,ht.get(I.$anc)),fi=Qe.set(t.$mM.ExtHostSearch,ht.get(te.$wnc)),ni=Qe.set(t.$mM.ExtHostTask,ht.get(et.$Ync)),$i=Qe.set(t.$mM.ExtHostOutputService,ht.get(Pe.$Lnc)),li=Qe.set(t.$mM.ExtHostLocalization,ht.get(ke.$3mc)),wi=Qe.set(t.$mM.ExtHostUrls,new Ct.$$nc(Qe)),It=Qe.set(t.$mM.ExtHostDocuments,new z.$cmc(Qe,St)),Ei=Qe.set(t.$mM.ExtHostDocumentContentProviders,new q.$inc(Qe,St,bt)),ri=Qe.set(t.$mM.ExtHostDocumentSaveParticipant,new R.$jnc(bt,It,Qe.getProxy(t.$lM.MainThreadBulkEdits))),pe=Qe.set(t.$mM.ExtHostNotebook,new Q.$znc(Qe,$t,St,It,Kt,fi)),Ae=Qe.set(t.$mM.ExtHostNotebookDocuments,new he.$Fnc(pe)),ae=Qe.set(t.$mM.ExtHostNotebookEditors,new ce.$Gnc(bt,pe)),J=Qe.set(t.$mM.ExtHostNotebookKernels,new Te.$Hnc(Qe,mt,pe,$t,bt)),Me=Qe.set(t.$mM.ExtHostNotebookRenderers,new fe.$Jnc(Qe,pe)),Ve=Qe.set(t.$mM.ExtHostNotebookDocumentSaveParticipant,new Y.$Enc(bt,pe,Qe.getProxy(t.$lM.MainThreadBulkEdits))),Xe=Qe.set(t.$mM.ExtHostEditors,new Ue.$lmc(Qe,St)),qe=Qe.set(t.$mM.ExtHostTreeViews,new X.$9nc(Qe.getProxy(t.$lM.MainThreadTreeViews),$t,bt)),ut=Qe.set(t.$mM.ExtHostEditorInsets,new v.$mmc(Qe.getProxy(t.$lM.MainThreadEditorInsets),Xe,mt.remote)),yt=Qe.set(t.$mM.ExtHostDiagnostics,new V.$bmc(Qe,bt,xt,St)),Lt=Qe.set(t.$mM.ExtHostLanguages,new Le.$Cnc(Qe,It,$t.converter,zt)),ct=Qe.set(t.$mM.ExtHostLanguageFeatures,new x.$dmc(Qe,zt,It,$t,yt,bt,Mt,Bt)),Ot=Qe.set(t.$mM.ExtHostFileSystem,new ge.$mnc(Qe,ct)),Ft=Qe.set(t.$mM.ExtHostFileSystemEventService,new Ce.$nnc(Qe,bt,St)),Di=Qe.set(t.$mM.ExtHostQuickOpen,(0,F.$Pnc)(Qe,ft,$t)),Ii=Qe.set(t.$mM.ExtHostSCM,new G.$Rnc(Qe,$t,It,bt)),Ji=Qe.set(t.$mM.ExtHostQuickDiff,new B.$Onc(Qe,zt)),Ni=Qe.set(t.$mM.ExtHostShare,new Oe.$Snc(Qe,zt)),Oi=Qe.set(t.$mM.ExtHostComments,(0,h.$nmc)(Qe,$t,It)),Ci=Qe.set(t.$mM.ExtHostProgress,new je.$Nnc(Qe.getProxy(t.$lM.MainThreadProgress))),Ti=Qe.set(t.$mM.ExtHostLabelService,new U.$Bnc(Qe)),Li=Qe.set(t.$mM.ExtHostTheming,new rt.$6nc(Qe)),Qi=Qe.set(t.$mM.ExtHostTimeline,new Z.$8nc(Qe,$t)),Fi=Qe.set(t.$mM.ExtHostWebviews,new Vt.$Bmc(Qe,mt.remote,ft,bt,Mt)),Pi=Qe.set(t.$mM.ExtHostWebviewPanels,new Qt.$Emc(Qe,Fi,ft)),zi=Qe.set(t.$mM.ExtHostCustomEditors,new k.$Fmc(Qe,It,Jt,Fi,Pi)),Ui=Qe.set(t.$mM.ExtHostWebviewViews,new ii.$_nc(Qe,Fi)),vi=Qe.set(t.$mM.ExtHostTesting,new gt.$2nc(Qe,bt,$t,St)),Xi=Qe.set(t.$mM.ExtHostUriOpeners,new st.$0nc(Qe)),Zi=Qe.set(t.$mM.ExtHostProfileContentHandlers,new Re.$Mnc(Qe));Qe.set(t.$mM.ExtHostInteractive,new ne.$Anc(Qe,pe,St,$t,bt));const Mi=Qe.set(t.$mM.ExtHostChatAgents2,new l.$imc(Qe,bt,$t)),Yi=Qe.set(t.$mM.ExtHostChatVariables,new g.$jmc(Qe)),ji=Qe.set(t.$mM.ExtHostAiRelatedInformation,new c.$7lc(Qe)),gn=Qe.set(t.$mM.ExtHostAiEmbeddingVector,new ye.$lnc(Qe)),xi=Qe.set(t.$mM.ExtHostStatusBar,new Ge.$Vnc(Qe,$t.converter)),Bi=Qe.set(t.$mM.ExtHostSpeech,new Be.$Tnc(Qe)),pi=Qe.set(t.$mM.ExtHostEmbeddings,new de.$knc(Qe)),mn=Object.values(t.$mM);Qe.assertRegistered(mn);const $n=new a.$hmc(Qe,St),_i=new $.$kmc(Qe),Vi=new me.$Dnc(Qe,bt),Ri=new W.$hnc(Qe);return u.$emc.register($t),function(ze,hi,Wi){function nt(_){return(oe,Fe,ot)=>{const vt=_(Pt=>{try{oe.call(Fe,Pt)}catch(Si){N.$2(new Error(`[ExtensionListenerError] Extension '${ze.identifier.value}' FAILED to handle event: ${Si.toString()}`,{cause:Si})),Bt.onExtensionError(ze.identifier,Si)}});return ot?.push(vt),vt}}const wt=function(){let _=!ze.isUnderDevelopment;function oe(){_||(bt.info(`Extension '${ze.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),_=!0)}return function Fe(ot){if(Array.isArray(ot))ot.forEach(Fe);else if(typeof ot=="string")oe();else{const vt=ot;typeof vt.scheme>"u"&&oe(),typeof vt.exclusive=="boolean"&&(0,Ze.$MG)(ze,"documentFiltersExclusive")}return ot}}(),en={getSession(_,oe,Fe){return typeof Fe?.forceNewSession=="object"&&Fe.forceNewSession.learnMore&&(0,Ze.$MG)(ze,"authLearnMore"),Nt.getSession(ze,_,oe,Fe)},getSessions(_,oe){return(0,Ze.$MG)(ze,"authGetSessions"),Nt.getSessions(ze,_,oe)},async hasSession(_,oe){return(0,Ze.$MG)(ze,"authSession"),!!await Nt.getSession(ze,_,oe,{silent:!0})},get onDidChangeSessions(){return nt(Nt.onDidChangeSessions)},registerAuthenticationProvider(_,oe,Fe,ot){return Nt.registerAuthenticationProvider(_,oe,Fe,ot)}},gi={registerCommand(_,oe,Fe){return $t.registerCommand(!0,_,oe,Fe,void 0,ze)},registerTextEditorCommand(_,oe,Fe){return $t.registerCommand(!0,_,(...ot)=>{const vt=Xe.getActiveTextEditor();if(!vt){bt.warn("Cannot execute "+_+" because there is no active text editor.");return}return vt.edit(Pt=>{oe.apply(Fe,[vt,Pt,...ot])}).then(Pt=>{Pt||bt.warn("Edits from command "+_+" were not applied.")},Pt=>{bt.warn("An error occurred while running command "+_,Pt)})},void 0,void 0,ze)},registerDiffInformationCommand:(_,oe,Fe)=>((0,Ze.$MG)(ze,"diffCommand"),$t.registerCommand(!0,_,async(...ot)=>{const vt=St.activeEditor(!0);if(!vt){bt.warn("Cannot execute "+_+" because there is no active text editor.");return}const Pt=await Xe.getDiffInformation(vt.id);oe.apply(Fe,[Pt,...ot])},void 0,void 0,ze)),executeCommand(_,...oe){return $t.executeCommand(_,...oe)},getCommands(_=!1){return $t.getCommands(_)}},ki={get machineId(){return mt.telemetryInfo.machineId},get sessionId(){return mt.telemetryInfo.sessionId},get language(){return mt.environment.appLanguage},get appName(){return mt.environment.appName},get appRoot(){return mt.environment.appRoot?.fsPath??""},get appHost(){return mt.environment.appHost},get uriScheme(){return mt.environment.appUriScheme},get clipboard(){return _i.value},get shell(){return Dt.getDefaultShell(!1)},get onDidChangeShell(){return nt(Dt.onDidChangeShell)},get isTelemetryEnabled(){return Bt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return nt(Bt.onDidChangeTelemetryEnabled)},get telemetryConfiguration(){return(0,Ze.$MG)(ze,"telemetry"),Bt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,Ze.$MG)(ze,"telemetry"),nt(Bt.onDidChangeTelemetryConfiguration)},get isNewAppInstall(){return(0,tt.$9O)(mt.telemetryInfo.firstSessionDate)},createTelemetryLogger(_,oe){return tt.$8O.validateSender(_),Bt.instantiateLogger(ze,_,oe)},openExternal(_,oe){return At.openUri(_,{allowTunneling:!!mt.remote.authority,allowContributedOpeners:oe?.allowContributedOpeners})},async asExternalUri(_){if(_.scheme===mt.environment.appUriScheme)return wi.createAppUri(_);try{return await At.asExternalUri(_,{allowTunneling:!!mt.remote.authority})}catch(oe){if((0,A.$Hg)(_,A.Schemas.http)||(0,A.$Hg)(_,A.Schemas.https))return _;throw oe}},get remoteName(){return(0,r.$Km)(mt.remote.authority)},get remoteAuthority(){return(0,Ze.$MG)(ze,"resolvers"),mt.remote.authority},get uiKind(){return mt.uiKind},get logLevel(){return bt.getLevel()},get onDidChangeLogLevel(){return nt(bt.onDidChangeLogLevel)},get appQuality(){return(0,Ze.$MG)(ze,"resolvers"),mt.quality},get appCommit(){return(0,Ze.$MG)(ze,"resolvers"),mt.commit}};mt.environment.extensionTestsLocationURI||Object.freeze(ki);const pn={createTestController(_,oe,Fe){return vi.createTestController(ze,_,oe,Fe)},createTestObserver(){return(0,Ze.$MG)(ze,"testObserver"),vi.createTestObserver()},runTests(_){return(0,Ze.$MG)(ze,"testObserver"),vi.runTests(_)},get onDidChangeTestResults(){return(0,Ze.$MG)(ze,"testObserver"),nt(vi.onResultsChanged)},get testResults(){return(0,Ze.$MG)(ze,"testObserver"),vi.results}},ti=mt.remote.isRemote?we.ExtensionKind.Workspace:we.ExtensionKind.UI,Ai={getExtension(_,oe){(0,Ze.$LG)(ze,"extensionsAny")||(oe=!1);const Fe=hi.mine.getExtensionDescription(_);if(Fe)return new De.$9mc(Tt,ze.identifier,Fe,ti,!1);if(oe){const ot=hi.all.getExtensionDescription(_);if(ot)return new De.$9mc(Tt,ze.identifier,ot,ti,!0)}},get all(){const _=[];for(const oe of hi.mine.getAllExtensionDescriptions())_.push(new De.$9mc(Tt,ze.identifier,oe,ti,!1));return _},get allAcrossExtensionHosts(){(0,Ze.$MG)(ze,"extensionsAny");const _=new w.$Um(hi.mine.getAllExtensionDescriptions().map(Fe=>Fe.identifier)),oe=[];for(const Fe of hi.all.getAllExtensionDescriptions()){const ot=!_.has(Fe.identifier);oe.push(new De.$9mc(Tt,ze.identifier,Fe,ti,ot))}return oe},get onDidChange(){return(0,Ze.$LG)(ze,"extensionsAny")?nt(M.Event.any(hi.mine.onDidChange,hi.all.onDidChange)):nt(hi.mine.onDidChange)}},tn={createDiagnosticCollection(_){return yt.createDiagnosticCollection(ze.identifier,_)},get onDidChangeDiagnostics(){return nt(yt.onDidChangeDiagnostics)},getDiagnostics:_=>yt.getDiagnostics(_),getLanguages(){return Lt.getLanguages()},setTextDocumentLanguage(_,oe){return Lt.changeLanguage(_.uri,oe)},match(_,oe){const Fe=He.LanguageSelector.from(_);let ot;return(0,O.$hu)(Fe)&&(ot=pe.notebookDocuments.find(vt=>vt.apiNotebook.getCells().find(Pt=>Pt.document===oe))?.apiNotebook),(0,O.$gu)(Fe,oe.uri,oe.languageId,!0,ot?.uri,ot?.notebookType)},registerCodeActionsProvider(_,oe,Fe){return ct.registerCodeActionProvider(ze,wt(_),oe,Fe)},registerDocumentPasteEditProvider(_,oe,Fe){return(0,Ze.$MG)(ze,"documentPaste"),ct.registerDocumentPasteEditProvider(ze,wt(_),oe,Fe)},registerCodeLensProvider(_,oe){return ct.registerCodeLensProvider(ze,wt(_),oe)},registerDefinitionProvider(_,oe){return ct.registerDefinitionProvider(ze,wt(_),oe)},registerDeclarationProvider(_,oe){return ct.registerDeclarationProvider(ze,wt(_),oe)},registerImplementationProvider(_,oe){return ct.registerImplementationProvider(ze,wt(_),oe)},registerTypeDefinitionProvider(_,oe){return ct.registerTypeDefinitionProvider(ze,wt(_),oe)},registerHoverProvider(_,oe){return ct.registerHoverProvider(ze,wt(_),oe,ze.identifier)},registerEvaluatableExpressionProvider(_,oe){return ct.registerEvaluatableExpressionProvider(ze,wt(_),oe,ze.identifier)},registerInlineValuesProvider(_,oe){return ct.registerInlineValuesProvider(ze,wt(_),oe,ze.identifier)},registerDocumentHighlightProvider(_,oe){return ct.registerDocumentHighlightProvider(ze,wt(_),oe)},registerMultiDocumentHighlightProvider(_,oe){return ct.registerMultiDocumentHighlightProvider(ze,wt(_),oe)},registerLinkedEditingRangeProvider(_,oe){return ct.registerLinkedEditingRangeProvider(ze,wt(_),oe)},registerReferenceProvider(_,oe){return ct.registerReferenceProvider(ze,wt(_),oe)},registerRenameProvider(_,oe){return ct.registerRenameProvider(ze,wt(_),oe)},registerNewSymbolNamesProvider(_,oe){return(0,Ze.$MG)(ze,"newSymbolNamesProvider"),ct.registerNewSymbolNamesProvider(ze,wt(_),oe)},registerDocumentSymbolProvider(_,oe,Fe){return ct.registerDocumentSymbolProvider(ze,wt(_),oe,Fe)},registerWorkspaceSymbolProvider(_){return ct.registerWorkspaceSymbolProvider(ze,_)},registerDocumentFormattingEditProvider(_,oe){return ct.registerDocumentFormattingEditProvider(ze,wt(_),oe)},registerDocumentRangeFormattingEditProvider(_,oe){return ct.registerDocumentRangeFormattingEditProvider(ze,wt(_),oe)},registerOnTypeFormattingEditProvider(_,oe,Fe,...ot){return ct.registerOnTypeFormattingEditProvider(ze,wt(_),oe,[Fe].concat(ot))},registerDocumentSemanticTokensProvider(_,oe,Fe){return ct.registerDocumentSemanticTokensProvider(ze,wt(_),oe,Fe)},registerDocumentRangeSemanticTokensProvider(_,oe,Fe){return ct.registerDocumentRangeSemanticTokensProvider(ze,wt(_),oe,Fe)},registerSignatureHelpProvider(_,oe,Fe,...ot){return typeof Fe=="object"?ct.registerSignatureHelpProvider(ze,wt(_),oe,Fe):ct.registerSignatureHelpProvider(ze,wt(_),oe,typeof Fe>"u"?[]:[Fe,...ot])},registerCompletionItemProvider(_,oe,...Fe){return ct.registerCompletionItemProvider(ze,wt(_),oe,Fe)},registerInlineCompletionItemProvider(_,oe,Fe){return oe.handleDidShowCompletionItem&&(0,Ze.$MG)(ze,"inlineCompletionsAdditions"),oe.handleDidPartiallyAcceptCompletionItem&&(0,Ze.$MG)(ze,"inlineCompletionsAdditions"),Fe&&(0,Ze.$MG)(ze,"inlineCompletionsAdditions"),ct.registerInlineCompletionsProvider(ze,wt(_),oe,Fe)},registerInlineEditProvider(_,oe){return(0,Ze.$MG)(ze,"inlineEdit"),ct.registerInlineEditProvider(ze,wt(_),oe)},registerDocumentLinkProvider(_,oe){return ct.registerDocumentLinkProvider(ze,wt(_),oe)},registerColorProvider(_,oe){return ct.registerColorProvider(ze,wt(_),oe)},registerFoldingRangeProvider(_,oe){return ct.registerFoldingRangeProvider(ze,wt(_),oe)},registerSelectionRangeProvider(_,oe){return ct.registerSelectionRangeProvider(ze,_,oe)},registerCallHierarchyProvider(_,oe){return ct.registerCallHierarchyProvider(ze,_,oe)},registerTypeHierarchyProvider(_,oe){return ct.registerTypeHierarchyProvider(ze,_,oe)},setLanguageConfiguration:(_,oe)=>ct.setLanguageConfiguration(ze,_,oe),getTokenInformationAtPosition(_,oe){return(0,Ze.$MG)(ze,"tokenInformation"),Lt.tokenAtPosition(_,oe)},registerInlayHintsProvider(_,oe){return ct.registerInlayHintsProvider(ze,_,oe)},createLanguageStatusItem(_,oe){return Lt.createLanguageStatusItem(ze,_,oe)},registerDocumentDropEditProvider(_,oe,Fe){return ct.registerDocumentOnDropEditProvider(ze,_,oe,(0,Ze.$LG)(ze,"documentPaste")?Fe:void 0)}},nn={get activeTextEditor(){return Xe.getActiveTextEditor()},get visibleTextEditors(){return Xe.getVisibleTextEditors()},get activeTerminal(){return Dt.activeTerminal},get terminals(){return Dt.terminals},async showTextDocument(_,oe,Fe){m.URI.isUri(_)&&_.scheme===A.Schemas.vscodeRemote&&!_.authority&&Mt.report("workspace.showTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority.");const ot=await(m.URI.isUri(_)?Promise.resolve(qi.openTextDocument(_)):Promise.resolve(_));return Xe.showTextDocument(ot,oe,Fe)},createTextEditorDecorationType(_){return Xe.createTextEditorDecorationType(ze,_)},onDidChangeActiveTextEditor(_,oe,Fe){return nt(Xe.onDidChangeActiveTextEditor)(_,oe,Fe)},onDidChangeVisibleTextEditors(_,oe,Fe){return nt(Xe.onDidChangeVisibleTextEditors)(_,oe,Fe)},onDidChangeTextEditorSelection(_,oe,Fe){return nt(Xe.onDidChangeTextEditorSelection)(_,oe,Fe)},onDidChangeTextEditorOptions(_,oe,Fe){return nt(Xe.onDidChangeTextEditorOptions)(_,oe,Fe)},onDidChangeTextEditorVisibleRanges(_,oe,Fe){return nt(Xe.onDidChangeTextEditorVisibleRanges)(_,oe,Fe)},onDidChangeTextEditorViewColumn(_,oe,Fe){return nt(Xe.onDidChangeTextEditorViewColumn)(_,oe,Fe)},onDidCloseTerminal(_,oe,Fe){return nt(Dt.onDidCloseTerminal)(_,oe,Fe)},onDidOpenTerminal(_,oe,Fe){return nt(Dt.onDidOpenTerminal)(_,oe,Fe)},onDidChangeActiveTerminal(_,oe,Fe){return nt(Dt.onDidChangeActiveTerminal)(_,oe,Fe)},onDidChangeTerminalDimensions(_,oe,Fe){return(0,Ze.$MG)(ze,"terminalDimensions"),nt(Dt.onDidChangeTerminalDimensions)(_,oe,Fe)},onDidChangeTerminalState(_,oe,Fe){return nt(Dt.onDidChangeTerminalState)(_,oe,Fe)},onDidWriteTerminalData(_,oe,Fe){return(0,Ze.$MG)(ze,"terminalDataWriteEvent"),nt(Dt.onDidWriteTerminalData)(_,oe,Fe)},onDidExecuteTerminalCommand(_,oe,Fe){return(0,Ze.$MG)(ze,"terminalExecuteCommandEvent"),nt(Dt.onDidExecuteTerminalCommand)(_,oe,Fe)},onDidChangeTerminalShellIntegration(_,oe,Fe){return(0,Ze.$MG)(ze,"terminalShellIntegration"),nt(ai.onDidChangeTerminalShellIntegration)(_,oe,Fe)},onDidStartTerminalShellExecution(_,oe,Fe){return(0,Ze.$MG)(ze,"terminalShellIntegration"),nt(ai.onDidStartTerminalShellExecution)(_,oe,Fe)},onDidEndTerminalShellExecution(_,oe,Fe){return(0,Ze.$MG)(ze,"terminalShellIntegration"),nt(ai.onDidEndTerminalShellExecution)(_,oe,Fe)},get state(){return At.getState()},onDidChangeWindowState(_,oe,Fe){return nt(At.onDidChangeWindowState)(_,oe,Fe)},showInformationMessage(_,...oe){return Vi.showMessage(ze,p.default.Info,_,oe[0],oe.slice(1))},showWarningMessage(_,...oe){return Vi.showMessage(ze,p.default.Warning,_,oe[0],oe.slice(1))},showErrorMessage(_,...oe){return Vi.showMessage(ze,p.default.Error,_,oe[0],oe.slice(1))},showQuickPick(_,oe,Fe){return Di.showQuickPick(ze,_,oe,Fe)},showWorkspaceFolderPick(_){return Di.showWorkspaceFolderPick(_)},showInputBox(_,oe){return Di.showInput(_,oe)},showOpenDialog(_){return Ri.showOpenDialog(ze,_)},showSaveDialog(_){return Ri.showSaveDialog(_)},createStatusBarItem(_,oe,Fe){let ot,vt,Pt;return typeof _=="string"?(ot=_,vt=oe,Pt=Fe):(vt=_,Pt=oe),xi.createStatusBarEntry(ze,ot,vt,Pt)},setStatusBarMessage(_,oe){return xi.setStatusBarMessage(_,oe)},withScmProgress(_){return Mt.report("window.withScmProgress",ze,"Use 'withProgress' instead."),Ci.withProgress(ze,{location:we.ProgressLocation.SourceControl},(oe,Fe)=>_({report(ot){}}))},withProgress(_,oe){return Ci.withProgress(ze,_,oe)},createOutputChannel(_,oe){return $i.createOutputChannel(_,oe,ze)},createWebviewPanel(_,oe,Fe,ot){return Pi.createWebviewPanel(ze,_,oe,Fe,ot)},createWebviewTextEditorInset(_,oe,Fe,ot){return(0,Ze.$MG)(ze,"editorInsets"),ut.createWebviewEditorInset(_,oe,Fe,ot,ze)},createTerminal(_,oe,Fe){return typeof _=="object"?"pty"in _?Dt.createExtensionTerminal(_):Dt.createTerminalFromOptions(_):Dt.createTerminal(_,oe,Fe)},registerTerminalLinkProvider(_){return Dt.registerLinkProvider(_)},registerTerminalProfileProvider(_,oe){return Dt.registerProfileProvider(ze,_,oe)},registerTerminalQuickFixProvider(_,oe){return(0,Ze.$MG)(ze,"terminalQuickFixProvider"),Dt.registerTerminalQuickFixProvider(_,ze.identifier.value,oe)},registerTreeDataProvider(_,oe){return qe.registerTreeDataProvider(_,oe,ze)},createTreeView(_,oe){return qe.createTreeView(_,oe,ze)},registerWebviewPanelSerializer:(_,oe)=>Pi.registerWebviewPanelSerializer(ze,_,oe),registerCustomEditorProvider:(_,oe,Fe={})=>zi.registerCustomEditorProvider(ze,_,oe,Fe),registerFileDecorationProvider(_){return Rt.registerFileDecorationProvider(_,ze)},registerUriHandler(_){return wi.registerUriHandler(ze,_)},createQuickPick(){return Di.createQuickPick(ze)},createInputBox(){return Di.createInputBox(ze)},get activeColorTheme(){return Li.activeColorTheme},onDidChangeActiveColorTheme(_,oe,Fe){return nt(Li.onDidChangeActiveColorTheme)(_,oe,Fe)},registerWebviewViewProvider(_,oe,Fe){return Ui.registerWebviewViewProvider(ze,_,oe,Fe?.webviewOptions)},get activeNotebookEditor(){return pe.activeNotebookEditor},onDidChangeActiveNotebookEditor(_,oe,Fe){return nt(pe.onDidChangeActiveNotebookEditor)(_,oe,Fe)},get visibleNotebookEditors(){return pe.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return nt(pe.onDidChangeVisibleNotebookEditors)},onDidChangeNotebookEditorSelection(_,oe,Fe){return nt(ae.onDidChangeNotebookEditorSelection)(_,oe,Fe)},onDidChangeNotebookEditorVisibleRanges(_,oe,Fe){return nt(ae.onDidChangeNotebookEditorVisibleRanges)(_,oe,Fe)},showNotebookDocument(_,oe){return pe.showNotebookDocument(_,oe)},registerExternalUriOpener(_,oe,Fe){return(0,Ze.$MG)(ze,"externalUriOpener"),Xi.registerExternalUriOpener(ze.identifier,_,oe,Fe)},registerProfileContentHandler(_,oe){return(0,Ze.$MG)(ze,"profileContentHandlers"),Zi.registerProfileContentHandler(ze,_,oe)},registerQuickDiffProvider(_,oe,Fe,ot){return(0,Ze.$MG)(ze,"quickDiffProvider"),Ji.registerQuickDiffProvider(wt(_),oe,Fe,ot)},get tabGroups(){return Wt.tabGroups},registerShareProvider(_,oe){return(0,Ze.$MG)(ze,"shareProvider"),Ni.registerShareProvider(wt(_),oe)}},qi={get rootPath(){return Mt.report("workspace.rootPath",ze,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(_){throw new N.$9("rootPath")},getWorkspaceFolder(_){return ft.getWorkspaceFolder(_)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(_){throw new N.$9("name")},get workspaceFile(){return ft.workspaceFile},set workspaceFile(_){throw new N.$9("workspaceFile")},updateWorkspaceFolders:(_,oe,...Fe)=>ft.updateWorkspaceFolders(ze,_,oe||0,...Fe),onDidChangeWorkspaceFolders:function(_,oe,Fe){return nt(ft.onDidChangeWorkspace)(_,oe,Fe)},asRelativePath:(_,oe)=>ft.getRelativePath(_,oe),findFiles:(_,oe,Fe,ot)=>ft.findFiles(_,oe,Fe,ze.identifier,ot),findFiles2:(_,oe,Fe)=>((0,Ze.$MG)(ze,"findFiles2"),ft.findFiles2(_,oe,ze.identifier,Fe)),findTextInFiles:(_,oe,Fe,ot)=>{(0,Ze.$MG)(ze,"findTextInFiles");let vt,Pt;return typeof oe=="object"?(vt=oe,Pt=Fe):(vt={},Pt=oe,ot=Fe),ft.findTextInFiles(_,vt||{},Pt,ze.identifier,ot)},save:_=>ft.save(_),saveAs:_=>ft.saveAs(_),saveAll:_=>ft.saveAll(_),applyEdit(_,oe){return $n.applyWorkspaceEdit(_,ze,oe)},createFileSystemWatcher:(_,oe,Fe,ot)=>{let vt;return typeof oe=="boolean"?vt={ignoreCreateEvents:!!oe,ignoreChangeEvents:!!Fe,ignoreDeleteEvents:!!ot,correlate:!1}:oe&&((0,Ze.$MG)(ze,"createFileSystemWatcher"),vt={...oe,correlate:!0}),Ft.createFileSystemWatcher(ft,ze,_,vt)},get textDocuments(){return It.getAllDocumentData().map(_=>_.document)},set textDocuments(_){throw new N.$9("textDocuments")},openTextDocument(_){let oe;const Fe=_;if(typeof _=="string")oe=Promise.resolve(m.URI.file(_));else if(m.URI.isUri(_))oe=Promise.resolve(_);else if(!Fe||typeof Fe=="object")oe=It.createDocumentData(Fe);else throw new Error("illegal argument - uriOrFileNameOrOptions");return oe.then(ot=>(ot.scheme===A.Schemas.vscodeRemote&&!ot.authority&&Mt.report("workspace.openTextDocument",ze,"A URI of 'vscode-remote' scheme requires an authority."),It.ensureDocumentData(ot).then(vt=>vt.document)))},onDidOpenTextDocument:(_,oe,Fe)=>nt(It.onDidAddDocument)(_,oe,Fe),onDidCloseTextDocument:(_,oe,Fe)=>nt(It.onDidRemoveDocument)(_,oe,Fe),onDidChangeTextDocument:(_,oe,Fe)=>nt(It.onDidChangeDocument)(_,oe,Fe),onDidSaveTextDocument:(_,oe,Fe)=>nt(It.onDidSaveDocument)(_,oe,Fe),onWillSaveTextDocument:(_,oe,Fe)=>nt(ri.getOnWillSaveTextDocumentEvent(ze))(_,oe,Fe),get notebookDocuments(){return pe.notebookDocuments.map(_=>_.apiNotebook)},async openNotebookDocument(_,oe){let Fe;if(m.URI.isUri(_))Fe=_,await pe.openNotebookDocument(_);else if(typeof _=="string")Fe=m.URI.revive(await pe.createNotebookDocument({viewType:_,content:oe}));else throw new Error("Invalid arguments");return pe.getNotebookDocument(Fe).apiNotebook},onDidSaveNotebookDocument(_,oe,Fe){return nt(Ae.onDidSaveNotebookDocument)(_,oe,Fe)},onDidChangeNotebookDocument(_,oe,Fe){return nt(Ae.onDidChangeNotebookDocument)(_,oe,Fe)},onWillSaveNotebookDocument(_,oe,Fe){return nt(Ve.getOnWillSaveNotebookDocumentEvent(ze))(_,oe,Fe)},get onDidOpenNotebookDocument(){return nt(pe.onDidOpenNotebookDocument)},get onDidCloseNotebookDocument(){return nt(pe.onDidCloseNotebookDocument)},registerNotebookSerializer(_,oe,Fe,ot){return pe.registerNotebookSerializer(ze,_,oe,Fe,(0,Ze.$LG)(ze,"notebookLiveShare")?ot:void 0)},onDidChangeConfiguration:(_,oe,Fe)=>nt(Wi.onDidChangeConfiguration)(_,oe,Fe),getConfiguration(_,oe){return oe=arguments.length===1?void 0:oe,Wi.getConfiguration(_,oe,ze)},registerTextDocumentContentProvider(_,oe){return Ei.registerTextDocumentContentProvider(_,oe)},registerTaskProvider:(_,oe)=>(Mt.report("window.registerTaskProvider",ze,"Use the corresponding function on the 'tasks' namespace instead"),ni.registerTaskProvider(ze,_,oe)),registerFileSystemProvider(_,oe,Fe){return(0,T.$Rc)(Ot.registerFileSystemProvider(ze,_,oe,Fe),Kt.addFileSystemProvider(_,oe,Fe))},get fs(){return Kt.value},registerFileSearchProvider:(_,oe)=>((0,Ze.$MG)(ze,"fileSearchProvider"),fi.registerFileSearchProvider(_,oe)),registerTextSearchProvider:(_,oe)=>((0,Ze.$MG)(ze,"textSearchProvider"),fi.registerTextSearchProvider(_,oe)),registerAITextSearchProvider:(_,oe)=>((0,Ze.$MG)(ze,"aiTextSearchProvider"),(0,Ze.$MG)(ze,"textSearchProvider"),fi.registerAITextSearchProvider(_,oe)),registerRemoteAuthorityResolver:(_,oe)=>((0,Ze.$MG)(ze,"resolvers"),Tt.registerRemoteAuthorityResolver(_,oe)),registerResourceLabelFormatter:_=>((0,Ze.$MG)(ze,"resolvers"),Ti.$registerResourceLabelFormatter(_)),getRemoteExecServer:_=>((0,Ze.$MG)(ze,"resolvers"),Tt.getRemoteExecServer(_)),onDidCreateFiles:(_,oe,Fe)=>nt(Ft.onDidCreateFile)(_,oe,Fe),onDidDeleteFiles:(_,oe,Fe)=>nt(Ft.onDidDeleteFile)(_,oe,Fe),onDidRenameFiles:(_,oe,Fe)=>nt(Ft.onDidRenameFile)(_,oe,Fe),onWillCreateFiles:(_,oe,Fe)=>nt(Ft.getOnWillCreateFileEvent(ze))(_,oe,Fe),onWillDeleteFiles:(_,oe,Fe)=>nt(Ft.getOnWillDeleteFileEvent(ze))(_,oe,Fe),onWillRenameFiles:(_,oe,Fe)=>nt(Ft.getOnWillRenameFileEvent(ze))(_,oe,Fe),openTunnel:_=>((0,Ze.$MG)(ze,"tunnels"),jt.openTunnel(ze,_).then(oe=>{if(!oe)throw new Error("cannot open tunnel");return oe})),get tunnels(){return(0,Ze.$MG)(ze,"tunnels"),jt.getTunnels()},onDidChangeTunnels:(_,oe,Fe)=>((0,Ze.$MG)(ze,"tunnels"),nt(jt.onDidChangeTunnels)(_,oe,Fe)),registerPortAttributesProvider:(_,oe)=>((0,Ze.$MG)(ze,"portsAttributes"),jt.registerPortsAttributesProvider(_,oe)),registerTunnelProvider:(_,oe)=>((0,Ze.$MG)(ze,"tunnelFactory"),jt.registerTunnelProvider(_,oe)),registerTimelineProvider:(_,oe)=>((0,Ze.$MG)(ze,"timeline"),Qi.registerTimelineProvider(_,oe,ze.identifier,$t.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:_=>((0,Ze.$MG)(ze,"workspaceTrust"),ft.requestWorkspaceTrust(_)),onDidGrantWorkspaceTrust:(_,oe,Fe)=>nt(ft.onDidGrantWorkspaceTrust)(_,oe,Fe),registerEditSessionIdentityProvider:(_,oe)=>((0,Ze.$MG)(ze,"editSessionIdentityProvider"),ft.registerEditSessionIdentityProvider(_,oe)),onWillCreateEditSessionIdentity:(_,oe,Fe)=>((0,Ze.$MG)(ze,"editSessionIdentityProvider"),nt(ft.getOnWillCreateEditSessionIdentityEvent(ze))(_,oe,Fe)),registerCanonicalUriProvider:(_,oe)=>((0,Ze.$MG)(ze,"canonicalUriProvider"),ft.registerCanonicalUriProvider(_,oe)),getCanonicalUri:(_,oe,Fe)=>((0,Ze.$MG)(ze,"canonicalUriProvider"),ft.provideCanonicalUri(_,oe,Fe))},rn={get inputBox(){return Mt.report("scm.inputBox",ze,"Use 'SourceControl.inputBox' instead"),Ii.getLastInputBox(ze)},createSourceControl(_,oe,Fe){return Ii.createSourceControl(ze,_,oe,Fe)}},bn={createCommentController(_,oe){return Oi.createCommentController(ze,_,oe)}},sn={get activeDebugSession(){return kt.activeDebugSession},get activeDebugConsole(){return kt.activeDebugConsole},get breakpoints(){return kt.breakpoints},get activeStackItem(){return kt.activeStackItem},registerDebugVisualizationProvider(_,oe){return(0,Ze.$MG)(ze,"debugVisualization"),kt.registerDebugVisualizationProvider(ze,_,oe)},registerDebugVisualizationTreeProvider(_,oe){return(0,Ze.$MG)(ze,"debugVisualization"),kt.registerDebugVisualizationTree(ze,_,oe)},onDidStartDebugSession(_,oe,Fe){return nt(kt.onDidStartDebugSession)(_,oe,Fe)},onDidTerminateDebugSession(_,oe,Fe){return nt(kt.onDidTerminateDebugSession)(_,oe,Fe)},onDidChangeActiveDebugSession(_,oe,Fe){return nt(kt.onDidChangeActiveDebugSession)(_,oe,Fe)},onDidReceiveDebugSessionCustomEvent(_,oe,Fe){return nt(kt.onDidReceiveDebugSessionCustomEvent)(_,oe,Fe)},onDidChangeBreakpoints(_,oe,Fe){return nt(kt.onDidChangeBreakpoints)(_,oe,Fe)},onDidChangeActiveStackItem(_,oe,Fe){return nt(kt.onDidChangeActiveStackItem)(_,oe,Fe)},registerDebugConfigurationProvider(_,oe,Fe){return kt.registerDebugConfigurationProvider(_,oe,Fe||Zt.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(_,oe){return kt.registerDebugAdapterDescriptorFactory(ze,_,oe)},registerDebugAdapterTrackerFactory(_,oe){return kt.registerDebugAdapterTrackerFactory(_,oe)},startDebugging(_,oe,Fe){return!Fe||typeof Fe=="object"&&"configuration"in Fe?kt.startDebugging(_,oe,{parentSession:Fe}):kt.startDebugging(_,oe,Fe||{})},stopDebugging(_){return kt.stopDebugging(_)},addBreakpoints(_){return kt.addBreakpoints(_)},removeBreakpoints(_){return kt.removeBreakpoints(_)},asDebugSourceUri(_,oe){return kt.asDebugSourceUri(_,oe)}},on={registerTaskProvider:(_,oe)=>ni.registerTaskProvider(ze,_,oe),fetchTasks:_=>ni.fetchTasks(_),executeTask:_=>ni.executeTask(ze,_),get taskExecutions(){return ni.taskExecutions},onDidStartTask:(_,oe,Fe)=>nt(ni.onDidStartTask)(_,oe,Fe),onDidEndTask:(_,oe,Fe)=>nt(ni.onDidEndTask)(_,oe,Fe),onDidStartTaskProcess:(_,oe,Fe)=>nt(ni.onDidStartTaskProcess)(_,oe,Fe),onDidEndTaskProcess:(_,oe,Fe)=>nt(ni.onDidEndTaskProcess)(_,oe,Fe)},wn={createNotebookController(_,oe,Fe,ot,vt){return J.createNotebookController(ze,_,oe,Fe,ot,(0,Ze.$LG)(ze,"notebookMessaging")?vt:void 0)},registerNotebookCellStatusBarItemProvider:(_,oe)=>pe.registerNotebookCellStatusBarItemProvider(ze,_,oe),createRendererMessaging(_){return Me.createRendererMessaging(ze,_)},createNotebookControllerDetectionTask(_){return(0,Ze.$MG)(ze,"notebookKernelSource"),J.createNotebookControllerDetectionTask(ze,_)},registerKernelSourceActionProvider(_,oe){return(0,Ze.$MG)(ze,"notebookKernelSource"),J.registerKernelSourceActionProvider(ze,_,oe)},onDidChangeNotebookCellExecutionState(_,oe,Fe){return(0,Ze.$MG)(ze,"notebookCellExecutionState"),nt(J.onDidChangeNotebookCellExecutionState)(_,oe,Fe)}},vn={t(..._){if(typeof _[0]=="string"){const oe=_.shift(),Fe=!_||typeof _[0]!="object"?_:_[0];return li.getMessage(ze.identifier.value,{message:oe,args:Fe})}return li.getMessage(ze.identifier.value,_[0])},get bundle(){return li.getBundle(ze.identifier.value)},get uri(){return li.getBundleUri(ze.identifier.value)}},an={_version:1,transferActiveChat(_){return(0,Ze.$MG)(ze,"interactive"),Mi.transferActiveChat(_)}},Hi={getRelatedInformation(_,oe){return(0,Ze.$MG)(ze,"aiRelatedInformation"),ji.getRelatedInformation(ze,_,oe)},registerRelatedInformationProvider(_,oe){return(0,Ze.$MG)(ze,"aiRelatedInformation"),ji.registerRelatedInformationProvider(ze,_,oe)},registerEmbeddingVectorProvider(_,oe){return(0,Ze.$MG)(ze,"aiRelatedInformation"),gn.registerEmbeddingVectorProvider(ze,_,oe)}},cn={_version:1,registerChatResponseProvider(_,oe,Fe){return(0,Ze.$MG)(ze,"chatProvider"),qt.registerLanguageModel(ze,_,oe,Fe)},registerChatVariableResolver(_,oe,Fe,ot,vt){return(0,Ze.$MG)(ze,"chatVariableResolver"),Yi.registerVariableResolver(ze,_,oe,Fe,ot,vt)},registerMappedEditsProvider(_,oe){return(0,Ze.$MG)(ze,"mappedEditsProvider"),ct.registerMappedEditsProvider(ze,_,oe)},createChatParticipant(_,oe){return(0,Ze.$MG)(ze,"chatParticipant"),Mi.createChatAgent(ze,_,oe)},createDynamicChatParticipant(_,oe,Fe){return(0,Ze.$MG)(ze,"chatParticipantAdditions"),Mi.createDynamicChatAgent(ze,_,oe,Fe)}},un={selectChatModels:_=>((0,Ze.$MG)(ze,"languageModels"),qt.selectLanguageModels(ze,_??{})),onDidChangeChatModels:(_,oe,Fe)=>((0,Ze.$MG)(ze,"languageModels"),qt.onDidChangeProviders(_,oe,Fe)),get embeddingModels(){return(0,Ze.$MG)(ze,"embeddings"),pi.embeddingsModels},onDidChangeEmbeddingModels:(_,oe,Fe)=>((0,Ze.$MG)(ze,"embeddings"),pi.onDidChange(_,oe,Fe)),registerEmbeddingsProvider(_,oe){return(0,Ze.$MG)(ze,"embeddings"),pi.registerEmbeddingsProvider(ze,_,oe)},async computeEmbeddings(_,oe,Fe){return(0,Ze.$MG)(ze,"embeddings"),pi.computeEmbeddings(_,oe,Fe)}},ln={registerSpeechProvider(_,oe){return(0,Ze.$MG)(ze,"speech"),Bi.registerProvider(ze.identifier,_,oe)}};return{version:mt.version,ai:Hi,authentication:en,commands:gi,comments:bn,chat:cn,debug:sn,env:ki,extensions:Ai,interactive:an,l10n:vn,languages:tn,lm:un,notebooks:wn,scm:rn,speech:ln,tasks:on,tests:pn,window:nn,workspace:qi,Breakpoint:we.$oN,TerminalOutputAnchor:we.TerminalOutputAnchor,ChatResultFeedbackKind:we.ChatResultFeedbackKind,ChatVariableLevel:we.ChatVariableLevel,ChatCompletionItem:we.$jO,CallHierarchyIncomingCall:we.$MM,CallHierarchyItem:we.$LM,CallHierarchyOutgoingCall:we.$NM,CancellationError:N.$5,CancellationTokenSource:C.$qe,CandidatePortSource:t.CandidatePortSource,CodeAction:we.$IM,CodeActionKind:we.$JM,CodeActionTriggerKind:we.CodeActionTriggerKind,CodeLens:we.$OM,Color:we.$2M,ColorInformation:we.$3M,ColorPresentation:we.$4M,ColorThemeKind:we.ColorThemeKind,CommentMode:we.CommentMode,CommentState:we.CommentState,CommentThreadCollapsibleState:we.CommentThreadCollapsibleState,CommentThreadState:we.CommentThreadState,CommentThreadApplicability:we.CommentThreadApplicability,CompletionItem:we.$VM,CompletionItemKind:we.CompletionItemKind,CompletionItemTag:we.CompletionItemTag,CompletionList:we.$WM,CompletionTriggerKind:we.CompletionTriggerKind,ConfigurationTarget:we.ConfigurationTarget,CustomExecution:we.$_M,DebugAdapterExecutable:we.$sN,DebugAdapterInlineImplementation:we.$vN,DebugAdapterNamedPipeServer:we.$uN,DebugAdapterServer:we.$tN,DebugConfigurationProviderTriggerKind:Zt.DebugConfigurationProviderTriggerKind,DebugConsoleMode:we.DebugConsoleMode,DebugVisualization:we.$LN,DecorationRangeBehavior:we.DecorationRangeBehavior,Diagnostic:we.$BM,DiagnosticRelatedInformation:we.$AM,DiagnosticSeverity:we.DiagnosticSeverity,DiagnosticTag:we.DiagnosticTag,Disposable:we.$nM,DocumentHighlight:we.$EM,DocumentHighlightKind:we.DocumentHighlightKind,MultiDocumentHighlight:we.$FM,DocumentLink:we.$1M,DocumentSymbol:we.$HM,EndOfLine:we.EndOfLine,EnvironmentVariableMutatorType:we.EnvironmentVariableMutatorType,EvaluatableExpression:we.$yN,InlineValueText:we.$zN,InlineValueVariableLookup:we.$AN,InlineValueEvaluatableExpression:we.$BN,InlineCompletionTriggerKind:we.InlineCompletionTriggerKind,EventEmitter:M.$fe,ExtensionKind:we.ExtensionKind,ExtensionMode:we.ExtensionMode,ExternalUriOpenerPriority:we.ExternalUriOpenerPriority,FileChangeType:we.FileChangeType,FileDecoration:we.$NN,FileDecoration2:we.$NN,FileSystemError:we.$EN,FileType:f.FileType,FilePermission:f.FilePermission,FoldingRange:we.$FN,FoldingRangeKind:we.FoldingRangeKind,FunctionBreakpoint:we.$qN,InlineCompletionItem:we.$XM,InlineCompletionList:we.$YM,Hover:we.$CM,VerboseHover:we.$DM,HoverVerbosityAction:we.HoverVerbosityAction,IndentAction:S.IndentAction,Location:we.$zM,MarkdownString:we.$PM,OverviewRulerLane:d.OverviewRulerLane,ParameterInformation:we.$QM,PortAutoForwardAction:we.PortAutoForwardAction,Position:we.$oM,ProcessExecution:we.$0M,ProgressLocation:we.ProgressLocation,QuickInputButtons:we.$MN,Range:we.$pM,RelativePattern:we.$mN,Selection:we.$qM,SelectionRange:we.$KM,SemanticTokens:we.$IN,SemanticTokensBuilder:we.$HN,SemanticTokensEdit:we.$JN,SemanticTokensEdits:we.$KN,SemanticTokensLegend:we.$GN,ShellExecution:we.$$M,ShellQuoting:we.ShellQuoting,SignatureHelp:we.$SM,SignatureHelpTriggerKind:we.SignatureHelpTriggerKind,SignatureInformation:we.$RM,SnippetString:we.$yM,SourceBreakpoint:we.$pN,StandardTokenType:we.StandardTokenType,StatusBarAlignment:we.StatusBarAlignment,SymbolInformation:we.$GM,SymbolKind:we.SymbolKind,SymbolTag:we.SymbolTag,Task:we.$aN,TaskGroup:we.$9M,TaskPanelKind:we.TaskPanelKind,TaskRevealKind:we.TaskRevealKind,TaskScope:we.TaskScope,TerminalLink:we.$5M,TerminalQuickFixTerminalCommand:we.$7M,TerminalQuickFixOpener:we.$6M,TerminalLocation:we.TerminalLocation,TerminalProfile:we.$8M,TerminalExitReason:we.TerminalExitReason,TerminalShellExecutionCommandLineConfidence:we.TerminalShellExecutionCommandLineConfidence,TextDocumentSaveReason:we.TextDocumentSaveReason,TextEdit:we.$uM,SnippetTextEdit:we.$wM,TextEditorCursorStyle:D.TextEditorCursorStyle,TextEditorLineNumbersStyle:we.TextEditorLineNumbersStyle,TextEditorRevealType:we.TextEditorRevealType,TextEditorSelectionChangeKind:we.TextEditorSelectionChangeKind,SyntaxTokenType:we.SyntaxTokenType,TextDocumentChangeReason:we.TextDocumentChangeReason,ThemeColor:we.$lN,ThemeIcon:we.$kN,TreeItem:we.$bN,TreeItemCheckboxState:we.TreeItemCheckboxState,TreeItemCollapsibleState:we.TreeItemCollapsibleState,TypeHierarchyItem:we.$0N,UIKind:Yt.UIKind,Uri:m.URI,ViewColumn:we.ViewColumn,WorkspaceEdit:we.$xM,DocumentPasteTriggerKind:we.DocumentPasteTriggerKind,DocumentDropEdit:we.$hN,DocumentDropOrPasteEditKind:we.$iN,DocumentPasteEdit:we.$jN,InlayHint:we.$UM,InlayHintLabelPart:we.$TM,InlayHintKind:we.InlayHintKind,RemoteAuthorityResolverError:we.$tM,ResolvedAuthority:we.$rM,ManagedResolvedAuthority:we.$sM,SourceControlInputBoxValidationType:we.SourceControlInputBoxValidationType,ExtensionRuntime:we.ExtensionRuntime,TimelineItem:we.$XN,NotebookRange:we.$PN,NotebookCellKind:we.NotebookCellKind,NotebookCellExecutionState:we.NotebookCellExecutionState,NotebookCellData:we.$QN,NotebookData:we.$RN,NotebookRendererScript:we.$VN,NotebookCellStatusBarAlignment:we.NotebookCellStatusBarAlignment,NotebookEditorRevealType:we.NotebookEditorRevealType,NotebookCellOutput:we.$TN,NotebookCellOutputItem:we.$SN,NotebookCellStatusBarItem:we.$UN,NotebookControllerAffinity:we.NotebookControllerAffinity,NotebookControllerAffinity2:we.NotebookControllerAffinity2,NotebookEdit:we.$vM,NotebookKernelSourceAction:we.$WN,NotebookVariablesRequestKind:we.NotebookVariablesRequestKind,PortAttributes:we.$ZN,LinkedEditingRanges:we.$YN,TestResultState:we.TestResultState,TestRunRequest:we.$1N,TestMessage:we.$2N,TestTag:we.$3N,TestRunProfileKind:we.TestRunProfileKind,TextSearchCompleteMessageType:si.TextSearchCompleteMessageType,DataTransfer:we.$gN,DataTransferItem:we.$cN,TestCoverageCount:we.$4N,FileCoverage:we.$6N,FileCoverage2:we.$6N,StatementCoverage:we.$7N,BranchCoverage:we.$8N,DeclarationCoverage:we.$9N,WorkspaceTrustState:we.WorkspaceTrustState,LanguageStatusSeverity:we.LanguageStatusSeverity,QuickPickItemKind:we.QuickPickItemKind,InputBoxValidationSeverity:we.InputBoxValidationSeverity,TabInputText:we.$$N,TabInputTextDiff:we.$_N,TabInputTextMerge:we.$aO,TabInputCustom:we.$bO,TabInputNotebook:we.$dO,TabInputNotebookDiff:we.$eO,TabInputWebview:we.$cO,TabInputTerminal:we.$fO,TabInputInteractiveWindow:we.$gO,TabInputChat:we.$hO,TabInputTextMultiDiff:we.$iO,TelemetryTrustedValue:s.$jp,LogLevel:o.LogLevel,EditSessionIdentityMatch:n.EditSessionIdentityMatch,InteractiveSessionVoteDirection:we.InteractiveSessionVoteDirection,ChatCopyKind:we.ChatCopyKind,InteractiveEditorResponseFeedbackKind:we.InteractiveEditorResponseFeedbackKind,DebugStackFrame:we.$wN,DebugThread:we.$xN,RelatedInformationType:we.RelatedInformationType,SpeechToTextStatus:we.SpeechToTextStatus,TextToSpeechStatus:we.TextToSpeechStatus,PartialAcceptTriggerKind:we.PartialAcceptTriggerKind,KeywordRecognitionStatus:we.KeywordRecognitionStatus,ChatResponseMarkdownPart:we.$kO,ChatResponseFileTreePart:we.$oO,ChatResponseAnchorPart:we.$pO,ChatResponseProgressPart:we.$qO,ChatResponseProgressPart2:we.$rO,ChatResponseReferencePart:we.$uO,ChatResponseWarningPart:we.$sO,ChatResponseTextEditPart:we.$vO,ChatResponseMarkdownWithVulnerabilitiesPart:we.$lO,ChatResponseCommandButtonPart:we.$tO,ChatResponseDetectedParticipantPart:we.$mO,ChatResponseConfirmationPart:we.$nO,ChatRequestTurn:we.$wO,ChatResponseTurn:we.$xO,ChatLocation:we.ChatLocation,LanguageModelChatMessageRole:we.LanguageModelChatMessageRole,LanguageModelChatMessage:we.$yO,LanguageModelChatMessage2:we.$yO,LanguageModelChatSystemMessage:we.$zO,LanguageModelChatUserMessage:we.$AO,LanguageModelChatAssistantMessage:we.$BO,LanguageModelError:we.$CO,NewSymbolName:we.$DN,NewSymbolNameTag:we.NewSymbolNameTag,NewSymbolNameTriggerKind:we.NewSymbolNameTriggerKind,InlineEdit:we.$DO,InlineEditTriggerKind:we.InlineEditTriggerKind}}}}),define(Se[308],Ie([1,0,56,118,39,112,40,35,68,53,121,123,124,84,88,80,111,65,47,83,63,67,248,12,122,81,82,86,90,116]),function(le,e,C,N,M,T,A,p,m,D,O,S,d,w,f,o,r,s,n,t,c,u,i,b,a,l,g,$,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,C.$Cs)(l.$3mc,l.$2mc,1),(0,C.$Cs)(b.$6j,i.$doc,1),(0,C.$Cs)(o.$8lc,o.$9lc,1),(0,C.$Cs)(p.$_O,p.$$O,0),(0,C.$Cs)($.$fmc,$.$gmc,0),(0,C.$Cs)(v.$Wmc,v.$Xmc,0),(0,C.$Cs)(A.$umc,A.$smc,0),(0,C.$Cs)(s.$wmc,s.$vmc,0),(0,C.$Cs)(S.$anc,S.$enc,0),(0,C.$Cs)(T.$gnc,T.$fnc,0),(0,C.$Cs)(m.$1O,m.$ZO,0),(0,C.$Cs)(g.$4mc,g.$5mc,0),(0,C.$Cs)(n.$_lc,n.$$lc,0),(0,C.$Cs)(N.$Lnc,N.$Knc,1),(0,C.$Cs)(d.$wnc,d.$xnc,0),(0,C.$Cs)(w.$Pmc,w.$Omc,0),(0,C.$Cs)(O.$Ync,O.$Xnc,0),(0,C.$Cs)(D.$Smc,D.$Vmc,0),(0,C.$Cs)(y.$Znc,y.$1nc,0),(0,C.$Cs)(f.$1Db,f.$2Db,0),(0,C.$Cs)(r.$boc,r.$aoc,0),(0,C.$Cs)(M.$rmc,M.$qmc,0),(0,C.$Cs)(t.$Zmc,t.$Ymc,0),(0,C.$Cs)(c.$0O,c.$7O,0),(0,C.$Cs)(u.$Gmc,u.$Hmc,0),(0,C.$Cs)(a.$$mc,a.$_mc,0)}),define(Se[309],Ie([1,0,307,41,2,304,7,11,254]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.$nqc=void 0;class D extends T.$goc{j(){}getModule(w,f){for(const o of this.b){const r=o(w);if(r){w=r;break}}if(this.a.has(w))return this.a.get(w).load(w,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class O extends N.$7mc{constructor(){super(...arguments),this.extensionRuntime=A.ExtensionRuntime.Webworker}async vb(){this.h.createInstance(m.$mqc);const w=this.h.invokeFunction(C.$coc);this.r=this.h.createInstance(D,w,{mine:this.J,all:this.L}),await this.r.install(),performance.mark("code/extHost/didInitAPI"),await this.Bb()}wb(w){return w.browser}async xb(w,f,o){f=f.with({path:S(f.path,".js")});const r=w?.identifier.value;r&&performance.mark(`code/extHost/willFetchExtensionCode/${r}`);const s=M.URI.revive(await this.C.$asBrowserUri(f)),n=await fetch(s.toString(!0));if(r&&performance.mark(`code/extHost/didFetchExtensionCode/${r}`),n.status!==200)throw new Error(n.statusText);const t=await n.text(),c=`${f.toString(!0)}#vscode-extension`,u=`${t}
//# sourceURL=${c}`;let i;try{i=new Function("module","exports","require",u)}catch(g){throw console.error(r?`Loading code for extension ${r} failed: ${g.message}`:`Loading code failed: ${g.message}`),console.error(`${f.toString(!0)}${typeof g.line=="number"?` line ${g.line}`:""}${typeof g.column=="number"?` column ${g.column}`:""}`),console.error(g),g}w&&await this.w.initializeLocalizedMessages(w);const b={},a={exports:b},l=g=>{const $=this.r.getModule(g,f);if($===void 0)throw new Error(`Cannot load module '${g}'`);return $};try{return o.codeLoadingStart(),r&&performance.mark(`code/extHost/willLoadExtensionCode/${r}`),i(a,b,l),a.exports!==b?a.exports:b}finally{r&&performance.mark(`code/extHost/didLoadExtensionCode/${r}`),o.codeLoadingStop()}}async $setRemoteEnvironment(w){}async Bb(w=5e3){if(!this.f.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+w;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,p.$zh)(10)}}e.$nqc=O;function S(d,w){return d.endsWith(w)?d:d+w}}),define(Se[310],Ie([1,0,71,56,12,41,217,87,309]),function(le,e,C,N,M,T,A,p,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,N.$Cs)(M.$5j,new C.$vi(A.$foc,[!0],!0)),(0,N.$Cs)(T.$8mc,m.$nqc,0),(0,N.$Cs)(p.$xmc,p.$ymc,0)}),define(Se[316],Ie([1,0,22,5,79,305,256,19,60,16,2,308,310]),function(le,e,C,N,M,T,A,p,m,D,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=u;const S=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const d=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function w(i){return/^(file|vscode-remote):/i.test(i)}const f=fetch.bind(self);function o(i){self.fetch=async function(b,a){return b instanceof Request||w(String(b))&&(b=(await i(O.URI.parse(String(b)))).toString(!0)),f(b,a)},self.XMLHttpRequest=class extends XMLHttpRequest{open(b,a,l,g,$){(async()=>(w(a.toString())&&(a=(await i(O.URI.parse(a.toString()))).toString(!0)),super.open(b,a,l??!0,g,$)))()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const i=self.Worker;Worker=function(b,a){if(/^file:/i.test(b.toString()))b=D.$Sg.uriToBrowserUri(O.URI.parse(b.toString())).toString(!0);else if(/^vscode-remote:/i.test(b.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const g=`(${function(h){function E(P){return typeof P=="string"||P instanceof URL?String(P).replace(/^file:\/\//i,"vscode-file://vscode-app"):P}const k=fetch.bind(self);self.fetch=function(P,V){return P instanceof Request?k(P,V):k(E(P),V)},self.XMLHttpRequest=class extends XMLHttpRequest{open(P,V,W,q,R){return super.open(P,E(V),W??!0,q,R)}};const I=importScripts.bind(self);self.importScripts=(...P)=>{I(...P.map(E))},I(h)}.toString()}('${b}'))`;a=a||{},a.name=`${name} -> ${a.name||p.$nc(b.toString())}`;const $=new Blob([g],{type:"application/javascript"}),v=URL.createObjectURL($);return new i(v,a)}}else self.Worker=class extends A.$oqc{constructor(i,b){super(d,i,{name:p.$nc(i.toString()),...b})}};const r=new class{constructor(){this.pid=void 0}exit(i){S()}};class s{constructor(){const b=new MessageChannel,a=new N.$fe;let l=!1;d(b.port2,[b.port2]),b.port1.onmessage=g=>{const{data:$}=g;if(!($ instanceof ArrayBuffer)){console.warn("UNKNOWN data received",$);return}const v=C.$He.wrap(new Uint8Array($,0,$.byteLength));if((0,M.$3m)(v,2)){l=!0,t("received terminate message from renderer");return}a.fire(v)},this.protocol={onMessage:a.event,send:g=>{if(!l){const $=g.buffer.buffer.slice(g.buffer.byteOffset,g.buffer.byteOffset+g.buffer.byteLength);b.port1.postMessage($,[$])}}}}}function n(i){return new Promise(b=>{const a=i.onMessage(l=>{a.dispose();const g=JSON.parse(l.toString());i.send((0,M.$2m)(0)),b({protocol:i,initData:g})});i.send((0,M.$2m)(1))})}let t=i=>S();function c(i){return!!i&&typeof i=="object"&&i.type==="vscode.init"&&i.data instanceof Map}function u(){m.mark("code/extHost/willConnectToRenderer");const i=new s;return{onmessage(b){c(b)&&n(i.protocol).then(a=>{m.mark("code/extHost/didWaitForInitData");const l=new T.$ioc(a.protocol,a.initData,r,null,b.data);o(g=>l.asBrowserUri(g)),t=g=>l.terminate(g)})}}}})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/5e68ffd760038bb156894a87f896910be510accd/core/vs/workbench/api/worker/extensionHostWorker.js.map
